![](https://www.flexpart.eu/chrome/site/flexpart_banner.png)
# Welcome to Flexpart - The Lagrangian particle dispersion model

This is the main development site @ University of Vienna.

Other references:

- [FLEXPART.eu](https://flexpart.eu)
- [FLEXPART@NILU](https://git.nilu.no/flexpart/flexpart)

### What is this repository for?

* This repository contains versions of the Lagrangian model FLEXPART
* Development versions
* Issues on the FLEXPART model, [tickets](https://gitlab.phaidra.org/flexpart/flexpart/-/issues)/[mail](mailto:gitlab.phaidra+flexpart-flexpart-456-issue-@univie.ac.at)
* Feature requests for future versions

## Getting started with Flexpart

The model is written in Fortran. It needs to be compiled for the architecture that runs it. Please have a look at the instructions on building FLEXPART available [here](./documentation/docs/building.md) or [online](https://flexpart.img.univie.ac.at/docs). There is also a containerized version of FLEXPART available.


### Contribution guidelines

* The version contributed should compile on a reference version of the system and compiler. 
   - `FLEXPART 10.4` used as a reference gfortran 5.4 on Ubuntu 16.04
   - `FLEXPART 11` uses as a reference gfortran 8.5.0 on AlmaLinux 8/RockyLinux 8 or gfortran 11.4.1 on RockyLinux 9

* Code contribution including new features and bug fixes should be complemented with appropriate tests
   An essential test consists of a set of input files and directories that allow FLEXPART to run.
   A test can be accompanied by output files for verification
* Code review
* report issues via mail to [support](mailto:gitlab.phaidra+flexpart-flexpart-456-issue-@univie.ac.at)
* become an active developer and request a user account on gitlab.

# Flexpart Testing

There are two different sets of Flexpart testing:

1. Testing basic functionality of different options
2. Testing quality of results


## Testing basic functionality

There are several options that can be tested with different options.

```ini
***************************************************************************************************************
*                                                                                                             *
*      Input file for the Lagrangian particle dispersion model FLEXPART                                       *
*                           Please select your options                                                        *
*                                                                                                             *
***************************************************************************************************************
&COMMAND

BINARY:
 LDIRECT=               1, ! Simulation direction in time   ; 1 (forward) or -1 (backward)


FIXED
 IBDATE=         20120101, ! Start date of the simulation   ; YYYYMMDD: YYYY=year, MM=month, DD=day  
 IBTIME=           060000, ! Start time of the simulation   ; HHMISS: HH=hours, MI=min, SS=sec; UTC
 IEDATE=         20120101, ! End date of the simulation     ; same format as IBDATE 
 IETIME=           120000, ! End  time of the simulation    ; same format as IBTIME
 LOUTSTEP=           3600, ! Interval of model output; average concentrations calculated every LOUTSTEP (s)  
 LOUTAVER=           3600, ! Interval of output averaging (s)
 LOUTSAMPLE=          900, ! Interval of output sampling  (s), higher stat. accuracy with shorter intervals
 LSYNCTIME=           900, ! All processes are synchronized to this time interval (s)
 IFINE=                 4, ! Reduction for time step in vertical transport, used only if CTL>1


BINARY -1 off
 LOUTRESTART=       86400, ! Interval of writing restart files (s)
 
BINARY 10 on
 CTL=          -5.0000000, ! CTL>1, ABL time step = (Lagrangian timescale (TL))/CTL, uses LSYNCTIME if CTL<0


OPTIONS: 0,1,2,3,4,5 (9,10,11,12,13)
 IOUT=                  1, ! Gridded output type: [0]off [1]mass 2]pptv 3]1&2 4]plume 5]1&4, +8 for NetCDF output     
OPTIONS: 0,1,2
 IPOUT=                 0, ! Particle position output: 0]off 1]every output 2]only at end
BINARY:
 LSUBGRID=              0, ! Increase of ABL heights due to sub-grid scale orographic variations;[0]off 1]on 
 LCONVECTION=           1, ! Switch for convection parameterization;0]off [1]on
 LAGESPECTRA=           0, ! Switch for calculation of age spectra (needs AGECLASSES);[0]off 1]on

OPTIONS: 0, 1 (needs a restart file), 2 (no), 3 (lucie file), 4 depends on 3 (2 files)
 IPIN=                  0, ! Warm start from particle dump; [0]no 1]from restart.bin file 2]from previous partoutput file 3]self made initial conditions 4]restart.bin and self made initial conditions
 
BINARY:
 IOUTPUTFOREACHRELEASE= 1, ! Separate output fields for each location in the RELEASE file; [0]no 1]yes 
 IFLUX=                 0, ! Output of mass fluxes through output grid box boundaries
 MDOMAINFILL=           0, ! Switch for domain-filling, if limited-area particles generated at boundary

OPTIONS: ????
 IND_SOURCE=            1, ! Unit to be used at the source; [1]mass 2]mass mixing ratio 
 IND_RECEPTOR=          1, ! Unit to be used at the receptor; [0]no receptor [1]mass 2]mass mixing ratio 3]wet depo. 4]dry depo.
 
BINARY: 
 MQUASILAG=             0, ! Quasi-Lagrangian mode to track individual numbered particles 
 NESTED_OUTPUT=         0, ! Output also for a nested domain 

OPTIONS: ???  (only with binary, option 5)
 LINIT_COND=            0, ! Output sensitivity to initial conditions (bkw mode only) [0]off 1]conc 2]mmr 

OPTIONS: (only with binary, option 5)
 SURF_ONLY=             0, ! Output only for the lowest model layer, used w/ LINIT_COND=1 or 2
 
BINRAY: (CTL > 10, IFINE > 10) ???
 CBLFLAG=               0, ! Skewed, not Gaussian turbulence in the convective ABL, need large CTL and IFINE
 
????
 OHFIELDS_PATH= "../../flexin/", ! Default path for OH file
 
OPTIONS: (depends on wind fields) ???
 NXSHIFT=             359, ! Shift of the global meteorological data. Default 359 for ECMWF and 0 for GFS if not given
 /
```

0) CONFIGURE EXECUTABLE AND WIND FILES

ln -s  path/to/test_winds .

export FLEXPART=path/to/FLEXPART 

1) CREATE DEFAULT CASE

./set_default_example_10.4.sh

RESULT: 
options 
pathnames  
output 

2) CREATE ADDITIONAL TEST CASES (from default) 
 
./gen_options.sh define_options_1.sh   
./gen_options.sh define_options_2.sh 
etc. for single groups 
or 
./gen_options_all.sh 
for all existing tests

RESULT:
options_decription 
 
./gen_pathnames.sh 
From existing options, generate output dirs and pathnames 

3) CREATE EXEC RUNS: 
# need path to suitable executable
# export FLEXPART=/home/ignacio/repos/flexpart/src/FLEXPART 
 
./gen_batch_jobs_cl.sh $FLEXPART
Generates run scripts coding executable 

4) RUN JOBS 

#certain modules may be needed for this step in some systems 
 
./run_batch_cl.sh 


The process steps can be automated with the makefile

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine getrb(nc,ustar,nyl,diffh2o,reldiff,rb)
  !                 i    i    i     i       i    o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of the quasilaminar sublayer resistance to dry deposition.    *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 20 May 1995                                    *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! rb(ncmax)       sublayer resistance                                        *
  ! schmidt         Schmidt number                                             *
  ! ustar [m/s]     friction velocity                                          *
  ! diffh20 [m2/s]  diffusivity of water vapor in air                          *
  ! reldiff         diffusivity relative to H2O                                *
  !                                                                            *
  ! Constants:                                                                 *
  ! karman          von Karman constant                                        *
  ! pr              Prandtl number                                             *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  real :: ustar,diffh2o,rb(maxspec),schmidt,nyl
  real :: reldiff(maxspec)
  integer :: ic,nc
  real,parameter :: pr=0.72

  do ic=1,nc
    if (reldiff(ic).gt.0.) then
      schmidt=nyl/diffh2o*reldiff(ic)
      rb(ic)=2.0*(schmidt/pr)**0.67/(karman*ustar)
    endif
  end do

end subroutine getrb

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readreceptors

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the receptor points.    *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     1 August 1996                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! receptorarea(maxreceptor)  area of dx*dy at location of receptor           *
  ! receptorname(maxreceptor)  names of receptors                              *
  ! xreceptor,yreceptor  coordinates of receptor points                        *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitreceptor         unit connected to file RECEPTORS                      *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: j
  real :: x,y,xm,ym
  character(len=16) :: receptor


  ! For backward runs, do not allow receptor output. Thus, set number of receptors to zero
  !*****************************************************************************

  if (ldirect.lt.0) then
    numreceptor=0
    return
  endif


  ! Open the RECEPTORS file and read output grid specifications
  !************************************************************

  open(unitreceptor,file=path(1)(1:length(1))//'RECEPTORS', &
       status='old',err=999)

  call skplin(5,unitreceptor)


  ! Read the names and coordinates of the receptors
  !************************************************

  j=0
100   j=j+1
    read(unitreceptor,*,end=99)
    read(unitreceptor,*,end=99)
    read(unitreceptor,*,end=99)
    read(unitreceptor,'(4x,a16)',end=99) receptor
    call skplin(3,unitreceptor)
    read(unitreceptor,'(4x,f11.4)',end=99) x
    call skplin(3,unitreceptor)
    read(unitreceptor,'(4x,f11.4)',end=99) y
    if ((x.eq.0.).and.(y.eq.0.).and. &
         (receptor.eq.'                ')) then
      j=j-1
      goto 100
    endif
    if (j.gt.maxreceptor) then
    write(*,*) ' #### FLEXPART MODEL ERROR! TOO MANY RECEPTOR #### '
    write(*,*) ' #### POINTS ARE GIVEN.                       #### '
    write(*,*) ' #### MAXIMUM NUMBER IS ',maxreceptor,'       #### '
    write(*,*) ' #### PLEASE MAKE CHANGES IN FILE RECEPTORS   #### '
    endif
    receptorname(j)=receptor
    xreceptor(j)=(x-xlon0)/dx       ! transform to grid coordinates
    yreceptor(j)=(y-ylat0)/dy
    xm=r_earth*cos(y*pi/180.)*dx/180.*pi
    ym=r_earth*dy/180.*pi
    receptorarea(j)=xm*ym
    goto 100

99   numreceptor=j-1
  close(unitreceptor)
  return


999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "RECEPTORS"  #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  stop

end subroutine readreceptors

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

!-----------------------------------------------------------------------
function distance2(rlat1,rlon1,rlat2,rlon2)

  !$$$  SUBPROGRAM DOCUMENTATION BLOCK
  !
  ! SUBPROGRAM:  GCDIST     COMPUTE GREAT CIRCLE DISTANCE
  !   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
  !
  ! ABSTRACT: THIS SUBPROGRAM COMPUTES GREAT CIRCLE DISTANCE
  !      BETWEEN TWO POINTS ON THE EARTH. COORDINATES ARE GIVEN IN RADIANS!
  !
  ! PROGRAM HISTORY LOG:
  !   96-04-10  IREDELL
  !
  ! USAGE:    ...GCDIST(RLAT1,RLON1,RLAT2,RLON2)
  !
  !   INPUT ARGUMENT LIST:
  !rlat1    - REAL LATITUDE OF POINT 1 IN RADIANS
  !rlon1    - REAL LONGITUDE OF POINT 1 IN RADIANS
  !rlat2    - REAL LATITUDE OF POINT 2 IN RADIANS
  !rlon2    - REAL LONGITUDE OF POINT 2 IN RADIANS
  !
  !   OUTPUT ARGUMENT LIST:
  !distance2   - REAL GREAT CIRCLE DISTANCE IN KM
  !
  ! ATTRIBUTES:
  !   LANGUAGE: Fortran 90
  !
  !$$$

  use par_mod, only: dp

  implicit none

  real                    :: rlat1,rlon1,rlat2,rlon2,distance2
  real(kind=dp)           :: clat1,clat2,slat1,slat2,cdlon,crd
  real(kind=dp),parameter :: rerth=6.3712e6_dp
  real(kind=dp),parameter :: pi=3.14159265358979_dp

  if ((abs(rlat1-rlat2).lt.0.0003).and. &
       (abs(rlon1-rlon2).lt.0.0003)) then
    distance2=0.0_dp
  else

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    clat1=cos(real(rlat1,kind=dp))
    slat1=sin(real(rlat1,kind=dp))
    clat2=cos(real(rlat2,kind=dp))
    slat2=sin(real(rlat2,kind=dp))
    cdlon=cos(real(rlon1-rlon2,kind=dp))
    crd=slat1*slat2+clat1*clat2*cdlon
    distance2=real(rerth*acos(crd)/1000.0_dp)
  endif
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
end function distance2

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine get_settling(itime,xt,yt,zt,nsp,settling)
  !                          i   i  i  i   i     o
  !*****************************************************************************
  !                                                                            *
  !  This subroutine calculates particle settling velocity.                    *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    May 2010                                                                *
  !                                                                            *
  !  Improvement over traditional settling calculation in FLEXPART:            *
  !  generalize to higher Reynolds numbers and also take into account the      *
  !  temperature dependence of dynamic viscosity.                              *
  !                                                                            *
  !  Based on:                                                                 *
  !  Naeslund E., and Thaning, L. (1991): On the settling velocity in a        *
  !  nonstationary atmosphere, Aerosol Science and Technology 14, 247-256.     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! xt,yt,zt           coordinates position for which wind data shall be cal-  *
  !                    culated                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: itime,indz
  real :: xt,yt,zt

  ! Auxiliary variables needed for interpolation
  real :: dz1,dz2,dz
  real :: rho1(2),tt1(2),temperature,airdens,vis_dyn,vis_kin,viscosity
  real :: settling,settling_old,reynolds,c_d
  integer :: i,n,nix,njy,indzh,nsp


  !*****************************************************************************
  ! 1. Interpolate temperature and density: nearest neighbor interpolation sufficient
  !*****************************************************************************

  nix=int(xt)
  njy=int(yt)

  ! Determine the level below the current position for u,v
  !*******************************************************

  do i=2,nz
    if (height(i).gt.zt) then
      indz=i-1
      goto 6
    endif
  end do
6   continue


  ! Vertical distance to the level below and above current position
  !****************************************************************

  dz=1./(height(indz+1)-height(indz))
  dz1=(zt-height(indz))*dz
  dz2=(height(indz+1)-zt)*dz


  ! Bilinear horizontal interpolation
  !**********************************

  ! Loop over 2 levels
  !*******************

  do n=1,2
    indzh=indz+n-1
    rho1(n)=rho(nix,njy,indzh,1)
    tt1(n)=tt(nix,njy,indzh,1)
  end do


  ! Linear vertical interpolation
  !******************************

  temperature=dz2*tt1(1)+dz1*tt1(2)
  airdens=dz2*rho1(1)+dz1*rho1(2)


  vis_dyn=viscosity(temperature)
  vis_kin=vis_dyn/airdens

  reynolds=dquer(nsp)/1.e6*abs(vsetaver(nsp))/vis_kin



  ! Iteration to determine both Reynolds number and settling velocity
  !******************************************************************

  settling_old=vsetaver(nsp)    ! initialize iteration with Stokes' law, constant viscosity estimate

  do i=1,20    ! do a few iterations

    if (reynolds.lt.1.917) then
      c_d=24./reynolds
    else if (reynolds.lt.500.) then
      c_d=18.5/(reynolds**0.6)
    else
      c_d=0.44
    endif

    settling=-1.* &
         sqrt(4*ga*dquer(nsp)/1.e6*density(nsp)*cunningham(nsp)/ &
         (3.*c_d*airdens))

    if (abs((settling-settling_old)/settling).lt.0.01) goto 11  ! stop iteration

    reynolds=dquer(nsp)/1.e6*abs(settling)/vis_kin
    settling_old=settling
  end do

11   continue

end subroutine get_settling

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine convmix(itime)
  !                     i
  !**************************************************************
  !handles all the calculations related to convective mixing
  !Petra Seibert, Bernd C. Krueger, Feb 2001
  !nested grids included, Bernd C. Krueger, May 2001
  !
  !Changes by Caroline Forster, April 2004 - February 2005:
  !  convmix called every lsynctime seconds
  !CHANGES by A. Stohl:
  !  various run-time optimizations - February 2005
  !CHANGES by C. Forster, November 2005, NCEP GFS version
  !      in the ECMWF version convection is calculated on the
  !      original eta-levels
  !      in the GFS version convection is calculated on the
  !      FLEXPART levels
  !**************************************************************

  use par_mod
  use com_mod
  use conv_mod

  implicit none

  integer :: igr,igrold, ipart, itime, ix, j, inest
  integer :: ipconv
  integer :: jy, kpart, ktop, ngrid,kz
  integer :: igrid(maxpart), ipoint(maxpart), igridn(maxpart,maxnests)
  ! itime [s]                 current time
  ! igrid(maxpart)            horizontal grid position of each particle
  ! igridn(maxpart,maxnests)  dto. for nested grids
  ! ipoint(maxpart)           pointer to access particles according to grid position

  logical :: lconv
  real :: x, y, xtn,ytn, ztold, delt
  real :: dt1,dt2,dtt
  integer :: mind1,mind2
  ! dt1,dt2,dtt,mind1,mind2       variables used for time interpolation
  integer :: itage,nage

  !monitoring variables
  !real sumconv,sumall


  ! Calculate auxiliary variables for time interpolation
  !*****************************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)
  mind1=memind(1)
  mind2=memind(2)
  delt=real(abs(lsynctime))


  lconv = .false.

  ! if no particles are present return after initialization
  !********************************************************

  if (numpart.le.0) return

  ! Assign igrid and igridn, which are pseudo grid numbers indicating particles
  ! that are outside the part of the grid under consideration
  ! (e.g. particles near the poles or particles in other nests).
  ! Do this for all nests but use only the innermost nest; for all others
  ! igrid shall be -1
  ! Also, initialize index vector ipoint
  !************************************************************************

  do ipart=1,numpart
    igrid(ipart)=-1
    do j=numbnests,1,-1
      igridn(ipart,j)=-1
    end do
    ipoint(ipart)=ipart
  ! do not consider particles that are (yet) not part of simulation
    if (itra1(ipart).ne.itime) goto 20
    x = xtra1(ipart)
    y = ytra1(ipart)

  ! Determine which nesting level to be used
  !**********************************************************

    ngrid=0
    do j=numbnests,1,-1
      if ( x.gt.xln(j) .and. x.lt.xrn(j) .and. &
           y.gt.yln(j) .and. y.lt.yrn(j) ) then
        ngrid=j
        goto 23
      endif
    end do
 23   continue

  ! Determine nested grid coordinates
  !**********************************

    if (ngrid.gt.0) then
  ! nested grids
      xtn=(x-xln(ngrid))*xresoln(ngrid)
      ytn=(y-yln(ngrid))*yresoln(ngrid)
      ix=nint(xtn)
      jy=nint(ytn)
      igridn(ipart,ngrid) = 1 + jy*nxn(ngrid) + ix
    else if(ngrid.eq.0) then
  ! mother grid
      ix=nint(x)
      jy=nint(y)
      igrid(ipart) = 1 + jy*nx + ix
    endif

 20 continue
  end do

  !sumall = 0.
  !sumconv = 0.

  !*****************************************************************************
  ! 1. Now, do everything for the mother domain and, later, for all of the nested domains
  ! While all particles have to be considered for redistribution, the Emanuel convection
  ! scheme only needs to be called once for every grid column where particles are present.
  ! Therefore, particles are sorted according to their grid position. Whenever a new grid
  ! cell is encountered by looping through the sorted particles, the convection scheme is called.
  !*****************************************************************************

  ! sort particles according to horizontal position and calculate index vector IPOINT

  call sort2(numpart,igrid,ipoint)

  ! Now visit all grid columns where particles are present
  ! by going through the sorted particles

  igrold = -1
  do kpart=1,numpart
    igr = igrid(kpart)
    if (igr .eq. -1) goto 50
    ipart = ipoint(kpart)
  !  sumall = sumall + 1
    if (igr .ne. igrold) then
  ! we are in a new grid column
      jy = (igr-1)/nx
      ix = igr - jy*nx - 1

  ! Interpolate all meteorological data needed for the convection scheme
      psconv=(ps(ix,jy,1,mind1)*dt2+ps(ix,jy,1,mind2)*dt1)*dtt
      tt2conv=(tt2(ix,jy,1,mind1)*dt2+tt2(ix,jy,1,mind2)*dt1)*dtt
      td2conv=(td2(ix,jy,1,mind1)*dt2+td2(ix,jy,1,mind2)*dt1)*dtt
!!$      do kz=1,nconvlev+1    !old
      do kz=1,nuvz-1           !bugfix
        pconv(kz)=(pplev(ix,jy,kz,mind1)*dt2+ &
             pplev(ix,jy,kz,mind2)*dt1)*dtt
        tconv(kz)=(tt(ix,jy,kz,mind1)*dt2+ &
             tt(ix,jy,kz,mind2)*dt1)*dtt
        qconv(kz)=(qv(ix,jy,kz,mind1)*dt2+ &
             qv(ix,jy,kz,mind2)*dt1)*dtt
      end do

  ! Calculate translocation matrix
      call calcmatrix(lconv,delt,cbaseflux(ix,jy))
      igrold = igr
      ktop = 0
    endif

  ! treat particle only if column has convection
    if (lconv .eqv. .true.) then
  ! assign new vertical position to particle

      ztold=ztra1(ipart)
      call redist(ipart,ktop,ipconv)
  !    if (ipconv.le.0) sumconv = sumconv+1

  ! Calculate the gross fluxes across layer interfaces
  !***************************************************

      if (iflux.eq.1) then
        itage=abs(itra1(ipart)-itramem(ipart))
        do nage=1,nageclass
          if (itage.lt.lage(nage)) goto 37
        end do
 37     continue

        if (nage.le.nageclass) &
             call calcfluxes(nage,ipart,real(xtra1(ipart)), &
             real(ytra1(ipart)),ztold)
      endif

    endif   !(lconv .eqv. .true)
50  continue
  end do


  !*****************************************************************************
  ! 2. Nested domains
  !*****************************************************************************

  ! sort particles according to horizontal position and calculate index vector IPOINT

  do inest=1,numbnests
    do ipart=1,numpart
      ipoint(ipart)=ipart
      igrid(ipart) = igridn(ipart,inest)
    enddo
    call sort2(numpart,igrid,ipoint)

  ! Now visit all grid columns where particles are present
  ! by going through the sorted particles

    igrold = -1
    do kpart=1,numpart
      igr = igrid(kpart)
      if (igr .eq. -1) goto 60
      ipart = ipoint(kpart)
  !    sumall = sumall + 1
      if (igr .ne. igrold) then
  ! we are in a new grid column
        jy = (igr-1)/nxn(inest)
        ix = igr - jy*nxn(inest) - 1

  ! Interpolate all meteorological data needed for the convection scheme
        psconv=(psn(ix,jy,1,mind1,inest)*dt2+ &
             psn(ix,jy,1,mind2,inest)*dt1)*dtt
        tt2conv=(tt2n(ix,jy,1,mind1,inest)*dt2+ &
             tt2n(ix,jy,1,mind2,inest)*dt1)*dtt
        td2conv=(td2n(ix,jy,1,mind1,inest)*dt2+ &
             td2n(ix,jy,1,mind2,inest)*dt1)*dtt
!!$        do kz=1,nconvlev+1    !old
        do kz=1,nuvz-1           !bugfix
          tconv(kz)=(tthn(ix,jy,kz+1,mind1,inest)*dt2+ &
               tthn(ix,jy,kz+1,mind2,inest)*dt1)*dtt
          qconv(kz)=(qvhn(ix,jy,kz+1,mind1,inest)*dt2+ &
               qvhn(ix,jy,kz+1,mind2,inest)*dt1)*dtt
        end do

  ! calculate translocation matrix
  !*******************************
        call calcmatrix(lconv,delt,cbasefluxn(ix,jy,inest))
        igrold = igr
        ktop = 0
      endif

  ! treat particle only if column has convection
      if (lconv .eqv. .true.) then
  ! assign new vertical position to particle
        ztold=ztra1(ipart)
        call redist(ipart,ktop,ipconv)
  !      if (ipconv.le.0) sumconv = sumconv+1

  ! Calculate the gross fluxes across layer interfaces
  !***************************************************

        if (iflux.eq.1) then
          itage=abs(itra1(ipart)-itramem(ipart))
          do nage=1,nageclass
            if (itage.lt.lage(nage)) goto 47
          end do
 47       continue

          if (nage.le.nageclass) &
               call calcfluxes(nage,ipart,real(xtra1(ipart)), &
               real(ytra1(ipart)),ztold)
        endif

      endif !(lconv .eqv. .true.)


60    continue
    end do
  end do
  !--------------------------------------------------------------------------
  !write(*,*)'############################################'
  !write(*,*)'TIME=',
  !    &  itime
  !write(*,*)'fraction of particles under convection',
  !    &  sumconv/(sumall+0.001)
  !write(*,*)'total number of particles',
  !    &  sumall
  !write(*,*)'number of particles under convection',
  !    &  sumconv
  !write(*,*)'############################################'

  return
end subroutine convmix

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

! From numerical recipes
! Change by A. Stohl: Use of integer instead of real values

subroutine sort2(n,arr,brr)

  implicit none

  integer :: n
  integer :: arr(n),brr(n)
  integer,parameter :: m=7,nstack=50
  integer :: i,ir,j,jstack,k,l,istack(nstack)
  integer :: a,b,temp
  jstack=0
  l=1
  ir=n
1   if(ir-l.lt.m)then
    do j=l+1,ir
      a=arr(j)
      b=brr(j)
      do i=j-1,1,-1
        if(arr(i).le.a)goto 2
        arr(i+1)=arr(i)
        brr(i+1)=brr(i)
      end do
      i=0
2     arr(i+1)=a
      brr(i+1)=b
    end do
    if(jstack.eq.0)return
    ir=istack(jstack)
    l=istack(jstack-1)
    jstack=jstack-2
  else
    k=(l+ir)/2
    temp=arr(k)
    arr(k)=arr(l+1)
    arr(l+1)=temp
    temp=brr(k)
    brr(k)=brr(l+1)
    brr(l+1)=temp
    if(arr(l+1).gt.arr(ir))then
      temp=arr(l+1)
      arr(l+1)=arr(ir)
      arr(ir)=temp
      temp=brr(l+1)
      brr(l+1)=brr(ir)
      brr(ir)=temp
    endif
    if(arr(l).gt.arr(ir))then
      temp=arr(l)
      arr(l)=arr(ir)
      arr(ir)=temp
      temp=brr(l)
      brr(l)=brr(ir)
      brr(ir)=temp
    endif
    if(arr(l+1).gt.arr(l))then
      temp=arr(l+1)
      arr(l+1)=arr(l)
      arr(l)=temp
      temp=brr(l+1)
      brr(l+1)=brr(l)
      brr(l)=temp
    endif
    i=l+1
    j=ir
    a=arr(l)
    b=brr(l)
3   continue
      i=i+1
    if(arr(i).lt.a)goto 3
4   continue
      j=j-1
    if(arr(j).gt.a)goto 4
    if(j.lt.i)goto 5
    temp=arr(i)
    arr(i)=arr(j)
    arr(j)=temp
    temp=brr(i)
    brr(i)=brr(j)
    brr(j)=temp
    goto 3
5   arr(l)=arr(j)
    arr(j)=a
    brr(l)=brr(j)
    brr(j)=b
    jstack=jstack+2
    if(jstack.gt.nstack) then
       print*, 'nstack too small in sort2'
       stop
    end if
    if(ir-i+1.ge.j-l)then
      istack(jstack)=ir
      istack(jstack-1)=i
      ir=j-1
    else
      istack(jstack)=j-1
      istack(jstack-1)=l
      l=i
    endif
  endif
  goto 1
end subroutine sort2
!  (C) Copr. 1986-92 Numerical Recipes Software us.

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine openouttraj

  !*****************************************************************************
  !                                                                            *
  !   This routine opens the output file for the plume trajectory output       *
  !   produced by the cluster analysis.                                        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     27 January 2001                                                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod

  implicit none

  integer :: i
  real :: xp1,yp1,xp2,yp2


  ! Open output file for trajectory output
  !***************************************

  open(unitouttraj,file=path(2)(1:length(2))//'trajectories.txt', &
       form='formatted',err=998)

  if (ldirect.eq.1) then
  write(unitouttraj,'(i8,1x,i6,1x,a)') ibdate,ibtime,'FLEXPART V8.2'
  else
  write(unitouttraj,'(i8,1x,i6,1x,a)') iedate,ietime,'FLEXPART V8.2'
  endif
  write(unitouttraj,*) method,lsubgrid,lconvection
  write(unitouttraj,*) numpoint
  do i=1,numpoint
    xp1=xpoint1(i)*dx+xlon0
    yp1=ypoint1(i)*dy+ylat0
    xp2=xpoint2(i)*dx+xlon0
    yp2=ypoint2(i)*dy+ylat0
    write(unitouttraj,*) ireleasestart(i),ireleaseend(i), &
         xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i),kindz(i),npart(i)
    if (numpoint.le.1000) then
      write(unitouttraj,'(a)') compoint(i)(1:40)
    else
      write(unitouttraj,'(a)') compoint(1001)(1:40)
    endif
  end do

  return

998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### trajectories.txt                         #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  stop

end subroutine openouttraj

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readpartpositions

  !*****************************************************************************
  !                                                                            *
  !   This routine opens the particle dump file and reads all the particle     *
  !   positions from a previous run to initialize the current run.             *
  !                                                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 March 2000                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: ibdatein,ibtimein,nspecin,itimein,numpointin,i,j,ix
  integer :: id1,id2,it1,it2
  real :: xlonin,ylatin,ran1,topo,hmixi,pvi,qvi,rhoi,tri,tti
  character :: specin*7
  real(kind=dp) :: julin,julpartin,juldate

  integer :: idummy = -8

  numparticlecount=0

  ! Open header file of dumped particle data
  !*****************************************

  open(unitpartin,file=path(2)(1:length(2))//'header', &
       form='unformatted',err=998)

  read(unitpartin) ibdatein,ibtimein
  read(unitpartin)
  read(unitpartin)

  read(unitpartin)
  read(unitpartin)
  read(unitpartin) nspecin
  nspecin=nspecin/3
  if ((ldirect.eq.1).and.(nspec.ne.nspecin)) goto 997

  do i=1,nspecin
    read(unitpartin)
    read(unitpartin)
    read(unitpartin) j,specin
    if ((ldirect.eq.1).and.(species(i)(1:7).ne.specin)) goto 996
  end do

  read(unitpartin) numpointin
  if (numpointin.ne.numpoint) goto 995
  do i=1,numpointin
    read(unitpartin)
    read(unitpartin)
    read(unitpartin)
    read(unitpartin)
    do j=1,nspec
      read(unitpartin)
      read(unitpartin)
      read(unitpartin)
    end do
  end do
  read(unitpartin)
  read(unitpartin)

  do ix=0,numxgrid-1
    read(unitpartin)
  end do


  ! Open data file of dumped particle data
  !***************************************

  close(unitpartin)
  open(unitpartin,file=path(2)(1:length(2))//'partposit_end', &
       form='unformatted',err=998)


100   read(unitpartin,end=99) itimein
    i=0
200   i=i+1
    read(unitpartin) npoint(i),xlonin,ylatin,ztra1(i),itramem(i), &
         topo,pvi,qvi,rhoi,hmixi,tri,tti,(xmass1(i,j),j=1,nspec)

    if (xlonin.eq.-9999.9) goto 100
    xtra1(i)=(xlonin-xlon0)/dx
    ytra1(i)=(ylatin-ylat0)/dy
    numparticlecount=max(numparticlecount,npoint(i))
    goto 200

99   numpart=i-1

  close(unitpartin)

  julin=juldate(ibdatein,ibtimein)+real(itimein,kind=dp)/86400._dp
  if (abs(julin-bdate).gt.1.e-5) goto 994
  do i=1,numpart
    julpartin=juldate(ibdatein,ibtimein)+ &
         real(itramem(i),kind=dp)/86400._dp
    nclass(i)=min(int(ran1(idummy)*real(nclassunc))+1, &
         nclassunc)
    idt(i)=mintime
    itra1(i)=0
    itramem(i)=nint((julpartin-bdate)*86400.)
    itrasplit(i)=ldirect*itsplit
  end do

  return


994   write(*,*) ' #### FLEXPART MODEL ERROR IN READPARTPOSITIONS#### '
  write(*,*) ' #### ENDING TIME OF PREVIOUS MODEL RUN DOES   #### '
  write(*,*) ' #### NOT AGREE WITH STARTING TIME OF THIS RUN.#### '
  call caldate(julin,id1,it1)
  call caldate(bdate,id2,it2)
  write(*,*) 'julin: ',julin,id1,it1
  write(*,*) 'bdate: ',bdate,id2,it2
  stop

995   write(*,*) ' #### FLEXPART MODEL ERROR IN READPARTPOSITIONS#### '
  write(*,*) ' #### NUMBER OF RELEASE LOCATIONS DOES NOT     #### '
  write(*,*) ' #### AGREE WITH CURRENT SETTINGS!             #### '
  stop

996   write(*,*) ' #### FLEXPART MODEL ERROR IN READPARTPOSITIONS#### '
  write(*,*) ' #### SPECIES NAMES TO BE READ IN DO NOT       #### '
  write(*,*) ' #### AGREE WITH CURRENT SETTINGS!             #### '
  stop

997   write(*,*) ' #### FLEXPART MODEL ERROR IN READPARTPOSITIONS#### '
  write(*,*) ' #### THE NUMBER OF SPECIES TO BE READ IN DOES #### '
  write(*,*) ' #### NOT AGREE WITH CURRENT SETTINGS!         #### '
  stop

998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'grid'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  stop

end subroutine readpartpositions

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readpaths

  !*****************************************************************************
  !                                                                            *
  !     Reads the pathnames, where input/output files are expected to be.      *
  !     The file pathnames must be available in the current working directory. *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     1 February 1994                                                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! length(numpath)    lengths of the path names                               *
  ! path(numpath)      pathnames of input/output files                         *
  !                                                                            *
  ! Constants:                                                                 *
  ! numpath            number of pathnames to be read in                       *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: i

  ! Read the pathname information stored in unitpath
  !*************************************************


  open(unitpath,file='pathnames',status='old',err=999)

  do i=1,numpath
    read(unitpath,'(a)',err=998) path(i)
    length(i)=index(path(i),' ')-1
  end do

  ! Check whether any nested subdomains are to be used
  !***************************************************

  do i=1,maxnests
    read(unitpath,'(a)') path(numpath+2*(i-1)+1)
    read(unitpath,'(a)') path(numpath+2*(i-1)+2)
    if (path(numpath+2*(i-1)+1)(1:5).eq.'=====') goto 30
    length(numpath+2*(i-1)+1)=index(path(numpath+2*(i-1)+1),' ')-1
    length(numpath+2*(i-1)+2)=index(path(numpath+2*(i-1)+2),' ')-1
  end do


  ! Determine number of available nested domains
  !*********************************************

30   numbnests=i-1

  close(unitpath)
  return

998   write(*,*) ' #### TRAJECTORY MODEL ERROR! ERROR WHILE     #### '
  write(*,*) ' #### READING FILE PATHNAMES.                 #### '
  stop

999   write(*,*) ' #### TRAJECTORY MODEL ERROR! FILE "pathnames"#### '
  write(*,*) ' #### CANNOT BE OPENED IN THE CURRENT WORKING #### '
  write(*,*) ' #### DIRECTORY.                              #### '
  stop

end subroutine readpaths

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readwind(indj,n,uuh,vvh,wwh)

  !**********************************************************************
  !                                                                     *
  !             TRAJECTORY MODEL SUBROUTINE READWIND                    *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  !             AUTHOR:      G. WOTAWA                                  *
  !             DATE:        1997-08-05                                 *
  !             LAST UPDATE: 2000-10-17, Andreas Stohl                  *
  !             CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with *
  !                                 ECMWF grib_api                      *
  !             CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
  !                                 ECMWF grib_api                      *
  !                                                                     *
  !**********************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:
  !   Variables tth and qvh (on eta coordinates) in common block
  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION:                                                        *
  !                                                                     *
  ! READING OF ECMWF METEOROLOGICAL FIELDS FROM INPUT DATA FILES. THE   *
  ! INPUT DATA FILES ARE EXPECTED TO BE AVAILABLE IN GRIB CODE          *
  !                                                                     *
  ! INPUT:                                                              *
  ! indj               indicates number of the wind field to be read in *
  ! n                  temporal index for meteorological fields (1 to 3)*
  !                                                                     *
  ! IMPORTANT VARIABLES FROM COMMON BLOCK:                              *
  !                                                                     *
  ! wfname             File name of data to be read in                  *
  ! nx,ny,nuvz,nwz     expected field dimensions                        *
  ! nlev_ec            number of vertical levels ecmwf model            *
  ! uu,vv,ww           wind fields                                      *
  ! tt,qv              temperature and specific humidity                *
  ! ps                 surface pressure                                 *
  !                                                                     *
  !**********************************************************************

  use GRIB_API
  use par_mod
  use com_mod

  implicit none

  !HSO  parameters for grib_api
  integer :: ifile
  integer :: iret
  integer :: igrib
  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
  integer :: gotGrid
  !HSO  end

  real(kind=4) :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real(kind=4) :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real(kind=4) :: wwh(0:nxmax-1,0:nymax-1,nwzmax)
  integer :: indj,i,j,k,n,levdiff2,ifield,iumax,iwmax

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  ! dimension of isec2 at least (22+n), where n is the number of parallels or
  ! meridians in a quasi-regular (reduced) Gaussian or lat/long grid

  ! dimension of zsec2 at least (10+nn), where nn is the number of vertical
  ! coordinate parameters

  integer :: isec1(56),isec2(22+nxmax+nymax)
  real(kind=4) :: zsec4(jpunp)
  real(kind=4) :: xaux,yaux,xaux0,yaux0
  real(kind=8) :: xauxin,yauxin
  real,parameter :: eps=1.e-4
  real(kind=4) :: nsss(0:nxmax-1,0:nymax-1),ewss(0:nxmax-1,0:nymax-1)
  real :: plev1,pmean,tv,fu,hlev1,ff10m,fflev1

  logical :: hflswitch,strswitch

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: gribFunction = 'readwind'

  hflswitch=.false.
  strswitch=.false.
  levdiff2=nlev_ec-nwz+1
  iumax=0
  iwmax=0

  !
  ! OPENING OF DATA FILE (GRIB CODE)
  !
5   call grib_open_file(ifile,path(3)(1:length(3)) &
         //trim(wfname(indj)),'r',iret)
  if (iret.ne.GRIB_SUCCESS) then
    goto 888   ! ERROR DETECTED
  endif
  !turn on support for multi fields messages */
  !call grib_multi_support_on

  gotGrid=0
  ifield=0
10   ifield=ifield+1
  !
  ! GET NEXT FIELDS
  !
  call grib_new_from_file(ifile,igrib,iret)
  if (iret.eq.GRIB_END_OF_FILE)  then
    goto 50    ! EOF DETECTED
  elseif (iret.ne.GRIB_SUCCESS) then
    goto 888   ! ERROR DETECTED
  endif

  !first see if we read GRIB1 or GRIB2
  call grib_get_int(igrib,'editionNumber',gribVer,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  if (gribVer.eq.1) then ! GRIB Edition 1

  !print*,'GRiB Edition 1'
  !read the grib2 identifiers
  call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',isec1(8),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !change code for etadot to code for omega
  if (isec1(6).eq.77) then
    isec1(6)=135
  endif

  else

  !print*,'GRiB Edition 2'
  !read the grib2 identifiers
  call grib_get_int(igrib,'discipline',discipl,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterCategory',parCat,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterNumber',parNum,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',valSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !print*,discipl,parCat,parNum,typSurf,valSurf

  !convert to grib1 identifiers
  isec1(6)=-1
  isec1(7)=-1
  isec1(8)=-1
  isec1(8)=valSurf     ! level
  if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! T
    isec1(6)=130         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105)) then ! U
    isec1(6)=131         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105)) then ! V
    isec1(6)=132         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! Q
    isec1(6)=133         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1)) then !SP
    isec1(6)=134         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
    isec1(6)=135         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
    isec1(6)=151         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103)) then ! 10U
    isec1(6)=165         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103)) then ! 10V
    isec1(6)=166         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103)) then ! 2T
    isec1(6)=167         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103)) then ! 2D
    isec1(6)=168         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
    isec1(6)=141         ! indicatorOfParameter
  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
    isec1(6)=164         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
    isec1(6)=142         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
    isec1(6)=143         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SHF
    isec1(6)=146         ! indicatorOfParameter
  elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
    isec1(6)=176         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
    isec1(6)=180         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
    isec1(6)=181         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
    isec1(6)=129         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
    isec1(6)=160         ! indicatorOfParameter
  elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
       (typSurf.eq.1)) then ! LSM
    isec1(6)=172         ! indicatorOfParameter
  else
    print*,'***ERROR: undefined GRiB2 message found!',discipl, &
         parCat,parNum,typSurf
  endif

  endif

  !HSO  get the size and data of the values array
  if (isec1(6).ne.-1) then
    call grib_get_real4_array(igrib,'values',zsec4,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
  endif

  !HSO  get the required fields from section 2 in a gribex compatible manner
  if (ifield.eq.1) then
  call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
       isec2(2),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
       isec2(3),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'numberOfVerticalCoordinateValues', &
       isec2(12))
  call grib_check(iret,gribFunction,gribErrorMsg)
  ! CHECK GRID SPECIFICATIONS
  if(isec2(2).ne.nxfield) stop 'READWIND: NX NOT CONSISTENT'
  if(isec2(3).ne.ny) stop 'READWIND: NY NOT CONSISTENT'
  if(isec2(12)/2-1.ne.nlev_ec) &
       stop 'READWIND: VERTICAL DISCRETIZATION NOT CONSISTENT'
  endif ! ifield

  !HSO  get the second part of the grid dimensions only from GRiB1 messages
  if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
    call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
         xauxin,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
         yauxin,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    xaux=xauxin+real(nxshift)*dx
    yaux=yauxin
    xaux0=xlon0
    yaux0=ylat0
    if(xaux.lt.0.) xaux=xaux+360.
    if(yaux.lt.0.) yaux=yaux+360.
    if(xaux0.lt.0.) xaux0=xaux0+360.
    if(yaux0.lt.0.) yaux0=yaux0+360.
    if(abs(xaux-xaux0).gt.eps) &
         stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT'
    if(abs(yaux-yaux0).gt.eps) &
         stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT'
    gotGrid=1
  endif ! gotGrid

  do j=0,nymin1
    do i=0,nxfield-1
      k=isec1(8)
      if(isec1(6).eq.130) tth(i,j,nlev_ec-k+2,n)= &!! TEMPERATURE
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.131) uuh(i,j,nlev_ec-k+2)= &!! U VELOCITY
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.132) vvh(i,j,nlev_ec-k+2)= &!! V VELOCITY
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.133) then                      !! SPEC. HUMIDITY
        qvh(i,j,nlev_ec-k+2,n)=zsec4(nxfield*(ny-j-1)+i+1)
        if (qvh(i,j,nlev_ec-k+2,n) .lt. 0.) &
             qvh(i,j,nlev_ec-k+2,n) = 0.
  !        this is necessary because the gridded data may contain
  !        spurious negative values
      endif
      if(isec1(6).eq.134) ps(i,j,1,n)= &!! SURF. PRESS.
           zsec4(nxfield*(ny-j-1)+i+1)

      if(isec1(6).eq.135) wwh(i,j,nlev_ec-k+1)= &!! W VELOCITY
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.141) sd(i,j,1,n)= &!! SNOW DEPTH
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.151) msl(i,j,1,n)= &!! SEA LEVEL PRESS.
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.164) tcc(i,j,1,n)= &!! CLOUD COVER
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.165) u10(i,j,1,n)= &!! 10 M U VELOCITY
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.166) v10(i,j,1,n)= &!! 10 M V VELOCITY
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.167) tt2(i,j,1,n)= &!! 2 M TEMPERATURE
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.168) td2(i,j,1,n)= &!! 2 M DEW POINT
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.142) then                      !! LARGE SCALE PREC.
        lsprec(i,j,1,n)=zsec4(nxfield*(ny-j-1)+i+1)
        if (lsprec(i,j,1,n).lt.0.) lsprec(i,j,1,n)=0.
      endif
      if(isec1(6).eq.143) then                      !! CONVECTIVE PREC.
        convprec(i,j,1,n)=zsec4(nxfield*(ny-j-1)+i+1)
        if (convprec(i,j,1,n).lt.0.) convprec(i,j,1,n)=0.
      endif
      if(isec1(6).eq.146) sshf(i,j,1,n)= &!! SENS. HEAT FLUX
           zsec4(nxfield*(ny-j-1)+i+1)
      if((isec1(6).eq.146).and.(zsec4(nxfield*(ny-j-1)+i+1).ne.0.)) &
           hflswitch=.true.    ! Heat flux available
      if(isec1(6).eq.176) then                      !! SOLAR RADIATION
        ssr(i,j,1,n)=zsec4(nxfield*(ny-j-1)+i+1)
        if (ssr(i,j,1,n).lt.0.) ssr(i,j,1,n)=0.
      endif
      if(isec1(6).eq.180) ewss(i,j)= &!! EW SURFACE STRESS
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.181) nsss(i,j)= &!! NS SURFACE STRESS
           zsec4(nxfield*(ny-j-1)+i+1)
      if(((isec1(6).eq.180).or.(isec1(6).eq.181)).and. &
           (zsec4(nxfield*(ny-j-1)+i+1).ne.0.)) strswitch=.true.    ! stress available
  !sec        strswitch=.true.
      if(isec1(6).eq.129) oro(i,j)= &!! ECMWF OROGRAPHY
           zsec4(nxfield*(ny-j-1)+i+1)/ga
      if(isec1(6).eq.160) excessoro(i,j)= &!! STANDARD DEVIATION OF OROGRAPHY
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.172) lsm(i,j)= &!! ECMWF LAND SEA MASK
           zsec4(nxfield*(ny-j-1)+i+1)
      if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
      if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+1)

    end do
  end do

  call grib_release(igrib)
  goto 10                      !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !

50   call grib_close_file(ifile)

  !error message if no fields found with correct first longitude in it
  if (gotGrid.eq.0) then
    print*,'***ERROR: input file needs to contain GRiB1 formatted'// &
         'messages'
    stop
  endif

  if(levdiff2.eq.0) then
    iwmax=nlev_ec+1
    do i=0,nxmin1
      do j=0,nymin1
        wwh(i,j,nlev_ec+1)=0.
      end do
    end do
  endif

  ! For global fields, assign the leftmost data column also to the rightmost
  ! data column; if required, shift whole grid by nxshift grid points
  !*************************************************************************

  if (xglobal) then
    call shift_field_0(ewss,nxfield,ny)
    call shift_field_0(nsss,nxfield,ny)
    call shift_field_0(oro,nxfield,ny)
    call shift_field_0(excessoro,nxfield,ny)
    call shift_field_0(lsm,nxfield,ny)
    call shift_field(ps,nxfield,ny,1,1,2,n)
    call shift_field(sd,nxfield,ny,1,1,2,n)
    call shift_field(msl,nxfield,ny,1,1,2,n)
    call shift_field(tcc,nxfield,ny,1,1,2,n)
    call shift_field(u10,nxfield,ny,1,1,2,n)
    call shift_field(v10,nxfield,ny,1,1,2,n)
    call shift_field(tt2,nxfield,ny,1,1,2,n)
    call shift_field(td2,nxfield,ny,1,1,2,n)
    call shift_field(lsprec,nxfield,ny,1,1,2,n)
    call shift_field(convprec,nxfield,ny,1,1,2,n)
    call shift_field(sshf,nxfield,ny,1,1,2,n)
    call shift_field(ssr,nxfield,ny,1,1,2,n)
    call shift_field(tth,nxfield,ny,nuvzmax,nuvz,2,n)
    call shift_field(qvh,nxfield,ny,nuvzmax,nuvz,2,n)
    call shift_field(uuh,nxfield,ny,nuvzmax,nuvz,1,1)
    call shift_field(vvh,nxfield,ny,nuvzmax,nuvz,1,1)
    call shift_field(wwh,nxfield,ny,nwzmax,nwz,1,1)
  endif

  do i=0,nxmin1
    do j=0,nymin1
      surfstr(i,j,1,n)=sqrt(ewss(i,j)**2+nsss(i,j)**2)
    end do
  end do

  if ((.not.hflswitch).or.(.not.strswitch)) then
    write(*,*) 'WARNING: No flux data contained in GRIB file ', &
         wfname(indj)

  ! CALCULATE USTAR AND SSHF USING THE PROFILE METHOD
  ! As ECMWF has increased the model resolution, such that now the first model
  ! level is at about 10 m (where 10-m wind is given), use the 2nd ECMWF level
  ! (3rd model level in FLEXPART) for the profile method
  !***************************************************************************

    do i=0,nxmin1
      do j=0,nymin1
        plev1=akz(3)+bkz(3)*ps(i,j,1,n)
        pmean=0.5*(ps(i,j,1,n)+plev1)
        tv=tth(i,j,3,n)*(1.+0.61*qvh(i,j,3,n))
        fu=-r_air*tv/ga/pmean
        hlev1=fu*(plev1-ps(i,j,1,n))   ! HEIGTH OF FIRST MODEL LAYER
        ff10m= sqrt(u10(i,j,1,n)**2+v10(i,j,1,n)**2)
        fflev1=sqrt(uuh(i,j,3)**2+vvh(i,j,3)**2)
        call pbl_profile(ps(i,j,1,n),td2(i,j,1,n),hlev1, &
             tt2(i,j,1,n),tth(i,j,3,n),ff10m,fflev1, &
             surfstr(i,j,1,n),sshf(i,j,1,n))
        if(sshf(i,j,1,n).gt.200.) sshf(i,j,1,n)=200.
        if(sshf(i,j,1,n).lt.-400.) sshf(i,j,1,n)=-400.
      end do
    end do
  endif


  ! Assign 10 m wind to model level at eta=1.0 to have one additional model
  ! level at the ground
  ! Specific humidity is taken the same as at one level above
  ! Temperature is taken as 2 m temperature
  !**************************************************************************

     do i=0,nxmin1
        do j=0,nymin1
           uuh(i,j,1)=u10(i,j,1,n)
           vvh(i,j,1)=v10(i,j,1,n)
           qvh(i,j,1,n)=qvh(i,j,2,n)
           tth(i,j,1,n)=tt2(i,j,1,n)
        end do
     end do

  if(iumax.ne.nuvz-1) stop 'READWIND: NUVZ NOT CONSISTENT'
  if(iwmax.ne.nwz)    stop 'READWIND: NWZ NOT CONSISTENT'

  return
888   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfname(indj),'                    #### '
  write(*,*) ' #### IS NOT GRIB FORMAT !!!                  #### '
  stop 'Execution terminated'
999   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfname(indj),'                    #### '
  write(*,*) ' #### CANNOT BE OPENED !!!                    #### '
  stop 'Execution terminated'

end subroutine readwind

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine hanna(z)
  !                 i
  !*****************************************************************************
  !                                                                            *
  !   Computation of \sigma_i and \tau_L based on the scheme of Hanna (1982)   *
  !                                                                            *
  !   Author: A. Stohl                                                         *
  !                                                                            *
  !   4 December 1997                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dsigwdz [1/s]     vertical gradient of sigw                                *
  ! ol [m]            Obukhov length                                           *
  ! sigu, sigv, sigw  standard deviations of turbulent velocity fluctuations   *
  ! tlu [s]           Lagrangian time scale for the along wind component.      *
  ! tlv [s]           Lagrangian time scale for the cross wind component.      *
  ! tlw [s]           Lagrangian time scale for the vertical wind component.   *
  ! ust, ustar [m/s]  friction velocity                                        *
  ! wst, wstar [m/s]  convective velocity scale                                *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use hanna_mod

  implicit none

  real :: corr,z



  !**********************
  ! 1. Neutral conditions
  !**********************

  if (h/abs(ol).lt.1.) then
    ust=max(1.e-4,ust)
    corr=z/ust
    sigu=1.e-2+2.0*ust*exp(-3.e-4*corr)
    sigw=1.3*ust*exp(-2.e-4*corr)
    dsigwdz=-2.e-4*sigw
    sigw=sigw+1.e-2
    sigv=sigw
    tlu=0.5*z/sigw/(1.+1.5e-3*corr)
    tlv=tlu
    tlw=tlu


  !***********************
  ! 2. Unstable conditions
  !***********************

  else if (ol.lt.0.) then


  ! Determine sigmas
  !*****************

    sigu=1.e-2+ust*(12-0.5*h/ol)**0.33333
    sigv=sigu
    sigw=sqrt(1.2*wst**2*(1.-.9*zeta)*zeta**0.66666+ &
         (1.8-1.4*zeta)*ust**2)+1.e-2
    dsigwdz=0.5/sigw/h*(-1.4*ust**2+wst**2* &
         (0.8*max(zeta,1.e-3)**(-.33333)-1.8*zeta**0.66666))


  ! Determine average Lagrangian time scale
  !****************************************

    tlu=0.15*h/sigu
    tlv=tlu
    if (z.lt.abs(ol)) then
      tlw=0.1*z/(sigw*(0.55-0.38*abs(z/ol)))
    else if (zeta.lt.0.1) then
      tlw=0.59*z/sigw
    else
      tlw=0.15*h/sigw*(1.-exp(-5*zeta))
    endif


  !*********************
  ! 3. Stable conditions
  !*********************

  else
    sigu=1.e-2+2.*ust*(1.-zeta)
    sigv=1.e-2+1.3*ust*(1.-zeta)
    sigw=sigv
    dsigwdz=-1.3*ust/h
    tlu=0.15*h/sigu*(sqrt(zeta))
    tlv=0.467*tlu
    tlw=0.1*h/sigw*zeta**0.8
  endif


  tlu=max(10.,tlu)
  tlv=max(10.,tlv)
  tlw=max(30.,tlw)

  if (dsigwdz.eq.0.) dsigwdz=1.e-10

end subroutine hanna

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine releaseparticles(itime)
  !                              o
  !*****************************************************************************
  !                                                                            *
  !     This subroutine releases particles from the release locations.         *
  !                                                                            *
  !     It searches for a "vacant" storage space and assigns all particle      *
  !     information to that space. A space is vacant either when no particle   *
  !     is yet assigned to it, or when it's particle is expired and, thus,     *
  !     the storage space is made available to a new particle.                 *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     29 June 2002                                                           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]            current time                                          *
  ! ireleasestart, ireleaseend          start and end times of all releases    *
  ! npart(maxpoint)      number of particles to be released in total           *
  ! numrel               number of particles to be released during this time   *
  !                      step                                                  *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use xmass_mod
  use par_mod
  use com_mod

  implicit none

  !real xaux,yaux,zaux,ran1,rfraction,xmasssave(maxpoint)
  real :: xaux,yaux,zaux,ran1,rfraction
  real :: topo,rhoaux(2),r,t,rhoout,ddx,ddy,rddx,rddy,p1,p2,p3,p4
  real :: dz1,dz2,dz,xtn,ytn,xlonav,timecorrect(maxspec),press,pressold
  real :: presspart,average_timecorrect
  integer :: itime,numrel,i,j,k,n,ix,jy,ixp,jyp,ipart,minpart,ii
  integer :: indz,indzp,kz,ngrid
  integer :: nweeks,ndayofweek,nhour,jjjjmmdd,ihmmss,mm
  real(kind=dp) :: juldate,julmonday,jul,jullocal,juldiff
  real,parameter :: eps=nxmax/3.e5,eps2=1.e-6

  integer :: idummy = -7
  !save idummy,xmasssave
  !data idummy/-7/,xmasssave/maxpoint*0./


  ! Determine the actual date and time in Greenwich (i.e., UTC + correction for daylight savings time)
  !*****************************************************************************

  julmonday=juldate(19000101,0)          ! this is a Monday
  jul=bdate+real(itime,kind=dp)/86400._dp    ! this is the current day
  call caldate(jul,jjjjmmdd,ihmmss)
  mm=(jjjjmmdd-10000*(jjjjmmdd/10000))/100
  if ((mm.ge.4).and.(mm.le.9)) jul=jul+1._dp/24._dp   ! daylight savings time in summer


  ! For every release point, check whether we are in the release time interval
  !***************************************************************************

  minpart=1
  do i=1,numpoint
    if ((itime.ge.ireleasestart(i)).and. &! are we within release interval?
         (itime.le.ireleaseend(i))) then

  ! Determine the local day and time
  !*********************************

      xlonav=xlon0+(xpoint2(i)+xpoint1(i))/2.*dx  ! longitude needed to determine local time
      if (xlonav.lt.-180.) xlonav=xlonav+360.
      if (xlonav.gt.180.) xlonav=xlonav-360.
      jullocal=jul+real(xlonav,kind=dp)/360._dp   ! correct approximately for time zone to obtain local time

      juldiff=jullocal-julmonday
      nweeks=int(juldiff/7._dp)
      juldiff=juldiff-real(nweeks,kind=dp)*7._dp
      ndayofweek=int(juldiff)+1              ! this is the current day of week, starting with Monday
      nhour=nint((juldiff-real(ndayofweek-1,kind=dp))*24._dp)    ! this is the current hour
      if (nhour.eq.0) then
        nhour=24
        ndayofweek=ndayofweek-1
        if (ndayofweek.eq.0) ndayofweek=7
      endif

  ! Calculate a species- and time-dependent correction factor, distinguishing between
  ! area (those with release starting at surface) and point (release starting above surface) sources
  ! Also, calculate an average time correction factor (species independent)
  !*****************************************************************************
      average_timecorrect=0.
      do k=1,nspec
        if (zpoint1(i).gt.0.5) then      ! point source
          timecorrect(k)=point_hour(k,nhour)*point_dow(k,ndayofweek)
        else                             ! area source
          timecorrect(k)=area_hour(k,nhour)*area_dow(k,ndayofweek)
        endif
        average_timecorrect=average_timecorrect+timecorrect(k)
      end do
      average_timecorrect=average_timecorrect/real(nspec)

  ! Determine number of particles to be released this time; at start and at end of release,
  ! only half the particles are released
  !*****************************************************************************

      if (ireleasestart(i).ne.ireleaseend(i)) then
        rfraction=abs(real(npart(i))*real(lsynctime)/ &
             real(ireleaseend(i)-ireleasestart(i)))
        if ((itime.eq.ireleasestart(i)).or. &
             (itime.eq.ireleaseend(i))) rfraction=rfraction/2.

  ! Take the species-average time correction factor in order to scale the
  ! number of particles released this time
  !**********************************************************************
        rfraction=rfraction*average_timecorrect

        rfraction=rfraction+xmasssave(i)  ! number to be released at this time
        numrel=int(rfraction)
        xmasssave(i)=rfraction-real(numrel)
      else
        numrel=npart(i)
      endif

      xaux=xpoint2(i)-xpoint1(i)
      yaux=ypoint2(i)-ypoint1(i)
      zaux=zpoint2(i)-zpoint1(i)
      do j=1,numrel                       ! loop over particles to be released this time
        do ipart=minpart,maxpart          ! search for free storage space

  ! If a free storage space is found, attribute everything to this array element
  !*****************************************************************************

          if (itra1(ipart).ne.itime) then

  ! Particle coordinates are determined by using a random position within the release volume
  !*****************************************************************************

  ! Determine horizontal particle position
  !***************************************

            xtra1(ipart)=xpoint1(i)+ran1(idummy)*xaux
            if (xglobal) then
              if (xtra1(ipart).gt.real(nxmin1)) xtra1(ipart)= &
                   xtra1(ipart)-real(nxmin1)
              if (xtra1(ipart).lt.0.) xtra1(ipart)= &
                   xtra1(ipart)+real(nxmin1)
            endif
            ytra1(ipart)=ypoint1(i)+ran1(idummy)*yaux

  ! Assign mass to particle: Total mass divided by total number of particles.
  ! Time variation has partly been taken into account already by a species-average
  ! correction factor, by which the number of particles released this time has been
  ! scaled. Adjust the mass per particle by the species-dependent time correction factor
  ! divided by the species-average one
  !*****************************************************************************
            do k=1,nspec
               xmass1(ipart,k)=xmass(i,k)/real(npart(i)) &
                    *timecorrect(k)/average_timecorrect
  !            write (*,*) 'xmass1: ',xmass1(ipart,k),ipart,k
  ! Assign certain properties to particle
  !**************************************
            end do
            nclass(ipart)=min(int(ran1(idummy)*real(nclassunc))+1, &
                 nclassunc)
            numparticlecount=numparticlecount+1
            if (mquasilag.eq.0) then
              npoint(ipart)=i
            else
              npoint(ipart)=numparticlecount
            endif
            idt(ipart)=mintime               ! first time step
            itra1(ipart)=itime
            itramem(ipart)=itra1(ipart)
            itrasplit(ipart)=itra1(ipart)+ldirect*itsplit


  ! Determine vertical particle position
  !*************************************

            ztra1(ipart)=zpoint1(i)+ran1(idummy)*zaux

  ! Interpolation of topography and density
  !****************************************

  ! Determine the nest we are in
  !*****************************

            ngrid=0
            do k=numbnests,1,-1
              if ((xtra1(ipart).gt.xln(k)+eps).and. &
                   (xtra1(ipart).lt.xrn(k)-eps).and. &
                   (ytra1(ipart).gt.yln(k)+eps).and. &
                   (ytra1(ipart).lt.yrn(k)-eps)) then
                ngrid=k
                goto 43
              endif
            end do
43          continue

  ! Determine (nested) grid coordinates and auxiliary parameters used for interpolation
  !*****************************************************************************

            if (ngrid.gt.0) then
              xtn=(xtra1(ipart)-xln(ngrid))*xresoln(ngrid)
              ytn=(ytra1(ipart)-yln(ngrid))*yresoln(ngrid)
              ix=int(xtn)
              jy=int(ytn)
              ddy=ytn-real(jy)
              ddx=xtn-real(ix)
            else
              ix=int(xtra1(ipart))
              jy=int(ytra1(ipart))
              ddy=ytra1(ipart)-real(jy)
              ddx=xtra1(ipart)-real(ix)
            endif
            ixp=ix+1
            jyp=jy+1
            rddx=1.-ddx
            rddy=1.-ddy
            p1=rddx*rddy
            p2=ddx*rddy
            p3=rddx*ddy
            p4=ddx*ddy

            if (ngrid.gt.0) then
              topo=p1*oron(ix ,jy ,ngrid) &
                   + p2*oron(ixp,jy ,ngrid) &
                   + p3*oron(ix ,jyp,ngrid) &
                   + p4*oron(ixp,jyp,ngrid)
            else
              topo=p1*oro(ix ,jy) &
                   + p2*oro(ixp,jy) &
                   + p3*oro(ix ,jyp) &
                   + p4*oro(ixp,jyp)
            endif

  ! If starting height is in pressure coordinates, retrieve pressure profile and convert zpart1 to meters
  !*****************************************************************************
            if (kindz(i).eq.3) then
              presspart=ztra1(ipart)
              do kz=1,nz
                if (ngrid.gt.0) then
                  r=p1*rhon(ix ,jy ,kz,2,ngrid) &
                       +p2*rhon(ixp,jy ,kz,2,ngrid) &
                       +p3*rhon(ix ,jyp,kz,2,ngrid) &
                       +p4*rhon(ixp,jyp,kz,2,ngrid)
                  t=p1*ttn(ix ,jy ,kz,2,ngrid) &
                       +p2*ttn(ixp,jy ,kz,2,ngrid) &
                       +p3*ttn(ix ,jyp,kz,2,ngrid) &
                       +p4*ttn(ixp,jyp,kz,2,ngrid)
                else
                  r=p1*rho(ix ,jy ,kz,2) &
                       +p2*rho(ixp,jy ,kz,2) &
                       +p3*rho(ix ,jyp,kz,2) &
                       +p4*rho(ixp,jyp,kz,2)
                  t=p1*tt(ix ,jy ,kz,2) &
                       +p2*tt(ixp,jy ,kz,2) &
                       +p3*tt(ix ,jyp,kz,2) &
                       +p4*tt(ixp,jyp,kz,2)
                endif
                press=r*r_air*t/100.
                if (kz.eq.1) pressold=press

                if (press.lt.presspart) then
                  if (kz.eq.1) then
                    ztra1(ipart)=height(1)/2.
                  else
                    dz1=pressold-presspart
                    dz2=presspart-press
                    ztra1(ipart)=(height(kz-1)*dz2+height(kz)*dz1) &
                         /(dz1+dz2)
                  endif
                  goto 71
                endif
                pressold=press
              end do
71            continue
            endif

  ! If release positions are given in meters above sea level, subtract the
  ! topography from the starting height
  !***********************************************************************

            if (kindz(i).eq.2) ztra1(ipart)=ztra1(ipart)-topo
            if (ztra1(ipart).lt.eps2) ztra1(ipart)=eps2   ! Minimum starting height is eps2
            if (ztra1(ipart).gt.height(nz)-0.5) ztra1(ipart)= &
                 height(nz)-0.5 ! Maximum starting height is uppermost level - 0.5 meters



  ! For special simulations, multiply particle concentration air density;
  ! Simply take the 2nd field in memory to do this (accurate enough)
  !***********************************************************************
  !AF IND_SOURCE switches between different units for concentrations at the source
  !Af    NOTE that in backward simulations the release of particles takes place at the
  !Af         receptor and the sampling at the source.
  !Af          1="mass"
  !Af          2="mass mixing ratio"
  !Af IND_RECEPTOR switches between different units for concentrations at the receptor
  !Af          1="mass"
  !Af          2="mass mixing ratio"

  !Af switches for the releasefile:
  !Af IND_REL =  1 : xmass * rho
  !Af IND_REL =  0 : xmass * 1

  !Af ind_rel is defined in readcommand.f

            if (ind_rel .eq. 1) then

  ! Interpolate the air density
  !****************************

              do ii=2,nz
                if (height(ii).gt.ztra1(ipart)) then
                  indz=ii-1
                  indzp=ii
                  goto 6
                endif
              end do
6             continue

              dz1=ztra1(ipart)-height(indz)
              dz2=height(indzp)-ztra1(ipart)
              dz=1./(dz1+dz2)

              if (ngrid.gt.0) then
                do n=1,2
                  rhoaux(n)=p1*rhon(ix ,jy ,indz+n-1,2,ngrid) &
                       +p2*rhon(ixp,jy ,indz+n-1,2,ngrid) &
                       +p3*rhon(ix ,jyp,indz+n-1,2,ngrid) &
                       +p4*rhon(ixp,jyp,indz+n-1,2,ngrid)
                end do
              else
                do n=1,2
                  rhoaux(n)=p1*rho(ix ,jy ,indz+n-1,2) &
                       +p2*rho(ixp,jy ,indz+n-1,2) &
                       +p3*rho(ix ,jyp,indz+n-1,2) &
                       +p4*rho(ixp,jyp,indz+n-1,2)
                end do
              endif
              rhoout=(dz2*rhoaux(1)+dz1*rhoaux(2))*dz
              rho_rel(i)=rhoout


  ! Multiply "mass" (i.e., mass mixing ratio in forward runs) with density
  !********************************************************************

              do k=1,nspec
                xmass1(ipart,k)=xmass1(ipart,k)*rhoout
              end do
            endif


            numpart=max(numpart,ipart)
            goto 34      ! Storage space has been found, stop searching
          endif
        end do
        if (ipart.gt.maxpart) goto 996

34      minpart=ipart+1
      end do
      endif
  end do


  return

996   continue
  write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL SUBROUTINE RELEASEPARTICLES: ####'
  write(*,*) '####                                             ####'
  write(*,*) '#### ERROR - TOTAL NUMBER OF PARTICLES REQUIRED  ####'
  write(*,*) '#### EXCEEDS THE MAXIMUM ALLOWED NUMBER. REDUCE  ####'
  write(*,*) '#### EITHER NUMBER OF PARTICLES PER RELEASE POINT####'
  write(*,*) '#### OR REDUCE NUMBER OF RELEASE POINTS.         ####'
  write(*,*) '#####################################################'
  stop

end subroutine releaseparticles

!*******************************************************************************
!   Include file for convection
!   This file contains a global common block used by convect
!   and other subroutines
!   Author: P. Ferstl
!
!   Feb 2001
!
!*******************************************************************************

module conv_mod

  use par_mod, only: nconvlevmax, na, nxmax, nymax, nxmaxn, nymaxn, maxnests

  implicit none

  !integer,parameter :: nconvlevmax = nuvzmax-1, &
  !                     na = nconvlevmax+1
  !these parameters are defined in par_mod now!

  real :: pconv(nconvlevmax),phconv(na),dpr(nconvlevmax)
  real :: pconv_hpa(nconvlevmax),phconv_hpa(na)

  real :: ft(nconvlevmax), fq(nconvlevmax)
  real :: fmass(nconvlevmax,nconvlevmax),sub(nconvlevmax)
  real :: fmassfrac(nconvlevmax,nconvlevmax)
  real :: cbaseflux(0:nxmax-1,0:nymax-1)
  real :: cbasefluxn(0:nxmaxn-1,0:nymaxn-1,maxnests)
  real :: tconv(na),qconv(na),qsconv(na)
  real :: psconv,tt2conv,td2conv

  integer :: nconvlev,nconvtop

end module conv_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module outgrid_mod
  !*****************************************************************************
  !  Module storing and initialising grids                                     *
  !                                                                            *
  !  Changes                                                                   *
  !     2022 L. Bakels: moved outgrid_init, outgrid_init_nest and              *
  !                     initcond_calc to this module                       *
  !*****************************************************************************
  use par_mod
  use com_mod
  use windfields_mod

  implicit none

  real,allocatable, dimension (:) :: outheight
  real,allocatable, dimension (:) :: outheighthalf
  real,allocatable, dimension (:,:) :: oroout
  real,allocatable, dimension (:,:) :: orooutn
  real,allocatable, dimension (:,:) :: area
  real,allocatable, dimension (:,:) :: arean
  real,allocatable, dimension (:,:,:) :: volume
  real,allocatable, dimension (:,:,:) :: volumen
  real,allocatable, dimension (:,:,:) :: areaeast
  real,allocatable, dimension (:,:,:) :: areanorth
  real,allocatable, dimension (:,:,:) :: densityoutgrid
  real,allocatable, dimension (:,:,:) :: densitydrygrid ! added RLT 
  real,allocatable, dimension (:,:,:) :: factor_drygrid ! added RLT 
  real,allocatable, dimension (:,:,:) :: factor3d
  real,allocatable, dimension (:,:,:) :: grid
  real(dep_prec),allocatable, dimension (:,:) :: wetgrid
  real(dep_prec),allocatable, dimension (:,:) :: drygrid
  real,allocatable, dimension (:,:,:) :: gridsigma
  real(dep_prec),allocatable, dimension (:,:) :: drygridsigma
  real(dep_prec),allocatable, dimension (:,:) :: wetgridsigma
  real,allocatable, dimension (:) :: sparse_dump_r
  real,allocatable, dimension (:) :: sparse_dump_u
  integer,allocatable, dimension (:) :: sparse_dump_i

  real,allocatable, dimension (:,:,:,:,:,:,:) :: flux
  real,allocatable, dimension (:,:,:,:,:,:,:,:) :: flux_omp

  real,allocatable, dimension (:,:,:,:,:) :: init_cond
  real,allocatable, dimension (:,:,:,:,:,:) :: init_cond_omp

  !1 fluxw west - east
  !2 fluxe east - west
  !3 fluxs south - north
  !4 fluxn north - south
  !5 fluxu upward
  !6 fluxd downward
  !real,allocatable, dimension (:,:,:) :: areanorth
  !real,allocatable, dimension (:,:,:) :: areaeast
contains

subroutine alloc_grid

  implicit none

  integer :: stat

  ! if necessary allocate flux fields
  if (iflux.eq.1) then
    allocate(flux(6,0:numxgrid-1,0:numygrid-1,numzgrid, &
         1:nspec,1:maxpointspec_act,1:nageclass),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate flux array '
#ifdef _OPENMP
    allocate(flux_omp(6,0:numxgrid-1,0:numygrid-1,numzgrid, &
         1:nspec,1:maxpointspec_act,1:nageclass,numthreads))
    if (stat.ne.0) error stop 'ERROR: could not allocate flux_omp array '
#endif
  endif

  !write (*,*) 'Dimensions for fields', numxgrid,numygrid, &
  !     maxspec,maxpointspec_act,nclassunc,maxageclass

  ! allocate fields for concoutput with maximum dimension of outgrid
  ! and outgrid_nest

  allocate(gridsigma(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
  allocate(grid(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
  allocate(densityoutgrid(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
  ! RLT
  allocate(densitydrygrid(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
  allocate(factor_drygrid(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'

  allocate(factor3d(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
  allocate(sparse_dump_r(max(numxgrid,numxgridn)* &
       max(numygrid,numygridn)*numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'

   allocate(sparse_dump_u(max(numxgrid,numxgridn)* &
       max(numygrid,numygridn)*numzgrid),stat=stat)
        if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'

  allocate(sparse_dump_i(max(numxgrid,numxgridn)* &
       max(numygrid,numygridn)*numzgrid),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'

  ! deposition fields are only allocated for forward runs
  if (ldirect.gt.0) then
     allocate(wetgridsigma(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
     allocate(drygridsigma(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
     allocate(wetgrid(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
     allocate(drygrid(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) error stop 'ERROR: could not allocate gridunc'
  endif

  ! Initial condition field

  if (linit_cond.gt.0) then
    allocate(init_cond(0:numxgrid-1,0:numygrid-1,numzgrid,maxspec, &
         maxpointspec_act),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate init_cond'
#ifdef _OPENMP
    allocate(init_cond_omp(0:numxgrid-1,0:numygrid-1,numzgrid,maxspec, &
         maxpointspec_act,numthreads),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate init_cond_omp'
#endif
  endif
end subroutine alloc_grid

subroutine outgrid_init
  !
  !*****************************************************************************
  !                                                                            *
  !  This routine initializes the output grids                                 *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !  Changes                                                                   *
  !     2022 L. Bakels: OpenMP parallelisation                                 *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! area               surface area of all output grid cells                   *
  ! areaeast           eastward facing wall area of all output grid cells      *
  ! areanorth          northward facing wall area of all output grid cells     *
  ! volume             volumes of all output grid cells                        *
  !                                                                            *
  !*****************************************************************************

!  use ohr_mod
  use unc_mod
  use windfields_mod, only: nxmax
  implicit none

  integer :: ix,jy,kz,i,nage,l,iix,jjy,ixp,jyp,i1,j1,j,ngrid
  integer :: ks,kp,stat
  real :: ylat,gridarea,ylatp,ylatm,hzone,cosfactm,cosfactp
  real :: xlon,xl,yl,ddx,ddy,rddx,rddy,p1,p2,p3,p4,xtn,ytn,oroh
  real :: eps

  eps=nxmax/3.e5

  ! Compute surface area and volume of each grid cell: area, volume;
  ! and the areas of the northward and eastward facing walls: areaeast, areanorth
  !***********************************************************************
  do jy=0,numygrid-1
    ylat=outlat0+(real(jy)+0.5)*dyout
    ylatp=ylat+0.5*dyout
    ylatm=ylat-0.5*dyout
    if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
      hzone=dyout*r_earth*pi180
    else

  ! Calculate area of grid cell with formula M=2*pi*R*h*dx/360,
  ! see Netz, Formeln der Mathematik, 5. Auflage (1983), p.90
  !************************************************************

      cosfactp=cos(ylatp*pi180)
      cosfactm=cos(ylatm*pi180)
      if (cosfactp.lt.cosfactm) then
        hzone=sqrt(1-cosfactp**2)- &
             sqrt(1-cosfactm**2)
        hzone=hzone*r_earth
      else
        hzone=sqrt(1-cosfactm**2)- &
             sqrt(1-cosfactp**2)
        hzone=hzone*r_earth
      endif
    endif

  ! Surface are of a grid cell at a latitude ylat
  !**********************************************

    gridarea=2.*pi*r_earth*hzone*dxout/360.

    do ix=0,numxgrid-1
      area(ix,jy)=gridarea

  ! Volume = area x box height
  !***************************

      volume(ix,jy,1)=area(ix,jy)*outheight(1)
      areaeast(ix,jy,1)=dyout*r_earth*pi180*outheight(1)
      areanorth(ix,jy,1)=cos(ylat*pi180)*dxout*r_earth*pi180* &
           outheight(1)
      do kz=2,numzgrid
        areaeast(ix,jy,kz)=dyout*r_earth*pi180* &
             (outheight(kz)-outheight(kz-1))
        areanorth(ix,jy,kz)=cos(ylat*pi180)*dxout*r_earth*pi180* &
             (outheight(kz)-outheight(kz-1))
        volume(ix,jy,kz)=area(ix,jy)*(outheight(kz)-outheight(kz-1))
      end do
    end do
  end do




  !******************************************************************
  ! Determine average height of model topography in output grid cells
  !******************************************************************

  ! Loop over all output grid cells
  !********************************

  do jjy=0,numygrid-1
    do iix=0,numxgrid-1
      oroh=0.

  ! Take 100 samples of the topography in every grid cell
  !******************************************************

      do j1=1,10
        ylat=outlat0+(real(jjy)+real(j1)/10.-0.05)*dyout
        yl=(ylat-ylat0)/dy
        do i1=1,10
          xlon=outlon0+(real(iix)+real(i1)/10.-0.05)*dxout
          xl=(xlon-xlon0)/dx

  ! Determine the nest we are in
  !*****************************

          ngrid=0
          ! Temporary fix for nested layer edges: replaced eps with dxn and dyn (LB)
          do j=numbnests,1,-1
            if ((xl.gt.xln(j)+dxn(j)).and.(xl.lt.xrn(j)-dxn(j)).and. &
                 (yl.gt.yln(j)+dyn(j)).and.(yl.lt.yrn(j)-dyn(j))) then
              ngrid=j
              exit
            endif
          end do

  ! Determine (nested) grid coordinates and auxiliary parameters used for interpolation
  !*****************************************************************************

          if (ngrid.gt.0) then
            xtn=(xl-xln(ngrid))*xresoln(ngrid)
            ytn=(yl-yln(ngrid))*yresoln(ngrid)
            ix=max(min(int(xtn),nxn(ngrid)-1),0)
            jy=max(min(int(ytn),nyn(ngrid)-1),0)
            ! ix=int(xtn)
            ! jy=int(ytn)
            ddy=ytn-real(jy)
            ddx=xtn-real(ix)

          else
            ix=int(xl)
            jy=int(yl)
            ddy=yl-real(jy)
            ddx=xl-real(ix)
          endif
          ixp=ix+1
          jyp=jy+1
          rddx=1.-ddx
          rddy=1.-ddy
          p1=rddx*rddy
          p2=ddx*rddy
          p3=rddx*ddy
          p4=ddx*ddy

          if (ngrid.gt.0) then
            oroh=oroh+p1*oron(ix ,jy ,ngrid) &
                 + p2*oron(ixp,jy ,ngrid) &
                 + p3*oron(ix ,jyp,ngrid) &
                 + p4*oron(ixp,jyp,ngrid)
          else
            oroh=oroh+p1*oro(ix ,jy) &
                 + p2*oro(ixp,jy) &
                 + p3*oro(ix ,jyp) &
                 + p4*oro(ixp,jyp)
          endif
        end do
      end do

  ! Divide by the number of samples taken
  !**************************************

      oroout(iix,jjy)=oroh/100.
    end do
  end do

  !if ((ipin.ne.1).or.(ipin.ne.2).or.(ipin.ne.4)) then call alloc_grid_unc
  !call alloc_grid
  !************************
  ! Initialize output grids
  !************************

  ! Flux fields
  if (iflux.eq.1) then
    do i=1,5
      if ((ipin.ne.1).and.(ipin.ne.4)) flux(i,:,:,:,:,:,:)=0.
#ifdef _OPENMP
      flux_omp(i,:,:,:,:,:,:,:)=0.
#endif
    end do
  endif
  ! Initial condition field
  if ((nage.eq.1).and.(linit_cond.gt.0)) then
    if ((ipin.ne.1).and.(ipin.ne.4)) init_cond(:,:,:,:,:)=0.
#ifdef _OPENMP
    init_cond_omp(:,:,:,:,:,:)=0.
#endif
  endif
  ! Deposition fields
  if (ldirect.gt.0) then
    if ((ipin.ne.1).and.(ipin.ne.4)) then 
      wetgridunc(:,:,:,:,:,:)=0.
      drygridunc(:,:,:,:,:,:)=0.
    endif
#ifdef _OPENMP
    wetgridunc_omp(:,:,:,:,:,:,:)=0.
    drygridunc_omp(:,:,:,:,:,:,:)=0.
#endif
  endif
  ! Concentration fields
  if ((ipin.ne.1).and.(ipin.ne.4)) gridunc(:,:,:,:,:,:,:)=0.
  ! Weighting for LCM output
  gridcnt(:,:,:)=0.
#ifdef _OPENMP
  gridunc_omp(:,:,:,:,:,:,:,:)=0.
  gridcnt_omp(:,:,:,:)=0.
#endif

end subroutine outgrid_init

subroutine outgrid_init_nest
  !
  !*****************************************************************************
  !                                                                            *
  !  This routine calculates, for each grid cell of the output nest, the       *
  !  volume and the surface area.                                              *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !    30 August 2004                                                          *
  !                                                                            *
  !  Changes                                                                   *
  !     2022 L. Bakels: OpenMP parallelisation                                 *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! arean              surface area of all output nest cells                   *
  ! volumen            volumes of all output nest cells                        *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use windfields_mod, only: nxmax
  
  implicit none

  integer :: ix,jy,kz,ks,kp,nage,l,iix,jjy,ixp,jyp,i1,j1,j,ngrid
  integer :: stat
  real :: ylat,gridarea,ylatp,ylatm,hzone,cosfactm,cosfactp
  real :: xlon,xl,yl,ddx,ddy,rddx,rddy,p1,p2,p3,p4,xtn,ytn,oroh
  real :: eps

  eps=nxmax/3.e5

  ! Compute surface area and volume of each grid cell: area, volume;
  ! and the areas of the northward and eastward facing walls: areaeast, areanorth
  !***********************************************************************

  do jy=0,numygridn-1
    ylat=outlat0n+(real(jy)+0.5)*dyoutn
    ylatp=ylat+0.5*dyoutn
    ylatm=ylat-0.5*dyoutn
    if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
      hzone=dyoutn*r_earth*pi180
    else

  ! Calculate area of grid cell with formula M=2*pi*R*h*dx/360,
  ! see Netz, Formeln der Mathematik, 5. Auflage (1983), p.90
  !************************************************************

      cosfactp=cos(ylatp*pi180)
      cosfactm=cos(ylatm*pi180)
      if (cosfactp.lt.cosfactm) then
        hzone=sqrt(1-cosfactp**2)- &
             sqrt(1-cosfactm**2)
        hzone=hzone*r_earth
      else
        hzone=sqrt(1-cosfactm**2)- &
             sqrt(1-cosfactp**2)
        hzone=hzone*r_earth
      endif
    endif



  ! Surface are of a grid cell at a latitude ylat
  !**********************************************

    gridarea=2.*pi*r_earth*hzone*dxoutn/360.

    do ix=0,numxgridn-1
      arean(ix,jy)=gridarea

  ! Volume = area x box height
  !***************************

      volumen(ix,jy,1)=arean(ix,jy)*outheight(1)
      do kz=2,numzgrid
        volumen(ix,jy,kz)=arean(ix,jy)*(outheight(kz)-outheight(kz-1))
      end do
    end do
  end do


  !**************************************************************************
  ! Determine average height of model topography in nesteed output grid cells
  !**************************************************************************

  ! Loop over all output grid cells
  !********************************

  do jjy=0,numygridn-1
    do iix=0,numxgridn-1
      oroh=0.

  ! Take 100 samples of the topography in every grid cell
  !******************************************************

      do j1=1,10
        ylat=outlat0n+(real(jjy)+real(j1)/10.-0.05)*dyoutn
        yl=(ylat-ylat0)/dy
        do i1=1,10
          xlon=outlon0n+(real(iix)+real(i1)/10.-0.05)*dxoutn
          xl=(xlon-xlon0)/dx

  ! Determine the nest we are in
  !*****************************

          ngrid=0
          do j=numbnests,1,-1
            ! Temporary fix for nested layer edges: replaced eps with dxn and dyn (LB)
            if ((xl.gt.xln(j)+dxn(j)).and.(xl.lt.xrn(j)-dxn(j)).and. &
                 (yl.gt.yln(j)+dyn(j)).and.(yl.lt.yrn(j)-dyn(j))) then
              ngrid=j
              exit
            endif
          end do

  ! Determine (nested) grid coordinates and auxiliary parameters used for interpolation
  !*****************************************************************************

          if (ngrid.gt.0) then
            xtn=(xl-xln(ngrid))*xresoln(ngrid)
            ytn=(yl-yln(ngrid))*yresoln(ngrid)
            ix=int(xtn)
            jy=int(ytn)
            ddy=ytn-real(jy)
            ddx=xtn-real(ix)
          else
            ix=int(xl)
            jy=int(yl)
            ddy=yl-real(jy)
            ddx=xl-real(ix)
          endif
          ixp=ix+1
          jyp=jy+1
          rddx=1.-ddx
          rddy=1.-ddy
          p1=rddx*rddy
          p2=ddx*rddy
          p3=rddx*ddy
          p4=ddx*ddy

          if (ngrid.gt.0) then
            oroh=oroh+p1*oron(ix ,jy ,ngrid) &
                 + p2*oron(ixp,jy ,ngrid) &
                 + p3*oron(ix ,jyp,ngrid) &
                 + p4*oron(ixp,jyp,ngrid)
          else
            oroh=oroh+p1*oro(ix ,jy) &
                 + p2*oro(ixp,jy) &
                 + p3*oro(ix ,jyp) &
                 + p4*oro(ixp,jyp)
          endif
        end do
      end do

  ! Divide by the number of samples taken
  !**************************************

      orooutn(iix,jjy)=oroh/100.
    end do
  end do

  !*******************************
  ! Initialization of output grids
  !*******************************

  do kp=1,maxpointspec_act
    do ks=1,nspec
      do nage=1,nageclass
        do jy=0,numygridn-1
          do ix=0,numxgridn-1
            do l=1,nclassunc
  ! Deposition fields
              if (ldirect.gt.0) then
                wetgriduncn(ix,jy,ks,kp,l,nage)=0.
                drygriduncn(ix,jy,ks,kp,l,nage)=0.
#ifdef _OPENMP
                wetgriduncn_omp(ix,jy,ks,kp,l,nage,:)=0.
                drygriduncn_omp(ix,jy,ks,kp,l,nage,:)=0.
#endif
              endif
  ! Concentration fields
              do kz=1,numzgrid
                griduncn(ix,jy,kz,ks,kp,l,nage)=0.
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end subroutine outgrid_init_nest

subroutine initcond_calc(itime,i,thread)
  !                               i   i
  !*****************************************************************************
  !                                                                            *
  !     Calculation of the sensitivity to initial conditions for BW runs       *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     15 January 2010                                                        *
  !                                                                            *
  !  Changes                                                                   *
  !     2022 L. Bakels: OpenMP parallelisation                                 *
  !*****************************************************************************

  use interpol_mod, only: interpol_density,ix,jy,ixp,jyp
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use particle_mod

  implicit none

  integer, intent(in) :: itime,i,thread
  integer :: kz,ks
  integer :: nrelpointer
  real :: ddx,ddy
  real :: rhoi,xl,yl,wx,wy,w
  ! mind2        eso: pointer to 2nd windfield in memory


  ! For forward simulations, make a loop over the number of species;
  ! for backward simulations, make an additional loop over the release points
  !**************************************************************************

  ! Depending on output option, calculate air density or set it to 1
  ! linit_cond: 1=mass unit, 2=mass mixing ratio unit
  !*****************************************************************


  if (linit_cond.eq.1) then     ! mass unit
#ifdef ETA
    call update_zeta_to_z(itime,i)
#endif
    call interpol_density(itime,i,rhoi)
  elseif (linit_cond.eq.2) then    ! mass mixing ratio unit
    rhoi=1.
  endif

  !****************************************************************************
  ! 1. Evaluate grid concentrations using a uniform kernel of bandwidths dx, dy
  !****************************************************************************


  ! For backward simulations, look from which release point the particle comes from
  ! For domain-filling trajectory option, npoint contains a consecutive particle
  ! number, not the release point information. Therefore, nrelpointer is set to 1
  ! for the domain-filling option.
  !*****************************************************************************

  if ((ioutputforeachrelease.eq.0).or.(mdomainfill.eq.1)) then
    nrelpointer=1
  else
    nrelpointer=part(i)%npoint
  endif

  do kz=1,numzgrid                ! determine height of cell
    if (real(outheight(kz),kind=dp).gt.part(i)%z) exit
  end do

  if (kz.le.numzgrid) then           ! inside output domain


    xl=(real(part(i)%xlon)*dx+xoutshift)/dxout
    yl=(real(part(i)%ylat)*dy+youtshift)/dyout
    ix=int(xl)
    if (xl.lt.0.) ix=ix-1
    jy=int(yl)
    if (yl.lt.0.) jy=jy-1


  ! If a particle is close to the domain boundary, do not use the kernel either
  !****************************************************************************

    if ((xl.lt.0.5).or.(yl.lt.0.5).or. &
         (xl.gt.real(numxgrid-1)-0.5).or. &
         (yl.gt.real(numygrid-1)-0.5)) then             ! no kernel, direct attribution to grid cell
      if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
           (jy.le.numygrid-1)) then
        do ks=1,nspec
#ifdef _OPENMP
          init_cond_omp(ix,jy,kz,ks,nrelpointer,thread)= &
               init_cond_omp(ix,jy,kz,ks,nrelpointer,thread)+ &
               mass(i,ks)/rhoi
#else
          init_cond(ix,jy,kz,ks,nrelpointer)= &
               init_cond(ix,jy,kz,ks,nrelpointer)+ &
               mass(i,ks)/rhoi
#endif
        end do
      endif

    else                                 ! attribution via uniform kernel

      ddx=xl-real(ix)                   ! distance to left cell border
      ddy=yl-real(jy)                   ! distance to lower cell border
      if (ddx.gt.0.5) then
        ixp=ix+1
        wx=1.5-ddx
      else
        ixp=ix-1
        wx=0.5+ddx
      endif

      if (ddy.gt.0.5) then
        jyp=jy+1
        wy=1.5-ddy
      else
        jyp=jy-1
        wy=0.5+ddy
      endif


  ! Determine mass fractions for four grid points
  !**********************************************

      if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
          w=wx*wy
          do ks=1,nspec
#ifdef _OPENMP
            init_cond_omp(ix,jy,kz,ks,nrelpointer,thread)= &
                 init_cond_omp(ix,jy,kz,ks,nrelpointer,thread) + &
                 mass(i,ks)/rhoi*w
#else
            init_cond(ix,jy,kz,ks,nrelpointer)= &
                 init_cond(ix,jy,kz,ks,nrelpointer)+mass(i,ks)/rhoi*w
#endif
          end do
        endif

        if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
          w=wx*(1.-wy)
          do ks=1,nspec
#ifdef _OPENMP
            init_cond_omp(ix,jyp,kz,ks,nrelpointer,thread)= &
                 init_cond_omp(ix,jyp,kz,ks,nrelpointer,thread) + &
                 mass(i,ks)/rhoi*w
#else
            init_cond(ix,jyp,kz,ks,nrelpointer)= &
                 init_cond(ix,jyp,kz,ks,nrelpointer)+mass(i,ks)/rhoi*w
#endif
          end do
        endif
      endif


      if ((ixp.ge.0).and.(ixp.le.numxgrid-1)) then
        if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
          w=(1.-wx)*(1.-wy)
          do ks=1,nspec
#ifdef _OPENMP
            init_cond_omp(ixp,jyp,kz,ks,nrelpointer,thread)= &
                 init_cond_omp(ixp,jyp,kz,ks,nrelpointer,thread) + &
                 mass(i,ks)/rhoi*w
#else
            init_cond(ixp,jyp,kz,ks,nrelpointer)= &
                 init_cond(ixp,jyp,kz,ks,nrelpointer)+mass(i,ks)/rhoi*w
#endif
          end do
        endif

        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
          w=(1.-wx)*wy
          do ks=1,nspec
#ifdef _OPENMP
            init_cond_omp(ixp,jy,kz,ks,nrelpointer,thread)= &
                 init_cond_omp(ixp,jy,kz,ks,nrelpointer,thread) + &
                 mass(i,ks)/rhoi*w
#else
            init_cond(ixp,jy,kz,ks,nrelpointer)= &
                 init_cond(ixp,jy,kz,ks,nrelpointer)+mass(i,ks)/rhoi*w
#endif
          end do
        endif
      endif
    endif

  endif

end subroutine initcond_calc


end module outgrid_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module receptor_netcdf_mod

  !*****************************************************************************
  !                                                                            *
  !    This module contains variables and subroutines for reading input        *
  !    for satellite receptors and for saving the output of all receptor       *
  !    types to netcdf file                                                    *
  !                                                                            *
  !    Author, Rona Thompson                                                   *
  !                                                                            *
  !*****************************************************************************

  use netcdf
  use par_mod
  use com_mod
  use point_mod
  use date_mod
  use netcdf_output_mod, only: nf90_err
  use windfields_mod,    only: prs, height, nzmax, nz

  implicit none

  ! general receptors
  integer :: rpointer
  integer :: nc_id
  integer :: recdim_id, nchardim_id
  integer :: timevar_id, recvar_id, reclonvar_id, reclatvar_id, recaltvar_id, recnamevar_id
  integer, dimension(:), allocatable :: concvar_id, uncvar_id
  integer :: nnvar_id, xkvar_id 
  ! satellite receptors
  integer :: spointer
  integer :: memsatday
  character(len=8), dimension(:), allocatable :: sat_name 
  character(len=256), dimension(:), allocatable :: sat_file, sat_path
  integer :: ncsat_id
  integer :: satrecdim_id, ncharsatdim_id, sataltdim_id, satlayerdim_id
  integer :: sattimevar_id, satrecvar_id, satlonvar_id, satlatvar_id, sataltvar_id, satnamevar_id
  integer, dimension(:), allocatable :: satvar_id, satuncvar_id
  integer :: satnnvar_id, satxkvar_id

  contains


  subroutine alloc_satellite

  !*****************************************************************************
  !                                                                            *
  !    This routine allocates variables for satellite concentrations           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    if (numsatellite.gt.0) then
      allocate( csatellite(nspec,nlayermax,maxrecsample) )
      allocate( csatuncert(nspec,nlayermax,maxrecsample) )
      allocate( nnsatellite(nlayermax,maxrecsample) )
      allocate( xksatellite(nlayermax,maxrecsample) )
      csatellite(:,:,:)=0.
      csatuncert(:,:,:)=0.
      nnsatellite(:,:)=0.
      xksatellite(:,:)=0.
    endif

  end subroutine alloc_satellite


  subroutine receptorout_init

  !*****************************************************************************
  !                                                                            *
  !    Intitialize netcdf files for receptor concentrations                    *
  !                                                                            *
  !    Author: R. Thompson, Sep-2023                                           *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) :: fn, timeunit
    character(len=8)   :: adate
    character(len=6)   :: atime
    integer            :: ks, n, ks_start
    character(8)       :: date
    character(10)      :: time
    character(5)       :: zone

    if (numreceptor.eq.0) then
      return
    endif

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif

    ! time at simulation start
    if (ldirect.eq.1) then
      write(adate,'(i8.8)') ibdate
      write(atime,'(i6.6)') ibtime
    else
      write(adate,'(i8.8)') iedate
      write(atime,'(i6.6)') ietime
    end if

    if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
      ! concentration output file
      write(fn,'(A)') path(2)(1:length(2))//'receptor_conc.nc'
    else if (iout.eq.2) then
      ! mixing ratio output file
      ! note: for iout=3 (both conc and mixing ratio) only output conc at receptors
      write(fn,'(A)') path(2)(1:length(2))//'receptor_pptv.nc'
    endif

    ! initialization
    if (.not.allocated(concvar_id)) then
      allocate(concvar_id(nspec))
      allocate(uncvar_id(nspec))
    endif

    ! pointer for receptor dimension
    rpointer=1

    ! create file
    call nf90_err( nf90_create(trim(fn), nf90_clobber, nc_id) )

    ! define dimensions
    !******************

    call nf90_err( nf90_def_dim(nc_id, "rec", nf90_unlimited, recdim_id) )
    call nf90_err( nf90_def_dim(nc_id, 'nchar', 16, nchardim_id) )

    ! define variables
    !*****************

    ! time
    timeunit = 'seconds since '//adate(1:4)//'-'//adate(5:6)// &
                  '-'//adate(7:8)//' '//atime(1:2)//':'//atime(3:4)
    call nf90_err( nf90_def_var(nc_id, 'time', nf90_int, (/ recdim_id /), timevar_id) )
    call nf90_err( nf90_put_att(nc_id, timevar_id, 'units', trim(timeunit)) )
    call nf90_err( nf90_put_att(nc_id, timevar_id, 'calendar', 'proleptic_gregorian') )

    ! receptors 
    call nf90_err( nf90_def_var(nc_id, "rec", nf90_float, (/ recdim_id /), recvar_id) )
    call nf90_err( nf90_put_att(nc_id, recvar_id, "longname", "receptors") )
    call nf90_err( nf90_put_att(nc_id, recvar_id, "units", "index") )

    ! receptor names 
    call nf90_err( nf90_def_var(nc_id, "receptorname", nf90_char, (/ nchardim_id, recdim_id /), &
                    recnamevar_id) )
    call nf90_err( nf90_put_att(nc_id, recnamevar_id, "longname", "receptor name") )

    ! receptor longitude 
    call nf90_err( nf90_def_var(nc_id, "lon", nf90_float, (/ recdim_id /), reclonvar_id) )
    call nf90_err( nf90_put_att(nc_id, reclonvar_id, "longname", "receptor longitude") )
    call nf90_err( nf90_put_att(nc_id, reclonvar_id, "units", "degrees_east") )

    ! receptor latitude
    call nf90_err( nf90_def_var(nc_id, "lat", nf90_float, (/ recdim_id /), reclatvar_id) )
    call nf90_err( nf90_put_att(nc_id, reclatvar_id, "longname", "receptor latitude") )
    call nf90_err( nf90_put_att(nc_id, reclatvar_id, "units", "degrees_north") )

    ! receptor altitude
    call nf90_err( nf90_def_var(nc_id, "lev", nf90_float, (/ recdim_id /), recaltvar_id) )
    call nf90_err( nf90_put_att(nc_id, recaltvar_id, "longname", "receptor altitude") )
    call nf90_err( nf90_put_att(nc_id, recaltvar_id, "units", "meters") )

    ! species specific variables
    do ks=ks_start,nspec
      ! concentration/mixing ratio variables
      call nf90_err( nf90_def_var(nc_id, trim(species(ks)), nf90_float, (/ recdim_id /), concvar_id(ks)) )
      call nf90_err( nf90_def_var(nc_id, trim(species(ks))//"_uncert", nf90_float, (/ recdim_id /), &
                       uncvar_id(ks)) )
      if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
        call nf90_err( nf90_put_att(nc_id, concvar_id(ks), "units", "ng/m3") )
        call nf90_err( nf90_put_att(nc_id, concvar_id(ks), "longname", "mean receptor concentration") )
        call nf90_err( nf90_put_att(nc_id, uncvar_id(ks), "units", "ng/m3") )
        call nf90_err( nf90_put_att(nc_id, uncvar_id(ks), "longname", "uncertainty receptor concentration") )
      else if ((iout.eq.2)) then
        call nf90_err( nf90_put_att(nc_id, concvar_id(ks), "units", "pptv") )
        call nf90_err( nf90_put_att(nc_id, concvar_id(ks), "longname", "mean receptor VMR") )
        call nf90_err( nf90_put_att(nc_id, uncvar_id(ks), "units", "pptv") )
        call nf90_err( nf90_put_att(nc_id, uncvar_id(ks), "longname", "uncertainty receptor VMR") )
      endif
    end do

    ! not species specific variables
    !  number of particles in receptor output
    call nf90_err( nf90_def_var(nc_id,"npart", nf90_float, (/ recdim_id /), nnvar_id) )
    call nf90_err( nf90_put_att(nc_id, nnvar_id, "units", "counts") )
    call nf90_err( nf90_put_att(nc_id, nnvar_id, "longname","number of particles at receptor") )
    !  average kernel weight at receptor
    call nf90_err( nf90_def_var(nc_id,"kernel", nf90_float, (/ recdim_id /), xkvar_id) )
    call nf90_err( nf90_put_att(nc_id, xkvar_id, "units", "") )
    call nf90_err( nf90_put_att(nc_id, xkvar_id, "longname", "average kernel weight at receptor") )

    ! write global attributes
    !************************

    call date_and_time(date,time,zone)
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'Conventions', 'CF-1.6') )
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'title', 'FLEXPART receptor output') )
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'source', trim(flexversion)//' model output') )
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'history', date(1:4)//'-'//date(5:6)//&
                     '-'//date(7:8)//' '//time(1:2)//':'//time(3:4)//' '//zone ) )
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'references', &
          'Stohl et al., Atmos. Chem. Phys., 2005, doi:10.5194/acp-5-2461-200;'//&
          'Henne et al., in Lagrangian Modeling of the Atmosphere, 2012, doi:10.1029/2012GM001247') )

    ! end definition
    call nf90_err( nf90_enddef(nc_id) )

    ! write dimension variables 
    !**************************

    ! receptor index
    call nf90_err( nf90_put_var(nc_id, recvar_id, (/(n,n=1,numreceptor)/)) )

    ! close file
    call nf90_err( nf90_close(nc_id) )

  end subroutine receptorout_init


  subroutine satelliteout_init

  !*****************************************************************************
  !                                                                            *
  !    Intitialize netcdf files for satellite concentrations                   *
  !                                                                            *
  !    Author: R. Thompson, Oct-2023                                           *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) :: fn, timeunit
    character(len=8)   :: adate
    character(len=6)   :: atime
    integer            :: ks, n, ks_start
    character(8)       :: date
    character(10)      :: time
    character(5)       :: zone

    if (numsatellite.eq.0) then
      return
    endif

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif

    ! time at simulation start
    if (ldirect.eq.1) then
      write(adate,'(i8.8)') ibdate
      write(atime,'(i6.6)') ibtime
    else
      write(adate,'(i8.8)') iedate
      write(atime,'(i6.6)') ietime
    end if

    ! mixing ratio output for satellites 
    write(fn,'(A)') path(2)(1:length(2))//'satellite_pptv.nc'

   ! initialization
    if (.not.allocated(satvar_id)) then
      allocate(satvar_id(nspec))
      allocate(satuncvar_id(nspec))
    endif

    ! pointer for satellite receptor dimension
    spointer=1

    ! create file
    call nf90_err( nf90_create(trim(fn), nf90_clobber, ncsat_id) )

    ! define dimensions
    !******************

    call nf90_err( nf90_def_dim(ncsat_id, "rec", nf90_unlimited, satrecdim_id) )
    call nf90_err( nf90_def_dim(ncsat_id, "layer", (nlayermax-1), satlayerdim_id) )
    call nf90_err( nf90_def_dim(ncsat_id, "level", nlayermax, sataltdim_id) )
    call nf90_err( nf90_def_dim(ncsat_id, 'nchar', 24, ncharsatdim_id) )

    ! define variables
    !*****************

    ! Note: did not include variables for kernel parameters as currently use same
    ! at all sites and did not include windspeed, ageclasses, and release points

    ! time
    timeunit = 'seconds since '//adate(1:4)//'-'//adate(5:6)// &
                  '-'//adate(7:8)//' '//atime(1:2)//':'//atime(3:4)
    call nf90_err( nf90_def_var(ncsat_id, 'time', nf90_int, (/ satrecdim_id /), sattimevar_id) )
    call nf90_err( nf90_put_att(ncsat_id, sattimevar_id, 'units', trim(timeunit)) )
    call nf90_err( nf90_put_att(ncsat_id, sattimevar_id, 'calendar', 'proleptic_gregorian') )

    ! receptor names 
    call nf90_err( nf90_def_var(ncsat_id, "receptorname", nf90_char, (/ ncharsatdim_id, satrecdim_id /), &
                    satnamevar_id) )
    call nf90_err( nf90_put_att(ncsat_id, satnamevar_id, "longname", "receptor name") )

    ! receptors 
    call nf90_err( nf90_def_var(ncsat_id, "rec", nf90_float, (/ satrecdim_id /), satrecvar_id) )
    call nf90_err( nf90_put_att(ncsat_id, satrecvar_id, "longname", "receptors") )
    call nf90_err( nf90_put_att(ncsat_id, satrecvar_id, "units", "index") )

    ! receptor longitude 
    call nf90_err( nf90_def_var(ncsat_id, "lon", nf90_float, (/ satrecdim_id /), satlonvar_id) )
    call nf90_err( nf90_put_att(ncsat_id, satlonvar_id, "longname", "receptor longitude") )
    call nf90_err( nf90_put_att(ncsat_id, satlonvar_id, "units", "degrees_east") )

    ! receptor latitude
    call nf90_err( nf90_def_var(ncsat_id, "lat", nf90_float, (/ satrecdim_id /), satlatvar_id) )
    call nf90_err( nf90_put_att(ncsat_id, satlatvar_id, "longname", "receptor latitude") )
    call nf90_err( nf90_put_att(ncsat_id, satlatvar_id, "units", "degrees_north") )

    ! receptor altitude
    call nf90_err( nf90_def_var(ncsat_id, "alt", nf90_float, (/ sataltdim_id, satrecdim_id /), sataltvar_id) )
    call nf90_err( nf90_put_att(ncsat_id, sataltvar_id, "longname", "receptor altitude of levels") )
    call nf90_err( nf90_put_att(ncsat_id, sataltvar_id, "units", "meters") )

    ! species specific variables
    do ks=ks_start,nspec
      ! mixing ratio output for each layer of retrieval
      call nf90_err( nf90_def_var(ncsat_id, trim(species(ks)), nf90_float, (/ satlayerdim_id, satrecdim_id /), &
                       satvar_id(ks)) )
      call nf90_err( nf90_put_att(ncsat_id, satvar_id(ks), "units", "pptv") )
      call nf90_err( nf90_put_att(ncsat_id, satvar_id(ks), "longname", "mean VMR") )
      ! uncertainty output for each layer of retrieval
      call nf90_err( nf90_def_var(ncsat_id, trim(species(ks))//"_uncert", nf90_float, (/ satlayerdim_id, satrecdim_id /), &
                       satuncvar_id(ks)) )
      call nf90_err( nf90_put_att(ncsat_id, satuncvar_id(ks), "units", "pptv") )
      call nf90_err( nf90_put_att(ncsat_id, satuncvar_id(ks), "longname", "uncertainty VMR") )
    end do

    ! not species specific variables
    ! number of particles in receptor output
    call nf90_err( nf90_def_var(ncsat_id,"npart", nf90_float, (/ satlayerdim_id, satrecdim_id /), satnnvar_id) )
    call nf90_err( nf90_put_att(ncsat_id, satnnvar_id, "units", "counts") )
    call nf90_err( nf90_put_att(ncsat_id, satnnvar_id, "longname","number of particles at receptor") )
    ! average kernel weight at receptor
    call nf90_err( nf90_def_var(ncsat_id,"kernel", nf90_float, (/ satlayerdim_id, satrecdim_id /), satxkvar_id) )
    call nf90_err( nf90_put_att(ncsat_id, satxkvar_id, "units", "") )
    call nf90_err( nf90_put_att(ncsat_id, satxkvar_id, "longname", "average kernel weight at receptor") )

    ! write global attributes
    !************************

    call date_and_time(date,time,zone)
    call nf90_err( nf90_put_att(ncsat_id, nf90_global, 'Conventions', 'CF-1.6') )
    call nf90_err( nf90_put_att(ncsat_id, nf90_global, 'title', 'FLEXPART receptor output') )
    call nf90_err( nf90_put_att(ncsat_id, nf90_global, 'source', trim(flexversion)//' model output') )
    call nf90_err( nf90_put_att(ncsat_id, nf90_global, 'history', date(1:4)//'-'//date(5:6)//&
                     '-'//date(7:8)//' '//time(1:2)//':'//time(3:4)//' '//zone ) )
    call nf90_err( nf90_put_att(ncsat_id, nf90_global, 'references', &
          'Stohl et al., Atmos. Chem. Phys., 2005, doi:10.5194/acp-5-2461-200;'//&
          'Henne et al., in Lagrangian Modeling of the Atmosphere, 2012, doi:10.1029/2012GM001247') )

    ! end definition
    call nf90_err( nf90_enddef(ncsat_id) )

    ! write dimension variables 
    !**************************

    ! receptor index
    call nf90_err( nf90_put_var(ncsat_id, satrecvar_id, (/(n,n=1,numsatreceptor)/)) )

    ! close file
    call nf90_err( nf90_close(ncsat_id) )

  end subroutine satelliteout_init


  subroutine receptor_output_netcdf()

  !*****************************************************************************
  !                                                                            *
  !     This routine writes receptor concentrations to netcdf files            *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     January 2024                                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer :: ks, ks_start
    character(len=256) :: fn

    ! Open output files
    !******************

    if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
      ! concentration output file
      write(fn,'(A)') path(2)(1:length(2))//'receptor_conc.nc'
    else if (iout.eq.2) then
      ! mixing ratio output file
      ! note for iout=3 (both conc and mixing ratio) only output conc at receptors
      write(fn,'(A)') path(2)(1:length(2))//'receptor_pptv.nc'
    endif
    call nf90_err( nf90_open(trim(fn), nf90_write, nc_id) )

    ! Get variable ids
    !*****************

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif


    do ks = ks_start,nspec
      call nf90_err( nf90_inq_varid(nc_id, trim(species(ks)), concvar_id(ks)) )
      call nf90_err( nf90_inq_varid(nc_id, trim(species(ks))//"_uncert", uncvar_id(ks)) )
    end do
    call nf90_err( nf90_inq_varid(nc_id, "npart", nnvar_id) )
    call nf90_err( nf90_inq_varid(nc_id, "kernel", xkvar_id) )

  end subroutine receptor_output_netcdf


  subroutine satellite_output_netcdf()

  !*****************************************************************************
  !                                                                            *
  !     This routine writes receptor concentrations to netcdf files            *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     January 2024                                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer :: ks, ks_start
    character(len=256) :: fn

    ! Open output files
    !******************

    write(fn,'(A)') path(2)(1:length(2))//'satellite_pptv.nc'
    call nf90_err( nf90_open(trim(fn), nf90_write, ncsat_id) )

    ! Get variable ids
    !*****************

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif

    ! satellite receptors
    do ks = ks_start,nspec
      call nf90_err( nf90_inq_varid(ncsat_id, trim(species(ks)), satvar_id(ks)) )
      call nf90_err( nf90_inq_varid(ncsat_id, trim(species(ks))//"_uncert", satuncvar_id(ks)) )
    end do
    call nf90_err( nf90_inq_varid(ncsat_id, "npart", satnnvar_id) )
    call nf90_err( nf90_inq_varid(ncsat_id, "kernel", satxkvar_id) )

  end subroutine satellite_output_netcdf


  subroutine write_receptor_netcdf(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namerec,nrec)

  !*****************************************************************************
  !                                                                            *
  !     This routine writes receptor concentrations to netcdf files            *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     January 2024                                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none
  
    integer :: ks, ks_start, nrec
    real, dimension(nspec,maxrecsample,nlayermax) :: crec, cunc
    real, dimension(maxrecsample,nlayermax) :: nnrec, xkrec, altrec
    real, dimension(maxrecsample) :: lonrec, latrec
    integer, dimension(maxrecsample) :: timerec
    character(len=16), dimension(maxrecsample) :: namerec

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif

    !! testing
!    print*, 'write_receptor_netcdf: rpointer, nrec = ',rpointer, nrec

    ! species specific
    do ks=ks_start,nspec
      call nf90_err( nf90_put_var(nc_id, concvar_id(ks), crec(ks,1:nrec,1), (/rpointer/), (/nrec/) ) )
      call nf90_err( nf90_put_var(nc_id, uncvar_id(ks), cunc(ks,1:nrec,1), (/rpointer/), (/nrec/) ) )
    end do

    ! not species specific output
    ! receptor name
    call nf90_err( nf90_put_var(nc_id, recnamevar_id, namerec(1:nrec), (/1,rpointer/), (/16,nrec/) ) )
    ! receptor time
    call nf90_err( nf90_put_var(nc_id, timevar_id, timerec(1:nrec), (/rpointer/), (/nrec/) ) )
    ! receptor longitude
    call nf90_err( nf90_put_var(nc_id, reclonvar_id, lonrec(1:nrec), (/rpointer/), (/nrec/) ) )
    ! receptor latitude
    call nf90_err( nf90_put_var(nc_id, reclatvar_id, latrec(1:nrec), (/rpointer/), (/nrec/) ) )
    ! receptor latitude
    call nf90_err( nf90_put_var(nc_id, recaltvar_id, altrec(1:nrec,1), (/rpointer/), (/nrec/) ) )
    ! average number of particles all timesteps for each receptor
    call nf90_err( nf90_put_var(nc_id, nnvar_id, nnrec(1:nrec,1), (/rpointer/), (/nrec/) ) )
    ! average kernel all timesteps
    call nf90_err( nf90_put_var(nc_id, xkvar_id, xkrec(1:nrec,1), (/rpointer/), (/nrec/) ) )

  end subroutine write_receptor_netcdf

  
   subroutine write_satellite_netcdf(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namerec,nrec)

  !*****************************************************************************
  !                                                                            *
  !     This routine writes receptor concentrations to netcdf files            *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     January 2024                                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer :: ks, ks_start, nrec
    real, dimension(nspec,maxrecsample,nlayermax) :: crec, cunc
    real, dimension(maxrecsample,nlayermax) :: nnrec, xkrec, altrec
    real, dimension(maxrecsample) :: lonrec, latrec
    integer, dimension(maxrecsample) :: timerec
    character(len=24), dimension(maxrecsample) :: namerec

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif

    !! testing
!    print*, 'write_satellite_netcdf: spointer, nrec = ',spointer, nrec

    ! species specific output
    do ks = ks_start,nspec
      call nf90_err( nf90_put_var(ncsat_id,satvar_id(ks),transpose(crec(ks,1:nrec,1:nlayermax-1)),&
                     (/1,spointer/),(/nlayermax-1,nrec/) ) )
      call nf90_err( nf90_put_var(ncsat_id,satuncvar_id(ks),transpose(cunc(ks,1:nrec,1:nlayermax-1)),&
                     (/1,spointer/),(/nlayermax-1,nrec/) ) )
    end do

    ! non-species specific
    ! receptor name
    call nf90_err( nf90_put_var(ncsat_id, satnamevar_id, namerec(1:nrec), (/1,spointer/), (/24,nrec/) ) )
    ! receptor time 
    call nf90_err( nf90_put_var(ncsat_id, sattimevar_id, timerec(1:nrec), (/spointer/), (/nrec/) ) )
    ! receptor longitude
    call nf90_err( nf90_put_var(ncsat_id, satlonvar_id, lonrec(1:nrec), (/spointer/), (/nrec/) ) )
    ! receptor latitude
    call nf90_err( nf90_put_var(ncsat_id, satlatvar_id, latrec(1:nrec), (/spointer/), (/nrec/) ) )
    ! receptor altitude
    call nf90_err( nf90_put_var(ncsat_id, sataltvar_id, transpose(altrec(1:nrec,:)), (/1,spointer/), (/nlayermax,nrec/) ) )
    ! average number of particles all timesteps for each receptor
    call nf90_err( nf90_put_var(ncsat_id, satnnvar_id, transpose(nnrec(1:nrec,1:nlayermax-1)),&
                   (/1,spointer/), (/nlayermax-1,nrec/) ) )
    ! average kernel all timesteps
    call nf90_err( nf90_put_var(ncsat_id, satxkvar_id, transpose(xkrec(1:nrec,1:nlayermax-1)), &
                   (/1,spointer/), (/nlayermax-1,nrec/) ) )

  end subroutine write_satellite_netcdf

  
  !*****************************************************************************

  subroutine close_receptor_netcdf

    call nf90_err( nf90_close(nc_id) )

  end subroutine close_receptor_netcdf

  !*****************************************************************************

  subroutine close_satellite_netcdf

    call nf90_err( nf90_close(ncsat_id) )

  end subroutine close_satellite_netcdf

  !*****************************************************************************


  subroutine read_satellite_info

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the satellite information for which satellite       *
  !     retrievals should be read                                              *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     October 2023                                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) ::  ppath, pfile
    character(len=8) :: psatname
    integer :: readerror, writeerror
    integer :: j
    integer,parameter :: unitreceptorout=2
    logical :: lexist

    ! declare namelist
    namelist /satellites/ psatname, ppath, pfile

    ! For backward runs, do not allow receptor output
    !************************************************

    if (ldirect.lt.0) then
      return
    endif

    ! Open the SATELLITES file and read path and file info 
    !*****************************************************  

    open(unitreceptor,file=path(1)(1:length(1))//'SATELLITES',form='formatted',status='old',iostat=readerror)

    if (readerror.ne.0) then
      write(*,*) 'FLEXPART WARNING read_satellite_info: no satellite file found'
      return
    endif

    ! try namelist input
    read(unitreceptor,satellites,iostat=readerror)
    close(unitreceptor)

    if (readerror.ne.0) then
      write(*,*) ' #### FLEXPART ERROR in read_satellite_info: #### '
      write(*,*) ' #### error in namelist input #### '
      error stop
    endif ! only namelist input


    ! prepare namelist output if requested
    if (nmlout) then
      open(unitreceptorout,file=path(2)(1:length(2))//'SATELLITES.namelist',&
           &access='append',status='replace',iostat=writeerror)
      if (writeerror.ne.0) then
        write(*,*) ' #### FLEXPART ERROR read_satellite_info: cannot open file #### '
        write(*,*) ' #### '//trim(path(2)(1:length(2)))//'SATELLITES.namelist #### '
        error stop
      endif
    endif

    ! Get number of satellites
    !*************************

    numsatellite=0
    open (unitreceptor,file=trim(path(1))//'SATELLITES',status='old',iostat=readerror)
    j=0
    do while (readerror.eq.0)
      read(unitreceptor,satellites,iostat=readerror)
      if (readerror.ne.0) exit
      j=j+1
    end do
    numsatellite=j
    write(*,*) 'Number of satellites: ',numsatellite
    close(unitreceptor)

    ! Allocate arrays
    !****************

    allocate(sat_name(numsatellite),sat_path(numsatellite),sat_file(numsatellite))
    allocate(nnsatlayer(numsatellite))

    ! Read satellite info
    !********************

    open(unitreceptor,file=path(1)(1:length(1))//'SATELLITES',form='formatted',status='old',iostat=readerror)
    j=0
    do while (readerror.eq.0)
      read(unitreceptor,satellites,iostat=readerror)
      if (readerror.ne.0) exit
      j=j+1
      write(*,*) 'read_satellite_info: psatname, ppath = ',trim(psatname),', ',trim(ppath)
      sat_name(j)=trim(psatname)
      sat_path(j)=trim(ppath)
      sat_file(j)=trim(pfile)
      ! namelist output
      if (nmlout) then
        write(unitreceptorout,nml=satellites)
      endif
    end do
    close(unitreceptor)
    close(unitreceptorout)

  end subroutine read_satellite_info

  
  subroutine readreceptors_satellite(itime)

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the satellite retrieval information for which       *
  !     mixing ratios should be modelled                                       *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     October 2023                                                           *
  !                                                                            *
  !*****************************************************************************

    use binary_output_mod, only: satelliteout_init_binary

    implicit none

    integer            :: itime
    character(len=256) :: file_name
    character(len=6) :: anretr
    character(len=8) :: adate
    integer :: jjjjmmdd, hhmmss, yyyy, mm, dd
    integer :: nc_id, dimid, varid
    real    :: xm, ym
    real(kind=dp) :: jul, jd, curday
    real, allocatable, dimension(:,:) :: xpts, ypts, zpt1, zpt2
    integer, allocatable, dimension(:) :: npt, sdate, stime
    integer :: stat
    integer :: j, nn, nr, nretr, nlayer, tmp_numsat
    logical :: lexist
    real, allocatable, dimension(:) :: tmp_xsat, tmp_ysat, tmp_satarea
    real, allocatable, dimension(:,:) :: tmp_zsat
    integer, allocatable, dimension(:) :: tmp_tsat
    character(len=24), allocatable, dimension(:) :: tmp_satname

    ! For backward runs, do not allow receptor output
    !************************************************

    if (ldirect.lt.0) then
      return
    endif

    ! If no satellites do nothing
    !****************************

    if (numsatellite.eq.0) then
      return
    endif

    ! Check if retrievals already in memory for current day
    !******************************************************

    ! If itime is a full day do not update retrievals
    print*, 'readreceptors_satellite: mod = ',mod(real(itime),86400.)
    if ((itime.ne.0).and.(mod(real(itime),86400.).eq.0)) then
      return
    endif

    curday=bdate+real(itime,kind=dp)/86400._dp
    curday=floor(curday)
    print*, 'readreceptors_satellite: curday = ',curday
    print*, 'readreceptors_satellite: memsatday = ',memsatday
  
    if (memsatday.eq.curday ) then
      ! The retrievals for the current day are in memory -> don't do anything
      return
    endif
    memsatday=curday

    ! Get number of satellite receptors
    !**********************************

    ! Loop over satellites 
    jd=curday
    tmp_numsat=0
    do j=1,numsatellite
      ! get filename for current day
      call caldate(jd, jjjjmmdd, hhmmss)
      write(adate,'(I8.8)') jjjjmmdd
      file_name=sat_file(j)
      call getfilename(jjjjmmdd, file_name)
      write(*,*) 'readreceptors_satellite: file_name = ',file_name
      inquire(file=trim(sat_path(j))//'/'//trim(file_name),exist=lexist)
      if (.not.lexist) then
        write(*,*) 'readreceptors_satellite: no retrievals file for '//adate
        cycle
      endif
      ! open file
      call nf90_err( nf90_open(trim(sat_path(j))//'/'//trim(file_name), nf90_nowrite, nc_id) )
      ! read dimensions
      call nf90_err( nf90_inq_dimid(nc_id, 'retrieval', dimid) )
      call nf90_err( nf90_inquire_dimension(nc_id, dimid, len=nretr) )
      call nf90_err( nf90_inq_dimid(nc_id, 'nlayer', dimid) )
      call nf90_err( nf90_inquire_dimension(nc_id, dimid, len=nlayer) )
      tmp_numsat=tmp_numsat+nretr
      ! Define nlayermax only for first day (must not change by day)
      if (jd.eq.bdate) then
        nlayermax=max(nlayermax,nlayer)
        nnsatlayer(j)=nlayer
      endif
      call nf90_err(nf90_close(nc_id))
    end do
    if (jd.eq.bdate) then
      nlayermax=nlayermax+1 ! for levels
    endif
    print*, 'readreceptors_satellite: nlayermax = ',nlayermax

    ! Initialize satellite output
    !****************************

    ! Only do once
    print*, 'readreceptors_satellite: jd, bdate = ',jd, bdate
    if (jd.eq.bdate) then
      print*, 'readreceptors_satellite: allocating satellite variables'
      call alloc_satellite
      if (lnetcdfout.eq.1) then
#ifdef USE_NCF
        print*, 'readreceptors_satellite: initialising output file'
        call satelliteout_init
#endif
      else
        print*, 'readreceptors_satellite: initialising binary output file'
        call satelliteout_init_binary
      endif
    endif      

    ! Allocate temporary arrays
    !**************************

    allocate(tmp_xsat(tmp_numsat),tmp_ysat(tmp_numsat),&
             tmp_tsat(tmp_numsat),tmp_satarea(tmp_numsat),&
             tmp_zsat(nlayermax,tmp_numsat),tmp_satname(tmp_numsat))

    ! Deallocate existing satellite arrays
    !*************************************

    if (allocated(xsatellite)) then
      deallocate(xsatellite,ysatellite,&
                 tsatellite,satellitearea,&
                 zsatellite,satellitename)
    endif

    ! Read satellite retrievals info
    !*******************************

    numsatreceptor=0
    jd=curday
    call caldate(jd, jjjjmmdd, hhmmss)
    write(adate,'(I8.8)') jjjjmmdd
    print*, 'readreceptors_satellite: adate = ',adate

    do j=1,numsatellite

      ! get filename for current day
      ! assumes same format as output from prep_satellite
      call caldate(jd, jjjjmmdd, hhmmss)
      file_name=sat_file(j)
      call getfilename(jjjjmmdd, file_name)
      write(*,*) 'readreceptors_satellite: file_name = ',file_name
      inquire(file=trim(sat_path(j))//'/'//trim(file_name),exist=lexist)
      if (.not.lexist) then
        write(*,*) 'readreceptors_satellite: no retrievals file for '//adate
        cycle
      endif

      ! open file
      call nf90_err( nf90_open(trim(sat_path(j))//'/'//trim(file_name), nf90_nowrite, nc_id) )

      ! read dimensions
      call nf90_err( nf90_inq_dimid(nc_id, 'retrieval', dimid) )
      call nf90_err( nf90_inquire_dimension(nc_id, dimid, len=nretr) )
      call nf90_err( nf90_inq_dimid(nc_id, 'nlayer', dimid) )
      call nf90_err( nf90_inquire_dimension(nc_id, dimid, len=nlayer) )
      print*, 'readreceptors_satellite: nretr = ',nretr

      ! allocate temporary variables
      allocate(sdate(nretr),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate sdate'
      allocate(stime(nretr),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate stime'
      allocate(xpts(nretr,4),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate xpts'
      allocate(ypts(nretr,4),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate ypts'
      allocate(zpt1(nretr,nlayer),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate zpt1'
      allocate(zpt2(nretr,nlayer),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate zpt2'

      ! read coordinate variables      
      call nf90_err( nf90_inq_varid(nc_id,'idate',varid) )
      call nf90_err( nf90_get_var(nc_id,varid,sdate) )
      call nf90_err( nf90_inq_varid(nc_id,'itime',varid) )
      call nf90_err( nf90_get_var(nc_id,varid,stime) )
      call nf90_err( nf90_inq_varid(nc_id,'xpoints',varid) )
      call nf90_err( nf90_get_var(nc_id,varid,xpts) )
      call nf90_err( nf90_inq_varid(nc_id,'ypoints',varid) )
      call nf90_err( nf90_get_var(nc_id,varid,ypts) )
      call nf90_err( nf90_inq_varid(nc_id,'zpoint1',varid) )
      call nf90_err( nf90_get_var(nc_id,varid,zpt1) )
      call nf90_err( nf90_inq_varid(nc_id,'zpoint2',varid) )
      call nf90_err( nf90_get_var(nc_id,varid,zpt2) )
      call nf90_err( nf90_close(nc_id) )

      ! write to coordinates receptor variables
      do nr=1,nretr
        jul=juldate(sdate(nr),stime(nr))
        ! skip retrievals not for current day
        if (floor(jul).ne.curday) cycle
        numsatreceptor=numsatreceptor+1
        write(anretr,'(I6.6)') nr
        tmp_satname(numsatreceptor)=trim(sat_name(j))//'_'//adate//'_'//anretr
        tmp_tsat(numsatreceptor)=int((jul-bdate)*24.*3600.) ! time in sec
        ! transform to grid coordinates
        tmp_xsat(numsatreceptor)=(sum(xpts(nr,:))/4.-xlon0)/dx
        tmp_ysat(numsatreceptor)=(sum(ypts(nr,:))/4.-ylat0)/dy
        ! vertical coordinates layer boundaries in Pa
        tmp_zsat(1:nlayer,numsatreceptor)=zpt1(nr,:)
        tmp_zsat(nlayer+1,numsatreceptor)=zpt2(nr,nlayer)
        ! area for mixing ratio calc (used if ind_samp = -1)
        xm=r_earth*cos((sum(ypts(nr,:))/4.)*pi/180.)*dx/180.*pi
        ym=r_earth*dy/180.*pi
        tmp_satarea(numsatreceptor)=xm*ym
      end do ! nretr

      deallocate(sdate, stime, xpts, ypts, zpt1, zpt2)

    end do ! numsatellite

    write(*,*) 'readreceptors_satellite: numsatreceptor = ',numsatreceptor

    ! Reallocate satellite arrays to actual size
    !*******************************************

    allocate(xsatellite(numsatreceptor),ysatellite(numsatreceptor),&
           tsatellite(numsatreceptor),satellitearea(numsatreceptor),&
           zsatellite(nlayermax,numsatreceptor),satellitename(numsatreceptor))

    xsatellite=tmp_xsat(1:numsatreceptor)
    ysatellite=tmp_ysat(1:numsatreceptor)
    tsatellite=tmp_tsat(1:numsatreceptor)
    satellitearea=tmp_satarea(1:numsatreceptor)
    zsatellite=tmp_zsat(:,1:numsatreceptor)
    satellitename=tmp_satname(1:numsatreceptor)

    deallocate(tmp_xsat,tmp_ysat,tmp_tsat,tmp_satarea,tmp_zsat,tmp_satname)

    ! Transform vertical coordinates of satellite receptors
    !******************************************************

    if (numsatreceptor.gt.0) then
      call verttransform_satellite
    endif

  end subroutine readreceptors_satellite


  subroutine getfilename(jjjjmmdd,file_name)

  !*****************************************************************************
  !                                                                            *
  !    Get actual filename based on dates from generic name                    *
  !                                                                            *
  !    Author: R. Thompson, Sep-2023                                           *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) :: file_name, strtmp1, strtmp2
    character(len=4) :: ayear
    character(len=2) :: amonth, aday
    integer :: jjjjmmdd, yyyy, mm, dd, nn

    yyyy=jjjjmmdd/10000
    mm=(jjjjmmdd-yyyy*10000)/100
    dd=jjjjmmdd-yyyy*10000-mm*100
    write(ayear,'(I4)') yyyy
    write(amonth,'(I2.2)') mm
    write(aday,'(I2.2)') dd
    nn=index(file_name,'YYYY',back=.false.)
    if (nn.ne.0) then
      strtmp1=file_name(1:nn-1)
      nn=index(file_name,'YYYY',back=.true.)
      strtmp2=file_name(nn+4:len_trim(file_name))
      file_name=trim(strtmp1)//ayear//trim(strtmp2)
    endif
    nn=index(file_name,'MM',back=.false.)
    if (nn.ne.0) then
      strtmp1=file_name(1:nn-1)
      nn=index(file_name,'MM',back=.true.)
      strtmp2=file_name(nn+2:len_trim(file_name))
      file_name=trim(strtmp1)//amonth//trim(strtmp2)
    endif
    nn=index(file_name,'DD',back=.false.)
    if (nn.ne.0) then
      strtmp1=file_name(1:nn-1)
      nn=index(file_name,'DD',back=.true.)
      strtmp2=file_name(nn+2:len_trim(file_name))
      file_name=trim(strtmp1)//aday//trim(strtmp2)
    endif

  end subroutine getfilename


  subroutine verttransform_satellite

  !*****************************************************************************
  !                                                                            *
  !     This routine transforms the vertical coordinate of the satellite       *
  !     receptors from pressure to height above ground                         *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     October 2023                                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer :: nr, nn, nl, kz, nchar
    integer :: numsatlayer
    integer :: ix, jy, ixp, jyp
    real    :: p1, p2, p3, p4, ddx, ddy, rddx, rddy, dz1, dz2
    real    :: press, pressold, zpres

!$OMP PARALLEL &
!$OMP PRIVATE(nr,nn,nchar,numsatlayer,nl,zpres,ix,jy,ddx,ddy,ixp,jyp,rddx,rddy,&
!$OMP p1,p2,p3,p4,kz,press,pressold,dz1,dz2)

!$OMP DO
    do nr=1,numsatreceptor

      ! get actual number vertical layers for this retrieval
      do nn=1,numsatellite
        nchar=len_trim(sat_name(nn))
        if (satellitename(nr)(1:nchar).eq.trim(sat_name(nn))) then
          numsatlayer=nnsatlayer(nn)
          exit
        endif
      end do

      do nl=1,(numsatlayer+1)

        ! pressure of level in Pa 
        zpres=zsatellite(nl,nr)
        ix=int(xsatellite(nr))
        jy=int(ysatellite(nr))
        ddx=xsatellite(nr)-real(ix)
        ddy=ysatellite(nr)-real(jy)
        ixp=ix+1
        jyp=jy+1
        rddx=1.-ddx
        rddy=1.-ddy
        p1=rddx*rddy
        p2=ddx*rddy
        p3=rddx*ddy
        p4=ddx*ddy

        ! use pressure from second field regardless of time stamp
        ! think this is adequate otherwise need to transform just
        ! for retrievals in recoutaverage interval before calling receptorcalc
        do kz=1,nz
          press=p1*prs(ix,jy,kz,2) &
                 +p2*prs(ixp,jy,kz,2) &
                 +p3*prs(ix,jyp,kz,2) &
                 +p4*prs(ixp,jyp,kz,2)
          if (kz.eq.1) pressold=press
          if (press.lt.zpres) then
            if (kz.eq.1) then
              zsatellite(nl,nr)=height(1)/2.
            else
              dz1=pressold-zpres
              dz2=zpres-press
              zsatellite(nl,nr)=(height(kz-1)*dz2+height(kz)*dz1)/(dz1+dz2)
            endif
            exit  ! found height end loop over nz
          endif
          pressold=press
        end do ! nz
        if ((kz.gt.nz).and.(zpres.le.press)) then
          ! ztra1 press less than top of windfield press
          zsatellite(nl,nr)=0.5*(height(nz-1)+height(nz))
        endif

      end do ! numsatlayer

      !! testing
      if (nr.lt.20)  print*, 'zsatellite after transform = ',zsatellite(:,nr)

    end do ! numsatreceptor
!$OMP END DO
!$OMP END PARALLEL

  end subroutine verttransform_satellite

end module receptor_netcdf_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

function juldate(yyyymmdd,hhmiss)

  !*****************************************************************************
  !                                                                            *
  !     Calculates the Julian date                                             *
  !                                                                            *
  !     AUTHOR: Andreas Stohl (15 October 1993)                                *
  !                                                                            *
  !     Variables:                                                             *
  !     dd             Day                                                     *
  !     hh             Hour                                                    *
  !     hhmiss         Hour, minute + second                                   *
  !     ja,jm,jy       help variables                                          *
  !     juldate        Julian Date                                             *
  !     julday         help variable                                           *
  !     mi             Minute                                                  *
  !     mm             Month                                                   *
  !     ss             Second                                                  *
  !     yyyy           Year                                                    *
  !     yyyymmddhh     Date and Time                                           *
  !                                                                            *
  !     Constants:                                                             *
  !     igreg          help constant                                           *
  !                                                                            *
  !*****************************************************************************

  use par_mod, only: dp

  implicit none

  integer           :: yyyymmdd,yyyy,mm,dd,hh,mi,ss,hhmiss
  integer           :: julday,jy,jm,ja
  integer,parameter :: igreg=15+31*(10+12*1582)
  real(kind=dp)     :: juldate

  yyyy=yyyymmdd/10000
  mm=(yyyymmdd-10000*yyyy)/100
  dd=yyyymmdd-10000*yyyy-100*mm
  hh=hhmiss/10000
  mi=(hhmiss-10000*hh)/100
  ss=hhmiss-10000*hh-100*mi

  if (yyyy.eq.0) then
     print*, 'there is no year zero.'
     stop
  end if
  if (yyyy.lt.0) yyyy=yyyy+1
  if (mm.gt.2) then
    jy=yyyy
    jm=mm+1
  else
    jy=yyyy-1
    jm=mm+13
  endif
  julday=int(365.25*jy)+int(30.6001*jm)+dd+1720995
  if (dd+31*(mm+12*yyyy).ge.igreg) then
    ja=int(0.01*jy)
    julday=julday+2-ja+int(0.25*ja)
  endif

  juldate=real(julday,kind=dp)   + real(hh,kind=dp)/24._dp + &
       real(mi,kind=dp)/1440._dp  + real(ss,kind=dp)/86400._dp

end function juldate

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!*****************************************************************************
!                                                                            *
!   L. Bakels 2022: This module contains most output related subroutines     *
!                                                                            *
!*****************************************************************************

module output_mod
  
  use com_mod
  use par_mod
  use date_mod
#ifdef USE_NCF  
  use netcdf_output_mod
#endif
  use binary_output_mod
  use txt_output_mod

  implicit none

contains

subroutine init_output(itime,filesize)

  implicit none
  
  integer, intent(in) :: itime
  real, intent(inout) :: filesize
#ifdef USE_NCF
  real(kind=dp) ::          &
    jul
  integer ::                &
    jjjjmmdd,ihmmss,i
#endif

  ! Writing header information to either binary or NetCDF format
  if (itime.eq.itime_init) then
    if (iout.ne.0) then ! No gridded output for iout=0
      if (lnetcdfout.eq.1) then
#ifdef USE_NCF
        call writeheader_netcdf(lnest=.false.)
        if (nested_output.eq.1) call writeheader_netcdf(lnest=.true.)
#endif
      else if ((ipin.ne.1).or.(ipin.ne.4)) then ! Not necessary for restart
        call writeheader_bin

        !if (nested_output.eq.1) call writeheader_nest
        if ((nested_output.eq.1).and.(sfc_only.ne.1)) call writeheader_bin_nest
        if ((nested_output.eq.1).and.(sfc_only.eq.1)) call writeheader_bin_sfc_nest
        if ((nested_output.ne.1).and.(sfc_only.eq.1)) call writeheader_bin_sfc
      endif
    endif ! iout.ne.0
    ! FLEXPART 9.2 ticket ?? write header in ASCII format 
    if ((ipin.ne.1).or.(ipin.ne.4)) call writeheader_txt

    ! NetCDF only: Create file for storing initial particle positions.
#ifdef USE_NCF
    if (ipout.ge.1) then
      if (itime_init.ne.0) then
        jul=bdate+real(itime,kind=dp)/86400._dp
        call caldate(jul,jjjjmmdd,ihmmss)      
      endif
      ! if ((mdomainfill.eq.0).and.(ipin.le.1)) then
      !   if (itime_init.ne.0) then
      !     if (ldirect.eq.1) then
      !       call create_particles_initialoutput(ihmmss,jjjjmmdd,ibtime,ibdate)
      !     else
      !       call create_particles_initialoutput(ihmmss,jjjjmmdd,ietime,iedate)
      !     endif
      !   else if (ldirect.eq.1) then
      !     call create_particles_initialoutput(ibtime,ibdate,ibtime,ibdate)
      !   else
      !     call create_particles_initialoutput(ietime,iedate,ietime,iedate)
      !   endif
      ! endif
      ! Create header files for files that store the particle dump output
      if (itime_init.ne.0) then
        if (ldirect.eq.1) then
          call writeheader_partoutput(ihmmss,jjjjmmdd,ibtime,ibdate)
        else
          call writeheader_partoutput(ihmmss,jjjjmmdd,ietime,iedate)
        endif
      else if (ldirect.eq.1) then
        call writeheader_partoutput(ibtime,ibdate,ibtime,ibdate)
      else 
        call writeheader_partoutput(ietime,iedate,ietime,iedate)
      endif
    endif
#endif
  
  ! In case the particle output file is becoming larger than the maximum set
  ! in par_mod, create a new one while keeping track of the filesize.
  ! Also if a new restart file is created.
  else if ((mod(itime,ipoutfac*loutstep).eq.0).and.(ipout.ge.1)) then
#ifdef USE_NCF
    if ((filesize.ge.maxfilesize).or. &
      ((loutrestart.ne.-1).and.(mod(itime,loutrestart).eq.0))) then 
      jul=bdate+real(itime,kind=dp)/86400._dp
      call caldate(jul,jjjjmmdd,ihmmss)
      if (ldirect.eq.1) then 
        call writeheader_partoutput(ihmmss,jjjjmmdd,ibtime,ibdate)
      else 
        call writeheader_partoutput(ihmmss,jjjjmmdd,ietime,iedate)
      endif
      filesize = 0.
    endif
    do i=1,numpoint
      filesize = filesize + npart(i)*13.*4./1000000.
    end do
#endif
  endif
end subroutine init_output

subroutine finalise_output(itime)
  ! Complete the calculation of initial conditions for particles not yet terminated
  use particle_mod

  implicit none 

  integer, intent(in) :: itime
  integer :: i,j,ithread

  if (linit_cond.ge.1) then
    do i=1,count%alive
      j=count%ialive(i)
      call initcond_calc(itime,j,1)
    end do
#ifdef _OPENMP
    do ithread=1,numthreads
      init_cond(:,:,:,:,:)=init_cond(:,:,:,:,:)+init_cond_omp(:,:,:,:,:,ithread)
    end do
#endif
  endif


  if (ipout.eq.2) call output_particles(itime)!,active_per_rel)     ! dump particle positions

  if (linit_cond.ge.1) then
    if(linversionout.eq.1) then
      call initcond_output_inv(itime)   ! dump initial cond. field
    else
      call initcond_output(itime)   ! dump initial cond. fielf
    endif
  endif
end subroutine finalise_output

subroutine output_particles(itime,initial_output)
  !                        i
  !*****************************************************************************
  !                                                                            *
  !     Dump all particle positions                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     12 March 1999                                                          *
  !                                                                            *
  !     Changes L. Bakels, 2021                                                *
  !     Output is chosen by the fields set in PARTOPTIONS                      *
  !     Binary output is no longer supported. If required, function can be     *
  !     added below at "Put binary function here"                              *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use interpol_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use particle_mod
#ifdef USE_NCF
  use netcdf
  use netcdf_output_mod, only: partoutput_netcdf,open_partoutput_file, &
                               close_partoutput_file,partinitpointer1
  use omp_lib, only: OMP_GET_THREAD_NUM
#endif

  implicit none

  integer,intent(in) :: itime
  logical,optional,intent(in) :: initial_output
  logical :: init_out,lskip
  integer :: i,j,m,jjjjmmdd,ihmmss,np,ns,i_av
  real(kind=dp) :: jul
  real :: tmp(2)
  character :: adate*8,atime*6

  real :: dummy(2)
  real :: masstemp(count%allocated,nspec),masstemp_av(count%allocated,nspec)
  real :: wetdepotemp(count%allocated,nspec),drydepotemp(count%allocated,nspec)

  real :: output(num_partopt, count%allocated)

  real :: cartxyz(3)
  logical :: cartxyz_comp

#ifdef USE_NCF
  integer  :: ncid,ncid_tmp
#else
  error stop 'NETCDF missing! Please compile with netcdf if you want the particle dump.'
#endif

#ifdef USE_NCF
  if (present(initial_output)) then
    init_out=initial_output
  else
    init_out=.false.
  endif

!$OMP PARALLEL PRIVATE(i,j,m,tmp,ns,i_av,cartxyz_comp,cartxyz,np,lskip)
  ! Some variables needed for temporal interpolation
  !*************************************************
  call find_time_vars(itime)

!$OMP DO
  do i=1,count%allocated ! LB: Loop over all particles, including terminated ones because of 
  ! averages that could still be available. There should be a better way.
    !Initialise fields
    lskip=.false.

    if (.not. part(i)%spawned) lskip=.true. ! Not spawned yet
    if ((.not. init_out) .and. (part(i)%tstart.eq.itime)) lskip=.true. ! No information avail yet for new parts
    if (((.not. part(i)%alive).and.(abs(part(i)%tend-itime).ge.ipoutfac*loutstep)) .or. &
      (init_out .and. (i.lt.partinitpointer1-1 .or. (part(i)%alive .eqv. .false.) ))) lskip=.true.
    ! no particles that have been dead for longer than a write interval

    if (lskip) then
      output(:,i) = -1
      masstemp(i,:) = -1
      masstemp_av(i,:) = -1
      if (wetdep) wetdepotemp(i,:) = -1
      if (drydep) drydepotemp(i,:) = -1
      cycle
    endif
    !*****************************************************************************
    ! Interpolate several variables (PV, specific humidity, etc.) to particle position
    !*****************************************************************************
    ! Where in the grid? Stereographic (ngrid<0) or nested (ngrid>0)
    !***************************************************************
    call find_ngrid(real(part(i)%xlon),real(part(i)%ylat))
    call find_grid_indices(real(part(i)%xlon),real(part(i)%ylat))
    call find_grid_distances(real(part(i)%xlon),real(part(i)%ylat))
    ! First set dz1out from interpol_mod to -1 so it only is calculated once per particle
    !************************************************************************************
    dz1out=-1
    cartxyz_comp=.false.
    do np=1,num_partopt
      if (.not. partopt(np)%print) cycle ! Only compute when field should be printed
      i_av = partopt(np)%i_average
      if (init_out.and.(i_av.ne.0)) cycle ! no averages for initial particle output
      if ((i_av.ne.0).and.(part(i)%ntime.eq.0)) cycle ! no averages for freshly spawned particles

      select case (partopt(np)%name)
        case ('LO')
          output(np,i)=xlon0+real(part(i)%xlon)*dx
          cycle
        case ('LA')
          output(np,i)=ylat0+real(part(i)%ylat)*dy
          cycle
        case ('TO') ! Topography
          if (topo_written) cycle
          if (ngrid.le.0) then
            call hor_interpol(oro,output(np,i))
          else
            call hor_interpol_nest(oron,output(np,i))
          endif 
          cycle
        case ('TR') ! Tropopause
          if (ngrid.le.0) then
            do m=1,2
              call hor_interpol(tropopause,tmp(m),1,memind(m),1)
            end do
          else
            do m=1,2
              call hor_interpol_nest(tropopausen,tmp(m),1,memind(m),1)
            end do
          endif
          call temporal_interpolation(tmp(1),tmp(2),output(np,i))
          cycle
        case ('HM') ! PBL height
          if (ngrid.le.0) then
            do m=1,2
              call hor_interpol(hmix,tmp(m),1,memind(m),1)
            end do
          else
            do m=1,2
              call hor_interpol_nest(hmixn,tmp(m),1,memind(m),1)
            end do
          endif
          call temporal_interpolation(tmp(1),tmp(2),output(np,i))
          cycle
        case ('ZZ') ! Height
#ifdef ETA
          call update_zeta_to_z(itime, i) ! Convert eta z coordinate to meters if necessary
#endif
          output(np,i)=real(part(i)%z)
          cycle
        ! case ('UU') ! Longitudinal velocity
        !   output(np,i)=part(i)%vel%u !This would be preferred, but not implemented yet
        !   cycle
        case ('VS') ! Settling velocity
          output(np,i)=part(i)%settling
          cycle
        case ('MA') ! Mass
          if (mass_written) cycle
          masstemp(i,:)=mass(i,:)
          cycle
        case ('ma') ! Mass averaged
          do ns=1,nspec
            masstemp_av(i,ns)=val_av(i, i_av+(ns-1))/part(i)%ntime
          end do
          cycle
        case ('WD') ! Wet deposition
          if (wetdep) then
            wetdepotemp(i,:)=wetdeposit(i,:)
          endif
          cycle
        case ('DD') ! dry deposition
          if (drydep) then 
            drydepotemp(i,:)=drydeposit(i,:)
          endif
          cycle
        case ('lo')
          if (.not. cartxyz_comp) then
            cartxyz(1) = part(i)%cartx_av/part(i)%ntime
            cartxyz(2) = part(i)%carty_av/part(i)%ntime
            cartxyz(3) = part(i)%cartz_av/part(i)%ntime
            cartxyz_comp=.true.
          endif
          output(np,i) = atan2(cartxyz(1),-1.*cartxyz(2))/pi180
          if (output(np,i).gt.360.) output(np,i)=output(np,i)-360.
          if (output(np,i).lt.0.) output(np,i)=output(np,i)+360.
          cycle
        case ('la')
          if (.not. cartxyz_comp) then
            cartxyz(1) = part(i)%cartx_av/part(i)%ntime
            cartxyz(2) = part(i)%carty_av/part(i)%ntime
            cartxyz(3) = part(i)%cartz_av/part(i)%ntime
            cartxyz_comp=.true.
          endif
          output(np,i) = atan2(cartxyz(3),sqrt(cartxyz(1)*cartxyz(1)+ &
            cartxyz(2)*cartxyz(2)))/pi180
        case default
          if (.not. partopt(np)%average) then
            call interpol_partoutput_val(partopt(np)%name,output(np,i),i)
          else
            output(np,i) = val_av(i,i_av)/part(i)%ntime
          endif
      end select
    end do
    ! Reset dz1out
    !*************
    dz1out=-1
    cartxyz_comp=.false.

    if ((.not. init_out).and.(n_average.gt.0)) then
      val_av(i,:) = 0.
      part(i)%ntime = 0.
      part(i)%cartx_av = 0.
      part(i)%carty_av = 0.
      part(i)%cartz_av = 0.
    endif
  end do

!$OMP END DO
!$OMP END PARALLEL

  if ((.not. init_out).and.(numpart.gt.0)) then
    do np=1,num_partopt
      if (.not. partopt(np)%print) cycle
      if (partopt(np)%name.eq.'MA') then
        write(*,*) partopt(np)%long_name, masstemp(1,:)
      else if (partopt(np)%name.eq.'ma') then
        write(*,*) partopt(np)%long_name, masstemp_av(1,:)
      else if (partopt(np)%name.eq.'WD'.and.wetdep) then
        write(*,*) partopt(np)%long_name, wetdepotemp(1,:)
      else if (partopt(np)%name.eq.'DD'.and.drydep) then
        write(*,*) partopt(np)%long_name, drydepotemp(1,:)
      else
        write(*,*) partopt(np)%long_name, output(np,1)
      endif
    end do
    write(*,*) 'Alive: ', count%alive, 'Total spawned: ', count%spawned, 'Terminated: ', count%terminated
  endif

  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss
  j=1
  ! if (lnetcdfout.eq.1) then
  ! open output file
  if (init_out) then
    call open_partinit_file(ncid)
  else 
    if (.not. lpartoutputperfield) then
      call open_partoutput_file(ncid)

      ! First allocate the time and particle dimensions within the netcdf file
    else
      do np=1,num_partopt
        if (.not. partopt(np)%print) cycle
        call open_partoutput_file(partopt(np)%ncid,np)
      end do
    endif

    call update_partoutput_pointers(itime, ncid)
    !ppointer_part = count%allocated
  endif
  ! Fill the fields in parallel
  if (numpart.gt.0) then

  ! OpenMP output does not work on all systems depending on how they are set-up
! !$OMP PARALLEL PRIVATE(np,ns,ncid_tmp)
! !$OMP DO SCHEDULE(dynamic)
    do np=1,num_partopt
      if (.not. partopt(np)%print) cycle
      if (init_out.and.(partopt(np)%i_average.ne.0)) cycle ! no averages for initial particle output
      if (lpartoutputperfield.and. (.not. init_out)) then
        ncid_tmp=partopt(np)%ncid
      else
        ncid_tmp = ncid
      endif
      if (partopt(np)%name.eq.'MA') then
        do ns=1,nspec
          if (init_out) then
            call partinit_netcdf(masstemp(:,ns),'MA',ns,ncid_tmp)
          else
            call partoutput_netcdf(itime,masstemp(:,ns),np,ns,ncid_tmp)
          endif
        end do
      else if (partopt(np)%name.eq.'ma') then
        do ns=1,nspec
          call partoutput_netcdf(itime,masstemp_av(:,ns),np,ns,ncid_tmp)
        end do
      else if ((.not. init_out).and.(partopt(np)%name.eq.'WD').and.wetdep) then
        do ns=1,nspec
          call partoutput_netcdf(itime,wetdepotemp(:,ns),np,ns,ncid_tmp)
        end do
      else if ((.not. init_out).and.(partopt(np)%name.eq.'DD').and.drydep) then
        do ns=1,nspec
          call partoutput_netcdf(itime,drydepotemp(:,ns),np,ns,ncid_tmp)
        end do
      else
        if (init_out) then
          call partinit_netcdf(output(np,:),partopt(np)%name,j,ncid_tmp)
        else
          call partoutput_netcdf(itime,output(np,:),np,j,ncid_tmp)
        endif
      endif
      if (lpartoutputperfield) call close_partoutput_file(ncid_tmp)
    end do
! !$OMP END DO
! !$OMP END PARALLEL
  endif
  if (.not. lpartoutputperfield) call close_partoutput_file(ncid)
  if (mdomainfill.ge.1 .and. (.not. init_out)) then
    mass_written=.true. ! needs to be reduced within openmp loop
    topo_written=.true. ! same
  endif
  !else
    ! Put binary function here
  !endif
#else
    ! Put binary function here
#endif
end subroutine output_particles

subroutine output_conc(itime,loutstart,loutend,loutnext,outnum)
  use unc_mod
  use outgrid_mod
  use par_mod
  use com_mod
  use binary_output_mod 

  implicit none

  integer,intent(in) ::     &
    itime                     ! time index
  integer,intent(inout) ::  &
    loutstart,loutend,      & ! concentration calculation starting and ending time
    loutnext
  real,intent(inout) ::     &
    outnum                    ! concentration calculation sample number
  real(sp) ::               &
    gridtotalunc              ! concentration calculation related
  real(dep_prec) ::         &
    wetgridtotalunc,        & ! concentration calculation related
    drygridtotalunc           ! concentration calculation related
  real ::                   &
    weight                    ! concentration calculation sample weight


  ! Is the time within the computation interval, if not, return
  !************************************************************
  if ((ldirect*itime.lt.ldirect*loutstart).or.(ldirect*itime.gt.ldirect*loutend)) then
    return
  endif

  ! If we are exactly at the start or end of the concentration averaging interval,
  ! give only half the weight to this sample
  !*****************************************************************************
  if (mod(itime-loutstart,loutsample).eq.0) then
    if ((itime.eq.loutstart).or.(itime.eq.loutend)) then
      weight=0.5
    else
      weight=1.0
    endif
    outnum=outnum+weight
    if (iout.ne.0) call conccalc(itime,weight)
  endif

  ! If no grid is to be written to file, return (LB)
  !*************************************************
  if (iout.eq.0) then 
    if (itime.ne.loutend) return
    loutnext=loutnext+loutstep
    loutstart=loutnext-loutaver/2
    loutend=loutnext+loutaver/2
    if (itime.eq.loutstart) then
      weight=0.5
      outnum=outnum+weight
    endif
    return
  endif

  ! If it is not time yet to write outputs, return
  !***********************************************
  if ((itime.ne.loutend).or.(outnum.le.0).or.(itime.eq.itime_init)) then
    return
  endif

  ! Output and reinitialization of grid
  ! If necessary, first sample of new grid is also taken
  !*****************************************************
  if ((iout.le.3.).or.(iout.eq.5)) then
    if (linversionout.eq.0) then
      ! regular output format
      if (lnetcdfout.eq.1) then
#ifdef USE_NCF
        call concoutput_netcdf(itime,outnum,gridtotalunc,wetgridtotalunc,drygridtotalunc)
#endif
      else
        call concoutput(itime,outnum,gridtotalunc,wetgridtotalunc,drygridtotalunc)
      endif
    else
      ! inversion output - one file each release
      if (lnetcdfout.eq.1) then
        write(*,*) 'FLEXPART ERROR: netcdf output not avaiable yet for inversion format'
        error stop
      else
        call concoutput_inversion(itime,outnum,gridtotalunc,wetgridtotalunc,drygridtotalunc)
      endif
    endif

    if (nested_output .eq. 1) then
      if (linversionout.eq.0) then
        ! regular output format
        if (lnetcdfout.eq.1) then
#ifdef USE_NCF
          call concoutput_nest_netcdf(itime,outnum)
#endif
        else 
           call concoutput_nest(itime,outnum)
        endif
      else
        ! inversion output
        if (lnetcdfout.eq.1) then
          write(*,*) 'FLEXPART ERROR: netcdf output not avaiable yet for inversion format'
          error stop
        else
          call concoutput_inversion_nest(itime,outnum)
        endif
      endif
    endif
    outnum=0.
  endif

  write(*,45) itime,numpart,gridtotalunc,wetgridtotalunc,drygridtotalunc

45      format(i13,' Seconds simulated: ',i13, ' Particles:    Uncertainty: ',3f7.3)

  loutnext=loutnext+loutstep
  loutstart=loutnext-loutaver/2
  loutend=loutnext+loutaver/2
  if (itime.eq.loutstart) then
    weight=0.5
    outnum=outnum+weight
    call conccalc(itime,weight)
  endif
end subroutine output_conc

subroutine conccalc(itime,weight)
  !                      i     i
  !*****************************************************************************
  !                                                                            *
  !     Calculation of the concentrations on a regular grid using volume       *
  !     sampling                                                               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1996                                                            *
  !                                                                            *
  !     April 2000: Update to calculate age spectra                            *
  !                 Bug fix to avoid negative conc. at the domain boundaries,  *
  !                 as suggested by Petra Seibert                              *
  !                                                                            *
  !     2 July 2002: re-order if-statements in order to optimize CPU time      *
  !                                                                            *
  !     2021, LB: OpenMP parallelisation                                       *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! nspeciesdim     = nspec for forward runs, 1 for backward runs              *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use outgrid_mod
  use par_mod
  use com_mod
  use omp_lib, only: OMP_GET_THREAD_NUM
  use interpol_mod, only: interpol_density
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use particle_mod

  implicit none

  integer,intent(in) :: itime
  real,intent(in) :: weight
  integer :: itage,i,j,kz,ks,n,nage,inage,thread,ithread
  integer :: nrelpointer
  integer :: ix,jy,ixp,jyp
  real :: ddx,ddy
  real :: hx,hy,hz,hxyz,xd,yd,zd,xkern,r2,c(maxspec)
  real :: rhoi
  real :: xl,yl,wx,wy,w
  real,parameter :: factor=.596831, hxmax=6.0, hymax=4.0, hzmax=150.
  !  integer xscav_count

  ! For forward simulations, make a loop over the number of species;
  ! for backward simulations, make an additional loop over the
  ! releasepoints
  !***************************************************************************
  !  xscav_count=0
#ifdef _OPENMP
  call omp_set_num_threads(numthreads_grid)
#endif
!$OMP PARALLEL PRIVATE(i,itage,nage,inage,rhoi,nrelpointer,kz,xl,yl,ks,wx,wy,w,thread,ddx,ddy, &
!$OMP ix,jy,ixp,jyp)

#if (defined _OPENMP)
    thread = OMP_GET_THREAD_NUM()+1 ! Starts with 1
#else
    thread = 1
#endif

!$OMP DO
  do j=1,count%alive

    i=count%ialive(j)

  ! Determine age class of the particle
    itage=abs(itime-part(i)%tstart)
    nage=1
    if (lagespectra.eq.1) then
      do inage=1,nageclass
        nage=inage
        if (itage.lt.lage(nage)) exit
      end do
    endif

  !  if (xscav_frac1(i,1).lt.0) xscav_count=xscav_count+1
           
  !************************************************************************
  ! For special runs, interpolate the air density to the particle position
  !************************************************************************
  !AF IND_SOURCE switches between different units for concentrations at the source
  !Af    NOTE that in backward simulations the release of particles takes place
  !Af    at the receptor and the sampling at the source.
  !Af          1="mass"
  !Af          2="mass mixing ratio"
  !Af IND_RECEPTOR switches between different units for concentrations at the receptor
  !Af          1="mass"
  !Af          2="mass mixing ratio"
  !Af switches for the conccalcfile:
  !AF IND_SAMP =  0 : xmass * 1
  !Af IND_SAMP = -1 : xmass / rho
  !Af ind_samp is defined in readcommand.f
  !************************************************************************

    if ( ind_samp .eq. -1 ) then
#ifdef ETA
      call update_zeta_to_z(itime,i)
#endif
      call interpol_density(itime,i,rhoi)
    elseif (ind_samp.eq.0) then 
      rhoi = 1.
    endif

  !****************************************************************************
  ! 1. Evaluate grid concentrations using a uniform kernel of bandwidths dx, dy
  !****************************************************************************
  ! For backward simulations, look from which release point the particle comes from
  ! For domain-filling trajectory option, npoint contains a consecutive particle
  ! number, not the release point information. Therefore, nrelpointer is set to 1
  ! for the domain-filling option.
  !*****************************************************************************

    if ((ioutputforeachrelease.eq.0).or.(mdomainfill.eq.1)) then
       nrelpointer=1
    else
       nrelpointer=part(i)%npoint
    endif

    do kz=1,numzgrid                ! determine height of cell
      if (outheight(kz).gt.part(i)%z) exit
    end do

    if (kz.le.numzgrid) then           ! inside output domain


  !********************************
  ! Do everything for mother domain
  !********************************

      xl=(real(part(i)%xlon)*dx+xoutshift)/dxout
      yl=(real(part(i)%ylat)*dy+youtshift)/dyout
      ix=int(xl)
      if (xl.lt.0.) ix=ix-1
      jy=int(yl)
      if (yl.lt.0.) jy=jy-1



  ! For particles aged less than 3 hours, attribute particle mass to grid cell
  ! it resides in rather than use the kernel, in order to avoid its smoothing effect.
  ! For older particles, use the uniform kernel.
  ! If a particle is close to the domain boundary, do not use the kernel either.
  !*****************************************************************************

      if ((.not.lusekerneloutput).or.(itage.lt.10800).or. &
           (xl.lt.0.5).or.(yl.lt.0.5).or. &
           (xl.gt.real(numxgrid-1)-0.5).or. &
           (yl.gt.real(numygrid-1)-0.5)) then             ! no kernel, direct attribution to grid cell

        if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
             (jy.le.numygrid-1)) then
          if (DRYBKDEP.or.WETBKDEP) then
            do ks=1,nspec
#ifdef _OPENMP
              gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                   gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                   mass(i,ks)/rhoi*weight*max(xscav_frac1(i,ks),0.0)
#else
              gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                   gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                   mass(i,ks)/rhoi*weight*max(xscav_frac1(i,ks),0.0)
#endif
            end do
          else
            if (lparticlecountoutput) then
              do ks=1,nspec
#ifdef _OPENMP
                gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+1
#else
                gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+1
#endif
              end do
            else
              if (llcmoutput) then
                ! special case LCM output use mass ratio species to airtracer
                ! species 1 is always airtracer
                do ks=2,nspec
#ifdef _OPENMP
                  gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                       gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                       mass(i,ks)/mass(i,1)*weight
#else
                  gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                       gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                       mass(i,ks)/mass(i,1)*weight
#endif
                end do
#ifdef _OPENMP
                gridcnt_omp(ix,jy,kz,thread)=gridcnt_omp(ix,jy,kz,thread)+weight
#else
                gridcnt(ix,jy,kz)=gridcnt(ix,jy,kz)+weight
#endif
              else
                do ks=1,nspec
#ifdef _OPENMP
                  gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                       gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                       mass(i,ks)/rhoi*weight
#else
                  gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                       gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                       mass(i,ks)/rhoi*weight
#endif
                end do
              end if ! llcmoutput
            end if
          endif
        endif

      else                                 ! attribution via uniform kernel 

        ddx=xl-real(ix)                   ! distance to left cell border
        ddy=yl-real(jy)                   ! distance to lower cell border
        if (ddx.gt.0.5) then
          ixp=ix+1
          wx=1.5-ddx
        else
          ixp=ix-1
          wx=0.5+ddx
        endif

        if (ddy.gt.0.5) then
          jyp=jy+1
          wy=1.5-ddy
        else
          jyp=jy-1
          wy=0.5+ddy
        endif

  ! Determine mass fractions for four grid points
  !**********************************************

        if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
          if ((jy.ge.0).and.(jy.le.numygrid-1)) then
            w=wx*wy
            if (DRYBKDEP.or.WETBKDEP) then
               do ks=1,nspec
#ifdef _OPENMP
                 gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                   gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                   mass(i,ks)/rhoi*w*weight*max(xscav_frac1(i,ks),0.0)
#else
                 gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                   gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                   mass(i,ks)/rhoi*w*weight*max(xscav_frac1(i,ks),0.0)
#endif
               end do
            else
              if (llcmoutput) then
                ! special case CTM output use mass ratio species to airtracer
                ! species 1 is always airtracer
                do ks=2,nspec
#ifdef _OPENMP
                  gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/mass(i,1)*weight*w
#else
                  gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/mass(i,1)*weight*w
#endif
                end do
#ifdef _OPENMP
                gridcnt_omp(ix,jy,kz,thread)=gridcnt_omp(ix,jy,kz,thread)+w*weight
#else
                gridcnt(ix,jy,kz)=gridcnt(ix,jy,kz)+w*weight
#endif
              else
                do ks=1,nspec
#ifdef _OPENMP
                  gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     gridunc_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w
#else
                  gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     gridunc(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w
#endif
                 end do
              endif ! llcmoutput
            endif
          endif

          if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
            w=wx*(1.-wy)
            if (DRYBKDEP.or.WETBKDEP) then
              do ks=1,nspec
#ifdef _OPENMP
                 gridunc_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                   gridunc_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                   mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#else
                 gridunc(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                   gridunc(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                   mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#endif
              end do
            else
              if (llcmoutput) then
                ! special case CTM output use mass ratio species to airtracer
                ! species 1 is always airtracer
                do ks=2,nspec
#ifdef _OPENMP
                  gridunc_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     gridunc_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/mass(i,1)*weight*w
#else
                  gridunc(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     gridunc(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/mass(i,1)*weight*w
#endif
                end do
#ifdef _OPENMP
                gridcnt_omp(ix,jyp,kz,thread)=gridcnt_omp(ix,jyp,kz,thread)+w*weight
#else
                gridcnt(ix,jyp,kz)=gridcnt(ix,jyp,kz)+w*weight
#endif
              else 
                do ks=1,nspec
#ifdef _OPENMP
                  gridunc_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     gridunc_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w
#else
                  gridunc(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     gridunc(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w
#endif
                end do
              endif ! llcmoutput
            endif
          endif
        endif !ix ge 0


        if ((ixp.ge.0).and.(ixp.le.numxgrid-1)) then
          if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
            w=(1.-wx)*(1.-wy)
            if (DRYBKDEP.or.WETBKDEP) then
               do ks=1,nspec
#ifdef _OPENMP
                 gridunc_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                   gridunc_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                   mass(i,ks)/rhoi*w*weight*max(xscav_frac1(i,ks),0.0)
#else
                 gridunc(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                   gridunc(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                   mass(i,ks)/rhoi*w*weight*max(xscav_frac1(i,ks),0.0)
#endif
               end do
            else
              if (llcmoutput) then
                ! special case CTM output use mass ratio species to airtracer
                ! species 1 is always airtracer
                do ks=2,nspec
#ifdef _OPENMP
                  gridunc_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     gridunc_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/mass(i,1)*weight*w
#else
                  gridunc(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     gridunc(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/mass(i,1)*weight*w
#endif
                end do
#ifdef _OPENMP
                gridcnt_omp(ixp,jyp,kz,thread)=gridcnt_omp(ixp,jyp,kz,thread)+w*weight
#else
                gridcnt(ixp,jyp,kz)=gridcnt(ixp,jyp,kz)+w*weight
#endif
              else
                do ks=1,nspec
#ifdef _OPENMP
                  gridunc_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     gridunc_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w
#else
                  gridunc(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     gridunc(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w
#endif
                end do
              endif ! llcmoutput
            endif
          endif

          if ((jy.ge.0).and.(jy.le.numygrid-1)) then
            w=(1.-wx)*wy
            if (DRYBKDEP.or.WETBKDEP) then
               do ks=1,nspec
#ifdef _OPENMP
                 gridunc_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                   gridunc_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                   mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#else
                 gridunc(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                   gridunc(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                   mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#endif
               end do
            else
              if (llcmoutput) then
                ! special case CTM output use mass ratio species to airtracer
                ! species 1 is always airtracer
                do ks=2,nspec
#ifdef _OPENMP
                  gridunc_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                    gridunc_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                    mass(i,ks)/mass(i,1)*weight*w
#else
                  gridunc(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                    gridunc(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                    mass(i,ks)/mass(i,1)*weight*w
#endif
                end do
#ifdef _OPENMP
                gridcnt_omp(ixp,jy,kz,thread)=gridcnt_omp(ixp,jy,kz,thread)+w*weight
#else
                gridcnt(ixp,jy,kz)=gridcnt(ixp,jy,kz)+w*weight
#endif
              else
                do ks=1,nspec
#ifdef _OPENMP
                  gridunc_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                    gridunc_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                    mass(i,ks)/rhoi*weight*w
#else
                  gridunc(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                    gridunc(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                    mass(i,ks)/rhoi*weight*w
#endif
                end do
              endif ! llcmoutput
            endif
          endif
        endif !ixp ge 0
      endif

  !************************************
  ! Do everything for the nested domain
  !************************************

      if (nested_output.eq.1) then
        xl=(real(part(i)%xlon)*dx+xoutshiftn)/dxoutn
        yl=(real(part(i)%ylat)*dy+youtshiftn)/dyoutn
        ix=int(xl)
        if (xl.lt.0.) ix=ix-1
        jy=int(yl)
        if (yl.lt.0.) jy=jy-1


  ! For particles aged less than 3 hours, attribute particle mass to grid cell
  ! it resides in rather than use the kernel, in order to avoid its smoothing effect.
  ! For older particles, use the uniform kernel.
  ! If a particle is close to the domain boundary, do not use the kernel either.
  !*****************************************************************************

        if ((itage.lt.10800).or.(xl.lt.0.5).or.(yl.lt.0.5).or. &
             (xl.gt.real(numxgridn-1)-0.5).or. &
             (yl.gt.real(numygridn-1)-0.5).or.((.not.lusekerneloutput))) then
  ! no kernel, direct attribution to grid cell
          if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgridn-1).and. &
               (jy.le.numygridn-1)) then
            if (DRYBKDEP.or.WETBKDEP) then
               do ks=1,nspec
#ifdef _OPENMP
                 griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                   griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                   mass(i,ks)/rhoi*weight*max(xscav_frac1(i,ks),0.0)
#else            
                 griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                   griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                   mass(i,ks)/rhoi*weight*max(xscav_frac1(i,ks),0.0)
#endif
               end do
            else
              if (lparticlecountoutput) then
                do ks=1,nspec
#ifdef _OPENMP
                  griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                       griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+1
#else  
                  griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                       griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+1
#endif
                end do
              else
                do ks=1,nspec
#ifdef _OPENMP
                  griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                       griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                       mass(i,ks)/rhoi*weight
#else            
                  griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                       griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                       mass(i,ks)/rhoi*weight
#endif
                end do
              endif
            endif
          endif
          
        else                                 ! attribution via uniform kernel

          ddx=xl-real(ix)                   ! distance to left cell border
          ddy=yl-real(jy)                   ! distance to lower cell border
          if (ddx.gt.0.5) then
            ixp=ix+1
            wx=1.5-ddx
          else
            ixp=ix-1
            wx=0.5+ddx
          endif

          if (ddy.gt.0.5) then
            jyp=jy+1
            wy=1.5-ddy
          else
            jyp=jy-1
            wy=0.5+ddy
          endif


  ! Determine mass fractions for four grid points
  !**********************************************

          if ((ix.ge.0).and.(ix.le.numxgridn-1)) then
            if ((jy.ge.0).and.(jy.le.numygridn-1)) then
              w=wx*wy
              if (DRYBKDEP.or.WETBKDEP) then
                 do ks=1,nspec
#ifdef _OPENMP
                   griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#else              
                   griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#endif
                 end do
              else
                do ks=1,nspec
#ifdef _OPENMP
                   griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w
#else            
                   griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ix,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w
#endif
                 end do
              endif
            endif

            if ((jyp.ge.0).and.(jyp.le.numygridn-1)) then
              w=wx*(1.-wy)
              if (DRYBKDEP.or.WETBKDEP) then
                 do ks=1,nspec
#ifdef _OPENMP
                   griduncn_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#else              
                   griduncn(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#endif
                 end do
              else
                 do ks=1,nspec
#ifdef _OPENMP
                   griduncn_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w
#else              
                   griduncn(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ix,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w
#endif
                 end do
              endif
            endif
          endif


          if ((ixp.ge.0).and.(ixp.le.numxgridn-1)) then
            if ((jyp.ge.0).and.(jyp.le.numygridn-1)) then
              w=(1.-wx)*(1.-wy)
              if (DRYBKDEP.or.WETBKDEP) then
                 do ks=1,nspec
#ifdef _OPENMP
                   griduncn_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#else              
                   griduncn(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#endif
                 end do
              else
                 do ks=1,nspec
#ifdef _OPENMP
                   griduncn_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w
#else              
                   griduncn(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ixp,jyp,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w
#endif
                 end do
              endif
            endif

            if ((jy.ge.0).and.(jy.le.numygridn-1)) then
              w=(1.-wx)*wy
              if (DRYBKDEP.or.WETBKDEP) then
                 do ks=1,nspec
#ifdef _OPENMP
                   griduncn_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#else              
                   griduncn(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w*max(xscav_frac1(i,ks),0.0)
#endif
                 end do
              else
                 do ks=1,nspec
#ifdef _OPENMP
                    griduncn_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)= &
                     griduncn_omp(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage,thread)+ &
                     mass(i,ks)/rhoi*weight*w
#else              
                    griduncn(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)= &
                     griduncn(ixp,jy,kz,ks,nrelpointer,part(i)%nclass,nage)+ &
                     mass(i,ks)/rhoi*weight*w
#endif
                 end do
              endif
            endif
          endif
        endif
      endif
    endif
  end do
!$OMP END DO
!$OMP END PARALLEL
#ifdef _OPENMP
  call omp_set_num_threads(numthreads)
#endif
  ! Reduction of gridunc and griduncn
#ifdef _OPENMP
  do ithread=1,numthreads_grid
    gridunc(:,:,:,:,:,:,:)=gridunc(:,:,:,:,:,:,:)+gridunc_omp(:,:,:,:,:,:,:,ithread)
    gridcnt(:,:,:)=gridcnt(:,:,:)+gridcnt_omp(:,:,:,ithread)
    gridunc_omp(:,:,:,:,:,:,:,ithread)=0.
    gridcnt_omp(:,:,:,ithread)=0.
  end do
  if (nested_output.eq.1) then 
    do ithread=1,numthreads_grid
      griduncn(:,:,:,:,:,:,:)=griduncn(:,:,:,:,:,:,:)+griduncn_omp(:,:,:,:,:,:,:,ithread)
      griduncn_omp(:,:,:,:,:,:,:,ithread)=0.
    end do
  endif

#endif

end subroutine conccalc

subroutine partpos_avg(itime,j)

  !**********************************************************************
  ! This subroutine averages particle quantities, to be used for particle
  ! dump (in partoutput.f90). Averaging is done over output interval.
  ! Author: A. Stohl
  ! Changes L Bakels:
  !    - Computing fields defined in PARTOPTIONS
  !**********************************************************************

  use par_mod
  use com_mod
  use interpol_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif

  implicit none

  integer,intent(in) :: itime,j
  integer :: np,i_av,ns,m
  real :: xlon,ylat,x,y,z
  real :: hm(2)
  real :: output
  real :: tr(2)!,energy

  logical :: cart_comp

  if (ipout.eq.0) return ! No need to compute averages since there is no particle output

  if (n_average.eq.0) return

  if (.not. part(j)%alive) return

  if (part(j)%nstop) return ! If particle is to be killed, averages cannot be computed

 ! Some variables needed for temporal interpolation
  !*************************************************
  call find_time_vars(itime)

  xlon=xlon0+real(part(j)%xlon)*dx
  ylat=ylat0+real(part(j)%ylat)*dy

  !*****************************************************************************
  ! Interpolate several variables (PV, specific humidity, etc.) to particle position
  !*****************************************************************************
  ! Where in the grid? Stereographic (ngrid<0) or nested (ngrid>0)
  !***************************************************************
  call find_ngrid(real(part(j)%xlon),real(part(j)%ylat))
  call find_grid_indices(real(part(j)%xlon),real(part(j)%ylat))
  call find_grid_distances(real(part(j)%xlon),real(part(j)%ylat))

  ! First set dz1out from interpol_mod to -1 so it only is calculated once per particle
  !************************************************************************************
  part(j)%ntime=part(j)%ntime + 1
  dz1out=-1
  cart_comp=.false.
  do np=1,num_partopt
    if ((.not. partopt(np)%print) .or. (.not. partopt(np)%average)) cycle
    i_av = partopt(np)%i_average
    select case (partopt(np)%name)
      case ('to')
        if (ngrid.le.0) then
          call hor_interpol(oro,output)
        else
          call hor_interpol_nest(oron,output)
        endif
        val_av(j,i_av)=val_av(j,i_av)+output
      case ('tr')
        if (ngrid.le.0) then
          do m=1,2
            call hor_interpol(tropopause,tr(m),1,memind(m),1)
          end do
        else
          do m=1,2
            call hor_interpol_nest(tropopausen,tr(m),1,memind(m),1)
          end do
        endif
        call temporal_interpolation(tr(1),tr(2),output)
        val_av(j,i_av)=val_av(j,i_av)+output
      case ('hm')
        if (ngrid.le.0) then
          do m=1,2
            call hor_interpol(hmix,hm(m),1,memind(m),1)
          end do
        else
          do m=1,2
            call hor_interpol_nest(hmixn,hm(m),1,memind(m),1)
          end do
        endif
        call temporal_interpolation(hm(1),hm(2),output)
        val_av(j,i_av)=val_av(j,i_av)+output
      case ('lo')
        if (.not. cart_comp) then
          ! Calculate Cartesian 3D coordinates suitable for averaging
          !**********************************************************

          xlon=xlon*pi180
          ylat=ylat*pi180
          x = cos(ylat)*sin(xlon)
          y = -1.*cos(ylat)*cos(xlon)
          z = sin(ylat)

          part(j)%cartx_av=part(j)%cartx_av+x
          part(j)%carty_av=part(j)%carty_av+y
          part(j)%cartz_av=part(j)%cartz_av+z
          cart_comp=.true.
        endif
      case ('la')
        if (.not. cart_comp) then
          ! Calculate Cartesian 3D coordinates suitable for averaging
          !**********************************************************

          xlon=xlon*pi180
          ylat=ylat*pi180
          x = cos(ylat)*sin(xlon)
          y = -1.*cos(ylat)*cos(xlon)
          z = sin(ylat)

          part(j)%cartx_av=part(j)%cartx_av+x
          part(j)%carty_av=part(j)%carty_av+y
          part(j)%cartz_av=part(j)%cartz_av+z
          cart_comp=.true.
        endif
      case ('zz')
        ! Convert eta z coordinate to meters if necessary. Can be moved to output only
        !************************************************
#ifdef ETA
        call update_zeta_to_z(itime,j)
#endif
        val_av(j,i_av)=val_av(j,i_av)+real(part(j)%z)
      case ('ma')
        do ns=1,nspec
          val_av(j,i_av+(ns-1))=val_av(j,i_av+(ns-1))+mass(j,ns)
        end do
      case ('vs')
        val_av(j,i_av)=val_av(j,i_av)+part(j)%settling
      case default
        call interpol_partoutput_val(partopt(np)%name,output,j)
        val_av(j,i_av)=val_av(j,i_av)+output
    end select
  end do
  ! Reset dz1out
  !*************
  dz1out=-1
  cart_comp=.false.

  return
end subroutine partpos_avg

end module output_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine interpol_misslev(n)
  !                            i
  !*****************************************************************************
  !                                                                            *
  !  This subroutine interpolates u,v,w, density and density gradients.        *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    16 December 1997                                                        *
  !    Update: 2 March 1999                                                    *
  !                                                                            *
  !  Revision March 2005 by AST : all output variables in common block cal-    *
  !                               culation of standard deviation done in this  *
  !                               routine rather than subroutine call in order *
  !                               to save computation time                     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  level                                                   *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use interpol_mod
  use hanna_mod

  implicit none

  ! Auxiliary variables needed for interpolation
  real :: y1(2),y2(2),y3(2),rho1(2),rhograd1(2)
  real :: usl,vsl,wsl,usq,vsq,wsq,xaux
  integer :: m,n,indexh
  real,parameter :: eps=1.0e-30


  !********************************************
  ! Multilinear interpolation in time and space
  !********************************************


  !**************************************
  ! 1.) Bilinear horizontal interpolation
  ! 2.) Temporal interpolation (linear)
  !**************************************

  ! Loop over 2 time steps
  !***********************

  usl=0.
  vsl=0.
  wsl=0.
  usq=0.
  vsq=0.
  wsq=0.
  do m=1,2
    indexh=memind(m)
    if (ngrid.lt.0) then
      y1(m)=p1*uupol(ix ,jy ,n,indexh) &
           +p2*uupol(ixp,jy ,n,indexh) &
           +p3*uupol(ix ,jyp,n,indexh) &
           +p4*uupol(ixp,jyp,n,indexh)
      y2(m)=p1*vvpol(ix ,jy ,n,indexh) &
           +p2*vvpol(ixp,jy ,n,indexh) &
           +p3*vvpol(ix ,jyp,n,indexh) &
           +p4*vvpol(ixp,jyp,n,indexh)
        usl=usl+uupol(ix ,jy ,n,indexh)+uupol(ixp,jy ,n,indexh) &
             +uupol(ix ,jyp,n,indexh)+uupol(ixp,jyp,n,indexh)
        vsl=vsl+vvpol(ix ,jy ,n,indexh)+vvpol(ixp,jy ,n,indexh) &
             +vvpol(ix ,jyp,n,indexh)+vvpol(ixp,jyp,n,indexh)

        usq=usq+uupol(ix ,jy ,n,indexh)*uupol(ix ,jy ,n,indexh)+ &
             uupol(ixp,jy ,n,indexh)*uupol(ixp,jy ,n,indexh)+ &
             uupol(ix ,jyp,n,indexh)*uupol(ix ,jyp,n,indexh)+ &
             uupol(ixp,jyp,n,indexh)*uupol(ixp,jyp,n,indexh)
        vsq=vsq+vvpol(ix ,jy ,n,indexh)*vvpol(ix ,jy ,n,indexh)+ &
             vvpol(ixp,jy ,n,indexh)*vvpol(ixp,jy ,n,indexh)+ &
             vvpol(ix ,jyp,n,indexh)*vvpol(ix ,jyp,n,indexh)+ &
             vvpol(ixp,jyp,n,indexh)*vvpol(ixp,jyp,n,indexh)
    else
      y1(m)=p1*uu(ix ,jy ,n,indexh) &
           +p2*uu(ixp,jy ,n,indexh) &
           +p3*uu(ix ,jyp,n,indexh) &
           +p4*uu(ixp,jyp,n,indexh)
      y2(m)=p1*vv(ix ,jy ,n,indexh) &
           +p2*vv(ixp,jy ,n,indexh) &
           +p3*vv(ix ,jyp,n,indexh) &
           +p4*vv(ixp,jyp,n,indexh)
      usl=usl+uu(ix ,jy ,n,indexh)+uu(ixp,jy ,n,indexh) &
           +uu(ix ,jyp,n,indexh)+uu(ixp,jyp,n,indexh)
      vsl=vsl+vv(ix ,jy ,n,indexh)+vv(ixp,jy ,n,indexh) &
           +vv(ix ,jyp,n,indexh)+vv(ixp,jyp,n,indexh)

      usq=usq+uu(ix ,jy ,n,indexh)*uu(ix ,jy ,n,indexh)+ &
           uu(ixp,jy ,n,indexh)*uu(ixp,jy ,n,indexh)+ &
           uu(ix ,jyp,n,indexh)*uu(ix ,jyp,n,indexh)+ &
           uu(ixp,jyp,n,indexh)*uu(ixp,jyp,n,indexh)
      vsq=vsq+vv(ix ,jy ,n,indexh)*vv(ix ,jy ,n,indexh)+ &
           vv(ixp,jy ,n,indexh)*vv(ixp,jy ,n,indexh)+ &
           vv(ix ,jyp,n,indexh)*vv(ix ,jyp,n,indexh)+ &
           vv(ixp,jyp,n,indexh)*vv(ixp,jyp,n,indexh)
    endif
    y3(m)=p1*ww(ix ,jy ,n,indexh) &
         +p2*ww(ixp,jy ,n,indexh) &
         +p3*ww(ix ,jyp,n,indexh) &
         +p4*ww(ixp,jyp,n,indexh)
    rhograd1(m)=p1*drhodz(ix ,jy ,n,indexh) &
         +p2*drhodz(ixp,jy ,n,indexh) &
         +p3*drhodz(ix ,jyp,n,indexh) &
         +p4*drhodz(ixp,jyp,n,indexh)
    rho1(m)=p1*rho(ix ,jy ,n,indexh) &
         +p2*rho(ixp,jy ,n,indexh) &
         +p3*rho(ix ,jyp,n,indexh) &
         +p4*rho(ixp,jyp,n,indexh)
    wsl=wsl+ww(ix ,jy ,n,indexh)+ww(ixp,jy ,n,indexh) &
         +ww(ix ,jyp,n,indexh)+ww(ixp,jyp,n,indexh)
    wsq=wsq+ww(ix ,jy ,n,indexh)*ww(ix ,jy ,n,indexh)+ &
         ww(ixp,jy ,n,indexh)*ww(ixp,jy ,n,indexh)+ &
         ww(ix ,jyp,n,indexh)*ww(ix ,jyp,n,indexh)+ &
         ww(ixp,jyp,n,indexh)*ww(ixp,jyp,n,indexh)
  end do
  uprof(n)=(y1(1)*dt2+y1(2)*dt1)*dtt
  vprof(n)=(y2(1)*dt2+y2(2)*dt1)*dtt
  wprof(n)=(y3(1)*dt2+y3(2)*dt1)*dtt
  rhoprof(n)=(rho1(1)*dt2+rho1(2)*dt1)*dtt
  rhogradprof(n)=(rhograd1(1)*dt2+rhograd1(2)*dt1)*dtt
  indzindicator(n)=.false.


  ! Compute standard deviations
  !****************************

  xaux=usq-usl*usl/8.
  if (xaux.lt.eps) then
    usigprof(n)=0.
  else
    usigprof(n)=sqrt(xaux/7.)
  endif

  xaux=vsq-vsl*vsl/8.
  if (xaux.lt.eps) then
    vsigprof(n)=0.
  else
    vsigprof(n)=sqrt(xaux/7.)
  endif


  xaux=wsq-wsl*wsl/8.
  if (xaux.lt.eps) then
    wsigprof(n)=0.
  else
    wsigprof(n)=sqrt(xaux/7.)
  endif


end subroutine interpol_misslev

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine interpol_rain_nests(yy1,yy2,yy3,nxmaxn,nymaxn,nzmax, &
       maxnests,ngrid,nxn,nyn,memind,xt,yt,level,itime1,itime2,itime, &
       yint1,yint2,yint3)
  !                                i   i   i    i      i      i
  !   i       i    i   i    i    i  i    i     i      i      i
  !  o     o     o
  !****************************************************************************
  !                                                                           *
  !  Interpolation of meteorological fields on 2-d model layers for nested    *
  !  grids. This routine is related to levlin3interpol.f for the mother domain*
  !                                                                           *
  !  In horizontal direction bilinear interpolation interpolation is used.    *
  !  Temporally a linear interpolation is used.                               *
  !  Three fields are interpolated at the same time.                          *
  !                                                                           *
  !  This is a special version of levlininterpol to save CPU time.            *
  !                                                                           *
  !  1 first time                                                             *
  !  2 second time                                                            *
  !                                                                           *
  !                                                                           *
  !     Author: A. Stohl                                                      *
  !                                                                           *
  !     15 March 2000                                                         *
  !                                                                           *
  !****************************************************************************
  !                                                                           *
  ! Variables:                                                                *
  !                                                                           *
  ! dt1,dt2              time differences between fields and current position *
  ! dz1,dz2              z distance between levels and current position       *
  ! height(nzmax)        heights of the model levels                          *
  ! indexh               help variable                                        *
  ! indz                 the level closest to the current trajectory position *
  ! indzh                help variable                                        *
  ! itime                current time                                         *
  ! itime1               time of the first wind field                         *
  ! itime2               time of the second wind field                        *
  ! ix,jy                x,y coordinates of lower left subgrid point          *
  ! level                level at which interpolation shall be done           *
  ! memind(3)            points to the places of the wind fields              *
  ! nx,ny                actual field dimensions in x,y and z direction       *
  ! nxmax,nymax,nzmax    maximum field dimensions in x,y and z direction      *
  ! xt                   current x coordinate                                 *
  ! yint                 the final interpolated value                         *
  ! yt                   current y coordinate                                 *
  ! yy(0:nxmax,0:nymax,nzmax,3) meteorological field used for interpolation   *
  ! zt                   current z coordinate                                 *
  !                                                                           *
  !****************************************************************************

  implicit none

  integer :: maxnests,ngrid
  integer :: nxn(maxnests),nyn(maxnests),nxmaxn,nymaxn,nzmax,memind(2)
  integer :: m,ix,jy,ixp,jyp,itime,itime1,itime2,level,indexh
  real :: yy1(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: yy2(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: yy3(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
  real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4



  ! If point at border of grid -> small displacement into grid
  !***********************************************************

  if (xt.ge.(real(nxn(ngrid)-1)-0.0001)) &
       xt=real(nxn(ngrid)-1)-0.0001
  if (yt.ge.(real(nyn(ngrid)-1)-0.0001)) &
       yt=real(nyn(ngrid)-1)-0.0001



  !**********************************************************************
  ! 1.) Bilinear horizontal interpolation
  ! This has to be done separately for 2 fields (Temporal)
  !*******************************************************

  ! Determine the lower left corner and its distance to the current position
  !*************************************************************************

  ix=int(xt)
  jy=int(yt)
  ixp=ix+1
  jyp=jy+1
  ddx=xt-real(ix)
  ddy=yt-real(jy)
  rddx=1.-ddx
  rddy=1.-ddy
  p1=rddx*rddy
  p2=ddx*rddy
  p3=rddx*ddy
  p4=ddx*ddy


  ! Loop over 2 time steps
  !***********************

  do m=1,2
    indexh=memind(m)

    y1(m)=p1*yy1(ix ,jy ,level,indexh,ngrid) &
         + p2*yy1(ixp,jy ,level,indexh,ngrid) &
         + p3*yy1(ix ,jyp,level,indexh,ngrid) &
         + p4*yy1(ixp,jyp,level,indexh,ngrid)
    y2(m)=p1*yy2(ix ,jy ,level,indexh,ngrid) &
         + p2*yy2(ixp,jy ,level,indexh,ngrid) &
         + p3*yy2(ix ,jyp,level,indexh,ngrid) &
         + p4*yy2(ixp,jyp,level,indexh,ngrid)
    y3(m)=p1*yy3(ix ,jy ,level,indexh,ngrid) &
         + p2*yy3(ixp,jy ,level,indexh,ngrid) &
         + p3*yy3(ix ,jyp,level,indexh,ngrid) &
         + p4*yy3(ixp,jyp,level,indexh,ngrid)
  end do


  !************************************
  ! 2.) Temporal interpolation (linear)
  !************************************

  dt1=real(itime-itime1)
  dt2=real(itime2-itime)
  dt=dt1+dt2

  yint1=(y1(1)*dt2+y1(2)*dt1)/dt
  yint2=(y2(1)*dt2+y2(2)*dt1)/dt
  yint3=(y3(1)*dt2+y3(2)*dt1)/dt


end subroutine interpol_rain_nests

    program flexpartread

    parameter(nxmax=720,nymax=360,nzmax=40,maxtime=10)
    parameter(maxpoint=1,maxspec=1,maxageclass=1)

    double precision :: jul,julstart,juldate
    real :: outheight(nzmax)
    integer :: ireleasestart(maxpoint),ireleaseend(maxpoint)
    integer :: lage(0:maxageclass)
    real :: xpoint(maxpoint),ypoint(maxpoint),zpoint1(maxpoint)
    real :: zpoint2(maxpoint)
    integer :: ireldate(maxspec),ireltime(maxspec)

    real :: grid(0:nxmax-1,0:nymax-1,nzmax,maxspec,maxageclass)
    real :: footprint(0:nxmax-1,0:nymax-1)
    real :: footprint_total(0:nxmax-1,0:nymax-1,maxspec)
    real :: area(0:nxmax-1,0:nymax-1)
    real :: heightnn(0:nxmax-1,0:nymax-1,0:nzmax)
    real :: smallnum,r_sparse_dump(5000000)
    integer :: i_sparse_dump(5000000)
    parameter(smallnum=1.e-38)

    character dirname*120
    logical ::  dirnameisarg
    character filename*150,fileout*150,aday*8,atime*6
    character(250) :: filegrid
          
    logical :: sp_zer

    real :: sizegrid_m
    real :: sum_grid, sum_sum_grid
    real :: max_grid, max_max_grid
    character(4) :: grid_magnitude

    grid_magnitude='time'
    grid_magnitude='conc'
    grid_magnitude='pptv'

    dirnameisarg= .FALSE. 
    print*, 'iargc=', iargc()
    select case (iargc())
    case (2)
    dirnameisarg= .TRUE. 
    call getarg(1,dirname)
    len=index(dirname,' ')-1
    call getarg(2,grid_magnitude)
    case (1)
    call getarg(1,dirname)
    len=index(dirname,' ')-1
    !call getarg(1,grid_magnitude)
    case (0)
    grid_magnitude='time'
    end select
    print*, 'grid_magnitude=', grid_magnitude

 !   if ( .NOT. dirnameisarg) then
 !   !******************
 !       print*, " Read CONTROL file "
    !******************
 !       open(15,file='dirlist')
 !       200 read(15,'(a)',end=199) dirname
 !       len=index(dirname,' ')-1
 !   endif

!      do 50 mother_or_nest=1,2
    do 50 mother_or_nest=1,1

    !*********************************
    ! Read FLEXPART header information
    !*********************************

        if (mother_or_nest == 1) then
            filename=dirname(1:len)//'header'
        else if (mother_or_nest == 2) then
            filename=dirname(1:len)//'header_nest'
        endif
        print*, 'call readheader10f for', filename
    !        call readheader(filename,nxmax,numxgrid,nymax,numygrid,nzmax,
        call readheader10f(filename,nxmax,numxgrid,nymax,numygrid,nzmax, &
        numzgrid,outlon0,outlat0,dxout,dyout,outheight,ibdate,ibtime, &
        loutstep,maxspec,nspec,maxageclass,nageclass,lage,ireleasestart, &
        ireleaseend,maxpoint,numpoint,xpoint,ypoint,zpoint1,zpoint2, &
        heightnn,area)
        print*, 'print readheader10f output'
        print*,'! Write the header information'
                
        print*,'! Write info on output interval, averaging time, samplin &
        g time'
        print*,'! Write information on output grid setup'
        print*,'! Write number of species, and name for each species '
        print*,'dimension of the fields (1 for depo, numzgrid for conc)'
        print*,'! Write information on release points:'
        print*,'! Write information on some model switches'
        print*,'! Write age class information'
        print*,'! Write topography to output file'

                
        print*,'filename'
        !print*,

        print*,'nxmax,numxgrid,nymax,numygrid='
        print*,filename,nxmax,numxgrid,nymax,numygrid
        
        print*,'nzmax, numzgrid='
        print*,nzmax,numzgrid

        print*,'outlon0,outlat0,dxout,dyout,' 
        print*,outlon0,outlat0,dxout,dyout 
        
        print*,' outheight='
        do i=1,numzgrid
        print*, i, outheight(i)
        end do

        print*, 'ibdate,ibtime, loutstep'
        print*, ibdate,ibtime, loutstep

!  ,,,ireleasestart, &
!        ireleaseend,maxpoint,numpoint,xpoint,ypoint,zpoint1,zpoint2, &
!       heightnn,area)


        print*,'maxspec,nspec'
        print*,maxspec,nspec
    ! rint*,
        print*,'maxageclass,nageclass'
        print*, maxageclass,nageclass
    ! rint*,
        print*,'lage'
        print*, lage 

        print*,'ireleasestart,   ireleaseend,'
        print*, ireleasestart,   ireleaseend 

        print*,'maxpoint,numpoint'
        print*, maxpoint,numpoint 

        print*,'xpoint,ypoint'
        print*, xpoint,ypoint 

        print*,'zpoint1,zpoint2'
        print*, zpoint1,zpoint2  

        print*,'heightnn'
        print*, size(heightnn) 

!        print*,'xpoint,ypoint,zpoint1,zpoint2,'
!        print*, xpoint,ypoint,zpoint1,zpoint2 

    ! rint*,

        write(*,*) 'nspec',nspec
        julstart=juldate(ibdate,ibtime)
        do 30 k=1,nspec
            print*, 'k', k 
            jul=julstart+dble(float(ireleaseend(k))/86400.)
            call caldate(jul,ireldate(k),ireltime(k))
            print*,'ireldate',ireldate(k)
            print*,'ireltime',ireltime(k)
        30 END DO


         
    !      print*, 'about to exit'
    !      exit

    50 END DO

 !   if ( .NOT. dirnameisarg) then
 !       goto 200 !read(15, dirlist
 !       199 close(15) !dirlist
 !   endif

! ax_max_grid=max(max_max_grid,max_grid)
! um_sum_grid=sum_sum_grid+sum_grid

!         print*, 'for all times'
!         print*, 'sum sum(grid)=', sum_sum_grid
!         print*, 'max maxval(grid)=', max_max_grid

!         print*, 'sum_sum_grid_out=',sum_sum_grid
!         print*, 'max_max_grid_out=',max_max_grid
    END PROGRAM

program printpart

use work_arrays

CHARACTER(len=150)     :: flexout
CHARACTER (len=14), dimension(:), ALLOCATABLE  :: dates
CHARACTER (len=14) :: date
integer numpart !,nspec
real :: mx,my,mz



  flexout='/Users/ignacio/repos/flexpart/tests/examples/output_3-part1/'
  !date='20120101080000'
  !date='20120101090000'
  date='20120101100000'
  numpart=-1
  nspec=1

select case (iargc())
case (4)
  call getarg(1,flexout)  
  call getarg(2,date)  
  !call getarg(3,nspec)  
  !call getarg(4,numpart)  
case (3)
  call getarg(1,flexout)  
  call getarg(2,date)  
  !call getarg(3,nspec)  
case (2)
  call getarg(1,flexout)  
  call getarg(2,date)  
case (1)
  call getarg(1,flexout) 
  date='0000'
case (0)
  print*,'0 arguments, default'
  print*, flexout
  print*, date

end select

!CALL readpart2(flexout,dates(idate),numpart)
!CALL readpart2(flexout,date,numpart)
CALL readpart(flexout,date,numpart)

if (.false.) then
print*, 'numpart read:', numpart
numpart=5
endif

ALLOCATE(vnpoint(numpart),vitramem(numpart) )
ALLOCATE(vxlon(numpart),vylat(numpart) ,vztra1(numpart), &
          vtri(numpart),vhmixi(numpart),vtopo(numpart) , &
          vpvi(numpart),vtti(numpart),                   &
          vqvi(numpart),vrhoi(numpart)) 
ALLOCATE(xmass0(numpart,nspec))

CALL readpart(flexout,date,numpart)

if (.false.) then
print*, vnpoint
print*, vxlon
print*, vylat
print*, vztra1
endif

mx = SUM(vxlon)/SIZE(vxlon) 
my = SUM(vylat)/SIZE(vylat) 
mz = SUM(vztra1)/SIZE(vztra1) 

if (.false.) then
print*, 'mean x = ', mx
print*, 'mean y = ', my
print*, 'mean z = ', mz
endif

print*, mx,my,mz


!print*, SUM((vxlon- )**2)/SIZE(Array)

end program

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine calcpv_nests(l,n,uuhn,vvhn,pvhn)
  !                        i i  i    i    o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of potential vorticity on 3-d nested grid                     *
  !                                                                            *
  !     Author: P. James                                                       *
  !     22 February 2000                                                       *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 2)       *
  ! l                  index of current nest                                   *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: n,ix,jy,i,j,k,kl,ii,jj,klvrp,klvrm,klpt,kup,kdn,kch
  integer :: jyvp,jyvm,ixvp,ixvm,jumpx,jumpy,jux,juy,ivrm,ivrp,ivr
  integer :: nlck,l
  real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt,ppmk
  real :: ppml(nuvzmax)
  real :: thup,thdn
  real,parameter :: eps=1.e-5,p0=101325
  real :: uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: pvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)

  ! Set number of levels to check for adjacent theta
  nlck=nuvz/3
  !
  ! Loop over entire grid
  !**********************
  do jy=0,nyn(l)-1
    phi = (ylat0n(l) + jy * dyn(l)) * pi / 180.
    f = 0.00014585 * sin(phi)
    tanphi = tan(phi)
    cosphi = cos(phi)
  ! Provide a virtual jy+1 and jy-1 in case we are on domain edge (Lat)
      jyvp=jy+1
      jyvm=jy-1
      if (jy.eq.0) jyvm=0
      if (jy.eq.nyn(l)-1) jyvp=nyn(l)-1
  ! Define absolute gap length
      jumpy=2
      if (jy.eq.0.or.jy.eq.nyn(l)-1) jumpy=1
      juy=jumpy
  !
    do ix=0,nxn(l)-1
  ! Provide a virtual ix+1 and ix-1 in case we are on domain edge (Long)
      ixvp=ix+1
      ixvm=ix-1
      jumpx=2
      if (ix.eq.0) ixvm=0
      if (ix.eq.nxn(l)-1) ixvp=nxn(l)-1
      ivrp=ixvp
      ivrm=ixvm
  ! Define absolute gap length
      if (ix.eq.0.or.ix.eq.nxn(l)-1) jumpx=1
      jux=jumpx
  ! Precalculate pressure values for efficiency
      do kl=1,nuvz
        ppml(kl)=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
      end do
  !
  ! Loop over the vertical
  !***********************

      do kl=1,nuvz
        ppmk=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
        theta=tthn(ix,jy,kl,n,l)*(100000./ppmk)**kappa
        klvrp=kl+1
        klvrm=kl-1
        klpt=kl
  ! If top or bottom level, dthetadp is evaluated between the current
  ! level and the level inside, otherwise between level+1 and level-1
  !
        if (klvrp.gt.nuvz) klvrp=nuvz
        if (klvrm.lt.1) klvrm=1
        ppmk=akz(klvrp)+bkz(klvrp)*psn(ix,jy,1,n,l)
        thetap=tthn(ix,jy,klvrp,n,l)*(100000./ppmk)**kappa
        ppmk=akz(klvrm)+bkz(klvrm)*psn(ix,jy,1,n,l)
        thetam=tthn(ix,jy,klvrm,n,l)*(100000./ppmk)**kappa
        dthetadp=(thetap-thetam)/(ppml(klvrp)-ppml(klvrm))

  ! Compute vertical position at pot. temperature surface on subgrid
  ! and the wind at that position
  !*****************************************************************
  ! a) in x direction
        ii=0
        do i=ixvm,ixvp,jumpx
          ivr=i
          ii=ii+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
40        continue
  ! Upward branch
          kup=kup+1
          if (kch.ge.nlck) goto 21     ! No more levels to check,
  !                                       ! and no values found
          if (kup.ge.nuvz) goto 41
          kch=kch+1
          k=kup
          ppmk=akz(k)+bkz(k)*psn(ivr,jy,1,n,l)
          thdn=tthn(ivr,jy,k,n,l)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*psn(ivr,jy,1,n,l)
          thup=tthn(ivr,jy,k+1,n,l)*(100000./ppmk)**kappa

      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
    vx(ii)=(vvhn(ivr,jy,k,l)*dt2+vvhn(ivr,jy,k+1,l)*dt1)/dt
              goto 20
            endif
41        continue
  ! Downward branch
          kdn=kdn-1
          if (kdn.lt.1) goto 40
          kch=kch+1
          k=kdn
          ppmk=akz(k)+bkz(k)*psn(ivr,jy,1,n,l)
          thdn=tthn(ivr,jy,k,n,l)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*psn(ivr,jy,1,n,l)
          thup=tthn(ivr,jy,k+1,n,l)*(100000./ppmk)**kappa
      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
    vx(ii)=(vvhn(ivr,jy,k,l)*dt2+vvhn(ivr,jy,k+1,l)*dt1)/dt
              goto 20
            endif
            goto 40
  ! This section used when no values were found
21      continue
  ! Must use vv at current level and long. jux becomes smaller by 1
        vx(ii)=vvhn(ix,jy,kl,l)
        jux=jux-1
  ! Otherwise OK
20        continue
        end do
      if (jux.gt.0) then
      dvdx=(vx(2)-vx(1))/real(jux)/(dxn(l)*pi/180.)
      else
      dvdx=vvhn(ivrp,jy,kl,l)-vvhn(ivrm,jy,kl,l)
      dvdx=dvdx/real(jumpx)/(dxn(l)*pi/180.)
  ! Only happens if no equivalent theta value
  ! can be found on either side, hence must use values
  ! from either side, same pressure level.
      end if

  ! b) in y direction

        jj=0
        do j=jyvm,jyvp,jumpy
          jj=jj+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
70        continue
  ! Upward branch
          kup=kup+1
          if (kch.ge.nlck) goto 51     ! No more levels to check,
  !                                     ! and no values found
          if (kup.ge.nuvz) goto 71
          kch=kch+1
          k=kup
          ppmk=akz(k)+bkz(k)*psn(ix,j,1,n,l)
          thdn=tthn(ix,j,k,n,l)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*psn(ix,j,1,n,l)
          thup=tthn(ix,j,k+1,n,l)*(100000./ppmk)**kappa
      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
        uy(jj)=(uuhn(ix,j,k,l)*dt2+uuhn(ix,j,k+1,l)*dt1)/dt
              goto 50
            endif
71        continue
  ! Downward branch
          kdn=kdn-1
          if (kdn.lt.1) goto 70
          kch=kch+1
          k=kdn
          ppmk=akz(k)+bkz(k)*psn(ix,j,1,n,l)
          thdn=tthn(ix,j,k,n,l)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*psn(ix,j,1,n,l)
          thup=tthn(ix,j,k+1,n,l)*(100000./ppmk)**kappa
      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
        uy(jj)=(uuhn(ix,j,k,l)*dt2+uuhn(ix,j,k+1,l)*dt1)/dt
              goto 50
            endif
            goto 70
  ! This section used when no values were found
51      continue
  ! Must use uu at current level and lat. juy becomes smaller by 1
        uy(jj)=uuhn(ix,jy,kl,l)
        juy=juy-1
  ! Otherwise OK
50        continue
        end do
      if (juy.gt.0) then
      dudy=(uy(2)-uy(1))/real(juy)/(dyn(l)*pi/180.)
      else
      dudy=uuhn(ix,jyvp,kl,l)-uuhn(ix,jyvm,kl,l)
      dudy=dudy/real(jumpy)/(dyn(l)*pi/180.)
      end if
  !
      pvhn(ix,jy,kl,l)=dthetadp*(f+(dvdx/cosphi-dudy &
           +uuhn(ix,jy,kl,l)*tanphi)/r_earth)*(-1.e6)*9.81

  !
  ! Resest jux and juy
      jux=jumpx
      juy=jumpy
      end do
    end do
  end do
  !
end subroutine calcpv_nests

       SUBROUTINE readpart(flexout,datetime,numpart)
       use work_arrays
       implicit none
c      version 2 of 10 columns of reals
c      include '/home/ignacio/flexpart/FLEXPART8.1/includepar'
c      include '/home/ignacio/flexpart/FLEXPART8.1/includecom'
      DOUBLE PRECISION jul
!c      integer itime,i,j,jjjjmmdd,ihmmss itime in work_arrays
      integer i,j,jjjjmmdd,ihmmss
      integer ix,jy,ixp,jyp,indexh,m,il,ind,indz,indzp
      real xlon,ylat
      real dt1,dt2,dtt,ddx,ddy,rddx,rddy,p1,p2,p3,p4,dz1,dz2,dz
      real topo,hm(2),hmixi,pv1(2),pvprof(2),pvi,qv1(2),qvprof(2),qvi
      real tt1(2),ttprof(2),tti,rho1(2),rhoprof(2),rhoi
      real tr(2),tri
      character datetime*14 , flexout*150, filename*150     !atime*6,path*90,directory*90
      integer unitpartout
      integer iargc
      integer npoint
      real ztra1
      integer itramem(1)
c      real topo,pvi,qvi,rhoi,hmixi,tri,tti,
      real xmass(1,1) 
      !integer nspec,p
      integer p
      integer numpart
      integer ios 
      logical verbose

      verbose=.false. ! .true.
      unitpartout=1
      nspec=1

      filename=trim(flexout)//'partposit_'//datetime

      !print*,filename

      if ( datetime(1:1) == '0' ) then
        filename=trim(flexout)
        !print*,filename
        !stop 42
      endif

!      i=0
!      open(unitpartout,file=trim(flexout)//
!c     + 'part2_'//datetime,
!     + 'partposit_'//datetime,
!     + form='unformatted',IOSTAT=ios)
!
      open(unitpartout,file=trim(filename),
     + form='unformatted',IOSTAT=ios)

     
      read(unitpartout) itime
      if ( verbose ) then
        print *, 'readpart2> itime :' , itime
      endif
      if ( numpart==-1 ) then
        do while ( ios == 0 )
!          read(unitpartout, IOSTAT=ios)  xlon,ylat,ztra1,tri,hmixi
          read(unitpartout, IOSTAT=ios)  npoint, xlon,ylat,ztra1, !,tri,hmixi
     +    itramem,topo,pvi,qvi,rhoi,hmixi,tri,tti, xmass

        i=i+1
          if ( verbose ) then
            print *, 'readpart2> i,ios',  i,ios,npoint, xlon,ylat,ztra1 
          endif
!c      print *, 'ios', ios
!c          read(unitpartout) npoint,xlon,ylat,ztra1,
!c     +    itramem(i),topo,pvi,qvi,rhoi,hmixi,tri,tti,
!c     +    (xmass(i,j),j=1,nspec)
!npoint,xlon,ylat,ztra1,
!c     +    itramem(i),topo,pvi,qvi,rhoi,hmixi,tri,tti,
!c     +    xmass
        end do
!          numpart=i-1
          numpart=i-2
      else !numpart~=-1
        do i=1,numpart
!          read(unitpartout, IOSTAT=ios)  xlon,ylat,ztra1,tri,hmixi
!     +    ,topo,pvi,tti,qvi,rhoi
        read(unitpartout, IOSTAT=ios) vnpoint(i), 
     +    vxlon(i),vylat(i), vztra1(i),
     +    vitramem(i),
     +    vtopo(i),vpvi(i),vqvi(i),vrhoi(i),vhmixi(i), 
     +    vtri(i), vtti(i),
     +    (xmass0(i,j),j=1,nspec)
!        print *, 'readpart2> vztra1(i)',vztra1(i) ,i        
!c       vlat(i)=ylat
!c       interpolate OH from the field (needs month, x, y ,z )
!c        OH=
!c          print *, i,   xlon,ylat,ztra1,tri,hmixi
!c     + ,topo,pvi,tti,qvi,rhoi
        end do
      endif ! numpart==-1 
      close(unitpartout)
      end subroutine

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine boundcond_domainfill(itime,loutend)
  !                                  i      i
  !*****************************************************************************
  !                                                                            *
  ! Particles are created by this subroutine continuously throughout the       *
  ! simulation at the boundaries of the domain-filling box.                    *
  ! All particles carry the same amount of mass which alltogether comprises the*
  ! mass of air within the box, which remains (more or less) constant.         *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     16 October 2002                                                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nx_we(2)       grid indices for western and eastern boundary of domain-    *
  !                filling trajectory calculations                             *
  ! ny_sn(2)       grid indices for southern and northern boundary of domain-  *
  !                filling trajectory calculations                             *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod

  implicit none

  real :: dz,dz1,dz2,ran1,dt1,dt2,dtt,ylat,xm,cosfact,accmasst
  integer :: itime,in,indz,indzp,i,loutend
  integer :: j,k,ix,jy,m,indzh,indexh,minpart,ipart,mmass
  integer :: numactiveparticles

  real :: windl(2),rhol(2)
  real :: windhl(2),rhohl(2)
  real :: windx,rhox
  real :: deltaz,boundarea,fluxofmass

  integer :: ixm,ixp,jym,jyp,indzm,mm
  real :: pvpart,ddx,ddy,rddx,rddy,p1,p2,p3,p4,y1(2),yh1(2)

  integer :: idummy = -11


  ! If domain-filling is global, no boundary conditions are needed
  !***************************************************************

  if (gdomainfill) return

  accmasst=0.
  numactiveparticles=0

  ! Terminate trajectories that have left the domain, if domain-filling
  ! trajectory calculation domain is not global
  !********************************************************************

  do i=1,numpart
    if (itra1(i).eq.itime) then
      if ((ytra1(i).gt.real(ny_sn(2))).or. &
           (ytra1(i).lt.real(ny_sn(1)))) itra1(i)=-999999999
      if (((.not.xglobal).or.(nx_we(2).ne.(nx-2))).and. &
           ((xtra1(i).lt.real(nx_we(1))).or. &
           (xtra1(i).gt.real(nx_we(2))))) itra1(i)=-999999999
    endif
    if (itra1(i).ne.-999999999) numactiveparticles= &
         numactiveparticles+1
  end do


  ! Determine auxiliary variables for time interpolation
  !*****************************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)

  ! Initialize auxiliary variable used to search for vacant storage space
  !**********************************************************************

  minpart=1

  !***************************************
  ! Western and eastern boundary condition
  !***************************************

  ! Loop from south to north
  !*************************

  do jy=ny_sn(1),ny_sn(2)

  ! Loop over western (index 1) and eastern (index 2) boundary
  !***********************************************************

    do k=1,2

  ! Loop over all release locations in a column
  !********************************************

      do j=1,numcolumn_we(k,jy)

  ! Determine, for each release location, the area of the corresponding boundary
  !*****************************************************************************

        if (j.eq.1) then
          deltaz=(zcolumn_we(k,jy,2)+zcolumn_we(k,jy,1))/2.
        else if (j.eq.numcolumn_we(k,jy)) then
  !        deltaz=height(nz)-(zcolumn_we(k,jy,j-1)+
  !    +        zcolumn_we(k,jy,j))/2.
  ! In order to avoid taking a very high column for very many particles,
  ! use the deltaz from one particle below instead
          deltaz=(zcolumn_we(k,jy,j)-zcolumn_we(k,jy,j-2))/2.
        else
          deltaz=(zcolumn_we(k,jy,j+1)-zcolumn_we(k,jy,j-1))/2.
        endif
        if ((jy.eq.ny_sn(1)).or.(jy.eq.ny_sn(2))) then
          boundarea=deltaz*111198.5/2.*dy
        else
          boundarea=deltaz*111198.5*dy
        endif


  ! Interpolate the wind velocity and density to the release location
  !******************************************************************

  ! Determine the model level below the release position
  !*****************************************************

        do i=2,nz
          if (height(i).gt.zcolumn_we(k,jy,j)) then
            indz=i-1
            indzp=i
            goto 6
          endif
        end do
6       continue

  ! Vertical distance to the level below and above current position
  !****************************************************************

        dz1=zcolumn_we(k,jy,j)-height(indz)
        dz2=height(indzp)-zcolumn_we(k,jy,j)
        dz=1./(dz1+dz2)

  ! Vertical and temporal interpolation
  !************************************

        do m=1,2
          indexh=memind(m)
          do in=1,2
            indzh=indz+in-1
            windl(in)=uu(nx_we(k),jy,indzh,indexh)
            rhol(in)=rho(nx_we(k),jy,indzh,indexh)
          end do

          windhl(m)=(dz2*windl(1)+dz1*windl(2))*dz
          rhohl(m)=(dz2*rhol(1)+dz1*rhol(2))*dz
        end do

        windx=(windhl(1)*dt2+windhl(2)*dt1)*dtt
        rhox=(rhohl(1)*dt2+rhohl(2)*dt1)*dtt

  ! Calculate mass flux
  !********************

        fluxofmass=windx*rhox*boundarea*real(lsynctime)


  ! If the mass flux is directed into the domain, add it to previous mass fluxes;
  ! if it is out of the domain, set accumulated mass flux to zero
  !******************************************************************************

        if (k.eq.1) then
          if (fluxofmass.ge.0.) then
            acc_mass_we(k,jy,j)=acc_mass_we(k,jy,j)+fluxofmass
          else
            acc_mass_we(k,jy,j)=0.
          endif
        else
          if (fluxofmass.le.0.) then
            acc_mass_we(k,jy,j)=acc_mass_we(k,jy,j)+abs(fluxofmass)
          else
            acc_mass_we(k,jy,j)=0.
          endif
        endif
        accmasst=accmasst+acc_mass_we(k,jy,j)

  ! If the accumulated mass exceeds half the mass that each particle shall carry,
  ! one (or more) particle(s) is (are) released and the accumulated mass is
  ! reduced by the mass of this (these) particle(s)
  !******************************************************************************

        if (acc_mass_we(k,jy,j).ge.xmassperparticle/2.) then
          mmass=int((acc_mass_we(k,jy,j)+xmassperparticle/2.)/ &
               xmassperparticle)
          acc_mass_we(k,jy,j)=acc_mass_we(k,jy,j)- &
               real(mmass)*xmassperparticle
        else
          mmass=0
        endif

        do m=1,mmass
          do ipart=minpart,maxpart

  ! If a vacant storage space is found, attribute everything to this array element
  !*****************************************************************************

            if (itra1(ipart).ne.itime) then

  ! Assign particle positions
  !**************************

              xtra1(ipart)=real(nx_we(k))
              if (jy.eq.ny_sn(1)) then
                ytra1(ipart)=real(jy)+0.5*ran1(idummy)
              else if (jy.eq.ny_sn(2)) then
                ytra1(ipart)=real(jy)-0.5*ran1(idummy)
              else
                ytra1(ipart)=real(jy)+(ran1(idummy)-.5)
              endif
              if (j.eq.1) then
                ztra1(ipart)=zcolumn_we(k,jy,1)+(zcolumn_we(k,jy,2)- &
                     zcolumn_we(k,jy,1))/4.
              else if (j.eq.numcolumn_we(k,jy)) then
                ztra1(ipart)=(2.*zcolumn_we(k,jy,j)+ &
                     zcolumn_we(k,jy,j-1)+height(nz))/4.
              else
                ztra1(ipart)=zcolumn_we(k,jy,j-1)+ran1(idummy)* &
                     (zcolumn_we(k,jy,j+1)-zcolumn_we(k,jy,j-1))
              endif

  ! Interpolate PV to the particle position
  !****************************************
              ixm=int(xtra1(ipart))
              jym=int(ytra1(ipart))
              ixp=ixm+1
              jyp=jym+1
              ddx=xtra1(ipart)-real(ixm)
              ddy=ytra1(ipart)-real(jym)
              rddx=1.-ddx
              rddy=1.-ddy
              p1=rddx*rddy
              p2=ddx*rddy
              p3=rddx*ddy
              p4=ddx*ddy
              do i=2,nz
                if (height(i).gt.ztra1(ipart)) then
                  indzm=i-1
                  indzp=i
                  goto 26
                endif
              end do
26            continue
              dz1=ztra1(ipart)-height(indzm)
              dz2=height(indzp)-ztra1(ipart)
              dz=1./(dz1+dz2)
              do mm=1,2
                indexh=memind(mm)
                do in=1,2
                  indzh=indzm+in-1
                  y1(in)=p1*pv(ixm,jym,indzh,indexh) &
                       +p2*pv(ixp,jym,indzh,indexh) &
                       +p3*pv(ixm,jyp,indzh,indexh) &
                       +p4*pv(ixp,jyp,indzh,indexh)
                end do
                yh1(mm)=(dz2*y1(1)+dz1*y1(2))*dz
              end do
              pvpart=(yh1(1)*dt2+yh1(2)*dt1)*dtt
              ylat=ylat0+ytra1(ipart)*dy
              if (ylat.lt.0.) pvpart=-1.*pvpart


  ! For domain-filling option 2 (stratospheric O3), do the rest only in the stratosphere
  !*****************************************************************************

              if (((ztra1(ipart).gt.3000.).and. &
                   (pvpart.gt.pvcrit)).or.(mdomainfill.eq.1)) then
                nclass(ipart)=min(int(ran1(idummy)* &
                     real(nclassunc))+1,nclassunc)
                numactiveparticles=numactiveparticles+1
                numparticlecount=numparticlecount+1
                npoint(ipart)=numparticlecount
                idt(ipart)=mintime
                itra1(ipart)=itime
                itramem(ipart)=itra1(ipart)
                itrasplit(ipart)=itra1(ipart)+ldirect*itsplit
                xmass1(ipart,1)=xmassperparticle
                if (mdomainfill.eq.2) xmass1(ipart,1)= &
                     xmass1(ipart,1)*pvpart*48./29.*ozonescale/10.**9
              else
                goto 71
              endif


  ! Increase numpart, if necessary
  !*******************************

              numpart=max(numpart,ipart)
              goto 73      ! Storage space has been found, stop searching
            endif
          end do
          if (ipart.gt.maxpart) &
               stop 'boundcond_domainfill.f: too many particles required'
73        minpart=ipart+1
71        continue
        end do


      end do
    end do
  end do


  !*****************************************
  ! Southern and northern boundary condition
  !*****************************************

  ! Loop from west to east
  !***********************

  do ix=nx_we(1),nx_we(2)

  ! Loop over southern (index 1) and northern (index 2) boundary
  !*************************************************************

    do k=1,2
      ylat=ylat0+real(ny_sn(k))*dy
      cosfact=cos(ylat*pi180)

  ! Loop over all release locations in a column
  !********************************************

      do j=1,numcolumn_sn(k,ix)

  ! Determine, for each release location, the area of the corresponding boundary
  !*****************************************************************************

        if (j.eq.1) then
          deltaz=(zcolumn_sn(k,ix,2)+zcolumn_sn(k,ix,1))/2.
        else if (j.eq.numcolumn_sn(k,ix)) then
  !        deltaz=height(nz)-(zcolumn_sn(k,ix,j-1)+
  !    +        zcolumn_sn(k,ix,j))/2.
  ! In order to avoid taking a very high column for very many particles,
  ! use the deltaz from one particle below instead
          deltaz=(zcolumn_sn(k,ix,j)-zcolumn_sn(k,ix,j-2))/2.
        else
          deltaz=(zcolumn_sn(k,ix,j+1)-zcolumn_sn(k,ix,j-1))/2.
        endif
        if ((ix.eq.nx_we(1)).or.(ix.eq.nx_we(2))) then
          boundarea=deltaz*111198.5/2.*cosfact*dx
        else
          boundarea=deltaz*111198.5*cosfact*dx
        endif


  ! Interpolate the wind velocity and density to the release location
  !******************************************************************

  ! Determine the model level below the release position
  !*****************************************************

        do i=2,nz
          if (height(i).gt.zcolumn_sn(k,ix,j)) then
            indz=i-1
            indzp=i
            goto 16
          endif
        end do
16      continue

  ! Vertical distance to the level below and above current position
  !****************************************************************

        dz1=zcolumn_sn(k,ix,j)-height(indz)
        dz2=height(indzp)-zcolumn_sn(k,ix,j)
        dz=1./(dz1+dz2)

  ! Vertical and temporal interpolation
  !************************************

        do m=1,2
          indexh=memind(m)
          do in=1,2
            indzh=indz+in-1
            windl(in)=vv(ix,ny_sn(k),indzh,indexh)
            rhol(in)=rho(ix,ny_sn(k),indzh,indexh)
          end do

          windhl(m)=(dz2*windl(1)+dz1*windl(2))*dz
          rhohl(m)=(dz2*rhol(1)+dz1*rhol(2))*dz
        end do

        windx=(windhl(1)*dt2+windhl(2)*dt1)*dtt
        rhox=(rhohl(1)*dt2+rhohl(2)*dt1)*dtt

  ! Calculate mass flux
  !********************

        fluxofmass=windx*rhox*boundarea*real(lsynctime)

  ! If the mass flux is directed into the domain, add it to previous mass fluxes;
  ! if it is out of the domain, set accumulated mass flux to zero
  !******************************************************************************

        if (k.eq.1) then
          if (fluxofmass.ge.0.) then
            acc_mass_sn(k,ix,j)=acc_mass_sn(k,ix,j)+fluxofmass
          else
            acc_mass_sn(k,ix,j)=0.
          endif
        else
          if (fluxofmass.le.0.) then
            acc_mass_sn(k,ix,j)=acc_mass_sn(k,ix,j)+abs(fluxofmass)
          else
            acc_mass_sn(k,ix,j)=0.
          endif
        endif
        accmasst=accmasst+acc_mass_sn(k,ix,j)

  ! If the accumulated mass exceeds half the mass that each particle shall carry,
  ! one (or more) particle(s) is (are) released and the accumulated mass is
  ! reduced by the mass of this (these) particle(s)
  !******************************************************************************

        if (acc_mass_sn(k,ix,j).ge.xmassperparticle/2.) then
          mmass=int((acc_mass_sn(k,ix,j)+xmassperparticle/2.)/ &
               xmassperparticle)
          acc_mass_sn(k,ix,j)=acc_mass_sn(k,ix,j)- &
               real(mmass)*xmassperparticle
        else
          mmass=0
        endif

        do m=1,mmass
          do ipart=minpart,maxpart

  ! If a vacant storage space is found, attribute everything to this array element
  !*****************************************************************************

            if (itra1(ipart).ne.itime) then

  ! Assign particle positions
  !**************************

              ytra1(ipart)=real(ny_sn(k))
              if (ix.eq.nx_we(1)) then
                xtra1(ipart)=real(ix)+0.5*ran1(idummy)
              else if (ix.eq.nx_we(2)) then
                xtra1(ipart)=real(ix)-0.5*ran1(idummy)
              else
                xtra1(ipart)=real(ix)+(ran1(idummy)-.5)
              endif
              if (j.eq.1) then
                ztra1(ipart)=zcolumn_sn(k,ix,1)+(zcolumn_sn(k,ix,2)- &
                     zcolumn_sn(k,ix,1))/4.
              else if (j.eq.numcolumn_sn(k,ix)) then
                ztra1(ipart)=(2.*zcolumn_sn(k,ix,j)+ &
                     zcolumn_sn(k,ix,j-1)+height(nz))/4.
              else
                ztra1(ipart)=zcolumn_sn(k,ix,j-1)+ran1(idummy)* &
                     (zcolumn_sn(k,ix,j+1)-zcolumn_sn(k,ix,j-1))
              endif


  ! Interpolate PV to the particle position
  !****************************************
              ixm=int(xtra1(ipart))
              jym=int(ytra1(ipart))
              ixp=ixm+1
              jyp=jym+1
              ddx=xtra1(ipart)-real(ixm)
              ddy=ytra1(ipart)-real(jym)
              rddx=1.-ddx
              rddy=1.-ddy
              p1=rddx*rddy
              p2=ddx*rddy
              p3=rddx*ddy
              p4=ddx*ddy
              do i=2,nz
                if (height(i).gt.ztra1(ipart)) then
                  indzm=i-1
                  indzp=i
                  goto 126
                endif
              end do
126           continue
              dz1=ztra1(ipart)-height(indzm)
              dz2=height(indzp)-ztra1(ipart)
              dz=1./(dz1+dz2)
              do mm=1,2
                indexh=memind(mm)
                do in=1,2
                  indzh=indzm+in-1
                  y1(in)=p1*pv(ixm,jym,indzh,indexh) &
                       +p2*pv(ixp,jym,indzh,indexh) &
                       +p3*pv(ixm,jyp,indzh,indexh) &
                       +p4*pv(ixp,jyp,indzh,indexh)
                end do
                yh1(mm)=(dz2*y1(1)+dz1*y1(2))*dz
              end do
              pvpart=(yh1(1)*dt2+yh1(2)*dt1)*dtt
              if (ylat.lt.0.) pvpart=-1.*pvpart


  ! For domain-filling option 2 (stratospheric O3), do the rest only in the stratosphere
  !*****************************************************************************

              if (((ztra1(ipart).gt.3000.).and. &
                   (pvpart.gt.pvcrit)).or.(mdomainfill.eq.1)) then
                nclass(ipart)=min(int(ran1(idummy)* &
                     real(nclassunc))+1,nclassunc)
                numactiveparticles=numactiveparticles+1
                numparticlecount=numparticlecount+1
                npoint(ipart)=numparticlecount
                idt(ipart)=mintime
                itra1(ipart)=itime
                itramem(ipart)=itra1(ipart)
                itrasplit(ipart)=itra1(ipart)+ldirect*itsplit
                xmass1(ipart,1)=xmassperparticle
                if (mdomainfill.eq.2) xmass1(ipart,1)= &
                     xmass1(ipart,1)*pvpart*48./29.*ozonescale/10.**9
              else
                goto 171
              endif


  ! Increase numpart, if necessary
  !*******************************
              numpart=max(numpart,ipart)
              goto 173      ! Storage space has been found, stop searching
            endif
          end do
          if (ipart.gt.maxpart) &
               stop 'boundcond_domainfill.f: too many particles required'
173       minpart=ipart+1
171       continue
        end do


      end do
    end do
  end do


  xm=0.
  do i=1,numpart
    if (itra1(i).eq.itime) xm=xm+xmass1(i,1)
  end do

  !write(*,*) itime,numactiveparticles,numparticlecount,numpart,
  !    +xm,accmasst,xm+accmasst


  ! If particles shall be dumped, then accumulated masses at the domain boundaries
  ! must be dumped, too, to be used for later runs
  !*****************************************************************************

  if ((ipout.gt.0).and.(itime.eq.loutend)) then
    open(unitboundcond,file=path(2)(1:length(2))//'boundcond.bin', &
         form='unformatted')
    write(unitboundcond) numcolumn_we,numcolumn_sn, &
         zcolumn_we,zcolumn_sn,acc_mass_we,acc_mass_sn
    close(unitboundcond)
  endif

end subroutine boundcond_domainfill

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module emissions_mod

  !*****************************************************************************
  !                                                                            *
  !    This module contains variables and subroutines for injecting mass       *
  !    into particles based on gridded emissions estimates                     *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use point_mod,         only: xlon0, ylat0, dx, dy, npart
  use particle_mod
  use date_mod
  use totals_mod,        only: tot_em_up, tot_em_field, tot_em_res
  use netcdf
  use netcdf_output_mod, only: nf90_err

  implicit none

  real, parameter    :: tau_em_r=4000. ! time scale of residual emission release (s)
  real, parameter    :: tau_ipm=900.   ! time scale of micro mixing (s)
  logical, parameter :: ABLMIX=.true.  ! mass exchange for particles in same PBL grid cell

  integer                               :: nxem, nyem
  real                                  :: dxem, dyem
  integer, dimension(2)                 :: em_memtime 
  real, allocatable, dimension(:,:,:,:) :: em_field                ! emission fields all species
  real, allocatable, dimension(:)       :: lonem, latem            ! emission field lon and lat
  real, allocatable, dimension(:,:,:)   :: em_res                  ! residual emissions
  real, allocatable, dimension(:,:,:)   :: mass_field
  real, allocatable, dimension(:,:)     :: em_area                 ! area for emissions grid
  integer, allocatable, dimension(:,:)  :: nn_field
  real(kind=dp), dimension(2)           :: em_time
  character(len=32), allocatable, dimension(:) :: emf_name

  contains

  subroutine emissions(itime)

  !*****************************************************************************
  !                                                                            *
  !    This subroutine calculates the fraction of emission to be released      *
  !    in each timestep and adds this mass to the particles in the PBL         *
  !                                                                            *
  !    Author: S. Henne, Mar-2009                                              *
  !    Adapted by R. Thompson for v10.4, Oct-2023                              *
  !                                                                            *
  !*****************************************************************************

    use windfields_mod, only: hmix
    use omp_lib

    implicit none

    integer       :: itime
    real          :: xlon,ylat
    integer       :: ix, jy, ixp, jyp, ii, ks, em_ix, em_jy, ithread
    real          :: dt1,dt2,dtt,ddx,ddy,rddx,rddy,p1,p2,p3,p4,dz1,dz2,dz
    real          :: em_dt1, em_dt2, em_dtt
    real, dimension(2) :: hm 
    real          :: hmixi
    real          :: tmp, max_val, em_cur
    logical, dimension(npart(1)) :: em_cond
    integer       :: mm 
    character(len=20) :: frmt
    real          :: em_frac
    real, allocatable, dimension(:,:,:) :: em_neg
    real, allocatable, dimension(:,:) :: tot_em_up_tmp
    real, allocatable, dimension(:,:,:,:) :: mass_field_tmp, em_neg_tmp
    real          :: f_m
    logical       :: lexist
!    integer, parameter :: unittest=120


    ! fraction of stored emissions that is released in a time step
    em_frac = 1. - exp(-1.*real(lsynctime)/tau_em_r)

    ! distance of emission fields in memory from current time
    em_dt1 = float(itime-em_memtime(1))
    em_dt2 = float(em_memtime(2)-itime)
    em_dtt = 1./(em_dt1+em_dt2)

    ! determine temporal distances for interpolation of meteo fields
    dt1=float(itime-memtime(1))
    dt2=float(memtime(2)-itime)
    dtt=1./(dt1+dt2)

    tot_em_up(:) = 0.

    ! estimate mass in PBL from particle positions
    !**********************************************

    mass_field(:,:,:) = 0.
    allocate( em_neg(nspec-1,nxem,nyem) )
#if _OPENMP
    allocate( mass_field_tmp(nspec,nxem,nyem,numthreads))
    allocate( em_neg_tmp(nspec-1,nxem,nyem,numthreads))
    allocate( tot_em_up_tmp(nspec,numthreads) )
    mass_field_tmp(:,:,:,:) = 0.
    em_neg_tmp(:,:,:,:) = 0.
    tot_em_up_tmp(:,:) = 0.
#endif
    tot_em_up(:) = 0.
    mass_field(:,:,:) = 0.
    em_neg(:,:,:) = 0.

!$OMP PARALLEL &
!$OMP PRIVATE(ii,xlon,ylat,em_ix,em_jy,ix,jy,ixp,jyp,ddx,ddy, &
!$OMP rddx,rddy,p1,p2,p3,p4,mm,hm,hmixi,ks,ithread) 

#ifdef _OPENMP
    ithread = OMP_GET_THREAD_NUM()+1 ! Starts with 1
#else
    ithread = 1
#endif

!$OMP DO 
    do ii=1,count%alive  ! loop over all particles

      xlon=xlon0+part(ii)%xlon*dx
      ylat=ylat0+part(ii)%ylat*dy

      ! assume emission dimensions given as grid midpoints
      em_ix=min(nxem, int((xlon-(lonem(1)-0.5*dxem))/dxem)+1)
      em_jy=min(nyem, int((ylat-(latem(1)-0.5*dyem))/dyem)+1)
      !! testing
!      if (ii.lt.20) print*, 'lonem, lon, latem, lat = ',lonem(em_ix),xlon,latem(em_jy),ylat

      ! interpolate to particle position
      ix=int(part(ii)%xlon)
      jy=int(part(ii)%ylat)
      ixp=ix+1
      jyp=jy+1
      ddx=part(ii)%xlon-float(ix)
      ddy=part(ii)%ylat-float(jy)
      rddx=1.-ddx
      rddy=1.-ddy
      p1=rddx*rddy
      p2=ddx*rddy
      p3=rddx*ddy
      p4=ddx*ddy

      do mm=1,2
        ! PBL height at particle position
        hm(mm)=p1*hmix(ix,jy ,1,memind(mm)) + &
               p2*hmix(ixp,jy ,1,memind(mm)) + &
               p3*hmix(ix ,jyp,1,memind(mm)) + &
               p4*hmix(ixp,jyp,1,memind(mm))
      end do
      hmixi=(hm(1)*dt2+hm(2)*dt1)*dtt
      ! set minimum PBL height to dampen day/night amplitude of emission
      hmixi=max(hmixi,hmixmin)

      ! determine if particle is in PBL
      em_cond(ii) = part(ii)%z.le.hmixi

      if (em_cond(ii)) then
#ifdef _OPENMP
        mass_field_tmp(1:nspec,em_ix,em_jy,ithread)= &
              mass_field_tmp(1:nspec,em_ix,em_jy,ithread) + &
              mass(ii,1:nspec)
#else
        mass_field(1:nspec,em_ix,em_jy)=mass_field(1:nspec,em_ix,em_jy) + &
                                        mass(ii,1:nspec)
#endif
      endif

    end do   ! end of particle loop
!$OMP END DO
!$OMP END PARALLEL

#ifdef _OPENMP
    ! manual reduction of mass_field
    do ithread=1,numthreads
      mass_field(:,:,:) = mass_field(:,:,:)+mass_field_tmp(:,:,:,ithread)
    end do
#endif

    f_m = exp(-1.*real(lsynctime)/tau_ipm)

    ! estimate emissions for each particle
    !**************************************

!$OMP PARALLEL &
!$OMP PRIVATE(ii,xlon,ylat,em_ix,em_jy, &
!$OMP ks,em_cur,tmp,ithread) 

#ifdef _OPENMP
    ithread = OMP_GET_THREAD_NUM()+1 ! Starts with 1
#else
    ithread = 1
#endif

!$OMP DO
    do ii=1,count%alive ! loop over particles

      if (.not.em_cond(ii)) cycle ! skip particles not in PBL

      xlon=xlon0+part(ii)%xlon*dx
      ylat=ylat0+part(ii)%ylat*dy
      ! assume emission dimensions given as grid midpoints
      em_ix=min(nxem, int((xlon-(lonem(1)-0.5*dxem))/dxem)+1)
      em_jy=min(nyem, int((ylat-(latem(1)-0.5*dyem))/dyem)+1)

      ! loop over species
      ! skip species 1 as it is always air tracer with no emission
      do ks=2,nspec
        em_cur=(em_field(ks-1,em_ix,em_jy,1)*em_dt2 + &
                em_field(ks-1,em_ix,em_jy,2)*em_dt1)*em_dtt
        tmp=(em_cur*real(lsynctime) + em_res(ks-1,em_ix,em_jy)*em_frac ) * &
               mass(ii,1)/mass_field(1,em_ix,em_jy)

        ! micro mixing scheme executed before new emissions are taken up
        !*****************************************************************
        if (ABLMIX) then
          mass(ii,ks)=mass(ii,1) * &
                         (f_m * mass(ii,ks)/mass(ii,1) + &
                         (1.-f_m) * mass_field(ks,em_ix,em_jy)/mass_field(1,em_ix,em_jy))
        endif

        ! deal with negative emissions
        if (tmp.lt.0.) then
          if (-1.*tmp.gt.mass(ii,ks)) then
            tmp = tmp + mass(ii,ks)
            ! subtract mass from atmosphere by setting it to zero below
#ifdef _OPENMP
            tot_em_up_tmp(ks,ithread) = tot_em_up_tmp(ks,ithread) - real(mass(ii,ks),kind=dp)
#else
            tot_em_up(ks) = tot_em_up(ks) - real(mass(ii,ks),kind=dp)
#endif
            mass(ii,ks) = 0.
            ! add remaining uptake to em_neg 
#ifdef _OPENMP
            em_neg_tmp(ks-1,em_ix,em_jy,ithread) = em_neg_tmp(ks-1,em_ix,em_jy,ithread) + &
              tmp/mass(ii,1)*mass_field(1,em_ix,em_jy)
#else
            em_neg(ks-1, em_ix, em_jy) = em_neg(ks-1, em_ix, em_jy) + &
              tmp/mass(ii,1)*mass_field(1,em_ix,em_jy)
#endif
          else
            mass(ii,ks)=mass(ii,ks)+tmp
#ifdef _OPENMP
            tot_em_up_tmp(ks,ithread) = tot_em_up_tmp(ks,ithread) + real(tmp,kind=dp)
#else
            tot_em_up(ks) = tot_em_up(ks) + real(tmp,kind=dp)
#endif
          endif
        else
          mass(ii,ks)=mass(ii,ks)+tmp
#ifdef _OPENMP
          tot_em_up_tmp(ks,ithread) = tot_em_up_tmp(ks,ithread) + real(tmp,kind=dp)
#else
          tot_em_up(ks) = tot_em_up(ks) + real(tmp,kind=dp)
#endif
        endif ! negative emissions

      end do ! nspec

    end do ! loop over particles
!$OMP END DO

    ! loop over grid points to update residual emissions 
    ! skip species 1 as it is always air tracer
    !***************************************************

!$OMP DO 
    do jy=1,nyem
      do ix=1,nxem
        do ks=2,nspec
          if (mass_field(1,ix,jy).eq.0.) then
            em_cur=(em_field(ks-1,ix,jy,1)*em_dt2 + &
                    em_field(ks-1,ix,jy,2)*em_dt1)*em_dtt
            em_res(ks-1,ix,jy)=em_res(ks-1,ix,jy) + &
                             em_cur*real(lsynctime)
          else
            em_res(ks-1,ix,jy)=(1.-em_frac) * em_res(ks-1,ix,jy)
          endif
        end do
      end do
    end do
!$OMP END DO
!$OMP END PARALLEL

    ! manual reduction of em_neg and tot_em_up
#ifdef _OPENMP
    do ithread=1,numthreads
      em_neg(:,:,:) = em_neg(:,:,:)+em_neg_tmp(:,:,:,ithread)
      tot_em_up(:) = tot_em_up(:) + tot_em_up_tmp(:,ithread)
    end do
    deallocate( mass_field_tmp, em_neg_tmp, tot_em_up_tmp )
#endif

    ! update for negative emissions
    em_res(:,:,:) = em_res(:,:,:)+em_neg(:,:,:)
    deallocate(em_neg)

    ! calculate total emission flux and field
!$OMP PARALLEL IF(nspec>99) PRIVATE(ks)
!$OMP DO
    do ks=2,nspec
      tot_em_field(ks)=sum((em_field(ks-1,:,:,1)*em_dt2 + &
                         em_field(ks-1,:,:,2)*em_dt1)*em_dtt)*real(lsynctime)
      tot_em_res(ks)=sum(em_res(ks-1,:,:))
    end do
!$OMP END DO
!$OMP END PARALLEL

    !! test
!    inquire(file=path(2)(1:length(2))//'mass_field.txt',exist=lexist)
!    write(*,*) 'emissions: lexist = ',lexist
!    if (lexist) then
!      open(unittest,file=path(2)(1:length(2))//'mass_field.txt',ACCESS='APPEND',STATUS='OLD')
!    else
!      open(unittest,file=path(2)(1:length(2))//'mass_field.txt',STATUS='NEW')
!    endif
!    write(frmt, '(A, I4, A)') '(', nxem, 'E12.3)'
!    do jy=1,nyem-1
!      write(unittest,frmt) (mass_field(2,ix,jy),ix=1,nxem)
!    end do
!    close(unittest)
    !!

  end subroutine emissions

  subroutine getemissions(itime)

  !*****************************************************************************
  !                                                                            *
  !    This subroutine checks which emission fields need to be read and        *
  !    interpolates these to the current time step                             *
  !                                                                            *
  !    Author: Rona Thompson, Oct-2023                                         *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer       :: itime
    real(kind=dp) :: julstart, jd, jdmid
    integer       :: jjjjmmdd, hhmmss, dd, mm, yyyy
    integer       :: nn, ks, eomday, memid
    character(len=4)   :: ayear
    character(len=2)   :: amonth, aday
    character(len=256) :: em_name, file_name, strtmp1, strtmp2
    logical       :: lexist


    ! Check fields are available for the current time step
    !*****************************************************

    if ((ldirect*em_memtime(1).le.ldirect*itime).and. &
           (ldirect*em_memtime(2).gt.ldirect*itime)) then

      ! The rightfields are already in memory -> don't do anything
      return 

    else if ((ldirect*em_memtime(2).le.ldirect*itime).and. &
         (em_memtime(2).ne.0.)) then

      ! Current time is after 2nd field
      !*********************************

      ! update dates of emission fields
      em_memtime(1)=em_memtime(2)  ! time in sec
      em_time(1)=em_time(2)      ! julian date
      memid=2

      ! julian date of next emission field assuming monthly fields
      call caldate(em_time(1), jjjjmmdd, hhmmss)
      eomday=calceomday(jjjjmmdd/100)
      em_memtime(2)=em_memtime(1)+ldirect*eomday*24*3600   ! time in sec
      em_time(2)=em_time(1)+real(ldirect*eomday,kind=dp) ! julian date 
      call caldate(em_time(2), jjjjmmdd,hhmmss)
      yyyy=jjjjmmdd/10000
      mm=(jjjjmmdd-yyyy*10000)/100
      dd=jjjjmmdd-yyyy*10000-mm*100
      write(amonth,'(I2.2)') mm
      write(aday,'(I2.2)') dd
      write(ayear,'(I4)') yyyy

      ! skip species 1 as is always air tracer with no emissions
!$OMP PARALLEL IF(nspec>99) &
!$OMP PRIVATE(ks,file_name,nn,strtmp1,strtmp2,julstart,em_name,lexist)
!$OMP DO
      do ks=2,nspec

        write(*,*) 'Updating emission fields for: ',trim(species(ks)) 
    
        em_field(ks-1,:,:,1)=em_field(ks-1,:,:,2)

        ! Read new emission field and store in 2nd position
        !***************************************************

        ! TO DO: make more general to fit any field frequency

        file_name=emis_file(ks)
        nn=index(file_name,'YYYY',back=.false.)
        if (nn.ne.0) then
          strtmp1=file_name(1:nn-1)
          nn=index(file_name,'YYYY',back=.true.)
          strtmp2=file_name(nn+4:len_trim(file_name))
          file_name=trim(strtmp1)//ayear//trim(strtmp2)
          julstart=juldate((jjjjmmdd/10000)*10000+101,0)
        endif
        nn=index(file_name,'MM',back=.false.)
        if (nn.ne.0) then
          strtmp1=file_name(1:nn-1)
          nn=index(file_name,'MM',back=.true.)
          strtmp2=file_name(nn+2:len_trim(file_name))
          file_name=trim(strtmp1)//amonth//trim(strtmp2)
          julstart=juldate((jjjjmmdd/100)*100+1,0)
        endif
        nn=index(file_name,'DD',back=.false.)
        if (nn.ne.0) then
          strtmp1=file_name(1:nn-1)
          nn=index(file_name,'DD',back=.true.)
          strtmp2=file_name(nn+2:len_trim(file_name))
          file_name=trim(strtmp1)//aday//trim(strtmp2)
          julstart=juldate(jjjjmmdd,0)
        endif

        em_name=trim(emis_path(ks))//trim(file_name)
        inquire(file=em_name,exist=lexist)
        if (lexist) then
          write(*,*) 'Reading emissions field: ',trim(em_name)
          call reademissions(em_name, julstart, itime, memid, ks-1)
        else
          write(*,*) '#### FLEXPART ERROR                ####'
          write(*,*) '#### EMISSION FIELD NOT FOUND     ####'
          write(*,*) '#### '//trim(em_name)//' ####'
          error stop
        endif

      end do ! nspec
!$OMP END DO
!$OMP END PARALLEL

    else

      ! No emission field in memory that can be used
      !**********************************************

      ! read both fields into memory
      do memid=1,2

        if (memid.eq.1) then
          jd=bdate+real(ldirect*itime,kind=dp)/86400._dp 
          call caldate(jd, jjjjmmdd, hhmmss)
          ! middle of month day
          jdmid=juldate(int(jjjjmmdd/100)*100+15,0)
          if (jd.ge.jdmid) then
            ! use current month
            em_time(memid)=jdmid
          else
            ! use last month
            eomday=calceomday(jjjjmmdd/100)
            em_time(memid)=jdmid-real(eomday,kind=dp)          
          endif
        else
          call caldate(jd, jjjjmmdd, hhmmss)
          eomday=calceomday(jjjjmmdd/100)
          em_time(memid)=em_time(memid-1)+real(ldirect*eomday,kind=dp)
        endif
        em_memtime(memid)=int((em_time(memid)-bdate)*86400._dp)

        write(*,*) 'getemissions: memid, em_time = ',memid, em_time(memid)
        write(*,*) 'getemissions: memid, em_memtime = ',memid, em_memtime(memid)

        call caldate(em_time(memid), jjjjmmdd, hhmmss)
        yyyy=jjjjmmdd/10000
        mm=(jjjjmmdd-yyyy*10000)/100
        dd=jjjjmmdd-yyyy*10000-mm*100
        write(amonth,'(I2.2)') mm
        write(aday,'(I2.2)') dd
        write(ayear,'(I4)') yyyy

!$OMP PARALLEL IF(nspec>99) &
!$OMP PRIVATE(ks,file_name,nn,strtmp1,strtmp2,julstart,em_name,lexist)
!$OMP DO
        do ks=2,nspec

          write(*,*) 'Reading two new emission fields for: ',trim(species(ks))

          ! TO DO: make more general to fit any field frequency

          file_name=emis_file(ks)
          nn=index(file_name,'YYYY',back=.false.)
          if (nn.ne.0) then
            strtmp1=file_name(1:nn-1)
            nn=index(file_name,'YYYY',back=.true.)
            strtmp2=file_name(nn+4:len_trim(file_name))
            file_name=trim(strtmp1)//ayear//trim(strtmp2)
            julstart=juldate((jjjjmmdd/10000)*10000+101,0)
          endif
          nn=index(file_name,'MM',back=.false.)
          if (nn.ne.0) then
            strtmp1=file_name(1:nn-1)
            nn=index(file_name,'MM',back=.true.)
            strtmp2=file_name(nn+2:len_trim(file_name))
            file_name=trim(strtmp1)//amonth//trim(strtmp2)
            julstart=juldate((jjjjmmdd/100)*100+1,0)
          endif
          nn=index(file_name,'DD',back=.false.)
          if (nn.ne.0) then
            strtmp1=file_name(1:nn-1)
            nn=index(file_name,'DD',back=.true.)
            strtmp2=file_name(nn+2:len_trim(file_name))
            file_name=trim(strtmp1)//aday//trim(strtmp2)
            julstart=juldate(jjjjmmdd,0)
          endif

          em_name=trim(emis_path(ks))//trim(file_name)
          inquire(file=em_name,exist=lexist)
          if (lexist) then
            write(*,*) 'Reading emissions field: ',trim(em_name)
            call reademissions(em_name, julstart, itime, memid, ks-1)
          else
            write(*,*) '#### FLEXPART ERROR                ####'
            write(*,*) '#### EMISSION FIELD NOT FOUND     ####'
            write(*,*) '#### '//trim(em_name)//' ####'
            error stop
          endif

        end do ! nspec
!$OMP END DO
!$OMP END PARALLEL

      end do ! memid

    endif ! update fields


  end subroutine getemissions


  subroutine reademissions(em_name, julstart, itime, memid, kk)

  !*****************************************************************************
  !                                                                            *
  !    This subroutine reads the emission fields                               *
  !                                                                            *
  !    Author: Rona Thompson, Oct-2023                                         *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) :: em_name, unitinfo
    integer            :: memid, kk, itime
    real(kind=dp)      :: julstart, jtime
    integer            :: jjjjmmdd, ihmmss, mm
    integer            :: nn, ntem, len, ix, jy
    integer            :: ncid, dimid, varid, ndim, nvar, natt, xtype, indxt, unlimid
    real               :: ylatp, ylatm, hzone, cosfactm, cosfactp
    real               :: sclfact, offset
    integer, dimension(:), allocatable :: dimids
    real(kind=dp), dimension(:), allocatable :: jdate
    real, dimension(:), allocatable :: time
    real, dimension(:,:), allocatable :: emis
    character(len=32)  :: dimname, nameout, attname

    ! current time in julian days
    jtime=real(itime,kind=dp)/86400._dp+bdate

    ! Read netcdf file
    !******************

    ! open file
    call nf90_err( nf90_open(trim(em_name),nf90_NOWRITE,ncid) )

    ! inquire about dims and vars
    call nf90_err( nf90_inquire( ncid, ndim, nvar, natt, unlimid ) )
    allocate(dimids(ndim))

    if (.not.allocated(lonem)) then
      ! read dimension info
      do nn=1,ndim
        call nf90_err( nf90_inquire_dimension( ncid, nn, dimname, len ) )
        if ((index(dimname,'lon').ne.0).or.(index(dimname,'LON').ne.0) &
              .or.(index(dimname,'Lon').ne.0)) then
          ! longitude
          nxem=len
          allocate( lonem(nxem) )
          call nf90_err( nf90_inq_varid(ncid,trim(dimname),varid) )
          call nf90_err( nf90_get_var(ncid,varid,lonem) )
          dxem=abs(lonem(2)-lonem(1))
        endif
        if ((index(dimname,'lat').ne.0).or.(index(dimname,'LAT').ne.0) &
              .or.(index(dimname,'Lat').ne.0)) then
          ! latitude
          nyem=len
          allocate( latem(nyem) )
          call nf90_err( nf90_inq_varid(ncid,trim(dimname),varid) )
          call nf90_err( nf90_get_var(ncid,varid,latem) )
          dyem=abs(latem(2)-latem(1))
        endif
      end do ! ndim
      ! check dimensions read correctly
      if (.not.allocated(lonem)) then
        write(*,*) 'ERROR in reademissions: longitude dimension not found in file: '//trim(em_name)
        error stop
      endif
      if (.not.allocated(latem)) then
        write(*,*) 'ERROR in reademissions: latitude dimension not found in file: '//trim(em_name)
        error stop
      endif
      ! allocate emission variables
      allocate( em_field(nspec-1,nxem,nyem,2) )
      em_field(:,:,:,:)=0.
      allocate( em_res(nspec-1,nxem,nyem) )
      if (ipin.eq.2) then
        ! read residual emissions from end of previous run
        write(*,*) 'Reading residual emissions from previous run'
        call em_res_read
      else
        em_res(:,:,:)=0.
      endif
      allocate( mass_field(nspec,nxem,nyem) )
      mass_field(:,:,:)=0.
      ! calculate area for emissions grid
      allocate( em_area(nxem,nyem) )
      if (emis_unit(kk+1).eq.1) then
        ! emissions given per sqm
        do jy=1,nyem
          ylatp=latem(jy)+0.5*abs(latem(2)-latem(1))
          ylatm=latem(jy)-0.5*abs(latem(2)-latem(1))
          if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
            hzone=abs(latem(2)-latem(1))*r_earth*pi180
          else
            cosfactp=cos(ylatp*pi180)
            cosfactm=cos(ylatm*pi180)
            if (cosfactp.lt.cosfactm) then
              hzone=sqrt(1-cosfactp**2)-sqrt(1-cosfactm**2)
              hzone=hzone*r_earth
            else
              hzone=sqrt(1-cosfactm**2)-sqrt(1-cosfactp**2)
              hzone=hzone*r_earth
            endif
          endif
          em_area(:,jy)=pi180*r_earth*hzone*abs(lonem(2)-lonem(1))
        end do ! nyem
      else
        ! emissions given per gridcell
        em_area(:,:)=1.
      endif
    endif 
    
    ! read time dimension
    do nn=1,ndim
      call nf90_err( nf90_inquire_dimension( ncid, nn, dimname, len ) )
      if ((index(dimname,'time').ne.0).or.(index(dimname,'Time').ne.0).or. &
            (index(dimname,'TIME').ne.0).or.(index(dimname,'Date').ne.0).or. &
            (index(dimname,'date').ne.0).or.(index(dimname,'DATE').ne.0)) then
        ntem=len
        allocate( time(ntem), jdate(ntem) )
        call nf90_err( nf90_inq_varid(ncid,trim(dimname),varid) )
        call nf90_err( nf90_get_var(ncid,varid,time) )
        call nf90_err( nf90_get_att(ncid,varid,'units',unitinfo) )
        write(*,*) 'Time units: ',trim(unitinfo)
        if (index(unitinfo,'sec').ne.0) then
          ! seconds
          jdate=real(time-time(1),kind=dp)/3600._dp/24._dp+julstart
          indxt=minloc(abs(jdate-jtime),dim=1)
        else if (index(unitinfo,'hour').ne.0) then
          ! hours
          jdate=real(time-time(1),kind=dp)/24._dp+julstart
          indxt=minloc(abs(jdate-jtime),dim=1)
        else if (index(unitinfo,'day').ne.0) then
          ! days
          jdate=real(time-time(1),kind=dp)+julstart
          indxt=minloc(abs(jdate-jtime),dim=1)
        else if (index(unitinfo,'month').ne.0) then
          ! months
          call caldate(jtime,jjjjmmdd,ihmmss)
          mm=jjjjmmdd/10000
          indxt=minloc(abs(time-mm),dim=1)
        else
          write(*,*) 'ERROR in reademissions: unknown time units in file: '//trim(em_name)
          error stop
        endif
        deallocate( time, jdate )
        exit
      endif 
    end do ! ndim

    ! emission field
    allocate( emis(nxem,nyem) )
    write(*,*) 'Reading emissions for species '//trim(species(kk+1))
    call nf90_err( nf90_inq_varid(ncid,trim(emis_name(kk+1)),varid) )
    call nf90_err( nf90_inquire_variable(ncid,varid,nameout,xtype,ndim,dimids,natt) )
    sclfact=1.
    offset=0.
    if (natt.gt.0 ) then
      do nn=1,natt
        call nf90_err( nf90_inq_attname(ncid,varid,nn,attname) )
        if (index(attname,'add_offset').ne.0) then
          call nf90_err( nf90_get_att(ncid,varid,'add_offset',offset) )
        else if (index(attname,'scale_factor').ne.0) then
          call nf90_err( nf90_get_att(ncid,varid,'scale_factor',sclfact) )
        endif
      end do
    endif
    if (ndim.eq.2) then
      call nf90_err( nf90_get_var(ncid,varid,emis) )
    else if (ndim.eq.3) then
      write(*,*) 'reademissions: time index in file = ',indxt
      call nf90_err( nf90_get_var(ncid,varid,emis,start=(/1,1,indxt/),count=(/nxem,nyem,1/)) )
    endif
    emis=emis*sclfact+offset
    !! test
    print*, 'reademissions: sclfact, offset = ',sclfact, offset
    print*, 'reademissions: range(emis) = ',minval(emis), maxval(emis)
    print*, 'reademissions: range(em_area) = ',minval(em_area), maxval(em_area)
    print*, 'reademissions: emis_coeff, emis_unit = ',emis_coeff(kk+1), emis_unit(kk+1)
    print*, 'reademissions: emis total = ',sum(emis*em_area*emis_coeff(kk+1))*3600.*24.*365./1.e9
    em_field(kk,:,:,memid)=emis*em_area*emis_coeff(kk+1)

    ! close file
    call nf90_err( nf90_close(ncid) )

    deallocate(emis)

    return

  end subroutine reademissions

  subroutine em_res_write()

  !*****************************************************************************
  !                                                                            *
  !    This subroutine outputs the residual emissions to be used if            *
  !    picking up a run from where this one left off (ipin = 1)                *
  !                                                                            *
  !    Author: R. Thompson, Oct-2023                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) :: file_name
    integer :: nc_id, londim_id, latdim_id, specdim_id, nchardim_id
    integer :: spec_id, lon_id, lat_id, emres_id
    
    file_name=trim(path(2)(1:length(2)))//'emis_residual.nc' 
    
    call nf90_err( nf90_create(trim(file_name), nf90_clobber, ncid=nc_id) )

    ! define dimensions
    call nf90_err( nf90_def_dim(nc_id, 'species', nspec-1, specdim_id) )
    call nf90_err( nf90_def_dim(nc_id, 'longitude', nxem, londim_id) )
    call nf90_err( nf90_def_dim(nc_id, 'latitude', nyem, latdim_id) )
    call nf90_err( nf90_def_dim(nc_id, 'nchar', 18, nchardim_id) )

    ! define variables
    call nf90_err( nf90_def_var(nc_id, 'species', nf90_char, (/ nchardim_id, specdim_id /), spec_id) )
    call nf90_err( nf90_put_att(nc_id, spec_id, 'long_name', 'Species names') )
    call nf90_err( nf90_def_var(nc_id, 'longitude', nf90_float, (/ londim_id /), lon_id) )
    call nf90_err( nf90_put_att(nc_id, lon_id, 'units', 'degrees') )
    call nf90_err( nf90_def_var(nc_id, 'latitude', nf90_float, (/ latdim_id /), lat_id) )
    call nf90_err( nf90_put_att(nc_id, lat_id, 'units', 'degrees') )
    call nf90_err( nf90_def_var(nc_id, 'em_res', nf90_double, (/ specdim_id, londim_id, latdim_id /), emres_id) )
    call nf90_err( nf90_put_att(nc_id, emres_id, 'long_name', 'Emission residuals') )
    call nf90_err( nf90_put_att(nc_id, emres_id, 'units', 'kg') )

    call nf90_err( nf90_enddef(nc_id) )

    ! write variables
    call nf90_err( nf90_put_var(nc_id, spec_id, species(2:nspec)) )
    call nf90_err( nf90_put_var(nc_id, lon_id, lonem) )
    call nf90_err( nf90_put_var(nc_id, lat_id, latem) )
    call nf90_err( nf90_put_var(nc_id, emres_id, em_res) )

    call nf90_err( nf90_close(nc_id) )

  end subroutine em_res_write

  subroutine em_res_read()

  !*****************************************************************************
  !                                                                            *
  !    This subroutine reads the residual emissions from a previous run        *
  !    which have to be copied into the output directory of this run           *
  !                                                                            *
  !    Author: R. Thompson, Oct-2023                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) :: file_name
    integer :: nc_id, specdim_id, londim_id, latdim_id, emres_id
    integer :: xlen, ylen, splen
    logical :: lexist

    file_name=trim(path(2)(1:length(2)))//'emis_residual.nc'

    inquire(file=trim(file_name),exist=lexist)
    if (.not.lexist) then
      write(*,*) 'FLEXPART ERROR: cannot find file '//trim(file_name)
      error stop
    endif

    call nf90_err( nf90_open(file_name, nf90_nowrite, nc_id) )

    ! read dimensions
    call nf90_err( nf90_inq_dimid(nc_id, 'longitude', londim_id) )
    call nf90_err( nf90_inquire_dimension(nc_id, londim_id, len=xlen) )
    call nf90_err( nf90_inq_dimid(nc_id, 'latitude', latdim_id) )
    call nf90_err( nf90_inquire_dimension(nc_id, latdim_id, len=ylen) )
    call nf90_err( nf90_inq_dimid(nc_id, 'species', specdim_id) )
    call nf90_err( nf90_inquire_dimension(nc_id, specdim_id, len=splen) )

    ! check dimensions match input emissions
    if ((xlen.ne.nxem).or.(ylen.ne.nyem).or.(splen.ne.(nspec-1))) then
      write(*,*) 'FLEXPART ERROR: emis_residual dimensions do not match input emissions'
      error stop
    endif

    ! read em_res
    call nf90_err( nf90_inq_varid(nc_id, 'em_res', emres_id) )
    call nf90_err( nf90_get_var(nc_id, emres_id, em_res) )

    call nf90_err( nf90_close(nc_id) )

  end subroutine em_res_read


end module emissions_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!*****************************************************************************
!                                                                            *
!  This module handles conversions between ECMWF eta coordinates and         *
!  internal meter coordinates                                                *
!                                                                            *
!     Author: L. Bakels                                                      *
!*****************************************************************************

module coord_ecmwf_mod

  use par_mod
  use com_mod
  use windfields_mod

contains
#ifdef ETA
subroutine update_zeta_to_z(itime, ipart)
  use particle_mod
  implicit none 

  integer, intent(in) ::          &
    itime,                        & ! time index
    ipart                           ! particle index

  if (.not. part(ipart)%alive) return  
  if (part(ipart)%etaupdate) return

  call zeta_to_z(itime,part(ipart)%xlon,part(ipart)%ylat, &
    part(ipart)%zeta,part(ipart)%z)
  part(ipart)%etaupdate = .true.
  part(ipart)%meterupdate = .true.
end subroutine update_zeta_to_z

subroutine update_z_to_zeta(itime, ipart)
  use particle_mod
  implicit none 

  integer, intent(in) ::          &
    itime,                        & ! time index
    ipart                           ! particle index

  if (.not. part(ipart)%alive) return
  if (part(ipart)%meterupdate) return

  call z_to_zeta(itime,part(ipart)%xlon,part(ipart)%ylat, &
      part(ipart)%z,part(ipart)%zeta)
  part(ipart)%etaupdate = .true.
  part(ipart)%meterupdate = .true.
end subroutine update_z_to_zeta

subroutine z_to_zeta(itime,xt,yt,zold,zteta)
  !*****************************************************************************
  ! Converting z from meter coordinates to eta using logarithmic vertical      *
  ! interpolation                                                              *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! xt,yt,zold,zold    spatial positions of trajectory (meters)                *
  ! zteta              vertical position in eta coordinates (output)           *
  !                                                                            *
  ! etauvheight defined in windfields: half model heights for ETA coordinates  *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************
  use interpol_mod

  implicit none
  integer, intent(in) ::          &
    itime                           ! time index
  integer ::                      &
    i,m,k,n                         ! loop indices
  real(kind=dp), intent(in) ::    &
    xt,yt                           ! particle position
  real(kind=dp), intent(in) ::    &
    zold                            ! particle verticle position in eta coordinates
  real(kind=dp), intent(inout) :: &
    zteta                           ! converted output z in meters
  real ::                         &
    frac,                         & ! fraction between z levels
    ztemp1,ztemp2,                & ! z positions of the two encompassing levels
    ttemp1(2),                    & ! storing virtual temperature
    psint1(2),psint                 ! pressure of encompassing levels
  real ::                         &
    prx,pr1,pr2     ! pressure of encompassing levels

  if (.not. log_interpol) then
    call z_to_zeta_lin(itime,xt,yt,zold,zteta)
    return
  endif

  call find_ngrid(xt,yt)
  call find_grid_indices(real(xt),real(yt))
  call find_grid_distances(real(xt),real(yt))
  call find_time_vars(itime)

  ! Integration method as used in the original verttransform_ecmwf.f90
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ! First estimate the level it is at, to reduce computation time
  n=nz-3
  if (ngrid.le.0) then
    do i=2,nz-1
      if ((etauvheight(ix,jy,i,memind(1)).gt.real(zold)) .or. &
          (etauvheight(ixp,jy,i,memind(1)).gt.real(zold)) .or. & 
          (etauvheight(ix,jyp,i,memind(1)).gt.real(zold)) .or. &
          (etauvheight(ixp,jyp,i,memind(1)).gt.real(zold))) then
        n=i-2
        exit
      endif
    end do
  else
    do i=2,nz-1
      if ((etauvheightn(ix,jy,i,memind(1),ngrid).gt.real(zold)) .or. &
          (etauvheightn(ixp,jy,i,memind(1),ngrid).gt.real(zold)) .or. & 
          (etauvheightn(ix,jyp,i,memind(1),ngrid).gt.real(zold)) .or. &
          (etauvheightn(ixp,jyp,i,memind(1),ngrid).gt.real(zold))) then
        n=i-2
        exit
      endif
    end do
  endif
  n=max(n,2)

  ztemp1 = 0.
  do i=n,nz-1
    k=i
    if (ngrid.le.0) then
      do m=1,2
        call hor_interpol(etauvheight,ttemp1(m),i,memind(m),nzmax)
      end do
    else
      do m=1,2
        call hor_interpol_nest(etauvheightn,ttemp1(m),i,memind(m),nzmax)
      end do
    endif
    call temporal_interpolation(ttemp1(1),ttemp1(2),ztemp2)

    if (ztemp2.gt.real(zold)) then
      !frac = (real(zold)-ztemp1)/(ztemp2-ztemp1)
      exit
    else if (i.eq.nz-1) then
      frac = 1.
      exit
    endif
    ztemp1=ztemp2
  end do

  if (k.lt.nz-1) then
    if (ngrid.le.0) then
      do m=1,2
        call hor_interpol(ps,psint1(m),1,memind(m),1)
      end do
    else
      do m=1,2
        call hor_interpol_nest(psn,psint1(m),1,memind(m),1)
      end do
    endif
    call temporal_interpolation(psint1(1),psint1(2),psint)  
    pr1=akz(k-1) + bkz(k-1)*psint
    pr2=akz(k) + bkz(k)*psint

    prx=pr1/exp(log(pr2/pr1)/(ztemp2-ztemp1)*ztemp1) * &
      exp(log(pr2/pr1)/(ztemp2-ztemp1)*real(zold))
    frac=(prx-pr1)/(pr2 - pr1)
  endif

  zteta=real(uvheight(k-1)*(1.-frac)+uvheight(k)*frac,kind=dp)
end subroutine z_to_zeta

subroutine zeta_to_z(itime,xt,yt,zteta,ztout)
  !*****************************************************************************
  ! Converting z from eta coordinates to meters using logarithmic              *
  ! vertical interpolation                                                     *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! xt,yt,zteta        spatial position of trajectory                          *
  ! ztout              vertical postion in meter (output)                      *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************
  use interpol_mod

  implicit none
  integer, intent(in) ::          &
    itime                           ! time index
  integer ::                      &
    i,k,m,ii                        ! loop indices
  real(kind=dp), intent(in) ::    &
    xt,yt                           ! particle position
  real(kind=dp), intent(in) ::    &
    zteta                           ! particle verticle position in eta coordinates
  real(kind=dp), intent(inout) :: &
    ztout                           ! converted output z in meters
  real(kind=dp) ::                &
    frac,                         &  ! fraction between z levels
    prx,pr1,pr2                      ! pressure of encompassing levels
  real ::                         &
    ztemp1(2),                    & ! z positions of the two encompassing levels
    ttemp1(2),                    & ! storing virtual temperature
    psint1(2),psint                 ! pressure of encompassing levels
 
  if (.not. log_interpol) then
    call zeta_to_z_lin(itime,xt,yt,zteta,ztout)
    return
  endif

  ! Convert eta z coordinate to meters
  !***********************************
  call find_ngrid(xt,yt)
  call find_grid_indices(real(xt),real(yt))
  call find_grid_distances(real(xt),real(yt))
  call find_time_vars(itime)

  k=nz-1
  frac=1.
  do i=2,nz-1
    k=i
    if (zteta.ge.real(uvheight(k),kind=dp)) then
      frac=(zteta-real(uvheight(k-1),kind=dp))/(real(uvheight(k)-uvheight(k-1),kind=dp))
      exit
    endif
  end do

  if (ngrid.le.0) then
    do m=1,2
      call hor_interpol(ps,psint1(m),1,memind(m),1)
    end do
  else
    do m=1,2
      call hor_interpol_nest(psn,psint1(m),1,memind(m),1)
    end do
  endif

  call temporal_interpolation(psint1(1),psint1(2),psint)  
  pr1=real(akz(k-1) + bkz(k-1)*psint,kind=dp)
  pr2=real(akz(k) + bkz(k)*psint,kind=dp)
  prx=pr1*(1.-frac) + pr2*frac
  
  if (ngrid.le.0) then
    do ii=1,2
      do m=1,2
        call hor_interpol(etauvheight,ttemp1(m),k+ii-2,memind(m),nzmax)
      end do
      call temporal_interpolation(ttemp1(1),ttemp1(2),ztemp1(ii))
    end do
  else
    do ii=1,2
      do m=1,2
        call hor_interpol_nest(etauvheightn, &
          ttemp1(m),k+ii-2,memind(m),nzmax)
      end do
      call temporal_interpolation(ttemp1(1),ttemp1(2),ztemp1(ii))
    end do
  endif

  if ((pr2.eq.0).or.(pr1.eq.0)) then
    ztout = real(ztemp1(1),kind=dp)*(1.-frac)+real(ztemp1(2),kind=dp)*frac
    return
  endif
  
  ztout = ztemp1(1) + (ztemp1(2)-ztemp1(1))/log(pr2/pr1)*log(prx/pr1)
end subroutine zeta_to_z

subroutine w_to_weta(itime,dt,xt,yt,z_old,zeta_old,w_in,weta_out)
  !*****************************************************************************
  ! Converting z from meter coordinates to eta using logarithmic vertical      *
  ! interpolation                                                              *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! xt,yt,zold,zold    spatial positions of trajectory (meters)                *
  ! zteta              vertical position in eta coordinates (output)           *
  !                                                                            *
  ! etauvheight defined in windfields: half model heights for ETA coordinates  *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************
  use interpol_mod

  implicit none
  integer, intent(in)          ::  &
    itime                            ! time index
  real, intent(in)             ::  &
    dt                               ! time step
  real(kind=dp), intent(in)    ::  &
    xt,yt,z_old,zeta_old              ! particle position
  real, intent(in)             ::  &
    w_in                             ! w in meters/s
  real, intent(inout)          ::  &
    weta_out                         ! converted output w in meters to eta
  real(kind=dp)                ::  &
    znew

  call z_to_zeta(itime,xt,yt,z_old+real(w_in*dt,kind=dp),znew)

  weta_out=real(znew-zeta_old)/dt

end subroutine w_to_weta

subroutine z_to_zeta_lin(itime,xt,yt,zold,zteta)
  !*****************************************************************************
  ! Converting z from meter coordinates to eta using linear interpolation      *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! xt,yt,zold,zold    spatial positions of trajectory (meters)                *
  ! zteta              vertical position in eta coordinates (output)           *
  !                                                                            *
  ! etauvheight defined in windfields: half model heights for ETA coordinates  *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************
  use interpol_mod

  implicit none
  integer, intent(in) ::          &
    itime                           ! time index
  integer ::                      &
    i,m,k,n                         ! loop indices
  real(kind=dp), intent(in) ::    &
    xt,yt                           ! particle position
  real(kind=dp), intent(in) ::    &
    zold                            ! particle verticle position in eta coordinates
  real(kind=dp), intent(inout) :: &
    zteta                           ! converted output z in meters
  real ::                         &
    frac,                         & ! fraction between z levels
    ztemp1,ztemp2,                & ! z positions of the two encompassing levels
    ttemp1(2)                       ! storing virtual temperature

  call find_ngrid(xt,yt)
  call find_grid_indices(real(xt),real(yt))
  call find_grid_distances(real(xt),real(yt))
  call find_time_vars(itime)

  ! Integration method as used in the original verttransform_ecmwf.f90
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ! First estimate the level it is at, to reduce computation time
  n=nz-3
  if (ngrid.le.0) then
    do i=2,nz-1
      if ((etauvheight(ix,jy,i,memind(1)).gt.real(zold)) .or. &
          (etauvheight(ixp,jy,i,memind(1)).gt.real(zold)) .or. &
          (etauvheight(ix,jyp,i,memind(1)).gt.real(zold)) .or. &
          (etauvheight(ixp,jyp,i,memind(1)).gt.real(zold))) then
        n=i-2
        exit
      endif
    end do
  else
    do i=2,nz-1
      if ((etauvheightn(ix,jy,i,memind(1),ngrid).gt.real(zold)) .or. &
          (etauvheightn(ixp,jy,i,memind(1),ngrid).gt.real(zold)) .or. &
          (etauvheightn(ix,jyp,i,memind(1),ngrid).gt.real(zold)) .or. &
          (etauvheightn(ixp,jyp,i,memind(1),ngrid).gt.real(zold))) then
        n=i-2
        exit
      endif
    end do
  endif
  n=max(n,2)

  ztemp1 = 0.
  frac = 0.
  k=n
  do i=n,nz-1
    k=i
    if (ngrid.le.0) then
      do m=1,2
        call hor_interpol(etauvheight,ttemp1(m),i,memind(m),nzmax)
      end do
    else
      do m=1,2
        call hor_interpol_nest(etauvheightn,ttemp1(m),i,memind(m),nzmax)
      end do
    endif    
    call temporal_interpolation(ttemp1(1),ttemp1(2),ztemp2)

    if (ztemp2.gt.real(zold)) then
      frac = (real(zold)-ztemp1)/(ztemp2-ztemp1)
      exit
    else if (i.eq.nz-1) then
      frac = 1.
      exit
    endif
    ztemp1=ztemp2
  end do

  zteta=real(uvheight(k-1)*(1.-frac)+uvheight(k)*frac,kind=dp)
end subroutine z_to_zeta_lin

subroutine zeta_to_z_lin(itime,xt,yt,zteta,ztout)

  !*****************************************************************************
  ! Converting z from eta coordinates to meters using linear interpolation     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! xt,yt,zteta        spatial position of trajectory                          *
  ! ztout              vertical postion in meter (output)                      *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************
  use interpol_mod

  implicit none
  integer, intent(in) ::          &
    itime                           ! time index
  integer ::                      &
    i,k,m,ii                        ! loop indices
  real(kind=dp), intent(in) ::    &
    xt,yt                           ! particle position
  real(kind=dp), intent(in) ::    &
    zteta                           ! particle verticle position in eta coordinates
  real(kind=dp), intent(inout) :: &
    ztout                           ! converted output z in meters
  real(kind=dp) ::                &
    frac                            ! fraction between z levels
  real ::                         &
    ztemp1(2),                    & ! z positions of the two encompassing levels
    ttemp1(2)                       ! storing virtual temperature


  ! Convert eta z coordinate to meters
  !***********************************
  call find_ngrid(xt,yt)
  call find_grid_indices(real(xt),real(yt))
  call find_grid_distances(real(xt),real(yt))
  call find_time_vars(itime)

  k=nz-1
  frac=1.
  do i=2,nz-1
    k=i
    if (zteta.ge.real(uvheight(k),kind=dp)) then
      frac=(zteta-real(uvheight(k-1),kind=dp))/(real(uvheight(k)-uvheight(k-1),kind=dp))
      exit
    endif
  end do
  
  if (ngrid.le.0) then
    do ii=1,2
      do m=1,2
        call hor_interpol(etauvheight,ttemp1(m),k+ii-2,memind(m),nzmax)
      end do
      call temporal_interpolation(ttemp1(1),ttemp1(2),ztemp1(ii))
    end do
  else
    do ii=1,2
      do m=1,2
        call hor_interpol_nest(etauvheightn,ttemp1(m),k+ii-2,memind(m),nzmax)
      end do
      call temporal_interpolation(ttemp1(1),ttemp1(2),ztemp1(ii))
    end do
  endif
  
  ztout = real(ztemp1(1),kind=dp)*(1.-frac)+real(ztemp1(2),kind=dp)*frac
end subroutine zeta_to_z_lin
#endif
end module coord_ecmwf_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine writeheader_nest

  !*****************************************************************************
  !                                                                            *
  !  This routine produces a file header containing basic information on the   *
  !  settings of the FLEXPART run.                                             *
  !  The header file is essential and must be read in by any postprocessing    *
  !  program before reading in the output data.                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! xlon                   longitude                                           *
  ! xl                     model x coordinate                                  *
  ! ylat                   latitude                                            *
  ! yl                     model y coordinate                                  *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: jjjjmmdd,ihmmss,i,ix,jy,j
  real :: xp1,yp1,xp2,yp2


  !************************
  ! Open header output file
  !************************

  open(unitheader,file=path(2)(1:length(2))//'header_nest', &
       form='unformatted',err=998)


  ! Write the header information
  !*****************************

  if (ldirect.eq.1) then
    write(unitheader) ibdate,ibtime,'FLEXPART V8.2'
  else
    write(unitheader) iedate,ietime,'FLEXPART V8.2'
  endif

  ! Write info on output interval, averaging time, sampling time
  !*************************************************************

  write(unitheader) loutstep,loutaver,loutsample

  ! Write information on output grid setup
  !***************************************

  write(unitheader) outlon0n,outlat0n,numxgridn,numygridn, &
       dxoutn,dyoutn
  write(unitheader) numzgrid,(outheight(i),i=1,numzgrid)

  call caldate(bdate,jjjjmmdd,ihmmss)
  write(unitheader) jjjjmmdd,ihmmss

  ! Write number of species, and name for each species (+extra name for depositions)
  ! Indicate the dimension of the fields (i.e., 1 for deposition fields, numzgrid for
  ! concentration fields
  !*****************************************************************************

  write(unitheader) 3*nspec,maxpointspec_act
  do i=1,nspec
    write(unitheader) 1,'WD_'//species(i)(1:7)
    write(unitheader) 1,'DD_'//species(i)(1:7)
    write(unitheader) numzgrid,species(i)
  end do

  ! Write information on release points: total number, then for each point:
  ! start, end, coordinates, # of particles, name, mass
  !************************************************************************

  write(unitheader) numpoint
  do i=1,numpoint
    write(unitheader) ireleasestart(i),ireleaseend(i),kindz(i)
    xp1=xpoint1(i)*dx+xlon0
    yp1=ypoint1(i)*dy+ylat0
    xp2=xpoint2(i)*dx+xlon0
    yp2=ypoint2(i)*dy+ylat0
    write(unitheader) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
    write(unitheader) npart(i),1
    if (numpoint.le.1000) then
      write(unitheader) compoint(i)
    else
      write(unitheader) compoint(1001)
   endif
    do j=1,nspec
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
    end do
  end do

  ! Write information on some model switches
  !*****************************************

  write(unitheader) method,lsubgrid,lconvection, &
       ind_source,ind_receptor

  ! Write age class information
  !****************************

  write(unitheader) nageclass,(lage(i),i=1,nageclass)


  ! Write topography to output file
  !********************************

  do ix=0,numxgridn-1
    write(unitheader) (orooutn(ix,jy),jy=0,numygridn-1)
  end do
  close(unitheader)

  return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'header'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  stop

end subroutine writeheader_nest

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine getfields(itime,nstop)
  !                       i     o
  !*****************************************************************************
  !                                                                            *
  !  This subroutine manages the 3 data fields to be kept in memory.           *
  !  During the first time step of petterssen it has to be fulfilled that the  *
  !  first data field must have |wftime|<itime, i.e. the absolute value of     *
  !  wftime must be smaller than the absolute value of the current time in [s].*
  !  The other 2 fields are the next in time after the first one.              *
  !  Pointers (memind) are used, because otherwise one would have to resort the*
  !  wind fields, which costs a lot of computing time. Here only the pointers  *
  !  are resorted.                                                             *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     29 April 1994                                                          *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:
  !   Variables tth,qvh,tthn,qvhn (on eta coordinates) in common block.
  !   Function of nstop extended.
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! lwindinterval [s]    time difference between the two wind fields read in   *
  ! indj                 indicates the number of the wind field to be read in  *
  ! indmin               remembers the number of wind fields already treated   *
  ! memind(2)            pointer, on which place the wind fields are stored    *
  ! memtime(2) [s]       times of the wind fields, which are kept in memory    *
  ! itime [s]            current time since start date of trajectory calcu-    *
  !                      lation                                                *
  ! nstop                > 0, if trajectory has to be terminated               *
  ! nx,ny,nuvz,nwz       field dimensions in x,y and z direction               *
  ! uu(0:nxmax,0:nymax,nuvzmax,2)   wind components in x-direction [m/s]       *
  ! vv(0:nxmax,0:nymax,nuvzmax,2)   wind components in y-direction [m/s]       *
  ! ww(0:nxmax,0:nymax,nwzmax,2)    wind components in z-direction [deltaeta/s]*
  ! tt(0:nxmax,0:nymax,nuvzmax,2)   temperature [K]                            *
  ! ps(0:nxmax,0:nymax,2)           surface pressure [Pa]                      *
  !                                                                            *
  ! Constants:                                                                 *
  ! idiffmax             maximum allowable time difference between 2 wind      *
  !                      fields                                                *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: indj,itime,nstop,memaux

  real :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: pvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: wwh(0:nxmax-1,0:nymax-1,nwzmax)
  real :: uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: pvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: wwhn(0:nxmaxn-1,0:nymaxn-1,nwzmax,maxnests)

  integer :: indmin = 1


  ! Check, if wind fields are available for the current time step
  !**************************************************************

  nstop=0

  if ((ldirect*wftime(1).gt.ldirect*itime).or. &
       (ldirect*wftime(numbwf).lt.ldirect*itime)) then
    write(*,*) 'FLEXPART WARNING: NO WIND FIELDS ARE AVAILABLE.'
    write(*,*) 'A TRAJECTORY HAS TO BE TERMINATED.'
    nstop=4
    return
  endif


  if ((ldirect*memtime(1).le.ldirect*itime).and. &
       (ldirect*memtime(2).gt.ldirect*itime)) then

  ! The right wind fields are already in memory -> don't do anything
  !*****************************************************************

    continue

  else if ((ldirect*memtime(2).le.ldirect*itime).and. &
       (memtime(2).ne.999999999)) then


  ! Current time is after 2nd wind field
  ! -> Resort wind field pointers, so that current time is between 1st and 2nd
  !***************************************************************************

    memaux=memind(1)
    memind(1)=memind(2)
    memind(2)=memaux
    memtime(1)=memtime(2)


  ! Read a new wind field and store it on place memind(2)
  !******************************************************

    do indj=indmin,numbwf-1
       if (ldirect*wftime(indj+1).gt.ldirect*itime) then
          call readwind(indj+1,memind(2),uuh,vvh,wwh)
          call readwind_nests(indj+1,memind(2),uuhn,vvhn,wwhn)
          call calcpar(memind(2),uuh,vvh,pvh)
          call calcpar_nests(memind(2),uuhn,vvhn,pvhn)
          call verttransform(memind(2),uuh,vvh,wwh,pvh)
          call verttransform_nests(memind(2),uuhn,vvhn,wwhn,pvhn)
          memtime(2)=wftime(indj+1)
          nstop = 1
          goto 40
       endif
    end do
 40   indmin=indj

  else

  ! No wind fields, which can be used, are currently in memory
  ! -> read both wind fields
  !***********************************************************

     do indj=indmin,numbwf-1
        if ((ldirect*wftime(indj).le.ldirect*itime).and. &
             (ldirect*wftime(indj+1).gt.ldirect*itime)) then
           memind(1)=1
           call readwind(indj,memind(1),uuh,vvh,wwh)
           call readwind_nests(indj,memind(1),uuhn,vvhn,wwhn)
           call calcpar(memind(1),uuh,vvh,pvh)
           call calcpar_nests(memind(1),uuhn,vvhn,pvhn)
           call verttransform(memind(1),uuh,vvh,wwh,pvh)
           call verttransform_nests(memind(1),uuhn,vvhn,wwhn,pvhn)
           memtime(1)=wftime(indj)
           memind(2)=2
           call readwind(indj+1,memind(2),uuh,vvh,wwh)
           call readwind_nests(indj+1,memind(2),uuhn,vvhn,wwhn)
           call calcpar(memind(2),uuh,vvh,pvh)
           call calcpar_nests(memind(2),uuhn,vvhn,pvhn)
           call verttransform(memind(2),uuh,vvh,wwh,pvh)
           call verttransform_nests(memind(2),uuhn,vvhn,wwhn,pvhn)
           memtime(2)=wftime(indj+1)
           nstop = 1
           goto 60
        endif
     end do
 60   indmin=indj

  endif

  lwindinterv=abs(memtime(2)-memtime(1))

  if (lwindinterv.gt.idiffmax) nstop=3

end subroutine getfields

!*******************************************************************************
!   Include file for convection
!   This file contains a global common block used by convect
!   and other subroutines
!   Author: P. Ferstl
!
!   Feb 2001
!
!   Changes
!       2021 L. Bakels:
!          - Array operations in convect subroutine
!          - OpenMP parallelisation in convmix and redist
!          - Moved all subroutines related to the convection to this module
!*******************************************************************************

module conv_mod

  use com_mod, only: lconvection, numthreads,nxmaxn, nymaxn,numbnests
  use windfields_mod, only: metdata_format,akz,bkz,akm,bkm,nuvz, &
    uvheight,ps,tt2,td2,tth,qvh,pplev,tt,qv,nx,ny,tt2n,td2n,psn,tthn,qvhn, &
    yln,yrn,xln,xrn,yresoln,xresoln,nxn,nyn,dxn,dyn, &
    nxmax,nymax,nconvlevmax,na,nuvzmax
  use sort_mod
  implicit none

  !integer,parameter :: nconvlevmax = nuvzmax-1, &
  !                     na = nconvlevmax+1
  !these parameters are defined in par_mod now!
  real,allocatable,dimension(:,:) :: &
    pconv,                           & ! 
    phconv,                          & !
    dpr,                             & !
    pconv_hpa,                       & !
    phconv_hpa,                      & !
    sub,                             & ! subsidence
    tconv,                           & !
    qconv,                           & !
    qsconv                            
  real,allocatable,dimension(:,:,:) :: & !
    fmass,                           & !
    fmassfrac,                       & !
    cbaseflux                         
  real,allocatable,dimension(:,:,:,:) :: &
    cbasefluxn
  ! integer,dimension(na) :: &
  !   NENT
  ! real,dimension(na,na) :: &
  !   MENT,QENT,ELIJ,SIJ
  ! real,dimension(na) ::    &
  !   fup,fdown,M,MP,TVP,TV, &
  !   WATER,QP,EP,TH,WT,     &
  !   EVAP,CLW,SIGP,TP,CPN,  &
  !   LV,LVCP,H,HP,GZ,HM
  real,allocatable,dimension(:,:) ::    &
    uvzlev,wsub
  real :: psconv,tt2conv,td2conv
  
  integer :: nconvlev ! global variable set at start in FLEXPART.f90
  integer :: nconvtop ! needs to be private, set in convect

  save :: uvzlev

! $OMP THREADPRIVATE( fmass, sub, fmassfrac, &
! $OMP pconv, phconv, dpr, pconv_hpa, phconv_hpa, &
! $OMP tconv, qconv, qsconv, psconv, tt2conv, td2conv, &
! $OMP nconvtop,uvzlev,wsub,cbaseflux,cbasefluxn)

!$OMP THREADPRIVATE( psconv, tt2conv, td2conv,nconvtop)
! , &
! !$OMP fup,fdown,MENT,NENT,M,MP,QENT,ELIJ,SIJ,TVP,TV, &
! !$OMP WATER,QP,EP,TH,WT,EVAP,CLW,SIGP,TP,CPN,LV,LVCP, &
! !$OMP H,HP,GZ,HM)

contains

subroutine alloc_convect
  implicit none
  integer :: stat
  if (.not.lconvection.eq.1) return
  ! nconvlevmax=nuvzmax-1
  ! na=nconvlevmax+1
  allocate( pconv(nconvlevmax,numthreads),phconv(na,numthreads), &
    dpr(nconvlevmax,numthreads), &
    pconv_hpa(nconvlevmax,numthreads),phconv_hpa(na,numthreads), &
    fmass(nconvlevmax,nconvlevmax,numthreads),        &
    sub(nconvlevmax,numthreads), &
    fmassfrac(nconvlevmax,nconvlevmax,numthreads),   &
    cbaseflux(0:nxmax-1,0:nymax-1,numthreads),                        &
    cbasefluxn(0:nxmaxn-1,0:nymaxn-1,numbnests,numthreads),            &
    tconv(na,numthreads),qconv(na,numthreads),qsconv(na,numthreads),stat=stat)
  if (stat.ne.0) error stop "Could not allocate convection arrays"

  allocate( uvzlev(nuvzmax,numthreads),wsub(nuvzmax,numthreads),stat=stat)
  if (stat.ne.0) error stop "Could not allocate uvzlev or wsub"

  ! allocate(FUP(NA),FT(NA),FQ(NA),FDOWN(NA),NENT(NA),       &
  !   M(NA),MP(NA),MENT(NA,NA),QENT(NA,NA),ELIJ(NA,NA),      &
  !   SIJ(NA,NA),TVP(NA),TV(NA),WATER(NA),                   &
  !   QP(NA),EP(NA),TH(NA),WT(NA),EVAP(NA),CLW(NA),          &
  !   SIGP(NA),TP(NA),CPN(NA),                               &
  !   LV(NA),LVCP(NA),H(NA),HP(NA),GZ(NA),HM(NA))

end subroutine alloc_convect

subroutine dealloc_convect
  implicit none
  if (.not.lconvection.eq.1) return
  deallocate(pconv,phconv,dpr,pconv_hpa,phconv_hpa,sub,      &
    tconv,qconv,qsconv,fmass,fmassfrac,cbaseflux,cbasefluxn)
  deallocate(uvzlev,wsub)
  ! deallocate(fup,fdown,ment,ft,fq,M,MP,QENT,ELIJ,SIJ,TVP,TV, &
  !   WATER,QP,EP,TH,WT,EVAP,CLW,SIGP,TP,CPN,LV,LVCP, &
  !   H,HP,GZ,HM)
end subroutine dealloc_convect

subroutine set_conv_top()
! Determine the uppermost level for which the convection scheme shall be applied
! by assuming that there is no convection above 50 hPa (for standard SLP)
!*****************************************************************************  

  integer :: i
  real :: pint

  do i=1,nuvz-2
    pint=akz(i)+bkz(i)*101325.
    if (pint.lt.5000.) exit
  end do
  nconvlev=i
  if (nconvlev.gt.nconvlevmax-1) then
    nconvlev=nconvlevmax-1
    write(*,*) 'INFORMATION: Convection only calculated up to ', &
         akz(nconvlev)+bkz(nconvlev)*1013.25,' hPa'
  endif  

end subroutine set_conv_top

subroutine convmix(itime)
  !                     i
  !**************************************************************
  !handles all the calculations related to convective mixing
  !Petra Seibert, Bernd C. Krueger, Feb 2001
  !nested grids included, Bernd C. Krueger, May 2001
  !
  !Changes by Caroline Forster, April 2004 - February 2005:
  !  convmix called every lsynctime seconds
  !CHANGES by A. Stohl:
  !  various run-time optimizations - February 2005
  ! CHANGES by C. Forster, November 2005, NCEP GFS version
  !      in the ECMWF version convection is calculated on the
  !      original eta-levels
  !      in the GFS version convection is calculated on the
  !      FLEXPART levels
  !
  !   Unified ECMWF and GFS builds                                             
  !   Marian Harustak, 12.5.2017                                              
  !     - Merged convmix and convmix_gfs into one routine using if-then           
  !       for meteo-type dependent code                                        
  !**************************************************************
  use omp_lib
  use flux_mod
  use par_mod
  use com_mod
  use class_gribfile_mod
  use particle_mod

  implicit none

  integer :: igr,igrold, ipart, itime, ix, i, j, ik, inest
  integer :: ipconv,ithread,stat,countconv
  integer :: jy, kpart, ktop, ngrid,kz
  integer,allocatable :: igrid(:), ipoint(:), igridn(:,:)

  ! itime [s]                 current time
  ! igrid(maxpart)            horizontal grid position of each particle
  ! igridn(maxpart,maxnests)  dto. for nested grids
  ! ipoint(maxpart)           pointer to access particles according to grid position

  logical :: lconv,lcalcflux
  real :: x, y, xtn,ytn, ztold, delt
  real :: dt1,dt2,dtt
  integer :: mind1,mind2
  ! dt1,dt2,dtt,mind1,mind2       variables used for time interpolation
  integer :: itage,nage,inage

  ! OMP changes
  integer :: cnt,kk
  integer,allocatable,dimension(:) :: frst,kkcnt
  double precision :: tmarray(2)

  integer :: alivepart
  real:: eps
  eps=nxmax/3.e5
  ! Calculate auxiliary variables for time interpolation
  !*****************************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)
  mind1=memind(1)
  mind2=memind(2)
  delt=real(abs(lsynctime))

  lconv = .false.

  ! if no particles are present return after initialization
  !********************************************************
  call get_alivepart_num(alivepart)
  if (alivepart.le.0 ) return

  !call get_totalpart_num(totpart)
  allocate( igrid(alivepart),stat=stat)
  if (stat.ne.0) error stop "Could not allocate igrid"
  allocate( ipoint(alivepart),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ipoint"
  allocate( igridn(alivepart,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate igridn"

  ! Assign igrid and igridn, which are pseudo grid numbers indicating particles
  ! that are outside the part of the grid under consideration
  ! (e.g. particles near the poles or particles in other nests).
  ! Do this for all nests but use only the innermost nest; for all others
  ! igrid shall be -1
  ! Also, initialize index vector ipoint
  !************************************************************************
  igrid(:) = -1
  do j=numbnests,1,-1
    igridn(:,j)=-1
  end do

!$OMP PARALLEL PRIVATE(ipart, i, j, x, y, ngrid, xtn, ytn, ix, jy)
!$OMP DO
  do i=1,alivepart
    ! do not consider particles that are not (yet) part of simulation
    ipart=count%ialive(i)

    ipoint(i)=ipart

    x = real(part(ipart)%xlon)
    y = real(part(ipart)%ylat)

  ! Determine which nesting level to be used
  !**********************************************************

    ngrid=0
    if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
      do j=numbnests,1,-1
        ! Temporary fix for nested layer edges: replaced eps with dxn and dyn (LB)
        if ( x.gt.xln(j)+dxn(j) .and. x.lt.xrn(j)-dxn(j) .and. &
             y.gt.yln(j)+dyn(j) .and. y.lt.yrn(j)-dyn(j) ) then
          ngrid=j
          exit
        endif
      end do
    else
      do j=numbnests,1,-1
        if ( x.gt.xln(j) .and. x.lt.xrn(j) .and. &
             y.gt.yln(j) .and. y.lt.yrn(j) ) then
          ngrid=j
          exit
        endif
      end do
    endif
 ! 23   continue

  ! Determine nested grid coordinates
  !**********************************

    if (ngrid.gt.0) then
  ! nested grids
      xtn=(x-xln(ngrid))*xresoln(ngrid)
      ytn=(y-yln(ngrid))*yresoln(ngrid)
      ix=nint(xtn)
      jy=nint(ytn)
      ! igridn(ipart,ngrid) = 1 + jy*nxn(ngrid) + ix
      igridn(i,ngrid) = 1 + ix*nyn(ngrid) + jy
    else if(ngrid.eq.0) then
  ! mother grid
      ix=nint(x)
      jy=nint(y)
      !igrid(ipart) = 1 + jy*nx + ix
      igrid(i) = 1 + ix*ny + jy
    endif
  end do
!$OMP END DO
!$OMP END PARALLEL

  ! sumall = 0.
  ! sumconv = 0.

  !*****************************************************************************
  ! 1. Now, do everything for the mother domain and, later, for all of the nested domains
  ! While all particles have to be considered for redistribution, the Emanuel convection
  ! scheme only needs to be called once for every grid column where particles are present.
  ! Therefore, particles are sorted according to their grid position. Whenever a new grid
  ! cell is encountered by looping through the sorted particles, the convection scheme is called.
  !*****************************************************************************

  ! sort particles according to horizontal position and calculate index vector IPOINT

  call sort2(alivepart,igrid,ipoint)

  ! Now visit all grid columns where particles are present
  ! by going through the sorted particles

  !LB changes following the CTM version
  allocate( frst(nx*(ny+1)+1),stat=stat)
  if (stat.ne.0) error stop "Could not allocate frst"
  frst(1) = 1
  cnt = 2
  igrold = igrid(1)
  ! Looping over all particles and counting how many in each igrid reside.
  ! This is saved in frst. The number of consecutive particles in igrid is saved in frst(i)
  do kpart=1,alivepart
    if (igrold.ne.igrid(kpart)) then
      frst(cnt) = kpart
      igrold=igrid(kpart)
      cnt=cnt+1
    endif
  end do 
  frst(cnt) = alivepart+1

  allocate(kkcnt(cnt-1))
  countconv=0
  do kk=1,cnt-1
    if (igrid(frst(kk)).eq.-1) cycle ! Only consider grids that have particles inside
    countconv=countconv+1
    kkcnt(countconv)=kk
  end do

!$OMP PARALLEL PRIVATE(kk,jy,ix,tmarray,j,kz,ktop,lconv,kpart,ipart,&
!$OMP ztold,nage,ipconv,itage,ithread,lcalcflux)

#if (defined _OPENMP)
    ithread = OMP_GET_THREAD_NUM()+1 ! Starts at 1
#else
    ithread = 1
#endif

!$OMP DO SCHEDULE(dynamic)
  do ik=1,countconv
    
    !if (igrid(frst(kk)).eq.-1) cycle
    kk=kkcnt(ik)
    ! Find horizontal location of grid column
    ix = (igrid(frst(kk))-1)/ny
    jy = igrid(frst(kk)) - ix*ny - 1
    ! jy = (igrid(frst(kk))-1)/nx
    ! ix = igrid(frst(kk)) - jy*nx - 1

  ! Interpolate all meteorological data needed for the convection scheme
    psconv=(ps(ix,jy,1,mind1)*dt2+ps(ix,jy,1,mind2)*dt1)*dtt
    tt2conv=(tt2(ix,jy,1,mind1)*dt2+tt2(ix,jy,1,mind2)*dt1)*dtt
    td2conv=(td2(ix,jy,1,mind1)*dt2+td2(ix,jy,1,mind2)*dt1)*dtt

    if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
      do kz=1,nuvz-1           !bugfix
        tconv(kz,ithread)=(tth(ix,jy,kz+1,mind1)*dt2+ &
             tth(ix,jy,kz+1,mind2)*dt1)*dtt
        qconv(kz,ithread)=(qvh(ix,jy,kz+1,mind1)*dt2+ &
             qvh(ix,jy,kz+1,mind2)*dt1)*dtt
      end do
    else
      do kz=1,nuvz-1           !bugfix
        pconv(kz,ithread)=(pplev(ix,jy,kz,mind1)*dt2+ &
            pplev(ix,jy,kz,mind2)*dt1)*dtt
        tconv(kz,ithread)=(tt(ix,jy,kz,mind1)*dt2+ &
            tt(ix,jy,kz,mind2)*dt1)*dtt
        qconv(kz,ithread)=(qv(ix,jy,kz,mind1)*dt2+ &
            qv(ix,jy,kz,mind2)*dt1)*dtt
      end do
    end if

  ! Calculate translocation matrix
    call calcmatrix(lconv,delt,cbaseflux(ix,jy,ithread),ithread)
    
  ! treat particle only if column has convection
    if (lconv .eqv. .true.) then
      ktop = 0
  ! assign new vertical position to particle
      do kpart=frst(kk), frst(kk+1)-1
        ipart = ipoint(kpart)
        ztold=real(part(ipart)%z)
        call redist(itime,ipart,ktop,ipconv,ithread)
  !    if (ipconv.le.0) sumconv = sumconv+1

  ! Calculate the gross fluxes across layer interfaces
  !***************************************************

        if (iflux.eq.1) then
          lcalcflux=.true.
          if (lagespectra.eq.1) then
            nage=0
            itage=abs(itime-part(ipart)%tstart)
            do inage=1,nageclass
              if ((itage.lt.lage(inage)).and.(part(ipart)%alive)) exit
              nage=inage
            end do
            if (nage.eq.nageclass) lcalcflux=.false.
            nage=nage+1
          else
            nage=1
          endif

          if (lcalcflux) &
            call calcfluxes(itime,nage,ipart,real(part(ipart)%xlon), &
               real(part(ipart)%ylat),ztold,ithread)
        endif
      enddo

    endif   !(lconv .eqv. .true)
  end do
!$OMP END DO
!$OMP END PARALLEL

  deallocate(frst)

  ! OpenMP Reduction for dynamically allocated arrays. This is done manually since this
  ! is not yet supported in most OpenMP versions
  !************************************************************************************
  if (iflux.eq.1) then
    do ithread=1,numthreads
      flux(:,:,:,:,:,:,:)=flux(:,:,:,:,:,:,:)+flux_omp(:,:,:,:,:,:,:,ithread)
    end do
  endif

  !*****************************************************************************
  ! 2. Nested domains
  !*****************************************************************************

  ! sort particles according to horizontal position and calculate index vector IPOINT
  do inest=1,numbnests
    do i=1,alivepart
      ipoint(i)=count%ialive(i)
      igrid(i) = igridn(i,inest)
    enddo
    call sort2(alivepart,igrid,ipoint)

  ! Now visit all grid columns where particles are present
  ! by going through the sorted particles
!$OMP PARALLEL PRIVATE (igrold,kpart,ipart,igr,jy,ix,kz,lconv, &
!$OMP ktop,ztold,nage,ipconv,itage,lcalcflux,ithread)
    igrold = -1
#if (defined _OPENMP)
    ithread = OMP_GET_THREAD_NUM()+1 ! Starts at 1
#else
    ithread = 1
#endif
!$OMP DO SCHEDULE(dynamic)
    do kpart=1,alivepart
      igr = igrid(kpart)
      if (igr .eq. -1) cycle
      ipart = ipoint(kpart)
      ! sumall = sumall + 1
      if (igr .ne. igrold) then
  ! we are in a new grid column
        jy = (igr-1)/nxn(inest)
        ix = igr - jy*nxn(inest) - 1

  ! Interpolate all meteorological data needed for the convection scheme
        psconv=(psn(ix,jy,1,mind1,inest)*dt2+ &
             psn(ix,jy,1,mind2,inest)*dt1)*dtt
        tt2conv=(tt2n(ix,jy,1,mind1,inest)*dt2+ &
             tt2n(ix,jy,1,mind2,inest)*dt1)*dtt
        td2conv=(td2n(ix,jy,1,mind1,inest)*dt2+ &
             td2n(ix,jy,1,mind2,inest)*dt1)*dtt
!!$        do kz=1,nconvlev+1    !old
        do kz=1,nuvz-1           !bugfix
          tconv(kz,ithread)=(tthn(ix,jy,kz+1,mind1,inest)*dt2+ &
               tthn(ix,jy,kz+1,mind2,inest)*dt1)*dtt
          qconv(kz,ithread)=(qvhn(ix,jy,kz+1,mind1,inest)*dt2+ &
               qvhn(ix,jy,kz+1,mind2,inest)*dt1)*dtt
        end do

  ! calculate translocation matrix
  !*******************************
        call calcmatrix(lconv,delt,cbasefluxn(ix,jy,inest,ithread),ithread)
        igrold = igr
        ktop = 0
      endif

  ! treat particle only if column has convection
      if (lconv .eqv. .true.) then
  ! assign new vertical position to particle
        ztold=real(part(ipart)%z)
        call redist(itime,ipart,ktop,ipconv,ithread)
  !      if (ipconv.le.0) sumconv = sumconv+1

  ! Calculate the gross fluxes across layer interfaces
  !***************************************************
        if (iflux.eq.1) then
          lcalcflux=.true.
          if (lagespectra.eq.1) then
            nage=0
            itage=abs(itime-part(ipart)%tstart)
            do inage=1,nageclass
              if ((itage.lt.lage(inage)).and.(part(ipart)%alive)) exit
              nage=inage
            end do
            if (nage.eq.nageclass) lcalcflux=.false.
            nage=nage+1
          else
            nage=1
          endif

          if (lcalcflux) &
            call calcfluxes(itime,nage,ipart,real(part(ipart)%xlon), &
               real(part(ipart)%ylat),ztold,ithread)
        endif
      endif !(lconv .eqv. .true.)

    end do
!$OMP END DO
!$OMP END PARALLEL
  end do
  ! OpenMP Reduction for dynamically allocated arrays. This is done manually since this
  ! is not yet supported in most OpenMP versions
  !************************************************************************************
  if (iflux.eq.1) then
    do ithread=1,numthreads
      flux(:,:,:,:,:,:,:)=flux(:,:,:,:,:,:,:)+flux_omp(:,:,:,:,:,:,:,ithread)
    end do
  endif
  !--------------------------------------------------------------------------
  ! write(*,*)'############################################'
  ! write(*,*)'TIME=',&
  !    &  itime
  ! write(*,*)'fraction of particles under convection',&
  !    &  sumconv/(sumall+0.001)
  ! write(*,*)'total number of particles',&
  !    &  sumall
  ! write(*,*)'number of particles under convection',&
  !    &  sumconv
  ! write(*,*)'############################################'

  deallocate( igrid )
  deallocate( ipoint )
  deallocate( igridn )

  return
end subroutine convmix

subroutine calcmatrix(lconv,delt,cbmf,ithread)
  !                        o    i    o
  !*****************************************************************************
  !                                                                            *
  !  This subroutine calculates the matrix describing convective               *
  !  redistribution of mass in a grid column, using the subroutine             *
  !  convect43c.f provided by Kerry Emanuel.                                   *
  !                                                                            *
  !  Petra Seibert, Bernd C. Krueger, 2000-2001                                *
  !                                                                            *
  !*****************************************************************************
  ! Changes:                                                                   *
  !  changed by C. Forster, November 2003 - February 2004                      *
  !  array fmassfrac(nconvlevmax,nconvlevmax) represents                       *
  !  the convective redistribution matrix for the particles                    *
  !                                                                            *
  !   Unified ECMWF and GFS builds                                             *
  !   Marian Harustak, 12.5.2017                                               *
  !     - Merged calcmatrix and calcmatrix_gfs into one routine using if-then  *
  !       for meteo-type dependent code                                        *
  !*****************************************************************************
  !                                                                            *
  !  lconv        indicates whether there is convection in this cell, or not   *
  !  delt         time step for convection [s]                                 *
  !  cbmf         cloud base mass flux                                         *
  !  metdata_format format of metdata (ecmwf/gfs)                              *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use class_gribfile_mod
  use qvsat_mod

  implicit none

  integer,intent(in) :: ithread !OMP thread starting at 1
  real :: rlevmass,summe

  integer :: iflag, k, kk

  !1-d variables for convection
  !variables for redistribution matrix
  real :: cbmfold, precip, qprime
  real :: tprime, wd
  real :: delt,cbmf
  logical :: lconv

  lconv = .false.


  ! calculate pressure at eta levels for use in convect
  ! and assign temp & spec. hum. to 1D workspace
  ! -------------------------------------------------------

  ! pconv(1) is the pressure at the first level above ground
  ! phconv(k) is the pressure between levels k-1 and k
  ! dpr(k) is the pressure difference "around" tconv(k)
  ! phconv(kmax) must also be defined 1/2 level above pconv(kmax)
  ! Therefore, we define k = kuvz-1 and let kuvz start from 2
  ! top layer cannot be used for convection because p at top of this layer is
  ! not given


  phconv(1,ithread) = psconv
  ! Emanuel subroutine needs pressure in hPa, therefore convert all pressures
  ! do kuvz = 2,nuvz
  !   k = kuvz-1
  !   if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
  !     pconv(k) = (akz(kuvz) + bkz(kuvz)*psconv)
  !     phconv(kuvz) = (akm(kuvz) + bkm(kuvz)*psconv)
  !   else
  !     phconv(kuvz) =  0.5*(pconv(kuvz)+pconv(k))
  !   endif
  !   dpr(k) = phconv(k) - phconv(kuvz)
  !   qsconv(k) = f_qvsat( pconv(k), tconv(k) )

  ! initialize mass fractions
    ! do kk=1,nconvlev
    !   fmassfrac(k,kk)=0.
    ! end do
  ! end do
  ! LB 04.05.2021, replace above with array operations
  if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
    pconv(1:nuvz-1,ithread) = (akz(2:nuvz) + bkz(2:nuvz)*psconv)
    phconv(2:nuvz,ithread) = (akm(2:nuvz) + bkm(2:nuvz)*psconv)
  else
    phconv(2:nuvz,ithread) =  0.5*(pconv(2:nuvz,ithread)+pconv(1:nuvz-1,ithread))
  endif
  dpr(1:nuvz-1,ithread) = phconv(1:nuvz-1,ithread) - phconv(2:nuvz,ithread)
  do k = 1,nuvz-1
    qsconv(k,ithread) = f_qvsat( pconv(k,ithread), tconv(k,ithread) )
  end do
  fmassfrac(1:nuvz-1,1:nconvlev,ithread)=0.
  ! LB end

  !note that Emanuel says it is important
  !a. to set this =0. every grid point
  !b. to keep this value in the calling programme in the iteration

  ! CALL CONVECTION
  !******************

  cbmfold = cbmf
  ! Convert pressures to hPa, as required by Emanuel scheme
  !********************************************************
  !!$    do k=1,nconvlev     !old
  ! do k=1,nconvlev+1      !bugfix
  !   pconv_hpa(k)=pconv(k)/100.
  !   phconv_hpa(k)=phconv(k)/100.
  ! end do
  ! phconv_hpa(nconvlev+1)=phconv(nconvlev+1)/100.
  ! LB 04.05.2021, replace above with array operations
  pconv_hpa(1:nconvlev+1,ithread)=pconv(1:nconvlev+1,ithread)/100.
  phconv_hpa(1:nconvlev+1,ithread)=phconv(1:nconvlev+1,ithread)/100.
  ! LB end
    
  call convect(nconvlevmax, nconvlev, delt, iflag, &
       precip, wd, tprime, qprime, cbmf, ithread)

  ! do not update fmassfrac and cloudbase massflux
  ! if no convection takes place or
  ! if a CFL criterion is violated in convect43c.f
  if (iflag .ne. 1 .and. iflag .ne. 4) then
   cbmf=cbmfold
   return
  endif

  ! do not update fmassfrac and cloudbase massflux
  ! if the old and the new cloud base mass
  ! fluxes are zero
  if (cbmf.le.0..and.cbmfold.le.0.) then
   cbmf=cbmfold
   return
  endif

  ! Update fmassfrac
  ! account for mass displaced from level k to level k

  lconv = .true.
  do k=1,nconvtop
    rlevmass = dpr(k,ithread)/ga
    summe = 0.
    do kk=1,nconvtop
      fmassfrac(k,kk,ithread) = delt*fmass(k,kk,ithread)
      summe = summe + fmassfrac(k,kk,ithread)
    end do
    fmassfrac(k,k,ithread)=fmassfrac(k,k,ithread) + rlevmass - summe
  end do
  ! LB 04.05.2021, replace above with array operations (not the problem)
  ! fmassfrac(1:nconvtop,1:nconvtop) = delt*fmass(1:nconvtop,1:nconvtop)
  ! do k=1, nconvtop
  !     fmassfrac(k, k) = fmassfrac(k, k) + dpr(k)/ga - sum(fmassfrac(k, 1:nconvtop))
  ! end do
  ! LB end
end subroutine calcmatrix

subroutine redist(itime,ipart,ktop,ipconv,ithread)

  !**************************************************************************
  ! Do the redistribution of particles due to convection
  ! This subroutine is called for each particle which is assigned
  ! a new vertical position randomly, based on the convective redistribution
  ! matrix
  !**************************************************************************

  ! Petra Seibert, Feb 2001, Apr 2001, May 2001, Jan 2002, Nov 2002 and
  ! Andreas Frank, Nov 2002

  ! Caroline Forster:  November 2004 - February 2005

  use par_mod
  use com_mod
  use random_mod
  use omp_lib
  use interpol_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use particle_mod
  use qvsat_mod

  implicit none

  integer,intent(in) :: ithread ! OMP thread starting at 1
  real,parameter :: const=r_air/ga
  integer :: ipart, ktop,ipconv,itime
  integer :: k, kz, levnew, levold

  real :: totlevmass, wsubpart
  real :: temp_levold,temp_levold1
  real :: sub_levold,sub_levold1
  real :: rn, dlevfrac
  real :: ztold,ffraction, dlogp
  real :: dz, dz1, dz2
#ifndef ETA
  real :: tv, tv1, tv2, tvold, pold, pint
#endif

  ! ipart   ... number of particle to be treated

  ipconv=1

  ! !  determine vertical grid position of particle in the eta system
  ! !****************************************************************
#ifdef ETA
  ztold = real(part(abs(ipart))%zeta)
  ! find old particle grid position
  levold = nconvtop
  do kz = 2, nconvtop
    if (wheight(kz) .le. ztold ) then
      levold = kz-1
      exit
    endif
  end do
#else

  ! determine height of the eta half-levels (uvzlev)
  ! do that only once for each grid column
  ! i.e. when ktop.eq.1
  !**************************************************************

  if (ktop .le. 1) then

    tvold=tt2conv*(1.+0.378*ew(td2conv,psconv)/psconv)
    pold=psconv
    uvzlev(1,ithread)=0.

    pint = phconv(2,ithread)
  !  determine next virtual temperatures
    tv1 = tconv(1,ithread)*(1.+0.608*qconv(1,ithread))
    tv2 = tconv(2,ithread)*(1.+0.608*qconv(2,ithread))
  !  interpolate virtual temperature to half-level
    tv = tv1 + (tv2-tv1)*(pconv(1,ithread)-phconv(2,ithread))/ &
      (pconv(1,ithread)-pconv(2,ithread))
    tv = tv1 + (tv2-tv1)*(pconv(1,ithread)-phconv(2,ithread))/ &
      (pconv(1,ithread)-pconv(2,ithread))
    if (abs(tv-tvold).gt.0.2) then
      uvzlev(2,ithread) = uvzlev(1,ithread) + &
           const*log(pold/pint)* &
           (tv-tvold)/log(tv/tvold)
    else
      uvzlev(2,ithread) = uvzlev(1,ithread)+ &
           const*log(pold/pint)*tv
    endif
    tvold=tv
    tv1=tv2
    pold=pint

  ! integrate profile (calculation of height agl of eta layers) as required
    do kz = 3, nconvtop+1
  !    note that variables defined in calcmatrix.f (pconv,tconv,qconv)
  !    start at the first real ECMWF model level whereas kz and
  !    thus uvzlev(kz) starts at the surface. uvzlev is defined at the
  !    half-levels (between the tconv, qconv etc. values !)
  !    Thus, uvzlev(kz) is the lower boundary of the tconv(kz) cell.
      pint = phconv(kz,ithread)
  !    determine next virtual temperatures
      tv2 = tconv(kz,ithread)*(1.+0.608*qconv(kz,ithread))
  !    interpolate virtual temperature to half-level
      tv = tv1 + (tv2-tv1)*(pconv(kz-1,ithread)-phconv(kz,ithread))/ &
           (pconv(kz-1,ithread)-pconv(kz,ithread))
      tv = tv1 + (tv2-tv1)*(pconv(kz-1,ithread)-phconv(kz,ithread))/ &
           (pconv(kz-1,ithread)-pconv(kz,ithread))
      if (abs(tv-tvold).gt.0.2) then
        uvzlev(kz,ithread) = uvzlev(kz-1,ithread) + &
             const*log(pold/pint)* &
             (tv-tvold)/log(tv/tvold)
      else
        uvzlev(kz,ithread) = uvzlev(kz-1,ithread)+ &
             const*log(pold/pint)*tv
      endif
      tvold=tv
      tv1=tv2
      pold=pint


    end do

    ktop = 2

  endif
  
  ztold = real(part(abs(ipart))%z)
  ! find old particle grid position
  levold = nconvtop
  do kz = 2, nconvtop
    if (uvzlev(kz,ithread) .ge. ztold ) then
      levold = kz-1
      exit
    endif
  end do
#endif

  ! If the particle is above the potentially convective domain, it will be skipped
  if (levold.ne.nconvtop) then

    ! now redistribute particles
    !****************************

    !  Choose a random number and find corresponding level of destination
    !  Random numbers to be evenly distributed in [0,1]

    rn = ran3(iseed2(ithread-1),ithread-1)

    ! initialize levnew

    levnew = levold

    ffraction = 0.
    totlevmass=dpr(levold,ithread)/ga
    loop1: do k = 1,nconvtop
    ! for backward runs use the transposed matrix
     if (ldirect.eq.1) then
       ffraction=ffraction+fmassfrac(levold,k,ithread) / totlevmass
     else
       ffraction=ffraction+fmassfrac(k,levold,ithread) / totlevmass
     endif
     if (rn.le.ffraction) then
       levnew=k
    ! avoid division by zero or a too small number
    ! if division by zero or a too small number happens the
    ! particle is assigned to the center of the grid cell
       if (ffraction.gt.1.e-20) then
        if (ldirect.eq.1) then
          dlevfrac = (ffraction-rn) / fmassfrac(levold,k,ithread) * totlevmass
        else
          dlevfrac = (ffraction-rn) / fmassfrac(k,levold,ithread) * totlevmass
        endif
       else
         dlevfrac = 0.5
       endif
       exit loop1
     endif
    end do loop1

    ! now assign new position to particle
#ifdef ETA
    if ((levnew.le.nconvtop).and.(levnew.ne.levold)) then
      dlogp = (1.-dlevfrac) * (wheight(levnew+1)-wheight(levnew))
      call set_zeta(ipart,wheight(levnew)+dlogp)
      if (part(abs(ipart))%zeta.ge.1.) call set_zeta(ipart,1.-(part(abs(ipart))%zeta-1.))
      if (part(abs(ipart))%zeta.eq.1.) call update_zeta(ipart,-1.e-4)
      if (ipconv.gt.0) ipconv=-1
    endif
#else
    if ((levnew.le.nconvtop).and.(levnew.ne.levold)) then
      dlogp = (1.-dlevfrac)* (log(phconv(levnew+1,ithread))-log(phconv(levnew,ithread)))
      pint = log(phconv(levnew,ithread))+dlogp
      dz1 = pint - log(phconv(levnew,ithread))
      dz2 = log(phconv(levnew+1,ithread)) - pint
      dz = dz1 + dz2
      call set_z(ipart,(uvzlev(levnew,ithread)*dz2+uvzlev(levnew+1,ithread)*dz1)/dz)
      if (part(abs(ipart))%z.lt.0.) call set_z(ipart,-1.*part(abs(ipart))%z)
      if (ipconv.gt.0) ipconv=-1
    endif
#endif
    ! displace particle according to compensating subsidence
    ! this is done to those particles, that were not redistributed
    ! by the matrix
    !**************************************************************

    if ((levnew.le.nconvtop).and.(levnew.eq.levold)) then

      ! determine compensating vertical velocity at the levels
      ! above and below the particel position
      ! increase compensating subsidence by the fraction that
      ! is displaced by convection to this level

      if (levold.gt.1) then
        temp_levold = tconv(levold-1,ithread) + &
            (tconv(levold,ithread)-tconv(levold-1,ithread)) &
            *(pconv(levold-1,ithread)-phconv(levold,ithread))/ &
            (pconv(levold-1,ithread)-pconv(levold,ithread))
        ! LB: the units seem to not add up correctly, but adding lsynctime gives incorrect mixing
        ! in the lowest km and too many right above the ground
        ! sub_levold = sub(levold,ithread)/(1.-ga*sub(levold,ithread)*lsynctime/dpr(levold,ithread))
        sub_levold = sub(levold,ithread)/(1.-ga*sub(levold,ithread)/dpr(levold,ithread))
        wsub(levold,ithread)=-1.*sub_levold*r_air*temp_levold/(phconv(levold,ithread))
      else
        wsub(levold,ithread)=0.
      endif

      temp_levold1 = tconv(levold,ithread) + &
          (tconv(levold+1,ithread)-tconv(levold,ithread)) &
          *(pconv(levold,ithread)-phconv(levold+1,ithread))/ &
          (pconv(levold,ithread)-pconv(levold+1,ithread))
      !sub_levold1 = sub(levold+1,ithread)/(1.-ga*sub(levold+1,ithread)*lsynctime/dpr(levold+1,ithread))
      sub_levold1 = sub(levold+1,ithread)/(1.-ga*sub(levold+1,ithread)/dpr(levold+1,ithread))
      wsub(levold+1,ithread)=-1.*sub_levold1*r_air*temp_levold1/ &
          (phconv(levold+1,ithread))

      ! interpolate wsub to the vertical particle position
#ifdef ETA
      ztold = real(part(abs(ipart))%zeta)
      dz1 = ztold - wheight(levold)
      dz2 = wheight(levold+1) - ztold
      dz = dz1 + dz2

      ! Convert z(eta) to z(m) in order to add subsidence
      call update_zeta_to_z(itime, ipart)
      ! call zeta_to_z(itime,part(abs(ipart))%xlon,part(abs(ipart))%ylat, &
      !   part(abs(ipart))%zeta,part(abs(ipart))%z)

      wsubpart = (dz2*wsub(levold,ithread)+dz1*wsub(levold+1,ithread))/dz

      call update_z(ipart,wsubpart*real(lsynctime))

      if (part(abs(ipart))%z.lt.0.) call set_z(ipart,-1.*part(abs(ipart))%z)

      ! Convert new z(m) back to z(eta)
      call update_z_to_zeta(itime, ipart)
          
#else
      ztold = real(part(abs(ipart))%z)
      dz1 = ztold - uvzlev(levold,ithread)
      dz2 = uvzlev(levold+1,ithread) - ztold
      dz = dz1 + dz2

      wsubpart = (dz2*wsub(levold,ithread)+dz1*wsub(levold+1,ithread))/dz

      call update_z(ipart,wsubpart*real(lsynctime))

      if (part(abs(ipart))%z.lt.0.) call set_z(ipart,-1.*part(abs(ipart))%z)

#endif
    endif      !(levnew.le.nconvtop.and.levnew.eq.levold)
  endif
  ! Maximum altitude .5 meter below uppermost model level
  !*******************************************************

#ifdef ETA
  if (part(abs(ipart))%zeta .lt. uvheight(nz)) call set_zeta(ipart,uvheight(nz)+1.e-4)
  if (part(abs(ipart))%zeta.ge.1.) call set_zeta(ipart,1.-(part(abs(ipart))%zeta-1.))
  if (part(abs(ipart))%zeta.eq.1.) call update_zeta(ipart,-1.e-4)
#else
  if (part(abs(ipart))%z .gt. height(nz)-0.5) call set_z(ipart,height(nz)-0.5)
#endif

end subroutine redist

!**************************************************************************
!****                       SUBROUTINE CONVECT                        *****
!****                          VERSION 4.3c                           *****
!****                          20 May, 2002                           *****
!****                          Kerry Emanuel                          *****
!**************************************************************************
!
  SUBROUTINE CONVECT &
         (ND,  NL,   DELT, IFLAG, &
         PRECIP, WD,   TPRIME, QPRIME, CBMF, ithread  )
  !
  !-cv *************************************************************************
  !-cv C. Forster, November 2003 - May 2004:
  !-cv
  !-cv The subroutine has been downloaded from Kerry Emanuel's homepage,
  !-cv where further infos on the convection scheme can be found
  !-cv http://www-paoc.mit.edu/~emanuel/home.html
  !-cv
  !-cv The following changes have been made to integrate this subroutine
  !-cv into FLEXPART
  !-cv
  !-cv Putting most of the variables in a new common block
  !-cv renaming eps to eps0 because there is some eps already in includepar
  !-cv
  !-cv removing the arrays U,V,TRA and related arrays
  !-cv
  !-cv renaming the original arrays T,Q,QS,P,PH to
  !-cv TCONV,QCONV,QSCONV,PCONV_HPA,PHCONV_HPA
  !-cv
  !-cv Initialization of variables has been put into parameter statements
  !-cv instead of assignment of values at each call, in order to save 
  !-cv computation time.
  !***************************************************************************
  !
  !-----------------------------------------------------------------------------
  !    *** On input:      ***
  !
  !T:   Array of absolute temperature (K) of dimension ND, with first
  !      index corresponding to lowest model level. Note that this array
  !      will be altered by the subroutine if dry convective adjustment
  !      occurs and if IPBL is not equal to 0.
  !
  !Q:   Array of specific humidity (gm/gm) of dimension ND, with first
  !       index corresponding to lowest model level. Must be defined
  !       at same grid levels as T. Note that this array will be altered
  !       if dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !QS:  Array of saturation specific humidity of dimension ND, with first
  !       index corresponding to lowest model level. Must be defined
  !       at same grid levels as T. Note that this array will be altered
  !       if dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !U:   Array of zonal wind velocity (m/s) of dimension ND, witth first
  !       index corresponding with the lowest model level. Defined at
  !       same levels as T. Note that this array will be altered if
  !       dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !V:   Same as U but for meridional velocity.
  !
  !TRA: Array of passive tracer mixing ratio, of dimensions (ND,NTRA),
  !       where NTRA is the number of different tracers. If no
  !       convective tracer transport is needed, define a dummy
  !       input array of dimension (ND,1). Tracers are defined at
  !       same vertical levels as T. Note that this array will be altered
  !       if dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !P:   Array of pressure (mb) of dimension ND, with first
  !       index corresponding to lowest model level. Must be defined
  !       at same grid levels as T.
  !
  !PH:  Array of pressure (mb) of dimension ND+1, with first index
  !       corresponding to lowest level. These pressures are defined at
  !       levels intermediate between those of P, T, Q and QS. The first
  !       value of PH should be greater than (i.e. at a lower level than)
  !       the first value of the array P.
  !
  !ND:  The dimension of the arrays T,Q,QS,P,PH,FT and FQ
  !
  !NL:  The maximum number of levels to which convection can
  !       penetrate, plus 1.
  !       NL MUST be less than or equal to ND-1.
  !
  !NTRA:The number of different tracers. If no tracer transport
  !       is needed, set this equal to 1. (On most compilers, setting
  !       NTRA to 0 will bypass tracer calculation, saving some CPU.)
  !
  !DELT: The model time step (sec) between calls to CONVECT
  !
  !----------------------------------------------------------------------------
  !    ***   On Output:         ***
  !
  !IFLAG: An output integer whose value denotes the following:
  !
  !           VALUE                        INTERPRETATION
  !           -----                        --------------
  !             0               No moist convection; atmosphere is not
  !                             unstable, or surface temperature is less
  !                             than 250 K or surface specific humidity
  !                             is non-positive.
  !
  !             1               Moist convection occurs.
  !
  !             2               No moist convection: lifted condensation
  !                             level is above the 200 mb level.
  !
  !             3               No moist convection: cloud base is higher
  !                             then the level NL-1.
  !
  !             4               Moist convection occurs, but a CFL condition
  !                             on the subsidence warming is violated. This
  !                             does not cause the scheme to terminate.
  !
  !FT:   Array of temperature tendency (K/s) of dimension ND, defined at same
  !        grid levels as T, Q, QS and P.
  !
  !FQ:   Array of specific humidity tendencies ((gm/gm)/s) of dimension ND,
  !        defined at same grid levels as T, Q, QS and P.
  !
  !FU:   Array of forcing of zonal velocity (m/s^2) of dimension ND,
  !        defined at same grid levels as T.
  !
  !FV:   Same as FU, but for forcing of meridional velocity.
  !
  !FTRA: Array of forcing of tracer content, in tracer mixing ratio per
  !        second, defined at same levels as T. Dimensioned (ND,NTRA).
  !
  !PRECIP: Scalar convective precipitation rate (mm/day).
  !
  !WD:    A convective downdraft velocity scale. For use in surface
  !        flux parameterizations. See convect.ps file for details.
  !
  !TPRIME: A convective downdraft temperature perturbation scale (K).
  !         For use in surface flux parameterizations. See convect.ps
  !         file for details.
  !
  !QPRIME: A convective downdraft specific humidity
  !         perturbation scale (gm/gm).
  !         For use in surface flux parameterizations. See convect.ps
  !         file for details.
  !
  !CBMF:   The cloud base mass flux ((kg/m**2)/s). THIS SCALAR VALUE MUST
  !         BE STORED BY THE CALLING PROGRAM AND RETURNED TO CONVECT AT
  !         ITS NEXT CALL. That is, the value of CBMF must be "remembered"
  !         by the calling program between calls to CONVECT.
  !
  !-----------------------------------------------------------------------------
  !
  !    ***  THE PARAMETER NA SHOULD IN GENERAL BE GREATER THAN   ***
  !    ***                OR EQUAL TO  ND + 1                    ***
  !
  !
  use par_mod

  implicit none
  !
  !-cv====>Begin Module CONVECT    File convect.f      Undeclared variables
  !
  !Argument variables
  !
  integer, intent(in) :: ithread ! OMP thread starting at 1
  integer :: iflag, nd, nl
  !
  real :: cbmf, delt, precip, qprime, tprime, wd
  !
  !Local variables
  !
  integer :: i, icb, ihmin, inb, inb1, j, jtt, k
  integer :: nk
  !
  real :: ad, afac, ahmax, ahmin, alt, altem
  real :: am, amp1, anum, asij, awat, b6, bf2, bsum, by
  real :: byp, c6, cape, capem, cbmfold, chi, coeff
  real :: cpinv, cwat, damps
  real :: defrac, dei, delm, delp, delt0, delti, denom, dhdp
  real :: dpinv, dtma, dtmin, dtpbl, elacrit, ents
  real :: epmax, fac, fqold, frac, ftold
  real :: plcl, qp1, qsm, qstm, qti, rat
  real :: revap, rh, scrit, sigt, sjmax
  real :: sjmin, smid, smin, stemp, tca
  real :: tvaplcl, tvpplcl, tvx, tvy, wdtrain

  !integer jc,jn
  !real alvnew,a2,ahm,alv,rm,sum,qnew,dphinv,tc,thbar,tnew,x
  !REAL TOLD(NA)

  real :: FUP(NA),FDOWN(NA),FT(NA),FQ(NA)
  !
  !-cv====>End Module   CONVECT    File convect.f

  INTEGER :: NENT(NA)
  REAL :: M(NA),MP(NA),MENT(NA,NA),QENT(NA,NA),ELIJ(NA,NA)
  REAL :: SIJ(NA,NA),TVP(NA),TV(NA),WATER(NA)
  REAL :: QP(NA),EP(NA),WT(NA),EVAP(NA),CLW(NA)
  REAL :: SIGP(NA),TP(NA),CPN(NA)
  REAL :: LV(NA),LVCP(NA),H(NA),HP(NA),GZ(NA),HM(NA)
  !
  ! -----------------------------------------------------------------------
  !
  !   ***                     Specify Switches                         ***
  !
  !   ***   IPBL: Set to zero to bypass dry adiabatic adjustment       ***
  !   ***    Any other value results in dry adiabatic adjustment       ***
  !   ***     (Zero value recommended for use in models with           ***
  !   ***                   boundary layer schemes)                    ***
  !
  !   ***   MINORIG: Lowest level from which convection may originate  ***
  !   ***     (Should be first model level at which T is defined       ***
  !   ***      for models using bulk PBL schemes; otherwise, it should ***
  !   ***      be the first model level at which T is defined above    ***
  !   ***                      the surface layer)                      ***
  !
  INTEGER,PARAMETER :: IPBL=0
  INTEGER,PARAMETER :: MINORIG=1
  !
  !------------------------------------------------------------------------------
  !
  !   ***                    SPECIFY PARAMETERS                        ***
  !
  !   *** ELCRIT IS THE AUTOCONVERSION THERSHOLD WATER CONTENT (gm/gm) ***
  !   ***  TLCRIT IS CRITICAL TEMPERATURE BELOW WHICH THE AUTO-        ***
  !   ***       CONVERSION THRESHOLD IS ASSUMED TO BE ZERO             ***
  !   ***     (THE AUTOCONVERSION THRESHOLD VARIES LINEARLY            ***
  !   ***               BETWEEN 0 C AND TLCRIT)                        ***
  !   ***   ENTP IS THE COEFFICIENT OF MIXING IN THE ENTRAINMENT       ***
  !   ***                       FORMULATION                            ***
  !   ***  SIGD IS THE FRACTIONAL AREA COVERED BY UNSATURATED DNDRAFT  ***
  !   ***  SIGS IS THE FRACTION OF PRECIPITATION FALLING OUTSIDE       ***
  !   ***                        OF CLOUD                              ***
  !   ***        OMTRAIN IS THE ASSUMED FALL SPEED (P/s) OF RAIN       ***
  !   ***     OMTSNOW IS THE ASSUMED FALL SPEED (P/s) OF SNOW          ***
  !   ***  COEFFR IS A COEFFICIENT GOVERNING THE RATE OF EVAPORATION   ***
  !   ***                          OF RAIN                             ***
  !   ***  COEFFS IS A COEFFICIENT GOVERNING THE RATE OF EVAPORATION   ***
  !   ***                          OF SNOW                             ***
  !   ***     CU IS THE COEFFICIENT GOVERNING CONVECTIVE MOMENTUM      ***
  !   ***                         TRANSPORT                            ***
  !   ***    DTMAX IS THE MAXIMUM NEGATIVE TEMPERATURE PERTURBATION    ***
  !   ***        A LIFTED PARCEL IS ALLOWED TO HAVE BELOW ITS LFC      ***
  !   ***    ALPHA AND DAMP ARE PARAMETERS THAT CONTROL THE RATE OF    ***
  !   ***                 APPROACH TO QUASI-EQUILIBRIUM                ***
  !   ***   (THEIR STANDARD VALUES ARE  0.20 AND 0.1, RESPECTIVELY)    ***
  !   ***                   (DAMP MUST BE LESS THAN 1)                 ***
  !
  REAL,PARAMETER :: ELCRIT=.0011
  REAL,PARAMETER :: TLCRIT=-55.0
  REAL,PARAMETER :: ENTP=1.5
  REAL,PARAMETER :: SIGD=0.05
  REAL,PARAMETER :: SIGS=0.12
  REAL,PARAMETER :: OMTRAIN=50.0
  REAL,PARAMETER :: OMTSNOW=5.5
  REAL,PARAMETER :: COEFFR=1.0
  REAL,PARAMETER :: COEFFS=0.8
  REAL,PARAMETER :: CU=0.7
  REAL,PARAMETER :: BETA=10.0
  REAL,PARAMETER :: DTMAX=0.9
  REAL,PARAMETER :: ALPHA=0.025  !original 0.2
  REAL,PARAMETER :: DAMP=0.1
  !
  !   ***        ASSIGN VALUES OF THERMODYNAMIC CONSTANTS,        ***
  !   ***            GRAVITY, AND LIQUID WATER DENSITY.           ***
  !   ***             THESE SHOULD BE CONSISTENT WITH             ***
  !   ***              THOSE USED IN CALLING PROGRAM              ***
  !   ***     NOTE: THESE ARE ALSO SPECIFIED IN SUBROUTINE TLIFT  ***
  !
  REAL,PARAMETER :: CPD=1005.7
  REAL,PARAMETER :: CPV=1870.0
  REAL,PARAMETER :: CL=2500.0
  REAL,PARAMETER :: RV=461.5
  REAL,PARAMETER :: RD=287.04
  REAL,PARAMETER :: LV0=2.501E6
  REAL,PARAMETER :: G=9.81
  REAL,PARAMETER :: ROWL=1000.0
  !
  REAL,PARAMETER :: CPVMCL=CL-CPV
  REAL,PARAMETER :: EPS0=RD/RV
  REAL,PARAMETER :: EPSI=1./EPS0
  REAL,PARAMETER :: GINV=1.0/G
  REAL,PARAMETER :: EPSILON=1.e-20

  ! EPSILON IS A SMALL NUMBER USED TO EXCLUDE MASS FLUXES OF ZERO
  !
  DELTI=1.0/DELT
  !
  !      ***  INITIALIZE OUTPUT ARRAYS AND PARAMETERS  ***
  !

  FT(:NL+1)=0.0
  FQ(:NL+1)=0.0
  FDOWN(:NL+1)=0.0
  sub(:NL+1,ithread)=0.0
  FUP(:NL+1)=0.0
  M(:NL+1)=0.0
  MP(:NL+1)=0.0
  fmass(:NL+1,:NL+1,ithread)=0.0
  MENT(:NL+1,:NL+1)=0.0

  PRECIP=0.0
  WD=0.0
  TPRIME=0.0
  QPRIME=0.0
  IFLAG=0
  !
  !  IF(IPBL.NE.0)THEN
  !
  !***            PERFORM DRY ADIABATIC ADJUSTMENT            ***
  !
  !  JC=0
  !  DO 30 I=NL-1,1,-1
  !   JN=0
  !    SUM=TH(I)*(1.+qconv(I)*EPSI-qconv(I))
  !   DO 10 J=I+1,NL
  !    SUM=SUM+TH(J)*(1.+qconv(J)*EPSI-qconv(J))
  !    THBAR=SUM/REAL(J+1-I)
  !    IF((TH(J)*(1.+qconv(J)*EPSI-qconv(J))).LT.THBAR)JN=J
  !  10    CONTINUE
  !   IF(I.EQ.1)JN=MAX(JN,2)
  !   IF(JN.EQ.0)GOTO 30
  !  12    CONTINUE
  !   AHM=0.0
  !   RM=0.0
  !   DO 15 J=I,JN
  !    AHM=AHM+(CPD*(1.-qconv(J))+qconv(J)*CPV)*tconv(J)*
  !    +   (phconv_hpa(J)-phconv_hpa(J+1))
  !    RM=RM+qconv(J)*(phconv_hpa(J)-phconv_hpa(J+1))
  !  15    CONTINUE
  !   DPHINV=1./(phconv_hpa(I)-phconv_hpa(JN+1))
  !   RM=RM*DPHINV
  !   A2=0.0
  !   DO 20 J=I,JN
  !    qconv(J)=RM
  !    RDCP=(RD*(1.-qconv(J))+qconv(J)*RV)/
  !    1     (CPD*(1.-qconv(J))+qconv(J)*CPV)
  !    X=(0.001*pconv_hpa(J))**RDCP
  !    TOLD(J)=tconv(J)
  !    tconv(J)=X
  !    A2=A2+(CPD*(1.-qconv(J))+qconv(J)*CPV)*X*
  !    1    (phconv_hpa(J)-phconv_hpa(J+1))
  !  20    CONTINUE
  !   DO 25 J=I,JN
  !    TH(J)=AHM/A2
  !    tconv(J)=tconv(J)*TH(J)
  !    TC=TOLD(J)-273.15
  !    ALV=LV0-CPVMCL*TC
  !    qsconv(J)=qsconv(J)+qsconv(J)*(1.+qsconv(J)*(EPSI-1.))*ALV*
  !    1    (tconv(J)- TOLD(J))/(RV*TOLD(J)*TOLD(J))
  ! if (qslev(j) .lt. 0.) then
  !   write(*,*) 'qslev.lt.0 ',j,qslev
  ! endif
  !  25    CONTINUE
  !   IF((TH(JN+1)*(1.+qconv(JN+1)*EPSI-qconv(JN+1))).LT.
  !    1    (TH(JN)*(1.+qconv(JN)*EPSI-qconv(JN))))THEN
  !    JN=JN+1
  !    GOTO 12
  !   END IF
  !   IF(I.EQ.1)JC=JN
  !  30   CONTINUE
  !
  !   ***   Remove any supersaturation that results from adjustment ***
  !
  !IF(JC.GT.1)THEN
  ! DO 38 J=1,JC
  !    IF(qsconv(J).LT.qconv(J))THEN
  !     ALV=LV0-CPVMCL*(tconv(J)-273.15)
  !     TNEW=tconv(J)+ALV*(qconv(J)-qsconv(J))/(CPD*(1.-qconv(J))+
  !    1      CL*qconv(J)+qsconv(J)*(CPV-CL+ALV*ALV/(RV*tconv(J)*tconv(J))))
  !     ALVNEW=LV0-CPVMCL*(TNEW-273.15)
  !     QNEW=(ALV*qconv(J)-(TNEW-tconv(J))*(CPD*(1.-qconv(J))
  !    1     +CL*qconv(J)))/ALVNEW
  !     PRECIP=PRECIP+24.*3600.*1.0E5*(phconv_hpa(J)-phconv_hpa(J+1))*
  !    1      (qconv(J)-QNEW)/(G*DELT*ROWL)
  !     tconv(J)=TNEW
  !     qconv(J)=QNEW
  !     qsconv(J)=QNEW
  !    END IF
  !  38  CONTINUE
  !END IF
  !
  !END IF
  !
  !  *** CALCULATE ARRAYS OF GEOPOTENTIAL, HEAT CAPACITY AND STATIC ENERGY
  !
  GZ(1)=0.0
  CPN(1)=CPD*(1.-qconv(1,ithread))+qconv(1,ithread)*CPV
  H(1)=tconv(1,ithread)*CPN(1)
  LV(1)=LV0-CPVMCL*(tconv(1,ithread)-273.15)
  HM(1)=LV(1)*qconv(1,ithread)
  TV(1)=tconv(1,ithread)*(1.+qconv(1,ithread)*EPSI-qconv(1,ithread))
  AHMIN=1.0E12
  IHMIN=NL

  DO I=2,NL+1
    TVX=tconv(I,ithread)*(1.+qconv(I,ithread)*EPSI-qconv(I,ithread))
    TVY=tconv(I-1,ithread)*(1.+qconv(I-1,ithread)*EPSI-qconv(I-1,ithread))
    GZ(I)=GZ(I-1)+0.5*RD*(TVX+TVY)*(pconv_hpa(I-1,ithread)-pconv_hpa(I,ithread))/ &
         phconv_hpa(I,ithread)
    CPN(I)=CPD*(1.-qconv(I,ithread))+CPV*qconv(I,ithread)
    H(I)=tconv(I,ithread)*CPN(I)+GZ(I)
    LV(I)=LV0-CPVMCL*(tconv(I,ithread)-273.15)
    HM(I)=(CPD*(1.-qconv(I,ithread))+CL*qconv(I,ithread))*(tconv(I,ithread)- &
      tconv(1,ithread)) + LV(I)*qconv(I,ithread)+GZ(I)
    TV(I)=tconv(I,ithread)*(1.+qconv(I,ithread)*EPSI-qconv(I,ithread))
!
!  ***  Find level of minimum moist static energy    ***
!
    IF(I.GE.MINORIG.AND.HM(I).LT.AHMIN.AND.HM(I).LT.HM(I-1))THEN
      AHMIN=HM(I)
      IHMIN=I
    END IF
  END DO
  IHMIN=MIN(IHMIN, NL-1)
  !
  !  ***     Find that model level below the level of minimum moist       ***
  !  ***  static energy that has the maximum value of moist static energy ***
  !
  AHMAX=0.0
  !  ***  bug fixed: need to assign an initial value to NK
  !  HSO, 05.08.2009
  NK=MINORIG
  DO I=MINORIG,IHMIN
    IF(HM(I).GT.AHMAX)THEN
      NK=I
      AHMAX=HM(I)
    END IF
  END DO
  ! LB 04.05.2021, replace above with array operations (maxloc not working)
  ! NK=MINORIG+maxloc(HM(MINORIG:IHMIN))-1

  !
  !  ***  CHECK WHETHER PARCEL LEVEL TEMPERATURE AND SPECIFIC HUMIDITY   ***
  !  ***                          ARE REASONABLE                         ***
  !  ***      Skip convection if HM increases monotonically upward       ***
  !
  IF(tconv(NK,ithread).LT.250.0.OR.qconv(NK,ithread).LE.0.0.OR.IHMIN.EQ.(NL-1)) THEN
    IFLAG=0
    CBMF=0.0
    RETURN
  END IF
  !
  !   ***  CALCULATE LIFTED CONDENSATION LEVEL OF AIR AT PARCEL ORIGIN LEVEL ***
  !   ***       (WITHIN 0.2% OF FORMULA OF BOLTON, MON. WEA. REV.,1980)      ***
  !
  RH=qconv(NK,ithread)/qsconv(NK,ithread)
  CHI=tconv(NK,ithread)/(1669.0-122.0*RH-tconv(NK,ithread))
  PLCL=pconv_hpa(NK,ithread)*(RH**CHI)
  IF(PLCL.LT.200.0.OR.PLCL.GE.2000.0)THEN
    IFLAG=2
    CBMF=0.0
    RETURN
  END IF
  !
  !   ***  CALCULATE FIRST LEVEL ABOVE LCL (=ICB)  ***
  !
  ICB=NL-1
  DO I=NK+1,NL
    IF(pconv_hpa(I,ithread).LT.PLCL)THEN
      ICB=MIN(ICB,I)
    END IF
  END DO
  IF(ICB.GE.(NL-1))THEN
    IFLAG=3
    CBMF=0.0
    RETURN
  END IF
  !
  !   *** FIND TEMPERATURE UP THROUGH ICB AND TEST FOR INSTABILITY           ***
  !
  !   *** SUBROUTINE TLIFT CALCULATES PART OF THE LIFTED PARCEL VIRTUAL      ***
  !   ***  TEMPERATURE, THE ACTUAL TEMPERATURE AND THE ADIABATIC             ***
  !   ***                   LIQUID WATER CONTENT                             ***
  !
  CALL TLIFT(GZ,ICB,NK,TVP,TP,CLW,ND,NL,1,ithread)
  TVP(NK:ICB)=TVP(NK:ICB)-TP(NK:ICB)*qconv(NK,ithread)
  !
  !   ***  If there was no convection at last time step and parcel    ***
  !   ***       is stable at ICB then skip rest of calculation        ***
  !
  IF(CBMF.EQ.0.0.AND.TVP(ICB).LE.(TV(ICB)-DTMAX))THEN
    IFLAG=0
    RETURN
  END IF
  !
  !   ***  IF THIS POINT IS REACHED, MOIST CONVECTIVE ADJUSTMENT IS NECESSARY ***
  !
  IF(IFLAG.NE.4)IFLAG=1
  !
  !   ***  FIND THE REST OF THE LIFTED PARCEL TEMPERATURES          ***
  !
  CALL TLIFT(GZ,ICB,NK,TVP,TP,CLW,ND,NL,2,ithread)
  !
  !   ***  SET THE PRECIPITATION EFFICIENCIES AND THE FRACTION OF   ***
  !   ***          PRECIPITATION FALLING OUTSIDE OF CLOUD           ***
  !   ***      THESE MAY BE FUNCTIONS OF TP(I), pconv_hpa(I) AND CLW(I)     ***
  !
  EP(1:NK)=0.0
  SIGP(1:NL)=SIGS

  DO I=NK+1,NL
    TCA=TP(I)-273.15
    IF(TCA.GE.0.0)THEN
      ELACRIT=ELCRIT
    ELSE
      ELACRIT=ELCRIT*(1.0-TCA/TLCRIT)
    END IF
    ELACRIT=MAX(ELACRIT,0.0)
    EPMAX=0.999
    EP(I)=EPMAX*(1.0-ELACRIT/MAX(CLW(I),1.0E-8))
    EP(I)=MAX(EP(I),0.0)
    EP(I)=MIN(EP(I),EPMAX)
    SIGP(I)=SIGS
  END DO
  ! LB 04.05.2021, replace above with array operations 
  ! (this makes it less readable, and not any faster)
  ! PROBLEM 1 is within the statement below
  ! EPMAX=0.999
  ! where ((TP(NK+1:NL)-273.15).ge.0.0)
  !   EP(NK+1:NL)=EPMAX*(1.0-max(ELCRIT, 0.0)/MAX(CLW(NK+1:NL),1.0E-8))
  ! elsewhere
  !   EP(NK+1:NL)=EPMAX*(1.0-max(ELCRIT*(1.0-TCA/TLCRIT), 0.0)/MAX(CLW(NK+1:NL),1.0E-8))
  ! end where
  ! where (EP(NK+1:NL).lt.0.0)
  !   EP(NK+1:NL)=0.0
  ! elsewhere (EP(NK+1:NL).gt.EPMAX)
  !   EP(NK+1:NL)=EPMAX
  ! end where

  !
  !   ***       CALCULATE VIRTUAL TEMPERATURE AND LIFTED PARCEL     ***
  !   ***                    VIRTUAL TEMPERATURE                    ***
  ! !
  TVP(ICB+1:NL)=TVP(ICB+1:NL)-TP(ICB+1:NL)*qconv(NK,ithread)
  TVP(NL+1)=TVP(NL)-(GZ(NL+1)-GZ(NL))/CPD
  !
  !   ***        NOW INITIALIZE VARIOUS ARRAYS USED IN THE COMPUTATIONS       ***

  HP(:NL+1)=H(:NL+1)
  NENT(:NL+1)=0
  WATER(:NL+1)=0.0
  EVAP(:NL+1)=0.0
  WT(:NL+1)=OMTSNOW
  LVCP(:NL+1)=LV(:NL+1)/CPN(:NL+1)
  ELIJ(:NL+1,:NL+1)=0.0
  SIJ(:NL+1,:NL+1)=0.0
  DO I=1,NL+1
    QENT(I,:NL+1)=qconv(:NL+1,ithread)
  END DO  
  QP(1)=qconv(1,ithread)
  QP(2:NL+1)=qconv(:NL,ithread)

  !
  !  ***  FIND THE FIRST MODEL LEVEL (INB1) ABOVE THE PARCEL'S      ***
  !  ***          HIGHEST LEVEL OF NEUTRAL BUOYANCY                 ***
  !  ***     AND THE HIGHEST LEVEL OF POSITIVE CAPE (INB)           ***
  !
  CAPE=0.0
  CAPEM=0.0
  INB=ICB+1
  INB1=INB
  BYP=0.0
  DO I=ICB+1,NL-1
    BY=(TVP(I)-TV(I))*(phconv_hpa(I,ithread)-phconv_hpa(I+1,ithread))/ &
      pconv_hpa(I,ithread)
    CAPE=CAPE+BY
    IF(BY.GE.0.0)INB1=I+1
    IF(CAPE.GT.0.0)THEN
      INB=I+1
      BYP=(TVP(I+1)-TV(I+1))*(phconv_hpa(I+1,ithread)-phconv_hpa(I+2,ithread))/ &
           pconv_hpa(I+1,ithread)
      CAPEM=CAPE
    END IF
  END DO
  INB=MAX(INB,INB1)
  CAPE=CAPEM+BYP
  DEFRAC=CAPEM-CAPE
  DEFRAC=MAX(DEFRAC,0.001)
  FRAC=-CAPE/DEFRAC
  FRAC=MIN(FRAC,1.0)
  FRAC=MAX(FRAC,0.0)
  !
  !   ***   CALCULATE LIQUID WATER STATIC ENERGY OF LIFTED PARCEL   ***
  !
  HP(ICB:INB)=H(NK)+(LV(ICB:INB)+(CPD-CPV)*tconv(ICB:INB,ithread))* &
    EP(ICB:INB)*CLW(ICB:INB)
  !
  !   ***  CALCULATE CLOUD BASE MASS FLUX AND RATES OF MIXING, M(I),  ***
  !   ***                   AT EACH MODEL LEVEL                       ***
  !
  
  !
  !   ***     INTERPOLATE DIFFERENCE BETWEEN LIFTED PARCEL AND      ***
  !   ***  ENVIRONMENTAL TEMPERATURES TO LIFTED CONDENSATION LEVEL  ***
  !
  TVPPLCL=TVP(ICB-1)-RD*TVP(ICB-1)*(pconv_hpa(ICB-1,ithread)-PLCL)/ &
       (CPN(ICB-1)*pconv_hpa(ICB-1,ithread))
  TVAPLCL=TV(ICB)+(TVP(ICB)-TVP(ICB+1))*(PLCL-pconv_hpa(ICB,ithread))/ &
       (pconv_hpa(ICB,ithread)-pconv_hpa(ICB+1,ithread))
  DTPBL=0.0

  DTPBL=sum((TVP(NK:ICB-1)-TV(NK:ICB-1))*(phconv_hpa(NK:ICB-1,ithread)- &
    phconv_hpa(NK+1:ICB,ithread)))/ &
    (phconv_hpa(NK,ithread)-phconv_hpa(ICB,ithread))
  DTMIN=TVPPLCL-TVAPLCL+DTMAX+DTPBL
  DTMA=DTMIN
  !
  !   ***  ADJUST CLOUD BASE MASS FLUX   ***
  !
  CBMFOLD=CBMF
  ! *** C. Forster: adjustment of CBMF is not allowed to depend on FLEXPART timestep
  DELT0=DELT/3.
  DAMPS=DAMP*DELT/DELT0
  CBMF=(1.-DAMPS)*CBMF+0.1*ALPHA*DTMA
  CBMF=MAX(CBMF,0.0)
  !
  !   *** If cloud base mass flux is zero, skip rest of calculation  ***
  !
  IF(CBMF.EQ.0.0.AND.CBMFOLD.EQ.0.0)THEN
    RETURN
  END IF

  !
  !   ***   CALCULATE RATES OF MIXING,  M(I)   ***
  M(ICB)=0.0
  M(ICB+1:INB1)=ABS(TV(ICB+1:INB1)-TVP(ICB+1:INB1))+ &
        ENTP*0.02*(phconv_hpa(ICB+1:INB1,ithread)-phconv_hpa(ICB+2:INB1+1,ithread))
  M(INB1:INB)=ABS(TV(INB1)-TVP(INB1))+ &
        ENTP*0.02*(phconv_hpa(INB1,ithread)-phconv_hpa(INB1+1,ithread))
  M(ICB+1:INB)=CBMF*M(ICB+1:INB)/sum(M(ICB+1:INB))

  !
  !   ***  CALCULATE ENTRAINED AIR MASS FLUX (MENT), TOTAL WATER MIXING  ***
  !   ***     RATIO (QENT), TOTAL CONDENSED WATER (ELIJ), AND MIXING     ***
  !   ***                        FRACTION (SIJ)                          ***
  !
  DO I=ICB+1,INB
    QTI=qconv(NK,ithread)-EP(I)*CLW(I)
    DO J=ICB,INB
      BF2=1.+LV(J)*LV(J)*qsconv(J,ithread)/(RV*tconv(J,ithread)*tconv(J,ithread)*CPD)
      ANUM=H(J)-HP(I)+(CPV-CPD)*tconv(J,ithread)*(QTI-qconv(J,ithread))
      DENOM=H(I)-HP(I)+(CPD-CPV)*(qconv(I,ithread)-QTI)*tconv(J,ithread)
      DEI=DENOM
      IF(ABS(DEI).LT.0.01)DEI=0.01
      SIJ(I,J)=ANUM/DEI
      SIJ(I,I)=1.0
      ALTEM=SIJ(I,J)*qconv(I,ithread)+(1.-SIJ(I,J))*QTI-qsconv(J,ithread)
      ALTEM=ALTEM/BF2
      CWAT=CLW(J)*(1.-EP(J))
      STEMP=SIJ(I,J)
      IF((STEMP.LT.0.0.OR.STEMP.GT.1.0.OR. &
            ALTEM.GT.CWAT).AND.J.GT.I)THEN
        ANUM=ANUM-LV(J)*(QTI-qsconv(J,ithread)-CWAT*BF2)
        DENOM=DENOM+LV(J)*(qconv(I,ithread)-QTI)
        IF(ABS(DENOM).LT.0.01)DENOM=0.01
        SIJ(I,J)=ANUM/DENOM
        ALTEM=SIJ(I,J)*qconv(I,ithread)+(1.-SIJ(I,J))*QTI-qsconv(J,ithread)
        ALTEM=ALTEM-(BF2-1.)*CWAT
      END IF
      IF(SIJ(I,J).GT.0.0.AND.SIJ(I,J).LT.0.9)THEN
        QENT(I,J)=SIJ(I,J)*qconv(I,ithread)+(1.-SIJ(I,J))*QTI
        ELIJ(I,J)=ALTEM
        ELIJ(I,J)=MAX(0.0,ELIJ(I,J))
        MENT(I,J)=M(I)/(1.-SIJ(I,J))
        NENT(I)=NENT(I)+1
      END IF
      SIJ(I,J)=MAX(0.0,SIJ(I,J))
      SIJ(I,J)=MIN(1.0,SIJ(I,J))
    END DO
  !
  !   ***   IF NO AIR CAN ENTRAIN AT LEVEL I ASSUME THAT UPDRAFT DETRAINS  ***
  !   ***   AT THAT LEVEL AND CALCULATE DETRAINED AIR FLUX AND PROPERTIES  ***
  !
    IF(NENT(I).EQ.0)THEN
      MENT(I,I)=M(I)
      QENT(I,I)=qconv(NK,ithread)-EP(I)*CLW(I)
      ELIJ(I,I)=CLW(I)
      SIJ(I,I)=1.0
    END IF
  END DO
  SIJ(INB,INB)=1.0
  ! LB 04.05.2021, Attempt to array the loop above: PROBLEM 2 is here
  ! DO J=ICB,INB
  !   BF2=1.+LV(J)*LV(J)*qsconv(J)/(RV*tconv(J)*tconv(J)*CPD)
  !   CWAT=CLW(J)*(1.-EP(J))
  !   DO I=ICB+1,INB
  !     QTI=qconv(NK)-EP(I)*CLW(I)
  !     ANUM=H(J)-HP(I)+(CPV-CPD)*tconv(J)*(QTI-qconv(J))
  !     DENOM=H(I)-HP(I)+(CPD-CPV)*(qconv(I)-QTI)*tconv(J)
  !     DEI=DENOM
  !     IF(I.EQ.J)THEN
  !       SIJ(I,I)=1.0
  !     ELSE IF(ABS(DENOM).LT.0.01)THEN
  !       SIJ(I,J)=ANUM/0.01
  !     ELSE
  !       SIJ(I,J)=ANUM/DENOM
  !     END IF
  !     ALTEM=(SIJ(I,J)*qconv(I)+(1.-SIJ(I,J))*QTI-qsconv(J))/BF2
  !     IF((SIJ(I,J).LT.0.0.OR.SIJ(I,J).GT.1.0.OR. &
  !           ALTEM.GT.CWAT).AND.J.GT.I)THEN
  !       ANUM=ANUM-LV(J)*(QTI-qsconv(J)-CWAT*BF2)
  !       DENOM=DENOM+LV(J)*(qconv(I)-QTI)
  !       IF(ABS(DENOM).LT.0.01)DENOM=0.01
  !       SIJ(I,J)=ANUM/DENOM
  !       ALTEM=SIJ(I,J)*qconv(I)+(1.-SIJ(I,J))*QTI-qsconv(J)
  !       ALTEM=ALTEM-(BF2-1.)*CWAT
  !     END IF
  !     IF(SIJ(I,J).GT.0.0.AND.SIJ(I,J).LT.0.9)THEN
  !       QENT(I,J)=SIJ(I,J)*qconv(I)+(1.-SIJ(I,J))*QTI
  !       ELIJ(I,J)=ALTEM
  !       ELIJ(I,J)=MAX(0.0,ELIJ(I,J))
  !       MENT(I,J)=M(I)/(1.-SIJ(I,J))
  !       NENT(I)=NENT(I)+1
  !     END IF
  !     SIJ(I,J)=MAX(0.0,SIJ(I,J))
  !     SIJ(I,J)=MIN(1.0,SIJ(I,J))
  !   END DO
  ! END DO
  ! !
  ! !   ***   IF NO AIR CAN ENTRAIN AT LEVEL I ASSUME THAT UPDRAFT DETRAINS  ***
  ! !   ***   AT THAT LEVEL AND CALCULATE DETRAINED AIR FLUX AND PROPERTIES  ***
  ! !
  ! do I=ICB+1,INB
  !   IF(NENT(I).EQ.0)THEN
  !     MENT(I,I)=M(I)
  !     QENT(I,I)=qconv(NK)-EP(I)*CLW(I)
  !     ELIJ(I,I)=CLW(I)
  !     SIJ(I,I)=1.0
  !   END IF
  ! END DO
  ! SIJ(INB,INB)=1.0


  !
  !   ***  NORMALIZE ENTRAINED AIR MASS FLUXES TO REPRESENT EQUAL  ***
  !   ***              PROBABILITIES OF MIXING                     ***
  !
  ! LB 04.05.2021, depending on how often NENT.ne.0, reversing the loop could
  ! speed it up...
  DO I=ICB+1,INB
    IF(NENT(I).NE.0)THEN
      QP1=qconv(NK,ithread)-EP(I)*CLW(I)
      ANUM=H(I)-HP(I)-LV(I)*(QP1-qsconv(I,ithread))
      DENOM=H(I)-HP(I)+LV(I)*(qconv(I,ithread)-QP1)
      IF(ABS(DENOM).LT.0.01)DENOM=0.01
      SCRIT=ANUM/DENOM
      ALT=QP1-qsconv(I,ithread)+SCRIT*(qconv(I,ithread)-QP1)
      IF(ALT.LT.0.0)SCRIT=1.0
      SCRIT=MAX(SCRIT,0.0)
      ASIJ=0.0
      SMIN=1.0
      DO J=ICB,INB
        IF(SIJ(I,J).GT.0.0.AND.SIJ(I,J).LT.0.9)THEN
          IF(J.GT.I)THEN
            SMID=MIN(SIJ(I,J),SCRIT)
            SJMAX=SMID
            SJMIN=SMID
            IF(SMID.LT.SMIN.AND.SIJ(I,J+1).LT.SMID)THEN
              SMIN=SMID
              SJMAX=MIN(SIJ(I,J+1),SIJ(I,J),SCRIT)
              SJMIN=MAX(SIJ(I,J-1),SIJ(I,J))
              SJMIN=MIN(SJMIN,SCRIT)
            END IF
          ELSE
            SJMAX=MAX(SIJ(I,J+1),SCRIT)
            SMID=MAX(SIJ(I,J),SCRIT)
            SJMIN=0.0
            IF(J.GT.1)SJMIN=SIJ(I,J-1)
            SJMIN=MAX(SJMIN,SCRIT)
          END IF
          DELP=ABS(SJMAX-SMID)
          DELM=ABS(SJMIN-SMID)
          ASIJ=ASIJ+(DELP+DELM)*(phconv_hpa(J,ithread)-phconv_hpa(J+1,ithread))
          MENT(I,J)=MENT(I,J)*(DELP+DELM)* &
               (phconv_hpa(J,ithread)-phconv_hpa(J+1,ithread))
        END IF
      END DO
      ASIJ=MAX(1.0E-21,ASIJ)
      ASIJ=1.0/ASIJ
      DO J=ICB,INB
        MENT(I,J)=MENT(I,J)*ASIJ
      END DO
      BSUM=0.0
      DO J=ICB,INB
        BSUM=BSUM+MENT(I,J)
      END DO
      IF(BSUM.LT.1.0E-18)THEN
        NENT(I)=0
        MENT(I,I)=M(I)
        QENT(I,I)=qconv(NK,ithread)-EP(I)*CLW(I)
        ELIJ(I,I)=CLW(I)
        SIJ(I,I)=1.0
      END IF
    END IF
  END DO

  !
  !   ***  CHECK WHETHER EP(INB)=0, IF SO, SKIP PRECIPITATING    ***
  !   ***             DOWNDRAFT CALCULATION                      ***
  !
  if (EP(INB).ge.0.0001) then
    !
    !   ***  INTEGRATE LIQUID WATER EQUATION TO FIND CONDENSED WATER   ***
    !   ***                AND CONDENSED WATER FLUX                    ***
    !
    JTT=2
    !
    !    ***                    BEGIN DOWNDRAFT LOOP                    ***
    !
    DO I=INB,1,-1
    !
    !    ***              CALCULATE DETRAINED PRECIPITATION             ***
    !
      WDTRAIN=G*EP(I)*M(I)*CLW(I)
      IF(I.GT.1)THEN
        DO J=1,I-1
          AWAT=ELIJ(J,I)-(1.-EP(I))*CLW(I)
          AWAT=MAX(0.0,AWAT)
          WDTRAIN=WDTRAIN+G*AWAT*MENT(J,I)
        END DO
      END IF
    !
    !    ***    FIND RAIN WATER AND EVAPORATION USING PROVISIONAL   ***
    !    ***              ESTIMATES OF QP(I)AND QP(I-1)             ***
    !
    !
    !  ***  Value of terminal velocity and coefficient of evaporation for snow   ***
    !
      COEFF=COEFFS
      WT(I)=OMTSNOW
    !
    !  ***  Value of terminal velocity and coefficient of evaporation for rain   ***
    !
      IF(tconv(I,ithread).GT.273.0)THEN
        COEFF=COEFFR
        WT(I)=OMTRAIN
      END IF
      QSM=0.5*(qconv(I,ithread)+QP(I+1))
      AFAC=COEFF*phconv_hpa(I,ithread)*(qsconv(I,ithread)-QSM)/ &
           (1.0E4+2.0E3*phconv_hpa(I,ithread)*qsconv(I,ithread))
      AFAC=MAX(AFAC,0.0)
      SIGT=SIGP(I)
      SIGT=MAX(0.0,SIGT)
      SIGT=MIN(1.0,SIGT)
      B6=100.*(phconv_hpa(I,ithread)-phconv_hpa(I+1,ithread))*SIGT*AFAC/WT(I)
      C6=(WATER(I+1)*WT(I+1)+WDTRAIN/SIGD)/WT(I)
      REVAP=0.5*(-B6+SQRT(B6*B6+4.*C6))
      EVAP(I)=SIGT*AFAC*REVAP
      WATER(I)=REVAP*REVAP
    !
    !    ***  CALCULATE PRECIPITATING DOWNDRAFT MASS FLUX UNDER     ***
    !    ***              HYDROSTATIC APPROXIMATION                 ***
    !
      if (.not. I.eq.1) then
        DHDP=(H(I)-H(I-1))/(pconv_hpa(I-1,ithread)-pconv_hpa(I,ithread))
        DHDP=MAX(DHDP,10.0)
        MP(I)=100.*GINV*LV(I)*SIGD*EVAP(I)/DHDP
        MP(I)=MAX(MP(I),0.0)
      !
      !   ***   ADD SMALL AMOUNT OF INERTIA TO DOWNDRAFT              ***
      !
        FAC=20.0/(phconv_hpa(I-1,ithread)-phconv_hpa(I,ithread))
        MP(I)=(FAC*MP(I+1)+MP(I))/(1.+FAC)
      !
      !    ***      FORCE MP TO DECREASE LINEARLY TO ZERO                 ***
      !    ***      BETWEEN ABOUT 950 MB AND THE SURFACE                  ***
      !
        IF(pconv_hpa(I,ithread).GT.(0.949*pconv_hpa(1,ithread)))THEN
          JTT=MAX(JTT,I)
          MP(I)=MP(JTT)*(pconv_hpa(1,ithread)-pconv_hpa(I,ithread))/(pconv_hpa(1,ithread)- &
              pconv_hpa(JTT,ithread))
        END IF
      endif
    !
    !    ***       FIND MIXING RATIO OF PRECIPITATING DOWNDRAFT     ***
    !
      if (.not. I.eq.INB) then
        IF(I.EQ.1)THEN
          QSTM=qsconv(1,ithread)
        ELSE
          QSTM=qsconv(I-1,ithread)
        END IF
        IF(MP(I).GT.MP(I+1))THEN
          RAT=MP(I+1)/MP(I)
          QP(I)=QP(I+1)*RAT+qconv(I,ithread)*(1.0-RAT)+100.*GINV* &
               SIGD*(phconv_hpa(I,ithread)-phconv_hpa(I+1,ithread))*(EVAP(I)/MP(I))
         ELSE
          IF(MP(I+1).GT.0.0)THEN
            QP(I)=(GZ(I+1)-GZ(I)+QP(I+1)*(LV(I+1)+tconv(I+1,ithread)*(CL-CPD))+ &
              CPD*(tconv(I+1,ithread)-tconv(I,ithread)))/ &
              (LV(I)+tconv(I,ithread)*(CL-CPD))
          END IF
        END IF
        QP(I)=MIN(QP(I),QSTM)
        QP(I)=MAX(QP(I),0.0)
      endif
    END DO
    !
    !   ***  CALCULATE SURFACE PRECIPITATION IN MM/DAY     ***
    !
    PRECIP=PRECIP+WT(1)*SIGD*WATER(1)*3600.*24000./(ROWL*G)
    !
  endif ! Downdraft calculation
  !
  !   ***  CALCULATE DOWNDRAFT VELOCITY SCALE AND SURFACE TEMPERATURE AND  ***
  !   ***                    WATER VAPOR FLUCTUATIONS                      ***
  !
  WD=BETA*ABS(MP(ICB))*0.01*RD*tconv(ICB,ithread)/(SIGD*pconv_hpa(ICB,ithread))
  QPRIME=0.5*(QP(1)-qconv(1,ithread))
  TPRIME=LV0*QPRIME/CPD
  !
  !   ***  CALCULATE TENDENCIES OF LOWEST LEVEL POTENTIAL TEMPERATURE  ***
  !   ***                      AND MIXING RATIO                        ***
  !

  DPINV=0.01/(phconv_hpa(1,ithread)-phconv_hpa(2,ithread))
  AM=0.0
  IF(NK.EQ.1)THEN
    AM = sum(M(2:INB))
  END IF
  ! save saturated upward mass flux for first level
  FUP(1)=AM
  IF((2.*G*DPINV*AM).GE.DELTI)IFLAG=4
  FT(1)=FT(1)+G*DPINV*AM*(tconv(2,ithread)-tconv(1,ithread)+(GZ(2)-GZ(1))/CPN(1))
  FT(1)=FT(1)-LVCP(1)*SIGD*EVAP(1)
  FT(1)=FT(1)+SIGD*WT(2)*(CL-CPD)*WATER(2)*(tconv(2,ithread)- &
       tconv(1,ithread))*DPINV/CPN(1)
  FQ(1)=FQ(1)+G*MP(2)*(QP(2)-qconv(1,ithread))* &
       DPINV+SIGD*EVAP(1)
  FQ(1)=FQ(1)+G*AM*(qconv(2,ithread)-qconv(1,ithread))*DPINV

  FQ(1)=FQ(1)+G*DPINV*sum(MENT(2:INB,1)*(QENT(2:INB,1)-qconv(1,ithread)))
  !
  !   ***  CALCULATE TENDENCIES OF POTENTIAL TEMPERATURE AND MIXING RATIO  ***
  !   ***               AT LEVELS ABOVE THE LOWEST LEVEL                   ***
  !
  !   ***  FIRST FIND THE NET SATURATED UPDRAFT AND DOWNDRAFT MASS FLUXES  ***
  !   ***                      THROUGH EACH LEVEL                          ***
  !
  DO I=2,INB
    DPINV=0.01/(phconv_hpa(I,ithread)-phconv_hpa(I+1,ithread))
    CPINV=1.0/CPN(I)
    AMP1=0.0
    AD=0.0
    IF(I.GE.NK)THEN
      AMP1 = sum(M(I+1:INB+1))
    END IF
    AMP1 = AMP1 + sum(MENT(1:I,I+1:INB+1))
  ! save saturated upward mass flux
    FUP(I)=AMP1
    IF((2.*G*DPINV*AMP1).GE.DELTI)IFLAG=4

    AD = sum(MENT(I:INB,1:I-1))
  ! save saturated downward mass flux
    FDOWN(I)=AD
    FT(I)=FT(I)+G*DPINV*(AMP1*(tconv(I+1,ithread)-tconv(I,ithread)+(GZ(I+1)-GZ(I))* &
         CPINV)-AD*(tconv(I,ithread)-tconv(I-1,ithread)+(GZ(I)-GZ(I-1))*CPINV)) &
         -SIGD*LVCP(I)*EVAP(I)
    FT(I)=FT(I)+G*DPINV*MENT(I,I)*(HP(I)-H(I)+ &
         tconv(I,ithread)*(CPV-CPD)*(qconv(I,ithread)-QENT(I,I)))*CPINV
    FT(I)=FT(I)+SIGD*WT(I+1)*(CL-CPD)*WATER(I+1)* &
         (tconv(I+1,ithread)-tconv(I,ithread))*DPINV*CPINV
    FQ(I)=FQ(I)+G*DPINV*(AMP1*(qconv(I+1,ithread)-qconv(I,ithread))- &
         AD*(qconv(I,ithread)-qconv(I-1,ithread)))
    DO K=1,I-1
      AWAT=ELIJ(K,I)-(1.-EP(I))*CLW(I)
      AWAT=MAX(AWAT,0.0)
      FQ(I)=FQ(I)+G*DPINV*MENT(K,I)*(QENT(K,I)-AWAT-qconv(I,ithread))
    END DO

    FQ(I)=FQ(I)+G*DPINV*sum(MENT(I:INB,I)*(QENT(I:INB,I)-qconv(I,ithread)))
    FQ(I)=FQ(I)+SIGD*EVAP(I)+G*(MP(I+1)* &
         (QP(I+1)-qconv(I,ithread))-MP(I)*(QP(I)-qconv(I-1,ithread)))*DPINV
  END DO
  !
  !   *** Adjust tendencies at top of convection layer to reflect  ***
  !   ***       actual position of the level zero CAPE             ***
  !
  FQOLD=FQ(INB)
  FQ(INB)=FQ(INB)*(1.-FRAC)
  FQ(INB-1)=FQ(INB-1)+FRAC*FQOLD*((phconv_hpa(INB,ithread)- &
       phconv_hpa(INB+1,ithread))/ &
       (phconv_hpa(INB-1,ithread)-phconv_hpa(INB,ithread)))*LV(INB)/LV(INB-1)
  FTOLD=FT(INB)
  FT(INB)=FT(INB)*(1.-FRAC)
  FT(INB-1)=FT(INB-1)+FRAC*FTOLD*((phconv_hpa(INB,ithread)- &
       phconv_hpa(INB+1,ithread))/ &
       (phconv_hpa(INB-1,ithread)-phconv_hpa(INB,ithread)))*CPN(INB)/CPN(INB-1)
!
!   ***   Very slightly adjust tendencies to force exact   ***
!   ***     enthalpy, momentum and tracer conservation     ***
!
  ENTS=0.0

  ENTS = sum((CPN(1:INB)*FT(1:INB)+LV(1:INB)*FQ(1:INB))* &
        (phconv_hpa(1:INB,ithread)-phconv_hpa(2:INB+1,ithread)))

  ENTS=ENTS/(phconv_hpa(1,ithread)-phconv_hpa(INB+1,ithread))

  FT(1:INB)=FT(1:INB) - ENTS/CPN(1:INB)

  ! ************************************************
  ! **** DETERMINE MASS DISPLACEMENT MATRIX
  ! ***** AND COMPENSATING SUBSIDENCE
  ! ************************************************

  ! mass displacement matrix due to saturated up-and downdrafts
  ! inside the cloud and determine compensating subsidence
  ! FUP(I) (saturated updrafts), FDOWN(I) (saturated downdrafts) are assumed to be
  ! balanced by  compensating subsidence (SUB(I))
  ! FDOWN(I) and SUB(I) defined positive downwards

  ! nconvtop IS THE TOP LEVEL AT WHICH CONVECTIVE MASS FLUXES ARE DIAGNOSED
  ! EPSILON IS A SMALL NUMBER

  fmass(NK, :INB+1,ithread) = fmass(NK,:INB+1,ithread)+M(:INB+1)
  fmass(:INB+1,:INB+1,ithread) = fmass(:INB+1,:INB+1,ithread)+MENT(:INB+1,:INB+1)
  sub(1,ithread) = 0.
  sub(2:INB+1,ithread) = FUP(1:INB) - FDOWN(2:INB+1)
  nconvtop=1
  do i=1,INB+1
    do j=1,INB+1
      if (fmass(j,i,ithread).gt.EPSILON) nconvtop=MAX(nconvtop,i,j)
    end do
  end do
  if (nconvtop.lt.nconvlevmax-1) then 
    nconvtop=nconvtop+1
  else
    error stop 'Convection reaches top level of input data. &
      More levels are needed.'
  end if
  RETURN
  !
END SUBROUTINE CONVECT
!
! ---------------------------------------------------------------------------
!
SUBROUTINE TLIFT(GZ,ICB,NK,TVP,TPK,CLW,ND,NL,KK, ithread)
  !
  !-cv
  use par_mod

  implicit none
  !-cv
  !====>Begin Module TLIFT      File convect.f      Undeclared variables
  !
  !Argument variables
  !
  integer, intent(in) :: ithread
  integer :: icb, kk, nd, nk, nl
  !
  !Local variables
  !
  integer :: i, j, nsb, nst
  !
  real :: ah0, ahg, alv, cpinv, cpp, denom
  real :: es, qg, rg, s, tc, tg
  !
  !====>End Module   TLIFT      File convect.f

  REAL :: GZ(ND),TPK(ND),CLW(ND)
  REAL :: TVP(ND)
  !
  !   ***   ASSIGN VALUES OF THERMODYNAMIC CONSTANTS     ***
  !
  REAL,PARAMETER :: CPD=1005.7
  REAL,PARAMETER :: CPV=1870.0
  REAL,PARAMETER :: CL=2500.0
  REAL,PARAMETER :: RV=461.5
  REAL,PARAMETER :: RD=287.04
  REAL,PARAMETER :: LV0=2.501E6
  !
  REAL,PARAMETER :: CPVMCL=CL-CPV
  REAL,PARAMETER :: EPS0=RD/RV
  REAL,PARAMETER :: EPSI=1./EPS0
  !
  !   ***  CALCULATE CERTAIN PARCEL QUANTITIES, INCLUDING STATIC ENERGY   ***
  !
  AH0=(CPD*(1.-qconv(NK,ithread))+CL*qconv(NK,ithread))*tconv(NK,ithread)+ &
    qconv(NK,ithread)*(LV0-CPVMCL*(tconv(NK,ithread)-273.15))+GZ(NK)
  CPP=CPD*(1.-qconv(NK,ithread))+qconv(NK,ithread)*CPV
  CPINV=1./CPP
  !
  IF(KK.EQ.1)THEN
  !
  !   ***   CALCULATE LIFTED PARCEL QUANTITIES BELOW CLOUD BASE   ***
  !
    CLW(1:ICB-1) = 0.0
    TPK(NK:ICB-1)=tconv(NK,ithread)-(GZ(NK:ICB-1)-GZ(NK))*CPINV
    TVP(NK:ICB-1)=TPK(NK:ICB-1)*(1.+qconv(NK,ithread)*EPSI)
  END IF
  !
  !    ***  FIND LIFTED PARCEL QUANTITIES ABOVE CLOUD BASE    ***
  !
  NST=ICB
  NSB=ICB
  IF(KK.EQ.2)THEN
    NST=NL
    NSB=ICB+1
  END IF
  DO I=NSB,NST
    TG=tconv(I,ithread)
    QG=qsconv(I,ithread)
    ALV=LV0-CPVMCL*(tconv(I,ithread)-273.15)
    DO J=1,2
      S=CPD+ALV*ALV*QG/(RV*tconv(I,ithread)*tconv(I,ithread))
      S=1./S
      AHG=CPD*TG+(CL-CPD)*qconv(NK,ithread)*tconv(I,ithread)+ALV*QG+GZ(I)
      TG=TG+S*(AH0-AHG)
      TG=MAX(TG,35.0)
      TC=TG-273.15
      DENOM=243.5+TC
      IF(TC.GE.0.0)THEN
        ES=6.112*EXP(17.67*TC/DENOM)
      ELSE
        ES=EXP(23.33086-6111.72784/TG+0.15215*LOG(TG))
      END IF
      QG=EPS0*ES/(pconv_hpa(I,ithread)-ES*(1.-EPS0))
    END DO
    ALV=LV0-CPVMCL*(tconv(I,ithread)-273.15)
    TPK(I)=(AH0-(CL-CPD)*qconv(NK,ithread)*tconv(I,ithread)-GZ(I)-ALV*QG)/CPD
    CLW(I)=qconv(NK,ithread)-QG
    CLW(I)=MAX(0.0,CLW(I))
    RG=QG/(1.-qconv(NK,ithread))
    TVP(I)=TPK(I)*(1.+RG*EPSI)
  END DO
  RETURN
END SUBROUTINE TLIFT

end module conv_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  ! This module stores all meteorological input data and contains routines     *
  ! reading and allocating this data                                           *
  !                                                                            *
  ! L. Bakels 2023: Dynamical allocation of all windfields                     *
  !                                                                            *
  !*****************************************************************************

module windfields_mod
  use par_mod
  use com_mod
  use point_mod
  use pbl_profile_mod

  implicit none

 !******************************************************************************
 ! Variables associated with the ECMWF meteorological input data ("wind fields")
 !******************************************************************************

  integer ::            &
    numbwf                ! actual number of wind fields

  integer,allocatable,dimension(:) ::            &
    wftime         ! times relative to beginning time of wind fields [s]

  character(len=255),allocatable,dimension(:) :: &
    wfname        ! file names of wind fields

  ! Nested equivalents
  !*******************
  character(len=255),allocatable,dimension(:,:) :: &
    wfnamen                                          ! nested wind field names

  !Windfield parameters
  !********************
  integer :: nxmax,nymax,nuvzmax,nwzmax,nzmax !Size of windfield

  ! Fixed fields, unchangeable with time
  !*************************************
  real, allocatable,dimension(:,:) :: &
    oro,                              & ! orography of the ECMWF model
    excessoro,                        & ! excess orography mother domain
    lsm                                 ! land sea mask of the ECMWF model

  ! Nested fields, unchangeable with time
  !**************************************
  real, allocatable,dimension(:,:,:) :: &
    oron,                               & ! orography of the ECMWF model
    excessoron,                         & ! excess orography mother domain
    lsmn                                  ! land sea mask of the ECMWF model

  ! 3d fields necessary for eta coordinates option
  !************************************************
  real, allocatable,dimension(:,:,:,:) :: &
    uueta,vveta,                          & ! wind components on half model levels in x and y direction [m/s]
    wweta,                                & ! wind component on model levels in z direction [eta/s]
    uupoleta,vvpoleta,                    & ! wind components on half model levels in polar stereographic projection [m/s]
    tteta,                                & ! temperature data on half model levels [K]
    pveta,                                & ! potential vorticity on half model levels
    rhoeta,                               & ! air density on half model levels [kg/m3]
    prseta,                               & ! air pressure on half model levels
    drhodzeta,                            & ! vertical air density gradient on half model levels [kg/m2]
    !tvirtual,                             & ! Virtual temperature on half model levels
    etauvheight,etawheight                  ! Saved half model and model heights for ETA coordinate system [m]

  ! 3d fields
  !**********
  real, allocatable,dimension(:,:,:,:) :: &
    uu,vv,ww,                             & ! wind components in x,y and z direction [m/s]
    uupol,vvpol,                          & ! wind components in polar stereographic projection [m/s]
    tt,tth,                               & ! temperature data on internal and half model levels [K]
    qv,qvh,                               & ! specific humidity data on internal and half model levels (eta if 'ETA')
    pv,                                   & ! potential vorticity
    rho,                                  & ! air density [kg/m3]
    drhodz,                               & ! vertical air density gradient [kg/m2]
    pplev,                                & ! Pressure on half model levels
    prs,                                  & ! air pressure RLT
    rho_dry                                 ! dry air density RLT Only printed out in binary mode???

  ! Cloud properties
  !*****************************************
  real, allocatable,dimension(:,:,:,:) :: &
    clwc,                                 & ! liquid   [kg/kg] ZHG
    ciwc,                                 & ! ice      [kg/kg] ZHG
    clwch,                                & ! original eta level liquid [kg/kg] ZHG
    ciwch                                   ! original eta level ice [kg/kg] ZHG
  real, allocatable,dimension(:,:,:) ::   &
    ctwc                                    ! ESO: =icloud_stats(:,:,4,:) total cloud water content
  integer,allocatable,dimension(:,:,:) ::    & ! new scavenging AT 2021
    icloudbot,                            & ! cloud bottom height [m/eta]
    icloudtop                               ! cloud top [m/eta]

  ! 3d nested fields
  !*****************
  real,allocatable,dimension(:,:,:,:,:) :: &
    uun, vvn, wwn,                         & ! wind components in x,y and z direction [m/s]
    ttn, tthn,                             & ! temperature data on internal and half model levels [K]
    qvn, qvhn,                             & ! specific humidity data on internal and half model levels
    pvn,                                   & ! potential vorticity
    rhon,                                  & ! air density [kg/m3]
    prsn,                                   & ! air pressure RLT
    drhodzn                                  ! vertical air density gradient [kg/m2] 

  ! ETA equivalents
  real,allocatable,dimension(:,:,:,:,:) :: &
    uuetan,vvetan,                         & ! wind components on half model levels in x and y direction [m/s]
    wwetan,                                & ! wind component on model levels in z direction [eta/s]
    ttetan,                                & ! temperature data on half model levels [K]
    pvetan,                                & ! potential vorticity on half model levels
    rhoetan,                               & ! air density on half model levels [kg/m3]
    prsetan,                               & ! air pressure on half model levels
    drhodzetan,                            & ! vertical air density gradient on half model levels [kg/m2]
    !tvirtualn,                             & ! Virtual temperature on half model levels
    etauvheightn,etawheightn                 ! Saved half model and model heights for ETA coordinate system [m]


  ! Nested cloud properties
  real,allocatable,dimension(:,:,:,:,:) :: &
    clwcn,                                 & ! liquid   [kg/kg] ZHG
    ciwcn,                                 & ! ice      [kg/kg] ZHG
    clwchn,                                & ! original eta level liquid [kg/kg] ZHG
    ciwchn                                   ! original eta level ice [kg/kg] ZHG
  real,allocatable,dimension(:,:,:,:) ::   &
    ctwcn                                    ! ESO: =icloud_stats(:,:,4,:) total cloud water content
  integer,allocatable,dimension(:,:,:,:) :: & ! new scavenging AT 2021
    icloudbotn,                             & ! cloud bottom height [m/eta]
    icloudtopn                                ! cloud thickness [m/eta]

  ! 2d fields
  !**********
  real, allocatable,dimension(:,:,:,:) :: &
    ps,                                 & ! surface pressure
    sd,                                 & ! snow depth
    msl,                                & ! mean sea level pressure
    tcc,                                & ! total cloud cover
    u10,                                & ! 10 meter u
    v10,                                & ! 10 meter v
    tt2,                                & ! 2 meter temperature
    td2,                                & ! 2 meter dew point
    sshf,                               & ! surface sensible heat flux
    ssr,                                & ! surface solar radiation
    sfcstress,                          & ! surface stress
    ustar,                              & ! friction velocity [m/s]
    wstar,                              & ! convective velocity scale [m/s]
    hmix,                               & ! mixing height [m]
    tropopause,                         & ! altitude of thermal tropopause [m]
    oli                                   ! inverse Obukhov length (1/L) [m]

  ! 2d fields
  !**********
  real, allocatable,dimension(:,:,:,:,:) :: & ! newWetDepoScheme, extra precip dimension AT 2021
    lsprec,                                 & ! large scale total precipitation [mm/h]
    convprec                                  ! convective precipitation [mm/h]

  ! 2d nested fields
  !*******************
  real, allocatable,dimension(:,:,:,:,:) :: &
    psn,                                    & ! surface pressure
    sdn,                                    & ! snow depth
    msln,                                   & ! mean sea level pressure
    tccn,                                   & ! total cloud cover
    u10n,                                   & ! 10 meter u
    v10n,                                   & ! 10 meter v
    tt2n,                                   & ! 2 meter temperature
    td2n,                                   & ! 2 meter dew point
    sshfn,                                  & ! surface sensible heat flux
    ssrn,                                   & ! surface solar radiation
    sfcstressn,                             & ! surface stress
    ustarn,                                 & ! friction velocity [m/s]
    wstarn,                                 & ! convective velocity scale [m/s]
    hmixn,                                  & ! mixing height [m]
    tropopausen,                            & ! altitude of thermal tropopause [m]
    olin,                                   & ! inverse Obukhov length (1/L) [m]
    vdepn                                     !

  ! 2d fields
  !**********
  real, allocatable,dimension(:,:,:,:,:,:) :: & ! newWetDepoScheme, extra precip dimension AT 2021
    lsprecn,                                 & ! large scale total precipitation [mm/h]
    convprecn                                  ! convective precipitation [mm/h]

  integer :: metdata_format  ! storing the input data type (ECMWF/NCEP)

  !****************************************************************************
  ! Variables defining actual size and geographical location of the wind fields
  !****************************************************************************

  integer ::   &
    nx,ny,nz,  & ! actual dimensions of wind fields in x,y and z direction, respectively
    nxmin1,    & ! nx-1
    nymin1,    & ! ny-1
    nxfield,   & ! same as nx for limited area fields, but for global fields nx=nxfield+1
    nuvz,nwz,  & ! vertical dimension of original ECMWF data (u,v components/ w components(staggered grid))
    nmixz,     & ! number of levels up to maximum PBL height (3500 m)
    nlev_ec      ! number of levels ECMWF model
  real ::      &
    dxconst,   & ! auxiliary variables for utransform
    dyconst      ! auxiliary variables for vtransform
  integer :: nconvlevmax !maximum number of levels for convection
  integer :: na ! parameter used in Emanuel's convect subroutine

  !*************************************************
  ! Variables used for vertical model discretization
  !*************************************************
  real,allocatable,dimension(:) :: &
    height,                        & ! heights of all levels [m]
    wheight,                       & ! model level heights [m]
    uvheight,                      & ! half-model level heights [m]
    akm,bkm,                       & ! coefficients which regulate vertical discretization of ecmwf model levels
    akz,bkz,                       & ! model discretization coefficients at the centre of the layers
    aknew,bknew                      ! model discretization coefficients at the interpolated levels

  !*********************************************************************
  ! Variables characterizing size and location of the nested wind fields
  !*********************************************************************

  integer,allocatable,dimension(:) :: &
    nxn,nyn                             ! actual dimensions of nested wind fields in x and y direction
  real,allocatable,dimension(:) ::    &
    dxn,dyn,                          & ! grid distances in x,y direction for the nested grids
    xlon0n,                           & ! geographical longitude of lower left grid point of nested wind fields
    ylat0n                              ! geographical latitude of lower left grid point of nested wind fields

  !*************************************************
  ! Certain auxiliary variables needed for the nests
  !*************************************************

  real,allocatable,dimension(:) :: &
    xresoln,yresoln,               & ! Factors by which the resolutions in the nests
                                     ! are enhanced compared to mother grid
    xln,yln,xrn,yrn                  ! Corner points of nested grids in grid coordinates of mother grid

contains

subroutine detectformat

  !*****************************************************************************
  !                                                                            *
  !   This routine reads the 1st file with windfields to determine             *
  !   the format.                                                              *
  !                                                                            *
  !     Authors: M. Harustak                                                   *
  !                                                                            *
  !     6 May 2015                                                             *
  !                                                                            *
  !   Unified ECMWF and GFS builds                                             *
  !   Marian Harustak, 12.5.2017                                               *
  !     - Added routine to FP10 Flexpart distribution                          *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! fname                file name of file to check                            *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use class_gribfile_mod


  implicit none

  character(len=255) :: filename

  ! If no file is available
  if ( numbwf.le.0 ) then
    print*,'No wind file available'
    metdata_format = GRIBFILE_CENTRE_UNKNOWN
    return
  endif

  ! construct filename
  filename = path(3)(1:length(3)) // trim(wfname(1))
 
  ! get format
  metdata_format = gribfile_centre(TRIM(filename))
end subroutine detectformat

subroutine gridcheck_ecmwf

  !**********************************************************************
  !                                                                     *
  !             FLEXPART MODEL SUBROUTINE GRIDCHECK                     *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  !             AUTHOR:      G. WOTAWA                                  *
  !             DATE:        1997-08-06                                 *
  !             LAST UPDATE: 1997-10-10                                 *
  !                                                                     *
  !             Update:      1999-02-08, global fields allowed, A. Stohl*
  !             CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with *
  !                                 ECMWF grib_api                      *
  !             CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
  !                                 ECMWF grib_api                      *
  !                                                                     *
  !   Unified ECMWF and GFS builds                                      *
  !   Marian Harustak, 12.5.2017                                        *
  !     - Renamed from gridcheck to gridcheck_ecmwf                     *
  !                                                                     *
  !                                                                     *  
  !  Anne Tipka, Petra Seibert 2021-02: implement new interpolation     *
  !    for precipitation according to #295 using 2 additional fields    *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION:                                                        *
  !                                                                     *
  ! THIS SUBROUTINE DETERMINES THE GRID SPECIFICATIONS (LOWER LEFT      *
  ! LONGITUDE, LOWER LEFT LATITUDE, NUMBER OF GRID POINTS, GRID DIST-   *
  ! ANCE AND VERTICAL DISCRETIZATION OF THE ECMWF MODEL) FROM THE       *
  ! GRIB HEADER OF THE FIRST INPUT FILE. THE CONSISTANCY (NO CHANGES    *
  ! WITHIN ONE FLEXPART RUN) IS CHECKED IN THE ROUTINE "READWIND" AT    *
  ! ANY CALL.                                                           *
  !                                                                     *
  ! XLON0                geographical longitude of lower left gridpoint *
  ! YLAT0                geographical latitude of lower left gridpoint  *
  ! NX                   number of grid points x-direction              *
  ! NY                   number of grid points y-direction              *
  ! DX                   grid distance x-direction                      *
  ! DY                   grid distance y-direction                      *
  ! NUVZ                 number of grid points for horizontal wind      *
  !                      components in z direction                      *
  ! NWZ                  number of grid points for vertical wind        *
  !                      component in z direction                       *
  ! sizesouth, sizenorth give the map scale (i.e. number of virtual grid*
  !                      points of the polar stereographic grid):       *
  !                      used to check the CFL criterion                *
  ! UVHEIGHT(1)-         heights of gridpoints where u and v are        *
  ! UVHEIGHT(NUVZ)       given                                          *
  ! WHEIGHT(1)-          heights of gridpoints where w is given         *
  ! WHEIGHT(NWZ)                                                        *
  !                                                                     *
  !**********************************************************************

  use grib_api
  use cmapf_mod, only: stlmbr,stcm2p

  implicit none

  integer :: ifile
  integer :: iret
  integer :: igrib
  integer :: gotGrid,stat
  real(kind=4) :: xaux1,xaux2,yaux1,yaux2
  real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in
  integer :: gribVer,parCat,parNum,typSfc,valSurf,discipl,parId
  !HSO  end
  integer :: ix,jy,i,ifn,ifield,j,iumax,iwmax,numskip,size1,size2
  integer :: k ! (as k, is the level in ECWMF notation, top->bot)
  real :: sizesouth,sizenorth,xauxa

  integer :: istep, ipf ! istep=stepRange for precip field identification
  integer :: pcount ! counter for precipitation fields
  
  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  ! dimension of isec2 at least (22+n), where n is the number of parallels or
  ! meridians in a quasi-regular (reduced) Gaussian or lat/long grid

  ! dimension of zsec2 at least (10+nn), where nn is the number of vertical
  ! coordinate parameters

  real(kind=4),allocatable,dimension(:) :: zsec2
  real(kind=4),allocatable,dimension(:) :: zsec4
  ! AT PS replace isec1, isec2 arrays by scalar values because we don't need
  !    arrays anymore. isec1(X) -> isX, isec2(X) -> jsX  
  integer :: is6, js2, js3, js12
  character(len=1) :: opt

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'

  character(len=20) :: thisSubr = 'gridcheck_ecmwf'
  
  logical :: lstep(0:2), luseprec

  iumax=0
  iwmax=0
  
  ! AT defaults to identify precipitation interpolation algorithm
  luseprec=.false.
  lprecint=.false.
  lstep(:)=.false.
  pcount=0

  if(ideltas.gt.0) then
    ifn=1
  else
    ifn=numbwf
  endif
  !
  ! OPENING OF DATA FILE (GRIB CODE)
  !
  call grib_open_file(ifile,path(3)(1:length(3))//trim(wfname(ifn)),'r',iret)
  if (iret.ne.GRIB_SUCCESS) goto 999   ! ERROR DETECTED
  
  !turn on support for multi fields messages
  !call grib_multi_support_on

  gotGrid=0
  ifield=0
  do while(.true.)
    ifield=ifield+1
    
    ! reading messages from GRIB file
    !--------------------------------
    
    call grib_new_from_file(ifile,igrib,iret)
    if (iret.eq.GRIB_END_OF_FILE ) then
      exit   ! EOF DETECTED
    elseif (iret.ne.GRIB_SUCCESS) then
      goto 999   ! ERROR DETECTED
    endif

    !first see if we read GRIB1 or GRIB2
    call grib_get_int(igrib,'editionNumber',gribVer,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    ! AT stepRange is used to identify additional precip fields
    call grib_get_int(igrib,'stepRange',istep,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)

    if (gribVer.eq.1) then ! GRIB Edition 1

      ! read the grib1 identifiers
      call grib_get_int(igrib,'indicatorOfParameter',is6,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)
    
      call grib_get_int(igrib,'level',k,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      !change code for etadot to code for omega
      if (is6 .eq. 77) is6=135

    else  ! GRiB Edition 2

      !read the grib2 identifiers
      call grib_get_int(igrib,'discipline',discipl,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_int(igrib,'parameterCategory',parCat,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_int(igrib,'parameterNumber',parNum,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_int(igrib,'typeOfFirstFixedSurface',typSfc,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_int(igrib,'level',k,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_int(igrib,'paramId',parId,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      !convert to grib1 identifiers
      is6=-1
      if (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! T
        is6=130 
      elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 105) then ! U
        is6=131 
      elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 105) then ! V
        is6=132 
      elseif (parCat .eq. 1 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! Q
        is6=133 
      ! ESO Cloud water is in a) fields CLWC and CIWC, *or* b) field QC 
      elseif (parCat .eq. 1 .and. parNum .eq. 83 .and. typSfc .eq. 105) then ! clwc
        is6=246 
      elseif (parCat .eq. 1 .and. parNum .eq. 84 .and. typSfc .eq. 105) then ! ciwc
        is6=247 
      ! ESO qc(=clwc+ciwc):
      elseif (parCat .eq. 201 .and. parNum .eq. 31 .and. typSfc .eq. 105) then ! qc
        is6=201031 
      elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 1) then !SP
        is6=134 
      elseif (parCat .eq. 2 .and. parNum .eq. 32) then ! W, actually eta dot
        is6=135 
      elseif (parCat .eq. 128 .and. parNum .eq. 77) then ! W, actually eta dot
        is6=135 
      elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 101) then ! SLP
        is6=151 
      elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 103) then ! 10U
        is6=165 
      elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 103) then ! 10V
        is6=166 
      elseif (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 103) then ! 2T
        is6=167 
      elseif (parCat .eq. 0 .and. parNum .eq. 6 .and. typSfc .eq. 103) then ! 2D
        is6=168 
      elseif (parCat .eq. 1 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SD
        is6=141 
      elseif (parCat .eq. 6 .and. parNum .eq. 1 .or. parId .eq. 164) then ! CC
        is6=164 
      elseif (parCat .eq. 1 .and. parNum .eq. 9 .or. parId .eq. 142) then ! LSP
        is6=142 
      elseif (parCat .eq. 1 .and. parNum .eq. 10) then ! CP
        is6=143 
      elseif (parCat .eq. 0 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SHF
        is6=146 
      elseif (parCat .eq. 4 .and. parNum .eq. 9 .and. typSfc .eq. 1) then ! SR
        is6=176 
      elseif (parCat .eq. 2 .and. parNum .eq. 38 .or. parId .eq. 180) then ! EWSS --correct
        is6=180 
      elseif (parCat .eq. 2 .and. parNum .eq. 37 .or. parId .eq. 181) then ! NSSS --correct
        is6=181 
      elseif (parCat .eq. 3 .and. parNum .eq. 4) then ! ORO
        is6=129 
      elseif (parCat .eq. 3 .and. parNum .eq. 7 .or. parId .eq. 160) then ! SDO
        is6=160 
      elseif (discipl .eq. 2 .and. parCat .eq. 0 .and. parNum .eq. 0 .and. &
         typSfc .eq. 1) then ! LSM
        is6=172 
      elseif (parNum .eq. 152) then 
        is6=152         ! avoid warning for lnsp    
      else
        print*,'***WARNING: undefined GRiB2 message found!',discipl, &
             parCat,parNum,typSfc
      endif
      if (parId .ne. is6 .and. parId .ne. 77) write(*,*) 'parId',parId, 'is6',is6

    endif !gribVer

!    call grib_get_int(igrib,'numberOfPointsAlongAParallel',js2,iret)
!    if (js2 .gt. nxmax) THEN
!      write(*,*) 'FLEXPART error: Too many grid points in x direction.'
!      write(*,*) 'Reduce resolution of wind fields.'
!      write(*,*) 'Or change parameter settings in file par_mod.f90'
!      write(*,*) js2,nxmax
!      stop
!    endif

    ! AT, PS
    ! Identify how many precip fields are available per input time step 
    if (is6 .eq. 142 .or. is6 .eq. 143) then ! PRECIPITATION
      pcount=pcount+1
      lstep(istep)=.true.
      ipf=istep+1
      if (pcount .gt. 2) then ! additional precip field found
        if (numpf .eq. 1) then
          write(*,*) '*** ERROR: additional precip fields available        ***'
          write(*,*) '*** You must use them, set numpf=3 and recompile     ***'
          stop 'readwind_ecmwf: set numpf to 3 in par_mod.f90'
        elseif (ipf .le. numpf) then
          luseprec=.true.
        else
          write(*,*) '*** ERROR: unexpected value of numpf=',numpf,'         ***'
          write(*,*) '*** Set to 1 or 3 and recompile                        ***'
          stop 'readwind_ecmwf: numpf too small'
        endif
      else ! regular precip field
        luseprec=.true.
      endif
    endif

    if (ifield .eq. 1) then

      call grib_get_int(igrib,'numberOfPointsAlongAParallel',js2,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_int(igrib,'numberOfPointsAlongAMeridian',js3,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_int(igrib,'numberOfVerticalCoordinateValues',js12)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees',xaux1in,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      nxfield=js2
      ny=js3
      nlev_ec=js12/2-1
      ! call grib_get_size(igrib,'values',size1,iret)
      ! call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_size(igrib,'pv',size2,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      allocate(zsec2(size2), stat=stat)
      if (stat.ne.0) error stop "Could not allocate zsec2"
      call grib_get_real4_array(igrib,'pv',zsec2,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)
      
    endif  ! ifield

    !get the size and data of the values array
    if (is6.ne.-1) then
      ! LB: Within ecCodes, especially when moving from the grib_api to eccodes,
      ! memory is allocated within the function below when the input array is 
      ! dynamically allocated. This is why it needs to be allocated and 
      ! deallocated for every field to avoid unexpected behaviour.
      call grib_get_size(igrib,'values',size1,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)
      allocate(zsec4(size1), stat=stat)
      if (stat.ne.0) error stop "Could not allocate zsec4"
      call grib_get_real4_array(igrib,'values',zsec4,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)
    endif

    !HSO  get the second part of the grid dimensions only from GRiB1 messages
    if (is6 .eq. 167 .and. gotGrid .eq. 0) then

      call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees',xaux2in,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees',yaux1in,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      call grib_get_real8(igrib,'latitudeOfFirstGridPointInDegrees',yaux2in,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)
      
      xaux1=real(xaux1in)
      xaux2=real(xaux2in)
      yaux1=real(yaux1in)
      yaux2=real(yaux2in)
      if (xaux1.gt.180.) xaux1=xaux1-360.
      if (xaux2.gt.180.) xaux2=xaux2-360.
      if (xaux1.lt.-180.) xaux1=xaux1+360.
      if (xaux2.lt.-180.) xaux2=xaux2+360.
      if (xaux2.lt.xaux1) xaux2=xaux2+360.

      xlon0=xaux1
      ylat0=yaux1
      dx=(xaux2-xaux1)/real(nxfield-1)
      dy=(yaux2-yaux1)/real(ny-1)
      dxconst=180./(dx*r_earth*pi)
      dyconst=180./(dy*r_earth*pi)
      gotGrid=1
      
      !-------------------------------------------------------------
      ! Check whether fields are global
      ! If they contain the poles, specify polar stereographic map
      ! projections using the stlmbr- and stcm2p-calls
      !-------------------------------------------------------------

      xauxa=abs(xaux2+dx-360.-xaux1)
      if (xauxa.lt.0.001) then
        nx=nxfield+1                 ! field is cyclic
        xglobal=.true.
        if (abs(nxshift).ge.nx) &
          error stop 'nxshift in file par_mod is too large'
        xlon0=xlon0+real(nxshift)*dx
      else
        nx=nxfield
        xglobal=.false.
        if (nxshift.ne.0) &
          error stop 'nxshift (par_mod) must be zero for non-global domain'
      endif
      nxmin1=nx-1
      nymin1=ny-1
      if (xlon0.gt.180.) xlon0=xlon0-360.
      xauxa=abs(yaux1+90.)
      if (xglobal.and.xauxa.lt.0.001) then
        sglobal=.true.               ! field contains south pole
        ! Enhance the map scale by factor 3 (*2=6) compared to north-south
        ! map scale
        sizesouth=6.*(switchsouth+90.)/dy
        call stlmbr(southpolemap,-90.,0.)
        call stcm2p(southpolemap,0.,0.,switchsouth,0.,sizesouth, &
             sizesouth,switchsouth,180.)
        switchsouthg=(switchsouth-ylat0)/dy
      else
        sglobal=.false.
        switchsouthg=999999.
      endif
      xauxa=abs(yaux2-90.)
      if (xglobal.and.xauxa.lt.0.001) then
        nglobal=.true.               ! field contains north pole
        ! Enhance the map scale by factor 3 (*2=6) compared to north-south
        ! map scale
        sizenorth=6.*(90.-switchnorth)/dy
        call stlmbr(northpolemap,90.,0.)
        call stcm2p(northpolemap,0.,0.,switchnorth,0.,sizenorth, &
             sizenorth,switchnorth,180.)
        switchnorthg=(switchnorth-ylat0)/dy
      else
        nglobal=.false.
        switchnorthg=999999.
      endif
      if (nxshift.lt.0) &
        error stop 'nxshift (par_mod) must not be negative'
      if (nxshift.ge.nxfield) error stop 'nxshift (par_mod) too large'
    endif ! gotGrid

    ! if (nx.gt.nxmax) then
    !   write(*,*) 'FLEXPART error: Too many grid points in x direction.'
    !   write(*,*) 'Reduce resolution of wind fields.'
    !   write(*,*) 'Or change parameter settings in file par_mod.'
    !   write(*,*) nx,nxmax
    !   error stop
    ! endif

    ! if (ny.gt.nymax) then
    !   write(*,*) 'FLEXPART error: Too many grid points in y direction.'
    !   write(*,*) 'Reduce resolution of wind fields.'
    !   write(*,*) 'Or change parameter settings in file par_mod.'
    !   write(*,*) ny,nymax
    !   error stop
    ! endif

    if (is6 .eq. 131) iumax=max(iumax,nlev_ec-k+1)
    if (is6 .eq. 135) iwmax=max(iwmax,nlev_ec-k+1)

    if (is6 .eq. 167) then
      ! Asking grid values and allocate memory to read windfields
      nxmax=nxfield
      if (xglobal) then
        nxmax=nxfield+1
      endif
      nymax=ny
      nwzmax=iwmax+1
      nuvzmax=iumax+1
      nzmax=nuvzmax
      nconvlevmax=iumax
      na=nuvzmax
      ! Temporary nxmax and nymax
      call alloc_fixedfields
      write(*,*) 'grid dim:',nxmax,nymax,nwzmax,nuvzmax,nconvlevmax,na
    endif

    if(is6.eq.129) then
      do jy=0,ny-1
        do ix=0,nxfield-1
          oro(ix,jy)=zsec4(nxfield*(ny-jy-1)+ix+1)/ga
        end do
      end do
    endif
    if(is6.eq.172) then
      do jy=0,ny-1
        do ix=0,nxfield-1
          lsm(ix,jy)=zsec4(nxfield*(ny-jy-1)+ix+1)
        end do
      end do
    endif
    if(is6.eq.160) then
      do jy=0,ny-1
        do ix=0,nxfield-1
          excessoro(ix,jy)=zsec4(nxfield*(ny-jy-1)+ix+1)
        end do
      end do
    endif

    call grib_release(igrib)
    if (is6.ne.-1) deallocate( zsec4 )

  end do                      !! READ NEXT GRIB MESSAGE (LEVEL OR PARAMETER)

  !
  ! CLOSING OF INPUT DATA FILE
  !
  call grib_close_file(ifile)
  
  if (luseprec .eqv. .false.) &
     error stop "Conditions for precipitation interpolation not fulfilled! &
       Please check number of precipitation fields per type in GRIB files and &
       numpf parameter in par_mod.f90."
  
  ! save info for type of precipitation interpolation
  ! true if new interpolation / false for old interpolation 
  if ( all(lstep) ) lprecint=.true.

  ! Allocate memory for windfields
  !*******************************
  call alloc_windfields

  !error message if no fields found with correct first longitude in it
  if (gotGrid.eq.0) then
    print*,'***ERROR: input file needs to contain GRIB1 formatted messages'
    error stop
  endif

  nuvz=iumax
  nwz =iwmax
  if(nuvz.eq.nlev_ec) nwz=nlev_ec+1

  if (nuvz+1 .gt. nuvzmax) then
    write(*,*) 'FLEXPART error: Too many u,v grid points in z direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.f90'
    write(*,*) nuvz+1,nuvzmax
    stop
  endif

 if (nwz .gt. nwzmax) then
    write(*,*) 'FLEXPART error: Too many w grid points in z direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.f90'
    write(*,*) nwz,nwzmax
    error stop
  endif


  ! If desired, shift all grids by nxshift grid cells
  !**************************************************

  if (xglobal) then
    call shift_field_0(oro,nxfield,ny)
    call shift_field_0(lsm,nxfield,ny)
    call shift_field_0(excessoro,nxfield,ny)
  endif

  ! Output of grid info
  !********************
  write(*,'(a,2i7)') ' Vertical levels in ECMWF data: ', nuvz+1,nwz
  write(*,*)
  write(*,'(a)') ' Mother domain:'
  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Longitude range: ', &
        xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Latitude range : ', &
        ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
  write(*,*)

  ! Calculate vertical discretization of ECMWF model 
  ! Parameters akm,bkm describe the hybrid "ETA" coordinate system

  numskip=nlev_ec-nuvz  ! number of ecmwf model layers not used
 
  akm=0
  bkm=0
  akz=0
  bkz=0
  do i=1,nwz ! LB: should start counting from 0 to get the top level?
    akm(nwz-i+1)=zsec2(numskip+i)
    !   write (*,*) 'ifield:',ifield,k,j,zsec2(10+j)
    bkm(nwz-i+1)=zsec2(nlev_ec+1+numskip+i)
    wheight(nwz-i+1)=akm(nwz-i+1)/101325.+bkm(nwz-i+1) ! From FLEXTRA
  end do

  ! Calculation of AKZ, BKZ
  ! AKZ,BKZ: model discretization parameters at the center of each model layer
  !
  ! Assign the 10 m winds to an artificial model level with akz=0 and bkz=1.0,
  ! i.e. ground level
  !*****************************************************************************

  akz(1)=0.
  bkz(1)=1.
  uvheight(1)=1.
  do i=1,nuvz
    uvheight(i+1)=0.5*(wheight(i+1)+wheight(i)) ! From FLEXTRA
    akz(i+1)=0.5*(akm(i+1)+akm(i))
    bkz(i+1)=0.5*(bkm(i+1)+bkm(i))
  end do
  ! exuvheight=wheight
  nuvz=nuvz+1

  ! NOTE: In FLEXPART versions up to 4.0, the number of model levels was doubled
  ! upon the transformation to z levels. In order to save computer memory, this is
  ! not done anymore in the standard version. However, this option can still be
  ! switched on by replacing the following lines with those below, that are
  ! currently commented out. For this, similar changes are necessary in
  ! verttransform.f and verttranform_nest.f
  !*****************************************************************************

  nz=nuvz
  if (nz.gt.nzmax) error stop 'nzmax too small'
  do i=1,nuvz
    aknew(i)=akz(i)
    bknew(i)=bkz(i)
  end do

  deallocate( zsec2 )
  return

999 write(*,*)
  write(*,*) ' ################################################# '
  write(*,*) ' SUBROUTINE GRIDCHECK:'
  write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfname(ifn)
  write(*,*) ' ################################################# '

end subroutine gridcheck_ecmwf

subroutine gridcheck_gfs

  !**********************************************************************
  !                                                                     *
  !             FLEXPART MODEL SUBROUTINE GRIDCHECK                     *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  !             AUTHOR:      G. WOTAWA                                  *
  !             DATE:        1997-08-06                                 *
  !             LAST UPDATE: 1997-10-10                                 *
  !                                                                     *
  !             Update:      1999-02-08, global fields allowed, A. Stohl*
  !             CHANGE: 17/11/2005, Caroline Forster, GFS data          *
  !             CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with *
  !                                 ECMWF grib_api                      *
  !             CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
  !                                 ECMWF grib_api                      *
  !                                                                     *
  !   Unified ECMWF and GFS builds                                      *
  !   Marian Harustak, 12.5.2017                                        *
  !     - Renamed routine from gridcheck to gridcheck_gfs               *
  !                                                                     *
  !                                                                     *  
  !  Anne Tipka, Petra Seibert 2021-02: implement new interpolation     *
  !    for precipitation according to #295 using 2 additional fields    *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION:                                                        *
  !                                                                     *
  ! THIS SUBROUTINE DETERMINES THE GRID SPECIFICATIONS (LOWER LEFT      *
  ! LONGITUDE, LOWER LEFT LATITUDE, NUMBER OF GRID POINTS, GRID DIST-   *
  ! ANCE AND VERTICAL DISCRETIZATION OF THE ECMWF MODEL) FROM THE       *
  ! GRIB HEADER OF THE FIRST INPUT FILE. THE CONSISTANCY (NO CHANGES    *
  ! WITHIN ONE FLEXPART RUN) IS CHECKED IN THE ROUTINE "READWIND" AT    *
  ! ANY CALL.                                                           *
  !                                                                     *
  ! XLON0                geographical longitude of lower left gridpoint *
  ! YLAT0                geographical latitude of lower left gridpoint  *
  ! NX                   number of grid points x-direction              *
  ! NY                   number of grid points y-direction              *
  ! DX                   grid distance x-direction                      *
  ! DY                   grid distance y-direction                      *
  ! NUVZ                 number of grid points for horizontal wind      *
  !                      components in z direction                      *
  ! NWZ                  number of grid points for vertical wind        *
  !                      component in z direction                       *
  ! sizesouth, sizenorth give the map scale (i.e. number of virtual grid*
  !                      points of the polar stereographic grid):       *
  !                      used to check the CFL criterion                *
  ! UVHEIGHT(1)-         heights of gridpoints where u and v are        *
  ! UVHEIGHT(NUVZ)       given                                          *
  ! WHEIGHT(1)-          heights of gridpoints where w is given         *
  ! WHEIGHT(NWZ)                                                        *
  !                                                                     *
  !**********************************************************************

  use grib_api
  use cmapf_mod, only: stlmbr,stcm2p


  implicit none

  !HSO  parameters for grib_api
  integer :: ifile
  integer :: iret
  integer :: igrib,stat,size1
  real(kind=4) :: xaux1,xaux2,yaux1,yaux2
  real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in
  integer :: gribVer,parCat,parNum,typSfc,valSurf,discipl
  !HSO  end
  integer :: ix,jy,i,ifn,ifield,j,k,iumax,iwmax,numskip
  real :: sizesouth,sizenorth,xauxa
  real :: xsec18 !ip 
  real,allocatable,dimension(:) :: akm_usort,pres,tmppres
  real,parameter :: eps=0.0001

  ! NCEP GFS
  real :: help

  integer :: i179,i180,i181

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  integer :: isec1(8),isec2(3)
  real(kind=4),allocatable,dimension(:) :: zsec4
  character(len=1) :: opt

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: gribFunction = 'gridcheckwind_gfs'

!  real(kind=4),allocatable,dimension(:) :: zsec4
!  integer :: iret,size1,size2,stat



!
  if (numbnests.ge.1) then
  write(*,*) ' ###########################################'
  write(*,*) ' FLEXPART ERROR SUBROUTINE GRIDCHECK:'
  write(*,*) ' NO NESTED WINDFIELDAS ALLOWED FOR GFS!      '
  write(*,*) ' ###########################################'
  error stop
  endif

  iumax=0
  iwmax=0

  if(ideltas.gt.0) then
    ifn=1
  else
    ifn=numbwf
  endif
  !
  ! OPENING OF DATA FILE (GRIB CODE)
  !
5   call grib_open_file(ifile,path(3)(1:length(3)) &
         //trim(wfname(ifn)),'r',iret)
  if (iret.ne.GRIB_SUCCESS) then
    goto 999   ! ERROR DETECTED
  endif
  !turn on support for multi fields messages
  call grib_multi_support_on

  ifield=0
  do
    ifield=ifield+1
    !
    ! GET NEXT FIELDS
    !
    call grib_new_from_file(ifile,igrib,iret)
    if (iret.eq.GRIB_END_OF_FILE )  then
      exit    ! EOF DETECTED
    elseif (iret.ne.GRIB_SUCCESS) then
      goto 999   ! ERROR DETECTED
    endif

    !first see if we read GRIB1 or GRIB2
    call grib_get_int(igrib,'editionNumber',gribVer,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)

    if (gribVer.eq.1) then ! GRIB Edition 1

      !read the grib1 identifiers
      call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'indicatorOfTypeOfLevel',isec1(7),iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'level',isec1(8),iret)
      call grib_check(iret,gribFunction,gribErrorMsg)

      xsec18 = real(isec1(8))
      
    else ! GRIB Edition 2

      !read the grib2 identifiers
      call grib_get_int(igrib,'discipline',discipl,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'parameterCategory',parCat,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'parameterNumber',parNum,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'typeOfFirstFixedSurface',typSfc,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'scaledValueOfFirstFixedSurface', &
           valSurf,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)

      !convert to grib1 identifiers
      isec1(6)=-1
      isec1(7)=-1
      isec1(8)=-1
      xsec18 = -1.0
      
      if ((parCat.eq.2).and.(parNum.eq.2).and.(typSfc.eq.100)) then ! U
        isec1(6)=33          ! indicatorOfParameter
        isec1(7)=100         ! indicatorOfTypeOfLevel
        isec1(8)=valSurf/100 ! level, convert to hPa
        xsec18=valSurf/100.0 ! level, convert to hPa
        
      ! fixgfs11
      call grib_get_size(igrib,'values',size1,iret)
      allocate( zsec4(size1),stat=stat )
      if (stat.ne.0) error stop "Could not allocate zsec4"
      call grib_get_real4_array(igrib,'values',zsec4,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      !PRINT*,zsec4(1:15)
      !stop    'MIP2 in gridcheck' 
      deallocate(zsec4)
        
      elseif ((parCat.eq.3).and.(parNum.eq.5).and.(typSfc.eq.1)) then ! TOPO
        isec1(6)=7           ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
        xsec18=real(0)
        
      elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSfc.eq.1) &
           .and.(discipl.eq.2)) then ! LSM
        isec1(6)=81          ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
        xsec18=real(0)
      endif

    endif ! gribVer

    if(ifield.eq.1) then

      !get the required fields from section 2
      !store compatible to gribex input
      call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
           isec2(2),iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
           isec2(3),iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
           xaux1in,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees', &
           xaux2in,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
           yaux1in,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_real8(igrib,'latitudeOfFirstGridPointInDegrees', &
           yaux2in,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)



      ! Fix for flexpart.eu ticket #48
      if (xaux2in.lt.0) xaux2in = 359.0

      xaux1=real(xaux1in)
      xaux2=real(xaux2in)
      yaux1=real(yaux1in)
      yaux2=real(yaux2in)

      nxfield=isec2(2)
      ny=isec2(3)
      if((abs(xaux1).lt.eps).and.(xaux2.ge.359)) then ! NCEP DATA FROM 0 TO

        ! fixgfs11
        ! xaux1=-179.0                             ! 359 DEG EAST ->
        ! xaux2=-179.0+360.-360./real(nxfield)    ! TRANSFORMED TO -179
        ! reset to working v10 settings
        xaux1=-180.0                             ! 359 DEG EAST ->
        xaux2=-180.0+360.-360./real(nxfield)    ! TRANSFORMED TO -179
      endif                                      ! TO 180 DEG EAST

      if (xaux1.gt.180) xaux1=xaux1-360.0
      if (xaux2.gt.180) xaux2=xaux2-360.0
      if (xaux1.lt.-180) xaux1=xaux1+360.0
      if (xaux2.lt.-180) xaux2=xaux2+360.0
      if (xaux2.lt.xaux1) xaux2=xaux2+360.
      xlon0=xaux1
      ylat0=yaux1
      dx=(xaux2-xaux1)/real(nxfield-1)
      dy=(yaux2-yaux1)/real(ny-1)
      dxconst=180./(dx*r_earth*pi)
      dyconst=180./(dy*r_earth*pi)
      !HSO end edits


      ! Check whether fields are global
      ! If they contain the poles, specify polar stereographic map
      ! projections using the stlmbr- and stcm2p-calls
      !***********************************************************

      xauxa=abs(xaux2+dx-360.-xaux1)
      if (xauxa.lt.0.001) then
        nx=nxfield+1                 ! field is cyclic
        xglobal=.true.
        if (abs(nxshift).ge.nx) &
          error stop 'nxshift in file par_mod is too large'
        xlon0=xlon0+real(nxshift)*dx
      else
        nx=nxfield
        xglobal=.false.
        if (nxshift.ne.0) &
          error stop 'nxshift (par_mod) must be zero for non-global domain'
      endif
      nxmin1=nx-1
      nymin1=ny-1
      if (xlon0.gt.180.) xlon0=xlon0-360.
      xauxa=abs(yaux1+90.)
      if (xglobal.and.xauxa.lt.0.001) then
        sglobal=.true.               ! field contains south pole
    ! Enhance the map scale by factor 3 (*2=6) compared to north-south
    ! map scale
        sizesouth=6.*(switchsouth+90.)/dy
        call stlmbr(southpolemap,-90.,0.)
        call stcm2p(southpolemap,0.,0.,switchsouth,0.,sizesouth, &
             sizesouth,switchsouth,180.)
        switchsouthg=(switchsouth-ylat0)/dy
      else
        sglobal=.false.
        switchsouthg=999999.
      endif
      xauxa=abs(yaux2-90.)
      if (xglobal.and.xauxa.lt.0.001) then
        nglobal=.true.               ! field contains north pole
    ! Enhance the map scale by factor 3 (*2=6) compared to north-south
    ! map scale
        sizenorth=6.*(90.-switchnorth)/dy
        call stlmbr(northpolemap,90.,0.)
        call stcm2p(northpolemap,0.,0.,switchnorth,0.,sizenorth, &
             sizenorth,switchnorth,180.)
        switchnorthg=(switchnorth-ylat0)/dy
      else
        nglobal=.false.
        switchnorthg=999999.
      endif
      ! Set nxmax and nymax and allocate the fields for oro lsm and excessoro
      nxmax=nx
      nymax=ny
      call alloc_fixedfields

    endif ! ifield.eq.1

    if (nxshift.lt.0) error stop 'nxshift (par_mod) must not be negative'
    if (nxshift.ge.nxfield) error stop 'nxshift (par_mod) too large'

    if (isec1(6).ne.-1) then
    !  get the size and data of the values array
      !get the size and data of the values array
      call grib_get_size(igrib,'values',size1,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      allocate(zsec4(size1),stat=stat)
      if (stat.ne.0) error stop "Could not allocate zsec4"
      call grib_get_real4_array(igrib,'values',zsec4,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
    endif

    ! NCEP ISOBARIC LEVELS
    !*********************

    if((isec1(6).eq.33).and.(isec1(7).eq.100)) then ! check for U wind
      iumax=iumax+1
      ! fixgfs11 
      allocate( tmppres(iumax), stat=stat)
      if (stat.ne.0) error stop "Could not allocate tmppres"
      if (iumax.gt.1) tmppres(1:iumax-1)=pres
      !pres(iumax)=real(isec1(8))*100.0
      call move_alloc(tmppres,pres)
      pres(iumax)=xsec18*100.0 
      ! ip 30.1.24 fix vertical coordinate reading bug   
    endif

    ! fixgfs11 TODO: finish cleanup
    i179=nint(179./dx)
    if (dx.lt.0.7) then
      i180=nint(180./dx)+1    ! 0.5 deg data
    else
      i180=nint(179./dx)+1    ! 1 deg data
    endif
    i181=i180+1

  ! fixgfs11 -- revert to working v10.4 setting
  i180=nint(180./dx)    ! 0.5 deg data
  i181=i180
  i179=i180

    ! NCEP TERRAIN
    !*************

    if((isec1(6).eq.007).and.(isec1(7).eq.001)) then

    ! IP 8/5/23
      do jy=0,ny-1
        do ix=0,nxfield-1
          help=zsec4(nxfield*(ny-jy-1)+ix+1)
          if(ix.le.i180) then
            oro(i179+ix,jy)=help
            excessoro(i179+ix,jy)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
          else
            oro(ix-i181,jy)=help
            excessoro(ix-i181,jy)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
          endif
        end do
      end do
    endif

    ! NCEP LAND SEA MASK
    !*******************

    if((isec1(6).eq.081).and.(isec1(7).eq.001)) then
      do jy=0,ny-1
        do ix=0,nxfield-1
          help=zsec4(nxfield*(ny-jy-1)+ix+1)
          if(ix.le.i180) then
            lsm(i179+ix,jy)=help
          else
            lsm(ix-i181,jy)=help
          endif
        end do
      end do
    endif

    call grib_release(igrib)
    if (isec1(6).ne.-1) deallocate( zsec4 ) !IP 28/11/23 fix to run GFS tests
  end do                      !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !

  ! HSO
  call grib_close_file(ifile)
  ! HSO end edits

  nuvz=iumax
  nwz =iumax
  nlev_ec=iumax
  
  ! Allocate memory for windfields
  !*******************************
  nwzmax=nwz
  nuvzmax=nuvz
  nzmax=nuvz
  nconvlevmax=iumax
  na=nuvzmax
  call alloc_windfields

  if (nx.gt.nxmax) then
    write(*,*) 'FLEXPART error: Too many grid points in x direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) nx,nxmax
    error stop
  endif

  if (ny.gt.nymax) then
    write(*,*) 'FLEXPART error: Too many grid points in y direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) ny,nymax
    error stop
  endif

  if (nuvz.gt.nuvzmax) then
    write(*,*) 'FLEXPART error: Too many u,v grid points in z '// &
         'direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) nuvz,nuvzmax
    error stop
  endif

  if (nwz.gt.nwzmax) then
    write(*,*) 'FLEXPART error: Too many w grid points in z '// &
         'direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) nwz,nwzmax
    error stop
  endif

  ! If desired, shift all grids by nxshift grid cells
  !**************************************************

  if (xglobal) then
    call shift_field_0(oro,nxfield,ny)
    call shift_field_0(lsm,nxfield,ny)
    call shift_field_0(excessoro,nxfield,ny)
  endif

  ! Output of grid info
  !********************

  if (lroot) then
    write(*,*)
    write(*,*)
    write(*,'(a,2i7)') 'Vertical levels in NCEP data: ', &
         nuvz,nwz
    write(*,*)
    write(*,'(a)') 'Mother domain:'
    write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
         xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
    write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range : ', &
         ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
    write(*,*)
  end if

  ! CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
  ! PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM

  allocate( akm_usort(nwzmax), stat=stat)
  if (stat.ne.0) error stop "Could not allocate akm_usort"
  numskip=nlev_ec-nuvz  ! number of ecmwf model layers not used
                        ! by trajectory model
  do i=1,nwz
    j=numskip+i
    k=nlev_ec+1+numskip+i
    akm_usort(nwz-i+1)=pres(nwz-i+1)
    bkm(nwz-i+1)=0.0
  end do

  !******************************
  ! change Sabine Eckhardt: akm should always be in descending order ... readwind adapted!
  !******************************
      do i=1,nwz
         if (akm_usort(1).gt.akm_usort(2)) then
            akm(i)=akm_usort(i)
         else
            akm(i)=akm_usort(nwz-i+1)
         endif
      end do

  !
  ! CALCULATION OF AKZ, BKZ
  ! AKZ,BKZ: model discretization parameters at the center of each model
  !     layer
  !
  ! Assign the 10 m winds to an artificial model level with akz=0 and bkz=1.0,
  ! i.e. ground level
  !*****************************************************************************

  do i=1,nuvz
     akz(i)=akm(i)
     bkz(i)=bkm(i)
  end do


  ! NOTE: In FLEXPART versions up to 4.0, the number of model levels was doubled
  ! upon the transformation to z levels. In order to save computer memory, this is
  ! not done anymore in the standard version. However, this option can still be
  ! switched on by replacing the following lines with those below, that are
  ! currently commented out. For this, similar changes are necessary in
  ! verttransform.f and verttranform_nest.f
  !*****************************************************************************

  nz=nuvz
  if (nz.gt.nzmax) error stop 'nzmax too small'
  do i=1,nuvz
    aknew(i)=akz(i)
    bknew(i)=bkz(i)
  end do

  ! Switch on following lines to use doubled vertical resolution
  !*************************************************************
  !nz=nuvz+nwz-1
  !if (nz.gt.nzmax) stop 'nzmax too small'
  !do 100 i=1,nwz
  !  aknew(2*(i-1)+1)=akm(i)
  !00     bknew(2*(i-1)+1)=bkm(i)
  !do 110 i=2,nuvz
  !  aknew(2*(i-1))=akz(i)
  !10     bknew(2*(i-1))=bkz(i)
  ! End doubled vertical resolution
  deallocate(  akm_usort,pres )
  return

999   write(*,*)
  write(*,*) ' ###########################################'// &
       '###### '
  write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
  write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfname(ifn)
  write(*,*) ' ###########################################'// &
       '###### '
  write(*,*)
  write(*,'(a)') '!!! PLEASE INSERT A NEW CD-ROM AND   !!!'
  write(*,'(a)') '!!! PRESS ANY KEY TO CONTINUE...     !!!'
  write(*,'(a)') '!!! ...OR TERMINATE FLEXPART PRESSING!!!'
  write(*,'(a)') '!!! THE "X" KEY...                   !!!'
  write(*,*)
  read(*,'(a)') opt
  if(opt.eq.'X') then
    error stop
  else
    goto 5
  endif

end subroutine gridcheck_gfs

subroutine gridcheck_nest

  !*****************************************************************************
  !                                                                            *
  !     This routine checks the grid specification for the nested model        *
  !     domains. It is similar to subroutine gridcheck, which checks the       *
  !     mother domain.                                                         *
  !                                                                            *
  !     Authors: A. Stohl, G. Wotawa                                           *
  !                                                                            *
  !     8 February 1999                                                        *
  !                                                                            *
  !                                                                            *  
  !  Anne Tipka, Petra Seibert 2021-02: implement new interpolation            *
  !    for precipitation according to #295 using 2 additional fields           *
  !                                                                            *
  !*****************************************************************************
  !  CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with ECMWF grib_api    *
  !  CHANGE: 03/12/2008, Harald Sodemann, change to f90 grib_api               *
  !  Petra Seibert, Anne Tipka, 2021-02: implement new interpolation           *
  !    for precipitation according to #295 using 2 additional fields           *
  !*****************************************************************************

  use grib_api

  implicit none

  integer :: ifile
  integer :: iret

  integer :: igrib,size1,size2,stat
  integer :: istep, ipf, npf ! istep=stepRange for precip field identification
  integer :: gribVer,parCat,parNum,typSfc,discipl
  integer :: parID !added by mc for making it consistent with new gridcheck.f90
  integer :: gotGrib

  integer :: i,j,l,ifn,ifield,iumax,iwmax,numskip,nlev_ecn
  integer :: nuvzn,nwzn
  real :: akmn(nwzmax),bkmn(nwzmax),akzn(nuvzmax),bkzn(nuvzmax)
  real(kind=4) :: xaux1,xaux2,yaux1,yaux2
  real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  real(kind=4),allocatable,dimension(:) :: zsec2,zsec4
  ! PS replace isec1, isec2 arrays by scalar values because we don't need
  !    arrays anymore. isec1(X) -> isX, isec2(X) -> jsX  
  integer :: is6, js2, js3, js12
  integer :: k ! (as k, is the level in ECWMF notation, top->bot)

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: thisSubr  = 'gridcheck_nest'

  xresoln(0)=1.       ! resolution enhancement for mother grid
  yresoln(0)=1.       ! resolution enhancement for mother grid

  ! Loop about all nesting levels
  !******************************

  do l=1,numbnests

    iumax=0
    iwmax=0

    if(ideltas.gt.0) then
      ifn=1
    else
      ifn=numbwf
    endif
    !
    ! OPENING OF DATA FILE (GRIB CODE)
    !
    ifile=0
    igrib=0
    iret=0

    call grib_open_file(ifile,path(numpath+2*(l-1)+1) &
           (1:length(numpath+2*(l-1)+1))//trim(wfnamen(l,ifn)),'r',iret)
    if (iret .ne. GRIB_SUCCESS) goto 999   ! ERROR DETECTED
    !turn on support for multi fields messages
    !call grib_multi_support_on

    gotGrib=0
    ifield=0
    do
      ifield=ifield+1

      ! reading messages from GRIB file
      !--------------------------------

      call grib_new_from_file(ifile,igrib,iret)
      if (iret.eq.GRIB_END_OF_FILE)  then
        exit    ! EOF DETECTED
      elseif (iret.ne.GRIB_SUCCESS) then
        goto 999   ! ERROR DETECTED
      endif
      !turn on support for multi fields messages
      !call grib_multi_support_on

      !first see whether we read GRIB1 or GRIB2
      call grib_get_int(igrib,'editionNumber',gribVer,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      if (gribVer .eq. 1) then ! GRIB Edition 1
      
        call grib_get_int(igrib,'indicatorOfParameter',is6,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'level',k,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        !change code for etadot to code for omega
        if (is6 .eq. 77) is6=135

      else ! GRiB Edition 2

        call grib_get_int(igrib,'discipline',discipl,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'parameterCategory',parCat,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'parameterNumber',parNum,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'typeOfFirstFixedSurface',typSfc,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'level',k,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'paramId',parId,iret) 
        call grib_check(iret,thisSubr,gribErrorMsg) 

        !convert to grib1 identifiers
        is6=-1
        if (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! T
          is6=130 
        elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 105) then ! U
          is6=131 
        elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 105) then ! V
          is6=132 
        elseif (parCat .eq. 1 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! Q
          is6=133 
        ! ESO Cloud water is in a) fields CLWC and CIWC, *or* b) field QC 
        elseif (parCat .eq. 1 .and. parNum .eq. 83 .and. typSfc .eq. 105) then ! clwc
          is6=246 
        elseif (parCat .eq. 1 .and. parNum .eq. 84 .and. typSfc .eq. 105) then ! ciwc
          is6=247 
        ! ESO qc(=clwc+ciwc):
        elseif (parCat .eq. 201 .and. parNum .eq. 31 .and. typSfc .eq. 105) then ! qc
          is6=201031 
        elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 1) then !SP
          is6=134 
        elseif (parCat .eq. 2 .and. parNum .eq. 32) then ! W, actually eta dot
          is6=135 
        elseif (parCat .eq. 128 .and. parNum .eq. 77) then ! W, actually eta dot
          is6=135 
        elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 101) then ! SLP
          is6=151 
        elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 103) then ! 10U
          is6=165 
        elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 103) then ! 10V
          is6=166 
        elseif (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 103) then ! 2T
          is6=167 
        elseif (parCat .eq. 0 .and. parNum .eq. 6 .and. typSfc .eq. 103) then ! 2D
          is6=168 
        elseif (parCat .eq. 1 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SD
          is6=141 
        elseif (parCat .eq. 6 .and. parNum .eq. 1 .or. parId .eq. 164) then ! CC
          is6=164 
        elseif (parCat .eq. 1 .and. parNum .eq. 9 .or. parId .eq. 142) then ! LSP
          is6=142 
        elseif (parCat .eq. 1 .and. parNum .eq. 10) then ! CP
          is6=143 
        elseif (parCat .eq. 0 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SHF
          is6=146 
        elseif (parCat .eq. 4 .and. parNum .eq. 9 .and. typSfc .eq. 1) then ! SR
          is6=176 
        elseif (parCat .eq. 2 .and. parNum .eq. 38 .or. parId .eq. 180) then ! EWSS --correct
          is6=180 
        elseif (parCat .eq. 2 .and. parNum .eq. 37 .or. parId .eq. 181) then ! NSSS --correct
          is6=181 
        elseif (parCat .eq. 3 .and. parNum .eq. 4) then ! ORO
          is6=129 
        elseif (parCat .eq. 3 .and. parNum .eq. 7 .or. parId .eq. 160) then ! SDO
          is6=160 
        elseif (discipl .eq. 2 .and. parCat .eq. 0 .and. parNum .eq. 0 .and. &
             typSfc .eq. 1) then ! LSM
          is6=172 
        elseif (parNum .eq. 152) then 
          is6=152         ! avoid warning for lnsp    
        else
          print*,'***WARNING: undefined GRiB2 message found!',discipl, &
            parCat,parNum,typSfc       
        endif
        if (parId .ne. is6 .and. parId .ne. 77) write(*,*) 'parId',parId, 'is6',is6
      endif !gribVer

      !HSO  get the required fields from section 2 in a gribex compatible manner
      if (ifield.eq.1) then
        call grib_get_int(igrib,'numberOfPointsAlongAParallel',js2,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_int(igrib,'numberOfPointsAlongAMeridian',js3,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_int(igrib,'numberOfVerticalCoordinateValues',js12)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees',xaux1in,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        nxn(l)=js2
        nyn(l)=js3
        nlev_ecn=js12/2-1

        if (nxn(l).gt.nxmaxn) nxmaxn=nxn(l)
        if (nyn(l).gt.nymaxn) nymaxn=nyn(l)

        call grib_get_size(igrib,'pv',size2,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        allocate(zsec2(size2), stat=stat)
        if (stat.ne.0) error stop "Could not allocate zsec2"

        !HSO    get the size and data of the vertical coordinate array
        call grib_get_real4_array(igrib,'pv',zsec2,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call alloc_fixedfields_nest
        write(*,*) 'Dimensions nest:',nxmaxn,nymaxn,nlev_ecn
      endif ! ifield eq 1

      !get the size and data of the values array
      if (is6.ne.-1) then
        call grib_get_size(igrib,'values',size1,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        allocate(zsec4(size1), stat=stat)
        if (stat.ne.0) error stop "Could not allocate zsec4"
        call grib_get_real4_array(igrib,'values',zsec4,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
      endif

      !HSO  get the second part of the grid dimensions only from GRiB1 messages
      if (is6 .eq. 167 .and. gotGrib .eq. 0) then !added by mc to make it consistent with new gridchek.f90 note that gotGrid must be changed in gotGrib!!
        
        call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', & !comment by mc: note that this was in the (if (ifield.eq.1) ..end above in gridchek.f90 see line 257
             xaux1in,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees', &
             xaux2in,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
             yaux1in,iret)     
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_real8(igrib,'latitudeOfFirstGridPointInDegrees', &
             yaux2in,iret)           
        call grib_check(iret,thisSubr,gribErrorMsg)
        xaux1=real(xaux1in)
        xaux2=real(xaux2in)
        yaux1=real(yaux1in)
        yaux2=real(yaux2in)
        if(xaux1.gt.180.) xaux1=xaux1-360.0
        if(xaux2.gt.180.) xaux2=xaux2-360.0
        if(xaux1.lt.-180.) xaux1=xaux1+360.0
        if(xaux2.lt.-180.) xaux2=xaux2+360.0
        if (xaux2.lt.xaux1) xaux2=xaux2+360.0
        xlon0n(l)=xaux1
        ylat0n(l)=yaux1
        dxn(l)=(xaux2-xaux1)/real(nxn(l)-1)
        dyn(l)=(yaux2-yaux1)/real(nyn(l)-1)
        gotGrib=1 !comment by mc gotGRIB is used instead of gotGrid!!!
      endif

      if(is6.eq.131) iumax=max(iumax,nlev_ec-k+1)
      if(is6.eq.135) iwmax=max(iwmax,nlev_ec-k+1)

      if(is6.eq.129) then
        do j=0,nyn(l)-1
          do i=0,nxn(l)-1
            oron(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
          enddo
        enddo
      endif
      if(is6.eq.172) then
        do j=0,nyn(l)-1
          do i=0,nxn(l)-1
            lsmn(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
          enddo
        enddo
      endif
      if(is6.eq.160) then
        do j=0,nyn(l)-1
          do i=0,nxn(l)-1
            excessoron(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
          enddo
        enddo
      endif

      call grib_release(igrib)
      if (is6.ne.-1) deallocate( zsec4 )
    end do                 !! READ NEXT LEVEL OR PARAMETER
    !
    ! CLOSING OF INPUT DATA FILE
    !
    call grib_close_file(ifile)

    !error message if no fields found with correct first longitude in it
    if (gotGrib.eq.0) then
      print*,'***ERROR: input file needs to contain GRiB1 formatted'// &
           'messages'
      error stop
    endif

    nuvzn=iumax
    nwzn=iwmax
    if(nuvzn.eq.nlev_ec) nwzn=nlev_ecn+1

    if ((nuvzn.gt.nuvzmax).or.(nwzn.gt.nwzmax)) then
      write(*,*) 'FLEXPART error: Nested wind fields have too many '// &
           'vertical levels.'
      write(*,*) 'Problem was encountered for nesting level ',l
      error stop
    endif


    ! Output of grid info
    !********************

    write(*,'(a,i2,a)') ' Nested domain ',l,':'
    write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Longitude range: ', &
         xlon0n(l),' to ',xlon0n(l)+(nxn(l)-1)*dxn(l), &
         '   Grid distance: ',dxn(l)
    write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Latitude range : ', &
         ylat0n(l),' to ',ylat0n(l)+(nyn(l)-1)*dyn(l), &
         '   Grid distance: ',dyn(l)
    write(*,*)

    ! Determine, how much the resolutions in the nests are enhanced as
    ! compared to the mother grid
    !*****************************************************************

    xresoln(l)=dx/dxn(l)
    yresoln(l)=dy/dyn(l)

    ! Determine the mother grid coordinates of the corner points of the
    ! nested grids
    ! Convert first to geographical coordinates, then to grid coordinates
    !********************************************************************

    xaux1=xlon0n(l)
    xaux2=xlon0n(l)+real(nxn(l)-1)*dxn(l)
    yaux1=ylat0n(l)
    yaux2=ylat0n(l)+real(nyn(l)-1)*dyn(l)

    xln(l)=(xaux1-xlon0)/dx
    xrn(l)=(xaux2-xlon0)/dx
    yln(l)=(yaux1-ylat0)/dy
    yrn(l)=(yaux2-ylat0)/dy


    if ((xln(l).lt.0.).or.(yln(l).lt.0.).or. &
         (xrn(l).gt.real(nxmin1)).or.(yrn(l).gt.real(nymin1))) then
      write(*,*) 'Nested domain does not fit into mother domain'
      write(*,*) 'For global mother domain fields, you can shift'
      write(*,*) 'shift the mother domain into x-direction'
      write(*,*) 'by setting nxshift (file par_mod) to a'
      write(*,*) 'positive value. Execution is terminated.'
      error stop
    endif

    ! CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
    ! PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM

    numskip=nlev_ecn-nuvzn ! number of ecmwf model layers not used by FLEXPART
    do i=1,nwzn
      akmn(nwzn-i+1)=zsec2(numskip+i)
      bkmn(nwzn-i+1)=zsec2(nlev_ecn+1+numskip+i)
    end do

    !
    ! CALCULATION OF AKZ, BKZ
    ! AKZ,BKZ: model discretization parameters at the center of each model
    !     layer
    !
    ! Assign the 10 m winds to an artificial model level with akz=0 and bkz=1.0,
    ! i.e. ground level
    !*****************************************************************************

    akzn(1)=0.
    bkzn(1)=1.
    do i=1,nuvzn
      akzn(i+1)=0.5*(akmn(i+1)+akmn(i))
      bkzn(i+1)=0.5*(bkmn(i+1)+bkmn(i))
    end do
    nuvzn=nuvzn+1

  ! Check, whether the heights of the model levels of the nested
  ! wind fields are consistent with those of the mother domain.
  ! If not, terminate model run.
  !*************************************************************

    do i=1,nuvz
      if ((akzn(i).ne.akz(i)).or.(bkzn(i).ne.bkz(i))) then
        write(*,*) 'FLEXPART error: The wind fields of nesting level',l
        write(*,*) 'are not consistent with the mother domain:'
        write(*,*) 'Differences in vertical levels detected.'
        error stop
      endif
    end do

    do i=1,nwz
      if ((akmn(i).ne.akm(i)).or.(bkmn(i).ne.bkm(i))) then
        write(*,*) 'FLEXPART error: The wind fields of nesting level',l
        write(*,*) 'are not consistent with the mother domain:'
        write(*,*) 'Differences in vertical levels detected.'
        error stop
      endif
    end do

    deallocate( zsec2 )
  end do

  ! Allocate memory for windfields using nxmax, nymaxn, numbnest
  !*************************************************************
  call alloc_windfields_nest



  return

999   write(*,*)
  write(*,*) ' ###########################################'// &
       '###### '
  write(*,*) '                FLEXPART SUBROUTINE GRIDCHECK:'
  write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfnamen(l,ifn)
  write(*,*) ' FOR NESTING LEVEL ',k
  write(*,*) ' ###########################################'// &
       '###### '
  error stop

end subroutine gridcheck_nest

subroutine readwind_ecmwf(indj,n,uuh,vvh,wwh)

  !**********************************************************************
  !                                                                     *
  !             TRAJECTORY MODEL SUBROUTINE READWIND                    *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  !             AUTHOR:      G. WOTAWA                                  *
  !             DATE:        1997-08-05                                 *
  !             LAST UPDATE: 2000-10-17, Andreas Stohl                  *
  !             CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with *
  !                                 ECMWF grib_api                      *
  !             CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
  !                                 ECMWF grib_api                      *
  !                                                                     *
  !  Changes, Bernd C. Krueger, Feb. 2001:                              *
  !   Variables tth and qvh (on eta coordinates) in common block        *
  !                                                                     *
  !   Unified ECMWF and GFS builds                                      *
  !   Marian Harustak, 12.5.2017                                        *
  !     - Renamed from readwind to readwind_ecmwf                       *
  !                                                                     *
  !  L. Bakels, 2021: OpenMP parallelisation (following CTM version)    * 
  !                                                                     *  
  !  Anne Tipka, Petra Seibert 2021-02: implement new interpolation     *
  !    for precipitation according to #295 using 2 additional fields    *
  !    change some double loops in wrong order to forall constructs     *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION:                                                        *
  !                                                                     *
  ! READING OF ECMWF METEOROLOGICAL FIELDS FROM INPUT DATA FILES. THE   *
  ! INPUT DATA FILES ARE EXPECTED TO BE AVAILABLE IN GRIB CODE          *
  !                                                                     *
  ! INPUT:                                                              *
  ! indj               indicates number of the wind field to be read in *
  ! n                  temporal index for meteorological fields (1 to 3)*
  !                                                                     *
  ! IMPORTANT VARIABLES FROM COMMON BLOCK:                              *
  !                                                                     *
  ! wfname             File name of data to be read in                  *
  ! nx,ny,nuvz,nwz     expected field dimensions                        *
  ! nlev_ec            number of vertical levels ecmwf model            *
  ! uu,vv,ww           wind fields                                      *
  ! tt,qv              temperature and specific humidity                *
  ! ps                 surface pressure                                 *
  !                                                                     *
  !**********************************************************************

  use grib_api

  implicit none

  !HSO  parameters for grib_api
  integer :: ifile
  integer :: iret, size1, stat
  integer, dimension(:), allocatable   :: igrib
  integer :: nfield, ii, arsize
  integer :: istep, ipf, npf ! istep=stepRange for precip field identification
  integer :: gribVer,parCat,parNum,typSfc,discipl,parId
  integer :: gotGrid
  ! HSO  end

  real(kind=4), intent(inout) :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real(kind=4), intent(inout) :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real(kind=4), intent(inout) :: wwh(0:nxmax-1,0:nymax-1,nwzmax)
  integer, intent(in) :: indj,n
  integer :: i,j,ifield,iumax,iwmax

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  ! dimension of isec2 at least (22+n), where n is the number of parallels or
  ! meridians in a quasi-regular (reduced) Gaussian or lat/long grid
  ! LB: Only 3 indices are used in this function, so isec2 has dimension 12

  ! dimension of zsec2 at least (10+nn), where nn is the number of vertical
  ! coordinate parameters

  real(kind=4),allocatable,dimension(:) :: zsec4
  ! integer  :: isec1(56),isec2(22+nxmax+nymax)
  ! AT replace isec1, isec2 arrays by scalar values because we don't need
  !    arrays anymore. isec1(X) -> isX, isec2(X) -> jsX  
  integer :: is6, js2, js3, js12
  integer :: k ! (as k, is the level in ECWMF notation, top->bot)
  integer :: kz, kz1 ! (level in FLEXPART notation, bot->top)
  integer :: jy ! y index in FLEXPART notation (S->N)

  real(kind=4) :: xaux,yaux,xaux0,yaux0
  real(kind=8) :: xauxin,yauxin
  real,parameter :: eps=1.e-4
  real(kind=4) :: nsss(0:nxmax-1,0:nymax-1),ewss(0:nxmax-1,0:nymax-1)
  real :: plev1,pmean,tv,fu,hlev1,ff10m,fflev1,conversion_factor

  logical :: hflswitch,strswitch,lstep(0:2)

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: thisSubr  = 'readwind_ecmwf'

  hflswitch=.false.
  strswitch=.false.
  
  iumax=0
  iwmax=0

  !
  ! OPENING OF DATA FILE (GRIB CODE)
  !
  call grib_open_file(ifile,path(3)(1:length(3))//trim(wfname(indj)),'r',iret)
  if (iret .ne. GRIB_SUCCESS) goto 888   ! ERROR DETECTED

  ! COUNT NUMBER OF MESSAGES IN FILE 
  !
  call grib_count_in_file(ifile,nfield)

  ! allocate memory for grib handles
  allocate(igrib(nfield), stat=stat)
  if (stat.ne.0) error stop "Could not allocate igrib"
  ! initialise
  igrib(:) = -1
 
  ! LOAD ALL MESSAGES FROM FILE
  !
  do ii = 1,nfield
    call grib_new_from_file(ifile, igrib(ii), iret)
  end do
  
  ! CLOSE FILE 
  !
  call grib_close_file(ifile)

  !turn on support for multi fields messages */
  !call grib_multi_support_on

  gotGrid=0

!$OMP PARALLEL DEFAULT(none) &
!$OMP SHARED (nfield, igrib, thisSubr, nxfield, ny, nlev_ec, dx, xlon0, ylat0, &
!$OMP   n, tth, uuh, vvh, iumax, qvh, ps, wwh, iwmax, sd, msl, tcc, u10, v10, tt2, &
!$OMP   td2, lsprec, convprec, sshf, hflswitch, ssr, ewss, nsss, strswitch, oro,   &
!$OMP   excessoro, lsm, nymin1,ciwch,clwch,nxshift,lprecint, lcw, lcwsum) & 
!$OMP PRIVATE(ii, gribVer, iret, is6, discipl, parCat, parNum, parId, typSfc, & 
!$OMP   zsec4, js2, js3, js12, gribErrorMsg, xauxin, yauxin, xaux, yaux, xaux0,  &
!$OMP   yaux0,k,arsize,stat,conversion_factor,size1,istep,ipf,npf,kz,kz1,jy)  &
!$OMP REDUCTION(+:gotGrid)

  !
  ! GET NEXT FIELDS
  !

!$OMP DO SCHEDULE(static)

  fieldloop : do ii=1,nfield

  !first see if we read GRIB1 or GRIB2
  call grib_get_int(igrib(ii),'editionNumber',gribVer,iret)
  call grib_check(iret,thisSubr,gribErrorMsg)
  
  ! AT stepRange is used to identify additional precip fields
  call grib_get_int(igrib(ii),'stepRange',istep,iret)
  call grib_check(iret,thisSubr,gribErrorMsg)
  ipf=istep+1

  if (gribVer.eq.1) then ! GRIB Edition 1

    !read the grib2 identifiers
    call grib_get_int(igrib(ii),'indicatorOfParameter',is6,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    call grib_get_int(igrib(ii),'level',k,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)

    ! change code for etadot to code for omega
    if (is6.eq.77) is6=135
    
    conversion_factor=1.

  else ! GRiB Edition 2

    !read the grib2 identifiers
    call grib_get_int(igrib(ii),'discipline',discipl,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    call grib_get_int(igrib(ii),'parameterCategory',parCat,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    call grib_get_int(igrib(ii),'parameterNumber',parNum,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    call grib_get_int(igrib(ii),'typeOfFirstFixedSurface',typSfc,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    call grib_get_int(igrib(ii),'level',k,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    call grib_get_int(igrib(ii),'paramId',parId,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)

    !convert to grib1 identifiers
    is6=-1
    conversion_factor=1.
    if (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! T
      is6=130 
    elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 105) then ! U
      is6=131 
    elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 105) then ! V
      is6=132 
    elseif (parCat .eq. 1 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! Q
      is6=133 
    ! ESO Cloud water is in a) fields CLWC and CIWC, *or* b) field QC 
    elseif (parCat .eq. 1 .and. parNum .eq. 83 .and. typSfc .eq. 105) then ! clwc
      is6=246 
    elseif (parCat .eq. 1 .and. parNum .eq. 84 .and. typSfc .eq. 105) then ! ciwc
      is6=247 
    ! ESO qc(=clwc+ciwc):
    elseif (parCat .eq. 201 .and. parNum .eq. 31 .and. typSfc .eq. 105) then ! qc
      is6=201031 
    elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 1) then !SP
      is6=134 
    elseif (parCat .eq. 2 .and. parNum .eq. 32) then ! W, actually eta dot
      is6=135 
    elseif (parCat .eq. 128 .and. parNum .eq. 77) then ! W, actually eta dot
      is6=135 
    elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 101) then ! SLP
      is6=151 
    elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 103) then ! 10U
      is6=165 
    elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 103) then ! 10V
      is6=166 
    elseif (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 103) then ! 2T
      is6=167 
    elseif (parCat .eq. 0 .and. parNum .eq. 6 .and. typSfc .eq. 103) then ! 2D
      is6=168 
    elseif (parCat .eq. 1 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SD
      is6=141 
      conversion_factor=1000.
    elseif (parCat .eq. 6 .and. parNum .eq. 1 .or. parId .eq. 164) then ! CC
      is6=164 
    elseif (parCat .eq. 1 .and. parNum .eq. 9 .or. parId .eq. 142) then ! LSP
      is6=142 
    elseif (parCat .eq. 1 .and. parNum .eq. 10) then ! CP
      is6=143 
      conversion_factor=1000.
    elseif (parCat .eq. 0 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SHF
      is6=146 
    elseif (parCat .eq. 4 .and. parNum .eq. 9 .and. typSfc .eq. 1) then ! SR
      is6=176 
    elseif (parCat .eq. 2 .and. parNum .eq. 38 .or. parId .eq. 180) then ! EWSS --correct
      is6=180 
    elseif (parCat .eq. 2 .and. parNum .eq. 37 .or. parId .eq. 181) then ! NSSS --correct
      is6=181 
    elseif (parCat .eq. 3 .and. parNum .eq. 4) then ! ORO
      is6=129 
    elseif (parCat .eq. 3 .and. parNum .eq. 7 .or. parId .eq. 160) then ! SDO
      is6=160 
    elseif (discipl .eq. 2 .and. parCat .eq. 0 .and. parNum .eq. 0 .and. &
         typSfc .eq. 1) then ! LSM
      is6=172 
    elseif (parNum .eq. 152) then 
      is6=152         ! avoid warning for lnsp    
    else
      print*,'***WARNING: undefined GRiB2 message found!',discipl,parCat,parNum,typSfc
    endif
   
    if (parId .ne. is6 .and. parId .ne. 77) write(*,*) 'parId',parId, 'is6',is6

  endif ! grib Version conversion

  !HSO  get the size and data of the values array
  if (is6.ne.-1) then
    call grib_get_size(igrib(ii),'values',size1,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    allocate(zsec4(size1), stat=stat)
    if (stat.ne.0) error stop "Could not allocate zsec4"

    call grib_get_real4_array(igrib(ii),'values',zsec4,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
  endif

  !HSO  get the required fields from section 2 in a gribex compatible manner
  if (ii.eq.1) then
    call grib_get_int(igrib(ii),'numberOfPointsAlongAParallel',js2,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)

    call grib_get_int(igrib(ii),'numberOfPointsAlongAMeridian',js3,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)

    call grib_get_int(igrib(ii),'numberOfVerticalCoordinateValues',js12)
    call grib_check(iret,thisSubr,gribErrorMsg)

    ! CHECK GRID SPECIFICATIONS
    if(js2.ne.nxfield) error stop 'READWIND: NX NOT CONSISTENT'
    if(js3.ne.ny) error stop 'READWIND: NY NOT CONSISTENT'
    if(js12/2-1 .ne. nlev_ec) &
      error stop 'READWIND: VERTICAL DISCRETIZATION NOT CONSISTENT'
  endif ! ifield

!$OMP CRITICAL
  !HSO  get the second part of the grid dimensions only from GRiB1 messages
  if (is6 .eq. 167 .and. gotGrid.eq.0) then
  
    call grib_get_real8(igrib(ii),'longitudeOfFirstGridPointInDegrees', &
         xauxin,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    call grib_get_real8(igrib(ii),'latitudeOfLastGridPointInDegrees', &
         yauxin,iret)
    call grib_check(iret,thisSubr,gribErrorMsg)
    
    if (xauxin.gt.180.) xauxin=xauxin-360.
    if (xauxin.lt.-180.) xauxin=xauxin+360.

    xaux=real(xauxin)+real(nxshift)*dx
    yaux=real(yauxin)
    if (xaux.gt.180.) xaux=xaux-360.0

    if(abs(xaux-xlon0).gt.eps) &
      error stop 'READWIND ECMWF : LOWER LEFT LONGITUDE NOT CONSISTENT'
    if(abs(yaux-ylat0).gt.eps) &
      error stop 'READWIND ECMWF: LOWER LEFT LATITUDE NOT CONSISTENT'
    gotGrid=1
  endif ! gotGrid
!$OMP END CRITICAL


  kz=nlev_ec-k+2  ! used for all 3D fields except W
  kz1=nlev_ec-k+1 ! used for W

  select case(is6) 
  !! TEMPERATURE
    case(130) 
      do j=0,nymin1
        do i=0,nxfield-1
          tth(i,j,kz,n) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
  !! U VELOCITY
    case(131) 
      do j=0,nymin1
        do i=0,nxfield-1
          uuh(i,j,kz) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
!$OMP CRITICAL
      iumax=max(iumax,kz1)
!$OMP END CRITICAL
  !! V VELOCITY
    case(132)
      do j=0,nymin1
        do i=0,nxfield-1
          vvh(i,j,kz) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do
  !! SPEC. HUMIDITY
    case(133)
      do j=0,nymin1
        do i=0,nxfield-1
          qvh(i,j,kz,n) = zsec4(nxfield*(ny-j-1)+i+1)
          if (qvh(i,j,kz,n) .lt. 0.) &
               qvh(i,j,kz,n) = 0.
    !        this is necessary because the gridded data may contain
    !        spurious negative values
        end do 
      end do
  !! SURF. PRESS.
    case(134) 
      do j=0,nymin1
        do i=0,nxfield-1
          ps(i,j,1,n) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do
  !! W VELOCITY
    case(135)
      do j=0,nymin1
        do i=0,nxfield-1
          wwh(i,j,kz1) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
!$OMP CRITICAL
      iwmax=max(iwmax,kz1)
!$OMP END CRITICAL
  !! SNOW DEPTH
    case(141) 
      do j=0,nymin1
        do i=0,nxfield-1
          sd(i,j,1,n)= zsec4(nxfield*(ny-j-1)+i+1)/conversion_factor
        end do 
      end do
  !! SEA LEVEL PRESS.
    case(151)
      do j=0,nymin1
        do i=0,nxfield-1
          msl(i,j,1,n) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do
  !! CLOUD COVER
    case(164)
      do j=0,nymin1
        do i=0,nxfield-1
          tcc(i,j,1,n) =  zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
  !! 10 M U VELOCITY
    case(165) 
      do j=0,nymin1
        do i=0,nxfield-1
          u10(i,j,1,n)= zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
  !! 10 M V VELOCITY
    case(166) 
      do j=0,nymin1
        do i=0,nxfield-1
          v10(i,j,1,n) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
  !! 2 M TEMPERATURE
    case(167)
      do j=0,nymin1
        do i=0,nxfield-1
          tt2(i,j,1,n) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
  !! 2 M DEW POINT
    case(168)
      do j=0,nymin1
        do i=0,nxfield-1
          td2(i,j,1,n) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do
  !! LARGE SCALE PREC.
    case(142)
      do j=0,nymin1
        do i=0,nxfield-1
          lsprec(i,j,1,ipf,n)=zsec4(nxfield*(ny-j-1)+i+1)
          if (lsprec(i,j,1,ipf,n).lt.0.) lsprec(i,j,1,ipf,n)=0.
        end do 
      end do
  !! CONVECTIVE PREC.
    case(143)
      do j=0,nymin1
        do i=0,nxfield-1
          convprec(i,j,1,ipf,n)=zsec4(nxfield*(ny-j-1)+i+1)/conversion_factor
          if (convprec(i,j,1,ipf,n).lt.0.) convprec(i,j,1,ipf,n)=0.
        end do 
      end do
  !! SENS. HEAT FLUX
    case(146)
      do j=0,nymin1
        do i=0,nxfield-1
          sshf(i,j,1,n) = zsec4(nxfield*(ny-j-1)+i+1)
!$OMP CRITICAL
          if(zsec4(nxfield*(ny-j-1)+i+1).ne.0.) &  
            hflswitch=.true.    ! Heat flux available
!$OMP END CRITICAL
        end do 
      end do
  !! SOLAR RADIATION
    case(176)
      do j=0,nymin1
        do i=0,nxfield-1
          ssr(i,j,1,n)=zsec4(nxfield*(ny-j-1)+i+1)
          if (ssr(i,j,1,n).lt.0.) ssr(i,j,1,n)=0.
        end do 
      end do
  !! EW SURFACE STRESS
    case(180)
      do j=0,nymin1
        do i=0,nxfield-1
          ewss(i,j) = zsec4(nxfield*(ny-j-1)+i+1)
!$OMP CRITICAL
          if (zsec4(nxfield*(ny-j-1)+i+1).ne.0.) strswitch=.true.    ! stress available
!$OMP END CRITICAL
        end do 
      end do 
  !! NS SURFACE STRESS
    case(181)
     do j=0,nymin1
       do i=0,nxfield-1
         nsss(i,j) = zsec4(nxfield*(ny-j-1)+i+1)
!$OMP CRITICAL
         if (zsec4(nxfield*(ny-j-1)+i+1).ne.0.) strswitch=.true.    ! stress available
!$OMP END CRITICAL
       end do 
     end do 
  !! ECMWF OROGRAPHY
    case(129)
      do j=0,nymin1
        do i=0,nxfield-1
          oro(i,j) = zsec4(nxfield*(ny-j-1)+i+1)/ga
        end do 
      end do
  !! STANDARD DEVIATION OF OROGRAPHY
    case(160)
      do j=0,nymin1
        do i=0,nxfield-1
          excessoro(i,j) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do 
  !! ECMWF LAND SEA MASK
    case(172)
      do j=0,nymin1
        do i=0,nxfield-1
          lsm(i,j) = zsec4(nxfield*(ny-j-1)+i+1)
        end do 
      end do
! ZHG add reading of cloud water fields
! ESO add reading of total cloud water fields
! ESO TODO: add check whether either CLWC or CIWC is missing (->error)
!           if all 3 cw fields exist, use QC and disregard the others
  !! CLWC  Cloud liquid water content [kg/kg]
    case(246)    
      do j=0,nymin1
        do i=0,nxfield-1
          clwch(i,j,kz,n)=zsec4(nxfield*(ny-j-1)+i+1)
        end do
      end do
!$OMP CRITICAL
      lcw=.true.
      lcwsum=.false.
!$OMP END CRITICAL
  !! CIWC  Cloud ice water content
    case(247)
      do j=0,nymin1
        do i=0,nxfield-1
          ciwch(i,j,kz,n)=zsec4(nxfield*(ny-j-1)+i+1)
        end do
      end do
  !ZHG end
  !ESO read qc (=clwc+ciwc)
  !! QC  Cloud liquid water content [kg/kg]
    case(201031)
      do j=0,nymin1
        do i=0,nxfield-1      
          clwch(i,j,kz,n)=zsec4(nxfield*(ny-j-1)+i+1)
        end do
      end do
!$OMP CRITICAL
      lcw=.true.
      lcwsum=.true.
!$OMP END CRITICAL

    end select

    call grib_release(igrib(ii))

    if (is6.ne.-1) deallocate( zsec4 )
  end do fieldloop
!$OMP END DO

!$OMP END PARALLEL

  deallocate(igrib)
  !
  ! CLOSING OF INPUT DATA FILE
  !

  ! 50 call grib_close_file(ifile)

  !error message if no fields found with correct first longitude in it
  if (gotGrid.eq.0) then
    print*,'***ERROR: input file needs to contain GRiB1 formatted messages'
    error stop
  endif

  if(nlev_ec-nwz+1 .eq. 0) then
    iwmax=nlev_ec+1
    wwh(:,:,iwmax)=0.
  endif

  ! For global fields, assign the leftmost data column also to the rightmost
  ! data column; if required, shift whole grid by nxshift grid points
  !*************************************************************************

  if (xglobal) then
    if (lprecint) then
      npf=numpf
    else
      npf=1
    endif
!$OMP PARALLEL SECTIONS PRIVATE(ipf)
!$OMP SECTION
    call shift_field_0(ewss,nxfield,ny)
!$OMP SECTION
    call shift_field_0(nsss,nxfield,ny)
!$OMP SECTION
    call shift_field_0(oro,nxfield,ny)
!$OMP SECTION
    call shift_field_0(excessoro,nxfield,ny)
!$OMP SECTION
    call shift_field_0(lsm,nxfield,ny)
!$OMP SECTION
    call shift_field(ps,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(sd,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(msl,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(tcc,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(u10,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(v10,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(tt2,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(td2,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    do ipf=1,npf
      call shift_field(lsprec(:,:,:,ipf,n),nxfield,ny,1,1,1,1)
    end do
!$OMP SECTION
    do ipf=1,npf
      call shift_field(convprec(:,:,:,ipf,n),nxfield,ny,1,1,1,1)
    end do
!$OMP SECTION
    call shift_field(sshf,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(ssr,nxfield,ny,1,1,numwfmem,n)
!$OMP SECTION
    call shift_field(tth,nxfield,ny,nuvzmax,nuvz,numwfmem,n)
!$OMP SECTION
    call shift_field(qvh,nxfield,ny,nuvzmax,nuvz,numwfmem,n)
!$OMP SECTION
    call shift_field(uuh,nxfield,ny,nuvzmax,nuvz,1,1)
!$OMP SECTION
    call shift_field(vvh,nxfield,ny,nuvzmax,nuvz,1,1)
!$OMP SECTION
    call shift_field(wwh,nxfield,ny,nwzmax,nwz,1,1)
!$OMP SECTION
  !ZHG
    call shift_field(clwch,nxfield,ny,nuvzmax,nuvz,numwfmem,n)
!$OMP SECTION
    if (.not.lcwsum) call shift_field(ciwch,nxfield,ny,nuvzmax,nuvz,numwfmem,n)
  !ZHG end
!$OMP END PARALLEL SECTIONS
  endif

  ! Temporary fix for zero values in the meteo data
  if (hflswitch .and. strswitch) then
    do i=0,nxmin1
      do j=0,nymin1
        if ((ewss(i,j).eq.0.).and.(nsss(i,j).eq.0.)) then
          if ((i.ne.0).and.(j.ne.0).and.(i.ne.nxmin1).and.(j.ne.nymin1)) then
            ewss(i,j)=(ewss(i-1,j-1)+ewss(i+1,j+1)+ewss(i+1,j)+ewss(i-1,j)+ &
                       ewss(i,j+1)+ewss(i,j-1)+ewss(i-1,j+1)+ewss(i+1,j-1))/8.
            nsss(i,j)=(nsss(i-1,j-1)+nsss(i+1,j+1)+nsss(i+1,j)+nsss(i-1,j)+ &
                       nsss(i,j+1)+nsss(i,j-1)+nsss(i-1,j+1)+nsss(i+1,j-1))/8.
          else if ((i.eq.0).and.(j.eq.0)) then
            ewss(i,j)=(ewss(i+1,j+1)+ewss(i+1,j)+ewss(i,j+1))/3.
            nsss(i,j)=(nsss(i+1,j+1)+nsss(i+1,j)+nsss(i,j+1))/3.
          else if ((i.eq.nxmin1).and.(j.eq.nymin1)) then
            ewss(i,j)=(ewss(i-1,j-1)+ewss(i-1,j)+ewss(i,j-1))/3.
            nsss(i,j)=(nsss(i-1,j-1)+nsss(i-1,j)+nsss(i,j-1))/3.
          else if ((i.eq.0).and.(j.eq.nymin1)) then
            ewss(i,j)=(ewss(i+1,j-1)+ewss(i+1,j)+ewss(i,j-1))/3.
            nsss(i,j)=(nsss(i+1,j-1)+nsss(i+1,j)+nsss(i,j-1))/3.
          else if ((i.eq.nxmin1).and.(j.eq.0)) then
            ewss(i,j)=(ewss(i-1,j+1)+ewss(i-1,j)+ewss(i,j+1))/3.
            nsss(i,j)=(nsss(i-1,j+1)+nsss(i-1,j)+nsss(i,j+1))/3.
          else if (i.eq.0) then
            ewss(i,j)=(ewss(i+1,j+1)+ewss(i+1,j)+ewss(i,j+1)+ewss(i,j-1)+ewss(i+1,j-1))/5.
            nsss(i,j)=(nsss(i+1,j+1)+nsss(i+1,j)+nsss(i,j+1)+nsss(i,j-1)+nsss(i+1,j-1))/5.
          else if (i.eq.nxmin1) then
            ewss(i,j)=(ewss(i-1,j+1)+ewss(i-1,j)+ewss(i,j+1)+ewss(i,j-1)+ewss(i-1,j-1))/5.
            nsss(i,j)=(nsss(i-1,j+1)+nsss(i-1,j)+nsss(i,j+1)+nsss(i,j-1)+nsss(i-1,j-1))/5.
          else if (j.eq.0) then
            ewss(i,j)=(ewss(i+1,j+1)+ewss(i+1,j)+ewss(i-1,j)+ewss(i,j+1)+ewss(i-1,j+1))/5.
            nsss(i,j)=(nsss(i+1,j+1)+nsss(i+1,j)+nsss(i-1,j)+nsss(i,j+1)+nsss(i-1,j+1))/5.
          else if (j.eq.nymin1) then
            ewss(i,j)=(ewss(i+1,j-1)+ewss(i+1,j)+ewss(i-1,j)+ewss(i,j-1)+ewss(i-1,j-1))/5.
            nsss(i,j)=(nsss(i+1,j-1)+nsss(i+1,j)+nsss(i-1,j)+nsss(i,j-1)+nsss(i-1,j-1))/5.
          endif
        endif
        sfcstress(i,j,1,n)=sqrt(ewss(i,j)**2+nsss(i,j)**2)
      end do
    end do
  endif

  if (.not.hflswitch .or. .not.strswitch) then
    write(*,*) 'WARNING: No flux data contained in GRIB file ', wfname(indj)

  ! CALCULATE USTAR AND SSHF USING THE PROFILE METHOD
  ! As ECMWF has increased the model resolution, such that now the first model
  ! level is at about 10 m (where 10-m wind is given), use the 2nd ECMWF level
  ! (3rd model level in FLEXPART) for the profile method
  !***************************************************************************

    do j=0,nymin1
      do i=0,nxmin1
        plev1=akz(3)+bkz(3)*ps(i,j,1,n)
        pmean=0.5*(ps(i,j,1,n)+plev1)
        tv=tth(i,j,3,n)*(1.+0.61*qvh(i,j,3,n))
        fu=-r_air*tv/ga/pmean
        hlev1=fu*(plev1-ps(i,j,1,n))   ! HEIGTH OF FIRST MODEL LAYER
        ff10m= sqrt(u10(i,j,1,n)**2+v10(i,j,1,n)**2)
        fflev1=sqrt(uuh(i,j,3)**2+vvh(i,j,3)**2)
        call pbl_profile(ps(i,j,1,n),td2(i,j,1,n),hlev1, &
             tt2(i,j,1,n),tth(i,j,3,n),ff10m,fflev1, &
             sfcstress(i,j,1,n),sshf(i,j,1,n))
        if(sshf(i,j,1,n).gt.200.) sshf(i,j,1,n)=200.
        if(sshf(i,j,1,n).lt.-400.) sshf(i,j,1,n)=-400.
      end do
    end do
  endif


  ! Assign 10 m wind to model level at eta=1.0 to have one additional model
  ! level at the ground
  ! Specific humidity is taken the same as at one level above
  ! Temperature is taken as 2 m temperature
  !**************************************************************************

  forall (i=0:nxmin1, j=0:nymin1)
      uuh(i,j,1)=u10(i,j,1,n)
      vvh(i,j,1)=v10(i,j,1,n)
      qvh(i,j,1,n)=qvh(i,j,2,n)
      tth(i,j,1,n)=tt2(i,j,1,n)
  end forall

  if(iumax.ne.nuvz-1) error stop 'READWIND: NUVZ NOT CONSISTENT'
  if(iwmax.ne.nwz)    error stop 'READWIND: NWZ NOT CONSISTENT'

  return

888 write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfname(indj),'                    #### '
  write(*,*) ' #### IS NOT GRIB FORMAT !!!                  #### '
  error stop 'Execution terminated'

end subroutine readwind_ecmwf

subroutine readwind_gfs(indj,n,uuh,vvh,wwh)

  !***********************************************************************
  !                                                                      *
  !              TRAJECTORY MODEL SUBROUTINE READWIND                    *
  !                                                                      *
  !***********************************************************************
  !                                                                      *
  !              AUTHOR:      G. WOTAWA                                  *
  !              DATE:        1997-08-05                                 *
  !              LAST UPDATE: 2000-10-17, Andreas Stohl                  *
  !              CHANGE: 01/02/2001, Bernd C. Krueger, Variables tth and *
  !                      qvh (on eta coordinates) in common block        *
  !              CHANGE: 16/11/2005, Caroline Forster, GFS data          *
  !              CHANGE: 11/01/2008, Harald Sodemann, Input of GRIB1/2   *
  !                      data with the ECMWF grib_api library            *
  !              CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
  !                                  ECMWF grib_api                      *
  !                                                                      *
  !   Unified ECMWF and GFS builds                                       *
  !   Marian Harustak, 12.5.2017                                         *
  !     - Renamed routine from readwind to readwind_gfs                  *
  !                                                                      *
  !   Petra Seibert, Anne Tipka, 2021-02: implement new interpolation    *
  !   just catch numpf>1 and produce error msg, adjust rank of precip    *
  !   and correct some loops in bad order                                *
  !                                                                      *
  !                                                                      *  
  !  Anne Tipka, Petra Seibert 2021-02: implement new interpolation      *
  !    for precipitation according to #295 using 2 additional fields     *
  !    change some double loops in wrong order to forall constructs      *
  !                                                                      *
  !***********************************************************************
  !*                                                                     *
  !* DESCRIPTION:                                                        *
  !*                                                                     *
  !* READING OF ECMWF METEOROLOGICAL FIELDS FROM INPUT DATA FILES. THE   *
  !* INPUT DATA FILES ARE EXPECTED TO BE AVAILABLE IN GRIB CODE          *
  !*                                                                     *
  !* INPUT:                                                              *
  !* indj               indicates number of the wind field to be read in *
  !* n                  temporal index for meteorological fields (1 to 3)*
  !*                                                                     *
  !* IMPORTANT VARIABLES FROM COMMON BLOCK:                              *
  !*                                                                     *
  !* wfname             File name of data to be read in                  *
  !* nx,ny,nuvz,nwz     expected field dimensions                        *
  !* nlev_ec            number of vertical levels ecmwf model            *
  !* uu,vv,ww           wind fields                                      *
  !* tt,qv              temperature and specific humidity                *
  !* ps                 surface pressure                                 *
  !*                                                                     *
  !***********************************************************************

  use grib_api
  use qvsat_mod

  implicit none

  !HSO  new parameters for grib_api
  integer :: ifile
  integer :: iret,size1,size2,stat
  integer :: igrib
  integer :: ipf 
  integer :: gribVer,parCat,parNum,typSfc,valSurf,discipl
  !HSO end edits
  real :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: wwh(0:nxmax-1,0:nymax-1,nwzmax)
  integer :: ii,indj,i,j,k,n,levdiff2,ifield,iumax,iwmax

  ! NCEP
  integer :: numpt,numpu,numpv,numpw,numprh,numpclwch
  real :: help, temp
  real :: elev
  real :: ulev1(0:nxmax-1,0:nymax-1),vlev1(0:nxmax-1,0:nymax-1)
  real :: tlev1(0:nxmax-1,0:nymax-1)
  real :: qvh2(0:nxmax-1,0:nymax-1)

  integer :: i179,i180,i181

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING
  !HSO kept isec1, isec2 and zsec4 for consistency with gribex GRIB input

  integer :: isec1(8),isec2(3)
  real           :: xsec18  ! IP 29.1.24  
  real(kind=4),allocatable,dimension(:) :: zsec4
  real(kind=4) :: xaux,yaux,xaux0,yaux0
  real(kind=8) :: xauxin,yauxin
  real,parameter :: eps=1.e-4
  real(kind=4) :: ewss(0:nxmax-1,0:nymax-1),nsss(0:nxmax-1,0:nymax-1)
  real :: plev1,hlev1,ff10m,fflev1

  logical :: hflswitch,strswitch

  !HSO  for grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: gribFunction = 'readwind_gfs'
  character(len=20) :: shortname

  if (numpf .gt. 1) goto 777 ! additional precip fields not implemented in GFS
 
  hflswitch=.false.
  strswitch=.false.
  levdiff2=nlev_ec-nwz+1
  iumax=0
  iwmax=0


  ! OPENING OF DATA FILE (GRIB CODE)

  !HSO
  call grib_open_file(ifile,path(3)(1:length(3)) &
         //trim(wfname(indj)),'r',iret)
  if (iret.ne.GRIB_SUCCESS) then
    goto 888   ! ERROR DETECTED
  endif
  !turn on support for multi fields messages
  call grib_multi_support_on

  numpt=0
  numpu=0
  numpv=0
  numpw=0
  numprh=0
  numpclwch=0
  ifield=0
  do
    ifield=ifield+1
    !
    ! GET NEXT FIELDS
    !
    call grib_new_from_file(ifile,igrib,iret)
    if (iret.eq.GRIB_END_OF_FILE)  then
      exit   ! EOF DETECTED
    elseif (iret.ne.GRIB_SUCCESS) then
      goto 888   ! ERROR DETECTED
    endif

    !first see if we read GRIB1 or GRIB2
    call grib_get_int(igrib,'editionNumber',gribVer,iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)

    if (gribVer.eq.1) then ! GRIB Edition 1

    !read the grib1 identifiers
    call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'indicatorOfTypeOfLevel',isec1(7),iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'level',isec1(8),iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)

! IP 01.24: port form nilu dev branch 
!JMA / SH: isec1(8) not evaluated any more below
!b/c with GRIB 2 this may be a real variable
    xsec18 = real(isec1(8))
    
    else ! GRIB Edition 2

    !read the grib2 identifiers
    call grib_get_string(igrib,'shortName',shortname,iret)

    call grib_get_int(igrib,'discipline',discipl,iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'parameterCategory',parCat,iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'parameterNumber',parNum,iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'typeOfFirstFixedSurface',typSfc,iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'scaledValueOfFirstFixedSurface', &
         valSurf,iret)
    !  call grib_check(iret,gribFunction,gribErrorMsg)
    
    !  write(*,*) 'Field: ',ifield,parCat,parNum,typSfc,shortname
    !convert to grib1 identifiers
    isec1(6)=-1
    isec1(7)=-1
    isec1(8)=-1

    xsec18  =-1.0

    if ((parCat.eq.0).and.(parNum.eq.0).and.(typSfc.eq.100)) then ! T
      isec1(6)=11          ! indicatorOfParameter
      isec1(7)=100         ! indicatorOfTypeOfLevel
      isec1(8)=valSurf/100 ! level, convert to hPa
      xsec18=valSurf/100.0 ! level, convert to hPa
    

      ! IPfixgfs11
      call grib_get_size(igrib,'values',size1,iret)
      allocate( zsec4(size1),stat=stat )
      call grib_get_real4_array(igrib,'values',zsec4,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
      deallocate(zsec4)


    elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSfc.eq.100)) then ! U
      isec1(6)=33          ! indicatorOfParameter
      isec1(7)=100         ! indicatorOfTypeOfLevel
      isec1(8)=valSurf/100 ! level, convert to hPa
      xsec18=valSurf/100.0 ! level, convert to hPa

     ! IPfixgfs11
     call grib_get_size(igrib,'values',size1,iret)
     allocate( zsec4(size1),stat=stat )
     call grib_get_real4_array(igrib,'values',zsec4,iret)
     call grib_check(iret,gribFunction,gribErrorMsg)
     deallocate(zsec4)


      
    elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSfc.eq.100)) then ! V
      isec1(6)=34          ! indicatorOfParameter
      isec1(7)=100         ! indicatorOfTypeOfLevel
      isec1(8)=valSurf/100 ! level, convert to hPa
      xsec18=valSurf/100.0 ! level, convert to hPa
    elseif ((parCat.eq.2).and.(parNum.eq.8).and.(typSfc.eq.100)) then ! W
      isec1(6)=39          ! indicatorOfParameter
      isec1(7)=100         ! indicatorOfTypeOfLevel
      isec1(8)=valSurf/100 ! level, convert to hPa
      xsec18=valSurf/100.0 ! level, convert to hPa
    elseif ((parCat.eq.1).and.(parNum.eq.1).and.(typSfc.eq.100)) then ! RH
      isec1(6)=52          ! indicatorOfParameter
      isec1(7)=100         ! indicatorOfTypeOfLevel
      isec1(8)=valSurf/100 ! level, convert to hPa
      xsec18=valSurf/100.0 ! level, convert to hPa
    elseif ((parCat.eq.1).and.(parNum.eq.1).and.(typSfc.eq.103)) then ! RH2
      isec1(6)=52          ! indicatorOfParameter
      isec1(7)=105         ! indicatorOfTypeOfLevel
      isec1(8)=2
      xsec18=real(2)
    elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSfc.eq.103)) then ! T2
      isec1(6)=11          ! indicatorOfParameter
      isec1(7)=105         ! indicatorOfTypeOfLevel
      isec1(8)=2
      xsec18=real(2)
    elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSfc.eq.103)) then ! U10
      isec1(6)=33          ! indicatorOfParameter
      isec1(7)=105         ! indicatorOfTypeOfLevel
      isec1(8)=10
      xsec18=real(10)
    elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSfc.eq.103)) then ! V10
      isec1(6)=34          ! indicatorOfParameter
      isec1(7)=105         ! indicatorOfTypeOfLevel
      isec1(8)=10
      xsec18=real(10)
    elseif ((parCat.eq.1).and.(parNum.eq.22).and.(typSfc.eq.100)) then ! CLWMR Cloud Mixing Ratio [kg/kg]:
      isec1(6)=153         ! indicatorOfParameter
      isec1(7)=100         ! indicatorOfTypeOfLevel
      isec1(8)=valSurf/100 ! level, convert to hPa
      xsec18=valSurf/100.0 ! level, convert to hPa
    elseif ((parCat.eq.3).and.(parNum.eq.1).and.(typSfc.eq.101)) then ! SLP
      isec1(6)=2           ! indicatorOfParameter
      isec1(7)=102         ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSfc.eq.1).and.(discipl.eq.0)) then ! SP
      isec1(6)=1           ! indicatorOfParameter
      isec1(7)=1           ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    elseif ((parCat.eq.1).and.(parNum.eq.13).and.(typSfc.eq.1)) then ! SNOW
      isec1(6)=66          ! indicatorOfParameter
      isec1(7)=1           ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSfc.eq.104)) then ! T sigma 0
      isec1(6)=11          ! indicatorOfParameter
      isec1(7)=107         ! indicatorOfTypeOfLevel
      isec1(8)=0.995       ! lowest sigma level !LB: isec1 is an integer array!!!
      xsec18=0.995         ! lowest sigma level
    elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSfc.eq.104)) then ! U sigma 0
      isec1(6)=33          ! indicatorOfParameter
      isec1(7)=107         ! indicatorOfTypeOfLevel
      isec1(8)=0.995       ! lowest sigma level !LB: isec1 is an integer array!!!
      xsec18=0.995         ! lowest sigma level
    elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSfc.eq.104)) then ! V sigma 0
      isec1(6)=34          ! indicatorOfParameter
      isec1(7)=107         ! indicatorOfTypeOfLevel
      isec1(8)=0.995       ! lowest sigma level !LB: isec1 is an integer array!!!
      xsec18=0.995         ! lowest sigma level
    elseif ((parCat.eq.3).and.(parNum.eq.5).and.(typSfc.eq.1)) then ! TOPO
      isec1(6)=7           ! indicatorOfParameter
      isec1(7)=1           ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSfc.eq.1) &
         .and.(discipl.eq.2)) then ! LSM
      isec1(6)=81          ! indicatorOfParameter
      isec1(7)=1           ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    elseif ((parCat.eq.3).and.(parNum.eq.196).and.(typSfc.eq.1)) then ! BLH
      isec1(6)=221         ! indicatorOfParameter
      isec1(7)=1           ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    elseif ((parCat.eq.1).and.(parNum.eq.7).and.(typSfc.eq.1)) then ! LSP/TP
      isec1(6)=62          ! indicatorOfParameter
      isec1(7)=1           ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    elseif ((parCat.eq.1).and.(parNum.eq.196).and.(typSfc.eq.1)) then ! CP
      isec1(6)=63          ! indicatorOfParameter
      isec1(7)=1           ! indicatorOfTypeOfLevel
      isec1(8)=0
      xsec18=real(0)
    endif

    endif ! gribVer

    if(ifield.eq.1) then

      !get the required fields from section 2
      !store compatible to gribex input
      call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
           isec2(2),iret)
      !  call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
           isec2(3),iret)
      !  call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
           xauxin,iret)
      !  call grib_check(iret,gribFunction,gribErrorMsg)
      call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
           yauxin,iret)
      !  call grib_check(iret,gribFunction,gribErrorMsg)
      xaux=real(xauxin)+real(nxshift)*dx
      yaux=real(yauxin)

      ! CHECK GRID SPECIFICATIONS

      if(isec2(2).ne.nxfield) error stop 'READWIND: NX NOT CONSISTENT'
      if(isec2(3).ne.ny) error stop 'READWIND: NY NOT CONSISTENT'
      ! if(xaux.eq.0.) xaux=-179.0     ! NCEP DATA
      ! IPfixgfs11: revert to working v10.4 settings

      if(xaux.eq.0.) xaux=-180.0     ! NCEP DATA
      
      xaux0=xlon0
      yaux0=ylat0
      if(xaux.lt.0.) xaux=xaux+360.
      if(yaux.lt.0.) yaux=yaux+360.
      if(xaux0.lt.0.) xaux0=xaux0+360.
      if(yaux0.lt.0.) yaux0=yaux0+360.
      if(abs(xaux-xaux0).gt.eps) &
           error stop 'READWIND GFS: LOWER LEFT LONGITUDE NOT CONSISTENT'
      if(abs(yaux-yaux0).gt.eps) &
           error stop 'READWIND GFS: LOWER LEFT LATITUDE NOT CONSISTENT'
    endif
    !HSO end of edits

    if (isec1(6).ne.-1) then
    !  get the size and data of the values array
      call grib_get_size(igrib,'values',size1,iret)
      allocate( zsec4(size1),stat=stat )
      if (stat.ne.0) error stop "Could not allocate zsec4"
      call grib_get_real4_array(igrib,'values',zsec4,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)
    endif

    i179=nint(179./dx)
    if (dx.lt.0.7) then
      i180=nint(180./dx)+1    ! 0.5 deg data
    else
      i180=nint(179./dx)+1    ! 1 deg data
    endif
    i181=i180+1

    ! IPfixgfs11: revert to v10.4 working settings 
    i180=nint(180./dx)
    i181=i180
    i179=i180 
    

    if (isec1(6).ne.-1) then


    do j=0,nymin1
      do i=0,nxfield-1
        if((isec1(6).eq.011).and.(isec1(7).eq.100)) then
    ! TEMPERATURE
           if((i.eq.0).and.(j.eq.0)) then
              !do ii=1,nuvz
              !  if ((isec1(8)*100.0).eq.akz(ii)) numpt=ii
              !end do
            numpt=minloc(abs(xsec18*100.0-akz),dim=1) ! IP 29.1.24
            ! IPfixgfs11
            ! numpt was const 1, and akzs were from not initialized allocation
          endif
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if (help.le.0) then
            write (*, *) 'i, j: ', i, j
            stop 'help <= 0.0 from zsec4'
          endif
!          if(i.le.i180) then ! 1==180 fills missing 0 lines in tth
          if(i.lt.i180) then
            tth(i179+i,j,numpt,n)=help
          else
            tth(i-i181,j,numpt,n)=help
          endif
        endif
        if((isec1(6).eq.033).and.(isec1(7).eq.100)) then
    ! U VELOCITY
           if((i.eq.0).and.(j.eq.0)) then
             ! do ii=1,nuvz
             !   if ((isec1(8)*100.0).eq.akz(ii)) numpu=ii
             ! end do
            numpu=minloc(abs(xsec18*100.0-akz),dim=1)             
          endif
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            uuh(i179+i,j,numpu)=help
          else
            uuh(i-i181,j,numpu)=help
          endif
        endif
        if((isec1(6).eq.034).and.(isec1(7).eq.100)) then
    ! V VELOCITY
           if((i.eq.0).and.(j.eq.0)) then
              !do ii=1,nuvz
              !  if ((isec1(8)*100.0).eq.akz(ii)) numpv=ii
              !end do
             numpv=minloc(abs(xsec18*100.0-akz),dim=1)             
          endif
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            vvh(i179+i,j,numpv)=help
          else
            vvh(i-i181,j,numpv)=help
          endif
        endif
        if((isec1(6).eq.052).and.(isec1(7).eq.100)) then
    ! RELATIVE HUMIDITY -> CONVERT TO SPECIFIC HUMIDITY LATER
           if((i.eq.0).and.(j.eq.0)) then
!              do ii=1,nuvz
!                if ((isec1(8)*100.0).eq.akz(ii)) numprh=ii
!              end do
            numprh=minloc(abs(xsec18*100.0-akz),dim=1)
              
          endif
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            qvh(i179+i,j,numprh,n)=help
          else
            qvh(i-i181,j,numprh,n)=help
          endif
        endif
        if((isec1(6).eq.001).and.(isec1(7).eq.001)) then
    ! SURFACE PRESSURE
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            ps(i179+i,j,1,n)=help
          else
            ps(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.039).and.(isec1(7).eq.100)) then
    ! W VELOCITY
!           if((i.eq.0).and.(j.eq.0)) then
!              do ii=1,nuvz
!                if ((isec1(8)*100.0).eq.akz(ii)) numpw=ii
!              end do
!          endif
          if((i.eq.0).and.(j.eq.0)) numpw=minloc(abs(xsec18*100.0-akz),dim=1)
          
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            wwh(i179+i,j,numpw)=help
          else
            wwh(i-i181,j,numpw)=help
          endif
        endif
        if((isec1(6).eq.066).and.(isec1(7).eq.001)) then
    ! SNOW DEPTH
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            sd(i179+i,j,1,n)=help
          else
            sd(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.002).and.(isec1(7).eq.102)) then
    ! MEAN SEA LEVEL PRESSURE
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            msl(i179+i,j,1,n)=help
          else
            msl(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.071).and.(isec1(7).eq.244)) then
    ! TOTAL CLOUD COVER
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            tcc(i179+i,j,1,n)=help
          else
            tcc(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.033).and.(isec1(7).eq.105).and. &
             (nint(xsec18).eq.10)) then       
!             (isec1(8).eq.10)) then   


    ! 10 M U VELOCITY
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            u10(i179+i,j,1,n)=help
          else
            u10(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.034).and.(isec1(7).eq.105).and. &
        (nint(xsec18).eq.10)) then
!             (isec1(8).eq.10)) then
             
    ! 10 M V VELOCITY
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            v10(i179+i,j,1,n)=help
          else
            v10(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.011).and.(isec1(7).eq.105).and. &
             (nint(xsec18).eq.2)) then
!             (isec1(8).eq.02)) then
            
    ! 2 M TEMPERATURE
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            tt2(i179+i,j,1,n)=help
          else
            tt2(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.017).and.(isec1(7).eq.105).and. &
             (nint(xsec18).eq.2)) then
       !      (isec1(8).eq.02)) then
             
    ! 2 M DEW POINT TEMPERATURE
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            td2(i179+i,j,1,n)=help
          else
            td2(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.062).and.(isec1(7).eq.001)) then
    ! LARGE SCALE PREC.
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            lsprec(i179+i,j,1,1,n)=help
          else
            lsprec(i-i181,j,1,1,n)=help
          endif
        endif
        if((isec1(6).eq.063).and.(isec1(7).eq.001)) then
    ! CONVECTIVE PREC.
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            convprec(i179+i,j,1,1,n)=help
          else
            convprec(i-i181,j,1,1,n)=help
          endif
        endif
        if((isec1(6).eq.007).and.(isec1(7).eq.001)) then
    ! TOPOGRAPHY
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            oro(i179+i,j)=help
            excessoro(i179+i,j)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
          else
            oro(i-i181,j)=help
            excessoro(i-i181,j)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
          endif
        endif
        if((isec1(6).eq.081).and.(isec1(7).eq.001)) then
    ! LAND SEA MASK
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            lsm(i179+i,j)=help
          else
            lsm(i-i181,j)=help
          endif
        endif
        if((isec1(6).eq.221).and.(isec1(7).eq.001)) then
    ! MIXING HEIGHT
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            hmix(i179+i,j,1,n)=help
          else
            hmix(i-i181,j,1,n)=help
          endif
        endif
        if((isec1(6).eq.052).and.(isec1(7).eq.105).and. &
             (isec1(8).eq.02)) then
    ! 2 M RELATIVE HUMIDITY
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            qvh2(i179+i,j)=help
          else
            qvh2(i-i181,j)=help
          endif
        endif
        if((isec1(6).eq.011).and.(isec1(7).eq.107)) then
    ! TEMPERATURE LOWEST SIGMA LEVEL
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            tlev1(i179+i,j)=help
          else
            tlev1(i-i181,j)=help
          endif
        endif
        if((isec1(6).eq.033).and.(isec1(7).eq.107)) then
    ! U VELOCITY LOWEST SIGMA LEVEL
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            ulev1(i179+i,j)=help
          else
            ulev1(i-i181,j)=help
          endif
        endif
        if((isec1(6).eq.034).and.(isec1(7).eq.107)) then
    ! V VELOCITY LOWEST SIGMA LEVEL
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            vlev1(i179+i,j)=help
          else
            vlev1(i-i181,j)=help
          endif
        endif
    ! SEC & IP 12/2018 read GFS clouds
        if((isec1(6).eq.153).and.(isec1(7).eq.100)) then  !! CLWCR  Cloud liquid water content [kg/kg] 
           if((i.eq.0).and.(j.eq.0)) then
            !  do ii=1,nuvz
            !1    if ((isec1(8)*100.0).eq.akz(ii)) numpclwch=ii
            ! end do
            numpclwch=minloc(abs(xsec18*100.0-akz),dim=1)     
          endif
          help=zsec4(nxfield*(ny-j-1)+i+1)
          if(i.lt.i180) then
            clwch(i179+i,j,numpclwch,n)=help
          else
            clwch(i-i181,j,numpclwch,n)=help
          endif
          lcw=.true.
          lcwsum=.true.
        endif


      end do
    end do

    endif

    if((isec1(6).eq.33).and.(isec1(7).eq.100)) then
    ! NCEP ISOBARIC LEVELS
      iumax=iumax+1
    endif

    call grib_release(igrib)

    if (isec1(6).ne.-1) deallocate( zsec4 ) !IP 28/11/23 fix deallocation error
  end do                      !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !

  !HSO close grib file
  call grib_close_file(ifile)
   
  ! SENS. HEAT FLUX
  sshf(:,:,1,n)=0.0     ! not available from gfs.tccz.pgrbfxx files
  hflswitch=.false.    ! Heat flux not available
  ! SOLAR RADIATIVE FLUXES
  ssr(:,:,1,n)=0.0      ! not available from gfs.tccz.pgrbfxx files
  ! EW SURFACE STRESS
  ewss=0.0         ! not available from gfs.tccz.pgrbfxx files
  ! NS SURFACE STRESS
  nsss=0.0         ! not available from gfs.tccz.pgrbfxx files
  strswitch=.false.    ! stress not available

  ! CONVERT TP TO LSP (GRIB2 only)
  if (gribVer.eq.2) then
    do j=0,nymin1
    do i=0,nxfield-1
     if(i.le.i180) then
     if (convprec(i179+i,j,1,1,n).lt.lsprec(i179+i,j,1,1,n)) then ! neg precip would occur
         lsprec(i179+i,j,1,1,n)= &
              lsprec(i179+i,j,1,1,n)-convprec(i179+i,j,1,1,n)
     else
         lsprec(i179+i,j,1,1,n)=0
     endif
     else
     if (convprec(i-i181,j,1,1,n).lt.lsprec(i-i181,j,1,1,n)) then
          lsprec(i-i181,j,1,1,n)= &
               lsprec(i-i181,j,1,1,n)-convprec(i-i181,j,1,1,n)
     else
          lsprec(i-i181,j,1,1,n)=0
     endif
     endif
    enddo
    enddo
  endif
  !HSO end edits


  ! TRANSFORM RH TO SPECIFIC HUMIDITY

  do j=0,ny-1
    do i=0,nxfield-1
      do k=1,nuvz
        help=qvh(i,j,k,n)
        temp=tth(i,j,k,n)
        if (temp .le. 0.0) then 
          write (*, *) 'STOP: TRANSFORM RH TO SPECIFIC HUMIDITY: temp, i, j, k, n'
          write (*, *) temp, i, j, k, n
!          temp = 273.0
          stop
        endif

        plev1=akm(k)+bkm(k)*ps(i,j,1,n)
        !print*, temp,plev1  
        elev=ew(temp,plev1)*help/100.0
        qvh(i,j,k,n)=xmwml*(elev/(plev1-((1.0-xmwml)*elev)))
      end do
    end do
  end do

  ! CALCULATE 2 M DEW POINT FROM 2 M RELATIVE HUMIDITY
  ! USING BOLTON'S (1980) FORMULA
  ! BECAUSE td2 IS NOT AVAILABLE FROM NCEP GFS DATA
  k=2 ! CHECK THIS!!!
  do j=0,ny-1
    do i=0,nxfield-1
        help=qvh2(i,j)
        temp=tt2(i,j,1,n)
        if (temp .le. 0.0) then 
          write (*, *) 'STOP: CALCULATE 2 M DEW POINT FROM 2 M RELATIVE HUMIDITY: temp, i, j, k, n'
          write (*, *) temp, i, j, k, n
!          temp = 273.0
          stop
        endif

        plev1=akm(k)+bkm(k)*ps(i,j,1,n)
        elev=ew(temp,plev1)/100.*help/100.   !vapour pressure in hPa
        td2(i,j,1,n)=243.5/(17.67/log(elev/6.112)-1)+273.
        if (help.le.0.) td2(i,j,1,n)=tt2(i,j,1,n)
    end do
  end do

  if(levdiff2.eq.0) then
    iwmax=nlev_ec+1
    do i=0,nxmin1
      do j=0,nymin1
        wwh(i,j,nlev_ec+1)=0.
      end do
    end do
  endif


  ! For global fields, assign the leftmost data column also to the rightmost
  ! data column; if required, shift whole grid by nxshift grid points
  !*************************************************************************

  if (xglobal) then
    call shift_field_0(ewss,nxfield,ny)
    call shift_field_0(nsss,nxfield,ny)
    call shift_field_0(oro,nxfield,ny)
    call shift_field_0(excessoro,nxfield,ny)
    call shift_field_0(lsm,nxfield,ny)
    call shift_field_0(ulev1,nxfield,ny)
    call shift_field_0(vlev1,nxfield,ny)
    call shift_field_0(tlev1,nxfield,ny)
    call shift_field_0(qvh2,nxfield,ny)
    call shift_field(ps,nxfield,ny,1,1,2,n)
    call shift_field(sd,nxfield,ny,1,1,2,n)
    call shift_field(msl,nxfield,ny,1,1,2,n)
    call shift_field(tcc,nxfield,ny,1,1,2,n)
    call shift_field(u10,nxfield,ny,1,1,2,n)
    call shift_field(v10,nxfield,ny,1,1,2,n)
    call shift_field(tt2,nxfield,ny,1,1,2,n)
    call shift_field(td2,nxfield,ny,1,1,2,n)
    do ipf=1,numpf
      call shift_field(lsprec(:,:,:,ipf,n),nxfield,ny,1,1,1,1)
      call shift_field(convprec(:,:,:,ipf,n),nxfield,ny,1,1,1,1)
    enddo
    call shift_field(sshf,nxfield,ny,1,1,2,n)
    call shift_field(ssr,nxfield,ny,1,1,2,n)
    call shift_field(hmix,nxfield,ny,1,1,2,n)
    call shift_field(tth,nxfield,ny,nuvzmax,nuvz,2,n)
    call shift_field(qvh,nxfield,ny,nuvzmax,nuvz,2,n)
    call shift_field(uuh,nxfield,ny,nuvzmax,nuvz,1,1)
    call shift_field(vvh,nxfield,ny,nuvzmax,nuvz,1,1)
    call shift_field(wwh,nxfield,ny,nwzmax,nwz,1,1)
  ! IP & SEC adding GFS Clouds 20181205
    call shift_field(clwch,nxfield,ny,nuvzmax,nuvz,2,n)
  endif

  do i=0,nxmin1
    do j=0,nymin1
  ! Convert precip. from mm/s -> mm/hour
      convprec(i,j,1,1,n)=convprec(i,j,1,1,n)*3600.
      lsprec(i,j,1,1,n)=lsprec(i,j,1,1,n)*3600.
      sfcstress(i,j,1,n)=sqrt(ewss(i,j)**2+nsss(i,j)**2)
    end do
  end do

  if ((.not.hflswitch).or.(.not.strswitch)) then
  !  write(*,*) 'WARNING: No flux data contained in GRIB file ',
  !    +  wfname(indj)

  ! CALCULATE USTAR AND SSHF USING THE PROFILE METHOD
  !***************************************************************************

    do j=0,nymin1
      do i=0,nxmin1
        hlev1=30.0                     ! HEIGHT OF FIRST MODEL SIGMA LAYER
        ff10m= sqrt(u10(i,j,1,n)**2+v10(i,j,1,n)**2)
        fflev1=sqrt(ulev1(i,j)**2+vlev1(i,j)**2)
        call pbl_profile(ps(i,j,1,n),td2(i,j,1,n),hlev1, &
             tt2(i,j,1,n),tlev1(i,j),ff10m,fflev1, &
             sfcstress(i,j,1,n),sshf(i,j,1,n))
        if(sshf(i,j,1,n).gt.200.) sshf(i,j,1,n)=200.
        if(sshf(i,j,1,n).lt.-400.) sshf(i,j,1,n)=-400.
      end do
    end do
  endif

  if(iumax.ne.nuvz) error stop 'READWIND: NUVZ NOT CONSISTENT'
  if(iumax.ne.nwz) error stop 'READWIND: NWZ NOT CONSISTENT'

  return
  
777 continue
  write(*,*) ' #### FLEXPART MODEL ERROR!                       ####'
  write(*,*) ' #### Additional precip fields not implemented in ####'
  write(*,*) ' #### GFS version                                 ####'
  write(*,*) ' #### Set numpf=1 in par_mod.f90 and recompile!   ####'
  stop 'Execution terminated'
  
888   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfname(indj),'                    #### '
  write(*,*) ' #### IS NOT GRIB FORMAT !!!                  #### '
  error stop 'Execution terminated'

end subroutine readwind_gfs

subroutine readwind_nest(indj,n,uuhn,vvhn,wwhn)
  !                       i   i  o    o    o
  !*****************************************************************************
  !                                                                            *
  !     This routine reads the wind fields for the nested model domains.       *
  !     It is similar to subroutine readwind, which reads the mother domain.   *
  !                                                                            *
  !     Authors: A. Stohl, G. Wotawa                                           *
  !                                                                            *
  !     8 February 1999                                                        *
  !                                                                            *
  !     Last update: 17 October 2000, A. Stohl                                 *
  !                                                                            *
  !                                                                            *  
  !  Anne Tipka, Petra Seibert 2021-02: implement new interpolation            *
  !    for precipitation according to #295 using 2 additional fields           *
  !    change some double loops in wrong order to forall constructs            *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:                                     *
  !        Variables tthn and qvhn (on eta coordinates) in common block        *
  !  CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with ECMWF grib_api    *
  !  CHANGE: 03/12/2008, Harald Sodemann, update to f90 with ECMWF grib_api    *
  !*****************************************************************************

  use grib_api

  implicit none

  integer :: ifile
  integer :: iret,size1,stat
  integer :: igrib
  integer :: istep, ipf, npf ! istep=stepRange for precip field identification
  integer :: gribVer,parCat,parNum,typSfc,discipl,parId
  integer :: gotGrid

  real :: uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: wwhn(0:nxmaxn-1,0:nymaxn-1,nwzmax,maxnests)
  integer :: indj,i,j,l,n,ifield,iumax,iwmax

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  real(kind=4),allocatable,dimension(:) :: zsec4
  ! PS replace isec1, isec2 arrays by scalar values because we don't need
  !    arrays anymore. isec1(X) -> isX, isec2(X) -> jsX  
  integer :: is6, js2, js3, js12
  integer :: k ! (as k, is the level in ECWMF notation, top->bot)
  integer :: kz, kz1 ! (level in FLEXPART notation, bot->top)
  integer :: jy ! y index in FLEXPART notation (S->N)
  integer :: ij ! 2D index unrolled to 1D

  real(kind=4) :: xaux,yaux
  real(kind=8) :: xauxin,yauxin
  real(kind=4),parameter :: eps=1.e-4

  real :: ewss(0:nxmaxn-1,0:nymaxn-1),nsss(0:nxmaxn-1,0:nymaxn-1)
  real :: plev1,pmean,tv,fu,hlev1,ff10m,fflev1
  real :: conversion_factor 

  logical :: hflswitch,strswitch

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: thisSubr  = 'readwind_nest'

  l_loop: do l=1,numbnests
    hflswitch=.false.
    strswitch=.false.
    iumax=0
    iwmax=0

    ifile=0
    igrib=0
    iret=0

    !
    ! OPENING OF DATA FILE (GRIB CODE)
    !
    call grib_open_file(ifile,path(numpath+2*(l-1)+1) &
         (1:length(numpath+2*(l-1)+1))//trim(wfnamen(l,indj)),'r')
    if (iret .ne. GRIB_SUCCESS) goto 888   ! ERROR DETECTED
    !turn on support for multi fields messages */
    !call grib_multi_support_on

    gotGrid=0
    ifield=0

    do
      ifield=ifield+1
      !
      ! GET NEXT FIELDS
      !
      call grib_new_from_file(ifile,igrib,iret)
      if (iret.eq.GRIB_END_OF_FILE)  then
        exit    ! EOF DETECTED
      elseif (iret.ne.GRIB_SUCCESS) then
        goto 888   ! ERROR DETECTED
      endif

      !first see if we read GRIB1 or GRIB2
      call grib_get_int(igrib,'editionNumber',gribVer,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)

      ! AT stepRange is used to identify additional precip fields
      call grib_get_int(igrib,'stepRange',istep,iret)
      call grib_check(iret,thisSubr,gribErrorMsg)
      ipf=istep+1

      if (gribVer.eq.1) then ! GRIB Edition 1

        call grib_get_int(igrib,'indicatorOfParameter',is6,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'level',k,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        ! change code for etadot to code for omega
        if (is6 .eq. 77) is6=135
        conversion_factor=1.

      else ! GRIB Edition 2

        call grib_get_int(igrib,'discipline',discipl,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_int(igrib,'parameterCategory',parCat,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_int(igrib,'parameterNumber',parNum,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_int(igrib,'typeOfFirstFixedSurface',typSfc,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_int(igrib,'level',k,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        call grib_get_int(igrib,'paramId',parId,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)

        !convert to grib1 identifiers
        is6=-1
        conversion_factor=1.
        if (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! T
          is6=130 
        elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 105) then ! U
          is6=131 
        elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 105) then ! V
          is6=132 
        elseif (parCat .eq. 1 .and. parNum .eq. 0 .and. typSfc .eq. 105) then ! Q
          is6=133 
        ! ESO Cloud water is in a) fields CLWC and CIWC, *or* b) field QC 
        elseif (parCat .eq. 1 .and. parNum .eq. 83 .and. typSfc .eq. 105) then ! clwc
          is6=246 
        elseif (parCat .eq. 1 .and. parNum .eq. 84 .and. typSfc .eq. 105) then ! ciwc
          is6=247 
        ! ESO qc(=clwc+ciwc):
        elseif (parCat .eq. 201 .and. parNum .eq. 31 .and. typSfc .eq. 105) then ! qc
          is6=201031 
        elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 1) then !SP
          is6=134 
        elseif (parCat .eq. 2 .and. parNum .eq. 32) then ! W, actually eta dot
          is6=135 
        elseif (parCat .eq. 128 .and. parNum .eq. 77) then ! W, actually eta dot
          is6=135 
        elseif (parCat .eq. 3 .and. parNum .eq. 0 .and. typSfc .eq. 101) then ! SLP
          is6=151 
        elseif (parCat .eq. 2 .and. parNum .eq. 2 .and. typSfc .eq. 103) then ! 10U
          is6=165 
        elseif (parCat .eq. 2 .and. parNum .eq. 3 .and. typSfc .eq. 103) then ! 10V
          is6=166 
        elseif (parCat .eq. 0 .and. parNum .eq. 0 .and. typSfc .eq. 103) then ! 2T
          is6=167 
        elseif (parCat .eq. 0 .and. parNum .eq. 6 .and. typSfc .eq. 103) then ! 2D
          is6=168 
        elseif (parCat .eq. 1 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SD
          is6=141 
          conversion_factor=1000.
        elseif (parCat .eq. 6 .and. parNum .eq. 1 .or. parId .eq. 164) then ! CC
          is6=164 
        elseif (parCat .eq. 1 .and. parNum .eq. 9 .or. parId .eq. 142) then ! LSP
          is6=142 
        elseif (parCat .eq. 1 .and. parNum .eq. 10) then ! CP
          is6=143 
          conversion_factor=1000.
        elseif (parCat .eq. 0 .and. parNum .eq. 11 .and. typSfc .eq. 1) then ! SHF
          is6=146 
        elseif (parCat .eq. 4 .and. parNum .eq. 9 .and. typSfc .eq. 1) then ! SR
          is6=176 
        elseif (parCat .eq. 2 .and. parNum .eq. 38 .or. parId .eq. 180) then ! EWSS --correct
          is6=180 
        elseif (parCat .eq. 2 .and. parNum .eq. 37 .or. parId .eq. 181) then ! NSSS --correct
          is6=181 
        elseif (parCat .eq. 3 .and. parNum .eq. 4) then ! ORO
          is6=129 
        elseif (parCat .eq. 3 .and. parNum .eq. 7 .or. parId .eq. 160) then ! SDO
          is6=160 
        elseif (discipl .eq. 2 .and. parCat .eq. 0 .and. parNum .eq. 0 .and. &
             typSfc .eq. 1) then ! LSM
          is6=172 
        elseif (parNum .eq. 152) then 
          is6=152         ! avoid warning for lnsp    
        else
          print*,'***WARNING: undefined GRiB2 message found!',discipl, &
               parCat,parNum,typSfc
        endif
        if (parId .ne. is6 .and. parId .ne. 77) &
          write(*,*) 'parId',parId, 'is6',is6

      endif ! grib Version conversion

      !HSO  get the required fields from section 2 in a gribex compatible manner
      if(ifield.eq.1) then
        call grib_get_int(igrib,'numberOfPointsAlongAParallel',js2,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'numberOfPointsAlongAMeridian',js3,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_int(igrib,'numberOfVerticalCoordinateValues',js12)
        call grib_check(iret,thisSubr,gribErrorMsg)
        ! CHECK GRID SPECIFICATIONS
        if (js2 .ne. nxn(l)) &
          stop 'READWIND: NX NOT CONSISTENT FOR A NESTING LEVEL'
        if (js3 .ne. nyn(l)) &
          stop 'READWIND: NY NOT CONSISTENT FOR A NESTING LEVEL'
        if (js12/2-1 .ne. nlev_ec) stop 'READWIND: VERTICAL DISCRETIZATION NOT&
          &CONSISTENT FOR A NESTING LEVEL'
       
      endif ! ifield

      !HSO  get the size and data of the values array
      if (is6 .ne. -1) then
        call grib_get_size(igrib,'values',size1,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        allocate(zsec4(size1), stat=stat)
        if (stat.ne.0) error stop "Could not allocate zsec4"

        call grib_get_real4_array(igrib,'values',zsec4,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
      endif

      !HSO  get the second part of the grid dimensions only from GRiB1 messages
      if (is6 .eq. 167 .and. gotGrid .eq. 0) then
      
        call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
          xauxin,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees',yauxin,iret)
        call grib_check(iret,thisSubr,gribErrorMsg)
        
        if (xauxin .gt. 180.) xauxin=xauxin-360.0
        if (xauxin .lt. -180.) xauxin=xauxin+360.0
        
        xaux=real(xauxin)
        yaux=real(yauxin)

        if (abs(xaux-xlon0n(l)).gt.eps) &
        stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT FOR A NESTING LEVEL'
        if (abs(yaux-ylat0n(l)).gt.eps) &
        stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT FOR A NESTING LEVEL'
        gotGrid=1
        
      endif ! gotGrid
      
      kz=nlev_ec-k+2  ! used for all 3D fields except W
      kz1=nlev_ec-k+1 ! used for W

      do j=0,nyn(l)-1
        jy=nyn(l)-j-1
        do i=0,nxn(l)-1
          ij=nxn(l)*jy + i+1
          if (is6 .eq. 130) then ! TEMPERATURE
            tthn(i,j,kz,n,l)=zsec4(ij)
          elseif (is6 .eq. 131) then ! U VELOCITY
            uuhn(i,j,kz,l)=zsec4(ij)
            iumax=max(iumax,kz1)
          elseif (is6 .eq. 132) then ! V VELOCITY
            vvhn(i,j,kz,l)=zsec4(ij)
          elseif (is6 .eq. 133) then ! SPEC. HUMIDITY
            qvhn(i,j,kz,n,l)=zsec4(ij)
            if (qvhn(i,j,kz,n,l) .lt. 0.) qvhn(i,j,kz,n,l) = 0.
  !        necessary because the gridded data may contain spurious negative values
          elseif (is6 .eq. 134) then ! SURF. PRESS.
            psn(i,j,1,n,l)=zsec4(ij)
          elseif (is6 .eq. 135) then ! W VELOCITY
            wwhn(i,j,kz1,l)=zsec4(ij)
            iwmax=max(iwmax,kz1)
          elseif (is6 .eq. 141) then ! SNOW DEPTH
            sdn(i,j,1,n,l)=zsec4(ij)/conversion_factor 
          elseif (is6 .eq. 151) then ! SEA LEVEL PRESS.
            msln(i,j,1,n,l)=zsec4(ij)
          elseif (is6 .eq. 164) then ! CLOUD COVER
            tccn(i,j,1,n,l)=zsec4(ij)
          elseif (is6 .eq. 165) then ! 10 M U VELOCITY
            u10n(i,j,1,n,l)=zsec4(ij)
          elseif (is6 .eq. 166) then ! 10 M V VELOCITY
            v10n(i,j,1,n,l)=zsec4(ij)
          elseif (is6 .eq. 167) then ! 2 M TEMPERATURE
            tt2n(i,j,1,n,l)=zsec4(ij)
          elseif (is6 .eq. 168) then ! 2 M DEW POINT
            td2n(i,j,1,n,l)=zsec4(ij)
          elseif (is6 .eq. 142) then ! LARGE SCALE PREC.
              lsprecn(i,j,1,ipf,n,l)=zsec4(ij)
              if (lsprecn(i,j,1,ipf,n,l).lt.0.) lsprecn(i,j,1,ipf,n,l)=0.
          elseif (is6 .eq. 143) then ! CONVECTIVE PREC.
              convprecn(i,j,1,ipf,n,l)=zsec4(ij)/conversion_factor
              if (convprecn(i,j,1,ipf,n,l).lt.0.) convprecn(i,j,1,ipf,n,l)=0.
          elseif (is6 .eq. 146) then ! SENS. HEAT FLUX
            sshfn(i,j,1,n,l)=zsec4(ij)
            if (zsec4(ij).ne.0.) hflswitch=.true. ! Heat flux available
          elseif (is6 .eq. 176) then ! SOLAR RADIATION
            ssrn(i,j,1,n,l)=zsec4(ij)            
            if (ssrn(i,j,1,n,l).lt.0.) ssrn(i,j,1,n,l)=0.
          elseif (is6 .eq. 180) then ! EW SURFACE STRESS
            ewss(i,j)=zsec4(ij)
          elseif (is6 .eq. 181) then ! NS SURFACE STRESS
            nsss(i,j)=zsec4(ij)
            if (zsec4(ij).ne.0.) strswitch=.true.  ! stress available
          elseif (is6 .eq. 129) then ! ECMWF OROGRAPHY
            oron(i,j,l)=zsec4(ij)/ga
          elseif (is6 .eq. 160) then ! STANDARD DEVIATION OF OROGRAPHY
            excessoron(i,j,l)=zsec4(ij)
          elseif (is6 .eq. 172) then ! ECMWF LAND SEA MASK
            lsmn(i,j,l)=zsec4(ij)
          ! ZHG add reading of cloud water fields
          ! ESO add reading of total cloud water fields
          ! ESO TODO: add check whether either CLWC or CIWC is missing (->error)
          !           if all 3 cw fields exist, use QC and disregard the others
          elseif (is6 .eq. 246) then ! CLWC  Cloud liquid water content [kg/kg]
            clwchn(i,j,kz,n,l)=zsec4(ij)
            lcw_nest(l)=.true.
            lcwsum_nest(l)=.false.
          elseif (is6 .eq. 247) then ! CIWC  Cloud ice water content
            ciwchn(i,j,kz,n,l)=zsec4(ij)
          elseif (is6 .eq. 201031) then ! QC Cloud water content (liq+ice) [kg/kg]
            clwchn(i,j,kz,n,l)=zsec4(ij)
            lcw_nest(l)=.true.
            lcwsum_nest(l)=.true.
          endif

        end do
      end do

      call grib_release(igrib)
      deallocate(zsec4)
    end do                      !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !
    call grib_close_file(ifile)

    !error message if no field found with correct first longitude in it
    if (gotGrid .eq. 0) then
      print*,'***ERROR: input file needs to contain GRiB1-formatted messages'
      stop
    endif

    if (nlev_ec-nwz+1 .eq. 0) then
      iwmax=nlev_ec+1
      wwhn(:,:,iwmax,l)=0.
    endif

    ! Assign 10 m wind to model level at eta=1.0 to have one additional model
    ! level at the ground
    ! Specific humidity is taken the same as at one level above
    ! Temperature is taken as 2 m temperature
    !**************************************************************************
    forall (i=0:nxn(l)-1,j=0:nyn(l)-1) &
        sfcstressn(i,j,1,n,l)=sqrt(ewss(i,j)**2+nsss(i,j)**2)


    if ((.not.hflswitch).or.(.not.strswitch)) then
      write(*,*) 'WARNING: No flux data contained in GRIB file ', &
           wfnamen(l,indj)

    ! CALCULATE USTAR AND SSHF USING THE PROFILE METHOD
    ! As ECMWF has increased the model resolution, such that now the first model
    ! level is at about 10 m (where 10-m wind is given), use the 2nd ECMWF level
    ! (3rd model level in FLEXPART) for the profile method
    !***************************************************************************

      do j=0,nyn(l)-1
        do i=0,nxn(l)-1
          plev1=akz(3)+bkz(3)*psn(i,j,1,n,l)
          pmean=0.5*(psn(i,j,1,n,l)+plev1)
          tv=tthn(i,j,3,n,l)*(1.+0.61*qvhn(i,j,3,n,l))
          fu=-r_air*tv/ga/pmean
          hlev1=fu*(plev1-psn(i,j,1,n,l)) ! HEIGHT OF FIRST MODEL LAYER
          ff10m= sqrt(u10n(i,j,1,n,l)**2+v10n(i,j,1,n,l)**2)
          fflev1=sqrt(uuhn(i,j,3,l)**2+vvhn(i,j,3,l)**2)
          call pbl_profile(psn(i,j,1,n,l),td2n(i,j,1,n,l),hlev1, &
               tt2n(i,j,1,n,l),tthn(i,j,3,n,l),ff10m,fflev1, &
               sfcstressn(i,j,1,n,l),sshfn(i,j,1,n,l))
          if (sshfn(i,j,1,n,l) .gt. +200.) sshfn(i,j,1,n,l)=+200.
          if (sshfn(i,j,1,n,l) .lt. -400.) sshfn(i,j,1,n,l)=-400.
        end do
      enddo

    endif
    
    ! Assign 10 m wind to model level at eta=1.0 to have one additional model
    ! level at the ground
    ! Specific humidity is taken the same as at one level above
    ! Temperature is taken as 2 m temperature
    !**************************************************************************

    forall (i=0:nxn(l)-1, j=0:nyn(l)-1)
      uuhn(i,j,1,l)=u10n(i,j,1,n,l)
      vvhn(i,j,1,l)=v10n(i,j,1,n,l)
      qvhn(i,j,1,n,l)=qvhn(i,j,2,n,l)
      tthn(i,j,1,n,l)=tt2n(i,j,1,n,l)
    end forall


    if(iumax.ne.nuvz-1) error stop &
         'READWIND: NUVZ NOT CONSISTENT FOR A NESTING LEVEL'
    if(iwmax.ne.nwz) error stop &
         'READWIND: NWZ NOT CONSISTENT FOR A NESTING LEVEL'

  end do l_loop

  return
888   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfnamen(l,indj),' FOR NESTING LEVEL  #### '
  write(*,*) ' #### ',l,' IS NOT GRIB FORMAT !!!           #### '
  error stop 'Execution terminated'

end subroutine readwind_nest

subroutine shift_field_0(field,nxf,nyf)
  !                          i/o   i   i
  !*****************************************************************************
  !                                                                            *
  !  This subroutine shifts global fields by nxshift grid cells, in order to   *
  !  facilitate all sorts of nested wind fields, or output grids, which,       *
  !  without shifting, would overlap with the domain "boundary".               *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    3 July 2002                                                             *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: nxf,nyf,ix,jy,ixs
  real :: field(0:nxmax-1,0:nymax-1),xshiftaux(0:nxmax-1)

  ! Loop over y and z
  !******************

  do jy=0,nyf-1

  ! Shift the data
  !***************

    if (nxshift.ne.0) then
      do ix=0,nxf-1
        if (ix.ge.nxshift) then
          ixs=ix-nxshift
        else
          ixs=nxf-nxshift+ix
        endif
        xshiftaux(ixs)=field(ix,jy)
      end do
      do ix=0,nxf-1
        field(ix,jy)=xshiftaux(ix)
      end do
    endif

  ! Repeat the westernmost grid cells at the easternmost domain "boundary"
  !***********************************************************************

    field(nxf,jy)=field(0,jy)
  end do

  return
end subroutine shift_field_0

subroutine shift_field(field,nxf,nyf,nzfmax,nzf,nmax,n)
  !                        i/o   i   i    i     i   i   i
  !*****************************************************************************
  !                                                                            *
  !  This subroutine shifts global fields by nxshift grid cells, in order to   *
  !  facilitate all sorts of nested wind fields, or output grids, which,       *
  !  without shifting, would overlap with the domain "boundary".               *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    3 July 2002                                                             *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: nxf,nyf,nzf,n,ix,jy,kz,ixs,nzfmax,nmax
  real :: field(0:nxmax-1,0:nymax-1,nzfmax,nmax),xshiftaux(0:nxmax-1)

  ! Loop over y and z
  !******************

  do kz=1,nzf
    do jy=0,nyf-1

  ! Shift the data
  !***************

      if (nxshift.ne.0) then
        do ix=0,nxf-1
          if (ix.ge.nxshift) then
            ixs=ix-nxshift
          else
            ixs=nxf-nxshift+ix
          endif
          xshiftaux(ixs)=field(ix,jy,kz,n)
        end do
        do ix=0,nxf-1
          field(ix,jy,kz,n)=xshiftaux(ix)
        end do
      endif

  ! Repeat the westernmost grid cells at the easternmost domain "boundary"
  !***********************************************************************

      field(nxf,jy,kz,n)=field(0,jy,kz,n)
    end do
  end do
end subroutine shift_field

subroutine alloc_fixedfields
  implicit none
  integer :: stat

  allocate(oro(0:nxmax-1,0:nymax-1),stat=stat)
  if (stat.ne.0) error stop "Could not allocate oro"
  allocate(excessoro(0:nxmax-1,0:nymax-1),stat=stat)
  if (stat.ne.0) error stop "Could not allocate excessoro"
  allocate(lsm(0:nxmax-1,0:nymax-1),stat=stat)
  if (stat.ne.0) error stop "Could not allocate lsm"
end subroutine alloc_fixedfields

subroutine alloc_fixedfields_nest
  implicit none 
  integer :: stat

  allocate(oron(0:nxmaxn-1,0:nymaxn-1,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate oron"
  allocate(excessoron(0:nxmaxn-1,0:nymaxn-1,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate excessoron"
  allocate(lsmn(0:nxmaxn-1,0:nymaxn-1,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate lsmn"
end subroutine alloc_fixedfields_nest

subroutine alloc_windfields
  implicit none
  integer :: stat
  ! Eta coordinates
  !****************
#ifdef ETA
  allocate(uueta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate uueta"
  allocate(vveta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate vveta"
  allocate(wweta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wweta"
  allocate(uupoleta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate uupoleta"
  allocate(vvpoleta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate vvpoleta"
  allocate(tteta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tteta"
  allocate(pveta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate pveta"
  allocate(prseta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate prseta"
  allocate(rhoeta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate rhoeta"
  allocate(drhodzeta(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate drhodzeta"
#endif
  allocate(etauvheight(0:nxmax-1,0:nymax-1,nuvzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate etauvheight"
  allocate(etawheight(0:nxmax-1,0:nymax-1,nuvzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate etawheight"

  ! Intrinsic coordinates
  !**********************
  allocate(uu(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate uu"
  allocate(vv(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate vv"
  allocate(ww(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ww"
  allocate(uupol(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate uupol"
  allocate(vvpol(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate vvpol"
  allocate(tt(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tt"
  allocate(tth(0:nxmax-1,0:nymax-1,nuvzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tth"
  allocate(pv(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate pv"
  allocate(qv(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate qv"
  allocate(qvh(0:nxmax-1,0:nymax-1,nuvzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate qvh"
  allocate(rho(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate rho"
  allocate(drhodz(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate drhodz"
  allocate(pplev(0:nxmax-1,0:nymax-1,nuvzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate pplev"
  allocate(prs(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate prs"
  allocate(rho_dry(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate rho_dry"

  ! Cloud data
  !***********
  allocate(clwc(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate clwc"
  allocate(ciwc(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ciwc"
  allocate(clwch(0:nxmax-1,0:nymax-1,nuvzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate clwch"
  allocate(ciwch(0:nxmax-1,0:nymax-1,nuvzmax,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ciwch"

  clwc=0.0
  ciwc=0.0
  clwch=0.0
  ciwch=0.0

  allocate(ctwc(0:nxmax-1,0:nymax-1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ctwc"
  allocate(icloudbot(0:nxmax-1,0:nymax-1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate icloudbot"
  allocate(icloudtop(0:nxmax-1,0:nymax-1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate icloudtop"

  ! 2d fields
  !**********
  allocate(ps(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ps"
  allocate(sd(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate sd"
  allocate(msl(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate msl"
  allocate(tcc(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tcc"
  allocate(u10(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate u10"
  allocate(v10(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate v10"
  allocate(tt2(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tt2"
  allocate(td2(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate td2"
  allocate(lsprec(0:nxmax-1,0:nymax-1,1,numpf,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate lsprec"
  allocate(convprec(0:nxmax-1,0:nymax-1,1,numpf,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate convprec"
  allocate(sshf(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate sshf"
  allocate(ssr(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ssr"
  allocate(sfcstress(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate sfcstress"
  allocate(ustar(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ustar"
  allocate(wstar(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wstar"
  allocate(hmix(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate hmix"
  allocate(tropopause(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tropopause"
  allocate(oli(0:nxmax-1,0:nymax-1,1,numwfmem),stat=stat)
  if (stat.ne.0) error stop "Could not allocate oli"

  ! Vertical descritisation arrays
  !*******************************
  allocate(height(nzmax),wheight(nzmax),uvheight(nzmax),stat=stat)
  if (stat.ne.0) error stop "Could not allocate height arrays"
  allocate(akm(nwzmax),bkm(nwzmax),akz(nuvzmax),bkz(nuvzmax), &
    aknew(nzmax),bknew(nzmax),stat=stat)
  if (stat.ne.0) error stop "Could not allocate model level parameters"
end subroutine alloc_windfields

subroutine alloc_windfields_nest
  !*******************************************************************************    
  ! Dynamic allocation of arrays
  !
  ! For nested wind fields. 
  ! 
  !*******************************************************************************
  implicit none 
  integer :: stat

  allocate(uun(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate uun"
  allocate(vvn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate vvn"
  allocate(wwn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wwn"
  allocate(ttn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ttn"
  allocate(qvn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate qvn"
  allocate(pvn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate pvn"
  allocate(clwcn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate clwcn"
  allocate(ciwcn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ciwcn"

  ! ETA equivalents
#ifdef ETA
  allocate(uuetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate uuetan"
  allocate(vvetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate vvetan"
  allocate(wwetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wwetan"
  allocate(ttetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ttetan"
  allocate(pvetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate pvetan"
  allocate(prsetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests) ,stat=stat)
  if (stat.ne.0) error stop "Could not allocate prsetan"
  allocate(rhoetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate rhoetan"
  allocate(drhodzetan(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate drhodzetan"
#endif
  allocate(etauvheightn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate etauvheightn"
  allocate(etawheightn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate etawheightn"

  allocate(icloudbotn(0:nxmax-1,0:nymax-1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate icloudbotn"
  allocate(icloudtopn(0:nxmax-1,0:nymax-1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate icloudtopn"
  allocate(prsn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate prsn"
  allocate(rhon(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate rhon"
  allocate(drhodzn(0:nxmaxn-1,0:nymaxn-1,nzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate drhodzn"
  allocate(tthn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tthn"
  allocate(qvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate qvhn"
  allocate(clwchn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate clwchn"
  allocate(ciwchn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ciwchn"
  allocate(ctwcn(0:nxmaxn-1,0:nymaxn-1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ctwcn"

  ! 2d fields
  !***********
  allocate(psn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate psn"
  allocate(sdn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate sdn"
  allocate(msln(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate msln"
  allocate(tccn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tccn"
  allocate(u10n(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate u10n"
  allocate(v10n(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate v10n"
  allocate(tt2n(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tt2n"
  allocate(td2n(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate td2n"
  allocate(lsprecn(0:nxmaxn-1,0:nymaxn-1,1,numpf,numwfmem,maxnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate lsprecn"
  allocate(convprecn(0:nxmaxn-1,0:nymaxn-1,1,numpf,numwfmem,maxnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate convprecn"
  allocate(sshfn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate sshfn"
  allocate(ssrn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ssrn"
  allocate(sfcstressn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate sfcstressn"
  allocate(ustarn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ustarn"
  allocate(wstarn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wstarn"
  allocate(hmixn(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate hmixn"
  allocate(tropopausen(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate tropopausen"
  allocate(olin(0:nxmaxn-1,0:nymaxn-1,1,numwfmem,numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate olin"

  ! Initialise
  !************  
  clwcn(:,:,:,:,:)=0.
  ciwcn(:,:,:,:,:)=0.
  clwchn(:,:,:,:,:)=0.
  ciwchn(:,:,:,:,:)=0.
end subroutine alloc_windfields_nest

subroutine alloc_nest_properties
  implicit none 
  integer :: stat

  allocate(nxn(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate nxn"
  allocate(nyn(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate nyn"
  allocate(dxn(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate dxn"
  allocate(dyn(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate dyn"
  allocate(xlon0n(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate xlon0n"
  allocate(ylat0n(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate ylat0n"

  allocate(xresoln(0:numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate xresoln"
  allocate(yresoln(0:numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate yresoln"
  allocate(xln(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate xln"
  allocate(yln(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate yln"
  allocate(xrn(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate xrn"
  allocate(yrn(numbnests),stat=stat)
  if (stat.ne.0) error stop "Could not allocate yrn"
end subroutine alloc_nest_properties

subroutine dealloc_windfields_nest
  
  deallocate(wfnamen)

  deallocate(nxn,nyn,dxn,dyn,xlon0n,ylat0n)

  deallocate(oron,excessoron,lsmn)

  deallocate(uun,vvn,wwn,ttn,qvn,pvn,clwcn,ciwcn, &
    rhon,prsn,drhodzn,tthn,qvhn,clwchn,ciwchn,ctwcn,etauvheightn,etawheightn)

#ifdef ETA
  deallocate(uuetan,vvetan,wwetan,ttetan,pvetan,prsetan,rhoetan, &
    drhodzetan)
#endif

  deallocate(psn,sdn,msln,tccn,u10n,v10n,tt2n,td2n,lsprecn,convprecn, &
    sshfn,ssrn,sfcstressn,ustarn,wstarn,hmixn,tropopausen,olin)

  deallocate(xresoln,yresoln,xln,yln,xrn,yrn)
end subroutine dealloc_windfields_nest

subroutine dealloc_windfields
  implicit none

  deallocate(wftime,wfname)
  deallocate(oro,excessoro,lsm)

#ifdef ETA
  deallocate(uueta,vveta,wweta,uupoleta,vvpoleta,tteta,pveta, &
    prseta,rhoeta,drhodzeta)
#endif

  deallocate(etauvheight,etawheight)
  
  deallocate(uu,vv,ww,uupol,vvpol,tt,tth,qv,qvh,pv,rho,drhodz,pplev,prs,rho_dry)

  deallocate(clwc,ciwc,clwch,ciwch,ctwc)

  deallocate(ps,sd,msl,tcc,u10,v10,tt2,td2,lsprec,convprec,sshf,ssr,sfcstress, &
    ustar,wstar,hmix,tropopause,oli)

  deallocate(height,wheight,uvheight,akm,bkm,akz,bkz,aknew,bknew)
end subroutine dealloc_windfields

end module windfields_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine windalign(u,v,ffap,ffcp,ux,vy)
  !                     i i  i    i   o  o
  !*****************************************************************************
  !                                                                            *
  !  Transformation from along- and cross-wind components to u and v           *
  !  components.                                                               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     3 June 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ffap  turbulent wind in along wind direction                               *
  ! ffcp  turbulent wind in cross wind direction                               *
  ! u     main wind component in x direction                                   *
  ! ux    turbulent wind in x direction                                        *
  ! v     main wind component in y direction                                   *
  ! vy    turbulent wind in y direction                                        *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real :: u,v,ffap,ffcp,ux,vy,ffinv,ux1,ux2,vy1,vy2,sinphi,cosphi
  real,parameter :: eps=1.e-30


  ! Transform along wind components
  !********************************

  ffinv=1./max(sqrt(u*u+v*v),eps)
  sinphi=v*ffinv
  vy1=sinphi*ffap
  cosphi=u*ffinv
  ux1=cosphi*ffap


  ! Transform cross wind components
  !********************************

  ux2=-sinphi*ffcp
  vy2=cosphi*ffcp


  ! Add contributions from along and cross wind components
  !*******************************************************

  ux=ux1+ux2
  vy=vy1+vy2

end subroutine windalign

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine outgrid_init
  !
  !*****************************************************************************
  !                                                                            *
  !  This routine initializes the output grids                                 *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! area               surface area of all output grid cells                   *
  ! areaeast           eastward facing wall area of all output grid cells      *
  ! areanorth          northward facing wall area of all output grid cells     *
  ! volume             volumes of all output grid cells                        *
  !                                                                            *
  !*****************************************************************************

  use flux_mod
  use oh_mod
  use unc_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: ix,jy,kz,i,nage,l,iix,jjy,ixp,jyp,i1,j1,j,ngrid
  integer :: ks,kp,stat
  real :: ylat,gridarea,ylatp,ylatm,hzone,cosfactm,cosfactp
  real :: xlon,xl,yl,ddx,ddy,rddx,rddy,p1,p2,p3,p4,xtn,ytn,oroh
  real,parameter :: eps=nxmax/3.e5


  ! Compute surface area and volume of each grid cell: area, volume;
  ! and the areas of the northward and eastward facing walls: areaeast, areanorth
  !***********************************************************************
  do jy=0,numygrid-1
    ylat=outlat0+(real(jy)+0.5)*dyout
    ylatp=ylat+0.5*dyout
    ylatm=ylat-0.5*dyout
    if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
      hzone=dyout*r_earth*pi180
    else

  ! Calculate area of grid cell with formula M=2*pi*R*h*dx/360,
  ! see Netz, Formeln der Mathematik, 5. Auflage (1983), p.90
  !************************************************************

      cosfactp=cos(ylatp*pi180)
      cosfactm=cos(ylatm*pi180)
      if (cosfactp.lt.cosfactm) then
        hzone=sqrt(1-cosfactp**2)- &
             sqrt(1-cosfactm**2)
        hzone=hzone*r_earth
      else
        hzone=sqrt(1-cosfactm**2)- &
             sqrt(1-cosfactp**2)
        hzone=hzone*r_earth
      endif
    endif

  ! Surface are of a grid cell at a latitude ylat
  !**********************************************

    gridarea=2.*pi*r_earth*hzone*dxout/360.

    do ix=0,numxgrid-1
      area(ix,jy)=gridarea

  ! Volume = area x box height
  !***************************

      volume(ix,jy,1)=area(ix,jy)*outheight(1)
      areaeast(ix,jy,1)=dyout*r_earth*pi180*outheight(1)
      areanorth(ix,jy,1)=cos(ylat*pi180)*dxout*r_earth*pi180* &
           outheight(1)
      do kz=2,numzgrid
        areaeast(ix,jy,kz)=dyout*r_earth*pi180* &
             (outheight(kz)-outheight(kz-1))
        areanorth(ix,jy,kz)=cos(ylat*pi180)*dxout*r_earth*pi180* &
             (outheight(kz)-outheight(kz-1))
        volume(ix,jy,kz)=area(ix,jy)*(outheight(kz)-outheight(kz-1))
      end do
    end do
  end do




  !******************************************************************
  ! Determine average height of model topography in output grid cells
  !******************************************************************

  ! Loop over all output grid cells
  !********************************

  do jjy=0,numygrid-1
    do iix=0,numxgrid-1
      oroh=0.

  ! Take 100 samples of the topography in every grid cell
  !******************************************************

      do j1=1,10
        ylat=outlat0+(real(jjy)+real(j1)/10.-0.05)*dyout
        yl=(ylat-ylat0)/dy
        do i1=1,10
          xlon=outlon0+(real(iix)+real(i1)/10.-0.05)*dxout
          xl=(xlon-xlon0)/dx

  ! Determine the nest we are in
  !*****************************

          ngrid=0
          do j=numbnests,1,-1
            if ((xl.gt.xln(j)+eps).and.(xl.lt.xrn(j)-eps).and. &
                 (yl.gt.yln(j)+eps).and.(yl.lt.yrn(j)-eps)) then
              ngrid=j
              goto 43
            endif
          end do
43        continue

  ! Determine (nested) grid coordinates and auxiliary parameters used for interpolation
  !*****************************************************************************

          if (ngrid.gt.0) then
            xtn=(xl-xln(ngrid))*xresoln(ngrid)
            ytn=(yl-yln(ngrid))*yresoln(ngrid)
            ix=int(xtn)
            jy=int(ytn)
            ddy=ytn-real(jy)
            ddx=xtn-real(ix)
          else
            ix=int(xl)
            jy=int(yl)
            ddy=yl-real(jy)
            ddx=xl-real(ix)
          endif
          ixp=ix+1
          jyp=jy+1
          rddx=1.-ddx
          rddy=1.-ddy
          p1=rddx*rddy
          p2=ddx*rddy
          p3=rddx*ddy
          p4=ddx*ddy

          if (ngrid.gt.0) then
            oroh=oroh+p1*oron(ix ,jy ,ngrid) &
                 + p2*oron(ixp,jy ,ngrid) &
                 + p3*oron(ix ,jyp,ngrid) &
                 + p4*oron(ixp,jyp,ngrid)
          else
            oroh=oroh+p1*oro(ix ,jy) &
                 + p2*oro(ixp,jy) &
                 + p3*oro(ix ,jyp) &
                 + p4*oro(ixp,jyp)
          endif
        end do
      end do

  ! Divide by the number of samples taken
  !**************************************

      oroout(iix,jjy)=oroh/100.
    end do
  end do

  ! if necessary allocate flux fields
  if (iflux.eq.1) then
    allocate(flux(6,0:numxgrid-1,0:numygrid-1,numzgrid, &
         1:nspec,1:maxpointspec_act,1:nageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate flux array '
  endif

  !write (*,*) 'allocating: in a sec',OHREA
  if (OHREA.eqv..TRUE.) then
  !   write (*,*) 'allocating: ',maxxOH,maxyOH,maxzOH
    allocate(OH_field(12,0:maxxOH-1,0:maxyOH-1,maxzOH) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate OH array '
    allocate(OH_field_height(7) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate OH array '
  endif
  ! gridunc,griduncn        uncertainty of outputted concentrations
  allocate(gridunc(0:numxgrid-1,0:numygrid-1,numzgrid,maxspec, &
       maxpointspec_act,nclassunc,maxageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  if (ldirect.gt.0) then
  allocate(wetgridunc(0:numxgrid-1,0:numygrid-1,maxspec, &
       maxpointspec_act,nclassunc,maxageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  allocate(drygridunc(0:numxgrid-1,0:numygrid-1,maxspec, &
       maxpointspec_act,nclassunc,maxageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  endif
  !write (*,*) 'Dimensions for fields', numxgrid,numygrid, &
  !     maxspec,maxpointspec_act,nclassunc,maxageclass

  write (*,*) ' Allocating fields for nested and global output (x,y): ', &
       max(numxgrid,numxgridn),max(numygrid,numygridn) 

  ! allocate fields for concoutput with maximum dimension of outgrid
  ! and outgrid_nest

  allocate(gridsigma(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  allocate(grid(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  allocate(densityoutgrid(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'

  allocate(factor3d(0:max(numxgrid,numxgridn)-1, &
       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  allocate(sparse_dump_r(max(numxgrid,numxgridn)* &
       max(numygrid,numygridn)*numzgrid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  allocate(sparse_dump_i(max(numxgrid,numxgridn)* &
       max(numygrid,numygridn)*numzgrid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'

  ! deposition fields are only allocated for forward runs
  if (ldirect.gt.0) then
     allocate(wetgridsigma(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
     allocate(drygridsigma(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
     allocate(wetgrid(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
     allocate(drygrid(0:max(numxgrid,numxgridn)-1, &
          0:max(numygrid,numygridn)-1),stat=stat)
     if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  endif

  ! Initial condition field

  if (linit_cond.gt.0) then
    allocate(init_cond(0:numxgrid-1,0:numygrid-1,numzgrid,maxspec, &
         maxpointspec_act),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate init_cond'
  endif

  !************************
  ! Initialize output grids
  !************************

  do ks=1,nspec
  do kp=1,maxpointspec_act
    do i=1,numreceptor
  ! Receptor points
      creceptor(i,ks)=0.
    end do
    do nage=1,nageclass
      do jy=0,numygrid-1
        do ix=0,numxgrid-1
          do l=1,nclassunc
  ! Deposition fields
            if (ldirect.gt.0) then
            wetgridunc(ix,jy,ks,kp,l,nage)=0.
            drygridunc(ix,jy,ks,kp,l,nage)=0.
            endif
            do kz=1,numzgrid
              if (iflux.eq.1) then
  ! Flux fields
                 do i=1,5
                   flux(i,ix,jy,kz,ks,kp,nage)=0.
                 end do
              endif
  ! Initial condition field
              if ((l.eq.1).and.(nage.eq.1).and.(linit_cond.gt.0)) &
                   init_cond(ix,jy,kz,ks,kp)=0.
  ! Concentration fields
              gridunc(ix,jy,kz,ks,kp,l,nage)=0.
            end do
          end do
        end do
      end do
    end do
  end do
  end do



end subroutine outgrid_init

module pbl_profile_mod
  use par_mod
  use qvsat_mod

  implicit none

contains

function psih (z,l)

  !*****************************************************************************
  !                                                                            *
  !     Calculation of the stability correction term                           *
  !                                                                            *
  !     AUTHOR: Matthias Langer, adapted by Andreas Stohl (6 August 1993)      *
  !             Update: G. Wotawa, 11 October 1994                             *
  !                                                                            *
  !     Literature:                                                            *
  !     [1] C.A.Paulson (1970), A Mathematical Representation of Wind Speed    *
  !           and Temperature Profiles in the Unstable Atmospheric Surface     *
  !           Layer. J.Appl.Met.,Vol.9.(1970), pp.857-861.                     *
  !                                                                            *
  !     [2] A.C.M. Beljaars, A.A.M. Holtslag (1991), Flux Parameterization over*
  !           Land Surfaces for Atmospheric Models. J.Appl.Met. Vol. 30,pp 327-*
  !           341                                                              *
  !                                                                            *
  !     Variables:                                                             *
  !     L     = Monin-Obukhov-length [m]                                       *
  !     z     = height [m]                                                     *
  !     zeta  = auxiliary variable                                             *
  !                                                                            *
  !     Constants:                                                             *
  !     eps   = 1.2E-38, SUN-underflow: to avoid division by zero errors       *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real :: psih,x,z,zeta,l
  real,parameter :: a=1.,b=0.667,c=5.,d=0.35,eps=1.e-20

  if ((l.ge.0).and.(l.lt.eps)) then
    l=eps
  else if ((l.lt.0).and.(l.gt.(-1.*eps))) then
    l=-1.*eps
  endif

  if ((log10(z)-log10(abs(l))).lt.log10(eps)) then
    psih=0.
  else
    zeta=z/l
    if (zeta.gt.0.) then
      psih = - (1.+0.667*a*zeta)**(1.5) - b*(zeta-c/d)*exp(-d*zeta) &
           - b*c/d + 1.
    else
      x=(1.-16.*zeta)**(.25)
      psih=2.*log((1.+x*x)*0.5)
    end if
  end if

end function psih

real function psim(z,al)

  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION: CALCULATION OF THE STABILITY CORRECTION FUNCTION FOR   *
  !              MOMENTUM AS FUNCTION OF HEIGHT Z AND OBUKHOV SCALE     *
  !              HEIGHT L                                               *
  !                                                                     *
  !**********************************************************************

  implicit none

  real :: z,al,zeta,x,a1,a2

  zeta=z/al
  if(zeta.le.0.) then
  ! UNSTABLE CASE
    x=(1.-15.*zeta)**0.25
    a1=((1.+x)*0.5)**2
    a2=(1.+x**2)*0.5
    psim=log(a1*a2)-2.*atan(x)+pi*0.5
  else
  ! STABLE CASE
    psim=-4.7*zeta
  endif

end function psim

subroutine pbl_profile(ps,td2m,zml1,t2m,tml1,u10m,uml1,stress,hf)

  !********************************************************************
  !                                                                   *
  !                    G. WOTAWA, 1995-07-07                          *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  ! DESCRIPTION: CALCULATION OF FRICTION VELOCITY AND SURFACE SENS-   *
  !              IBLE HEAT FLUX USING THE PROFILE METHOD (BERKOVICZ   *
  !              AND PRAHM, 1982)                                     *
  !                                                                   *
  ! Output now is surface stress instead of ustar                     *
  !                                                                   *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  ! INPUT:                                                            *
  !                                                                   *
  !                                                                   *
  ! ps      surface pressure(Pa)                                      *
  ! td2m    two metre dew point(K)                                    *
  ! zml1    heigth of first model level (m)                           *
  ! t2m     two metre temperature (K)                                 *
  ! tml1    temperature first model level (K)                         *
  ! u10m    ten metre wind speed (ms-1)                               *
  ! uml1    wind speed first model level (ms-1)                       *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  ! OUTPUT:                                                           *
  !                                                                   *
  ! stress  surface stress (i.e., friction velocity (ms-1) squared    *
  !                         multiplied with air density)              *
  ! hf      surface sensible heat flux (Wm-2)                         *
  !                                                                   *
  !********************************************************************
  ! ustar   friction velocity (ms-1)                                  *
  ! maxiter maximum number of iterations                              *
  !********************************************************************

  implicit none

  integer :: iter
  real :: ps,td2m,rhoa,zml1,t2m,tml1,u10m,uml1,ustar,hf
  real :: al,alold,aldiff,tmean,crit
  real :: deltau,deltat,thetastar,e,tv,stress
  integer,parameter :: maxiter=10
  real,parameter    :: r1=0.74

  e=ew(td2m,ps)               ! vapor pressure
  tv=t2m*(1.+0.378*e/ps)   ! virtual temperature
  rhoa=ps/(r_air*tv)       ! air density

  deltau=uml1-u10m         !! Wind Speed difference between
                           !! Model level 1 and 10 m

  if(deltau.le.0.001) then    !! Monin-Obukhov Theory not
    al=9999.               !! applicable --> Set dummy values
    ustar=0.01
    stress=ustar*ustar*rhoa
    hf=0.0
    return
  endif
  deltat=tml1-t2m+0.0098*(zml1-2.)  !! Potential temperature difference
                                    !! between model level 1 and 10 m

  if(abs(deltat).le.0.03) then    !! Neutral conditions
    hf=0.0
    al=9999.
    ustar=(vonkarman*deltau)/ &
         (log(zml1/10.)-psim(zml1,al)+psim(10.,al))
    stress=ustar*ustar*rhoa
    return
  endif

  tmean=0.5*(t2m+tml1)
  crit=(0.0219*tmean*(zml1-2.0)*deltau**2)/ &
       (deltat*(zml1-10.0)**2)
  if((deltat.gt.0).and.(crit.le.1.)) then
                                    !! Successive approximation will
    al=50.                          !! not converge
    ustar=(vonkarman*deltau)/ &
         (log(zml1*0.1)-psim(zml1,al)+psim(10.,al))
    thetastar=(vonkarman*deltat/r1)/ &
         (log(zml1*0.5)-psih(zml1,al)+psih(2.,al))
    hf=rhoa*cpa*ustar*thetastar
    stress=ustar*ustar*rhoa
    return
  endif

  al=9999.                 ! Start iteration assuming neutral conditions
  do iter=1,maxiter
    alold=al
    ustar=(vonkarman*deltau)/ &
         (log(zml1*0.1)-psim(zml1,al)+psim(10.,al))
    thetastar=(vonkarman*deltat/r1)/ &
         (log(zml1*0.5)-psih(zml1,al)+psih(2.,al))
    al=(tmean*ustar**2)/(ga*vonkarman*thetastar)
    aldiff=abs((al-alold)/alold)
    if(aldiff.lt.0.01) exit  !! Successive approximation successful
  end do
  hf=rhoa*cpa*ustar*thetastar
  if(al.gt.9999.) al=9999.
  if(al.lt.-9999.) al=-9999.

  stress=ustar*ustar*rhoa
end subroutine pbl_profile

end module pbl_profile_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine initial_cond_output(itime)
  !                                 i
  !*****************************************************************************
  !                                                                            *
  !     Output of the initial condition sensitivity field.                     *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use point_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: itime,i,ix,jy,kz,ks,kp,sp_count_i,sp_count_r
  real :: sp_fact,fact_recept
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  logical :: sp_zer
  character(len=3) :: anspec


  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  do ks=1,nspec

    write(anspec,'(i3.3)') ks
    open(97,file=path(2)(1:length(2))//'grid_initial'// &
         '_'//anspec,form='unformatted')
    write(97) itime

    do kp=1,maxpointspec_act

      if (ind_rel.eq.1) then
        fact_recept=rho_rel(kp)
      else
        fact_recept=1.
      endif

  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

  ! Write out dummy "wet and dry deposition" fields, to keep same format
  ! as for concentration output
      sp_count_i=0
      sp_count_r=0
      write(97) sp_count_i
      write(97) (sparse_dump_i(i),i=1,sp_count_i)
      write(97) sp_count_r
      write(97) (sparse_dump_r(i),i=1,sp_count_r)
      write(97) sp_count_i
      write(97) (sparse_dump_i(i),i=1,sp_count_i)
      write(97) sp_count_r
      write(97) (sparse_dump_r(i),i=1,sp_count_r)


  ! Write out sensitivity to initial conditions
      sp_count_i=0
      sp_count_r=0
      sp_fact=-1.
      sp_zer=.true.
      do kz=1,numzgrid
        do jy=0,numygrid-1
          do ix=0,numxgrid-1
            if (init_cond(ix,jy,kz,ks,kp).gt.smallnum) then
              if (sp_zer.eqv..true.) then ! first non zero value
                sp_count_i=sp_count_i+1
                sparse_dump_i(sp_count_i)= &
                     ix+jy*numxgrid+kz*numxgrid*numygrid
                sp_zer=.false.
                sp_fact=sp_fact*(-1.)
              endif
              sp_count_r=sp_count_r+1
              sparse_dump_r(sp_count_r)=sp_fact* &
                   init_cond(ix,jy,kz,ks,kp)/xmass(kp,ks)*fact_recept
            else ! concentration is zero
              sp_zer=.true.
            endif
          end do
        end do
      end do
      write(97) sp_count_i
      write(97) (sparse_dump_i(i),i=1,sp_count_i)
      write(97) sp_count_r
      write(97) (sparse_dump_r(i),i=1,sp_count_r)


    end do

    close(97)

  end do


end subroutine initial_cond_output

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readoutgrid_nest

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the output nest.        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     4 June 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dxoutn,dyoutn        grid distances of output nest                         *
  ! numxgridn,numygridn,numzgrid    nest dimensions                            *
  ! outlon0n,outlat0n    lower left corner of nest                             *
  ! outheight(maxzgrid)  height levels of output grid [m]                      *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitoutgrid          unit connected to file OUTGRID                        *
  !                                                                            *
  !*****************************************************************************

  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: stat
  real :: xr,xr1,yr,yr1
  real,parameter :: eps=1.e-4



  ! Open the OUTGRID file and read output grid specifications
  !**********************************************************

  open(unitoutgrid,file=path(1)(1:length(1))//'OUTGRID_NEST', &
       status='old',err=999)


  call skplin(5,unitoutgrid)


  ! 1.  Read horizontal grid specifications
  !****************************************

  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f11.4)') outlon0n
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f11.4)') outlat0n
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,i5)') numxgridn
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,i5)') numygridn
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f12.5)') dxoutn
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f12.5)') dyoutn


    allocate(orooutn(0:numxgridn-1,0:numygridn-1) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
    allocate(arean(0:numxgridn-1,0:numygridn-1) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
    allocate(volumen(0:numxgridn-1,0:numygridn-1,numzgrid) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'

  ! Check validity of output grid (shall be within model domain)
  !*************************************************************

  xr=outlon0n+real(numxgridn)*dxoutn
  yr=outlat0n+real(numygridn)*dyoutn
  xr1=xlon0+real(nxmin1)*dx
  yr1=ylat0+real(nymin1)*dy
  if ((outlon0n+eps.lt.xlon0).or.(outlat0n+eps.lt.ylat0) &
       .or.(xr.gt.xr1+eps).or.(yr.gt.yr1+eps)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! PART OF OUTPUT    ####'
    write(*,*) ' #### NEST IS OUTSIDE MODEL DOMAIN. CHANGE    ####'
    write(*,*) ' #### FILE OUTGRID IN DIRECTORY               ####'
    write(*,'(a)') path(1)(1:length(1))
    stop
  endif

  xoutshiftn=xlon0-outlon0n
  youtshiftn=ylat0-outlat0n
  close(unitoutgrid)
  return


999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE OUTGRID_NEST #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,*) ' #### xxx/flexpart/options                    #### '
  stop

end subroutine readoutgrid_nest

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!*****************************************************************************
!                                                                            *
!   L. Bakels 2022: This module contains the computation of particle         *
!                   trajectories                                             *
!                                                                            *
!*****************************************************************************

module advance_mod
  use point_mod
  use par_mod
  use com_mod
  use interpol_mod
  use cmapf_mod
  use random_mod, only: ran3,iseed1
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use particle_mod
  use turbulence_mod
  use settling_mod
  use windfields_mod, only: nxmax

  implicit none 
    real, parameter ::              &
      eps2=1.e-9,                   &
      eps3=tiny(1.0),               &
      eps_eta=1.e-4
    real ::                         &
      eps

  private :: adv_above_pbl, adv_in_pbl, petterssen_corr, update_xy, pushpartdown

contains
  
subroutine advance(itime,ipart,ithread)

  !*****************************************************************************
  !                                                                            *
  !  Calculation of turbulent particle trajectories utilizing a                *
  !  zero-acceleration scheme, which is corrected by a numerically more        *
  !  accurate Petterssen scheme whenever possible.                             *
  !                                                                            *
  !  Particle positions are read in, incremented, and returned to the calling  *
  !  program.                                                                  *
  !                                                                            *
  !  In different regions of the atmosphere (PBL vs. free troposphere),        *
  !  different parameters are needed for advection, parameterizing turbulent   *
  !  velocities, etc. For efficiency, different interpolation routines have    *
  !  been written for these different cases, with the disadvantage that there  *
  !  exist several routines doing almost the same. They all share the          *
  !  included file 'interpol_mod'. The following                               *
  !  interpolation routines are used:                                          *
  !                                                                            *
  !  interpol_all(_nest)     interpolates everything (called inside the PBL)  *
  !  interpol_misslev(_nest) if a particle moves vertically in the PBL,       *
  !                           additional parameters are interpolated if it     *
  !                           crosses a model level                            *
  !  interpol_wind(_nest)    interpolates the wind and determines the         *
  !                           standard deviation of the wind (called outside   *
  !                           PBL) also interpolates potential vorticity       *
  !  interpol_wind_short(_nest) only interpolates the wind (needed for the    *
  !                           Petterssen scheme)                               *
  !  interpol_vdep(_nest)    interpolates deposition velocities               *
  !                                                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     16 December 1997                                                       *
  !                                                                            *
  !  Changes:                                                                  *
  !                                                                            *
  !  8 April 2000: Deep convection parameterization                            *
  !                                                                            *
  !  May 2002: Petterssen scheme introduced                                    *
  !                                                                            *
  !  2021, L. Bakels:                                                          *
  !         - Separated PBL and above PBL computations in different            *
  !           subroutines                                                      *
  !         - Moved all turbulence computations to turbulence_mod.f90          *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! icbt               1 if particle not transferred to forbidden state,       *
  !                    else -1                                                 *
  ! dawsave            accumulated displacement in along-wind direction        *
  ! dcwsave            accumulated displacement in cross-wind direction        *
  ! dxsave             accumulated displacement in longitude                   *
  ! dysave             accumulated displacement in latitude                    *
  ! h [m]              Mixing height                                           *
  ! lwindinterv [s]    time interval between two wind fields                   *
  ! itime [s]          time at which this subroutine is entered                *
  ! itimec [s]         actual time, which is incremented in this subroutine    *
  ! href [m]           height for which dry deposition velocity is calculated  *
  ! ladvance [s]       Total integration time period                           *
  ! ldirect            1 forward, -1 backward                                  *
  ! ldt [s]            Time step for the next integration                      *
  ! lsynctime [s]      Synchronisation interval of FLEXPART                    *
  ! ngrid              index which grid is to be used                          *
  ! nrand              index for a variable to be picked from rannumb          *
  ! nstop              if > 1 particle has left domain and must be stopped     *
  ! prob               probability of absorption due to dry deposition         *
  ! rannumb(maxrand)   normally distributed random variables                   *
  ! rhoa               air density                                             *
  ! rhograd            vertical gradient of the air density                    *
  ! up,vp,wp           random velocities due to turbulence (along wind, cross  *
  !                    wind, vertical wind                                     *
  ! usig,vsig,wsig     mesoscale wind fluctuations                             *
  ! xt,yt,zt           Particle position                                       *
  !                                                                            *
  !*****************************************************************************

  implicit none
  integer, intent(in) ::          &
    itime,                        & ! time index
    ipart,                        & ! particle index
    ithread                         ! OMP thread starting at 0
  integer ::                      &
    itimec,                       &
    i,j,                          & ! loop variables
    nrand,                        & ! random number used for turbulence
    memindnext,                   & ! seems useless
    ngr                             ! temporary new grid index of moved particle
  real ::                         &
    ux,vy,                        & ! random turbulent velocities above PBL
    tropop,                       & ! height of troposphere
    dxsave,dysave,                & ! accumulated displacement in long and lat
    dawsave,dcwsave,              & ! accumulated displacement in wind directions
    ztseta,wsigeta_tmp              ! real of eta z position
  logical ::                      &
    abovePBL
    ! flag will be set to 'true' if computation needs to be completed above PBL
#ifdef ETA
  real :: weta_settling             ! Settling velocity in eta coordinates
#endif

  eps=nxmax/3.e5

  part(ipart)%nstop=.false.
  do i=1,nmixz
    indzindicator(i,ithread+1)=.true.
  end do
  
  if (DRYDEP) then    ! reset probability for deposition
    depoindicator(:,ithread+1)=.true.
    prob(ipart,:)=0.
  endif
  
  if (lsettling) part(ipart)%settling=0.

  dxsave=0.           ! reset position displacements
  dysave=0.           ! due to mean wind
  dawsave=0.          ! and turbulent wind
  dcwsave=0.

  itimec=itime

  nrand=int(ran3(iseed1(ithread),ithread)*real(maxrand-1))+1

  ! Determine whether lat/long grid or polarstereographic projection
  ! is to be used
  ! Furthermore, determine which nesting level to be used
  !*****************************************************************
  call find_ngrid(part(ipart)%xlon,part(ipart)%ylat)

  !***************************
  ! Interpolate necessary data
  !***************************

  if (abs(itime-memtime(1)).lt.abs(itime-memtime(2))) then
    memindnext=1
  else
    memindnext=2
  endif

  ! Convert z(eta) to z(m) for the turbulence scheme, w(m/s) 
  ! is computed in verttransform_ecmwf.f90
#ifdef ETA
  call update_zeta_to_z(itime,ipart)
  ztseta=real(part(ipart)%zeta)
#else
  ztseta=0.
#endif
  ! Determine nested grid coordinates
  ! Determine the lower left corner and its distance to the current position
  ! Calculate variables for time interpolation
  !*******************************************
  call init_interpol(itime, &
    real(part(ipart)%xlon),real(part(ipart)%ylat), &
    real(part(ipart)%z),ztseta)

  ! Compute maximum mixing height around particle position
  !*******************************************************

  ! Compute height of troposphere and PBL at x-y location of particle
  call interpol_htropo_hmix(tropop,h)
  zeta=real(part(ipart)%z)/h

  !*************************************************************
  ! If particle is in the PBL, interpolate once and then make a
  ! time loop until end of interval is reached
  !*************************************************************
  ! In the PBL we use meters instead of eta coordinates for vertical transport
  
  abovePBL=.true.
  if (zeta.le.1.) then
  
    abovePBL=.false.

    call adv_in_pbl(itime,itimec,&
      dxsave,dysave,dawsave,dcwsave,abovePBL,nrand,ipart,ithread)
#ifdef ETA
    if (lsettling) then
      call w_to_weta(itime,real(part(ipart)%idt),part(ipart)%xlon, &
        part(ipart)%ylat,part(ipart)%z,part(ipart)%zeta, &
        part(ipart)%settling,weta_settling)
      weta=weta+weta_settling
    endif
#endif
  endif 

  !**********************************************************
  ! For all particles that are outside the PBL, make a single
  ! time step. Only horizontal turbulent disturbances are
  ! calculated. Vertical disturbances are reset.
  !**********************************************************

  ! Interpolate the wind
  !*********************
  
  if (abovePBL) call adv_above_pbl(itime,itimec,dxsave,dysave, &
    ux,vy,tropop,nrand,ipart)
    ! Above PBL computation

  !****************************************************************
  ! Add mesoscale random disturbances
  ! This is done only once for the whole lsynctime interval to save
  ! computation time
  !****************************************************************

  ! Mesoscale wind velocity fluctuations are obtained by scaling
  ! with the standard deviation of the grid-scale winds surrounding
  ! the particle location, multiplied by a factor fturbmeso.
  ! The autocorrelation time constant is taken as half the
  ! time interval between wind fields
  !****************************************************************

  if (lturbulence.eq.1) then 
    ! mesoscale turbulence is found to give issues, so turned off
    if (lmesoscale_turb) then
#ifdef ETA
      ztseta=real(part(ipart)%zeta)
      wsigeta_tmp=wsigeta
#else
      ztseta=0.
      wsigeta_tmp=0.
#endif
      call interpol_mesoscale( &
        real(part(ipart)%xlon),real(part(ipart)%ylat), &
        real(part(ipart)%z),ztseta)
      call turbulence_mesoscale(nrand,dxsave,dysave,ipart, &
        usig,vsig,wsig,wsigeta_tmp,eps_eta)
    endif

    !*************************************************************
    ! Transform along and cross wind components to xy coordinates,
    ! add them to u and v, transform u,v to grid units/second
    ! and calculate new position
    !*************************************************************

    call windalign(dxsave,dysave,dawsave,dcwsave,ux,vy)
    dxsave=dxsave+ux   
     ! comment by MC: comment this line to stop particles horizontally for tests
    dysave=dysave+vy
  endif

  call update_xy(dxsave,dysave,ipart)
  if (part(ipart)%nstop) return

  ! If particle above highest model level, set it back into the domain
  !*******************************************************************
  call pushpartdown(ipart)
  
  !************************************************************************
  ! Now we could finish, as this was done in FLEXPART versions up to 4.0.
  ! However, truncation errors of the advection can be significantly
  ! reduced by doing one iteration of the Petterssen scheme, if this is
  ! possible.
  ! Note that this is applied only to the grid-scale winds, not to
  ! the turbulent winds.
  !************************************************************************

  ! The Petterssen scheme can only applied with long time steps (only then u
  ! is the "old" wind as required by the scheme); otherwise do nothing
  !*************************************************************************

  if (part(ipart)%idt .ne. abs(lsynctime)) return

 ! The Petterssen scheme can only be applied if the ending time of the time step
 ! (itime+ldt*ldirect) is still between the two wind fields held in memory;
 ! otherwise do nothing
 !******************************************************************************

  if (abs(itime+part(ipart)%idt*ldirect).gt.abs(memtime(2))) return

  ! Apply it also only if starting and ending point of current time step are on
  ! the same grid; otherwise do nothing
  !*****************************************************************************
  ! ngr = ngrid 
  ! call find_ngrid(part(ipart)%xlon,part(ipart)%ylat)

  if (nglobal .and. real(part(ipart)%ylat).gt.switchnorthg) then
    ngr=-1
  else if (sglobal.and. real(part(ipart)%ylat).lt.switchsouthg) then
    ngr=-2
  else
    ngr=0
    ! Temporary fix for nested layer edges: replaced eps with dxn and dyn (LB)
    do j=numbnests,1,-1
      if (real(part(ipart)%xlon).gt.xln(j)+dxn(j) .and. &
          real(part(ipart)%xlon).lt.xrn(j)-dxn(j) .and. &
          real(part(ipart)%ylat).gt.yln(j)+dyn(j) .and. &
          real(part(ipart)%ylat).lt.yrn(j)-dyn(j)) then
        ngr=j
        exit
      endif
    end do
  endif

  if (ngr.ne.ngrid) return

  call petterssen_corr(itime,ipart)

end subroutine advance

subroutine adv_above_pbl(itime,itimec,dxsave,dysave,ux,vy,tropop,nrand,ipart)

  implicit none
  integer, intent(in) ::          &
    itime,                        & ! time index
    ipart                           ! particle index
  integer, intent(inout) ::       &
    itimec,                       & ! next timestep
    nrand                           ! random number used for turbulence
  real, intent(in) ::             &
    tropop                          ! height of troposphere
  real, intent(inout) ::          &
    ux,vy,                        & ! random turbulent velocities above PBL
    dxsave,dysave                   ! accumulated displacement in long and lat
  real ::                         &
    dt,                           & ! real(ldt)
    xts,yts,zts,ztseta,           & ! local 'real' copy of the particle position
    wp                              ! random turbulence velocities
#ifdef ETA
  real :: weta_settling                   ! settling velocity in eta coordinates
#endif
  integer ::                      &
    insp,nsp                        ! loop variables for number of species

  zts=real(part(ipart)%z)
#ifdef ETA
  ztseta=real(part(ipart)%zeta)
#else
  ztseta=0.
#endif
  xts=real(part(ipart)%xlon)
  yts=real(part(ipart)%ylat)
  if (lsettling) part(ipart)%settling=0.

  call interpol_wind(itime,xts,yts,zts,ztseta)

  ! Compute everything for above the PBL

  ! Assume constant, uncorrelated, turbulent perturbations
  ! In the stratosphere, use a small vertical diffusivity d_strat,
  ! in the troposphere, use a larger horizontal diffusivity d_trop.
  ! Turbulent velocity scales are determined based on sqrt(d_trop/dt)
  !******************************************************************

  part(ipart)%idt=abs(lsynctime-itimec+itime)
  dt=real(part(ipart)%idt)

  if (lturbulence.eq.1) then
    call turbulence_above_pbl(dt,nrand,ux,vy,wp,tropop,zts)
  else
    !sec switch off turbulence
    ux=0.0
    vy=0.0
    wp=0.0
  endif

  ! If particle represents only a single species, add gravitational settling
  ! velocity. The settling velocity is zero for gases
  !*************************************************************************
  ! Does not work in eta coordinates yet
  if (mdomainfill.eq.0) then
    if (lsettling) then
      if ((ipin.ne.3).and.(ipin.ne.4)) then
        do insp=1,nspec
          nsp=insp
          if (xmass(part(ipart)%npoint,nsp).gt.eps3) exit
        end do
      else
        nsp=1
      endif
      ! LB change to eta coords?
      if (density(nsp).gt.0.) then
        call get_settling(xts,yts,zts,nsp,part(ipart)%settling)
#ifdef ETA
        call update_zeta_to_z(itime,ipart)
        if ((ldirect.eq.1).and.(part(ipart)%z+part(ipart)%settling*dt.lt.0.)) then
          part(ipart)%settling=-part(ipart)%z/dt
        endif
        call w_to_weta(itime,dt,part(ipart)%xlon,part(ipart)%ylat, &
          part(ipart)%z,part(ipart)%zeta,part(ipart)%settling,weta_settling)
        weta=weta+weta_settling
#else
        if ((ldirect.eq.1).and.(part(ipart)%z+part(ipart)%settling*dt.lt.0.)) then
          part(ipart)%settling=-part(ipart)%z/dt
        endif
        w=w+part(ipart)%settling
#endif
      end if
    endif
  end if

  ! Calculate position at time step itime+lsynctime
  !************************************************
  dxsave=dxsave+(u+ux)*dt
  dysave=dysave+(v+vy)*dt

#ifdef ETA
      if (wp.ne.0.) then
        call update_zeta_to_z(itime,ipart)
        call update_z(ipart,wp*dt*real(ldirect))
        if (part(ipart)%z.lt.0.) call set_z(ipart,min(h-eps2,-1.*part(ipart)%z))
          ! if particle below ground -> reflection
        call update_z_to_zeta(itime,ipart)
      endif
      call update_zeta(ipart,weta*dt*real(ldirect))
      if (part(ipart)%zeta.ge.1.) call set_zeta(ipart,1.-(part(ipart)%zeta-1.))
      if (part(ipart)%zeta.eq.1.) call update_zeta(ipart,-eps_eta)
#else
      call update_z(ipart,(w+wp)*dt*real(ldirect))
      if (part(ipart)%z.lt.0.) call set_z(ipart,min(h-eps2,-1.*part(ipart)%z))
#endif

end subroutine adv_above_pbl

subroutine adv_in_pbl(itime,itimec, dxsave,dysave,dawsave,dcwsave, abovePBL,  &
  nrand,ipart,ithread)

  use drydepo_mod, only: drydepo_probability

  implicit none

  logical, intent(inout) ::       &
    abovePBL                      
  ! flag will be set to 'true' if computation needs to be completed above PBL
  integer, intent(in) ::          &
    itime,                        & ! time index
    ipart,                        & ! particle index
    ithread                         ! number of the omp thread starting at 0
  real, intent(inout) ::          &
    dxsave,dysave,                & ! accumulated displacement in long and lat
    dawsave,dcwsave               ! accumulated displacement in wind directions
  integer, intent(inout) ::       &
    itimec,                       & ! next timestep
    nrand                           ! random number used for turbulence
  real ::                         &
    dt,                           & ! real(ldt)
    xts,yts,zts,ztseta,           & ! local 'real' copy of the particle position
    rhoa,                         & ! air density, used in CBL
    rhograd                     ! vertical gradient of air density, used in CBL
  integer ::                      &
    loop,                         & ! loop variable for time in the PBL
    nsp,insp                        ! loop variable for species
  real :: vdepo(maxspec)  ! deposition velocities for all species

  eps=nxmax/3.e5
  if (lsettling) part(ipart)%settling=0.

  ! BEGIN TIME LOOP
  !================
  ! For wind_coord_type=ETA:
  ! Within this loop, only METER coordinates are used, and the new z value will
  ! be updated to ETA coordinates at the end
  !****************************************************************************
#ifdef ETA
  call update_zeta_to_z(itime,ipart)
  ztseta=real(part(ipart)%zeta)
#else
  ztseta=0.
#endif

  loop=0
  pbl_loop: do
  
    loop=loop+1
    if (method.eq.1) then
      part(ipart)%idt=min(part(ipart)%idt,abs(lsynctime-itimec+itime))
      itimec=itimec+part(ipart)%idt*ldirect
    else
      part(ipart)%idt=abs(lsynctime)
      itimec=itime+lsynctime
    endif
    dt=real(part(ipart)%idt)
    xts=real(part(ipart)%xlon)
    yts=real(part(ipart)%ylat)
    zts=real(part(ipart)%z)

    zeta=zts/h
    if (loop.eq.1) then ! Temporal interpolation only for the first iteration

      if (ngrid.le.0) then
        xts=real(part(ipart)%xlon)
        yts=real(part(ipart)%ylat)
        call interpol_pbl(itime,xts,yts,zts,ztseta,ithread+1)
      else
        call interpol_pbl(itime,xtn,ytn,zts,ztseta,ithread+1)
      endif

    else

      ! Determine the level below the current position for u,v,rho
      !***********************************************************
      call find_z_level_meters(zts)

      ! If one of the levels necessary is not yet available,
      ! calculate it
      !*****************************************************
      call interpol_pbl_misslev(ithread+1)

    endif

  ! Vertical interpolation of u,v,w,rho and drhodz
  !***********************************************

  ! Vertical distance to the level below and above current position
  ! both in terms of (u,v) and (w) fields
  !****************************************************************

    call interpol_pbl_short(zts,rhoa,rhograd,ithread+1) ! Vertical interpolation

  ! Compute the turbulent disturbances
  ! Determine the sigmas and the timescales 
  !****************************************

    if (lturbulence.eq.1) then
      call turbulence_pbl(ipart,nrand,dt,zts,rhoa,rhograd,ithread) 
      ! Note: zts and nrand get updated

      ! Determine time step for next integration
      !*****************************************
      if (turbswitch) then
        part(ipart)%idt = int( &
          min( tlw, &
               h/max( 2.*abs(part(ipart)%turbvel%w*sigw), 1.e-5 ), &
               0.5/abs(dsigwdz) &
             ) *ctl)
      else
        part(ipart)%idt = int( &
          min( tlw, & 
               h/max( 2.*abs(part(ipart)%turbvel%w), 1.e-5) &
              ) *ctl)
      endif
    else
      part(ipart)%turbvel%u=0.
      part(ipart)%turbvel%v=0.
      part(ipart)%turbvel%w=0.
    endif

    part(ipart)%idt=max(part(ipart)%idt,mintime)


  ! If particle represents only a single species, add gravitational settling
  ! velocity. The settling velocity is zero for gases, or if particle
  ! represents more than one species
  !*************************************************************************

    if (mdomainfill.eq.0) then
      if (lsettling) then
        if ((ipin.ne.3).and.(ipin.ne.4)) then
          do insp=1,nspec
            nsp=insp
            if (xmass(part(ipart)%npoint,nsp).gt.eps3) exit
          end do
        else
          nsp=1
        endif
        if (density(nsp).gt.0.) then
          call get_settling(xts,yts,zts,nsp,part(ipart)%settling)  !bugfix
          if ((ldirect.eq.1).and.(part(ipart)%z+part(ipart)%settling*dt.lt.0.)) then
            part(ipart)%settling=-part(ipart)%z/dt
          endif
          w=w+part(ipart)%settling
        end if
      end if
    endif

  ! Horizontal displacements during time step dt are small real values compared
  ! to the position; adding the two, would result in large numerical errors.
  ! Thus, displacements are accumulated during lsynctime and are added to the
  ! position at the end
  !****************************************************************************

    dxsave=dxsave+u*dt
    dysave=dysave+v*dt
    dawsave=dawsave+part(ipart)%turbvel%u*dt
    dcwsave=dcwsave+part(ipart)%turbvel%v*dt
    ! How can I change the w to w(eta) efficiently?

#ifdef ETA
    call update_z(ipart,w*dt*real(ldirect))
    zts=real(part(ipart)%z)
    ! HSO/AL: Particle managed to go over highest level -> interpolation
    ! error in goto 700
    !          alias interpol_wind (division by zero)
    if (zts.ge.height(nz)) call set_z(ipart,height(nz)-100.*eps) 
     ! Manually for z instead
#else
    call update_z(ipart,w*dt*real(ldirect))
    call pushpartdown(ipart)
#endif
    ! end select
    zts=real(part(ipart)%z)
    
    if (zts.gt.h) then
#ifdef ETA
      call update_z_to_zeta(itime,ipart)
#endif
      if (itimec.ne.itime+lsynctime) abovePBL=.true. 
        ! complete the current interval above PBL
      return 
    endif
    
  ! Determine probability of deposition
  !************************************
    if (DRYDEP) then
      call drydepo_probability(ipart,dt,zts,vdepo,ithread+1)
    endif

    if (zts.lt.0.) call set_z(ipart,min(h-eps2,-1.*part(ipart)%z))    
      ! if particle below ground -> reflection

    if (itimec.eq.(itime+lsynctime)) then
      ! Convert z position that changed by turbulent motions to eta coords
#ifdef ETA
      call update_z_to_zeta(itime,ipart)
#endif
      return  ! finished
    endif

  end do pbl_loop

#ifdef ETA
  call update_z_to_zeta(itime,ipart)
#endif

end subroutine adv_in_pbl

subroutine petterssen_corr(itime,ipart)

  implicit none 

  integer, intent(in) ::          &
    itime,                        & ! time index
    ipart                           ! particle index
  integer ::                      &
    nsp,insp                        ! loop variables for number of species
  real ::                         &
    xts,yts,zts,ztseta,           & ! local 'real' copy of the particle position
    uold,vold
#ifdef ETA
  real :: woldeta,weta_settling ! eta equivalents
#else
  real :: wold
#endif

  xts=real(part(ipart)%xlon)
  yts=real(part(ipart)%ylat)
  zts=real(part(ipart)%z)
#ifdef ETA
  ztseta=real(part(ipart)%zeta)
#else
  ztseta=0.
#endif
  if (lsettling) part(ipart)%settling=0.

  ! Memorize the old wind
  !**********************

  uold=u
  vold=v

#ifdef ETA
    woldeta=weta
#else
    wold=w
#endif

  ! Interpolate wind at new position and time
  !******************************************
  call interpol_wind_short(itime+part(ipart)%idt*ldirect,xts,yts,zts,ztseta)

  if (mdomainfill.eq.0) then
    if (lsettling) then
      if ((ipin.ne.3).and.(ipin.ne.4)) then
        do insp=1,nspec
          nsp=insp
          if (xmass(part(ipart)%npoint,nsp).gt.eps3) exit
        end do
      else
        nsp=1
      endif
      if (density(nsp).gt.0.) then
#ifdef ETA
        call update_zeta_to_z(itime+part(ipart)%idt,ipart)
        call update_z_to_zeta(itime+part(ipart)%idt,ipart)
        zts=real(part(ipart)%z)
        call get_settling(xts,yts,zts,nsp,part(ipart)%settling) !bugfix
        if ((ldirect.eq.1).and. &
          (part(ipart)%z+part(ipart)%settling*part(ipart)%idt.lt.0)) then
          part(ipart)%settling=-part(ipart)%z/part(ipart)%idt
        endif
        call w_to_weta( &
          itime+part(ipart)%idt, real(part(ipart)%idt), part(ipart)%xlon, &
          part(ipart)%ylat, part(ipart)%z, part(ipart)%zeta, &
          part(ipart)%settling, weta_settling)
        weta=weta+weta_settling
         !woldeta=
   !real(part(ipart)%zeta-part(ipart)%zeta_prev)/real(part(ipart)%idt*ldirect)
#else
        call get_settling(xts,yts,zts,nsp,part(ipart)%settling)
        if ((ldirect.eq.1).and. &
          (part(ipart)%z+part(ipart)%settling*part(ipart)%idt.lt.0)) then
          part(ipart)%settling=-part(ipart)%z/part(ipart)%idt
        endif
        w=w+part(ipart)%settling
#endif
      end if
    endif
  end if

  ! Determine the difference vector between new and old wind
  ! (use half of it to correct position according to Petterssen)
  !*************************************************************

  u=(u-uold)*0.5
  v=(v-vold)*0.5

#ifdef ETA
    weta=(weta-woldeta)*0.5
    call update_zeta(ipart,weta*real(part(ipart)%idt*ldirect))
    if (part(ipart)%zeta.ge.1.) call set_zeta(ipart,1.-(part(ipart)%zeta-1.))
    if (part(ipart)%zeta.eq.1.) call update_zeta(ipart,-eps_eta)
#else
    w=(w-wold)*0.5
    call update_z(ipart,w*real(part(ipart)%idt*ldirect))
    if (part(ipart)%z.lt.0.) call set_z(ipart,min(h-eps2,-1.*part(ipart)%z))          ! if particle below ground -> reflection
#endif

  ! Finally, correct the old position
  !**********************************

  call update_xy(u*part(ipart)%idt,v*part(ipart)%idt,ipart)

  ! If particle above highest model level, set it back into the domain
  !*******************************************************************
  call pushpartdown(ipart)
  
end subroutine petterssen_corr

subroutine update_xy(xchange,ychange,ipart)

  implicit none

  integer, intent(in) ::          &
    ipart                           ! particle number
  real, intent(in) ::             &
    xchange,ychange                 ! change in position
  real ::                         &
    xlon,ylat,xpol,ypol,          & ! temporarily storing new particle positions
    gridsize,cosfact                ! used to compute new positions of particles

  eps=nxmax/3.e5

  if (ngrid.ge.0) then

    cosfact=dxconst/cos((real(part(ipart)%ylat)*dy+ylat0)*pi180)
    call update_xlon(ipart,real(xchange*cosfact*real(ldirect),kind=dp))
    call update_ylat(ipart,real(ychange*dyconst*real(ldirect),kind=dp))

  else if (ngrid.eq.-1) then      ! around north pole

    xlon=xlon0+real(part(ipart)%xlon)*dx !comment by MC: compute old part pos.
    ylat=ylat0+real(part(ipart)%ylat)*dy
    call cll2xy(northpolemap,ylat,xlon,xpol,ypol)   
      !convert old particle position in polar stereographic
    gridsize=1000.*cgszll(northpolemap,ylat)   
      !calculate size in m of grid element in polar stereographic coordinate
    xpol=xpol+xchange/gridsize*real(ldirect)        
      !position in grid unit polar stereographic
    ypol=ypol+ychange/gridsize*real(ldirect)
    call cxy2ll(northpolemap,xpol,ypol,ylat,xlon)   
      !convert to lat long coordinate
    call set_xlon(ipart,real((xlon-xlon0)/dx,kind=dp))
      !convert to grid units in lat long coordinate, comment by mc
    call set_ylat(ipart,real((ylat-ylat0)/dy,kind=dp))

  else if (ngrid.eq.-2) then    ! around south pole

    xlon=xlon0+real(part(ipart)%xlon)*dx
    ylat=ylat0+real(part(ipart)%ylat)*dy
    call cll2xy(southpolemap,ylat,xlon,xpol,ypol)
    gridsize=1000.*cgszll(southpolemap,ylat)
    xpol=xpol+xchange/gridsize*real(ldirect)
    ypol=ypol+ychange/gridsize*real(ldirect)
    call cxy2ll(southpolemap,xpol,ypol,ylat,xlon)
    call set_xlon(ipart,real((xlon-xlon0)/dx,kind=dp))
    call set_ylat(ipart,real((ylat-ylat0)/dy,kind=dp))

  endif

  ! If global data are available, use cyclic boundary condition
  !************************************************************

  if (xglobal) then
    if (part(ipart)%xlon .ge. real(nxmin1, kind=dp)) &
      call update_xlon(ipart,-real(nxmin1, kind=dp))
    if (part(ipart)%xlon .lt. 0.) call update_xlon(ipart,real(nxmin1, kind=dp))
    if (part(ipart)%xlon .le. real(eps, kind=dp)) &
      call set_xlon(ipart,real(eps, kind=dp))
    if (abs( part(ipart)%xlon - real(nxmin1, kind=dp)) .le. eps) &
      call set_xlon(ipart,real(nxmin1-eps,kind=dp))
  endif

  ! HSO/AL: Prevent particles from disappearing at the pole
  !******************************************************************
  if (sglobal .and. part(ipart)%ylat.lt.0. ) then
    call set_xlon(ipart, &
      mod( part(ipart)%xlon + real(nxmin1*0.5, kind=dp), real(nxmin1, kind=dp)))
    call set_ylat(ipart,-part(ipart)%ylat)
   ! In extremely rare cases, the ylat exceeds the bounds, 
   ! so we set it back into the domain here
    if ( part(ipart)%ylat.gt.real(nymin1,kind=dp) ) &
      call set_ylat(ipart, &
        real(nymin1, kind=dp) - mod( part(ipart)%ylat, real(nymin1, kind=dp)))
  else if (nglobal .and. part(ipart)%ylat .gt. real(nymin1, kind=dp) ) then
    call set_xlon(ipart, &
      mod( part(ipart)%xlon + real(nxmin1*0.5, kind=dp), real(nxmin1, kind=dp)))
    call set_ylat(ipart,2.*real(nymin1,kind=dp) - part(ipart)%ylat)
  endif

  ! Check position: If trajectory outside model domain, terminate it
  !*****************************************************************
  ! Not necessary to check when using global domain, but some problems in the
  ! meteo data could cause particles to go crazy.
  ! if (gdomainfill) return 

  if (part(ipart)%xlon.lt.0. .or. part(ipart)%xlon.ge.real(nxmin1,kind=dp) &
 .or. part(ipart)%ylat.lt.0. .or. part(ipart)%ylat.gt.real(nymin1,kind=dp)) then
    part(ipart)%nstop=.true.
    return
  endif
  
end subroutine update_xy

subroutine pushpartdown(ipart)

  implicit none 

  integer, intent(in) ::          &
    ipart                           ! particle index

  eps=nxmax/3.e5

#ifdef ETA
  if (part(ipart)%zeta.le.real(uvheight(nz),kind=dp)) then
    if ((ldirect.eq.-1) .and. (lsettling)) then
      part(ipart)%nstop=.true.
    else
      call set_zeta(ipart,uvheight(nz)+eps_eta)
    endif
  endif
#else
  if (part(ipart)%z.ge.real(height(nz),kind=dp)) then
    if ((ldirect.eq.-1) .and. (lsettling)) then
      part(ipart)%nstop=.true.
    else
      call set_z(ipart,height(nz)-100.*eps)
    endif
  endif
#endif
  
end subroutine pushpartdown

end module advance_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module erf_mod

  implicit none

  private :: gammln,gammp,gammq,gser,gcf
  public :: erf,erfc,erfcc

contains


! To be used, if the non-standard Fortran function erf does not exist on
! your machine
!
!aus:  Numerical Recipes (FORTRAN) / Chapter 6.
!
!6.1  FUNCTION GAMMLN
!6.2  FUNCTION GAMMP   <6.2:GSER/6.2:GCF/6.1:GAMMLN>
!6.2  FUNCTION GAMMQ   <6.2:GSER/6.2:GCF/6.1:GAMMLN>
!6.2  SUBROUTINE GSER    <6.1:GAMMLN>
!6.2  SUBROUTINE GCF     <6.1:GAMMLN>
!6.2  FUNCTION ERF     <6.2:GAMMP/6.2:GSER/6.2:GCF/6.1:GAMMLN>
!6.2  FUNCTION ERFC    <6.2.:GAMMP/6.2:GAMMQ/6.2:GSER/
!                       6.2:GCF/6.1:GAMMLN>
!6.2  FUNCTION ERFCC

function gammln(xx)

  use par_mod, only: dp

  implicit none

  integer :: j
  real :: gammln,xx
  real(kind=dp) :: ser,x,tmp
  real(kind=dp) :: cof(6) = (/ &
       76.18009173_dp, -86.50532033_dp, 24.01409822_dp, &
       -1.231739516_dp, .120858003e-2_dp, -.536382e-5_dp    /)
  real(kind=dp) :: stp = 2.50662827465_dp
  real(kind=dp) :: half = 0.5_dp, one = 1.0_dp, fpf = 5.5_dp

  x=real(xx,kind=dp)-one
  tmp=x+fpf
  tmp=(x+half)*log(tmp)-tmp
  ser=one
  do j=1,6
    x=x+one
    ser=ser+cof(j)/x
  end do
  gammln=real(tmp+log(stp*ser))
end function gammln

function gammp(a,x)

  implicit none

  real :: a, x, gln, gamser, gammp, gammcf

  if(x .lt. 0. .or. a .le. 0.) then
    error stop 'gammp: invalid input'
  end if
  if(x.lt.a+1.)then
    call gser(gamser,a,x,gln)
    gammp=gamser
  else
    call gcf(gammcf,a,x,gln)
    gammp=1.-gammcf
  endif
end function gammp

function gammq(a,x)

  implicit none

  real :: a, x, gln, gamser, gammq, gammcf

  if(x.lt.0..or.a.le.0.) then
    error stop 'gammq: invalid input'
  end if
  if(x.lt.a+1.)then
    call gser(gamser,a,x,gln)
    gammq=1.-gamser
  else
    call gcf(gammcf,a,x,gln)
    gammq=gammcf
  endif
end function gammq

subroutine gser(gamser,a,x,gln)

  implicit none

  integer :: n
  real :: gamser, a, x, gln, ap, summ, del
  !real, external :: gammln

  integer,parameter :: itmax=100
  real,parameter    :: eps=3.e-7

  gln=gammln(a)
  if(x.le.0.)then
    if(x.lt.0.) then
       error stop 'gser: invalid x input'
    end if
    gamser=0.
    return
  endif
  ap=a
  summ=1./a
  del=summ
  do n=1,itmax
    ap=ap+1.
    del=del*x/ap
    summ=summ+del
    if(abs(del).lt.abs(summ)*eps)go to 1
  end do
  error stop 'gser: a too large, itmax too small'
1   gamser=summ*exp(-x+a*log(x)-gln)
end subroutine gser

subroutine gcf(gammcf,a,x,gln)

  implicit none

  integer :: n
  real :: gammcf, a, x, gln, gold, a0, a1, b0, b1, fac, an, anf, ana, g
  !real, external :: gammln

  integer,parameter :: itmax=100
  real,parameter    :: eps=3.e-7

  gln=gammln(a)
  gold=0.
  a0=1.
  a1=x
  b0=0.
  b1=1.
  fac=1.
  do n=1,itmax
    an=real(n)
    ana=an-a
    a0=(a1+a0*ana)*fac
    b0=(b1+b0*ana)*fac
    anf=an*fac
    a1=x*a0+anf*a1
    b1=x*b0+anf*b1
    if(a1.ne.0.)then
      fac=1./a1
      g=b1*fac
      if(abs((g-gold)/g).lt.eps)go to 1
      gold=g
    endif
  end do
  error stop 'gcf: a too large, itmax too small'
1   gammcf=exp(-x+a*alog(x)-gln)*g
end subroutine gcf

function erf(x)

  implicit none

  real :: x, erf
  !real, external :: gammp

  if(x.lt.0.)then
    erf=-gammp(.5,x**2)
  else
    erf=gammp(.5,x**2)
  endif
end function erf

function erfc(x)

  implicit none

  real :: x, erfc
  !real, external :: gammp, gammq

  if(x.lt.0.)then
    erfc=1.+gammp(.5,x**2)
  else
    erfc=gammq(.5,x**2)
  endif
end function erfc

function erfcc(x)

  implicit none

  real :: x, z, t, erfcc

  z=abs(x)
  t=1./(1.+0.5*z)
  erfcc=t*exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+ &
       t*(.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+ &
       t*(1.48851587+t*(-.82215223+t*.17087277)))))))))
  if (x.lt.0.) erfcc=2.-erfcc
end function erfcc

end module erf_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readspecies(id_spec,pos_spec)

  !*****************************************************************************
  !                                                                            *
  !     This routine reads names and physical constants of chemical species/   *
  !     radionuclides given in the parameter pos_spec                          *
  !                                                                            *
  !   Author: A. Stohl                                                         *
  !                                                                            *
  !   11 July 1996                                                             *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! decaytime(maxtable)  half time for radiological decay                      *
  ! specname(maxtable)   names of chemical species, radionuclides              *
  ! wetscava, wetscavb   Parameters for determining scavenging coefficient     *
  ! ohreact              OH reaction rate                                      *
  ! id_spec              SPECIES number as referenced in RELEASE file          *
  ! id_pos               position where SPECIES data shall be stored           *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: i, pos_spec,j
  integer :: idow,ihour,id_spec
  character(len=3) :: aspecnumb
  logical :: spec_found

  ! Open the SPECIES file and read species names and properties
  !************************************************************
  specnum(pos_spec)=id_spec
  write(aspecnumb,'(i3.3)') specnum(pos_spec)
  open(unitspecies,file= &
       path(1)(1:length(1))//'SPECIES/SPECIES_'//aspecnumb,status='old', &
       err=998)
  !write(*,*) 'reading SPECIES',specnum(pos_spec)

  ASSSPEC=.FALSE.

  do i=1,6
    read(unitspecies,*)
  end do

    read(unitspecies,'(a10)',end=22) species(pos_spec)
  !  write(*,*) species(pos_spec)
    read(unitspecies,'(f18.1)',end=22) decay(pos_spec)
  !  write(*,*) decay(pos_spec)
    read(unitspecies,'(e18.1)',end=22) weta(pos_spec)
  !  write(*,*) weta(pos_spec)
    read(unitspecies,'(f18.2)',end=22) wetb(pos_spec)
  !  write(*,*) wetb(pos_spec)
    read(unitspecies,'(f18.1)',end=22) reldiff(pos_spec)
  !  write(*,*) reldiff(pos_spec)
    read(unitspecies,'(e18.1)',end=22) henry(pos_spec)
  !  write(*,*) henry(pos_spec)
    read(unitspecies,'(f18.1)',end=22) f0(pos_spec)
  !  write(*,*) f0(pos_spec)
    read(unitspecies,'(e18.1)',end=22) density(pos_spec)
  !  write(*,*) density(pos_spec)
    read(unitspecies,'(e18.1)',end=22) dquer(pos_spec)
  !  write(*,*) dquer(pos_spec)
    read(unitspecies,'(e18.1)',end=22) dsigma(pos_spec)
  !  write(*,*) dsigma(pos_spec)
    read(unitspecies,'(f18.2)',end=22) dryvel(pos_spec)
  !  write(*,*) dryvel(pos_spec)
    read(unitspecies,'(f18.2)',end=22) weightmolar(pos_spec)
  !  write(*,*) weightmolar(pos_spec)
    read(unitspecies,'(e18.1)',end=22) ohreact(pos_spec)
  !  write(*,*) ohreact(pos_spec)
    read(unitspecies,'(i18)',end=22) spec_ass(pos_spec)
  !  write(*,*) spec_ass(pos_spec)
    read(unitspecies,'(f18.2)',end=22) kao(pos_spec)
  !       write(*,*) kao(pos_spec)
    i=pos_spec

    if ((weta(pos_spec).gt.0).and.(henry(pos_spec).le.0)) then
       if (dquer(pos_spec).le.0) goto 996 ! no particle, no henry set
    endif

    if (spec_ass(pos_spec).gt.0) then
       spec_found=.FALSE.
       do j=1,pos_spec-1
          if (spec_ass(pos_spec).eq.specnum(j)) then
             spec_ass(pos_spec)=j
             spec_found=.TRUE.
             ASSSPEC=.TRUE.
          endif
       end do
       if (spec_found.eqv..FALSE.) then
          goto 997
       endif
    endif

    if (dsigma(i).eq.1.) dsigma(i)=1.0001   ! avoid floating exception
    if (dsigma(i).eq.0.) dsigma(i)=1.0001   ! avoid floating exception

    if ((reldiff(i).gt.0.).and.(density(i).gt.0.)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE "SPECIES"    ####'
      write(*,*) '#### IS CORRUPT. SPECIES CANNOT BE BOTH      ####'
      write(*,*) '#### PARTICLE AND GAS.                       ####'
      write(*,*) '#### SPECIES NUMBER',aspecnumb
      stop
    endif
20   continue


  ! Read in daily and day-of-week variation of emissions, if available
  !*******************************************************************

    do j=1,24           ! initialize everything to no variation
      area_hour(i,j)=1.
      point_hour(i,j)=1.
    end do
    do j=1,7
      area_dow(i,j)=1.
      point_dow(i,j)=1.
    end do

    read(unitspecies,*,end=22)
    do j=1,24     ! 24 hours, starting with 0-1 local time
      read(unitspecies,*) ihour,area_hour(i,j),point_hour(i,j)
    end do
    read(unitspecies,*)
    do j=1,7      ! 7 days of the week, starting with Monday
      read(unitspecies,*) idow,area_dow(i,j),point_dow(i,j)
    end do

22   close(unitspecies)

   return

996   write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL ERROR!                      #### '
  write(*,*) '#### WET DEPOSITION SWITCHED ON, BUT NO HENRYS  #### '
  write(*,*) '#### CONSTANT IS SET                            ####'
  write(*,*) '#### PLEASE MODIFY SPECIES DESCR. FILE!        #### '
  write(*,*) '#####################################################'
  stop


997   write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL ERROR!                      #### '
  write(*,*) '#### THE ASSSOCIATED SPECIES HAS TO BE DEFINED  #### '
  write(*,*) '#### BEFORE THE ONE WHICH POINTS AT IT          #### '
  write(*,*) '#### PLEASE CHANGE ORDER IN RELEASES OR ADD     #### '
  write(*,*) '#### THE ASSOCIATED SPECIES IN RELEASES         #### '
  write(*,*) '#####################################################'
  stop


998   write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL ERROR!                      #### '
  write(*,*) '#### THE SPECIES FILE FOR SPECIES ', id_spec
  write(*,*) '#### CANNOT BE FOUND: CREATE FILE'
  write(*,*) '#### ',path(1)(1:length(1)),'SPECIES/SPECIES_',aspecnumb
  write(*,*) '#####################################################'
  stop


end subroutine readspecies

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  ! L. Bakels 2022: - This module contains all subroutines handling the        *
  !                   internal storage and processing of the meteorological    *
  !                   data, including computation of PV and boundary           *
  !                   layer parameters                                         *
  !                 - The reading of the meteo data happens in windfields_mod  *
  !                 - The vertical coordinate transformation is done in        *
  !                   verttransform_mod                                        *
  !                                                                            *
  !*****************************************************************************

module getfields_mod
  
  use par_mod
  use com_mod
  use windfields_mod
  use verttransform_mod

  implicit none

  real,allocatable,dimension(:,:,:) ::    &
    uuh,                                  & ! wind components in x-direction [m/s] 
    vvh,                                  & ! wind components in y-direction [m/s] 
    pvh,                                  & ! potential vorticity
    wwh                                     ! wind components in y-direction [m/s]
  real,allocatable,dimension(:,:,:,:) ::  & ! Same for nexted grids
    uuhn,                                 & !
    vvhn,                                 & !
    pvhn,                                 & !
    wwhn,                                 & !
    pwater                                  ! RLT added partial pressure water vapor 
  real,allocatable,dimension(:,:,:) ::    & ! For calcpv
    ppml,                                 & !
    ppmk                                    !
  real,allocatable,dimension(:) ::        & ! For calcpar
    ttlev,                                & !
    qvlev,                                & !
    ulev,                                 & !
    vlev,                                 & !
    zlev                                    !

  private :: obukhov,richardson,scalev,calcpar,calcpar_nest,calcpv,calcpv_nest

  public :: getfields
contains

subroutine alloc_getfields
  implicit none
  integer :: stat

  allocate(uuh(0:nxmax-1,0:nymax-1,nuvzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate uuh'
  allocate(vvh(0:nxmax-1,0:nymax-1,nuvzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate vvh'
  allocate(pvh(0:nxmax-1,0:nymax-1,nuvzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate pvh'
  allocate(wwh(0:nxmax-1,0:nymax-1,nwzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate wwh'
  allocate(uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numbnests),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate uuhn'
  allocate(vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numbnests),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate vvhn'
  allocate(pvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numbnests),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate pvhn'
  allocate(wwhn(0:nxmaxn-1,0:nymaxn-1,nwzmax,numbnests),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate wwhn'
  allocate(pwater(0:nxmax-1,0:nymax-1,nzmax,numwfmem),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate pwater'

  allocate(ppml(0:nxmax-1,0:nymax-1,nuvzmax),ppmk(0:nxmax-1,0:nymax-1,nuvzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate ppml,ppmk'
  allocate(ttlev(nuvzmax),qvlev(nuvzmax),ulev(nuvzmax),vlev(nuvzmax),zlev(nuvzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate ttlev,qvlev,ulev,vlev,zlev'
end subroutine alloc_getfields

subroutine dealloc_getfields
  implicit none
  deallocate(uuh,vvh,pvh,wwh,uuhn,vvhn,pvhn,wwhn,pwater)
  deallocate(ppml,ppmk)
  deallocate(ttlev,qvlev,ulev,vlev,zlev)
end subroutine dealloc_getfields

subroutine getfields(itime,nstop)
  !                       i     o
  !*****************************************************************************
  !                                                                            *
  !  This subroutine manages the 3 data fields to be kept in memory.           *
  !  During the first time step of petterssen it has to be fulfilled that the  *
  !  first data field must have |wftime|<itime, i.e. the absolute value of     *
  !  wftime must be smaller than the absolute value of the current time in [s].*
  !  The other 2 fields are the next in time after the first one.              *
  !  Pointers (memind) are used, because otherwise one would have to resort the*
  !  wind fields, which costs a lot of computing time. Here only the pointers  *
  !  are resorted.                                                             *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     29 April 1994                                                          *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:                                     *
  !   Variables tth,qvh,tthn,qvhn (on eta coordinates) in common block.        *
  !   Function of nstop extended.                                              *
  !                                                                            *
  !   Unified ECMWF and GFS builds                                             *
  !   Marian Harustak, 12.5.2017                                               *
  !     - Added passing of metdata_format as it was needed by called routines  *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! lwindinterval [s]    time difference between the two wind fields read in   *
  ! indj                 indicates the number of the wind field to be read in  *
  ! indmin               remembers the number of wind fields already treated   *
  ! memind(2)            pointer, on which place the wind fields are stored    *
  ! memtime(2) [s]       times of the wind fields, which are kept in memory    *
  ! itime [s]            current time since start date of trajectory calcu-    *
  !                      lation                                                *
  ! nstop                > 0, if trajectory has to be terminated               *
  ! nx,ny,nuvz,nwz       field dimensions in x,y and z direction               *
  ! uu(0:nxmax,0:nymax,nuvzmax,2)   wind components in x-direction [m/s]       *
  ! vv(0:nxmax,0:nymax,nuvzmax,2)   wind components in y-direction [m/s]       *
  ! ww(0:nxmax,0:nymax,nwzmax,2)    wind components in z-direction [deltaeta/s]*
  ! tt(0:nxmax,0:nymax,nuvzmax,2)   temperature [K]                            *
  ! ps(0:nxmax,0:nymax,2)           surface pressure [Pa]                      *
  ! metdata_format     format of metdata (ecmwf/gfs)                           *
  !                                                                            *
  ! Constants:                                                                 *
  ! idiffmax             maximum allowable time difference between 2 wind      *
  !                      fields                                                *
  !                                                                            *
  !*****************************************************************************

  use class_gribfile_mod
  use wetdepo_mod

  implicit none

  integer :: indj,itime,nstop,memaux
  integer :: kz,ix,jy
  integer :: indmin = 1

  ! Check, if wind fields are available for the current time step
  !**************************************************************

  nstop=0
  if ((ldirect*wftime(1).gt.ldirect*itime).or. &
       (ldirect*wftime(numbwf).lt.ldirect*itime)) then
    write(*,*) 'FLEXPART WARNING: NO WIND FIELDS ARE AVAILABLE.'
    write(*,*) 'A TRAJECTORY HAS TO BE TERMINATED.'
    nstop=4
    return
  endif


  if ((ldirect*memtime(1).le.ldirect*itime).and. &
       (ldirect*memtime(2).gt.ldirect*itime)) then

  ! The right wind fields are already in memory -> don't do anything
  !*****************************************************************

    continue

  else if ((ldirect*memtime(2).le.ldirect*itime).and. &
       (memtime(2).ne.999999999)) then

  ! Current time is after 2nd wind field
  ! -> Resort wind field pointers, so that current time is between 1st and 2nd
  !***************************************************************************

    memaux=memind(1)
    memind(1)=memind(2)
    memind(2)=memaux
    memtime(1)=memtime(2)


  ! Read a new wind field and store it on place memind(2)
  !******************************************************

    do indj=indmin,numbwf-1
      if (ldirect*wftime(indj+1).gt.ldirect*itime) then
        if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
          call SYSTEM_CLOCK(count_clock, count_rate, count_max)
          s_temp = (count_clock - count_clock0)/real(count_rate)
          call readwind_ecmwf(indj+1,memind(2),uuh,vvh,wwh)
          call SYSTEM_CLOCK(count_clock, count_rate, count_max)
          s_readwind = s_readwind + ((count_clock - count_clock0)/real(count_rate)-s_temp)
        else
          call readwind_gfs(indj+1,memind(2),uuh,vvh,wwh)
        end if
        call readwind_nest(indj+1,memind(2),uuhn,vvhn,wwhn)
        call calcpar(memind(2))
        call calcpar_nest(memind(2))
        if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
          call verttransform_ecmwf(memind(2),uuh,vvh,wwh,pvh)
        else
          call verttransform_gfs(memind(2),uuh,vvh,wwh,pvh)
        end if
        call verttransform_nest(memind(2),uuhn,vvhn,wwhn,pvhn)
        memtime(2)=wftime(indj+1)
        nstop = 1
        exit
      endif
    end do
    indmin=indj

    if (WETBKDEP) then
      call writeprecip(itime,memind(1))
    endif

    if ((DRYDEP).or.(lnetcdfout.eq.0)) then
!$OMP PARALLEL PRIVATE(ix,jy,kz)
!$OMP DO
  ! RLT calculate dry air density
      do kz=1,nuvz
        do jy=0,nymin1
          do ix=0,nxmin1
            pwater(ix,jy,kz,memind(1))=qv(ix,jy,kz,memind(1))*prs(ix,jy,kz,memind(1))/ &
              ((r_air/r_water)*(1.-qv(ix,jy,kz,memind(1)))+qv(ix,jy,kz,memind(1)))
            pwater(ix,jy,kz,memind(2))=qv(ix,jy,kz,memind(2))*prs(ix,jy,kz,memind(2))/ &
              ((r_air/r_water)*(1.-qv(ix,jy,kz,memind(2)))+qv(ix,jy,kz,memind(2)))
            rho_dry(ix,jy,kz,memind(1))=(prs(ix,jy,kz,memind(1))-pwater(ix,jy,kz,memind(1)))/ &
              (r_air*tt(ix,jy,kz,memind(1)))
            rho_dry(ix,jy,kz,memind(2))=(prs(ix,jy,kz,memind(2))-pwater(ix,jy,kz,memind(2)))/ &
              (r_air*tt(ix,jy,kz,memind(2)))
          end do 
        end do
      end do
      ! pwater=qv*prs/((r_air/r_water)*(1.-qv)+qv)
      ! rho_dry=(prs-pwater)/(r_air*tt)
!$OMP END DO
!$OMP END PARALLEL
    endif
  else
 
  ! No wind fields, which can be used, are currently in memory
  ! -> read both wind fields
  !***********************************************************

    do indj=indmin,numbwf-1
      if ((ldirect*wftime(indj).le.ldirect*itime).and. &
           (ldirect*wftime(indj+1).gt.ldirect*itime)) then
        memind(1)=1
        if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
          call SYSTEM_CLOCK(count_clock, count_rate, count_max)
          s_temp = (count_clock - count_clock0)/real(count_rate)
          call readwind_ecmwf(indj,memind(1),uuh,vvh,wwh)
          call SYSTEM_CLOCK(count_clock, count_rate, count_max)
          s_readwind = s_readwind + ((count_clock - count_clock0)/real(count_rate)-s_temp)
        else
          call readwind_gfs(indj,memind(1),uuh,vvh,wwh)
        end if
        call readwind_nest(indj,memind(1),uuhn,vvhn,wwhn)
        call calcpar(memind(1))
        call calcpar_nest(memind(1))

        if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
          call verttransform_ecmwf(memind(1),uuh,vvh,wwh,pvh)
        else
          call verttransform_gfs(memind(1),uuh,vvh,wwh,pvh)
        end if

        call verttransform_nest(memind(1),uuhn,vvhn,wwhn,pvhn)
        memtime(1)=wftime(indj)
        memind(2)=2
        if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
          call SYSTEM_CLOCK(count_clock, count_rate, count_max)
          s_temp = (count_clock - count_clock0)/real(count_rate)
          call readwind_ecmwf(indj+1,memind(2),uuh,vvh,wwh)
          call SYSTEM_CLOCK(count_clock, count_rate, count_max)
          s_readwind = s_readwind + ((count_clock - count_clock0)/real(count_rate)-s_temp)
        else
          call readwind_gfs(indj+1,memind(2),uuh,vvh,wwh)
        end if
        call readwind_nest(indj+1,memind(2),uuhn,vvhn,wwhn)
        call calcpar(memind(2))
        call calcpar_nest(memind(2))
        if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
          call verttransform_ecmwf(memind(2),uuh,vvh,wwh,pvh)
        else
          call verttransform_gfs(memind(2),uuh,vvh,wwh,pvh)
        end if
        call verttransform_nest(memind(2),uuhn,vvhn,wwhn,pvhn)
        memtime(2)=wftime(indj+1)
        nstop = 1
        exit
      endif
    end do
    indmin=indj

    if (WETBKDEP) then
      call writeprecip(itime,memind(1))
    endif

    if ((DRYDEP).or.(lnetcdfout.eq.0)) then
!$OMP PARALLEL PRIVATE(ix,jy,kz)
!$OMP DO
    ! RLT calculate dry air density
      do kz=1,nuvz
        do jy=0,nymin1
          do ix=0,nxmin1
            pwater(ix,jy,kz,memind(1))=qv(ix,jy,kz,memind(1))*prs(ix,jy,kz,memind(1))/ &
              ((r_air/r_water)*(1.-qv(ix,jy,kz,memind(1)))+qv(ix,jy,kz,memind(1)))
            pwater(ix,jy,kz,memind(2))=qv(ix,jy,kz,memind(2))*prs(ix,jy,kz,memind(2))/ &
              ((r_air/r_water)*(1.-qv(ix,jy,kz,memind(2)))+qv(ix,jy,kz,memind(2)))
            rho_dry(ix,jy,kz,memind(1))=(prs(ix,jy,kz,memind(1))-pwater(ix,jy,kz,memind(1)))/ &
              (r_air*tt(ix,jy,kz,memind(1)))
            rho_dry(ix,jy,kz,memind(2))=(prs(ix,jy,kz,memind(2))-pwater(ix,jy,kz,memind(2)))/ &
              (r_air*tt(ix,jy,kz,memind(2)))
          end do 
        end do
      end do
      ! pwater=qv*prs/((r_air/r_water)*(1.-qv)+qv)
      ! rho_dry=(prs-pwater)/(r_air*tt)
!$OMP END DO
!$OMP END PARALLEL
    endif
  end if

  lwindinterv=abs(memtime(2)-memtime(1))

  if (lwindinterv.gt.idiffmax) nstop=3
end subroutine getfields

subroutine calcpv(n)
  !               i  i   i   o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of potential vorticity on 3-d grid.                           *
  !                                                                            *
  !     Author: P. James                                                       *
  !     3 February 2000                                                        *
  !                                                                            *
  !     Adaptation to FLEXPART, A. Stohl, 1 May 2000                           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 2)       *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: n,ix,jy,i,j,k,kl,ii,jj,klvrp,klvrm,klpt,kup,kdn,kch
  integer :: jyvp,jyvm,ixvp,ixvm,jumpx,jumpy,jux,juy,ivrm,ivrp,ivr
  integer :: nlck
  real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt
  real :: pvavr
  real :: thup,thdn
  real,parameter :: eps=1.e-5, p0=101325

  ! Set number of levels to check for adjacent theta
  nlck=nuvz/3
  !
  ! Loop over entire grid
  !**********************
  do kl=1,nuvz
    do jy=0,nymin1
      do ix=0,nxmin1
         ppml(ix,jy,kl)=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
      enddo
    enddo
  enddo

!  ppmk(:,:,1:nuvz)=(100000./ppml(:,:,1:nuvz))**kappa
  ppmk(0:nxmin1,0:nymin1,1:nuvz)=(100000./ppml(0:nxmin1,0:nymin1,1:nuvz))**kappa
!$OMP PARALLEL PRIVATE(jy,ix,kl,phi,f,tanphi,cosphi,jyvp,jyvm,jumpy,juy, &
!$OMP ixvp,ixvm,jumpx,ivrp,ivrm,jux,theta,klvrp,klvrm,klpt,thetap,thetam,dthetadp, &
!$OMP ii,i,ivr,kdn,kch,kup,thdn,thup,dt1,dt2,dt,vx,k,dvdx, &
!$OMP jj,j,uy,dudy)
!$OMP DO SCHEDULE(dynamic,1)
  do jy=0,nymin1
    if (sglobal.and.jy.eq.0) cycle
    if (nglobal.and.jy.eq.nymin1) cycle

    ! do kl=1,nuvz
    !   ppml(0:nxmin1,jy,kl)=akz(kl)+bkz(kl)*ps(0:nxmin1,jy,1,n)
    !   ppmk(0:nxmin1,jy,kl)=(100000./ppml(0:nxmin1,jy,kl))**kappa
    ! end do

    phi = (ylat0 + jy * dy) * pi / 180.
    f = 0.00014585 * sin(phi)
    tanphi = tan(phi)
    cosphi = cos(phi)
  ! Provide a virtual jy+1 and jy-1 in case we are on domain edge (Lat)
    jyvp=jy+1
    jyvm=jy-1
    if (jy.eq.0) jyvm=0
    if (jy.eq.nymin1) jyvp=nymin1
  ! Define absolute gap length
    jumpy=2
    if (jy.eq.0.or.jy.eq.nymin1) jumpy=1
    if (sglobal.and.jy.eq.1) then
      jyvm=1
      jumpy=1
    end if
    if (nglobal.and.jy.eq.ny-2) then
      jyvp=ny-2
      jumpy=1
    end if
    juy=jumpy
  !
    do ix=0,nxmin1
  ! Provide a virtual ix+1 and ix-1 in case we are on domain edge (Long)
      ixvp=ix+1
      ixvm=ix-1
      jumpx=2
      if (xglobal) then
         ivrp=ixvp
         ivrm=ixvm
         if (ixvm.lt.0) ivrm=ixvm+nxmin1
         if (ixvp.ge.nx) ivrp=ixvp-nx+1
      else
        if (ix.eq.0) ixvm=0
        if (ix.eq.nxmin1) ixvp=nxmin1
        ivrp=ixvp
        ivrm=ixvm
  ! Define absolute gap length
        if (ix.eq.0.or.ix.eq.nxmin1) jumpx=1
      end if
      jux=jumpx
  !
  ! Loop over the vertical
  !***********************

      do kl=1,nuvz
        theta=tth(ix,jy,kl,n)*ppmk(ix,jy,kl)
        klvrp=kl+1
        klvrm=kl-1
        klpt=kl
  ! If top or bottom level, dthetadp is evaluated between the current
  ! level and the level inside, otherwise between level+1 and level-1
  !
        if (klvrp.gt.nuvz) klvrp=nuvz
        if (klvrm.lt.1) klvrm=1
        thetap=tth(ix,jy,klvrp,n)*ppmk(ix,jy,klvrp)
        thetam=tth(ix,jy,klvrm,n)*ppmk(ix,jy,klvrm)
        dthetadp=(thetap-thetam)/(ppml(ix,jy,klvrp)-ppml(ix,jy,klvrm))

  ! Compute vertical position at pot. temperature surface on subgrid
  ! and the wind at that position
  !*****************************************************************
  ! a) in x direction
        ii=0
        x_loop: do i=ixvm,ixvp,jumpx
          ivr=i
          if (xglobal) then
             if (i.lt.0) ivr=ivr+nxmin1
             if (i.ge.nx) ivr=ivr-nx+1
          end if
          ii=ii+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
          x_lev_loop: do while (kch.lt.nlck)
  ! Upward branch
            kup=kup+1
            if (kup.lt.nuvz) then
              kch=kch+1
              k=kup
              thdn=tth(ivr,jy,k,n)*ppmk(ivr,jy,k)
              thup=tth(ivr,jy,k+1,n)*ppmk(ivr,jy,k+1)


              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
                cycle x_loop
              endif
            endif
    ! Downward branch
            kdn=kdn-1
            if (kdn.ge.1) then
              kch=kch+1
              k=kdn
              thdn=tth(ivr,jy,k,n)*ppmk(ivr,jy,k)
              thup=tth(ivr,jy,k+1,n)*ppmk(ivr,jy,k+1)

              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
                cycle x_loop
              endif
            endif
          end do x_lev_loop
    ! This section used when no values were found
  ! Must use vv at current level and long. jux becomes smaller by 1
          vx(ii)=vvh(ix,jy,kl)
          jux=jux-1
  ! Otherwise OK
        end do x_loop
        if (jux.gt.0) then
          dvdx=(vx(2)-vx(1))/real(jux)/(dx*pi/180.)
        else
          dvdx=vvh(ivrp,jy,kl)-vvh(ivrm,jy,kl)
          dvdx=dvdx/real(jumpx)/(dx*pi/180.)
  ! Only happens if no equivalent theta value
  ! can be found on either side, hence must use values
  ! from either side, same pressure level.
        end if

  ! b) in y direction

        jj=0
        y_loop: do j=jyvm,jyvp,jumpy
          jj=jj+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
          y_lev_loop: do while (kch.lt.nlck)
  ! Upward branch
            kup=kup+1
            if (kup.lt.nuvz) then
              kch=kch+1
              k=kup
              thdn=tth(ix,j,k,n)*ppmk(ix,j,k)
              thup=tth(ix,j,k+1,n)*ppmk(ix,j,k+1)
              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
                cycle y_loop
              endif
            endif
    ! Downward branch
            kdn=kdn-1
            if (kdn.ge.1) then
              kch=kch+1
              k=kdn
              thdn=tth(ix,j,k,n)*ppmk(ix,j,k)
              thup=tth(ix,j,k+1,n)*ppmk(ix,j,k+1)
              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
                cycle y_loop
              endif
            endif
          end do y_lev_loop
  ! This section used when no values were found
  ! Must use uu at current level and lat. juy becomes smaller by 1
          uy(jj)=uuh(ix,jy,kl)
          juy=juy-1
  ! Otherwise OK
        end do y_loop
        if (juy.gt.0) then
          dudy=(uy(2)-uy(1))/real(juy)/(dy*pi/180.)
        else
          dudy=uuh(ix,jyvp,kl)-uuh(ix,jyvm,kl)
          dudy=dudy/real(jumpy)/(dy*pi/180.)
        end if
    !
        pvh(ix,jy,kl)=dthetadp*(f+(dvdx/cosphi-dudy &
             +uuh(ix,jy,kl)*tanphi)/r_earth)*(-1.e6)*9.81
  !
  ! Resest jux and juy
        jux=jumpx
        juy=jumpy
      end do
    end do
  end do
!$OMP END DO 
!$OMP END PARALLEL
  !
  ! Fill in missing PV values on poles, if present
  ! Use mean PV of surrounding latitude ring
  !
  if (sglobal) then
     do kl=1,nuvz
        pvavr=0.
        do ix=0,nxmin1
           pvavr=pvavr+pvh(ix,1,kl)
        end do
        pvavr=pvavr/real(nx)
        jy=0
        do ix=0,nxmin1
           pvh(ix,jy,kl)=pvavr
        end do
     end do
  end if
  if (nglobal) then
     do kl=1,nuvz
        pvavr=0.
        do ix=0,nxmin1
           pvavr=pvavr+pvh(ix,ny-2,kl)
        end do
        pvavr=pvavr/real(nx)
        jy=nymin1
        do ix=0,nxmin1
           pvh(ix,jy,kl)=pvavr
        end do
     end do
  end if
end subroutine calcpv

subroutine calcpv_nest(l,n)
  !                     i i  i    i    o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of potential vorticity on 3-d nested grid                     *
  !                                                                            *
  !     Author: P. James                                                       *
  !     22 February 2000                                                       *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 2)       *
  ! l                  index of current nest                                   *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************
  
  implicit none

  integer :: n,ix,jy,i,j,k,kl,ii,jj,klvrp,klvrm,klpt,kup,kdn,kch
  integer :: jyvp,jyvm,ixvp,ixvm,jumpx,jumpy,jux,juy,ivrm,ivrp,ivr
  integer :: nlck,l
  real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt
  real :: thup,thdn
  real,parameter :: eps=1.e-5,p0=101325

  ! Set number of levels to check for adjacent theta
  nlck=nuvz/3
  !
  ! Loop over entire grid
  !**********************
  do kl=1,nuvz
    do jy=0,nyn(l)-1
      do ix=0,nxn(l)-1
         ppml(ix,jy,kl)=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
      enddo
    enddo
  enddo
  !  ppmk=(100000./ppml)**kappa
  ppmk(0:nxn(l)-1,0:nyn(l)-1,1:nuvz)=(100000./ppml(0:nxn(l)-1,0:nyn(l)-1,1:nuvz))**kappa

  do jy=0,nyn(l)-1
    phi = (ylat0n(l) + jy * dyn(l)) * pi / 180.
    f = 0.00014585 * sin(phi)
    tanphi = tan(phi)
    cosphi = cos(phi)
  ! Provide a virtual jy+1 and jy-1 in case we are on domain edge (Lat)
      jyvp=jy+1
      jyvm=jy-1
      if (jy.eq.0) jyvm=0
      if (jy.eq.nyn(l)-1) jyvp=nyn(l)-1
  ! Define absolute gap length
      jumpy=2
      if (jy.eq.0.or.jy.eq.nyn(l)-1) jumpy=1
      juy=jumpy
  !
    do ix=0,nxn(l)-1
  ! Provide a virtual ix+1 and ix-1 in case we are on domain edge (Long)
      ixvp=ix+1
      ixvm=ix-1
      jumpx=2
      if (ix.eq.0) ixvm=0
      if (ix.eq.nxn(l)-1) ixvp=nxn(l)-1
      ivrp=ixvp
      ivrm=ixvm
  ! Define absolute gap length
      if (ix.eq.0.or.ix.eq.nxn(l)-1) jumpx=1
      jux=jumpx
  !
  ! Loop over the vertical
  !***********************

      do kl=1,nuvz
        theta=tthn(ix,jy,kl,n,l)*ppmk(ix,jy,kl)
        klvrp=kl+1
        klvrm=kl-1
        klpt=kl
  ! If top or bottom level, dthetadp is evaluated between the current
  ! level and the level inside, otherwise between level+1 and level-1
  !
        if (klvrp.gt.nuvz) klvrp=nuvz
        if (klvrm.lt.1) klvrm=1
        thetap=tthn(ix,jy,klvrp,n,l)*ppmk(ix,jy,klvrp)
        thetam=tthn(ix,jy,klvrm,n,l)*ppmk(ix,jy,klvrm)
        dthetadp=(thetap-thetam)/(ppml(ix,jy,klvrp)-ppml(ix,jy,klvrm))

  ! Compute vertical position at pot. temperature surface on subgrid
  ! and the wind at that position
  !*****************************************************************
  ! a) in x direction
        ii=0
        x_loop: do i=ixvm,ixvp,jumpx
          ivr=i
          ii=ii+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
          x_lev_loop: do while (kch.lt.nlck)
  ! Upward branch
            kup=kup+1
            if (kup.lt.nuvz) then
              kch=kch+1
              k=kup
              thdn=tthn(ivr,jy,k,n,l)*ppmk(ivr,jy,k)
              thup=tthn(ivr,jy,k+1,n,l)*ppmk(ivr,jy,k+1)

              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                vx(ii)=(vvhn(ivr,jy,k,l)*dt2+vvhn(ivr,jy,k+1,l)*dt1)/dt
                cycle x_loop
              endif
            endif
  ! Downward branch
            kdn=kdn-1
            if (kdn.ge.1) then
              kch=kch+1
              k=kdn
              thdn=tthn(ivr,jy,k,n,l)*ppmk(ivr,jy,k)
              thup=tthn(ivr,jy,k+1,n,l)*ppmk(ivr,jy,k+1)
              
              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                vx(ii)=(vvhn(ivr,jy,k,l)*dt2+vvhn(ivr,jy,k+1,l)*dt1)/dt
                cycle x_loop
              endif
            endif
          end do x_lev_loop
  ! This section used when no values were found
  ! Must use vv at current level and long. jux becomes smaller by 1
          vx(ii)=vvhn(ix,jy,kl,l)
          jux=jux-1
  ! Otherwise OK
        end do x_loop
        if (jux.gt.0) then
          dvdx=(vx(2)-vx(1))/real(jux)/(dxn(l)*pi/180.)
        else
          dvdx=vvhn(ivrp,jy,kl,l)-vvhn(ivrm,jy,kl,l)
          dvdx=dvdx/real(jumpx)/(dxn(l)*pi/180.)
  ! Only happens if no equivalent theta value
  ! can be found on either side, hence must use values
  ! from either side, same pressure level.
        end if

  ! b) in y direction

        jj=0
        y_loop: do j=jyvm,jyvp,jumpy
          jj=jj+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
          y_lev_loop: do while (kch.lt.nlck)
  ! Upward branch
            kup=kup+1
            if (kup.lt.nuvz) then
              kch=kch+1
              k=kup
              thdn=tthn(ix,j,k,n,l)*ppmk(ix,j,k)
              thup=tthn(ix,j,k+1,n,l)*ppmk(ix,j,k+1)
              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                uy(jj)=(uuhn(ix,j,k,l)*dt2+uuhn(ix,j,k+1,l)*dt1)/dt
                cycle y_loop
              endif
            endif
  ! Downward branch
            kdn=kdn-1
            if (kdn.ge.1) then
              kch=kch+1
              k=kdn
              thdn=tthn(ix,j,k,n,l)*ppmk(ix,j,k)
              thup=tthn(ix,j,k+1,n,l)*ppmk(ix,j,k+1)
              if (((thdn.ge.theta).and.(thup.le.theta)).or. &
              ((thdn.le.theta).and.(thup.ge.theta))) then
                dt1=abs(theta-thdn)
                dt2=abs(theta-thup)
                dt=dt1+dt2
                if (dt.lt.eps) then   ! Avoid division by zero error
                  dt1=0.5             ! G.W., 10.4.1996
                  dt2=0.5
                  dt=1.0
                endif
                uy(jj)=(uuhn(ix,j,k,l)*dt2+uuhn(ix,j,k+1,l)*dt1)/dt
                cycle y_loop
              endif
            endif
          end do y_lev_loop
  ! This section used when no values were found
  ! Must use uu at current level and lat. juy becomes smaller by 1
          uy(jj)=uuhn(ix,jy,kl,l)
          juy=juy-1
  ! Otherwise OK
        end do y_loop
        if (juy.gt.0) then
          dudy=(uy(2)-uy(1))/real(juy)/(dyn(l)*pi/180.)
        else
          dudy=uuhn(ix,jyvp,kl,l)-uuhn(ix,jyvm,kl,l)
          dudy=dudy/real(jumpy)/(dyn(l)*pi/180.)
        end if

        pvhn(ix,jy,kl,l)=dthetadp*(f+(dvdx/cosphi-dudy &
             +uuhn(ix,jy,kl,l)*tanphi)/r_earth)*(-1.e6)*9.81

  ! Resest jux and juy
        jux=jumpx
        juy=jumpy
      end do
    end do
  end do
end subroutine calcpv_nest

subroutine calcpar(n)
  !                   i  i   i   o
  !*****************************************************************************
  !                                                                            *
  !     Computation of several boundary layer parameters needed for the        *
  !     dispersion calculation and calculation of dry deposition velocities.   *
  !     All parameters are calculated over the entire grid.                    *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     21 May 1995                                                            *
  !                                                                            *
  !*****************************************************************************
  !     Petra Seibert, Feb 2000:                                               *
  !     convection scheme:                                                     *
  !     new variables in call to richardson                                    *
  !                                                                            *
  !   CHANGE 17/11/2005 Caroline Forster NCEP GFS version                      *
  !                                                                            *
  !   Changes, Bernd C. Krueger, Feb. 2001:                                    *
  !    Variables tth and qvh (on eta coordinates) in common block              *
  !                                                                            *
  !   Unified ECMWF and GFS builds                                             *
  !   Marian Harustak, 12.5.2017                                               *
  !     - Merged calcpar and calcpar_gfs into one routine using if-then        *
  !       for meteo-type dependent code                                        *
  !*****************************************************************************
  !  Changes Anne Tipka June 2023:                                             *
  !    sum up precipitation fields over number of available fields in a single *
  !    time interval (newWetDepoScheme)                                        *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 3)       *
  ! metdata_format     format of metdata (ecmwf/gfs)                           * 
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !                                                                            *
  ! Functions:                                                                 *
  ! scalev             computation of ustar                                    *
  ! obukhov            computatio of Obukhov length                            *
  !                                                                            *
  !*****************************************************************************

  use class_gribfile_mod
  use drydepo_mod
  use qvsat_mod

  implicit none

  integer :: n,ix,jy,i,kz,lz,kzmin,llev,loop_start,ierr,stat
  real :: ol,hmixplus
  real :: rh,subsceff,ylat
  real :: altmin,tvold,pold,zold,pint,tv,hmixdummy,akzdummy
  real,allocatable,dimension(:) :: vd
  real,parameter :: const=r_air/ga

  !write(*,*) 'in calcpar writting snowheight'
  !***********************************
  ! for test: write out snow depths

  ! open(4,file='slandusetest',form='formatted')
  ! do 5 ix=0,nxmin1
  !5       write (4,*) (sd(ix,jy,1,n),jy=0,nymin1)
  !  close(4)


  ! Loop over entire grid
  !**********************
!$OMP PARALLEL PRIVATE(jy,ix,ulev,vlev,ttlev,qvlev,llev,ylat,ol,i,hmixplus, &
!$OMP subsceff,vd,kz,lz,zlev,rh,kzmin,pold,zold,tvold,pint,tv,loop_start,ierr, &
!$OMP altmin)

  allocate( vd(maxspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate vd inside of OMP loop'

!$OMP DO
  do jy=0,nymin1
  ! Set minimum height for tropopause
  !**********************************

    ylat=ylat0+real(jy)*dy
    if ((ylat.ge.-20.).and.(ylat.le.20.)) then
      altmin = 5000.
    else
      if ((ylat.gt.20.).and.(ylat.lt.40.)) then
        altmin=2500.+(40.-ylat)*125.
      else if ((ylat.gt.-40.).and.(ylat.lt.-20.)) then
        altmin=2500.+(40.+ylat)*125.
      else
        altmin=2500.
      endif
    endif

    do ix=0,nxmin1

  ! 1) Calculation of friction velocity
  !************************************

      ustar(ix,jy,1,n)=scalev(ps(ix,jy,1,n),tt2(ix,jy,1,n), &
           td2(ix,jy,1,n),sfcstress(ix,jy,1,n))
      if (ustar(ix,jy,1,n).le.1.e-8) ustar(ix,jy,1,n)=1.e-8

  ! 2) Calculation of inverse Obukhov length scale
  !***********************************************

      if (metdata_format.eq.GRIBFILE_CENTRE_NCEP) then
        ! NCEP version: find first level above ground
        llev = 0
        do i=1,nuvz
          if (ps(ix,jy,1,n).lt.akz(i)) llev=i
        end do
        llev = llev+1
        if (llev.gt.nuvz) llev = nuvz-1
        ! NCEP version

        ! calculate inverse Obukhov length scale with tth(llev)
        ol=obukhov(ps(ix,jy,1,n),tt2(ix,jy,1,n),td2(ix,jy,1,n), &
          tth(ix,jy,llev,n),ustar(ix,jy,1,n),sshf(ix,jy,1,n), &
          akm,bkm,akz(llev))
      else
        llev=0
        ol=obukhov(ps(ix,jy,1,n),tt2(ix,jy,1,n),td2(ix,jy,1,n), &
          tth(ix,jy,2,n),ustar(ix,jy,1,n),sshf(ix,jy,1,n),akm,bkm,akzdummy)
      end if

      if (ol.ne.0.) then
        oli(ix,jy,1,n)=1./ol
      else
        oli(ix,jy,1,n)=99999.
      endif


  ! 3) Calculation of convective velocity scale and mixing height
  !**************************************************************

      do i=1,nuvz
        ulev(i)=uuh(ix,jy,i)
        vlev(i)=vvh(ix,jy,i)
        ttlev(i)=tth(ix,jy,i,n)
        qvlev(i)=qvh(ix,jy,i,n)
      end do

      if (metdata_format.eq.GRIBFILE_CENTRE_NCEP) then
        ! NCEP version hmix has been read in in readwind.f, is therefore not calculated here
      call richardson(ps(ix,jy,1,n),ustar(ix,jy,1,n),ttlev,qvlev, &
           ulev,vlev,nuvz,akz,bkz,sshf(ix,jy,1,n),tt2(ix,jy,1,n), &
             td2(ix,jy,1,n),hmixdummy,wstar(ix,jy,1,n),hmixplus,ierr)
      else
        call richardson(ps(ix,jy,1,n),ustar(ix,jy,1,n),ttlev,qvlev, &
             ulev,vlev,nuvz,akz,bkz,sshf(ix,jy,1,n),tt2(ix,jy,1,n), &
             td2(ix,jy,1,n),hmix(ix,jy,1,n),wstar(ix,jy,1,n),hmixplus,ierr)
      end if

      if (ierr.lt.0) then
        write(*,9500) 'failure', ix, jy
        error stop 'calcpar: richardson computation failed'
      endif
9500      format( 'calcpar - richardson ', a, ' - ix,jy=', 2i5 )
      
      if(lsubgrid.eq.1) then
        subsceff=min(excessoro(ix,jy),hmixplus)
      else
        subsceff=0.0
      endif
  !
  ! CALCULATE HMIX EXCESS ACCORDING TO SUBGRIDSCALE VARIABILITY AND STABILITY
  !
      hmix(ix,jy,1,n)=hmix(ix,jy,1,n)+subsceff
      hmix(ix,jy,1,n)=max(hmixmin,hmix(ix,jy,1,n)) ! set minimum PBL height
      hmix(ix,jy,1,n)=min(hmixmax,hmix(ix,jy,1,n)) ! set maximum PBL height

  ! 4) Calculation of dry deposition velocities
  !********************************************

      if (DRYDEP) then
  ! Sabine Eckhardt, Dec 06: use new index for z0 for water depending on
  ! windspeed
        z0_drydep(ix,jy)=0.016*ustar(ix,jy,1,n)*ustar(ix,jy,1,n)/ga

  ! Calculate relative humidity at surface
  !***************************************
        rh=ew(td2(ix,jy,1,n),ps(ix,jy,1,n))/ew(tt2(ix,jy,1,n),ps(ix,jy,1,n))

        call getvdep(n,ix,jy,ustar(ix,jy,1,n), &
             tt2(ix,jy,1,n),ps(ix,jy,1,n),1./oli(ix,jy,1,n), &
             ssr(ix,jy,1,n),rh,sum(lsprec(ix,jy,1,:,n))+sum(convprec(ix,jy,1,:,n)), &
             sd(ix,jy,1,n),vd)

        do i=1,nspec
          vdep(ix,jy,i,n)=vd(i)
        end do

      endif

  !******************************************************
  ! Calculate height of thermal tropopause (Hoinka, 1997)
  !******************************************************

  ! 1) Calculate altitudes of model levels
  !***************************************

      tvold=tt2(ix,jy,1,n)*(1.+0.378*ew(td2(ix,jy,1,n),ps(ix,jy,1,n))/ &
           ps(ix,jy,1,n))
      pold=ps(ix,jy,1,n)
      zold=0.
      if (metdata_format.eq.GRIBFILE_CENTRE_NCEP) then
        loop_start=llev
      else
        loop_start=2
      end if
      do kz=loop_start,nuvz
        pint=akz(kz)+bkz(kz)*ps(ix,jy,1,n)  ! pressure on model layers
        tv=tth(ix,jy,kz,n)*(1.+0.608*qvh(ix,jy,kz,n))

        if (abs(tv-tvold).gt.0.2) then
          zlev(kz)=zold+const*log(pold/pint)*(tv-tvold)/log(tv/tvold)
        else
          zlev(kz)=zold+const*log(pold/pint)*tv
        endif
        tvold=tv
        pold=pint
        zold=zlev(kz)
      end do

  ! 2) Define a minimum level kzmin, from which upward the tropopause is
  !    searched for. This is to avoid inversions in the lower troposphere
  !    to be identified as the tropopause
  !************************************************************************

      if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
        !LB, The CTM version has 2 (as bugfix), so I changed it 2 from 1 to try out
        loop_start=2
      else
        loop_start=llev
      end if

      kzmin=nuvz
      do kz=loop_start,nuvz
        if (zlev(kz).ge.altmin) then
          kzmin=kz
          exit
        endif
      end do

  ! 3) Search for first stable layer above minimum height that fulfills the
  !    thermal tropopause criterion
  !************************************************************************

      outer: do kz=kzmin,nuvz
        inner: do lz=kz+1,nuvz
          if ((zlev(lz)-zlev(kz)).gt.2000.) then
            if (((tth(ix,jy,kz,n)-tth(ix,jy,lz,n))/ &
                 (zlev(lz)-zlev(kz))).lt.0.002) then
              tropopause(ix,jy,1,n)=zlev(kz)
              exit outer
            endif
            exit inner
          endif
        end do inner
      end do outer

    end do
  end do
!$OMP END DO
  deallocate(vd)
!$OMP END PARALLEL
  ! Calculation of potential vorticity on 3-d grid
  !***********************************************

  call calcpv(n)
end subroutine calcpar

subroutine calcpar_nest(n)
  !                         i  i    i    o
  !*****************************************************************************
  !                                                                            *
  !     Computation of several boundary layer parameters needed for the        *
  !     dispersion calculation and calculation of dry deposition velocities.   *
  !     All parameters are calculated over the entire grid.                    *
  !     This routine is similar to calcpar, but is used for the nested grids.  *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     8 February 1999                                                        *
  !                                                                            *
  !*****************************************************************************
  !     Petra Seibert, Feb 2000:                                               *
  !     convection scheme:                                                     *
  !     new variables in call to richardson                                    *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:                                     *
  !   Variables tth and qvh (on eta coordinates) in common block               *
  !                                                                            *
  !   Unified ECMWF and GFS builds                                             *
  !   Marian Harustak, 12.5.2017                                               *
  !*****************************************************************************
  !  Changes Anne Tipka June 2023:                                             *
  !    sum up precipitation fields over number of available fields in a single *
  !    time interval (newWetDepoScheme)                                        *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 3)       *
  ! metdata_format     format of metdata (ecmwf/gfs)                           *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !                                                                            *
  ! Functions:                                                                 *
  ! scalev             computation of ustar                                    *
  ! obukhov            computatio of Obukhov length                            *
  !                                                                            *
  !*****************************************************************************

  use drydepo_mod
  use qvsat_mod

  implicit none

  integer :: n,ix,jy,i,l,kz,lz,kzmin,ierr,stat
  real :: ol,hmixplus,dummyakzllev
  real :: rh,subsceff,ylat
  real :: altmin,tvold,pold,zold,pint,tv
  real,allocatable,dimension(:) :: vd
  real,parameter :: const=r_air/ga


  ! Loop over all nests
  !********************

  do l=1,numbnests

  ! Loop over entire grid
  !**********************
!$OMP PARALLEL DEFAULT(SHARED) &
!$OMP PRIVATE(i,ix,jy,kz,lz,kzmin,tvold,pold,zold,zlev,tv,pint, &
!$OMP rh,ierr,subsceff,ulev,vlev,ttlev,qvlev,ol,altmin,ylat,hmixplus, &
!$OMP dummyakzllev,stat,vd )

  allocate( vd(maxspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate vd inside of OMP loop'

!$OMP DO
  do jy=0,nyn(l)-1

  ! Set minimum height for tropopause
  !**********************************

    ylat=ylat0n(l)+real(jy)*dyn(l)
    if ((ylat.ge.-20.).and.(ylat.le.20.)) then
      altmin = 5000.
    else
      if ((ylat.gt.20.).and.(ylat.lt.40.)) then
        altmin=2500.+(40.-ylat)*125.
      else if ((ylat.gt.-40.).and.(ylat.lt.-20.)) then
        altmin=2500.+(40.+ylat)*125.
      else
        altmin=2500.
      endif
    endif

    do ix=0,nxn(l)-1

  ! 1) Calculation of friction velocity
  !************************************

      ustarn(ix,jy,1,n,l)=scalev(psn(ix,jy,1,n,l),tt2n(ix,jy,1,n,l), &
           td2n(ix,jy,1,n,l),sfcstressn(ix,jy,1,n,l))
      if (ustarn(ix,jy,1,n,l).le.1.e-8) ustarn(ix,jy,1,n,l)=1.e-8

  ! 2) Calculation of inverse Obukhov length scale
  !***********************************************

      ol=obukhov(psn(ix,jy,1,n,l),tt2n(ix,jy,1,n,l), &
           td2n(ix,jy,1,n,l),tthn(ix,jy,2,n,l),ustarn(ix,jy,1,n,l), &
           sshfn(ix,jy,1,n,l),akm,bkm,dummyakzllev)
      if (ol.ne.0.) then
        olin(ix,jy,1,n,l)=1./ol
      else
        olin(ix,jy,1,n,l)=99999.
      endif


  ! 3) Calculation of convective velocity scale and mixing height
  !**************************************************************

      do i=1,nuvz
        ulev(i)=uuhn(ix,jy,i,l)
        vlev(i)=vvhn(ix,jy,i,l)
        ttlev(i)=tthn(ix,jy,i,n,l)
        qvlev(i)=qvhn(ix,jy,i,n,l)
      end do

      call richardson(psn(ix,jy,1,n,l),ustarn(ix,jy,1,n,l),ttlev, &
           qvlev,ulev,vlev,nuvz,akz,bkz,sshfn(ix,jy,1,n,l), &
           tt2n(ix,jy,1,n,l),td2n(ix,jy,1,n,l),hmixn(ix,jy,1,n,l), &
           wstarn(ix,jy,1,n,l),hmixplus,ierr)
      if (ierr.lt.0) then
        write(*,9500) 'failure', ix, jy, l
        error stop 'calcpar_nest: richardson computation failed'
      endif
9500      format( 'calcparn - richardson ', a, ' - ix,jy=', 2i5 )

      if(lsubgrid.eq.1) then
        subsceff=min(excessoron(ix,jy,l),hmixplus)
      else
        subsceff=0.0
      endif
  !
  ! CALCULATE HMIX EXCESS ACCORDING TO SUBGRIDSCALE VARIABILITY AND STABILITY
  !
      hmixn(ix,jy,1,n,l)=hmixn(ix,jy,1,n,l)+subsceff
      hmixn(ix,jy,1,n,l)=max(hmixmin,hmixn(ix,jy,1,n,l)) ! minim PBL height
      hmixn(ix,jy,1,n,l)=min(hmixmax,hmixn(ix,jy,1,n,l)) ! maxim PBL height


  ! 4) Calculation of dry deposition velocities
  !********************************************

      if (DRYDEP) then
        ! z0(4)=0.016*ustarn(ix,jy,1,n,l)*ustarn(ix,jy,1,n,l)/ga
        ! z0(9)=0.016*ustarn(ix,jy,1,n,l)*ustarn(ix,jy,1,n,l)/ga
        z0_drydepn(ix,jy,l)=0.016*ustarn(ix,jy,1,n,l)*ustarn(ix,jy,1,n,l)/ga

  ! Calculate relative humidity at surface
  !***************************************
        rh=ew(td2n(ix,jy,1,n,l),psn(ix,jy,1,n,l))/ew(tt2n(ix,jy,1,n,l),psn(ix,jy,1,n,l))

        call getvdep_nest(n,ix,jy,ustarn(ix,jy,1,n,l), &
             tt2n(ix,jy,1,n,l),psn(ix,jy,1,n,l),1./olin(ix,jy,1,n,l), &
             ssrn(ix,jy,1,n,l),rh,sum(lsprecn(ix,jy,1,:,n,l))+ &
             sum(convprecn(ix,jy,1,:,n,l)),sdn(ix,jy,1,n,l),vd,l)

        do i=1,nspec
          vdepn(ix,jy,i,n,l)=vd(i)
        end do

      endif

  !******************************************************
  ! Calculate height of thermal tropopause (Hoinka, 1997)
  !******************************************************

  ! 1) Calculate altitudes of ECMWF model levels
  !*********************************************

      tvold=tt2n(ix,jy,1,n,l)*(1.+0.378*ew(td2n(ix,jy,1,n,l),psn(ix,jy,1,n,l))/ &
           psn(ix,jy,1,n,l))
      pold=psn(ix,jy,1,n,l)
      zold=0.
      do kz=2,nuvz
        pint=akz(kz)+bkz(kz)*psn(ix,jy,1,n,l)  ! pressure on model layers
        tv=tthn(ix,jy,kz,n,l)*(1.+0.608*qvhn(ix,jy,kz,n,l))

        if (abs(tv-tvold).gt.0.2) then
         zlev(kz)=zold+const*log(pold/pint)*(tv-tvold)/log(tv/tvold)
        else
          zlev(kz)=zold+const*log(pold/pint)*tv
        endif
        tvold=tv
        pold=pint
        zold=zlev(kz)
      end do

  ! 2) Define a minimum level kzmin, from which upward the tropopause is
  !    searched for. This is to avoid inversions in the lower troposphere
  !    to be identified as the tropopause
  !************************************************************************
      kzmin=1
      do kz=1,nuvz
        if (zlev(kz).ge.altmin) then
          kzmin=kz
          exit
        endif
      end do

  ! 3) Search for first stable layer above minimum height that fulfills the
  !    thermal tropopause criterion
  !************************************************************************

      kzloop : do kz=kzmin,nuvz
        lzloop : do lz=kz+1,nuvz
          if ((zlev(lz)-zlev(kz)).gt.2000.) then
            if (((tthn(ix,jy,kz,n,l)-tthn(ix,jy,lz,n,l))/ &
                 (zlev(lz)-zlev(kz))).lt.0.002) then
              tropopausen(ix,jy,1,n,l)=zlev(kz)
              exit kzloop
            endif
            exit lzloop
          endif
        end do lzloop
      end do kzloop

    end do
  end do

!$OMP END DO

  deallocate(vd)
!$OMP END PARALLEL

  ! Calculation of potential vorticity on 3-d grid
  !***********************************************

  call calcpv_nest(l,n)

  end do
end subroutine calcpar_nest

real function obukhov(ps,tsfc,tdsfc,tlev,ustar,hf,akm,bkm,plev)

  !********************************************************************
  !                                                                   *
  !                       Author: G. WOTAWA                           *
  !                       Date:   1994-06-27                          *
  !                                                                   *
  !     This program calculates Obukhov scale height from surface     *
  !     meteorological data and sensible heat flux.                   *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !  Update: A. Stohl, 2000-09-25, avoid division by zero by          *
  !  setting ustar to minimum value                                   *
  !  CHANGE: 17/11/2005 Caroline Forster NCEP GFS version             *
  !                                                                   *
  !   Unified ECMWF and GFS builds                                    *
  !   Marian Harustak, 12.5.2017                                      *
  !     - Merged obukhov and obukhov_gfs into one routine using       *
  !       if-then for meteo-type dependent code                       *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !     INPUT:                                                        *
  !                                                                   *
  !     ps      surface pressure [Pa]                                 *
  !     tsfc   surface temperature [K]                               *
  !     tdsfc  surface dew point [K]                                 *
  !     tlev    temperature first model level [K]                     *
  !     ustar   scale velocity [m/s]                                  *
  !     hf      surface sensible heat flux [W/m2]                     *
  !     akm     ECMWF vertical discretization parameter               *
  !     bkm     ECMWF vertical discretization parameter               *
  !     plev                                                          *
  !     metdata_format format of metdata (ecmwf/gfs)                  *
  !                                                                   *
  !********************************************************************

  use class_gribfile_mod
  use qvsat_mod

  implicit none

  real,dimension(:) :: akm,bkm
  real :: ps,tsfc,tdsfc,tlev,ustar,hf,e,tv,rhoa,plev
  real :: ak1,bk1,theta,thetastar


  e=ew(tdsfc,ps)                           ! vapor pressure
  tv=tsfc*(1.+0.378*e/ps)               ! virtual temperature
  rhoa=ps/(r_air*tv)                      ! air density
  if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
  ak1=(akm(1)+akm(2))*0.5
  bk1=(bkm(1)+bkm(2))*0.5
  plev=ak1+bk1*ps                        ! Pressure level 1
  end if
  theta=tlev*(100000./plev)**(r_air/cpa) ! potential temperature
  if (ustar.le.0.) ustar=1.e-8
  thetastar=hf/(rhoa*cpa*ustar)           ! scale temperature
  if(abs(thetastar).gt.1.e-10) then
     obukhov=theta*ustar**2/(karman*ga*thetastar)
  else
     obukhov=9999                        ! zero heat flux
  endif
  if (obukhov.gt. 9999.) obukhov= 9999.
  if (obukhov.lt.-9999.) obukhov=-9999.
end function obukhov

subroutine richardson(psfc,ust,ttlev,qvlev,ulev,vlev,nuvz, &
       akz,bkz,hf,tt2,td2,h,wst,hmixplus,ierr)
  !                        i    i    i     i    i    i    i
  ! i   i  i   i   i  o  o     o
  !****************************************************************************
  !                                                                           *
  !     Calculation of mixing height based on the critical Richardson number. *
  !     Calculation of convective time scale.                                 *
  !     For unstable conditions, one iteration is performed. An excess        *
  !     temperature (dependent on hf and wst) is calculated, added to the     *
  !     temperature at the lowest model level. Then the procedure is repeated.*
  !                                                                           *
  !     Author: A. Stohl                                                      *
  !                                                                           *
  !     22 August 1996                                                        *
  !                                                                           *
  !     Literature:                                                           *
  !     Vogelezang DHP and Holtslag AAM (1996): Evaluation and model impacts  *
  !     of alternative boundary-layer height formulations. Boundary-Layer     *
  !     Meteor. 81, 245-269.                                                  *
  !                                                                           *
  !****************************************************************************
  !                                                                           *
  !     Update: 1999-02-01 by G. Wotawa                                       *
  !                                                                           *
  !     Two meter level (temperature, humidity) is taken as reference level   *
  !     instead of first model level.                                         *
  !     New input variables tt2, td2 introduced.                              *
  !                                                                           *
  !     CHANGE: 17/11/2005 Caroline Forster NCEP GFS version                  * 
  !                                                                           *
  !     Unified ECMWF and GFS builds                                          *
  !     Marian Harustak, 12.5.2017                                            *
  !       - Merged richardson and richardson_gfs into one routine using       *
  !         if-then for meteo-type dependent code                             *
  !                                                                           *
  !****************************************************************************
  !                                                                           *
  ! Variables:                                                                *
  ! h                          mixing height [m]                              *
  ! hf                         sensible heat flux                             *
  ! psfc                      surface pressure at point (xt,yt) [Pa]         *
  ! tv                         virtual temperature                            *
  ! wst                        convective velocity scale                      *
  ! metdata_format             format of metdata (ecmwf/gfs)                  *
  !                                                                           *
  ! Constants:                                                                *
  ! ric                        critical Richardson number                     *
  !                                                                           *
  !****************************************************************************

  use class_gribfile_mod
  use qvsat_mod

  implicit none

  integer,intent(out) ::            &
    ierr                              ! Returns error when no richardson number can be found
  real, intent(out) ::              &
    h,                              & ! mixing height [m]
    wst,                            & ! convective velocity scale
    hmixplus                          !
  integer,intent(in)  ::            &
    nuvz                              ! Upper vertical level
  real,intent(in) ::                &
    psfc,                           & ! surface pressure at point (xt,yt) [Pa] 
    ust,                            & ! Scale velocity
    hf,                             & ! Surface sensible heat flux
    tt2,td2                           ! Temperature
  real,intent(in),dimension(:) ::   &
    ttlev,                          &
    qvlev,                          &
    ulev,                           &
    vlev,                           &
    akz,bkz
  integer ::                        &
    i,k,iter,llev,loop_start,kcheck   ! Loop variables
  real ::                           &
    tv,tvold,                       & ! Virtual temperature
    zref,z,zold,zl,zl1,zl2,         & ! Heights
    pint,pold,                      & ! Pressures
    theta,thetaold,thetaref,thetal, & ! Potential temperature
    theta1,theta2,thetam,           &
    ri,                             & ! Richardson number per level
    ril,                            & ! Richardson number sub level
    excess,                         & !
    ul,vl,                          & ! Velocities sub level
    wspeed,                         & ! Wind speed at z=hmix
    bvfsq,                          & ! Brunt-Vaisala frequency
    bvf,                            & ! square root of bvfsq
    rh,rhold,rhl
  real,parameter    :: const=r_air/ga, ric=0.25, b=100., bs=8.5
  integer,parameter :: itmax=3

  excess=0.0

  if (metdata_format.eq.GRIBFILE_CENTRE_NCEP) then
    ! NCEP version: find first model level above ground
    !**************************************************

     llev = 0
     do i=1,nuvz
       if (psfc.lt.akz(i)) llev=i
     end do
     llev = llev+1
    ! sec llev should not be 1!
     if (llev.eq.1) llev = 2
     if (llev.gt.nuvz) llev = nuvz-1
    ! NCEP version
  end if


  ! Compute virtual temperature and virtual potential temperature at
  ! reference level (2 m)
  !*****************************************************************

  do iter=1,itmax,1

    pold=psfc
    tvold=tt2*(1.+0.378*ew(td2,psfc)/psfc)
    zold=2.0
    zref=zold
    rhold=ew(td2,psfc)/ew(tt2,psfc)


    thetaref=tvold*(100000./pold)**(r_air/cpa)+excess
    thetaold=thetaref


    ! Integrate z up to one level above zt
    !*************************************
    if (metdata_format.eq.GRIBFILE_CENTRE_NCEP) then
      loop_start=llev
    else
      loop_start=2
    end if
    kcheck=loop_start
    do k=loop_start,nuvz
      kcheck=k
      pint=akz(k)+bkz(k)*psfc  ! pressure on model layers
      tv=ttlev(k)*(1.+0.608*qvlev(k))

      if (abs(tv-tvold).gt.0.2) then
        z=zold+const*log(pold/pint)*(tv-tvold)/log(tv/tvold)
      else
        z=zold+const*log(pold/pint)*tv
      endif

      theta=tv*(100000./pint)**(r_air/cpa)
    ! PS
      rh = qvlev(k) / f_qvsat( pint, ttlev(k) )


    ! Calculate Richardson number at each level
    !****************************************

      ri=ga/thetaref*(theta-thetaref)*(z-zref)/ &
           max(((ulev(k)-ulev(2))**2+(vlev(k)-vlev(2))**2+b*ust**2),0.1)

    !  addition of second condition: MH should not be placed in an
    !  unstable layer (PS / Feb 2000)
      if (ri.gt.ric .and. thetaold.lt.theta) exit

      tvold=tv
      pold=pint
      rhold=rh
      thetaold=theta
      zold=z
    end do
    ! Check opied from FLEXPART-WRF, 2022 LB
    if (kcheck.ge.nuvz) then
      write(*,*) 'richardson not working, no stable layer -- k = nuvz'
      ierr = -10
      goto 7000
    endif
    !k=min(k,nuvz) ! ESO: make sure k <= nuvz (ticket #139) !MD change to work without goto

    ! Determine Richardson number between the critical levels
    !********************************************************

    zl1=zold
    theta1=thetaold
    do i=1,20
      zl=zold+real(i)/20.*(z-zold)
      ul=ulev(kcheck-1)+real(i)/20.*(ulev(kcheck)-ulev(kcheck-1))
      vl=vlev(kcheck-1)+real(i)/20.*(vlev(kcheck)-vlev(kcheck-1))
      thetal=thetaold+real(i)/20.*(theta-thetaold)
      rhl=rhold+real(i)/20.*(rh-rhold)
      ril=ga/thetaref*(thetal-thetaref)*(zl-zref)/ &
           max(((ul-ulev(2))**2+(vl-vlev(2))**2+b*ust**2),0.1)
      zl2=zl
      theta2=thetal
      if (ril.gt.ric) exit
      if (i.eq.20) then
        write(*,*) 'WARNING: NO RICHARDSON NUMBER GREATER THAN 0.25 FOUND', kcheck,nuvz,ril,ri
        exit
      endif
      zl1=zl
      theta1=thetal
      if (i.eq.20) error stop 'RICHARDSON: NO RICHARDSON NUMBER GREATER THAN 0.25 FOUND'
    end do

    h=zl
    thetam=0.5*(theta1+theta2)
    wspeed=sqrt(ul**2+vl**2)                    ! Wind speed at z=hmix
    bvfsq=(ga/thetam)*(theta2-theta1)/(zl2-zl1) ! Brunt-Vaisala frequency
                                                ! at z=hmix

    ! Under stable conditions, limit the maximum effect of the subgrid-scale topography
    ! by the maximum lifting possible from the available kinetic energy
    !*****************************************************************************

    if(bvfsq.le.0.) then
      hmixplus=9999.
    else
      bvf=sqrt(bvfsq)
      hmixplus=wspeed/bvf*convke
    endif


    ! Calculate convective velocity scale
    !************************************

    if (hf.lt.0.) then
      wst=(-h*ga/thetaref*hf/cpa)**0.333
      excess=-bs*hf/cpa/wst
    else
      wst=0.
      exit
    endif
  end do

  ierr = 0
  return

! Fatal error -- print the inputs
7000  continue
  write(*,'(a         )') 'nuvz'
  write(*,'(i5        )')  nuvz
  write(*,'(a         )') 'psfc,ust,hf,tt2,td2,h,wst,hmixplus'
  write(*,'(1p,4e18.10)')  psfc,ust,hf,tt2,td2,h,wst,hmixplus
  return
end subroutine richardson

real function scalev(ps,t,td,stress)

  !********************************************************************
  !                                                                   *
  !                       Author: G. WOTAWA                           *
  !                       Date:   1994-06-27                          *
  !                       Update: 1996-05-21 A. Stohl                 *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !     This Programm calculates scale velocity ustar from surface    *
  !     stress and air density.                                       *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !     INPUT:                                                        *
  !                                                                   *
  !     ps      surface pressure [Pa]                                 *
  !     t       surface temperature [K]                               *
  !     td      surface dew point [K]                                 *
  !     stress  surface stress [N/m2]                                 *
  !                                                                   *
  !********************************************************************
  use qvsat_mod

  implicit none

  real :: ps,t,td,e,tv,rhoa,stress

  e=ew(td,ps)                       ! vapor pressure
  tv=t*(1.+0.378*e/ps)           ! virtual temperature
  rhoa=ps/(r_air*tv)              ! air density
  scalev=sqrt(abs(stress)/rhoa)
end function scalev

end module getfields_mod

  !*****************************************************************************
  !                                                                            *
  ! L. Bakels 2022: This module contains all interpolation subroutines         *
  !                 Code has been organised into subroutines                   *
  !                 Vertical logarithmic interpolation is optional (par_mod)   *
  !                                                                            *
  !*****************************************************************************

module interpol_mod
  use par_mod
  use com_mod
  use windfields_mod
  use particle_mod

  implicit none

  real,allocatable,dimension(:,:) ::          &
    uprof,vprof,wprof,              &
    usigprof,vsigprof,wsigprof,     &
    rhoprof,rhogradprof
  logical,allocatable,dimension(:,:) ::       &
    indzindicator,depoindicator

  real :: u,v,w,usig,vsig,wsig

  real :: p1,p2,p3,p4,ddx,ddy,rddx,rddy,dtt,dt1,dt2
  real :: xtn,ytn
  real :: dz1out,dz2out
  integer :: nix,njy
  integer :: ix,jy,ixp,jyp,ngrid,indz,indzp
  integer :: induv,indpuv
  logical :: lbounds(2) ! marking particles below or above bounds
#ifdef ETA
  real,allocatable,dimension(:,:) :: wprofeta ! ,wsigprofeta
  real :: ueta,veta,weta,wsigeta
  integer :: indzeta,indzpeta
  logical :: lbounds_w(2),lbounds_uv(2) ! marking particles below or above bounds
#endif

#ifdef ETA
  private :: interpol_wind_eta,stdev_eta,interpol_partoutput_val_eta
#else
  private :: interpol_wind_meter,stdev_meter,interpol_partoutput_val_meter
#endif

  interface hor_interpol
    procedure hor_interpol_4d,hor_interpol_2d
  end interface hor_interpol
  
  interface hor_interpol_nest
    procedure hor_interpol_4d_nest,hor_interpol_2d_nest
  end interface hor_interpol_nest

  interface find_ngrid
    procedure find_ngrid_dp, find_ngrid_sp
  end interface find_ngrid

! uprof,vprof,wprof,usigprof,vsigprof,wsigprof,indzindicator, wsigprofeta,
! rhoprof,rhogradprof,wprofeta,depoindicator,
#ifdef ETA
!$OMP THREADPRIVATE( &
!$OMP u,v,w,usig,vsig,wsig, &
!$OMP p1,p2,p3,p4,ddx,ddy,rddx,rddy,dtt,dt1,dt2,ix,jy,ixp,jyp, &
!$OMP ngrid,indz,indzp, &
!$OMP induv,indpuv,lbounds,lbounds_w,lbounds_uv, &
!$OMP indzeta,indzpeta,ueta,veta,weta,wsigeta, &
!$OMP xtn,ytn,nix,njy,dz1out,dz2out)
#else
!$OMP THREADPRIVATE( &
!$OMP u,v,w,usig,vsig,wsig, &
!$OMP p1,p2,p3,p4,ddx,ddy,rddx,rddy,dtt,dt1,dt2,ix,jy,ixp,jyp, &
!$OMP ngrid,indz,indzp, &
!$OMP induv,indpuv,lbounds,xtn,ytn,nix,njy,dz1out,dz2out)
#endif


contains

subroutine alloc_interpol ! wsigprofeta(nzmax,numthreads),
  implicit none 
  integer :: stat

  allocate( uprof(nzmax,numthreads),vprof(nzmax,numthreads),wprof(nzmax,numthreads),      &
    usigprof(nzmax,numthreads),vsigprof(nzmax,numthreads),wsigprof(nzmax,numthreads),  &
    rhoprof(nzmax,numthreads),rhogradprof(nzmax,numthreads), &
    indzindicator(nzmax,numthreads),stat=stat)
  if (stat.ne.0) error stop "Could not allocate interpol prof arrays"
#ifdef ETA
  allocate( wprofeta(nzmax,numthreads),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wprofeta"
#endif
  if (DRYDEP) then
    allocate( depoindicator(maxspec,numthreads),stat=stat)
    if (stat.ne.0) error stop "Could not allocate depoindicator"
  endif
end subroutine alloc_interpol

subroutine dealloc_interpol ! wsigprofeta,
  deallocate(uprof,vprof,wprof,      &
    usigprof,vsigprof,wsigprof,  &
    rhoprof,rhogradprof,indzindicator)
#ifdef ETA
  deallocate(wprofeta)
#endif
  if (DRYDEP) deallocate( depoindicator )
end subroutine dealloc_interpol

subroutine init_interpol(itime,xt,yt,zt,zteta)

  ! This routine initialises all important values used in the interpol module
  ! This includes:
  ! - The current grid number in which the particle is positioned
  ! - The interpolation fractions of the grid (x,y,z) and of time

  integer, intent(in) :: itime             ! time step
  real, intent(in)    :: xt,yt             ! particle positions
  real, intent(in)    :: zt                ! height in meters
  real, intent(in)    :: zteta             ! height in eta coordinates

  call find_ngrid(xt,yt)
  call find_grid_indices(xt,yt)
  call find_grid_distances(xt,yt)
  call find_time_vars(itime)
  call find_z_level(zt,zteta)

end subroutine init_interpol

subroutine find_grid_indices(xt,yt)

  real, intent(in) :: xt,yt                 ! particle positions

  if (ngrid.gt.0) then ! Nest
    xtn=(xt-xln(ngrid))*xresoln(ngrid)
    ytn=(yt-yln(ngrid))*yresoln(ngrid)
    ! ix=int(xtn)
    ! jy=int(ytn)
    ! nix=nint(xtn)
    ! njy=nint(ytn)
    nix=max(min(int(xtn),nxn(ngrid)-1),0)
    njy=max(min(int(ytn),nyn(ngrid)-1),0)
    ix=nix
    jy=njy
    ixp=ix+1
    jyp=jy+1
    return
  else
    ix=int(xt)
    jy=int(yt)
    nix=ix!nint(xt)
    njy=jy!nint(yt)
    ixp=ix+1
    jyp=jy+1
  endif

  ! eso: Temporary fix for particle exactly at north pole
  if (jyp.ge.nymax) then
    write(*,*) 'WARNING: interpol_mod.f90 jyp >= nymax. xt,yt:',xt,yt
    jyp=jyp-1
  end if

  if (ixp.ge.nxmax) then
    write(*,*) 'WARNING: interpol_mod.f90 ixp >= nxmax. xt,yt:',xt,yt
    ixp=ixp-nxmax
  end if

end subroutine find_grid_indices

subroutine find_grid_distances(xt,yt)

  implicit none 

  real, intent(in) :: xt,yt                 ! particle positions

  if (ngrid.le.0) then
    ddx=xt-real(ix)
    ddy=yt-real(jy)
  else ! Nest
    ddx=xtn-real(ix)
    ddy=ytn-real(jy)
  endif
  rddx=1.-ddx
  rddy=1.-ddy
  p1=rddx*rddy
  p2=ddx*rddy
  p3=rddx*ddy
  p4=ddx*ddy

end subroutine find_grid_distances

subroutine find_time_vars(itime)

  integer, intent(in) :: itime             ! time step
  
  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)  

end subroutine find_time_vars

subroutine find_z_level(zt,zteta)

  real, intent(in)     :: &
    zt,                   & ! height in meters
    zteta                   ! height in eta

#ifdef ETA
    call find_z_level_meters(zt)
    call find_z_level_eta(zteta)
#else
    call find_z_level_meters(zt)
#endif

end subroutine find_z_level

subroutine find_z_level_meters(zt)

  real, intent(in)     :: zt       ! height in meters
  integer              :: i

  indz=nz-1
  indzp=nz
  if (zt.le.height(1)) then
    lbounds(1)=.true.
    lbounds(2)=.false.
    indz=1
    indzp=2
  else if (zt.ge.height(nz)) then
    lbounds(1)=.false.
    lbounds(2)=.true.
  else
    lbounds(1)=.false.
    lbounds(2)=.false.
    do i=2,nz
      if (height(i).gt.zt) then
        indz=i-1
        indzp=i
        exit
      endif
    end do
  endif

end subroutine find_z_level_meters

#ifdef ETA
subroutine find_z_level_eta(zteta)

  real, intent(in)       :: zteta    ! height in eta coordinates

  call find_z_level_eta_w(zteta)

  call find_z_level_eta_uv(zteta)

end subroutine find_z_level_eta

subroutine find_z_level_eta_w(zteta)

  real, intent(in)       :: zteta    ! height in eta coordinates
  integer                :: i        ! loop variable

  indzeta=nz-1
  indzpeta=nz
  ! Flag particles that are above or below bounds
  if (zteta.ge.wheight(1)) then
    lbounds_w(1)=.true.
    lbounds_w(2)=.false.
    indzeta=1
    indzpeta=2
  else if (zteta.le.wheight(nz)) then
    lbounds_w(1)=.false.
    lbounds_w(2)=.true.
  else
    lbounds_w(1)=.false.
    lbounds_w(2)=.false.
    do i=2,nz
      if (wheight(i).lt.zteta) then
        indzeta=i-1
        indzpeta=i
        exit
      endif
    end do
  endif

end subroutine find_z_level_eta_w

subroutine find_z_level_eta_uv(zteta)

  real, intent(in)       :: zteta    ! height in eta coordinates
  integer                :: i        ! loop variable

  induv=nz-1
  indpuv=nz
  if (zteta.gt.uvheight(1)) then
    lbounds_uv(1)=.true.
    lbounds_uv(2)=.false.
    induv=1 
    indpuv=2
  else if (zteta.lt.uvheight(nz)) then
    lbounds_uv(1)=.false.
    lbounds_uv(2)=.true.
  else
    lbounds_uv(1)=.false.
    lbounds_uv(2)=.false.
    do i=2,nz
      if (uvheight(i).lt.zteta) then
        induv=i-1
        indpuv=i
        exit
      endif
    end do
  endif

end subroutine find_z_level_eta_uv
#endif

subroutine find_vert_vars(vertlevels,zpos,zlevel,dz1,dz2,bounds,wlevel)

  !*****************************************************************************
  !                                                                            *
  ! This subroutine computes the vertical interpolation variables              *
  ! logarithmically, unless log_interpol=.false. in the par_mod                *
  !                                                                            *
  ! Author: L. Bakels                                                          *
  !*****************************************************************************

  real, intent(in)    :: vertlevels(:)    ! vertical levels in coordinate system
  real, intent(in)    :: zpos             ! verticle particle position
  integer, intent(in) :: zlevel           ! vertical level of interest
  logical, intent(in) :: bounds(2),wlevel ! flag marking if particles are
                                          ! outside bounds  
  real, intent(inout) :: dz1,dz2          ! fractional distance to point 1 
                                          ! (closer to ground) and 2
  real                :: dz,dh1,dh,pfact
  real                :: psint1(2),psint,pr1,pr2,pr_test 
                                          ! pressure of encompassing levels
  integer             :: m

  ! Only do logarithmic interpolation when using ETA coordinates, since the
  ! levels are following pressure, while METER levels are linear.
  !##############################################################
  if (.not. log_interpol) then
    call find_vert_vars_lin(vertlevels,zpos,zlevel,dz1,dz2,bounds)
    return
  endif
  
  ! To check if taking the logarithm is safe
  if (wlevel) then
    pr_test=akm(zlevel+1)+bkm(zlevel+1)
  else
    pr_test=akz(zlevel+1)+bkz(zlevel+1)
  endif

  ! If the particle is below bounds (bounds(1)==.true.):
  if (bounds(1)) then
    dz1=0.
    dz2=1.
  ! If above bounds (bounds(2)==.true.):
  else if (bounds(2)) then
    dz1=1.
    dz2=0.

  ! Instead of the linear z variables, we need the ones that correspond to 
  ! the pressure of the height of the particle in relation to the model levels
  !***************************************************************************
  else if (pr_test.eq.0) then
    dz=1./(vertlevels(zlevel+1)-vertlevels(zlevel))
    dz1=(zpos-vertlevels(zlevel))*dz
    dz2=(vertlevels(zlevel+1)-zpos)*dz
  else
    if (ngrid.le.0) then
      do m=1,2
        call hor_interpol(ps,psint1(m),1,memind(m),1)
      end do
    else
      do m=1,2
        call hor_interpol_nest(psn,psint1(m),1,memind(m),1)
      end do
    endif
    call temporal_interpolation(psint1(1),psint1(2),psint)
    dh = vertlevels(zlevel+1)-vertlevels(zlevel)
    dh1 = zpos - vertlevels(zlevel)
    if (wlevel) then
      pr1=akm(zlevel) + bkm(zlevel)*psint
      pr2=akm(zlevel+1) + bkm(zlevel+1)*psint
    else
      pr1=akz(zlevel) + bkz(zlevel)*psint
      pr2=akz(zlevel+1) + bkz(zlevel+1)*psint
    endif
    pfact = log(pr2/pr1)*dh1/dh  
    dz = 1./(pr2-pr1)
    dz1 = pr1*(exp(pfact)-1.)*dz 
    dz2 = 1.-dz1
  endif
  ! else if ((vertlevels(zlevel).eq.0).or.(vertlevels(zlevel+1).eq.0)) then
  !   ! Linear interpolation for bottom or top layer is zero
  !   dz=1./(vertlevels(zlevel+1)-vertlevels(zlevel))
  !   dz1=(zpos-vertlevels(zlevel))*dz
  !   dz2=(vertlevels(zlevel+1)-zpos)*dz
  ! else 
  !   ! Logaritmic interpolation
  !   dz=1./(log(vertlevels(zlevel+1))-log(vertlevels(zlevel)))
  !   dz1=(log(zpos)-log(vertlevels(zlevel)))*dz
  !   dz2=(log(vertlevels(zlevel+1))-log(zpos))*dz
  ! endif
end subroutine find_vert_vars

subroutine find_vert_vars_lin(vertlevels,zpos,zlevel,dz1,dz2,bounds)

  real, intent(in)    :: vertlevels(:)   ! vertical levels in coordinate system
  real, intent(in)    :: zpos            ! verticle particle position
  integer, intent(in) :: zlevel          ! vertical level of interest
  logical, intent(in) :: bounds(2)       ! flag marking if particles are outside
                                         ! bounds  
  real, intent(inout) :: dz1,dz2         ! fractional distance to point 1
                                         ! (closer to ground) and 2
  real                :: dz

  ! If the particle is below bounds (bounds(1)==.true.):
  if (bounds(1)) then
    dz1=0.
    dz2=1.
  ! If above bounds (bounds(2)==.true.):
  else if (bounds(2)) then
    dz1=1.
    dz2=0.
  else
    dz=1./(vertlevels(zlevel+1)-vertlevels(zlevel))
    dz1=(zpos-vertlevels(zlevel))*dz
    dz2=(vertlevels(zlevel+1)-zpos)*dz
  endif
end subroutine find_vert_vars_lin

subroutine find_ngrid_dp(xt,yt)

  real eps           
  real(kind=dp), intent(in) :: xt,yt ! particle positions on grid
  integer :: j

  eps=nxmax/3.e5
  if (nglobal.and.(real(yt).gt.switchnorthg)) then
    ngrid=-1
  else if (sglobal.and.(real(yt).lt.switchsouthg)) then
    ngrid=-2
  else
    ngrid=0
    ! Temporary fix for nested layer edges: replaced eps with dxn and dyn (LB)
    do j=numbnests,1,-1
      if (real(xt).gt.xln(j)+dxn(j) .and. real(xt).lt.xrn(j)-dxn(j) .and. &
          real(yt).gt.yln(j)+dyn(j) .and. real(yt).lt.yrn(j)-dyn(j)) then
        ngrid=j
        exit
      endif
    end do
  endif
  
end subroutine find_ngrid_dp

subroutine find_ngrid_sp(xt,yt)

  real :: eps           
  real, intent(in) :: xt,yt ! particle positions on grid
  integer :: j

  eps=nxmax/3.e5
  if (nglobal .and. yt.gt.switchnorthg) then
    ngrid=-1
  else if (sglobal .and. yt.lt.switchsouthg) then
    ngrid=-2
  else
    ngrid=0
    ! Temporary fix for nested layer edges: replaced eps with dxn and dyn (LB)
    do j=numbnests,1,-1
      if (xt.gt.xln(j)+dxn(j) .and. xt.lt.xrn(j)-dxn(j) .and. &
          yt.gt.yln(j)+dyn(j) .and. yt.lt.yrn(j)-dyn(j)) then
        ngrid=j
        exit
      endif
    end do
  endif
end subroutine find_ngrid_sp

subroutine hor_interpol_4d(field,output,zlevel,indexh,ztot)

  integer, intent(in) :: zlevel,ztot,indexh   ! interpolation z level, z
  real, intent(in)    :: field(0:nxmax-1,0:nymax-1,ztot,numwfmem) 
   ! input field to interpolate
  real, intent(inout) :: output  ! interpolated values

  output=p1*field(ix ,jy ,zlevel,indexh) &
       + p2*field(ixp,jy ,zlevel,indexh) &
       + p3*field(ix ,jyp,zlevel,indexh) &
       + p4*field(ixp,jyp,zlevel,indexh)
end subroutine hor_interpol_4d

subroutine hor_interpol_2d(field,output)
  implicit none 

  real, intent(in)    :: field(0:nxmax-1,0:nymax-1)       ! 2D imput field
  real, intent(inout) :: output                           ! Interpolated value

  output=p1*field(ix ,jy) &
         + p2*field(ixp,jy) &
         + p3*field(ix ,jyp) &
         + p4*field(ixp,jyp)
end subroutine hor_interpol_2d

subroutine hor_interpol_4d_nest(field,output,zlevel,indexh,ztot)

  integer, intent(in) :: zlevel,ztot,indexh   ! interpolation z level, z
  real, intent(in)    :: field(0:nxmaxn-1,0:nymaxn-1,ztot,numwfmem,numbnests) 
                                              ! input field to interpolate 
  real, intent(inout) :: output               ! interpolated values

  output=p1*field(ix ,jy ,zlevel,indexh,ngrid) &
       + p2*field(ixp,jy ,zlevel,indexh,ngrid) &
       + p3*field(ix ,jyp,zlevel,indexh,ngrid) &
       + p4*field(ixp,jyp,zlevel,indexh,ngrid)
end subroutine hor_interpol_4d_nest

subroutine hor_interpol_2d_nest(field,output)

  real, intent(in)    :: field(0:nxmaxn-1,0:nymaxn-1,numbnests) 
                                          ! input field to interpolate
  real, intent(inout) :: output           ! interpolated values

  output=p1*field(ix ,jy ,ngrid) &
       + p2*field(ixp,jy ,ngrid) &
       + p3*field(ix ,jyp,ngrid) &
       + p4*field(ixp,jyp,ngrid)
end subroutine hor_interpol_2d_nest

subroutine temporal_interpolation(time1,time2,output)

  real, intent(in)    :: time1,time2     ! input data at two timesteps 
  real, intent(inout) :: output          ! interpolated data

  output=(time1*dt2+time2*dt1)*dtt
end subroutine temporal_interpolation

subroutine vert_interpol(input1,input2,dz1,dz2,output)

  real, intent(in)    :: input1,input2   ! input data at two vertical levels, 
                                         ! 1 being closer to ground
  real, intent(in)    :: dz1,dz2         ! logarithmic interpolation values
  real, intent(inout) :: output          ! interpolated data

  output = input1*dz2 + input2*dz1 ! input1**dz2 * input2**dz1
end subroutine vert_interpol

subroutine bilin_spatial_interpol(field,output,zlevel,dz1,dz2,ztot)

  integer, intent(in) :: zlevel,ztot        ! interpolation z level
  real, intent(in)    :: field(0:nxmax-1,0:nymax-1,ztot,numwfmem)  
                                            ! input field to interpolate
  real, intent(in)    :: dz1,dz2
  real, intent(inout) :: output(2)          ! interpolated values
  integer             :: m,n,indzh
  real                :: output1(2)

  do m=1,2
    
    do n=1,2
      indzh=zlevel+n-1
      call hor_interpol_4d(field,output1(n),indzh,memind(m),ztot)
    end do
    
    !**********************************
    ! 2.) Linear vertical interpolation on logarithmic scale
    !**********************************    
    call vert_interpol(output1(1),output1(2),dz1,dz2,output(m))
    
  end do
  
end subroutine bilin_spatial_interpol

subroutine bilin_spatial_interpol_nest(field,output,zlevel,dz1,dz2,ztot)

  integer, intent(in) :: zlevel,ztot       ! interpolation z level
  real, intent(in)    :: field(0:nxmaxn-1,0:nymaxn-1,ztot,numwfmem,numbnests)  
                                           ! input field to interpolate
  real, intent(in)    :: dz1,dz2
  real, intent(inout) :: output(2)         ! interpolated values
  integer             :: m,n,indzh
  real                :: output1(2)

  do m=1,2
  
    do n=1,2
      indzh=zlevel+n-1
      call hor_interpol_4d_nest(field,output1(n),indzh,memind(m),ztot)
    end do
    
    !**********************************
    ! 2.) Linear vertical interpolation on logarithmic scale
    !**********************************    
    call vert_interpol(output1(1),output1(2),dz1,dz2,output(m))
    
  end do
  
end subroutine bilin_spatial_interpol_nest

subroutine compute_sl_sq(field,sl,sq,zlevel,indexh,ztot)

  integer, intent(in) :: zlevel,ztot,indexh   ! interpolation z levels
  real, intent(in)    :: field(0:nxmax-1,0:nymax-1,ztot,numwfmem) 
                                              ! input field to interpolate
  real, intent(inout) :: sl,sq                ! standard deviation

  sl=sl+field(ix ,jy ,zlevel,indexh)+field(ixp,jy ,zlevel,indexh) &
       +field(ix ,jyp,zlevel,indexh)+field(ixp,jyp,zlevel,indexh)

  sq=sq+field(ix ,jy ,zlevel,indexh)*field(ix ,jy ,zlevel,indexh)+ &
        field(ixp,jy ,zlevel,indexh)*field(ixp,jy ,zlevel,indexh)+ &
        field(ix ,jyp,zlevel,indexh)*field(ix ,jyp,zlevel,indexh)+ &
        field(ixp,jyp,zlevel,indexh)*field(ixp,jyp,zlevel,indexh)

end subroutine compute_sl_sq

subroutine compute_sl_sq_nest(field,sl,sq,zlevel,indexh,ztot)
  integer, intent(in) :: zlevel,ztot,indexh   ! interpolation z levels
  real, intent(in)    :: field(0:nxmaxn-1,0:nymaxn-1,ztot,numwfmem,numbnests) 
                                              ! input field to interpolate
  real, intent(inout) :: sl,sq                ! standard deviation

  sl=sl+field(ix ,jy ,zlevel,indexh,ngrid)+field(ixp,jy ,zlevel,indexh,ngrid) &
       +field(ix ,jyp,zlevel,indexh,ngrid)+field(ixp,jyp,zlevel,indexh,ngrid)

  sq=sq+field(ix ,jy ,zlevel,indexh,ngrid)*field(ix ,jy ,zlevel,indexh,ngrid)+ &
        field(ixp,jy ,zlevel,indexh,ngrid)*field(ixp,jy ,zlevel,indexh,ngrid)+ &
        field(ix ,jyp,zlevel,indexh,ngrid)*field(ix ,jyp,zlevel,indexh,ngrid)+ &
        field(ixp,jyp,zlevel,indexh,ngrid)*field(ixp,jyp,zlevel,indexh,ngrid)
end subroutine compute_sl_sq_nest

subroutine stdev(sl,sq,divisor,output)

  real, intent(in) :: sl,sq,divisor
  real, intent(out) :: output
  real :: xaux
  real,parameter      :: eps=1.0e-30

  xaux= sq - sl*sl/divisor

  if (xaux.lt.eps) then
    output=0.
  else
    output=sqrt(xaux/(divisor-1.))
  endif

end subroutine stdev

! Interpolation functions
!************************

subroutine interpol_pbl(itime,xt,yt,zt,zteta,ithread)
  !                          i   i  i  i
  !*****************************************************************************
  !                                                                            *
  !  This subroutine interpolates everything that is needed for calculating the*
  !  dispersion.                                                               *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    16 December 1997                                                        *
  !                                                                            *
  !  Revision March 2005 by AST : all output variables in common block cal-    *
  !                               culation of standard deviation done in this  *
  !                               routine rather than subroutine call in order *
  !                               to save computation time                     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! memtime(3) [s]     times of the wind fields in memory                      *
  ! xt,yt,zt           coordinates position for which wind data shall be       *
  !                    culated                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use turbulence_mod

  integer,intent(in)  :: ithread ! If OMP, number of the thread, otherwise 1
  integer, intent(in) :: itime
  real, intent(in)    :: xt,yt,zt,zteta
  integer             :: m,n,indexh
  integer             :: iw(2),iweta(2)
  real                :: uh1(2),vh1(2),wh1(2),wetah1(2),rho1(2),rhograd1(2)
  real                :: dz1weta,dz2weta
  real,parameter      :: eps=1.0e-30

  ! Auxiliary variables needed for interpolation
  real :: ust1(2),wst1(2),oli1(2),oliaux

  !********************************************
  ! Multilinear interpolation in time and space
  !********************************************

  ! ngrid and grid coordinates have already been definded, and are included
  ! in the input (for nested: xtn,ytn; for not nested: xts,yts)

  !************************************************************************
  ! Determine the lower left corner and its distance to the current position
  !*************************************************************************

  call find_grid_distances(xt,yt)

  ! Calculate variables for time interpolation
  !*******************************************

  call find_time_vars(itime)

  !********************************************************
  ! 1. Interpolate u*, w* and Obukhov length for turbulence
  !********************************************************

  ! a) Bilinear horizontal interpolation
  if (ngrid.le.0) then ! No nest
    do m=1,2
      indexh=memind(m)
      call hor_interpol(ustar,ust1(m),1,memind(m),1)
      call hor_interpol(wstar,wst1(m),1,memind(m),1)
      call hor_interpol(oli,oli1(m),1,memind(m),1)
    end do
  else ! Nest
    do m=1,2
      indexh=memind(m)
      call hor_interpol_nest(ustarn,ust1(m),1,memind(m),1)
      call hor_interpol_nest(wstarn,wst1(m),1,memind(m),1)
      call hor_interpol_nest(olin,oli1(m),1,memind(m),1)
    end do
  endif    

  ! b) Temporal interpolation
  call temporal_interpolation(ust1(1),ust1(2),ust)
  call temporal_interpolation(wst1(1),wst1(2),wst)
  call temporal_interpolation(oli1(1),oli1(2),oliaux)

  if (oliaux.ne.0.) then
    ol=1./oliaux
  else
    ol=99999.
  endif

  ! Within the PBL, only METER coordinates are used
  ! with the exception of mesoscale turbulence,
  ! which uses wsigeta computed in interpol_mesoscale
  !**************************************************

  ! Determine the level below the current position
  !***********************************************
  call find_z_level_meters(zt)

  iw(:)=(/ indz, indzp /)

  ! w(eta) velocities are necessary for the Petterssen correction
  !**************************************************************
#ifdef ETA
    call find_z_level_eta(zteta)
    iweta(:)=(/ indzeta, indzpeta /)
#endif

  !**************************************
  ! 1.) Bilinear horizontal interpolation
  ! 2.) Temporal interpolation (linear)
  !**************************************
  
  ! Loop over 2 time steps and indz levels
  !***************************************
  if (ngrid.le.0) then ! No nest
    do n=1,2
      do m=1,2
        call hor_interpol(ww,wh1(m),iw(n),memind(m),nzmax)
#ifdef ETA
        call hor_interpol(wweta,wetah1(m),iweta(n),memind(m),nzmax)
#endif
        call hor_interpol(rho,rho1(m),iw(n),memind(m),nzmax)
        call hor_interpol(drhodz,rhograd1(m),iw(n),memind(m),nzmax)
        if (ngrid.lt.0) then
          call hor_interpol(uupol,uh1(m),iw(n),memind(m),nzmax)
          call hor_interpol(vvpol,vh1(m),iw(n),memind(m),nzmax)
        else
          call hor_interpol(uu,uh1(m),iw(n),memind(m),nzmax)
          call hor_interpol(vv,vh1(m),iw(n),memind(m),nzmax)
        endif
      end do
      call temporal_interpolation(wh1(1),wh1(2),wprof(iw(n),ithread))
#ifdef ETA
      call temporal_interpolation(wetah1(1),wetah1(2),wprofeta(iweta(n),ithread))
#endif      
      call temporal_interpolation(uh1(1),uh1(2),uprof(iw(n),ithread))
      call temporal_interpolation(vh1(1),vh1(2),vprof(iw(n),ithread))
      call temporal_interpolation(rho1(1),rho1(2),rhoprof(iw(n),ithread))
      call temporal_interpolation(rhograd1(1),rhograd1(2),rhogradprof(iw(n),ithread))
    end do
  else ! Nest
    do n=1,2
      do m=1,2
        call hor_interpol_nest(wwn,wh1(m),iw(n),memind(m),nzmax)
#ifdef ETA
        call hor_interpol_nest(wwetan,wetah1(m),iweta(n),memind(m),nzmax)
#endif
        call hor_interpol_nest(uun,uh1(m),iw(n),memind(m),nzmax)
        call hor_interpol_nest(vvn,vh1(m),iw(n),memind(m),nzmax)
        call hor_interpol_nest(rhon,rho1(m),iw(n),memind(m),nzmax)
        call hor_interpol_nest(drhodzn,rhograd1(m),iw(n),memind(m),nzmax)
      end do
      call temporal_interpolation(wh1(1),wh1(2),wprof(iw(n),ithread))
#ifdef ETA
      call temporal_interpolation(wetah1(1),wetah1(2),wprofeta(iweta(n),ithread))
#endif
      call temporal_interpolation(uh1(1),uh1(2),uprof(iw(n),ithread))
      call temporal_interpolation(vh1(1),vh1(2),vprof(iw(n),ithread))
      call temporal_interpolation(rho1(1),rho1(2),rhoprof(iw(n),ithread))
      call temporal_interpolation(rhograd1(1),rhograd1(2),rhogradprof(iw(n),ithread))

      indzindicator(iw(n),ithread)=.false.
    end do
  endif

  ! Only necessary for the Petterssen correction
#ifdef ETA
  call find_vert_vars(wheight,zteta,indzeta, &
    dz1weta,dz2weta,lbounds_w,.true.)
  call vert_interpol(wprofeta(indzeta,ithread),wprofeta(indzpeta,ithread), &
    dz1weta,dz2weta,weta)
#endif

end subroutine interpol_pbl

subroutine interpol_pbl_misslev(ithread)
  !*****************************************************************************
  !                                                                            *
  !  This subroutine interpolates u,v,w, density and density gradients.        *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    16 December 1997                                                        *
  !    Update: 2 March 1999                                                    *
  !                                                                            *
  !  Revision March 2005 by AST : all output variables in common block cal-    *
  !                               culation of standard deviation done in this  *
  !                               routine rather than subroutine call in order *
  !                               to save computation time                     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  level                                                   *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  integer,intent(in)  :: ithread ! number of OMP thread starting at 1
  real                :: uh1(2),vh1(2),wh1(2),rho1(2),rhograd1(2)
  integer             :: m,n,iw(2)

  ! Within the PBL, only METER coordinates are used
  ! with the exception of mesoscale turbulence,
  ! which uses wsigeta computed in interpol_mesoscale
  !**************************************************

  !********************************************
  ! Multilinear interpolation in time and space
  !********************************************

  iw(:)=(/ indz, indzp /)
  do n=1,2
    if (indzindicator(iw(n),ithread)) then
      if (ngrid.le.0) then ! No nest
        do m=1,2
          call hor_interpol(ww,wh1(m),iw(n),memind(m),nzmax)
          call hor_interpol(rho,rho1(m),iw(n),memind(m),nzmax)
          call hor_interpol(drhodz,rhograd1(m),iw(n),memind(m),nzmax)
          if (ngrid.lt.0) then
            call hor_interpol(uupol,uh1(m),iw(n),memind(m),nzmax)
            call hor_interpol(vvpol,vh1(m),iw(n),memind(m),nzmax)
          else
            call hor_interpol(uu,uh1(m),iw(n),memind(m),nzmax)
            call hor_interpol(vv,vh1(m),iw(n),memind(m),nzmax)
          endif
        end do
      else ! Nest
        do m=1,2
          call hor_interpol_nest(wwn,wh1(m),iw(n),memind(m),nzmax)
          call hor_interpol_nest(uun,uh1(m),iw(n),memind(m),nzmax)
          call hor_interpol_nest(vvn,vh1(m),iw(n),memind(m),nzmax)
          call hor_interpol_nest(rhon,rho1(m),iw(n),memind(m),nzmax)
          call hor_interpol_nest(drhodzn,rhograd1(m),iw(n),memind(m),nzmax)
        end do
      endif
      call temporal_interpolation(wh1(1),wh1(2),wprof(iw(n),ithread))
      call temporal_interpolation(uh1(1),uh1(2),uprof(iw(n),ithread))
      call temporal_interpolation(vh1(1),vh1(2),vprof(iw(n),ithread))
      call temporal_interpolation(rho1(1),rho1(2),rhoprof(iw(n),ithread))
      call temporal_interpolation(rhograd1(1),rhograd1(2),rhogradprof(iw(n),ithread))

      indzindicator(iw(n),ithread)=.false.
    endif
  end do
end subroutine interpol_pbl_misslev

subroutine interpol_pbl_short(zt,rhoa,rhograd,ithread)
  implicit none 

  integer,intent(in)  :: ithread ! number of OMP thread starting at 1
  real, intent(in)    :: zt
  real, intent(inout) :: rhoa,rhograd
  real                :: dz1,dz2

  call find_vert_vars(height,zt,indz,dz1,dz2,lbounds,.false.)

  call vert_interpol(wprof(indz,ithread),wprof(indzp,ithread),dz1,dz2,w)
  call vert_interpol(uprof(indz,ithread),uprof(indzp,ithread),dz1,dz2,u)
  call vert_interpol(vprof(indz,ithread),vprof(indzp,ithread),dz1,dz2,v)
  call vert_interpol(rhoprof(indz,ithread),rhoprof(indzp,ithread),dz1,dz2,rhoa)
  call vert_interpol(rhogradprof(indz,ithread),rhogradprof(indzp,ithread),dz1,dz2,rhograd)
end subroutine interpol_pbl_short

subroutine interpol_mesoscale(xt,yt,zt,zteta)

  use turbulence_mod

  real, intent(in)    :: xt,yt,zt,zteta
#ifdef ETA
  integer             :: iuv(2),iweta(2)
#endif
  integer             :: iw(2)

  ! Where in the grid? Stereographic (ngrid<0) or nested (ngrid>0)
  !***************************************************************
  call find_ngrid(xt,yt)

  call find_grid_indices(xt,yt)

  ! Determine the level below the current position
  !***********************************************
  call find_z_level_meters(zt)
  iw(:)=(/ indz, indzp /)
  
#ifdef ETA
  call find_z_level_eta(zteta)
  iuv(:)=(/ induv, indpuv /)
  iweta(:)=(/ indzeta, indzpeta /)
  call stdev_eta(iw,iuv,iweta)
#else
  iw(:)=(/ indz, indzp /)
  call stdev_meter(iw)
#endif

end subroutine interpol_mesoscale

subroutine interpol_wind(itime,xt,yt,zt,zteta)
  !                           i   i  i  i

  !*****************************************************************************
  !                                                                            *
  !  This subroutine interpolates the wind data to current trajectory position.*
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    16 December 1997                                                        *
  !                                                                            *
  !  Revision March 2005 by AST : all output variables in common block cal-    *
  !                               culation of standard deviation done in this  *
  !                               routine rather than subroutine call in order *
  !                               to save computation time                     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! u,v,w              wind components                                         *
  ! itime [s]          current temporal position                               *
  ! memtime(3) [s]     times of the wind fields in memory                      *
  ! xt,yt,zt           coordinates position for which wind data shall be       *
  !                    calculated                                              *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  integer, intent(in) :: itime
  real, intent(in)    :: xt,yt,zt,zteta
#ifdef ETA
  integer             :: iuv(2),iweta(2)
#else
  integer             :: iw(2)
#endif

  ! Where in the grid? Stereographic (ngrid<0) or nested (ngrid>0)
  !***************************************************************
  call find_ngrid(xt,yt)

  call find_grid_indices(xt,yt)
  ! ! Multilinear interpolation in time and space
  ! !********************************************

  ! Determine the lower left corner and its distance to the current position
  !*************************************************************************
  call find_grid_distances(xt,yt)

  ! Calculate variables for time interpolation
  !*******************************************
  call find_time_vars(itime)

  ! Interpolate over the windfields depending on the prefered
  ! coordinate system
  !**********************************************************
#ifdef ETA
  ! Same for eta coordinates
  !*************************
  call find_z_level_eta(zteta)

  iuv(:)  = (/ induv, indpuv /)
  iweta(:)= (/ indzeta, indzpeta /)
  call interpol_wind_eta(zteta,iuv,iweta)
  !call stdev_wind_eta(iw,iuv,iweta)
#else
  ! Determine the level below the current position for u,v
  !*******************************************************
  call find_z_level_meters(zt)

  iw(:)=(/ indz, indzp /)
  call interpol_wind_meter(zt,iw)
  !call stdev_wind_meter(iw)
#endif

end subroutine interpol_wind

subroutine interpol_wind_short(itime,xt,yt,zt,zteta)
!                                i   i  i  i  i

  !*****************************************************************************
  !                                                                            *
  !  This subroutine interpolates the wind data to current trajectory position.*
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    16 December 1997                                                        *
  !                                                                            *
  !  Revision March 2005 by AST : all output variables in common block         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! u,v,w              wind components                                         *
  ! itime [s]          current temporal position                               *
  ! memtime(3) [s]     times of the wind fields in memory                      *
  ! xt,yt,zt           coordinates position for which wind data shall be       *
  !                    calculated                                              *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  integer, intent(in) :: itime
  real, intent(in) :: xt,yt,zt,zteta
#ifdef ETA
  integer             :: iuv(2),iweta(2)
#else
  integer             :: iw(2)
#endif

  !********************************************
  ! Multilinear interpolation in time and space
  !********************************************

  ! Where in the grid? Stereographic (ngrid<0) or nested (ngrid>0)
  !***************************************************************
  call find_ngrid(xt,yt)
  call find_grid_indices(xt,yt)
  call find_grid_distances(xt,yt)

  ! Calculate variables for time interpolation
  !*******************************************
  call find_time_vars(itime)

  ! Interpolate over the windfields depending on the prefered
  ! coordinate system
  !**********************************************************
#ifdef ETA
  ! Determine the level below the current position for eta coordinates
  !*******************************************************************
  call find_z_level_eta(zteta)

  iuv(:)=(/ induv, indpuv /)
  iweta(:)=(/ indzeta, indzpeta /)
  ! Interpolate the u, v, weta windfields
  !**************************************
  call interpol_wind_eta(zteta,iuv,iweta)
#else

  ! Determine the level below the current position for u,v
  !*******************************************************
  call find_z_level_meters(zt)

  iw(:)=(/ indz, indzp /)
  call interpol_wind_meter(zt,iw)
#endif

end subroutine interpol_wind_short

subroutine interpol_partoutput_val(fieldname,output,j)
  integer, intent(in)         :: j          ! particle number
  character(2), intent(in)    :: fieldname  ! input field to interpolate over
  real, intent(inout)         :: output

  ! Interpolate over the windfields depending on the prefered
  ! coordinate system
  !**********************************************************
#ifdef ETA
  call interpol_partoutput_val_eta(fieldname,output,j)
#else
  call interpol_partoutput_val_meter(fieldname,output,j)
#endif
end subroutine interpol_partoutput_val

subroutine interpol_htropo_hmix(tropop,h)

  real, intent(inout) :: tropop   ! height of troposphere
  real, intent(inout) :: h        ! mixing height
  real    :: h1(2)                ! mixing height of 2 timesteps
  integer :: mind                 ! windfield index
  integer :: i,j,k,m              ! loop variables

  h=0.
  if (ngrid.le.0) then
    if (interpolhmix) then
      do m=1,2
        call hor_interpol(hmix,h1(m),1,memind(m),1)
      end do
    else
      do k=1,2
        mind=memind(k) ! eso: compatibility with 3-field version
        do j=jy,jyp
          do i=ix,ixp
             if (hmix(i,j,1,mind).gt.h) h=hmix(i,j,1,mind)
          end do
        end do
      end do
    endif
    tropop=tropopause(nix,njy,1,memind(1))
  else
    do k=1,2
      mind=memind(k)
      do j=jy,jyp
        do i=ix,ixp
          if (hmixn(i,j,1,mind,ngrid).gt.h) h=hmixn(i,j,1,mind,ngrid)
        end do
      end do
    end do
    tropop=tropopausen(nix,njy,1,memind(1),ngrid)
  endif

  if (interpolhmix) h= (h1(1)*dt2 + h1(2)*dt1)*dtt 

end subroutine interpol_htropo_hmix

subroutine interpol_density(itime,ipart,output)

  integer, intent(in) :: itime,ipart  ! time and particle index
  real, intent(inout) :: output ! output density (rhoi)
  integer :: ind
  real :: dz1,dz2,rhoprof(2)

  ! Where in the grid? Stereographic (ngrid<0) or nested (ngrid>0)
  !***************************************************************
  call find_ngrid(part(ipart)%xlon,part(ipart)%ylat)
  call find_grid_indices(real(part(ipart)%xlon),real(part(ipart)%ylat))
  call find_grid_distances(real(part(ipart)%xlon),real(part(ipart)%ylat))
  call find_time_vars(itime)

  ! Take density from 2nd wind field in memory 
  !(accurate enough, no time interpolation needed)
  !***********************************************
  
#ifdef ETA
  call find_z_level_eta(real(part(ipart)%zeta))
  call find_vert_vars(uvheight,real(part(ipart)%zeta),induv, &
    dz1,dz2,lbounds_uv,.false.)
  if (ngrid.le.0) then
    do ind=induv,indpuv
      call hor_interpol(rhoeta,rhoprof(ind-induv+1),ind,memind(2),nzmax)
    end do
  else
    do ind=induv,indpuv
      call hor_interpol_nest(rhoetan,rhoprof(ind-induv+1),ind,memind(2), &
        nzmax)
    end do
  endif
#else
  call find_z_level_meters(real(part(ipart)%z))
  call find_vert_vars(height,real(part(ipart)%z),indz, &
    dz1,dz2,lbounds,.false.)
  if (ngrid.le.0) then
    do ind=indz,indzp
      call hor_interpol(rho,rhoprof(ind-indz+1),ind,memind(2),nzmax)
    end do
  else
    do ind=indz,indzp
      call hor_interpol_nest(rhon,rhoprof(ind-indz+1),ind,memind(2),nzmax)
    end do
  endif
#endif
  call vert_interpol(rhoprof(1),rhoprof(2),dz1,dz2,output)
end subroutine interpol_density

subroutine interpol_rain(itime,kz,yint1,yint2,yint3,ytint,yint4,intiy1,intiy2,icmv)
  !                       i     i   o     o     o     o     o     o      o     i   
  !****************************************************************************
  !                                                                           *
  !  Interpolation of meteorological fields on 2-d model layers.              *
  !  In horizontal direction bilinear interpolation is used.                  *
  !  Temporally a linear interpolation is used.                               *
  !  Seven fields are interpolated at the same time.                          *
  !                                                                           *
  !  This is a special version of levlininterpol to save CPU time.            *
  !                                                                           *
  !  1 first time                                                             *
  !  2 second time                                                            *
  !                                                                           *
  !                                                                           *
  !     Author: A. Stohl                                                      *
  !                                                                           *
  !     30 August 1996                                                        *
  !                                                                           *
  !                                                                           *
  ! PS, AP 04/2019, 11/2020:                                                  *
  !                 put back temporal interpolation of rain, from v10.01      *
  !      and cloud bottom / thickness interpolation                           *
  ! PS, AP 01/2021:                                                           *
  !      interpolate particle temperature and cloud total water               *
  ! PS, AP 02/2021:                                                           *
  !      interpolation of precipitation using two additional fields           *
  !      which are temporally equidistant between the main fields             *
  !                                                                           *
  !****************************************************************************
  !                                                                           *
  ! Variables:                                                                *
  !                                                                           *
  ! dt1,dt2              time differences between fields and current position *
  ! dz1,dz2              z distance between levels and current position       *
  ! height(nzmax)        heights of the model levels                          *
  ! mm                   help variable                                        *
  ! indz                 the level closest to the current trajectory position *
  ! indzh                help variable                                        *
  ! itime                current time                                         *
  ! ix,jy                x,y coordinates of lower left subgrid point          *
  ! level                level at which interpolation shall be done 2d, =1    *
  ! kz                   level at which interpolation shall be done           *
  ! memind(3)            points to the places of the wind fields              *
  ! nx,ny                actual field dimensions in x,y and z direction       *
  ! nxmax,nymax,nzmax    maximum field dimensions in x,y and z direction      *
  ! xt                   current x coordinate                                 *
  ! yint                 the final interpolated value                         *
  ! yt                   current y coordinate                                 *
  ! yy?(0:nxmax,0:nymax,nzx2d,3) meteorological field used for interpolation  *
  ! yyt(0:nxmax,0:nymax,nzmax,3) tt field                                     * 
  ! iy1,iy2(0:nxmax,0:nymax,3) cloud bottom, thickness fields (integer)       *
  ! zt                   current z coordinate                                 *
  !                                                                           *
  !****************************************************************************
  use par_mod, only: numwfmem, numpf
  use com_mod, only: lcw

  implicit none

  integer, intent(in) :: kz, icmv, itime
  integer, intent(out) :: intiy1,intiy2
  real, intent(out) :: yint1,yint2,yint3,ytint,yint4
  integer :: m
  integer :: mm
  real :: ip1,ip2,ip3,ip4,ipsum
  real :: dt,dtp1,dtp2,rt
  real :: y1(2),y2(2),y3(2),y4(2),yi1(2),yi2(2),ytt(2) ! interpolated values
  
  integer, dimension(2) :: ip, mp

  !**********************************************************************
  ! 1.) Bilinear horizontal interpolation
  ! This has to be done separately for 2 fields (Temporal)
  !*******************************************************
  ! Loop over 2 time steps
  !***********************

  !-------------------------------------------------------------------------
  ! PS, AT new interpolation of precip with 2 additional fields
  ! therefore, we need a special treatment of lsp,cp which are in yy1,yy2
  !-------------------------------------------------------------------------
  !
  !      1.1 1.2 1.3               ip(1).mp(1)
  !      1.2 1.3 2.1               ip(2).mp(2)
  !
  !   ||___|___|___||___|___|___||
  !
  ! ip  1   2   3    1   2   3    1
  ! m        1            2  
  !
  !-------------------------------------------------------------------------

  dt1 = real(itime  - memtime(1))
  dt2 = real(memtime(2) - itime)
  dt  = real(memtime(2) - memtime(1))
  if (dt.eq.0. .and. dt1.eq.0.) then ! Fix if last last timestep and memtime(2)=memtime(1)
    dt = 1.
    dt2 = 1.
  endif
  dtt = dt/3.
  if (numpf .eq. 1) then
    mp(1) = 1
    mp(2) = 2
    ip(1) = 1
    ip(2) = 1
    dtp1 = dt1
    dtp2 = dt2
  else
    rt = abs(dt1/dt)
    if (0 .le. rt .and. rt .lt. 1./3.) then
      mp(1) = 1
      mp(2) = 1
      ip(1) = 1
      ip(2) = 2
      dtp1 = dt1
      dtp2 = dt2 - 2.*dtt
    elseif (1./3. .le. rt .and.  rt .lt. 2./3.) then
      mp(1) = 1
      mp(2) = 1
      ip(1) = 2
      ip(2) = 3
      dtp1 = dt1 - dtt
      dtp2 = dt2 - dtt
    elseif (2./3. .le. rt .and.  rt .lt. 1.) then
      mp(1) = 1
      mp(2) = 2
      ip(1) = 3
      ip(2) = 1
      dtp1 = dt1 - 2.*dtt
      dtp2 = dt2
    endif
  endif


  if (ngrid.le.0) then ! No nest
    do m=1,2
      mm=memind(mp(m))
      y1(m)= p1*lsprec(ix ,jy ,1,ip(m),mm) &
           + p2*lsprec(ixp,jy ,1,ip(m),mm) &
           + p3*lsprec(ix ,jyp,1,ip(m),mm) &
           + p4*lsprec(ixp,jyp,1,ip(m),mm)
      y2(m)= p1*convprec(ix ,jy ,1,ip(m),mm) &
           + p2*convprec(ixp,jy ,1,ip(m),mm) &
           + p3*convprec(ix ,jyp,1,ip(m),mm) &
           + p4*convprec(ixp,jyp,1,ip(m),mm)

      mm=memind(m)
      y3(m)= p1*tcc(ix ,jy ,1,mm) &
           + p2*tcc(ixp,jy ,1,mm) &
           + p3*tcc(ix ,jyp,1,mm) &
           + p4*tcc(ixp,jyp,1,mm)
#ifdef ETA
      ytt(m)=p1*tteta(ix ,jy ,kz,mm) &
           + p2*tteta(ixp,jy ,kz,mm) &
           + p3*tteta(ix ,jyp,kz,mm) &
           + p4*tteta(ixp,jyp,kz,mm)
#else
      ytt(m)=p1*tt(ix ,jy ,kz,mm) &
           + p2*tt(ixp,jy ,kz,mm) &
           + p3*tt(ix ,jyp,kz,mm) &
           + p4*tt(ixp,jyp,kz,mm)
#endif
      if (lcw) &
        y4(m)= p1*ctwc(ix ,jy ,mm) &
           + p2*ctwc(ixp,jy ,mm) &
           + p3*ctwc(ix ,jyp,mm) &
           + p4*ctwc(ixp,jyp,mm)

  !PS clouds:
      ip1=1.
      ip2=1.
      ip3=1.
      ip4=1.
      ipsum=1.
      if (icloudbot(ix ,jy ,mm) .eq. icmv) then
        ip1=0.
        ipsum=ipsum-p1
      endif
      if (icloudbot(ixp,jy ,mm) .eq. icmv) then
        ip2=0.
        ipsum=ipsum-p2
      endif
      if (icloudbot(ix ,jyp,mm) .eq. icmv) then
        ip3=0.
        ipsum=ipsum-p3
      endif
      if (icloudbot(ixp,jyp,mm) .eq. icmv) then
        ip4=0.
        ipsum=ipsum-p4
      endif
      if (ipsum .eq. 0.) then
        yi1(m)=icmv
      else
        yi1(m)=(ip1*p1*icloudbot(ix ,jy ,mm) &
              + ip2*p2*icloudbot(ixp,jy ,mm) &
              + ip3*p3*icloudbot(ix ,jyp,mm) &
              + ip4*p4*icloudbot(ixp,jyp,mm))/ipsum
        ! AP test output
  !      if (yi1(m) .lt. 1.) then
  !        write(*,*) ip1,ip2,ip3,ip4,ipsum
  !        write(*,*) p1,p2,p3,p4
  !        write(*,*) iy1(ix ,jy ,mm), iy1(ixp,jy ,mm),  iy1(ix ,jyp,mm), iy1(ixp,jyp,mm)
  !      endif            
              
      endif
          
      ip1=1.
      ip2=1.
      ip3=1.
      ip4=1.
      ipsum=1.
      if (icloudtop(ix ,jy ,mm) .eq. icmv) then
        ip1=0.
        ipsum=ipsum-p1
      endif
      if (icloudtop(ixp,jy ,mm) .eq. icmv) then
        ip2=0.
        ipsum=ipsum-p2
      endif
      if (icloudtop(ix ,jyp,mm) .eq. icmv) then
        ip3=0.
        ipsum=ipsum-p3
      endif
      if (icloudtop(ixp,jyp,mm) .eq. icmv) then
        ip4=0.
        ipsum=ipsum-p4
      endif
      if (ipsum .eq. 0.) then
        yi2(m)=icmv
      else
        yi2(m)=(ip1*p1*icloudtop(ix ,jy ,mm) &
              + ip2*p2*icloudtop(ixp,jy ,mm) &
              + ip3*p3*icloudtop(ix ,jyp,mm) &
              + ip4*p4*icloudtop(ixp,jyp,mm))/ipsum
      endif
  !PS end clouds
    end do
  else ! Nest
    do m=1,2
      mm=memind(mp(m))
      y1(m)= p1*lsprecn(ix ,jy ,1,ip(m),mm,ngrid) &
           + p2*lsprecn(ixp,jy ,1,ip(m),mm,ngrid) &
           + p3*lsprecn(ix ,jyp,1,ip(m),mm,ngrid) &
           + p4*lsprecn(ixp,jyp,1,ip(m),mm,ngrid)
      y2(m)= p1*convprecn(ix ,jy ,1,ip(m),mm,ngrid) &
           + p2*convprecn(ixp,jy ,1,ip(m),mm,ngrid) &
           + p3*convprecn(ix ,jyp,1,ip(m),mm,ngrid) &
           + p4*convprecn(ixp,jyp,1,ip(m),mm,ngrid)

      mm=memind(m)
      y3(m)= p1*tccn(ix ,jy ,1,mm,ngrid) &
           + p2*tccn(ixp,jy ,1,mm,ngrid) &
           + p3*tccn(ix ,jyp,1,mm,ngrid) &
           + p4*tccn(ixp,jyp,1,mm,ngrid)
#ifdef ETA
      ytt(m)=p1*ttetan(ix ,jy ,kz,mm,ngrid) &
           + p2*ttetan(ixp,jy ,kz,mm,ngrid) &
           + p3*ttetan(ix ,jyp,kz,mm,ngrid) &
           + p4*ttetan(ixp,jyp,kz,mm,ngrid)
#else
      ytt(m)=p1*ttn(ix ,jy ,kz,mm,ngrid) &
           + p2*ttn(ixp,jy ,kz,mm,ngrid) &
           + p3*ttn(ix ,jyp,kz,mm,ngrid) &
           + p4*ttn(ixp,jyp,kz,mm,ngrid)
#endif
      if (lcw_nest(ngrid)) &
        y4(m)= p1*ctwcn(ix ,jy ,mm,ngrid) &
           + p2*ctwcn(ixp,jy ,mm,ngrid) &
           + p3*ctwcn(ix ,jyp,mm,ngrid) &
           + p4*ctwcn(ixp,jyp,mm,ngrid)

  !PS clouds:
      ip1=1.
      ip2=1.
      ip3=1.
      ip4=1.
      ipsum=1.
      if (icloudbotn(ix ,jy ,mm,ngrid) .eq. icmv) then
        ip1=0.
        ipsum=ipsum-p1
      endif
      if (icloudbotn(ixp,jy ,mm,ngrid) .eq. icmv) then
        ip2=0.
        ipsum=ipsum-p2
      endif
      if (icloudbotn(ix ,jyp,mm,ngrid) .eq. icmv) then
        ip3=0.
        ipsum=ipsum-p3
      endif
      if (icloudbotn(ixp,jyp,mm,ngrid) .eq. icmv) then
        ip4=0.
        ipsum=ipsum-p4
      endif
      if (ipsum .eq. 0.) then
        yi1(m)=icmv
      else
        yi1(m)=(ip1*p1*icloudbotn(ix ,jy ,mm,ngrid) &
              + ip2*p2*icloudbotn(ixp,jy ,mm,ngrid) &
              + ip3*p3*icloudbotn(ix ,jyp,mm,ngrid) &
              + ip4*p4*icloudbotn(ixp,jyp,mm,ngrid))/ipsum
      endif
          
      ip1=1.
      ip2=1.
      ip3=1.
      ip4=1.
      ipsum=1.
      if (icloudtopn(ix ,jy ,mm,ngrid) .eq. icmv) then
        ip1=0.
        ipsum=ipsum-p1
      endif
      if (icloudtopn(ixp,jy ,mm,ngrid) .eq. icmv) then
        ip2=0.
        ipsum=ipsum-p2
      endif
      if (icloudtopn(ix ,jyp,mm,ngrid) .eq. icmv) then
        ip3=0.
        ipsum=ipsum-p3
      endif
      if (icloudtopn(ixp,jyp,mm,ngrid) .eq. icmv) then
        ip4=0.
        ipsum=ipsum-p4
      endif
      if (ipsum .eq. 0.) then
        yi2(m)=icmv
      else
        yi2(m)=(ip1*p1*icloudtopn(ix ,jy ,mm,ngrid) &
              + ip2*p2*icloudtopn(ixp,jy ,mm,ngrid) &
              + ip3*p3*icloudtopn(ix ,jyp,mm,ngrid) &
              + ip4*p4*icloudtopn(ixp,jyp,mm,ngrid))/ipsum
      endif
  !PS end clouds
    end do
  endif

  !************************************
  ! 2.) Temporal interpolation (linear)
  !************************************

  yint1=(y1(1)*dtp2+y1(2)*dtp1)/dtt ! lsp
  yint2=(y2(1)*dtp2+y2(2)*dtp1)/dtt ! cp
  
  yint3=(y3(1)*dt2+y3(2)*dt1)/dt
  yint4=(y4(1)*dt2+y4(2)*dt1)/dt
  ytint=(ytt(1)*dt2+ytt(2)*dt1)/dt

!PS clouds:450.

!  write(*,*) yi1(1),yi1(2),yi2(1),yi2(2),dt,dt1,dt2
  intiy1=int((yi1(1)*dt2 + yi1(2)*dt1)/dt)
  if (int(yi1(1)) .eq. icmv) intiy1=int(yi1(2))
  if (int(yi1(2)) .eq. icmv) intiy1=int(yi1(1))

  intiy2=int((yi2(1)*dt2 + yi2(2)*dt1)/dt)
  if (int(yi2(1)) .eq. icmv) intiy2=int(yi2(2))
  if (int(yi2(2)) .eq. icmv) intiy2=int(yi2(1))
  
!  write(*,*) 'before cbot: ', intiy1, ' cthick: ', intiy2   
  if (intiy1 .ne. icmv .and. intiy2 .ne. icmv) then
    intiy2 = intiy2 !intiy1 + intiy2 ! convert cloud thickness to cloud top
  else
    intiy1=icmv
    intiy2=icmv
  endif
  if (intiy2 .ne. icmv .and. intiy2 .lt. 0) then
    write(*,*) itime, memind(1), memind(2)
    write(*,*) yi1(1),yi1(2),yi2(1),yi2(2),dt,dt1,dt2
    write(*,*) 'final cbot: ', intiy1, ' ctop: ', intiy2
    stop 'intiy2 (cloud top) negative'
  endif
!PS end clouds

end subroutine interpol_rain

!*********************
!* PRIVATE FUNCTIONS *
!*********************
! Interpolation of wind fields
!*****************************
#ifdef ETA
subroutine interpol_wind_eta(zteta,iuv,iweta)

!* PRIVATE FUNCTION *

  real, intent(in)    :: zteta
  integer,intent(in)  :: iuv(2),iweta(2)
  integer             :: n,m
  real                :: uh(2),vh(2),wetah(2),uh1(2),vh1(2),wetah1(2)
  real                :: dz1uv,dz2uv,dz1weta,dz2weta

  !**********************************************************************
  ! 1.) Bilinear horizontal interpolation
  ! This has to be done separately for 6 fields (Temporal(2)*Vertical(3))
  !**********************************************************************

  ! Vertical distance to the level below and above current position
  !****************************************************************
  call find_vert_vars(uvheight,zteta,induv,dz1uv,dz2uv,lbounds_uv,.false.)
  call find_vert_vars(wheight,zteta,indzeta,dz1weta,dz2weta,lbounds_w,.true.)

  ! Loop over 2 time steps and 2 levels
  !************************************
  if (ngrid.le.0) then ! No nest
    do m=1,2
      do n=1,2
        call hor_interpol(wweta,wetah1(n),iweta(n),memind(m),nzmax)
        if (ngrid.lt.0) then
          call hor_interpol(uupoleta,uh1(n),iuv(n),memind(m),nzmax)
          call hor_interpol(vvpoleta,vh1(n),iuv(n),memind(m),nzmax)
        else
          call hor_interpol(uueta,uh1(n),iuv(n),memind(m),nzmax)
          call hor_interpol(vveta,vh1(n),iuv(n),memind(m),nzmax)
        endif
      end do
      call vert_interpol(uh1(1),uh1(2),dz1uv,dz2uv,uh(m))
      call vert_interpol(vh1(1),vh1(2),dz1uv,dz2uv,vh(m))
      call vert_interpol(wetah1(1),wetah1(2),dz1weta,dz2weta,wetah(m))
    end do 
  else ! Nest
    do m=1,2
      do n=1,2
        
        ! wetah1(n) = p1*wwetan(ix ,jy ,iweta(n),memind(m),ngrid) &
        !           + p2*wwetan(ixp,jy ,iweta(n),memind(m),ngrid) &
        !           + p3*wwetan(ix ,jyp,iweta(n),memind(m),ngrid) &
        !           + p4*wwetan(ixp,jyp,iweta(n),memind(m),ngrid)
        call hor_interpol_nest(wwetan,wetah1(n),iweta(n),memind(m),nzmax)
        call hor_interpol_nest(uuetan,uh1(n),iuv(n),memind(m),nzmax)
        call hor_interpol_nest(vvetan,vh1(n),iuv(n),memind(m),nzmax)
      end do
      call vert_interpol(uh1(1),uh1(2),dz1uv,dz2uv,uh(m))
      call vert_interpol(vh1(1),vh1(2),dz1uv,dz2uv,vh(m))
      call vert_interpol(wetah1(1),wetah1(2),dz1weta,dz2weta,wetah(m))
    end do    
  endif
  call temporal_interpolation(uh(1),uh(2),u)
  call temporal_interpolation(vh(1),vh(2),v)
  call temporal_interpolation(wetah(1),wetah(2),weta)
end subroutine interpol_wind_eta
#else

subroutine interpol_wind_meter(zt,iw)

!* PRIVATE FUNCTION *

  real, intent(in)    :: zt
  integer,intent(in)  :: iw(2)
  integer             :: n,m
  real                :: uh(2),vh(2),wh(2),uh1(2),vh1(2),wh1(2)
  real                :: dz1w,dz2w

  !**********************************************************************
  ! 1.) Bilinear horizontal interpolation
  ! This has to be done separately for 6 fields (Temporal(2)*Vertical(3))
  !**********************************************************************

  ! Vertical distance to the level below and above current position
  !****************************************************************
  call find_vert_vars(height,zt,indz,dz1w,dz2w,lbounds,.false.)

  ! Loop over 2 time steps and 2 levels
  !************************************
  if (ngrid.le.0) then ! No nest
    do m=1,2
      do n=1,2
        call hor_interpol(ww,wh1(n),iw(n),memind(m),nzmax)
        if (ngrid.lt.0) then
          call hor_interpol(uupol,uh1(n),iw(n),memind(m),nzmax)
          call hor_interpol(vvpol,vh1(n),iw(n),memind(m),nzmax)
        else
          call hor_interpol(uu,uh1(n),iw(n),memind(m),nzmax)
          call hor_interpol(vv,vh1(n),iw(n),memind(m),nzmax)
        endif
      end do
      call vert_interpol(wh1(1),wh1(2),dz1w,dz2w,wh(m))
      call vert_interpol(uh1(1),uh1(2),dz1w,dz2w,uh(m))
      call vert_interpol(vh1(1),vh1(2),dz1w,dz2w,vh(m))
    end do 
  else ! Nest
    do m=1,2
      do n=1,2
        call hor_interpol_nest(wwn,wh1(n),iw(n),memind(m),nzmax)
        call hor_interpol_nest(uun,uh1(n),iw(n),memind(m),nzmax)
        call hor_interpol_nest(vvn,vh1(n),iw(n),memind(m),nzmax)
      end do
      call vert_interpol(wh1(1),wh1(2),dz1w,dz2w,wh(m))
      call vert_interpol(uh1(1),uh1(2),dz1w,dz2w,uh(m))
      call vert_interpol(vh1(1),vh1(2),dz1w,dz2w,vh(m))
    end do    
  endif
  call temporal_interpolation(wh(1),wh(2),w)
  call temporal_interpolation(uh(1),uh(2),u)
  call temporal_interpolation(vh(1),vh(2),v)
end subroutine interpol_wind_meter
#endif

#ifdef ETA
subroutine interpol_partoutput_val_eta(fieldname,output,j)
  implicit none

  integer, intent(in)         :: j          ! particle number
  character(2), intent(in)    :: fieldname  ! input field to interpolate over
  real, intent(inout)         :: output
  real                        :: field1(2)

  if (int(dz1out).eq.-1) then
    call find_z_level_eta(real(part(j)%zeta))
    call find_vert_vars(uvheight,real(part(j)%zeta),induv,dz1out,dz2out, &
      lbounds_uv,.false.)
  endif

  select case(fieldname)
    case('PR','pr')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(prseta,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(prsetan,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('PV','pv')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(pveta,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(pvetan,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('QV','qv')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(qv,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(qvn,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('TT','tt')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(tteta,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(ttetan,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('UU','uu')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(uueta,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(uuetan,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('VV','vv')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(vveta,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(vvetan,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('WW','ww')
      call find_z_level_meters(real(part(j)%z))
      call find_vert_vars(height,real(part(j)%z),indz,dz1out,dz2out,lbounds,.false.)
      if (ngrid.le.0) then
        call bilin_spatial_interpol(ww,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(wwn,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
      dz1out = -1
    case('RH','rh')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(rhoeta,field1,induv,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(rhoetan,field1,induv,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
  end select
end subroutine interpol_partoutput_val_eta
#else

subroutine interpol_partoutput_val_meter(fieldname,output,j)
  implicit none

!* PRIVATE FUNCTION *

  integer, intent(in)         :: j          ! particle number
  character(2), intent(in)    :: fieldname  ! input field to interpolate over
  real, intent(inout)         :: output
  real                        :: field1(2)

  if (int(dz1out).eq.-1) then
    call find_z_level_meters(real(part(j)%z))
    call find_vert_vars(height,real(part(j)%z),indz,dz1out,dz2out,lbounds,.false.)
  endif

  select case(fieldname)
    case('PR','pr')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(prs,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(prsn,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('PV','pv')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(pv,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(pvn,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('QV','qv')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(qv,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(qvn,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('TT','tt')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(tt,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(ttn,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('UU','uu')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(uu,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(uun,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('VV','vv')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(vv,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(vvn,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('WW','ww')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(ww,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(wwn,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
    case('RH','rh')
      if (ngrid.le.0) then
        call bilin_spatial_interpol(rho,field1,indz,dz1out,dz2out,nzmax)
      else
        call bilin_spatial_interpol_nest(rhon,field1,indz,dz1out,dz2out,nzmax)
      endif
      call temporal_interpolation(field1(1),field1(2),output)
  end select
end subroutine interpol_partoutput_val_meter
#endif
! #ifdef ETA
! subroutine interpol_pbl_eta(zt,zteta,rhoa,rhograd,ithread)
  
!   integer,intent(in)  :: ithread
!   real, intent(in)    :: zt,zteta
!   real, intent(inout) :: rhoa,rhograd
!   real                :: dz1w,dz2w,dz1uv,dz2uv,dz1weta,dz2weta

!   call find_vert_vars(height,zt,indz,dz1w,dz2w,lbounds,.false.)
!   call find_vert_vars(uvheight,zteta,induv,dz1uv,dz2uv,lbounds_uv,.false.)
!   call find_vert_vars(wheight,zteta,indzeta,dz1weta,dz2weta,lbounds_w,.true.)

!   call vert_interpol(wprof(indz,ithread),wprof(indzp,ithread),dz1w,dz2w,w)
!   call vert_interpol(uprof(induv,ithread),uprof(indpuv,ithread),dz1uv,dz2uv,u)
!   call vert_interpol(vprof(induv,ithread),vprof(indpuv,ithread),dz1uv,dz2uv,v)
!   call vert_interpol(rhoprof(induv,ithread),rhoprof(indpuv,ithread),dz1uv,dz2uv,rhoa)
!   call vert_interpol(rhogradprof(induv,ithread),rhogradprof(indpuv,ithread),dz1uv,dz2uv,rhograd)
!   call vert_interpol(wprofeta(indzeta,ithread),wprofeta(indzpeta,ithread),dz1weta,dz2weta,weta)
! end subroutine interpol_pbl_eta
! #endif

#ifdef ETA
subroutine stdev_eta(iw,iuv,iweta)

!* PRIVATE FUNCTION *

  ! Standard deviation of surrounding grid points
  ! Only used in mesoscale turbulence calculations
  !***********************************************

  integer,intent(in)  :: iw(2),iuv(2),iweta(2)
  real :: wsl,wsq,usl,usq,vsl,vsq,wetasl,wetasq
  integer             :: n,m
  real,parameter      :: eps=1.0e-30
  
  ! Standard deviations
  !********************
  wsl=0.
  wsq=0.
  usl=0.
  usq=0.
  vsl=0.
  vsq=0.
  wetasl=0.
  wetasq=0.

  if (ngrid.le.0) then ! No nest  
    do m=1,2
      do n=1,2
        call compute_sl_sq(ww,wsl,wsq,iw(n),memind(m),nzmax)
        call compute_sl_sq(wweta,wetasl,wetasq,iweta(n),memind(m),nzmax)
        if (ngrid.lt.0) then
          call compute_sl_sq(uupoleta,usl,usq,iuv(n),memind(m),nzmax)
          call compute_sl_sq(vvpoleta,vsl,vsq,iuv(n),memind(m),nzmax)
        else
          call compute_sl_sq(uueta,usl,usq,iuv(n),memind(m),nzmax)
          call compute_sl_sq(vveta,vsl,vsq,iuv(n),memind(m),nzmax)
        endif
      end do
    end do
  else ! Nest
    do m=1,2
      do n=1,2
        call compute_sl_sq_nest(wwn,wsl,wsq,iw(n),memind(m),nzmax)
        call compute_sl_sq_nest(wwetan,wetasl,wetasq,iweta(n),memind(m),nzmax)
        call compute_sl_sq_nest(uuetan,usl,usq,iuv(n),memind(m),nzmax)
        call compute_sl_sq_nest(vvetan,vsl,vsq,iuv(n),memind(m),nzmax)
      end do
    end do
  endif

  call stdev(wsl,wsq,16.,wsig)
  call stdev(usl,usq,16.,usig)
  call stdev(vsl,vsq,16.,vsig)
  call stdev(wetasl,wetasq,16.,wsigeta)

end subroutine stdev_eta
#else

subroutine stdev_meter(iw)

!* PRIVATE FUNCTION *

  ! Standard deviation of surrounding grid points
  ! Only used in mesoscale turbulence calculations
  !***********************************************

  integer,intent(in)  :: iw(2)
  real                :: wsl,wsq,usl,usq,vsl,vsq
  integer             :: n,m
  real,parameter      :: eps=1.0e-30

  ! Standard deviations
  !********************
  wsl=0.
  wsq=0.
  usl=0.
  usq=0.
  vsl=0.
  vsq=0.

  if (ngrid.le.0) then ! No nest  
    do m=1,2
      do n=1,2
        call compute_sl_sq(ww,wsl,wsq,iw(n),memind(m),nzmax)
        if (ngrid.lt.0) then
          call compute_sl_sq(uupol,usl,usq,iw(n),memind(m),nzmax)
          call compute_sl_sq(vvpol,vsl,vsq,iw(n),memind(m),nzmax)
        else
          call compute_sl_sq(uu,usl,usq,iw(n),memind(m),nzmax)
          call compute_sl_sq(vv,vsl,vsq,iw(n),memind(m),nzmax)
        endif
      end do
    end do
  else ! Nest
    do m=1,2
      do n=1,2
        call compute_sl_sq_nest(wwn,wsl,wsq,iw(n),memind(m),nzmax)
        call compute_sl_sq_nest(uun,usl,usq,iw(n),memind(m),nzmax)
        call compute_sl_sq_nest(vvn,vsl,vsq,iw(n),memind(m),nzmax)
      end do
    end do
  endif

  call stdev(wsl,wsq,16.,wsig)
  call stdev(usl,usq,16.,usig)
  call stdev(vsl,vsq,16.,vsig)

end subroutine stdev_meter
#endif
end module interpol_mod

!! MODIFIED SORTING MODULE FROM STDLIB
!! Licensing:
!!
!! This file is subject both to the Fortran Standard Library license, and
!! to additional licensing requirements as it contains translations of
!! other software.
!!
!! The Fortran Standard Library, including this file, is distributed under
!! the MIT license that should be included with the library's distribution.
!!
!!   Copyright (c) 2021 Fortran stdlib developers
!!
!!   Permission is hereby granted, free of charge, to any person obtaining a
!!   copy of this software and associated documentation files (the
!!   "Software"),  to deal in the Software without restriction, including
!!   without limitation the rights to use, copy, modify, merge, publish,
!!   distribute, sublicense, and/or sellcopies of the Software, and to permit
!!   persons to whom the Software is furnished to do so, subject to the
!!   following conditions:
!!
!!   The above copyright notice and this permission notice shall be included
!!   in all copies or substantial portions of the Software.
!!
!!   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
!!   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
!!   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
!!   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
!!   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
!!   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
!!   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
!!
!! Two of the generic subroutines, `ORD_SORT` and `SORT_INDEX`, are
!! substantially translations to Fortran 2008 of the `"Rust" sort` sorting
!! routines in
!! [`slice.rs`](https://github.com/rust-lang/rust/blob/90eb44a5897c39e3dff9c7e48e3973671dcd9496/src/liballoc/slice.rs)
!! The `rust sort` implementation is distributed with the header:
!!
!!   Copyright 2012-2015 The Rust Project Developers. See the COPYRIGHT
!!   file at the top-level directory of this distribution and at
!!   http://rust-lang.org/COPYRIGHT.
!!
!!   Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
!!   http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
!!   <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
!!   option. This file may not be copied, modified, or distributed
!!   except according to those terms.
!!
!! so the license for the original`slice.rs` code is compatible with the use
!! of modified versions of the code in the Fortran Standard Library under
!! the MIT license.
!!
!! One of the generic subroutines, `SORT`, is substantially a
!! translation to Fortran 2008, of the `introsort` of David Musser.
!! David Musser has given permission to include a variant of `introsort`
!! in the Fortran Standard Library under the MIT license provided
!! we cite:
!!
!!   Musser, D.R., "Introspective Sorting and Selection Algorithms,"
!!   Software-Practice and Experience, Vol. 27(8), 983-993 (August 1997).
!!
!! as the official source of the algorithm.


module sort_mod
  use par_mod
  implicit none

  integer, parameter, public :: int_size = 8
  ! Constants for use by tim_sort
  integer, parameter :: &
  ! The maximum number of entries in a run stack, good for an array of
  ! 2**64 elements see
  ! https://svn.python.org/projects/python/trunk/Objects/listsort.txt
      max_merge_stack = int( ceiling( log( real(2.,kind=dp)**64 ) / &
                             log(real(1.6180339887,kind=dp)) ) )

  type run_type
  !! Version: experimental
  !!
  !! Used to pass state around in a stack among helper functions for the
  !! `ORD_SORT` and `SORT_INDEX` algorithms
      integer(int_size) :: base = 0
      integer(int_size) :: len = 0
  end type run_type

contains

  subroutine sort2(n,arr,brr)
    implicit none
    integer, intent(in) :: n
    integer, intent(inout) :: arr(n),brr(n)
    integer, dimension(:) :: brrout(n), work(n/2)
    integer(int_size), dimension(:) :: iwork(0:n/2-1)
    integer(int_size), dimension(:) :: iarr(n)
    integer :: i

    call sort_index(arr, iarr, work, iwork)

    do i=1,n
      brrout(i) = brr(iarr(i))
    end do

    brr = brrout

  end subroutine sort2

  pure elemental function optval(x,default) result(y)
    implicit none
    logical, intent(in), optional :: x
    logical, intent(in) :: default
    logical :: y

    if (present(x)) then
      y = x
    else
      y = default
    end if
  end function optval

  subroutine sort_index( array, index, work, iwork, reverse )
  ! A modification of `${name1}$_ord_sort` to return an array of indices that
  ! would perform a stable sort of the `ARRAY` as input, and also sort `ARRAY`
  ! as desired. The indices by default
  ! correspond to a non-decreasing sort, but if the optional argument
  ! `REVERSE` is present with a value of `.TRUE.` the indices correspond to
  ! a non-increasing sort. The logic of the determination of indexing largely
  ! follows the `"Rust" sort` found in `slice.rs`:
  ! https://github.com/rust-lang/rust/blob/90eb44a5897c39e3dff9c7e48e3973671dcd9496/src/liballoc/slice.rs#L2159
  ! The Rust version is a simplification of the Timsort algorithm described
  ! in https://svn.python.org/projects/python/trunk/Objects/listsort.txt, as
  ! it drops both the use of 'galloping' to identify bounds of regions to be
  ! sorted and the estimation of the optimal `run size`. However it remains
  ! a hybrid sorting algorithm combining an iterative Merge sort controlled
  ! by a stack of `RUNS` identified by regions of uniformly decreasing or
  ! non-decreasing sequences that may be expanded to a minimum run size, with
  ! an insertion sort.
  !
  ! Note the Fortran implementation simplifies the logic as it only has to
  ! deal with Fortran arrays of intrinsic types and not the full generality
  ! of Rust's arrays and lists for arbitrary types. It also adds the
  ! estimation of the optimal `run size` as suggested in Tim Peters'
  ! original listsort.txt, and the optional `work` and `iwork` arraya to be
  ! used as scratch memory.

    integer, intent(inout)                    :: array(0:)
    integer(int_size), intent(out)           :: index(0:)
    integer, intent(out), optional            :: work(0:)
    integer(int_size), intent(out), optional :: iwork(0:)
    logical, intent(in), optional            :: reverse

    integer(int_size) :: array_size, i, stat
    integer, allocatable :: buf(:)
    integer(int_size), allocatable :: ibuf(:)

    array_size = size(array, kind=int_size)

    do i = 0, array_size-1
      index(i) = i+1
    end do

    if ( optval(reverse, .false.) ) then
      call reverse_segment( array, index )
    end if

  ! If necessary allocate buffers to serve as scratch memory.
    if ( present(work) ) then
      if ( size(work, kind=int_size) < array_size/2 ) then
        error stop "work array is too small."
      end if
      if ( present(iwork) ) then
        if ( size(iwork, kind=int_size) < array_size/2 ) then
          error stop "iwork array is too small."
        endif
        call merge_sort( array, index, work, iwork )
      else
        allocate( ibuf(0:array_size/2-1), stat=stat )
        if ( stat /= 0 ) error stop "Allocation of index buffer failed."
        call merge_sort( array, index, work, ibuf )
      end if
    else
      allocate( buf(0:array_size/2-1), stat=stat )
      if ( stat /= 0 ) error stop "Allocation of array buffer failed."
      if ( present(iwork) ) then
        if ( size(iwork, kind=int_size) < array_size/2 ) then
          error stop "iwork array is too small."
        endif
        call merge_sort( array, index, buf, iwork )
      else
        allocate( ibuf(0:array_size/2-1), stat=stat )
        if ( stat /= 0 ) error stop "Allocation of index buffer failed."
        call merge_sort( array, index, buf, ibuf )
      end if
    end if

    if ( optval(reverse, .false.) ) then
      call reverse_segment( array, index )
    end if

  end subroutine sort_index

  pure function calc_min_run( n ) result(min_run)
  !! Returns the minimum length of a run from 32-63 so that N/MIN_RUN is
  !! less than or equal to a power of two. See
  !! https://svn.python.org/projects/python/trunk/Objects/listsort.txt
    integer(int_size)             :: min_run
    integer(int_size), intent(in) :: n

    integer(int_size) :: num, r

    num = n
    r = 0_int_size

    do while( num >= 64 )
      r = ior( r, iand(num, 1_int_size) )
      num = ishft(num, -1_int_size)
    end do
    min_run = num + r

  end function calc_min_run


  pure subroutine insertion_sort( array, index )
  ! Sorts `ARRAY` using an insertion sort, while maintaining consistency in
  ! location of the indices in `INDEX` to the elements of `ARRAY`.
    integer, intent(inout)            :: array(0:)
    integer(int_size), intent(inout) :: index(0:)

    integer(int_size) :: i, j, key_index
    integer :: key

    do j=1, size(array, kind=int_size)-1
      key = array(j)
      key_index = index(j)
      i = j - 1
      do while( i >= 0 )
        if ( array(i) <= key ) exit
        array(i+1) = array(i)
        index(i+1) = index(i)
        i = i - 1
      end do
      array(i+1) = key
      index(i+1) = key_index
    end do

  end subroutine insertion_sort


  pure function collapse( runs ) result ( r )
  ! Examine the stack of runs waiting to be merged, identifying adjacent runs
  ! to be merged until the stack invariants are restablished:
  !
  ! 1. len(-3) > len(-2) + len(-1)
  ! 2. len(-2) > len(-1)

    integer(int_size) :: r
    type(run_type), intent(in), target :: runs(0:)

    integer(int_size) :: n
    logical :: test

    n = size(runs, kind=int_size)
    test = .false.
    if (n >= 2) then
      if ( runs( n-1 ) % base == 0 .or. &
           runs( n-2 ) % len <= runs(n-1) % len ) then
          test = .true.
      else if ( n >= 3 ) then ! X exists
        if ( runs(n-3) % len <= &
             runs(n-2) % len + runs(n-1) % len ) then
          test = .true.
!               |X| <= |Y| + |Z| => will need to merge due to rho1 or rho2
        else if( n >= 4 ) then
          if ( runs(n-4) % len <= &
               runs(n-3) % len + runs(n-2) % len ) then
              test = .true.
!               |W| <= |X| + |Y| => will need to merge due to rho1 or rho3
          end if
        end if
      end if
    end if
    if ( test ) then
! By default merge Y & Z, rho2 or rho3
      if ( n >= 3 ) then
        if ( runs(n-3) % len < runs(n-1) % len ) then
          r = n - 3
! |X| < |Z| => merge X & Y, rho1
          return
        end if
      end if
      r = n - 2
! |Y| <= |Z| => merge Y & Z, rho4
      return
    else
      r = -1
    end if

  end function collapse


  pure subroutine insert_head( array, index )
  ! Inserts `array(0)` into the pre-sorted sequence `array(1:)` so that the
  ! whole `array(0:)` becomes sorted, copying the first element into
  ! a temporary variable, iterating until the right place for it is found.
  ! copying every traversed element into the slot preceding it, and finally,
  ! copying data from the temporary variable into the resulting hole.
  ! Consistency of the indices in `index` with the elements of `array`
  ! are maintained.

    integer, intent(inout)            :: array(0:)
    integer(int_size), intent(inout) :: index(0:)

    integer :: tmp
    integer(int_size) :: i, tmp_index

    tmp = array(0)
    tmp_index = index(0)
    find_hole: do i=1, size(array, kind=int_size)-1
      if ( array(i) >= tmp ) exit find_hole
      array(i-1) = array(i)
      index(i-1) = index(i)
    end do find_hole
    array(i-1) = tmp
    index(i-1) = tmp_index

  end subroutine insert_head


  subroutine merge_sort( array, index, buf, ibuf )
  ! The Rust merge sort borrows some (but not all) of the ideas from TimSort,
  ! which is described in detail at
  ! (http://svn.python.org/projects/python/trunk/Objects/listsort.txt).
  !
  ! The algorithm identifies strictly descending and non-descending
  ! subsequences, which are called natural runs. Where these runs are less
  ! than a minimum run size they are padded by adding additional samples
  ! using an insertion sort. The merge process is driven by a stack of
  ! pending unmerged runs. Each newly found run is pushed onto the stack,
  ! and then pairs of adjacentd runs are merged until these two invariants
  ! are satisfied:
  !
  ! 1. for every `i` in `1..size(runs)-1`: `runs(i - 1)%len > runs(i)%len`
  ! 2. for every `i` in `2..size(runs)-1`: `runs(i - 2)%len >
  !    runs(i - 1)%len + runs(i)%len`
  !
  ! The invariants ensure that the total running time is `O(n log n)`
  ! worst-case. Consistency of the indices in `index` with the elements of
  ! `array` are maintained.

      integer, intent(inout)            :: array(0:)
      integer(int_size), intent(inout) :: index(0:)
      integer, intent(inout)            :: buf(0:)
      integer(int_size), intent(inout) :: ibuf(0:)

      integer(int_size) :: array_size, finish, min_run, r, r_count, &
          start
      type(run_type) :: runs(0:max_merge_stack-1), left, right

      array_size = size(array, kind=int_size)

  ! Very short runs are extended using insertion sort to span at least this
  ! many elements. Slices of up to this length are sorted using insertion sort.
      min_run = calc_min_run( array_size )

      if ( array_size <= min_run ) then
        if ( array_size >= 2 ) call insertion_sort( array, index )
        return
      end if


  ! Following Rust sort, natural runs in `array` are identified by traversing
  ! it backwards. By traversing it backward, merges more often go in the
  ! opposite direction (forwards). According to developers of Rust sort,
  ! merging forwards is slightly faster than merging backwards. Therefore
  ! identifying runs by traversing backwards should improve performance.
      r_count = 0
      finish = array_size - 1
      do while ( finish >= 0 )
  ! Find the next natural run, and reverse it if it's strictly descending.
        start = finish
        if ( start > 0 ) then
          start = start - 1
          if ( array(start+1) < array(start) ) then
            Descending: do while ( start > 0 )
                if ( array(start) >= array(start-1) ) &
                    exit Descending
                start = start - 1
            end do Descending
            call reverse_segment( array(start:finish), &
                                index(start:finish) )
          else
            Ascending: do while( start > 0 )
                if ( array(start) < array(start-1) ) exit Ascending
                start = start - 1
            end do Ascending
          end if
        end if

! If the run is too short insert some more elements using an insertion sort.
        Insert: do while ( start > 0 )
          if ( finish - start >= min_run - 1 ) exit Insert
          start = start - 1
          call insert_head( array(start:finish), index(start:finish) )
        end do Insert
        if ( start == 0 .and. finish == array_size - 1 ) return

        runs(r_count) = run_type( base = start, &
                                  len = finish - start + 1 )
        finish = start-1
        r_count = r_count + 1

! Determine whether pairs of adjacent runs need to be merged to satisfy
! the invariants, and, if so, merge them.
        Merge_loop: do
          r = collapse( runs(0:r_count - 1) )
          if ( r < 0 .or. r_count <= 1 ) exit Merge_loop
          left = runs( r + 1 )
          right = runs( r )
          call merge( array( left % base: &
                           right % base + right % len - 1 ), &
                      left % len, buf, &
                      index( left % base: &
                           right % base + right % len - 1 ), ibuf )

          runs(r) = run_type( base = left % base, &
                              len = left % len + right % len )
          if ( r == r_count - 3 ) runs(r+1) = runs(r+2)
          r_count = r_count - 1

        end do Merge_loop
      end do
      if ( r_count /= 1 ) &
        error stop "MERGE_SORT completed without RUN COUNT == 1."
  end subroutine merge_sort


  pure subroutine merge( array, mid, buf, index, ibuf )
  ! Merges the two non-decreasing runs `ARRAY(0:MID-1)` and `ARRAY(MID:)`
  ! using `BUF` as temporary storage, and stores the merged runs into
  ! `ARRAY(0:)`. `MID` must be > 0, and < `SIZE(ARRAY)-1`. Buffer `BUF`
  ! must be long enough to hold the shorter of the two runs.
    integer, intent(inout)            :: array(0:)
    integer(int_size), intent(in)    :: mid
    integer, intent(inout)            :: buf(0:)
    integer(int_size), intent(inout) :: index(0:)
    integer(int_size), intent(inout) :: ibuf(0:)

    integer(int_size) :: array_len, i, j, k

    array_len = size(array, kind=int_size)

! Merge first copies the shorter run into `buf`. Then, depending on which
! run was shorter, it traces the copied run and the longer run forwards
! (or backwards), comparing their next unprocessed elements and then
! copying the lesser (or greater) one into `array`.

    if ( mid <= array_len - mid ) then ! The left run is shorter.
      buf(0:mid-1) = array(0:mid-1)
      ibuf(0:mid-1) = index(0:mid-1)
      i = 0
      j = mid
      merge_lower: do k = 0, array_len-1
        if ( buf(i) <= array(j) ) then
          array(k) = buf(i)
          index(k) = ibuf(i)
          i = i + 1
          if ( i >= mid ) exit merge_lower
        else
          array(k) = array(j)
          index(k) = index(j)
          j = j + 1
          if ( j >= array_len ) then
            array(k+1:) = buf(i:mid-1)
            index(k+1:) = ibuf(i:mid-1)
            exit merge_lower
          end if
        end if
      end do merge_lower
    else ! The right run is shorter
      buf(0:array_len-mid-1) = array(mid:array_len-1)
      ibuf(0:array_len-mid-1) = index(mid:array_len-1)
      i = mid - 1
      j = array_len - mid -1
      merge_upper: do k = array_len-1, 0, -1
        if ( buf(j) >= array(i) ) then
          array(k) = buf(j)
          index(k) = ibuf(j)
          j = j - 1
          if ( j < 0 ) exit merge_upper
        else
          array(k) = array(i)
          index(k) = index(i)
          i = i - 1
          if ( i < 0 ) then
            array(0:k-1) = buf(0:j)
            index(0:k-1) = ibuf(0:j)
            exit merge_upper
          end if
        end if
      end do merge_upper
    end if
  end subroutine merge

  pure subroutine reverse_segment( array, index )
  ! Reverse a segment of an array in place
    integer, intent(inout) :: array(0:)
    integer(int_size), intent(inout) :: index(0:)

    integer(int_size) :: itemp, lo, hi
    integer :: temp

    lo = 0
    hi = size( array, kind=int_size ) - 1
    do while( lo < hi )
      temp = array(lo)
      array(lo) = array(hi)
      array(hi) = temp
      itemp = index(lo)
      index(lo) = index(hi)
      index(hi) = itemp
      lo = lo + 1
      hi = hi - 1
    end do

  end subroutine reverse_segment

end module sort_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readcommand

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the current model run.  *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     18 May 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! bdate                beginning date as Julian date                         *
  ! ctl                  factor by which time step must be smaller than        *
  !                      Lagrangian time scale                                 *
  ! ibdate,ibtime        beginnning date and time (YYYYMMDD, HHMISS)           *
  ! ideltas [s]          modelling period                                      *
  ! iedate,ietime        ending date and time (YYYYMMDD, HHMISS)               *
  ! ifine                reduction factor for vertical wind time step          *
  ! outputforeachrel     for forward runs it is possible either to create      *
  !                      one outputfield or several for each releasepoint      *
  ! iflux                switch to turn on (1)/off (0) flux calculations       *
  ! iout                 1 for conc. (residence time for backward runs) output,*
  !                      2 for mixing ratio output, 3 both, 4 for plume        *
  !                      trajectory output, 5 = options 1 and 4                *
  ! ipin                 1 continue simulation with dumped particle data, 0 no *
  ! ipout                0 no particle dump, 1 every output time, 3 only at end*
  ! itsplit [s]          time constant for particle splitting                  *
  ! loutaver [s]         concentration output is an average over loutaver      *
  !                      seconds                                               *
  ! loutsample [s]       average is computed from samples taken every [s]      *
  !                      seconds                                               *
  ! loutstep [s]         time interval of concentration output                 *
  ! lsynctime [s]        synchronisation time interval for all particles       *
  ! lagespectra          switch to turn on (1)/off (0) calculation of age      *
  !                      spectra                                               *
  ! lconvection          value of either 0 and 1 indicating mixing by          *
  !                      convection                                            *
  !                      = 0 .. no convection                                  *
  !                      + 1 .. parameterisation of mixing by subgrid-scale    *
  !                              convection = on                               *
  ! lsubgrid             switch to turn on (1)/off (0) subgrid topography      *
  !                      parameterization                                      *
  ! method               method used to compute the particle pseudovelocities  *
  ! mdomainfill          1 use domain-filling option, 0 not, 2 use strat. O3   *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitcommand          unit connected to file COMMAND                        *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  real(kind=dp) :: juldate
  character(len=50) :: line
  logical :: old


  ! Open the command file and read user options
  !********************************************


  open(unitcommand,file=path(1)(1:length(1))//'COMMAND',status='old', &
       err=999)

  ! Check the format of the COMMAND file (either in free format,
  ! or using formatted mask)
  ! Use of formatted mask is assumed if line 10 contains the word 'DIRECTION'
  !**************************************************************************

  call skplin(9,unitcommand)
  read (unitcommand,901) line
901   format (a)
  if (index(line,'LDIRECT') .eq. 0) then
    old = .false.
  else
    old = .true.
  endif
  rewind(unitcommand)

  ! Read parameters
  !****************

  call skplin(7,unitcommand)
  if (old) call skplin(1,unitcommand)

  read(unitcommand,*) ldirect
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ibdate,ibtime
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) iedate,ietime
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) loutstep
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) loutaver
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) loutsample
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) itsplit
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) lsynctime
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ctl
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ifine
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) iout
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ipout
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) lsubgrid
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) lconvection
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) lagespectra
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ipin
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ioutputforeachrelease
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) iflux
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) mdomainfill
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ind_source
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) ind_receptor
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) mquasilag
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) nested_output
  if (old) call skplin(3,unitcommand)
  read(unitcommand,*) linit_cond
  close(unitcommand)

  ifine=max(ifine,1)


  ! Determine how Markov chain is formulated (for w or for w/sigw)
  !***************************************************************

  if (ctl.ge.0.1) then
    turbswitch=.true.
  else
    turbswitch=.false.
    ifine=1
  endif
  fine=1./real(ifine)
  ctl=1./ctl

  ! Set the switches required for the various options for input/output units
  !*************************************************************************
  !AF Set the switches IND_REL and IND_SAMP for the release and sampling
  !Af switches for the releasefile:
  !Af IND_REL =  1 : xmass * rho
  !Af IND_REL =  0 : xmass * 1

  !Af switches for the conccalcfile:
  !AF IND_SAMP =  0 : xmass * 1
  !Af IND_SAMP = -1 : xmass / rho

  !AF IND_SOURCE switches between different units for concentrations at the source
  !Af   NOTE that in backward simulations the release of computational particles
  !Af   takes place at the "receptor" and the sampling of p[articles at the "source".
  !Af          1 = mass units
  !Af          2 = mass mixing ratio units
  !Af IND_RECEPTOR switches between different units for concentrations at the receptor
  !Af          1 = mass units
  !Af          2 = mass mixing ratio units

  if ( ldirect .eq. 1 ) then  ! FWD-Run
  !Af set release-switch
     if (ind_source .eq. 1 ) then !mass
        ind_rel = 0
     else ! mass mix
        ind_rel = 1
     endif
  !Af set sampling switch
     if (ind_receptor .eq. 1) then !mass
        ind_samp = 0
     else ! mass mix
        ind_samp = -1
     endif
  elseif (ldirect .eq. -1 ) then !BWD-Run
  !Af set sampling switch
     if (ind_source .eq. 1 ) then !mass
        ind_samp = -1
     else ! mass mix
        ind_samp = 0
     endif
  !Af set release-switch
     if (ind_receptor .eq. 1) then !mass
        ind_rel = 1
     else ! mass mix
        ind_rel = 0
     endif
  endif

  !*************************************************************
  ! Check whether valid options have been chosen in file COMMAND
  !*************************************************************

  ! Check options for initial condition output: Switch off for forward runs
  !************************************************************************

  if (ldirect.eq.1) linit_cond=0
  if ((linit_cond.lt.0).or.(linit_cond.gt.2)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! INVALID OPTION    #### '
    write(*,*) ' #### FOR LINIT_COND IN FILE "COMMAND".       #### '
    stop
  endif

  ! Check input dates
  !******************

  if (iedate.lt.ibdate) then
    write(*,*) ' #### FLEXPART MODEL ERROR! BEGINNING DATE    #### '
    write(*,*) ' #### IS LARGER THAN ENDING DATE. CHANGE      #### '
    write(*,*) ' #### EITHER POINT 2 OR POINT 3 IN FILE       #### '
    write(*,*) ' #### "COMMAND".                              #### '
    stop
  else if (iedate.eq.ibdate) then
    if (ietime.lt.ibtime) then
    write(*,*) ' #### FLEXPART MODEL ERROR! BEGINNING TIME    #### '
    write(*,*) ' #### IS LARGER THAN ENDING TIME. CHANGE      #### '
    write(*,*) ' #### EITHER POINT 2 OR POINT 3 IN FILE       #### '
    write(*,*) ' #### "COMMAND".                              #### '
    stop
    endif
  endif


  ! Determine kind of dispersion method
  !************************************

  if (ctl.gt.0.) then
    method=1
    mintime=minstep
  else
    method=0
    mintime=lsynctime
  endif

  ! Check whether a valid option for gridded model output has been chosen
  !**********************************************************************

  if ((iout.lt.1).or.(iout.gt.5)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### IOUT MUST BE 1, 2, 3, 4, OR 5!          #### '
    stop
  endif

  !AF check consistency between units and volume mixing ratio
  if ( ((iout.eq.2).or.(iout.eq.3)).and. &
       (ind_source.gt.1 .or.ind_receptor.gt.1) ) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### VOLUME MIXING RATIO ONLY SUPPORTED      #### '
    write(*,*) ' #### FOR MASS UNITS (at the moment)          #### '
    stop
  endif



  ! For quasilag output for each release is forbidden
  !*****************************************************************************

  if ((ioutputforeachrelease.eq.1).and.(mquasilag.eq.1)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### OUTPUTFOREACHRELEASE AND QUASILAGRANGIAN####'
      write(*,*) '#### MODE IS NOT POSSIBLE   !                ####'
      stop
  endif


  ! For quasilag backward is forbidden
  !*****************************************************************************

  if ((ldirect.lt.0).and.(mquasilag.eq.1)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR BACKWARD RUNS, QUASILAGRANGIAN MODE ####'
      write(*,*) '#### IS NOT POSSIBLE   !                     ####'
      stop
  endif


  ! For backward runs one releasefield for all releases makes no sense,
  ! For quasilag and domainfill ioutputforechrelease is forbidden
  !*****************************************************************************

  if ((ldirect.lt.0).and.(ioutputforeachrelease.eq.0)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR BACKWARD RUNS, IOUTPUTFOREACHRLEASE ####'
      write(*,*) '#### MUST BE SET TO ONE!                     ####'
      stop
  endif


  ! For backward runs one releasefield for all releases makes no sense,
  ! and is "forbidden"
  !*****************************************************************************

  if ((mdomainfill.eq.1).and.(ioutputforeachrelease.eq.1)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR DOMAIN FILLING RUNS OUTPUT FOR      ####'
      write(*,*) '#### EACH RELEASE IS FORBIDDEN !             ####'
      stop
  endif


  ! For domain-filling trajectories, a plume centroid trajectory makes no sense,
  ! For backward runs, only residence time output (iout=1) or plume trajectories (iout=4),
  ! or both (iout=5) makes sense; other output options are "forbidden"
  !*****************************************************************************

  if (ldirect.lt.0) then
    if ((iout.eq.2).or.(iout.eq.3)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR BACKWARD RUNS, IOUT MUST BE 1,4,OR 5####'
      stop
    endif
  endif


  ! For domain-filling trajectories, a plume centroid trajectory makes no sense,
  ! and is "forbidden"
  !*****************************************************************************

  if (mdomainfill.ge.1) then
    if ((iout.eq.4).or.(iout.eq.5)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR DOMAIN-FILLING TRAJECTORY OPTION,   ####'
      write(*,*) '#### IOUT MUST NOT BE SET TO 4 OR 5.         ####'
      stop
    endif
  endif



  ! Check whether a valid options for particle dump has been chosen
  !****************************************************************

  if ((ipout.ne.0).and.(ipout.ne.1).and.(ipout.ne.2)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### IPOUT MUST BE 1, 2 OR 3!                #### '
    stop
  endif

  if(lsubgrid.ne.1) then
    write(*,*) '             ----------------               '
    write(*,*) ' INFORMATION: SUBGRIDSCALE TERRAIN EFFECT IS'
    write(*,*) ' NOT PARAMETERIZED DURING THIS SIMULATION.  '
    write(*,*) '             ----------------               '
  endif


  ! Check whether convection scheme is either turned on or off
  !***********************************************************

  if ((lconvection.ne.0).and.(lconvection.ne.1)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### LCONVECTION MUST BE SET TO EITHER 1 OR 0#### '
    stop
  endif


  ! Check whether synchronisation interval is sufficiently short
  !*************************************************************

  if (lsynctime.gt.(idiffnorm/2)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! SYNCHRONISATION   #### '
    write(*,*) ' #### TIME IS TOO LONG. MAKE IT SHORTER.      #### '
    write(*,*) ' #### MINIMUM HAS TO BE: ', idiffnorm/2
    stop
  endif


  ! Check consistency of the intervals, sampling periods, etc., for model output
  !*****************************************************************************

  if (loutaver.eq.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! TIME AVERAGE OF   #### '
    write(*,*) ' #### CONCENTRATION FIELD OUTPUT MUST NOT BE  #### '
    write(*,*) ' #### ZERO.                                   #### '
    write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
    stop
  endif

  if (loutaver.gt.loutstep) then
    write(*,*) ' #### FLEXPART MODEL ERROR! TIME AVERAGE OF   #### '
    write(*,*) ' #### CONCENTRATION FIELD OUTPUT MUST NOT BE  #### '
    write(*,*) ' #### GREATER THAN INTERVAL OF OUTPUT.        #### '
    write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
    stop
  endif

  if (loutsample.gt.loutaver) then
    write(*,*) ' #### FLEXPART MODEL ERROR! SAMPLING TIME OF  #### '
    write(*,*) ' #### CONCENTRATION FIELD OUTPUT MUST NOT BE  #### '
    write(*,*) ' #### GREATER THAN TIME AVERAGE OF OUTPUT.    #### '
    write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
    stop
  endif

  if (mod(loutaver,lsynctime).ne.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! AVERAGING TIME OF #### '
    write(*,*) ' #### CONCENTRATION FIELD MUST BE A MULTIPLE  #### '
    write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
    stop
  endif

  if ((loutaver/lsynctime).lt.2) then
    write(*,*) ' #### FLEXPART MODEL ERROR! AVERAGING TIME OF #### '
    write(*,*) ' #### CONCENTRATION FIELD MUST BE AT LEAST    #### '
    write(*,*) ' #### TWICE THE SYNCHRONISATION INTERVAL      #### '
    stop
  endif

  if (mod(loutstep,lsynctime).ne.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! INTERVAL BETWEEN  #### '
    write(*,*) ' #### CONCENTRATION FIELDS MUST BE A MULTIPLE #### '
    write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
    stop
  endif

  if ((loutstep/lsynctime).lt.2) then
    write(*,*) ' #### FLEXPART MODEL ERROR! INTERVAL BETWEEN  #### '
    write(*,*) ' #### CONCENTRATION FIELDS MUST BE AT LEAST   #### '
    write(*,*) ' #### TWICE THE SYNCHRONISATION INTERVAL      #### '
    stop
  endif

  if (mod(loutsample,lsynctime).ne.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! SAMPLING TIME OF  #### '
    write(*,*) ' #### CONCENTRATION FIELD MUST BE A MULTIPLE  #### '
    write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
    stop
  endif

  if (itsplit.lt.loutaver) then
    write(*,*) ' #### FLEXPART MODEL ERROR! SPLITTING TIME FOR#### '
    write(*,*) ' #### PARTICLES IS TOO SHORT. PLEASE INCREASE #### '
    write(*,*) ' #### SPLITTING TIME CONSTANT.                #### '
    stop
  endif

  if ((mquasilag.eq.1).and.(iout.ge.4)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! CONFLICTING       #### '
    write(*,*) ' #### OPTIONS: IF MQUASILAG=1, PLUME          #### '
    write(*,*) ' #### TRAJECTORY OUTPUT IS IMPOSSIBLE.        #### '
    stop
  endif

  ! Compute modeling time in seconds and beginning date in Julian date
  !*******************************************************************

  outstep=real(abs(loutstep))
  if (ldirect.eq.1) then
    bdate=juldate(ibdate,ibtime)
    edate=juldate(iedate,ietime)
    ideltas=nint((edate-bdate)*86400.)
  else if (ldirect.eq.-1) then
    loutaver=-1*loutaver
    loutstep=-1*loutstep
    loutsample=-1*loutsample
    lsynctime=-1*lsynctime
    bdate=juldate(iedate,ietime)
    edate=juldate(ibdate,ibtime)
    ideltas=nint((edate-bdate)*86400.)
  else
    write(*,*) ' #### FLEXPART MODEL ERROR! DIRECTION IN      #### '
    write(*,*) ' #### FILE "COMMAND" MUST BE EITHER -1 OR 1.  #### '
    stop
  endif

  return

999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "COMMAND"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  stop

end subroutine readcommand

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine interpol_wind_short(itime,xt,yt,zt)
  !                                 i   i  i  i
  !*****************************************************************************
  !                                                                            *
  !  This subroutine interpolates the wind data to current trajectory position.*
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    16 December 1997                                                        *
  !                                                                            *
  !  Revision March 2005 by AST : all output variables in common block         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! u,v,w              wind components                                         *
  ! itime [s]          current temporal position                               *
  ! memtime(3) [s]     times of the wind fields in memory                      *
  ! xt,yt,zt           coordinates position for which wind data shall be       *
  !                    calculated                                              *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use interpol_mod

  implicit none

  integer :: itime
  real :: xt,yt,zt

  ! Auxiliary variables needed for interpolation
  real :: dz1,dz2,dz
  real :: u1(2),v1(2),w1(2),uh(2),vh(2),wh(2)
  integer :: i,m,n,indexh,indzh


  !********************************************
  ! Multilinear interpolation in time and space
  !********************************************

  ddx=xt-real(ix)
  ddy=yt-real(jy)
  rddx=1.-ddx
  rddy=1.-ddy
  p1=rddx*rddy
  p2=ddx*rddy
  p3=rddx*ddy
  p4=ddx*ddy

  ! Calculate variables for time interpolation
  !*******************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)

  ! Determine the level below the current position for u,v
  !*******************************************************

  do i=2,nz
    if (height(i).gt.zt) then
      indz=i-1
      goto 6
    endif
  end do
6   continue


  ! Vertical distance to the level below and above current position
  !****************************************************************

  dz=1./(height(indz+1)-height(indz))
  dz1=(zt-height(indz))*dz
  dz2=(height(indz+1)-zt)*dz


  !**********************************************************************
  ! 1.) Bilinear horizontal interpolation
  ! This has to be done separately for 6 fields (Temporal(2)*Vertical(3))
  !**********************************************************************

  ! Loop over 2 time steps and 2 levels
  !************************************

  do m=1,2
    indexh=memind(m)
    do n=1,2
      indzh=indz+n-1

      if (ngrid.lt.0) then
        u1(n)=p1*uupol(ix ,jy ,indzh,indexh) &
             +p2*uupol(ixp,jy ,indzh,indexh) &
             +p3*uupol(ix ,jyp,indzh,indexh) &
             +p4*uupol(ixp,jyp,indzh,indexh)
        v1(n)=p1*vvpol(ix ,jy ,indzh,indexh) &
             +p2*vvpol(ixp,jy ,indzh,indexh) &
             +p3*vvpol(ix ,jyp,indzh,indexh) &
             +p4*vvpol(ixp,jyp,indzh,indexh)
      else
        u1(n)=p1*uu(ix ,jy ,indzh,indexh) &
             +p2*uu(ixp,jy ,indzh,indexh) &
             +p3*uu(ix ,jyp,indzh,indexh) &
             +p4*uu(ixp,jyp,indzh,indexh)
        v1(n)=p1*vv(ix ,jy ,indzh,indexh) &
             +p2*vv(ixp,jy ,indzh,indexh) &
             +p3*vv(ix ,jyp,indzh,indexh) &
             +p4*vv(ixp,jyp,indzh,indexh)
      endif
      w1(n)=p1*ww(ix ,jy ,indzh,indexh) &
           +p2*ww(ixp,jy ,indzh,indexh) &
           +p3*ww(ix ,jyp,indzh,indexh) &
           +p4*ww(ixp,jyp,indzh,indexh)
    end do


  !**********************************
  ! 2.) Linear vertical interpolation
  !**********************************

    uh(m)=dz2*u1(1)+dz1*u1(2)
    vh(m)=dz2*v1(1)+dz1*v1(2)
    wh(m)=dz2*w1(1)+dz1*w1(2)
  end do



  !************************************
  ! 3.) Temporal interpolation (linear)
  !************************************

  u=(uh(1)*dt2+uh(2)*dt1)*dtt
  v=(vh(1)*dt2+vh(2)*dt1)*dtt
  w=(wh(1)*dt2+wh(2)*dt1)*dtt

end subroutine interpol_wind_short

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

! DJM - 2017-05-09 - added #ifdef USE_MPIINPLACE cpp directive to     *
! enable declaration of a gridunc0 array if required by MPI code in   *
! mpi_mod.f90                                                         *
!                                                                     *
!**********************************************************************

module unc_mod

  use par_mod, only:dp,dep_prec,nclassunc

  implicit none

  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: gridunc
  real(dep_prec),allocatable, dimension (:,:,:)         :: gridcnt
#ifdef USE_MPIINPLACE
#else
  ! If MPI_IN_PLACE option is not used in mpi_mod.f90::mpif_tm_reduce_grid(),
  ! then an aux array is needed for parallel grid reduction
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: gridunc0
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: griduncn0
#endif
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: griduncn
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: drygridunc
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: drygriduncn
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: wetgridunc
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: wetgriduncn
#ifdef _OPENMP
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:,:) :: gridunc_omp
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:,:) :: griduncn_omp
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: drygridunc_omp
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: drygriduncn_omp
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: wetgridunc_omp
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:,:) :: wetgriduncn_omp
  real(dep_prec),allocatable, dimension (:,:,:,:)       :: gridcnt_omp
#endif
! For sum of individual contributions, used for the MPI version
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: drygridunc0
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: drygriduncn0
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: wetgridunc0
  real(dep_prec),allocatable, dimension (:,:,:,:,:,:) :: wetgriduncn0

contains

subroutine alloc_grid_unc()
  use com_mod

  implicit none 

  integer :: stat
  
  ! gridunc,griduncn        uncertainty of outputted concentrations
  allocate(gridunc(0:numxgrid-1,0:numygrid-1,numzgrid,nspec, &
       maxpointspec_act,nclassunc,nageclass),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
  allocate(gridcnt(0:numxgrid-1,0:numygrid-1,numzgrid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate gridcnt'
#ifdef _OPENMP
  allocate(gridunc_omp(0:numxgrid-1,0:numygrid-1,numzgrid,nspec, &
       maxpointspec_act,nclassunc,nageclass,numthreads_grid),stat=stat)
  if (stat.ne.0) then
    write(*,*)'ERROR: could not allocate gridunc_omp'
    write(*,*)'increase the memory or reduce MAXTHREADGRID in COMMAND.'
    error stop
  endif
  allocate(gridcnt_omp(0:numxgrid-1,0:numygrid-1,numzgrid,numthreads_grid),stat=stat)
  if (stat.ne.0) then
    write(*,*)'ERROR: could not allocate gridcnt_omp'
    write(*,*)'increase the memory or reduce MAXTHREADGRID in COMMAND.'
    error stop
  endif
#endif
  if (ldirect.gt.0) then
    allocate(wetgridunc(0:numxgrid-1,0:numygrid-1,nspec, &
         maxpointspec_act,nclassunc,nageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate wetgridunc'
    allocate(drygridunc(0:numxgrid-1,0:numygrid-1,nspec, &
         maxpointspec_act,nclassunc,nageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate drygridunc'
#ifdef _OPENMP
    allocate(wetgridunc_omp(0:numxgrid-1,0:numygrid-1,nspec, &
         maxpointspec_act,nclassunc,nageclass,numthreads_grid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate wetgridunc_omp'
    allocate(drygridunc_omp(0:numxgrid-1,0:numygrid-1,nspec, &
         maxpointspec_act,nclassunc,nageclass,numthreads_grid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate drygridunc_omp'
#endif
  endif

#ifdef USE_MPIINPLACE
#else
! Extra field for totals at MPI root process
  if (lroot.and.mpi_mode.gt.0) then
! If MPI_IN_PLACE option is not used in mpi_mod.f90::mpif_tm_reduce_grid(),
! then an aux array is needed for parallel grid reduction
    allocate(gridunc0(0:numxgrid-1,0:numygrid-1,numzgrid,nspec, &
         maxpointspec_act,nclassunc,nageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc0'
  else if (.not.lroot.and.mpi_mode.gt.0) then
    allocate(gridunc0(1,1,1,1,1,1,1),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc0'
  end if
#endif
  if (ldirect.gt.0) then
    if (lroot.and.mpi_mode.gt.0) then
      allocate(wetgridunc0(0:numxgrid-1,0:numygrid-1,nspec, &
           maxpointspec_act,nclassunc,nageclass),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate wetgridunc0'
      allocate(drygridunc0(0:numxgrid-1,0:numygrid-1,nspec, &
           maxpointspec_act,nclassunc,nageclass),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR: could not allocate drygridunc0'

  ! allocate a dummy to avoid compilator complaints
    else if (.not.lroot.and.mpi_mode.gt.0) then
      allocate(wetgridunc0(1,1,1,1,1,1),stat=stat)
      allocate(drygridunc0(1,1,1,1,1,1),stat=stat)
    end if
  end if

  if (lroot) then
    write (*,*) 'Allocating fields for global output (x,y): ', &
      numxgrid,numygrid
  end if

end subroutine alloc_grid_unc

subroutine alloc_grid_unc_nest()
  use com_mod

  implicit none

  integer :: stat

  ! gridunc,griduncn        uncertainty of outputted concentrations
  allocate(griduncn(0:numxgridn-1,0:numygridn-1,numzgrid,nspec, &
       maxpointspec_act,nclassunc,nageclass),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc'
#ifdef _OPENMP
  allocate(griduncn_omp(0:numxgridn-1,0:numygridn-1,numzgrid,nspec, &
       maxpointspec_act,nclassunc,nageclass,numthreads_grid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc_omp'
#endif

  if (ldirect.gt.0) then
    allocate(wetgriduncn(0:numxgridn-1,0:numygridn-1,nspec, &
         maxpointspec_act,nclassunc,nageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR:could not allocate nested wetgridunc'
    allocate(drygriduncn(0:numxgridn-1,0:numygridn-1,nspec, &
         maxpointspec_act,nclassunc,nageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR:could not allocate nested drygridunc'
#ifdef _OPENMP
    allocate(wetgriduncn_omp(0:numxgridn-1,0:numygridn-1,nspec, &
         maxpointspec_act,nclassunc,nageclass,numthreads_grid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR:could not allocate nested wetgridunc_omp'
    allocate(drygriduncn_omp(0:numxgridn-1,0:numygridn-1,nspec, &
         maxpointspec_act,nclassunc,nageclass,numthreads_grid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR:could not allocate nested drygriduncn_omp'
#endif
  endif

#ifdef USE_MPIINPLACE
#else
  ! Extra field for totals at MPI root process
  if (lroot.and.mpi_mode.gt.0) then
  ! If MPI_IN_PLACE option is not used in mpi_mod.f90::mpif_tm_reduce_grid_nest(),
  ! then an aux array is needed for parallel grid reduction
    allocate(griduncn0(0:numxgridn-1,0:numygridn-1,numzgrid,nspec, &
         maxpointspec_act,nclassunc,nageclass),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc'
  ! allocate a dummy to avoid compilator complaints
  else if (.not.lroot.and.mpi_mode.gt.0) then
    allocate(griduncn0(1,1,1,1,1,1,1),stat=stat)
  end if
#endif
  if (ldirect.gt.0) then
    if (lroot.and.mpi_mode.gt.0) then
      allocate(wetgriduncn0(0:numxgridn-1,0:numygridn-1,nspec, &
           maxpointspec_act,nclassunc,nageclass),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc'
      allocate(drygriduncn0(0:numxgridn-1,0:numygridn-1,nspec, &
           maxpointspec_act,nclassunc,nageclass),stat=stat)
      if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc'
  !  endif
  ! allocate a dummy to avoid compilator complaints
    else if (.not.lroot.and.mpi_mode.gt.0) then
      allocate(wetgriduncn0(1,1,1,1,1,1),stat=stat)
      allocate(drygriduncn0(1,1,1,1,1,1),stat=stat)
    end if
  end if

  if (lroot) then
    write (*,*) 'Allocating fields for nested output (x,y): ', &
      numxgridn,numygridn
  end if

end subroutine alloc_grid_unc_nest

subroutine deposit_decay()
  ! Accumulated deposited mass radioactively decays
  use com_mod

  implicit none

  integer ::                &
    j,i,                    & ! loop variable over grid
    ks,                     & ! loop variable species
    kp,                     & ! loop variable for maxpointspec_act
    l,                      & ! loop variable over nclassunc
    nage                      ! loop variable over age classes

!$OMP PARALLEL PRIVATE(ks,kp,nage,l,j,i)
!$OMP DO COLLAPSE(2)
  do ks=1,nspec
  do kp=1,maxpointspec_act
    if (decay(ks).gt.0.) then
      do nage=1,nageclass
        do l=1,nclassunc
  ! Mother output grid
          do j=0,numygrid-1
            do i=0,numxgrid-1
              wetgridunc(i,j,ks,kp,l,nage)= &
                   wetgridunc(i,j,ks,kp,l,nage)* &
                   exp(-1.*outstep*decay(ks))
              drygridunc(i,j,ks,kp,l,nage)= &
                   drygridunc(i,j,ks,kp,l,nage)* &
                   exp(-1.*outstep*decay(ks))
            end do
          end do
  ! Nested output grid
          if (nested_output.eq.1) then
            do j=0,numygridn-1
              do i=0,numxgridn-1
                wetgriduncn(i,j,ks,kp,l,nage)= &
                     wetgriduncn(i,j,ks,kp,l,nage)* &
                     exp(-1.*outstep*decay(ks))
                drygriduncn(i,j,ks,kp,l,nage)= &
                     drygriduncn(i,j,ks,kp,l,nage)* &
                     exp(-1.*outstep*decay(ks))
              end do
            end do
          endif
        end do
      end do
    endif
  end do
  end do
!$OMP END DO
!$OMP END PARALLEL
end subroutine deposit_decay

end module unc_mod

  !*****************************************************************************
  !                                                                            *
  ! Module that organises particle information in derived types                *
  ! Particles are terminated and spawned using routines from this module so    *
  ! that global particle counts (spawned, allocated, terminated) are kept      *
  ! up to date                                                                 *
  !                                                                            *
  ! Author: L. Bakels 2022                                                     *
  !                                                                            *
  !*****************************************************************************

module particle_mod
  use com_mod, only: maxspec,DRYDEP,WETDEP,DRYBKDEP,WETBKDEP,iout, &
    n_average,nspec,ipout,ipin
  use par_mod, only: dp,ispeed

  implicit none
  
  type :: coordinates
    real(kind=dp) ::              &
      xlon,                       & ! longitude in grid coordinates
      ylat                          ! latitude in grid coordinates
    real          ::              &
      z                             ! height in meters
#ifdef ETA
    real          ::              &
      zeta                          ! height in eta (ECMWF) coordinates
#endif
  end type coordinates

  type :: velocities
    real               ::         &
      u,                          & ! x velocity
      v,                          & ! y velocity
      w                             ! z velocity
#ifdef ETA
    real               ::         &
      weta                          ! z velocity in eta (ECMWF) coordinates
#endif
  end type velocities

  type :: particle
    real(kind=dp)      ::         &
      xlon,                       & ! Longitude in grid coordinates
      ylat,                       & ! Latitude in grid coordinates
      xlon_prev, ylat_prev,       & ! Keeping the previous positions in memory
      z,                          & ! height in meters
      z_prev                        ! Previous position
#ifdef ETA
    real(kind=dp)      ::         &
      zeta,                       & ! Height in eta (ECMWF) coordinates
      zeta_prev                     ! Previous position
#endif
    type(velocities)   ::         &
      !vel,                        & ! Velocities from interpolated windfields
      turbvel,                    & ! Random turbulent velocities
      mesovel                       ! Mesoscale turbulent velocities
    real               ::         &
      settling                      ! Settling velocity for dry and wet(?) deposit
    logical            ::         &
      alive=.false.,              & ! Flag to show if the particle is still in the running
      spawned=.false.,            & ! Flag to show that particle has spawned (includes terminated parts)
      nstop=.false.                 ! Flag to stop particle (used in advance, stopped in timemanager)
#ifdef ETA
    logical            ::         &
      etaupdate=.false.,          & ! If false, z(meter) is more up-to-date than z(eta)
      meterupdate=.false.           ! If false, z(eta) is more up-to-date than z(meter)
#endif
    integer(kind=2)    ::         &
      icbt                          ! Forbidden state flag   
    integer            ::         &
      tstart,                     & ! spawning time in seconds after start
      tend,                       & ! termination time in seconds after start
      npoint,                     & ! release point
      nclass,                     &
      !species(maxspec),           & ! the number of the corresponding species file of the particle
      idt                           ! internal time of the particle
    ! real,allocatable,dimension(:) ::  &
    !   mass,                       & ! Particle mass for each particle species
    !   mass_init,                  & ! Initial mass of each particle
    !   wetdepo,                    & ! Wet deposition (cumulative)
    !   drydepo,                    & ! Dry deposition (cumulative)
    !   prob                          ! Probability of absorption at ground due to dry deposition
    
    ! real,allocatable   ::         &
    !   val_av(:)                     ! Averaged values; only used when average_output=.true.
    real               ::         &
      ntime=0.,                   & ! Number of timesteps to average over
      cartx_av=0.,                & ! Averaged x pos;
      carty_av=0.,                & ! Averaged y pos;
      cartz_av=0.                   ! Averaged z pos;

  end type particle

  type :: particlecount          
    integer              ::       &
      alive=0,                    & ! Number of particles that are alive
      spawned=0,                  & ! Total number of spawned particles
      terminated=0,               & ! Total number of particles that have been terminated
      allocated=0,                & ! Number of total allocated particle spaces
      iterm_max=0,                & ! Number of empty spaces for overwriting particles
      ninmem=0                      ! Number of particles currently in memory
    logical,allocatable  ::       &
      inmem(:)                      ! Logical to keep track which particle numbers are allocated
    integer,allocatable  ::       &                  
      ialive(:),                  & ! Array that stores alive particle numbers up to count%alive for OMP loops 
      iterm(:)                      ! Array that stores terminated particle numbers up to count%allocated
  end type

  type(particle), allocatable ::  &
    part(:)                         ! This is where all particles are being stored
  type(particlecount)         ::  &
    count                           ! Keeping track of global particle number within the simulation
  real,allocatable            ::  &
    val_av(:,:),                  &  ! Averaged values; only used when average_output=.true.
    xscav_frac1(:,:),             &  ! Only allocated when wet or dry deposit backward mode is switched on
    mass(:,:),                    &  ! mass 
    mass_init(:,:),               &
    wetdeposit(:,:),                 &
    drydeposit(:,:),                 &
    prob(:,:)

  real,allocatable            ::  &
    xplum(:),yplum(:),zplum(:)      ! Only allocated for iout=4 or 5 (plumetraj)
  integer,allocatable         ::  &
    nclust(:)                       ! Only allocated for iout=4 or 5 (plumetraj)
  ! private ::                      &
  !   count             
  public ::                       &
    particle,                     &
    part,                         &
    alloc_particles,              &
    dealloc_particle_range,       &
    dealloc_particle,             &
    dealloc_all_particles,        &
    terminate_particle,           &
    rewrite_ialive,               &
    rewrite_iterm,                &
    spawn_particle,               &
    spawn_particles,              &
    get_totalpart_num,            &
    get_alivepart_num,            &
    get_newpart_index,            &
    particle_allocated,           &
    update_xlon,                  &
    update_ylat,                  &
    update_z,                     &
    count,                        &
    val_av,                       &
    xscav_frac1,                  &
    mass,                         &
    mass_init,                    &
    wetdeposit,                   &
    drydeposit,                   &
    prob,                         &
    xplum,                        &
    yplum,                        &
    zplum,                        &
    nclust                       

  interface update_xlon
    procedure update_xlon_dp, update_xlon_sp, update_xlon_int
  end interface update_xlon

  interface set_xlon
    procedure set_xlon_dp, set_xlon_sp, set_xlon_int
  end interface set_xlon

  interface update_ylat
    procedure update_ylat_dp, update_ylat_sp, update_ylat_int
  end interface update_ylat

  interface set_ylat
    procedure set_ylat_dp, set_ylat_sp, set_ylat_int
  end interface set_ylat

  interface update_z
    procedure update_z_dp,update_z_sp
  end interface update_z

  interface set_z
    procedure set_z_dp,set_z_sp
  end interface set_z

#ifdef ETA
  interface update_zeta
    procedure update_zeta_dp,update_zeta_sp
  end interface update_zeta

  interface set_zeta
    procedure set_zeta_dp,set_zeta_sp
  end interface set_zeta
#endif
contains

  logical function particle_allocated(ipart)
    !******************************************
    ! Checks if the memory of the particle is *
    ! still allocated                         *
    !******************************************

    implicit none 

    integer, intent(in)    :: ipart   ! Particle index
    !logical :: is_particle_allocated
    
    if (ipart.gt.count%allocated) then
      particle_allocated = .false.
    else
      particle_allocated = count%inmem(ipart)
    endif
  end function particle_allocated

  subroutine get_newpart_index(ipart,iterm_index)
    !**************************************************
    ! Returns the first free spot to put a new particle
    !**************************************************
    implicit none

    integer, intent(inout) :: ipart   ! First free index
    integer, intent(inout) :: iterm_index
    integer :: i

    if (ipin.le.1 .and. ipout.eq.0 .and. ispeed.eq.0 ) then
      if ((ipin.eq.0 .and. count%terminated.eq.0) .or. &
        (count%allocated.gt.count%spawned)) then
        ipart = count%spawned + 1
      else if (iterm_index.le.count%iterm_max) then
        ! Find dead particles to replace
        if (count%iterm(iterm_index).eq.-1) then
          error stop 'BUG: Attempting to overwrite particle: get_newpart_index.'
        endif
        ipart=count%iterm(iterm_index)
        count%iterm(iterm_index) = -1
        iterm_index = iterm_index+1
      else
        write(*,*) ipart
        ipart=count%allocated + 1
      endif
    else
      ipart = count%spawned + 1
    endif
  end subroutine get_newpart_index

  subroutine get_totalpart_num(npart)
    !********************************************
    ! Returns total number of particles spawned *
    !********************************************
    implicit none 

    integer, intent(inout) :: npart   ! Number of particles

    npart = count%spawned
  end subroutine get_totalpart_num

  subroutine get_alivepart_num(npart)
    !**********************************************
    ! Returns number of particles currently alive *
    !**********************************************
    implicit none 

    integer, intent(inout) :: npart   ! Number of particles

    npart = count%alive
  end subroutine get_alivepart_num

  subroutine spawn_particles(itime, nmpart)
    !******************************************************
    ! Spawning particles
    !
    ! This routine spawns new particles and allocates the 
    ! memory if necessary.
    !******************************************************
    implicit none 

    integer, intent(in) :: &
      itime,               &  ! spawning time
      nmpart                  ! number of particles that are being spawned
    integer ::             &
      i ,j                    ! loop variable

    ! Check if new memory needs to be allocated 
    !*******************************************
    if (nmpart+count%spawned.gt.count%allocated) then
      call alloc_particles( (nmpart+count%spawned) - count%allocated )
    endif

    ! Set the spawning time for each new particle and mark it as alive
    !*****************************************************************
    part(count%spawned+1:count%spawned+nmpart)%tstart = itime
    part(count%spawned+1:count%spawned+nmpart)%alive = .true.
    part(count%spawned+1:count%spawned+nmpart)%spawned = .true.

    ! Updating the list with alive particle numbers that is used to
    ! loop over when doing particle computations
    !*************************************************************
    j=count%spawned+1
    do i=count%alive+1,count%alive+nmpart
      count%ialive(i)=j
      j = j+1
    end do

    ! Update the number of particles that are currently alive
    !********************************************************
    count%alive = count%alive + nmpart

    ! Update the total number of spawned particles
    !*********************************************
    count%spawned = count%spawned + nmpart

  end subroutine spawn_particles

  subroutine spawn_particle(itime, ipart)
    !******************************************************
    ! Spawning particles
    !
    ! This routine spawns new particles and allocates the 
    ! memory if necessary.
    !******************************************************
    implicit none 

    integer, intent(in) :: &
      itime,               & ! spawning time
      ipart                  ! number of particles that are being spawned

    ! Check if new memory needs to be allocated 
    !*******************************************
    if (.not. particle_allocated(ipart)) call alloc_particle(ipart)

    if (part(ipart)%alive) then
      write(*,*) ipart, count%alive, count%terminated, count%allocated
      error stop 'Attempting to overwrite existing particle'
    endif

    ! Update the number of particles that are currently alive
    !********************************************************
    count%alive = count%alive + 1

    ! Set the spawning time for each new particle and mark it as alive
    !*****************************************************************
    part(ipart)%tstart = itime
    part(ipart)%alive = .true.
    part(ipart)%spawned = .true.

    ! Updating the list with alive particle numbers that is used to
    ! loop over when doing particle computations
    !*************************************************************
    count%ialive(count%alive) = ipart

    ! Update the total number of spawned particles
    !*********************************************
    count%spawned = count%spawned + 1

  end subroutine spawn_particle

  subroutine terminate_particle(ipart,itime)
    !*****************************************************
    ! Terminating specified particle
    !
    ! This routine terminates a selected particle
    !***************************************************** 
    implicit none

    integer, intent(in) :: &
      ipart,               & ! to be terminated particle index
      itime                  ! Time at which particle is terminated

    ! Flagging the particle as having been terminated
    !************************************************
    part(ipart)%alive=.false.  
    part(ipart)%tend=itime

    ! Update the number of current particles that are alive
    !******************************************************
    count%alive = count%alive - 1

    ! Update the total number of terminated particles during the whole run
    !**********************************************************************
    count%terminated = count%terminated + 1
  end subroutine terminate_particle

  subroutine rewrite_ialive()
    implicit none

    integer :: i,j

    j=1
    do i=1,count%allocated
      if (part(i)%alive) then
        count%ialive(j)=i
        j=j+1
      endif
    end do

    count%alive=j-1

    if (ipin.le.1 .and. ipout.eq.0 .and. ispeed.eq.0) call rewrite_iterm
  end subroutine rewrite_ialive

  subroutine rewrite_iterm()
    implicit none

    integer :: i,j

    j=1
    do i=1,count%allocated
      if (.not. part(i)%alive) then
        count%iterm(j)=i
        j=j+1
      endif
    end do

    count%iterm_max=j-1

  end subroutine rewrite_iterm

  subroutine rewrite_ialive_single(ipart)
    implicit none

    integer, intent(in) :: &
      ipart                  ! to be terminated particle index    
    integer ::             &
      i,                   & ! loop variable
      iloc                   ! location of ipart in count%ialive

    ! And remove from the ialive array
    !*********************************
    ! iloc=findloc(count%ialive,ipart,1) ! findloc not supported in gcc<v9
    iloc=count%allocated
    do i=1,count%alive+2
      if (count%ialive(i).eq.ipart) then
        iloc=i
        exit
      endif
    end do
    if (iloc.ne.count%allocated) then
!$OMP PARALLEL
!$OMP WORKSHARE
      count%ialive(iloc:count%allocated-1)=count%ialive(iloc+1:count%allocated)
!$OMP END WORKSHARE
!$OMP END PARALLEL
    endif
  end subroutine rewrite_ialive_single
 
  subroutine alloc_particles(nmpart)

    implicit none 

    integer, intent(in)        :: nmpart
    type(particle),allocatable :: tmppart(:)
    logical, allocatable       :: tmpcount(:)
    real, allocatable          :: tmpxscav(:,:),tmpval_av(:,:),tmpmass(:,:),tmpdepo(:,:)
    real, allocatable          :: tmpxl(:),tmpyl(:),tmpzl(:)
    integer, allocatable       :: tmpnclust(:)
    integer                    :: i,stat

    if (nmpart.gt.100) &
      write(*,*) 'Allocating ',nmpart,' particles', count%allocated, count%terminated, count%spawned

    ! Keeping track of the allocated memory in case 
    ! there is a reason for deallocating some of it
    !**********************************************
    allocate( tmpcount(count%allocated+nmpart),stat=stat)
    if (stat.ne.0) error stop "Could not allocate tmpcount"
    if (count%allocated.gt.0) tmpcount(1:count%allocated) = count%inmem
    call move_alloc(tmpcount,count%inmem)
    allocate( tmpnclust(count%allocated+nmpart),stat=stat)
    if (stat.ne.0) error stop "Could not allocate tmpnclust"
    if (count%allocated.gt.0) tmpnclust(1:count%allocated) = count%ialive
    call move_alloc(tmpnclust,count%ialive)

    if (ipin.le.1 .and. ipout.eq.0) then
      allocate( tmpnclust(count%allocated+nmpart),stat=stat)
      if (stat.ne.0) error stop "Could not allocate tmpnclust"
      if (count%allocated.gt.0) tmpnclust(1:count%allocated) = count%iterm
      call move_alloc(tmpnclust,count%iterm)
    endif 

    count%inmem(count%allocated+1:count%allocated+nmpart) = .true.

    ! Allocating new particle spaces
    !*******************************
    allocate( tmppart(count%allocated+nmpart),stat=stat)
    if (stat.ne.0) error stop "Could not allocate tmppart"

    do i=1,count%allocated+nmpart
      ! allocate( tmppart(i)%mass(maxspec),tmppart(i)%mass_init(maxspec),stat=stat)
      ! if (stat.ne.0) error stop "Could not allocate tmppart"
      ! if (DRYDEP) then
      !   allocate( tmppart(i)%drydepo(maxspec),tmppart(i)%prob(maxspec),stat=stat)
      !   if (stat.ne.0) error stop "Could not allocate tmppart"
      !   tmppart(i)%drydepo(maxspec)=0.
      ! endif
      ! if (WETDEP) then 
      !   allocate( tmppart(i)%wetdepo(maxspec),stat=stat)
      !   if (stat.ne.0) error stop "Could not allocate tmppart"
      !   tmppart(i)%wetdepo(maxspec)=0.
      ! endif
      tmppart(i)%ntime=0 ! Preventing particles to be written to partoutput when they just spawned
    end do
    if (count%allocated.gt.0) tmppart(1:count%allocated) = part
    call move_alloc(tmppart,part)

    allocate( tmpmass(count%allocated+nmpart,maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate tmpmass"
    if (count%allocated.gt.0) tmpmass(1:count%allocated,:) = mass
    call move_alloc(tmpmass,mass)

    allocate( tmpmass(count%allocated+nmpart,maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate tmpmass_init"
    if (count%allocated.gt.0) tmpmass(1:count%allocated,:) = mass_init
    call move_alloc(tmpmass,mass_init)

    if (DRYDEP) then
      allocate( tmpdepo(count%allocated+nmpart,maxspec),stat=stat)
      if (stat.ne.0) error stop "Could not allocate drydeposit"
      if (count%allocated.gt.0) tmpdepo(1:count%allocated,:) = drydeposit
      call move_alloc(tmpdepo,drydeposit)
      drydeposit(count%allocated+1:count%allocated+nmpart,:)=0.

      allocate( tmpdepo(count%allocated+nmpart,maxspec),stat=stat)
      if (stat.ne.0) error stop "Could not allocate prob"
      if (count%allocated.gt.0) tmpdepo(1:count%allocated,:) = prob
      call move_alloc(tmpdepo,prob)
      prob(count%allocated+1:count%allocated+nmpart,:)=0.
    endif
    if (WETDEP) then 
      allocate( tmpdepo(count%allocated+nmpart,maxspec),stat=stat)
      if (stat.ne.0) error stop "Could not allocate wetdeposit"
      if (count%allocated.gt.0) tmpdepo(1:count%allocated,:) = wetdeposit
      call move_alloc(tmpdepo,wetdeposit)
      wetdeposit(count%allocated+1:count%allocated+nmpart,:)=0.
    endif

    ! If wet or dry deposition backward mode is switched on, xscav_frac1
    ! needs to be allocated
    !*******************************************************************
    if (WETBKDEP.or.DRYBKDEP) then
      allocate( tmpxscav(count%allocated+nmpart,maxspec),stat=stat)
      if (stat.ne.0) error stop "Could not allocate tmpxscav"
      if (count%allocated.gt.0) tmpxscav(1:count%allocated,:) = xscav_frac1
      call move_alloc(tmpxscav,xscav_frac1)
      ! Initialise it here
      xscav_frac1(count%allocated+1:count%allocated+nmpart,:) = -1.
    endif

    if (n_average.gt.0) then 
      allocate( tmpval_av(count%allocated+nmpart,n_average),stat=stat)
      if (stat.ne.0) error stop "Could not allocate val_av"
      if (count%allocated.gt.0) tmpval_av(1:count%allocated,:) = val_av
      tmpval_av(count%allocated+1:count%allocated+nmpart,:) = 0
      call move_alloc(tmpval_av, val_av)
    endif

    if ((iout.eq.4).or.(iout.eq.5)) then
      allocate( tmpxl(count%allocated+nmpart),stat=stat)
      if (stat.ne.0) error stop "Could not allocate tmpxl"
      if (count%allocated.gt.0) tmpxl(1:count%allocated) = xplum
      call move_alloc(tmpxl,xplum)
      
      allocate( tmpyl(count%allocated+nmpart),stat=stat)
      if (stat.ne.0) error stop "Could not allocate tmpyl"
      if (count%allocated.gt.0) tmpyl(1:count%allocated) = yplum
      call move_alloc(tmpyl,yplum)

      allocate( tmpzl(count%allocated+nmpart),stat=stat)
      if (stat.ne.0) error stop "Could not allocate tmpzl"
      if (count%allocated.gt.0) tmpzl(1:count%allocated) = zplum
      call move_alloc(tmpzl,zplum)

      allocate( tmpnclust(count%allocated+nmpart),stat=stat)
      if (stat.ne.0) error stop "Could not allocate tmpnclust"
      if (count%allocated.gt.0) tmpnclust(1:count%allocated) = nclust
      call move_alloc(tmpnclust,nclust)
    endif

    count%allocated = count%allocated+nmpart
    if (nmpart.gt.100) write(*,*) 'Finished allocation'
  end subroutine alloc_particles

  subroutine alloc_particle(ipart)

    implicit none 

    integer, intent(in) :: ipart

    ! Keeping track of the allocated memory in case 
    ! there is a reason for deallocating some of it
    !**********************************************
    if (ipart.gt.count%allocated) then 
      call alloc_particles(ipart-count%allocated)
    else
      error stop 'Error: You are trying to allocate an already existing particle'
    endif

  end subroutine alloc_particle

  subroutine dealloc_particle_range(istart,iend)

    implicit none

    integer, intent(in) :: istart,iend

    !deallocate( part(istart:iend) )
    count%inmem(istart:iend) = .false.
  end subroutine dealloc_particle_range

  subroutine dealloc_particle(ipart)

    implicit none

    integer, intent(in) :: ipart ! particle index

    !deallocate( part(ipart) )
    part = part(1:ipart) ! FORTRAN 2008 only
    count%inmem(ipart+1:) = .false.
  end subroutine dealloc_particle

  subroutine dealloc_all_particles()

    implicit none

    integer :: i

    if (n_average.gt.0) deallocate( val_av )
    deallocate( part )
    deallocate( count%inmem )
    deallocate( count%ialive )
    if (ipin.le.1 .and. ipout.eq.0) deallocate( count%iterm )
    deallocate( mass, mass_init )

    if (WETBKDEP.or.DRYBKDEP) then
      deallocate( xscav_frac1 )
    endif

    if (WETDEP) deallocate( wetdeposit )
    if (DRYDEP) deallocate( drydeposit,prob )

    if ((iout.eq.4).or.(iout.eq.5)) then
      deallocate( xplum )
      deallocate( yplum )
      deallocate( zplum )
      deallocate( nclust )
    endif
  end subroutine dealloc_all_particles

! Update_xlon
  subroutine update_xlon_dp(ipart,xchange)
    !**************************************
    ! Updates the longitude of the particle
    !**************************************
    implicit none

    integer, intent(in)       :: ipart   ! particle index
    real(kind=dp), intent(in) :: xchange

    part(ipart)%xlon = part(ipart)%xlon + xchange
  end subroutine update_xlon_dp

  subroutine update_xlon_sp(ipart,xchange)
    !**************************************
    ! Updates the longitude of the particle
    !**************************************
    implicit none

    integer, intent(in) :: ipart    ! particle index
    real, intent(in)    :: xchange

    part(ipart)%xlon = part(ipart)%xlon + real(xchange,kind=dp)
  end subroutine update_xlon_sp

  subroutine update_xlon_int(ipart,xchange)
    !**************************************
    ! Updates the longitude of the particle
    !**************************************
    implicit none

    integer, intent(in) :: ipart  ! particle index
    integer, intent(in) :: xchange

    part(ipart)%xlon = part(ipart)%xlon + real(xchange,kind=dp)
  end subroutine update_xlon_int
! End Update_xlon

! Set_xlon
  subroutine set_xlon_dp(ipart,xvalue)
    !**************************************
    ! Sets the longitude of the particle
    !**************************************
    implicit none

    integer, intent(in)       :: ipart  ! particle index
    real(kind=dp), intent(in) :: xvalue

    part(ipart)%xlon = xvalue
  end subroutine set_xlon_dp

  subroutine set_xlon_sp(ipart,xvalue)
    !**************************************
    ! Sets the longitude of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart   ! particle index
    real, intent(in)       :: xvalue

    part(ipart)%xlon = real(xvalue,kind=dp)
  end subroutine set_xlon_sp

  subroutine set_xlon_int(ipart,xvalue)
    !**************************************
    ! Sets the longitude of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    integer, intent(in)    :: xvalue

    part(ipart)%xlon = real(xvalue,kind=dp)
  end subroutine set_xlon_int
! End Set_xlon 

! Update_ylat
  subroutine update_ylat_dp(ipart,ychange)
    !**************************************
    ! Updates the latitude of the particle
    !**************************************
    implicit none

    integer, intent(in)       :: ipart  ! particle index
    real(kind=dp), intent(in) :: ychange

    part(ipart)%ylat = part(ipart)%ylat + ychange
  end subroutine update_ylat_dp

  subroutine update_ylat_sp(ipart,ychange)
    !**************************************
    ! Updates the latitude of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    real, intent(in)       :: ychange

    part(ipart)%ylat = part(ipart)%ylat + real(ychange,kind=dp)
  end subroutine update_ylat_sp

  subroutine update_ylat_int(ipart,ychange)
    !**************************************
    ! Updates the latitude of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart ! particle index
    integer, intent(in)    :: ychange

    part(ipart)%ylat = part(ipart)%ylat + real(ychange,kind=dp)
  end subroutine update_ylat_int
! End Update_ylat

! Set_ylat
  subroutine set_ylat_dp(ipart,yvalue)
    !**************************************
    ! Sets the latitude of the particle
    !**************************************
    implicit none

    integer, intent(in)       :: ipart  ! particle index
    real(kind=dp), intent(in) :: yvalue

    part(ipart)%ylat = yvalue
  end subroutine set_ylat_dp

  subroutine set_ylat_sp(ipart,yvalue)
    !**************************************
    ! Sets the latitude of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    real, intent(in)       :: yvalue

    part(ipart)%ylat = real(yvalue,kind=dp)
  end subroutine set_ylat_sp

  subroutine set_ylat_int(ipart,yvalue)
    !**************************************
    ! Sets the latitude of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    integer, intent(in) :: yvalue

    part(ipart)%ylat = real(yvalue,kind=dp)
  end subroutine set_ylat_int
! End Set_ylat

! Update z positions
  subroutine update_z_dp(ipart,zchange)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)        :: ipart  ! particle index
    real(kind=dp), intent(in)  :: zchange

    part(ipart)%z = part(ipart)%z + zchange
#ifdef ETA
    part(ipart)%meterupdate=.false.
    part(ipart)%etaupdate=.true.
#endif
  end subroutine update_z_dp

  subroutine update_z_sp(ipart,zchange)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    real, intent(in)       :: zchange

    part(ipart)%z = part(ipart)%z + real(zchange,kind=dp)
#ifdef ETA
    part(ipart)%meterupdate=.false.
    part(ipart)%etaupdate=.true.
#endif
  end subroutine update_z_sp  

#ifdef ETA
  subroutine update_zeta_dp(ipart,zchange)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)        :: ipart  ! particle index
    real(kind=dp), intent(in)  :: zchange

    part(ipart)%zeta = part(ipart)%zeta + zchange
    part(ipart)%etaupdate=.false.
    part(ipart)%meterupdate=.true.
  end subroutine update_zeta_dp

  subroutine update_zeta_sp(ipart,zchange)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    real, intent(in)       :: zchange

    part(ipart)%zeta = part(ipart)%zeta + real(zchange,kind=dp)
    part(ipart)%etaupdate=.false.
    part(ipart)%meterupdate=.true.
  end subroutine update_zeta_sp
#endif
! End update z positions

! Update z positions
  subroutine set_z_dp(ipart,zvalue)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)        :: ipart  ! particle index
    real(kind=dp), intent(in)  :: zvalue

    part(ipart)%z = zvalue
#ifdef ETA
    part(ipart)%meterupdate=.false.
    part(ipart)%etaupdate=.true.
#endif
  end subroutine set_z_dp  

  subroutine set_z_sp(ipart,zvalue)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    real, intent(in)       :: zvalue

    part(ipart)%z = real(zvalue,kind=dp)
#ifdef ETA
    part(ipart)%meterupdate=.false.
    part(ipart)%etaupdate=.true.
#endif
  end subroutine set_z_sp

#ifdef ETA
  subroutine set_zeta_dp(ipart,zvalue)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)        :: ipart  ! particle index
    real(kind=dp), intent(in)  :: zvalue

    part(ipart)%zeta = zvalue
    part(ipart)%etaupdate=.false.
    part(ipart)%meterupdate=.true.
  end subroutine set_zeta_dp

  subroutine set_zeta_sp(ipart,zvalue)
    !**************************************
    ! Updates the height of the particle
    !**************************************
    implicit none

    integer, intent(in)    :: ipart  ! particle index
    real, intent(in)       :: zvalue

    part(ipart)%zeta = real(zvalue,kind=dp)
    part(ipart)%etaupdate=.false.
    part(ipart)%meterupdate=.true.
  end subroutine set_zeta_sp
#endif
! End update z positions

end module particle_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

!  Taken from Press et al., Numerical Recipes

function ran1(idum)

  implicit none

  integer :: idum
  real    :: ran1
  integer,parameter :: ia=16807, im=2147483647, iq=127773, ir=2836
  integer,parameter :: ntab=32, ndiv=1+(im-1)/ntab
  real,parameter    :: am=1./im, eps=1.2e-7, rnmx=1.-eps
  integer :: j, k
  integer :: iv(ntab) = (/ (0,j=1,ntab) /)
  integer :: iy=0

  if (idum.le.0.or.iy.eq.0) then
    idum=max(-idum,1)
    do j=ntab+8,1,-1
      k=idum/iq
      idum=ia*(idum-k*iq)-ir*k
      if (idum.lt.0) idum=idum+im
      if (j.le.ntab) iv(j)=idum
    enddo
    iy=iv(1)
  endif
  k=idum/iq
  idum=ia*(idum-k*iq)-ir*k
  if (idum.lt.0) idum=idum+im
  j=1+iy/ndiv
  iy=iv(j)
  iv(j)=idum
  ran1=min(am*iy,rnmx)
end function ran1


function gasdev(idum)

  implicit none

  integer :: idum
  real    :: gasdev, fac, r, v1, v2
  integer :: iset = 0
  real    :: gset = 0.
  real, external :: ran3

  if (iset.eq.0) then
1   v1=2.*ran3(idum)-1.
    v2=2.*ran3(idum)-1.
    r=v1**2+v2**2
    if(r.ge.1.0 .or. r.eq.0.0) go to 1
    fac=sqrt(-2.*log(r)/r)
    gset=v1*fac
    gasdev=v2*fac
    iset=1
  else
    gasdev=gset
    iset=0
  endif
end function gasdev


subroutine gasdev1(idum,random1,random2)

  implicit none

  integer :: idum
  real :: random1, random2, fac, v1, v2, r
  real, external :: ran3

1   v1=2.*ran3(idum)-1.
  v2=2.*ran3(idum)-1.
  r=v1**2+v2**2
  if(r.ge.1.0 .or. r.eq.0.0) go to 1
  fac=sqrt(-2.*log(r)/r)
  random1=v1*fac
  random2=v2*fac
  ! Limit the random numbers to lie within the interval -3 and +3
  !**************************************************************
  if (random1.lt.-3.) random1=-3.
  if (random2.lt.-3.) random2=-3.
  if (random1.gt.3.) random1=3.
  if (random2.gt.3.) random2=3.
end subroutine gasdev1


function ran3(idum)

  implicit none

  integer :: idum
  real :: ran3

  integer,parameter :: mbig=1000000000, mseed=161803398, mz=0
  real,parameter    :: fac=1./mbig
  integer :: i,ii,inext,inextp,k
  integer :: mj,mk,ma(55)

  save inext,inextp,ma
  integer :: iff = 0

  if(idum.lt.0.or.iff.eq.0)then
    iff=1
    mj=mseed-iabs(idum)
    mj=mod(mj,mbig)
    ma(55)=mj
    mk=1
    do i=1,54
      ii=mod(21*i,55)
      ma(ii)=mk
      mk=mj-mk
      if(mk.lt.mz)mk=mk+mbig
      mj=ma(ii)
    end do
    do k=1,4
      do i=1,55
        ma(i)=ma(i)-ma(1+mod(i+30,55))
        if(ma(i).lt.mz)ma(i)=ma(i)+mbig
      end do
    end do
    inext=0
    inextp=31
    idum=1
  endif
  inext=inext+1
  if(inext.eq.56)inext=1
  inextp=inextp+1
  if(inextp.eq.56)inextp=1
  mj=ma(inext)-ma(inextp)
  if(mj.lt.mz)mj=mj+mbig
  ma(inext)=mj
  ran3=mj*fac
end function ran3
!  (C) Copr. 1986-92 Numerical Recipes Software US.

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module initdomain_mod

  !*****************************************************************************
  !                                                                            *
  !    This module contains variables and subroutines for initializing         *
  !    particles and their mass for global domain-filling runs                 *
  !                                                                            *
  !*****************************************************************************

  use netcdf
  use par_mod
  use com_mod

  implicit none

  integer, allocatable, dimension(:)    :: specnini ! spec number in initial fields info
  integer, allocatable, dimension(:)    :: nxini    ! number grid cells longitude
  integer, allocatable, dimension(:)    :: nyini    ! number grid cells latitude
  integer, allocatable, dimension(:)    :: nzini    ! number grid cell vertical
  real, allocatable, dimension(:,:)     :: lonini   ! longitudes of initial fields 
  real, allocatable, dimension(:,:)     :: latini   ! latitudes of initial fields
  real, allocatable, dimension(:)       :: dxini, dyini ! longitude, latitude resolution of initial fields
  real, allocatable, dimension(:,:)     :: altini   ! altitudes of initial fields
  real, allocatable, dimension(:,:,:,:) :: prsini   ! pressure of initial fields
  real, allocatable, dimension(:,:,:,:) :: gridini  ! initial mixing ratios (dry air, ppbv)

  contains

  subroutine readgridini(ks, lexist)

  !******************************************************************************
  !                                                                             *
  !      Reads mixing ratios from a netcdf file with general format             *
  !                                                                             *
  !      Author: Rona Thompson, Sep-2023                                        *
  !                                                                             *
  !******************************************************************************
  !                                                                             *
  ! Variables:                                                                  *
  ! ks                 relative number of species                               *
  ! lexist             logical to indicate if INITCONC file specified           *
  !                                                                             *
  !******************************************************************************

    use date_mod
    use windfields_mod, only: nxmax,nymax,nzmax
    use netcdf_output_mod, only: nf90_err

    implicit none

    integer :: ks
    logical :: lexist
    integer :: ninit
    integer, dimension(:), allocatable :: specnum_rel
    character(len=256) :: path_name, file_name, unitinfo, strtmp1, strtmp2, nameout
    character(len=10)  :: var_name, hya_name, hyb_name, ps_name, prs_name, q_name, alt_name
    real :: coeff
    integer :: readerror
    integer :: ncid, dimid, varid, ndim, nvar, natt, unlimid, ndims, xtype, natts, len
    integer :: yyyymmdd, hhmiss, yyyy, mm
    integer, dimension(:), allocatable :: dimids
    character(len=256) :: dimname, attname
    character(len=2)  :: amonth
    character(len=4)  :: ayear
    integer :: nn, indxn, ntini, indxt, ix, jy, kz
    real, dimension(:), allocatable :: time, hya, hyb
    real, dimension(:,:), allocatable :: psurf
    real, dimension(:,:,:), allocatable :: shumid, pw
    real(kind=dp) :: julstart
    real(kind=dp), dimension(:), allocatable :: jdate
    real :: sclfact, offset
    logical :: lfexist
    integer,parameter :: unitinitconc=103, unitinitconcout=104

    ! declare namelists
    namelist /initconc_ctrl/ &
         ninit, &
         specnum_rel

    namelist /initconc/ &
         path_name, file_name, var_name, &
         hya_name, hyb_name, &
         ps_name, q_name, &
         prs_name, alt_name, &
         coeff

    ! Read initconc input info
    ! ************************

    allocate(specnum_rel(maxspec))

    ! presetting namelist initconc_ctrl
    ninit = -1  ! use negative value to determine failed namelist input
    specnum_rel(:) = 0

    ! read initconc_ctrl to find how many fields are specified 
    open(unitinitconc,file=path(1)(1:length(1))//'INITCONC',status='old',form='formatted',iostat=readerror)
    if (readerror.ne.0) then
      write(*,*) 'WARNING: cannot open file INITCONC'
      write(*,*) 'Trying to initialize using latitude profiles'
      lexist=.false.
      return
    endif

    ! check if namelist input provided
    read(unitinitconc,initconc_ctrl,iostat=readerror)
    if (readerror.ne.0 ) then
      write(*,*) 'ERROR in readgridini: cannot read INITCONC namelist'
      error stop
    endif
    write(*,*) 'ninit, specnum = ',ninit, specnum_rel

    ! namelist output
    if (nmlout.and.lroot) then
      inquire(file=path(2)(1:length(2))//'INITCONC.namelist',exist=lfexist)
      if (lfexist) then
        open(unitinitconcout,file=path(2)(1:length(2))//'INITCONC.namelist',status='old',&
              access='append',iostat=readerror)
      else
        open(unitinitconcout,file=path(2)(1:length(2))//'INITCONC.namelist',status='new',&
              iostat=readerror)
      endif
      if (readerror.ne.0) then
        write(*,*) 'ERROR in readgridini: file INITCONC cannot be opened'
        write(*,*) 'in the directory',path(2)(1:length(2))
        error stop
      endif
      if (.not.lfexist) then
        ! write this only once
        write(unitinitconcout,nml=initconc_ctrl)
      endif
    endif

    ! allocate variables used for initial mixing ratios
    if (.not.allocated(gridini)) then
      allocate( nxini(ninit), nyini(ninit), nzini(ninit) )
      allocate( dxini(ninit), dyini(ninit) )
      allocate( lonini(nxmax,ninit), latini(nymax,ninit), altini(nzmax,ninit) )
      allocate( prsini(nxmax,nymax,nzmax,ninit), gridini(nxmax,nymax,nzmax,ninit) )
      allocate( specnini(ninit) )
      nxini(:)=0
      nyini(:)=0
      nzini(:)=0
      lonini(:,:)=0.
      latini(:,:)=0.
      altini(:,:)=0.
      prsini(:,:,:,:)=0.
      gridini(:,:,:,:)=0.
      specnini(:)=specnum_rel(1:ninit)
    endif

    ! presetting namelist initconc
    path_name=""
    file_name=""
    var_name=""
    hya_name=""
    hyb_name=""
    ps_name=""
    q_name=""
    prs_name=""
    alt_name=""
    coeff=-1.

    ! read initconc file info
    do nn=1,ninit
      read(unitinitconc,initconc,iostat=readerror)
      if (readerror.ne.0) then
        write(*,*) 'ERROR in readgridini: cannot read file info for ',specnum_rel(nn)
        error stop
      endif
      if (specnum_rel(nn).eq.specnum(ks)) then
        indxn=nn ! index to gridini for this species
        exit
      endif
    end do

    ! namelist output
    if (nmlout.and.lroot) then
      write(unitinitconcout,nml=initconc)
    endif

    write(*,*) 'readgridini: path, filename, varname = ',path_name,file_name,var_name
    write(*,*) 'readgridini: specnum_rel(indxn), specnum(ks), indxn = ',specnum_rel(indxn), specnum(ks), indxn

    close(unitinitconc)
    close(unitinitconcout)

    ! get file name for current year and month
    call caldate(bdate,yyyymmdd,hhmiss)
    yyyy=yyyymmdd/10000
    mm=(yyyymmdd-(yyyymmdd/10000)*10000)/100
    write(ayear,'(I4)') yyyy
    write(amonth,'(I2.2)') mm
    nn=index(file_name,'YYYY',back=.false.)
    if (nn.ne.0) then
      strtmp1=file_name(1:nn-1)
      nn=index(file_name,'YYYY',back=.true.)
      strtmp2=file_name(nn+4:len_trim(file_name))
      file_name=trim(strtmp1)//ayear//trim(strtmp2)
      julstart=juldate((yyyymmdd/10000)*10000+101,0)
    endif
    nn=index(file_name,'MM',back=.false.)
    if (nn.ne.0) then
      strtmp1=file_name(1:nn-1)
      nn=index(file_name,'MM',back=.true.)
      strtmp2=file_name(nn+2:len_trim(file_name))
      file_name=trim(strtmp1)//amonth//trim(strtmp2)
      julstart=juldate((yyyymmdd/100)*100+1,0)
    endif
    write(*,*) 'readgridini: julstart = ',julstart
    write(*,*) 'readgridini: initial mixing ratio file to read: '//trim(path_name)//trim(file_name)

    ! check file exists
    inquire(file=trim(path_name)//trim(file_name), exist=lexist)
    if (.not.lexist) then
      write(*,*) 'ERROR readgridini: file not found: '//trim(path_name)//trim(file_name)
      error stop
    endif

    ! Read netcdf file
    !******************

    ! open file
    call nf90_err( nf90_open( trim(path_name)//trim(file_name), nf90_nowrite, ncid ) )

    ! inquire about dims and vars
    call nf90_err( nf90_inquire( ncid, ndim, nvar, natt, unlimid ) )
    write(*,*) 'ndim, nvar:', ndim, nvar
    allocate(dimids(ndim))

    ! read dimension info
    !********************
    do nn=1,ndim
      call nf90_err( nf90_inquire_dimension( ncid, nn, dimname, len ) )
      if ((index(dimname,'lon').ne.0).or.(index(dimname,'LON').ne.0) &
            .or.(index(dimname,'Lon').ne.0)) then
        if (len.gt.nxmax) then
          write(*,*) 'ERROR in readgridini: length longitude exceeds nxmax'
          error stop
        endif
        nxini(indxn)=len
        call nf90_err( nf90_inq_varid(ncid,trim(dimname),varid) )
        call nf90_err( nf90_get_var(ncid,varid,lonini(1:nxini(indxn),indxn)) )
        dxini(indxn)=abs(lonini(2,indxn)-lonini(1,indxn))
      else if ((index(dimname,'lat').ne.0).or.(index(dimname,'LAT').ne.0) &
            .or.(index(dimname,'Lat').ne.0)) then
        if (len.gt.nymax) then
          write(*,*) 'ERROR in readgridini: length latitude exceeds nymax'
          error stop
        endif
        nyini(indxn)=len
        call nf90_err( nf90_inq_varid(ncid,trim(dimname),varid) )
        call nf90_err( nf90_get_var(ncid,varid,latini(1:nyini(indxn),indxn)) )
        dyini(indxn)=abs(latini(2,indxn)-latini(1,indxn))
      else if (((index(dimname,'lev').ne.0).or.(index(dimname,'LEV').ne.0) &
            .or.(index(dimname,'Lev').ne.0)).and.(index(dimname,'hlevel').eq.0)) then
        if (len.gt.nzmax) then
          write(*,*) 'ERROR in readgridini: length vertical coord exceeds nzmax'
          error stop
        endif
        nzini(indxn)=len
      else if ((index(dimname,'time').ne.0).or.(index(dimname,'Time').ne.0) &
            .or.(index(dimname,'Date').ne.0).or.(index(dimname,'date').ne.0)) then
        ntini=len
        allocate( time(ntini), jdate(ntini) )
        call nf90_err( nf90_inq_varid(ncid,trim(dimname),varid) )
        call nf90_err( nf90_get_var(ncid,varid,time) )
        call nf90_err( nf90_get_att(ncid,varid,'units',unitinfo) )
        write(*,*) 'Time units: ',trim(unitinfo)
        if (index(unitinfo,'sec').ne.0) then
          jdate=real(time-time(1),kind=dp)/3600._dp/24._dp+julstart
          indxt=minloc(abs(jdate-bdate),dim=1)
        else if (index(unitinfo,'hour').ne.0) then
          jdate=real(time-time(1),kind=dp)/24._dp+julstart
          indxt=minloc(abs(jdate-bdate),dim=1)
        else if (index(unitinfo,'day').ne.0) then
          jdate=real(time-time(1),kind=dp)+julstart
          indxt=minloc(abs(jdate-bdate),dim=1)
        else if (index(unitinfo,'month').ne.0) then
          indxt=minloc(abs(time-mm),dim=1)
        else
          write(*,*) 'ERROR in readgridini: unknown time units in file: '//trim(path_name)//trim(file_name)
          error stop
        endif
        write(*,*) 'readgridini: time index in file = ',indxt
        deallocate( time, jdate )
      endif
    enddo

    if ((nxini(indxn).eq.0).or.(nyini(indxn).eq.0)) then
      write(*,*) 'ERROR in reagridini: unable to find lat and lon dimensions in file: '//trim(path_name)//trim(file_name)
      error stop
    endif
    write(*,*) 'readgridini: nxini(indxn), nyini(indxn), nzini(indxn) = ',nxini(indxn), nyini(indxn), nzini(indxn)
    write(*,*) 'readgridini: lonini(1:nxini(indxn),indxn) = ',lonini(1:nxini(indxn),indxn)
    write(*,*) 'readgridini: latini(1:nyini(indxn),indxn) = ',latini(1:nyini(indxn),indxn)

    ! read vertical coordinates
    !**************************
    if ((alt_name.eq."").and.(prs_name.eq."")) then
      ! hybrid pressure coordinates
      write(*,*) 'readgridini: reading hybrid pressure coordinates'
      if ((hya_name.eq."").or.(hyb_name.eq."").or.(ps_name.eq."")) then
        write(*,*) 'ERROR in readgridini: hybrid pressure coordinates and/or surface pressure missing'
        error stop
      endif
      ! read hybrid pressure coordinates
      allocate( hya(nzini(indxn)), hyb(nzini(indxn)), psurf(nxini(indxn),nyini(indxn)) )
      call nf90_err( nf90_inq_varid(ncid,trim(hya_name),varid) )
      call nf90_err( nf90_get_var(ncid,varid,hya) )
      call nf90_err( nf90_inq_varid(ncid,trim(hyb_name),varid) )
      call nf90_err( nf90_get_var(ncid,varid,hyb) )
      write(*,*) 'read hybrid pressure coords'
      ! read surface pressure
      call nf90_err( nf90_inq_varid(ncid,trim(ps_name),varid) )
      call nf90_err( nf90_inquire_variable(ncid,varid,nameout,xtype,ndims,dimids,natts) )
      write(*,*) 'psurf: ndims, natts = ',ndims, natts
      sclfact=0.
      offset=0.
      if (natts.gt.0 ) then
        do nn=1,natts
          call nf90_err( nf90_inq_attname(ncid,varid,nn,attname) )
          if (index(attname,'add_offset').ne.0) then
            call nf90_err( nf90_get_att(ncid,varid,'add_offset',offset) )
          else if (index(attname,'scale_factor').ne.0) then
            call nf90_err( nf90_get_att(ncid,varid,'scale_factor',sclfact) )
          endif
        end do
      endif
      write(*,*) 'psurf: sclfact, offset = ',sclfact, offset
      if (ndims.eq.2) then
        call nf90_err( nf90_get_var(ncid,varid,psurf,start=(/1,1/),count=(/nxini(indxn),nyini(indxn)/)) )
      else if (ndims.eq.3) then
        ! read from first time step (assume this is good enough)
        call nf90_err( nf90_get_var(ncid,varid,psurf,start=(/1,1,1/),count=(/nxini(indxn),nyini(indxn),1/)) )
      endif
      if ((sclfact.ne.0).and.(offset.ne.0)) then
        psurf=psurf*sclfact+offset
      endif
      ! calculate pressure
      do kz=1,nzini(indxn)
        prsini(1:nxini(indxn),1:nyini(indxn),kz,indxn)=hya(kz)+hyb(kz)*psurf(:,:)
      end do
      deallocate( psurf, hya, hyb )
    else if (alt_name.ne."") then
      ! height coordinates (assume metres above ground)
      call nf90_err( nf90_inq_varid(ncid,trim(alt_name),varid) )
      call nf90_err( nf90_get_var(ncid,varid,altini(1:nzini(indxn),indxn)) )
    else if (prs_name.ne."") then
      ! pressure coordinates
      call nf90_err( nf90_inq_varid(ncid,trim(prs_name),varid) )
      call nf90_err( nf90_get_var(ncid,varid,prsini(1,1,1:nzini(indxn),indxn)) )
      do jy=1,nyini(indxn)
        do ix=1,nxini(indxn)
          prsini(ix,jy,:,indxn)=prsini(1,1,:,indxn)
        end do
      end do
    endif

    ! read mixing ratio variables
    !****************************
    if (var_name.eq."") then
      write(*,*) 'ERROR in readgridini: mixing ratios missing in file'//trim(path_name)//trim(file_name)
      error stop
    endif
    call nf90_err( nf90_inq_varid(ncid,trim(var_name),varid) )
    call nf90_err( nf90_inquire_variable(ncid,varid,nameout,xtype,ndims,dimids,natts) )
    write(*,*) 'conc: ndims, natts, dimids = ',ndims, natts, dimids
    sclfact=0.
    offset=0.
    if (natts.gt.0 ) then
      do nn=1,natts
        call nf90_err( nf90_inq_attname(ncid,varid,nn,attname) )
        if (index(attname,'add_offset').ne.0) then
          call nf90_err( nf90_get_att(ncid,varid,'add_offset',offset) )
        else if (index(attname,'scale_factor').ne.0) then
          call nf90_err( nf90_get_att(ncid,varid,'scale_factor',sclfact) )
        endif
      end do
    endif
    write(*,*) 'conc: sclfact, offset = ',sclfact, offset
    if (ndims.eq.3) then
      call nf90_err( nf90_get_var(ncid,varid,gridini(1:nxini(indxn),1:nyini(indxn),1:nzini(indxn),indxn), &
                         start=(/1,1,1/),count=(/nxini(indxn),nyini(indxn),nzini(indxn)/)) )
    else if (ndims.eq.4) then
      call nf90_err( nf90_get_var(ncid,varid,gridini(1:nxini(indxn),1:nyini(indxn),1:nzini(indxn),indxn), &
                         start=(/1,1,1,indxt/),count=(/nxini(indxn),nyini(indxn),nzini(indxn),1/)) )
    endif
    if ((sclfact.ne.0).and.(offset.ne.0)) then
      gridini(:,:,:,indxn)=gridini(:,:,:,indxn)*sclfact+offset
    endif

    ! other variables
    !****************
    if (q_name.ne."") then
      ! read specific humidity
      allocate( shumid(nxini(indxn),nyini(indxn),nzini(indxn)), pw(nxini(indxn),nyini(indxn),nzini(indxn)) )
      call nf90_err( nf90_inq_varid(ncid,trim(q_name),varid) )
      call nf90_err( nf90_inquire_variable(ncid,varid,nameout,xtype,ndims,dimids,natts) )
      sclfact=0.
      offset=0.
      if (natts.gt.0 ) then
        do nn=1,natts
          call nf90_err( nf90_inq_attname(ncid,varid,nn,attname) )
          if (index(attname,'add_offset').ne.0) then
            call nf90_err( nf90_get_att(ncid,varid,'add_offset',offset) )
          else if (index(attname,'scale_factor').ne.0) then
            call nf90_err( nf90_get_att(ncid,varid,'scale_factor',sclfact) )
          endif
        end do
      endif
      if (ndims.eq.3) then
        call nf90_err( nf90_get_var(ncid,varid,shumid(:,:,:), &
                           start=(/1,1,1/),count=(/nxini(indxn),nyini(indxn),nzini(indxn)/)) )
      else if (ndims.eq.4) then
        call nf90_err( nf90_get_var(ncid,varid,shumid(:,:,:), &
                           start=(/1,1,1,indxt/),count=(/nxini(indxn),nyini(indxn),nzini(indxn),1/)) )
      endif
      write(*,*) 'conc: sclfact, offset = ',sclfact, offset
      if ((sclfact.ne.0).and.(offset.ne.0)) then
        shumid=shumid*sclfact+offset
      endif
      ! partial pressure of water from specific humidity
      pw = shumid*prsini(1:nxini(indxn),1:nyini(indxn),1:nzini(indxn),indxn)/(0.622 + 0.378*shumid)
      ! correct mixing ratio to dry air (needed in init_domainfill)
      gridini(1:nxini(indxn),1:nyini(indxn),1:nzini(indxn),indxn)= &
                   gridini(1:nxini(indxn),1:nyini(indxn),1:nzini(indxn),indxn)* &
                   prsini(1:nxini(indxn),1:nyini(indxn),1:nzini(indxn),indxn)/ &
                   (prsini(1:nxini(indxn),1:nyini(indxn),1:nzini(indxn),indxn) - pw)
      deallocate( shumid, pw )
    endif

    ! convert units to ppbv
    !**********************
    if (coeff.gt.0) gridini(:,:,:,indxn)=gridini(:,:,:,indxn)*coeff
    write(*,*) 'range(gridini) = ',minval(gridini(1:nxini(indxn),1:nyini(indxn),1,indxn)),&
                    maxval(gridini(1:nxini(indxn),1:nyini(indxn),1,indxn))

  end subroutine readgridini


  subroutine init_domainfill_ncf

  !******************************************************************************
  !                                                                             *
  !  Initializes particles equally distributed over the first release location  *
  !  specified in file RELEASES. This box is assumed to be the domain for doing *
  !  domain-filling trajectory calculations.                                    *
  !  All particles carry the same amount of mass which alltogether comprises the*
  !  mass of air within the box.                                                *
  !                                                                             *
  !  Author: A. Stohl, Oct 2002                                                 *
  !  Modifications:                                                             * 
  !    R. Thompson, Sep 2023: added initialization of mass from grid based      *
  !                           on code of S. Henne for Flexpart-CTM              *
  !                                                                             *
  !******************************************************************************
  !                                                                             *
  ! Variables:                                                                  *
  !                                                                             *
  ! numparticlecount    consecutively counts the number of particles released   *
  ! nx_we(2)       grid indices for western and eastern boundary of domain-     *
  !                filling trajectory calculations                              *
  ! ny_sn(2)       grid indices for southern and northern boundary of domain-   *
  !                filling trajectory calculations                              *
  !                                                                             *
  !******************************************************************************

    use point_mod
    use random_mod
    use outgrid_mod
    use particle_mod
#ifdef ETA
    use coord_ecmwf_mod
#endif
    use initialise_mod, only: nx_we,ny_sn,numcolumn,numcolumn_we,numcolumn_sn, &
                              zcolumn_we,zcolumn_sn,acc_mass_we,acc_mass_sn, &
                              xmassperparticle,alloc_domainfill
    use totals_mod,     only: tot_mass

    implicit none

    integer :: j,ix,jy,kz,ncolumn,numparttot,iterminate,stat
    real :: ylat,ylatp,ylatm,hzone
    real :: cosfactm,cosfactp,deltacol,dz1,dz2,dz,pnew,pnew_temp,fractus
    real,parameter :: pih=pi/180.
    real :: colmasstotal,zposition
    real :: hgt_tmp
    real, allocatable,dimension(:) :: pp

    integer :: ixm,ixp,jym,jyp,indzm,indzp,nn,indzh,i,ii,jj,ks,indxn
    real :: pvpart,ddx,ddy,rddx,rddy,p1,p2,p3,p4,y1(2)
    integer :: idummy = -11
    logical :: deall
    real,parameter :: eps=1.e-6

    ! dry and moist air density at particle position
    real :: rho_d_i, rho_m_i

    ! variables for column mass calculation 
    integer,allocatable,dimension(:,:) :: nncolumn
    real,allocatable,dimension(:)   :: gridarea 
    real,allocatable,dimension(:,:) :: colmass 
    real,parameter :: weightair=28.97

    ! variables to store source profiles
    real :: bg_lat(maxspec,ny), dummy1, dummy2
    real :: ppbvpart, presspart
    character(256) :: filename
    logical :: lexist, lgridini
    real :: xl, yl

    ! io variables
    character(30) :: frmt
    integer, parameter :: unitcolmass=98, unitinitconc=99

    ! Determine the release region (only full grid cells), over which particles
    ! shall be initialized
    ! Use 2 fields for west/east and south/north boundary
    !**************************************************************************
    call alloc_domainfill
    nx_we(1)=max(int(xpoint1(1)),0)
    nx_we(2)=min((int(xpoint2(1))+1),nxmin1)
    ny_sn(1)=max(int(ypoint1(1)),0)
    ny_sn(2)=min((int(ypoint2(1))+1),nymin1)
 
    ! For global simulations (both global wind data and global domain-filling),
    ! set a switch, such that no boundary conditions are used
    !**************************************************************************
    if (xglobal.and.sglobal.and.nglobal) then
      if ((nx_we(1).eq.0).and.(nx_we(2).eq.nxmin1).and. &
           (ny_sn(1).eq.0).and.(ny_sn(2).eq.nymin1)) then
        gdomainfill=.true.
      else
        gdomainfill=.false.
      endif
    endif

    ! If resuming a run from particle dump
    ! calculate total mass each species then exit
    !********************************************
    if (gdomainfill.and.ipin.ne.0) then
      write(*,*) 'Initialising particles from partoutput'
      tot_mass(:)=0.
      do ks=2,nspec
        tot_mass(ks)=sum(mass(1:count%alive,ks))
        write(*,'(A,E12.4,A)') 'Species '//species(ks)//': ',tot_mass(ks),' (kg)'
      end do
      return
    endif

    ! Allocate fields used within this subroutine
    !*********************************************
    allocate( nncolumn(0:nxmax-1, 0:nymax-1),stat=stat )
    if (stat.ne.0) write(*,*)'ERROR: could not allocate nncolumn'
    allocate(gridarea(0:nymax-1),colmass(0:nxmax-2,0:nymax-1),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridarea or colmass'

    ! Do not release particles twice (i.e., not at both in the leftmost and rightmost
    ! grid cell) for a global domain
    !*****************************************************************************
    if (xglobal) nx_we(2)=min(nx_we(2),nx-2)
    write(*,*) 'init_domainfill: nx_we, ny_sn = ',nx_we, ny_sn
    
    ! Try reading initial mixing ratio fields into gridini
    !*****************************************************
    ! this is to restart from 3D fields
    ! grid_pptv files have to be present for all species except 1 (airtracer)
    lgridini = .true.
    do ks=2,nspec ! species 1 is assumed to be air tracer
      call readgridini(ks,lexist)
      if (.not.lexist) then
        lgridini = .false.
        exit
      end if
    end do

    if (lgridini) then
      write(*,*) "Initialising all species with gridded input"
      !! test
      open(unitoutgrid,file=path(2)(1:length(2))//'gridini.txt',status='replace',action='write')
      write(frmt,fmt='(A,I4,A)') '(',nxini(1),'(E14.6))'
      do kz=1,nzini(1)
        do jj=1,nyini(1)
          write(unitoutgrid,frmt) gridini(1:nxini(1),jj,kz,1)
        end do
      end do
      close(unitoutgrid)
      !!
    else
      ! read latitude profiles for initialization
      do ks=2,nspec  ! species 1 is assumed to be air tracer
        filename=trim(path(2)(1:length(2)))//'latitude_profile_'//trim(species(ks))//'.txt'
        print*, 'init_domainfill: filename = ',filename
        inquire(file=filename,exist=lexist)
        if (lexist) then
          open(unitinitconc,file=filename,action='read')
          do jj=1,ny
            read(unitinitconc,'(3F13.6)') dummy1, bg_lat(ks,jj), dummy2
            write(*,*) 'read values; ', dummy1, bg_lat(ks,jj), dummy2
          enddo
          close(unitinitconc)
          write(*,'(A)') "Initialising species "//species(ks)//" with latitudinal profile"
        else
          bg_lat(ks,:) = 1.
          write(*,'(A)') "Initialising species "//species(ks)//" with value in RELEASES"
        endif
      end do ! nspec
    endif ! lgridini

    ! Calculate area of grid cell with formula M=2*pi*R*h*dx/360,
    ! see Netz, Formeln der Mathematik, 5. Auflage (1983), p.90
    ! Note gridarea is for meteo grid
    !************************************************************

    write(*,*) 'init_domainfill: nxmin1, nxmax, nymin1, nymax = ',nxmin1, nxmax, nymin1, nymax

    ! for the south pole
    if (sglobal) then
      ylat=ylat0
      ylatp=ylat+0.5*dy
      ylatm=ylat
      cosfactm=0.
      cosfactp=cos(ylatp*pih)*r_earth
      hzone=sqrt(r_earth**2-cosfactm**2)- &
           sqrt(r_earth**2-cosfactp**2)
      gridarea(0)=2.*pi*r_earth*hzone*dx/360.
    endif

    ! do the same for the north pole
    if (nglobal) then
      ylat=ylat0+real(nymin1)*dy
      ylatp=ylat
      ylatm=ylat-0.5*dy
      cosfactp=0.
      cosfactm=cos(ylatm*pih)*r_earth
      hzone=sqrt(r_earth**2-cosfactp**2)- &
           sqrt(r_earth**2-cosfactm**2)
      gridarea(nymin1)=2.*pi*r_earth*hzone*dx/360.
    endif

    ! Initialise the sum over the total mass of the atmosphere
    colmasstotal=0.
    colmass(:,:)=0.

    write(*,*) 'init_domainfill: ny_sn, nx_we = ',ny_sn, nx_we
    write(*,*) 'init_domainfill: dxini, dyini = ',dxini, dyini

    allocate( pp(nzmax),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate pp'

!$OMP PARALLEL PRIVATE(jy,ix,ylat,ylatp,ylatm,hzone,cosfactp,cosfactm,pp) 

!$OMP DO
    ! loop over latitudes
    do jy=ny_sn(1),ny_sn(2)
      if (sglobal.and.(jy.eq.ny_sn(1))) cycle
      if (nglobal.and.(jy.eq.ny_sn(2))) cycle
      ylat=ylat0+real(jy)*dy
      ylatp=ylat+0.5*dy
      ylatm=ylat-0.5*dy
      if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
        hzone=1./dyconst
      else
        cosfactp=cos(ylatp*pih)*r_earth
        cosfactm=cos(ylatm*pih)*r_earth
        if (cosfactp.lt.cosfactm) then
          hzone=sqrt(r_earth**2-cosfactp**2)- &
               sqrt(r_earth**2-cosfactm**2)
        else
          hzone=sqrt(r_earth**2-cosfactm**2)- &
               sqrt(r_earth**2-cosfactp**2)
        endif
      endif
      gridarea(jy)=2.*pi*r_earth*hzone*dx/360.
    end do
!$OMP END DO
!$OMP BARRIER

    ! Calculate total mass of each grid column and of the whole atmosphere
    !*********************************************************************

!$OMP DO
    do jy=ny_sn(1),ny_sn(2)        
      do ix=nx_we(1),nx_we(2)      
        pp(1)=prs(ix,jy,1,1)
        pp(nz)=prs(ix,jy,nz,1)
        colmass(ix,jy)=(pp(1)-pp(nz))/ga*gridarea(jy)
      end do
    end do
!$OMP END DO
!$OMP END PARALLEL

    deallocate(pp)

    colmasstotal=sum(colmass)
    write(*,*) 'Atmospheric mass air = ',colmasstotal

    ! Output of colmass distribution
    !********************************

    open(unitcolmass,file=path(2)(1:length(2))//'colmass.dat',action='write')
    write(frmt, '(A, I4, A)') '(', ny_sn(2)-ny_sn(1)+1, 'E12.3)'
    do ix=nx_we(1),nx_we(2)
      write(unitcolmass, frmt) (colmass(ix,i),i=0,(nymax-1))
    end do
    close(unitcolmass)

    ! If not continuing from particle dump
    !*************************************

    if (ipin.eq.0) numpart=0

    ! Determine the particle positions
    !*********************************
    allocate( pp(nzmax),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate pp'
    numparttot=0
    numcolumn=0
    iterminate=0

    ! allocate all particles before loop
    call spawn_particles(0, npart(1))
    write(*,*)  'init_domainfill: count%alive = ',count%alive

    do jy=ny_sn(1),ny_sn(2)        ! loop about latitudes
      ylat=ylat0+real(jy)*dy
      do ix=nx_we(1),nx_we(2)      ! loop about longitudes
        ncolumn=nint(0.999*real(npart(1))*colmass(ix,jy)/colmasstotal)
        ! this condition means with 0.5 degrees need around 200 million particles 
        ! to avoid any grid cells having zero particles
        ncolumn=max(ncolumn,1)
        nncolumn(ix,jy) = ncolumn
        if (ncolumn.gt.numcolumn) numcolumn=ncolumn

        ! Calculate pressure at the altitudes of model surfaces, using the air density
        ! information, which is stored as a 3-d field
        pp(:)=prs(ix,jy,:,1)

        ! Loop over number of particles in grid column
        deltacol=(pp(1)-pp(nz))/real(ncolumn)
        pnew=pp(1)+deltacol/2.
        jj=0
        do j=1,ncolumn      
          jj=jj+1

          ! For columns with many particles (i.e. around the equator), distribute
          ! the particles equally, for columns with few particles (i.e. around the
          ! poles), distribute the particles randomly. When only few particles are
          ! left distribute them randomly

          if ((ncolumn.gt.20).and.(ncolumn-j.gt.20)) then
            pnew_temp=pnew-ran1(idummy,0)*deltacol
            pnew=pnew-deltacol
          else if (ncolumn.gt.20) then
            pnew_temp=pnew-ran1(idummy,0)*(pnew-pp(nz))
          else
            pnew_temp=pp(1)-ran1(idummy,0)*(pp(1)-pp(nz))
          endif
          pnew_temp=min(pp(1),pnew_temp) 
          pnew_temp=max(pp(nz)+eps,pnew_temp)

          ! find vertical layer
          do kz=1,nz-1
            if ((pp(kz).ge.pnew_temp).and.(pp(kz+1).lt.pnew_temp)) then
              dz1=log(pp(kz))-log(pnew_temp)
              dz2=log(pnew_temp)-log(pp(kz+1))
              dz=1./(dz1+dz2)

              ! Assign particle position
              !*************************

              ! Do the following steps only if particles are not read in from 
              ! previous model run
              if (ipin.eq.0) then
                
                ! Horizontal position
                call set_xlon(numpart+jj,real(real(ix)-0.5+ran1(idummy,0),kind=dp))
                if (ix.eq.0) call set_xlon(numpart+jj,real(ran1(idummy,0),kind=dp))
                if (ix.eq.nxmin1) &
                     call set_xlon(numpart+jj,real(real(nxmin1)-ran1(idummy,0),kind=dp))
                call set_ylat(numpart+jj,real(real(jy)-0.5+ran1(idummy,0),kind=dp))
                if (jy.eq.0) call set_ylat(numpart+jj,real(ran1(idummy,0),kind=dp))
                if (jy.eq.nymin1) &
                     call set_ylat(numpart+jj,real(real(nymin1)-ran1(idummy,0),kind=dp))  
                ! Vertical position
                hgt_tmp=(height(kz)*dz2+height(kz+1)*dz1)*dz
                call set_z(numpart+jj,hgt_tmp)
                if (real(part(numpart+jj)%z).gt.(height(nz)-0.5)) &
                     call set_z(numpart+jj,height(nz)-0.5)
#ifdef ETA
                call update_z_to_zeta(0, numpart+jj)
#endif
                ! Interpolate PV to the particle position
                !****************************************
                ixm=int(part(numpart+jj)%xlon)
                jym=int(part(numpart+jj)%ylat)
                ixp=ixm+1
                jyp=jym+1
                ddx=real(part(numpart+jj)%xlon)-real(ixm)
                ddy=real(part(numpart+jj)%ylat)-real(jym)
                rddx=1.-ddx
                rddy=1.-ddy
                p1=rddx*rddy
                p2=ddx*rddy
                p3=rddx*ddy
                p4=ddx*ddy
                indzm=nz-1
                indzp=nz
                do ii=2,nz
                  if (real(height(ii),kind=dp).gt.part(numpart+jj)%z) then
                    indzm=ii-1
                    indzp=ii
                    exit
                  endif
                end do
                dz1=real(part(numpart+jj)%z)-height(indzm)
                dz2=height(indzp)-real(part(numpart+jj)%z)
                dz=1./(dz1+dz2)
                do ii=1,2
                  indzh=indzm+ii-1
                  y1(ii)=p1*pv(ixm,jym,indzh,1) &
                       + p2*pv(ixp,jym,indzh,1) &
                       + p3*pv(ixm,jyp,indzh,1) &
                       + p4*pv(ixp,jyp,indzh,1)
                end do
                pvpart=(dz2*y1(1)+dz1*y1(2))*dz
                if (ylat.lt.0.) pvpart=-1.*pvpart

                ! Interpolate moist air density to the particle position
                !*******************************************************
                do ii=1,2
                  indzh=indzm+ii-1
                  y1(ii)=p1*rho(ixm,jym,indzh,1) &
                       +p2*rho(ixp,jym,indzh,1) &
                       +p3*rho(ixm,jyp,indzh,1) &
                       +p4*rho(ixp,jyp,indzh,1)
                end do
                rho_m_i=(dz2*y1(1)+dz1*y1(2))*dz

                ! Interpolate dry air density to the particle position
                !*****************************************************
                do ii=1,2
                  indzh=indzm+ii-1
                  y1(ii)=p1*rho(ixm,jym,indzh,1)*(1-qv(ixm,jym,indzh,1)) &
                       +p2*rho(ixp,jym,indzh,1)*(1-qv(ixp,jym,indzh,1)) &
                       +p3*rho(ixm,jyp,indzh,1)*(1-qv(ixm,jyp,indzh,1)) &
                       +p4*rho(ixp,jyp,indzh,1)*(1-qv(ixp,jyp,indzh,1))
                end do
                rho_d_i=(dz2*y1(1)+dz1*y1(2))*dz

                ! For domain-filling option 2 (stratospheric O3), 
                ! do the rest only in the stratosphere
                !************************************************

                if (((part(numpart+jj)%z.gt.3000.).and. &
                     (pvpart.gt.pvcrit)).or.(mdomainfill.eq.1)) then

                  ! Assign certain properties to the particle
                  !******************************************
                  part(numpart+jj)%nclass=min(int(ran1(idummy,0)*real(nclassunc))+1,nclassunc)
                  numparticlecount=numparticlecount+1
                  part(numpart+jj)%npoint=numparticlecount
                  part(numpart+jj)%idt=mintime
                  mass(numpart+jj,1)=colmass(ix,jy)/real(ncolumn)

                  if (lgridini) then

                    ! Initialize particle mass using gridded input
                    !*********************************************
                    ! Assume input is in units of ppv and species 1 carries airmass tracer so
                    ! mass of other species is easily determined
                    ! loop over all species, assuming species 1 is airtracer
                    do ks=2, nspec
                      indxn=minloc(abs(specnini-specnum(ks)),dim=1)
                      ! lon and lat of particle
                      xl=real(part(numpart+jj)%xlon)*dx+xlon0
                      yl=real(part(numpart+jj)%ylat)*dy+ylat0
                      ! get coordinates in gridini
                      ! Assumes lon and lat dimensions are midpoints
                      ixm=int((xl-(lonini(1,indxn)-0.5*dxini(indxn)))/dxini(indxn))+1
                      jym=int((yl-(latini(1,indxn)-0.5*dyini(indxn)))/dyini(indxn))+1
                      ixm=min(ixm,nxini(indxn))
                      jym=min(jym,nyini(indxn))
                      !! testing
!                      if (jj.eq.1.and.jy.lt.5.and.ix.lt.5) then 
!                        print*, 'init_domainfill: lonini, xl, latini, yl = ',lonini(ixm,indxn),xl,latini(jym,indxn),yl
!                      endif !!
                      ! Get vertical position in gridini
                      if (any(altini(:,indxn).gt.0)) then
                        ! vertical coordinate in metres above ground
                        indzm=nzini(indxn)-1
                        indzp=nzini(indxn)
                        do ii=2,nzini(indxn)
                          if (altini(ii,indxn).gt.real(part(numpart+jj)%z)) then
                            indzm=ii-1
                            indzp=ii
                            exit
                          endif
                        enddo
                        dz1=real(part(numpart+jj)%z)-altini(indzm,indxn)
                        dz2=altini(indzp,indxn)-real(part(numpart+jj)%z)
                        dz=1./(dz1+dz2)
                        ppbvpart=(dz2*gridini(ixm,jym,indzm,indxn)+ &
                                    dz1*gridini(ixm,jym,indzp,indxn))*dz
                      else if (any(prsini(:,:,:,indxn).gt.0)) then
                        ! vertical coordinate in pressure (Pa)
                        presspart=pnew_temp
                        indzm=nzini(indxn)-1
                        indzp=nzini(indxn)
                        do ii=2,nzini(indxn)
                          if (presspart.gt.prsini(ixm,jym,ii,indxn)) then
                            indzm=ii-1
                            indzp=ii
                            exit
                          endif
                        end do
                        dz1=presspart-prsini(ixm,jym,indzm,indxn)
                        dz2=prsini(ixm,jym,indzp,indxn)-presspart
                        dz=1./(dz1+dz2)
                        ppbvpart=(dz2*gridini(ixm,jym,indzm,indxn)+ &
                                  dz1*gridini(ixm,jym,indzp,indxn))*dz
                      endif 
                      !! test
!                      if (numpart.lt.100) write(*,*) 'init_domainfill: ratio dry/moist density =',rho_d_i/rho_m_i
                      mass(numpart+jj,ks)=mass(numpart+jj,1) * &
                           weightmolar(ks)/weightair * &
                           rho_d_i/rho_m_i*ppbvpart/1.E9
                    end do ! nspec

                  else

                    ! Initialize with latitude profile
                    !*********************************
                    ! loop over all species, assuming species 1 is airtracer
                    do ks=2, nspec
                      mass(numpart+jj,ks)=mass(numpart+jj,1)* &
                           weightmolar(ks)/weightair * &
                           rho_d_i/rho_m_i*bg_lat(ks,jy)/1.E9
                    end do

                  endif ! lgridini

                  ! Assign ozone mass if domain-filling option 2
                  !*********************************************
                  if (mdomainfill.eq.2) mass(numpart+jj,1)= &
                       mass(numpart+jj,1)*pvpart*48./29.*ozonescale/10.**9

                  mass_init(numpart+jj,1)=mass(numpart+jj,1)

                else

                  ! Particle in stratosphere and not domain-filling option 1
                  !*********************************************************
                  call terminate_particle(numpart+jj, 0)
                  jj=jj-1
                  iterminate=iterminate+1

                endif ! domainfill option
              endif ! if initialization
            endif ! if in layer
          end do ! loop over layers
        end do ! loop over column

        numparttot=numparttot+ncolumn
        if (ipin.eq.0) numpart=numpart+jj

      end do ! loop over longitude

    end do ! loop over latitude

    write(*,*) 'init_domainfill: numpart, numparttot = ',numpart, numparttot

    ! Terminate unused particles
    !***************************
    do j=(numpart+1),count%alive
      call terminate_particle(j,0) ! Cannot be within an OMP region
      iterminate=iterminate+1
    end do  
    write(*,*) 'init_domainfill: after terminating extra particles count%alive = ',count%alive

    ! Total mass each species
    !************************
    tot_mass(:)=0.
    do ks=2,nspec
      tot_mass(ks)=sum(mass(1:count%alive,ks))
      write(*,'(A,E12.4,A)') 'Species '//species(ks)//': ',tot_mass(ks),' (kg)'
    end do

    xmassperparticle=colmasstotal/real(numparttot)

    ! Output colmass distribution
    !****************************

    open(unitcolmass,file=path(2)(1:length(2))//'ncolumn.dat',action='write')
    write(frmt, '(A, I4, A)') '(', ny_sn(2)-ny_sn(1)+1, 'I5)'
    do ix=nx_we(1), nx_we(2)
      write(unitcolmass,frmt) (nncolumn(ix, jj), jj=ny_sn(1),ny_sn(2))
    end do
    close(unitcolmass)

    ! For boundary conditions, we need fewer particle release heights per column,
    ! because otherwise it takes too long until enough mass has accumulated to
    ! release a particle at the boundary (would take dx/u seconds), leading to
    ! relatively large position errors of the order of one grid distance.
    ! It's better to release fewer particles per column, but to do so more often.
    ! Thus, use on the order of nz starting heights per column.
    ! We thus repeat the above to determine fewer starting heights, that are
    ! used furtheron in subroutine boundcond_domainfill.f90
    !****************************************************************************

    fractus=real(numcolumn)/real(nz)
    write(*,*) 'Total number of particles at model start: ',numpart
    write(*,*) 'Maximum number of particles per column: ',numcolumn
    write(*,*) 'If ',fractus,' <1, better use more particles'
    fractus=sqrt(max(fractus,1.))/2.

    do jy=ny_sn(1),ny_sn(2)      ! loop about latitudes
      do ix=nx_we(1),nx_we(2)      ! loop about longitudes
        ncolumn=nint(0.999/fractus*real(npart(1))*colmass(ix,jy) &
           /colmasstotal)
        if (ncolumn.gt.maxcolumn) error stop 'maxcolumn too small'
        if (ncolumn.eq.0) cycle

        ! Memorize how many particles per column shall be used for all boundaries
        ! This is further used in subroutine boundcond_domainfill.f
        ! Use 2 fields for west/east and south/north boundary
        !************************************************************************

        if (ix.eq.nx_we(1)) numcolumn_we(1,jy)=ncolumn
        if (ix.eq.nx_we(2)) numcolumn_we(2,jy)=ncolumn
        if (jy.eq.ny_sn(1)) numcolumn_sn(1,ix)=ncolumn
        if (jy.eq.ny_sn(2)) numcolumn_sn(2,ix)=ncolumn

        ! Calculate pressure at the altitudes of model surfaces, using the air density
        ! information, which is stored as a 3-d field
        !*****************************************************************************

        do kz=1,nz
          pp(kz)=prs(ix,jy,kz,1) 
        end do

        ! Determine the reference starting altitudes
        !*******************************************

        deltacol=(pp(1)-pp(nz))/real(ncolumn)
        pnew=pp(1)+deltacol/2.
        do j=1,ncolumn
          pnew=pnew-deltacol
          do kz=1,nz-1
            if ((pp(kz).ge.pnew).and.(pp(kz+1).lt.pnew)) then
              dz1=pp(kz)-pnew
              dz2=pnew-pp(kz+1)
              dz=1./(dz1+dz2)
              zposition=(height(kz)*dz2+height(kz+1)*dz1)*dz
              if (zposition.gt.height(nz)-0.5) zposition=height(nz)-0.5

        ! Memorize vertical positions where particles are introduced
        ! This is further used in subroutine boundcond_domainfill.f
        !***********************************************************

              if (ix.eq.nx_we(1)) zcolumn_we(1,jy,j)=zposition
              if (ix.eq.nx_we(2)) zcolumn_we(2,jy,j)=zposition
              if (jy.eq.ny_sn(1)) zcolumn_sn(1,ix,j)=zposition
              if (jy.eq.ny_sn(2)) zcolumn_sn(2,ix,j)=zposition

        ! Initialize mass that has accumulated at boundary to zero
        !*********************************************************

              acc_mass_we(1,jy,j)=0.
              acc_mass_we(2,jy,j)=0.
              acc_mass_sn(1,jy,j)=0.
              acc_mass_sn(2,jy,j)=0.

            endif
          end do
        end do
      end do
    end do

    ! If there were more particles allocated than used,
    ! Deallocate unused memory and update numpart
    !**************************************************

    deall=.false.
    do i=numpart, 1, -1
      if (.not. part(i)%alive) then
        deall=.true.
        numpart = numpart - 1
      else
        exit
      endif
    end do

    if (deall) call dealloc_particle(numpart) ! deallocates everything above numpart
    write(*,*) 'init_domainfill: after dealloc count%alive = ',count%alive
    write(*,*) 'init_domainfill: count%allocated = ',count%allocated


    ! If particles shall be read in to continue an existing run,
    ! then the accumulated masses at the domain boundaries must be read in, too.
    ! This overrides any previous calculations.
    !***************************************************************************

    if ((ipin.eq.1).and.(.not.gdomainfill)) then
      open(unitboundcond,file=path(2)(1:length(2))//'boundcond.bin', &
           form='unformatted')
      read(unitboundcond) numcolumn_we,numcolumn_sn, &
           zcolumn_we,zcolumn_sn,acc_mass_we,acc_mass_sn
      close(unitboundcond)
    endif

    deallocate(pp,nncolumn,gridarea)

  end subroutine init_domainfill_ncf

  !*****************************************************************************
  !                                                                            *
  !    netcdf error message handling                                           *
  !                                                                            *
  !*****************************************************************************

!  subroutine nf90_err(status)
!
!    integer, intent (in) :: status
!
!    if(status /= nf90_noerr) then
!      print*, trim(nf90_strerror(status))
!      error stop 'Stopped'
!    end if
!
!  end subroutine nf90_err

end module initdomain_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine wetdepo(itime,ltsample,loutnext)
  !                     i      i        i
  !*****************************************************************************
  !                                                                            *
  ! Calculation of wet deposition using the concept of scavenging coefficients.*
  ! For lack of detailed information, washout and rainout are jointly treated. *
  ! It is assumed that precipitation does not occur uniformly within the whole *
  ! grid cell, but that only a fraction of the grid cell experiences rainfall. *
  ! This fraction is parameterized from total cloud cover and rates of large   *
  ! scale and convective precipitation.                                        *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    1 December 1996                                                         *
  !                                                                            *
  ! Correction by Petra Seibert, Sept 2002:                                    *
  ! use centred precipitation data for integration                             *
  ! Code may not be correct for decay of deposition!                           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! cc [0-1]           total cloud cover                                       *
  ! convp [mm/h]       convective precipitation rate                           *
  ! grfraction [0-1]   fraction of grid, for which precipitation occurs        *
  ! ix,jy              indices of output grid cell for each particle           *
  ! itime [s]          actual simulation time [s]                              *
  ! jpart              particle index                                          *
  ! ldeltat [s]        interval since radioactive decay was computed           *
  ! lfr, cfr           area fraction covered by precipitation for large scale  *
  !                    and convective precipitation (dependent on prec. rate)  *
  ! loutnext [s]       time for which gridded deposition is next output        *
  ! loutstep [s]       interval at which gridded deposition is output          *
  ! lsp [mm/h]         large scale precipitation rate                          *
  ! ltsample [s]       interval over which mass is deposited                   *
  ! prec [mm/h]        precipitation rate in subgrid, where precipitation occurs*
  ! wetdeposit         mass that is wet deposited                              *
  ! wetgrid            accumulated deposited mass on output grid               *
  ! wetscav            scavenging coefficient                                  *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod

  implicit none

  integer :: jpart,itime,ltsample,loutnext,ldeltat,i,j,ix,jy
  integer :: ngrid,itage,nage,hz,il,interp_time, n, clouds_v
  integer :: ks, kp
  real :: S_i, act_temp, cl, cle ! in cloud scavenging
  real :: clouds_h ! cloud height for the specific grid point
  real :: xtn,ytn,lsp,convp,cc,grfraction,prec,wetscav
  real :: wetdeposit(maxspec),restmass
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  save lfr,cfr


  real :: lfr(5) = (/ 0.5,0.65,0.8,0.9,0.95/)
  real :: cfr(5) = (/ 0.4,0.55,0.7,0.8,0.9 /)

  ! Compute interval since radioactive decay of deposited mass was computed
  !************************************************************************

  if (itime.le.loutnext) then
    ldeltat=itime-(loutnext-loutstep)
  else                                  ! first half of next interval
    ldeltat=itime-loutnext
  endif


  ! Loop over all particles
  !************************

  do jpart=1,numpart
    if (itra1(jpart).eq.-999999999) goto 20
    if(ldirect.eq.1)then
      if (itra1(jpart).gt.itime) goto 20
    else
      if (itra1(jpart).lt.itime) goto 20
    endif
  ! Determine age class of the particle
    itage=abs(itra1(jpart)-itramem(jpart))
    do nage=1,nageclass
      if (itage.lt.lage(nage)) goto 33
    end do
33   continue


  ! Determine which nesting level to be used
  !*****************************************

    ngrid=0
    do j=numbnests,1,-1
      if ((xtra1(jpart).gt.xln(j)).and.(xtra1(jpart).lt.xrn(j)).and. &
           (ytra1(jpart).gt.yln(j)).and.(ytra1(jpart).lt.yrn(j))) then
        ngrid=j
        goto 23
      endif
    end do
23   continue


  ! Determine nested grid coordinates
  !**********************************

    if (ngrid.gt.0) then
      xtn=(xtra1(jpart)-xln(ngrid))*xresoln(ngrid)
      ytn=(ytra1(jpart)-yln(ngrid))*yresoln(ngrid)
      ix=int(xtn)
      jy=int(ytn)
    else
      ix=int(xtra1(jpart))
      jy=int(ytra1(jpart))
    endif


  ! Interpolate large scale precipitation, convective precipitation and
  ! total cloud cover
  ! Note that interpolated time refers to itime-0.5*ltsample [PS]
  !********************************************************************
    interp_time=nint(itime-0.5*ltsample)

    if (ngrid.eq.0) then
      call interpol_rain(lsprec,convprec,tcc,nxmax,nymax, &
           1,nx,ny,memind,real(xtra1(jpart)),real(ytra1(jpart)),1, &
           memtime(1),memtime(2),interp_time,lsp,convp,cc)
    else
      call interpol_rain_nests(lsprecn,convprecn,tccn, &
           nxmaxn,nymaxn,1,maxnests,ngrid,nxn,nyn,memind,xtn,ytn,1, &
           memtime(1),memtime(2),interp_time,lsp,convp,cc)
    endif

    if ((lsp.lt.0.01).and.(convp.lt.0.01)) goto 20

  ! get the level were the actual particle is in
      do il=2,nz
        if (height(il).gt.ztra1(jpart)) then
          hz=il-1
          goto 26
        endif
      end do
26     continue

  n=memind(2)
  if (abs(memtime(1)-interp_time).lt.abs(memtime(2)-interp_time)) &
       n=memind(1)

  ! if there is no precipitation or the particle is above the clouds no
  ! scavenging is done

  if (ngrid.eq.0) then
     clouds_v=clouds(ix,jy,hz,n)
     clouds_h=cloudsh(ix,jy,n)
  else
     clouds_v=cloudsn(ix,jy,hz,n,ngrid)
     clouds_h=cloudsnh(ix,jy,n,ngrid)
  endif
  !write(*,*) 'there is
  !    + precipitation',(clouds(ix,jy,ihz,n),ihz=1,20),lsp,convp,hz
  if (clouds_v.le.1) goto 20
  !write (*,*) 'there is scavenging'

  ! 1) Parameterization of the the area fraction of the grid cell where the
  !    precipitation occurs: the absolute limit is the total cloud cover, but
  !    for low precipitation rates, an even smaller fraction of the grid cell
  !    is used. Large scale precipitation occurs over larger areas than
  !    convective precipitation.
  !**************************************************************************

    if (lsp.gt.20.) then
      i=5
    else if (lsp.gt.8.) then
      i=4
    else if (lsp.gt.3.) then
      i=3
    else if (lsp.gt.1.) then
      i=2
    else
      i=1
    endif

    if (convp.gt.20.) then
      j=5
    else if (convp.gt.8.) then
      j=4
    else if (convp.gt.3.) then
      j=3
    else if (convp.gt.1.) then
      j=2
    else
      j=1
    endif

    grfraction=max(0.05,cc*(lsp*lfr(i)+convp*cfr(j))/(lsp+convp))

  ! 2) Computation of precipitation rate in sub-grid cell
  !******************************************************

    prec=(lsp+convp)/grfraction

  ! 3) Computation of scavenging coefficients for all species
  !    Computation of wet deposition
  !**********************************************************

    do ks=1,nspec                                  ! loop over species
      wetdeposit(ks)=0.
      if (weta(ks).gt.0.) then
        if (clouds_v.ge.4) then
  !          BELOW CLOUD SCAVENGING
  !          for aerosols and not highliy soluble substances weta=5E-6
          wetscav=weta(ks)*prec**wetb(ks)                ! scavenging coeff.
  !        write(*,*) 'bel. wetscav: ',wetscav
        else ! below_cloud clouds_v is lt 4 and gt 1 -> in cloud scavenging
  !        IN CLOUD SCAVENGING
  ! BUGFIX tt for nested fields should be ttn
  ! sec may 2008
          if (ngrid.gt.0) then
             act_temp=ttn(ix,jy,hz,n,ngrid)
          else
             act_temp=tt(ix,jy,hz,n)
          endif
          cl=2E-7*prec**0.36
          if (dquer(ks).gt.0) then ! is particle
            S_i=0.9/cl
           else ! is gas
            cle=(1-cl)/(henry(ks)*(r_air/3500.)*act_temp)+cl
            S_i=1/cle
           endif
           wetscav=S_i*prec/3.6E6/clouds_h
  !         write(*,*) 'in. wetscav:'
  !    +          ,wetscav,cle,cl,act_temp,prec,clouds_h
        endif


  !      if (wetscav.le.0) write (*,*) 'neg, or 0 wetscav!'
  !    +          ,wetscav,cle,cl,act_temp,prec,clouds_h,clouds_v
        wetdeposit(ks)=xmass1(jpart,ks)* &
             (1.-exp(-wetscav*abs(ltsample)))*grfraction  ! wet deposition
  !      new particle mass:
  !      if (wetdeposit(ks).gt.0) then
  !         write(*,*) 'wetdepo: ',wetdeposit(ks),ks
  !      endif
        restmass = xmass1(jpart,ks)-wetdeposit(ks)
         if (ioutputforeachrelease.eq.1) then
           kp=npoint(jpart)
         else
           kp=1
         endif
        if (restmass .gt. smallnum) then
          xmass1(jpart,ks)=restmass
  !ccccccccccccccc depostatistic
  !       wetdepo_sum(ks,kp)=wetdepo_sum(ks,kp)+wetdeposit(ks)
  !ccccccccccccccc depostatistic
        else
          xmass1(jpart,ks)=0.
        endif
  ! Correct deposited mass to the last time step when radioactive decay of
  ! gridded deposited mass was calculated
       if (decay(ks).gt.0.) then
          wetdeposit(ks)=wetdeposit(ks) &
               *exp(abs(ldeltat)*decay(ks))
       endif
      else  ! weta(k)
         wetdeposit(ks)=0.
      endif ! weta(k)
    end do

  ! Sabine Eckhard, June 2008 create deposition runs only for forward runs
  ! Add the wet deposition to accumulated amount on output grid and nested output grid
  !*****************************************************************************

    if (ldirect.eq.1) then
    call wetdepokernel(nclass(jpart),wetdeposit,real(xtra1(jpart)), &
         real(ytra1(jpart)),nage,kp)
    if (nested_output.eq.1) call wetdepokernel_nest(nclass(jpart), &
         wetdeposit,real(xtra1(jpart)),real(ytra1(jpart)), &
         nage,kp)
    endif

20  continue
  end do

end subroutine wetdepo

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!*****************************************************************************
!                                                                            *
!   L. Bakels 2022: This module contains all subroutines for                 *
!                   reading option files                                     *
!                                                                            *
!*****************************************************************************

module readoptions_mod
  use par_mod
  use com_mod
  use date_mod
  use point_mod
  use windfields_mod

  implicit none

contains

subroutine readageclasses

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the age classes to be used for the current model    *
  !     run.                                                                   *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !     20 March 2000                                                          *
  !     HSO, 1 July 2014                                                       *
  !     Added optional namelist input                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: i

  ! namelist help variables
  integer :: ios,stat
  ! namelist declaration
  namelist /nage/ &
    nageclass
  namelist /ageclass/ &
    lage

  nageclass=-1 ! preset to negative value to identify failed namelist input

  ! If age spectra calculation is switched off, set number of age classes
  ! to 1 and maximum age to a large number
  !**********************************************************************

  if (lagespectra.ne.1) then
    nageclass=1
    allocate( lage(nageclass),stat=stat)
    if (stat.ne.0) error stop "Could not allocate lage"
    lage(nageclass)=999999999
    return
  endif

  ! If age spectra claculation is switched on,
  ! open the AGECLASSSES file and read user options
  !************************************************

  open(unitageclasses,file=path(1)(1:length(1))//'AGECLASSES', &
    form='formatted',status='old',err=999)

  ! try to read in as a namelist

  read(unitageclasses,nage,iostat=ios)
  allocate( lage(nageclass),stat=stat)
  if (stat.ne.0) error stop "Could not allocate lage"
  read(unitageclasses,ageclass,iostat=ios)
  close(unitageclasses)

  if ((nageclass.lt.0).or.(ios.ne.0)) then
    open(unitageclasses,file=path(1)(1:length(1))//'AGECLASSES', &
      status='old',err=999)
    do i=1,13
      read(unitageclasses,*)
    end do
    read(unitageclasses,*) nageclass
    allocate( lage(nageclass),stat=stat)
    if (stat.ne.0) error stop "Could not allocate lage"
    read(unitageclasses,*) lage(1)
    do i=2,nageclass
      read(unitageclasses,*) lage(i)
    end do
    close(unitageclasses)
  endif

  ! write ageclasses file in namelist format to output directory if requested
  if (nmlout.and.lroot) then
    open(unitageclasses,file=path(2)(1:length(2))//'AGECLASSES.namelist', &
      err=1000)
    write(unitageclasses,nml=nage)
    write(unitageclasses,nml=ageclass)
    close(unitageclasses)
  endif

  if (lage(1).le.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! AGE OF FIRST      #### '
    write(*,*) ' #### CLASS MUST BE GREATER THAN ZERO. CHANGE #### '
    write(*,*) ' #### SETTINGS IN FILE AGECLASSES.            #### '
    error stop 'First age class must be larger than zero'
  endif

  do i=2,nageclass
    if (lage(i).le.lage(i-1)) then
      write(*,*) ' #### FLEXPART MODEL ERROR! AGE CLASSES     #### '
      write(*,*) ' #### MUST BE GIVEN IN TEMPORAL ORDER.      #### '
      write(*,*) ' #### CHANGE SETTINGS IN FILE AGECLASSES.   #### '
      error stop 'Age classes must be in temporal order'
    endif
  end do

  return

999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "AGECLASSES" #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  error stop 'AGECLASSES cannot be opened'

1000  write(*,*) ' #### FLEXPART MODEL ERROR! FILE "AGECLASSES" #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(2)(1:length(2))
  error stop 'AGECLASSES cannot be opened'
end subroutine readageclasses

subroutine readavailable

  !*****************************************************************************
  !                                                                            *
  !   This routine reads the dates and times for which windfields are          *
  !   available.                                                               *
  !                                                                            *
  !     Authors: A. Stohl                                                      *
  !                                                                            *
  !     6 February 1994                                                        *
  !     8 February 1999, Use of nested fields, A. Stohl                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! bdate                beginning date as Julian date                         *
  ! beg                  beginning date for windfields                         *
  ! endl                  ending date for windfields                           *
  ! fname                filename of wind field, help variable                 *
  ! ideltas [s]          duration of modelling period                          *
  ! idiff                time difference between 2 wind fields                 *
  ! idiffnorm            normal time difference between 2 wind fields          *
  ! idiffmax [s]         maximum allowable time between 2 wind fields          *
  ! jul                  julian date, help variable                            *
  ! numbwf               actual number of wind fields                          *
  ! wfname(numbwf)        file names of needed wind fields                     *
  ! wftime(numbwf) [s]times of wind fields relative to beginning time          *
  ! wfname1,wftime1 = same as above, but only local (help variables)           *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitavailab          unit connected to file AVAILABLE                      *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: i,idiff,ldat,ltim,k,stat
  integer,allocatable,dimension(:) :: wftime1,tmpwftime,numbwfn
  integer,allocatable,dimension(:,:) :: wftimen,wftime1n,tmpwftimen
  logical :: lwarntd=.true.
  real(kind=dp) :: jul,beg,endl
  character(len=255) :: fname
  character(len=255),allocatable,dimension(:) :: wfname1, &
    tmpwfname
  character(len=255),allocatable,dimension(:,:) :: wfname1n,tmpwfnamen

  ! Windfields are only used, if they are within the modelling period.
  ! However, 1 additional day at the beginning and at the end is used for
  ! interpolation. -> Compute beginning and ending date for the windfields.
  !************************************************************************

  if (ideltas.gt.0) then         ! forward trajectories
    beg=bdate-1._dp
    endl=bdate+real(ideltas,kind=dp)/86400._dp+real(idiffmax,kind=dp)/ &
         86400._dp
  else                           ! backward trajectories
    beg=bdate+real(ideltas,kind=dp)/86400._dp-real(idiffmax,kind=dp)/ &
         86400._dp
    endl=bdate+1._dp
  endif

  ! Open the wind field availability file and read available wind fields
  ! within the modelling period.
  !*********************************************************************

  open(unitavailab,file=path(4)(1:length(4)),status='old', &
       err=999)

  do i=1,3
    read(unitavailab,*)
  end do

  numbwf=0
100   read(unitavailab,'(i8,1x,i6,2(6x,a255))',end=99) &
           ldat,ltim,fname
    jul=juldate(ldat,ltim)
    if ((jul.ge.beg).and.(jul.le.endl)) then
      numbwf=numbwf+1
      allocate( tmpwfname(numbwf),tmpwftime(numbwf),stat=stat)
      if (stat.ne.0) error stop 'ERROR: could not allocate tmpwfname'
      if (numbwf.gt.1) then
        tmpwfname(1:numbwf-1)=wfname1
        tmpwftime(1:numbwf-1)=wftime1
      endif
      tmpwfname(numbwf)=fname(1:index(fname,' '))
      tmpwftime(numbwf)=nint((jul-bdate)*86400._dp)

      call move_alloc(tmpwfname,wfname1)
      call move_alloc(tmpwftime,wftime1)
    endif
    goto 100       ! next wind field

99   continue

  close(unitavailab)

  ! Open the wind field availability file and read available wind fields
  ! within the modelling period (nested grids)
  !*********************************************************************
  if (numbnests.gt.0) then
    allocate( numbwfn(numbnests),stat=stat)
    if (stat.ne.0) error stop 'ERROR: could not allocate numwfn'

    do k=1,numbnests
    !print*,length(numpath+2*(k-1)+1),length(numpath+2*(k-1)+2),length(4),length(3)
    !print*,path(numpath+2*(k-1)+2)(1:length(numpath+2*(k-1)+2))
      open(unitavailab,file=path(numpath+2*(k-1)+2) &
           (1:length(numpath+2*(k-1)+2)),status='old',err=998)

      do i=1,3
        read(unitavailab,*)
      end do

      numbwfn(k)=0
700   read(unitavailab,'(i8,1x,i6,2(6x,a255))',end=699) ldat, &
             ltim,fname
        jul=juldate(ldat,ltim)
        if ((jul.ge.beg).and.(jul.le.endl)) then
          numbwfn(k)=numbwfn(k)+1
          allocate( tmpwfnamen(numbnests,numbwfn(k)),tmpwftimen(numbnests,numbwfn(k)), &
            stat=stat)
          if (stat.ne.0) error stop 'ERROR: could not allocate tmpwfnamen'
          if (numbwfn(k).gt.1) then
            tmpwfnamen(:,1:numbwfn(k)-1)=wfname1n
            tmpwftimen(:,1:numbwfn(k)-1)=wftime1n
          endif
          tmpwfnamen(k,numbwfn(k))=fname(1:index(fname,' '))
          tmpwftimen(k,numbwfn(k))=nint((jul-bdate)*86400._dp)
          call move_alloc(tmpwfnamen,wfname1n)
          call move_alloc(tmpwftimen,wftime1n)
        endif
        goto 700       ! next wind field

699   continue

      close(unitavailab)
    end do
  endif

  ! Check wind field times of file AVAILABLE (expected to be in temporal order)
  !****************************************************************************

  if (numbwf.eq.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! NO WIND FIELDS    #### '
    write(*,*) ' #### AVAILABLE FOR SELECTED TIME PERIOD.     #### '
    error stop 'No wind fields available for selected time period'
  endif

  do i=2,numbwf
    if (wftime1(i).le.wftime1(i-1)) then
      write(*,*) 'FLEXPART ERROR: FILE AVAILABLE IS CORRUPT.'
      write(*,*) 'THE WIND FIELDS ARE NOT IN TEMPORAL ORDER.'
      write(*,*) 'PLEASE CHECK FIELD ',wfname1(i)
      error stop 'AVAILABLE file error'
    endif
  end do

  ! Check wind field times of file AVAILABLE for the nested fields
  ! (expected to be in temporal order)
  !***************************************************************

  do k=1,numbnests
    if (numbwfn(k).eq.0) then
      write(*,*) '#### FLEXPART MODEL ERROR! NO WIND FIELDS  ####'
      write(*,*) '#### AVAILABLE FOR SELECTED TIME PERIOD.   ####'
      error stop 'No nested wind fields available for selected time period'
    endif

    do i=2,numbwfn(k)
      if (wftime1n(k,i).le.wftime1n(k,i-1)) then
      write(*,*) 'FLEXPART ERROR: FILE AVAILABLE IS CORRUPT. '
      write(*,*) 'THE NESTED WIND FIELDS ARE NOT IN TEMPORAL ORDER.'
      write(*,*) 'PLEASE CHECK FIELD ',wfname1n(k,i)
      write(*,*) 'AT NESTING LEVEL ',k
      error stop 'nested AVAILABLE file error'
      endif
    end do

  end do

  ! Allocating global fields storing the windfield names and times
  !***************************************************************
  allocate(wfname(numbwf),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wfname"
  allocate(wftime(numbwf),stat=stat)
  if (stat.ne.0) error stop "Could not allocate wftime"
  if (numbnests.gt.0) then
    allocate(wfnamen(numbnests,numbwf),stat=stat)
    if (stat.ne.0) error stop "Could not allocate wfnamen"
    allocate(wftimen(numbnests,numbwf),stat=stat)
    if (stat.ne.0) error stop "Could not allocate wftimen"
  endif
  ! For backward trajectories, reverse the order of the windfields
  !***************************************************************

  if (ideltas.ge.0) then
    do i=1,numbwf
      wfname(i)=wfname1(i)
      wftime(i)=wftime1(i)
    end do
    do k=1,numbnests
      do i=1,numbwfn(k)
        wfnamen(k,i)=wfname1n(k,i)
        wftimen(k,i)=wftime1n(k,i)
      end do
    end do
  else
    do i=1,numbwf
      wfname(numbwf-i+1)=wfname1(i)
      wftime(numbwf-i+1)=wftime1(i)
    end do
    do k=1,numbnests
      do i=1,numbwfn(k)
        wfnamen(k,numbwfn(k)-i+1)=wfname1n(k,i)
        wftimen(k,numbwfn(k)-i+1)=wftime1n(k,i)
      end do
    end do
  endif

  ! Check the time difference between the wind fields. If it is big,
  ! write a warning message. If it is too big, terminate the trajectory.
  !*********************************************************************

  do i=2,numbwf
    idiff=abs(wftime(i)-wftime(i-1))
    if (idiff.gt.idiffmax.and.lroot) then
      write(*,*) 'FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO'
      write(*,*) 'WIND FIELDS IS TOO BIG FOR TRANSPORT CALCULATION.&
           &'
      write(*,*) 'THEREFORE, TRAJECTORIES HAVE TO BE SKIPPED.'
    else if (idiff.gt.idiffnorm.and.lroot.and.lwarntd) then
      write(*,*) 'FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO'
      write(*,*) 'WIND FIELDS IS BIG. THIS MAY CAUSE A DEGRADATION'
      write(*,*) 'OF SIMULATION QUALITY.'
      lwarntd=.false. ! only issue this warning once
    endif
  end do

  do k=1,numbnests
    if (numbwfn(k).ne.numbwf) then
      write(*,*) 'FLEXPART ERROR: THE AVAILABLE FILES FOR THE'
      write(*,*) 'NESTED WIND FIELDS ARE NOT CONSISTENT WITH'
      write(*,*) 'THE AVAILABLE FILE OF THE MOTHER DOMAIN.  '
      write(*,*) 'ERROR AT NEST LEVEL: ',k
      error stop 'Not the same number of nested wind field files as mother domain'
    endif
    do i=1,numbwf
      if (wftimen(k,i).ne.wftime(i)) then
        write(*,*) 'FLEXPART ERROR: THE AVAILABLE FILES FOR THE'
        write(*,*) 'NESTED WIND FIELDS ARE NOT CONSISTENT WITH'
        write(*,*) 'THE AVAILABLE FILE OF THE MOTHER DOMAIN.  '
        write(*,*) 'ERROR AT NEST LEVEL: ',k
        error stop 'Not the same time period of nested wind field files as mother domain'
      endif
    end do
  end do

  ! Reset the times of the wind fields that are kept in memory to no time
  !**********************************************************************

  do i=1,2
    memind(i)=i
    memtime(i)=999999999
  end do
  deallocate( wftime1,wfname1)
  if (numbnests.gt.0) deallocate(wftime1n,wftimen,wfname1n,numbwfn)
  return

998   write(*,*) ' #### FLEXPART MODEL ERROR! AVAILABLE FILE   #### '
  write(*,'(a)') '     '//path(numpath+2*(k-1)+2) &
       (1:length(numpath+2*(k-1)+2))
  write(*,*) ' #### CANNOT BE OPENED             #### '
  error stop 'Nested AVAILABLE file cannot be opened'

999   write(*,*) ' #### FLEXPART MODEL ERROR! AVAILABLE FILE #### '
  write(*,'(a)') '     '//path(4)(1:length(4))
  write(*,*) ' #### CANNOT BE OPENED           #### '
  error stop 'AVAILABLE file cannot be opened'
end subroutine readavailable

subroutine readcommand

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the current model run.  *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     18 May 1996                                                            *
  !     HSO, 1 July 2014                                                       *
  !     Added optional namelist input                                          *
  !                                                                            * 
  !                                                                            *
  !     January 2024 Rona Thompson                                             *
  !     Added new variables for LCM                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! bdate                beginning date as Julian date                         *
  ! ctl                  factor by which time step must be smaller than        *
  !                      Lagrangian time scale                                 *
  ! ibdate,ibtime        beginnning date and time (YYYYMMDD, HHMISS)           *
  ! ideltas [s]          modelling period                                      *
  ! iedate,ietime        ending date and time (YYYYMMDD, HHMISS)               *
  ! ifine                reduction factor for vertical wind time step          *
  ! outputforeachrel     for forward runs it is possible either to create      *
  !                      one outputfield or several for each releasepoint      *
  ! iflux                switch to turn on (1)/off (0) flux calculations       *
  ! iout                 1 for conc. (residence time for backward runs) output,*
  !                      2 for mixing ratio output, 3 both, 4 for plume        *
  !                      trajectory output, 5 = options 1 and 4                *
  ! ipin                 1 continue simulation with restart.bin file,          *
  !                      2 continue simulaion with dumped particle data, 0 no  *
  !                      3 use self-defined initial conditions in netcdf       *
  !                      4 initial run using option 3, restart from restart.bin*
  ! ipout                0 no particle dump, 1 every output time, 3 only at end*
  ! ipoutfac             increase particle dump interval by factor (default 1) *
  ! loutaver [s]         concentration output is an average over loutaver      *
  !                      seconds                                               *
  ! loutsample [s]       average is computed from samples taken every [s]      *
  !                      seconds                                               *
  ! loutstep [s]         time interval of concentration output                 *
  ! lrecoutstep [s]      time interval of receptor output                      *
  ! lrecoutaver [s]      receptor output is an average of lrecoutaver seconds  *
  ! lrecoutsample [s]    average is computed from samples taken every [s]      *
  ! lsynctime [s]        synchronisation time interval for all particles       *
  ! lagespectra          switch to turn on (1)/off (0) calculation of age      *
  !                      spectra                                               *
  ! lconvection          value of either 0 and 1 indicating mixing by          *
  !                      convection                                            *
  !                      = 0 .. no convection                                  *
  !                      + 1 .. parameterisation of mixing by subgrid-scale    *
  !                              convection = on                               *
  ! lsubgrid             switch to turn on (1)/off (0) subgrid topography      *
  !                      parameterization                                      *
  ! method               method used to compute the particle pseudovelocities  *
  ! mdomainfill          1 use domain-filling option, 0 not, 2 use strat. O3   *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitcommand          unit connected to file COMMAND                        *
  !                                                                            *
  !*****************************************************************************

  implicit none

  character(len=50) :: line
  integer :: ios
  integer :: lturbulence_meso,lcmoutput
  character(len=50) :: ohfields_path ! deprecated

  namelist /command/ &
  ldirect, &
  ibdate,ibtime, &
  iedate,ietime, &
  loutstep, &
  loutaver, &
  loutsample, &
  loutrestart, &
  lrecoutstep, &
  lrecoutaver, &
  lrecoutsample, &
  lsynctime, &
  ctl, &
  ifine, &
  iout, &
  ipout, &
  ipoutfac, &
  lsubgrid, &
  lconvection, &
  lturbulence, &
  lturbulence_meso, &
  lagespectra, &
  ipin, &
  ioutputforeachrelease, &
  iflux, &
  mdomainfill, &
  ind_source, &
  ind_receptor, &
  mquasilag, &
  nested_output, &
  linit_cond, &
  lnetcdfout, &
  sfc_only, &
  surf_only, &
  cblflag, &
  linversionout, &
  d_trop, &
  d_strat, &
  nxshift, &
  maxthreadgrid, &
  maxfilesize, &
  logvertinterp, &
  ohfields_path, &
  lcmoutput, &
  itsplit  ! deprecated: only for IO back compatibility  

  ! Presetting namelist command
  ldirect=0
  ibdate=20000101
  ibtime=0
  iedate=20000102
  ietime=0
  loutstep=10800
  loutaver=10800
  loutsample=900
  lrecoutstep=-1
  lrecoutaver=-1
  lrecoutsample=-1
  loutrestart=-1
  lsynctime=900
  ctl=-5.0
  ifine=4
  iout=3
  ipout=0
  ipoutfac=1
  lsubgrid=1
  lconvection=1
  lturbulence=1
  lturbulence_meso=0
  lagespectra=0
  ipin=0
  ioutputforeachrelease=1
  iflux=1
  mdomainfill=0
  ind_source=1
  ind_receptor=1
  mquasilag=0
  nested_output=0
  linit_cond=0
  lnetcdfout=1
  sfc_only=0
  surf_only=-1
  cblflag=0 ! if using old-style COMMAND file, set to 1 here to use mc cbl routine
  linversionout=0
  nxshift=-9999
  maxthreadgrid=1
  maxfilesize=10000
  logvertinterp=0
  ohfields_path=''
  lcmoutput=0
  itsplit=999999999 ! deprecated: only for IO back compatibility  

  !Af set release-switch
  WETBKDEP=.false.
  DRYBKDEP=.false.


  ! Open the command file and read user options
  ! Namelist input first: try to read as namelist file
  !**************************************************************************
  open(unitcommand,file=path(1)(1:length(1))//'COMMAND',status='old', &
    form='formatted',err=999)

  ! try namelist input (default)
  read(unitcommand,command,iostat=ios)
  if (ios.ne.0) then
        backspace(unitcommand)
        read(unitcommand,fmt='(A)') line
        if (lroot) write(*,*) &
            'Invalid line in COMMAND reads: '//trim(line)
  end if
  
  close(unitcommand)

  if (lturbulence_meso.ne.0) lmesoscale_turb=.true.
  if (logvertinterp.ne.0) log_interpol=.true.

  if (surf_only.ne.-1) then
    write(*,*) 'WARNING: SURF_ONLY in COMMAND will be deprecated and renamed SFC_ONLY'
    write(*,*) 'Continuing with SURF_ONLY...'
    sfc_only=surf_only
  endif
  ! distinguish namelist from fixed text input
  if ((ios.ne.0).or.(ldirect.eq.0)) then ! parse as text file format
    if (lroot) write(*,*) 'COMMAND either having unrecognised entries, &
      &or in old format, please update to namelist format.'
      error stop 'COMMAND has unrecognised entries or is not a namelist'
  endif ! input format

  ! write command file in namelist format to output directory if requested
  if (nmlout.and.lroot) then
    open(unitcommand,file=path(2)(1:length(2))//'COMMAND.namelist',err=1000)
    write(unitcommand,nml=command)
    close(unitcommand)
  endif

  ifine=max(ifine,1)

  ! Determine how Markov chain is formulated (for w or for w/sigw)
  !***************************************************************
  if (cblflag.eq.1) then ! added by mc to properly set parameters for CBL simulations 
    turbswitch=.true.
    if (lsynctime .gt. maxtl) lsynctime=maxtl  !maxtl defined in com_mod.f90
    if (ctl.lt.5) then
      print *,'WARNING: CBL flag active the ratio of TLu/dt has been set to 5'
      ctl=5.
    end if
    if (ifine*ctl.lt.50) then
      ifine=int(50./ctl)+1

      print *,'WARNING: CBL flag active the ratio of TLW/dt was < 50, &
        &ifine has been re-set to',ifine
  !pause
    endif
    print *,'WARNING: CBL flag active the ratio of TLW/dt is ',ctl*ifine
    print *,'WARNING: CBL flag active lsynctime is ',lsynctime
  else                    !added by mc
    if (ctl.ge.0.1) then
      turbswitch=.true.
    else
      turbswitch=.false.
      ifine=1
    endif
  endif                   !added by mc
  fine=1./real(ifine)
  ctl=1./ctl

  ! Set the switches required for the various options for input/output units
  !*************************************************************************
  !AF Set the switches IND_REL and IND_SAMP for the release and sampling
  !Af switches for the releasefile:
  !Af IND_REL =  1 : xmass * rho
  !Af IND_REL =  0 : xmass * 1

  !Af switches for the conccalcfile:
  !AF IND_SAMP =  0 : xmass * 1
  !Af IND_SAMP = -1 : xmass / rho

  !AF IND_SOURCE switches between different units for concentrations at the source
  !Af   NOTE that in backward simulations the release of computational particles
  !Af   takes place at the "receptor" and the sampling of particles at the "source".
  !Af          1 = mass units
  !Af          2 = mass mixing ratio units
  !Af IND_RECEPTOR switches between different units for concentrations at the receptor
  !            0 = no receptors
  !Af          1 = mass units
  !Af          2 = mass mixing ratio units
  !            3 = wet deposition in outputfield
  !            4 = dry deposition in outputfield

  ! Settings for LCM output
  !************************************************************
  ! MDOMAINFILL  = 1 | LLCMOUTPUT = true
  ! IND_SOURCE   = 1 | IND_SAMP   = 0
  ! IND_RECEPTOR = 1 | calculates mass ratio mixing ratio
  ! IOUT         = 2 | as ratio species_mass to airtracer_mass 
  !------------------------------------------------------------

  if ( ldirect .eq. 1 ) then  ! FWD-Run
  !Af set release-switch
     if (ind_source .eq. 1 ) then !mass
        ind_rel = 0
     else ! mass mix
        ind_rel = 1
     endif
  !Af set sampling switch
     if (ind_receptor .le. 1) then !mass
        ind_samp = 0
     else ! mass mix
        ind_samp = -1
     endif
  elseif (ldirect .eq. -1 ) then !BWD-Run
  !Af set sampling switch
     if (ind_source .eq. 1 ) then !mass
        ind_samp = -1
     else ! mass mix
        ind_samp = 0
     endif
     select case (ind_receptor)
     case (1)  !  1 .. concentration at receptor
        ind_rel = 1
     case (2)  !  2 .. mixing ratio at receptor
        ind_rel = 0
     case (3)  ! 3 .. wet deposition in outputfield 
        ind_rel = 3
        if (lroot) then
          write(*,*) ' #### FLEXPART WET DEPOSITION BACKWARD MODE    #### '
          write(*,*) ' #### Releaseheight is forced to 0 - 20km      #### '
          write(*,*) ' #### Release is performed above ground lev    #### '
        end if
         WETBKDEP=.true.
         !allocate(xscav_frac1(maxpart,maxspec))
     case (4)  ! 4 .. dry deposition in outputfield
         ind_rel = 4
         if (lroot) then
           write(*,*) ' #### FLEXPART DRY DEPOSITION BACKWARD MODE    #### '
           write(*,*) ' #### Releaseheight is forced to 0 - 2*href    #### '
           write(*,*) ' #### Release is performed above ground lev    #### '
         end if
         DRYBKDEP=.true.
         !allocate(xscav_frac1(maxpart,maxspec))
     end select
  endif

  !*************************************************************
  ! Check whether valid options have been chosen in file COMMAND
  !*************************************************************

  ! Check options for initial condition output: Switch off for forward runs
  !************************************************************************

  if (ldirect.eq.1) linit_cond=0
  if ((linit_cond.lt.0).or.(linit_cond.gt.2)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! INVALID OPTION    #### '
    write(*,*) ' #### FOR LINIT_COND IN FILE "COMMAND".       #### '
    error stop 'LINIT_COND in COMMAND is invalid'
  endif

  ! Check input dates
  !******************

  if (iedate.lt.ibdate) then
    write(*,*) ' #### FLEXPART MODEL ERROR! BEGINNING DATE    #### '
    write(*,*) ' #### IS LARGER THAN ENDING DATE. CHANGE      #### '
    write(*,*) ' #### EITHER POINT 2 OR POINT 3 IN FILE       #### '
    write(*,*) ' #### "COMMAND".                              #### '
    error stop 'COMMAND: beginning date is larger than ending date'
  else if (iedate.eq.ibdate) then
    if (ietime.lt.ibtime) then
    write(*,*) ' #### FLEXPART MODEL ERROR! BEGINNING TIME    #### '
    write(*,*) ' #### IS LARGER THAN ENDING TIME. CHANGE      #### '
    write(*,*) ' #### EITHER POINT 2 OR POINT 3 IN FILE       #### '
    write(*,*) ' #### "COMMAND".                              #### '
    error stop 'COMMAND: beginning time is larger than ending time'
    endif
  endif

! #ifndef USE_NCF
!   if ((loutrestart.ne.-1).or.(ipin.ne.0)) then
!     write(*,*) ' WARNING: restart option set with intervals'
!     write(*,*) ' LOUTRESTART', loutrestart
!     write(*,*) ' not possible when using binary gridded output'
!     write(*,*) ' ==> RESTART FUNCTION SWITCHED OFF!'
!   endif
!   if (ipin.ne.0) then 
!     write(*,*) ' ERROR: restart option not possible using binary'
!     write(*,*) ' output.'
!     write(*,*) ' Please only use IPIN>0 when compiling and running using'
!     write(*,*) ' netcdf output. '
!   endif
! #else
!   if ((surf_only.eq.1).or.(linversionout.eq.1)) then
!     write(*,*) ' ERROR: NetCDF output for surface only or for inversions'
!     write(*,*) ' is not yet implemented. Please compile without NetCDF.'
!     error stop 'Surface only option is not supported for NetCDF'
!   endif
! #endif

  ! Determine kind of dispersion method
  !************************************

  if (ctl.gt.0.) then
    method=1
    mintime=minstep
  else
    method=0
    mintime=lsynctime
  endif

  ! Check for netcdf output switch
  !*******************************
  if (iout.gt.8) then
    lnetcdfout=1
    iout = iout -8
  endif
  if (lnetcdfout.eq.1) then
#ifndef USE_NCF
    write(*,*) 'WARNING: netcdf output not activated during compile time &
      &but switched on in COMMAND or set to default value 1.'
    write(*,*) 'Please recompile with netcdf library (`make [...] ncf=yes`) &
      &when requiring NetCDF output.'
    write(*,*) 'LNETCDFOUT set to 0.'
    lnetcdfout = 0
#endif
  else
#ifdef USE_NCF
    write(*,*) 'WARNING: Executable compiled using NetCDF libraries, but &
      &BINARY output is requested. If this was unintended, please add 8 &
      &to IOUT or set LOUTNETCDF=1 in the COMMAND file.'
#endif
  endif

  if ((lnetcdfout.eq.1).and.((sfc_only.eq.1).or.(linversionout.eq.1))) then
    write(*,*) ' WARNING: NetCDF output for surface only or for inversions'
    write(*,*) ' is not yet implemented. LNETCDFOUT set to 0.'
    lnetcdfout=0
  endif

#ifndef USE_NCF
  if (ipout.ne.0) then
    write(*,*) 'ERROR: NETCDF missing! Please recompile with the netcdf'
    write(*,*) 'library if you want the particle dump or set IPOUT=0.'
    error stop 'FLEXPART not compiled with NetCDF'
  endif
#endif

  ! Check whether RECEPTOR commands are given, otherwise give them default values
  !******************************************************************************

  if (lrecoutstep.eq.-1) then
    write(*,*) 'WARNING: FILE COMMAND LRECOUTSTEP not provided,'
    write(*,*) 'value of LOUTSTEP will be used if RECEPTORS are'
    write(*,*) 'required.'
    lrecoutstep=loutstep
  endif

  if (lrecoutaver.eq.-1) then
    write(*,*) 'WARNING: FILE COMMAND LRECOUTAVER not provided,'
    write(*,*) 'value of LOUTAVER will be used if RECEPTORS are'
    write(*,*) 'required.'
    lrecoutaver=loutaver
  endif

  if (lrecoutsample.eq.-1) then
    write(*,*) 'WARNING: FILE COMMAND LRECOUTSTEP not provided,'
    write(*,*) 'value of LOUTSAMPLE will be used if RECEPTORS are'
    write(*,*) 'required.'
    lrecoutsample=loutsample
  endif

  ! Check whether a valid option for gridded model output has been chosen
  !**********************************************************************

  if (iout.eq.0) then
    write(*,*) 'WARNING: IOUT set to zero, no gridded information will be &
      &written to file'
  else if ((iout.lt.0).or.(iout.gt.5)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### IOUT MUST BE 1, 2, 3, 4 OR 5 FOR        #### '
    write(*,*) ' #### STANDARD FLEXPART OUTPUT OR  9 - 13     #### '
    write(*,*) ' #### FOR NETCDF OUTPUT                       #### '
    error stop
  endif

  !AF check consistency between units and volume mixing ratio
  if ( ((iout.eq.2).or.(iout.eq.3)).and. &
       (ind_source.gt.1 .or.ind_receptor.gt.1) ) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### VOLUME MIXING RATIO ONLY SUPPORTED      #### '
    write(*,*) ' #### FOR MASS UNITS (at the moment)          #### '
    error stop
  endif


  ! For quasilag output for each release is forbidden
  !*****************************************************************************

  if ((ioutputforeachrelease.eq.1).and.(mquasilag.eq.1)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### OUTPUTFOREACHRELEASE AND QUASILAGRANGIAN####'
      write(*,*) '#### MODE IS NOT POSSIBLE   !                ####'
      error stop
  endif


  ! For quasilag backward is forbidden
  !*****************************************************************************

  if ((ldirect.lt.0).and.(mquasilag.eq.1)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR BACKWARD RUNS, QUASILAGRANGIAN MODE ####'
      write(*,*) '#### IS NOT POSSIBLE   !                     ####'
      error stop
  endif


  ! For backward runs one releasefield for all releases makes no sense,
  ! For quasilag and domainfill ioutputforechrelease is forbidden
  !*****************************************************************************

  if ((ldirect.lt.0).and.(ioutputforeachrelease.eq.0)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR BACKWARD RUNS, IOUTPUTFOREACHRLEASE ####'
      write(*,*) '#### MUST BE SET TO ONE!                     ####'
      error stop
  endif


  ! For backward runs one releasefield for all releases makes no sense,
  ! and is "forbidden"
  !*****************************************************************************

  if ((mdomainfill.eq.1).and.(ioutputforeachrelease.eq.1)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR DOMAIN FILLING RUNS OUTPUT FOR      ####'
      write(*,*) '#### EACH RELEASE IS FORBIDDEN !             ####'
      error stop
  endif

  ! Inversion output format only for backward runs
  !*****************************************************************************
  
  if ((linversionout.eq.1).and.(ldirect.eq.1)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### INVERSION OUTPUT FORMAT ONLY FOR        ####'
      write(*,*) '#### BACKWARD RUNS                           ####'
      error stop
  endif


  ! For domain-filling trajectories, a plume centroid trajectory makes no sense,
  ! For backward runs, only residence time output (iout=1) or plume trajectories (iout=4),
  ! or both (iout=5) makes sense; other output options are "forbidden"
  !*****************************************************************************

  if (ldirect.lt.0) then
    if ((iout.eq.2).or.(iout.eq.3)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR BACKWARD RUNS, IOUT MUST BE 1,4,OR 5####'
      error stop
    endif
  endif


  ! For domain-filling trajectories, a plume centroid trajectory makes no sense,
  ! and is "forbidden"
  !*****************************************************************************

  if (mdomainfill.ge.1) then
    if ((iout.eq.4).or.(iout.eq.5)) then
      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
      write(*,*) '#### FOR DOMAIN-FILLING TRAJECTORY OPTION,   ####'
      write(*,*) '#### IOUT MUST NOT BE SET TO 4 OR 5.         ####'
      error stop
    endif
  endif

  ! Check whether a valid options for particle dump has been chosen
  !****************************************************************

  if ((ipout.ne.0).and.(ipout.ne.1).and.(ipout.ne.2).and.(ipout.ne.3)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### IPOUT MUST BE 0, 1, 2 OR 3!             #### '
    error stop
  endif

  ! Check whether input and output settings don't contradict
  !*********************************************************
  ! if (((iout.eq.4).or.(iout.eq.5)).and.((ipin.eq.3).or.(ipin.eq.4))) then
  !   write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
  !   write(*,*) ' #### IOUT CANNOT BE 4 or 5 (plume) WHEN      #### '
  !   write(*,*) ' #### READING FROM part_ic.nc (ipin=4/5)      #### '
  !   error stop
  ! endif    

  if(lsubgrid.ne.1.and.verbosity.eq.0) then
    write(*,*) '             ----------------               '
    write(*,*) ' INFORMATION: SUBGRIDSCALE TERRAIN EFFECT IS'
    write(*,*) ' NOT PARAMETERIZED DURING THIS SIMULATION.  '
    write(*,*) '             ----------------               '
  endif


  ! Check whether convection scheme is either turned on or off
  !***********************************************************

  if ((lconvection.ne.0).and.(lconvection.ne.1)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
    write(*,*) ' #### LCONVECTION MUST BE SET TO EITHER 1 OR 0#### '
    error stop
  endif


  ! Check whether synchronisation interval is sufficiently short
  !*************************************************************

  if (lsynctime.gt.(idiffnorm/2)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! SYNCHRONISATION   #### '
    write(*,*) ' #### TIME IS TOO LONG. MAKE IT SHORTER.      #### '
    write(*,*) ' #### MINIMUM HAS TO BE: ', idiffnorm/2
    error stop
  endif


  ! Check consistency of the intervals, sampling periods, etc., for model output
  !*****************************************************************************

  if (loutaver.eq.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! TIME AVERAGE OF   #### '
    write(*,*) ' #### CONCENTRATION FIELD OUTPUT MUST NOT BE  #### '
    write(*,*) ' #### ZERO.                                   #### '
    write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
    error stop
  endif

  if (loutaver.gt.loutstep) then
    write(*,*) ' #### FLEXPART MODEL ERROR! TIME AVERAGE OF   #### '
    write(*,*) ' #### CONCENTRATION FIELD OUTPUT MUST NOT BE  #### '
    write(*,*) ' #### GREATER THAN INTERVAL OF OUTPUT.        #### '
    write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
    error stop
  endif

  if (loutsample.gt.loutaver) then
    write(*,*) ' #### FLEXPART MODEL ERROR! SAMPLING TIME OF  #### '
    write(*,*) ' #### CONCENTRATION FIELD OUTPUT MUST NOT BE  #### '
    write(*,*) ' #### GREATER THAN TIME AVERAGE OF OUTPUT.    #### '
    write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
    error stop
  endif

  if (mod(loutaver,lsynctime).ne.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! AVERAGING TIME OF #### '
    write(*,*) ' #### CONCENTRATION FIELD MUST BE A MULTIPLE  #### '
    write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
    error stop
  endif

  if ((loutaver/lsynctime).lt.2) then
    write(*,*) ' #### FLEXPART MODEL ERROR! AVERAGING TIME OF #### '
    write(*,*) ' #### CONCENTRATION FIELD MUST BE AT LEAST    #### '
    write(*,*) ' #### TWICE THE SYNCHRONISATION INTERVAL      #### '
    error stop
  endif

  if (mod(loutstep,lsynctime).ne.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! INTERVAL BETWEEN  #### '
    write(*,*) ' #### CONCENTRATION FIELDS MUST BE A MULTIPLE #### '
    write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
    error stop
  endif

  if ((loutstep/lsynctime).lt.2) then
    write(*,*) ' #### FLEXPART MODEL ERROR! INTERVAL BETWEEN  #### '
    write(*,*) ' #### CONCENTRATION FIELDS MUST BE AT LEAST   #### '
    write(*,*) ' #### TWICE THE SYNCHRONISATION INTERVAL      #### '
    error stop
  endif

  if (mod(loutsample,lsynctime).ne.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! SAMPLING TIME OF  #### '
    write(*,*) ' #### CONCENTRATION FIELD MUST BE A MULTIPLE  #### '
    write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
    error stop
  endif

  if ((mquasilag.eq.1).and.(iout.ge.4)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! CONFLICTING       #### '
    write(*,*) ' #### OPTIONS: IF MQUASILAG=1, PLUME          #### '
    write(*,*) ' #### TRAJECTORY OUTPUT IS IMPOSSIBLE.        #### '
    error stop
  endif

  ! Check consistency of the intervals for receptors
  ! ************************************************
  ! only if ldirect=1 

  if (ldirect.eq.1) then

    if (lrecoutaver.eq.0) then
      write(*,*) ' #### FLEXPART MODEL ERROR! TIME AVERAGE OF   #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST NOT BE ZERO        #### '
      write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
      stop
    endif

    if (lrecoutaver.gt.lrecoutstep) then
      write(*,*) ' #### FLEXPART MODEL ERROR! TIME AVERAGE OF   #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST NOT BE             #### '
      write(*,*) ' #### GREATER THAN INTERVAL OF OUTPUT.        #### '
      write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
      stop
    endif

    if (lrecoutsample.gt.lrecoutaver) then
      write(*,*) ' #### FLEXPART MODEL ERROR! SAMPLING TIME OF  #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST NOT BE             #### '
      write(*,*) ' #### GREATER THAN TIME AVERAGE OF OUTPUT.    #### '
      write(*,*) ' #### CHANGE INPUT IN FILE COMMAND.           #### '
      stop
    endif

    if (mod(lrecoutaver,lsynctime).ne.0) then
      write(*,*) ' #### FLEXPART MODEL ERROR! AVERAGING TIME OF #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST BE A MULTIPLE      #### '
      write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
      stop
    endif

    if ((lrecoutaver/lsynctime).lt.2) then
      write(*,*) ' #### FLEXPART MODEL ERROR! AVERAGING TIME OF #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST BE AT LEAST        #### '
      write(*,*) ' #### TWICE THE SYNCHRONISATION INTERVAL      #### '
      stop
    endif

    if (mod(lrecoutstep,lsynctime).ne.0) then
      write(*,*) ' #### FLEXPART MODEL ERROR! INTERVAL BETWEEN  #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST BE A MULTIPLE      #### '
      write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
      stop
    endif

    if ((lrecoutstep/lsynctime).lt.2) then
      write(*,*) ' #### FLEXPART MODEL ERROR! INTERVAL BETWEEN  #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST BE AT LEAST        #### '
      write(*,*) ' #### TWICE THE SYNCHRONISATION INTERVAL      #### '
      stop
    endif

    if (mod(lrecoutsample,lsynctime).ne.0) then
      write(*,*) ' #### FLEXPART MODEL ERROR! SAMPLING TIME OF  #### '
      write(*,*) ' #### RECEPTOR OUTPUT MUST BE A MULTIPLE      #### '
      write(*,*) ' #### OF THE SYNCHRONISATION INTERVAL         #### '
      stop
    endif

  endif ! ldirect

  ! Switch for LCM mode
  !*******************************************************************

  if ( (lcmoutput.ne.0) .and. ((.not. ind_source.eq.1).or. &
    (.not. ind_receptor.eq.1).or.(.not. iout.eq.2).or. &
    (.not. ldirect.eq.1).or.(.not. mdomainfill.eq.1)) ) then
    write(*,*) 'LCM output requested, but one of the following options'
    write(*,*) 'is not correctly set in COMMAND:'
    write(*,*) 'ind_source =', ind_source, 'should be set to 1'
    write(*,*) 'ind_receptor =', ind_receptor, 'should be set to 1'
    write(*,*) 'iout =', iout, 'should be set to 2'
    write(*,*) 'ldirect =', ldirect, 'should be set to 1'
    write(*,*) 'mdomainfill =', mdomainfill, 'should be set to 1'
    error stop
  endif
  if (lcmoutput.eq.0) then
    llcmoutput=.false.
  else
    llcmoutput=.true.
  endif

  write(*,*) 'Switch for LCM output LCMOUTPUT = ',llcmoutput

  ! Compute modeling time in seconds and beginning date in Julian date
  !*******************************************************************

  outstep=real(abs(loutstep))
  if (ldirect.eq.1) then
    bdate=juldate(ibdate,ibtime)
    edate=juldate(iedate,ietime)
    ideltas=nint((edate-bdate)*86400.)
  else if (ldirect.eq.-1) then
    loutaver=-1*loutaver
    loutstep=-1*loutstep
    loutsample=-1*loutsample
    lsynctime=-1*lsynctime
    bdate=juldate(iedate,ietime)
    edate=juldate(ibdate,ibtime)
    ideltas=nint((edate-bdate)*86400.)
  else
    write(*,*) ' #### FLEXPART MODEL ERROR! DIRECTION IN      #### '
    write(*,*) ' #### FILE "COMMAND" MUST BE EITHER -1 OR 1.  #### '
    error stop
  endif

  return

999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "COMMAND"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  error stop

1000   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "COMMAND"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(2)(1:length(2))
  error stop
end subroutine readcommand

subroutine readdepo

  !*****************************************************************************
  !                                                                            *
  !  Reads dry deposition parameters needed by the procedure of Wesely (1989). *
  !  Wesely (1989): Parameterization of surface resistances to gaseous         *
  !  dry deposition in regional-scale numerical models.                        *
  !  Atmos. Environ. 23, 1293-1304.                                            *
  !                                                                            *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 19 May 1995                                    *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! rcl(maxspec,5,9) [s/m] Lower canopy resistance                             *
  ! rgs(maxspec,5,9) [s/m] Ground resistance                                   *
  ! rlu(maxspec,5,9) [s/m] Leaf cuticular resistance                           *
  ! rm(maxspec) [s/m]      Mesophyll resistance, set in readreleases           *
  ! ri(maxspec) [s/m]      Stomatal resistance                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  ! FOR THIS SUBROUTINE, numclass=9 IS ASSUMED
  !*******************************************

  real :: rluh(5,numclass),rgssh(5,numclass),rgsoh(5,numclass)
  real :: rclsh(5,numclass),rcloh(5,numclass)
  integer :: i,j,ic
  logical :: ios, ios2
  character(12) :: file_sfcdepo


  ! Read deposition constants related with landuse and seasonal category
  !*********************************************************************
  file_sfcdepo='sfcdepo.t'
  inquire(file=path(1)(1:length(1))//trim(file_sfcdepo),exist=ios)
  if (.not. ios) then
    file_sfcdepo='surfdepo.t'
    inquire(file=path(1)(1:length(1))//trim(file_sfcdepo),exist=ios2)
    if (ios2) then
      write(*,*) 'WARNING: surfdepo.t should be renamed to sfcdepo.t'
      write(*,*) 'Continuing with surfdepo.t'
    endif
  endif

  open(unitwesely,file=path(1)(1:length(1))//trim(file_sfcdepo), &
       status='old',err=999)

  do i=1,16
    read(unitwesely,*)
  end do
  do i=1,5
    read(unitwesely,*)
    read(unitwesely,'(8x,13f8.0)') (ri(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rluh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rac(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rgssh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rgsoh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rclsh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rcloh(i,j),j=1,numclass)
  end do

  ! TEST
  ! do 31 i=1,5
  !   ri(i,13)=ri(i,5)
  !   rluh(i,13)=rluh(i,5)
  !   rac(i,13)=rac(i,5)
  !   rgssh(i,13)=rgssh(i,5)
  !   rgsoh(i,13)=rgsoh(i,5)
  !   rclsh(i,13)=rclsh(i,5)
  !   rcloh(i,13)=rcloh(i,5)
  !31             continue
  ! TEST
  ! Sabine Eckhardt, Dec 06, set resistances of 9999 to 'infinite' (1E25)
  do i=1,5
    do j=1,numclass
      if    (ri(i,j).eq.9999.)    ri(i,j)=1.E25
      if  (rluh(i,j).eq.9999.)  rluh(i,j)=1.E25
      if   (rac(i,j).eq.9999.)   rac(i,j)=1.E25
      if (rgssh(i,j).eq.9999.) rgssh(i,j)=1.E25
      if (rgsoh(i,j).eq.9999.) rgsoh(i,j)=1.E25
      if (rclsh(i,j).eq.9999.) rclsh(i,j)=1.E25
      if (rcloh(i,j).eq.9999.) rcloh(i,j)=1.E25
    end do
  end do



  do i=1,5
    do j=1,numclass
      ri(i,j)=max(ri(i,j),0.001)
      rluh(i,j)=max(rluh(i,j),0.001)
      rac(i,j)=max(rac(i,j),0.001)
      rgssh(i,j)=max(rgssh(i,j),0.001)
      rgsoh(i,j)=max(rgsoh(i,j),0.001)
      rclsh(i,j)=max(rclsh(i,j),0.001)
      rcloh(i,j)=max(rcloh(i,j),0.001)
    end do
  end do
  close(unitwesely)


  ! Compute additional parameters
  !******************************

  do ic=1,nspec
    if (reldiff(ic).gt.0.) then     ! gas is dry deposited
      do i=1,5
        do j=1,numclass
          rlu(ic,i,j)=rluh(i,j)/(1.e-5*henry(ic)+f0(ic))
          rgs(ic,i,j)=1./(henry(ic)/(10.e5*rgssh(i,j))+f0(ic)/ &
               rgsoh(i,j))
          rcl(ic,i,j)=1./(henry(ic)/(10.e5*rclsh(i,j))+f0(ic)/ &
               rcloh(i,j))
        end do
      end do
    endif
  end do


  return

999   write(*,*) '### FLEXPART ERROR! FILE              ###'
  write(*,*) '### sfcdepo.t DOES NOT EXIST.        ###'
  error stop
end subroutine readdepo

subroutine readlanduse

  !*****************************************************************************
  !                                                                            *
  !      Reads the landuse inventory into memory and relates it to Leaf Area   *
  !      Index and roughness length.                                           *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 10 January 1994                                *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! i                       loop indices                                       *
  ! landinvent(1200,600,13) area fractions of 13 landuse categories            *
  ! LENGTH(numpath)         length of the path names                           *
  ! PATH(numpath)           contains the path names                            *
  ! unitland                unit connected with landuse inventory              *
  !                                                                            *
  ! -----                                                                      *
  ! Sabine Eckhardt, Dec 06 - new landuse inventary                            *
  ! after                                                                      *
  ! Belward, A.S., Estes, J.E., and Kline, K.D., 1999,                         *
  ! The IGBP-DIS 1-Km Land-Cover Data Set DISCover:                            *
  ! A Project Overview: Photogrammetric Engineering and Remote Sensing,        *
  ! v. 65, no. 9, p. 1013-1020                                                 *
  !                                                                            *
  ! LANDUSE CATEGORIES:                                                        *
  !                                                                            *
  ! 1   Urban land                                                             *
  ! 2   Agricultural land                                                      *
  ! 3   Range land                                                             *
  ! 4   Deciduous forest                                                       *
  ! 5   Coniferous forest                                                      *
  ! 6   Mixed forest including wetland                                         *
  ! 7   water, both salt and fresh                                             *
  ! 8   barren land mostly desert                                              *
  ! 9   nonforested wetland                                                    *
  ! 10  mixed agricultural and range land                                      *
  ! 11  rocky open areas with low growing shrubs                               *
  ! 12  ice                                                                    *
  ! 13  rainforest                                                             *
  !                                                                            *
  !*****************************************************************************

  use drydepo_mod
  
  implicit none

  integer :: ix,jy,i,k,lu_cat,lu_perc
  integer(kind=1) :: ilr
  integer(kind=1) :: ilr_buffer(2160000)
  integer :: il,irecread
  real :: rlr, r2lr
  logical :: ios,ios2
  character(12) :: file_sfcdata


  ! Read landuse inventory
  !***********************
  ! The landuse information is saved in a compressed format and written
  ! out by records of the length of 1 BYTE. Each grid cell consists of 3
  ! Bytes, which include 3 landuse categories (val 1-13 and 16 percentage
  ! categories) So one half byte is used to store the Landusecat the other
  ! for the percentageclass in 6.25 steps (100/6.25=16)
  ! e.g.
  ! 4 3  percentage 4 = 4*6.25 => 25% landuse class 3
  ! 2 1  percentage 2 = 2*6.25 => 13% landuse class 1
  ! 1 12 percentage 1 = 1*6.26 => 6.25% landuse class 12

  open(unitland,file=path(1)(1:length(1))//'IGBP_int1.dat',status='old', &
    form='UNFORMATTED', err=998, convert='little_endian')
  read (unitland) (ilr_buffer(i),i=1,2160000)
  close(unitland)

  irecread=1
  do ix=1,1200
    do jy=1,600
  ! the 3 most abundant landuse categories in the inventory
  ! first half byte contains the landuse class
  ! second half byte contains the respective percentage
      do k=1,3
  ! 1 byte is read
        ilr=ilr_buffer(irecread)
  !      ilr=0
        irecread=irecread+1
  ! as only signed integer values exist an unsigned value is constructed
        if (ilr.lt.0) then
           il=ilr+256
        else
           il=ilr
        endif
  ! dividing by 16 has the effect to get rid of the right half of the byte
  ! so just the left half remains, this corresponds to a shift right of 4
  ! bits
        rlr=real(il)/16.
        lu_cat=int(rlr)
  ! the left half of the byte is substracted from the whole in order to
  ! get only the right half of the byte
        r2lr=rlr-int(rlr)
  ! shift left by 4
        lu_perc=int(r2lr*16.)
        landinvent(ix,jy,k)=lu_cat
        landinvent(ix,jy,k+3)=lu_perc
  ! if ((jy.lt.10).and.(ix.lt.10)) write(*,*) 'reading: ',ix,jy,lu_cat,lu_perc
      end do
    end do
  end do

  ! Read relation landuse,z0
  !*****************************
  file_sfcdata='sfcdata.t'
  inquire(file=path(1)(1:length(1))//trim(file_sfcdata),exist=ios)
  if (.not. ios) then
    file_sfcdata='surfdata.t'
    inquire(file=path(1)(1:length(1))//trim(file_sfcdata),exist=ios2)
    if (ios2) then
      write(*,*) 'WARNING: surfdata.t should be renamed to sfcdata.t'
      write(*,*) 'Continuing with surfdata.t'
    endif
  endif

  open(unitsfcdata,file=path(1)(1:length(1))//trim(file_sfcdata), &
            status='old',err=999)

  do i=1,4
    read(unitsfcdata,*)
  end do
  do i=1,numclass
    read(unitsfcdata,'(45x,f15.3)') z0(i)
  end do
  close(unitsfcdata)

  return

  ! Issue error messages
  !*********************
998 write(*,*) ' #### FLEXPART ERROR! FILE                     ####'
  write(*,*)   ' #### ', path(1)(1:length(1))//'IGBP_int1.dat'
  write(*,*)   " #### (LANDUSE INVENTORY) COULD NOT BE OPENED  ####"
  error stop

999 write(*,*) ' #### FLEXPART ERROR! FILE              ####'
  write(*,*)   ' #### ', path(1)(1:length(1))//'sfcdata.t'
  write(*,*)   ' #### DOES NOT EXIST.                   ####'
  error stop
end subroutine readlanduse

subroutine readoutgrid

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the output grid.        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     4 June 1996                                                            *
  !     HSO, 1 July 2014
  !     Added optional namelist input
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dxout,dyout          grid distance                                         *
  ! numxgrid,numygrid,numzgrid    grid dimensions                              *
  ! outlon0,outlat0      lower left corner of grid                             *
  ! outheight(maxzgrid)  height levels of output grid [m]                      *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitoutgrid          unit connected to file OUTGRID                        *
  !                                                                            *
  !*****************************************************************************

  use outgrid_mod

  implicit none

  integer :: i,j,stat
  real :: outhelp,xr,xr1,yr,yr1
  real,parameter :: eps=1.e-4

  ! namelist variables
  integer, parameter :: maxoutlev=500
  integer :: ios
  real,allocatable, dimension (:) :: outheights

  ! declare namelist
  namelist /outgrid/ &
    outlon0,outlat0, &
    numxgrid,numygrid, &
    dxout,dyout, &
    outheights

  ! allocate large array for reading input
  allocate(outheights(maxoutlev),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate outheights'

  ! helps identifying failed namelist input
  dxout=-1.0
  outheights=-1.0

  ! Open the OUTGRID file and read output grid specifications
  !**********************************************************

  open(unitoutgrid,file=path(1)(1:length(1))//'OUTGRID',status='old', &
    form='formatted',err=999)

  ! try namelist input
  read(unitoutgrid,outgrid,iostat=ios)
  close(unitoutgrid)

  if ((dxout.le.0).or.(ios.ne.0)) then

    ios=1

    open(unitoutgrid,file=path(1)(1:length(1))//'OUTGRID',status='old',err=999)

    call skplin(5,unitoutgrid)

    ! 1.  Read horizontal grid specifications
    !****************************************

    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f11.4)') outlon0
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f11.4)') outlat0
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,i5)') numxgrid
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,i5)') numygrid
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f12.5)') dxout
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f12.5)') dyout

  endif

  ! Check validity of output grid (shall be within model domain)
  !*************************************************************

  xr=outlon0+real(numxgrid)*dxout
  yr=outlat0+real(numygrid)*dyout
  xr1=xlon0+real(nxmin1)*dx
  yr1=ylat0+real(nymin1)*dy
  if ((outlon0+eps.lt.xlon0).or.(outlat0+eps.lt.ylat0) &
       .or.(xr.gt.xr1+eps).or.(yr.gt.yr1+eps)) then
    write(*,*) outlon0,outlat0
    write(*,*) xr1,yr1,xlon0,ylat0,xr,yr,dxout,dyout
    write(*,*) ' #### FLEXPART MODEL ERROR! PART OF OUTPUT    ####'
    write(*,*) ' #### GRID IS OUTSIDE MODEL DOMAIN. CHANGE    ####'
    write(*,*) ' #### FILE OUTGRID IN DIRECTORY               ####'
    write(*,'(a)') path(1)(1:length(1))
    error stop
  endif

  ! 2. Count Vertical levels of output grid
  !****************************************

  if (ios.ne.0) then
    j=0
100 j=j+1
    do i=1,3
      read(unitoutgrid,*,end=99)
    end do
    read(unitoutgrid,'(4x,f7.1)',end=99) outhelp
    if (outhelp.eq.0.) goto 99
    goto 100
99  numzgrid=j-1
  else
    do i=1,maxoutlev
      if (outheights(i).lt.0) exit
    end do
    numzgrid=i-1
  end if

  allocate(outheight(numzgrid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate outheight'
  allocate(outheighthalf(numzgrid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate outheighthalf'

  ! 2. Vertical levels of output grid
  !**********************************

  if (ios.ne.0) then

    rewind(unitoutgrid)
    call skplin(29,unitoutgrid)

    do j=1,numzgrid
      do i=1,3
        read(unitoutgrid,*)
      end do
      read(unitoutgrid,'(4x,f7.1)') outhelp
      outheight(j)=outhelp
      outheights(j)=outhelp
    end do
    close(unitoutgrid)

  else

    do j=1,numzgrid
      outheight(j)=outheights(j)
    end do

  endif

  ! write outgrid file in namelist format to output directory if requested
  if (nmlout.and.lroot) then
    ! reallocate outheights with actually required dimension for namelist writing
    deallocate(outheights)
    allocate(outheights(numzgrid),stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outheights'

    do j=1,numzgrid
      outheights(j)=outheight(j)
    end do

    open(unitoutgrid,file=path(2)(1:length(2))//'OUTGRID.namelist',err=1000)
    write(unitoutgrid,nml=outgrid)
    close(unitoutgrid)
  endif

  ! Check whether vertical levels are specified in ascending order
  !***************************************************************

  do j=2,numzgrid
    if (outheight(j).le.outheight(j-1)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! YOUR SPECIFICATION#### '
    write(*,*) ' #### OF OUTPUT LEVELS IS CORRUPT AT LEVEL    #### '
    write(*,*) ' #### ',j,'                              #### '
    write(*,*) ' #### PLEASE MAKE CHANGES IN FILE OUTGRID.    #### '
    endif
  end do

  ! Determine the half levels, i.e. middle levels of the output grid
  !*****************************************************************

  outheighthalf(1)=outheight(1)*0.5
  do j=2,numzgrid
    outheighthalf(j)=(outheight(j-1)+outheight(j))*0.5
  end do

  xoutshift=xlon0-outlon0
  youtshift=ylat0-outlat0

  allocate(oroout(0:numxgrid-1,0:numygrid-1),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate oroout'
  allocate(area(0:numxgrid-1,0:numygrid-1),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate area'
  allocate(volume(0:numxgrid-1,0:numygrid-1,numzgrid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate volume'
  allocate(areaeast(0:numxgrid-1,0:numygrid-1,numzgrid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate areaeast'
  allocate(areanorth(0:numxgrid-1,0:numygrid-1,numzgrid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate areanorth'
  return

999 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "OUTGRID"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  error stop

1000 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "OUTGRID"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(2)(1:length(2))
  error stop
end subroutine readoutgrid

subroutine readoutgrid_nest

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the output nest.        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     4 June 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dxoutn,dyoutn        grid distances of output nest                         *
  ! numxgridn,numygridn,numzgrid    nest dimensions                            *
  ! outlon0n,outlat0n    lower left corner of nest                             *
  ! outheight(maxzgrid)  height levels of output grid [m]                      *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitoutgrid          unit connected to file OUTGRID                        *
  !                                                                            *
  !*****************************************************************************

  use outgrid_mod

  implicit none

  integer :: stat
  real :: xr,xr1,yr,yr1
  real,parameter :: eps=1.e-4

  integer :: ios

  ! declare namelist
  namelist /outgridn/ &
    outlon0n,outlat0n, &
    numxgridn,numygridn, &
    dxoutn,dyoutn

  ! helps identifying failed namelist input
  dxoutn=-1.0

  ! Open the OUTGRID file and read output grid specifications
  !**********************************************************

  open(unitoutgrid,file=path(1)(1:length(1))//'OUTGRID_NEST',form='formatted',status='old',err=999)

  ! try namelist input
  read(unitoutgrid,outgridn,iostat=ios)
  close(unitoutgrid)

  if ((dxoutn.le.0).or.(ios.ne.0)) then

    open(unitoutgrid,file=path(1)(1:length(1))//'OUTGRID_NEST',status='old',err=999)
    call skplin(5,unitoutgrid)

    ! 1.  Read horizontal grid specifications
    !****************************************

    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f11.4)') outlon0n
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f11.4)') outlat0n
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,i5)') numxgridn
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,i5)') numygridn
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f12.5)') dxoutn
    call skplin(3,unitoutgrid)
    read(unitoutgrid,'(4x,f12.5)') dyoutn

    close(unitoutgrid)
  endif

  ! write outgrid_nest file in namelist format to output directory if requested
  if (nmlout.and.lroot) then
    open(unitoutgrid,file=path(2)(1:length(2))//'OUTGRID_NEST.namelist',err=1000)
    write(unitoutgrid,nml=outgridn)
    close(unitoutgrid)
  endif

  allocate(orooutn(0:numxgridn-1,0:numygridn-1),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate orooutn'
  allocate(arean(0:numxgridn-1,0:numygridn-1),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate arean'
  allocate(volumen(0:numxgridn-1,0:numygridn-1,numzgrid),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate volumen'

  ! Check validity of output grid (shall be within model domain)
  !*************************************************************

  xr=outlon0n+real(numxgridn)*dxoutn
  yr=outlat0n+real(numygridn)*dyoutn
  xr1=xlon0+real(nxmin1)*dx
  yr1=ylat0+real(nymin1)*dy
  if ((outlon0n+eps.lt.xlon0).or.(outlat0n+eps.lt.ylat0) &
       .or.(xr.gt.xr1+eps).or.(yr.gt.yr1+eps)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! PART OF OUTPUT    ####'
    write(*,*) ' #### NEST IS OUTSIDE MODEL DOMAIN. CHANGE    ####'
    write(*,*) ' #### FILE OUTGRID IN DIRECTORY               ####'
    write(*,'(a)') path(1)(1:length(1))
    error stop
  endif

  xoutshiftn=xlon0-outlon0n
  youtshiftn=ylat0-outlat0n
  return

999 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "OUTGRID"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  error stop

1000 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "OUTGRID"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(2)(1:length(2))
  error stop
end subroutine readoutgrid_nest

subroutine readpaths

  !*****************************************************************************
  !                                                                            *
  !     Reads the pathnames, where input/output files are expected to be.      *
  !     The file pathnames must be available in the current working directory. *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     1 February 1994                                                        *
  !     last modified                                                          *
  !     HS, 7.9.2012                                                           *
  !     option to give pathnames file as command line option                   *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! length(numpath)    lengths of the path names                               *
  ! path(numpath)      pathnames of input/output files                         *
  !                                                                            *
  ! Constants:                                                                 *
  ! numpath            number of pathnames to be read in                       *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer   :: i
  character(256) :: string_test 
  character(1) :: character_test 

  ! Read the pathname information stored in unitpath
  !*************************************************

  open(unitpath,file=trim(pathfile),status='old',err=999)

  do i=1,numpath
    read(unitpath,'(a)',err=998) path(i)
    length(i)=index(path(i),' ')-1

    
    string_test = path(i)
    character_test = string_test(length(i):length(i))
    !print*, 'character_test,  string_test ', character_test,  string_test 
      if ((character_test .NE. '/') .AND. (i .LT. 4))  then
         print*, 'WARNING: path not ending in /' 
         print*, path(i)
         path(i) = string_test(1:length(i)) // '/'
         length(i)=length(i)+1
         print*, 'fix: padded with /' 
         print*, path(i)
         print*, 'length(i) increased 1' 
      endif
  end do

  ! Check whether any nested subdomains are to be used
  !***************************************************

  do i=1,maxnests
  ! ESO 2016 Added 'end'/'err' in case user forgot '====' at end of file and
  ! maxnests > numbnests
    read(unitpath,'(a)', end=30, err=30) path(numpath+2*(i-1)+1)
    read(unitpath,'(a)', end=30, err=30) path(numpath+2*(i-1)+2)
    if (path(numpath+2*(i-1)+1)(1:5).eq.'=====') goto 30
    length(numpath+2*(i-1)+1)=index(path(numpath+2*(i-1)+1),' ')-1
    length(numpath+2*(i-1)+2)=index(path(numpath+2*(i-1)+2),' ')-1
  end do


  ! Determine number of available nested domains
  !*********************************************

30  numbnests=i-1

  close(unitpath)
  return

998   write(*,*) ' #### TRAJECTORY MODEL ERROR! ERROR WHILE     #### '
  write(*,*) ' #### READING FILE PATHNAMES.                 #### '
  error stop

999   write(*,*) ' #### TRAJECTORY MODEL ERROR! FILE "pathnames"#### '
  write(*,*) ' #### CANNOT BE OPENED IN THE CURRENT WORKING #### '
  write(*,*) ' #### DIRECTORY.                              #### '
  error stop
end subroutine readpaths

subroutine readreceptors

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the receptor points.    *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !     1 August 1996                                                          *
  !                                                                            *
  !     HSO, 14 August 2013: Added optional namelist input
  !     PS, 2/2015: access= -> position=
  !     PS, 6/2015: variable names, simplify code
  !     PS, 3/2023: remove position=append, makes no sense for new file        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! receptorarea   area of dx*dy at location of receptor                       *
  ! receptorname   names of receptors                                          *
  ! xreceptor,yreceptor  coordinates of receptor points                        *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitreceptor         unit connected to file RECEPTORS                      *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: j
  real :: xm,ym
  character(len=16) :: receptor

  integer :: ios
  real :: lon,lat,alt   ! for namelist input, lon/lat are used instead of x,y
  real(kind=dp) :: time

!  real,allocatable,dimension(:) :: tmpxrec,tmpyrec,tmprecarea
!  character(len=16),allocatable,dimension(:) :: tmprecname

  ! declare namelist
  namelist /receptors/ &
    receptor, lon, lat, alt, time

  numreceptor=0 ! Initialise numreceptor

  ! For backward runs no receptor output
  !*************************************

  if (ldirect.lt.0) then
    return
  endif

  ! Open the RECEPTORS file and read output grid specifications
  !************************************************************

  open (unitreceptor,file=trim(path(1))//'RECEPTORS',form='formatted', &
    status='old',err=999)

  lon = -999.
  lat = -999.
  time = -999.
  lrecregular = .false.

  ! try namelist input
  read(unitreceptor,receptors,iostat=ios)
  close (unitreceptor)

  if ((lon.lt.-900).or.(ios.ne.0)) then
    go to 999
  else ! only namelist input possible

    ! prepare namelist output if requested
    if (nmlout) open(unitreceptorout,file=trim(path(2))// &
      'RECEPTORS.namelist',status='replace',err=1000)  

    ! Get number of receptors
    !************************
    open (unitreceptor,file=trim(path(1))//'RECEPTORS',status='old',err=999)
    j=0
    do while (ios.eq.0)
      lon=-999.9
      read(unitreceptor,receptors,iostat=ios)
      if ((lon.lt.-900).or.(ios.ne.0)) exit    
      ! skip receptors for which a timestamp is given but are not in simulation window 
      if ((time.ne.-999.).and.((time.lt.bdate).or.(time.ge.edate))) cycle 
      j=j+1
    end do
    numreceptor=j
    write(*,*) 'Number of receptors: ',numreceptor
    close (unitreceptor)

    ! Allocate arrays
    !****************

    allocate(receptorname(numreceptor),xreceptor(numreceptor),&
              yreceptor(numreceptor),zreceptor(numreceptor),&
              treceptor(numreceptor),receptorarea(numreceptor))

    ! Read the names and coordinates of the receptors
    !************************************************

    open (unitreceptor,file=trim(path(1))//'RECEPTORS',status='old',iostat=ios)
    j=0
    do while (ios.eq.0)
      lon=-999.9
      read(unitreceptor,receptors,iostat=ios)
      if ((lon.lt.-900).or.(ios.ne.0)) exit          ! read error
      ! skip receptors for which a timestamp is given but are not in simulation window 
      if ((time.ne.-999.).and.((time.lt.bdate).or.(time.ge.edate))) cycle 
      j=j+1
      receptorname(j)=receptor
      xreceptor(j)=(lon-xlon0)/dx       ! transform to grid coordinates
      yreceptor(j)=(lat-ylat0)/dy
      zreceptor(j)=alt
      if (time.ne.-999.) then
        treceptor(j)=int((time-bdate)*24.*3600.) ! time in sec
        ! round to nearest 10 seconds
        treceptor(j)=nint(real(treceptor(j))/10.)*10
      else
        treceptor(j)=-999
      endif
      xm=r_earth*cos(lat*pi/180.)*dx/180.*pi
      ym=r_earth*dy/180.*pi
      receptorarea(j)=xm*ym
      ! write receptors in namelist format to output directory if requested
      if (nmlout) write(unitreceptorout,nml=receptors)
    end do
    close (unitreceptor)
    if (nmlout) close (unitreceptorout)

  endif 

  ! if not timestamp given in namelist assume regular output
  ! according to COMMAND file settings
  if (.not.any(treceptor.ne.-999)) then
    lrecregular=.true.
  endif

  !! testing
!  write(*,*) 'readreceptors: '
!  do j=1,numreceptor
!    print*, 'receptorname = ',receptorname(j)
!    print*, 'xreceptor, yreceptor, zreceptor = ',xreceptor(j), yreceptor(j), zreceptor(j)
!    print*, 'treceptor = ',treceptor(j)
!  end do
  !!

  return

999 write(*,*) ' #### FLEXPART WARNING: File RECEPTORS cannot be opened #### '
    write(*,*) ' #### in directory '//trim(path(1))//' #### '
    write(*,*) ' #### continuing without RECEPTOR output #### '
  numreceptor=0
  return

1000 write(*,*) ' #### FLEXPART MODEL ERROR! File "RECEPTORS"      #### '
  write(*,*)    ' #### cannot be opened in the output directory    #### '
  write(*,'(a)') ' #### '//trim(path(2))
  write(*,*)    ' #### either write perm missing or old file exists ####'
  error stop

end subroutine readreceptors


subroutine readreleases

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the release point specifications for the current    *
  !     model run. Several release points can be used at the same time.        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     18 May 1996                                                            *
  !                                                                            *
  !     Update: 29 January 2001                                                *
  !     Release altitude can be either in magl or masl                         *
  !     HSO, 12 August 2013
  !     Added optional namelist input
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! decay               decay constant of species                              *
  ! dquer [um]          mean particle diameters                                *
  ! dsigma              e.g. dsigma=10 or dsigma=0.1 means that 68% of the mass*
  !                     are between 0.1*dquer and 10*dquer                     *
  ! ireleasestart, ireleaseend [s] starting time and ending time of each       *
  !                     release                                                *
  ! kindz               1: zpoint is in m agl, 2: zpoint is in m asl, 3: zpoint*
  !                     is in hPa                                              *
  ! npart               number of particles to be released                     *
  ! nspec               number of species to be released                       *
  ! density [kg/m3]     density of the particles                               *
  ! rm [s/m]            Mesophyll resistance                                   *
  ! species             name of species                                        *
  ! xmass               total mass of each species                             *
  ! xpoint1,ypoint1     geograf. coordinates of lower left corner of release   *
  !                     area                                                   *
  ! xpoint2,ypoint2     geograf. coordinates of upper right corner of release  *
  !                     area                                                   *
  ! weta_gas, wetb_gas  parameters for below-cloud scavenging (gas)            *
  ! crain_aero, csnow_aero  parameters for below-cloud scavenging (aerosol)    *
  ! ccn_aero, in_aero   parameters for in-cloud scavenging (aerosol)           *
  ! zpoint1,zpoint2     height range, over which release takes place           *
  ! num_min_discrete    if less, release cannot be randomized and happens at   *
  !                     time mid-point of release interval                     *
  ! lroot               true if serial version, or if MPI and root process     *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use xmass_mod
  use drydepo_mod

  implicit none

  integer :: numpartmax,i,j,id1,it1,id2,it2,stat,irel,ispc,nsettle
  integer,parameter :: num_min_discrete=100
  real :: releaserate,cun
  real(kind=dp) :: jul1,jul2,julm
  real,parameter :: eps2=1.e-9
  character(len=50) :: line

  ! help variables for namelist reading
  integer :: numpoints, parts, ios, nspec_init
  integer*2 :: zkind
  integer :: idate1, itime1, idate2, itime2
  real :: lon1,lon2,lat1,lat2,z1,z2
  character*40 :: comment
  integer,parameter :: unitreleasesout=2
  real,allocatable, dimension (:) :: mass
  integer,allocatable, dimension (:) :: specnum_rel,specnum_rel2
  real,allocatable,dimension(:) :: vsh,fracth,schmih

  ! declare namelists
  namelist /releases_ctrl/ &
       nspec, &
       specnum_rel

  namelist /release/ &
       idate1, itime1, &
       idate2, itime2, &
       lon1, lon2, &
       lat1, lat2, &
       z1, z2, &
       zkind, &
       mass, &
       parts, &
       comment

  numpoint=0
  nspec_init=50 ! necessary to allocate specnum_rel, would be cleaner to change RELEASES 
                ! in one extra namelist

  allocate(specnum_rel(nspec_init),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate specnum_rel'

  ! presetting namelist releases_ctrl
  nspec = -1  ! use negative value to determine failed namelist input
  specnum_rel = 0

  !sec, read release to find how many releasepoints should be allocated
  open(unitreleases,file=path(1)(1:length(1))//'RELEASES',status='old', &
    form='formatted',err=999)

  ! check if namelist input provided
  read(unitreleases,releases_ctrl,iostat=ios)

  if (nspec.gt.nspec_init) then
    write(*,*) 'Requested number of species:',nspec
    error stop 'More than 50 species at a time is not possible when using &
     & RELEASES. You can do this with the part_ic.nc option (IPIN=3).'
  end if
  ! Allocate fields with maxspec
  maxspec=nspec
  call alloc_com()
  ! allocate with maxspec for first input loop
  allocate(mass(maxspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate mass'

  if (ios.ne.0) then
        backspace(unitreleases)
        read(unitreleases,fmt='(A)') line
        if (lroot) write(*,*) &
             'Invalid line in RELEASES: '//trim(line)
            !cgz; Check if the number of species in RELEASES_CTRL is larger than the maximum number of species in par_mod
        if ((lroot) .and. nspec.gt.maxspec) goto 994
  end if
    
  ! prepare namelist output if requested
  if (nmlout.and.lroot) then
    open(unitreleasesout,file=path(2)(1:length(2))//'RELEASES.namelist', &
      access='append',status='replace',err=1000)
  endif

  if ((ios.ne.0).or.(nspec.lt.0)) then
    if (lroot) write(*,*) 'RELEASE either having unrecognised entries, &
      &or in old format, please update to namelist format.'
      error stop
  else
    if ((ipin.ne.3).and.(ipin.ne.4)) then ! Not necessary to read releases when using part_ic.nc
      ios=0
      do while (ios.eq.0) 
        idate1=-1
        read(unitreleases,release,iostat=ios)
        if ((idate1.lt.0).or.(ios.ne.0)) then
          ios=1
        else
          numpoint=numpoint+1
        endif
      end do
      ios=0
    else
      numpoint=1
    endif
  endif

  rewind(unitreleases)

  if (nspec.gt.maxspec) goto 994

  ! allocate arrays of matching size for number of species (namelist output)
  deallocate(mass)
  allocate(mass(nspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate mass'
  allocate(specnum_rel2(nspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate specnum_rel2'
  specnum_rel2=specnum_rel(1:nspec)
  deallocate(specnum_rel) 
  ! eso: BUG, crashes here for nspec=12 and maxspec=6,
  ! TODO: catch error and exit
  allocate(specnum_rel(nspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate specnum_rel'
  specnum_rel=specnum_rel2
  deallocate(specnum_rel2)

  !allocate memory for numpoint releaspoints
  allocate(ireleasestart(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate ireleasestart'
  allocate(ireleaseend(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate ireleaseend'
  allocate(xpoint1(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate xpoint1'
  allocate(xpoint2(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate xpoint2'
  allocate(ypoint1(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate ypoint1'
  allocate(ypoint2(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate ypoint2'
  allocate(zpoint1(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate zpoint1'
  allocate(zpoint2(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate zpoint2'
  allocate(kindz(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate kindz'
  allocate(xmass(numpoint,maxspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate xmass'
  allocate(rho_rel(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate rho_rel'
  allocate(npart(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate npart'
  allocate(xmasssave(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate xmasssave'

  if (lroot) write (*,*) 'Releasepoints : ', numpoint

  do i=1,numpoint
    xmasssave(i)=0.
  end do

  !now save the information
  DEP=.false.
  DRYDEP=.false.
  WETDEP=.false.
  CLREA=.false.
  LDECAY=.false.
  do i=1,maxspec
    DRYDEPSPEC(i)=.false.
    WETDEPSPEC(i)=.false.
  end do

  ! namelist output
  if (nmlout.and.lroot) then
    write(unitreleasesout,nml=releases_ctrl)
  endif

  do i=1,nspec
    call readspecies(specnum_rel(i),i)
  end do

  ! Allocate fields that depend on ndia
  call alloc_com_ndia

  do i=1,nspec

  ! Allocate temporary memory necessary for the different diameter bins
  !********************************************************************
    allocate( vsh(ndia(i)),fracth(ndia(i)),schmih(ndia(i)),stat=stat)
    if (stat.ne.0) error stop "Could not allocate vsh,fracth,schmih"

  ! Molecular weight
  !*****************

    if (((iout.eq.2).or.(iout.eq.3)).and.(weightmolar(i).lt.0.)) then
      write(*,*) 'For mixing ratio output, valid molar weight'
      write(*,*) 'must be specified for all simulated species.'
      write(*,*) 'Check table SPECIES or choose concentration'
      write(*,*) 'output instead if molar weight is not known.'
      error stop
    endif

  ! Radioactive decay
  !******************
    if (decay(i).gt.0) then
      LDECAY=.true.
      decay(i)=0.693147/decay(i) !conversion half life to decay constant
    endif

  ! Dry deposition of gases
  !************************

    if (reldiff(i).gt.0.) rm(i)=1./(henry(i)/3000.+100.*f0(i))    ! mesophyll resistance

  ! Dry deposition of particles
  !****************************

    vsetaver(i)=0.
    cunningham(i)=0.
    dquer(i)=dquer(i)*1000000.         ! Conversion m to um
    if (density(i).gt.0.) then         ! Additional parameters
      call part0(dquer(i),dsigma(i),density(i),ndia(i),fracth,schmih,cun,vsh)
      do j=1,ndia(i)
        fract(i,j)=fracth(j)
        schmi(i,j)=schmih(j)
        vset(i,j)=vsh(j)
        cunningham(i)=cunningham(i)+cun*fract(i,j)
        vsetaver(i)=vsetaver(i)-vset(i,j)*fract(i,j)
      end do
      if (lroot) write(*,*) 'Average settling velocity: ',i,vsetaver(i)
    endif

  ! Dry deposition for constant deposition velocity
  !************************************************

    dryvel(i)=dryvel(i)*0.01         ! conversion to m/s

  ! Check if wet deposition shall be calculated
  !*********************************************

  ! ESO 04.2016 check for below-cloud scavenging (gas or aerosol)
    if ((dquer(i).le.0..and.(weta_gas(i).gt.0. .or. wetb_gas(i).gt.0.)) .or. &
         &(dquer(i).gt.0. .and. (crain_aero(i) .gt. 0. .or. csnow_aero(i).gt.0.)))  then
      WETDEP=.true.
      WETDEPSPEC(i)=.true.
      if (lroot) then
        write (*,*) '  Below-cloud scavenging: ON'
  !  write (*,*) 'Below-cloud scavenging coefficients: ',weta(i),i
      end if
    else
      if (lroot) write (*,*) '  Below-cloud scavenging: OFF'
    endif

  ! NIK 31.01.2013 + 10.12.2013 + 15.02.2015
    if (dquer(i).gt.0..and.(ccn_aero(i).gt.0. .or. in_aero(i).gt.0.))  then
      WETDEP=.true.
      WETDEPSPEC(i)=.true.
      if (lroot) then
        write (*,*) '  In-cloud scavenging: ON'
  !        write (*,*) 'In-cloud scavenging coefficients: ',&
  !           &ccn_aero(i),in_aero(i),i !,wetc_in(i), wetd_in(i),i
      end if
    else
      if (lroot) write (*,*) '  In-cloud scavenging: OFF' 
    endif

    if ((reldiff(i).gt.0.).or.(density(i).gt.0.).or.(dryvel(i).gt.0.)) then
      DRYDEP=.true.
      DRYDEPSPEC(i)=.true.
    endif

    deallocate(vsh,fracth,schmih)
  end do ! end loop over species

  if (WETDEP.or.DRYDEP) DEP=.true.

  ! Check if chemical reaction shall be calculated
  !***********************************************

  if (any(reaccconst(:,:).gt.0.)) then
    CLREA=.true.
    if (lroot) write (*,*) '  Chemical reactions switched on'
  endif

  ! Check if emissions shall be used
  !*********************************

  if (any(emis_path(:).ne."")) then
    LEMIS=.true.
    if (lroot) write(*,*) '  Emissions switched on'
  endif

  ! Not necessary to read releases when using part_ic.nc
  !*****************************************************
  if ((ipin.eq.3).or.(ipin.eq.4)) then
    maxpointspec_act=1
    return 
  endif
  
  ! Read specifications for each release point
  !*******************************************
  numpoints=numpoint
  numpoint=0
  numpartmax=0
  releaserate=0.
101 numpoint=numpoint+1

  if (numpoint.gt.numpoints) goto 250
  zkind = 1
  mass = 0
  parts = 0
  comment = ' '
  read(unitreleases,release,iostat=ios)
  id1=idate1
  it1=itime1
  id2=idate2
  it2=itime2
  xpoint1(numpoint)=lon1
  xpoint2(numpoint)=lon2
  ypoint1(numpoint)=lat1
  ypoint2(numpoint)=lat2
  zpoint1(numpoint)=z1
  zpoint2(numpoint)=z2
  kindz(numpoint)=zkind
  do i=1,nspec
    xmass(numpoint,i)=mass(i)
  end do
  npart(numpoint)=parts
  compoint(min(1001,numpoint))=comment

! namelist output
  if (nmlout.and.lroot) then
    write(unitreleasesout,nml=release)
  endif

  ! If a release point contains no particles, stop and issue error message
  !***********************************************************************

  if (npart(numpoint).eq.0) then
    write(*,*) 'FLEXPART MODEL ERROR'
    write(*,*) 'RELEASES file is corrupt.'
    write(*,*) 'At least for one release point, there are zero'
    write(*,*) 'particles released. Make changes to RELEASES.'
    error stop
  endif

  ! If FLEXPART is run for backward deposition force zpoint
  !*********************************************************************
  if (WETBKDEP) then
    zpoint1(numpoint)=0.
    zpoint2(numpoint)=20000.
    kindz(numpoint)=1
  endif
  if (DRYBKDEP) then
    zpoint1(numpoint)=0.
    zpoint2(numpoint)=2.*href
    kindz(numpoint)=1
  endif


  ! Check whether x coordinates of release point are within model domain
  !*********************************************************************

  if (xpoint1(numpoint).lt.xlon0) &
       xpoint1(numpoint)=xpoint1(numpoint)+360.
  if (xpoint1(numpoint).gt.xlon0+(nxmin1)*dx) &
       xpoint1(numpoint)=xpoint1(numpoint)-360.
  if (xpoint2(numpoint).lt.xlon0) &
       xpoint2(numpoint)=xpoint2(numpoint)+360.
  if (xpoint2(numpoint).gt.xlon0+(nxmin1)*dx) &
       xpoint2(numpoint)=xpoint2(numpoint)-360.

  ! Determine relative beginning and ending times of particle release
  !******************************************************************

  jul1=juldate(id1,it1)
  jul2=juldate(id2,it2)
  julm=(jul1+jul2)*0.5
  if (jul1.gt.jul2) then
    write(*,*) 'FLEXPART MODEL ERROR'
    write(*,*) 'Release stops before it begins.'
    write(*,*) 'Make changes to file RELEASES.'
    error stop
  endif
  if (mdomainfill.eq.0) then   ! no domain filling
    if (ldirect.eq.1) then
      if (((jul1.lt.bdate).or.(jul2.gt.edate)).and.(ipin.eq.0)) then
        write(*,*) 'FLEXPART MODEL ERROR'
        write(*,*) 'Release starts before simulation begins or ends'
        write(*,*) 'after simulation stops.'
        write(*,*) 'Make files COMMAND and RELEASES consistent.'
        error stop
      endif
      if (npart(numpoint).gt.num_min_discrete) then
        ireleasestart(numpoint)=int((jul1-bdate)*86400.)
        ireleaseend(numpoint)=int((jul2-bdate)*86400.)
      else
        ireleasestart(numpoint)=int((julm-bdate)*86400.)
        ireleaseend(numpoint)=int((julm-bdate)*86400.)
      endif
    else if (ldirect.eq.-1) then
      if (((jul1.lt.edate).or.(jul2.gt.bdate)).and.(ipin.eq.0)) then
        write(*,*) 'FLEXPART MODEL ERROR'
        write(*,*) 'Release starts before simulation begins or ends'
        write(*,*) 'after simulation stops.'
        write(*,*) 'Make files COMMAND and RELEASES consistent.'
        error stop
      endif
      if (npart(numpoint).gt.num_min_discrete) then
        ireleasestart(numpoint)=int((jul1-bdate)*86400.)
        ireleaseend(numpoint)=int((jul2-bdate)*86400.)
      else
        ireleasestart(numpoint)=int((julm-bdate)*86400.)
        ireleaseend(numpoint)=int((julm-bdate)*86400.)
      endif
    endif
  endif


  ! Determine the release rate (particles per second) and total number
  ! of particles released during the simulation
  !*******************************************************************

  if (ireleasestart(numpoint).ne.ireleaseend(numpoint)) then
    releaserate=releaserate+real(npart(numpoint))/ &
         real(ireleaseend(numpoint)-ireleasestart(numpoint))
  else
    releaserate=99999999.
  endif
  numpartmax=numpartmax+npart(numpoint)
  goto 101

250 close(unitreleases)

  if (nmlout.and.lroot) then
    close(unitreleasesout)
  endif

  !if (lroot) write (*,*) 'Particles allocated (maxpart)  : ',maxpart
  if (lroot) write (*,*) 'Particles released (numpartmax): ',numpartmax
  numpoint=numpoint-1

  if (ioutputforeachrelease.eq.1) then
    maxpointspec_act=numpoint
  else
    maxpointspec_act=1
  endif

  ! Disable settling if more than 1 species at any release point
  ! or if MQUASILAG and more than one species
  !*************************************************************

  if (mquasilag.ne.0) then
    if (nspec.gt.1) lsettling=.false.
  else
    do irel=1,numpoint
      nsettle=0
      do ispc=1,nspec
        if (xmass(irel,ispc).gt.eps2) nsettle=nsettle+1
      end do
      if (nsettle.gt.1) lsettling=.false.
    end do
  end if

  if (lroot) then
    if (.not.lsettling) then 
      write(*,*) 'WARNING: more than 1 species per release point, settling &
           &disabled'
    end if
  end if

  ! Check, whether the total number of particles may exceed totally allowed
  ! number of particles at some time during the simulation
  !************************************************************************

  ! if (releaserate.gt. &
  !      0.99*real(maxpart)/real(lage(nageclass))) then
  !   if (numpartmax.gt.maxpart.and.lroot) then
  !     write(*,*) '#####################################################'
  !     write(*,*) '#### FLEXPART MODEL SUBROUTINE READRELEASES:     ####'
  !     write(*,*) '####                                             ####'
  !     write(*,*) '####WARNING - TOTAL NUMBER OF PARTICLES SPECIFIED####'
  !     write(*,*) '#### IN FILE "RELEASES" MAY AT SOME POINT DURING ####'
  !     write(*,*) '#### THE SIMULATION EXCEED THE MAXIMUM ALLOWED   ####'
  !     write(*,*) '#### NUMBER (MAXPART).IF RELEASES DO NOT OVERLAP,####'
  !     write(*,*) '#### FLEXPART CAN POSSIBLY COMPLETE SUCCESSFULLY.####'
  !     write(*,*) '#### HOWEVER, FLEXPART MAY HAVE TO STOP          ####'
  !     write(*,*) '#### AT SOME TIME DURING THE SIMULATION. PLEASE  ####'
  !     write(*,*) '#### MAKE SURE THAT YOUR SETTINGS ARE CORRECT.   ####'
  !     write(*,*) '#####################################################'
  !     write(*,*) 'Maximum release rate may be: ',releaserate, &
  !          ' particles per second'
  !     write(*,*) 'Maximum allowed release rate is: ', &
  !          real(maxpart)/real(lage(nageclass)),' particles per second'
  !     write(*,*) &
  !          'Total number of particles released during the simulation is: ', &
  !          numpartmax
  !     write(*,*) 'Maximum allowed number of particles is: ',maxpart
  !   endif
  ! endif


  if (lroot) then
    write(*,FMT='(A,ES14.7)') ' Total mass released:', sum(xmass(1:numpoint,1:nspec))
  end if

  return

994 write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL SUBROUTINE READRELEASES:     ####'
  write(*,*) '####                                             ####'
  write(*,*) '#### ERROR - MAXIMUM NUMBER OF EMITTED SPECIES IS####'
  write(*,*) '#### TOO LARGE. PLEASE REDUCE NUMBER OF SPECIES. ####'
  write(*,*) '#####################################################'
  error stop

999 write(*,*) '#####################################################'
  write(*,*) '   FLEXPART MODEL SUBROUTINE READRELEASES: '
  write(*,*)
  write(*,*) 'FATAL ERROR - FILE CONTAINING PARTICLE RELEASE POINTS'
  write(*,*) 'POINTS IS NOT AVAILABLE OR YOU ARE NOT'
  write(*,*) 'PERMITTED FOR ANY ACCESS'
  write(*,*) '#####################################################'
  error stop

1000 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "RELEASES"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(2)(1:length(2))
  error stop
end subroutine readreleases

subroutine readspecies(id_spec,pos_spec)

  !*****************************************************************************
  !                                                                            *
  !     This routine reads names and physical constants of chemical species/   *
  !     radionuclides given in the parameter pos_spec                          *
  !                                                                            *
  !   Author: A. Stohl                                                         *
  !                                                                            *
  !   11 July 1996                                                             *
  !                                                                            *
  !   Changes:                                                                 *
  !   N. Kristiansen, 31.01.2013: Including parameters for in-cloud scavenging *
  !                                                                            *
  !   HSO, 13 August 2013
  !   added optional namelist input
  !                                                                            *
  !   R. Thompson, 18.01.2024                                                  *
  !   variables for LCM                                                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! decaytime(maxtable)   half time for radiological decay                     *
  ! specname(maxtable)    names of chemical species, radionuclides             *
  ! weta_gas, wetb_gas    Parameters for below-cloud scavenging of gasses      *
  ! crain_aero,csnow_aero Parameters for below-cloud scavenging of aerosols    *
  ! ccn_aero,in_aero      Parameters for in-cloud scavenging of aerosols       *
  ! reaccconst            Chemical reaction rate constant C                    *
  ! reacdconst            Chemical reaction rate constant D                    *
  ! reacnconst            Chemical reaction rate constant n                    *
  ! id_spec               SPECIES number as referenced in RELEASE file         *
  ! id_pos                position where SPECIES data shall be stored          *                                                        
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: i, pos_spec,j
  integer :: idow,ihour,id_spec
  character(len=3) :: aspecnumb

  character(len=16)  :: pspecies, pemis_name
  character(len=256) :: pemis_path, pemis_file
  integer :: pemis_unit
  real :: pemis_coeff
  character(len=50) :: line
  real :: pdecay, pweta_gas, pwetb_gas, preldiff, phenry, pf0, pdensity, pdquer
  real :: pdsigma, pdryvel, pweightmolar, pdia
  character(len=10), allocatable, dimension(:) :: preactions
  real, allocatable, dimension(:) :: pcconst, pdconst, pnconst
  real :: pcrain_aero, pcsnow_aero, pccn_aero, pin_aero
  real :: pohcconst,pohdconst,pohnconst ! deprecated
  real :: parea_dow(7), parea_hour(24), ppoint_dow(7), ppoint_hour(24)
  !integer :: pndia
  integer :: ios
  integer :: pshape,porient
  ! Daria Tatsii: species shape properties
  real ::pla,pia,psa,f,e,paspectratio

  ! declare namelist
  namelist /species_params/ &
       pspecies, pdecay, pweta_gas, pwetb_gas, &
       pcrain_aero, pcsnow_aero, pccn_aero, pin_aero, &
       preldiff, phenry, pf0, pdensity, pdquer, pdia, &
       pdsigma, pdryvel, pweightmolar, pohnconst, &
       preactions, pcconst, pdconst, pnconst, pohcconst, pohdconst, &
       pemis_path, pemis_file, pemis_name, pemis_unit, pemis_coeff, &
       parea_dow, parea_hour, ppoint_dow, ppoint_hour, &
       pshape, paspectratio, pla, pia, psa, porient !pndia, 

  ! allocate reaction variables
  allocate(preactions(maxreagent))
  allocate(pcconst(maxreagent))
  allocate(pdconst(maxreagent))
  allocate(pnconst(maxreagent))
  if (.not.allocated(reaccconst)) then
    allocate(reaccconst(maxreagent,nspec))
    allocate(reacdconst(maxreagent,nspec))
    allocate(reacnconst(maxreagent,nspec))
    reaccconst(:,:)=-9.99e-9
    reacdconst(:,:)=-9.99
    reacnconst(:,:)=-9.99
    allocate(emis_path(nspec))
    allocate(emis_file(nspec))
    allocate(emis_name(nspec))
    allocate(emis_unit(nspec))
    allocate(emis_coeff(nspec))
  endif

  pspecies="" ! read failure indicator value
  pdecay=-999.9
  pweta_gas=-9.9E-09
  pwetb_gas=0.0
  pcrain_aero=-9.9E-09
  pcsnow_aero=-9.9E-09
  pccn_aero=-9.9E-09
  pin_aero=-9.9E-09
  preldiff=-9.9
  phenry=-9.9
  pf0=0.0
  pdensity=-9.9E09
  pdquer=-9.9
  pdia=-9.9
  pdsigma=0.0
  !pndia=1
  pdryvel=-9.99
  preactions(:)=""
  pcconst(:)=-9.99e-9
  pdconst(:)=-9.99
  pnconst(:)=-9.99
  pohcconst=-9.99
  pohdconst=-9.99
  pohnconst=-9.99
  pweightmolar=-999.9
  parea_dow=-999.9
  parea_hour=-999.9
  ppoint_dow=-999.9
  ppoint_hour=-999.9
  pshape=0 ! 0 for sphere, 1 for other shapes
  paspectratio=-1.
  pla=-1. ! longest axis in micrometer
  pia=-1. ! Intermediate axis
  psa=-1. ! Smallest axis
  porient=0 ! 0 for horizontal, 1 for random
  pemis_path="" ! read failure indicator value
  pemis_file="" ! read failure indicator value
  pemis_name="" ! read failure indicator value
  pemis_unit=0
  pemis_coeff=1.

  do j=1,24           ! initialize everything to no variation
    parea_hour(j)=1.
    ppoint_hour(j)=1.
    area_hour(pos_spec,j)=1.
    point_hour(pos_spec,j)=1.
  end do
  do j=1,7
    parea_dow(j)=1.
    ppoint_dow(j)=1.
    area_dow(pos_spec,j)=1.
    point_dow(pos_spec,j)=1.
  end do

  ! Open the SPECIES file and read species names and properties
  !************************************************************
  specnum(pos_spec)=id_spec
  write(aspecnumb,'(i3.3)') specnum(pos_spec)
  open(unitspecies,file=path(1)(1:length(1))//'SPECIES/SPECIES_'//aspecnumb, &
    status='old',form='formatted',err=998)
  write(*,*) 'reading SPECIES',specnum(pos_spec)

  ASSSPEC=.FALSE.

  read(unitspecies,species_params,iostat=ios)
  ! check on which line of species file problem occurs
  if (ios.ne.0) then
    backspace(unitspecies)
    read(unitspecies,fmt='(A)') line
    if (lroot) write(*,*) &
        'Invalid line in species: '//trim(line)
  end if
  close(unitspecies)

  if ((len(trim(pspecies)).eq.0).or.(ios.ne.0)) then ! no namelist found
    if (lroot) then
      write(*,*) "FLEXPART ERROR: SPECIES file not in NAMELIST format"
      write(*,*) "fixed format no longer supported"
    endif
    error stop
  endif

  if ((pohcconst.ne.-9.99).or.(pohdconst.ne.-9.99).or.(pohnconst.ne.-9.99)) then
    write(*,*) "ERROR: POHCCONST,POHDCONST, and POHNCONST in SPECIES file are deprecated."
    error stop
  endif
  species(pos_spec)=pspecies
  decay(pos_spec)=pdecay
  weta_gas(pos_spec)=pweta_gas
  wetb_gas(pos_spec)=pwetb_gas
  crain_aero(pos_spec)=pcrain_aero
  csnow_aero(pos_spec)=pcsnow_aero
  ccn_aero(pos_spec)=pccn_aero
  in_aero(pos_spec)=pin_aero
  reldiff(pos_spec)=preldiff
  henry(pos_spec)=phenry
  f0(pos_spec)=pf0
  density(pos_spec)=pdensity
  if (pdia.ne.-9.9) then
    dquer(pos_spec)=pdia
  else if (pdquer.ne.-9.9) then
    write(*,*) 'WARNING: PDQUER will be depricated, please use PDIA instead.'
    dquer(pos_spec)=pdquer ! For backwards compatibility
  else
    dquer(pos_spec)=0.0
  endif
  dsigma(pos_spec)=pdsigma
  ! ndia(pos_spec)=pndia
  dryvel(pos_spec)=pdryvel
  weightmolar(pos_spec)=pweightmolar
  emis_path(pos_spec)=pemis_path
  emis_file(pos_spec)=pemis_file
  emis_name(pos_spec)=pemis_name
  emis_unit(pos_spec)=pemis_unit
  emis_coeff(pos_spec)=pemis_coeff
  ishape(pos_spec)=pshape
  orient(pos_spec)=porient

  ! Daria Tatsii 2023: compute particle shape dimensions
  if (ishape(pos_spec).ge.1) then ! Compute shape according to given axes
    select case (ishape(pos_spec))
      case (1)
        write(*,*) "Particle shape USER-DEFINED for particle", id_spec
        if ((psa.le.0.0).or.(pia.le.0.0).or.(pla.le.0.0)) then
          write(*,*) "#### ERROR: Shape=1 (user-defined) is chosen, &
            &but no valid axes are provided."
          write(*,*) "#### SPECIES file requires SA, IA, and LA parameter &
            &greater than zero."
          error stop
        endif
        write(*,*) "SA,IA,LA:",psa,pia,pla
      case (2) ! Cylinders (fibers) !
        if (paspectratio.le.0.0) then
          write(*,*) "#### ERROR: Shape=2 cylinder is chosen, but no valid apect ratio is provided."
          write(*,*) "#### SPECIES file requires ASPECTRATIO parameter greater than zero."
          error stop
        endif
        psa=(((dquer(pos_spec)**3.0)*2.0)/ &
                (3.0*paspectratio))**(1.0/3.0)
        pia=psa
        pla=psa*paspectratio
        write(*,*) "Particle shape CYLINDER for particle", id_spec
        write(*,*) "SA,IA,LA:",psa,pia,pla
      case (3) ! Cubes !
        write(*,*) "Particle shape CUBE for particle", id_spec
        psa=((dquer(pos_spec)**3)*pi/6.0)**(1.0/3.0)
        pia=(2.0**0.5)*psa
        pla=(3.0**0.5)*psa
        if ((psa.le.0.0).or.(pia.le.0.0).or.(pla.le.0.0)) then
          write(*,*) "#### ERROR: Shape=3 (user-defined) is chosen, but no valid axes are provided."
          write(*,*) "#### SPECIES file requires SA, IA, and LA parameter greater than zero."
          error stop
        endif
        write(*,*) "SA,IA,LA:",psa,pia,pla
      case (4) ! Tetrahedrons !
        write(*,*) "Particle shape TETRAHEDRON for particle", id_spec
        pla=((dquer(pos_spec)**3)*pi*2**(0.5))**(1.0/3.0)
        pia=pla*((3.0/4.0)**(0.5))
        psa=pla*((2.0/3.0)**(0.5))
        if ((psa.le.0.0).or.(pia.le.0.0).or.(pla.le.0.0)) then
          write(*,*) "#### ERROR: Shape=4 (user-defined) is chosen, but no valid axes are provided."
          write(*,*) "#### SPECIES file requires SA, IA, and LA parameter greater than zero."
          error stop
        endif
        write(*,*) "SA,IA,LA:",psa,pia,pla
      case (5) ! Octahedrons !
        write(*,*) "Particle shape OCTAHEDRON for particle", id_spec
        psa=dquer(pos_spec)*(pi/(2.0*2.0**(0.5)))**3
        pia=psa
        pla=psa*(2.0**(0.5))
        if ((psa.le.0.0).or.(pia.le.0.0).or.(pla.le.0.0)) then
          write(*,*) "#### ERROR: Shape=5 (user-defined) is chosen, but no valid axes are provided."
          write(*,*) "#### SPECIES file requires SA, IA, and LA parameter greater than zero."
          error stop
        endif
        write(*,*) "SA,IA,LA:",psa,pia,pla
      case (6) ! Ellipsoids !
        write(*,*) "Particle shape ELLIPSOID for particle", id_spec
        psa=dquer(pos_spec)/(2.0**(1.0/3.0)) 
        pia=psa
        pla=2*pia
        if ((psa.le.0.0).or.(pia.le.0.0).or.(pla.le.0.0)) then
          write(*,*) "#### ERROR: Shape=6 (user-defined) is chosen, but no valid axes are provided."
          write(*,*) "#### SPECIES file requires SA, IA, and LA parameter greater than zero."
          error stop
        endif
        write(*,*) "SA,IA,LA:",psa,pia,pla
    end select

    ! When using the shape option, dquer is the sphere equivalent diameter
     
    f=psa/pia
    e=pia/pla
    ! Drag coefficient scheme by Bagheri & Bonadonna, 2016 to define settling velocities of other shapes (by D.Tatsii)
    if ((ishape(pos_spec).eq.2).or.((ishape(pos_spec).eq.1).and. &
      (pia.eq.psa).and.(pla.ge.20.0*pia))) then

      Fn(pos_spec)=f*f*e  ! simplified equation, validated by experiments with fibers
      Fs(pos_spec)=f*e**(1.3)   ! simplified equation, validated by experiments with fibers
    else
      Fn(pos_spec)=f*f*e*((dquer(pos_spec))**3)/(psa*pia*pla) ! Newton's regime  
      Fs(pos_spec)=f*e**(1.3)*(dquer(pos_spec)**3/(psa*pia*pla)) ! Stokes' regime
    endif

    ! Pre-compute ks and kn values needed for horizontal and average orientation (B&B Figure 12 k_(s,max))
    ks1(pos_spec)=(Fs(pos_spec)**(1./3.) + Fs(pos_spec)**(-1./3.))/2.
    ks2(pos_spec)=0.5*((Fs(pos_spec)**0.05)+(Fs(pos_spec)**(-0.36)))
    kn2(pos_spec)=10.**(alpha2*(-log10(Fn(pos_spec)))**beta2)

  else ! Spheres
    write(*,*) "Particle shape SPHERE for particle", id_spec
  endif

  ! assign chemical reaction rate constants to table
  !*************************************************

  print*, 'readspecies: preactions = ',preactions

  if (any(preactions.ne."")) then
    do j=1,maxreagent
      if ( preactions(j).eq."" ) cycle
      do i=1,maxreagent
        if (preactions(j).eq.reagents(i)) then
          reaccconst(i,pos_spec)=pcconst(j)
          reacdconst(i,pos_spec)=pdconst(j)
          reacnconst(i,pos_spec)=pnconst(j)
          exit
        endif
      end do
      if (i.gt.nreagent) then
        write(*,*) '#### FLEXPART MODEL ERROR       ####'
        write(*,*) '#### REAGENT NOT FOUND FOR      ####'
        write(*,*) '#### REACTION '//trim(preactions(j))//' ####'
        error stop
      endif
    end do
  endif

  ! Check reaction rates
  if (lroot) then
    write(*,*) 'Reaction rates for ',species(pos_spec),':'
    do j=1,nreagent
      if (reaccconst(j,pos_spec).lt.0.) reaccconst(j,pos_spec)=0.
      if (reacdconst(j,pos_spec).lt.0.) reacdconst(j,pos_spec)=0.
      if (reacnconst(j,pos_spec).lt.0.) reacnconst(j,pos_spec)=0.
      write(*,*) reagents(j),': C, D, N = ',reaccconst(j,pos_spec),reacdconst(j,pos_spec),reacnconst(j,pos_spec)
    end do
  endif

  do j=1,24     ! 24 hours, starting with 0-1 local time
    area_hour(pos_spec,j)=parea_hour(j)
    point_hour(pos_spec,j)=ppoint_hour(j)
  end do
  do j=1,7      ! 7 days of the week, starting with Monday
    area_dow(pos_spec,j)=parea_dow(j)
    point_dow(pos_spec,j)=ppoint_dow(j)
  end do

  i=pos_spec

  !NIK 16.02.2015
  ! Check scavenging parameters given in SPECIES file

  if (lroot) then
  ! ZHG 2016.04.07 Start of changes
    write(*,*) ' '
    if (dquer(pos_spec) .gt.0)  write(*,'(a,i3,a,a,a)')       ' SPECIES: ', &
         id_spec,'  ', species(pos_spec),'  (AEROSOL) '
    if (dquer(pos_spec) .le.0)  write(*,'(a,i3,a,a,a)')       ' SPECIES: ', &
         id_spec,'  ', species(pos_spec),'  (GAS) '

  ! Particles
  !**********
    if (dquer(pos_spec).gt.0) then
      if (ccn_aero(pos_spec) .gt. 0) then
        write(*,'(a,f5.2)') '  Particle CCN  efficiency (CCNeff):', ccn_aero(pos_spec)
      else 
        write(*,'(a)')      '  Particle CCN  efficiency (CCNeff):   OFF'
      endif
      if (in_aero(pos_spec) .gt. 0) then
        write(*,'(a,f5.2)') '  Particle  IN  efficiency (INeff) :', in_aero(pos_spec)
      else
        write(*,'(a)')      '  Particle  IN  efficiency (INeff) :   OFF'
      endif
      if (crain_aero(pos_spec) .gt. 0) then
        write(*,'(a,f5.2)') '  Particle Rain efficiency (Crain) :', crain_aero(pos_spec)
      else
        write(*,'(a)')      '  Particle Rain efficiency (Crain) :   OFF'
      endif
      if (csnow_aero(pos_spec) .gt. 0) then
        write(*,'(a,f5.2)') '  Particle Snow efficiency (Csnow) :', csnow_aero(pos_spec)
      else
        write(*,'(a)')      '  Particle Snow efficiency (Csnow) :   OFF'
      end if
      if (density(pos_spec) .gt. 0) then
        write(*,'(a)') '  Dry deposition is turned         :   ON'
        if (reldiff(pos_spec).gt.0) then
          error stop 'density>0 (SPECIES is a particle) implies reldiff <=0  '
        endif
      else
        if (reldiff(pos_spec).le.0) then
          error stop 'density<=0 (SPECIES is a gas) implies reldiff >0  '
        endif      
        write(*,'(a)') '  Dry deposition is (density<0)    :   OFF'
      end if
      if (crain_aero(pos_spec).gt.10.0 .or. csnow_aero(pos_spec).gt.10.0 .or. &
           &ccn_aero(pos_spec).gt.1.0 .or. in_aero(pos_spec).gt.1.0) then
        write(*,*) '*******************************************'
        write(*,*) ' WARNING: Particle Scavenging parameter likely out of range '
        write(*,*) '       Likely   range for Crain    0.0-10'
        write(*,*) '       Likely   range for Csnow    0.0-10'
        write(*,*) '       Physical range for CCNeff   0.0-1'
        write(*,*) '       Physical range for INeff    0.0-1'
        write(*,*) '*******************************************'
      end if
    else
  ! Gas
  !****
      if (weta_gas(pos_spec) .gt. 0 .and. wetb_gas(pos_spec).gt.0) then
        write(*,*)          '  Wet removal for gases      is turned: ON'
        write(*,*)          '  Gas below-cloud scavenging parameter A  ', &
             &weta_gas(pos_spec)
        write(*,'(a,f5.2)') '  Gas below-cloud scavenging parameter B  ', &
             &wetb_gas(pos_spec)
      else
        write(*,*)          '  Wet removal for gases      is turned: OFF '
      end if
      if (reldiff(i).gt.0.) then
        write(*,*)          '  Dry deposition for gases   is turned: ON '
      else
        write(*,*)          '  Dry deposition for gases   is turned: OFF '
      end if
      if (weta_gas(pos_spec).gt.0.) then !if wet deposition is turned on
        if (weta_gas(pos_spec).gt.1E-04 .or. weta_gas(pos_spec).lt.1E-09 .or. &
             &wetb_gas(pos_spec).gt.0.8 .or. wetb_gas(pos_spec).lt.0.4) then
          write(*,*) '*******************************************'
          write(*,*) ' WARNING: Gas below-cloud scavengig is out of likely range'
          write(*,*) '          Likely range for A is 1E-04 to 1E-08'
          write(*,*) '          Likely range for B is 0.60  to 0.80 ' 
          write(*,*) '*******************************************'
        end if
      endif

      if (((weta_gas(pos_spec).gt.0).or.(wetb_gas(pos_spec).gt.0)).and.&
           &(henry(pos_spec).le.0)) then
        if (dquer(pos_spec).le.0) goto 996 ! no particle, no henry set
      endif
    end if
  end if

  !if (ndia(pos_spec).gt.maxndia) then
  !  maxndia=ndia(pos_spec)
  !endif
  ndia(pos_spec)=maxndia ! Setting all ndia to maxndia (par_mod.f90)
  !  if (dsigma(i).eq.0.) dsigma(i)=1.0001   ! avoid floating exception
  if (dquer(i).gt.0 .and. dsigma(i).le.1.) then !dsigma(i)=1.0001   ! avoid floating exception
    !write(*,*) '#### FLEXPART MODEL ERROR!                      ####'
    write(*,*) '#### FLEXPART MODEL WARNING                     ####'
    write(*,*) '#### in SPECIES_',aspecnumb, '                             ####'
    write(*,*) '#### from v10.4 dsigma has to be larger than 1  ####'  
    write(*,*) '#### to adapt older SPECIES files,              ####' 
    write(*,*) '#### if dsigma was < 1                          ####' 
    write(*,*) '#### use the reciprocal of the old dsigma       ####'  
    if (.not.debug_mode) then 
      error stop
    else
       write(*,*) 'debug mode: continue'
    endif
  endif

  if ((reldiff(i).gt.0.).and.(density(i).gt.0.)) then
    write(*,*) '#### FLEXPART MODEL ERROR! FILE "SPECIES"    ####'
    write(*,*) '#### IS CORRUPT. SPECIES CANNOT BE BOTH      ####'
    write(*,*) '#### PARTICLE AND GAS.                       ####'
    write(*,*) '#### SPECIES NUMBER',aspecnumb
    error stop
  endif

22 close(unitspecies)

! namelist output if requested
  if (nmlout.and.lroot) then
    open(unitspecies,file=path(2)(1:length(2))//'SPECIES_'//aspecnumb//'.namelist',access='append',status='replace',err=1000)
    write(unitspecies,nml=species_params)
    close(unitspecies)
  endif

  return

996 write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL ERROR!                      #### '
  write(*,*) '#### WET DEPOSITION SWITCHED ON, BUT NO HENRYS  #### '
  write(*,*) '#### CONSTANT IS SET                            ####'
  write(*,*) '#### PLEASE MODIFY SPECIES DESCR. FILE!        #### '
  write(*,*) '#####################################################'
  error stop

998 write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL ERROR!                      #### '
  write(*,*) '#### THE SPECIES FILE FOR SPECIES ', id_spec
  write(*,*) '#### CANNOT BE FOUND: CREATE FILE'
  write(*,*) '#### ',path(1)(1:length(1)),'SPECIES/SPECIES_',aspecnumb
  write(*,*) '#####################################################'
  error stop

1000 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "SPECIES_',aspecnumb,'.namelist'
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(2)(1:length(2))
  error stop
end subroutine readspecies

subroutine readpartoptions

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the age classes to be used for the current model    *
  !     run.                                                                   *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !     20 March 2000                                                          *
  !     HSO, 1 July 2014                                                       *
  !     Added optional namelist input                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: np,stat

  ! namelist help variables
  integer :: ios

  logical ::                      &
    longitude=.false.,            &
    longitude_average=.false.,    &
    latitude=.false.,             &
    latitude_average=.false.,     &
    height=.false.,               &
    height_average=.false.,       &
    pv=.false.,                   &
    pv_average=.false.,           &
    qv=.false.,                   &
    qv_average=.false.,           &
    density=.false.,              &
    density_average=.false.,      &
    temperature=.false.,          &
    temperature_average=.false.,  &
    pressure=.false.,             &
    pressure_average=.false.,     &
    mixingheight=.false.,         &
    mixingheight_average=.false., &
    tropopause=.false.,           &
    tropopause_average=.false.,   &
    topography=.false.,           &
    topography_average=.false.,   &
    mass=.false.,                 &
    mass_average=.false.,         &
    u=.false.,                    &
    u_average=.false.,            &
    v=.false.,                    &
    v_average=.false.,            &
    w=.false.,                    &
    w_average=.false.,            &
    vsettling=.false.,            &
    vsettling_average=.false.,    &
    wetdeposition=.false.,        &
    drydeposition=.false.

  ! namelist declaration
  namelist /partoptions/  &
    longitude,            &
    longitude_average,    &
    latitude,             &
    latitude_average,     &
    height,               &
    height_average,       &
    pv,                   &
    pv_average,           &
    qv,                   &
    qv_average,           &
    density,              &
    density_average,      &
    temperature,          &
    temperature_average,  &
    pressure,             &
    pressure_average,     &
    mixingheight,         &
    mixingheight_average, &
    tropopause,           &
    tropopause_average,   &
    topography,           &
    topography_average,   &
    mass,                 &
    mass_average,         &
    u,                    &
    u_average,            &
    v,                    &
    v_average,            &
    w,                    &
    w_average,            &
    vsettling,            &
    vsettling_average,    &
    wetdeposition,        &
    drydeposition

  ! If age spectra claculation is switched on,
  ! open the AGECLASSSES file and read user options
  !************************************************

  open(unitpartoptions,file=path(1)(1:length(1))//'PARTOPTIONS',form='formatted',status='old',err=9999)

  ! try to read in as a namelist
  read(unitpartoptions,partoptions,iostat=ios)
  close(unitpartoptions)

  if (ios.ne.0) then
    write(*,*) 'Namelist error in PARTOPTIONS file', trim(path(1)(1:length(1))//'PARTOPTIONS')
    error stop
  endif
  allocate( partopt(num_partopt),stat=stat)
  if (stat.ne.0) error stop "Could not allocate partopt"
  ! Save values in particle options derived type
  !*********************************************
  partopt(1)%long_name='longitude'
  partopt(1)%short_name='lon'
  partopt(1)%name='LO'
  partopt(1)%print=longitude

  partopt(2)%long_name='longitude_average'
  partopt(2)%short_name='lon_av'
  partopt(2)%name='lo'
  partopt(2)%print=longitude_average
  partopt(2)%average=.true.

  partopt(3)%long_name='latitude'
  partopt(3)%short_name='lat'
  partopt(3)%name='LA'
  partopt(3)%print=latitude

  partopt(4)%long_name='latitude_average'
  partopt(4)%short_name='lat_av'
  partopt(4)%name='la'
  partopt(4)%print=latitude_average
  partopt(4)%average=.true.

  partopt(5)%long_name='height'
  partopt(5)%short_name='z'
  partopt(5)%name='ZZ'
  partopt(5)%print=height

  partopt(6)%long_name='height_average'
  partopt(6)%short_name='z_av'
  partopt(6)%name='zz'
  partopt(6)%print=height_average
  partopt(6)%average=.true.

  partopt(7)%long_name='potential_vorticity'
  partopt(7)%short_name='pv'
  partopt(7)%name='PV'
  partopt(7)%print=pv

  partopt(8)%long_name='potential_vorticity_average'
  partopt(8)%short_name='pv_av'
  partopt(8)%name='pv'
  partopt(8)%print=pv_average
  partopt(8)%average=.true.

  partopt(9)%long_name='specific_humidity'
  partopt(9)%short_name='sh'
  partopt(9)%name='QV'
  partopt(9)%print=qv

  partopt(10)%long_name='specific_humidity_average'
  partopt(10)%short_name='sh_av'
  partopt(10)%name='qv'
  partopt(10)%print=qv_average
  partopt(10)%average=.true.

  partopt(11)%long_name='density'
  partopt(11)%short_name='rho'
  partopt(11)%name='RH'
  partopt(11)%print=density

  partopt(12)%long_name='density_average'
  partopt(12)%short_name='rho_av'
  partopt(12)%name='rh'
  partopt(12)%print=density_average
  partopt(12)%average=.true.

  partopt(13)%long_name='temperature'
  partopt(13)%short_name='T'
  partopt(13)%name='TT'
  partopt(13)%print=temperature

  partopt(14)%long_name='temperature_average'
  partopt(14)%short_name='T_av'
  partopt(14)%name='tt'
  partopt(14)%print=temperature_average
  partopt(14)%average=.true.

  partopt(15)%long_name='pressure'
  partopt(15)%short_name='prs'
  partopt(15)%name='PR'
  partopt(15)%print=pressure

  partopt(16)%long_name='pressure_average'
  partopt(16)%short_name='prs_av'
  partopt(16)%name='pr'
  partopt(16)%print=pressure_average
  partopt(16)%average=.true.

  partopt(17)%long_name='mixingheight'
  partopt(17)%short_name='hmix'
  partopt(17)%name='HM'
  partopt(17)%print=mixingheight

  partopt(18)%long_name='mixingheight_average'
  partopt(18)%short_name='hmix_av'
  partopt(18)%name='hm'
  partopt(18)%print=mixingheight_average
  partopt(18)%average=.true.

  partopt(19)%long_name='tropopause'
  partopt(19)%short_name='tro'
  partopt(19)%name='TR'
  partopt(19)%print=tropopause

  partopt(20)%long_name='tropopause_average'
  partopt(20)%short_name='tro_av'
  partopt(20)%name='tr'
  partopt(20)%print=tropopause_average
  partopt(20)%average=.true.

  partopt(21)%long_name='topography'
  partopt(21)%short_name='to'
  partopt(21)%name='TO'
  partopt(21)%print=topography

  partopt(22)%long_name='topography_average'
  partopt(22)%short_name='to_av'
  partopt(22)%name='to'
  partopt(22)%print=topography_average
  partopt(22)%average=.true.

  partopt(23)%long_name='mass'
  partopt(23)%short_name='m'
  partopt(23)%name='MA'
  partopt(23)%print=mass

  partopt(24)%long_name='mass_average'
  partopt(24)%short_name='m_av'
  partopt(24)%name='ma'
  partopt(24)%print=mass_average
  partopt(24)%average=.true.
  
  partopt(25)%long_name='longitudinal_velocity'
  partopt(25)%short_name='u'
  partopt(25)%name='UU'
  partopt(25)%print=u

  partopt(26)%long_name='longitudinal_velocity_average'
  partopt(26)%short_name='u_av'
  partopt(26)%name='uu'
  partopt(26)%print=u_average
  partopt(26)%average=.true.

  partopt(27)%long_name='latitudinal_velocity'
  partopt(27)%short_name='v'
  partopt(27)%name='VV'
  partopt(27)%print=v

  partopt(28)%long_name='latitudinal_velocity_average'
  partopt(28)%short_name='v_av'
  partopt(28)%name='vv'
  partopt(28)%print=v_average
  partopt(28)%average=.true.

  partopt(29)%long_name='vertical_velocity'
  partopt(29)%short_name='w'
  partopt(29)%name='WW'
  partopt(29)%print=w

  partopt(30)%long_name='vertical_velocity_average'
  partopt(30)%short_name='w_av'
  partopt(30)%name='ww'
  partopt(30)%print=w_average
  partopt(30)%average=.true.

  partopt(31)%long_name='settling_velocity'
  partopt(31)%short_name='vset'
  partopt(31)%name='VS'
  partopt(31)%print=vsettling

  partopt(32)%long_name='settling_velocity_average'
  partopt(32)%short_name='vset_av'
  partopt(32)%name='vs'
  partopt(32)%print=vsettling_average
  partopt(32)%average=.true.

  partopt(33)%long_name='wetdeposition'
  partopt(33)%short_name='wetdepo'
  partopt(33)%name='WD'
  partopt(33)%print=wetdeposition

  partopt(34)%long_name='drydeposition'
  partopt(34)%short_name='drydepo'
  partopt(34)%name='DD'
  partopt(34)%print=drydeposition

  ! Numbers are assigned to the averaged fields for proper
  ! allocation and reading in particle_mod and output_mod
  !******************************************************
  n_average=0
  do np=1,num_partopt
    if (partopt(np)%average .and. partopt(np)%print) then 
      n_average=n_average+1
      partopt(np)%i_average = n_average
      if ((partopt(np)%name.eq.'MA') .or. (partopt(np)%name.eq.'ma')) then
        n_average=n_average + (maxspec-1)
      endif
    endif
  end do

  ! write partoptions file in namelist format to output directory if requested
  if (nmlout.and.lroot) then
    open(unitpartoptions,file=path(2)(1:length(2))//'PARTOPTIONS.namelist',err=10000)
    write(unitpartoptions,nml=partoptions)
    close(unitpartoptions)
  endif


  ! Restart files, when using in combination with averaged particle output, 
  ! need to be synchronised to prevent false averages in the first step of
  ! the new run
  !************************************************************************
  if ((ipout.ne.0).and.(n_average.gt.0).and.(loutrestart.ne.-1)) then
    if (mod(loutrestart,ipoutfac*loutstep).ne.0) then
      write(*,*) '### FLEXPART MODEL ERROR! FILE COMMAND:     ###'
      write(*,*) '### LOUTRESTART NEEDS TO BE DIVISABLE BY    ###'
      write(*,*) '### LOUTSTEP*IPOUTFAC.                      ###'
      error stop
    endif
  endif

  return

9999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "PARTOPTIONS" #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  error stop

10000  write(*,*) ' #### FLEXPART MODEL ERROR! FILE "PARTOPTIONS" #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(2)(1:length(2))
  error stop
end subroutine readpartoptions

subroutine skplin(nlines,iunit)
  !                    i      i
  !*****************************************************************************
  !                                                                            *
  !   This routine reads nlines from unit iunit and discards them              *
  !                                                                            *
  !   Authors: Petra Seibert                                                   *
  !                                                                            *
  !   31 Dec 1998                                                              *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! iunit   unit number from which lines are to be skipped                     *
  ! nlines  number of lines to be skipped                                      *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: i,iunit, nlines

  do i=1,nlines
    read(iunit,*)
  end do

end subroutine skplin

end module readoptions_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine caldate(juldate,yyyymmdd,hhmiss)
  !                      i       o       o
  !*****************************************************************************
  !                                                                            *
  !     Calculates the Gregorian date from the Julian date                     *
  !                                                                            *
  !     AUTHOR: Andreas Stohl (21 January 1994), adapted from Numerical Recipes*
  !                                                                            *
  !     Variables:                                                             *
  !     dd             Day                                                     *
  !     hh             Hour                                                    *
  !     hhmiss         Hour, Minute, Second                                    *
  !     ja,jb,jc,jd,je help variables                                          *
  !     jalpha         help variable                                           *
  !     juldate        Julian Date                                             *
  !     julday         help variable                                           *
  !     mi             Minute                                                  *
  !     mm             Month                                                   *
  !     ss             Seconds                                                 *
  !     yyyy           Year                                                    *
  !     yyyymmdd       Year, Month, Day                                        *
  !                                                                            *
  !     Constants:                                                             *
  !     igreg          help constant                                           *
  !                                                                            *
  !*****************************************************************************

  use par_mod, only: dp

  implicit none

  integer           :: yyyymmdd,yyyy,mm,dd,hhmiss,hh,mi,ss
  integer           :: julday,ja,jb,jc,jd,je,jalpha
  real(kind=dp)     :: juldate
  integer,parameter :: igreg=2299161

  julday=int(juldate)
  if(julday.ge.igreg)then
    jalpha=int(((julday-1867216)-0.25)/36524.25)
    ja=julday+1+jalpha-int(0.25*jalpha)
  else
    ja=julday
  endif
  jb=ja+1524
  jc=int(6680.+((jb-2439870)-122.1)/365.25)
  jd=365*jc+int(0.25*jc)
  je=int((jb-jd)/30.6001)
  dd=jb-jd-int(30.6001*je)
  mm=je-1
  if (mm.gt.12) mm=mm-12
  yyyy=jc-4715
  if (mm.gt.2) yyyy=yyyy-1
  if (yyyy.le.0) yyyy=yyyy-1

  yyyymmdd=10000*yyyy+100*mm+dd
  hh=int(24._dp*(juldate-real(julday,kind=dp)))
  mi=int(1440._dp*(juldate-real(julday,kind=dp))-60._dp*real(hh,kind=dp))
  ss=nint(86400._dp*(juldate-real(julday,kind=dp))-3600._dp*real(hh,kind=dp)- &
       60._dp*real(mi,kind=dp))
  if (ss.eq.60) then  ! 60 seconds = 1 minute
    ss=0
    mi=mi+1
  endif
  if (mi.eq.60) then
    mi=0
    hh=hh+1
  endif
  hhmiss=10000*hh+100*mi+ss

end subroutine caldate

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  ! This module contains routines that output gridded data to binary files.    *
  !                                                                            *
  ! Not all routines that should have a netcdf equivalent, have one yet:       *
  ! writeheader_bin_sfc_nest,writeheader_bin_sfc,                              *
  ! initcond_output,initcond_output_inversion                                  *
  ! concoutput_inversion, concoutput_inversion_nest                            *
  !                                                                            *
  !   L. Bakels 2022                                                           *
  !                                                                            *
  !*****************************************************************************
  
module binary_output_mod

  use point_mod
  use outgrid_mod
  use par_mod
  use com_mod
  use date_mod
  use windfields_mod

  implicit none

contains

subroutine writeheader_bin

  !*****************************************************************************
  !                                                                            *
  !  This routine produces a file header containing basic information on the   *
  !  settings of the FLEXPART run.                                             *
  !  The header file is essential and must be read in by any postprocessing    *
  !  program before reading in the output data.                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  !  Modified to remove TRIM around the output of flexversion so that          *
  !  it will be a constant length (defined in com_mod.f90) in output header    *
  !                                                                            *
  !     Don Morton, Boreal Scientific Computing                                *
  !     07 May 2017                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! xlon                   longitude                                           *
  ! xl                     model x coordinate                                  *
  ! ylat                   latitude                                            *
  ! yl                     model y coordinate                                  *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: jjjjmmdd,ihmmss,i,ix,jy,j
  real :: xp1,yp1,xp2,yp2


  !************************
  ! Open header output file
  !************************

  open(unitheader,file=path(2)(1:length(2))//'header', &
       form='unformatted',err=998)


  ! Write the header information
  !*****************************

  if (ldirect.eq.1) then
    write(unitheader) ibdate,ibtime, flexversion
  else
    write(unitheader) iedate,ietime, flexversion
  endif

  ! Write info on output interval, averaging time, sampling time
  !*************************************************************

  write(unitheader) loutstep,loutaver,loutsample

  ! Write information on output grid setup
  !***************************************

  write(unitheader) outlon0,outlat0,numxgrid,numygrid, &
       dxout,dyout
  write(unitheader) numzgrid,(outheight(i),i=1,numzgrid)

  call caldate(bdate,jjjjmmdd,ihmmss)
  write(unitheader) jjjjmmdd,ihmmss

  ! Write number of species, and name for each species (+extra name for depositions)
  ! Indicate the dimension of the fields (i.e., 1 for deposition fields, numzgrid for
  ! concentration fields
  !*****************************************************************************

  write(unitheader) 3*nspec,maxpointspec_act
  do i=1,nspec
    write(unitheader) 1,'WD_'//species(i)(1:7)
    write(unitheader) 1,'DD_'//species(i)(1:7)
    write(unitheader) numzgrid,species(i)
  end do

  ! Write information on release points: total number, then for each point:
  ! start, end, coordinates, # of particles, name, mass
  !************************************************************************

  write(unitheader) numpoint
  do i=1,numpoint
    write(unitheader) ireleasestart(i),ireleaseend(i),kindz(i)
    xp1=xpoint1(i)*dx+xlon0
    yp1=ypoint1(i)*dy+ylat0
    xp2=xpoint2(i)*dx+xlon0
    yp2=ypoint2(i)*dy+ylat0
    write(unitheader) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
    write(unitheader) npart(i),1
    if (numpoint.le.1000) then
      write(unitheader) compoint(i)
    else
      write(unitheader) compoint(1001)
    endif
    do j=1,nspec
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
    end do
  end do

  ! Write information on some model switches
  !*****************************************

  write(unitheader) method,lsubgrid,lconvection, &
       ind_source,ind_receptor

  ! Write age class information
  !****************************

  write(unitheader) nageclass,(lage(i),i=1,nageclass)


  ! Write topography to output file
  !********************************

  do ix=0,numxgrid-1
    write(unitheader) (oroout(ix,jy),jy=0,numygrid-1)
  end do
  close(unitheader)

  return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'header'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  error stop

end subroutine writeheader_bin

subroutine writeheader_bin_nest

  !*****************************************************************************
  !                                                                            *
  !  This routine produces a file header containing basic information on the   *
  !  settings of the FLEXPART run.                                             *
  !  The header file is essential and must be read in by any postprocessing    *
  !  program before reading in the output data.                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  !  Modified to remove TRIM around the output of flexversion so that          *
  !  it will be a constant length (defined in com_mod.f90) in output header    *
  !                                                                            *
  !     Don Morton, Boreal Scientific Computing                                *
  !     07 May 2017                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! xlon                   longitude                                           *
  ! xl                     model x coordinate                                  *
  ! ylat                   latitude                                            *
  ! yl                     model y coordinate                                  *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: jjjjmmdd,ihmmss,i,ix,jy,j
  real :: xp1,yp1,xp2,yp2


  !************************
  ! Open header output file
  !************************

  open(unitheader,file=path(2)(1:length(2))//'header_nest', &
       form='unformatted',err=998)


  ! Write the header information
  !*****************************

  if (ldirect.eq.1) then
    write(unitheader) ibdate,ibtime, flexversion
  else
    write(unitheader) iedate,ietime, flexversion
  endif

  ! Write info on output interval, averaging time, sampling time
  !*************************************************************

  write(unitheader) loutstep,loutaver,loutsample

  ! Write information on output grid setup
  !***************************************

  write(unitheader) outlon0n,outlat0n,numxgridn,numygridn, &
       dxoutn,dyoutn
  write(unitheader) numzgrid,(outheight(i),i=1,numzgrid)

  call caldate(bdate,jjjjmmdd,ihmmss)
  write(unitheader) jjjjmmdd,ihmmss

  ! Write number of species, and name for each species (+extra name for depositions)
  ! Indicate the dimension of the fields (i.e., 1 for deposition fields, numzgrid for
  ! concentration fields
  !*****************************************************************************

  write(unitheader) 3*nspec,maxpointspec_act
  do i=1,nspec
    write(unitheader) 1,'WD_'//species(i)(1:7)
    write(unitheader) 1,'DD_'//species(i)(1:7)
    write(unitheader) numzgrid,species(i)
  end do

  ! Write information on release points: total number, then for each point:
  ! start, end, coordinates, # of particles, name, mass
  !************************************************************************

  write(unitheader) numpoint
  do i=1,numpoint
    write(unitheader) ireleasestart(i),ireleaseend(i),kindz(i)
    xp1=xpoint1(i)*dx+xlon0
    yp1=ypoint1(i)*dy+ylat0
    xp2=xpoint2(i)*dx+xlon0
    yp2=ypoint2(i)*dy+ylat0
    write(unitheader) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
    write(unitheader) npart(i),1
    if (numpoint.le.1000) then
      write(unitheader) compoint(i)
    else
      write(unitheader) compoint(1001)
   endif
    do j=1,nspec
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
    end do
  end do

  ! Write information on some model switches
  !*****************************************

  write(unitheader) method,lsubgrid,lconvection, &
       ind_source,ind_receptor

  ! Write age class information
  !****************************

  write(unitheader) nageclass,(lage(i),i=1,nageclass)


  ! Write topography to output file
  !********************************

  do ix=0,numxgridn-1
    write(unitheader) (orooutn(ix,jy),jy=0,numygridn-1)
  end do
  close(unitheader)

  return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'header'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  error stop

end subroutine writeheader_bin_nest

subroutine writeheader_bin_sfc_nest

  !*****************************************************************************
  !                                                                            *
  !  This routine produces a file header containing basic information on the   *
  !  settings of the FLEXPART run.                                             *
  !  The header file is essential and must be read in by any postprocessing    *
  !  program before reading in the output data.                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  !  Modified to remove TRIM around the output of flexversion so that          *
  !  it will be a constant length (defined in com_mod.f90) in output header    *
  !                                                                            *
  !     Don Morton, Boreal Scientific Computing                                *
  !     07 May 2017                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! xlon                   longitude                                           *
  ! xl                     model x coordinate                                  *
  ! ylat                   latitude                                            *
  ! yl                     model y coordinate                                  *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: jjjjmmdd,ihmmss,i,ix,jy,j
  real :: xp1,yp1,xp2,yp2


  !************************
  ! Open header output file
  !************************

  open(unitheader,file=path(2)(1:length(2))//'header_nest_grid_time', &
       form='unformatted',err=998)


  ! Write the header information
  !*****************************

  if (ldirect.eq.1) then
    write(unitheader) ibdate,ibtime,flexversion
  else
    write(unitheader) iedate,ietime,flexversion
  endif

  ! Write info on output interval, averaging time, sampling time
  !*************************************************************

  write(unitheader) loutstep,loutaver,loutsample

  ! Write information on output grid setup
  !***************************************

  write(unitheader) outlon0n,outlat0n,numxgridn,numygridn, &
       dxoutn,dyoutn
  write(unitheader) 1,(outheight(1),i=1,1)

  call caldate(bdate,jjjjmmdd,ihmmss)
  write(unitheader) jjjjmmdd,ihmmss

  ! Write number of species, and name for each species (+extra name for depositions)
  ! Indicate the dimension of the fields (i.e., 1 for deposition fields, numzgrid for
  ! concentration fields
  !*****************************************************************************

  write(unitheader) 3*nspec,maxpointspec_act
  do i=1,nspec
    write(unitheader) 1,'WD_'//species(i)(1:7)
    write(unitheader) 1,'DD_'//species(i)(1:7)
    write(unitheader) 1,species(i)
  end do

  ! Write information on release points: total number, then for each point:
  ! start, end, coordinates, # of particles, name, mass
  !************************************************************************

  write(unitheader) numpoint
  do i=1,numpoint
    write(unitheader) ireleasestart(i),ireleaseend(i),kindz(i)
    xp1=xpoint1(i)*dx+xlon0
    yp1=ypoint1(i)*dy+ylat0
    xp2=xpoint2(i)*dx+xlon0
    yp2=ypoint2(i)*dy+ylat0
    write(unitheader) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
    write(unitheader) npart(i),1
    if (numpoint.le.1000) then
      write(unitheader) compoint(i)
    else
      write(unitheader) compoint(1001)
   endif
    do j=1,nspec
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
    end do
  end do

  ! Write information on some model switches
  !*****************************************

  write(unitheader) method,lsubgrid,lconvection, &
       ind_source,ind_receptor

  ! Write age class information
  !****************************

  write(unitheader) nageclass,(lage(i),i=1,nageclass)


  ! Write topography to output file
  !********************************

  do ix=0,numxgridn-1
    write(unitheader) (orooutn(ix,jy),jy=0,numygridn-1)
  end do
  close(unitheader)

  return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'header'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  error stop

end subroutine writeheader_bin_sfc_nest

subroutine writeheader_bin_sfc

  !*****************************************************************************
  !                                                                            *
  !  This routine produces a file header containing basic information on the   *
  !  settings of the FLEXPART run.                                             *
  !  The header file is essential and must be read in by any postprocessing    *
  !  program before reading in the output data.                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  !  Modified to remove TRIM around the output of flexversion so that          *
  !  it will be a constant length (defined in com_mod.f90) in output header    *
  !                                                                            *
  !     Don Morton, Boreal Scientific Computing                                *
  !     07 May 2017                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! xlon                   longitude                                           *
  ! xl                     model x coordinate                                  *
  ! ylat                   latitude                                            *
  ! yl                     model y coordinate                                  *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: jjjjmmdd,ihmmss,i,ix,jy,j
  real :: xp1,yp1,xp2,yp2


  !************************
  ! Open header output file
  !************************

  open(unitheader,file=path(2)(1:length(2))//'header_grid_time', &
       form='unformatted',err=998)


  ! Write the header information
  !*****************************

  if (ldirect.eq.1) then
    write(unitheader) ibdate,ibtime, flexversion
  else
    write(unitheader) iedate,ietime, flexversion
  endif

  ! Write info on output interval, averaging time, sampling time
  !*************************************************************

  write(unitheader) loutstep,loutaver,loutsample

  ! Write information on output grid setup
  !***************************************

  write(unitheader) outlon0,outlat0,numxgrid,numygrid, &
       dxout,dyout
  write(unitheader) 1,(outheight(1),i=1,1)

  call caldate(bdate,jjjjmmdd,ihmmss)
  write(unitheader) jjjjmmdd,ihmmss

  ! Write number of species, and name for each species (+extra name for depositions)
  ! Indicate the dimension of the fields (i.e., 1 for deposition fields, numzgrid for
  ! concentration fields
  !*****************************************************************************

  write(unitheader) 3*nspec,maxpointspec_act
  do i=1,nspec
    write(unitheader) 1,'WD_'//species(i)(1:7)
    write(unitheader) 1,'DD_'//species(i)(1:7)
    write(unitheader) 1,species(i)
  end do

  ! Write information on release points: total number, then for each point:
  ! start, end, coordinates, # of particles, name, mass
  !************************************************************************

  write(unitheader) numpoint
  do i=1,numpoint
    write(unitheader) ireleasestart(i),ireleaseend(i),kindz(i)
    xp1=xpoint1(i)*dx+xlon0
    yp1=ypoint1(i)*dy+ylat0
    xp2=xpoint2(i)*dx+xlon0
    yp2=ypoint2(i)*dy+ylat0
    write(unitheader) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
    write(unitheader) npart(i),1
    if (numpoint.le.1000) then
      write(unitheader) compoint(i)
    else
      write(unitheader) compoint(1001)
    endif
    do j=1,nspec
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
      write(unitheader) xmass(i,j)
    end do
  end do

  ! Write information on some model switches
  !*****************************************

  write(unitheader) method,lsubgrid,lconvection, &
       ind_source,ind_receptor

  ! Write age class information
  !****************************

  write(unitheader) nageclass,(lage(i),i=1,nageclass)


  ! Write topography to output file
  !********************************

  do ix=0,numxgrid-1
    write(unitheader) (oroout(ix,jy),jy=0,numygrid-1)
  end do
  close(unitheader)

  return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'header'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  error stop

end subroutine writeheader_bin_sfc

subroutine receptorout_init_binary

  !*****************************************************************************
  !                                                                            *
  !  This routine opens the receptor output files and writes out the receptor  *
  !  names, location and times. The receptor output files are not              *
  !  closed, but kept open throughout the simulation. Concentrations are       *
  !  continuously  dumped to these files.                                      *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !     7 August 2002                                                          *
  !                                                                            *
  !     Modified: R. Thompson                                                  *
  !     January 2024: for moving receptors                                     *
  !                   changed format write to:                                 *
  !                     nspec                                                  *
  !                   and then for each timestep and receptors:                *
  !                     name, lat, lon, alt, time, nn, xk, conc, unc           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! numreceptor            actual number of receptor points specified          *
  ! receptorname           names of the receptor points                        *
  ! xreceptor              longitude coordinate of the receptor points         *
  ! yreceptor              latitude coordinate of the receptor points          *
  ! zreceptor              altitude coordinate of the receptor points          *
  ! treceptor              time coordinate of the receptor points              *
  !                                                                            *
  !*****************************************************************************

  implicit none

    if (numreceptor.eq.0) then
      return
    endif

    ! Open output file for receptor points and write number 
    ! of receptors and species for concentration and uncertainty variables
    !**********************************************************************

    ! Concentration output
    if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
      if ((ipin.eq.1).or.(ipin.eq.4)) then
        open(unitoutrecept,file=path(2)(1:length(2))//'receptor_conc', &
           access='APPEND',status='OLD',err=997)
      else
        open(unitoutrecept,file=path(2)(1:length(2))//'receptor_conc', &
             form='unformatted',err=997)
        write(unitoutrecept)   numreceptor
        if (llcmoutput) then
          write(unitoutrecept) nspec-1 ! first species is mass of air
        else
          write(unitoutrecept) nspec
        endif
      endif
    endif

    ! Mixing ratio output
    if ((iout.eq.2).or.(iout.eq.3)) then
      if ((ipin.eq.1).or.(ipin.eq.4)) then
        open(unitoutreceptppt,file=path(2)(1:length(2))//'receptor_pptv', &
           access='APPEND',status='OLD',err=998)
      else
        open(unitoutreceptppt,file=path(2)(1:length(2))//'receptor_pptv', &
             form='unformatted',err=998)
        write(unitoutreceptppt)   numreceptor
        if (llcmoutput) then
          write(unitoutreceptppt) nspec-1 ! first species is mass of air
        else
          write(unitoutreceptppt) nspec
        endif
      endif
    endif

    return

997   write(*,*) ' #### FLEXPART MODEL ERROR! THE FILE           #### '
    write(*,*) ' ####              receptor_conc               #### '
    write(*,*) ' #### CANNOT BE OPENED.                        #### '
    error stop

998   write(*,*) ' #### FLEXPART MODEL ERROR! THE FILE           #### '
    write(*,*) ' ####              receptor_pptv               #### '
    write(*,*) ' #### CANNOT BE OPENED.                        #### '
    error stop

end subroutine receptorout_init_binary


subroutine satelliteout_init_binary

  !*****************************************************************************
  !                                                                            *
  !  This routine opens the satellite output files for subsequent writing      *
  !                                                                            *
  !     Author: R. Thompson                                                    *
  !     January 2024                                                           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! numsatreceptor         actual number of satellite receptors                *
  ! nspec                  number of species                                   *
  ! nlayermax              max number of layers in retrievals                  *
  !                                                                            *
  !*****************************************************************************

  implicit none

    if (numsatreceptor.eq.0) then
      return
    endif

    ! Open output file for satellite receptors and write number 
    ! of receptors and species for concentration and uncertainty variables
    !**********************************************************************

    ! Mixing ratio output
    if ((ipin.eq.1).or.(ipin.eq.4)) then
      open(unitoutsatellite,file=path(2)(1:length(2))//'satellite_pptv', &
         access='APPEND',status='OLD',err=998)
    else
      open(unitoutsatellite,file=path(2)(1:length(2))//'satellite_pptv', &
           form='unformatted',err=998)
!      write(unitoutsatellite)   numsatreceptor
      if (llcmoutput) then
        write(unitoutsatellite) nspec-1 ! first species is mass of air
      else
        write(unitoutsatellite) nspec
      endif
      write(unitoutsatellite)   nlayermax
    endif

    return  

998 write(*,*) ' #### FLEXPART MODEL ERROR! THE FILE           #### '
    write(*,*) ' ####           satellite_pptv                 #### '
    write(*,*) ' #### CANNOT BE OPENED.                        #### '
    error stop

end subroutine satelliteout_init_binary


subroutine write_receptor_binary(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namerec,nrec)

  !*****************************************************************************
  !                                                                            *
  !  This routine writes the receptor concentrations for each time step        *
  !  and receptor to binary output files                                       *
  !                                                                            *
  !  R. Thompson, January 2024                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

    integer :: nrec, ks, ks_start
    real, dimension(nspec,maxrecsample,nlayermax) :: crec, cunc
    real, dimension(maxrecsample,nlayermax) :: nnrec, xkrec, altrec
    real, dimension(maxrecsample) :: lonrec, latrec
    integer, dimension(maxrecsample) :: timerec
    character(len=16), dimension(maxrecsample) :: namerec

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif

    if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
      write(unitoutrecept) nrec
      write(unitoutrecept) namerec(1:nrec)
      write(unitoutrecept) lonrec(1:nrec)
      write(unitoutrecept) latrec(1:nrec)
      write(unitoutrecept) altrec(1:nrec,1)
      write(unitoutrecept) timerec(1:nrec)
      write(unitoutrecept) nnrec(1:nrec,1)
      write(unitoutrecept) xkrec(1:nrec,1)
      write(unitoutrecept) (crec(ks,1:nrec,1),ks=ks_start,nspec)
      write(unitoutrecept) (cunc(ks,1:nrec,1),ks=ks_start,nspec)
    endif
    if ((iout.eq.2).or.(iout.eq.3)) then
      write(unitoutreceptppt) nrec
      write(unitoutreceptppt) namerec(1:nrec)
      write(unitoutreceptppt) lonrec(1:nrec)
      write(unitoutreceptppt) latrec(1:nrec)
      write(unitoutreceptppt) altrec(1:nrec,1)
      write(unitoutreceptppt) timerec(1:nrec)
      write(unitoutreceptppt) nnrec(1:nrec,1)
      write(unitoutreceptppt) xkrec(1:nrec,1)
      write(unitoutreceptppt) (crec(ks,1:nrec,1),ks=ks_start,nspec)
      write(unitoutreceptppt) (cunc(ks,1:nrec,1),ks=ks_start,nspec)
    endif

end subroutine write_receptor_binary


subroutine write_satellite_binary(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namerec,nrec)

  !*****************************************************************************
  !                                                                            *
  !  This routine writes the satellite concentrations for each time step       *
  !  and receptor to binary output files                                       *
  !                                                                            *
  !  R. Thompson, January 2024                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

    integer :: nrec, n, ks, ks_start
    real, dimension(nspec,maxrecsample,nlayermax) :: crec, cunc
    real, dimension(maxrecsample,nlayermax) :: nnrec, xkrec, altrec
    real, dimension(maxrecsample) :: lonrec, latrec
    integer, dimension(maxrecsample) :: timerec
    character(len=24), dimension(maxrecsample) :: namerec

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif
   
    ! satellite only mixing ratio output
    write(unitoutsatellite) nrec
    write(unitoutsatellite) namerec(1:nrec)
    write(unitoutsatellite) timerec(1:nrec)
    write(unitoutsatellite) lonrec(1:nrec)
    write(unitoutsatellite) latrec(1:nrec)
    write(unitoutsatellite) (altrec(n,1:nlayermax),n=1,nrec)
    write(unitoutsatellite) (nnrec(n,1:nlayermax),n=1,nrec)
    write(unitoutsatellite) (xkrec(n,1:nlayermax),n=1,nrec)
    do ks=ks_start,nspec
      write(unitoutsatellite) (crec(ks,n,1:nlayermax),n=1,nrec)
      write(unitoutsatellite) (cunc(ks,n,1:nlayermax),n=1,nrec)
    end do

end subroutine write_satellite_binary


subroutine concoutput(itime,outnum,gridtotalunc,wetgridtotalunc, &
     drygridtotalunc)
  !                        i     i          o             o
  !       o
  !*****************************************************************************
  !                                                                            *
  !     Output of the concentration grid                                       *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! outnum          number of samples                                          *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  ! tot_mu          1 for forward, initial mass mixing ration for backw. runs  *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use mean_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,i,ix,jy,kz,ks,kp,l,iix,jjy,kzz,nage,jjjjmmdd,ihmmss
  integer :: sp_count_i,sp_count_r
  real :: sp_fact
  real :: outnum,xl,yl

  real(dep_prec) :: auxgrid(nclassunc)
  real(sp) :: gridtotal,gridsigmatotal,gridtotalunc
  real(dep_prec) :: wetgridtotal,wetgridsigmatotal,wetgridtotalunc
  real(dep_prec) :: drygridtotal,drygridsigmatotal,drygridtotalunc
  real :: halfheight,dz,dz1,dz2,tot_mu(maxspec,maxpointspec_act)
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  real,parameter :: weightair=28.97
  logical :: sp_zer
  logical,save :: init=.true.
  character :: adate*8,atime*6
  character(len=3) :: anspec
  integer :: mind
  character(LEN=8),save :: file_stat='REPLACE'
  logical :: ldates_file
  logical :: lexist
  integer :: ierr
  character(LEN=100) :: dates_char
  integer :: numzwrite, ks_start

  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss

  ! Overwrite existing dates file on first call, later append to it
  ! This fixes a bug where the dates file kept growing across multiple runs
  ! Restarting a run:
  if ((ipin.eq.1).or.(ipin.eq.4)) then
    file_stat='OLD'
    init=.false.
  endif

  ! If 'dates' file exists in output directory, make a backup
  inquire(file=path(2)(1:length(2))//'dates', exist=ldates_file)
  if (ldates_file.and.init) then
    open(unit=unitdates, file=path(2)(1:length(2))//'dates',form='formatted', &
         &access='sequential', status='old', action='read', iostat=ierr)
    open(unit=unittmp, file=path(2)(1:length(2))//'dates.bak', access='sequential', &
         &status='replace', action='write', form='formatted', iostat=ierr)
    do while (.true.)
      read(unitdates, '(a)', iostat=ierr) dates_char
      if (ierr.ne.0) exit
      write(unit=unittmp, fmt='(a)', iostat=ierr, advance='yes') trim(dates_char)
    end do
    close(unit=unitdates)
    close(unit=unittmp)
  end if

  open(unitdates,file=path(2)(1:length(2))//'dates', ACCESS='APPEND', STATUS=file_stat)
  write(unitdates,'(a)') adate//atime
  close(unitdates)  

  ! Overwrite existing dates file on first call, later append to it
  ! This fixes a bug where the dates file kept growing across multiple runs
  IF (init) THEN
    file_stat='OLD'
    init=.false.
  END IF


  ! For forward simulations, output fields have dimension MAXSPEC,
  ! for backward simulations, output fields have dimension MAXPOINT.
  ! Thus, make loops either about nspec, or about numpoint
  !*****************************************************************


  if (ldirect.eq.1) then
    tot_mu(:,:)=1.
  else
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=xmass(kp,ks)
      end do
    end do
  endif


  !*******************************************************************
  ! Compute air density: sufficiently accurate to take it
  ! from coarse grid at some time
  ! Determine center altitude of output layer, and interpolate density
  ! data to that altitude
  ! 
  ! Note:
  !  llcmoutput = true: grid is mass_spec/mass_air  
  !                     for iout 1,3, or 5 multiply by rho
  !                     for iout 2 multiply by 1
  !  llcmoutput = false: grid is mass_spec/V
  !                     for iout 1,3, or 5 multiply by 1
  !                     for iout 2 multiply by 1/rho 
  !*******************************************************************

!$OMP PARALLEL &
!$OMP PRIVATE(kz,halfheight,kzz,dz1,dz2,dz,xl,yl,iix,jjy, &
!$OMP ix,jy,l,ks,kp,nage,auxgrid) &
!$OMP REDUCTION(+:wetgridtotal,wetgridsigmatotal, &
!$OMP drygridtotal,drygridsigmatotal,gridtotal,gridsigmatotal)

  if (((.not.llcmoutput).and.(iout.eq.2)).or.&
      (llcmoutput.and.((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)))) then
    ! compute density
    mind=memind(2)
!$OMP DO
    do kz=1,numzgrid
      if (kz.eq.1) then
        halfheight=outheight(1)*0.5
      else
        halfheight=(outheight(kz)+outheight(kz-1))*0.5
      endif
      do kzz=2,nz
        if ((height(kzz-1).lt.halfheight).and. &
             (height(kzz).gt.halfheight)) exit
      end do
      kzz=max(min(kzz,nz),2)
      dz1=halfheight-height(kzz-1)
      dz2=height(kzz)-halfheight
      dz=dz1+dz2
      do jy=0,numygrid-1
        do ix=0,numxgrid-1
          xl=outlon0+real(ix)*dxout
          yl=outlat0+real(jy)*dyout
          xl=(xl-xlon0)/dx
          yl=(yl-ylat0)/dy !v9.1.1 
          iix=max(min(nint(xl),nxmin1),0)
          jjy=max(min(nint(yl),nymin1),0)
          densityoutgrid(ix,jy,kz)=(rho(iix,jjy,kzz,mind)*dz1+ &
               rho(iix,jjy,kzz-1,mind)*dz2)/dz
          densitydrygrid(ix,jy,kz)=(rho_dry(iix,jjy,kzz,mind)*dz1+ &
               rho_dry(iix,jjy,kzz-1,mind)*dz2)/dz  
        end do
      end do
    end do
!$OMP END DO
    ! conversion factor for output relative to dry air
    factor_drygrid=densityoutgrid/densitydrygrid
    if (llcmoutput) then
      ! because divide grid by densityoutgrid
      densityoutgrid=1./densityoutgrid
    endif
  else
    ! no division by density
    densityoutgrid(:,:,:)=1.
  endif

  ! Output is different for forward and backward simulations
  if (ldirect.eq.1) then
!$OMP DO
    do kz=1,numzgrid
      do jy=0,numygrid-1
        do ix=0,numxgrid-1
          if (llcmoutput) then
            if (gridcnt(ix,jy,kz).gt.0.) then
              factor3d(ix,jy,kz)=1.e12/gridcnt(ix,jy,kz)
            else
              factor3d(ix,jy,kz)=0.
            endif
          else
            factor3d(ix,jy,kz)=1.e12/volume(ix,jy,kz)/outnum
          endif
        end do
      end do
    end do
!$OMP END DO
  else
    factor3d(:,:,:)=real(abs(loutaver))/outnum
  endif

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  gridtotal=0.
  gridsigmatotal=0.
  gridtotalunc=0.
  wetgridtotal=0.
  wetgridsigmatotal=0.
  wetgridtotalunc=0.
  drygridtotal=0.
  drygridsigmatotal=0.
  drygridtotalunc=0.

  if (llcmoutput) then
    ks_start=2
  else
    ks_start=1
  endif

  do ks=ks_start,nspec

!$OMP BARRIER
!$OMP SINGLE
    write(anspec,'(i3.3)') ks

    if (DRYBKDEP.or.WETBKDEP) then !scavdep output
      if (DRYBKDEP) & 
      open(unitoutgrid,file=path(2)(1:length(2))//'grid_drydep_'//adate// &
           atime//'_'//anspec,form='unformatted')
      if (WETBKDEP) & 
      open(unitoutgrid,file=path(2)(1:length(2))//'grid_wetdep_'//adate// &
           atime//'_'//anspec,form='unformatted')
      write(unitoutgrid) itime
    else
      if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
        if (ldirect.eq.1) then
          open(unitoutgrid,file=path(2)(1:length(2))//'grid_conc_'//adate// &
             atime//'_'//anspec,form='unformatted')
        else
          open(unitoutgrid,file=path(2)(1:length(2))//'grid_time_'//adate// &
             atime//'_'//anspec,form='unformatted')
        endif
        write(unitoutgrid) itime
      endif
      if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio
        open(unitoutgridppt,file=path(2)(1:length(2))//'grid_pptv_'//adate// &
           atime//'_'//anspec,form='unformatted')
        write(unitoutgridppt) itime
      endif
    endif ! if deposition output
!$OMP END SINGLE

    do kp=1,maxpointspec_act
      do nage=1,nageclass
!$OMP DO
        do jy=0,numygrid-1
          do ix=0,numxgrid-1

  ! WET DEPOSITION
            if ((WETDEP).and.(ldirect.gt.0)) then
              do l=1,nclassunc
                auxgrid(l)=wetgridunc(ix,jy,ks,kp,l,nage)
              end do
              call mean(auxgrid,wetgrid(ix,jy), &
                   wetgridsigma(ix,jy),nclassunc)
  ! Multiply by number of classes to get total concentration
              wetgrid(ix,jy)=wetgrid(ix,jy) &
                   *nclassunc
              wetgridtotal=wetgridtotal+wetgrid(ix,jy)
  ! Calculate standard deviation of the mean
              wetgridsigma(ix,jy)= &
                   wetgridsigma(ix,jy)* &
                   sqrt(real(nclassunc))
              wetgridsigmatotal=wetgridsigmatotal+ &
                   wetgridsigma(ix,jy)
            endif

  ! DRY DEPOSITION
            if ((DRYDEP).and.(ldirect.gt.0)) then
              do l=1,nclassunc
                auxgrid(l)=drygridunc(ix,jy,ks,kp,l,nage)
              end do
              call mean(auxgrid,drygrid(ix,jy), &
                   drygridsigma(ix,jy),nclassunc)
  ! Multiply by number of classes to get total concentration
              drygrid(ix,jy)=drygrid(ix,jy)* &
                   nclassunc
              drygridtotal=drygridtotal+drygrid(ix,jy)
  ! Calculate standard deviation of the mean
              drygridsigma(ix,jy)= &
                   drygridsigma(ix,jy)* &
                   sqrt(real(nclassunc))
              drygridsigmatotal=drygridsigmatotal+ &
                   drygridsigma(ix,jy)
            endif

  ! CONCENTRATION OR MIXING RATIO
            do kz=1,numzgrid
              do l=1,nclassunc
                auxgrid(l)=gridunc(ix,jy,kz,ks,kp,l,nage)
              end do
              call mean(auxgrid,grid(ix,jy,kz), &
                   gridsigma(ix,jy,kz),nclassunc)
  ! Multiply by number of classes to get total concentration
              grid(ix,jy,kz)= &
                   grid(ix,jy,kz)*nclassunc
              gridtotal=gridtotal+grid(ix,jy,kz)
  ! Calculate standard deviation of the mean
              gridsigma(ix,jy,kz)= &
                   gridsigma(ix,jy,kz)* &
                   sqrt(real(nclassunc))
              gridsigmatotal=gridsigmatotal+ &
                   gridsigma(ix,jy,kz)
            end do
          end do
        end do
!$OMP END DO

  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

!$OMP BARRIER
!$OMP SINGLE

  ! Concentration output
  !*********************

        if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then

  ! Wet deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(WETDEP)) then
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
  ! concentration greater zero
                if (wetgrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)=ix+jy*numxgrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact*1.e12*real(wetgrid(ix,jy))/area(ix,jy)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgrid) sp_count_i
          write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgrid) sp_count_r
          write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)

  ! Dry deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(DRYDEP)) then
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
                if (drygrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)=ix+jy*numxgrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact* &
                       1.e12*real(drygrid(ix,jy))/area(ix,jy)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgrid) sp_count_i
          write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgrid) sp_count_r
          write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)

  ! Concentrations
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          numzwrite=numzgrid
          if (sfc_only.eq.1) numzwrite=1
          do kz=1,numzwrite
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgrid+kz*numxgrid*numygrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  if (lparticlecountoutput) then
                    sparse_dump_r(sp_count_r)= &
                         sp_fact* &
                         grid(ix,jy,kz)
                  else
                    sparse_dump_r(sp_count_r)= &
                         sp_fact* &
                         grid(ix,jy,kz)* &
                         factor3d(ix,jy,kz)/tot_mu(ks,kp)
                  end if

                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          end do
          write(unitoutgrid) sp_count_i
          write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgrid) sp_count_r
          write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)
        endif !  concentration output

  ! Mixing ratio output
  !********************

        if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio

  ! Wet deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(WETDEP)) then
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
                if (wetgrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact* &
                       1.e12*real(wetgrid(ix,jy))/area(ix,jy)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

  ! Dry deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(DRYDEP)) then
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
                if (drygrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact* &
                       1.e12*real(drygrid(ix,jy))/area(ix,jy)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

  ! Mixing ratios
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          numzwrite=numzgrid
          if (sfc_only.eq.1) numzwrite=1
          do kz=1,numzwrite
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgrid+kz*numxgrid*numygrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact* &
                       factor3d(ix,jy,kz)*grid(ix,jy,kz)* &
                       weightair/weightmolar(ks)/densityoutgrid(ix,jy,kz)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          end do
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

        endif ! output for ppt
!$OMP END SINGLE
!$OMP BARRIER
      end do
    end do

    close(unitoutgridppt)
    close(unitoutgrid)

  end do
!$OMP END PARALLEL

  ! Write out conversion factor for dry air
  !****************************************

  if (.not.llcmoutput) then
    inquire(file=path(2)(1:length(2))//'factor_drygrid',exist=lexist)
    if (lexist) then
      ! open and append
      open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid',form='unformatted',&
            status='old',action='write',access='append')
    else
      ! create new
      open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid',form='unformatted',&
            status='new',action='write')
    endif
    sp_count_i=0
    sp_count_r=0
    sp_fact=-1.
    sp_zer=.true.
    numzwrite=numzgrid
    if (sfc_only.eq.1) numzwrite=1
    do kz=1,numzwrite
      do jy=0,numygrid-1
        do ix=0,numxgrid-1
          if (factor_drygrid(ix,jy,kz).gt.(1.+smallnum).or.factor_drygrid(ix,jy,kz).lt.(1.-smallnum)) then
            if (sp_zer.eqv..true.) then ! first value not equal to one
              sp_count_i=sp_count_i+1
              sparse_dump_i(sp_count_i)= &
                  ix+jy*numxgrid+kz*numxgrid*numygrid
              sp_zer=.false.
              sp_fact=sp_fact*(-1.)
            endif
            sp_count_r=sp_count_r+1
            sparse_dump_r(sp_count_r)= &
                 sp_fact*factor_drygrid(ix,jy,kz)
          else ! factor is one
            sp_zer=.true.
          endif
        end do
      end do
    end do
    write(unitoutfactor) sp_count_i
    write(unitoutfactor) (sparse_dump_i(i),i=1,sp_count_i)
    write(unitoutfactor) sp_count_r
    write(unitoutfactor) (sparse_dump_r(i),i=1,sp_count_r)
    close(unitoutfactor)
  endif

  if (gridtotal.gt.0.) gridtotalunc=gridsigmatotal/gridtotal
  if (wetgridtotal.gt.0.) wetgridtotalunc=wetgridsigmatotal/ &
       wetgridtotal
  if (drygridtotal.gt.0.) drygridtotalunc=drygridsigmatotal/ &
       drygridtotal

  gridunc(:,:,:,:,:,:,:)=0.
  gridcnt(:,:,:) = 0.
#ifdef _OPENMP
  gridunc_omp(:,:,:,:,:,:,:,:) = 0.
  gridcnt_omp(:,:,:,:) = 0.
#endif  

end subroutine concoutput

subroutine concoutput_nest(itime,outnum)
  !                        i     i
  !*****************************************************************************
  !                                                                            *
  !     Output of the nested concentration grid                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! outnum          number of samples                                          *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  ! tot_mu          1 for forward, initial mass mixing ration for backw. runs  *
  !                                                                            *
  !*****************************************************************************
  use unc_mod
  use mean_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,i,ix,jy,kz,ks,kp,l,iix,jjy,kzz,nage,jjjjmmdd,ihmmss
  integer :: sp_count_i,sp_count_r
  real :: sp_fact
  real :: outnum,xl,yl
  real(dep_prec) :: auxgrid(nclassunc)
  real :: halfheight,dz,dz1,dz2,tot_mu(maxspec,maxpointspec_act)
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  real,parameter :: weightair=28.97
  logical :: sp_zer
  character :: adate*8,atime*6
  character(len=3) :: anspec
  logical :: lexist
  integer :: mind 
  integer :: numzwrite


  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss


  ! For forward simulations, output fields have dimension MAXSPEC,
  ! for backward simulations, output fields have dimension MAXPOINT.
  ! Thus, make loops either about nspec, or about numpoint
  !*****************************************************************


  if (ldirect.eq.1) then
    tot_mu(:,:)=1.
  else
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=xmass(kp,ks)
      end do
    end do
  endif


  !*******************************************************************
  ! Compute air density: sufficiently accurate to take it
  ! from coarse grid at some time
  ! Determine center altitude of output layer, and interpolate density
  ! data to that altitude
  !*******************************************************************

  mind=memind(2)

!$OMP PARALLEL &
!$OMP PRIVATE(halfheight,kzz,dz1,dz2,dz,xl,yl,iix,jjy, &
!$OMP kz,ix,jy,l,ks,kp,nage,auxgrid) 

!$OMP DO
  do kz=1,numzgrid
    if (kz.eq.1) then
      halfheight=outheight(1)*0.5
    else
      halfheight=(outheight(kz)+outheight(kz-1))*0.5
    endif
    do kzz=2,nz
      if ((height(kzz-1).lt.halfheight).and. &
           (height(kzz).gt.halfheight)) exit
    end do
    kzz=max(min(kzz,nz),2)
    dz1=halfheight-height(kzz-1)
    dz2=height(kzz)-halfheight
    dz=dz1+dz2
    do jy=0,numygridn-1
      do ix=0,numxgridn-1
        xl=outlon0n+real(ix)*dxoutn
        yl=outlat0n+real(jy)*dyoutn
        xl=(xl-xlon0)/dx
        yl=(yl-ylat0)/dy
        iix=max(min(nint(xl),nxmin1),0)
        jjy=max(min(nint(yl),nymin1),0)
        densityoutgrid(ix,jy,kz)=(rho(iix,jjy,kzz,mind)*dz1+ &
             rho(iix,jjy,kzz-1,mind)*dz2)/dz
        densitydrygrid(ix,jy,kz)=(rho_dry(iix,jjy,kzz,mind)*dz1+ &
             rho_dry(iix,jjy,kzz-1,mind)*dz2)/dz
      end do
    end do
  end do
!$OMP END DO

  ! conversion factor for output relative to dry air
  factor_drygrid=densityoutgrid/densitydrygrid

  ! Output is different for forward and backward simulations
  if ( ldirect.eq.1) then
    factor3d(:,:,:)=1.e12/volumen(:,:,:)/outnum
  else
    factor3d(:,:,:)=real(abs(loutaver))/outnum
  endif

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  do ks=1,nspec

!$OMP BARRIER
!$OMP SINGLE
    write(anspec,'(i3.3)') ks
 
    if (DRYBKDEP.or.WETBKDEP) then !scavdep output
      if (DRYBKDEP) &
      open(unitoutgrid,file=path(2)(1:length(2))//'grid_drydep_nest_'//adate// &
           atime//'_'//anspec,form='unformatted')
      if (WETBKDEP) &
      open(unitoutgrid,file=path(2)(1:length(2))//'grid_wetdep_nest_'//adate// &
           atime//'_'//anspec,form='unformatted')
      write(unitoutgrid) itime
    else
      if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
        if (ldirect.eq.1) then
          open(unitoutgrid,file=path(2)(1:length(2))//'grid_conc_nest_' &
            //adate// &
            atime//'_'//anspec,form='unformatted')
        else
          open(unitoutgrid,file=path(2)(1:length(2))//'grid_time_nest_' &
            //adate// &
            atime//'_'//anspec,form='unformatted')
        endif
        write(unitoutgrid) itime
      endif
    endif
    if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio
     open(unitoutgridppt,file=path(2)(1:length(2))//'grid_pptv_nest_' &
          //adate// &
          atime//'_'//anspec,form='unformatted')

      write(unitoutgridppt) itime
    endif
!$OMP END SINGLE

    do kp=1,maxpointspec_act
      do nage=1,nageclass
!$OMP DO
        do jy=0,numygridn-1
          do ix=0,numxgridn-1

  ! WET DEPOSITION
            if ((WETDEP).and.(ldirect.gt.0)) then
              do l=1,nclassunc
                auxgrid(l)=wetgriduncn(ix,jy,ks,kp,l,nage)
              end do
              call mean(auxgrid,wetgrid(ix,jy), &
                   wetgridsigma(ix,jy),nclassunc)
  ! Multiply by number of classes to get total concentration
              wetgrid(ix,jy)=wetgrid(ix,jy) &
                   *nclassunc
  ! Calculate standard deviation of the mean
              wetgridsigma(ix,jy)= &
                   wetgridsigma(ix,jy)* &
                   sqrt(real(nclassunc))
            endif

  ! DRY DEPOSITION

            if ((DRYDEP).and.(ldirect.gt.0)) then
              do l=1,nclassunc
                auxgrid(l)=drygriduncn(ix,jy,ks,kp,l,nage)
              end do
              call mean(auxgrid,drygrid(ix,jy), &
                   drygridsigma(ix,jy),nclassunc)
  ! Multiply by number of classes to get total concentration
              drygrid(ix,jy)=drygrid(ix,jy)* &
                   nclassunc
  ! Calculate standard deviation of the mean
              drygridsigma(ix,jy)= &
                   drygridsigma(ix,jy)* &
                   sqrt(real(nclassunc))
            endif

  ! CONCENTRATION OR MIXING RATIO
            do kz=1,numzgrid
              do l=1,nclassunc
                auxgrid(l)=griduncn(ix,jy,kz,ks,kp,l,nage)
              end do
              call mean(auxgrid,grid(ix,jy,kz), &
                   gridsigma(ix,jy,kz),nclassunc)
  ! Multiply by number of classes to get total concentration
              grid(ix,jy,kz)= &
                   grid(ix,jy,kz)*nclassunc
  ! Calculate standard deviation of the mean
              gridsigma(ix,jy,kz)= &
                   gridsigma(ix,jy,kz)* &
                   sqrt(real(nclassunc))
            end do
          end do ! ix
        end do ! jy
!$OMP END DO

  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

!$OMP BARRIER
!$OMP SINGLE

  ! Concentration output
  !*********************
        if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then

  ! Wet deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(WETDEP)) then
           do jy=0,numygridn-1
             do ix=0,numxgridn-1
  !concentration greater zero
               if (wetgrid(ix,jy).gt.smallnum) then
                 if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)=ix+jy*numxgridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact*1.e12*real(wetgrid(ix,jy))/arean(ix,jy)
               else ! concentration is zero
                  sp_zer=.true.
               endif
             end do
           end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgrid) sp_count_i
          write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgrid) sp_count_r
          write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)

  ! Dry deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(DRYDEP)) then
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (drygrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                     sp_count_i=sp_count_i+1
                     sparse_dump_i(sp_count_i)=ix+jy*numxgridn
                     sp_zer=.false.
                     sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact* &
                       1.e12*real(drygrid(ix,jy))/arean(ix,jy)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgrid) sp_count_i
          write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgrid) sp_count_r
          write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)

  ! Concentrations
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          numzwrite=numzgrid
          if (sfc_only.eq.1) numzwrite=1
          do kz=1,numzwrite
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn+kz*numxgridn*numygridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                        sp_fact* &
                        grid(ix,jy,kz)* &
                        factor3d(ix,jy,kz)/tot_mu(ks,kp)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          end do
          write(unitoutgrid) sp_count_i
          write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgrid) sp_count_r
          write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)

        endif !  concentration output

  ! Mixing ratio output
  !********************

        if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio

  ! Wet deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(WETDEP)) then
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (wetgrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*real(wetgrid(ix,jy))/arean(ix,jy)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

  ! Dry deposition
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          if ((ldirect.eq.1).and.(DRYDEP)) then
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (drygrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*real(drygrid(ix,jy))/arean(ix,jy)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          else
            sp_count_i=0
            sp_count_r=0
          endif
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

  ! Mixing ratios
          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          numzwrite=numzgrid
          if (sfc_only.eq.1) numzwrite=1
          do kz=1,numzwrite
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn+kz*numxgridn*numygridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*grid(ix,jy,kz) &
                      /volumen(ix,jy,kz)/outnum* &
                      weightair/weightmolar(ks)/densityoutgrid(ix,jy,kz)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          end do
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

        endif ! output for ppt
!$OMP END SINGLE
!$OMP BARRIER
      end do
    end do

    close(unitoutgridppt)
    close(unitoutgrid)

  end do
!$OMP END PARALLEL

  ! Write out conversion factor for dry air
  !****************************************

  inquire(file=path(2)(1:length(2))//'factor_drygrid_nest',exist=lexist)
  if (lexist) then
    ! open and append
    open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid_nest',form='unformatted',&
            status='old',action='write',access='append')
  else
    ! create new
    open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid_nest',form='unformatted',&
            status='new',action='write')
  endif
  sp_count_i=0
  sp_count_r=0
  sp_fact=-1.
  sp_zer=.true.
  numzwrite=numzgrid
  if (sfc_only.eq.1) numzwrite=1
  do kz=1,numzwrite
    do jy=0,numygridn-1
      do ix=0,numxgridn-1
        if (factor_drygrid(ix,jy,kz).gt.(1.+smallnum).or.factor_drygrid(ix,jy,kz).lt.(1.-smallnum)) then
          if (sp_zer.eqv..true.) then ! first value not equal to one
            sp_count_i=sp_count_i+1
            sparse_dump_i(sp_count_i)= &
                  ix+jy*numxgridn+kz*numxgridn*numygridn
            sp_zer=.false.
            sp_fact=sp_fact*(-1.)
          endif
          sp_count_r=sp_count_r+1
          sparse_dump_r(sp_count_r)= &
               sp_fact*factor_drygrid(ix,jy,kz)
        else ! factor is one
          sp_zer=.true.
        endif
      end do
    end do
  end do
  write(unitoutfactor) sp_count_i
  write(unitoutfactor) (sparse_dump_i(i),i=1,sp_count_i)
  write(unitoutfactor) sp_count_r
  write(unitoutfactor) (sparse_dump_r(i),i=1,sp_count_r)
  close(unitoutfactor)

  griduncn(:,:,:,:,:,:,:)=0.
#ifdef _OPENMP
  griduncn_omp(:,:,:,:,:,:,:,:) = 0.
#endif

end subroutine concoutput_nest


subroutine concoutput_inversion(itime,outnum,gridtotalunc,wetgridtotalunc, &
     drygridtotalunc)
  !                        i     i          o             o
  !       o
  !*****************************************************************************
  !                                                                            *
  !     Output of the concentration grid formatted for inversions.             *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !     January 2017,  Separate files by release but include all timesteps     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! outnum          number of samples                                          *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  ! tot_mu          1 for forward, initial mass mixing ration for backw. runs  *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use mean_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,i,ix,jy,kz,ks,kp,l,iix,jjy,kzz,nage,jjjjmmdd,ihmmss
  integer :: sp_count_i,sp_count_r
  real :: sp_fact
  real :: outnum,xl,yl
  real(dep_prec) :: auxgrid(nclassunc)
  real(sp) :: gridtotal,gridsigmatotal,gridtotalunc
  real(dep_prec) :: wetgridtotal,wetgridsigmatotal,wetgridtotalunc
  real(dep_prec) :: drygridtotal,drygridsigmatotal,drygridtotalunc
  real :: halfheight,dz,dz1,dz2,tot_mu(maxspec,maxpointspec_act)
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  real,parameter :: weightair=28.97
  logical :: sp_zer
  character :: adate*8,atime*6
  character(len=3) :: anspec
  logical :: lexist
  character :: areldate*8,areltime*6
  logical,save :: lstart=.true.
  logical,save,allocatable,dimension(:) :: lstartrel
  integer :: ierr
  character(LEN=100) :: dates_char
  integer, parameter :: unitrelnames=654


  if(lstart) then
    allocate(lstartrel(maxpointspec_act))
    lstartrel(:)=.true.
  endif

  if (verbosity.eq.1) then
    CALL SYSTEM_CLOCK(count_clock)
    WRITE(*,*) 'SYSTEM_CLOCK',count_clock - count_clock0   
  endif

  ! Determine current calendar date
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss


  ! Prepare output files for dates
  !**********************************************************

  ! Overwrite existing dates file on first call, later append to it
  ! If 'dates' file exists in output directory, copy to new file dates.old
  inquire(file=path(2)(1:length(2))//'dates', exist=lexist)
  if (lexist.and.lstart) then
    ! copy contents of existing dates file to dates.old
    print*, 'warning: replacing old dates file'
    open(unit=unitdates, file=path(2)(1:length(2))//'dates',form='formatted', &
         &access='sequential', status='old', action='read', iostat=ierr)
    open(unit=unittmp, file=path(2)(1:length(2))//'dates.old', access='sequential', &
         &status='replace', action='write', form='formatted', iostat=ierr)
    do while (.true.)
      read(unitdates, '(a)', iostat=ierr) dates_char
      if (ierr.ne.0) exit
      write(unit=unittmp, fmt='(a)', iostat=ierr, advance='yes') trim(dates_char)
    end do
    close(unit=unitdates)
    close(unit=unittmp)
    ! create new dates file
    open(unit=unitdates, file=path(2)(1:length(2))//'dates',form='formatted', &
         &access='sequential', status='replace', iostat=ierr)
    close(unit=unitdates)
  endif

  open(unitdates,file=path(2)(1:length(2))//'dates', ACCESS='APPEND')
  write(unitdates,'(a)') adate//atime
  close(unitdates)

  !CGZ: Make a filename with names of releases
  if (lstart) then
    open(unit=unitrelnames, file=path(2)(1:length(2))//'releases_out',form='formatted', &
         &access='sequential', status='replace', iostat=ierr)
    close(unitrelnames)
  endif

  print*, 'after creating dates files: lstart = ',lstart
  !  print*, 'outnum:',outnum
  !  print*, 'datetime:',adate//atime


  ! For forward simulations, output fields have dimension MAXSPEC,
  ! for backward simulations, output fields have dimension MAXPOINT.
  ! Thus, make loops either about nspec, or about numpoint
  !*****************************************************************


  if (ldirect.eq.1) then
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=1
      end do
    end do
  else
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=xmass(kp,ks)
      end do
    end do
  endif


  if (verbosity.eq.1) then
    print*,'concoutput_inversion 2'
    CALL SYSTEM_CLOCK(count_clock)
    WRITE(*,*) 'SYSTEM_CLOCK',count_clock - count_clock0   
  endif

  !*******************************************************************
  ! Compute air density: sufficiently accurate to take it
  ! from coarse grid at some time
  ! Determine center altitude of output layer, and interpolate density
  ! data to that altitude
  !*******************************************************************

  do kz=1,numzgrid
    if (kz.eq.1) then
      halfheight=outheight(1)*0.5
    else
      halfheight=(outheight(kz)+outheight(kz-1))*0.5
    endif
    do kzz=2,nz
      if ((height(kzz-1).lt.halfheight).and. &
           (height(kzz).gt.halfheight)) goto 46
    end do
46  kzz=max(min(kzz,nz),2)
    dz1=halfheight-height(kzz-1)
    dz2=height(kzz)-halfheight
    dz=dz1+dz2
    do jy=0,numygrid-1
      do ix=0,numxgrid-1
        xl=outlon0+real(ix)*dxout
        yl=outlat0+real(jy)*dyout
        xl=(xl-xlon0)/dx
        yl=(yl-ylat0)/dy
        iix=max(min(nint(xl),nxmin1),0)
        jjy=max(min(nint(yl),nymin1),0)
        densityoutgrid(ix,jy,kz)=(rho(iix,jjy,kzz,2)*dz1+ &
             rho(iix,jjy,kzz-1,2)*dz2)/dz
  ! RLT
        densitydrygrid(ix,jy,kz)=(rho_dry(iix,jjy,kzz,2)*dz1+ &
             rho_dry(iix,jjy,kzz-1,2)*dz2)/dz
      end do
    end do
  end do

  ! conversion factor for output relative to dry air
  factor_drygrid=densityoutgrid/densitydrygrid

  ! Output is different for forward and backward simulations
  do kz=1,numzgrid
    do jy=0,numygrid-1
      do ix=0,numxgrid-1
        if (ldirect.eq.1) then
          factor3d(ix,jy,kz)=1.e12/volume(ix,jy,kz)/outnum
        else
          factor3d(ix,jy,kz)=real(abs(loutaver))/outnum
        endif
      end do
    end do
  end do

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  if (verbosity.eq.1) then
    print*,'concoutput_inversion 3 (sd)'
    CALL SYSTEM_CLOCK(count_clock)
    WRITE(*,*) 'SYSTEM_CLOCK',count_clock - count_clock0   
  endif
  gridtotal=0.
  gridsigmatotal=0.
  gridtotalunc=0.
  wetgridtotal=0.
  wetgridsigmatotal=0.
  wetgridtotalunc=0.
  drygridtotal=0.
  drygridsigmatotal=0.
  drygridtotalunc=0.

  do ks=1,nspec

    write(anspec,'(i3.3)') ks

    ! loop over releases
    do kp=1,maxpointspec_act

      print*, 'itime = ',itime
      print*, 'ireleasestart(kp) = ',ireleasestart(kp)
      print*, 'ireleaseend(kp) = ',ireleaseend(kp)

      ! check itime is within release and backward trajectory length
      if (nageclass.eq.1) then
        if ((itime.gt.ireleaseend(kp)).or.(itime.lt.(ireleasestart(kp)-lage(1)))) then
          go to 10
        endif
      endif

      ! calculate date of release for filename
      jul=bdate+real(ireleasestart(kp),kind=dp)/86400._dp    ! this is the current day
      call caldate(jul,jjjjmmdd,ihmmss)     
      write(areldate,'(i8.8)') jjjjmmdd
      write(areltime,'(i6.6)') ihmmss
      print*, 'areldate/areltime = ',areldate//areltime

      ! calculate date of field
      jul=bdate+real(itime,kind=dp)/86400._dp
      call caldate(jul,jjjjmmdd,ihmmss)
      write(adate,'(i8.8)') jjjjmmdd
      write(atime,'(i6.6)') ihmmss

      if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
        if (ldirect.eq.1) then
          ! concentrations
          inquire(file=path(2)(1:length(2))//'grid_conc_'//areldate// &
                  areltime//'_'//anspec,exist=lexist)
          if(lexist.and..not.lstartrel(kp)) then
            ! open and append to existing file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_conc_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='old',action='write',access='append')
          else
            ! open new file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_conc_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='replace',action='write')
          endif
        else
          ! residence times
          inquire(file=path(2)(1:length(2))//'grid_time_'//areldate// &
                  areltime//'_'//anspec,exist=lexist)
          if(lexist.and..not.lstartrel(kp)) then
            ! open and append to existing file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_time_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='old',action='write',access='append')
          else
            ! open new file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_time_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='replace',action='write')
            ! add part of the filename to a file (similar to dates) for easier post-processing
            open(unit=unitrelnames, file=path(2)(1:length(2))//'releases_out',form='formatted', &
                 & access='APPEND', iostat=ierr)
            write(unitrelnames,'(a)') areldate//areltime//'_'//anspec
            close(unitrelnames)
          endif
        endif
        write(unitoutgrid) jjjjmmdd
        write(unitoutgrid) ihmmss
      endif

      if ((iout.eq.2).or.(iout.eq.3)) then      
        ! mixing ratio
        inquire(file=path(2)(1:length(2))//'grid_pptv_'//areldate// &
                areltime//'_'//anspec,exist=lexist)
        if(lexist.and..not.lstartrel(kp)) then
          ! open and append to existing file
          open(unitoutgridppt,file=path(2)(1:length(2))//'grid_pptv_'//areldate// &
               areltime//'_'//anspec,form='unformatted',status='old',action='write',access='append')
        else
          ! open new file
          open(unitoutgridppt,file=path(2)(1:length(2))//'grid_pptv_'//areldate// &
               areltime//'_'//anspec,form='unformatted',status='replace',action='write')
        endif   
        write(unitoutgridppt) jjjjmmdd
        write(unitoutgridppt) ihmmss
      endif

      lstartrel(kp)=.false.

      do nage=1,nageclass

        do jy=0,numygrid-1
          do ix=0,numxgrid-1

  ! CONCENTRATION OR MIXING RATIO
            do kz=1,numzgrid
              do l=1,nclassunc
                auxgrid(l)=gridunc(ix,jy,kz,ks,kp,l,nage)
              end do
              call mean(auxgrid,grid(ix,jy,kz), &
                   gridsigma(ix,jy,kz),nclassunc)
  ! Multiply by number of classes to get total concentration
              grid(ix,jy,kz)= &
                   grid(ix,jy,kz)*nclassunc
              gridtotal=gridtotal+grid(ix,jy,kz)
  ! Calculate standard deviation of the mean
              gridsigma(ix,jy,kz)= &
                   gridsigma(ix,jy,kz)* &
                   sqrt(real(nclassunc))
              gridsigmatotal=gridsigmatotal+ &
                   gridsigma(ix,jy,kz)
            end do
          end do
        end do


  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

        if (verbosity.eq.1) then
          print*,'concoutput_inversion 4 (output)'
          CALL SYSTEM_CLOCK(count_clock)
          WRITE(*,*) 'SYSTEM_CLOCK',count_clock - count_clock0   
        endif

  ! Concentration output
  !*********************

        if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then

          if (verbosity.eq.1) then
            print*,'concoutput_inversion (Wet deposition)'
            CALL SYSTEM_CLOCK(count_clock)
            WRITE(*,*) 'SYSTEM_CLOCK',count_clock - count_clock0   
          endif

          if (verbosity.eq.1) then
            print*,'concoutput_inversion (Concentrations)'
            CALL SYSTEM_CLOCK(count_clock)
            WRITE(*,*) 'SYSTEM_CLOCK',count_clock - count_clock0   
          endif

  ! Concentrations

  ! sfc_only write only 1st layer 

          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          do kz=1,1
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgrid+kz*numxgrid*numygrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact* &
                       grid(ix,jy,kz)* &
                       factor3d(ix,jy,kz)/tot_mu(ks,kp)
                  sparse_dump_u(sp_count_r)= &
                       gridsigma(ix,jy,kz)* &
                       factor3d(ix,jy,kz)/tot_mu(ks,kp)

                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          end do
          write(unitoutgrid) sp_count_i
          write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgrid) sp_count_r
          write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)

        endif !  concentration output

  ! Mixing ratio output
  !********************

        if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio

  ! Mixing ratios

  ! sfc_only write only 1st layer 

          sp_count_i=0
          sp_count_r=0
          sp_fact=-1.
          sp_zer=.true.
          do kz=1,1
            do jy=0,numygrid-1
              do ix=0,numxgrid-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgrid+kz*numxgrid*numygrid
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                  endif
                  sp_count_r=sp_count_r+1
                  sparse_dump_r(sp_count_r)= &
                       sp_fact* &
                       1.e12*grid(ix,jy,kz) &
                       /volume(ix,jy,kz)/outnum* &
                       weightair/weightmolar(ks)/densityoutgrid(ix,jy,kz)
                  sparse_dump_u(sp_count_r)= &
                       1.e12*gridsigma(ix,jy,kz)/volume(ix,jy,kz)/ &
                       outnum*weightair/weightmolar(ks)/ &
                       densityoutgrid(ix,jy,kz)
                else ! concentration is zero
                  sp_zer=.true.
                endif
              end do
            end do
          end do
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

        endif ! output for ppt

      end do  ! nageclass

      close(unitoutgridppt)
      close(unitoutgrid)

      ! itime is outside range
10    continue

    end do  ! maxpointspec_act

  end do  ! nspec

  ! Write out conversion factor for dry air
  !*****************************************

  inquire(file=path(2)(1:length(2))//'factor_drygrid',exist=lexist)
  if (lexist.and..not.lstart) then
    ! open and append
    open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid',form='unformatted',&
            status='old',action='write',access='append')
  else
    ! create new
    open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid',form='unformatted',&
            status='replace',action='write')
  endif
  sp_count_i=0
  sp_count_r=0
  sp_fact=-1.
  sp_zer=.true.
  do kz=1,1
    do jy=0,numygrid-1
      do ix=0,numxgrid-1
        if (factor_drygrid(ix,jy,kz).gt.(1.+smallnum).or.factor_drygrid(ix,jy,kz).lt.(1.-smallnum)) then
          if (sp_zer.eqv..true.) then ! first value not equal to one
            sp_count_i=sp_count_i+1
            sparse_dump_i(sp_count_i)= &
                  ix+jy*numxgrid+kz*numxgrid*numygrid
            sp_zer=.false.
            sp_fact=sp_fact*(-1.)
          endif
          sp_count_r=sp_count_r+1
          sparse_dump_r(sp_count_r)= &
               sp_fact*factor_drygrid(ix,jy,kz)
        else ! factor is one
          sp_zer=.true.
        endif
      end do
    end do
  end do
  write(unitoutfactor) sp_count_i
  write(unitoutfactor) (sparse_dump_i(i),i=1,sp_count_i)
  write(unitoutfactor) sp_count_r
  write(unitoutfactor) (sparse_dump_r(i),i=1,sp_count_r)
  close(unitoutfactor)

  if (gridtotal.gt.0.) gridtotalunc=gridsigmatotal/gridtotal

  ! reset lstart
  if (lstart) then
    lstart=.false.
  endif
  print*, 'after writing output files: lstart = ',lstart

  ! Reinitialization of grid
  !*************************

  gridunc(:,:,:,:,:,:,:)=0.

end subroutine concoutput_inversion


subroutine concoutput_inversion_nest(itime,outnum)
  !                        i     i
  !*****************************************************************************
  !                                                                            *
  !     Output of the nested concentration grid formatted for inversions.      *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !     January 2017,  Separate files by release but include all timesteps     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! outnum          number of samples                                          *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  ! tot_mu          1 for forward, initial mass mixing ration for backw. runs  *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use mean_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,i,ix,jy,kz,ks,kp,l,iix,jjy,kzz,nage,jjjjmmdd,ihmmss
  integer :: sp_count_i,sp_count_r
  real :: sp_fact
  real :: outnum,xl,yl

  real(dep_prec) :: auxgrid(nclassunc)
  real :: halfheight,dz,dz1,dz2,tot_mu(maxspec,maxpointspec_act)
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  real,parameter :: weightair=28.97
  logical :: sp_zer
  logical,save :: lnstart=.true.
  logical,save,allocatable,dimension(:) :: lnstartrel
  character :: adate*8,atime*6
  character(len=3) :: anspec
  logical :: lexist
  character :: areldate*8,areltime*6

  if(lnstart) then
    allocate(lnstartrel(maxpointspec_act))
    lnstartrel(:)=.true.
  endif
  print*, 'lnstartrel = ',lnstartrel

  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss

  print*, 'outnum:',outnum
  print*, 'datetime:',adate//atime

  ! For forward simulations, output fields have dimension MAXSPEC,
  ! for backward simulations, output fields have dimension MAXPOINT.
  ! Thus, make loops either about nspec, or about numpoint
  !*****************************************************************


    if (ldirect.eq.1) then
       do ks=1,nspec
         do kp=1,maxpointspec_act
           tot_mu(ks,kp)=1
         end do
       end do
   else
      do ks=1,nspec
             do kp=1,maxpointspec_act
               tot_mu(ks,kp)=xmass(kp,ks)
             end do
      end do
    endif


  !*******************************************************************
  ! Compute air density: sufficiently accurate to take it
  ! from coarse grid at some time
  ! Determine center altitude of output layer, and interpolate density
  ! data to that altitude
  !*******************************************************************

  do kz=1,numzgrid
    if (kz.eq.1) then
      halfheight=outheight(1)*0.5
    else
      halfheight=(outheight(kz)+outheight(kz-1))*0.5
    endif
    do kzz=2,nz
      if ((height(kzz-1).lt.halfheight).and. &
           (height(kzz).gt.halfheight)) goto 46
    end do
46   kzz=max(min(kzz,nz),2)
    dz1=halfheight-height(kzz-1)
    dz2=height(kzz)-halfheight
    dz=dz1+dz2
    do jy=0,numygridn-1
      do ix=0,numxgridn-1
        xl=outlon0n+real(ix)*dxoutn
        yl=outlat0n+real(jy)*dyoutn
        xl=(xl-xlon0)/dx
        yl=(yl-ylat0)/dy
        iix=max(min(nint(xl),nxmin1),0)
        jjy=max(min(nint(yl),nymin1),0)
        densityoutgrid(ix,jy,kz)=(rho(iix,jjy,kzz,2)*dz1+ &
             rho(iix,jjy,kzz-1,2)*dz2)/dz
        densitydrygrid(ix,jy,kz)=(rho_dry(iix,jjy,kzz,2)*dz1+ &
             rho_dry(iix,jjy,kzz-1,2)*dz2)/dz
      end do
    end do
  end do

  ! conversion factor for output relative to dry air
  factor_drygrid=densityoutgrid/densitydrygrid

  ! Output is different for forward and backward simulations
  if (ldirect.eq.1) then
    factor3d(:,:,:)=1.e12/volumen(:,:,:)/outnum
  else
    factor3d(:,:,:)=real(abs(loutaver))/outnum
  endif

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  do ks=1,nspec

  write(anspec,'(i3.3)') ks

    do kp=1,maxpointspec_act

      print*, 'itime = ',itime
      print*, 'lage(1) = ',lage(1)
      print*, 'ireleasestart(kp) = ',ireleasestart(kp)
      print*, 'ireleaseend(kp) = ',ireleaseend(kp)

      ! check itime is within release and backward trajectory length
      if (nageclass.eq.1) then
        if ((itime.gt.ireleaseend(kp)).or.(itime.lt.(ireleasestart(kp)-lage(1)))) then
          go to 10
        endif
      endif

      ! calculate date of release
      jul=bdate+real(ireleasestart(kp),kind=dp)/86400._dp    ! this is the current day
      call caldate(jul,jjjjmmdd,ihmmss)
      write(areldate,'(i8.8)') jjjjmmdd
      write(areltime,'(i6.6)') ihmmss
      print*, areldate//areltime

      ! calculate date of field
      jul=bdate+real(itime,kind=dp)/86400._dp
      call caldate(jul,jjjjmmdd,ihmmss)
      write(adate,'(i8.8)') jjjjmmdd
      write(atime,'(i6.6)') ihmmss
      print*, adate//atime

      if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
        if (ldirect.eq.1) then
          ! concentrations
          inquire(file=path(2)(1:length(2))//'grid_conc_nest_'//areldate// &
                  areltime//'_'//anspec,exist=lexist)
          if(lexist.and..not.lnstartrel(kp)) then
            ! open and append to existing file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_conc_nest_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='old',action='write',access='append')
          else
            ! open new file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_conc_nest_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='replace',action='write')
          endif
        else
          ! residence times
          inquire(file=path(2)(1:length(2))//'grid_time_nest_'//areldate// &
                  areltime//'_'//anspec,exist=lexist)
          if(lexist.and..not.lnstartrel(kp)) then
            ! open and append to existing file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_time_nest_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='old',action='write',access='append')
          else
            ! open new file
            open(unitoutgrid,file=path(2)(1:length(2))//'grid_time_nest_'//areldate// &
                 areltime//'_'//anspec,form='unformatted',status='replace',action='write')
          endif
        endif
        write(unitoutgrid) jjjjmmdd
        write(unitoutgrid) ihmmss
      endif

      if ((iout.eq.2).or.(iout.eq.3)) then
        ! mixing ratio
        inquire(file=path(2)(1:length(2))//'grid_pptv_nest_'//areldate// &
                areltime//'_'//anspec,exist=lexist)
        if(lexist.and..not.lnstartrel(kp)) then
          ! open and append to existing file
          open(unitoutgridppt,file=path(2)(1:length(2))//'grid_pptv_nest_'//areldate// &
               areltime//'_'//anspec,form='unformatted',status='old',action='write',access='append')
        else
          ! open new file
          open(unitoutgridppt,file=path(2)(1:length(2))//'grid_pptv_nest_'//areldate// &
               areltime//'_'//anspec,form='unformatted',status='replace',action='write')
        endif
        write(unitoutgridppt) jjjjmmdd
        write(unitoutgridppt) ihmmss
      endif

      lnstartrel(kp)=.false.

      do nage=1,nageclass

        do jy=0,numygridn-1
          do ix=0,numxgridn-1

  ! CONCENTRATION OR MIXING RATIO
            do kz=1,numzgrid
              do l=1,nclassunc
                auxgrid(l)=griduncn(ix,jy,kz,ks,kp,l,nage)
              end do
              call mean(auxgrid,grid(ix,jy,kz), &
                     gridsigma(ix,jy,kz),nclassunc)
  ! Multiply by number of classes to get total concentration
              grid(ix,jy,kz)= &
                   grid(ix,jy,kz)*nclassunc
  ! Calculate standard deviation of the mean
              gridsigma(ix,jy,kz)= &
                   gridsigma(ix,jy,kz)* &
                   sqrt(real(nclassunc))
            end do
          end do
        end do


  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

  ! Concentration output
  !*********************

        if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then

  ! Concentrations

  ! sfc_only write only 1st layer 

         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
          do kz=1,1
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn+kz*numxgridn*numygridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                   endif
                   sp_count_r=sp_count_r+1
                   sparse_dump_r(sp_count_r)= &
                        sp_fact* &
                        grid(ix,jy,kz)* &
                        factor3d(ix,jy,kz)/tot_mu(ks,kp)
  !                 if ((factor(ix,jy,kz)/tot_mu(ks,kp)).eq.0)
  !    +              write (*,*) factor(ix,jy,kz),tot_mu(ks,kp),ks,kp
                   sparse_dump_u(sp_count_r)= &
                        gridsigma(ix,jy,kz)* &
                        factor3d(ix,jy,kz)/tot_mu(ks,kp)
              else ! concentration is zero
                  sp_zer=.true.
              endif
              end do
            end do
          end do
         write(unitoutgrid) sp_count_i
         write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
         write(unitoutgrid) sp_count_r
         write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)

      endif !  concentration output

  ! Mixing ratio output
  !********************

      if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio


  ! Mixing ratios

    ! sfc_only write only 1st layer 

         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
          do kz=1,1
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn+kz*numxgridn*numygridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*grid(ix,jy,kz) &
                      /volumen(ix,jy,kz)/outnum* &
                      weightair/weightmolar(ks)/densityoutgrid(ix,jy,kz)
                 sparse_dump_u(sp_count_r)= &
                      1.e12*gridsigma(ix,jy,kz)/volumen(ix,jy,kz)/ &
                      outnum*weightair/weightmolar(ks)/ &
                      densityoutgrid(ix,jy,kz)
              else ! concentration is zero
                  sp_zer=.true.
              endif
              end do
            end do
          end do
          write(unitoutgridppt) sp_count_i
          write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
          write(unitoutgridppt) sp_count_r
          write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)

        endif ! output for ppt
 
      end do ! nageclass

      close(unitoutgridppt)
      close(unitoutgrid)

      ! itime is outside range
10    continue

    end do ! maxpointspec_act

  end do ! nspec

  ! Write out conversion factor for dry air
  !*****************************************

  inquire(file=path(2)(1:length(2))//'factor_drygrid_nest',exist=lexist)
  if (lexist.and..not.lnstart) then
    ! open and append
    open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid_nest',form='unformatted',&
            status='old',action='write',access='append')
  else
    ! create new
    open(unitoutfactor,file=path(2)(1:length(2))//'factor_drygrid_nest',form='unformatted',&
            status='replace',action='write')
  endif
  sp_count_i=0
  sp_count_r=0
  sp_fact=-1.
  sp_zer=.true.
  do kz=1,1
    do jy=0,numygridn-1
      do ix=0,numxgridn-1
        if (factor_drygrid(ix,jy,kz).gt.(1.+smallnum).or.factor_drygrid(ix,jy,kz).lt.(1.-smallnum)) then
          if (sp_zer.eqv..true.) then ! first value not equal to one
            sp_count_i=sp_count_i+1
            sparse_dump_i(sp_count_i)= &
                  ix+jy*numxgridn+kz*numxgridn*numygridn
            sp_zer=.false.
            sp_fact=sp_fact*(-1.)
          endif
          sp_count_r=sp_count_r+1
          sparse_dump_r(sp_count_r)= &
               sp_fact*factor_drygrid(ix,jy,kz)
        else ! factor is one
          sp_zer=.true.
        endif
      end do
    end do
  end do
  write(unitoutfactor) sp_count_i
  write(unitoutfactor) (sparse_dump_i(i),i=1,sp_count_i)
  write(unitoutfactor) sp_count_r
  write(unitoutfactor) (sparse_dump_r(i),i=1,sp_count_r)
  close(unitoutfactor)

  ! reset lnstart
  if (lnstart) then
    lnstart=.false.
  endif

  ! Reinitialization of grid
  !*************************

  griduncn(:,:,:,:,:,:,:)=0.

end subroutine concoutput_inversion_nest


subroutine initcond_output(itime)
  !                                 i
  !*****************************************************************************
  !                                                                            *
  !     Output of the initial condition sensitivity field.                     *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  !                                                                            *
  !*****************************************************************************

  use unc_mod

  implicit none

  integer :: itime,i,ix,jy,kz,ks,kp,sp_count_i,sp_count_r
  real :: sp_fact,fact_recept
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  logical :: sp_zer
  character(len=3) :: anspec


  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  do ks=1,nspec

    write(anspec,'(i3.3)') ks
    open(97,file=path(2)(1:length(2))//'grid_initial'// &
         '_'//anspec,form='unformatted')
    write(97) itime

    do kp=1,maxpointspec_act

      if (ind_rel.eq.1) then
        fact_recept=rho_rel(kp)
      else
        fact_recept=1.
      endif

  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

  ! Write out dummy "wet and dry deposition" fields, to keep same format
  ! as for concentration output
      sp_count_i=0
      sp_count_r=0
      write(97) sp_count_i
      write(97) (sparse_dump_i(i),i=1,sp_count_i)
      write(97) sp_count_r
      write(97) (sparse_dump_r(i),i=1,sp_count_r)
      write(97) sp_count_i
      write(97) (sparse_dump_i(i),i=1,sp_count_i)
      write(97) sp_count_r
      write(97) (sparse_dump_r(i),i=1,sp_count_r)


  ! Write out sensitivity to initial conditions
      sp_count_i=0
      sp_count_r=0
      sp_fact=-1.
      sp_zer=.true.
      do kz=1,numzgrid
        do jy=0,numygrid-1
          do ix=0,numxgrid-1
            if (init_cond(ix,jy,kz,ks,kp).gt.smallnum) then
              if (sp_zer.eqv..true.) then ! first non zero value
                sp_count_i=sp_count_i+1
                sparse_dump_i(sp_count_i)= &
                     ix+jy*numxgrid+kz*numxgrid*numygrid
                sp_zer=.false.
                sp_fact=sp_fact*(-1.)
              endif
              sp_count_r=sp_count_r+1
              sparse_dump_r(sp_count_r)=sp_fact* &
                   init_cond(ix,jy,kz,ks,kp)/xmass(kp,ks)*fact_recept
            else ! concentration is zero
              sp_zer=.true.
            endif
          end do
        end do
      end do
      write(97) sp_count_i
      write(97) (sparse_dump_i(i),i=1,sp_count_i)
      write(97) sp_count_r
      write(97) (sparse_dump_r(i),i=1,sp_count_r)


    end do

    close(97)

  end do
end subroutine initcond_output

subroutine initcond_output_inv(itime)
  !                                 i
  !*****************************************************************************
  !                                                                            *
  !     Output of the initial condition sensitivity field.                     *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  !                                                                            *
  !*****************************************************************************

  use unc_mod

  implicit none

  integer :: itime,i,ix,jy,kz,ks,kp,sp_count_i,sp_count_r
  integer :: jjjjmmdd, ihmmss
  real(kind=dp) :: jul
  real :: sp_fact,fact_recept
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  logical :: sp_zer,lexist
  logical,save :: listart=.true.
  logical,save,allocatable,dimension(:) :: listartrel
  character :: adate*8,atime*6
  character :: areldate*8,areltime*6
  character(len=3) :: anspec

  if(listart) then
    allocate(listartrel(maxpointspec_act))
    listartrel(:)=.true.
  endif
  print*, 'listartrel = ',listartrel

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  do ks=1,nspec

    write(anspec,'(i3.3)') ks

    do kp=1,maxpointspec_act

      ! calculate date of release
      jul=bdate+real(ireleasestart(kp),kind=dp)/86400._dp    ! this is the current day
      call caldate(jul,jjjjmmdd,ihmmss)
      write(areldate,'(i8.8)') jjjjmmdd
      write(areltime,'(i6.6)') ihmmss
      print*, areldate//areltime

      ! calculate date of field
      jul=bdate+real(itime,kind=dp)/86400._dp
      call caldate(jul,jjjjmmdd,ihmmss)
      write(adate,'(i8.8)') jjjjmmdd
      write(atime,'(i6.6)') ihmmss
      print*, adate//atime

      inquire(file=path(2)(1:length(2))//'grid_initial_'//areldate// &
         areltime//'_'//anspec,exist=lexist)
      if(lexist.and..not.listartrel(kp)) then
        ! open and append to existing file
        open(97,file=path(2)(1:length(2))//'grid_initial_'//areldate// &
             areltime//'_'//anspec,form='unformatted',status='old',action='write',access='append') 
      else
        ! open new file
        open(97,file=path(2)(1:length(2))//'grid_initial_'//areldate// &
             areltime//'_'//anspec,form='unformatted',status='replace',action='write')
      endif
      write(97) jjjjmmdd
      write(97) ihmmss

      listartrel(kp)=.false.

      if (ind_rel.eq.1) then
        fact_recept=rho_rel(kp)
      else
        fact_recept=1.
      endif

  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

  ! Write out dummy "wet and dry deposition" fields, to keep same format
  ! as for concentration output

  ! Write out sensitivity to initial conditions
      sp_count_i=0
      sp_count_r=0
      sp_fact=-1.
      sp_zer=.true.
      do kz=1,numzgrid
        do jy=0,numygrid-1
          do ix=0,numxgrid-1
            if (init_cond(ix,jy,kz,ks,kp).gt.smallnum) then
              if (sp_zer.eqv..true.) then ! first non zero value
                sp_count_i=sp_count_i+1
                sparse_dump_i(sp_count_i)= &
                     ix+jy*numxgrid+kz*numxgrid*numygrid
                sp_zer=.false.
                sp_fact=sp_fact*(-1.)
              endif
              sp_count_r=sp_count_r+1
              sparse_dump_r(sp_count_r)=sp_fact* &
                   init_cond(ix,jy,kz,ks,kp)/xmass(kp,ks)*fact_recept
            else ! concentration is zero
              sp_zer=.true.
            endif
          end do
        end do
      end do
      write(97) sp_count_i
      write(97) (sparse_dump_i(i),i=1,sp_count_i)
      write(97) sp_count_r
      write(97) (sparse_dump_r(i),i=1,sp_count_r)

      close(97)

    end do

  end do

  ! reset listart
  if (listart) then
    listart=.false.
  endif

end subroutine initcond_output_inv

end module binary_output_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

real function scalev(ps,t,td,stress)

  !********************************************************************
  !                                                                   *
  !                       Author: G. WOTAWA                           *
  !                       Date:   1994-06-27                          *
  !                       Update: 1996-05-21 A. Stohl                 *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !     This Programm calculates scale velocity ustar from surface    *
  !     stress and air density.                                       *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !     INPUT:                                                        *
  !                                                                   *
  !     ps      surface pressure [Pa]                                 *
  !     t       surface temperature [K]                               *
  !     td      surface dew point [K]                                 *
  !     stress  surface stress [N/m2]                                 *
  !                                                                   *
  !********************************************************************
  
  use par_mod

  implicit none

  real :: ps,t,td,e,ew,tv,rhoa,stress

  e=ew(td)                       ! vapor pressure
  tv=t*(1.+0.378*e/ps)           ! virtual temperature
  rhoa=ps/(r_air*tv)              ! air density
  scalev=sqrt(abs(stress)/rhoa)

end function scalev

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine calcpar(n,uuh,vvh,pvh)
  !                   i  i   i   o
  !*****************************************************************************
  !                                                                            *
  !     Computation of several boundary layer parameters needed for the        *
  !     dispersion calculation and calculation of dry deposition velocities.   *
  !     All parameters are calculated over the entire grid.                    *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     21 May 1995                                                            *
  !                                                                            *
  ! ------------------------------------------------------------------         *
  !     Petra Seibert, Feb 2000:                                               *
  !     convection scheme:                                                     *
  !     new variables in call to richardson                                    *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:
  !   Variables tth and qvh (on eta coordinates) in common block
  !*****************************************************************************
  !                                                                            *
  !  CHANGE 17/11/2005 Caroline Forster NCEP GFS version                       *
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 3)       *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !                                                                            *
  ! Functions:                                                                 *
  ! scalev             computation of ustar                                    *
  ! obukhov            computatio of Obukhov length                            *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: n,ix,jy,i,kz,lz,kzmin,llev
  real :: ttlev(nuvzmax),qvlev(nuvzmax),obukhov,scalev,ol,hmixplus
  real :: ulev(nuvzmax),vlev(nuvzmax),ew,rh,vd(maxspec),subsceff,ylat
  real :: altmin,tvold,pold,zold,pint,tv,zlev(nuvzmax),hmixdummy
  real :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: pvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real,parameter :: const=r_air/ga


  ! Loop over entire grid
  !**********************

  do jy=0,nymin1

  ! Set minimum height for tropopause
  !**********************************

    ylat=ylat0+real(jy)*dy
    if ((ylat.ge.-20.).and.(ylat.le.20.)) then
      altmin = 5000.
    else
      if ((ylat.gt.20.).and.(ylat.lt.40.)) then
        altmin=2500.+(40.-ylat)*125.
      else if ((ylat.gt.-40.).and.(ylat.lt.-20.)) then
        altmin=2500.+(40.+ylat)*125.
      else
        altmin=2500.
      endif
    endif

    do ix=0,nxmin1

  ! 1) Calculation of friction velocity
  !************************************

      ustar(ix,jy,1,n)=scalev(ps(ix,jy,1,n),tt2(ix,jy,1,n), &
           td2(ix,jy,1,n),surfstr(ix,jy,1,n))
      if (ustar(ix,jy,1,n).le.1.e-8) ustar(ix,jy,1,n)=1.e-8

  ! 2) Calculation of inverse Obukhov length scale
  !***********************************************

  ! NCEP version: find first level above ground
      llev = 0
      do i=1,nuvz
       if (ps(ix,jy,1,n).lt.akz(i)) llev=i
      end do
       llev = llev+1
       if (llev.gt.nuvz) llev = nuvz-1
  ! NCEP version

  ! calculate inverse Obukhov length scale with tth(llev)
      ol=obukhov(ps(ix,jy,1,n),tt2(ix,jy,1,n),td2(ix,jy,1,n), &
           tth(ix,jy,llev,n),ustar(ix,jy,1,n),sshf(ix,jy,1,n),akz(llev))
      if (ol.ne.0.) then
        oli(ix,jy,1,n)=1./ol
      else
        oli(ix,jy,1,n)=99999.
      endif


  ! 3) Calculation of convective velocity scale and mixing height
  !**************************************************************

      do i=1,nuvz
        ulev(i)=uuh(ix,jy,i)
        vlev(i)=vvh(ix,jy,i)
        ttlev(i)=tth(ix,jy,i,n)
        qvlev(i)=qvh(ix,jy,i,n)
      end do

  ! NCEP version hmix has been read in in readwind.f, is therefore not calculated here
      call richardson(ps(ix,jy,1,n),ustar(ix,jy,1,n),ttlev,qvlev, &
           ulev,vlev,nuvz,akz,bkz,sshf(ix,jy,1,n),tt2(ix,jy,1,n), &
           td2(ix,jy,1,n),hmixdummy,wstar(ix,jy,1,n),hmixplus)

      if(lsubgrid.eq.1) then
        subsceff=min(excessoro(ix,jy),hmixplus)
      else
        subsceff=0
      endif
  !
  ! CALCULATE HMIX EXCESS ACCORDING TO SUBGRIDSCALE VARIABILITY AND STABILITY
  !
      hmix(ix,jy,1,n)=hmix(ix,jy,1,n)+subsceff
      hmix(ix,jy,1,n)=max(hmixmin,hmix(ix,jy,1,n)) ! set minimum PBL height
      hmix(ix,jy,1,n)=min(hmixmax,hmix(ix,jy,1,n)) ! set maximum PBL height

  ! 4) Calculation of dry deposition velocities
  !********************************************

      if (DRYDEP) then
  ! Sabine Eckhardt, Dec 06: use new index for z0 for water depending on
  ! windspeed
        z0(7)=0.016*ustar(ix,jy,1,n)*ustar(ix,jy,1,n)/ga

  ! Calculate relative humidity at surface
  !***************************************
        rh=ew(td2(ix,jy,1,n))/ew(tt2(ix,jy,1,n))

        call getvdep(n,ix,jy,ustar(ix,jy,1,n), &
             tt2(ix,jy,1,n),ps(ix,jy,1,n),1./oli(ix,jy,1,n), &
             ssr(ix,jy,1,n),rh,lsprec(ix,jy,1,n)+convprec(ix,jy,1,n), &
             sd(ix,jy,1,n),vd)

        do i=1,nspec
          vdep(ix,jy,i,n)=vd(i)
        end do

      endif

  !******************************************************
  ! Calculate height of thermal tropopause (Hoinka, 1997)
  !******************************************************

  ! 1) Calculate altitudes of NCEP model levels
  !*********************************************

      tvold=tt2(ix,jy,1,n)*(1.+0.378*ew(td2(ix,jy,1,n))/ &
           ps(ix,jy,1,n))
      pold=ps(ix,jy,1,n)
      zold=0.
      do kz=llev,nuvz
        pint=akz(kz)+bkz(kz)*ps(ix,jy,1,n)  ! pressure on model layers
        tv=tth(ix,jy,kz,n)*(1.+0.608*qvh(ix,jy,kz,n))

        if (abs(tv-tvold).gt.0.2) then
         zlev(kz)=zold+const*log(pold/pint)*(tv-tvold)/log(tv/tvold)
        else
          zlev(kz)=zold+const*log(pold/pint)*tv
        endif
        tvold=tv
        pold=pint
        zold=zlev(kz)
      end do

  ! 2) Define a minimum level kzmin, from which upward the tropopause is
  !    searched for. This is to avoid inversions in the lower troposphere
  !    to be identified as the tropopause
  !************************************************************************

      do kz=llev,nuvz
        if (zlev(kz).ge.altmin) then
          kzmin=kz
          goto 45
        endif
      end do
45    continue

  ! 3) Search for first stable layer above minimum height that fulfills the
  !    thermal tropopause criterion
  !************************************************************************

      do kz=kzmin,nuvz
        do lz=kz+1,nuvz
          if ((zlev(lz)-zlev(kz)).gt.2000.) then
            if (((tth(ix,jy,kz,n)-tth(ix,jy,lz,n))/ &
                 (zlev(lz)-zlev(kz))).lt.0.002) then
              tropopause(ix,jy,1,n)=zlev(kz)
              goto 51
            endif
            goto 50
          endif
        end do
50      continue
      end do
51    continue


    end do
  end do


  ! Calculation of potential vorticity on 3-d grid
  !***********************************************

  call calcpv(n,uuh,vvh,pvh)


end subroutine calcpar

MODULE class_gribfile_mod

    !*****************************************************************
    !                                                                *
    !  This is a class-like structure for providing access to the    *
    !  metadata and data within a GRIB met file                      *
    !                                                                *
    !                                                                *
    !*****************************************************************

    IMPLICIT NONE
    PRIVATE   ! The default is that everything is private, unless
              ! specified otherwise

    ! Note that all public interfaces and variables should have a
    ! GRIBFILE_ prefix

    PUBLIC :: gribfile_object,                &
              gribfile_object_create,         &
              gribfile_printobj,              &
              gribfile_centre,                &
              gribfile_num_xlon,              &
              gribfile_num_ylat,              &
              gribfile_num_zlevel


    PUBLIC :: GRIBFILE_TYPE_ECMWF_GRIB1,      &
              GRIBFILE_TYPE_ECMWF_GRIB2,      &
              GRIBFILE_TYPE_ECMWF_GRIB1_2,    &
              GRIBFILE_TYPE_NCEP_GRIB1,       &
              GRIBFILE_TYPE_NCEP_GRIB2,       &
              GRIBFILE_TYPE_UNKNOWN,          &
              GRIBFILE_CENTRE_NCEP,           &
              GRIBFILE_CENTRE_ECMWF,          &
              GRIBFILE_CENTRE_UNKNOWN

    ! These are codes for designating the type of GRIB file  
    ! being looked at
    INTEGER, PARAMETER :: GRIBFILE_TYPE_ECMWF_GRIB1 = 1,     &
                          GRIBFILE_TYPE_ECMWF_GRIB2 = 2,     &
                          GRIBFILE_TYPE_ECMWF_GRIB1_2 = 3,   &
                          GRIBFILE_TYPE_NCEP_GRIB1 = 4,      &
                          GRIBFILE_TYPE_NCEP_GRIB2 = 5,      &
                          GRIBFILE_TYPE_UNKNOWN = -9999,     &
                          GRIBFILE_CENTRE_NCEP = 1,          &
                          GRIBFILE_CENTRE_ECMWF = 2,         &
                          GRIBFILE_CENTRE_UNKNOWN = -9999

    ! These are the official centre codes for NCEP and ECMWF in grib files.
    INTEGER, PARAMETER :: CENTRE_NCEP = 7, CENTRE_ECMWF = 98

    TYPE gribfile_object
        PRIVATE    ! Make everything in here private so it's not directly manipulated outside
        LOGICAL :: is_instantiated = .FALSE.
        CHARACTER(LEN=256) :: file_path = ''
        INTEGER :: grib_edition = 0  ! Not sure we want this, since it can vary on hybrid files
        INTEGER :: grib_centre = GRIBFILE_CENTRE_UNKNOWN
        INTEGER :: gribfile_type = GRIBFILE_TYPE_UNKNOWN
        INTEGER :: num_xlon = -9999
        INTEGER :: num_ylat = -9999
        INTEGER :: num_zlevel = -9999
    END TYPE gribfile_object



CONTAINS


    TYPE(gribfile_object) FUNCTION gribfile_object_create(filepath)

        ! This is the "constructor" for the pseudo gribfile object.  Given the path to a gribfile,
        ! fills in attributes that can be accessed through methods in this
        ! module

        USE grib_api

        IMPLICIT NONE

        CHARACTER(LEN=*), INTENT(IN) :: filepath  ! full path to GRIB file

        TYPE(gribfile_object) :: returned_object

        INTEGER :: grib_centre, gribfile_type
        INTEGER :: xlon, ylat, zlev


        CALL get_centre_and_type(filepath, grib_centre, gribfile_type)
        returned_object%grib_centre = grib_centre
        returned_object%gribfile_type = gribfile_type

        ! Get dimensions of 3d u field
        CALL get_3d_u_dims(filepath, gribfile_type, xlon, ylat, zlev)
        returned_object%num_xlon = xlon
        returned_object%num_ylat = ylat
        returned_object%num_zlevel = zlev


        returned_object%is_instantiated = .TRUE.
        returned_object%file_path = TRIM(filepath)

        gribfile_object_create = returned_object

    END FUNCTION gribfile_object_create


    SUBROUTINE gribfile_printobj(gribfile_obj)

        ! Pretty prints the attributes of the gribfile pseudo-object
        TYPE(gribfile_object), INTENT(IN) :: gribfile_obj

        PRINT *, 'is_instantiated: ', gribfile_obj%is_instantiated
        PRINT *, 'filepath: ', TRIM(gribfile_obj%file_path)
        PRINT *, 'grib_centre: ', gribfile_obj%grib_centre
        PRINT *, 'gribfile_type: ', gribfile_obj%gribfile_type
        PRINT *, 'num_xlon: ', gribfile_obj%num_xlon
        PRINT *, 'num_ylat: ', gribfile_obj%num_ylat
        PRINT *, 'num_zlevel: ', gribfile_obj%num_zlevel

    END SUBROUTINE gribfile_printobj

    INTEGER FUNCTION gribfile_centre(filepath)

        ! Returns an integer constant denoting the grib centre (currently either ECMWF, NCEP or UNKNOWN)
        ! for the specified filepath.  Returns one of the GRIBFILE_CENTRE_ constants defined at top of this
        ! module.


        USE grib_api

        IMPLICIT NONE

        CHARACTER(LEN=*), INTENT(IN) :: filepath ! full path to GRIB file



        INTEGER :: ifile, iret, igrib, grib_centre

        CALL grib_open_file(ifile, filepath, 'r', iret)
        IF (iret == 0) THEN
            ! Use first record to detect centre, which is assumed constant
            ! amongst all messages
            CALL grib_new_from_file(ifile, igrib, iret)
            CALL grib_get(igrib, 'centre', grib_centre)
            CALL grib_close_file(ifile)
        ELSE
            PRINT *, "WARNING: problem opening GRIB file: ", filepath
            grib_centre = -999
        END IF





        IF (grib_centre == CENTRE_NCEP) THEN
            gribfile_centre = GRIBFILE_CENTRE_NCEP
        ELSE IF (grib_centre == CENTRE_ECMWF) THEN
            gribfile_centre = GRIBFILE_CENTRE_ECMWF
        ELSE
            gribfile_centre = GRIBFILE_CENTRE_UNKNOWN
        END IF

    END FUNCTION gribfile_centre


    ! This is currently a PRIVATE subroutine
    SUBROUTINE get_centre_and_type(filepath, grib_centre, gribfile_type)
        ! Given specified grib file, passes back centre and gribfile
        ! type to the calling program.  Numeric codes are defined as integer parameters
        ! in this module

        ! To get this information, we have to iterate through the entire file in order to
        ! determine if it is hybrid or not
        !

        USE grib_api
        IMPLICIT NONE
        CHARACTER(LEN=*), INTENT(IN) :: filepath  ! full path to GRIB file
        INTEGER, INTENT(OUT) :: grib_centre, gribfile_type

        INTEGER :: fileptr, iret, igrib, grib_edition
        LOGICAL :: end_of_file
        LOGICAL :: grib1_detected, grib2_detected


        grib1_detected = .FALSE.
        grib2_detected = .FALSE.

        CALL grib_open_file(fileptr, filepath, 'r', iret)
        IF (iret /= 0) THEN
            PRINT *, 'class_gributils:get_centre_and_type()...'
            PRINT *, '     unable to open filepath: ', filepath
            STOP
        END IF


        ! Use first record to detect centre and and grib version of first messages.  We will
        ! then assume that all following messages have same centre, but not necessarily same
        ! GRIB version
        CALL grib_new_from_file(fileptr, igrib, iret)
        CALL grib_get(igrib, 'centre', grib_centre)
        CALL grib_get(igrib, 'edition', grib_edition)

        IF (grib_edition == 1) grib1_detected = .TRUE.
        IF (grib_edition == 2) grib2_detected = .TRUE.

        ! Now, iterate through the rest of records to determine if this is a mixed edition file
        end_of_file = .FALSE.
        DO WHILE (.NOT. end_of_file)
            CALL grib_new_from_file(fileptr, igrib, iret)
            IF (iret .eq. GRIB_END_OF_FILE) THEN
                end_of_file = .TRUE.
            ELSE

                ! Get edition from file
                CALL grib_get(igrib, 'edition', grib_edition)
                IF (grib_edition .eq. 1) grib1_detected = .TRUE.
                IF (grib_edition .eq. 2) grib2_detected = .TRUE.
            END IF
        END DO

    CALL grib_close_file(fileptr)

    ! Determine the gribfile type depending on centre and edition(s)
    IF (grib_centre == CENTRE_ECMWF) THEN
        IF (grib1_detected .AND. grib2_detected) THEN
            gribfile_type = GRIBFILE_TYPE_ECMWF_GRIB1_2
        ELSE IF (grib1_detected .AND. .NOT. grib2_detected) THEN
            gribfile_type = GRIBFILE_TYPE_ECMWF_GRIB1
        ELSE IF (.NOT. grib1_detected .AND. grib2_detected) THEN
            gribfile_type = GRIBFILE_TYPE_ECMWF_GRIB2
        ELSE
            gribfile_type = GRIBFILE_TYPE_UNKNOWN
        ENDIF
    ELSE IF (grib_centre == CENTRE_NCEP) THEN
        IF (grib1_detected .AND. .NOT. grib2_detected) THEN
             gribfile_type = GRIBFILE_TYPE_NCEP_GRIB1
        ELSE IF (.NOT. grib1_detected .AND. grib2_detected) THEN
            gribfile_type = GRIBFILE_TYPE_NCEP_GRIB2
        ELSE
            gribfile_type = GRIBFILE_TYPE_UNKNOWN
        ENDIF
    ELSE
        gribfile_type = GRIBFILE_TYPE_UNKNOWN
    ENDIF

    END SUBROUTINE get_centre_and_type


    SUBROUTINE get_3d_u_dims(filepath, gribfile_type, xlon, ylat, zlev)

        ! Looks at the 3d u fields in the GRIBFILE to get x and y dims, as well as number of levels
        USE grib_api

        IMPLICIT NONE

        CHARACTER(LEN=*), INTENT(IN) :: filepath  ! full path to GRIB file
        INTEGER, INTENT(IN) :: gribfile_type
        INTEGER, INTENT(OUT) :: xlon, ylat, zlev

        INTEGER :: ifile, iret, igrib
        LOGICAL :: end_of_file

        ! These will be assigned according to type of grib file, then used to filter
        ! for the 3d messages
        ! Name of the key being sought
        CHARACTER(LEN=64) :: keyname_leveltype, keyname_shortname, keyname_level, &
                             keyname_xlon, keyname_ylat

        ! The key value being filtered for
        CHARACTER(LEN=64) :: keyvalue_leveltype, keyvalue_shortname

        ! Actual values read in from the grib file
        CHARACTER(LEN=64) :: value_leveltype, value_shortname
        INTEGER :: value_level

        INTEGER :: num_levels

        ! Get the field names to read, based on the type of grib file

        !!! Note that ALL of these have the same key names, except that
        !!! leveltype is 'hybrid' in ECMWF and 'isobaricInhPa' in NCEP.
        !!! This could probably be consolidated, but because these are
        !!! files that go through some preprocessing, and aren't 
        !!! necessarily standard (at least for ECMWF), I'm going to be
        !!! safe and leave it as is for now, so it would be easier to
        !!! modify for one type, if necessary.
        IF (gribfile_type == GRIBFILE_TYPE_ECMWF_GRIB1) THEN
            keyname_leveltype = 'typeOfLevel'
            keyname_shortname = 'shortName'
            keyname_level = 'level'
            keyvalue_leveltype = 'hybrid'
            keyvalue_shortname = 'u'
            keyname_xlon = 'Ni'
            keyname_ylat = 'Nj'
        ELSE IF (gribfile_type == GRIBFILE_TYPE_ECMWF_GRIB1_2) THEN
            keyname_leveltype = 'typeOfLevel'
            keyname_shortname = 'shortName'
            keyname_level = 'level'
            keyvalue_leveltype = 'hybrid'
            keyvalue_shortname = 'u'
            keyname_xlon = 'Ni'
            keyname_ylat = 'Nj'
        ELSE IF (gribfile_type == GRIBFILE_TYPE_ECMWF_GRIB2) THEN
            keyname_leveltype = 'typeOfLevel'
            keyname_shortname = 'shortName'
            keyname_level = 'level'
            keyvalue_leveltype = 'hybrid'
            keyvalue_shortname = 'u'
            keyname_xlon = 'Ni'
            keyname_ylat = 'Nj'
        ELSE IF (gribfile_type == GRIBFILE_TYPE_NCEP_GRIB1) THEN
            keyname_leveltype = 'typeOfLevel'
            keyname_shortname = 'shortName'
            keyname_level = 'level'
            keyvalue_leveltype = 'isobaricInhPa'
            keyvalue_shortname = 'u'
            keyname_xlon = 'Ni'
            keyname_ylat = 'Nj'
        ELSE IF (gribfile_type == GRIBFILE_TYPE_NCEP_GRIB2) THEN
            keyname_leveltype = 'typeOfLevel'
            keyname_shortname = 'shortName'
            keyname_level = 'level'
            keyvalue_leveltype = 'isobaricInhPa'
            keyvalue_shortname = 'u'
            keyname_xlon = 'Ni'
            keyname_ylat = 'Nj'
        ELSE
            PRINT *, 'class_gribfile:get_3d_u_dims(): Unsupported gribfile type: ', gribfile_type
            STOP
        ENDIF

        CALL grib_open_file(ifile, filepath, 'r', iret)
        IF (iret == 0) THEN

            ! Iterate through all messages to count 3d u messages (levels) and get x,y dimensions
            end_of_file = .FALSE.
            num_levels = 0
            DO WHILE (.NOT. end_of_file)
                CALL grib_new_from_file(ifile, igrib, iret)
                IF (iret .eq. GRIB_END_OF_FILE) THEN
                    end_of_file = .TRUE.
                ELSE

                    ! Get relevant keys and filter for the 3d U wind
                    CALL grib_get(igrib, keyname_shortname, value_shortname)
                    CALL grib_get(igrib, keyname_leveltype, value_leveltype)
                    CALL grib_get(igrib, keyname_level, value_level)
                    IF ( TRIM(value_leveltype) == TRIM(keyvalue_leveltype) .AND. &
                         TRIM(value_shortname) == TRIM(keyvalue_shortname) ) THEN

                        ! If this is first 3d U wind message, get dimensions
                        IF (num_levels == 0) THEN
                            CONTINUE
                            CALL grib_get(igrib, keyname_xlon, xlon)
                            CALL grib_get(igrib, keyname_ylat, ylat)
                        ENDIF
                        !PRINT *, TRIM(value_shortname), '  ', TRIM(value_leveltype), '  ', value_level
                        num_levels = num_levels + 1
                    END IF
                END IF
            END DO


        ELSE
            PRINT *, "ERROR: class_gribfile::get_3d_u_dims(): problem opening GRIB file: ", filepath
            STOP
        END IF

        CALL grib_close_file(ifile)

        zlev = num_levels

    END SUBROUTINE get_3d_u_dims



    !!! Getter methods
    INTEGER FUNCTION gribfile_num_xlon(gribfile_obj)

        ! Returns x (lon) dimension of met data
        TYPE(gribfile_object), INTENT(IN) :: gribfile_obj

        IF (.NOT. gribfile_obj%is_instantiated) THEN
            PRINT *, 'ERROR: class_gribfile: gribfile_obj not instantiated'
        ENDIF
        gribfile_num_xlon = gribfile_obj%num_xlon

    END FUNCTION gribfile_num_xlon

    INTEGER FUNCTION gribfile_num_ylat(gribfile_obj)

        ! Returns y (lat) dimension of met data
        TYPE(gribfile_object), INTENT(IN) :: gribfile_obj

        IF (.NOT. gribfile_obj%is_instantiated) THEN
            PRINT *, 'ERROR: class_gribfile: gribfile_obj not instantiated'
        ENDIF
        gribfile_num_ylat = gribfile_obj%num_ylat

    END FUNCTION gribfile_num_ylat

    INTEGER FUNCTION gribfile_num_zlevel(gribfile_obj)

        ! Returns z (level) dimension of met data
        TYPE(gribfile_object), INTENT(IN) :: gribfile_obj

        IF (.NOT. gribfile_obj%is_instantiated) THEN
            PRINT *, 'ERROR: class_gribfile: gribfile_obj not instantiated'
        ENDIF
        gribfile_num_zlevel = gribfile_obj%num_zlevel

    END FUNCTION gribfile_num_zlevel

END MODULE class_gribfile_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine getvdep_nests(n,ix,jy,ust,temp,pa, &
       L,gr,rh,rr,snow,vdepo,lnest)
  !                   i i  i   i   i   i  i i  i  i    i o i
  !*****************************************************************************
  !                                                                            *
  !  This routine calculates the dry deposition velocities.                    *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     20 December 1996                                                       *
  !     Sabine Eckhardt, Jan 07                                                *
  !     if the latitude is negative: add half a year to the julian day         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! gr [W/m2]         global radiation                                         *
  ! L [m]             Obukhov length                                           *
  ! nyl               kinematic viscosity                                      *
  ! pa [Pa]           surface air pressure                                     *
  ! ra [s/m]          aerodynamic resistance                                   *
  ! raquer [s/m]      average aerodynamic resistance                           *
  ! rh [0-1]          relative humidity                                        *
  ! rhoa              density of the air                                       *
  ! rr [mm/h]         precipitation rate                                       *
  ! temp [K]          2m temperature                                           *
  ! tc [C]            2m temperature                                           *
  ! ust [m/s]         friction velocity                                        *
  ! snow [m of water equivalent] snow depth                                    *
  ! xlanduse          fractions of numclasS landuses for each model grid point *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: yyyymmdd,hhmmss,yyyy,mmdd,n,lseason,i,j,ix,jy,lnest
  real :: vdepo(maxspec),vd,rb(maxspec),rc(maxspec),raquer,ylat
  real :: raerod,ra,ust,temp,tc,pa,L,gr,rh,rr,myl,nyl,rhoa,diffh2o,snow
  real :: slanduse(numclass)
  real,parameter :: eps=1.e-5
  real(kind=dp) :: jul

  ! Calculate month and determine the seasonal category
  !****************************************************

  jul=bdate+real(wftime(n),kind=dp)/86400._dp

  ylat=jy*dy+ylat0
  if (ylat.lt.0) then
      jul=jul+365/2
  endif


  call caldate(jul,yyyymmdd,hhmmss)
  yyyy=yyyymmdd/10000
  mmdd=yyyymmdd-10000*yyyy

  if ((ylat.gt.-20).and.(ylat.lt.20)) then
     mmdd=600 ! summer
  endif

  if ((mmdd.ge.1201).or.(mmdd.le.301)) then
    lseason=4
  else if ((mmdd.ge.1101).or.(mmdd.le.331)) then
    lseason=3
  else if ((mmdd.ge.401).and.(mmdd.le.515)) then
    lseason=5
  else if ((mmdd.ge.516).and.(mmdd.le.915)) then
    lseason=1
  else
    lseason=2
  endif

  ! Calculate diffusivity of water vapor
  !************************************
  diffh2o=2.11e-5*(temp/273.15)**1.94*(101325/pa)

  ! Conversion of temperature from K to C
  !**************************************

  tc=temp-273.15

  ! Calculate dynamic viscosity
  !****************************

  if (tc.lt.0) then
    myl=(1.718+0.0049*tc-1.2e-05*tc**2)*1.e-05
  else
    myl=(1.718+0.0049*tc)*1.e-05
  endif

  ! Calculate kinematic viscosity
  !******************************

  rhoa=pa/(287.*temp)
  nyl=myl/rhoa


  ! 0. Set all deposition velocities zero
  !**************************************

  do i=1,nspec
    vdepo(i)=0.
  end do


  ! 1. Compute surface layer resistances rb
  !****************************************

  call getrb(nspec,ust,nyl,diffh2o,reldiff,rb)

  ! change for snow
  do j=1,numclass
    if (snow.gt.0.001) then ! 10 mm
       if (j.eq.12) then
         slanduse(j)=1.
       else
         slanduse(j)=0.
       endif
    else
       slanduse(j)=xlandusen(ix,jy,j,lnest)
    endif
  end do

  raquer=0.
  do j=1,numclass            ! loop over all landuse classes

    if (slanduse(j).gt.eps)  then

  ! 2. Calculate aerodynamic resistance ra
  !***************************************

      ra=raerod(L,ust,z0(j))
      raquer=raquer+ra*slanduse(j)

  ! 3. Calculate surface resistance for gases
  !******************************************

      call getrc(nspec,lseason,j,tc,gr,rh,rr,rc)

  ! 4. Calculate deposition velocities for gases and ...
  ! 5. ... sum deposition velocities for all landuse classes
  !*********************************************************

      do i=1,nspec
        if (reldiff(i).gt.0.) then
          if ((ra+rb(i)+rc(i)).gt.0.) then
            vd=1./(ra+rb(i)+rc(i))
  ! XXXXXXXXXXXXXXXXXXXXXXXXXX TEST
  !         vd=1./rc(i)
  ! XXXXXXXXXXXXXXXXXXXXXXXXXX TEST
          else
            vd=9.999
          endif
          vdepo(i)=vdepo(i)+vd*slanduse(j)
        endif
      end do
    endif
  end do


  ! 6. Calculate deposition velocities for particles
  !*************************************************

  call partdep(nspec,density,fract,schmi,vset,raquer,ust,nyl,vdepo)


  ! 7. If no detailed parameterization available, take constant deposition
  !    velocity if that is available
  !***********************************************************************

  do i=1,nspec
    if ((reldiff(i).lt.0.).and.(density(i).lt.0.).and. &
         (dryvel(i).gt.0.)) then
      vdepo(i)=dryvel(i)
    endif
  end do


end subroutine getvdep_nests

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine calcpv(n,uuh,vvh,pvh)
  !                  i  i   i   o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of potential vorticity on 3-d grid.                           *
  !                                                                            *
  !     Author: P. James                                                       *
  !     3 February 2000                                                        *
  !                                                                            *
  !     Adaptation to FLEXPART, A. Stohl, 1 May 2000                           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 2)       *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: n,ix,jy,i,j,k,kl,ii,jj,klvrp,klvrm,klpt,kup,kdn,kch
  integer :: jyvp,jyvm,ixvp,ixvm,jumpx,jumpy,jux,juy,ivrm,ivrp,ivr
  integer :: nlck
  real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt,ppmk
  real :: pvavr,ppml(nuvzmax)
  real :: thup,thdn
  real,parameter :: eps=1.e-5, p0=101325
  real :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: pvh(0:nxmax-1,0:nymax-1,nuvzmax)

  ! Set number of levels to check for adjacent theta
  nlck=nuvz/3
  !
  ! Loop over entire grid
  !**********************
  do jy=0,nymin1
    if (sglobal.and.jy.eq.0) goto 10
    if (nglobal.and.jy.eq.nymin1) goto 10
    phi = (ylat0 + jy * dy) * pi / 180.
    f = 0.00014585 * sin(phi)
    tanphi = tan(phi)
    cosphi = cos(phi)
  ! Provide a virtual jy+1 and jy-1 in case we are on domain edge (Lat)
      jyvp=jy+1
      jyvm=jy-1
      if (jy.eq.0) jyvm=0
      if (jy.eq.nymin1) jyvp=nymin1
  ! Define absolute gap length
      jumpy=2
      if (jy.eq.0.or.jy.eq.nymin1) jumpy=1
      if (sglobal.and.jy.eq.1) then
         jyvm=1
         jumpy=1
      end if
      if (nglobal.and.jy.eq.ny-2) then
         jyvp=ny-2
         jumpy=1
      end if
      juy=jumpy
  !
    do ix=0,nxmin1
  ! Provide a virtual ix+1 and ix-1 in case we are on domain edge (Long)
      ixvp=ix+1
      ixvm=ix-1
      jumpx=2
      if (xglobal) then
         ivrp=ixvp
         ivrm=ixvm
         if (ixvm.lt.0) ivrm=ixvm+nxmin1
         if (ixvp.ge.nx) ivrp=ixvp-nx+1
      else
        if (ix.eq.0) ixvm=0
        if (ix.eq.nxmin1) ixvp=nxmin1
        ivrp=ixvp
        ivrm=ixvm
  ! Define absolute gap length
        if (ix.eq.0.or.ix.eq.nxmin1) jumpx=1
      end if
      jux=jumpx
  ! Precalculate pressure values for efficiency
      do kl=1,nuvz
        ppml(kl)=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
      end do
  !
  ! Loop over the vertical
  !***********************

      do kl=1,nuvz
        ppmk=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
        theta=tth(ix,jy,kl,n)*(100000./ppmk)**kappa
        klvrp=kl+1
        klvrm=kl-1
        klpt=kl
  ! If top or bottom level, dthetadp is evaluated between the current
  ! level and the level inside, otherwise between level+1 and level-1
  !
        if (klvrp.gt.nuvz) klvrp=nuvz
        if (klvrm.lt.1) klvrm=1
        ppmk=akz(klvrp)+bkz(klvrp)*ps(ix,jy,1,n)
        thetap=tth(ix,jy,klvrp,n)*(100000./ppmk)**kappa
        ppmk=akz(klvrm)+bkz(klvrm)*ps(ix,jy,1,n)
        thetam=tth(ix,jy,klvrm,n)*(100000./ppmk)**kappa
        dthetadp=(thetap-thetam)/(ppml(klvrp)-ppml(klvrm))

  ! Compute vertical position at pot. temperature surface on subgrid
  ! and the wind at that position
  !*****************************************************************
  ! a) in x direction
        ii=0
        do i=ixvm,ixvp,jumpx
          ivr=i
          if (xglobal) then
             if (i.lt.0) ivr=ivr+nxmin1
             if (i.ge.nx) ivr=ivr-nx+1
          end if
          ii=ii+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
40        continue
  ! Upward branch
          kup=kup+1
          if (kch.ge.nlck) goto 21     ! No more levels to check,
  !                                       ! and no values found
          if (kup.ge.nuvz) goto 41
          kch=kch+1
          k=kup
          ppmk=akz(k)+bkz(k)*ps(ivr,jy,1,n)
          thdn=tth(ivr,jy,k,n)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*ps(ivr,jy,1,n)
          thup=tth(ivr,jy,k+1,n)*(100000./ppmk)**kappa


      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
          vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
              goto 20
            endif
41        continue
  ! Downward branch
          kdn=kdn-1
          if (kdn.lt.1) goto 40
          kch=kch+1
          k=kdn
          ppmk=akz(k)+bkz(k)*ps(ivr,jy,1,n)
          thdn=tth(ivr,jy,k,n)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*ps(ivr,jy,1,n)
          thup=tth(ivr,jy,k+1,n)*(100000./ppmk)**kappa

      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
          vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
              goto 20
            endif
            goto 40
  ! This section used when no values were found
21      continue
  ! Must use vv at current level and long. jux becomes smaller by 1
        vx(ii)=vvh(ix,jy,kl)
        jux=jux-1
  ! Otherwise OK
20        continue
        end do
      if (jux.gt.0) then
      dvdx=(vx(2)-vx(1))/real(jux)/(dx*pi/180.)
      else
      dvdx=vvh(ivrp,jy,kl)-vvh(ivrm,jy,kl)
      dvdx=dvdx/real(jumpx)/(dx*pi/180.)
  ! Only happens if no equivalent theta value
  ! can be found on either side, hence must use values
  ! from either side, same pressure level.
      end if

  ! b) in y direction

        jj=0
        do j=jyvm,jyvp,jumpy
          jj=jj+1
  ! Search adjacent levels for current theta value
  ! Spiral out from current level for efficiency
          kup=klpt-1
          kdn=klpt
          kch=0
70        continue
  ! Upward branch
          kup=kup+1
          if (kch.ge.nlck) goto 51     ! No more levels to check,
  !                                     ! and no values found
          if (kup.ge.nuvz) goto 71
          kch=kch+1
          k=kup
          ppmk=akz(k)+bkz(k)*ps(ix,j,1,n)
          thdn=tth(ix,j,k,n)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*ps(ix,j,1,n)
          thup=tth(ix,j,k+1,n)*(100000./ppmk)**kappa
      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
              uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
              goto 50
            endif
71        continue
  ! Downward branch
          kdn=kdn-1
          if (kdn.lt.1) goto 70
          kch=kch+1
          k=kdn
          ppmk=akz(k)+bkz(k)*ps(ix,j,1,n)
          thdn=tth(ix,j,k,n)*(100000./ppmk)**kappa
          ppmk=akz(k+1)+bkz(k+1)*ps(ix,j,1,n)
          thup=tth(ix,j,k+1,n)*(100000./ppmk)**kappa
      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
           ((thdn.le.theta).and.(thup.ge.theta))) then
              dt1=abs(theta-thdn)
              dt2=abs(theta-thup)
              dt=dt1+dt2
              if (dt.lt.eps) then   ! Avoid division by zero error
                dt1=0.5             ! G.W., 10.4.1996
                dt2=0.5
                dt=1.0
              endif
              uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
              goto 50
            endif
            goto 70
  ! This section used when no values were found
51      continue
  ! Must use uu at current level and lat. juy becomes smaller by 1
        uy(jj)=uuh(ix,jy,kl)
        juy=juy-1
  ! Otherwise OK
50        continue
        end do
      if (juy.gt.0) then
      dudy=(uy(2)-uy(1))/real(juy)/(dy*pi/180.)
      else
      dudy=uuh(ix,jyvp,kl)-uuh(ix,jyvm,kl)
      dudy=dudy/real(jumpy)/(dy*pi/180.)
      end if
  !
      pvh(ix,jy,kl)=dthetadp*(f+(dvdx/cosphi-dudy &
           +uuh(ix,jy,kl)*tanphi)/r_earth)*(-1.e6)*9.81


  !
  ! Resest jux and juy
      jux=jumpx
      juy=jumpy
      end do
    end do
10  continue
  end do
  !
  ! Fill in missing PV values on poles, if present
  ! Use mean PV of surrounding latitude ring
  !
      if (sglobal) then
         do kl=1,nuvz
            pvavr=0.
            do ix=0,nxmin1
               pvavr=pvavr+pvh(ix,1,kl)
            end do
            pvavr=pvavr/real(nx)
            jy=0
            do ix=0,nxmin1
               pvh(ix,jy,kl)=pvavr
            end do
         end do
      end if
      if (nglobal) then
         do kl=1,nuvz
            pvavr=0.
            do ix=0,nxmin1
               pvavr=pvavr+pvh(ix,ny-2,kl)
            end do
            pvavr=pvavr/real(nx)
            jy=nymin1
            do ix=0,nxmin1
               pvh(ix,jy,kl)=pvavr
            end do
         end do
      end if

end subroutine calcpv

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine mean(x,xm,xs,number)

  !*****************************************************************************
  !                                                                            *
  !  This subroutine calculates mean and standard deviation of a given element.*
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 25 January 1994                                *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! x(number)           field of input data                                    *
  ! xm                  mean                                                   *
  ! xs                  standard deviation                                     *
  ! number              number of elements of field x                          *
  !                                                                            *
  ! Constants:                                                                 *
  ! eps                 tiny number                                            *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: number,i
  real :: x(number),xm,xs,xl,xq,xaux
  real,parameter :: eps=1.0e-30

  xl=0.
  xq=0.
  do i=1,number
    xl=xl+x(i)
    xq=xq+x(i)*x(i)
  end do

  xm=xl/real(number)

  xaux=xq-xl*xl/real(number)

  if (xaux.lt.eps) then
    xs=0.
  else
    xs=sqrt(xaux/real(number-1))
  endif

end subroutine mean

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

real function ew(x)

  !****************************************************************
  !SAETTIGUNGSDAMPFDRUCK UEBER WASSER IN PA. X IN KELVIN.
  !NACH DER GOFF-GRATCH-FORMEL.
  !****************************************************************

  implicit none

  real :: x, y, a, c, d

  ew=0.
  if(x.le.0.) stop 'sorry: t not in [k]'
  y=373.16/x
  a=-7.90298*(y-1.)
  a=a+(5.02808*0.43429*alog(y))
  c=(1.-(1./y))*11.344
  c=-1.+(10.**c)
  c=-1.3816*c/(10.**7)
  d=(1.-y)*3.49149
  d=-1.+(10.**d)
  d=8.1328*d/(10.**3)
  y=a+c+d
  ew=101324.6*(10.**y)       ! Saettigungsdampfdruck in Pa

end function ew

module txt_output_mod

  implicit none


contains

subroutine writeheader_txt

  !*****************************************************************************
  !                                                                            *
  !  This routine produces a file header containing basic information on the   *
  !  settings of the FLEXPART run.                                             *
  !  The header file is essential and must be read in by any postprocessing    *
  !  program before reading in the output data.                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !     modified IP 2013 for text output                                       *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! xlon                   longitude                                           *
  ! xl                     model x coordinate                                  *
  ! ylat                   latitude                                            *
  ! yl                     model y coordinate                                  *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use outgrid_mod
  use par_mod
  use com_mod
  use date_mod

  implicit none

  !  integer :: jjjjmmdd,ihmmss,i,ix,jy,j
  integer :: jjjjmmdd,ihmmss,i,j
  real :: xp1,yp1,xp2,yp2


  !************************
  ! Open header output file
  !************************

  open(unitheader,file=path(2)(1:length(2))//'header_txt', &
       form='formatted',err=998)
  open(unitheader_txt,file=path(2)(1:length(2))//'header_txt_releases', &
       form='formatted',err=998)


  ! Write the header information
  !*****************************
  
  write(unitheader,*) '# ibdate,ibtime, iedate, ietime, flexversion'
  write(unitheader,*) ibdate, ibtime, iedate, ietime, trim(flexversion) !  'FLEXPART V9.0'
  !if (ldirect.eq.1) then
  !  write(unitheader,*) ibdate,ibtime,trim(flexversion) !  'FLEXPART V9.0'
  !else
  !  write(unitheader,*) iedate,ietime,trim(flexversion) ! 'FLEXPART V9.0'
  !endif

  ! Write info on output interval, averaging time, sampling time
  !*************************************************************
  
  write(unitheader,*) '# interval, averaging time, sampling time'
  write(unitheader,*) loutstep,loutaver,loutsample

  ! Write information on output grid setup
  !***************************************
  
  write(unitheader,*) '# information on grid setup    '
  write(unitheader,*) '#outlon0,outlat0,numxgrid,numygrid,dxout,dyout'
  write(unitheader,*) outlon0,outlat0,numxgrid,numygrid, &
       dxout,dyout  
  write(unitheader,*) '# numzgrid, outheight(.) '
  write(unitheader,*) numzgrid,(outheight(i),i=1,numzgrid)

  write(unitheader,*) '# jjjjmmdd,ihmmss'
  call caldate(bdate,jjjjmmdd,ihmmss)
  write(unitheader,*) jjjjmmdd,ihmmss

  ! Write number of species, and name for each species (+extra name for depositions)
  ! Indicate the vertical dimension of the fields (i.e., 1 for deposition fields, numzgrid for
  ! concentration fields
  !*****************************************************************************

  write(unitheader,*) '# information on species'
  write(unitheader,*) '# 3*nspec,maxpointspec_act'
  write(unitheader,*) 3*nspec,maxpointspec_act
  write(unitheader,*) '# for nspec:'
  write(unitheader,*) '# 1, WD_ '
  write(unitheader,*) '# 1, DD_ '
  write(unitheader,*) '# numzgrid,species'
  do i=1,nspec
    write(unitheader,*) 1,'WD_'//species(i)(1:7)
    write(unitheader,*) 1,'DD_'//species(i)(1:7)
    write(unitheader,*) numzgrid,species(i)
  end do

  ! Write information on release points: total number, then for each point:
  ! start, end, coordinates, # of particles, name, mass
  !************************************************************************


  write(unitheader_txt,*) '# information on release points'
  write(unitheader_txt,*) '# numpoint'
  write(unitheader_txt,*) numpoint
  if ((ipin.ne.3).and.(ipin.ne.4)) then
    write(unitheader_txt,*) '# for numpoint:'
    do i=1,numpoint
      write(unitheader_txt,*) ireleasestart(i),ireleaseend(i),kindz(i)
      xp1=xpoint1(i)*dx+xlon0
      yp1=ypoint1(i)*dy+ylat0
      xp2=xpoint2(i)*dx+xlon0
      yp2=ypoint2(i)*dy+ylat0
      write(unitheader_txt,*) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
      write(unitheader_txt,*) npart(i),1
      if (numpoint.le.1000) then
        write(unitheader_txt,*) compoint(i)
      else
        write(unitheader_txt,*) compoint(1001)
      endif
      do j=1,nspec
        write(unitheader_txt,*) xmass(i,j)
        write(unitheader_txt,*) xmass(i,j)
        write(unitheader_txt,*) xmass(i,j)
      end do
    end do
  endif

  ! Write information on model switches
  !*****************************************

  write(unitheader,*) '# information on model switches'
  write(unitheader,*) '# method,lsubgrid,lconvection, ind_source,ind_receptor'
  write(unitheader,*) method,lsubgrid,lconvection, &
       ind_source,ind_receptor

  ! Write age class information
  !****************************
  
  write(unitheader,*) '# information on age class     '
  write(unitheader,*) nageclass,(lage(i),i=1,nageclass)


  !Do not write topography to text output file. Keep it on the binary one
  !********************************

  !do ix=0,numxgrid-1
  !  write(unitheader,*) (oroout(ix,jy),jy=0,numygrid-1)
  !end do

  close(unitheader)
  close(unitheader_txt)

  return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'header_txt'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  error stop
end subroutine writeheader_txt

end module txt_output_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine advance(itime,nrelpoint,ldt,up,vp,wp, &
       usigold,vsigold,wsigold,nstop,xt,yt,zt,prob,icbt)
  !                     i    i  i/oi/oi/o
  !  i/o     i/o     i/o     o  i/oi/oi/o i/o  i/o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of turbulent particle trajectories utilizing a                *
  !  zero-acceleration scheme, which is corrected by a numerically more        *
  !  accurate Petterssen scheme whenever possible.                             *
  !                                                                            *
  !  Particle positions are read in, incremented, and returned to the calling  *
  !  program.                                                                  *
  !                                                                            *
  !  In different regions of the atmosphere (PBL vs. free troposphere),        *
  !  different parameters are needed for advection, parameterizing turbulent   *
  !  velocities, etc. For efficiency, different interpolation routines have    *
  !  been written for these different cases, with the disadvantage that there  *
  !  exist several routines doing almost the same. They all share the          *
  !  included file 'interpol_mod'. The following                               *
  !  interpolation routines are used:                                          *
  !                                                                            *
  !  interpol_all(_nests)     interpolates everything (called inside the PBL)  *
  !  interpol_misslev(_nests) if a particle moves vertically in the PBL,       *
  !                           additional parameters are interpolated if it     *
  !                           crosses a model level                            *
  !  interpol_wind(_nests)    interpolates the wind and determines the         *
  !                           standard deviation of the wind (called outside   *
  !                           PBL) also interpolates potential vorticity       *
  !  interpol_wind_short(_nests) only interpolates the wind (needed for the    *
  !                           Petterssen scheme)                               *
  !  interpol_vdep(_nests)    interpolates deposition velocities               *
  !                                                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     16 December 1997                                                       *
  !                                                                            *
  !  Changes:                                                                  *
  !                                                                            *
  !  8 April 2000: Deep convection parameterization                            *
  !                                                                            *
  !  May 2002: Petterssen scheme introduced                                    *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! icbt               1 if particle not transferred to forbidden state,       *
  !                    else -1                                                 *
  ! dawsave            accumulated displacement in along-wind direction        *
  ! dcwsave            accumulated displacement in cross-wind direction        *
  ! dxsave             accumulated displacement in longitude                   *
  ! dysave             accumulated displacement in latitude                    *
  ! h [m]              Mixing height                                           *
  ! lwindinterv [s]    time interval between two wind fields                   *
  ! itime [s]          time at which this subroutine is entered                *
  ! itimec [s]         actual time, which is incremented in this subroutine    *
  ! href [m]           height for which dry deposition velocity is calculated  *
  ! ladvance [s]       Total integration time period                           *
  ! ldirect            1 forward, -1 backward                                  *
  ! ldt [s]            Time step for the next integration                      *
  ! lsynctime [s]      Synchronisation interval of FLEXPART                    *
  ! ngrid              index which grid is to be used                          *
  ! nrand              index for a variable to be picked from rannumb          *
  ! nstop              if > 1 particle has left domain and must be stopped     *
  ! prob               probability of absorption due to dry deposition         *
  ! rannumb(maxrand)   normally distributed random variables                   *
  ! rhoa               air density                                             *
  ! rhograd            vertical gradient of the air density                    *
  ! up,vp,wp           random velocities due to turbulence (along wind, cross  *
  !                    wind, vertical wind                                     *
  ! usig,vsig,wsig     mesoscale wind fluctuations                             *
  ! usigold,vsigold,wsigold  like usig, etc., but for the last time step       *
  ! vdepo              Deposition velocities for all species                   *
  ! xt,yt,zt           Particle position                                       *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod
  use interpol_mod
  use hanna_mod
  use cmapf_mod

  implicit none

  real(kind=dp) :: xt,yt
  real :: zt,xts,yts,weight
  integer :: itime,itimec,nstop,ldt,i,j,k,nrand,loop,memindnext
  integer :: ngr,nix,njy,ks,nsp,nrelpoint
  real :: dz,dz1,dz2,xlon,ylat,xpol,ypol,gridsize
  real :: ru,rv,rw,dt,ux,vy,cosfact,xtn,ytn,tropop
  real :: prob(maxspec),up,vp,wp,dxsave,dysave,dawsave
  real :: dcwsave
  real :: usigold,vsigold,wsigold,r,rs
  real :: uold,vold,wold,vdepo(maxspec)
  !real uprof(nzmax),vprof(nzmax),wprof(nzmax)
  !real usigprof(nzmax),vsigprof(nzmax),wsigprof(nzmax)
  !real rhoprof(nzmax),rhogradprof(nzmax)
  real :: rhoa,rhograd,ran3,delz,dtf,rhoaux,dtftlw,uxscale,wpscale
  integer(kind=2) :: icbt
  real,parameter :: eps=nxmax/3.e5,eps2=1.e-9


  !!! CHANGE: TEST OF THE WELL-MIXED CRITERION
  !  integer,parameter :: iclass=10
  !  real(kind=dp) :: zacc,tacc,t(iclass),th(0:iclass),hsave
  !  logical dump
  !  save zacc,tacc,t,th,hsave,dump
  !!! CHANGE

  integer :: idummy = -7
  real    :: settling = 0.


  !!! CHANGE: TEST OF THE WELL-MIXED CRITERION
  !if (idummy.eq.-7) then
  !open(550,file='WELLMIXEDTEST')
  !do 17 i=0,iclass
  !7      th(i)=real(i)/real(iclass)
  !endif
  !!! CHANGE


  nstop=0
  do i=1,nmixz
    indzindicator(i)=.true.
  end do


  if (DRYDEP) then    ! reset probability for deposition
    do ks=1,nspec
      depoindicator(ks)=.true.
      prob(ks)=0.
    end do
  endif

  dxsave=0.           ! reset position displacements
  dysave=0.           ! due to mean wind
  dawsave=0.          ! and turbulent wind
  dcwsave=0.

  itimec=itime

  nrand=int(ran3(idummy)*real(maxrand-1))+1


  ! Determine whether lat/long grid or polarstereographic projection
  ! is to be used
  ! Furthermore, determine which nesting level to be used
  !*****************************************************************

  if (nglobal.and.(yt.gt.switchnorthg)) then
    ngrid=-1
  else if (sglobal.and.(yt.lt.switchsouthg)) then
    ngrid=-2
  else
    ngrid=0
    do j=numbnests,1,-1
      if ((xt.gt.xln(j)+eps).and.(xt.lt.xrn(j)-eps).and. &
           (yt.gt.yln(j)+eps).and.(yt.lt.yrn(j)-eps)) then
        ngrid=j
        goto 23
      endif
    end do
23   continue
  endif


  !***************************
  ! Interpolate necessary data
  !***************************

  if (abs(itime-memtime(1)).lt.abs(itime-memtime(2))) then
    memindnext=1
  else
    memindnext=2
  endif

  ! Determine nested grid coordinates
  !**********************************

  if (ngrid.gt.0) then
    xtn=(xt-xln(ngrid))*xresoln(ngrid)
    ytn=(yt-yln(ngrid))*yresoln(ngrid)
    ix=int(xtn)
    jy=int(ytn)
    nix=nint(xtn)
    njy=nint(ytn)
  else
    ix=int(xt)
    jy=int(yt)
    nix=nint(xt)
    njy=nint(yt)
  endif
  ixp=ix+1
  jyp=jy+1


  ! Compute maximum mixing height around particle position
  !*******************************************************

  h=0.
  if (ngrid.le.0) then
    do k=1,2
      do j=jy,jyp
        do i=ix,ixp
          if (hmix(i,j,1,k).gt.h) h=hmix(i,j,1,k)
        end do
      end do
    end do
    tropop=tropopause(nix,njy,1,1)
  else
    do k=1,2
      do j=jy,jyp
        do i=ix,ixp
          if (hmixn(i,j,1,k,ngrid).gt.h) h=hmixn(i,j,1,k,ngrid)
        end do
      end do
    end do
    tropop=tropopausen(nix,njy,1,1,ngrid)
  endif

  zeta=zt/h



  !*************************************************************
  ! If particle is in the PBL, interpolate once and then make a
  ! time loop until end of interval is reached
  !*************************************************************

  if (zeta.le.1.) then

  ! BEGIN TIME LOOP
  !================

    loop=0
100   loop=loop+1
      if (method.eq.1) then
        ldt=min(ldt,abs(lsynctime-itimec+itime))
        itimec=itimec+ldt*ldirect
      else
        ldt=abs(lsynctime)
        itimec=itime+lsynctime
      endif
      dt=real(ldt)

      zeta=zt/h


      if (loop.eq.1) then
        if (ngrid.le.0) then
          xts=real(xt)
          yts=real(yt)
          call interpol_all(itime,xts,yts,zt)
        else
          call interpol_all_nests(itime,xtn,ytn,zt)
        endif

      else


  ! Determine the level below the current position for u,v,rho
  !***********************************************************

        do i=2,nz
          if (height(i).gt.zt) then
            indz=i-1
            indzp=i
            goto 6
          endif
        end do
6       continue

  ! If one of the levels necessary is not yet available,
  ! calculate it
  !*****************************************************

        do i=indz,indzp
          if (indzindicator(i)) then
            if (ngrid.le.0) then
              call interpol_misslev(i)
            else
              call interpol_misslev_nests(i)
            endif
          endif
        end do
      endif


  ! Vertical interpolation of u,v,w,rho and drhodz
  !***********************************************

  ! Vertical distance to the level below and above current position
  ! both in terms of (u,v) and (w) fields
  !****************************************************************

      dz=1./(height(indzp)-height(indz))
      dz1=(zt-height(indz))*dz
      dz2=(height(indzp)-zt)*dz

      u=dz1*uprof(indzp)+dz2*uprof(indz)
      v=dz1*vprof(indzp)+dz2*vprof(indz)
      w=dz1*wprof(indzp)+dz2*wprof(indz)
      rhoa=dz1*rhoprof(indzp)+dz2*rhoprof(indz)
      rhograd=dz1*rhogradprof(indzp)+dz2*rhogradprof(indz)


  ! Compute the turbulent disturbances
  ! Determine the sigmas and the timescales
  !****************************************

      if (turbswitch) then
        call hanna(zt)
      else
        call hanna1(zt)
      endif


  !*****************************************
  ! Determine the new diffusivity velocities
  !*****************************************

  ! Horizontal components
  !**********************

      if (nrand+1.gt.maxrand) nrand=1
      if (dt/tlu.lt..5) then
        up=(1.-dt/tlu)*up+rannumb(nrand)*sigu*sqrt(2.*dt/tlu)
      else
        ru=exp(-dt/tlu)
        up=ru*up+rannumb(nrand)*sigu*sqrt(1.-ru**2)
      endif
      if (dt/tlv.lt..5) then
        vp=(1.-dt/tlv)*vp+rannumb(nrand+1)*sigv*sqrt(2.*dt/tlv)
      else
        rv=exp(-dt/tlv)
        vp=rv*vp+rannumb(nrand+1)*sigv*sqrt(1.-rv**2)
      endif
      nrand=nrand+2


      if (nrand+ifine.gt.maxrand) nrand=1
      rhoaux=rhograd/rhoa
      dtf=dt*fine

      dtftlw=dtf/tlw

  ! Loop over ifine short time steps for vertical component
  !********************************************************

      do i=1,ifine

  ! Determine the drift velocity and density correction velocity
  !*************************************************************

        if (turbswitch) then
          if (dtftlw.lt..5) then
            wp=((1.-dtftlw)*wp+rannumb(nrand+i)*sqrt(2.*dtftlw) &
                 +dtf*(dsigwdz+rhoaux*sigw))*real(icbt)
          else
            rw=exp(-dtftlw)
            wp=(rw*wp+rannumb(nrand+i)*sqrt(1.-rw**2) &
                 +tlw*(1.-rw)*(dsigwdz+rhoaux*sigw))*real(icbt)
          endif
          delz=wp*sigw*dtf
        else
          rw=exp(-dtftlw)
          wp=(rw*wp+rannumb(nrand+i)*sqrt(1.-rw**2)*sigw &
               +tlw*(1.-rw)*(dsigw2dz+rhoaux*sigw**2))*real(icbt)
          delz=wp*dtf
        endif

  !****************************************************
  ! Compute turbulent vertical displacement of particle
  !****************************************************

        if (abs(delz).gt.h) delz=mod(delz,h)

  ! Determine if particle transfers to a "forbidden state" below the ground
  ! or above the mixing height
  !************************************************************************

        if (delz.lt.-zt) then         ! reflection at ground
          icbt=-1
          zt=-zt-delz
        else if (delz.gt.(h-zt)) then ! reflection at h
          icbt=-1
          zt=-zt-delz+2.*h
        else                         ! no reflection
          icbt=1
          zt=zt+delz
        endif

        if (i.ne.ifine) then
          zeta=zt/h
          call hanna_short(zt)
        endif

      end do
      nrand=nrand+i

  ! Determine time step for next integration
  !*****************************************

      if (turbswitch) then
        ldt=int(min(tlw,h/max(2.*abs(wp*sigw),1.e-5), &
             0.5/abs(dsigwdz))*ctl)
      else
        ldt=int(min(tlw,h/max(2.*abs(wp),1.e-5))*ctl)
      endif
      ldt=max(ldt,mintime)


  ! If particle represents only a single species, add gravitational settling
  ! velocity. The settling velocity is zero for gases, or if particle
  ! represents more than one species
  !*************************************************************************

      if (mdomainfill.eq.0) then
        do nsp=1,nspec
          if (xmass(nrelpoint,nsp).gt.eps2) goto 887
        end do
887     nsp=min(nsp,nspec)
!!$        if (density(nsp).gt.0.) &
!!$             call get_settling(itime,xts,yts,zt,nsp,settling)    !old
        if (density(nsp).gt.0.) &
             call get_settling(itime,real(xt),real(yt),zt,nsp,settling)  !bugfix
        w=w+settling
      endif

  ! Horizontal displacements during time step dt are small real values compared
  ! to the position; adding the two, would result in large numerical errors.
  ! Thus, displacements are accumulated during lsynctime and are added to the
  ! position at the end
  !****************************************************************************

      dxsave=dxsave+u*dt
      dysave=dysave+v*dt
      dawsave=dawsave+up*dt
      dcwsave=dcwsave+vp*dt
      zt=zt+w*dt*real(ldirect)

      if (zt.gt.h) then
        if (itimec.eq.itime+lsynctime) goto 99
        goto 700    ! complete the current interval above PBL
      endif


  !!! CHANGE: TEST OF THE WELL-MIXED CRITERION
  !!! These lines may be switched on to test the well-mixed criterion
  !if (zt.le.h) then
  !  zacc=zacc+zt/h*dt
  !  hsave=hsave+h*dt
  !  tacc=tacc+dt
  !  do 67 i=1,iclass
  !    if ((zt/h.gt.th(i-1)).and.(zt/h.le.th(i)))
  !    +    t(i)=t(i)+dt
  !7        continue
  !endif
  !if ((mod(itime,10800).eq.0).and.dump) then
  ! dump=.false.
  ! write(550,'(i6,12f10.3)') itime,hsave/tacc,zacc/tacc,
  !    + (t(i)/tacc*real(iclass),i=1,iclass)
  !  zacc=0.
  !  tacc=0.
  !  do 68 i=1,iclass
  !8        t(i)=0.
  !  hsave=0.
  !endif
  !if (mod(itime,10800).ne.0) dump=.true.
  !!! CHANGE


  ! Determine probability of deposition
  !************************************

      if ((DRYDEP).and.(zt.lt.2.*href)) then
        do ks=1,nspec
          if (DRYDEPSPEC(ks)) then
            if (depoindicator(ks)) then
              if (ngrid.le.0) then
                call interpol_vdep(ks,vdepo(ks))
              else
                call interpol_vdep_nests(ks,vdepo(ks))
              endif
            endif
  ! correction by Petra Seibert, 10 April 2001
  !   this formulation means that prob(n) = 1 - f(0)*...*f(n)
  !   where f(n) is the exponential term
               prob(ks)=1.+(prob(ks)-1.)* &
                    exp(-vdepo(ks)*abs(dt)/(2.*href))
          endif
        end do
      endif

      if (zt.lt.0.) zt=min(h-eps2,-1.*zt)    ! if particle below ground -> reflection

      if (itimec.eq.(itime+lsynctime)) then
        usig=0.5*(usigprof(indzp)+usigprof(indz))
        vsig=0.5*(vsigprof(indzp)+vsigprof(indz))
        wsig=0.5*(wsigprof(indzp)+wsigprof(indz))
        goto 99  ! finished
      endif
      goto 100

  ! END TIME LOOP
  !==============


  endif



  !**********************************************************
  ! For all particles that are outside the PBL, make a single
  ! time step. Only horizontal turbulent disturbances are
  ! calculated. Vertical disturbances are reset.
  !**********************************************************


  ! Interpolate the wind
  !*********************

700   continue
  if (ngrid.le.0) then
    xts=real(xt)
    yts=real(yt)
    call interpol_wind(itime,xts,yts,zt)
  else
    call interpol_wind_nests(itime,xtn,ytn,zt)
  endif


  ! Compute everything for above the PBL

  ! Assume constant, uncorrelated, turbulent perturbations
  ! In the stratosphere, use a small vertical diffusivity d_strat,
  ! in the troposphere, use a larger horizontal diffusivity d_trop.
  ! Turbulent velocity scales are determined based on sqrt(d_trop/dt)
  !******************************************************************

  ldt=abs(lsynctime-itimec+itime)
  dt=real(ldt)

  if (zt.lt.tropop) then  ! in the troposphere
    uxscale=sqrt(2.*d_trop/dt)
    if (nrand+1.gt.maxrand) nrand=1
    ux=rannumb(nrand)*uxscale
    vy=rannumb(nrand+1)*uxscale
    nrand=nrand+2
    wp=0.
  else if (zt.lt.tropop+1000.) then     ! just above the tropopause: make transition
    weight=(zt-tropop)/1000.
    uxscale=sqrt(2.*d_trop/dt*(1.-weight))
    if (nrand+2.gt.maxrand) nrand=1
    ux=rannumb(nrand)*uxscale
    vy=rannumb(nrand+1)*uxscale
    wpscale=sqrt(2.*d_strat/dt*weight)
    wp=rannumb(nrand+2)*wpscale+d_strat/1000.
    nrand=nrand+3
  else                 ! in the stratosphere
    if (nrand.gt.maxrand) nrand=1
    ux=0.
    vy=0.
    wpscale=sqrt(2.*d_strat/dt)
    wp=rannumb(nrand)*wpscale
    nrand=nrand+1
  endif


  ! If particle represents only a single species, add gravitational settling
  ! velocity. The settling velocity is zero for gases
  !*************************************************************************



    if (mdomainfill.eq.0) then
      do nsp=1,nspec
        if (xmass(nrelpoint,nsp).gt.eps2) goto 888
      end do
888   nsp=min(nsp,nspec)
!!$      if (density(nsp).gt.0.) &
!!$           call get_settling(itime,xts,yts,zt,nsp,settling)    !old
      if (density(nsp).gt.0.) &
           call get_settling(itime,real(xt),real(yt),zt,nsp,settling)  !bugfix
      w=w+settling
    endif

  ! Calculate position at time step itime+lsynctime
  !************************************************

  dxsave=dxsave+(u+ux)*dt
  dysave=dysave+(v+vy)*dt
  zt=zt+(w+wp)*dt*real(ldirect)
  if (zt.lt.0.) zt=min(h-eps2,-1.*zt)    ! if particle below ground -> reflection

99   continue



  !****************************************************************
  ! Add mesoscale random disturbances
  ! This is done only once for the whole lsynctime interval to save
  ! computation time
  !****************************************************************


  ! Mesoscale wind velocity fluctuations are obtained by scaling
  ! with the standard deviation of the grid-scale winds surrounding
  ! the particle location, multiplied by a factor turbmesoscale.
  ! The autocorrelation time constant is taken as half the
  ! time interval between wind fields
  !****************************************************************

  r=exp(-2.*real(abs(lsynctime))/real(lwindinterv))
  rs=sqrt(1.-r**2)
  if (nrand+2.gt.maxrand) nrand=1
  usigold=r*usigold+rs*rannumb(nrand)*usig*turbmesoscale
  vsigold=r*vsigold+rs*rannumb(nrand+1)*vsig*turbmesoscale
  wsigold=r*wsigold+rs*rannumb(nrand+2)*wsig*turbmesoscale

  dxsave=dxsave+usigold*real(lsynctime)
  dysave=dysave+vsigold*real(lsynctime)

  zt=zt+wsigold*real(lsynctime)
  if (zt.lt.0.) zt=-1.*zt    ! if particle below ground -> refletion

  !*************************************************************
  ! Transform along and cross wind components to xy coordinates,
  ! add them to u and v, transform u,v to grid units/second
  ! and calculate new position
  !*************************************************************

  call windalign(dxsave,dysave,dawsave,dcwsave,ux,vy)
  dxsave=dxsave+ux
  dysave=dysave+vy
  if (ngrid.ge.0) then
    cosfact=dxconst/cos((yt*dy+ylat0)*pi180)
    xt=xt+real(dxsave*cosfact*real(ldirect),kind=dp)
    yt=yt+real(dysave*dyconst*real(ldirect),kind=dp)
  else if (ngrid.eq.-1) then      ! around north pole
    xlon=xlon0+xt*dx
    ylat=ylat0+yt*dy
    call cll2xy(northpolemap,ylat,xlon,xpol,ypol)
    gridsize=1000.*cgszll(northpolemap,ylat,xlon)
    dxsave=dxsave/gridsize
    dysave=dysave/gridsize
    xpol=xpol+dxsave*real(ldirect)
    ypol=ypol+dysave*real(ldirect)
    call cxy2ll(northpolemap,xpol,ypol,ylat,xlon)
    xt=(xlon-xlon0)/dx
    yt=(ylat-ylat0)/dy
  else if (ngrid.eq.-2) then    ! around south pole
    xlon=xlon0+xt*dx
    ylat=ylat0+yt*dy
    call cll2xy(southpolemap,ylat,xlon,xpol,ypol)
    gridsize=1000.*cgszll(southpolemap,ylat,xlon)
    dxsave=dxsave/gridsize
    dysave=dysave/gridsize
    xpol=xpol+dxsave*real(ldirect)
    ypol=ypol+dysave*real(ldirect)
    call cxy2ll(southpolemap,xpol,ypol,ylat,xlon)
    xt=(xlon-xlon0)/dx
    yt=(ylat-ylat0)/dy
  endif


  ! If global data are available, use cyclic boundary condition
  !************************************************************

  if (xglobal) then
    if (xt.ge.real(nxmin1)) xt=xt-real(nxmin1)
    if (xt.lt.0.) xt=xt+real(nxmin1)
    if (xt.le.eps) xt=eps
    if (abs(xt-real(nxmin1)).le.eps) xt=real(nxmin1)-eps
  endif


  ! Check position: If trajectory outside model domain, terminate it
  !*****************************************************************

  if ((xt.lt.0.).or.(xt.ge.real(nxmin1)).or.(yt.lt.0.).or. &
       (yt.ge.real(nymin1))) then
    nstop=3
    return
  endif

  ! If particle above highest model level, set it back into the domain
  !*******************************************************************

  if (zt.ge.height(nz)) zt=height(nz)-100.*eps


  !************************************************************************
  ! Now we could finish, as this was done in FLEXPART versions up to 4.0.
  ! However, truncation errors of the advection can be significantly
  ! reduced by doing one iteration of the Petterssen scheme, if this is
  ! possible.
  ! Note that this is applied only to the grid-scale winds, not to
  ! the turbulent winds.
  !************************************************************************

  ! The Petterssen scheme can only applied with long time steps (only then u
  ! is the "old" wind as required by the scheme); otherwise do nothing
  !*************************************************************************

  if (ldt.ne.abs(lsynctime)) return

  ! The Petterssen scheme can only be applied if the ending time of the time step
  ! (itime+ldt*ldirect) is still between the two wind fields held in memory;
  ! otherwise do nothing
  !******************************************************************************

  if (abs(itime+ldt*ldirect).gt.abs(memtime(2))) return

  ! Apply it also only if starting and ending point of current time step are on
  ! the same grid; otherwise do nothing
  !*****************************************************************************
  if (nglobal.and.(yt.gt.switchnorthg)) then
    ngr=-1
  else if (sglobal.and.(yt.lt.switchsouthg)) then
    ngr=-2
  else
    ngr=0
    do j=numbnests,1,-1
      if ((xt.gt.xln(j)+eps).and.(xt.lt.xrn(j)-eps).and. &
           (yt.gt.yln(j)+eps).and.(yt.lt.yrn(j)-eps)) then
        ngr=j
        goto 43
      endif
    end do
43   continue
  endif

  if (ngr.ne.ngrid) return

  ! Determine nested grid coordinates
  !**********************************

  if (ngrid.gt.0) then
    xtn=(xt-xln(ngrid))*xresoln(ngrid)
    ytn=(yt-yln(ngrid))*yresoln(ngrid)
    ix=int(xtn)
    jy=int(ytn)
  else
    ix=int(xt)
    jy=int(yt)
  endif
  ixp=ix+1
  jyp=jy+1


  ! Memorize the old wind
  !**********************

  uold=u
  vold=v
  wold=w

  ! Interpolate wind at new position and time
  !******************************************

  if (ngrid.le.0) then
    xts=real(xt)
    yts=real(yt)
    call interpol_wind_short(itime+ldt*ldirect,xts,yts,zt)
  else
    call interpol_wind_short_nests(itime+ldt*ldirect,xtn,ytn,zt)
  endif

  if (mdomainfill.eq.0) then
    do nsp=1,nspec
      if (xmass(nrelpoint,nsp).gt.eps2) goto 889
    end do
889   nsp=min(nsp,nspec)
!!$    if (density(nsp).gt.0.) &
!!$         call get_settling(itime+ldt,xts,yts,zt,nsp,settling)    !old
    if (density(nsp).gt.0.) &
         call get_settling(itime+ldt,real(xt),real(yt),zt,nsp,settling)  !bugfix
    w=w+settling
  endif


  ! Determine the difference vector between new and old wind
  ! (use half of it to correct position according to Petterssen)
  !*************************************************************

  u=(u-uold)/2.
  v=(v-vold)/2.
  w=(w-wold)/2.


  ! Finally, correct the old position
  !**********************************

  zt=zt+w*real(ldt*ldirect)
  if (zt.lt.0.) zt=min(h-eps2,-1.*zt)    ! if particle below ground -> reflection
  if (ngrid.ge.0) then
    cosfact=dxconst/cos((yt*dy+ylat0)*pi180)
    xt=xt+real(u*cosfact*real(ldt*ldirect),kind=dp)
    yt=yt+real(v*dyconst*real(ldt*ldirect),kind=dp)
  else if (ngrid.eq.-1) then      ! around north pole
    xlon=xlon0+xt*dx
    ylat=ylat0+yt*dy
    call cll2xy(northpolemap,ylat,xlon,xpol,ypol)
    gridsize=1000.*cgszll(northpolemap,ylat,xlon)
    u=u/gridsize
    v=v/gridsize
    xpol=xpol+u*real(ldt*ldirect)
    ypol=ypol+v*real(ldt*ldirect)
    call cxy2ll(northpolemap,xpol,ypol,ylat,xlon)
    xt=(xlon-xlon0)/dx
    yt=(ylat-ylat0)/dy
  else if (ngrid.eq.-2) then    ! around south pole
    xlon=xlon0+xt*dx
    ylat=ylat0+yt*dy
    call cll2xy(southpolemap,ylat,xlon,xpol,ypol)
    gridsize=1000.*cgszll(southpolemap,ylat,xlon)
    u=u/gridsize
    v=v/gridsize
    xpol=xpol+u*real(ldt*ldirect)
    ypol=ypol+v*real(ldt*ldirect)
    call cxy2ll(southpolemap,xpol,ypol,ylat,xlon)
    xt=(xlon-xlon0)/dx
    yt=(ylat-ylat0)/dy
  endif

  ! If global data are available, use cyclic boundary condition
  !************************************************************

  if (xglobal) then
    if (xt.ge.real(nxmin1)) xt=xt-real(nxmin1)
    if (xt.lt.0.) xt=xt+real(nxmin1)
    if (xt.le.eps) xt=eps
    if (abs(xt-real(nxmin1)).le.eps) xt=real(nxmin1)-eps
  endif

  ! Check position: If trajectory outside model domain, terminate it
  !*****************************************************************

  if ((xt.lt.0.).or.(xt.ge.real(nxmin1)).or.(yt.lt.0.).or. &
       (yt.ge.real(nymin1))) then
    nstop=3
    return
  endif

  ! If particle above highest model level, set it back into the domain
  !*******************************************************************

  if (zt.ge.height(nz)) zt=height(nz)-100.*eps


end subroutine advance

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  ! L. Bakels 2022, This module contains routines that are relevant for the    *
  !                 plume trajectory computations                              *
  !                                                                            *
  !*****************************************************************************
module plume_mod
  
  implicit none
  private :: centerofmass,clustering,distance,distance2

  public :: plumetraj,openouttraj
contains

subroutine plumetraj(itime)
  !                       i
  !*****************************************************************************
  !                                                                            *
  ! Determines a plume centroid trajectory for each release site, and manages  *
  ! clustering of particle locations. Certain parameters (average PV,          *
  ! tropopause height, etc., are provided along the plume trajectories.        *
  ! At the end, output is written to file 'trajectories.txt'.                  *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 January 2002                                                        *
  !                                                                            *
  ! Variables:                                                                 *
  ! fclust          fraction of particles belonging to each cluster            *
  ! hmixcenter      mean mixing height for all particles                       *
  ! ncluster        number of clusters to be used                              *
  ! pvcenter        mean PV for all particles                                  *
  ! pvfract         fraction of particles with PV<2pvu                         *
  ! rms             total horizontal rms distance after clustering             *
  ! rmsdist         total horizontal rms distance before clustering            *
  ! rmsclust        horizontal rms distance for each individual cluster        *
  ! topocenter      mean topography underlying all particles                   *
  ! tropocenter     mean tropopause height at the positions of particles       *
  ! tropofract      fraction of particles within the troposphere               *
  ! zrms            total vertical rms distance after clustering               *
  ! zrmsdist        total vertical rms distance before clustering              *
  ! xclust,yclust,  Cluster centroid positions                                 *
  ! zclust                                                                     *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod
  use mean_mod
  use particle_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use windfields_mod

  implicit none

  integer :: ii,itime,ix,jy,ixp,jyp,indexh,i,j,k,m,n,il,ind,indz,indzp
  ! real :: xl(maxpart),yl(maxpart),zl(maxpart) ! moved to particle_mod and now xplum,yplum,zplum
  real :: xcenter,ycenter,zcenter,dist,rmsdist,zrmsdist

  real :: xclust(ncluster),yclust(ncluster),zclust(ncluster)
  real :: fclust(ncluster),rms,rmsclust(ncluster),zrms

  real :: dt1,dt2,dtt,ddx,ddy,rddx,rddy,p1,p2,p3,p4,dz1,dz2,dz
  real :: topo,topocenter,hm(2),hmixi,hmixfract,hmixcenter
  real :: pv1(2),pvprof(2),pvi,pvcenter,pvfract,tr(2),tri,tropofract
  real :: tropocenter


  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)


  ! Loop about all release points
  !******************************

  do j=1,numpoint
    if (abs(ireleasestart(j)-itime).gt.lage(nageclass)) cycle
    topocenter=0.
    hmixcenter=0.
    hmixfract=0.
    tropocenter=0.
    tropofract=0.
    pvfract=0.
    pvcenter=0.
    rmsdist=0.
    zrmsdist=0.

    n=0
    do ii=1,count%alive
      i=count%ialive(ii)
      if (part(i)%npoint.ne.j) cycle
      n=n+1
      xplum(n)=xlon0+real(part(i)%xlon)*dx
      yplum(n)=ylat0+real(part(i)%ylat)*dy
#ifdef ETA
      call update_zeta_to_z(itime,i)
#endif
      zplum(n)=real(part(i)%z)

  ! Interpolate PBL height, PV, and tropopause height to each
  ! particle position in order to determine fraction of particles
  ! within the PBL, above tropopause height, and average PV.
  ! Interpolate topography, too, and convert to altitude asl
  !**************************************************************

      ix=int(part(i)%xlon)
      jy=int(part(i)%ylat)
      ixp=ix+1
      jyp=jy+1

      ! eso: Temporary fix for particle exactly at north pole
      if (jyp >= nymax) then
        write(*,*) 'WARNING: plume_mod.f90 jyp >= nymax. xt,yt:',part(i)%xlon,part(i)%ylat
        jyp=jyp-1
      end if

      if (ixp >= nxmax) then
        write(*,*) 'WARNING: plume_mod.f90 ixp >= nxmax. xt,yt:',part(i)%xlon,part(i)%ylat
        ixp=ixp-nxmax
      end if

      ddx=real(part(i)%xlon)-real(ix)
      ddy=real(part(i)%ylat)-real(jy)
      rddx=1.-ddx
      rddy=1.-ddy
      p1=rddx*rddy
      p2=ddx*rddy
      p3=rddx*ddy
      p4=ddx*ddy

  ! Topography
  !***********

      topo=p1*oro(ix ,jy) &
           + p2*oro(ixp,jy) &
           + p3*oro(ix ,jyp) &
           + p4*oro(ixp,jyp)
      topocenter=topocenter+topo

  ! Potential vorticity
  !********************
      indz=nz-1
      indzp=nz
      do il=2,nz
        if (height(il).gt.zplum(n)) then
          indz=il-1
          indzp=il
          exit
        endif
      end do

      dz1=zplum(n)-height(indz)
      dz2=height(indzp)-zplum(n)
      dz=1./(dz1+dz2)


      do ind=indz,indzp
        do m=1,2
          indexh=memind(m)
          pv1(m)=p1*pv(ix ,jy ,ind,indexh) &
               +p2*pv(ixp,jy ,ind,indexh) &
               +p3*pv(ix ,jyp,ind,indexh) &
               +p4*pv(ixp,jyp,ind,indexh)
        end do
        pvprof(ind-indz+1)=(pv1(1)*dt2+pv1(2)*dt1)*dtt
      end do
      pvi=(dz1*pvprof(2)+dz2*pvprof(1))*dz
      pvcenter=pvcenter+pvi
      if (yplum(n).gt.0.) then
        if (pvi.lt.2.) pvfract=pvfract+1.
      else
        if (pvi.gt.-2.) pvfract=pvfract+1.
      endif


  ! Tropopause and PBL height
  !**************************

      do m=1,2
        indexh=memind(m)

        tr(m)=p1*tropopause(ix ,jy ,1,indexh) &
             + p2*tropopause(ixp,jy ,1,indexh) &
             + p3*tropopause(ix ,jyp,1,indexh) &
             + p4*tropopause(ixp,jyp,1,indexh)

        hm(m)=p1*hmix(ix ,jy ,1,indexh) &
             + p2*hmix(ixp,jy ,1,indexh) &
             + p3*hmix(ix ,jyp,1,indexh) &
             + p4*hmix(ixp,jyp,1,indexh)
      end do

      hmixi=(hm(1)*dt2+hm(2)*dt1)*dtt
      tri=(tr(1)*dt2+tr(2)*dt1)*dtt
      if (zplum(n).lt.tri) tropofract=tropofract+1.
      tropocenter=tropocenter+tri+topo
      if (zplum(n).lt.hmixi) hmixfract=hmixfract+1.
      zplum(n)=zplum(n)+topo        ! convert to height asl
      hmixcenter=hmixcenter+hmixi

    end do


  ! Make statistics for all plumes with n>0 particles
  !**************************************************

    if (n.gt.0) then
      topocenter=topocenter/real(n)
      hmixcenter=hmixcenter/real(n)
      pvcenter=pvcenter/real(n)
      tropocenter=tropocenter/real(n)
      hmixfract=100.*hmixfract/real(n)
      pvfract=100.*pvfract/real(n)
      tropofract=100.*tropofract/real(n)

  ! Cluster the particle positions
  !*******************************

      call clustering(n,xclust,yclust,zclust,fclust,rms, &
           rmsclust,zrms)


  ! Determine center of mass position on earth and average height
  !**************************************************************

      call centerofmass(xplum,yplum,n,xcenter,ycenter)
      call mean(zplum,zcenter,zrmsdist,n)

  ! Root mean square distance from center of mass
  !**********************************************

      do k=1,n
        dist=distance(yplum(k),xplum(k),ycenter,xcenter)
        rmsdist=rmsdist+dist*dist
      end do
      if (rmsdist.gt.0.) rmsdist=sqrt(rmsdist/real(n))
      rmsdist=max(rmsdist,0.)

  ! Write out results in trajectory data file
  !******************************************

      write(unitouttraj,'(i5,i8,2f9.4,4f8.1,f8.2,4f8.1,3f6.1,&
           &5(2f8.3,f7.0,f6.1,f8.1))')&
           &j,itime-(ireleasestart(j)+ireleaseend(j))/2, &
           xcenter,ycenter,zcenter,topocenter,hmixcenter,tropocenter, &
           pvcenter,rmsdist,rms,zrmsdist,zrms,hmixfract,pvfract, &
           tropofract, &
           (xclust(k),yclust(k),zclust(k),fclust(k),rmsclust(k), &
           k=1,ncluster)
    endif

  end do
end subroutine plumetraj

subroutine centerofmass(xl,yl,n,xcenter,ycenter)
  !                        i  i  i    o       o
  !*****************************************************************************
  !                                                                            *
  !   This routine calculates the center of mass of n points on the Earth.     *
  !   Input are the longitudes (xl) and latitudes (yl) of the individual       *
  !   points, output is the longitude and latitude of the centre of mass.      *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 January 2002                                                        *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  integer :: n,l
  real :: xl(n),yl(n),xll,yll,xav,yav,zav,x,y,z,xcenter,ycenter


  xav=0.
  yav=0.
  zav=0.

  do l=1,n

  ! Convert longitude and latitude from degrees to radians
  !*******************************************************

    xll=xl(l)*pi180
    yll=yl(l)*pi180

  ! Calculate 3D coordinates from longitude and latitude
  !*****************************************************

    x = cos(yll)*sin(xll)
    y = -1.*cos(yll)*cos(xll)
    z = sin(yll)


  ! Find the mean location in Cartesian coordinates
  !************************************************

    xav=xav+x
    yav=yav+y
    zav=zav+z
  end do

  xav=xav/real(n)
  yav=yav/real(n)
  zav=zav/real(n)


  ! Project the point back onto Earth's surface
  !********************************************

  xcenter=atan2(xav,-1.*yav)
  ycenter=atan2(zav,sqrt(xav*xav+yav*yav))

  ! Convert back to degrees
  !************************

  xcenter=xcenter/pi180
  ycenter=ycenter/pi180
end subroutine centerofmass

subroutine clustering(n,xclust,yclust,zclust,fclust,rms, &
       rmsclust,zrms)
  !                      i  i  i  i   o      o      o      o     o
  !   o      o
  !*****************************************************************************
  !                                                                            *
  !   This routine clusters the particle position into ncluster custers.       *
  !   Input are the longitudes (xl) and latitudes (yl) of the individual       *
  !   points, output are the cluster mean positions (xclust,yclust).           *
  !   Vertical positions are not directly used for the clustering.             *
  !                                                                            *
  !   For clustering, the procedure described in Dorling et al. (1992) is used.*
  !                                                                            *
  !   Dorling, S.R., Davies, T.D. and Pierce, C.E. (1992):                     *
  !   Cluster analysis: a technique for estimating the synoptic meteorological *
  !   controls on air and precipitation chemistry - method and applications.   *
  !   Atmospheric Environment 26A, 2575-2581.                                  *
  !                                                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     1 February 2002                                                        *
  !                                                                            *
  ! Variables:                                                                 *
  ! fclust          fraction of particles belonging to each cluster            *
  ! ncluster        number of clusters to be used                              *
  ! rms             total horizontal rms distance after clustering             *
  ! rmsclust        horizontal rms distance for each individual cluster        *
  ! zrms            total vertical rms distance after clustering               *
  ! xclust,yclust,  Cluster centroid positions                                 *
  ! zclust                                                                     *
  ! xl,yl,zl        particle positions                                         *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use particle_mod

  implicit none

  integer :: n,i,j,l,numb(ncluster),ncl
  real :: xclust(ncluster),yclust(ncluster),x,y,z
  real :: zclust(ncluster),distances,distancemin,rms,rmsold
  real :: xav(ncluster),yav(ncluster),zav(ncluster),fclust(ncluster)
  real :: rmsclust(ncluster)
  real :: zdist,zrms



  if (n.lt.ncluster) return
  rmsold=-5.

  ! Convert longitude and latitude from degrees to radians
  !*******************************************************

  do i=1,n
    nclust(i)=i
    xplum(i)=xplum(i)*pi180
    yplum(i)=yplum(i)*pi180
  end do


  ! Generate a seed for each cluster
  !*********************************

  do j=1,ncluster
    zclust(j)=0.
    xclust(j)=xplum(j*n/ncluster)
    yclust(j)=yplum(j*n/ncluster)
  end do


  ! Iterative loop to compute the cluster means
  !********************************************

  do l=1,100

  ! Assign each particle to a cluster: criterion minimum distance to the
  ! cluster mean position
  !*********************************************************************


    do i=1,n
      distancemin=10.**10.
      ncl=1
      do j=1,ncluster
        distances=distance2(yplum(i),xplum(i),yclust(j),xclust(j))
        if (distances.lt.distancemin) then
          distancemin=distances
          ncl=j
        endif
      end do
      nclust(i)=ncl
    end do


  ! Recalculate the cluster centroid position: convert to 3D Cartesian coordinates,
  ! calculate mean position, and re-project this point onto the Earth's surface
  !*****************************************************************************

    do j=1,ncluster
      xav(j)=0.
      yav(j)=0.
      zav(j)=0.
      rmsclust(j)=0.
      numb(j)=0
    end do
    rms=0.

    do i=1,n
      numb(nclust(i))=numb(nclust(i))+1
      distances=distance2(yplum(i),xplum(i), &
           yclust(nclust(i)),xclust(nclust(i)))

  ! rms is the total rms of all particles
  ! rmsclust is the rms for a particular cluster
  !*********************************************

      rms=rms+distances*distances
      rmsclust(nclust(i))=rmsclust(nclust(i))+distances*distances

  ! Calculate Cartesian 3D coordinates from longitude and latitude
  !***************************************************************

      x = cos(yplum(i))*sin(xplum(i))
      y = -1.*cos(yplum(i))*cos(xplum(i))
      z = sin(yplum(i))
      xav(nclust(i))=xav(nclust(i))+x
      yav(nclust(i))=yav(nclust(i))+y
      zav(nclust(i))=zav(nclust(i))+z
    end do

    rms=sqrt(rms/real(n))


  ! Find the mean location in Cartesian coordinates
  !************************************************

    do j=1,ncluster
      if (numb(j).gt.0) then
        rmsclust(j)=sqrt(rmsclust(j)/real(numb(j)))
        xav(j)=xav(j)/real(numb(j))
        yav(j)=yav(j)/real(numb(j))
        zav(j)=zav(j)/real(numb(j))

  ! Project the point back onto Earth's surface
  !********************************************

        xclust(j)=atan2(xav(j),-1.*yav(j))
        yclust(j)=atan2(zav(j),sqrt(xav(j)*xav(j)+yav(j)*yav(j)))
      endif
    end do


  ! Leave the loop if the RMS distance decreases only slightly between 2 iterations
  !*****************************************************************************

    if ((l.gt.1).and.(abs(rms-rmsold)/rmsold.lt.0.005)) exit
    rmsold=rms

  end do

  ! Convert longitude and latitude from radians to degrees
  !*******************************************************

  do i=1,n
    xplum(i)=xplum(i)/pi180
    yplum(i)=yplum(i)/pi180
    zclust(nclust(i))=zclust(nclust(i))+zplum(i)
  end do

  do j=1,ncluster
    xclust(j)=xclust(j)/pi180
    yclust(j)=yclust(j)/pi180
    if (numb(j).gt.0) zclust(j)=zclust(j)/real(numb(j))
    fclust(j)=100.*real(numb(j))/real(n)
  end do

  ! Determine total vertical RMS deviation
  !***************************************

  zrms=0.
  do i=1,n
    zdist=zplum(i)-zclust(nclust(i))
    zrms=zrms+zdist*zdist
  end do
  if (zrms.gt.0.) zrms=sqrt(zrms/real(n))

end subroutine clustering

real function distance(rlat1,rlon1,rlat2,rlon2)

  !$$$  SUBPROGRAM DOCUMENTATION BLOCK
  !
  ! SUBPROGRAM:  GCDIST     COMPUTE GREAT CIRCLE DISTANCE
  !   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
  !
  ! ABSTRACT: THIS SUBPROGRAM COMPUTES GREAT CIRCLE DISTANCE
  !      BETWEEN TWO POINTS ON THE EARTH.
  !
  ! PROGRAM HISTORY LOG:
  !   96-04-10  IREDELL
  !
  ! USAGE:    ...GCDIST(RLAT1,RLON1,RLAT2,RLON2)
  !
  !   INPUT ARGUMENT LIST:
  !rlat1    - REAL LATITUDE OF POINT 1 IN DEGREES
  !rlon1    - REAL LONGITUDE OF POINT 1 IN DEGREES
  !rlat2    - REAL LATITUDE OF POINT 2 IN DEGREES
  !rlon2    - REAL LONGITUDE OF POINT 2 IN DEGREES
  !
  !   OUTPUT ARGUMENT LIST:
  !distance - REAL GREAT CIRCLE DISTANCE IN KILOMETERS
  !
  ! ATTRIBUTES:
  !   LANGUAGE: Fortran 90
  !
  !$$$

  use par_mod, only: dp

  implicit none

  real          :: rlat1,rlon1,rlat2,rlon2
  real(kind=dp) :: clat1,clat2,slat1,slat2,cdlon,crd
  real(kind=dp),parameter :: rerth=6.3712e6_dp
  real(kind=dp),parameter :: pi=3.14159265358979_dp, dpr=180.0_dp/pi
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if ((abs(rlat1-rlat2).lt.0.03).and. &
       (abs(rlon1-rlon2).lt.0.03)) then
    distance=0.
  else
    clat1=cos(real(rlat1,kind=dp)/dpr)
    slat1=sin(real(rlat1,kind=dp)/dpr)
    clat2=cos(real(rlat2,kind=dp)/dpr)
    slat2=sin(real(rlat2,kind=dp)/dpr)
    cdlon=cos(real((rlon1-rlon2),kind=dp)/dpr)
    crd=slat1*slat2+clat1*clat2*cdlon
    distance=real(rerth*acos(crd)/1000.0_dp)
  endif
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
end function distance

real function distance2(rlat1,rlon1,rlat2,rlon2)

  !$$$  SUBPROGRAM DOCUMENTATION BLOCK
  !
  ! SUBPROGRAM:  GCDIST     COMPUTE GREAT CIRCLE DISTANCE
  !   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
  !
  ! ABSTRACT: THIS SUBPROGRAM COMPUTES GREAT CIRCLE DISTANCE
  !      BETWEEN TWO POINTS ON THE EARTH. COORDINATES ARE GIVEN IN RADIANS!
  !
  ! PROGRAM HISTORY LOG:
  !   96-04-10  IREDELL
  !
  ! USAGE:    ...GCDIST(RLAT1,RLON1,RLAT2,RLON2)
  !
  !   INPUT ARGUMENT LIST:
  !rlat1    - REAL LATITUDE OF POINT 1 IN RADIANS
  !rlon1    - REAL LONGITUDE OF POINT 1 IN RADIANS
  !rlat2    - REAL LATITUDE OF POINT 2 IN RADIANS
  !rlon2    - REAL LONGITUDE OF POINT 2 IN RADIANS
  !
  !   OUTPUT ARGUMENT LIST:
  !distance2   - REAL GREAT CIRCLE DISTANCE IN KM
  !
  ! ATTRIBUTES:
  !   LANGUAGE: Fortran 90
  !
  !$$$

  use par_mod, only: dp

  implicit none

  real                    :: rlat1,rlon1,rlat2,rlon2
  real(kind=dp)           :: clat1,clat2,slat1,slat2,cdlon,crd
  real(kind=dp),parameter :: rerth=6.3712e6_dp
  real(kind=dp),parameter :: pi=3.14159265358979_dp

  if ((abs(rlat1-rlat2).lt.0.0003).and. &
       (abs(rlon1-rlon2).lt.0.0003)) then
    distance2=0.0_dp
  else

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    clat1=cos(real(rlat1,kind=dp))
    slat1=sin(real(rlat1,kind=dp))
    clat2=cos(real(rlat2,kind=dp))
    slat2=sin(real(rlat2,kind=dp))
    cdlon=cos(real(rlon1-rlon2,kind=dp))
    crd=slat1*slat2+clat1*clat2*cdlon
    distance2=real(rerth*acos(crd)/1000.0_dp)
  endif
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
end function distance2

subroutine openouttraj

  !*****************************************************************************
  !                                                                            *
  !   This routine opens the output file for the plume trajectory output       *
  !   produced by the cluster analysis.                                        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     27 January 2001                                                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod

  implicit none

  integer :: i
  real :: xp1,yp1,xp2,yp2


  ! Open output file for trajectory output
  !***************************************

  open(unitouttraj,file=path(2)(1:length(2))//'trajectories.txt', &
       form='formatted',err=998)

  if (ldirect.eq.1) then
  write(unitouttraj,'(i8,1x,i6,1x,a)') ibdate,ibtime, trim(flexversion)
  else
  write(unitouttraj,'(i8,1x,i6,1x,a)') iedate,ietime, trim(flexversion)
  endif
  write(unitouttraj,*) method,lsubgrid,lconvection
  write(unitouttraj,*) numpoint
  do i=1,numpoint
    xp1=xpoint1(i)*dx+xlon0
    yp1=ypoint1(i)*dy+ylat0
    xp2=xpoint2(i)*dx+xlon0
    yp2=ypoint2(i)*dy+ylat0
    write(unitouttraj,*) ireleasestart(i),ireleaseend(i), &
         xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i),kindz(i),npart(i)
    if (numpoint.le.1000) then
      write(unitouttraj,'(a)') compoint(i)(1:40)
    else
      write(unitouttraj,'(a)') compoint(1001)(1:40)
    endif
  end do

  return

998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### trajectories.txt                         #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  error stop

end subroutine openouttraj

end module plume_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine assignland

  !*****************************************************************************
  !                                                                            *
  !     This routine assigns fractions of the 13 landuse classes to each ECMWF *
  !     grid point.                                                            *
  !     The landuse inventory of                                               *
  !                                                                            *
  ! Belward, A.S., Estes, J.E., and Kline, K.D., 1999,                         *
  ! The IGBP-DIS 1-Km Land-Cover Data Set DISCover:                            *
  ! A Project Overview: Photogrammetric Engineering and Remote Sensing ,       *
  ! v. 65, no. 9, p. 1013-1020                                                 *
  !                                                                            *
  !     if there are no data in the inventory                                  *
  !     the ECMWF land/sea mask is used to distinguish                         *
  !     between sea (-> ocean) and land (-> grasslands).                       *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     5 December 1996                                                        *
  !     8 February 1999 Additional use of nests, A. Stohl                      *
  !    29 December 2006 new landuse inventory, S. Eckhardt                     *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! xlanduse          fractions of numclass landuses for each model grid point *
  ! landinvent       landuse inventory (0.3 deg resolution)                    *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: ix,jy,k,l,li,nrefine,iix,jjy
  integer,parameter :: lumaxx=1200,lumaxy=600
  integer,parameter :: xlon0lu=-180,ylat0lu=-90
  real,parameter :: dxlu=0.3
  real :: xlon,ylat,sumperc,p,xi,yj
  real :: xlandusep(lumaxx,lumaxy,numclass)
  ! character*2 ck

  do ix=1,lumaxx
    do jy=1,lumaxy
          do k=1,numclass
            xlandusep(ix,jy,k)=0.
          end do
          sumperc=0.
          do li=1,3
            sumperc=sumperc+landinvent(ix,jy,li+3)
          end do
          do li=1,3
            k=landinvent(ix,jy,li)
          if (sumperc.gt.0) then
            p=landinvent(ix,jy,li+3)/sumperc
          else
            p=0
          endif
  ! p has values between 0 and 1
            xlandusep(ix,jy,k)=p
          end do
    end do
  end do

  ! do 13 k=1,11
  ! write (ck,'(i2.2)') k
  ! open(4,file='xlandusetest'//ck,form='formatted')
  ! do 11 ix=1,lumaxx
  !11       write (4,*) (xlandusep(ix,jy,k),jy=1,lumaxy)
  !11       write (4,*) (landinvent(ix,jy,k),jy=1,lumaxy)
  !13     close(4)

  ! write (*,*) xlon0,ylat0,xlon0n(1),ylat0n(1),nxmin1,nymin1
  ! write (*,*) dx, dy, dxout, dyout, ylat0, xlon0
  nrefine=10
  do ix=0,nxmin1
    do jy=0,nymin1
      do k=1,numclass
        sumperc=0.
        xlanduse(ix,jy,k)=0.
      end do
        do iix=1, nrefine
          xlon=(ix+(iix-1)/real(nrefine))*dx+xlon0        ! longitude, should be between -180 and 179
          if (xlon.ge.(xlon0lu+lumaxx*dxlu))  then
               xlon=xlon-lumaxx*dxlu
          endif
          do jjy=1, nrefine
           ylat=(jy+(jjy-1)/real(nrefine))*dy+ylat0       ! and lat. of each gridpoint
           xi=int((xlon-xlon0lu)/dxlu)+1
           yj=int((ylat-ylat0lu)/dxlu)+1
           if (xi.gt.lumaxx) xi=xi-lumaxx
           if (yj.gt.lumaxy) yj=yj-lumaxy
           if (xi.lt.0) then
              write (*,*) 'problem with landuseinv sampling: ', &
                   xlon,xlon0lu,ix,iix,xlon0,dx,nxmax
              stop
           endif
           do k=1,numclass
              xlanduse(ix,jy,k)= &
                   xlanduse(ix,jy,k)+xlandusep(int(xi),int(yj),k)
             sumperc=sumperc+xlanduse(ix,jy,k)  ! just for the check if landuseinv. is available
           end do
          end do
        end do
          if (sumperc.gt.0) then                       ! detailed landuse available
          sumperc=0.
          do k=1,numclass
              xlanduse(ix,jy,k)= &
                   xlanduse(ix,jy,k)/real(nrefine*nrefine)
            sumperc=sumperc+xlanduse(ix,jy,k)
          end do
  !cc the sum of all categories should be 1 ... 100 percent ... in order to get vdep right!
          if (sumperc.lt.1-1E-5) then
            do k=1,numclass
              xlanduse(ix,jy,k)= &
                   xlanduse(ix,jy,k)/sumperc
            end do
          endif
          else
            if (lsm(ix,jy).lt.0.1) then           ! over sea  -> ocean
              xlanduse(ix,jy,3)=1.
            else                                  ! over land -> rangeland
              xlanduse(ix,jy,7)=1.
            endif
          endif


    end do
  end do

  !***********************************
  ! for test: write out xlanduse

  ! open(4,file='landusetest',form='formatted')
  ! do 56 k=1,13
  ! do 55 ix=0,nxmin1
  !55    write (4,*) (xlanduse(ix,jy,k),jy=0,nymin1)
  !56    continue
  ! close(4)
  ! write (*,*) 'landuse written'
  !stop
  !  open(4,file='landseatest'//ck,form='formatted')
  ! do 57 ix=0,nxmin1
  !57       write (4,*) (lsm(ix,jy),jy=0,nymin1)
  !  write (*,*) 'landseamask written'

  !****************************************
  ! Same as above, but for the nested grids
  !****************************************

  !************** TEST ********************
  ! dyn(1)=dyn(1)/40
  ! dxn(1)=dxn(1)/40
  ! xlon0n(1)=1
  ! ylat0n(1)=50
  !************** TEST ********************

  do l=1,numbnests
    do ix=0,nxn(l)-1
      do jy=0,nyn(l)-1
        do k=1,numclass
          sumperc=0.
          xlandusen(ix,jy,k,l)=0.
        end do
          do iix=1, nrefine
           xlon=(ix+(iix-1)/real(nrefine))*dxn(l)+xlon0n(l)
           do jjy=1, nrefine
             ylat=(jy+(jjy-1)/real(nrefine))*dyn(l)+ylat0n(l)
             xi=int((xlon-xlon0lu)/dxlu)+1
             yj=int((ylat-ylat0lu)/dxlu)+1
             if (xi.gt.lumaxx) xi=xi-lumaxx
             if (yj.gt.lumaxy) yj=yj-lumaxy
             do k=1,numclass
                xlandusen(ix,jy,k,l)=xlandusen(ix,jy,k,l)+ &
                     xlandusep(int(xi),int(yj),k)
               sumperc=sumperc+xlandusen(ix,jy,k,l)
             end do
           end do
          end do
          if (sumperc.gt.0) then                     ! detailed landuse available
          sumperc=0.
            do k=1,numclass
               xlandusen(ix,jy,k,l)= &
                    xlandusen(ix,jy,k,l)/real(nrefine*nrefine)
              sumperc=sumperc+xlandusen(ix,jy,k,l)
            end do
  !cc the sum of all categories should be 1 ... 100 percent ... in order to get vdep right!
            if (sumperc.lt.1-1E-5) then
              do k=1,numclass
                xlandusen(ix,jy,k,l)=xlandusen(ix,jy,k,l)/sumperc
              end do
            endif
          else                                    ! check land/sea mask
            if (lsmn(ix,jy,l).lt.0.1) then   ! over sea  -> ocean
              xlandusen(ix,jy,3,l)=1.
            else                        ! over land -> grasslands
              xlandusen(ix,jy,7,l)=1.
            endif
          endif
      end do
    end do
  end do

  !***********************************
  ! for test: write out xlanduse

  ! do 66 k=1,11
  ! write (ck,'(i2.2)') k
  ! open(4,file='nlandusetest'//ck,form='formatted')
  ! do 65 ix=0,nxn(1)-1
  !65       write (4,*) (xlandusen(ix,jy,k,1),jy=0,nyn(1)-1)
  !66      close(4)

  ! write (*,*) 'landuse nested written'


end subroutine assignland

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine skplin(nlines,iunit)
  !                    i      i
  !*****************************************************************************
  !                                                                            *
  !   This routine reads nlines from unit iunit and discards them              *
  !                                                                            *
  !   Authors: Petra Seibert                                                   *
  !                                                                            *
  !   31 Dec 1998                                                              *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! iunit   unit number from which lines are to be skipped                     *
  ! nlines  number of lines to be skipped                                      *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: i,iunit, nlines

  do i=1,nlines
    read(iunit,*)
  end do

end subroutine skplin

!*****************************************************************************
!                                                                            *
! L. Bakels 2021: This module contains dry deposition related subroutines    *
!                                                                            *
! To do: dry deposition mass loss substraction of individual particles       *
!        should be moved from to timemanager_mod.f90 to here                 *
!                                                                            *
!                                                                            *
!*****************************************************************************

module drydepo_mod
  use par_mod
  use com_mod
  use unc_mod
  use windfields_mod
  use erf_mod
  
  implicit none

  real,allocatable,dimension(:,:,:) :: xlanduse 
   ! area fractions in percent [0-1]
  real,allocatable,dimension(:,:,:,:) :: xlandusen
   ! nested area fractions in percent [0-1]
  real,allocatable,dimension(:,:,:,:) :: vdep ! deposition velocity [m/s]

  ! roughness length
  real,allocatable,dimension(:,:) :: z0_drydep
  ! roughtness lenght nested area
  real,allocatable,dimension(:,:,:) :: z0_drydepn

contains

subroutine alloc_drydepo

  implicit none
  integer:: stat

  if (.not. drydep) return
  write(*,*) 'allocate drydepo fields'
  allocate(xlanduse(0:nxmax-1,0:nymax-1,numclass),      &
           vdep(0:nxmax-1,0:nymax-1,maxspec,numwfmem), &
           z0_drydep(0:nxmax-1,0:nymax-1), stat=stat)
  if (stat.ne.0) error stop "Could not allocate drydepo fields"
  if (numbnests.ge.1) then
    allocate(xlandusen(0:nxmaxn-1,0:nymaxn-1,numclass,numbnests), &
           vdepn(0:nxmaxn-1,0:nymaxn-1,maxspec,numwfmem,numbnests), &
           z0_drydepn(0:nxmaxn-1,0:nymaxn-1,numbnests), stat=stat)
    if (stat.ne.0) error stop "Could not allocate drydepo fields"
  endif  
           
end subroutine alloc_drydepo

subroutine dealloc_drydepo

  if (.not. drydep) return
  deallocate(xlanduse,vdep,z0_drydep)
  if (numbnests.ge.1) then
    deallocate(xlandusen,vdepn,z0_drydepn)
  endif

end subroutine dealloc_drydepo

subroutine assignland

  !*****************************************************************************
  !                                                                            *
  !     This routine assigns fractions of the 13 landuse classes to each ECMWF *
  !     grid point.                                                            *
  !     The landuse inventory of                                               *
  !                                                                            *
  ! Belward, A.S., Estes, J.E., and Kline, K.D., 1999,                         *
  ! The IGBP-DIS 1-Km Land-Cover Data Set DISCover:                            *
  ! A Project Overview: Photogrammetric Engineering and Remote Sensing ,       *
  ! v. 65, no. 9, p. 1013-1020                                                 *
  !                                                                            *
  !     if there are no data in the inventory                                  *
  !     the ECMWF land/sea mask is used to distinguish                         *
  !     between sea (-> ocean) and land (-> grasslands).                       *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     5 December 1996                                                        *
  !     8 February 1999 Additional use of nests, A. Stohl                      *
  !    29 December 2006 new landuse inventory, S. Eckhardt                     *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! xlanduse          fractions of numclass landuses for each model grid point *
  ! landinvent       landuse inventory (0.3 deg resolution)                    *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: ix,jy,k,l,li,nrefine,iix,jjy,stat
  integer,parameter :: lumaxx=1200,lumaxy=600
  integer,parameter :: xlon0lu=-180,ylat0lu=-90
  real,parameter :: dxlu=0.3
  real :: xlon,ylat,sumperc,p,xi,yj
  real,allocatable,dimension(:,:,:) :: xlandusep
  ! character*2 ck

  if (.not.DRYDEP) return
  
  allocate( xlandusep(lumaxx,lumaxy,numclass), stat=stat)
  if (stat.ne.0) error stop "Could not allocate xlandusep in assignland"

  do ix=1,lumaxx
    do jy=1,lumaxy
       do k=1,numclass
         xlandusep(ix,jy,k)=0.
       end do
       sumperc=0.
       do li=1,3
         sumperc=sumperc+landinvent(ix,jy,li+3)
       end do
       do li=1,3
         k=landinvent(ix,jy,li)
       if (sumperc.gt.0) then
         p=landinvent(ix,jy,li+3)/sumperc
       else
         p=0
       endif
! p has values between 0 and 1
         xlandusep(ix,jy,k)=p
       end do
    end do
  end do

  ! do 13 k=1,11
  ! write (ck,'(i2.2)') k
  ! open(4,file='xlandusetest'//ck,form='formatted')
  ! do 11 ix=1,lumaxx
  !11       write (4,*) (xlandusep(ix,jy,k),jy=1,lumaxy)
  !11       write (4,*) (landinvent(ix,jy,k),jy=1,lumaxy)
  !13     close(4)

  ! write (*,*) xlon0,ylat0,xlon0n(1),ylat0n(1),nxmin1,nymin1
  ! write (*,*) dx, dy, dxout, dyout, ylat0, xlon0
  nrefine=10
  do ix=0,nxmin1
    do jy=0,nymin1
      do k=1,numclass
        sumperc=0.
        xlanduse(ix,jy,k)=0.
      end do
        do iix=1, nrefine
          xlon=(ix+(iix-1)/real(nrefine))*dx+xlon0        ! longitude, should be between -180 and 179
          if (xlon.ge.(xlon0lu+lumaxx*dxlu))  then
               xlon=xlon-lumaxx*dxlu
          endif
          do jjy=1, nrefine
           ylat=(jy+(jjy-1)/real(nrefine))*dy+ylat0       ! and lat. of each gridpoint
           xi=int((xlon-xlon0lu)/dxlu)+1
           yj=int((ylat-ylat0lu)/dxlu)+1
           if (xi.gt.lumaxx) xi=xi-lumaxx
           if (yj.gt.lumaxy) yj=yj-lumaxy
           if (xi.lt.0) then
              write (*,*) 'problem with landuseinv sampling: ', &
                   xlon,xlon0lu,ix,iix,xlon0,dx,nxmax
              error stop
           endif
           do k=1,numclass
              xlanduse(ix,jy,k)= &
                   xlanduse(ix,jy,k)+xlandusep(int(xi),int(yj),k)
             sumperc=sumperc+xlanduse(ix,jy,k)  ! just for the check if landuseinv. is available
           end do
          end do
        end do
          if (sumperc.gt.0) then                       ! detailed landuse available
          sumperc=0.
          do k=1,numclass
              xlanduse(ix,jy,k)= &
                   xlanduse(ix,jy,k)/real(nrefine*nrefine)
            sumperc=sumperc+xlanduse(ix,jy,k)
          end do
  !cc the sum of all categories should be 1 ... 100 percent ... in order to get vdep right!
          if (sumperc.lt.1-1E-5) then
            do k=1,numclass
              xlanduse(ix,jy,k)= &
                   xlanduse(ix,jy,k)/sumperc
            end do
          endif
          else
            if (lsm(ix,jy).lt.0.1) then           ! over sea  -> ocean
              xlanduse(ix,jy,3)=1.
            else                                  ! over land -> rangeland
              xlanduse(ix,jy,7)=1.
            endif
          endif


    end do
  end do

  !***********************************
  ! for test: write out xlanduse

  ! open(4,file='landusetest',form='formatted')
  ! do 56 k=1,13
  ! do 55 ix=0,nxmin1
  !55    write (4,*) (xlanduse(ix,jy,k),jy=0,nymin1)
  !56    continue
  ! close(4)
  ! write (*,*) 'landuse written'
  !stop
  !  open(4,file='landseatest'//ck,form='formatted')
  ! do 57 ix=0,nxmin1
  !57       write (4,*) (lsm(ix,jy),jy=0,nymin1)
  !  write (*,*) 'landseamask written'

  !****************************************
  ! Same as above, but for the nested grids
  !****************************************

  !************** TEST ********************
  ! dyn(1)=dyn(1)/40
  ! dxn(1)=dxn(1)/40
  ! xlon0n(1)=1
  ! ylat0n(1)=50
  !************** TEST ********************

  do l=1,numbnests
    do ix=0,nxn(l)-1
      do jy=0,nyn(l)-1
        do k=1,numclass
          sumperc=0.
          xlandusen(ix,jy,k,l)=0.
        end do
          do iix=1, nrefine
           xlon=(ix+(iix-1)/real(nrefine))*dxn(l)+xlon0n(l)
           do jjy=1, nrefine
             ylat=(jy+(jjy-1)/real(nrefine))*dyn(l)+ylat0n(l)
             xi=int((xlon-xlon0lu)/dxlu)+1
             yj=int((ylat-ylat0lu)/dxlu)+1
             if (xi.gt.lumaxx) xi=xi-lumaxx
             if (yj.gt.lumaxy) yj=yj-lumaxy
             do k=1,numclass
                xlandusen(ix,jy,k,l)=xlandusen(ix,jy,k,l)+ &
                     xlandusep(int(xi),int(yj),k)
               sumperc=sumperc+xlandusen(ix,jy,k,l)
             end do
           end do
          end do
          if (sumperc.gt.0) then                     ! detailed landuse available
          sumperc=0.
            do k=1,numclass
               xlandusen(ix,jy,k,l)= &
                    xlandusen(ix,jy,k,l)/real(nrefine*nrefine)
              sumperc=sumperc+xlandusen(ix,jy,k,l)
            end do
  !cc the sum of all categories should be 1 ... 100 percent ... in order to get vdep right!
            if (sumperc.lt.1-1E-5) then
              do k=1,numclass
                xlandusen(ix,jy,k,l)=xlandusen(ix,jy,k,l)/sumperc
              end do
            endif
          else                                    ! check land/sea mask
            if (lsmn(ix,jy,l).lt.0.1) then   ! over sea  -> ocean
              xlandusen(ix,jy,3,l)=1.
            else                        ! over land -> grasslands
              xlandusen(ix,jy,7,l)=1.
            endif
          endif
      end do
    end do
  end do

  !***********************************
  ! for test: write out xlanduse

  ! do 66 k=1,11
  ! write (ck,'(i2.2)') k
  ! open(4,file='nlandusetest'//ck,form='formatted')
  ! do 65 ix=0,nxn(1)-1
  !65       write (4,*) (xlandusen(ix,jy,k,1),jy=0,nyn(1)-1)
  !66      close(4)

  ! write (*,*) 'landuse nested written'
end subroutine assignland

real function raerod (l,ust,z0)
  !*****************************************************************************
  !                                                                            *
  !     Calculation of the aerodynamical resistance ra from ground up to href  *
  !                                                                            *
  !     AUTHOR: Matthias Langer, modified by Andreas Stohl (6 August 1993)     *
  !                                                                            *
  !     Literature:                                                            *
  !     [1]  Hicks/Baldocchi/Meyers/Hosker/Matt (1987), A Preliminary          *
  !             Multiple Resistance Routine for Deriving Dry Deposition        *
  !             Velocities from Measured Quantities.                           *
  !             Water, Air and Soil Pollution 36 (1987), pp.311-330.           *
  !     [2]  Scire/Yamartino/Carmichael/Chang (1989),                          *
  !             CALGRID: A Mesoscale Photochemical Grid Model.                 *
  !             Vol II: User's Guide. (Report No.A049-1, June, 1989)           *
  !                                                                            *
  !     Variable list:                                                         *
  !     L     = Monin-Obukhov-length [m]                                       *
  !     ust   = friction velocity [m/sec]                                      *
  !     z0    = surface roughness length [m]                                   *
  !     href  = reference height [m], for which deposition velocity is         *
  !             calculated                                                     *
  !                                                                            *
  !     Constants:                                                             *
  !     karman    = von Karman-constant (~0.4)                                 *
  !     ramin = minimum resistence of ra (1 s/m)                               *
  !                                                                            *
  !     Subprograms and functions:                                             *
  !     function psih (z/L)                                                    *
  !                                                                            *
  !*****************************************************************************

  use pbl_profile_mod, only: psih

  implicit none

  real :: l,ust,z0

  raerod=(alog(href/z0)-psih(href,l)+psih(z0,l))/(karman*ust)

end function raerod

subroutine drydepo_massloss(ipart,ks,ldeltat,drydepopart)
  use particle_mod

  implicit none

  integer,intent(in) ::  &
    ipart,               & ! particle index
    ks,                  & ! species index
    ldeltat                ! radioactive decay time
  real(dep_prec),intent(out) ::  &
    drydepopart            ! drydeposit for particle ipart
  real decfact             ! radioactive decay factor

  if (decay(ks).gt.0.) then             ! radioactive decay
    decfact=exp(-real(abs(lsynctime))*decay(ks))
  else
    decfact=1.
  endif
  drydepopart=mass(ipart,ks)*prob(ipart,ks)*decfact
  
  drydeposit(ipart,ks)=drydeposit(ipart,ks)+ &
    mass(ipart,ks)*prob(ipart,ks)*decfact

  mass(ipart,ks)=mass(ipart,ks)*(1.-prob(ipart,ks))*decfact

  if (decay(ks).gt.0.) then   ! correct for decay (see wetdepo)
    drydepopart=drydepopart*exp(real(abs(ldeltat))*decay(ks))
  endif

end subroutine drydepo_massloss

subroutine drydepokernel(nunc,deposit,x,y,nage,kp,thread)
  !                          i      i    i i  i
  !*****************************************************************************
  !                                                                            *
  !     Attribution of the deposition to the grid using a uniform kernel with  *
  !     bandwidths dx and dy.                                                  *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     26 December 1996                                                       *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nunc             uncertainty class of the respective particle              *
  ! nage             age class of the respective particle                      *
  ! deposit          amount (kg) to be deposited                               *
  !                                                                            *
  !*****************************************************************************
  ! Changes:
  ! eso 10/2016: Added option to disregard kernel 
  ! 
  !*****************************************************************************

  implicit none

  integer,intent(in) :: thread
  real(dep_prec), dimension(maxspec) :: deposit
  real :: x,y,ddx,ddy,xl,yl,wx,wy,w
  integer :: ix,jy,ixp,jyp,ks,nunc,nage,kp


  xl=(x*dx+xoutshift)/dxout
  yl=(y*dy+youtshift)/dyout
  ix=int(xl)
  jy=int(yl)
  ddx=xl-real(ix)                   ! distance to left cell border
  ddy=yl-real(jy)                   ! distance to lower cell border

  if (ddx.gt.0.5) then
    ixp=ix+1
    wx=1.5-ddx
  else
    ixp=ix-1
    wx=0.5+ddx
  endif

  if (ddy.gt.0.5) then
    jyp=jy+1
    wy=1.5-ddy
  else
    jyp=jy-1
    wy=0.5+ddy
  endif

  ! If no kernel is used, direct attribution to grid cell
  !******************************************************

  if (.not.lusekerneloutput) then
    do ks=1,nspec
      if ((abs(deposit(ks)).gt.0).and.DRYDEPSPEC(ks)) then
        if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
             (jy.le.numygrid-1)) then
#ifdef _OPENMP
          gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)= &
               gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)
#else
          drygridunc(ix,jy,ks,kp,nunc,nage)= &
               drygridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)
#endif
        end if
      end if
    end do
  else ! use kernel 


  ! Determine mass fractions for four grid points
  !**********************************************
    do ks=1,nspec

     if ((abs(deposit(ks)).gt.0).and.DRYDEPSPEC(ks)) then

        if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
          (jy.le.numygrid-1)) then
          w=wx*wy
#ifdef _OPENMP
          gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)= &
             gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
          drygridunc(ix,jy,ks,kp,nunc,nage)= &
             drygridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
       endif

      if ((ixp.ge.0).and.(jyp.ge.0).and.(ixp.le.numxgrid-1).and. &
         (jyp.le.numygrid-1)) then
        w=(1.-wx)*(1.-wy)
#ifdef _OPENMP
        gridunc_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)= &
             gridunc_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
        drygridunc(ixp,jyp,ks,kp,nunc,nage)= &
             drygridunc(ixp,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
      endif

      if ((ixp.ge.0).and.(jy.ge.0).and.(ixp.le.numxgrid-1).and. &
         (jy.le.numygrid-1)) then
        w=(1.-wx)*wy
#ifdef _OPENMP
        gridunc_omp(ixp,jy,1,ks,kp,nunc,nage,thread)= &
             gridunc_omp(ixp,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
        drygridunc(ixp,jy,ks,kp,nunc,nage)= &
             drygridunc(ixp,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
      endif

      if ((ix.ge.0).and.(jyp.ge.0).and.(ix.le.numxgrid-1).and. &
         (jyp.le.numygrid-1)) then
        w=wx*(1.-wy)
#ifdef _OPENMP
        gridunc_omp(ix,jyp,1,ks,kp,nunc,nage,thread)= &
             gridunc_omp(ix,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
        drygridunc(ix,jyp,ks,kp,nunc,nage)= &
             drygridunc(ix,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
      endif

      endif ! deposit>0
    end do
  end if
end subroutine drydepokernel

subroutine drydepokernel_nest(nunc,deposit,x,y,nage,kp,thread)
  !                               i      i    i i  i
  !*****************************************************************************
  !                                                                            *
  !     Attribution of the deposition from an individual particle to the       *
  !     nested deposition fields using a uniform kernel with bandwidths        *
  !     dxoutn and dyoutn.                                                     *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     26 December 1996                                                       *
  !                                                                            *
  !      2 September 2004: Adaptation from drydepokernel.                      *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nunc             uncertainty class of the respective particle              *
  ! nage             age class of the respective particle                      *
  ! deposit          amount (kg) to be deposited                               *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer,intent(in) :: thread
  real(dep_prec), dimension(maxspec) :: deposit
  real :: x,y,ddx,ddy,xl,yl,wx,wy,w
  integer :: ix,jy,ixp,jyp,ks,kp,nunc,nage



  xl=(x*dx+xoutshiftn)/dxoutn
  yl=(y*dy+youtshiftn)/dyoutn
  ix=int(xl)
  jy=int(yl)
  ddx=xl-real(ix)                   ! distance to left cell border
  ddy=yl-real(jy)                   ! distance to lower cell border

  if (ddx.gt.0.5) then
    ixp=ix+1
    wx=1.5-ddx
  else
    ixp=ix-1
    wx=0.5+ddx
  endif

  if (ddy.gt.0.5) then
    jyp=jy+1
    wy=1.5-ddy
  else
    jyp=jy-1
    wy=0.5+ddy
  endif


  ! Determine mass fractions for four grid points
  !**********************************************
  do ks=1,nspec

    if (DRYDEPSPEC(ks).and.(abs(deposit(ks)).gt.0)) then

      if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgridn-1).and. &
           (jy.le.numygridn-1)) then
        w=wx*wy
#ifdef _OPENMP
        griduncn_omp(ix,jy,1,ks,kp,nunc,nage,thread)= &
             griduncn_omp(ix,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
        drygriduncn(ix,jy,ks,kp,nunc,nage)= &
             drygriduncn(ix,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
      endif

      if ((ixp.ge.0).and.(jyp.ge.0).and.(ixp.le.numxgridn-1).and. &
           (jyp.le.numygridn-1)) then
        w=(1.-wx)*(1.-wy)
#ifdef _OPENMP
        griduncn_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)= &
             griduncn_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
        drygriduncn(ixp,jyp,ks,kp,nunc,nage)= &
             drygriduncn(ixp,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
      endif

      if ((ixp.ge.0).and.(jy.ge.0).and.(ixp.le.numxgridn-1).and. &
           (jy.le.numygridn-1)) then
        w=(1.-wx)*wy
#ifdef _OPENMP
        griduncn_omp(ixp,jy,1,ks,kp,nunc,nage,thread)= &
             griduncn_omp(ixp,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
        drygriduncn(ixp,jy,ks,kp,nunc,nage)= &
             drygriduncn(ixp,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
      endif

      if ((ix.ge.0).and.(jyp.ge.0).and.(ix.le.numxgridn-1).and. &
           (jyp.le.numygridn-1)) then
        w=wx*(1.-wy)
#ifdef _OPENMP
        griduncn_omp(ix,jyp,1,ks,kp,nunc,nage,thread)= &
             griduncn_omp(ix,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
        drygriduncn(ix,jyp,ks,kp,nunc,nage)= &
             drygriduncn(ix,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
      endif

    endif

  end do
end subroutine drydepokernel_nest

subroutine part0(dquer,dsigma,density,ni,fract,schmi,cun,vsh)
  !                  i      i       i   i   o     o    o   o
  !*****************************************************************************
  !                                                                            *
  !      Calculation of time independent factors of the dry deposition of      *
  !      particles:                                                            *
  !      Log-Normal-distribution of mass [dM/dlog(dp)], unimodal               *
  !                                                                            *
  !      AUTHOR: Matthias Langer, adapted by Andreas Stohl, 13 November 1993   *
  !                                                                            *
  !      Literature:                                                           *
  !      [1]  Scire/Yamartino/Carmichael/Chang (1989),                         *
  !             CALGRID: A Mesoscale Photochemical Grid Model.                 *
  !             Vol II: User's Guide. (Report No.A049-1, June, 1989)           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! alpha            help variable                                             *
  ! cun              'slip-flow' correction after Cunningham                   *
  ! d01 [um]         upper diameter                                            *
  ! d02 [um]         lower diameter                                            *
  ! dc [m2/s]        coefficient of Brownian diffusion                         *
  ! delta            distance given in standard deviation units                *
  ! density [kg/m3]  density of the particle                                   *
  ! dmean            geometric mean diameter of interval                       *
  ! dquer [um]       geometric mass mean particle diameter                     *
  ! dsigma           e.g. dsigma=10 or dsigma=0.1 means that 68% of the mass   *
  !                  are between 0.1*dquer and 10*dquer                        *
  ! fract(ni)        mass fraction of each diameter interval                   *
  ! kn               Knudsen number                                            *
  ! ni               number of diameter intervals, for which deposition        *
  !                  is calculated                                             *
  ! schmidt          Schmidt number                                            *
  ! schmi            schmidt**2/3                                              *
  ! vsh [m/s]        gravitational settling velocity of the particle           *
  ! x01              normalized upper diameter                                 *
  ! x02              normalized lower diameter                                 *
  !                                                                            *
  ! Constants:                                                                 *
  ! g [m/s2]         Acceleration of gravity                                   *
  ! kb [J/K]         Stefan-Boltzmann constant                                 *
  ! lam [m]          mean free path of air molecules                           *
  ! myl [kg/m/s]     dynamical viscosity of air                                *
  ! nyl [m2/s]       kinematic viscosity of air                                *
  ! tr               reference temperature                                     *
  !                                                                            *
  ! Function:                                                                  *
  ! erf              calculates the integral of the Gauss function             *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real,parameter :: tr=293.15

  integer :: i,ni
  real :: dquer,dsigma,density,xdummy,d01,d02,delta,x01,x02
  real :: dmean,alpha,cun,dc,schmidt,kn,erf,fract_norm
  real,dimension(ni),intent(inout) :: fract,schmi,vsh
  real,parameter :: myl=1.81e-5,nyl=0.15e-4
  real,parameter :: lam=6.53e-8,kb=1.38e-23,eps=1.2e-38

  ! xdummy constant for all intervals
  !**********************************

  xdummy=sqrt(2.)*alog(dsigma)


  ! particles diameters are split up to ni intervals between
  ! dquer-3*dsigma and dquer+3*dsigma
  !*********************************************************
  ! Normalisation. Why was it not normalised?
  !******************************************
  x01=alog(dsigma**3)/xdummy
  x02=alog(dsigma**(-3))/xdummy
  fract_norm=0.5*(erf(x01)-erf(x02))

  delta=6./real(ni)

  d01=dquer*dsigma**(-3)
  do i=1,ni
    d02=d01
    d01=dquer*dsigma**(-3.+delta*real(i))
    x01=alog(d01/dquer)/xdummy
    x02=alog(d02/dquer)/xdummy
    !print*,'part0:: d02=' , d02 , 'd01=', d01

  ! Area under Gauss-function is calculated and gives mass fraction of interval
  !****************************************************************************

    fract(i)=0.5*(erf(x01)-erf(x02))/fract_norm
    !print*,'part0:: fract(',i,')', fract(i)
    !print*,'part0:: fract', fract(i), x01, x02, erf(x01), erf(x02)

  ! Geometric mean diameter of interval in [m]
  !*******************************************

    dmean=1.E-6*exp(0.5*alog(d01*d02))
    !print*,'part0:: dmean=', dmean

  ! Calculation of time independent parameters of each interval
  !************************************************************

    kn=2.*lam/dmean
    if ((-1.1/kn).le.log10(eps)*log(10.)) then
      alpha=1.257
    else
      alpha=1.257+0.4*exp(-1.1/kn)
    endif
    cun=1.+alpha*kn
    dc=kb*tr*cun/(3.*pi*myl*dmean)
    schmidt=nyl/dc
    schmi(i)=schmidt**(-2./3.)
    vsh(i)=ga*density*dmean*dmean*cun/(18.*myl)

    !print*,'part0:: vsh(',i,')', vsh(i)

  end do

  !stop 'part0' 
end subroutine part0

subroutine get_vdep_prob(itime,xt,yt,zt,tmpprob,ithread)
  !                    i     i  i  i  o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of the probability for dry deposition                         * 
  !                                                                            *
  !  Particle positions are read in - prob returned                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          time at which this subroutine is entered                *
  ! itimec [s]         actual time, which is incremented in this subroutine    *
  ! href [m]           height for which dry deposition velocity is calculated  *
  ! ldirect            1 forward, -1 backward                                  *
  ! ldt [s]            Time step for the next integration                      *
  ! lsynctime [s]      Synchronisation interval of FLEXPART                    *
  ! ngrid              index which grid is to be used                          *
  ! prob               probability of absorption due to dry deposition         *
  ! vdepo              Deposition velocities for all species                   *
  ! xt,yt,zt           Particle position                                       *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod
  use interpol_mod

  implicit none

  real,intent(in) :: xt,yt,zt
  integer,intent(in) :: itime,ithread !ithread starting at 1
  real,intent(out) :: tmpprob(maxspec)
  integer :: ks,m,memindnext!nix,njy,
  real :: vdepo(maxspec),vdeptemp(2)
  real :: eps

  eps=nxmax/3.e5

  if (DRYDEP) then    ! reset probability for deposition
    do ks=1,nspec
      depoindicator(ks,ithread)=.true.
      tmpprob(ks)=0.
    end do
  endif


  ! Determine whether lat/long grid or polarstereographic projection
  ! is to be used
  ! Furthermore, determine which nesting level to be used
  !*****************************************************************
  call find_ngrid(xt,yt)

  !***************************
  ! Interpolate necessary data
  !***************************

  if (abs(itime-memtime(1)).lt.abs(itime-memtime(2))) then
    memindnext=1
  else
    memindnext=2
  endif

  ! Determine nested grid coordinates
  !**********************************
  call find_grid_indices(xt,yt)

  ! Determine probability of deposition
  !************************************

  if ((DRYDEP).and.(real(zt).lt.2.*href)) then
    do ks=1,nspec
      if (DRYDEPSPEC(ks)) then
        if (depoindicator(ks,ithread)) then
          if (ngrid.le.0) then
            do m=1,2
              call hor_interpol(vdep,vdeptemp(m),ks,memind(m),maxspec)
            end do
          else
            do m=1,2
              call hor_interpol_nest(vdepn,vdeptemp(m),ks,memind(m),maxspec)
            end do
          endif
          call temporal_interpolation(vdeptemp(1),vdeptemp(2),vdepo(ks))
        endif
  ! correction by Petra Seibert, 10 April 2001
  !   this formulation means that prob(n) = 1 - f(0)*...*f(n)
  !   where f(n) is the exponential term
        tmpprob(ks)=vdepo(ks)
  !               prob(ks)=vdepo(ks)/2./href
  ! instead of prob - return vdepo -> result kg/m2/s
      endif
    end do
  endif
end subroutine get_vdep_prob

subroutine drydepo_probability(ipart,dt,zts,vdepo,ithread)
  use par_mod
  use com_mod
  use interpol_mod
  use particle_mod

  implicit none

  integer,intent(in) :: ithread ! OMP thread starting at 1
  integer,intent(in) :: ipart ! particle index
  real,intent(out) :: vdepo(maxspec)  ! deposition velocities for all species
  real,intent(in) :: dt,zts             ! real(ldt), real(zt)
  integer :: ns,m                      ! loop variable over species
  real :: vdeptemp(2)

  if (zts.lt.2.*href) then
    do ns=1,nspec
      if (DRYDEPSPEC(ns)) then
        if (depoindicator(ns,ithread)) then
          if (ngrid.le.0) then
            do m=1,2
              call hor_interpol(vdep,vdeptemp(m),ns,memind(m),maxspec)
            end do
          else
            do m=1,2
              call hor_interpol_nest(vdepn,vdeptemp(m),ns,memind(m),maxspec)
            end do
          endif
          call temporal_interpolation(vdeptemp(1),vdeptemp(2),vdepo(ns))
        endif
  ! correction by Petra Seibert, 10 April 2001
  !   this formulation means that prob(n) = 1 - f(0)*...*f(n)
  !   where f(n) is the exponential term
        prob(ipart,ns)=1.+(prob(ipart,ns)-1.)*exp(-vdepo(ns)*abs(dt)/(2.*href))
        !if (pp.eq.535) write(*,*) 'advance1', ks,dtt,p1,vdep(ix,jy,ks,1)
      endif
    end do
  endif
end subroutine drydepo_probability

subroutine getvdep(n,ix,jy,ust,temp,pa,L,gr,rh,rr,snow,vdepo)
  !                   i i  i   i   i   i  i i  i  i    i o
  !*****************************************************************************
  !                                                                            *
  !  This routine calculates the dry deposition velocities.                    *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     20 December 1996                                                       *
  !     Sabine Eckhardt, Jan 07                                                *
  !     if the latitude is negative: add half a year to the julian day         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! gr [W/m2]         global radiation                                         *
  ! L [m]             Obukhov length                                           *
  ! nyl               kinematic viscosity                                      *
  ! pa [Pa]           surface air pressure                                     *
  ! ra [s/m]          aerodynamic resistance                                   *
  ! raquer [s/m]      average aerodynamic resistance                           *
  ! rh [0-1]          relative humidity                                        *
  ! rhoa              density of the air                                       *
  ! rr [mm/h]         precipitation rate                                       *
  ! temp [K]          2m temperature                                           *
  ! tc [C]            2m temperature                                           *
  ! ust [m/s]         friction velocity                                        *
  ! snow [m of water equivalent] snow depth                                    *
  ! xlanduse          fractions of numclasS landuses for each model grid point *
  !                                                                            *
  !*****************************************************************************
  use date_mod
  
  implicit none

  integer :: yyyymmdd,hhmmss,yyyy,mmdd,n,lseason,i,j,ix,jy
  real :: vdepo(maxspec),vd,rb(maxspec),rc(maxspec),raquer,ylat
  real :: ra,ust,temp,tc,pa,L,gr,rh,rr,myl,nyl,rhoa,diffh2o,snow
  real :: slanduse(numclass)
  real,parameter :: eps=1.e-5
  real(kind=dp) :: jul

  ! Calculate month and determine the seasonal category
  !****************************************************

  jul=bdate+real(wftime(n),kind=dp)/86400._dp

  ylat=jy*dy+ylat0
  if (ylat.lt.0) then
      jul=jul+365.*0.5
  endif


  call caldate(jul,yyyymmdd,hhmmss)
  yyyy=yyyymmdd/10000
  mmdd=yyyymmdd-10000*yyyy

  if ((ylat.gt.-20).and.(ylat.lt.20)) then
     mmdd=600 ! summer
  endif

  if ((mmdd.ge.1201).or.(mmdd.le.301)) then
    lseason=4
  else if ((mmdd.ge.1101).or.(mmdd.le.331)) then
    lseason=3
  else if ((mmdd.ge.401).and.(mmdd.le.515)) then
    lseason=5
  else if ((mmdd.ge.516).and.(mmdd.le.915)) then
    lseason=1
  else
    lseason=2
  endif

  ! Calculate diffusivity of water vapor
  !************************************
  diffh2o=2.11e-5*(temp/273.15)**1.94*(101325/pa)

  ! Conversion of temperature from K to C
  !**************************************

  tc=temp-273.15

  ! Calculate dynamic viscosity
  !****************************

  ! Why is this different from the viscosity funtion???

  if (tc.lt.0) then
    myl=(1.718+0.0049*tc-1.2e-05*tc**2)*1.e-05
  else
    myl=(1.718+0.0049*tc)*1.e-05
  endif

  ! Calculate kinematic viscosity
  !******************************

  rhoa=pa/(287.*temp)
  nyl=myl/rhoa


  ! 0. Set all deposition velocities zero
  !**************************************

  do i=1,nspec
    vdepo(i)=0.
  end do


  ! 1. Compute surface layer resistances rb
  !****************************************

  call getrb(nspec,ust,nyl,diffh2o,reldiff,rb)

  ! change for snow
  do j=1,numclass
    if (snow.gt.0.001) then ! 10 mm
       if (j.eq.12) then
         slanduse(j)=1.
       else
         slanduse(j)=0.
       endif
    else
       slanduse(j)=xlanduse(ix,jy,j)
    endif
  end do

  raquer=0.
  do j=1,numclass            ! loop over all landuse classes

    if (slanduse(j).gt.eps)  then

  ! 2. Calculate aerodynamic resistance ra
  !***************************************
      if (DRYDEP.and.(j.eq.7)) then
        ra=raerod(L,ust,z0_drydep(ix,jy))
      else
        ra=raerod(L,ust,z0(j))
      endif
      raquer=raquer+ra*slanduse(j)

  ! 3. Calculate surface resistance for gases
  !******************************************

      call getrc(nspec,lseason,j,tc,gr,rh,rr,rc)

  ! 4. Calculate deposition velocities for gases and ...
  ! 5. ... sum deposition velocities for all landuse classes
  !*********************************************************

      do i=1,nspec
        if (reldiff(i).gt.0.) then
          if ((ra+rb(i)+rc(i)).gt.0.) then
            vd=1./(ra+rb(i)+rc(i))
          else
            vd=9.999
          endif
          vdepo(i)=vdepo(i)+vd*slanduse(j)
        endif
      end do
    endif
  end do


  ! 6. Calculate deposition velocities for particles
  !*************************************************

  call partdep(nspec,density,fract,schmi,vset,raquer,ust,nyl, &
    rhoa,vdepo)

  !if (debug_mode) then
  !  print*,'getvdep:188: vdepo=', vdepo
    !stop
  !endif

  ! 7. If no detailed parameterization available, take constant deposition
  !    velocity if that is available
  !***********************************************************************

  do i=1,nspec
    if ((reldiff(i).lt.0.).and.(density(i).lt.0.).and. &
         (dryvel(i).gt.0.)) then
      vdepo(i)=dryvel(i)
    endif
  end do
end subroutine getvdep

subroutine getvdep_nest(n,ix,jy,ust,temp,pa, &
       L,gr,rh,rr,snow,vdepo,lnest)
  !                   i i  i   i   i   i  i i  i  i    i o i
  !*****************************************************************************
  !                                                                            *
  !  This routine calculates the dry deposition velocities.                    *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     20 December 1996                                                       *
  !     Sabine Eckhardt, Jan 07                                                *
  !     if the latitude is negative: add half a year to the julian day         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! gr [W/m2]         global radiation                                         *
  ! L [m]             Obukhov length                                           *
  ! nyl               kinematic viscosity                                      *
  ! pa [Pa]           surface air pressure                                     *
  ! ra [s/m]          aerodynamic resistance                                   *
  ! raquer [s/m]      average aerodynamic resistance                           *
  ! rh [0-1]          relative humidity                                        *
  ! rhoa              density of the air                                       *
  ! rr [mm/h]         precipitation rate                                       *
  ! temp [K]          2m temperature                                           *
  ! tc [C]            2m temperature                                           *
  ! ust [m/s]         friction velocity                                        *
  ! snow [m of water equivalent] snow depth                                    *
  ! xlanduse          fractions of numclasS landuses for each model grid point *
  !                                                                            *
  !*****************************************************************************
  use date_mod

  implicit none

  integer :: yyyymmdd,hhmmss,yyyy,mmdd,n,lseason,i,j,ix,jy,lnest
  real :: vdepo(maxspec),vd,rb(maxspec),rc(maxspec),raquer,ylat
  real :: ra,ust,temp,tc,pa,L,gr,rh,rr,myl,nyl,rhoa,diffh2o,snow
  real :: slanduse(numclass)
  real,parameter :: eps=1.e-5
  real(kind=dp) :: jul

  ! Calculate month and determine the seasonal category
  !****************************************************

  jul=bdate+real(wftime(n),kind=dp)/86400._dp

  ylat=jy*dy+ylat0
  if (ylat.lt.0) then
      jul=jul+365.*0.5
  endif


  call caldate(jul,yyyymmdd,hhmmss)
  yyyy=yyyymmdd/10000
  mmdd=yyyymmdd-10000*yyyy

  if ((ylat.gt.-20).and.(ylat.lt.20)) then
     mmdd=600 ! summer
  endif

  if ((mmdd.ge.1201).or.(mmdd.le.301)) then
    lseason=4
  else if ((mmdd.ge.1101).or.(mmdd.le.331)) then
    lseason=3
  else if ((mmdd.ge.401).and.(mmdd.le.515)) then
    lseason=5
  else if ((mmdd.ge.516).and.(mmdd.le.915)) then
    lseason=1
  else
    lseason=2
  endif

  ! Calculate diffusivity of water vapor
  !************************************
  diffh2o=2.11e-5*(temp/273.15)**1.94*(101325/pa)

  ! Conversion of temperature from K to C
  !**************************************

  tc=temp-273.15

  ! Calculate dynamic viscosity
  !****************************

  if (tc.lt.0) then
    myl=(1.718+0.0049*tc-1.2e-05*tc**2)*1.e-05
  else
    myl=(1.718+0.0049*tc)*1.e-05
  endif

  ! Calculate kinematic viscosity
  !******************************

  rhoa=pa/(287.*temp)
  nyl=myl/rhoa


  ! 0. Set all deposition velocities zero
  !**************************************

  do i=1,nspec
    vdepo(i)=0.
  end do


  ! 1. Compute surface layer resistances rb
  !****************************************

  call getrb(nspec,ust,nyl,diffh2o,reldiff,rb)

  ! change for snow
  do j=1,numclass
    if (snow.gt.0.001) then ! 10 mm
       if (j.eq.12) then
         slanduse(j)=1.
       else
         slanduse(j)=0.
       endif
    else
       slanduse(j)=xlandusen(ix,jy,j,lnest)
    endif
  end do

  raquer=0.
  do j=1,numclass            ! loop over all landuse classes

    if (slanduse(j).gt.eps)  then

  ! 2. Calculate aerodynamic resistance ra
  !***************************************
      if (DRYDEP.and.(j.eq.7)) then
        ra=raerod(L,ust,z0_drydepn(ix,jy,lnest))
      else
        ra=raerod(L,ust,z0(j))
      endif
      raquer=raquer+ra*slanduse(j)

  ! 3. Calculate surface resistance for gases
  !******************************************

      call getrc(nspec,lseason,j,tc,gr,rh,rr,rc)

  ! 4. Calculate deposition velocities for gases and ...
  ! 5. ... sum deposition velocities for all landuse classes
  !*********************************************************

      do i=1,nspec
        if (reldiff(i).gt.0.) then
          if ((ra+rb(i)+rc(i)).gt.0.) then
            vd=1./(ra+rb(i)+rc(i))
  ! XXXXXXXXXXXXXXXXXXXXXXXXXX TEST
  !         vd=1./rc(i)
  ! XXXXXXXXXXXXXXXXXXXXXXXXXX TEST
          else
            vd=9.999
          endif
          vdepo(i)=vdepo(i)+vd*slanduse(j)
        endif
      end do
    endif
  end do


  ! 6. Calculate deposition velocities for particles
  !*************************************************

  call partdep(nspec,density,fract,schmi,vset,raquer,ust,nyl, &
    rhoa,vdepo)

  ! 7. If no detailed parameterization available, take constant deposition
  !    velocity if that is available
  !***********************************************************************

  do i=1,nspec
    if ((reldiff(i).lt.0.).and.(density(i).lt.0.).and. &
         (dryvel(i).gt.0.)) then
      vdepo(i)=dryvel(i)
    endif
  end do
end subroutine getvdep_nest

subroutine partdep(nc,density,fract,schmi,vset,ra,ustar,nyl,rhoa,vdep_tmp)
  !                   i     i      i     i    i   i    i    i  i, i, i/o
  !*****************************************************************************
  !                                                                            *
  !      Calculation of the dry deposition velocities of particles.            *
  !      This routine is based on Stokes' law for considering settling and     *
  !      assumes constant dynamic viscosity of the air.                        *
  !                                                                            *
  !     AUTHOR: Andreas Stohl, 12 November 1993                                *
  !                            Update: 20 December 1996                        *
  !                                                                            *
  !     Literature:                                                            *
  !     [1]  Hicks/Baldocchi/Meyers/Hosker/Matt (1987), A Preliminary          *
  !             Multiple Resistance Routine for Deriving Dry Deposition        *
  !             Velocities from Measured Quantities.                           *
  !             Water, Air and Soil Pollution 36 (1987), pp.311-330.           *
  !     [2]  Slinn (1982), Predictions for Particle Deposition to              *
  !             Vegetative Canopies. Atm.Env.16-7 (1982), pp.1785-1794.        *
  !     [3]  Slinn/Slinn (1980),  Predictions for Particle Deposition on       *
  !             Natural Waters. Atm.Env.14 (1980), pp.1013-1016.               *
  !     [4]  Scire/Yamartino/Carmichael/Chang (1989),                          *
  !             CALGRID: A Mesoscale Photochemical Grid Model.                 *
  !             Vol II: User's Guide. (Report No.A049-1, June, 1989)           *
  !     [5]  Langer M. (1992): Ein einfaches Modell zur Abschaetzung der       *
  !             Depositionsgeschwindigkeit von Teilchen und Gasen.             *
  !             Internal report.                                               *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! alpha                help variable                                         *
  ! fract(nc,ni)         mass fraction of each diameter interval               *
  ! lpdep(nc)            1 for particle deposition, 0 else                     *
  ! nc                   actual number of chemical components                  *
  ! ni                   number of diameter intervals, for which vdepj is calc.*
  ! rdp [s/m]            deposition layer resistance                           *
  ! ra [s/m]             aerodynamical resistance                              *
  ! schmi(nc,ni)         Schmidt number**2/3 of each diameter interval         *
  ! stokes               Stokes number                                         *
  ! ustar [m/s]          friction velocity                                     *
  ! vdep_tmp(nc) [m/s]       deposition velocities of all components               *
  ! vdepj [m/s]          help, deposition velocity of 1 interval               *
  ! vset(nc,ni)          gravitational settling velocity of each interval      *
  !                                                                            *
  ! Constants:                                                                 *
  ! nc                   number of chemical species                            *
  ! ni                   number of diameter intervals, for which deposition    *
  !                      is calculated                                         *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real, intent(in) ::       &
    nyl,                    & ! kinematic viscosity
    rhoa,                   & ! air density
    ustar,                  & ! friction velocity
    ra,                     & ! aerodynamical resistance
    vset(maxspec,maxndia),  & ! gravitational settling velocity of each interval
    density(maxspec),       & ! density of the particle
    fract(maxspec,maxndia)    ! mass fraction of each diameter interval
  real, intent(inout) ::    &
    vdep_tmp(maxspec)
  real :: schmi(maxspec,maxndia)
  real :: stokes,vdepj,rdp,alpha
  real :: & ! Variables related to shape
    dfdr, alpha1, beta1, ks, kn, c_d, &
    settling, settling_old, reynolds, kn1

  real,parameter :: eps=1.e-5
  integer :: ic,j,nc,i


  do ic=1,nc                  ! loop over all species
    if (density(ic).gt.0.) then
      do j=1,ndia(ic)         ! loop over all diameter intervals
        if (ustar.gt.eps) then          
          if (ishape(ic).eq.0) then

            reynolds=dquer(ic)/1.e6*vset(ic,j)/nyl
            settling_old=-1.0*vset(ic,j)

            do i=1,20

              if (reynolds.le.0.02) then
                c_d=(24.0/reynolds)

              else ! Clif and Gauvin scheme is used
                c_d=(24.0/reynolds)*(1+0.15*(reynolds**0.687))+ &
                  0.42/(1.0+42500.0/(reynolds**1.16))
              endif


            ! Settling velocity of a particle is defined by the Newton's impact law:
              settling=-1.* &
                      sqrt(4.*ga*dquer(ic)/1.e6*density(ic)*cunningham(ic)/ &
                      (3.*c_d*rhoa))

              if (abs((settling-settling_old)/settling).lt.0.01) exit     
              reynolds=dquer(ic)/1.e6*abs(settling)/nyl
              settling_old=settling
            end do
      
            ! Stokes number for each diameter interval
            !*****************************************
            ! Use this stokes number for different shapes
            stokes=abs(settling)/ga*ustar*ustar/nyl
            alpha=-3./stokes

            ! Deposition layer resistance
            !****************************

            if (alpha.le.log10(eps)) then
              rdp=1./(schmi(ic,j)*ustar)
            else
              rdp=1./((schmi(ic,j)+10.**alpha)*ustar)
            endif

            vdepj=abs(settling)+1./(ra+rdp+ra*rdp*abs(settling))

          else ! Daria Tatsii: Drag coefficient scheme by Bagheri & Bonadonna 2016
               ! Settling velocities of other shapes

            reynolds=dquer(ic)/1.e6*vset(ic,j)/nyl
            settling_old=-1.0*vset(ic,j)

            ! Orientation of particles
            !*************************
            if (orient(ic).eq.0) then
              ! Horizontal orientation
              ks=ks2(ic)  ! B&B Figure 12 k_(s,max)
              kn=kn2(ic)
            else if (orient(ic).eq.1) then 
              ! Random orientation
              dfdr=density(ic)/rhoa

              alpha1=0.45+10.0/(exp(2.5*log10(dfdr))+30.0)
              beta1=1.-37.0/(exp(3.0*log10(dfdr))+100.0)
              ks=ks1(ic)
              kn=10.**(alpha1*(-log10(Fn(ic)))**beta1)
            else
              ! The average of random and horizontal orientation
              dfdr=density(ic)/rhoa

              alpha1=0.45+10.0/(exp(2.5*log10(dfdr))+30.0)
              beta1=1.-37.0/(exp(3.0*log10(dfdr))+100.0)
              kn1=10.**(alpha1*(-log10(Fn(ic)))**beta1)
              ks=(ks1(ic)+ks2(ic))*0.5
              kn=(kn1+kn2(ic))*0.5
            endif

            do i=1,20
              c_d=(24.*ks/reynolds)*(1.+0.125*((reynolds*kn/ks)**(2./3.)))+ &
                (0.46*kn/(1.+5330./(reynolds*kn/ks)))

              ! Settling velocity of a particle is defined by the Newton's impact law:
              settling=-1.* &
                      sqrt(4.*ga*dquer(ic)/1.e6*density(ic)*cunningham(ic)/ &
                      (3.*c_d*rhoa))

              if (abs((settling-settling_old)/settling).lt.0.01) exit

              reynolds=dquer(ic)/1.e6*abs(settling)/nyl
              settling_old=settling
            end do
            ! We assume aerodynamic resistance ra and quasi-laminar sub-layer resistance rdp
            ! Stokes number for each diameter interval
            !*****************************************
            ! Use this stokes number for different shapes
            stokes=abs(settling)/ga*ustar*ustar/nyl
            alpha=-3./stokes

            ! Deposition layer resistance
            !****************************

            if (alpha.le.log10(eps)) then
              rdp=1./(schmi(ic,j)*ustar)
            else
              rdp=1./((schmi(ic,j)+10.**alpha)*ustar)
            endif
            
            
            vdepj=abs(settling)+1./(ra+rdp+ra*rdp*abs(settling))

          endif

        else
          vdepj=vset(ic,j)
        endif

        ! deposition velocities of each interval are weighted with mass fraction
        !***********************************************************************

        vdep_tmp(ic)=vdep_tmp(ic)+vdepj*fract(ic,j)
          
      end do
    endif
  end do

end subroutine partdep

subroutine getrb(nc,ustar,nyl,diffh2o,reldiff,rb)
  !                 i    i    i     i       i    o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of the quasilaminar sublayer resistance to dry deposition.    *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 20 May 1995                                    *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! rb(ncmax)       sublayer resistance                                        *
  ! schmidt         Schmidt number                                             *
  ! ustar [m/s]     friction velocity                                          *
  ! diffh20 [m2/s]  diffusivity of water vapor in air                          *
  ! reldiff         diffusivity relative to H2O                                *
  !                                                                            *
  ! Constants:                                                                 *
  ! karman          von Karman constant                                        *
  ! pr              Prandtl number                                             *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real :: ustar,diffh2o,rb(maxspec),schmidt,nyl
  real :: reldiff(maxspec)
  integer :: ic,nc
  real,parameter :: pr=0.72

  do ic=1,nc
    if (reldiff(ic).gt.0.) then
      schmidt=nyl/diffh2o*reldiff(ic)
      rb(ic)=2.0*(schmidt/pr)**0.67/(karman*ustar)
    endif
  end do
end subroutine getrb

subroutine getrc(nc,i,j,t,gr,rh,rr,rc)
  !                 i  i i i i  i  i  o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of the surface resistance according to the procedure given    *
  !  in:                                                                       *
  !  Wesely (1989): Parameterization of surface resistances to gaseous         *
  !  dry deposition in regional-scale numerical models.                        *
  !  Atmos. Environ. 23, 1293-1304.                                            *
  !                                                                            *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 19 May 1995                                    *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! reldiff(maxspec)  diffusivity of H2O/diffusivity of component i            *
  ! gr [W/m2]       global radiation                                           *
  ! i               index of seasonal category                                 *
  ! j               index of landuse class                                     *
  ! ldep(maxspec)          1, if deposition shall be calculated for species i  *
  ! nc                   actual number of chemical components                  *
  ! rcl(maxspec,5,8) [s/m] Lower canopy resistance                             *
  ! rgs(maxspec,5,8) [s/m] Ground resistance                                   *
  ! rlu(maxspec,5,8) [s/m] Leaf cuticular resistance                           *
  ! rm(maxspec) [s/m]      Mesophyll resistance                                *
  ! t [C]           temperature                                                *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: i,j,ic,nc
  real :: gr,rh,rr,t,rs,rsm,corr,rluc,rclc,rgsc,rdc,rluo
  real :: rc(maxspec)


  ! Compute stomatal resistance
  !****************************
  ! Sabine Eckhardt, Dec 06: use 1E25 instead of 99999. for infinite res.

  if ((t.gt.0.).and.(t.lt.40.)) then
    rs=ri(i,j)*(1.+(200./(gr+0.1))**2)*(400./(t*(40.-t)))
  else
    rs=1.E25
  !  rs=99999.
  endif


  ! Correct stomatal resistance for effect of dew and rain
  !*******************************************************

  if ((rh.gt.0.9).or.(rr.gt.0.)) rs=rs*3.

  ! Compute the lower canopy resistance
  !************************************

  rdc=100.*(1.+1000./(gr+10.))


  corr=1000.*exp(-1.*t-4.)
  do ic=1,nc
    if (reldiff(ic).gt.0.) then

  ! Compute combined stomatal and mesophyll resistance
  !***************************************************

      rsm=rs*reldiff(ic)+rm(ic)

  ! Correct leaf cuticular, lower canopy and ground resistance
  !***********************************************************

      rluc=rlu(ic,i,j)+corr
      rclc=rcl(ic,i,j)+corr
      rgsc=rgs(ic,i,j)+corr

  ! Correct leaf cuticular resistance for effect of dew and rain
  !*************************************************************

      if (rr.gt.0.) then
        rluo=1./(1./1000.+1./(3.*rluc))
        rluc=1./(1./(3.*rluc)+1.e-7*henry(ic)+f0(ic)/rluo)
      else if (rh.gt.0.9) then
        rluo=1./(1./3000.+1./(3.*rluc))
        rluc=1./(1./(3.*rluc)+1.e-7*henry(ic)+f0(ic)/rluo)
      endif

  ! Combine resistances to give total resistance
  !*********************************************

      rc(ic)=1./(1./rsm+1./rluc+1./(rdc+rclc)+1./(rac(i,j)+rgsc))
  ! Sabine Eckhardt, Dec 06: avoid possible excessively high vdep
      if (rc(ic).lt.10.) rc(ic)=10.
    endif
  end do
end subroutine getrc

end module drydepo_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine verttransform_nests(n,uuhn,vvhn,wwhn,pvhn)
  !                               i   i    i    i   i
  !*****************************************************************************
  !                                                                            *
  !     This subroutine transforms temperature, dew point temperature and      *
  !     wind components from eta to meter coordinates.                         *
  !     The vertical wind component is transformed from Pa/s to m/s using      *
  !     the conversion factor pinmconv.                                        *
  !     In addition, this routine calculates vertical density gradients        *
  !     needed for the parameterization of the turbulent velocities.           *
  !     It is similar to verttransform, but makes the transformations for      *
  !     the nested grids.                                                      *
  !                                                                            *
  !     Author: A. Stohl, G. Wotawa                                            *
  !                                                                            *
  !     12 August 1996                                                         *
  !     Update: 16 January 1998                                                *
  !                                                                            *
  !     Major update: 17 February 1999                                         *
  !     by G. Wotawa                                                           *
  !                                                                            *
  !     - Vertical levels for u, v and w are put together                      *
  !     - Slope correction for vertical velocity: Modification of calculation  *
  !       procedure                                                            *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:       (marked "C-cv")
  !   Variables tthn and qvhn (on eta coordinates) from common block
  !*****************************************************************************
  ! Sabine Eckhardt, March 2007
  ! add the variable cloud for use with scavenging - descr. in com_mod
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! nxn,nyn,nuvz,nwz                field dimensions in x,y and z direction    *
  ! uun                             wind components in x-direction [m/s]       *
  ! vvn                             wind components in y-direction [m/s]       *
  ! wwn                             wind components in z-direction [deltaeta/s]*
  ! ttn                             temperature [K]                            *
  ! pvn                             potential vorticity (pvu)                  *
  ! psn                             surface pressure [Pa]                      *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: ix,jy,kz,iz,n,l,kmin,kl,klp,ix1,jy1,ixp,jyp
  integer :: rain_cloud_above,kz_inv
  real :: f_qvsat,pressure,rh,lsp,convp
  real :: uvzlev(nuvzmax),wzlev(nwzmax),rhoh(nuvzmax),pinmconv(nzmax)
  real :: uvwzlev(0:nxmaxn-1,0:nymaxn-1,nzmax)
  real :: ew,pint,tv,tvold,pold,dz1,dz2,dz,ui,vi
  real :: dzdx,dzdy
  real :: dzdx1,dzdx2,dzdy1,dzdy2
  real :: uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: pvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: wwhn(0:nxmaxn-1,0:nymaxn-1,nwzmax,maxnests)
  real,parameter :: const=r_air/ga


  ! Loop over all nests
  !********************

  do l=1,numbnests

  ! Loop over the whole grid
  !*************************

  do jy=0,nyn(l)-1
    do ix=0,nxn(l)-1

      tvold=tt2n(ix,jy,1,n,l)*(1.+0.378*ew(td2n(ix,jy,1,n,l))/ &
           psn(ix,jy,1,n,l))
      pold=psn(ix,jy,1,n,l)
      uvzlev(1)=0.
      wzlev(1)=0.
      rhoh(1)=pold/(r_air*tvold)


  ! Compute heights of eta levels
  !******************************

      do kz=2,nuvz
        pint=akz(kz)+bkz(kz)*psn(ix,jy,1,n,l)
        tv=tthn(ix,jy,kz,n,l)*(1.+0.608*qvhn(ix,jy,kz,n,l))
        rhoh(kz)=pint/(r_air*tv)

        if (abs(tv-tvold).gt.0.2) then
          uvzlev(kz)=uvzlev(kz-1)+const*log(pold/pint)* &
               (tv-tvold)/log(tv/tvold)
        else
          uvzlev(kz)=uvzlev(kz-1)+const*log(pold/pint)*tv
        endif

        tvold=tv
        pold=pint
      end do


      do kz=2,nwz-1
        wzlev(kz)=(uvzlev(kz+1)+uvzlev(kz))/2.
      end do
      wzlev(nwz)=wzlev(nwz-1)+ &
           uvzlev(nuvz)-uvzlev(nuvz-1)

  ! NOTE: In FLEXPART versions up to 4.0, the number of model levels was doubled
  ! upon the transformation to z levels. In order to save computer memory, this is
  ! not done anymore in the standard version. However, this option can still be
  ! switched on by replacing the following lines with those below, that are
  ! currently commented out.
  ! Note that one change is also necessary in gridcheck.f,
  ! and three changes in verttransform.f
  !*****************************************************************************
      uvwzlev(ix,jy,1)=0.0
      do kz=2,nuvz
        uvwzlev(ix,jy,kz)=uvzlev(kz)
      end do

  ! Switch on following lines to use doubled vertical resolution
  ! Switch off the three lines above.
  !*************************************************************
  !22          uvwzlev(ix,jy,(kz-1)*2)=uvzlev(kz)
  !     do 23 kz=2,nwz
  !23          uvwzlev(ix,jy,(kz-1)*2+1)=wzlev(kz)
  ! End doubled vertical resolution

  ! pinmconv=(h2-h1)/(p2-p1)

      pinmconv(1)=(uvwzlev(ix,jy,2)-uvwzlev(ix,jy,1))/ &
           ((aknew(2)+bknew(2)*psn(ix,jy,1,n,l))- &
           (aknew(1)+bknew(1)*psn(ix,jy,1,n,l)))
      do kz=2,nz-1
        pinmconv(kz)=(uvwzlev(ix,jy,kz+1)-uvwzlev(ix,jy,kz-1))/ &
             ((aknew(kz+1)+bknew(kz+1)*psn(ix,jy,1,n,l))- &
             (aknew(kz-1)+bknew(kz-1)*psn(ix,jy,1,n,l)))
      end do
      pinmconv(nz)=(uvwzlev(ix,jy,nz)-uvwzlev(ix,jy,nz-1))/ &
           ((aknew(nz)+bknew(nz)*psn(ix,jy,1,n,l))- &
           (aknew(nz-1)+bknew(nz-1)*psn(ix,jy,1,n,l)))


  ! Levels, where u,v,t and q are given
  !************************************

      uun(ix,jy,1,n,l)=uuhn(ix,jy,1,l)
      vvn(ix,jy,1,n,l)=vvhn(ix,jy,1,l)
      ttn(ix,jy,1,n,l)=tthn(ix,jy,1,n,l)
      qvn(ix,jy,1,n,l)=qvhn(ix,jy,1,n,l)
      pvn(ix,jy,1,n,l)=pvhn(ix,jy,1,l)
      rhon(ix,jy,1,n,l)=rhoh(1)
      uun(ix,jy,nz,n,l)=uuhn(ix,jy,nuvz,l)
      vvn(ix,jy,nz,n,l)=vvhn(ix,jy,nuvz,l)
      ttn(ix,jy,nz,n,l)=tthn(ix,jy,nuvz,n,l)
      qvn(ix,jy,nz,n,l)=qvhn(ix,jy,nuvz,n,l)
      pvn(ix,jy,nz,n,l)=pvhn(ix,jy,nuvz,l)
      rhon(ix,jy,nz,n,l)=rhoh(nuvz)
      kmin=2
      do iz=2,nz-1
        do kz=kmin,nuvz
          if(height(iz).gt.uvzlev(nuvz)) then
            uun(ix,jy,iz,n,l)=uun(ix,jy,nz,n,l)
            vvn(ix,jy,iz,n,l)=vvn(ix,jy,nz,n,l)
            ttn(ix,jy,iz,n,l)=ttn(ix,jy,nz,n,l)
            qvn(ix,jy,iz,n,l)=qvn(ix,jy,nz,n,l)
            pvn(ix,jy,iz,n,l)=pvn(ix,jy,nz,n,l)
            rhon(ix,jy,iz,n,l)=rhon(ix,jy,nz,n,l)
            goto 30
          endif
          if ((height(iz).gt.uvzlev(kz-1)).and. &
               (height(iz).le.uvzlev(kz))) then
           dz1=height(iz)-uvzlev(kz-1)
           dz2=uvzlev(kz)-height(iz)
           dz=dz1+dz2
           uun(ix,jy,iz,n,l)=(uuhn(ix,jy,kz-1,l)*dz2+ &
                uuhn(ix,jy,kz,l)*dz1)/dz
           vvn(ix,jy,iz,n,l)=(vvhn(ix,jy,kz-1,l)*dz2+ &
                vvhn(ix,jy,kz,l)*dz1)/dz
           ttn(ix,jy,iz,n,l)=(tthn(ix,jy,kz-1,n,l)*dz2+ &
                tthn(ix,jy,kz,n,l)*dz1)/dz
           qvn(ix,jy,iz,n,l)=(qvhn(ix,jy,kz-1,n,l)*dz2+ &
                qvhn(ix,jy,kz,n,l)*dz1)/dz
           pvn(ix,jy,iz,n,l)=(pvhn(ix,jy,kz-1,l)*dz2+ &
                pvhn(ix,jy,kz,l)*dz1)/dz
           rhon(ix,jy,iz,n,l)=(rhoh(kz-1)*dz2+rhoh(kz)*dz1)/dz
           kmin=kz
           goto 30
          endif
        end do
30      continue
      end do


  ! Levels, where w is given
  !*************************

      wwn(ix,jy,1,n,l)=wwhn(ix,jy,1,l)*pinmconv(1)
      wwn(ix,jy,nz,n,l)=wwhn(ix,jy,nwz,l)*pinmconv(nz)
      kmin=2
      do iz=2,nz
        do kz=kmin,nwz
          if ((height(iz).gt.wzlev(kz-1)).and. &
               (height(iz).le.wzlev(kz))) then
           dz1=height(iz)-wzlev(kz-1)
           dz2=wzlev(kz)-height(iz)
           dz=dz1+dz2
           wwn(ix,jy,iz,n,l)=(wwhn(ix,jy,kz-1,l)*pinmconv(kz-1)*dz2 &
                +wwhn(ix,jy,kz,l)*pinmconv(kz)*dz1)/dz
           kmin=kz
           goto 40
          endif
        end do
40      continue
      end do

  ! Compute density gradients at intermediate levels
  !*************************************************

      drhodzn(ix,jy,1,n,l)=(rhon(ix,jy,2,n,l)-rhon(ix,jy,1,n,l))/ &
           (height(2)-height(1))
      do kz=2,nz-1
        drhodzn(ix,jy,kz,n,l)=(rhon(ix,jy,kz+1,n,l)- &
             rhon(ix,jy,kz-1,n,l))/(height(kz+1)-height(kz-1))
      end do
      drhodzn(ix,jy,nz,n,l)=drhodzn(ix,jy,nz-1,n,l)

    end do
  end do


  !****************************************************************
  ! Compute slope of eta levels in windward direction and resulting
  ! vertical wind correction
  !****************************************************************

  do jy=1,nyn(l)-2
    do ix=1,nxn(l)-2

      kmin=2
      do iz=2,nz-1

        ui=uun(ix,jy,iz,n,l)*dxconst*xresoln(l)/ &
             cos((real(jy)*dyn(l)+ylat0n(l))*pi180)
        vi=vvn(ix,jy,iz,n,l)*dyconst*yresoln(l)

        do kz=kmin,nz
          if ((height(iz).gt.uvwzlev(ix,jy,kz-1)).and. &
               (height(iz).le.uvwzlev(ix,jy,kz))) then
            dz1=height(iz)-uvwzlev(ix,jy,kz-1)
            dz2=uvwzlev(ix,jy,kz)-height(iz)
            dz=dz1+dz2
            kl=kz-1
            klp=kz
            kmin=kz
            goto 47
          endif
        end do

47      ix1=ix-1
        jy1=jy-1
        ixp=ix+1
        jyp=jy+1

        dzdx1=(uvwzlev(ixp,jy,kl)-uvwzlev(ix1,jy,kl))/2.
        dzdx2=(uvwzlev(ixp,jy,klp)-uvwzlev(ix1,jy,klp))/2.
        dzdx=(dzdx1*dz2+dzdx2*dz1)/dz

        dzdy1=(uvwzlev(ix,jyp,kl)-uvwzlev(ix,jy1,kl))/2.
        dzdy2=(uvwzlev(ix,jyp,klp)-uvwzlev(ix,jy1,klp))/2.
        dzdy=(dzdy1*dz2+dzdy2*dz1)/dz

        wwn(ix,jy,iz,n,l)=wwn(ix,jy,iz,n,l)+(dzdx*ui+dzdy*vi)

      end do

    end do
  end do


  !write (*,*) 'initializing nested cloudsn, n:',n
  !   create a cloud and rainout/washout field, cloudsn occur where rh>80%
  do jy=0,nyn(l)-1
    do ix=0,nxn(l)-1
      rain_cloud_above=0
      lsp=lsprecn(ix,jy,1,n,l)
      convp=convprecn(ix,jy,1,n,l)
      cloudsnh(ix,jy,n,l)=0
      do kz_inv=1,nz-1
         kz=nz-kz_inv+1
         pressure=rhon(ix,jy,kz,n,l)*r_air*ttn(ix,jy,kz,n,l)
         rh=qvn(ix,jy,kz,n,l)/f_qvsat(pressure,ttn(ix,jy,kz,n,l))
         cloudsn(ix,jy,kz,n,l)=0
         if (rh.gt.0.8) then ! in cloud
            if ((lsp.gt.0.01).or.(convp.gt.0.01)) then
               rain_cloud_above=1
               cloudsnh(ix,jy,n,l)=cloudsnh(ix,jy,n,l)+ &
                    height(kz)-height(kz-1)
               if (lsp.ge.convp) then
                  cloudsn(ix,jy,kz,n,l)=3 ! lsp dominated rainout
               else
                  cloudsn(ix,jy,kz,n,l)=2 ! convp dominated rainout
               endif
            else ! no precipitation
                  cloudsn(ix,jy,kz,n,l)=1 ! cloud
            endif
         else ! no cloud
            if (rain_cloud_above.eq.1) then ! scavenging
               if (lsp.ge.convp) then
                  cloudsn(ix,jy,kz,n,l)=5 ! lsp dominated washout
               else
                  cloudsn(ix,jy,kz,n,l)=4 ! convp dominated washout
               endif
            endif
         endif
      end do
    end do
  end do

  end do

end subroutine verttransform_nests

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

! Changes to the routines by A. Stohl
! xi,xi0,eta,eta0 are double precision variables to avoid problems
! at poles

module cmapf_mod

  use par_mod, only: dp

  implicit none
  private

  public :: cc2gll, cll2xy, cgszll, cxy2ll, stlmbr, stcm2p

  real,parameter :: rearth=6371.2, almst1=.9999999

  real,parameter :: pi=3.14159265358979
  real,parameter :: radpdg=pi/180., dgprad=180./pi

contains

subroutine cc2gll (strcmp, xlat,xlong, ue,vn, ug,vg)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  use par_mod, only: dp

  implicit none

  real :: strcmp(9), xlat, xlong, ue, vn, ug, vg,xpolg,ypolg

  real(kind=dp) :: along,slong,clong,rot

  along = cspanf( xlong - strcmp(2), -180., 180.)
  if (xlat.gt.89.985) then
  !*  North polar meteorological orientation: "north" along prime meridian
    rot = - strcmp(1) * along + xlong - 180.
  elseif (xlat.lt.-89.985) then
  !*  South polar meteorological orientation: "north" along prime meridian
    rot = - strcmp(1) * along - xlong
  else
    rot = - strcmp(1) * along
  endif
  slong = sin( radpdg * rot )
  clong = cos( radpdg * rot )
  xpolg = real(slong * strcmp(5) + clong * strcmp(6))
  ypolg = real(clong * strcmp(5) - slong * strcmp(6))
  ug = ypolg * ue + xpolg * vn
  vg = ypolg * vn - xpolg * ue
  return
end subroutine cc2gll

! subroutine ccrvll (strcmp, xlat,xlong, gx,gy)
!   !*  Written on 9/20/94 by Dr. Albion Taylor  NOAA / OAR / ARL

!   use par_mod, only: dp

!   implicit none

!   real(kind=dp) :: xpolg,ypolg,temp,along,slong,clong,ctemp, curv
!   real :: strcmp(9), xlat, xlong, gx, gy

!   along = cspanf( xlong - strcmp(2), -180., 180.)
!   slong = sin( radpdg * strcmp(1) * along)
!   clong = cos( radpdg * strcmp(1) * along)
!   xpolg = - slong * strcmp(5) + clong * strcmp(6)
!   ypolg = clong * strcmp(5) + slong * strcmp(6)
!   temp = sin(radpdg * xlat)
!   ctemp = cos(radpdg * xlat)
!   curv = (strcmp(1) - temp) / ctemp / rearth
!   gx = real(curv * xpolg)
!   gy = real(curv * ypolg)
!   return
! end subroutine ccrvll

! subroutine ccrvxy (strcmp, x,y, gx,gy)
!   !*  Written on 9/20/94 by Dr. Albion Taylor  NOAA / OAR / ARL

!   use par_mod, only: dp

!   implicit none

!   real :: strcmp(9), x, y, gx, gy
!   real(kind=dp) :: xpolg,ypolg,temp,ymerc,efact,curv

!   temp = strcmp(1) * strcmp(7) /rearth
!   xpolg = strcmp(6) + temp * (strcmp(3) - x)
!   ypolg = strcmp(5) + temp * (strcmp(4) - y)
!   temp = sqrt ( xpolg ** 2 + ypolg ** 2 )
!   if (temp.gt.0.) then
!     ymerc = - log( temp) /strcmp(1)
!     efact = exp(ymerc)
!     curv = ( (strcmp(1) - 1.d0) * efact + &
!          (strcmp(1) + 1.d0) / efact ) &
!          * .5d0 / rearth
!     gx = real(xpolg * curv / temp)
!     gy = real(ypolg * curv / temp)
!   else
!     if (abs(strcmp(1)) .eq. 1.) then
!       gx = 0.
!       gy = 0.
!     else
!       gx = 1./rearth
!       gy = 1./rearth
!     endif
!   endif
!   return
! end subroutine ccrvxy

! subroutine cg2cll (strcmp, xlat,xlong, ug,vg, ue,vn)
!   !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

!   use par_mod, only: dp

!   implicit none

!   real(kind=dp) :: xpolg,ypolg,along,slong,clong,rot
!   real :: strcmp(9), xlat, xlong, ug, vg, ue, vn

!   along = cspanf( xlong - strcmp(2), -180., 180.)
!   if (xlat.gt.89.985) then
!   !*  North polar meteorological orientation: "north" along prime meridian
!     rot = - strcmp(1) * along + xlong - 180.
!   elseif (xlat.lt.-89.985) then
!   !*  South polar meteorological orientation: "north" along prime meridian
!     rot = - strcmp(1) * along - xlong
!   else
!     rot = - strcmp(1) * along
!   endif
!   slong = sin( radpdg * rot )
!   clong = cos( radpdg * rot )
!   xpolg = slong * strcmp(5) + clong * strcmp(6)
!   ypolg = clong * strcmp(5) - slong * strcmp(6)
!   ue = real(ypolg) * ug - real(xpolg) * vg
!   vn = real(ypolg) * vg + real(xpolg) * ug
!   return
! end subroutine cg2cll

! subroutine cg2cxy (strcmp, x,y, ug,vg, ue,vn)
!   !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

!   use par_mod, only: dp

!   implicit none

!   real :: strcmp(9) , x, y, ug, vg, ue, vn

!   real :: clong, radial, rot, slong, xlat, xlong
!   real(kind=dp) :: xpolg,ypolg,temp,xi0,eta0,xi,eta

!   xi0 = ( x - strcmp(3) ) * strcmp(7) / rearth
!   eta0 = ( y - strcmp(4) ) * strcmp(7) /rearth
!   xi = xi0 * strcmp(5) - eta0 * strcmp(6)
!   eta = eta0 * strcmp(5) + xi0 * strcmp(6)
!   radial = real(2. * eta - strcmp(1) * (xi*xi + eta*eta))
!   if (radial.gt.strcmp(8)) then
!   !*  Case north of 89 degrees. Meteorological wind direction definition
!   !*      changes.
!     call cnxyll(strcmp, xi,eta, xlat,xlong)
!   !*  North polar meteorological orientation: "north" along prime meridian
!     rot = strcmp(1) * (xlong - strcmp(2)) - xlong - 180.
!     slong = - sin( radpdg * rot )
!     clong = cos( radpdg * rot )
!     xpolg = slong * strcmp(5) + clong * strcmp(6)
!     ypolg = clong * strcmp(5) - slong * strcmp(6)
!   else if (radial.lt.strcmp(9)) then
!   !*  Case south of -89 degrees. Meteorological wind direction definition
!   !*      changes.
!     call cnxyll(strcmp, xi,eta, xlat,xlong)
!   !*  South polar meteorological orientation: "north" along prime meridian
!     rot = strcmp(1) * (xlong - strcmp(2)) + xlong
!     slong = - sin( radpdg * rot )
!     clong = cos( radpdg * rot )
!     xpolg = slong * strcmp(5) + clong * strcmp(6)
!     ypolg = clong * strcmp(5) - slong * strcmp(6)
!   else
!   !* Normal case. Meteorological direction of wind related to true north.
!     xpolg = strcmp(6) - strcmp(1) * xi0
!     ypolg = strcmp(5) - strcmp(1) * eta0
!     temp = sqrt ( xpolg ** 2 + ypolg ** 2 )
!     xpolg = xpolg / temp
!     ypolg = ypolg / temp
!   end if
!   ue = ( real(ypolg) * ug - real(xpolg) * vg )
!   vn = ( real(ypolg) * vg + real(xpolg) * ug )
!   return
! end subroutine cg2cxy

real function cgszll (strcmp, xlat)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  use par_mod, only: dp

  implicit none

  real :: strcmp(9), xlat

  real(kind=dp) :: slat,ymerc,efact

  if (xlat .gt. 89.985) then
  !* Close to north pole
    if (strcmp(1) .gt. 0.9999) then
  !* and to gamma == 1.
      cgszll = 2. * strcmp(7)
      return
    endif
    efact = cos(radpdg * xlat)
    if (efact .le. 0.) then
      cgszll = 0.
      return
    else
      ymerc = - log( efact /(1. + sin(radpdg * xlat)))
    endif
  else if (xlat .lt. -89.985) then
  !* Close to south pole
    if (strcmp(1) .lt. -0.9999) then
  !* and to gamma == -1.0
      cgszll = 2. * strcmp(7)
      return
    endif
    efact = cos(radpdg * xlat)
    if (efact .le. 0.) then
      cgszll = 0.
      return
    else
      ymerc = log( efact /(1. - sin(radpdg * xlat)))
    endif
  else
  slat = sin(radpdg * xlat)
  ymerc = log((1. + slat) / (1. - slat))*0.5
  !efact = exp(ymerc)
  !cgszll = 2. * strcmp(7) * exp (strcmp(1) * ymerc)
  !c             / (efact + 1./efact)
  endif
  cgszll = strcmp(7) * cos(radpdg * xlat) * exp(strcmp(1) *real(ymerc))
  return
end function cgszll

real function cgszxy (strcmp, x,y)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  use par_mod, only: dp

  implicit none

  real :: strcmp(9) , x, y
  real(kind=dp) :: ymerc,efact, radial, temp
  real(kind=dp) :: xi0,eta0,xi,eta


  xi0 = ( x - strcmp(3) ) * strcmp(7) / rearth
  eta0 = ( y - strcmp(4) ) * strcmp(7) /rearth
  xi = xi0 * strcmp(5) - eta0 * strcmp(6)
  eta = eta0 * strcmp(5) + xi0 * strcmp(6)
  radial = 2. * eta - strcmp(1) * (xi*xi + eta*eta)
  efact = strcmp(1) * radial
  if (efact .gt. almst1) then
    if (strcmp(1).gt.almst1) then
      cgszxy = 2. * strcmp(7)
    else
      cgszxy = 0.
    endif
    return
  endif
  if (abs(efact) .lt. 1.e-2) then
    temp = (efact / (2. - efact) )**2
    ymerc = radial / (2. - efact) * (1.    + temp * &
         (1./3. + temp * &
         (1./5. + temp * &
         (1./7. ))))
  else
    ymerc = - log( 1. - efact ) *0.5 /strcmp(1)
  endif
  if (ymerc .gt. 6.) then
    if (strcmp(1) .gt. almst1) then
      cgszxy = 2. * strcmp(7)
    else
      cgszxy = 0.
    endif
  else if (ymerc .lt. -6.) then
    if (strcmp(1) .lt. -almst1) then
      cgszxy = 2. * strcmp(7)
    else
      cgszxy = 0.
    endif
  else
    efact = exp(ymerc)
    cgszxy = 2. * strcmp(7) * exp (strcmp(1) * real(ymerc)) &
         / real(efact + 1./efact)
  endif
  return
end function cgszxy

subroutine cll2xy (strcmp, xlat,xlong, x,y)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  implicit none

  real :: strcmp(9) , xlat, xlong, x, y, xi, eta

  call cnllxy(strcmp, xlat,xlong, xi,eta)
  x = strcmp(3) + rearth/strcmp(7) * &
       (xi * strcmp(5) + eta * strcmp(6) )
  y = strcmp(4) + rearth/strcmp(7) * &
       (eta * strcmp(5) - xi * strcmp(6) )
  return
end subroutine cll2xy

subroutine cnllxy (strcmp, xlat,xlong, xi,eta)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL
  !  main transformation routine from latitude-longitude to
  !  canonical (equator-centered, radian unit) coordinates

  use par_mod, only: dp

  implicit none

  real :: strcmp(9), xlat, xlong, xi, eta, &
       gdlong, sndgam, csdgam, rhog1, gamma, dlong
  real(kind=dp) :: dlat,slat,mercy,gmercy

  gamma = real(strcmp(1))
  dlat = xlat
  dlong = real(cspanf(xlong - strcmp(2), -180., 180.))
  dlong = dlong * radpdg
  gdlong = gamma * real(dlong)
  if (abs(gdlong) .lt. .01) then
  !  Code for gamma small or zero.  This avoids round-off error or divide-
  !  by zero in the case of mercator or near-mercator projections.
    gdlong = gdlong * gdlong
    sndgam = dlong * (1. - 1./6. * gdlong * &
         (1. - 1./20. * gdlong * &
         (1. - 1./42. * gdlong )))
    csdgam = dlong * dlong * .5 * &
         (1. - 1./12. * gdlong * &
         (1. - 1./30. * gdlong * &
         (1. - 1./56. * gdlong )))
  else
  ! Code for moderate values of gamma
    sndgam = sin (gdlong) /gamma
    csdgam = (1. - cos(gdlong) )/gamma /gamma
  endif
  slat = sin(radpdg * dlat)
  if ((slat .ge. almst1) .or. (slat .le. -almst1)) then
    eta = 1./strcmp(1)
    xi = 0.
    return
  endif
  mercy = .5 * log( (1. + slat) / (1. - slat) )
  gmercy = gamma * mercy
  if (abs(gmercy) .lt. .001) then
  !  Code for gamma small or zero.  This avoids round-off error or divide-
  !  by zero in the case of mercator or near-mercator projections.
    rhog1 = real( mercy * (1. - .5 * gmercy * &
         (1. - 1./3. * gmercy * &
         (1. - 1./4. * gmercy ) ) ) )
  else
  ! Code for moderate values of gamma
    rhog1 = (1. - real(exp(-gmercy))) / gamma
  endif
  eta = rhog1 + (1. - gamma * rhog1) * gamma * csdgam
  xi = (1. - gamma * rhog1 ) * sndgam
end subroutine cnllxy

subroutine cnxyll (strcmp, xi,eta, xlat,xlong)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL
  !  main transformation routine from canonical (equator-centered,
  !  radian unit) coordinates

  use par_mod, only: dp

  implicit none

  real :: strcmp(9), xlat, xlong !, odist
  real(kind=dp) :: gamma,temp,arg1,arg2,ymerc,along,gxi,cgeta
  real(kind=dp) :: xi,eta

  gamma = strcmp(1)
  !  Calculate equivalent mercator coordinate
  !odist = xi*xi + eta*eta
  arg2 = 2. * eta - gamma * (xi*xi + eta*eta)
  arg1 = gamma * arg2
  ! Change by A. Stohl to avoid problems close to the poles
  ! if (arg1 .ge. almst1) then
  !  distance to north (or south) pole is zero (or imaginary ;) )
  ! xlat = sign(90.,strcmp(1))
  ! xlong = strcmp(2)
  ! return
  ! endif
  if (abs(arg1) .lt. .01) then
  !  Code for gamma small or zero.  This avoids round-off error or divide-
  !  by zero in the case of mercator or near-mercator projections.
    temp = (arg1 / (2. - arg1) )**2
    ymerc = arg2 / (2. - arg1) * (1.    + temp * &
         (1./3. + temp * &
         (1./5. + temp * &
         (1./7. ))))
  else
  ! Code for moderate values of gamma
    ymerc = - log ( 1. - arg1 ) *0.5 / gamma
  endif
  ! Convert ymerc to latitude
  temp = exp( - abs(ymerc) )
  xlat = real(sign(atan2((1. - temp) * (1. + temp), 2. * temp), ymerc))
  ! Find longitudes
  gxi = gamma*xi
  cgeta = 1. - gamma * eta
  if ( abs(gxi) .lt. .01*cgeta ) then
  !  Code for gamma small or zero.  This avoids round-off error or divide-
  !  by zero in the case of mercator or near-mercator projections.
    temp = ( gxi /cgeta )**2
    along = xi / cgeta * (1.    - temp * &
         (1./3. - temp * &
         (1./5. - temp * &
         (1./7.   ))))
  else
  ! Code for moderate values of gamma
    along = atan2( gxi, cgeta) / gamma
  endif
  xlong = sngl(strcmp(2) + dgprad * along)
  xlat = xlat * dgprad
  return
end subroutine cnxyll

! subroutine cpolll (strcmp, xlat,xlong, enx,eny,enz)
!   !*  Written on 11/23/94 by Dr. Albion Taylor  NOAA / OAR / ARL

!   use par_mod, only: dp

!   implicit none

!   real(kind=dp) :: xpolg,ypolg,along,slong,clong,rot
!   real :: strcmp(9), xlat, xlong, enx, eny, enz, clat

!   along = cspanf( xlong - strcmp(2), -180., 180.)
!   rot = - strcmp(1) * along
!   slong = sin( radpdg * rot )
!   clong = cos( radpdg * rot )
!   xpolg = slong * strcmp(5) + clong * strcmp(6)
!   ypolg = clong * strcmp(5) - slong * strcmp(6)
!   clat = cos(radpdg * xlat)
!   enx = clat * real(xpolg)
!   eny = clat * real(ypolg)
!   enz = sin(radpdg * xlat)
!   return
! end subroutine cpolll

! subroutine cpolxy (strcmp, x,y, enx,eny,enz)
!   !*  Written on 11/26/94 by Dr. Albion Taylor  NOAA / OAR / ARL

!   use par_mod, only: dp

!   implicit none

!   real :: strcmp(9) , x, y, enx, eny, enz
!   real(kind=dp) :: xpol,ypol,temp,xi0,eta0,xi,eta,radial
!   real(kind=dp) :: temp2,ymerc,arg,oarg,clat

!   xi0 = ( x - strcmp(3) ) * strcmp(7) / rearth
!   eta0 = ( y - strcmp(4) ) * strcmp(7) /rearth
!   xi = xi0 * strcmp(5) - eta0 * strcmp(6)
!   eta = eta0 * strcmp(5) + xi0 * strcmp(6)
!   radial = 2. * eta -  strcmp(1) * (xi*xi + eta*eta)
!   temp = strcmp(1) * radial
!   if (temp .ge. 1.) then
!     enx = 0.
!     eny = 0.
!     enz = sign(1.,strcmp(1))
!     return
!   endif
!   if (abs(temp).lt.1.e-2) then
!     temp2 = (temp / (2. - temp))**2
!     ymerc = radial / (2. - temp) * (1. + temp2 * &
!          (1./3. + temp2 * &
!          (1./5. + temp2 * &
!          (1./7.))))
!   else
!     ymerc = -.5 * log(1. - temp) / strcmp(1)
!   endif
!   arg = exp( ymerc )
!   oarg = 1./arg
!   clat = 2./(arg + oarg)
!   enz = real((arg - oarg) * clat /2.)
!   temp = clat / sqrt(1. - temp)
!   xpol = - xi * strcmp(1) * temp
!   ypol = (1. - eta * strcmp(1) ) * temp
!   enx = real(xpol * strcmp(5) + ypol * strcmp(6))
!   eny = ypol * strcmp(5) - xpol * strcmp(6)
!   return
! end subroutine cpolxy

real function cspanf (value, begin, end)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL
  !* real function cspanf returns a value in the interval (begin,end]
  !* which is equivalent to value, mod (end - begin).  It is used to
  !* reduce periodic variables to a standard range.  It adjusts for the
  !* behavior of the mod function which provides positive results for
  !* positive input, and negative results for negative input
  !* input:
  !*       value - real number to be reduced to the span
  !*       begin - first value of the span
  !*       end   - last value of the span
  !* returns:
  !*       the reduced value
  !* examples:
  !*      along = cspanf(xlong, -180., +180.)
  !*      dir  = cspanf(angle, 0., 360.)

  implicit none

  real :: first,last, value, begin, end, val

  first = min(begin,end)
  last = max(begin,end)
  val = mod( value - first , last - first)
  if ( val .le. 0.) then
    cspanf = val + last
  else
    cspanf = val + first
  endif
  return
end function cspanf

subroutine cxy2ll (strcmp, x,y, xlat,xlong)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  use par_mod, only: dp

  implicit none

  real(kind=dp) :: xi0,eta0,xi,eta
  real :: strcmp(9), x, y, xlat, xlong

  xi0 = ( x - strcmp(3) ) * strcmp(7) / rearth
  eta0 = ( y - strcmp(4) ) * strcmp(7) /rearth
  xi = xi0 * strcmp(5) - eta0 * strcmp(6)
  eta = eta0 * strcmp(5) + xi0 * strcmp(6)
  call cnxyll(strcmp, xi,eta, xlat,xlong)
  xlong = cspanf(xlong, -180., 180.)
  return
end subroutine cxy2ll

real function eqvlat (xlat1,xlat2)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  implicit none

  real :: xlat1, xlat2, x, ssind, sinl1, sinl2, al1, al2, tau

  ssind(x) = sin (radpdg*x)
  sinl1 = ssind (xlat1)
  sinl2 = ssind (xlat2)
  if (abs(sinl1 - sinl2) .gt. .001) then
    al1 = log((1. - sinl1)/(1. - sinl2))
    al2 = log((1. + sinl1)/(1. + sinl2))
  else
  !  Case lat1 near or equal to lat2
    tau = - (sinl1 - sinl2)/(2. - sinl1 - sinl2)
    tau = tau*tau
    al1  = 2. / (2. - sinl1 - sinl2) * (1.    + tau * &
         (1./3. + tau * &
         (1./5. + tau * &
         (1./7.))))
    tau =   (sinl1 - sinl2)/(2. + sinl1 + sinl2)
    tau = tau*tau
    al2  = -2. / (2. + sinl1 + sinl2) * (1.    + tau * &
         (1./3. + tau * &
         (1./5. + tau * &
         (1./7.))))
  endif
  eqvlat = asin((al1 + al2) / (al1 - al2))/radpdg
  return
end function eqvlat

! subroutine stcm1p(strcmp, x1,y1, xlat1,xlong1, &
!        xlatg,xlongg, gridsz, orient)
!   !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

!   implicit none

!   integer :: k
!   real :: strcmp(9), x1, y1, xlat1, xlong1, turn, orient, &
!        xlatg, xlongg, gridsz, x1a, y1a

!   do k=3,4
!     strcmp (k) = 0.
!   enddo
!     turn = radpdg * (orient - strcmp(1) * &
!          cspanf(xlongg - strcmp(2), -180., 180.) )
!   strcmp (5) = cos (turn)
!   strcmp (6) = - sin (turn)
!   strcmp (7) = 1.
!   strcmp (7) = gridsz * strcmp(7) &
!        / cgszll(strcmp, xlatg)
!   call cll2xy (strcmp, xlat1,xlong1, x1a,y1a)
!   strcmp(3) = strcmp(3) + x1 - x1a
!   strcmp(4) = strcmp(4) + y1 - y1a
!   return
! end subroutine stcm1p

subroutine stcm2p(strcmp, x1,y1, xlat1,xlong1, &
       x2,y2, xlat2,xlong2)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  implicit none

  real :: strcmp(9), x1, y1, xlat1, xlong1, &
       x2, y2, xlat2, xlong2

  integer :: k
  real    :: x1a, y1a, x2a, y2a, den, dena

  do k=3,6
    strcmp (k) = 0.
  enddo
  strcmp (5) = 1.
  strcmp (7) = 1.
  call cll2xy (strcmp, xlat1,xlong1, x1a,y1a)
  call cll2xy (strcmp, xlat2,xlong2, x2a,y2a)
  den = sqrt( (x1 - x2)**2 + (y1 - y2)**2 )
  dena = sqrt( (x1a - x2a)**2 + (y1a - y2a)**2 )
  strcmp(5) = ((x1a - x2a)*(x1 - x2) + (y1a - y2a) * (y1 - y2)) &
       /den /dena
  strcmp(6) = ((y1a - y2a)*(x1 - x2) - (x1a - x2a) * (y1 - y2)) &
       /den /dena
  strcmp (7) = strcmp(7) * dena / den
  call cll2xy (strcmp, xlat1,xlong1, x1a,y1a)
  strcmp(3) = strcmp(3) + x1 - x1a
  strcmp(4) = strcmp(4) + y1 - y1a
  return
end subroutine stcm2p

!*  General conformal map routines for meteorological modelers
!*  written on 3/31/94 by

!* Dr. Albion Taylor
!* NOAA / OAR / ARL                  phone: (301) 713-0295 x 132
!* rm. 3151, 1315 east-west highway  fax:   (301) 713-0119
!* silver spring, md 20910           e-mail: adtaylor@arlrisc.ssmc.noaa.gov

!*  subroutine stlmbr (strcmp, tnglat, clong)
!*    This routine initializes the map structure array strcmp to
!*    the form of a specific map projection
!*  inputs:
!*    tnglat - the latitude at which the projection will be tangent
!*             to the earth.  +90. For north polar stereographic,
!*             -90. for south polar stereographic, 0. For mercator,
!*             and other values for lambert conformal.
!*             -90 <= tnglat <= 90.
!*    clong -  a longitude in the region under consideration.  Longitudes
!*             between clong-180. and clong+180.  Will be mapped in one
!*             connected region
!*  outputs:
!*    strcmp - a 9-value map structure array for use with subsequent
!*             calls to the coordinate transform routines.
!*
!*  real function eqvlat (xlat1,xlat2)
!*    This function is provided to assist in finding the tangent latitude
!*    equivalent to the 2-reference latitude specification in the legend
!*    of most lambert conformal maps.  If the map specifies "scale
!*    1:xxxxx true at 40n and 60n", then eqvlat(40.,60.) will return the
!*    equivalent tangent latitude.
!*  inputs:
!*    xlat1,xlat2:  the two latitudes specified in the map legend
!*  returns:
!*    the equivalent tangent latitude
!*  example:  call stlmbr(strcmp, eqvlat(40.,60.), 90.)

!*  subroutine stcm2p (strcmp, x1,y1, xlat1,xlong1,
!*          x2,y2, xlat2,xlong2)
!*  subroutine stcm1p (strcmp, x1,y1, xlat1,xlong1,
!*          xlatg,xlongg, gridsz, orient)
!*    These routines complete the specification of the map structure
!*    array by conforming the map coordinates to the specifications
!*    of a particular grid.  Either stcm1p or stcm2p must be called,
!*    but not both
!*  inputs:
!*    strcmp - a 9-value map structure array, set to a particular map
!*             form by a previous call to stlmbr
!*    for stcm2p:
!*      x1,y1, x2,y2 - the map coordinates of two points on the grid
!*      xlat1,xlong1, xlat2,xlong2 - the geographic coordinates of the
!*             same two points
!*    for stcm1p:
!*      x1,y1 - the map coordinates of one point on the grid
!*      xlat1,xlong1 - the geographic coordinates of the same point
!*      xlatg,xlongg - latitude and longitude of reference point for
!*             gridsz and orientation specification.
!*      gridsz - the desired grid size in kilometers, at xlatg,xlongg
!*      orient - the angle, with respect to north, of a y-grid line, at
!*             the point xlatg,xlongg
!*  outputs:
!*    strcmp - a 9-value map structure array, fully set for use by
!*             other subroutines in this system

!*  subroutine cll2xy (strcmp, xlat,xlong, x,y)
!*  subroutine cxy2ll (strcmp, x,y, xlat,xlong)
!*     these routines convert between map coordinates x,y
!*     and geographic coordinates xlat,xlong
!*  inputs:
!*     strcmp(9) - 9-value map structure array
!*     for cll2xy:  xlat,xlong - geographic coordinates
!*     for cxy2ll:  x,y - map coordinates
!*  outputs:
!*     for cll2xy:  x,y - map coordinates
!*     for cxy2ll:  xlat,xlong - geographic coordinates

!*  subroutine cc2gxy (strcmp, x,y, ue,vn, ug,vg)
!*  subroutine cg2cxy (strcmp, x,y, ug,vg, ue,vn)
!*  subroutine cc2gll (strcmp, xlat,xlong, ue,vn, ug,vg)
!*  subroutine cg2cll (strcmp, xlat,xlong, ug,vg, ue,vn)
!*     These subroutines convert vector wind components from
!*     geographic, or compass, coordinates, to map or
!*     grid coordinates.  The site of the wind to be
!*     converted may be given either in geographic or
!*     map coordinates.  Wind components are all in kilometers
!*     per hour, whether geographic or map coordinates.
!*  inputs:
!*    strcmp(9) - 9-value map structure array
!*    for cc2gxy and cg2cxy:  x,y        -  map coordinates of site
!*    for cc2gll and cg2cll:  xlat,xlong -  geographic coordinates of site
!*    for cc2gxy and cc2gll:  ue,vn - east and north wind components
!*    for cg2cxy and cg2cll:  ug,vg - x- and y- direction wind components
!*  outputs:
!*    for cc2gxy and cc2gll:  ug,vg - x- and y- direction wind components
!*    for cg2cxy and cg2cll:  ue,vn - east and north wind components

!*  subroutine ccrvxy (strcmp, x, y,       gx,gy)
!*  subroutine ccrvll (strcmp, xlat,xlong, gx,gy)
!*    These subroutines return the curvature vector (gx,gy), as referenced
!*    to map coordinates, induced by the map transformation.  When
!*    non-linear terms in wind speed are important, a "geodesic" force
!*    should be included in the vector form [ (u,u) g - (u,g) u ] where the
!*    inner product (u,g) is defined as ux*gx + uy*gy.
!*  inputs:
!*    strcmp(9) - 9-value map structure array
!*    for ccrvxy:  x,y        -  map coordinates of site
!*    for ccrvll:  xlat,xlong -  geographic coordinates of site
!*  outputs:
!*    gx,gy       - vector coefficients of curvature, in units radians
!*                  per kilometer

!*  real function cgszll (strcmp, xlat)
!*  real function cgszxy (strcmp, x,y)
!*    These functions return the size, in kilometers, of each unit of
!*    motion in map coordinates (grid size).  The grid size at any
!*    location depends on that location; the position may be given in
!*    either map or geographic coordinates.
!*  inputs:
!*    strcmp(9) - 9-value map structure array
!*    for cgszxy:  x,y        -  map coordinates of site
!*    for cgszll:  xlat -  geographic coordinates of site
!*  returns:
!*    gridsize in kilometers at given site.

!*  subroutine cpolxy (strcmp, x,y, enx,eny,enz)
!*  subroutine cpolll (strcmp, xlat,xlong, enx,eny,enz)
!*    These subroutines provide 3-d vector components of a unit vector
!*    in the direction of the north polar axis.  When multiplied
!*    by twice the rotation rate of the earth (2 * pi/24 hr), the
!*    vertical component yields the coriolis factor.
!*  inputs:
!*    strcmp(9) - 9-value map structure array
!*    for cpolxy:  x,y        -  map coordinates of site
!*    for cpolll:  xlat,xlong -  geographic coordinates of site
!*  returns:
!*    enx,eny,enz the direction cosines of a unit vector in the
!*    direction of the rotation axis of the earth

!*  subroutine cnllxy (strcmp, xlat,xlong, xi,eta)
!*  subroutine cnxyll (strcmp, xi,eta, xlat,xlong)
!*    These subroutines perform the underlying transformations from
!*    geographic coordinates to and from canonical (equator centered)
!*    coordinates.  They are called by cxy2ll and cll2xy, but are not
!*    intended to be called directly

!*  real function cspanf (value, begin, end)
!*    This function assists other routines in providing a longitude in
!*    the proper range.  It adds to value whatever multiple of
!*    (end - begin) is needed to return a number begin < cspanf <= end

subroutine stlmbr(strcmp, tnglat, xlong)
  !*  Written on 3/31/94 by Dr. Albion Taylor  NOAA / OAR / ARL

  implicit none

  real :: strcmp(9), tnglat, xlong

  real :: eta, xi

  strcmp(1) = sin(radpdg * tnglat)
  !*  gamma = sine of the tangent latitude
  strcmp(2) = cspanf( xlong, -180., +180.)
  !* lambda_0 = reference longitude
  strcmp(3) = 0.
  !* x_0 = x- grid coordinate of origin (xi,eta) = (0.,0.)
  strcmp(4) = 0.
  !* y_0 = y-grid coordinate of origin (xi,eta) = (0.,0.)
  strcmp(5) = 1.
  !* Cosine of rotation angle from xi,eta to x,y
  strcmp(6) = 0.
  !* Sine of rotation angle from xi,eta to x,y
  strcmp(7) = rearth
  !* Gridsize in kilometers at the equator
  call cnllxy(strcmp, 89.,xlong, xi,eta)
  strcmp(8) = 2. * eta - strcmp(1) * eta * eta
  !* Radial coordinate for 1 degree from north pole
  call cnllxy(strcmp, -89.,xlong, xi,eta)
  strcmp(9) = 2. * eta - strcmp(1) * eta * eta
  !* Radial coordinate for 1 degree from south pole
  return
end subroutine stlmbr

end module cmapf_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readageclasses

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the age classes to be used for the current model    *
  !     run.                                                                   *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     20 March 2000                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: i


  ! If age spectra calculation is switched off, set number of age classes
  ! to 1 and maximum age to a large number
  !**********************************************************************

  if (lagespectra.ne.1) then
    nageclass=1
    lage(nageclass)=999999999
    return
  endif


  ! If age spectra claculation is switched on,
  ! open the AGECLASSSES file and read user options
  !************************************************

  open(unitageclasses,file=path(1)(1:length(1))//'AGECLASSES', &
       status='old',err=999)

  do i=1,13
    read(unitageclasses,*)
  end do
  read(unitageclasses,*) nageclass


  if (nageclass.gt.maxageclass) then
    write(*,*) ' #### FLEXPART MODEL ERROR! NUMBER OF AGE     #### '
    write(*,*) ' #### CLASSES GREATER THAN MAXIMUM ALLOWED.   #### '
    write(*,*) ' #### CHANGE SETTINGS IN FILE AGECLASSES OR   #### '
    write(*,*) ' #### RECOMPILE WITH LARGER MAXAGECLASS IN    #### '
    write(*,*) ' #### FILE PAR_MOD.                        #### '
    stop
  endif

  read(unitageclasses,*) lage(1)
  if (lage(1).le.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! AGE OF FIRST      #### '
    write(*,*) ' #### CLASS MUST BE GREATER THAN ZERO. CHANGE #### '
    write(*,*) ' #### SETTINGS IN FILE AGECLASSES.            #### '
    stop
  endif

  do i=2,nageclass
    read(unitageclasses,*) lage(i)
    if (lage(i).le.lage(i-1)) then
      write(*,*) ' #### FLEXPART MODEL ERROR! AGE CLASSES     #### '
      write(*,*) ' #### MUST BE GIVEN IN TEMPORAL ORDER.      #### '
      write(*,*) ' #### CHANGE SETTINGS IN FILE AGECLASSES.   #### '
      stop
    endif
  end do

  return

999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "AGECLASSES" #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,'(a)') path(1)(1:length(1))
  stop

end subroutine readageclasses

  !*****************************************************************************
  !                                                                            *
  ! 2021 L. Bakels: This module contains all turbulence related subroutines    *
  ! 2023 PS: include psih, psim into this module
  !                                                                            *
  !*****************************************************************************

module turbulence_mod
  use par_mod
  use com_mod
  use particle_mod
  use pbl_profile_mod

  implicit none

  real :: ust,wst,ol,h,zeta,sigu,sigv,tlu,tlv,tlw
  real :: sigw,dsigwdz,dsigw2dz

!$OMP THREADPRIVATE(ust,wst,ol,h,zeta,sigu,sigv,tlu,tlv,tlw, &
!$OMP sigw,dsigwdz,dsigw2dz)

contains

subroutine turbulence_pbl(ipart,nrand,dt,zts,rhoa,rhograd,thread)
  
  use cbl_mod
  
  implicit none 

  integer, intent(in) ::   &
    ipart,                 & ! particle index
    thread                   ! number of the omp thread
  integer, intent(inout) ::&
    nrand                    ! random number used for turbulence
  real,intent(in) ::       &
    dt,                    & ! real(ldt)
    rhoa,                  & ! air density, used in CBL
    rhograd                  ! vertical gradient of the air density, used in CBL
  real,intent(inout) ::    &
    zts                      ! local 'real' copy of the particle position
  real ::                     &
    delz,                     & ! change in vertical position due to turbulence
    ru,rv,rw,wp,icbt_r,       & ! used for computing turbulence
    dtf,rhoaux,dtftlw,ath,bth,& ! CBL related
    ptot_lhh,Q_lhh,phi_lhh,   & ! CBL related
    old_wp_buf                  ! CBL related
  integer ::                  &
    flagrein,                 & ! flag used in CBL scheme
    i                           ! loop variable
  integer(kind=2) :: icbt

  ! tlw,dsigwdz and dsigw2dz are defined in hanna
    if (turbswitch) then
      call hanna(zts)
    else
      call hanna1(zts)
    endif

  !*****************************************
  ! Determine the new diffusivity velocities
  !*****************************************

  ! Horizontal components
  !**********************
    if (nrand+1.gt.maxrand) nrand=1
    if (dt/tlu.lt..5) then
      part(ipart)%turbvel%u=(1.-dt/tlu)*part(ipart)%turbvel%u+rannumb(nrand)*sigu*sqrt(2.*dt/tlu)
    else
      ru=exp(-dt/tlu)
      part(ipart)%turbvel%u=ru*part(ipart)%turbvel%u+rannumb(nrand)*sigu*sqrt(1.-ru**2)
    endif
    if (dt/tlv.lt..5) then
      part(ipart)%turbvel%v=(1.-dt/tlv)*part(ipart)%turbvel%v+rannumb(nrand+1)*sigv*sqrt(2.*dt/tlv)
    else
      rv=exp(-dt/tlv)
      part(ipart)%turbvel%v=rv*part(ipart)%turbvel%v+rannumb(nrand+1)*sigv*sqrt(1.-rv**2)
    endif
    nrand=nrand+2


    if (nrand+ifine.gt.maxrand) nrand=1
    rhoaux=rhograd/rhoa
    dtf=dt*fine

    dtftlw=dtf/tlw

  ! Loop over ifine short time steps for vertical component
  !********************************************************
    wp=part(ipart)%turbvel%w
    icbt=part(ipart)%icbt
    do i=1,ifine
      icbt_r=real(icbt)
  ! Determine the drift velocity and density correction velocity
  !*************************************************************
      
      if (turbswitch) then
        if (dtftlw.lt..5) then
  !*************************************************************
  !************** CBL options added by mc see routine cblf90 ***
          ! LB needs to be checked if this works with openmp
          if (cblflag.eq.1) then  !modified by mc
            if (-h/ol.gt.5) then  !modified by mc
              flagrein=0
              nrand=nrand+1
              old_wp_buf=wp
              call cbl(wp,zts,wst,h,rhoa,rhograd,&
                sigw,dsigwdz,tlw,ptot_lhh,Q_lhh,phi_lhh,ath,bth,ol,flagrein) !inside the routine for inverse time
              wp=(wp+ath*dtf+&
                bth*rannumb(nrand)*sqrt(dtf))*icbt_r
              delz=wp*dtf
              if ((flagrein.eq.1).or.(wp.ne.wp).or.((wp-1.).eq.wp)) then
                call reinit_particle(zts,wst,h,sigw,old_wp_buf,nrand,ol)
                wp=old_wp_buf
                delz=wp*dtf
                nan_count(thread+1)=nan_count(thread+1)+1
              end if             
            else 
              nrand=nrand+1
              old_wp_buf=wp
              ath=-wp/tlw+sigw*dsigwdz+&
                wp*wp/sigw*dsigwdz+sigw*sigw/rhoa*rhograd  !1-note for inverse time should be -wp/tlw*ldirect+... calculated for wp=-wp
                                                                                  !2-but since ldirect =-1 for inverse time and this must be calculated for (-wp) and
                                                                                  !3-the gaussian pdf is symmetric (i.e. pdf(w)=pdf(-w) ldirect can be discarded
              bth=sigw*rannumb(nrand)*sqrt(2.*dtftlw)
              wp=(wp+ath*dtf+bth)*icbt_r  
              delz=wp*dtf
              if ((wp.ne.wp).or.((wp-1.).eq.wp)) then ! Catch infinity or NaN
                nrand=nrand+1                      
                wp=sigw*rannumb(nrand)
                delz=wp*dtf
                nan_count(thread+1)=nan_count(thread+1)+1
              end if
            end if
  !******************** END CBL option *******************************            
  !*******************************************************************            
          else
               wp=((1.-dtftlw)*wp+rannumb(nrand+i)*sqrt(2.*dtftlw) &
               +dtf*(dsigwdz+rhoaux*sigw))*icbt_r
               delz=wp*sigw*dtf
          end if
        else
          rw=exp(-dtftlw)
          wp=(rw*wp+rannumb(nrand+i)*sqrt(1.-rw**2) &
               +tlw*(1.-rw)*(dsigwdz+rhoaux*sigw))*icbt_r
          delz=wp*sigw*dtf
        endif
        
      else
        rw=exp(-dtftlw)
        wp=(rw*wp+rannumb(nrand+i)*sqrt(1.-rw**2)*sigw &
             +tlw*(1.-rw)*(dsigw2dz+rhoaux*sigw**2))*icbt_r
        delz=wp*dtf
      endif

  !****************************************************
  ! Compute turbulent vertical displacement of particle
  !****************************************************

      if (abs(delz).gt.h) delz=mod(delz,h)

  ! Determine if particle transfers to a "forbidden state" below the ground
  ! or above the mixing height
  !************************************************************************

      if (delz.lt.-zts) then         ! reflection at ground
        icbt=-1
        call set_z(ipart,-zts-delz)
      else if (delz.gt.(h-zts)) then ! reflection at h
        icbt=-1
        call set_z(ipart,-zts-delz+2.*h)
      else                         ! no reflection
        icbt=1
        call set_z(ipart,zts+delz)
      endif

      if (i.ne.ifine) then
        zeta=zts/h
        call hanna_short(zts)
      endif
      zts=real(part(ipart)%z)
    end do
    part(ipart)%turbvel%w=wp
    part(ipart)%icbt=icbt
    if (cblflag.ne.1) nrand=nrand+i
end subroutine turbulence_pbl

subroutine turbulence_above_pbl(dt,nrand,ux,vy,wp,tropop,zts)

  implicit none
  
  integer, intent(inout) ::       &
    nrand                           ! random number used for turbulence
  real, intent(inout) ::          &
    ux,vy,wp                        ! random turbulent velocities above PBL
  real, intent(in) ::             &
    tropop,                       & ! height of troposphere
    zts,                          & ! height of particle
    dt                              ! real(ldt)
  real ::                         &
    uxscale,wpscale,              & ! factor used in calculating turbulent perturbations above PBL
    weight                          ! transition above the tropopause

  if (zts.lt.tropop) then  ! in the troposphere
    uxscale=sqrt(2.*d_trop/dt)
    if (nrand+1.gt.maxrand) nrand=1
    ux=rannumb(nrand)*uxscale
    vy=rannumb(nrand+1)*uxscale
    nrand=nrand+2
    wp=0.
  else if (zts.lt.tropop+1000.) then     ! just above the tropopause: make transition
    weight=(zts-tropop)/1000.
    uxscale=sqrt(2.*d_trop/dt*(1.-weight))
    if (nrand+2.gt.maxrand) nrand=1
    ux=rannumb(nrand)*uxscale
    vy=rannumb(nrand+1)*uxscale
    wpscale=sqrt(2.*d_strat/dt*weight)
    wp=rannumb(nrand+2)*wpscale+d_strat/1000.
    nrand=nrand+3
  else                 ! in the stratosphere
    if (nrand.gt.maxrand) nrand=1
    ux=0.
    vy=0.
    wpscale=sqrt(2.*d_strat/dt)
    wp=rannumb(nrand)*wpscale
    nrand=nrand+1
  endif
end subroutine turbulence_above_pbl

subroutine turbulence_mesoscale(nrand,dxsave,dysave,ipart,usig,vsig,wsig,wsigeta,eps_eta)
  
  implicit none

  integer, intent(inout) ::       &
    nrand                           ! random number used for turbulence
  integer, intent(in) ::          &
    ipart                              ! particle index
  real, intent(in) ::             &
    eps_eta,usig,vsig,wsig,wsigeta
  real, intent(inout) ::          &
    dxsave,dysave                   ! accumulated displacement in long and lat
  real ::                         &
    r,rs                            ! mesoscale related

  r=exp(-2.*real(abs(lsynctime))/real(lwindinterv))
  rs=sqrt(1.-r**2)
  if (nrand+2.gt.maxrand) nrand=1
  part(ipart)%mesovel%u=r*part(ipart)%mesovel%u+rs*rannumb(nrand)*usig*fturbmeso
  part(ipart)%mesovel%v=r*part(ipart)%mesovel%v+rs*rannumb(nrand+1)*vsig*fturbmeso
  dxsave=dxsave+part(ipart)%mesovel%u*real(lsynctime)
  dysave=dysave+part(ipart)%mesovel%v*real(lsynctime)

#ifdef ETA
  part(ipart)%mesovel%w=r*part(ipart)%mesovel%w+rs*rannumb(nrand+2)*wsigeta*fturbmeso
  call update_zeta(ipart,part(ipart)%mesovel%w*real(lsynctime))
  if (part(ipart)%zeta.ge.1.) call set_zeta(ipart,1.-(part(ipart)%zeta-1.))
  if (part(ipart)%zeta.eq.1.) call update_zeta(ipart,-eps_eta)

#else
  part(ipart)%mesovel%w=r*part(ipart)%mesovel%w+rs*rannumb(nrand+2)*wsig*fturbmeso
  call update_z(ipart,part(ipart)%mesovel%w*real(lsynctime))
  if (part(ipart)%z.lt.0.) call set_z(ipart,-1.*part(ipart)%z)    ! if particle below ground -> refletion
#endif
end subroutine turbulence_mesoscale

subroutine hanna(z)
  !                 i
  !*****************************************************************************
  !                                                                            *
  !   Computation of \sigma_i and \tau_L based on the scheme of Hanna (1982)   *
  !   Source: 'Atmospheric Turbulence and Air Polution', chapter 4 and 7,      *
  !   J.A. Businger, edited by F.T.M. Nieuwstadt and H. van Dop                *            *
  !                                                                            *
  !   Author: A. Stohl                                                         *
  !                                                                            *
  !   4 December 1997                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dsigwdz [1/s]     vertical gradient of sigw                                *
  ! ol [m]            Obukhov length                                           *
  ! sigu, sigv, sigw  standard deviations of turbulent velocity fluctuations   *
  ! tlu [s]           Lagrangian time scale for the along wind component.      *
  ! tlv [s]           Lagrangian time scale for the cross wind component.      *
  ! tlw [s]           Lagrangian time scale for the vertical wind component.   *
  ! ust, ustar [m/s]  friction velocity                                        *
  ! wst, wstar [m/s]  convective velocity scale                                *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real :: corr,z


  !**********************
  ! 1. Neutral conditions
  !**********************


  ! The addition of 1.e-2 in sigu,sigv,sigw comes from ???

  if (h/abs(ol).lt.1.) then
    ust=max(1.e-4,ust)
    corr=z/ust

    ! Eq. 7.25 Hanna 1982: sigu/ust=2.0*exp(-3*f*z/ust),
    ! where f, the Coriolis parameter, is set to 1e-4
    sigu=1.e-2+2.0*ust*exp(-3.e-4*corr)

    ! Eq. 7.26 Hanna 1982: sigv/ust=sigw/ust=1.3*exp(-2*f*z/ust),
    ! where f, the Coriolis parameter, is set to 1e-4
    sigw=1.3*ust*exp(-2.e-4*corr)

    ! ???      
    dsigwdz=-2.e-4*sigw
    sigw=sigw+1.e-2
    sigv=sigw

    ! Eq.7.27 Hanna 1982: TL=0.5*z/sigw/(1+15*f*z/ust) assumed to be valid
    ! for all three components
    tlu=0.5*z/sigw/(1.+1.5e-3*corr)
    tlv=tlu
    tlw=tlu


  !***********************
  ! 2. Unstable conditions
  !***********************

  else if (ol.lt.0.) then


  ! Determine sigmas
  !*****************

    ! Eq. 4.15 Caughey 1982
    sigu=1.e-2+ust*(12.-0.5*h/ol)**0.33333
    sigv=sigu

    ! Ryall & Maryon 1998
    sigw=sqrt(1.2*wst**2*(1.-.9*zeta)*zeta**0.66666+ &
         (1.8-1.4*zeta)*ust**2)+1.e-2
    ! ???
    dsigwdz=0.5/sigw/h*(-1.4*ust**2+wst**2* &
         (0.8*max(zeta,1.e-3)**(-.33333)-1.8*zeta**0.66666))


  ! Determine average Lagrangian time scale
  !****************************************

    ! Eq. 7.17 Hanna  1982
    tlu=0.15*h/sigu
    tlv=tlu
    if (z.lt.abs(ol)) then
      tlw=0.1*z/(sigw*(0.55-0.38*abs(z/ol)))
    else if (zeta.lt.0.1) then
      tlw=0.59*z/sigw
    else
      tlw=0.15*h/sigw*(1.-exp(-5*zeta))
    endif


  !*********************
  ! 3. Stable conditions
  !*********************

  else
    sigu=1.e-2+2.*ust*(1.-zeta)   ! Eq. 7.20 Hanna 1982
    sigv=1.e-2+1.3*ust*(1.-zeta)  ! Eq. 7.19 Hanna 1982
    sigw=sigv
    dsigwdz=-1.3*ust/h            ! ???
    tlu=0.15*h/sigu*(sqrt(zeta))  ! Eq. 7.22 Hanna 1982
    tlv=0.467*tlu                 ! Eq. 7.23 Hanna 1982
    tlw=0.1*h/sigw*zeta**0.8      ! Eq. 7.24 Hanna 1982
  endif


  tlu=max(10.,tlu)
  tlv=max(10.,tlv)
  tlw=max(30.,tlw)

  if (dsigwdz.eq.0.) dsigwdz=1.e-10
end subroutine hanna

subroutine hanna1(z)
  !                  i
  !*****************************************************************************
  !                                                                            *
  !   Computation of \sigma_i and \tau_L based on the scheme of Hanna (1982)   *
  !   Source: 'Atmospheric Turbulence and Air Polution', chapter 4 and 7,      *
  !   J.A. Businger, edited by F.T.M. Nieuwstadt and H. van Dop                * 
  !                                                                            *
  !   Author: A. Stohl                                                         *
  !                                                                            *
  !   4 December 1997                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dsigwdz [1/s]     vertical gradient of sigw                                *
  ! ol [m]            Obukhov length                                           *
  ! sigu, sigv, sigw  standard deviations of turbulent velocity fluctuations   *
  ! tlu [s]           Lagrangian time scale for the along wind component.      *
  ! tlv [s]           Lagrangian time scale for the cross wind component.      *
  ! tlw [s]           Lagrangian time scale for the vertical wind component.   *
  ! ust, ustar [m/s]  friction velocity                                        *
  ! wst, wstar [m/s]  convective velocity scale                                *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real :: z,s1,s2



  !**********************
  ! 1. Neutral conditions
  !**********************

  if (h/abs(ol).lt.1.) then

    ust=max(1.e-4,ust)

    ! Eq. 7.25 Hanna 1982: sigu/ust=2.0*exp(-3*f*z/ust),
    ! where f, the Coriolis parameter, is set to 1e-4
    sigu=2.0*ust*exp(-3.e-4*z/ust)
    sigu=max(sigu,1.e-5)

    ! Eq. 7.26 Hanna 1982: sigv/ust=sigw/ust=1.3*exp(-2*f*z/ust),
    ! where f, the Coriolis parameter, is set to 1e-4
    sigv=1.3*ust*exp(-2.e-4*z/ust)
    sigv=max(sigv,1.e-5)
    sigw=sigv

    ! ???
    dsigw2dz=-6.76e-4*ust*exp(-4.e-4*z/ust)

    ! Eq.7.27 Hanna 1982: TL=0.5*z/sigw/(1+15*f*z/ust) assumed to be valid
    ! for all three components
    tlu=0.5*z/sigw/(1.+1.5e-3*z/ust)
    tlv=tlu
    tlw=tlu


  !***********************
  ! 2. Unstable conditions
  !***********************

  else if (ol.lt.0.) then


  ! Determine sigmas
  !*****************

    ! Eq. 4.15 Caughey 1982
    sigu=ust*(12.-0.5*h/ol)**0.33333
    sigu=max(sigu,1.e-6)
    sigv=sigu

    ! Eq. 7.15 Hanna 1982
    if (zeta.lt.0.03) then
      sigw=0.96*wst*(3*zeta-ol/h)**0.33333
      dsigw2dz=1.8432*wst*wst/h*(3*zeta-ol/h)**(-0.33333)
    else if (zeta.lt.0.4) then
      s1=0.96*(3*zeta-ol/h)**0.33333
      s2=0.763*zeta**0.175
      if (s1.lt.s2) then
        sigw=wst*s1
        dsigw2dz=1.8432*wst*wst/h*(3*zeta-ol/h)**(-0.33333)
      else
        sigw=wst*s2
        dsigw2dz=0.203759*wst*wst/h*zeta**(-0.65)
      endif
    else if (zeta.lt.0.96) then
      sigw=0.722*wst*(1-zeta)**0.207
      dsigw2dz=-.215812*wst*wst/h*(1-zeta)**(-0.586)
    else if (zeta.lt.1.00) then
      sigw=0.37*wst
      dsigw2dz=0.
    endif
    sigw=max(sigw,1.e-6)


  ! Determine average Lagrangian time scale
  !****************************************

    ! Eq. 7.17 Hanna  1982
    tlu=0.15*h/sigu
    tlv=tlu
    if (z.lt.abs(ol)) then
      tlw=0.1*z/(sigw*(0.55-0.38*abs(z/ol)))
    else if (zeta.lt.0.1) then
      tlw=0.59*z/sigw
    else
      tlw=0.15*h/sigw*(1.-exp(-5*zeta))
    endif


  !*********************
  ! 3. Stable conditions
  !*********************

  else
    sigu=2.*ust*(1.-zeta)
    sigv=1.3*ust*(1.-zeta)
    sigu=max(sigu,1.e-6)
    sigv=max(sigv,1.e-6)
    sigw=sigv
    dsigw2dz=3.38*ust*ust*(zeta-1.)/h
    tlu=0.15*h/sigu*(sqrt(zeta))
    tlv=0.467*tlu
    tlw=0.1*h/sigw*zeta**0.8
  endif




  tlu=max(10.,tlu)
  tlv=max(10.,tlv)
  tlw=max(30.,tlw)
end subroutine hanna1

subroutine hanna_short(z)
  !                       i
  !*****************************************************************************
  !                                                                            *
  !   Computation of \sigma_i and \tau_L based on the scheme of Hanna (1982)   *
  !                                                                            *
  !   Author: A. Stohl                                                         *
  !                                                                            *
  !   4 December 1997                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dsigwdz [1/s]     vertical gradient of sigw                                *
  ! ol [m]            Obukhov length                                           *
  ! sigu, sigv, sigw  standard deviations of turbulent velocity fluctuations   *
  ! tlu [s]           Lagrangian time scale for the along wind component.      *
  ! tlv [s]           Lagrangian time scale for the cross wind component.      *
  ! tlw [s]           Lagrangian time scale for the vertical wind component.   *
  ! ust, ustar [m/s]  friction velocity                                        *
  ! wst, wstar [m/s]  convective velocity scale                                *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real :: z



  !**********************
  ! 1. Neutral conditions
  !**********************

  if (h/abs(ol).lt.1.) then
    ust=max(1.e-4,ust)
    sigw=1.3*exp(-2.e-4*z/ust)
    dsigwdz=-2.e-4*sigw
    sigw=sigw*ust+1.e-2
    tlw=0.5*z/sigw/(1.+1.5e-3*z/ust)


  !***********************
  ! 2. Unstable conditions
  !***********************

  else if (ol.lt.0.) then


  ! Determine sigmas
  !*****************

    sigw=sqrt(1.2*wst**2*(1.-.9*zeta)*zeta**0.66666+ &
         (1.8-1.4*zeta)*ust**2)+1.e-2
    dsigwdz=0.5/sigw/h*(-1.4*ust**2+wst**2* &
         (0.8*max(zeta,1.e-3)**(-.33333)-1.8*zeta**0.66666))


  ! Determine average Lagrangian time scale
  !****************************************

    if (z.lt.abs(ol)) then
      tlw=0.1*z/(sigw*(0.55-0.38*abs(z/ol)))
    else if (zeta.lt.0.1) then
      tlw=0.59*z/sigw
    else
      tlw=0.15*h/sigw*(1.-exp(-5*zeta))
    endif


  !*********************
  ! 3. Stable conditions
  !*********************

  else
    sigw=1.e-2+1.3*ust*(1.-zeta)
    dsigwdz=-1.3*ust/h
    tlw=0.1*h/sigw*zeta**0.8
  endif


  tlu=max(10.,tlu)
  tlv=max(10.,tlv)
  tlw=max(30.,tlw)
  if (dsigwdz.eq.0.) dsigwdz=1.e-10
end subroutine hanna_short

subroutine windalign(u,v,ffap,ffcp,ux,vy)
  !                     i i  i    i   o  o
  !*****************************************************************************
  !                                                                            *
  !  Transformation from along- and cross-wind components to u and v           *
  !  components.                                                               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     3 June 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ffap  turbulent wind in along wind direction                               *
  ! ffcp  turbulent wind in cross wind direction                               *
  ! u     main wind component in x direction                                   *
  ! ux    turbulent wind in x direction                                        *
  ! v     main wind component in y direction                                   *
  ! vy    turbulent wind in y direction                                        *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real :: u,v,ffap,ffcp,ux,vy,ffinv,ux1,ux2,vy1,vy2,sinphi,cosphi
  real,parameter :: eps=1.e-30


  ! Transform along wind components
  !********************************

  ffinv=1./max(sqrt(u*u+v*v),eps)
  sinphi=v*ffinv
  vy1=sinphi*ffap
  cosphi=u*ffinv
  ux1=cosphi*ffap


  ! Transform cross wind components
  !********************************

  ux2=-sinphi*ffcp
  vy2=cosphi*ffcp


  ! Add contributions from along and cross wind components
  !*******************************************************

  ux=ux1+ux2
  vy=vy1+vy2
end subroutine windalign

end module turbulence_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine shift_field(field,nxf,nyf,nzfmax,nzf,nmax,n)
  !                        i/o   i   i    i     i   i   i
  !*****************************************************************************
  !                                                                            *
  !  This subroutine shifts global fields by nxshift grid cells, in order to   *
  !  facilitate all sorts of nested wind fields, or output grids, which,       *
  !  without shifting, would overlap with the domain "boundary".               *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    3 July 2002                                                             *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  integer :: nxf,nyf,nzf,n,ix,jy,kz,ixs,nzfmax,nmax
  real :: field(0:nxmax-1,0:nymax-1,nzfmax,nmax),xshiftaux(0:nxmax-1)

  ! Loop over y and z
  !******************

  do kz=1,nzf
    do jy=0,nyf-1

  ! Shift the data
  !***************

      if (nxshift.ne.0) then
        do ix=0,nxf-1
          if (ix.ge.nxshift) then
            ixs=ix-nxshift
          else
            ixs=nxf-nxshift+ix
          endif
          xshiftaux(ixs)=field(ix,jy,kz,n)
        end do
        do ix=0,nxf-1
          field(ix,jy,kz,n)=xshiftaux(ix)
        end do
      endif

  ! Repeat the westernmost grid cells at the easternmost domain "boundary"
  !***********************************************************************

      field(nxf,jy,kz,n)=field(0,jy,kz,n)
    end do
  end do

end subroutine shift_field

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine calcfluxes(nage,jpart,xold,yold,zold)
  !                       i     i    i    i    i
  !*****************************************************************************
  !                                                                            *
  !     Calculation of the gross fluxes across horizontal, eastward and        *
  !     northward facing surfaces. The routine calculates the mass flux        *
  !     due to the motion of only one particle. The fluxes of subsequent calls *
  !     to this subroutine are accumulated until the next output is due.       *
  !     Upon output, flux fields are re-set to zero in subroutine fluxoutput.f.*
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     04 April 2000                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nage                  Age class of the particle considered                 *
  ! jpart                 Index of the particle considered                     *
  ! xold,yold,zold        "Memorized" old positions of the particle            *
  !                                                                            *
  !*****************************************************************************

  use flux_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: jpart,nage,ixave,jyave,kz,kzave,kp
  integer :: k,k1,k2,ix,ix1,ix2,ixs,jy,jy1,jy2
  real :: xold,yold,zold,xmean,ymean


  ! Determine average positions
  !****************************

  if ((ioutputforeachrelease.eq.1).and.(mdomainfill.eq.0)) then
     kp=npoint(jpart)
  else
     kp=1
  endif

  xmean=(xold+xtra1(jpart))/2.
  ymean=(yold+ytra1(jpart))/2.

  ixave=int((xmean*dx+xoutshift)/dxout)
  jyave=int((ymean*dy+youtshift)/dyout)
  do kz=1,numzgrid                ! determine height of cell
    if (outheight(kz).gt.ztra1(jpart)) goto 16
  end do
16   kzave=kz


  ! Determine vertical fluxes
  !**************************

  if ((ixave.ge.0).and.(jyave.ge.0).and.(ixave.le.numxgrid-1).and. &
       (jyave.le.numygrid-1)) then
    do kz=1,numzgrid                ! determine height of cell
      if (outheighthalf(kz).gt.zold) goto 11
    end do
11   k1=min(numzgrid,kz)
    do kz=1,numzgrid                ! determine height of cell
      if (outheighthalf(kz).gt.ztra1(jpart)) goto 21
    end do
21   k2=min(numzgrid,kz)

    do k=1,nspec
      do kz=k1,k2-1
        flux(5,ixave,jyave,kz,k,kp,nage)= &
             flux(5,ixave,jyave,kz,k,kp,nage)+ &
             xmass1(jpart,k)
      end do
      do kz=k2,k1-1
        flux(6,ixave,jyave,kz,k,kp,nage)= &
             flux(6,ixave,jyave,kz,k,kp,nage)+ &
             xmass1(jpart,k)
      end do
    end do
  endif


  ! Determine west-east fluxes (fluxw) and east-west fluxes (fluxe)
  !****************************************************************

  if ((kzave.le.numzgrid).and.(jyave.ge.0).and. &
       (jyave.le.numygrid-1)) then

  ! 1) Particle does not cross domain boundary

    if (abs(xold-xtra1(jpart)).lt.real(nx)/2.) then
      ix1=int((xold*dx+xoutshift)/dxout+0.5)
      ix2=int((xtra1(jpart)*dx+xoutshift)/dxout+0.5)
      do k=1,nspec
        do ix=ix1,ix2-1
          if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
            flux(1,ix,jyave,kzave,k,kp,nage)= &
                 flux(1,ix,jyave,kzave,k,kp,nage) &
                 +xmass1(jpart,k)
          endif
        end do
        do ix=ix2,ix1-1
          if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
            flux(2,ix,jyave,kzave,k,kp,nage)= &
                 flux(2,ix,jyave,kzave,k,kp,nage) &
                 +xmass1(jpart,k)
          endif
        end do
      end do

  ! 2) Particle crosses domain boundary: use cyclic boundary condition
  !    and attribute flux to easternmost grid row only (approximation valid
  !    for relatively slow motions compared to output grid cell size)

    else
      ixs=int(((real(nxmin1)-1.e5)*dx+xoutshift)/dxout)
      if ((ixs.ge.0).and.(ixs.le.numxgrid-1)) then
        if (xold.gt.xtra1(jpart)) then       ! west-east flux
          do k=1,nspec
            flux(1,ixs,jyave,kzave,k,kp,nage)= &
                 flux(1,ixs,jyave,kzave,k,kp,nage) &
                 +xmass1(jpart,k)
          end do
        else                                 ! east-west flux
          do k=1,nspec
            flux(2,ixs,jyave,kzave,k,kp,nage)= &
                 flux(2,ixs,jyave,kzave,k,kp,nage) &
                 +xmass1(jpart,k)
          end do
        endif
      endif
    endif
  endif


  ! Determine south-north fluxes (fluxs) and north-south fluxes (fluxn)
  !********************************************************************

  if ((kzave.le.numzgrid).and.(ixave.ge.0).and. &
       (ixave.le.numxgrid-1)) then
    jy1=int((yold*dy+youtshift)/dyout+0.5)
    jy2=int((ytra1(jpart)*dy+youtshift)/dyout+0.5)

    do k=1,nspec
      do jy=jy1,jy2-1
        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
          flux(3,ixave,jy,kzave,k,kp,nage)= &
               flux(3,ixave,jy,kzave,k,kp,nage) &
               +xmass1(jpart,k)
        endif
      end do
      do jy=jy2,jy1-1
        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
          flux(4,ixave,jy,kzave,k,kp,nage)= &
               flux(4,ixave,jy,kzave,k,kp,nage) &
               +xmass1(jpart,k)
        endif
      end do
    end do
  endif

end subroutine calcfluxes

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readOHfield

  !*****************************************************************************
  !                                                                            *
  ! Reads the OH field into memory                                             *
  !                                                                            *
  ! AUTHOR: Sabine Eckhardt, June 2007                                         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! i                       loop indices                                       *
  ! LENGTH(numpath)         length of the path names                           *
  ! PATH(numpath)           contains the path names                            *
  ! unitoh                  unit connected with OH field                       *
  !                                                                            *
  ! -----                                                                      *
  !                                                                            *
  !*****************************************************************************

  use oh_mod
  use par_mod
  use com_mod

  implicit none

  integer :: ix,jy,lev,m


  ! Read OH field and level heights
  !********************************

! write (*,*) 'reading OH'
  open(unitOH,file=path(1)(1:length(1))//'OH_7lev_agl.dat', &
       status='old',form='UNFORMATTED', err=998)
  do m=1,12
    do lev=1,maxzOH
      do ix=0,maxxOH-1
  !      do 10 jy=0,maxyOH-1
          read(unitOH) (OH_field(m,ix,jy,lev),jy=0,maxyOH-1)
  !      if ((ix.eq.20).and.(lev.eq.1)) then
  !          write(*,*) 'reading: ', m, OH_field(m,ix,20,lev)
  !      endif
      end do
    end do
  end do
  close(unitOH)

  do lev=1,7
    OH_field_height(lev)=1000+real(lev-1)*2.*1000.
  end do

!  write (*,*) 'OH read'
  return

  ! Issue error messages
  !*********************

998   write(*,*) ' #### FLEXPART ERROR! FILE CONTAINING          ####'
  write(*,*) ' #### OH FIELD DOES NOT EXIST                  ####'
  stop

end subroutine readohfield

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine drydepokernel_nest(nunc,deposit,x,y,nage,kp)
  !                               i      i    i i  i
  !*****************************************************************************
  !                                                                            *
  !     Attribution of the deposition from an individual particle to the       *
  !     nested deposition fields using a uniform kernel with bandwidths        *
  !     dxoutn and dyoutn.                                                     *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     26 December 1996                                                       *
  !                                                                            *
  !      2 September 2004: Adaptation from drydepokernel.                      *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nunc             uncertainty class of the respective particle              *
  ! nage             age class of the respective particle                      *
  ! deposit          amount (kg) to be deposited                               *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use par_mod
  use com_mod

  implicit none

  real :: x,y,deposit(maxspec),ddx,ddy,xl,yl,wx,wy,w
  integer :: ix,jy,ixp,jyp,ks,kp,nunc,nage



  xl=(x*dx+xoutshiftn)/dxoutn
  yl=(y*dy+youtshiftn)/dyoutn
  ix=int(xl)
  jy=int(yl)
  ddx=xl-real(ix)                   ! distance to left cell border
  ddy=yl-real(jy)                   ! distance to lower cell border

  if (ddx.gt.0.5) then
    ixp=ix+1
    wx=1.5-ddx
  else
    ixp=ix-1
    wx=0.5+ddx
  endif

  if (ddy.gt.0.5) then
    jyp=jy+1
    wy=1.5-ddy
  else
    jyp=jy-1
    wy=0.5+ddy
  endif


  ! Determine mass fractions for four grid points
  !**********************************************
    do ks=1,nspec

  if (DRYDEPSPEC(ks).and.(abs(deposit(ks)).gt.0)) then

  if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgridn-1).and. &
       (jy.le.numygridn-1)) then
    w=wx*wy
      drygriduncn(ix,jy,ks,kp,nunc,nage)= &
           drygriduncn(ix,jy,ks,kp,nunc,nage)+deposit(ks)*w
  endif

  if ((ixp.ge.0).and.(jyp.ge.0).and.(ixp.le.numxgridn-1).and. &
       (jyp.le.numygridn-1)) then
    w=(1.-wx)*(1.-wy)
      drygriduncn(ixp,jyp,ks,kp,nunc,nage)= &
           drygriduncn(ixp,jyp,ks,kp,nunc,nage)+deposit(ks)*w
  endif

  if ((ixp.ge.0).and.(jy.ge.0).and.(ixp.le.numxgridn-1).and. &
       (jy.le.numygridn-1)) then
    w=(1.-wx)*wy
      drygriduncn(ixp,jy,ks,kp,nunc,nage)= &
           drygriduncn(ixp,jy,ks,kp,nunc,nage)+deposit(ks)*w
  endif

  if ((ix.ge.0).and.(jyp.ge.0).and.(ix.le.numxgridn-1).and. &
       (jyp.le.numygridn-1)) then
    w=wx*(1.-wy)
      drygriduncn(ix,jyp,ks,kp,nunc,nage)= &
           drygriduncn(ix,jyp,ks,kp,nunc,nage)+deposit(ks)*w
  endif

  endif

    end do
end subroutine drydepokernel_nest

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine fluxoutput(itime)
  !                        i
  !*****************************************************************************
  !                                                                            *
  !     Output of the gridded fluxes.                                          *
  !     Eastward, westward, northward, southward, upward and downward gross    *
  !     fluxes are written to output file in either sparse matrix or grid dump *
  !     format, whichever is more efficient.                                   *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     04 April 2000                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ncellse         number of cells with non-zero values for eastward fluxes   *
  ! sparsee         .true. if in sparse matrix format, else .false.            *
  !                                                                            *
  !*****************************************************************************

  use flux_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,ix,jy,kz,k,nage,jjjjmmdd,ihmmss,kp,i
  integer :: ncellse(maxspec,maxageclass),ncellsw(maxspec,maxageclass)
  integer :: ncellss(maxspec,maxageclass),ncellsn(maxspec,maxageclass)
  integer :: ncellsu(maxspec,maxageclass),ncellsd(maxspec,maxageclass)
  logical :: sparsee(maxspec,maxageclass),sparsew(maxspec,maxageclass)
  logical :: sparses(maxspec,maxageclass),sparsen(maxspec,maxageclass)
  logical :: sparseu(maxspec,maxageclass),sparsed(maxspec,maxageclass)
  character :: adate*8,atime*6


  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss


  open(unitflux,file=path(2)(1:length(2))//'grid_flux_'//adate// &
       atime,form='unformatted')

  !**************************************************************
  ! Check, whether output of full grid or sparse matrix format is
  ! more efficient in terms of storage space. This is checked for
  ! every species and for every age class
  !**************************************************************

  do k=1,nspec
    do nage=1,nageclass
      ncellse(k,nage)=0
      ncellsw(k,nage)=0
      ncellsn(k,nage)=0
      ncellss(k,nage)=0
      ncellsu(k,nage)=0
      ncellsd(k,nage)=0
    end do
  end do

  do k=1,nspec
  do kp=1,maxpointspec_act
    do nage=1,nageclass
      do jy=0,numygrid-1
        do ix=0,numxgrid-1
          do kz=1,numzgrid
            if (flux(2,ix,jy,kz,k,kp,nage).gt.0) ncellse(k,nage)= &
                 ncellse(k,nage)+1
            if (flux(1,ix,jy,kz,k,kp,nage).gt.0) ncellsw(k,nage)= &
                 ncellsw(k,nage)+1
            if (flux(4,ix,jy,kz,k,kp,nage).gt.0) ncellsn(k,nage)= &
                 ncellsn(k,nage)+1
            if (flux(3,ix,jy,kz,k,kp,nage).gt.0) ncellss(k,nage)= &
                 ncellss(k,nage)+1
            if (flux(5,ix,jy,kz,k,kp,nage).gt.0) ncellsu(k,nage)= &
                 ncellsu(k,nage)+1
            if (flux(6,ix,jy,kz,k,kp,nage).gt.0) ncellsd(k,nage)= &
                 ncellsd(k,nage)+1
          end do
        end do
      end do
    end do
  end do
  end do

  ! Output in sparse matrix format more efficient, if less than
  ! 2/5 of all cells contains concentrations>0
  !************************************************************

  do k=1,nspec
    do nage=1,nageclass
      if (4*ncellse(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsee(k,nage)=.true.
      else
        sparsee(k,nage)=.false.
      endif
      if (4*ncellsw(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsew(k,nage)=.true.
      else
        sparsew(k,nage)=.false.
      endif
      if (4*ncellsn(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsen(k,nage)=.true.
      else
        sparsen(k,nage)=.false.
      endif
      if (4*ncellss(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparses(k,nage)=.true.
      else
        sparses(k,nage)=.false.
      endif
      if (4*ncellsu(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparseu(k,nage)=.true.
      else
        sparseu(k,nage)=.false.
      endif
      if (4*ncellsd(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsed(k,nage)=.true.
      else
        sparsed(k,nage)=.false.
      endif
    end do
  end do



  ! Flux output: divide by area and time to get flux in ng/m2/s
  !************************************************************

  write(unitflux) itime
  do k=1,nspec
  do kp=1,maxpointspec_act
    do nage=1,nageclass

      if (sparsee(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(2,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(2,ix,jy,kz,k,kp,nage)/areaeast(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(2,ix,jy,kz,k,kp,nage)/ &
                 areaeast(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparsew(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(1,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(1,ix,jy,kz,k,kp,nage)/areaeast(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(1,ix,jy,kz,k,kp,nage)/ &
                 areaeast(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparses(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(3,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(3,ix,jy,kz,k,kp,nage)/areanorth(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(3,ix,jy,kz,k,kp,nage)/ &
                 areanorth(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparsen(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1 ! north
              if (flux(4,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(4,ix,jy,kz,k,kp,nage)/areanorth(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(4,ix,jy,kz,k,kp,nage)/ &
                 areanorth(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparseu(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(5,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(5,ix,jy,kz,k,kp,nage)/area(ix,jy)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(5,ix,jy,kz,k,kp,nage)/ &
                 area(ix,jy)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparsed(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(6,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(6,ix,jy,kz,k,kp,nage)/area(ix,jy)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(6,ix,jy,kz,k,kp,nage)/ &
                 area(ix,jy)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

    end do
  end do
  end do


  close(unitflux)


  ! Reinitialization of grid
  !*************************

  do k=1,nspec
  do kp=1,maxpointspec_act
    do jy=0,numygrid-1
      do ix=0,numxgrid-1
          do kz=1,numzgrid
            do nage=1,nageclass
              do i=1,6
                flux(i,ix,jy,kz,k,kp,nage)=0.
              end do
            end do
          end do
      end do
    end do
  end do
  end do


end subroutine fluxoutput

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!*****************************************************************************
!                                                                            *
!   L. Bakels 2022: this module contains all subroutines related to          *
!                   calculations between dates: caldate and juldate          *
!                                                                            *
!*****************************************************************************

module date_mod
  use par_mod, only: dp
  
  implicit none

contains

subroutine caldate(juliandate,yyyymmdd,hhmiss)
  !                      i       o       o
  !*****************************************************************************
  !                                                                            *
  !     Calculates the Gregorian date from the Julian date                     *
  !                                                                            *
  !     AUTHOR: Andreas Stohl (21 January 1994), adapted from Numerical Recipes*
  !                                                                            *
  !     PS 2020-07-27: add a check to avoid giving back 240000 for hhmiss      *
  !                                                                            *
  !                                                                            *
  !     Variables:                                                             *
  !     dd             Day                                                     *
  !     hh             Hour                                                    *
  !     hhmiss         Hour, Minute, Second                                    *
  !     ja,jb,jc,jd,je help variables                                          *
  !     jalpha         help variable                                           *
  !     juliandate        Julian Date                                          *
  !     julday         help variable                                           *
  !     mi             Minute                                                  *
  !     mm             Month                                                   *
  !     ss             Seconds                                                 *
  !     yyyy           Year                                                    *
  !     yyyymmdd       Year, Month, Day                                        *
  !                                                                            *
  !     Constants:                                                             *
  !     igreg          help constant                                           *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer           :: yyyymmdd,yyyy,mm,dd,hhmiss,hh,mi,ss
  integer           :: julday,ja,jb,jc,jd,je,jalpha
  real(kind=dp)     :: juliandate
  integer,parameter :: igreg=2299161

  julday=int(juliandate)
  ! PS check to avoid 240000 as hhmiss:  
  if ((juliandate-julday)*86400._dp .ge. 86399.5_dp) then
    juliandate = juliandate + juliandate-julday-86399.5_dp/86400._dp
    julday=int(juliandate)
  endif
  if(julday.ge.igreg)then
    jalpha=int(((julday-1867216)-0.25)/36524.25)
    ja=julday+1+jalpha-int(0.25*jalpha)
  else
    ja=julday
  endif
  jb=ja+1524
  jc=int(6680.+((jb-2439870)-122.1)/365.25)
  jd=365*jc+int(0.25*jc)
  je=int((jb-jd)/30.6001)
  dd=jb-jd-int(30.6001*je)
  mm=je-1
  if (mm.gt.12) mm=mm-12
  yyyy=jc-4715
  if (mm.gt.2) yyyy=yyyy-1
  if (yyyy.le.0) yyyy=yyyy-1

  yyyymmdd=10000*yyyy+100*mm+dd
  hh=int(24._dp*(juliandate-real(julday,kind=dp)))
  mi=int(1440._dp*(juliandate-real(julday,kind=dp))-60._dp*real(hh,kind=dp))
  ss=nint(86400._dp*(juliandate-real(julday,kind=dp))-3600._dp*real(hh,kind=dp)- &
       60._dp*real(mi,kind=dp))
  if (ss.eq.60) then  ! 60 seconds = 1 minute
    ss=0
    mi=mi+1
  endif
  if (mi.eq.60) then
    mi=0
    hh=hh+1
  endif
  hhmiss=10000*hh+100*mi+ss

end subroutine caldate

real(kind=dp) function juldate(yyyymmdd,hhmiss)

  !*****************************************************************************
  !                                                                            *
  !     Calculates the Julian date                                             *
  !                                                                            *
  !     AUTHOR: Andreas Stohl (15 October 1993)                                *
  !                                                                            *
  !     Variables:                                                             *
  !     dd             Day                                                     *
  !     hh             Hour                                                    *
  !     hhmiss         Hour, minute + second                                   *
  !     ja,jm,jy       help variables                                          *
  !     juldate        Julian Date                                             *
  !     julday         help variable                                           *
  !     mi             Minute                                                  *
  !     mm             Month                                                   *
  !     ss             Second                                                  *
  !     yyyy           Year                                                    *
  !     yyyymmddhh     Date and Time                                           *
  !                                                                            *
  !     Constants:                                                             *
  !     igreg          help constant                                           *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer           :: yyyymmdd,yyyy,mm,dd,hh,mi,ss,hhmiss
  integer           :: julday,jy,jm,ja
  integer,parameter :: igreg=15+31*(10+12*1582)
  !real(kind=dp)     :: juldate

  yyyy=yyyymmdd/10000
  mm=(yyyymmdd-10000*yyyy)/100
  dd=yyyymmdd-10000*yyyy-100*mm
  hh=hhmiss/10000
  mi=(hhmiss-10000*hh)/100
  ss=hhmiss-10000*hh-100*mi

  if (yyyy.eq.0) then
     error stop 'juldate: there is no year zero'
  end if
  if (yyyy.lt.0) yyyy=yyyy+1
  if (mm.gt.2) then
    jy=yyyy
    jm=mm+1
  else
    jy=yyyy-1
    jm=mm+13
  endif
  julday=int(365.25*jy)+int(30.6001*jm)+dd+1720995
  if (dd+31*(mm+12*yyyy).ge.igreg) then
    ja=int(0.01*jy)
    julday=julday+2-ja+int(0.25*ja)
  endif

  juldate=real(julday,kind=dp)   + real(hh,kind=dp)/24._dp + &
       real(mi,kind=dp)/1440._dp  + real(ss,kind=dp)/86400._dp

end function juldate

  !*****************************************************************************
  !                                                                            * 
  !    Calculates number of days in a month                                    * 
  !                                                                            * 
  !    Author: Rona Thompson (Sep 2023)                                        * 
  !                                                                            * 
  !    Variables:                                                              * 
  !    yyyymm       year and month                                             * 
  !    eomday       number of days in month (end of month day)                 * 
  !                                                                            * 
  !*****************************************************************************

  integer function calceomday(yyyymm)

    integer, intent(in) :: yyyymm
    integer :: yyyy,mm
    integer, dimension(12) :: leapdays,days
    integer :: eomday

    leapdays=(/31,29,31,30,31,30,31,31,30,31,30,31/)
    days=(/31,28,31,30,31,30,31,31,30,31,30,31/)

    yyyy=floor(yyyymm/100.)
    mm=yyyymm-yyyy*100

    if((float(yyyy)/100.).eq.float(yyyy/100)) then
      if((float(yyyy)/400.).eq.float(yyyy/400)) then
        eomday=leapdays(mm)
      else
        eomday=days(mm)
      endif
    else
      if((float(yyyy)/4.).eq.float(yyyy/4)) then
        eomday=leapdays(mm)
      else
        eomday=days(mm)
      endif
    endif

    calceomday=eomday

  end function calceomday


end module date_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine pbl_profile(ps,td2m,zml1,t2m,tml1,u10m,uml1,stress,hf)

  !********************************************************************
  !                                                                   *
  !                    G. WOTAWA, 1995-07-07                          *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  ! DESCRIPTION: CALCULATION OF FRICTION VELOCITY AND SURFACE SENS-   *
  !              IBLE HEAT FLUX USING THE PROFILE METHOD (BERKOVICZ   *
  !              AND PRAHM, 1982)                                     *
  !                                                                   *
  ! Output now is surface stress instead of ustar                     *
  !                                                                   *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  ! INPUT:                                                            *
  !                                                                   *
  !                                                                   *
  ! ps      surface pressure(Pa)                                      *
  ! td2m    two metre dew point(K)                                    *
  ! zml1    heigth of first model level (m)                           *
  ! t2m     two metre temperature (K)                                 *
  ! tml1    temperature first model level (K)                         *
  ! u10m    ten metre wind speed (ms-1)                               *
  ! uml1    wind speed first model level (ms-1)                       *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  ! OUTPUT:                                                           *
  !                                                                   *
  ! stress  surface stress (i.e., friction velocity (ms-1) squared    *
  !                         multiplied with air density)              *
  ! hf      surface sensible heat flux (Wm-2)                         *
  !                                                                   *
  !********************************************************************
  ! ustar   friction velocity (ms-1)                                  *
  ! maxiter maximum number of iterations                              *
  !********************************************************************

  use par_mod

  implicit none

  integer :: iter
  real :: ps,td2m,rhoa,zml1,t2m,tml1,u10m,uml1,ustar,hf
  real :: al,alold,aldiff,tmean,crit
  real :: deltau,deltat,thetastar,psim,psih,e,ew,tv,stress
  integer,parameter :: maxiter=10
  real,parameter    :: r1=0.74

  e=ew(td2m)               ! vapor pressure
  tv=t2m*(1.+0.378*e/ps)   ! virtual temperature
  rhoa=ps/(r_air*tv)       ! air density

  deltau=uml1-u10m         !! Wind Speed difference between
                           !! Model level 1 and 10 m

  if(deltau.le.0.001) then    !! Monin-Obukhov Theory not
    al=9999.               !! applicable --> Set dummy values
    ustar=0.01
    stress=ustar*ustar*rhoa
    hf=0.0
    return
  endif
  deltat=tml1-t2m+0.0098*(zml1-2.)  !! Potential temperature difference
                                    !! between model level 1 and 10 m

  if(abs(deltat).le.0.03) then    !! Neutral conditions
    hf=0.0
    al=9999.
    ustar=(vonkarman*deltau)/ &
         (log(zml1/10.)-psim(zml1,al)+psim(10.,al))
    stress=ustar*ustar*rhoa
    return
  endif

  tmean=0.5*(t2m+tml1)
  crit=(0.0219*tmean*(zml1-2.0)*deltau**2)/ &
       (deltat*(zml1-10.0)**2)
  if((deltat.gt.0).and.(crit.le.1.)) then
                                    !! Successive approximation will
    al=50.                          !! not converge
    ustar=(vonkarman*deltau)/ &
         (log(zml1/10.)-psim(zml1,al)+psim(10.,al))
    thetastar=(vonkarman*deltat/r1)/ &
         (log(zml1/2.)-psih(zml1,al)+psih(2.,al))
    hf=rhoa*cpa*ustar*thetastar
    stress=ustar*ustar*rhoa
    return
  endif

  al=9999.                 ! Start iteration assuming neutral conditions
  do iter=1,maxiter
    alold=al
    ustar=(vonkarman*deltau)/ &
         (log(zml1/10.)-psim(zml1,al)+psim(10.,al))
    thetastar=(vonkarman*deltat/r1)/ &
         (log(zml1/2.)-psih(zml1,al)+psih(2.,al))
    al=(tmean*ustar**2)/(ga*vonkarman*thetastar)
    aldiff=abs((al-alold)/alold)
    if(aldiff.lt.0.01) goto 30  !! Successive approximation successful
  end do
30   hf=rhoa*cpa*ustar*thetastar
  if(al.gt.9999.) al=9999.
  if(al.lt.-9999.) al=-9999.

  stress=ustar*ustar*rhoa

end subroutine pbl_profile

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine partoutput_short(itime)
  !                              i
  !*****************************************************************************
  !                                                                            *
  !     Dump all particle positions                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     12 March 1999                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,i,j,jjjjmmdd,ihmmss,numshortout,numshortall
  integer :: ix,jy,ixp,jyp
  real :: xlon,ylat,zlim,dt1,dt2,dtt,ddx,ddy,rddx,rddy,p1,p2,p3,p4,topo
  character :: adate*8,atime*6

  integer(kind=2) :: idump(3,maxpart)
  integer :: i4dump(maxpart)


  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss


  ! Some variables needed for temporal interpolation
  !*************************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)


  ! Loop about all particles
  !*************************

  numshortout=0
  numshortall=0
  do i=1,numpart

  ! Take only valid particles
  !**************************

    if (itra1(i).eq.itime) then
      xlon=xlon0+xtra1(i)*dx
      ylat=ylat0+ytra1(i)*dy

  !*****************************************************************************
  ! Interpolate several variables (PV, specific humidity, etc.) to particle position
  !*****************************************************************************

      ix=xtra1(i)
      jy=ytra1(i)
      ixp=ix+1
      jyp=jy+1
      ddx=xtra1(i)-real(ix)
      ddy=ytra1(i)-real(jy)
      rddx=1.-ddx
      rddy=1.-ddy
      p1=rddx*rddy
      p2=ddx*rddy
      p3=rddx*ddy
      p4=ddx*ddy

  ! Topography
  !***********

      topo=p1*oro(ix ,jy) &
           + p2*oro(ixp,jy) &
           + p3*oro(ix ,jyp) &
           + p4*oro(ixp,jyp)


  ! Convert positions to integer*2 variables (from -32768 to 32767)
  ! Do this only for region of main interest, i.e. extended North Atlantic region,
  ! and for the tracer of interest, i.e. the North American one
  !*****************************************************************************

      if (xlon.gt.180.) xlon=xlon-360.
      if (xlon.lt.-180.) xlon=xlon+360.

      numshortall=numshortall+1
      if ((xlon.gt.-140).and.(xlon.lt.60).and.(ylat.gt.10).and. &
           (xmass1(i,1).gt.0.)) then
        numshortout=numshortout+1
        idump(1,numshortout)=nint(xlon*180.)
        idump(2,numshortout)=nint(ylat*360.)
        zlim=min(ztra1(i)+topo,32766.)
        idump(3,numshortout)=nint(zlim)
        i4dump(numshortout)=npoint(i)
      endif

    endif
  end do


  ! Open output file and write the output
  !**************************************

  open(unitshortpart,file=path(2)(1:length(2))//'shortposit_'//adate// &
       atime,form='unformatted')

  ! Write current time to file
  !***************************

  write(unitshortpart) itime
  write(unitshortpart) numshortout
  write(unitshortpart) &
       (i4dump(i),(idump(j,i),j=1,3),i=1,numshortout)


  write(*,*) numshortout,numshortall

  close(unitshortpart)

end subroutine partoutput_short

      subroutine readgrid(filegrid,itime,nxmax,numxgrid,nymax,numygrid,
     +nzmax,numzgrid,maxspec,nspec,maxageclass,nageclass,grid,lage)

      real grid(0:nxmax-1,0:nymax-1,nzmax,maxspec,maxageclass)
      integer lage(0:maxageclass)

***************** new sparse output
      real smallnum
      integer fact,ii,ir
      real sparse_dump_r(nxmax*nymax*nzmax)
      integer sparse_dump_i(nxmax*nymax*nzmax)
      integer sp_count_i,sp_count_r
***************** new sparse output


      character*250 filegrid

      open(10,file=filegrid,form='unformatted',status='old')
      read(10,end=99) itime 
      !write(*,*) itime
      !print*, 'readgrid> itime=', itime

C Loop about all species
************************

      do 38 k=1,nspec

C Loop about all age classes
****************************

        do 38 nage=1,nageclass

C Initialize age class fields
*****************************

        do 63 ix=0,numxgrid-1
          do 63 jy=0,numygrid-1
            do 63 kz=1,numzgrid
63            grid(ix,jy,kz,k,nage)=0.


C Read wet deposition
*********************

        fact=1
        read(10) sp_count_i
        read(10) (sparse_dump_i(ix),ix=1,sp_count_i)
        read(10) sp_count_r
        read(10) (sparse_dump_r(ix),ix=1,sp_count_r)

c       ii=0
c       do 32 ir=1,sp_count_r
c         if ((sparse_dump_r(ir)*fact).gt.smallnum) then
c            ii=ii+1
c            n=sparse_dump_i(ii)
c            fact=fact*(-1.)
c         else
c            pos=pos+1
c         endif

c         jy=n/numxgrid
c         ix=n-numxgrid*jy
c         wetgrid(ix,jy,k,nage)=sparse_dump_r(ir)

c2      continue

C Read dry deposition
*********************

        fact=1
        read(10) sp_count_i
        read(10) (sparse_dump_i(ix),ix=1,sp_count_i)
        read(10) sp_count_r
        read(10) (sparse_dump_r(ix),ix=1,sp_count_r)

c       ii=0
c       do 36 ir=1,sp_count_r
c         if ((sparse_dump_r(ir)*fact).gt.smallnum) then
c            ii=ii+1
c            n=sparse_dump_i(ii)
c            fact=fact*(-1.)
c         else
c            pos=pos+1
c         endif

c         jy=n/numxgrid
c         ix=n-numxgrid*jy
c         drygrid(ix,jy,k,nage)=sparse_dump_r(ir)

c6      continue


C Read concentrations
*********************

        fact=1
        read(10) sp_count_i
        read(10) (sparse_dump_i(ix),ix=1,sp_count_i)
        read(10) sp_count_r
        read(10) (sparse_dump_r(ix),ix=1,sp_count_r)
c       write(*,*) sp_count_i,sp_count_r
c       write(*,*) (sparse_dump_i(ix),ix=1,sp_count_i)
c       write(*,*) (sparse_dump_r(ix),ix=1,sp_count_r)

        ii=0
        do 47 ir=1,sp_count_r
          if ((sparse_dump_r(ir)*fact).gt.smallnum) then
             ii=ii+1
             n=sparse_dump_i(ii)
             fact=fact*(-1.)
          else
             n=n+1
          endif

          kz=n/(numxgrid*numygrid)
          jy=(n-kz*numxgrid*numygrid)/numxgrid
          ix=n-numxgrid*numygrid*kz-numxgrid*jy
          grid(ix,jy,kz,k,nage)=abs(sparse_dump_r(ir))

47      continue

C End species loop, end age class loop
**************************************

138       continue
38      continue

      close(10)

99    continue


      end

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  !  This module handles all gridded netcdf output for concentration or        *
  !  residence time and wet and dry deposition output.                         *
  !                                                                            *
  !  - writeheader_netcdf generates file including all information previously  *
  !    stored in separate header files                                         *
  !  - concoutput_netcdf write concentration output and wet and dry deposition *
  !                                                                            *
  !     Author: D. Brunner                                                     *
  !                                                                            *
  !     12 April 2013                                                          *
  !                                                                            *
  ! HSO: 21 Oct 2014                                                           *
  !  - added option to not writeout releases information by changing           *
  !    switch write_releases                                                   *
  !  - additional updates for FLEXPART 9.x                                     *
  !                                                                            *
  ! ESO 2016                                                                   *
  !  - Deposition fields can be calculated in double precision, see variable   *
  !    'dep_prec' in par_mod                                                   *
  !  - Hardcoded options 'write_vol' and 'write_area' for grid cell            *
  !    volume and area                                                         *
  !                                                                            *
  ! LB: 2021                                                                   *
  !  - Particle dump and initial particle positions in NetCDF                  *
  !  - Receptor files in NetCDF format                                         *
  !                                                                            *
  ! RLT: 2024                                                                  *
  !  - Moved receptor output new module                                        *
  !*****************************************************************************


module netcdf_output_mod

  use netcdf

  use point_mod, only: ireleasestart,ireleaseend,kindz,dx,xlon0,dy,ylat0,&
                       xpoint1,ypoint1,xpoint2,ypoint2,zpoint1,zpoint2,npart,xmass
  use outgrid_mod,  only: outheight,oroout,densityoutgrid,factor3d,volume,&
                       wetgrid,wetgridsigma,drygrid,drygridsigma,grid,gridsigma,&
                       area,arean,volumen,orooutn
  use par_mod,   only: dep_prec, sp, dp, nclassunc,&
                       unitoutrecept,unitoutreceptppt,unittmp,lpartoutputperfield
  use com_mod

  use windfields_mod, only: oro,rho,nxmax,height,nxmin1,nymin1,nz,nx,ny,hmix, &
                       ! for concoutput_netcdf and concoutput_nest_netcdf 
                       tropopause,oron,rhon,xresoln,yresoln,xrn,xln,yrn,yln,nxn,nyn
  use mean_mod

  implicit none

  !  include 'netcdf.inc'

  ! parameter for data compression (1-9, 9 = most aggressive)
  integer, parameter :: deflate_level = 5
  logical, parameter :: min_size = .false.   ! if set true, redundant fields (topography) are not written to minimize file size

  integer            :: tpointer=0,tpointer_part=0,ppointer_part=0,partinitpointer=0,partinitpointer1=0
  character(len=255) :: ncfname, ncfnamen, ncfname_part, ncfname_partinit, ncfname_part_end

  ! netcdf dimension and variable IDs for main and nested output grid
  integer,allocatable,dimension(:) :: specID,specIDppt,wdspecID,ddspecID
  integer,allocatable,dimension(:) :: specIDn,specIDnppt,wdspecIDn,ddspecIDn, &
    recconcID,recpptvID
  integer                     :: timeID, timeIDn, timeIDpart
  integer, dimension(6)       :: dimids, dimidsn
  integer, dimension(5)       :: depdimids, depdimidsn

  ! For initial particle outputs
  integer  :: partIDi,tIDi,lonIDi,latIDi,levIDi,relIDi,pvIDi,prIDi,qvIDi, &
    rhoIDi,ttIDi,uIDi,vIDi,wIDi,topoIDi,trIDi,hmixIDi
  integer,allocatable,dimension(:) :: massIDi

  real :: eps
  !  private:: writemetadata, output_units, nf90_err

  ! switch output of release point information on/off
  logical, parameter :: write_releases = .true.

  ! switch output of grid cell volume and area on/off
  logical, parameter :: write_vol = .false.
  logical, parameter :: write_area = .false.

  ! switch for first time topo output in case of domainfill
  logical :: topo_written=.false.
  logical :: mass_written=.false.
  logical :: massav_written=.false.

  ! coordinate transformation from internal to world coord
  real :: xp1,yp1,xp2,yp2


  private

  public :: writeheader_netcdf,concoutput_netcdf,&
       concoutput_nest_netcdf,writeheader_partoutput,partoutput_netcdf,&
       open_partoutput_file,close_partoutput_file,create_particles_initialoutput,&
       topo_written,mass_written,wrt_part_initialpos,partinit_netcdf,open_partinit_file, &
       readpartpositions_netcdf,readinitconditions_netcdf,partinitpointer1,tpointer, &
       alloc_netcdf,dealloc_netcdf,nf90_err,update_partoutput_pointers,ppointer_part

contains

subroutine alloc_netcdf
  implicit none
  integer :: stat

  allocate( specID(maxspec),specIDppt(maxspec), wdspecID(maxspec),ddspecID(maxspec), &
    specIDn(maxspec),specIDnppt(maxspec), wdspecIDn(maxspec),ddspecIDn(maxspec), &
    recconcID(maxspec),recpptvID(maxspec), stat=stat)
  if (stat.ne.0) error stop "Could not allocate netcdf fields"

  allocate( massIDi(maxspec), stat=stat)
  if (stat.ne.0) error stop "Could not allocate netcdf fields 2"
end subroutine alloc_netcdf

subroutine dealloc_netcdf
  deallocate( specID,specIDppt,wdspecID,ddspecID,specIDn,specIDnppt,wdspecIDn,ddspecIDn, &
    recconcID,recpptvID )
  deallocate( massIDi )
end subroutine dealloc_netcdf

!****************************************************************
! determine output units (see table 1 in Stohl et al., ACP 2005
!****************************************************************
subroutine output_units(units)
  implicit none
  character(len=15), intent(out) :: units
  if (ldirect.eq.1) then
     ! forward simulation
     if (ind_source.eq.1) then
        if (ind_receptor.eq.1) then
           units = 'ng m-3'   ! hes the kg in Tab1 is only indicating the units of the relase not the output
        else
           units = 'ng kg-1'
        endif
     else
        if (ind_receptor.eq.1) then
           units = 'ng m-3'
        else
           units = 'ng kg-1'
        endif
     endif
  else
     ! backward simulation
     if (ind_source.eq.1) then
        if (ind_receptor.eq.1) then
           units = 's'
        else 
           units = 's m3 kg-1'
        endif
     else
        if (ind_receptor.eq.1) then
           units = 's kg m-3'
        else
           units = 's'
        endif
     endif
  endif
end subroutine output_units


!****************************************************************
! write metadata to netCDF file 
!****************************************************************
subroutine writemetadata(ncid,lnest)
  
  implicit none 

  integer, intent(in) :: ncid
  logical, intent(in) :: lnest
  character           :: time*10,date*8,adate*8,atime*6
  character(5)        :: zone
  character(255)      :: login_name, host_name

  ! gather system information 
  call date_and_time(date,time,zone)
  call getlog(login_name)
  call hostnm(host_name)
  
  ! hes CF convention requires these attributes
  call nf90_err(nf90_put_att(ncid, nf90_global, 'Conventions', 'CF-1.6'))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'title', 'FLEXPART model output'))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'git', trim(gitversion)))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'source', trim(flexversion)//' model output'))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'history', date(1:4)//'-'//date(5:6)// &
       '-'//date(7:8)//' '//time(1:2)//':'//time(3:4)//' '//zone//'  created by '//  &
       trim(login_name)//' on '//trim(host_name)))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'references', &
       'Stohl et al., Atmos. Chem. Phys., 2005, doi:10.5194/acp-5-2461-200'))

  ! attributes describing model run
  !************************************************************************************

  if (lnest) then
     call nf90_err(nf90_put_att(ncid, nf90_global, 'outlon0', outlon0n))
     call nf90_err(nf90_put_att(ncid, nf90_global, 'outlat0', outlat0n))
     call nf90_err(nf90_put_att(ncid, nf90_global, 'dxout', dxoutn))
     call nf90_err(nf90_put_att(ncid, nf90_global, 'dyout', dyoutn))
  else
     call nf90_err(nf90_put_att(ncid, nf90_global, 'outlon0', outlon0))
     call nf90_err(nf90_put_att(ncid, nf90_global, 'outlat0', outlat0))
     call nf90_err(nf90_put_att(ncid, nf90_global, 'dxout', dxout))
     call nf90_err(nf90_put_att(ncid, nf90_global, 'dyout', dyout))
  endif
  !   vertical levels stored in grid structure

  ! COMMAND file settings
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ldirect', ldirect))
  write(adate,'(i8.8)') ibdate
  write(atime,'(i6.6)') ibtime
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ibdate', adate))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ibtime', atime))
  write(adate,'(i8.8)') iedate
  write(atime,'(i6.6)') ietime
  call nf90_err(nf90_put_att(ncid, nf90_global, 'iedate', adate))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ietime', atime))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'loutstep', loutstep))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'loutaver', loutaver))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'loutsample', loutsample))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'loutrestart', loutrestart))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'lsynctime', lsynctime))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ctl', ctl))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ifine', ifine))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'iout', iout))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ipout', ipout))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'lsubgrid', lsubgrid))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'lconvection', lconvection))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'lagespectra', lagespectra))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ipin', ipin))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ioutputforeachrelease', ioutputforeachrelease))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'iflux', iflux))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'mdomainfill', mdomainfill))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ind_source', ind_source))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'ind_receptor', ind_receptor))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'mquasilag', mquasilag))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'nested_output', nested_output))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'sfc_only', sfc_only))
  call nf90_err(nf90_put_att(ncid, nf90_global, 'linit_cond', linit_cond))
end subroutine writemetadata


subroutine nf90_err(status)
  !****************************************************************
  ! netcdf error message handling
  !****************************************************************
  implicit none
  integer, intent (in) :: status
   if(status /= nf90_noerr) then
      print *, trim(nf90_strerror(status))
      error stop 'Stopped'
    end if
end subroutine nf90_err

subroutine writeheader_netcdf(lnest)

  !****************************************************************
  ! Create netcdf file and write header/metadata information
  ! lnest = .false. : Create main output file
  ! lnest = .true.  : Create nested output file
  !****************************************************************
  implicit none

  logical, intent(in) :: lnest

  integer :: ncid, sID, wdsID, ddsID
  integer :: timeDimID, latDimID, lonDimID, levDimID
  integer :: nspecDimID, npointDimID, nageclassDimID, ncharDimID, pointspecDimID
  integer :: tID, lonID, latID, levID, lageID, oroID, ncharrecDimID
  integer :: volID, areaID
  integer :: rellng1ID, rellng2ID, rellat1ID, rellat2ID, relzz1ID, relzz2ID
  integer :: relcomID, relkindzID, relstartID, relendID, relpartID, relxmassID
  integer :: nnx, nny 
  integer, dimension(6)       :: dIDs
  integer, dimension(5)       :: depdIDs
  character(len=255)          :: fname
  character(len=15)           :: units
  character(len=20)           :: fprefix
  character(len=3)            :: anspec
  CHARACTER                   :: adate*8,atime*6,timeunit*32
  !REAL, DIMENSION(1000)       :: coord
  real, allocatable, dimension(:) :: coord

  integer                     :: cache_size
  integer, dimension(6)       :: chunksizes
  integer, dimension(5)       :: dep_chunksizes

  integer                     :: i
  integer                     :: numzwrite


  ! Check if output directory exists (the netcdf library will
  ! otherwise give an error which can look confusing). 
  ! *********************************************************************
  open(unit=unittmp,file=trim(path(2)(1:length(2)))//'test_dir.txt',status='replace',&
       &err=100)
  close (unittmp, status='delete')
  goto 101
100 write(*,FMT='(80("#"))') 
  write(*,*) 'ERROR: output directory ', trim(path(2)(1:length(2))), ' does not exist&
       & (or failed to write there).' 
  write(*,*) 'EXITING' 
  write(*,FMT='(80("#"))')
  error stop
101 continue

  !************************
  ! Create netcdf file
  !************************

  numzwrite=numzgrid
  if (sfc_only.eq.1) numzwrite=1

  if (ldirect.eq.1) then
     write(adate,'(i8.8)') ibdate
     write(atime,'(i6.6)') ibtime
     fprefix = 'grid_conc_'
  else
     write(adate,'(i8.8)') iedate
     write(atime,'(i6.6)') ietime
     fprefix = 'grid_time_'
  endif
  if (DRYBKDEP) fprefix='grid_drydep_'
  if (WETBKDEP) fprefix='grid_wetdep_'

  if (lnest) then
     fname = path(2)(1:length(2))//trim(fprefix)//adate//atime//'_nest.nc'
     ncfnamen = fname
     nnx = numxgridn
     nny = numygridn
  else
     fname = path(2)(1:length(2))//trim(fprefix)//adate//atime//'.nc'
     ncfname = fname
     nnx = numxgrid
     nny = numygrid
  endif

  cache_size = 16 * nnx * nny * numzgrid

  ! If starting from a restart file, new data will be added to the existing grid file
  if ((ipin.eq.1).or.(ipin.eq.4)) then
    call read_grid_id(lnest)
    return
  endif

  ! setting cache size in bytes. It is set to 4 times the largest data block that is written
  !   size_type x nx x ny x nz
  ! create file
  call nf90_err(nf90_create(trim(fname), cmode = nf90_hdf5, ncid = ncid, &
    cache_size = cache_size))  

  ! create dimensions:
  !*************************
  ! time
  call nf90_err(nf90_def_dim(ncid, 'time', nf90_unlimited, timeDimID))
  timeunit = 'seconds since '//adate(1:4)//'-'//adate(5:6)// &
     '-'//adate(7:8)//' '//atime(1:2)//':'//atime(3:4)

  ! lon
  call nf90_err(nf90_def_dim(ncid, 'longitude', nnx, lonDimID))
  ! lat
  call nf90_err(nf90_def_dim(ncid, 'latitude', nny, latDimID))
  ! level
!  call nf90_err(nf90_def_dim(ncid, 'height', numzgrid, levDimID))
  call nf90_err(nf90_def_dim(ncid, 'height', numzwrite, levDimID))
  ! number of species
  call nf90_err(nf90_def_dim(ncid, 'numspec', nspec, nspecDimID))
  ! number of release points
  call nf90_err(nf90_def_dim(ncid, 'pointspec', maxpointspec_act, pointspecDimID))
  ! number of age classes
  call nf90_err(nf90_def_dim(ncid, 'nageclass', nageclass, nageclassDimID))
  ! dimension for release point characters
  call nf90_err(nf90_def_dim(ncid, 'nchar', 45, ncharDimID))
  ! number of actual release points
  call nf90_err(nf90_def_dim(ncid, 'numpoint', numpoint, npointDimID))


  ! create variables
  !*************************

  ! time
  call nf90_err(nf90_def_var(ncid, 'time', nf90_int, (/ timeDimID /), tID))
  call nf90_err(nf90_put_att(ncid, tID, 'units', timeunit))
  call nf90_err(nf90_put_att(ncid, tID, 'calendar', 'proleptic_gregorian'))
  if (lnest) then
     timeIDn = tID
  else
     timeID = tID
  endif

  ! lon
  call nf90_err(nf90_def_var(ncid, 'longitude', nf90_float, (/ lonDimID /), lonID))
  call nf90_err(nf90_put_att(ncid, lonID, 'long_name', 'longitude in degree east'))
  call nf90_err(nf90_put_att(ncid, lonID, 'axis', 'Lon'))
  call nf90_err(nf90_put_att(ncid, lonID, 'units', 'degrees_east'))
  call nf90_err(nf90_put_att(ncid, lonID, 'standard_name', 'grid_longitude'))
  call nf90_err(nf90_put_att(ncid, lonID, 'description', 'grid cell centers'))

  ! lat
  call nf90_err(nf90_def_var(ncid, 'latitude', nf90_float, (/ latDimID /), latID))
  call nf90_err(nf90_put_att(ncid, latID, 'long_name', 'latitude in degree north'))
  call nf90_err(nf90_put_att(ncid, latID, 'axis', 'Lat'))
  call nf90_err(nf90_put_att(ncid, latID, 'units', 'degrees_north'))
  call nf90_err(nf90_put_att(ncid, latID, 'standard_name', 'grid_latitude'))
  call nf90_err(nf90_put_att(ncid, latID, 'description', 'grid cell centers'))


  ! height
  call nf90_err(nf90_def_var(ncid, 'height', nf90_float, (/ levDimID /), levID))
  ! call nf90_err(nf90_put_att(ncid, levID, 'axis', 'Z'))
  call nf90_err(nf90_put_att(ncid, levID, 'units', 'meters'))
  call nf90_err(nf90_put_att(ncid, levID, 'positive', 'up'))
  call nf90_err(nf90_put_att(ncid, levID, 'standard_name', 'height'))
  call nf90_err(nf90_put_att(ncid, levID, 'long_name', 'height above ground'))

  ! volume
  if (write_vol) call nf90_err(nf90_def_var(ncid, 'volume', nf90_float, &
       &(/ lonDimID, latDimID, levDimID /), volID))
  ! area 
  if (write_area) call nf90_err(nf90_def_var(ncid, 'area', nf90_float, &
       &(/ lonDimID, latDimID /), areaID))


  if (write_releases.eqv..true.) then
    ! release comment
    call nf90_err(nf90_def_var(ncid, 'RELCOM', nf90_char, (/ ncharDimID,npointDimID /), &
         relcomID))
    call nf90_err(nf90_put_att(ncid, relcomID, 'long_name', 'release point name'))
    ! release longitude 1
    call nf90_err(nf90_def_var(ncid, 'RELLNG1', nf90_float, (/ npointDimID /), rellng1ID))
    call nf90_err(nf90_put_att(ncid, rellng1ID, 'units', 'degrees_east'))
    call nf90_err(nf90_put_att(ncid, rellng1ID, 'long_name', &
         'release longitude lower left corner'))
    ! release longitude 2
    call nf90_err(nf90_def_var(ncid, 'RELLNG2', nf90_float, (/ npointDimID /), rellng2ID))
    call nf90_err(nf90_put_att(ncid, rellng2ID, 'units', 'degrees_east'))
    call nf90_err(nf90_put_att(ncid, rellng2ID, 'long_name', &
         'release longitude upper right corner'))
    ! release latitude 1
    call nf90_err(nf90_def_var(ncid, 'RELLAT1', nf90_float, (/ npointDimID /), rellat1ID))
    call nf90_err(nf90_put_att(ncid, rellat1ID, 'units', 'degrees_north'))
    call nf90_err(nf90_put_att(ncid, rellat1ID, 'long_name', &
         'release latitude lower left corner'))
    ! release latitude 2
    call nf90_err(nf90_def_var(ncid, 'RELLAT2', nf90_float, (/ npointDimID /), rellat2ID))
    call nf90_err(nf90_put_att(ncid, rellat2ID, 'units', 'degrees_north'))
    call nf90_err(nf90_put_att(ncid, rellat2ID, 'long_name', &
         'release latitude upper right corner'))

    ! hes: if rotated_ll it would be convenient also to write the the release points in rotated_coordinates

    ! release height bottom
    call nf90_err(nf90_def_var(ncid, 'RELZZ1', nf90_float, (/ npointDimID /), relzz1ID))
    call nf90_err(nf90_put_att(ncid, relzz1ID, 'units', 'meters'))
    call nf90_err(nf90_put_att(ncid, relzz1ID, 'long_name', 'release height bottom'))
    ! release height top
    call nf90_err(nf90_def_var(ncid, 'RELZZ2', nf90_float, (/ npointDimID /), relzz2ID))
    call nf90_err(nf90_put_att(ncid, relzz2ID, 'units', 'meters'))
    call nf90_err(nf90_put_att(ncid, relzz2ID, 'long_name', 'release height top'))
    ! release kind
    call nf90_err(nf90_def_var(ncid, 'RELKINDZ', nf90_int, (/ npointDimID /), relkindzID))
    call nf90_err(nf90_put_att(ncid, relkindzID, 'long_name', 'release kind'))
    ! release start
    call nf90_err(nf90_def_var(ncid, 'RELSTART', nf90_int, (/ npointDimID /), relstartID))
    call nf90_err(nf90_put_att(ncid, relstartID, 'units', 'seconds'))
    call nf90_err(nf90_put_att(ncid, relstartID, 'long_name', &
         'release start relative to simulation start'))
    ! release end
    call nf90_err(nf90_def_var(ncid, 'RELEND', nf90_int, (/ npointDimID /), relendID))
    call nf90_err(nf90_put_att(ncid, relendID, 'units', 'seconds'))
    call nf90_err(nf90_put_att(ncid, relendID, 'long_name', &
         'release end relative to simulation start'))
    ! release particles
    call nf90_err(nf90_def_var(ncid, 'RELPART', nf90_int, (/ npointDimID /), relpartID))
    call nf90_err(nf90_put_att(ncid, relpartID, 'long_name', 'number of release particles'))
    ! release particle masses
    call nf90_err(nf90_def_var(ncid, 'RELXMASS', nf90_float, (/ npointDimID, nspecDimID /), &
         relxmassID))
    call nf90_err(nf90_put_att(ncid, relxmassID, 'long_name', 'total release particle mass'))
  end if
 
  ! age classes
  call nf90_err(nf90_def_var(ncid, 'LAGE', nf90_int, (/ nageclassDimID /), lageID))
  call nf90_err(nf90_put_att(ncid, lageID, 'units', 'seconds'))
  call nf90_err(nf90_put_att(ncid, lageID, 'long_name', 'age class'))

  ! output orography
  if (.not. min_size) then
    call nf90_err(nf90_def_var(ncid, 'ORO', nf90_int, (/ lonDimID, latDimID /), oroID,  &
      deflate_level=deflate_level, chunksizes= (/ nnx, nny /)))
    call nf90_err(nf90_put_att(ncid, oroID, 'standard_name', 'surface altitude'))
    call nf90_err(nf90_put_att(ncid, oroID, 'long_name', 'outgrid surface altitude'))
    call nf90_err(nf90_put_att(ncid, oroID, 'units', 'm'))
  end if

  ! concentration output, wet and dry deposition variables (one per species)
  call output_units(units)

  dIDs = (/ londimid, latdimid, levdimid, timedimid, pointspecdimid, nageclassdimid /)
  depdIDs = (/ londimid, latdimid, timedimid, pointspecdimid, nageclassdimid /)
  if (lnest) then
     dimidsn    = dIDs
     depdimidsn = depdIDs
  else
     dimids    = dIDs
     depdimids = depdIDs
  endif

  ! set chunksizes according to largest written portion of data in an individual call to 
  ! nf90_put_var
  if (int(nnx,kind=8)*int(nny,kind=8)*int(numzgrid,kind=8).gt.2147483647) then ! Larger than an 
    chunksizes = (/ nnx, nny, 1, 1, 1, 1 /)
  else
!    chunksizes = (/ nnx, nny, numzgrid, 1, 1, 1 /)
    chunksizes = (/ nnx, nny, numzwrite, 1, 1, 1 /)
  endif
  dep_chunksizes = (/ nnx, nny, 1, 1, 1 /)

  do i = 1,nspec
    write(anspec,'(i3.3)') i

    ! concentration output
    if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
      call nf90_err(nf90_def_var(ncid,'spec'//anspec//'_mr', nf90_float, dIDs, sID , &
           deflate_level = deflate_level,  &
           chunksizes = chunksizes ))
      call nf90_err(nf90_put_att(ncid, sID, 'units', units))
      call nf90_err(nf90_put_att(ncid, sID, 'long_name', species(i)))
      call nf90_err(nf90_put_att(ncid, sID, 'decay', decay(i)))
      call nf90_err(nf90_put_att(ncid, sID, 'weightmolar', weightmolar(i)))
    !        call nf90_err(nf90_put_att(ncid, sID, 'ohreact', ohreact(i)))
!      call nf90_err(nf90_put_att(ncid, sID, 'ohcconst', ohcconst(i)))
!      call nf90_err(nf90_put_att(ncid, sID, 'ohdconst', ohdconst(i)))
!      call nf90_err(nf90_put_att(ncid, sID, 'vsetaver', vsetaver(i)))

      if (lnest) then
         specIDn(i) = sID
      else
         specID(i) = sID
      endif
    endif

    ! mixing ratio output
    if ((iout.eq.2).or.(iout.eq.3)) then
      call nf90_err(nf90_def_var(ncid,'spec'//anspec//'_pptv', nf90_float, dIDs, sID , &
           deflate_level = deflate_level,  &
           chunksizes = chunksizes ))
      call nf90_err(nf90_put_att(ncid, sID, 'units', 'pptv'))
      call nf90_err(nf90_put_att(ncid, sID, 'long_name', species(i)))
      call nf90_err(nf90_put_att(ncid, sID, 'decay', decay(i)))
      call nf90_err(nf90_put_att(ncid, sID, 'weightmolar', weightmolar(i)))
    !        call nf90_err(nf90_put_att(ncid, sID, 'ohreact', ohreact(i)))
!      call nf90_err(nf90_put_att(ncid, sID, 'ohcconst', ohcconst(i)))
!      call nf90_err(nf90_put_att(ncid, sID, 'ohdconst', ohdconst(i)))
!      call nf90_err(nf90_put_att(ncid, sID, 'vsetaver', vsetaver(i)))

      if (lnest) then
         specIDnppt(i) = sID
      else
         specIDppt(i) = sID
      endif
    endif

    ! wet and dry deposition fields for forward runs
    if ((ldirect.eq.1).and.(wetdep)) then
      call nf90_err(nf90_def_var(ncid,'WD_spec'//anspec, nf90_float, depdIDs, &
           wdsID, deflate_level = deflate_level, &
           chunksizes = dep_chunksizes))
      call nf90_err(nf90_put_att(ncid, wdsID, 'units', '1e-12 kg m-2'))
      call nf90_err(nf90_put_att(ncid, wdsID, 'weta_gas', weta_gas(i)))
      call nf90_err(nf90_put_att(ncid, wdsID, 'wetb_gas', wetb_gas(i)))
      call nf90_err(nf90_put_att(ncid, wdsID, 'ccn_aero', ccn_aero(i)))
      call nf90_err(nf90_put_att(ncid, wdsID, 'in_aero', in_aero(i)))
      ! call nf90_err(nf90_put_att(ncid, wdsID, 'wetc_in', wetc_in(i)))
      ! call nf90_err(nf90_put_att(ncid, wdsID, 'wetd_in', wetd_in(i)))
      call nf90_err(nf90_put_att(ncid, wdsID, 'dquer', dquer(i)))
      call nf90_err(nf90_put_att(ncid, wdsID, 'henry', henry(i)))
      if (lnest) then
         wdspecIDn(i) = wdsID
      else
         wdspecID(i) = wdsID
      endif
    endif
    if ((ldirect.eq.1).and.(drydep)) then
      call nf90_err(nf90_def_var(ncid,'DD_spec'//anspec, nf90_float, depdIDs, &
           ddsID, deflate_level = deflate_level, &
           chunksizes = dep_chunksizes))
      call nf90_err(nf90_put_att(ncid, ddsID, 'units', '1e-12 kg m-2'))
      call nf90_err(nf90_put_att(ncid, ddsID, 'dryvel', dryvel(i)))
      call nf90_err(nf90_put_att(ncid, ddsID, 'reldiff', reldiff(i)))
      call nf90_err(nf90_put_att(ncid, ddsID, 'henry', henry(i)))
      call nf90_err(nf90_put_att(ncid, ddsID, 'f0', f0(i)))
      call nf90_err(nf90_put_att(ncid, ddsID, 'dquer', dquer(i)))
      call nf90_err(nf90_put_att(ncid, ddsID, 'density', density(i)))
      call nf90_err(nf90_put_att(ncid, ddsID, 'dsigma', dsigma(i)))
      if (lnest) then
         ddspecIDn(i) = ddsID
      else
         ddspecID(i) = ddsID
      endif
    endif
  end do

  ! global (metadata) attributes
  !*******************************
  call writemetadata(ncid,lnest)


  ! moves the file from define to data mode
  call nf90_err(nf90_enddef(ncid))

  ! fill with data
  !******************************
  ! longitudes (grid cell centers)
  if (lnest) then
    if (.not.allocated(coord)) allocate(coord(numxgridn))
     do i = 1,numxgridn
        coord(i) = outlon0n + (i-0.5)*dxoutn
     enddo
     call nf90_err(nf90_put_var(ncid, lonID, coord(1:numxgridn)))
     deallocate(coord)
  else
    if (.not.allocated(coord)) allocate(coord(numxgrid))
     do i = 1,numxgrid
        coord(i) = outlon0 + (i-0.5)*dxout
     enddo
     call nf90_err(nf90_put_var(ncid, lonID, coord(1:numxgrid)))
     deallocate(coord)
  endif
  ! latitudes (grid cell centers)
  if (lnest) then
    if (.not.allocated(coord)) allocate(coord(numygridn))
     do i = 1,numygridn
        coord(i) = outlat0n + (i-0.5)*dyoutn
     enddo
     call nf90_err(nf90_put_var(ncid, latID, coord(1:numygridn)))
     deallocate(coord)
  else
    if (.not.allocated(coord)) allocate(coord(numygrid))
     do i = 1,numygrid
        coord(i) = outlat0 + (i-0.5)*dyout
     enddo
     call nf90_err(nf90_put_var(ncid, latID, coord(1:numygrid)))
     deallocate(coord)
  endif
  ! levels
!  call nf90_err(nf90_put_var(ncid, levID, outheight(1:numzgrid)))
  call nf90_err(nf90_put_var(ncid, levID, outheight(1:numzwrite)))

  ! volume
  if (write_vol) then
    if (lnest) then
!      call nf90_err(nf90_put_var(ncid, volID, volumen(:,:,:)))
      call nf90_err(nf90_put_var(ncid, volID, volumen(:,:,1:numzwrite)))
    else
!      call nf90_err(nf90_put_var(ncid, volID, volume(:,:,:)))
      call nf90_err(nf90_put_var(ncid, volID, volume(:,:,1:numzwrite)))
    end if
  end if

  ! area
  if (write_area) then
    if (lnest) then
      call nf90_err(nf90_put_var(ncid, areaID, arean(:,:)))
    else
      call nf90_err(nf90_put_var(ncid, areaID, area(:,:)))
    end if
  end if

  if ((write_releases.eqv..true.).and.(ipin.ne.3).and.(ipin.ne.4)) then
    ! release point information
    do i = 1,numpoint
       call nf90_err(nf90_put_var(ncid, relstartID, ireleasestart(i), (/i/)))
       call nf90_err(nf90_put_var(ncid, relendID, ireleaseend(i), (/i/)))
       call nf90_err(nf90_put_var(ncid, relkindzID, kindz(i), (/i/)))
       xp1=xpoint1(i)*dx+xlon0
       yp1=ypoint1(i)*dy+ylat0
       xp2=xpoint2(i)*dx+xlon0
       yp2=ypoint2(i)*dy+ylat0
       call nf90_err(nf90_put_var(ncid, rellng1ID, xp1, (/i/)))
       call nf90_err(nf90_put_var(ncid, rellng2ID, xp2, (/i/)))
       call nf90_err(nf90_put_var(ncid, rellat1ID, yp1, (/i/)))
       call nf90_err(nf90_put_var(ncid, rellat2ID, yp2, (/i/)))
       call nf90_err(nf90_put_var(ncid, relzz1ID, zpoint1(i), (/i/)))
       call nf90_err(nf90_put_var(ncid, relzz2ID, zpoint2(i), (/i/)))
       call nf90_err(nf90_put_var(ncid, relpartID, npart(i), (/i/)))
       if ((i .le. 1000).and.(ipin.ne.3).and.(ipin.ne.4)) then
         call nf90_err(nf90_put_var(ncid, relcomID, compoint(i), (/1,i/), (/45,1/)))
       else
         call nf90_err(nf90_put_var(ncid, relcomID, 'NA', (/1,i/), (/45,1/)))
       endif 
       call nf90_err(nf90_put_var(ncid, relxmassID, xmass(i,1:nspec), (/i,1/), (/1,nspec/)))
    end do
  end if

  ! age classes
  call nf90_err(nf90_put_var(ncid, lageID, lage(1:nageclass)))

  ! orography 
  if (.not. min_size) then
    if (lnest) then
      call nf90_err(nf90_put_var(ncid, oroID, orooutn(0:(nnx-1), 0:(nny-1))))
    else
      call nf90_err(nf90_put_var(ncid, oroID, oroout(0:(nnx-1), 0:(nny-1))))
    endif
  end if

  call nf90_err(nf90_close(ncid))

  return
end subroutine writeheader_netcdf

subroutine read_grid_id(lnest)
  
  implicit none
  logical, intent(in) :: lnest

  integer :: ncid,i
  character(len=3)            :: anspec

  if (.not. lnest) then
    ! open output file
    call nf90_err(nf90_open(trim(ncfname), nf90_write, ncid))

    call nf90_err(nf90_inq_varid(ncid=ncid,name='time',varid=timeID))

    do i = 1,nspec
      write(anspec,'(i3.3)') i

      if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='spec'//anspec//'_mr',varid=specID(i)))
      endif
      if ((iout.eq.2).or.(iout.eq.3)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='spec'//anspec//'_pptv',varid=specIDppt(i)))
      endif
      if ((ldirect.eq.1).and.(wetdep)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='WD_spec'//anspec,varid=wdspecID(i)))
      endif
      if ((ldirect.eq.1).and.(drydep)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='DD_spec'//anspec,varid=ddspecID(i)))
      endif
    end do

  else

    ! open output file
    call nf90_err(nf90_open(trim(ncfnamen), nf90_write, ncid))

    call nf90_err(nf90_inq_varid(ncid=ncid,name='time',varid=timeIDn))

    do i = 1,nspec
      write(anspec,'(i3.3)') i

      if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='spec'//anspec//'_mr',varid=specIDn(i)))
      endif
      if ((iout.eq.2).or.(iout.eq.3)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='spec'//anspec//'_pptv',varid=specIDnppt(i)))
      endif
      if ((ldirect.eq.1).and.(wetdep)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='WD_spec'//anspec,varid=wdspecIDn(i)))
      endif
      if ((ldirect.eq.1).and.(drydep)) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name='DD_spec'//anspec,varid=ddspecIDn(i)))
      endif
    end do 
  endif

  call nf90_err(nf90_close(ncid))

end subroutine read_grid_id

subroutine concoutput_netcdf(itime,outnum,gridtotalunc,wetgridtotalunc,drygridtotalunc)
     
  !                          i     i          o             o
  !       o
  !*****************************************************************************
  !                                                                            *
  !     Output of the concentration grid and the concentrations.               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output in *
  !                    sparse matrix format; additional output of uncertainty  *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in module par_mod                  *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !     February 2010, Dominik Brunner, Empa                                   *
  !                    Adapted for COSMO                                       *
  !                    Remark: calculation of density could be improved.       *
  !                    Currently, it is calculated for the lower left corner   *
  !                    of each output grid cell rather than for its center.    *
  !                    Furthermore, the average density could be calculated    *
  !                    from the difference in pressure at the top and bottom   *
  !                    of each cell rather than by interpolation.              *
  !                                                                            *
  !     April 2013, Dominik Brunner, Empa                                      *
  !                    Adapted for netcdf output                               *
  !                                                                            *
  !     2022, Lucie Bakels:                                                    *
  !           - OpenMP parallelisation                                         *
  !           - Receptor output to NetCDF instead of binary format             *
  !                                                                            *
  !     January, 2024, Rona Thompson                                           *
  !           - removed output of receptors (new module)                       *
  !           - introduced option for LCM output                               *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! outnum          number of samples                                          *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  ! tot_mu          1 for forward, initial mass mixing ration for backw. runs  *
  !                                                                            *
  !*****************************************************************************

  use unc_mod

  implicit none

  integer, intent(in) :: itime
  real, intent(in)    :: outnum
  real(dep_prec),intent(out):: wetgridtotalunc,drygridtotalunc
  real, intent(out)   :: gridtotalunc
  integer             :: ncid,kp,ks,kz,ix,jy,iix,jjy,kzz,ngrid
  integer             :: ks_start
  integer             :: nage,i,l,jj
  real                :: tot_mu(maxspec,maxpointspec_act)
  real                :: halfheight,dz,dz1,dz2
  real                :: xl,yl
  real(dep_prec)      :: auxgrid(nclassunc)
  real(dep_prec)      :: gridtotal,gridsigmatotal
  real(dep_prec)      :: wetgridtotal,wetgridsigmatotal
  real(dep_prec)      :: drygridtotal,drygridsigmatotal
  ! real(sp)            :: gridtotal,gridsigmatotal
  ! real(sp)            :: wetgridtotal,wetgridsigmatotal
  ! real(sp)            :: drygridtotal,drygridsigmatotal
  integer             :: numzwrite

  real, parameter     :: weightair=28.97

  eps=nxmax/3.e5

  numzwrite=numzgrid
  if (sfc_only.eq.1 ) numzwrite=1

  ! open output file
  call nf90_err(nf90_open(trim(ncfname), nf90_write, ncid))

  ! write time
  tpointer = tpointer + 1
  call nf90_err(nf90_put_var( ncid, timeID, itime, (/ tpointer /)))
  
  ! For forward simulations, output fields have dimension MAXSPEC,
  ! for backward simulations, output fields have dimension MAXPOINT.
  ! Thus, make loops either about nspec, or about numpoint
  !*****************************************************************

  if (ldirect.eq.1) then
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=1.0
      end do
    end do
  else
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=xmass(kp,ks)
      end do
    end do
  endif


  gridtotal=0.
  gridsigmatotal=0.
  gridtotalunc=0.
  wetgridtotal=0._dep_prec
  wetgridsigmatotal=0._dep_prec
  wetgridtotalunc=0._dep_prec
  drygridtotal=0._dep_prec
  drygridsigmatotal=0._dep_prec
  drygridtotalunc=0._dep_prec

  !*******************************************************************
  ! Compute air density:
  ! brd134: we now take into account whether we are in the mother or in
  !    a nested domain (before only from mother domain)
  ! Determine center altitude of output layer, and interpolate density
  ! data to that altitude
  !
  ! Note:
  !  llcmoutput = true: grid is mass_spec/mass_air  
  !                     for iout 1,3, or 5 multiply by rho
  !                     for iout 2 multiply by 1
  !  llcmoutput = false: grid is mass_spec/V
  !                     for iout 1,3, or 5 multiply by 1
  !                     for iout 2 multiply by 1/rho
  !*******************************************************************

!$OMP PARALLEL PRIVATE(halfheight,kzz,dz1,dz2,dz,xl,yl,ngrid,iix,jjy, &
!$OMP kz,ix,jy,l,ks,kp,nage,auxgrid) REDUCTION(+:wetgridtotal,wetgridsigmatotal, &
!$OMP drygridtotal,drygridsigmatotal,gridtotal,gridsigmatotal)

  if (((.not.llcmoutput).and.(iout.eq.2)).or.&
      (llcmoutput.and.((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)))) then
    ! compute density
!$OMP DO
    do kz=1,numzgrid
      if (kz.eq.1) then
        halfheight=outheight(1)*0.5
      else
        halfheight=(outheight(kz)+outheight(kz-1))*0.5
      endif
      do kzz=2,nz
        if ((height(kzz-1).lt.halfheight).and. &
             (height(kzz).gt.halfheight)) exit
      end do
      kzz=max(min(kzz,nz),2)
      dz1=halfheight-height(kzz-1)
      dz2=height(kzz)-halfheight
      dz=dz1+dz2

      do jy=0,numygrid-1
        do ix=0,numxgrid-1
          xl=outlon0+real(ix)*dxout
          yl=outlat0+real(jy)*dyout
          ! grid index in mother domain
          xl=(xl-xlon0)/dx
          yl=(yl-ylat0)/dx

          ngrid=0
          do jj=numbnests,1,-1
            if ( xl.gt.xln(jj)+eps .and. xl.lt.xrn(jj)-eps .and. &
                   yl.gt.yln(jj)+eps .and. yl.lt.yrn(jj)-eps ) then
              ngrid=jj
              exit 
            end if
          end do

          if (ngrid.eq.0) then
            iix=max(min(nint(xl),nxmin1),0) ! if output grid cell is outside mother domain
            jjy=max(min(nint(yl),nymin1),0)

            densityoutgrid(ix,jy,kz)=(rho(iix,jjy,kzz,memind(2))*dz1+ &
              rho(iix,jjy,kzz-1,memind(2))*dz2)/dz
          else
            xl=(xl-xln(ngrid))*xresoln(ngrid)
            yl=(yl-yln(ngrid))*yresoln(ngrid)
            iix=max(min(nint(xl),nxn(ngrid)-1),0)
            jjy=max(min(nint(yl),nyn(ngrid)-1),0)

            densityoutgrid(ix,jy,kz)=(rhon(iix,jjy,kzz,memind(2), ngrid)*dz1+ &
              rhon(iix,jjy,kzz-1,memind(2), ngrid)*dz2)/dz
          endif
        end do
      end do
    end do
!$OMP END DO NOWAIT
    if (llcmoutput) then
      ! because divide grid by densityoutgrid
      densityoutgrid=1./densityoutgrid
    endif
  else
    ! no division by density
    densityoutgrid(:,:,:)=1.
  endif ! llcmoutput

  ! Output is different for forward and backward simulations
  if (ldirect.eq.1) then
!$OMP DO
    do kz=1,numzgrid
      do jy=0,numygrid-1
         do ix=0,numxgrid-1
            if (llcmoutput) then
              factor3d(ix,jy,kz)=1.e12/gridcnt(ix,jy,kz)
            else
              factor3d(ix,jy,kz)=1.e12/volume(ix,jy,kz)/outnum
            endif
         end do
      end do
    end do
!$OMP END DO
  else
!$OMP DO
    do kz=1,numzgrid
      do jy=0,numygrid-1
         do ix=0,numxgrid-1
            factor3d(ix,jy,kz)=real(abs(loutaver))/outnum
         end do
      end do
    end do
!$OMP END DO
  endif

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  if (llcmoutput) then
    ks_start=2
  else
    ks_start=1
  endif

  do ks=ks_start,nspec

    do kp=1,maxpointspec_act
      do nage=1,nageclass
!$OMP DO
        do jy=0,numygrid-1
          do ix=0,numxgrid-1

            ! WET DEPOSITION
            if ((wetdep).and.(ldirect.gt.0)) then
              if (mpi_mode.gt.0) then
                do l=1,nclassunc
                  auxgrid(l)=wetgridunc0(ix,jy,ks,kp,l,nage)
                end do
              else
                do l=1,nclassunc
                  auxgrid(l)=wetgridunc(ix,jy,ks,kp,l,nage)
                end do
              end if
              call mean(auxgrid,wetgrid(ix,jy), &
                   wetgridsigma(ix,jy),nclassunc)
              ! Multiply by number of classes to get total concentration
              wetgrid(ix,jy)=wetgrid(ix,jy)*real(nclassunc,kind=sp)
              wetgridtotal=wetgridtotal+wetgrid(ix,jy)
              ! Calculate standard deviation of the mean
              wetgridsigma(ix,jy)= &
                   wetgridsigma(ix,jy)* &
                   sqrt(real(nclassunc,kind=dep_prec))
              wetgridsigmatotal=wetgridsigmatotal+ &
                   wetgridsigma(ix,jy)
            endif

            ! DRY DEPOSITION
            if ((drydep).and.(ldirect.gt.0)) then
              if (mpi_mode.gt.0) then
                do l=1,nclassunc
                  auxgrid(l)=drygridunc0(ix,jy,ks,kp,l,nage)
                end do
              else
                do l=1,nclassunc
                  auxgrid(l)=drygridunc(ix,jy,ks,kp,l,nage)
                end do
              end if
              call mean(auxgrid,drygrid(ix,jy), &
                   drygridsigma(ix,jy),nclassunc)
              ! Multiply by number of classes to get total concentration
              drygrid(ix,jy)=drygrid(ix,jy)*real(nclassunc,kind=sp)
              drygridtotal=drygridtotal+drygrid(ix,jy)
              ! Calculate standard deviation of the mean
              drygridsigma(ix,jy)= &
                   drygridsigma(ix,jy)* &
                   sqrt(real(nclassunc, kind=dep_prec))
              drygridsigmatotal=drygridsigmatotal+ &
                   drygridsigma(ix,jy)
            endif

            ! CONCENTRATION OR MIXING RATIO
            do kz=1,numzgrid
              do l=1,nclassunc
                auxgrid(l)=gridunc(ix,jy,kz,ks,kp,l,nage)
              end do
              call mean(auxgrid,grid(ix,jy,kz), &
                   gridsigma(ix,jy,kz),nclassunc)
              ! Multiply by number of classes to get total concentration
              grid(ix,jy,kz)= &
                   grid(ix,jy,kz)*real(nclassunc)
              gridtotal=gridtotal+grid(ix,jy,kz)
              ! Calculate standard deviation of the mean
              gridsigma(ix,jy,kz)= &
                   gridsigma(ix,jy,kz)* &
                   sqrt(real(nclassunc))
              gridsigmatotal=gridsigmatotal+ &
                   gridsigma(ix,jy,kz)
            end do
          end do
        end do
!$OMP END DO
  !       print*,gridtotal,maxpointspec_act

        !*******************************************************************
        ! Generate output: may be in concentration (ng/m3) or in mixing
        ! ratio (ppt) or both
        ! Output the position and the values alternated multiplied by
        ! 1 or -1, first line is number of values, number of positions
        ! For backward simulations, the unit is seconds, stored in grid_time
        !*******************************************************************

        ! Concentration output
        !*********************
!$OMP BARRIER
!$OMP SINGLE
        if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then

          ! Wet deposition
          if ((ldirect.eq.1).and.(WETDEP)) then
            call nf90_err(nf90_put_var(ncid,wdspecID(ks),1.e12*&
                 wetgrid(0:numxgrid-1,0:numygrid-1)/area(0:numxgrid-1,0:numygrid-1),&
                 (/ 1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,1,1,1 /)))
          end if

          ! Dry deposition
          if ((ldirect.eq.1).and.(DRYDEP)) then
            call nf90_err(nf90_put_var(ncid,ddspecID(ks),1.e12*&
                 drygrid(0:numxgrid-1,0:numygrid-1)/area(0:numxgrid-1,0:numygrid-1),&
                 (/ 1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,1,1,1 /)))
          endif

          ! Concentrations
!          call nf90_err(nf90_put_var(ncid,specID(ks),grid(0:numxgrid-1,0:numygrid-1,&
!             1:numzgrid)*factor3d(0:numxgrid-1,0:numygrid-1,1:numzgrid)/tot_mu(ks,kp),&
!               (/ 1,1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,numzgrid,1,1,1 /) ))
          call nf90_err(nf90_put_var(ncid,specID(ks),grid(0:numxgrid-1,0:numygrid-1,&
             1:numzwrite)*factor3d(0:numxgrid-1,0:numygrid-1,1:numzwrite)/tot_mu(ks,kp),&
               (/ 1,1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,numzwrite,1,1,1 /) ))
 
        endif !  concentration output

        ! Mixing ratio output
        !********************

        if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio

          ! Wet deposition
          if ((ldirect.eq.1).and.(WETDEP)) then
            call nf90_err(nf90_put_var(ncid,wdspecID(ks),1.e12*&
                 wetgrid(0:numxgrid-1,0:numygrid-1)/area(0:numxgrid-1,0:numygrid-1),&
                 (/ 1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,1,1,1 /)))

          endif

          ! Dry deposition
          if ((ldirect.eq.1).and.(DRYDEP)) then
            call nf90_err(nf90_put_var(ncid,ddspecID(ks),1.e12*&
                 drygrid(0:numxgrid-1,0:numygrid-1)/area(0:numxgrid-1,0:numygrid-1),&
                 (/ 1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,1,1,1 /)))
          endif

          ! Mixing ratios
!          call nf90_err(nf90_put_var(ncid,specIDppt(ks),weightair/weightmolar(ks)*&
!               grid(0:numxgrid-1,0:numygrid-1,1:numzgrid)*&
!               factor3d(0:numxgrid-1,0:numygrid-1,1:numzgrid)/&
!               densityoutgrid(0:numxgrid-1,0:numygrid-1,1:numzgrid),&
!               (/ 1,1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,numzgrid,1,1,1 /)))
          call nf90_err(nf90_put_var(ncid,specIDppt(ks),weightair/weightmolar(ks)*&
               grid(0:numxgrid-1,0:numygrid-1,1:numzwrite)*&
               factor3d(0:numxgrid-1,0:numygrid-1,1:numzwrite)/&
               densityoutgrid(0:numxgrid-1,0:numygrid-1,1:numzwrite),&
               (/ 1,1,1,tpointer,kp,nage /), (/ numxgrid,numygrid,numzwrite,1,1,1 /)))

        endif ! output for ppt
!$OMP END SINGLE
!$OMP BARRIER
      end do ! nageclass
    end do ! maxpointspec_act

  end do ! nspec
!$OMP END PARALLEL

  if (gridtotal.gt.0.) gridtotalunc=real(gridsigmatotal/gridtotal,kind=sp)
  if (wetgridtotal.gt.0.) wetgridtotalunc=wetgridsigmatotal/ &
       wetgridtotal
  if (drygridtotal.gt.0.) drygridtotalunc=real(drygridsigmatotal/ &
       drygridtotal, kind=dep_prec)

  ! Close netCDF file
  !**************************
  call nf90_err(nf90_close(ncid))

  ! Reinitialization of grid
  !*************************
  gridunc(:,:,:,1:nspec,:,:,1:nageclass) = 0.  
  gridcnt(:,:,:) = 0.
#ifdef _OPENMP
  gridunc_omp(:,:,:,:,:,:,:,:) = 0.  
  gridcnt_omp(:,:,:,:) = 0.
#endif

end subroutine concoutput_netcdf


subroutine concoutput_nest_netcdf(itime,outnum)
  !                               i     i 
  !*****************************************************************************
  !                                                                            *
  !     Output of the concentration grid and the concentrations.               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output in *
  !                    sparse matrix format; additional output of uncertainty  *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                    are now specified in module par_mod                     *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                    in order to save disk space                             *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !     19 February 2010, Dominik Brunner, Empa: Adapted for COSMO             *
  !                                                                            *
  !     April 2013, Dominik Brunner, Empa                                      *
  !                    Adapted for netcdf output                               *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime           current simulation time                                    *
  ! outnum          number of samples                                          *
  !                                                                            *
  !*****************************************************************************

  use unc_mod, only: griduncn,drygriduncn,wetgriduncn,drygriduncn0,wetgriduncn0
 
  implicit none

  integer, intent(in) :: itime
  real, intent(in)    :: outnum
  integer             :: ncid,kp,ks,kz,ix,jy,iix,jjy,kzz,ngrid
  integer             :: nage,i,l,jj
  real                :: tot_mu(maxspec,maxpointspec_act)
  real                :: halfheight,dz,dz1,dz2
  real                :: xl,yl
  real(dep_prec)      :: auxgrid(nclassunc)
  real                :: gridtotal
  real, parameter     :: weightair=28.97
  integer             :: numzwrite

  eps=nxmax/3.e5

  numzwrite=numzgrid
  if (sfc_only.eq.1 ) numzwrite=1

  ! open output file
  call nf90_err(nf90_open(trim(ncfnamen), nf90_write, ncid))

  ! write time (do not increase time counter here, done in main output domain)
  call nf90_err(nf90_put_var( ncid, timeID, itime, (/ tpointer /)))
  
  ! For forward simulations, output fields have dimension MAXSPEC,
  ! for backward simulations, output fields have dimension MAXPOINT.
  ! Thus, make loops either about nspec, or about numpoint
  !*****************************************************************

  if (ldirect.eq.1) then
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=1.0
      end do
    end do
  else
    do ks=1,nspec
      do kp=1,maxpointspec_act
        tot_mu(ks,kp)=xmass(kp,ks)
      end do
    end do
  endif

  gridtotal=0.
  !*******************************************************************
  ! Compute air density:
  ! brd134: we now take into account whether we are in the mother or in
  !    a nested domain (before only from mother domain)
  ! Determine center altitude of output layer, and interpolate density
  ! data to that altitude
  !*******************************************************************
!$OMP PARALLEL PRIVATE(halfheight,kzz,dz1,dz2,dz,xl,yl,ngrid,iix,jjy, &
!$OMP kz,ix,jy,l,ks,kp,nage,auxgrid) REDUCTION(+:gridtotal)
!$OMP DO
  do kz=1,numzgrid
    if (kz.eq.1) then
      halfheight=outheight(1)*0.5
    else
      halfheight=(outheight(kz)+outheight(kz-1))*0.5
    endif
    do kzz=2,nz
      if ((height(kzz-1).lt.halfheight).and. &
           (height(kzz).gt.halfheight)) exit
    end do
    kzz=max(min(kzz,nz),2)
    dz1=halfheight-height(kzz-1)
    dz2=height(kzz)-halfheight
    dz=dz1+dz2

    do jy=0,numygridn-1
      do ix=0,numxgridn-1
        xl=outlon0n+real(ix)*dxoutn
        yl=outlat0n+real(jy)*dyoutn
        xl=(xl-xlon0)/dx
        yl=(yl-ylat0)/dy

        ngrid=0
        do jj=numbnests,1,-1
          if ( xl.gt.xln(jj)+eps .and. xl.lt.xrn(jj)-eps .and. &
                 yl.gt.yln(jj)+eps .and. yl.lt.yrn(jj)-eps ) then
            ngrid=jj
            exit 
          end if
        end do

        if (ngrid.eq.0) then
          iix=max(min(nint(xl),nxmin1),0)
          jjy=max(min(nint(yl),nymin1),0)

          densityoutgrid(ix,jy,kz)=(rho(iix,jjy,kzz,memind(2))*dz1+ &
             rho(iix,jjy,kzz-1,memind(2))*dz2)/dz
        else
          xl=(xl-xln(ngrid))*xresoln(ngrid)
          yl=(yl-yln(ngrid))*yresoln(ngrid)
          iix=max(min(nint(xl),nxn(ngrid)-1),0)
          jjy=max(min(nint(yl),nyn(ngrid)-1),0)
          densityoutgrid(ix,jy,kz)=(rhon(iix,jjy,kzz,memind(2), ngrid)*dz1+ &
             rhon(iix,jjy,kzz-1,memind(2), ngrid)*dz2)/dz
        endif

      end do
    end do
  end do
!$OMP END DO NOWAIT

  ! Output is different for forward and backward simulations
  if (ldirect.eq.1) then
!$OMP DO
     do kz=1,numzgrid
        do jy=0,numygridn-1
           do ix=0,numxgridn-1
              factor3d(ix,jy,kz)=1.e12/volumen(ix,jy,kz)/outnum
           end do
        end do
     end do
!$OMP END DO
  else
!$OMP DO
     do kz=1,numzgrid
        do jy=0,numygridn-1
           do ix=0,numxgridn-1
              factor3d(ix,jy,kz)=real(abs(loutaver))/outnum
           end do
        end do
     end do
!$OMP END DO
  endif

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  do ks=1,nspec

    do kp=1,maxpointspec_act
      do nage=1,nageclass
!$OMP DO
        do jy=0,numygridn-1
          do ix=0,numxgridn-1
            ! WET DEPOSITION
            if ((WETDEP).and.(ldirect.gt.0)) then
              if (mpi_mode.gt.0) then
                do l=1,nclassunc
                  auxgrid(l)=wetgriduncn0(ix,jy,ks,kp,l,nage)
                end do
              else
                do l=1,nclassunc
                  auxgrid(l)=wetgriduncn(ix,jy,ks,kp,l,nage)
                end do
              end if
              call mean(auxgrid,wetgrid(ix,jy), &
                   wetgridsigma(ix,jy),nclassunc)
              ! Multiply by number of classes to get total concentration
              wetgrid(ix,jy)=wetgrid(ix,jy)*real(nclassunc)
              ! Calculate standard deviation of the mean
              wetgridsigma(ix,jy)= &
                   wetgridsigma(ix,jy)* &
                   sqrt(real(nclassunc,kind=dep_prec))
            endif

            ! DRY DEPOSITION
            if ((DRYDEP).and.(ldirect.gt.0)) then
              if (mpi_mode.gt.0) then
                do l=1,nclassunc
                  auxgrid(l)=drygriduncn0(ix,jy,ks,kp,l,nage)
                end do
              else
                do l=1,nclassunc
                  auxgrid(l)=drygriduncn(ix,jy,ks,kp,l,nage)
                end do
              end if
              call mean(auxgrid,drygrid(ix,jy), &
                   drygridsigma(ix,jy),nclassunc)
              ! Multiply by number of classes to get total concentration
              drygrid(ix,jy)=drygrid(ix,jy)*real(nclassunc)
              ! Calculate standard deviation of the mean
              drygridsigma(ix,jy)= &
                   drygridsigma(ix,jy)* &
                   sqrt(real(nclassunc,kind=dep_prec))
            endif

            ! CONCENTRATION OR MIXING RATIO
            do kz=1,numzgrid
              do l=1,nclassunc
                auxgrid(l)=griduncn(ix,jy,kz,ks,kp,l,nage)
              end do
              call mean(auxgrid,grid(ix,jy,kz), &
                   gridsigma(ix,jy,kz),nclassunc)
              ! Multiply by number of classes to get total concentration
              grid(ix,jy,kz)= &
                   grid(ix,jy,kz)*real(nclassunc)
              gridtotal=gridtotal+grid(ix,jy,kz)
              ! Calculate standard deviation of the mean
              gridsigma(ix,jy,kz)= &
                   gridsigma(ix,jy,kz)* &
                   sqrt(real(nclassunc))
            end do
          end do
        end do
!$OMP END DO
  !       print*,gridtotal,maxpointspec_act

        !*******************************************************************
        ! Generate output: may be in concentration (ng/m3) or in mixing
        ! ratio (ppt) or both
        ! Output the position and the values alternated multiplied by
        ! 1 or -1, first line is number of values, number of positions
        ! For backward simulations, the unit is seconds, stored in grid_time
        !*******************************************************************

        ! Concentration output
        !*********************
!$OMP SINGLE
        if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then

          ! Wet deposition
          if ((ldirect.eq.1).and.(WETDEP)) then
             call nf90_err(nf90_put_var(ncid,wdspecIDn(ks),1.e12*&
                  wetgrid(0:numxgridn-1,0:numygridn-1)/arean(0:numxgridn-1,0:numygridn-1),&
                  (/ 1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,1,1,1 /)))
          endif

          ! Dry deposition
          if ((ldirect.eq.1).and.(DRYDEP)) then
             call nf90_err(nf90_put_var(ncid,ddspecIDn(ks),1.e12*&
                  drygrid(0:numxgridn-1,0:numygridn-1)/arean(0:numxgridn-1,0:numygridn-1),&
                  (/ 1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,1,1,1 /)))
          endif

          ! Concentrations
!          call nf90_err(nf90_put_var(ncid,specIDn(ks),grid(0:numxgridn-1,0:numygridn-1,&
!             1:numzgrid)*factor3d(0:numxgridn-1,0:numygridn-1,1:numzgrid)/tot_mu(ks,kp),&
!               (/ 1,1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,numzgrid,1,1,1 /)))
          call nf90_err(nf90_put_var(ncid,specIDn(ks),grid(0:numxgridn-1,0:numygridn-1,&
             1:numzwrite)*factor3d(0:numxgridn-1,0:numygridn-1,1:numzwrite)/tot_mu(ks,kp),&
               (/ 1,1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,numzwrite,1,1,1 /)))
 
        endif !  concentration output

        ! Mixing ratio output
        !********************

        if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio

          ! Wet deposition
          if ((ldirect.eq.1).and.(WETDEP)) then
             call nf90_err(nf90_put_var(ncid,wdspecIDn(ks),1.e12*&
                  wetgrid(0:numxgridn-1,0:numygridn-1)/arean(0:numxgridn-1,0:numygridn-1),&
                  (/ 1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,1,1,1 /)))
          endif

          ! Dry deposition
          if ((ldirect.eq.1).and.(DRYDEP)) then
             call nf90_err(nf90_put_var(ncid,ddspecIDn(ks),1.e12*&
                  drygrid(0:numxgridn-1,0:numygridn-1)/arean(0:numxgridn-1,0:numygridn-1),&
                  (/ 1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,1,1,1 /)))
          endif

          ! Mixing ratios
!          call nf90_err(nf90_put_var(ncid,specIDnppt(ks),weightair/weightmolar(ks)*&
!               grid(0:numxgridn-1,0:numygridn-1,1:numzgrid)*&
!               factor3d(0:numxgridn-1,0:numygridn-1,1:numzgrid)/&
!               densityoutgrid(0:numxgridn-1,0:numygridn-1,1:numzgrid),&
!               (/ 1,1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,numzgrid,1,1,1 /)))
          call nf90_err(nf90_put_var(ncid,specIDnppt(ks),weightair/weightmolar(ks)*&
               grid(0:numxgridn-1,0:numygridn-1,1:numzwrite)*&
               factor3d(0:numxgridn-1,0:numygridn-1,1:numzwrite)/&
               densityoutgrid(0:numxgridn-1,0:numygridn-1,1:numzwrite),&
               (/ 1,1,1,tpointer,kp,nage /), (/ numxgridn,numygridn,numzwrite,1,1,1 /)))

        endif ! output for ppt
!$OMP END SINGLE
!$OMP BARRIER
      end do
    end do

  end do
!$OMP END PARALLEL
  ! Close netCDF file
  !**************************
  call nf90_err(nf90_close(ncid))

  ! Reinitialization of grid
  !*************************

  griduncn(:,:,:,1:nspec,:,:,1:nageclass) = 0.  

end subroutine concoutput_nest_netcdf

! subroutine concoutput_sfc_nest_netcdf(itime,outnum)

!   implicit none

!   integer, intent(in) :: itime
!   real, intent(in)    :: outnum

!   print*,'Netcdf output for surface only not yet implemented'
! end subroutine concoutput_sfc_nest_netcdf

subroutine create_particles_initialoutput(itime,idate,itime_start,idate_start)

  !*****************************************************************************
  !                                                                            *
  !   This subroutine creates an initial particle positions and properties     *
  !   NetCDF file: partinit_xxx.nc                                             *
  !   The release time, release number and positions, together with all fields *
  !   specified in the PARTOPTIONS option file will saved.                     *
  !                                                                            *
  !   Author: L. Bakels 2022                                                   *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer, intent(in) :: itime,idate,itime_start,idate_start
  ! integer, intent(in) :: irelease
  integer             :: ncid,j,np
  integer             :: partDimID
  character(len=11)   :: fprefix
  character(len=3)    :: anspec
  character           :: adate*8,atime*6,adate_start*8,atime_start*6,timeunit*32
  character(len=255)  :: fname_partoutput
  real                :: fillval

  write(adate,'(i8.8)') idate
  write(atime,'(i6.6)') itime
  write(adate_start,'(i8.8)') idate_start
  write(atime_start,'(i6.6)') itime_start
  ! write(arelease, '(i3.3)') irelease
  fprefix = 'partinit_'!rel'//arelease//'_'

  fname_partoutput = path(2)(1:length(2))//trim(fprefix)//adate//atime//'.nc'
  !ncfname_part(irelease) = fname_partoutput
  ncfname_partinit = fname_partoutput

  call nf90_err(nf90_create(trim(fname_partoutput), cmode = nf90_hdf5, ncid = ncid))!, &
    ! cache_size = cache_size))

  ! create dimensions:
  !*************************
  
  ! particle
  partinitpointer=0
  call nf90_err(nf90_def_dim(ncid, 'particle', nf90_unlimited, partDimID))

  ! create variables
  !*************************

  ! particles
  call nf90_err(nf90_def_var(ncid, 'particle', nf90_int, (/ partDimID/), partIDi))
  call nf90_err(nf90_put_att(ncid, partIDi, 'long_name', 'particle index'))

  fillval = -1.
  ! time
  timeunit = 'seconds since '//adate_start(1:4)//'-'//adate_start(5:6)// &
     '-'//adate_start(7:8)//' '//atime_start(1:2)//':'//atime_start(3:4)

  call write_to_file(ncid,'time',nf90_int,(/ partDimID /),tIDi,(/ 1 /), &
    timeunit,.false.,'time','time of release')
  call nf90_err(nf90_put_att(ncid, tIDi, 'axis', 't'))
  call nf90_err(nf90_put_att(ncid, tIDi, 'calendar', 'proleptic_gregorian'))
  call nf90_err(nf90_put_att(ncid, tIDi, 'description', 'time of release'))

  ! lon  
  call write_to_file(ncid,'lon',nf90_float,(/ partDimID /),lonIDi,(/ 1 /), &
    'degrees_east',.false.,'longitude','longitude in degree east')
  call nf90_err(nf90_put_att(ncid, lonIDi, 'axis', 'Lon'))
  call nf90_err(nf90_put_att(ncid, lonIDi, 'description', 'longitude of particles'))

  ! lat
  call write_to_file(ncid,'lat',nf90_float,(/ partDimID /),latIDi,(/ 1 /), &
    'degrees_north',.false.,'latitude','latitude in degree north')
  call nf90_err(nf90_put_att(ncid, latIDi, 'axis', 'Lat'))
  call nf90_err(nf90_put_att(ncid, latIDi, 'description', 'latitude of particles'))

  ! height
  call write_to_file(ncid,'z',nf90_float,(/ partDimID /),levIDi,(/ 1 /), &
   'meters',.true.,'height','height above ground')

  ! release
  call write_to_file(ncid,'release',nf90_int,(/ partDimID /),relIDi,(/ 1 /), &
   '',.true.,'release','particle release')

  do np=1,num_partopt
    if (.not. partopt(np)%print) cycle
    select case(partopt(np)%name)
      case ('PV') ! Potential vorticity
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),pvIDi,(/ 1 /), &
          'pvu',.false.,'potential_vorticity','potential vorticity')
      case ('PR') ! Pressure
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),prIDi,(/ 1 /), &
          'Pa',.false.,'pressure','pressure')
      case ('QV') ! Specific humidity
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),qvIDi,(/ 1 /), &
          '',.false.,'specific_humidity','specific humidity')
      case ('RH') ! Density
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),rhoIDi,(/ 1 /), &
          'kg/m3',.true.,'density','density')
      case ('TT') ! Temperature
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),ttIDi,(/ 1 /), &
          'K',.true.,'temperature','temperature')
      case ('UU')
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),uIDi,(/ 1 /), &
          'm/s',.false.,'u','longitudinal velocity')
      case ('VV')
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),vIDi,(/ 1 /), &
          'm/s',.false.,'v','latitudinal velocity')
      case ('WW')
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),wIDi,(/ 1 /), &
          'm/s',.false.,'w','vertical velocity')
      case ('MA')
        do j=1,nspec
          ! Masses
          write(anspec, '(i3.3)') j
          call write_to_file(ncid,trim(partopt(np)%short_name)//anspec,nf90_float,(/ partDimID /),massIDi(j), &
            (/ 1 /),'kg',.true.,'mass'//anspec,'mass for nspec'//anspec) 
        end do        
      case ('TO')
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),topoIDi,(/ 1 /), &
          'meters',.false.,'topography','topography above sealevel')
      case ('TR')
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),trIDi,(/ 1 /), &
          'meters',.true.,'htropo','height above ground of tropopause')
      case ('HM') ! Mixing layer height
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ partDimID /),hmixIDi,(/ 1 /), &
          'meters',.true.,'hmix','height above ground of mixing layer')        
      case default
        cycle
    end select
  end do

  ! moves the file from define to data mode
  call nf90_err(nf90_enddef(ncid))

  call nf90_err(nf90_close(ncid))
end subroutine create_particles_initialoutput

subroutine wrt_part_initialpos(itime,istart,iend)

  !*****************************************************************************
  !                                                                            *
  !   This subroutine saves initial particle positions, release time and       *
  !   releasenumber to a NetCDF file created in create_particles_initialoutput *
  !   evertime a new particle is spawned.                                      *
  !                                                                            *
  !   Author: L. Bakels 2022                                                   *
  !                                                                            *
  !*****************************************************************************

  use particle_mod

  implicit none

  integer, intent(in) ::  &
    itime,               & ! time of particle release
    istart,              & ! index of first newly released particle
    iend                   ! index of last newly released partile
  integer, allocatable    :: partindices(:),releasetimes(:)
  integer :: newpart,ncid,j

  newpart = iend-istart
  if (newpart.eq.0) return
  write(*,*) newpart, ' particles are being added to partinit.'
  call nf90_err(nf90_open(trim(ncfname_partinit), nf90_write, ncid))

  allocate ( partindices(newpart) )

  do j=1,newpart
    partindices(j)=j+partinitpointer
  end do

  partinitpointer1= partinitpointer+1 ! this is also used in partinit_netcdf
  call nf90_err(nf90_put_var(ncid,partIDi,partindices,(/ partinitpointer1 /),(/ newpart /)))
  deallocate (partindices)

  allocate ( releasetimes(newpart) )
  releasetimes=itime
  call nf90_err(nf90_put_var(ncid,tIDi,releasetimes,(/ partinitpointer1 /),(/ newpart /)))
  deallocate (releasetimes)
  call nf90_err(nf90_put_var(ncid,lonIDi,xlon0+part(partinitpointer1:iend)%xlon*dx, (/ partinitpointer1 /),(/ newpart /)))
  call nf90_err(nf90_put_var(ncid,latIDi,ylat0+part(partinitpointer1:iend)%ylat*dy, (/ partinitpointer1 /),(/ newpart /)))
  call nf90_err(nf90_put_var(ncid,levIDi,part(partinitpointer1:iend)%z, (/ partinitpointer1 /),(/ newpart /)))
  call nf90_err(nf90_put_var(ncid,relIDi,part(partinitpointer1:iend)%npoint, (/ partinitpointer1 /),(/ newpart /)))

  call nf90_err(nf90_close(ncid))

  partinitpointer = partinitpointer+newpart
end subroutine wrt_part_initialpos

subroutine partinit_netcdf(field,fieldname,imass,ncid)

  !*****************************************************************************
  !                                                                            *
  !   This subroutine saves properties chosen by the user in PARTOPTIONS       *
  !   to a NetCDF file created in create_particles_initialoutput.              *
  !   This happens whenever a new particle is spawned.                         *
  !                                                                            *
  !   Author: L. Bakels 2022                                                   *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer, intent(in)            :: imass
  real, intent(in)               :: field(:)
  character(2), intent(in)       :: fieldname  ! input field to interpolate over
  integer                        :: ncid,newpart

  newpart = partinitpointer - (partinitpointer1-1)

  select case(fieldname)
    case('TO') ! Topography
      call nf90_err(nf90_put_var(ncid,topoIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('PV') ! Potential vorticity
      call nf90_err(nf90_put_var(ncid,pvIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('PR') ! Pressure
      call nf90_err(nf90_put_var(ncid,prIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('QV') ! Specific humidity
      call nf90_err(nf90_put_var(ncid,qvIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('RH') ! Air density
      call nf90_err(nf90_put_var(ncid,rhoIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('UU') ! Longitudinal velocity
      call nf90_err(nf90_put_var(ncid,uIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('VV') ! Latitudinal velocity
      call nf90_err(nf90_put_var(ncid,vIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('WW') ! Vertical velocity
      call nf90_err(nf90_put_var(ncid,wIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('TT') ! Temperature
      call nf90_err(nf90_put_var(ncid,ttIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('MA') ! Mass
      call nf90_err(nf90_put_var(ncid,massIDi(imass),field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('TR') ! Tropopause
      call nf90_err(nf90_put_var(ncid,trIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case('HM') ! Mixing height
      call nf90_err(nf90_put_var(ncid,hmixIDi,field(partinitpointer1:partinitpointer), &
        (/ partinitpointer1 /),(/ newpart /)))
    case default
      return
  end select
end subroutine partinit_netcdf

subroutine writeheader_partoutput(itime,idate,itime_start,idate_start)!,irelease)

  !*****************************************************************************
  !                                                                            *
  !   This subroutine creates a file (partoutput_xxx.nc), where every time     *
  !   interval particle properties specified in the PARTOPTIONS option file    *
  !   are saved to. Running options are saved as header informtion to this     *
  !   file as well.                                                            *
  !                                                                            *
  !   Author: L. Bakels 2021                                                   *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer, intent(in) :: itime,idate,itime_start,idate_start
  ! integer, intent(in) :: irelease
  integer             :: ncid,j,i,totpart,np
  integer             :: timeDimID,partDimID,tID
  integer             :: latDimID, lonDimID, lonID, latID
  character(len=255)  :: fprefix_part
  character(len=3)    :: anspec
  character           :: adate*8,atime*6,adate_start*8,atime_start*6,timeunit*32
  real, allocatable, dimension(:) :: coord

  logical,save :: first_time=.true.

  open(unit=unittmp,file=trim(path(2)(1:length(2)))//'test_dir.txt',status='replace',&
       &err=110)
  close (unittmp, status='delete')

  write(adate,'(i8.8)') idate
  write(atime,'(i6.6)') itime
  write(adate_start,'(i8.8)') idate_start
  write(atime_start,'(i6.6)') itime_start
  
  timeunit = 'seconds since '//adate_start(1:4)//'-'//adate_start(5:6)// &
       '-'//adate_start(7:8)//' '//atime_start(1:2)//':'//atime_start(3:4)

  ! write(arelease, '(i3.3)') irelease
  fprefix_part = 'partoutput_'//adate//atime !rel'//arelease//'_'

  ! Reset logicals that ensure ony 1 write out in case of domainfill
  topo_written=.false.
  mass_written=.false.
  massav_written=.false.

  totpart=0
  if (ipin.gt.1) then ! Not reading from a release has no npart
    totpart=numpart
  else
    do j=1,numpoint
      totpart = totpart+npart(j)
    end do
  endif
  !totpart = maxpart!max(numpart,totpart)
  !cache_size = 4 * 1 * (12+nspec)
  ncfname_part = path(2)(1:length(2))//trim(fprefix_part)
  if (lpartoutputperfield) then
    do np=1,num_partopt
      if (.not. partopt(np)%print ) cycle
      if (first_time) then
        call nf90_err(nf90_create(trim(ncfname_part)//'_'//trim(partopt(np)%long_name)//'_init.nc', &
          cmode = nf90_hdf5, ncid = partopt(np)%ncid))
        ncfname_part_end = '_init.nc'
      else
        call nf90_err(nf90_create(trim(ncfname_part)//'_'//trim(partopt(np)%long_name)//'.nc', &
          cmode = nf90_hdf5, ncid = partopt(np)%ncid))
        ncfname_part_end = '.nc'
      endif
    end do
    first_time=.false.
  else 
    if (first_time) then
      ncfname_part = path(2)(1:length(2))//trim(fprefix_part)//'_init.nc'
      first_time=.false.
    else
      ncfname_part = path(2)(1:length(2))//trim(fprefix_part)//'.nc'
    endif
    call nf90_err(nf90_create(trim(ncfname_part), cmode = nf90_hdf5, ncid = ncid))!, &
      ! cache_size = cache_size))    
  endif

  write(*,*) 'Write header, nspec,numpart,totpart: ', nspec,numpart,totpart

  if (lpartoutputperfield) then
    do np=1,num_partopt
      if (.not. partopt(np)%print) cycle
      call writeheader_partoutput_dims(np,partopt(np)%ncid,timeunit,timeDimID,partDimID,latDimID,lonDimID)
      call writeheader_partoutput_vars(np,partopt(np)%ncid,totpart,timeDimID,partDimID,latDimID,lonDimID)

      ! moves the file from define to data mode
      call nf90_err(nf90_enddef(partopt(np)%ncid))
      call nf90_err(nf90_close(partopt(np)%ncid))
    end do
  else
    call writeheader_partoutput_dims(1,ncid,timeunit,timeDimID,partDimID,latDimID,lonDimID)
    do np=1,num_partopt
      if (.not. partopt(np)%print) cycle
      call writeheader_partoutput_vars(np,ncid,totpart,timeDimID,partDimID,latDimID,lonDimID)
    end do

    ! moves the file from define to data mode
    call nf90_err(nf90_enddef(ncid))
    call nf90_err(nf90_close(ncid))
  endif

  return
110 write(*,FMT='(80("#"))') 
  write(*,*) 'ERROR: output directory ', trim(path(2)(1:length(2))), ' does not exist&
       & (or failed to write there).' 
  write(*,*) 'EXITING' 
  write(*,FMT='(80("#"))')
  error stop
end subroutine writeheader_partoutput

subroutine writeheader_partoutput_dims(np,ncid,timeunit,timeDimID,partDimID,latDimID,lonDimID)

  implicit none
  integer,intent(in)  :: ncid,np
  character,intent(in) :: timeunit*32
  integer,intent(out) :: timeDimID,partDimID
  integer,intent(out) :: latDimID, lonDimID
  integer             :: tID,partID

  logical,save :: first_time=.true.

  ! create dimensions:
  !*************************
  ! time
  call nf90_err(nf90_def_dim(ncid, 'time', nf90_unlimited, timeDimID))

  ! particle

  ! If domainfill, save topo, hmix, and htropo to grid to save space
  !*****************************************************************
  if (lpartoutputperfield.and.(mdomainfill.eq.1).and. &
    ((partopt(np)%name.eq.'TO') .or. &
    (partopt(np)%name.eq.'HM') .or. &
    (partopt(np)%name.eq.'TR'))) then
    call writeheader_partoutput_grid(ncid,lonDimID,latDimID)
  else 
    if (.not. lpartoutputperfield .and. (mdomainfill.eq.1)) then
      call writeheader_partoutput_grid(ncid,lonDimID,latDimID)
    endif
    call nf90_err(nf90_def_dim(ncid, 'particle', nf90_unlimited, partDimID))
    ! particles variables
    call nf90_err(nf90_def_var(ncid, 'particle', nf90_int, (/ partDimID/), partID))
    call nf90_err(nf90_put_att(ncid, partID, 'long_name', 'particle index'))
  endif
  ! create variables
  !*************************

  ! time
  tpointer_part=0
  call nf90_err(nf90_def_var(ncid, 'time', nf90_int, (/ timeDimID /), tID))
  call nf90_err(nf90_put_att(ncid, tID, 'units', timeunit))
  call nf90_err(nf90_put_att(ncid, tID, 'calendar', 'proleptic_gregorian'))

  timeIDpart=tID

  ! global (metadata) attributes
  !*******************************
  call writemetadata(ncid,lnest=.false.)

end subroutine writeheader_partoutput_dims

subroutine writeheader_partoutput_vars(np,ncid,totpart,timeDimID,partDimID,latDimID,lonDimID)

  implicit none
  integer,intent(in)  :: ncid,totpart,np
  integer,intent(in)  :: timeDimID,partDimID
  integer,intent(in)  :: latDimID, lonDimID
  integer             :: j,i,varid
  character(len=3)    :: anspec
  real                :: fillval

  fillval = -1.
  select case(partopt(np)%name)
    case ('LO') ! Longitude
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'degrees_east',.false.,'longitude','longitude of particles')
      call nf90_err(nf90_put_att(ncid, varid, 'axis', 'Lon'))
      call nf90_err(nf90_put_att(ncid, varid, 'description', 'longitude of particles'))
    case ('lo') ! Longitude averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'degrees_east',.false.,'longitude_average','averaged longitude of particles')
      call nf90_err(nf90_put_att(ncid, varid, 'axis', 'Lon'))
      call nf90_err(nf90_put_att(ncid, varid, 'description', 'averaged longitude of particles'))
    case ('LA') ! Latitude
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'degrees_north',.false.,'latitude','latitude in degree north')
      call nf90_err(nf90_put_att(ncid, varid, 'axis', 'Lat'))
      call nf90_err(nf90_put_att(ncid, varid, 'description', 'latitude of particles'))
    case ('la') ! Latitude averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'degrees_north',.false.,'latitude_average','averaged latitude in degree north')
      call nf90_err(nf90_put_att(ncid, varid, 'axis', 'Lat'))
      call nf90_err(nf90_put_att(ncid, varid, 'description', 'averaged latitude of particles'))
    case ('ZZ') ! Height
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'meters',.false.,'height','height above ground')
    case ('zz') ! Heights averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'meters',.false.,'height_average','averaged height above ground')
    case ('PV') ! Potential vorticity
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'pvu',.false.,'potential_vorticity','potential vorticity')
    case ('pv') ! Potential vorticity averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'pvu',.false.,'potential_vorticity_average','averaged potential vorticity')
    case ('PR') ! Pressure
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'Pa',.false.,'pressure','pressure')
    case ('pr') ! Pressure averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'Pa',.false.,'pressure_average','averaged pressure')
    case ('QV') ! Specific humidity
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'kg/kg',.false.,'specific_humidity','specific humidity')
    case ('qv') ! Specific humidity averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'kg/kg',.false.,'specific_humidity_average','averaged specific humidity')
    case ('RH') ! Density
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'kg/m3',.true.,'density','density')
    case ('rh') ! Density averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'kg/m3',.true.,'density_average','averaged density')
    case ('TT') ! Temperature
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'K',.true.,'temperature','temperature') 
    case ('tt') ! Temperature averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'K',.true.,'temperature_average','averaged temperature') 
    case ('UU')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'u','longitudinal velocity')    
    case ('uu')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'u_av','averaged longitudinal velocity')
    case ('VV')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'v','latitudinal velocity')
    case ('vv')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'v_average','latitudinal velocity averaged')
    case ('WW')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'w','vertical velocity')
    case ('ww')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'w_average','vertical velocity averaged')
    case ('VS')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'settling_velocity','settling velocity')
    case ('vs')
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /), &
        varid,(/ 1,totpart /),'m/s',.false.,'settling_velocity_average','settling velocity averaged')
    case ('MA') ! Mass
      if ((mdomainfill.ge.1).and.(nspec.eq.1)) then
        call nf90_err(nf90_def_var(ncid=ncid, name=trim(partopt(np)%short_name), xtype=nf90_float, &
          dimids=1, varid=varid))
        call nf90_err(nf90_put_att(ncid, varid, 'units', 'kg'))
        call nf90_err(nf90_put_att(ncid, varid, '_FillValue', fillval))
        call nf90_err(nf90_put_att(ncid, varid, 'positive', 'up'))
        call nf90_err(nf90_put_att(ncid, varid, 'standard_name', 'mass'))
        call nf90_err(nf90_put_att(ncid, varid, 'long_name', 'mass of each particle'))
      else
        do j=1,nspec
          ! Masses
          write(anspec, '(i3.3)') j
          call write_to_file(ncid,trim(partopt(np)%short_name)//anspec,nf90_float, &
            (/ timeDimID,partDimID /),varid, &
            (/ 1,totpart /),'kg',.true.,'mass'//anspec,'mass for nspec'//anspec)
        end do
      endif
    case ('ma') ! Mass averaged
      if ((mdomainfill.ge.1).and.(nspec.eq.1)) then
        call nf90_err(nf90_def_var(ncid=ncid, name=trim(partopt(np)%short_name), xtype=nf90_float, dimids=1, varid=varid))
        call nf90_err(nf90_put_att(ncid, varid, 'units', 'kg'))
        call nf90_err(nf90_put_att(ncid, varid, '_FillValue', fillval))
        call nf90_err(nf90_put_att(ncid, varid, 'positive', 'up'))
        call nf90_err(nf90_put_att(ncid, varid, 'standard_name', 'mass'))
        call nf90_err(nf90_put_att(ncid, varid, 'long_name', 'averaged mass of each particle'))
      else
        do j=1,nspec
          ! Masses averaged
          write(anspec, '(i3.3)') j
          call write_to_file(ncid,trim(partopt(np)%short_name)//anspec,nf90_float,(/ timeDimID,partDimID /),varid, &
            (/ 1,totpart /),'kg',.true.,'mass'//anspec,'averaged mass for nspec'//anspec) 
        end do
      endif
    case ('WD') ! Cumulative mass of wet deposition
      do j=1,nspec
        ! Masses
        write(anspec, '(i3.3)') j
        call write_to_file(ncid,trim(partopt(np)%short_name)//anspec,nf90_float,(/ timeDimID,partDimID /),varid, &
          (/ 1,totpart /),'kg',.true.,'mass'//anspec,'cumulative wet deposition for nspec'//anspec) 
      end do
    case ('DD') ! Cumulative mass of dry deposition
      do j=1,nspec
        ! Masses
        write(anspec, '(i3.3)') j
        call write_to_file(ncid,trim(partopt(np)%short_name)//anspec,nf90_float,(/ timeDimID,partDimID /),varid, &
          (/ 1,totpart /),'kg',.true.,'mass'//anspec,'cumulative dry deposition for nspec'//anspec) 
      end do
    case ('TO')  ! Topography, written to grid if domainfill
      if (mdomainfill.lt.1) then
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /),varid,(/ 1,totpart /), &
          'meters',.false.,'topography','topography above sealevel')
      else
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ lonDimID,latDimID /),varid,(/ nx,ny /), &
          'meters',.false.,'topography','topography above sealevel')
      endif
    case ('to') ! Topography averaged, no grid when domainfill
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /),varid,(/ 1,totpart /), &
        'meters',.false.,'topography','averaged topography above sealevel')
    case ('HM') ! Mixing layer height
      if (mdomainfill.lt.1) then
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /),varid,(/ 1,totpart /), &
          'meters',.true.,'hmix','height above ground of mixing layer')
      else
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,lonDimID,latDimID /),varid,(/ 1,nx,ny /), &
          'meters',.true.,'hmix','height above ground of mixing layer')  
      endif
    case ('hm') ! Mixing layer height averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /),varid,(/ 1,totpart /), &
        'meters',.true.,'hmix_average','averaged height above ground of mixing layer')
    case ('TR') ! Tropopause
      if (mdomainfill.lt.1) then
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /),varid,(/ 1,totpart /), &
          'meters',.true.,'htropo','height above ground of tropopause')
      else
        call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,lonDimID,latDimID /),varid,(/ 1,nx,ny /), &
          'meters',.true.,'htropo','height above ground of tropopause')
      endif
    case ('tr') ! Tropopause averaged
      call write_to_file(ncid,trim(partopt(np)%short_name),nf90_float,(/ timeDimID,partDimID /),varid,(/ 1,totpart /), &
        'meters',.true.,'htropo_average','averaged height above ground of tropopause')
    case default
      write(*,*) 'The field you are trying to write to file is not coded in yet: ', partopt(np)%name,partopt(np)%long_name
      error stop
  end select

end subroutine writeheader_partoutput_vars

subroutine writeheader_partoutput_grid(ncid,lonDimID,latDimID)

  implicit none

  integer,intent(in)  :: ncid
  integer,intent(out) :: lonDimID,latDimID
  real, allocatable, dimension(:) :: coord
  integer :: lonID, latID, i

  call nf90_err(nf90_def_dim(ncid, 'longitude', nx, lonDimID))
  call nf90_err(nf90_def_dim(ncid, 'latitude', ny, latDimID))

  ! lon
  call write_to_file(ncid,'longitude',nf90_float,(/ lonDimID /),lonID,(/ 1 /), &
    'degrees_east',.false.,'grid_longitude','longitude in degree east')
  call nf90_err(nf90_put_att(ncid, lonID, 'axis', 'Lon'))
  call nf90_err(nf90_put_att(ncid, lonID, 'description', 'grid cell centers'))

  ! lat
  call write_to_file(ncid,'latitude',nf90_float,(/ latDimID /),latID,(/ 1 /), &
    'degrees_north',.false.,'grid_latitude','latitude in degree north')
  call nf90_err(nf90_put_att(ncid, latID, 'axis', 'Lat'))
  call nf90_err(nf90_put_att(ncid, latID, 'description', 'grid cell centers'))

  if (.not.allocated(coord)) allocate(coord(nx))
  do i = 1,nx
    coord(i) = xlon0 + (i-1)*dx
  enddo
  call nf90_err(nf90_put_var(ncid, lonID, coord(1:nx)))
  deallocate(coord)

  if (.not.allocated(coord)) allocate(coord(ny))
  do i = 1,ny
    coord(i) = ylat0 + (i-1)*dy
  enddo
  call nf90_err(nf90_put_var(ncid, latID, coord(1:ny)))
  deallocate(coord)

end subroutine writeheader_partoutput_grid

subroutine write_to_file(ncid,short_name,xtype,dimids,varid,chunksizes,units,l_positive, &
  standard_name,long_name)

  !*****************************************************************************
  !                                                                            *
  !   Generalised writing data to netcdf file                                  *
  !                                                                            *
  !   Author: L. Bakels 2022                                                   *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer, intent(in) :: ncid, xtype
  integer, intent(out) :: varid
  character(len = *), intent(in) :: short_name,standard_name,long_name,units
  integer, dimension(:), intent(in) :: dimids,chunksizes
  logical, intent(in) :: l_positive

  call nf90_err(nf90_def_var(ncid, short_name, xtype, dimids, varid))
  call nf90_err(nf90_def_var_chunking(ncid,varid,NF90_CHUNKED,chunksizes=chunksizes))
  call nf90_err(nf90_def_var_deflate(ncid,varid,shuffle=0,deflate=1,deflate_level=1))
  call nf90_err(nf90_put_att(ncid, varid, 'units', units))
  if(xtype.eq.nf90_float) then
    call nf90_err(nf90_put_att(ncid, varid, '_FillValue', -1.))
  else 
    call nf90_err(nf90_put_att(ncid, varid, '_FillValue', -1))
  endif
  if(l_positive) call nf90_err(nf90_put_att(ncid, varid, 'positive', 'up'))
  call nf90_err(nf90_put_att(ncid, varid, 'standard_name', standard_name))
  call nf90_err(nf90_put_att(ncid, varid, 'long_name', long_name))
end subroutine write_to_file

subroutine open_partoutput_file(ncid,np)
  
  implicit none 

  integer, intent(out)               :: ncid
  integer, intent(in),optional         :: np

  if (lpartoutputperfield) then
    call nf90_err(nf90_open(trim(ncfname_part)//'_'//trim(partopt(np)%long_name)//trim(ncfname_part_end), &
      nf90_write, ncid))
  else
    call nf90_err(nf90_open(trim(ncfname_part), nf90_write, ncid))
  endif
end subroutine open_partoutput_file

subroutine close_partoutput_file(ncid)
  
  implicit none 

  integer                        :: ncid

  call nf90_err(nf90_close(ncid))
end subroutine close_partoutput_file

subroutine open_partinit_file(ncid)
  
  implicit none 

  integer, intent(inout)         :: ncid

  call nf90_err(nf90_open(trim(ncfname_partinit), nf90_write, ncid))
end subroutine open_partinit_file

subroutine update_partoutput_pointers(itime,ncid)

  use particle_mod

  implicit none

  integer, intent(in)         :: itime
  integer, intent(in),optional :: ncid
  integer, allocatable           :: partindices(:)
  integer                     :: j,tempIDend,newpart,np

  ! Time
  tpointer_part = tpointer_part + 1

  if (lpartoutputperfield) then
    do np=1,num_partopt
      if (.not. partopt(np)%print) cycle
      call nf90_err(nf90_inq_varid(ncid=partopt(np)%ncid,name='time',varid=tempIDend))
      call nf90_err(nf90_put_var(partopt(np)%ncid, tempIDend, itime, (/ tpointer_part /)))
    end do
  else
    call nf90_err(nf90_inq_varid(ncid=ncid,name='time',varid=tempIDend))
    call nf90_err(nf90_put_var(ncid, tempIDend, itime, (/ tpointer_part /)))
  endif

  ! Particles
  newpart = count%allocated - ppointer_part

  if (tpointer_part.eq.1) then 
    allocate ( partindices(count%allocated) )
    do j=1,count%allocated 
      partindices(j)=j
    end do 
    if (lpartoutputperfield) then
      do np=1,num_partopt
        if (.not. partopt(np)%print) cycle
        if ((mdomainfill.eq.1).and. &
          ((partopt(np)%name.eq.'TO') .or. &
          (partopt(np)%name.eq.'HM') .or. &
          (partopt(np)%name.eq.'TR'))) cycle
        call nf90_err(nf90_inq_varid(ncid=partopt(np)%ncid,name='particle',varid=tempIDend))
        call nf90_err(nf90_put_var(partopt(np)%ncid, tempIDend,partindices, (/ 1 /),(/ count%allocated /)))
      end do
    else
      call nf90_err(nf90_inq_varid(ncid=ncid,name='particle',varid=tempIDend))
      call nf90_err(nf90_put_var(ncid, tempIDend,partindices, (/ 1 /),(/ count%allocated /)))
    endif
    deallocate (partindices)

    ppointer_part = count%allocated

  else if (newpart.ge.0) then

    allocate ( partindices(newpart) )
    do j=1,newpart
      partindices(j)=j+ppointer_part
    end do
    if (lpartoutputperfield) then
      do np=1,num_partopt
        if (.not. partopt(np)%print) cycle
        if ((mdomainfill.eq.1).and. &
          ((partopt(np)%name.eq.'TO') .or. &
          (partopt(np)%name.eq.'HM') .or. &
          (partopt(np)%name.eq.'TR'))) cycle
        call nf90_err(nf90_inq_varid(ncid=partopt(np)%ncid,name='particle',varid=tempIDend))
        call nf90_err(nf90_put_var(partopt(np)%ncid, tempIDend,partindices, (/ ppointer_part+1 /),(/ newpart /)))
      end do
    else
      call nf90_err(nf90_inq_varid(ncid=ncid,name='particle',varid=tempIDend))
      call nf90_err(nf90_put_var(ncid, tempIDend,partindices, (/ ppointer_part+1 /),(/ newpart /)))
    endif
    deallocate (partindices)

    ppointer_part = count%allocated
  endif 

end subroutine update_partoutput_pointers

subroutine partoutput_netcdf(itime,field,np,imass,ncid)

  
  use particle_mod
  !*****************************************************************************
  !                                                                            *
  !   Writing a field from PARTOPTIONS to partoutput_xxx.nc created in         *
  !   writeheader_partoutput                                                   *
  !                                                                            *  
  !   Author: L. Bakels 2021                                                   *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer, intent(in)            :: itime,imass,ncid
  real, intent(in)               :: field(:)
  integer, intent(in)            :: np  ! input field to interpolate over
  integer                        :: tempIDend
  character(len=3)               :: anspec

  ! ! open output file
  ! call nf90_err(nf90_open(trim(ncfname_part), nf90_write, ncid))
  if ((mdomainfill.ge.1).and. ((partopt(np)%name.eq.'TO').or. &
    (partopt(np)%name.eq.'HM').or.(partopt(np)%name.eq.'TR'))) then
    if (partopt(np)%name.eq.'TO')  then
      if (topo_written.eqv..false.) then
        call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name),varid=tempIDend))
        call nf90_err(nf90_put_var(ncid,tempIDend,oro(0:nx-1,0:ny-1), (/ 1,1 /),(/ nx,ny /)))
        topo_written=.true.
      endif
    else if (partopt(np)%name.eq.'HM') then !HM
      call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name),varid=tempIDend))
      call nf90_err(nf90_put_var(ncid,tempIDend,hmix(0:nx-1,0:ny-1,1,memind(1)), &
        (/ tpointer_part,1,1 /),(/ 1,nx,ny /)))
    else !TR
      call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name),varid=tempIDend))
      call nf90_err(nf90_put_var(ncid,tempIDend,tropopause(0:nx-1,0:ny-1,1,memind(1)), &
        (/ tpointer_part,1,1 /),(/ 1,nx,ny /)))      
    endif

  else if (partopt(np)%name.eq.'MA') then
    if ((mdomainfill.ge.1).and.(imass.eq.1).and.(nspec.eq.1)) then
      if (mass_written.eqv..false.) then 
        call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name),varid=tempIDend))
        call nf90_err(nf90_put_var(ncid=ncid,varid=tempIDend,values=field(1)))
      endif
      mass_written=.true.
    else
      write(anspec, '(i3.3)') imass
      call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name)//anspec,varid=tempIDend))
      call nf90_err(nf90_put_var(ncid,tempIDend,field, (/ tpointer_part,1 /),(/ 1,count%allocated /)))
    endif
  else if (partopt(np)%name.eq.'ma') then
    if ((mdomainfill.ge.1).and.(imass.eq.1).and.(nspec.eq.1)) then
      if (mass_written.eqv..false.) then 
        call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name),varid=tempIDend))
        call nf90_err(nf90_put_var(ncid,tempIDend,field, (/ tpointer_part,1 /),(/ 1,count%allocated /)))
      endif
      massav_written=.true.
    else
      write(anspec, '(i3.3)') imass
      call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name)//anspec,varid=tempIDend))
      call nf90_err(nf90_put_var(ncid,tempIDend,field, (/ tpointer_part,1 /),(/ 1,count%allocated /)))
    endif
  else if ((partopt(np)%name.eq.'WD').or.(partopt(np)%name.eq.'DD')) then
    write(anspec, '(i3.3)') imass
    call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name)//anspec,varid=tempIDend))
    call nf90_err(nf90_put_var(ncid,tempIDend,field, (/ tpointer_part,1 /),(/ 1,count%allocated /)))
  else 
    call nf90_err(nf90_inq_varid(ncid=ncid,name=trim(partopt(np)%short_name),varid=tempIDend))
    call nf90_err(nf90_put_var(ncid,tempIDend,field, (/ tpointer_part,1 /),(/ 1,count%allocated /)))
  endif

  ! call nf90_err(nf90_close(ncid))
end subroutine partoutput_netcdf

subroutine readpartpositions_netcdf(ibtime,ibdate)

  !*****************************************************************************
  !                                                                            *
  !   IPIN=2: restarting from a partoutput_xxx.nc file written by a previous   *
  !           run, depending on what PARTOPTIONS the user has chosen, this     *
  !           option might not be possible to use                              *
  !                                                                            *
  !   Author: L. Bakels 2022                                                   *
  !                                                                            *
  !*****************************************************************************

  use random_mod
  use particle_mod
  use date_mod

  implicit none 

  integer, intent(in) :: ibtime,ibdate
  integer             :: ncidend,tIDend,pIDend,tempIDend
  integer             :: tlen,plen,tend,i,j,stat,iterminate
  integer             :: idate_start,itime_start
  character           :: adate*8,atime*6,timeunit*32,adate_start*8,atime_start*6
  character(len=3)    :: anspec
  real(kind=dp)       :: julin,julcommand
  ! real,allocatable,dimension(:) :: mass_temp
  integer :: idummy = -8

  write(adate,'(i8.8)') ibdate
  write(atime,'(i6.6)') ibtime
  
  if (mquasilag.ne.0) then 
    write(*,*) 'Combination of ipin, netcdf partoutput, and mquasilag!=0 does not work yet'
    error stop 
  endif

  ! Open partoutput_end.nc file
  call nf90_err(nf90_open(path(2)(1:length(2))//trim('partoutput_end.nc'), mode=NF90_NOWRITE,ncid=ncidend))

  ! Take the positions of the particles at the last timestep in the file
  ! It needs to be the same as given in the COMMAND file, this is arbitrary
  ! and should be removed in the future for easier use

  ! First get the time dimension
  call nf90_err(nf90_inq_dimid(ncid=ncidend,name='time',dimid=tIDend))
  call nf90_err(nf90_inquire_dimension(ncid=ncidend,dimid=tIDend,len=tlen))

  ! Check if the time corresponds to the one given in the COMMAND file
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='time',varid=tIDend))
  call nf90_err(nf90_get_att(ncid=ncidend,varid=tIDend,name='units',values=timeunit))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tIDend,values=tend,start=(/ tlen /)))!,count=(/ 1 /)))
  adate_start(1:4) = timeunit(15:18)
  adate_start(5:6) = timeunit(20:21)
  adate_start(7:8) = timeunit(23:24)
  atime_start = '000000'
  atime_start(1:2) = timeunit(26:27)
  atime_start(3:4) = timeunit(29:30)
  read(adate_start,*) idate_start
  read(atime_start,*) itime_start
  julin = juldate(idate_start,itime_start)+real(tend,kind=dp)/86400._dp
  julcommand = juldate(ibdate,ibtime)
  if (abs(julin-julcommand).gt.1.e-5) then 
    write(*,*) 'ERROR: The given starting time and date do not correspond to'
    write(*,*) 'the last timestep of partoutput_end.nc:'
    write(*,*) julin,julcommand,tend
    error stop 
  endif

  !! testing
!  print*, 'readpartpositions_netcdf: julin, julcommand = ',julin, julcommand

  ! Then the particle dimension
  call nf90_err(nf90_inq_dimid(ncid=ncidend,name='particle',dimid=pIDend))
  call nf90_err(nf90_inquire_dimension(ncid=ncidend,dimid=pIDend,len=plen))

  ! Now spawn the correct number of particles
  write(*,*) 'Npart:',plen
  call spawn_particles(0,plen)

  ! And give them the correct positions
  ! Longitude
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='lon',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%xlon, & 
    start=(/ tlen, 1 /),count=(/ 1, plen /)))
  part(:)%xlon=(part(:)%xlon-xlon0)/dx
  ! Latitude
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='lat',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%ylat, & 
    start=(/ tlen, 1 /),count=(/ 1, plen /)))
  part(:)%ylat=(part(:)%ylat-ylat0)/dx
  ! Height
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='z',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%z, & 
    start=(/ tlen, 1 /),count=(/ 1, plen /)))
  ! Mass
  ! allocate(mass_temp(count%allocated), stat=stat)
  ! if (stat.ne.0) error stop "Could not allocate mass_temp"
  if ((mdomainfill.eq.0).or.(nspec.gt.1)) then
    do j=1,nspec
      write(anspec, '(i3.3)') j
      call nf90_err(nf90_inq_varid(ncid=ncidend,name='m'//anspec,varid=tempIDend))
      call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=mass(:,j), & 
        start=(/ tlen, 1 /),count=(/ 1, plen /)))
      ! do i=1,count%allocated
      !   part(i)%mass(j)=mass_temp(i)
      ! end do
    end do
  endif
  ! deallocate( mass_temp )

  iterminate=0
  do i=1,plen
    if (part(i)%z.lt.0) then 
      call terminate_particle(i,0)
      if (mdomainfill.eq.0) then
        write(*,*) 'Particle ',i,'is not alive in the restart file.'
      endif
      iterminate=iterminate+1
    endif
    part(i)%nclass=min(int(ran1(idummy,0)*real(nclassunc))+1, &
         nclassunc)    
    part(i)%idt=mintime
    part(i)%npoint=1
  end do

  if (iterminate.gt.0) call rewrite_ialive()
  
  call nf90_err(nf90_close(ncidend))

  !! testing
!  print*, 'readpartpositions_netcdf: number alive = ',count%alive
!  print*, 'readpartpositions_netcdf: range(part%z) = ',minval(part(1:count%alive)%z),maxval(part(1:count%alive)%z)
!  print*, 'readpartpositions_netcdf: part(1)%tstart = ',part(1)%tstart

end subroutine readpartpositions_netcdf

subroutine readinitconditions_netcdf()

  !*****************************************************************************
  !                                                                            *
  !   IPIN=3: starting a run from a user defined initial particle conditions,  *
  !           more on how to create such a file can be found in the manual     *
  !   IPIN=4: restarting a run, while also reading in the initial particle     *
  !           conditions                                                       *
  !                                                                            *
  !   Author: L. Bakels 2022                                                   *
  !                                                                            *
  !*****************************************************************************

  use random_mod
  use particle_mod
  use date_mod
  use readoptions_mod
  use drydepo_mod

  implicit none 

  integer             :: ncidend,pIDend,tempIDend,stat
  integer             :: plen,i,j,release_max,nsp
  integer(kind=2)     :: zkind
  real                :: cun
  integer,allocatable, dimension (:) :: specnum_rel,numpoint_max
  ! real,allocatable,dimension(:,:) :: mass_temp
  real,allocatable,dimension(:) :: vsh,fracth,schmih
  logical :: lstart=.true.

  integer :: idummy = -8
  
  if (mquasilag.ne.0) then 
    write(*,*) 'Combination of ipin, netcdf partoutput, and mquasilag!=0 does not work yet'
    error stop 
  endif

  ! Open part_ic.nc file
  call nf90_err(nf90_open(trim(path(1)(1:length(1))//'part_ic.nc'), mode=NF90_NOWRITE,ncid=ncidend))

  ! How many species are contained in each particle?
  call nf90_err(nf90_inquire_attribute(ncid=ncidend,name='nspecies',varid=NF90_GLOBAL))
  call nf90_err(nf90_get_att(ncid=ncidend,varid=NF90_GLOBAL,name='nspecies',values=nspec))

  maxspec=nspec
  call alloc_com()

  ! Read number of fields that need to be output. This needs to happen after maxspec is defined
  ! but before particles are allocated (n_average is necessary).
  if (ipout.ne.0) call readpartoptions 

  ! allocate with maxspec for first input loop
  allocate(specnum_rel(maxspec),stat=stat)
  if (stat.ne.0) error stop 'ERROR: could not allocate specnum_rel'

  if (nspec.gt.maxspec) then
    error stop 'number of species in part_ic.nc is larger than the allowed maxspec set in the par_mod.f90'
  endif
  ! Which species?
  call nf90_err(nf90_inquire_attribute(ncid=ncidend,name='species',varid=NF90_GLOBAL))
  call nf90_err(nf90_get_att(ncid=ncidend,varid=NF90_GLOBAL,name='species',values=specnum_rel(1:nspec)))

  ! Read species and derive initial conditions
  !****************************************************
  DEP=.false.
  DRYDEP=.false.
  WETDEP=.false.
  CLREA=.false.
  do nsp=1,maxspec
    DRYDEPSPEC(nsp)=.false.
    WETDEPSPEC(nsp)=.false.
  end do

  do nsp=1,nspec
    call readspecies(specnum_rel(nsp),nsp)
  end do

  ! Allocate fields that depend on ndia
  call alloc_com_ndia

  do nsp=1,nspec
    ! Allocate temporary memory necessary for the different diameter bins
    !********************************************************************
    allocate(vsh(ndia(nsp)),fracth(ndia(nsp)),schmih(ndia(nsp)), stat=stat)
    if (stat.ne.0) error stop "Could not allocate vsh,fracth,schmih"

    ! Molecular weight
    !*****************
    if (((iout.eq.2).or.(iout.eq.3)).and.(weightmolar(nsp).lt.0.)) then
      write(*,*) 'For mixing ratio output, valid molar weight'
      write(*,*) 'must be specified for all simulated species.'
      write(*,*) 'Check table SPECIES or choose concentration'
      write(*,*) 'output instead if molar weight is not known.'
      error stop
    endif

    ! Radioactive decay
    !******************
    decay(nsp)=0.693147/decay(nsp) !conversion half life to decay constant

  ! Dry deposition of gases
  !************************

    if (reldiff(nsp).gt.0.) rm(nsp)=1./(henry(nsp)/3000.+100.*f0(nsp))    ! mesophyll resistance

  ! Dry deposition of particles
  !****************************

    vsetaver(nsp)=0.
    cunningham(nsp)=0.
    dquer(nsp)=dquer(nsp)*1000000.         ! Conversion m to um
    if (density(nsp).gt.0.) then         ! Additional parameters
      call part0(dquer(nsp),dsigma(nsp),density(nsp),ndia(nsp),fracth,schmih,cun,vsh)
      do j=1,ndia(nsp)
        fract(nsp,j)=fracth(j)
        schmi(nsp,j)=schmih(j)
        vset(nsp,j)=vsh(j)
        cunningham(nsp)=cunningham(nsp)+cun*fract(nsp,j)
        vsetaver(nsp)=vsetaver(nsp)-vset(nsp,j)*fract(nsp,j)
      end do
      if (lroot) write(*,*) 'Average settling velocity: ',i,vsetaver(nsp)
    endif

    ! Dry deposition for constant deposition velocity
    !************************************************

    dryvel(nsp)=dryvel(nsp)*0.01         ! conversion to m/s

    ! Check if wet deposition or OH reaction shall be calculated
    !***********************************************************

    ! ESO 04.2016 check for below-cloud scavenging (gas or aerosol)
    if ((dquer(nsp).le.0..and.(weta_gas(nsp).gt.0. .or. wetb_gas(nsp).gt.0.)) .or. &
         &(dquer(nsp).gt.0. .and. (crain_aero(nsp) .gt. 0. .or. csnow_aero(nsp).gt.0.)))  then
      WETDEP=.true.
      WETDEPSPEC(nsp)=.true.
      if (lroot) then
        write (*,*) '  Below-cloud scavenging: ON'
      end if
    else
      if (lroot) write (*,*) '  Below-cloud scavenging: OFF'
    endif

    ! NIK 31.01.2013 + 10.12.2013 + 15.02.2015
    if (dquer(nsp).gt.0..and.(ccn_aero(nsp).gt.0. .or. in_aero(nsp).gt.0.))  then
      WETDEP=.true.
      WETDEPSPEC(nsp)=.true.
      if (lroot) then
        write (*,*) '  In-cloud scavenging: ON'
      end if
    else
      if (lroot) write (*,*) '  In-cloud scavenging: OFF' 
    endif

    if (any(reaccconst(:,:).gt.0.)) then
      CLREA=.true.
      if (lroot) write (*,*) '  Chemical reactions switched on'
    endif

    if ((reldiff(nsp).gt.0.).or.(density(nsp).gt.0.).or.(dryvel(nsp).gt.0.)) then
      DRYDEP=.true.
      DRYDEPSPEC(nsp)=.true.
    endif

    deallocate(vsh,fracth,schmih)
  end do ! end loop over species

  if (WETDEP.or.DRYDEP) then 
   DEP=.true.
  endif

  deallocate(specnum_rel)
  !********************************* END READING SPECIES

  ! Get the particle dimension
  call nf90_err(nf90_inq_dimid(ncid=ncidend,name='particle',dimid=pIDend))
  call nf90_err(nf90_inquire_dimension(ncid=ncidend,dimid=pIDend,len=plen))

  ! Now spawn the correct number of particles
  write(*,*) 'Npart:',plen
  call alloc_particles( plen )
  ! allocate temporary mass array
  ! allocate(mass_temp(plen,nspec))

  ! And give them the correct positions
  ! Longitude
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='longitude',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%xlon, & 
    start=(/ 1 /),count=(/ plen /)))
  part(:)%xlon=(part(:)%xlon-xlon0)/dx
  ! Latitude
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='latitude',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%ylat, & 
    start=(/ 1 /),count=(/ plen /)))
  part(:)%ylat=(part(:)%ylat-ylat0)/dx
  ! Height
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='height',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%z, & 
    start=(/ 1 /),count=(/ plen /)))
  ! Spawning time
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='time',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%tstart, & 
    start=(/ 1 /),count=(/ plen /)))
  ! Mass
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='mass',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=mass, & 
    start=(/ 1,1 /),count=(/ plen,nspec /)))
  ! do i=1,plen
  !   do nsp=1,nspec
  !     part(i)%mass(nsp)=mass_temp(i,nsp)
  !   end do
  ! end do
  ! deallocate(mass_temp)

  ! Check if they are within the bounds
  do i=1,plen
    if ((part(i)%xlon.lt.0).or.(part(i)%xlon.gt.nx)) then
      write(*,*) 'Dimensions (nx,ny): ',nx,ny
      write(*,*) "Particle", i, "with xlon", part(i)%xlon
      error stop "Initial latitude particle outside of domain."
    endif
    if ((part(i)%ylat.lt.0).or.(part(i)%ylat.gt.ny)) then
        write(*,*) 'Dimensions (nx,ny): ',nx,ny
      write(*,*) "Particle", i, "with ylat", part(i)%ylat
      error stop "Initial latitude particle outside of domain."
    endif
    if (part(i)%z.lt.0) then
      write(*,*) "Particle", i, "with height", part(i)%z
      error stop "Initial height particle below surface/sea level."
    endif
    do nsp=1,nspec
      if (mass(i,nsp).lt.0) then
        write(*,*) "Particle", i, "of species", nsp, "with mass", mass(i,nsp)
        error stop "Negative initial mass."
      endif
    end do
    if (part(i)%tstart*ldirect.lt.0) then
      if (lstart) then
        write(*,*) "WARNING: (some) particles have a starting time of", part(i)%tstart, "in"
        if (ldirect.le.0) then 
          write(*,*) "backward mode, please only use negative values."
          write(*,*) "time array in part_ic.nc should be given in seconds after the"
          write(*,*) "start of your simulation. Positive values will be converted to"
          write(*,*) "negative starting times..."
        else 
          write(*,*) "forward mode, please only use positive values."
          write(*,*) "time array in part_ic.nc should be given in seconds after the"
          write(*,*) "start of your simulation. Negative values will be converted to"
          write(*,*) "positive starting times..."
        endif
        lstart=.false.
      endif
      part(i)%tstart = part(i)%tstart*(-1)
    endif
  end do
  ! Release
  call nf90_err(nf90_inq_varid(ncid=ncidend,name='release',varid=tempIDend))
  call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%npoint, & 
    start=(/ 1 /),count=(/ plen /)))
  ! ! Species
  ! call nf90_err(nf90_inq_varid(ncid=ncidend,name='species',varid=tempIDend))
  ! call nf90_err(nf90_get_var(ncid=ncidend,varid=tempIDend,values=part(:)%species, & 
  !   start=(/ 1 /),count=(/ plen /)))

  ! Count number of releases
  numpoint=0
  ! Allocate plen of numpoint_max, since each particle could in principle have 
  ! a unique release number
  allocate(numpoint_max(plen), stat=stat)
  if (stat.ne.0) error stop "Could not allocate numpoint_max"
  numpoint_max=0
  release_max=0

  ! Count number of releases
  l1: do i=1,plen
    ! See if the release number already exists
    l2: do j=1,numpoint
      if (part(i)%npoint.eq.numpoint_max(numpoint)) then
        cycle l1
      endif
    end do l2
    numpoint = numpoint+1 ! Counting the number of releases
    numpoint_max(numpoint)=part(i)%npoint ! Save the release numbers
    ! Save maximum release number
    if (part(i)%npoint.gt.release_max) release_max=part(i)%npoint 
  end do l1

  if (numpoint.eq.0) numpoint=1

  allocate(kindz(numpoint),stat=stat)
  kindz=-1
  if (stat.ne.0) write(*,*)'ERROR: could not allocate kindz'
  ! Above sea-level or ground?
  call nf90_err(nf90_inquire_attribute(ncid=ncidend,name='kindz',varid=NF90_GLOBAL))
  call nf90_err(nf90_get_att(ncid=ncidend,varid=NF90_GLOBAL,name='kindz',values=zkind))
  
  kindz=zkind
  do j=1,numpoint
    if ((kindz(j).le.0).or.(kindz(j).ge.4)) then
      write(*,*) 'ERROR: kindz should be an integer between 1 and 3, not', kindz(nsp)
      error stop
    endif
    if (kindz(j).eq.3) then
      do i=1,plen
        if (part(i)%z.gt.1500.) then
          error stop 'Pressure heights should be given in hPa units. Input value exceeds surface pressure!'
        endif
      end do
    endif
  end do

  if (ioutputforeachrelease.eq.1) then
    maxpointspec_act=numpoint
  else
    maxpointspec_act=1
  endif

  if (release_max.gt.numpoint) then
    write(*,*) "WARNING: release numbers in part_ic.nc are not consecutive:", &
      release_max, "is larger than the total number of releases:", numpoint, &
      " Releases will be renumbered starting from 1."

    do j=1,numpoint
      do i=1,plen
        if (part(i)%npoint.eq.numpoint_max(j)) then
          part(i)%npoint=j
        endif
      end do
    end do
  endif
  deallocate(numpoint_max)

  ! Setting zpoint1 and zpoint2 necessary for wet backward deposition and plumes
  allocate(zpoint1(numpoint),zpoint2(numpoint), stat=stat)
  if (stat.ne.0) error stop "Could not allocate zpoint"
  zpoint2(:)=0.
  zpoint1(:)=1.e8
  do i=1,plen
    if (part(i)%npoint.ne.1) cycle ! This will be computed after information about
                                   ! topography (2) or pressure (3) is known (kindz_to_z)
    if (part(i)%z.gt.zpoint2(part(i)%npoint)) zpoint2(part(i)%npoint)=real(part(i)%z)
    if (part(i)%z.lt.zpoint1(part(i)%npoint)) zpoint1(part(i)%npoint)=real(part(i)%z)
  end do

  ! Setting xpoint1, ypoint1, xpoint2, ypoint2
  allocate(ypoint1(numpoint),ypoint2(numpoint), stat=stat)
  if (stat.ne.0) error stop "Could not allocate ypoint"
  allocate(xpoint1(numpoint),xpoint2(numpoint), stat=stat)
  if (stat.ne.0) error stop "Could not allocate xpoint"
  xpoint2(:)=0.
  xpoint1(:)=1.e8
  ypoint2(:)=0.
  ypoint1(:)=1.e8
  do i=1,plen
    if (part(i)%xlon.gt.xpoint2(part(i)%npoint)) xpoint2(part(i)%npoint)=real(part(i)%xlon)
    if (part(i)%xlon.lt.xpoint1(part(i)%npoint)) xpoint1(part(i)%npoint)=real(part(i)%xlon)
    if (part(i)%ylat.gt.ypoint2(part(i)%npoint)) ypoint2(part(i)%npoint)=real(part(i)%ylat)
    if (part(i)%ylat.lt.ypoint1(part(i)%npoint)) ypoint1(part(i)%npoint)=real(part(i)%ylat)
  end do
  do j=1,numpoint
    xpoint1(j)=(xpoint1(j)-xlon0)/dx
    xpoint2(j)=(xpoint2(j)-xlon0)/dx
    ypoint1(j)=(ypoint1(j)-ylat0)/dy
    ypoint2(j)=(ypoint2(j)-ylat0)/dy
  end do

  allocate(xmass(numpoint,nspec), npart(numpoint),ireleasestart(numpoint), &
    ireleaseend(numpoint), stat=stat)
  if (stat.ne.0) error stop "Could not allocate xmass,npart,ireleasestart,ireleaseend"
  xmass=0
  npart=0
  ireleasestart=-1
  ireleaseend=-1
  do i=1,plen
    do j=1,numpoint
      if (part(i)%npoint.eq.j) then
         do nsp=1,nspec
           xmass(j,nsp) = xmass(j,nsp)+mass(i,nsp)
         end do 
      endif
      if (part(i)%npoint.eq.j) then 
        npart(j)=npart(j)+1
        if ((ireleasestart(j).gt.part(i)%tstart*ldirect).or.(ireleasestart(j).eq.-1)) &
          ireleasestart(j)=part(i)%tstart
        if ((ireleaseend(j).le.part(i)%tstart*ldirect).or.(ireleaseend(j).eq.-1)) &
          ireleaseend(j)=part(i)%tstart
      endif
    end do
  end do

  part(:)%idt=mintime
  mass_init(:,:)=mass(:,:)
  do i=1,plen
    part(i)%nclass=min(int(ran1(idummy,0)*real(nclassunc))+1, &
         nclassunc)
  end do

  allocate(rho_rel(numpoint),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate rho_rel in readinitconditions_netcdf'

  write(*,FMT='(A,ES14.7)') ' Total mass to be released:', sum(xmass(1:numpoint,1:nspec))
  call get_totalpart_num(numpart)
  numparticlecount=numpart
  call nf90_err(nf90_close(ncidend))

end subroutine readinitconditions_netcdf

end module netcdf_output_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readwind(indj,n,uuh,vvh,wwh)

  !***********************************************************************
  !*                                                                     *
  !*             TRAJECTORY MODEL SUBROUTINE READWIND                    *
  !*                                                                     *
  !***********************************************************************
  !*                                                                     *
  !*             AUTHOR:      G. WOTAWA                                  *
  !*             DATE:        1997-08-05                                 *
  !*             LAST UPDATE: 2000-10-17, Andreas Stohl                  *
  !*             CHANGE: 01/02/2001, Bernd C. Krueger, Variables tth and *
  !*                     qvh (on eta coordinates) in common block        *
  !*             CHANGE: 16/11/2005, Caroline Forster, GFS data          *
  !*             CHANGE: 11/01/2008, Harald Sodemann, Input of GRIB1/2   *
  !*                     data with the ECMWF grib_api library            *
  !*             CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
  !*                                 ECMWF grib_api                      *
  !*                                                                     *
  !***********************************************************************
  !*                                                                     *
  !* DESCRIPTION:                                                        *
  !*                                                                     *
  !* READING OF ECMWF METEOROLOGICAL FIELDS FROM INPUT DATA FILES. THE   *
  !* INPUT DATA FILES ARE EXPECTED TO BE AVAILABLE IN GRIB CODE          *
  !*                                                                     *
  !* INPUT:                                                              *
  !* indj               indicates number of the wind field to be read in *
  !* n                  temporal index for meteorological fields (1 to 3)*
  !*                                                                     *
  !* IMPORTANT VARIABLES FROM COMMON BLOCK:                              *
  !*                                                                     *
  !* wfname             File name of data to be read in                  *
  !* nx,ny,nuvz,nwz     expected field dimensions                        *
  !* nlev_ec            number of vertical levels ecmwf model            *
  !* uu,vv,ww           wind fields                                      *
  !* tt,qv              temperature and specific humidity                *
  !* ps                 surface pressure                                 *
  !*                                                                     *
  !***********************************************************************

  use grib_api
  use par_mod
  use com_mod

  implicit none

  !HSO  new parameters for grib_api
  integer :: ifile
  integer :: iret
  integer :: igrib
  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
  !HSO end edits
  real :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: wwh(0:nxmax-1,0:nymax-1,nwzmax)
  integer :: ii,indj,i,j,k,n,levdiff2,ifield,iumax,iwmax

  ! NCEP
  integer :: numpt,numpu,numpv,numpw,numprh
  real :: help, temp, ew
  real :: elev
  real :: ulev1(0:nxmax-1,0:nymax-1),vlev1(0:nxmax-1,0:nymax-1)
  real :: tlev1(0:nxmax-1,0:nymax-1)
  real :: qvh2(0:nxmax-1,0:nymax-1)

  integer :: i179,i180,i181

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING
  !HSO kept isec1, isec2 and zsec4 for consistency with gribex GRIB input

  integer :: isec1(8),isec2(3)
  real(kind=4) :: zsec4(jpunp)
  real(kind=4) :: xaux,yaux,xaux0,yaux0
  real(kind=8) :: xauxin,yauxin
  real,parameter :: eps=1.e-4
  real(kind=4) :: ewss(0:nxmax-1,0:nymax-1),nsss(0:nxmax-1,0:nymax-1)
  real :: plev1,hlev1,ff10m,fflev1

  logical :: hflswitch,strswitch

  !HSO  for grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: gribFunction = 'readwind_gfs'


  hflswitch=.false.
  strswitch=.false.
  levdiff2=nlev_ec-nwz+1
  iumax=0
  iwmax=0


  ! OPENING OF DATA FILE (GRIB CODE)

  !HSO
5   call grib_open_file(ifile,path(3)(1:length(3)) &
         //trim(wfname(indj)),'r',iret)
  if (iret.ne.GRIB_SUCCESS) then
    goto 888   ! ERROR DETECTED
  endif
  !turn on support for multi fields messages
  call grib_multi_support_on

  numpt=0
  numpu=0
  numpv=0
  numpw=0
  numprh=0
  ifield=0
10   ifield=ifield+1
  !
  ! GET NEXT FIELDS
  !
  call grib_new_from_file(ifile,igrib,iret)
  if (iret.eq.GRIB_END_OF_FILE)  then
    goto 50    ! EOF DETECTED
  elseif (iret.ne.GRIB_SUCCESS) then
    goto 888   ! ERROR DETECTED
  endif

  !first see if we read GRIB1 or GRIB2
  call grib_get_int(igrib,'editionNumber',gribVer,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  if (gribVer.eq.1) then ! GRIB Edition 1

  !read the grib1 identifiers
  call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'indicatorOfTypeOfLevel',isec1(7),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',isec1(8),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  else ! GRIB Edition 2

  !read the grib2 identifiers
  call grib_get_int(igrib,'discipline',discipl,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterCategory',parCat,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterNumber',parNum,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'scaledValueOfFirstFixedSurface', &
       valSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !convert to grib1 identifiers
  isec1(6)=-1
  isec1(7)=-1
  isec1(8)=-1
  if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.100)) then ! T
    isec1(6)=11          ! indicatorOfParameter
    isec1(7)=100         ! indicatorOfTypeOfLevel
    isec1(8)=valSurf/100 ! level, convert to hPa
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.100)) then ! U
    isec1(6)=33          ! indicatorOfParameter
    isec1(7)=100         ! indicatorOfTypeOfLevel
    isec1(8)=valSurf/100 ! level, convert to hPa
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.100)) then ! V
    isec1(6)=34          ! indicatorOfParameter
    isec1(7)=100         ! indicatorOfTypeOfLevel
    isec1(8)=valSurf/100 ! level, convert to hPa
  elseif ((parCat.eq.2).and.(parNum.eq.8).and.(typSurf.eq.100)) then ! W
    isec1(6)=39          ! indicatorOfParameter
    isec1(7)=100         ! indicatorOfTypeOfLevel
    isec1(8)=valSurf/100 ! level, convert to hPa
  elseif ((parCat.eq.1).and.(parNum.eq.1).and.(typSurf.eq.100)) then ! RH
    isec1(6)=52          ! indicatorOfParameter
    isec1(7)=100         ! indicatorOfTypeOfLevel
    isec1(8)=valSurf/100 ! level, convert to hPa
  elseif ((parCat.eq.1).and.(parNum.eq.1).and.(typSurf.eq.103)) then ! RH2
    isec1(6)=52          ! indicatorOfParameter
    isec1(7)=105         ! indicatorOfTypeOfLevel
    isec1(8)=2
  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103)) then ! T2
    isec1(6)=11          ! indicatorOfParameter
    isec1(7)=105         ! indicatorOfTypeOfLevel
    isec1(8)=2
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103)) then ! U10
    isec1(6)=33          ! indicatorOfParameter
    isec1(7)=105         ! indicatorOfTypeOfLevel
    isec1(8)=10
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103)) then ! V10
    isec1(6)=34          ! indicatorOfParameter
    isec1(7)=105         ! indicatorOfTypeOfLevel
    isec1(8)=10
  elseif ((parCat.eq.3).and.(parNum.eq.1).and.(typSurf.eq.101)) then ! SLP
    isec1(6)=2           ! indicatorOfParameter
    isec1(7)=102         ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1)) then ! SP
    isec1(6)=1           ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.1).and.(parNum.eq.13).and.(typSurf.eq.1)) then ! SNOW
    isec1(6)=66          ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.104)) then ! T sigma 0
    isec1(6)=11          ! indicatorOfParameter
    isec1(7)=107         ! indicatorOfTypeOfLevel
    isec1(8)=0.995       ! lowest sigma level
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.104)) then ! U sigma 0
    isec1(6)=33          ! indicatorOfParameter
    isec1(7)=107         ! indicatorOfTypeOfLevel
    isec1(8)=0.995       ! lowest sigma level
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.104)) then ! V sigma 0
    isec1(6)=34          ! indicatorOfParameter
    isec1(7)=107         ! indicatorOfTypeOfLevel
    isec1(8)=0.995       ! lowest sigma level
  elseif ((parCat.eq.3).and.(parNum.eq.5).and.(typSurf.eq.1)) then ! TOPO
    isec1(6)=7           ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.1) &
       .and.(discipl.eq.2)) then ! LSM
    isec1(6)=81          ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.3).and.(parNum.eq.196).and.(typSurf.eq.1)) then ! BLH
    isec1(6)=221         ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.1).and.(parNum.eq.7).and.(typSurf.eq.1)) then ! LSP/TP
    isec1(6)=62          ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.1).and.(parNum.eq.196).and.(typSurf.eq.1)) then ! CP
    isec1(6)=63          ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  endif

  endif ! gribVer

  if (isec1(6).ne.-1) then
  !  get the size and data of the values array
    call grib_get_real4_array(igrib,'values',zsec4,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
  endif

  if(ifield.eq.1) then

  !get the required fields from section 2
  !store compatible to gribex input
  call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
       isec2(2),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
       isec2(3),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
       xauxin,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
       yauxin,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  xaux=xauxin+real(nxshift)*dx
  yaux=yauxin

  ! CHECK GRID SPECIFICATIONS

    if(isec2(2).ne.nxfield) stop 'READWIND: NX NOT CONSISTENT'
    if(isec2(3).ne.ny) stop 'READWIND: NY NOT CONSISTENT'
    if(xaux.eq.0.) xaux=-179.0     ! NCEP DATA
    xaux0=xlon0
    yaux0=ylat0
    if(xaux.lt.0.) xaux=xaux+360.
    if(yaux.lt.0.) yaux=yaux+360.
    if(xaux0.lt.0.) xaux0=xaux0+360.
    if(yaux0.lt.0.) yaux0=yaux0+360.
    if(abs(xaux-xaux0).gt.eps) &
         stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT'
    if(abs(yaux-yaux0).gt.eps) &
         stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT'
  endif
  !HSO end of edits

  i179=nint(179./dx)
  if (dx.lt.0.7) then
    i180=nint(180./dx)+1    ! 0.5 deg data
  else
    i180=nint(179./dx)+1    ! 1 deg data
  endif
  i181=i180+1

  if (isec1(6).ne.-1) then

  do j=0,nymin1
    do i=0,nxfield-1
      if((isec1(6).eq.011).and.(isec1(7).eq.100)) then
  ! TEMPERATURE
         if((i.eq.0).and.(j.eq.0)) then
            do ii=1,nuvz
              if ((isec1(8)*100.0).eq.akz(ii)) numpt=ii
            end do
        endif
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          tth(i179+i,j,numpt,n)=help
        else
          tth(i-i181,j,numpt,n)=help
        endif
      endif
      if((isec1(6).eq.033).and.(isec1(7).eq.100)) then
  ! U VELOCITY
         if((i.eq.0).and.(j.eq.0)) then
            do ii=1,nuvz
              if ((isec1(8)*100.0).eq.akz(ii)) numpu=ii
            end do
        endif
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          uuh(i179+i,j,numpu)=help
        else
          uuh(i-i181,j,numpu)=help
        endif
      endif
      if((isec1(6).eq.034).and.(isec1(7).eq.100)) then
  ! V VELOCITY
         if((i.eq.0).and.(j.eq.0)) then
            do ii=1,nuvz
              if ((isec1(8)*100.0).eq.akz(ii)) numpv=ii
            end do
        endif
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          vvh(i179+i,j,numpv)=help
        else
          vvh(i-i181,j,numpv)=help
        endif
      endif
      if((isec1(6).eq.052).and.(isec1(7).eq.100)) then
  ! RELATIVE HUMIDITY -> CONVERT TO SPECIFIC HUMIDITY LATER
         if((i.eq.0).and.(j.eq.0)) then
            do ii=1,nuvz
              if ((isec1(8)*100.0).eq.akz(ii)) numprh=ii
            end do
        endif
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          qvh(i179+i,j,numprh,n)=help
        else
          qvh(i-i181,j,numprh,n)=help
        endif
      endif
      if((isec1(6).eq.001).and.(isec1(7).eq.001)) then
  ! SURFACE PRESSURE
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          ps(i179+i,j,1,n)=help
        else
          ps(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.039).and.(isec1(7).eq.100)) then
  ! W VELOCITY
         if((i.eq.0).and.(j.eq.0)) then
            do ii=1,nuvz
              if ((isec1(8)*100.0).eq.akz(ii)) numpw=ii
            end do
        endif
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          wwh(i179+i,j,numpw)=help
        else
          wwh(i-i181,j,numpw)=help
        endif
      endif
      if((isec1(6).eq.066).and.(isec1(7).eq.001)) then
  ! SNOW DEPTH
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          sd(i179+i,j,1,n)=help
        else
          sd(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.002).and.(isec1(7).eq.102)) then
  ! MEAN SEA LEVEL PRESSURE
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          msl(i179+i,j,1,n)=help
        else
          msl(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.071).and.(isec1(7).eq.244)) then
  ! TOTAL CLOUD COVER
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          tcc(i179+i,j,1,n)=help
        else
          tcc(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.033).and.(isec1(7).eq.105).and. &
           (isec1(8).eq.10)) then
  ! 10 M U VELOCITY
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          u10(i179+i,j,1,n)=help
        else
          u10(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.034).and.(isec1(7).eq.105).and. &
           (isec1(8).eq.10)) then
  ! 10 M V VELOCITY
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          v10(i179+i,j,1,n)=help
        else
          v10(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.011).and.(isec1(7).eq.105).and. &
           (isec1(8).eq.02)) then
  ! 2 M TEMPERATURE
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          tt2(i179+i,j,1,n)=help
        else
          tt2(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.017).and.(isec1(7).eq.105).and. &
           (isec1(8).eq.02)) then
  ! 2 M DEW POINT TEMPERATURE
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          td2(i179+i,j,1,n)=help
        else
          td2(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.062).and.(isec1(7).eq.001)) then
  ! LARGE SCALE PREC.
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          lsprec(i179+i,j,1,n)=help
        else
          lsprec(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.063).and.(isec1(7).eq.001)) then
  ! CONVECTIVE PREC.
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          convprec(i179+i,j,1,n)=help
        else
          convprec(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.007).and.(isec1(7).eq.001)) then
  ! TOPOGRAPHY
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          oro(i179+i,j)=help
          excessoro(i179+i,j)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
        else
          oro(i-i181,j)=help
          excessoro(i-i181,j)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
        endif
      endif
      if((isec1(6).eq.081).and.(isec1(7).eq.001)) then
  ! LAND SEA MASK
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          lsm(i179+i,j)=help
        else
          lsm(i-i181,j)=help
        endif
      endif
      if((isec1(6).eq.221).and.(isec1(7).eq.001)) then
  ! MIXING HEIGHT
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          hmix(i179+i,j,1,n)=help
        else
          hmix(i-i181,j,1,n)=help
        endif
      endif
      if((isec1(6).eq.052).and.(isec1(7).eq.105).and. &
           (isec1(8).eq.02)) then
  ! 2 M RELATIVE HUMIDITY
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          qvh2(i179+i,j)=help
        else
          qvh2(i-i181,j)=help
        endif
      endif
      if((isec1(6).eq.011).and.(isec1(7).eq.107)) then
  ! TEMPERATURE LOWEST SIGMA LEVEL
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          tlev1(i179+i,j)=help
        else
          tlev1(i-i181,j)=help
        endif
      endif
      if((isec1(6).eq.033).and.(isec1(7).eq.107)) then
  ! U VELOCITY LOWEST SIGMA LEVEL
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          ulev1(i179+i,j)=help
        else
          ulev1(i-i181,j)=help
        endif
      endif
      if((isec1(6).eq.034).and.(isec1(7).eq.107)) then
  ! V VELOCITY LOWEST SIGMA LEVEL
        help=zsec4(nxfield*(ny-j-1)+i+1)
        if(i.le.i180) then
          vlev1(i179+i,j)=help
        else
          vlev1(i-i181,j)=help
        endif
      endif

    end do
  end do

  endif

  if((isec1(6).eq.33).and.(isec1(7).eq.100)) then
  ! NCEP ISOBARIC LEVELS
    iumax=iumax+1
  endif

  call grib_release(igrib)
  goto 10                      !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !

  !HSO close grib file
50   continue
  call grib_close_file(ifile)

  ! SENS. HEAT FLUX
  sshf(:,:,1,n)=0.0     ! not available from gfs.tccz.pgrbfxx files
  hflswitch=.false.    ! Heat flux not available
  ! SOLAR RADIATIVE FLUXES
  ssr(:,:,1,n)=0.0      ! not available from gfs.tccz.pgrbfxx files
  ! EW SURFACE STRESS
  ewss=0.0         ! not available from gfs.tccz.pgrbfxx files
  ! NS SURFACE STRESS
  nsss=0.0         ! not available from gfs.tccz.pgrbfxx files
  strswitch=.false.    ! stress not available

  ! CONVERT TP TO LSP (GRIB2 only)
  if (gribVer.eq.2) then
    do j=0,nymin1
    do i=0,nxfield-1
     if(i.le.i180) then
     if (convprec(i179+i,j,1,n).lt.lsprec(i179+i,j,1,n)) then ! neg precip would occur
         lsprec(i179+i,j,1,n)= &
              lsprec(i179+i,j,1,n)-convprec(i179+i,j,1,n)
     else
         lsprec(i179+i,j,1,n)=0
     endif
     else
     if (convprec(i-i181,j,1,n).lt.lsprec(i-i181,j,1,n)) then
          lsprec(i-i181,j,1,n)= &
               lsprec(i-i181,j,1,n)-convprec(i-i181,j,1,n)
     else
          lsprec(i-i181,j,1,n)=0
     endif
     endif
    enddo
    enddo
  endif
  !HSO end edits


  ! TRANSFORM RH TO SPECIFIC HUMIDITY

  do j=0,ny-1
    do i=0,nxfield-1
      do k=1,nuvz
        help=qvh(i,j,k,n)
        temp=tth(i,j,k,n)
        plev1=akm(k)+bkm(k)*ps(i,j,1,n)
        elev=ew(temp)*help/100.0
        qvh(i,j,k,n)=xmwml*(elev/(plev1-((1.0-xmwml)*elev)))
      end do
    end do
  end do

  ! CALCULATE 2 M DEW POINT FROM 2 M RELATIVE HUMIDITY
  ! USING BOLTON'S (1980) FORMULA
  ! BECAUSE td2 IS NOT AVAILABLE FROM NCEP GFS DATA

  do j=0,ny-1
    do i=0,nxfield-1
        help=qvh2(i,j)
        temp=tt2(i,j,1,n)
        elev=ew(temp)/100.*help/100.   !vapour pressure in hPa
        td2(i,j,1,n)=243.5/(17.67/log(elev/6.112)-1)+273.
        if (help.le.0.) td2(i,j,1,n)=tt2(i,j,1,n)
    end do
  end do

  if(levdiff2.eq.0) then
    iwmax=nlev_ec+1
    do i=0,nxmin1
      do j=0,nymin1
        wwh(i,j,nlev_ec+1)=0.
      end do
    end do
  endif


  ! For global fields, assign the leftmost data column also to the rightmost
  ! data column; if required, shift whole grid by nxshift grid points
  !*************************************************************************

  if (xglobal) then
    call shift_field_0(ewss,nxfield,ny)
    call shift_field_0(nsss,nxfield,ny)
    call shift_field_0(oro,nxfield,ny)
    call shift_field_0(excessoro,nxfield,ny)
    call shift_field_0(lsm,nxfield,ny)
    call shift_field_0(ulev1,nxfield,ny)
    call shift_field_0(vlev1,nxfield,ny)
    call shift_field_0(tlev1,nxfield,ny)
    call shift_field_0(qvh2,nxfield,ny)
    call shift_field(ps,nxfield,ny,1,1,2,n)
    call shift_field(sd,nxfield,ny,1,1,2,n)
    call shift_field(msl,nxfield,ny,1,1,2,n)
    call shift_field(tcc,nxfield,ny,1,1,2,n)
    call shift_field(u10,nxfield,ny,1,1,2,n)
    call shift_field(v10,nxfield,ny,1,1,2,n)
    call shift_field(tt2,nxfield,ny,1,1,2,n)
    call shift_field(td2,nxfield,ny,1,1,2,n)
    call shift_field(lsprec,nxfield,ny,1,1,2,n)
    call shift_field(convprec,nxfield,ny,1,1,2,n)
    call shift_field(sshf,nxfield,ny,1,1,2,n)
    call shift_field(ssr,nxfield,ny,1,1,2,n)
    call shift_field(hmix,nxfield,ny,1,1,2,n)
    call shift_field(tth,nxfield,ny,nuvzmax,nuvz,2,n)
    call shift_field(qvh,nxfield,ny,nuvzmax,nuvz,2,n)
    call shift_field(uuh,nxfield,ny,nuvzmax,nuvz,1,1)
    call shift_field(vvh,nxfield,ny,nuvzmax,nuvz,1,1)
    call shift_field(wwh,nxfield,ny,nwzmax,nwz,1,1)
  endif

  do i=0,nxmin1
    do j=0,nymin1
  ! Convert precip. from mm/s -> mm/hour
      convprec(i,j,1,n)=convprec(i,j,1,n)*3600.
      lsprec(i,j,1,n)=lsprec(i,j,1,n)*3600.
      surfstr(i,j,1,n)=sqrt(ewss(i,j)**2+nsss(i,j)**2)
    end do
  end do

  if ((.not.hflswitch).or.(.not.strswitch)) then
  !  write(*,*) 'WARNING: No flux data contained in GRIB file ',
  !    +  wfname(indj)

  ! CALCULATE USTAR AND SSHF USING THE PROFILE METHOD
  !***************************************************************************

    do i=0,nxmin1
      do j=0,nymin1
        hlev1=30.0                     ! HEIGHT OF FIRST MODEL SIGMA LAYER
        ff10m= sqrt(u10(i,j,1,n)**2+v10(i,j,1,n)**2)
        fflev1=sqrt(ulev1(i,j)**2+vlev1(i,j)**2)
        call pbl_profile(ps(i,j,1,n),td2(i,j,1,n),hlev1, &
             tt2(i,j,1,n),tlev1(i,j),ff10m,fflev1, &
             surfstr(i,j,1,n),sshf(i,j,1,n))
        if(sshf(i,j,1,n).gt.200.) sshf(i,j,1,n)=200.
        if(sshf(i,j,1,n).lt.-400.) sshf(i,j,1,n)=-400.
      end do
    end do
  endif


  if(iumax.ne.nuvz) stop 'READWIND: NUVZ NOT CONSISTENT'
  if(iumax.ne.nwz)    stop 'READWIND: NWZ NOT CONSISTENT'

  return
888   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfname(indj),'                    #### '
  write(*,*) ' #### IS NOT GRIB FORMAT !!!                  #### '
  stop 'Execution terminated'
999   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfname(indj),'                    #### '
  write(*,*) ' #### CANNOT BE OPENED !!!                    #### '
  stop 'Execution terminated'

end subroutine readwind

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine getrc(nc,i,j,t,gr,rh,rr,rc)
  !                 i  i i i i  i  i  o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of the surface resistance according to the procedure given    *
  !  in:                                                                       *
  !  Wesely (1989): Parameterization of surface resistances to gaseous         *
  !  dry deposition in regional-scale numerical models.                        *
  !  Atmos. Environ. 23, 1293-1304.                                            *
  !                                                                            *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 19 May 1995                                    *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! reldiff(maxspec)  diffusivity of H2O/diffusivity of component i            *
  ! gr [W/m2]       global radiation                                           *
  ! i               index of seasonal category                                 *
  ! j               index of landuse class                                     *
  ! ldep(maxspec)          1, if deposition shall be calculated for species i  *
  ! nc                   actual number of chemical components                  *
  ! rcl(maxspec,5,8) [s/m] Lower canopy resistance                             *
  ! rgs(maxspec,5,8) [s/m] Ground resistance                                   *
  ! rlu(maxspec,5,8) [s/m] Leaf cuticular resistance                           *
  ! rm(maxspec) [s/m]      Mesophyll resistance                                *
  ! t [C]           temperature                                                *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: i,j,ic,nc
  real :: gr,rh,rr,t,rs,rsm,corr,rluc,rclc,rgsc,rdc,rluo
  real :: rc(maxspec)


  ! Compute stomatal resistance
  !****************************
  ! Sabine Eckhardt, Dec 06: use 1E25 instead of 99999. for infinite res.

  if ((t.gt.0.).and.(t.lt.40.)) then
    rs=ri(i,j)*(1.+(200./(gr+0.1))**2)*(400./(t*(40.-t)))
  else
    rs=1.E25
  !  rs=99999.
  endif


  ! Correct stomatal resistance for effect of dew and rain
  !*******************************************************

  if ((rh.gt.0.9).or.(rr.gt.0.)) rs=rs*3.

  ! Compute the lower canopy resistance
  !************************************

  rdc=100.*(1.+1000./(gr+10.))


  corr=1000.*exp(-1.*t-4.)
  do ic=1,nc
    if (reldiff(ic).gt.0.) then

  ! Compute combined stomatal and mesophyll resistance
  !***************************************************

      rsm=rs*reldiff(ic)+rm(ic)

  ! Correct leaf cuticular, lower canopy and ground resistance
  !***********************************************************

      rluc=rlu(ic,i,j)+corr
      rclc=rcl(ic,i,j)+corr
      rgsc=rgs(ic,i,j)+corr

  ! Correct leaf cuticular resistance for effect of dew and rain
  !*************************************************************

      if (rr.gt.0.) then
        rluo=1./(1./1000.+1./(3.*rluc))
        rluc=1./(1./(3.*rluc)+1.e-7*henry(ic)+f0(ic)/rluo)
      else if (rh.gt.0.9) then
        rluo=1./(1./3000.+1./(3.*rluc))
        rluc=1./(1./(3.*rluc)+1.e-7*henry(ic)+f0(ic)/rluo)
      endif

  ! Combine resistances to give total resistance
  !*********************************************

      rc(ic)=1./(1./rsm+1./rluc+1./(rdc+rclc)+1./(rac(i,j)+rgsc))
  ! Sabine Eckhardt, Dec 06: avoid possible excessively high vdep
      if (rc(ic).lt.10.) rc(ic)=10.
    endif
  end do

end subroutine getrc

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine init_domainfill
  !
  !*****************************************************************************
  !                                                                            *
  ! Initializes particles equally distributed over the first release location  *
  ! specified in file RELEASES. This box is assumed to be the domain for doing *
  ! domain-filling trajectory calculations.                                    *
  ! All particles carry the same amount of mass which alltogether comprises the*
  ! mass of air within the box.                                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     15 October 2002                                                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! numparticlecount    consecutively counts the number of particles released  *
  ! nx_we(2)       grid indices for western and eastern boundary of domain-    *
  !                filling trajectory calculations                             *
  ! ny_sn(2)       grid indices for southern and northern boundary of domain-  *
  !                filling trajectory calculations                             *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod

  implicit none

  integer :: j,ix,jy,kz,ncolumn,numparttot
  real :: gridarea(0:nymax-1),pp(nzmax),ylat,ylatp,ylatm,hzone,ran1
  real :: cosfactm,cosfactp,deltacol,dz1,dz2,dz,pnew,fractus
  real,parameter :: pih=pi/180.
  real :: colmass(0:nxmax-1,0:nymax-1),colmasstotal,zposition

  integer :: ixm,ixp,jym,jyp,indzm,indzp,in,indzh,i,jj
  real :: pvpart,ddx,ddy,rddx,rddy,p1,p2,p3,p4,y1(2)

  integer :: idummy = -11


  ! Determine the release region (only full grid cells), over which particles
  ! shall be initialized
  ! Use 2 fields for west/east and south/north boundary
  !**************************************************************************

  nx_we(1)=max(int(xpoint1(1)),0)
  nx_we(2)=min((int(xpoint2(1))+1),nxmin1)
  ny_sn(1)=max(int(ypoint1(1)),0)
  ny_sn(2)=min((int(ypoint2(1))+1),nymin1)

  ! For global simulations (both global wind data and global domain-filling),
  ! set a switch, such that no boundary conditions are used
  !**************************************************************************
  if (xglobal.and.sglobal.and.nglobal) then
    if ((nx_we(1).eq.0).and.(nx_we(2).eq.nxmin1).and. &
         (ny_sn(1).eq.0).and.(ny_sn(2).eq.nymin1)) then
      gdomainfill=.true.
    else
      gdomainfill=.false.
    endif
  endif

  ! Do not release particles twice (i.e., not at both in the leftmost and rightmost
  ! grid cell) for a global domain
  !*****************************************************************************
  if (xglobal) nx_we(2)=min(nx_we(2),nx-2)


  ! Calculate area of grid cell with formula M=2*pi*R*h*dx/360,
  ! see Netz, Formeln der Mathematik, 5. Auflage (1983), p.90
  !************************************************************

  do jy=ny_sn(1),ny_sn(2)      ! loop about latitudes
    ylat=ylat0+real(jy)*dy
    ylatp=ylat+0.5*dy
    ylatm=ylat-0.5*dy
    if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
      hzone=1./dyconst
    else
      cosfactp=cos(ylatp*pih)*r_earth
      cosfactm=cos(ylatm*pih)*r_earth
      if (cosfactp.lt.cosfactm) then
        hzone=sqrt(r_earth**2-cosfactp**2)- &
             sqrt(r_earth**2-cosfactm**2)
      else
        hzone=sqrt(r_earth**2-cosfactm**2)- &
             sqrt(r_earth**2-cosfactp**2)
      endif
    endif
    gridarea(jy)=2.*pi*r_earth*hzone*dx/360.
  end do

  ! Do the same for the south pole

  if (sglobal) then
    ylat=ylat0
    ylatp=ylat+0.5*dy
    ylatm=ylat
    cosfactm=0.
    cosfactp=cos(ylatp*pih)*r_earth
    hzone=sqrt(r_earth**2-cosfactm**2)- &
         sqrt(r_earth**2-cosfactp**2)
    gridarea(0)=2.*pi*r_earth*hzone*dx/360.
  endif

  ! Do the same for the north pole

  if (nglobal) then
    ylat=ylat0+real(nymin1)*dy
    ylatp=ylat
    ylatm=ylat-0.5*dy
    cosfactp=0.
    cosfactm=cos(ylatm*pih)*r_earth
    hzone=sqrt(r_earth**2-cosfactp**2)- &
         sqrt(r_earth**2-cosfactm**2)
    gridarea(nymin1)=2.*pi*r_earth*hzone*dx/360.
  endif


  ! Calculate total mass of each grid column and of the whole atmosphere
  !*********************************************************************

  colmasstotal=0.
  do jy=ny_sn(1),ny_sn(2)          ! loop about latitudes
    do ix=nx_we(1),nx_we(2)      ! loop about longitudes
      pp(1)=rho(ix,jy,1,1)*r_air*tt(ix,jy,1,1)
      pp(nz)=rho(ix,jy,nz,1)*r_air*tt(ix,jy,nz,1)
      colmass(ix,jy)=(pp(1)-pp(nz))/ga*gridarea(jy)
      colmasstotal=colmasstotal+colmass(ix,jy)
    end do
  end do

           write(*,*) 'Atm. mass: ',colmasstotal


  if (ipin.eq.0) numpart=0

  ! Determine the particle positions
  !*********************************

  numparttot=0
  numcolumn=0
  do jy=ny_sn(1),ny_sn(2)      ! loop about latitudes
    ylat=ylat0+real(jy)*dy
    do ix=nx_we(1),nx_we(2)      ! loop about longitudes
      ncolumn=nint(0.999*real(npart(1))*colmass(ix,jy)/ &
           colmasstotal)
      if (ncolumn.eq.0) goto 30
      if (ncolumn.gt.numcolumn) numcolumn=ncolumn

  ! Calculate pressure at the altitudes of model surfaces, using the air density
  ! information, which is stored as a 3-d field
  !*****************************************************************************

      do kz=1,nz
        pp(kz)=rho(ix,jy,kz,1)*r_air*tt(ix,jy,kz,1)
      end do


      deltacol=(pp(1)-pp(nz))/real(ncolumn)
      pnew=pp(1)+deltacol/2.
      jj=0
      do j=1,ncolumn
        jj=jj+1


  ! For columns with many particles (i.e. around the equator), distribute
  ! the particles equally, for columns with few particles (i.e. around the
  ! poles), distribute the particles randomly
  !***********************************************************************


        if (ncolumn.gt.20) then
          pnew=pnew-deltacol
        else
          pnew=pp(1)-ran1(idummy)*(pp(1)-pp(nz))
        endif

        do kz=1,nz-1
          if ((pp(kz).ge.pnew).and.(pp(kz+1).lt.pnew)) then
            dz1=pp(kz)-pnew
            dz2=pnew-pp(kz+1)
            dz=1./(dz1+dz2)

  ! Assign particle position
  !*************************
  ! Do the following steps only if particles are not read in from previous model run
  !*****************************************************************************
            if (ipin.eq.0) then
              xtra1(numpart+jj)=real(ix)-0.5+ran1(idummy)
              if (ix.eq.0) xtra1(numpart+jj)=ran1(idummy)
              if (ix.eq.nxmin1) xtra1(numpart+jj)= &
                   real(nxmin1)-ran1(idummy)
              ytra1(numpart+jj)=real(jy)-0.5+ran1(idummy)
              ztra1(numpart+jj)=(height(kz)*dz2+height(kz+1)*dz1)*dz
              if (ztra1(numpart+jj).gt.height(nz)-0.5) &
                   ztra1(numpart+jj)=height(nz)-0.5


  ! Interpolate PV to the particle position
  !****************************************
              ixm=int(xtra1(numpart+jj))
              jym=int(ytra1(numpart+jj))
              ixp=ixm+1
              jyp=jym+1
              ddx=xtra1(numpart+jj)-real(ixm)
              ddy=ytra1(numpart+jj)-real(jym)
              rddx=1.-ddx
              rddy=1.-ddy
              p1=rddx*rddy
              p2=ddx*rddy
              p3=rddx*ddy
              p4=ddx*ddy
              do i=2,nz
                if (height(i).gt.ztra1(numpart+jj)) then
                  indzm=i-1
                  indzp=i
                  goto 6
                endif
              end do
6             continue
              dz1=ztra1(numpart+jj)-height(indzm)
              dz2=height(indzp)-ztra1(numpart+jj)
              dz=1./(dz1+dz2)
              do in=1,2
                indzh=indzm+in-1
                y1(in)=p1*pv(ixm,jym,indzh,1) &
                     +p2*pv(ixp,jym,indzh,1) &
                     +p3*pv(ixm,jyp,indzh,1) &
                     +p4*pv(ixp,jyp,indzh,1)
              end do
              pvpart=(dz2*y1(1)+dz1*y1(2))*dz
              if (ylat.lt.0.) pvpart=-1.*pvpart


  ! For domain-filling option 2 (stratospheric O3), do the rest only in the stratosphere
  !*****************************************************************************

              if (((ztra1(numpart+jj).gt.3000.).and. &
                   (pvpart.gt.pvcrit)).or.(mdomainfill.eq.1)) then

  ! Assign certain properties to the particle
  !******************************************
                nclass(numpart+jj)=min(int(ran1(idummy)* &
                     real(nclassunc))+1,nclassunc)
                numparticlecount=numparticlecount+1
                npoint(numpart+jj)=numparticlecount
                idt(numpart+jj)=mintime
                itra1(numpart+jj)=0
                itramem(numpart+jj)=0
                itrasplit(numpart+jj)=itra1(numpart+jj)+ldirect* &
                     itsplit
                xmass1(numpart+jj,1)=colmass(ix,jy)/real(ncolumn)
                if (mdomainfill.eq.2) xmass1(numpart+jj,1)= &
                     xmass1(numpart+jj,1)*pvpart*48./29.*ozonescale/10.**9
              else
                jj=jj-1
              endif
            endif
          endif
        end do
      end do
      numparttot=numparttot+ncolumn
      if (ipin.eq.0) numpart=numpart+jj
30    continue
    end do
  end do


  ! Check whether numpart is really smaller than maxpart
  !*****************************************************

  if (numpart.gt.maxpart) then
    write(*,*) 'numpart too large: change source in init_atm_mass.f'
    write(*,*) 'numpart: ',numpart,' maxpart: ',maxpart
  endif


  xmassperparticle=colmasstotal/real(numparttot)


  ! Make sure that all particles are within domain
  !***********************************************

  do j=1,numpart
    if ((xtra1(j).lt.0.).or.(xtra1(j).ge.real(nxmin1)).or. &
         (ytra1(j).lt.0.).or.(ytra1(j).ge.real(nymin1))) then
      itra1(j)=-999999999
    endif
  end do




  ! For boundary conditions, we need fewer particle release heights per column,
  ! because otherwise it takes too long until enough mass has accumulated to
  ! release a particle at the boundary (would take dx/u seconds), leading to
  ! relatively large position errors of the order of one grid distance.
  ! It's better to release fewer particles per column, but to do so more often.
  ! Thus, use on the order of nz starting heights per column.
  ! We thus repeat the above to determine fewer starting heights, that are
  ! used furtheron in subroutine boundcond_domainfill.f.
  !****************************************************************************

  fractus=real(numcolumn)/real(nz)
  write(*,*) 'Total number of particles at model start: ',numpart
  write(*,*) 'Maximum number of particles per column: ',numcolumn
  write(*,*) 'If ',fractus,' <1, better use more particles'
  fractus=sqrt(max(fractus,1.))/2.

  do jy=ny_sn(1),ny_sn(2)      ! loop about latitudes
    do ix=nx_we(1),nx_we(2)      ! loop about longitudes
      ncolumn=nint(0.999/fractus*real(npart(1))*colmass(ix,jy) &
           /colmasstotal)
      if (ncolumn.gt.maxcolumn) stop 'maxcolumn too small'
      if (ncolumn.eq.0) goto 80


  ! Memorize how many particles per column shall be used for all boundaries
  ! This is further used in subroutine boundcond_domainfill.f
  ! Use 2 fields for west/east and south/north boundary
  !************************************************************************

      if (ix.eq.nx_we(1)) numcolumn_we(1,jy)=ncolumn
      if (ix.eq.nx_we(2)) numcolumn_we(2,jy)=ncolumn
      if (jy.eq.ny_sn(1)) numcolumn_sn(1,ix)=ncolumn
      if (jy.eq.ny_sn(2)) numcolumn_sn(2,ix)=ncolumn

  ! Calculate pressure at the altitudes of model surfaces, using the air density
  ! information, which is stored as a 3-d field
  !*****************************************************************************

      do kz=1,nz
        pp(kz)=rho(ix,jy,kz,1)*r_air*tt(ix,jy,kz,1)
      end do

  ! Determine the reference starting altitudes
  !*******************************************

      deltacol=(pp(1)-pp(nz))/real(ncolumn)
      pnew=pp(1)+deltacol/2.
      do j=1,ncolumn
        pnew=pnew-deltacol
        do kz=1,nz-1
          if ((pp(kz).ge.pnew).and.(pp(kz+1).lt.pnew)) then
            dz1=pp(kz)-pnew
            dz2=pnew-pp(kz+1)
            dz=1./(dz1+dz2)
            zposition=(height(kz)*dz2+height(kz+1)*dz1)*dz
           if (zposition.gt.height(nz)-0.5) zposition=height(nz)-0.5

  ! Memorize vertical positions where particles are introduced
  ! This is further used in subroutine boundcond_domainfill.f
  !***********************************************************

            if (ix.eq.nx_we(1)) zcolumn_we(1,jy,j)=zposition
            if (ix.eq.nx_we(2)) zcolumn_we(2,jy,j)=zposition
            if (jy.eq.ny_sn(1)) zcolumn_sn(1,ix,j)=zposition
            if (jy.eq.ny_sn(2)) zcolumn_sn(2,ix,j)=zposition

  ! Initialize mass that has accumulated at boundary to zero
  !*********************************************************

            acc_mass_we(1,jy,j)=0.
            acc_mass_we(2,jy,j)=0.
            acc_mass_sn(1,jy,j)=0.
            acc_mass_sn(2,jy,j)=0.
          endif
        end do
      end do
80    continue
    end do
  end do

  ! If particles shall be read in to continue an existing run,
  ! then the accumulated masses at the domain boundaries must be read in, too.
  ! This overrides any previous calculations.
  !***************************************************************************

  if (ipin.eq.1) then
    open(unitboundcond,file=path(2)(1:length(2))//'boundcond.bin', &
         form='unformatted')
    read(unitboundcond) numcolumn_we,numcolumn_sn, &
         zcolumn_we,zcolumn_sn,acc_mass_we,acc_mass_sn
    close(unitboundcond)
  endif




end subroutine init_domainfill

PROGRAM testdrive

    USE class_gribfile

    IMPLICIT NONE

    CHARACTER(LEN=256) :: the_file_path

    INTEGER, PARAMETER :: NCASES = 6
    CHARACTER(LEN=256), DIMENSION(NCASES) :: file_paths
    CHARACTER(LEN=256), DIMENSION(NCASES) :: descriptions

    TYPE(gribfile_object) :: my_gribfile

    INTEGER :: case_number

    !!!!!!!!!!!!!!!!!!!
    ! These define the header and the grib file used for each test
    descriptions(1) = "ECMWF GRIB1 on global 1.0 degree domain"
    file_paths(1) = "../../../devtest/case_data/met_data/ecmwf/t1_03h_ec1p0d/EN13062503"

    descriptions(2) = "ECMWF GRIB1/2 on tiny domain"
    file_paths(2) = "../../../devtest/case_data/met_data/ecmwf/t1_33h_ec1p0d/EL14091909"

    descriptions(3) = "ECMWF GRIB1/2 on global 1.0 degree domain"
    file_paths(3) = "../../../devtest/case_data/met_data/ecmwf/t1_03h_ec1p0d_grib1-2/EE13110700"

    descriptions(4) = "ECMWF GRIB2 on global 1.0 degree domain"
    file_paths(4) = "../../../devtest/case_data/met_data/ecmwf/t1_03h_ec1p0d_grib2/EN13110700"

    descriptions(5) = "NCEP GRIB1 on global 1.0 degree domain"
    file_paths(5) = "../../../devtest/case_data/met_data/ncep/t1_06h_nc1p0d_grib1/GD05051406"

    descriptions(6) = "NCEP GRIB2 on global 1.0 degree domain"
    file_paths(6) = "../../../devtest/case_data/met_data/ncep/t1_03h_nc1p0d/GF15021603"
    !!!!!!!!!!!!!!!!!!!

    DO case_number = 1,NCASES
        PRINT *,
        PRINT *, TRIM( descriptions( case_number) )

        my_gribfile = gribfile_object_create( file_paths(case_number) )
        PRINT *,
        PRINT *, 'Output from calling gribfile_printobj()...'
        PRINT *, '++++++++++'
        CALL gribfile_printobj(my_gribfile)
        PRINT *, '++++++++++'
        PRINT *,
        
        PRINT *, 'Output from the getter methods...'
        PRINT *, 'gribfile_center()   : ', gribfile_centre( file_paths(case_number) )

        PRINT *, 'gribfile_num_xlon   : ', gribfile_num_xlon(my_gribfile)
        PRINT *, 'gribfile_num_ylat   : ', gribfile_num_ylat(my_gribfile)
        PRINT *, 'gribfile_num_zlevel : ', gribfile_num_zlevel(my_gribfile)
        PRINT *,
        PRINT *, '----------------------------'
    ENDDO


END PROGRAM testdrive

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine timemanager

  !*****************************************************************************
  !                                                                            *
  ! Handles the computation of trajectories, i.e. determines which             *
  ! trajectories have to be computed at what time.                             *
  ! Manages dry+wet deposition routines, radioactive decay and the computation *
  ! of concentrations.                                                         *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     20 May 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:                                     *
  !        Call of convmix when new windfield is read                          *
  !------------------------------------                                        *
  !  Changes Petra Seibert, Sept 2002                                          *
  !     fix wet scavenging problem                                             *
  !     Code may not be correct for decay of deposition!                       *
  !  Changes Petra Seibert, Nov 2002                                           *
  !     call convection BEFORE new fields are read in BWD mode                 *
  !  Changes Caroline Forster, Feb 2005                                        *
  !new interface between flexpart and convection scheme                        *
  !Emanuel's latest subroutine convect43c.f is used                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! DEP                .true. if either wet or dry deposition is switched on   *
  ! decay(maxspec) [1/s] decay constant for radioactive decay                  *
  ! DRYDEP             .true. if dry deposition is switched on                 *
  ! ideltas [s]        modelling period                                        *
  ! itime [s]          actual temporal position of calculation                 *
  ! ldeltat [s]        time since computation of radioact. decay of depositions*
  ! loutaver [s]       averaging period for concentration calculations         *
  ! loutend [s]        end of averaging for concentration calculations         *
  ! loutnext [s]       next time at which output fields shall be centered      *
  ! loutsample [s]     sampling interval for averaging of concentrations       *
  ! loutstart [s]      start of averaging for concentration calculations       *
  ! loutstep [s]       time interval for which concentrations shall be         *
  !                    calculated                                              *
  ! npoint(maxpart)    index, which starting point the trajectory has          *
  !                    starting positions of trajectories                      *
  ! nstop              serves as indicator for fate of particles               *
  !                    in the particle loop                                    *
  ! nstop1             serves as indicator for wind fields (see getfields)     *
  ! outnum             number of samples for each concentration calculation    *
  ! outnum             number of samples for each concentration calculation    *
  ! prob               probability of absorption at ground due to dry          *
  !                    deposition                                              *
  ! WETDEP             .true. if wet deposition is switched on                 *
  ! weight             weight for each concentration sample (1/2 or 1)         *
  ! uap(maxpart),ucp(maxpart),uzp(maxpart) = random velocities due to          *
  !                    turbulence                                              *
  ! us(maxpart),vs(maxpart),ws(maxpart) = random velocities due to inter-      *
  !                    polation                                                *
  ! xtra1(maxpart), ytra1(maxpart), ztra1(maxpart) =                           *
  !                    spatial positions of trajectories                       *
  !                                                                            *
  ! Constants:                                                                 *
  ! maxpart            maximum number of trajectories                          *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use point_mod
  use xmass_mod
  use flux_mod
  use outg_mod
  use oh_mod
  use par_mod
  use com_mod

  implicit none

  integer :: j,ks,kp,l,n,itime,nstop,nstop1
! integer :: ksp
  integer :: loutnext,loutstart,loutend
  integer :: ix,jy,ldeltat,itage,nage
  real :: outnum,weight,prob(maxspec)
  real :: uap(maxpart),ucp(maxpart),uzp(maxpart),decfact
  real :: us(maxpart),vs(maxpart),ws(maxpart)
  integer(kind=2) :: cbt(maxpart)
  real :: drydeposit(maxspec),gridtotalunc,wetgridtotalunc
  real :: drygridtotalunc,xold,yold,zold,xmassfract
  !double precision xm(maxspec,maxpointspec_act),
  !    +                 xm_depw(maxspec,maxpointspec_act),
  !    +                 xm_depd(maxspec,maxpointspec_act)


  !open(88,file='TEST.dat')

  ! First output for time 0
  !************************

  loutnext=loutstep/2
  outnum=0.
  loutstart=loutnext-loutaver/2
  loutend=loutnext+loutaver/2

  !  open(127,file=path(2)(1:length(2))//'depostat.dat'
  !    +  ,form='unformatted')
  !write (*,*) 'writing deposition statistics depostat.dat!'

  !**********************************************************************
  ! Loop over the whole modelling period in time steps of mintime seconds
  !**********************************************************************

  !write (*,*) 'starting simulation'
  do itime=0,ideltas,lsynctime


  ! Computation of wet deposition, OH reaction and mass transfer
  ! between two species every lsynctime seconds
  ! maybe wet depo frequency can be relaxed later but better be on safe side
  ! wetdepo must be called BEFORE new fields are read in but should not
  ! be called in the very beginning before any fields are loaded, or
  ! before particles are in the system
  ! Code may not be correct for decay of deposition
  ! changed by Petra Seibert 9/02
  !********************************************************************

    if (WETDEP .and. itime .ne. 0 .and. numpart .gt. 0) &
         call wetdepo(itime,lsynctime,loutnext)

    if (OHREA .and. itime .ne. 0 .and. numpart .gt. 0) &
         call ohreaction(itime,lsynctime,loutnext)

    if (ASSSPEC .and. itime .ne. 0 .and. numpart .gt. 0) then
       stop 'associated species not yet implemented!'
  !     call transferspec(itime,lsynctime,loutnext)
    endif

  ! compute convection for backward runs
  !*************************************

      if ((ldirect.eq.-1).and.(lconvection.eq.1).and.(itime.lt.0)) &
           call convmix(itime)

  ! Get necessary wind fields if not available
  !*******************************************

    call getfields(itime,nstop1)
    if (nstop1.gt.1) stop 'NO METEO FIELDS AVAILABLE'
  ! Release particles
  !******************

    if (mdomainfill.ge.1) then
      if (itime.eq.0) then
        call init_domainfill
      else
        call boundcond_domainfill(itime,loutend)
      endif
    else
      call releaseparticles(itime)
    endif


  ! Compute convective mixing for forward runs
  ! for backward runs it is done before next windfield is read in
  !**************************************************************

      if ((ldirect.eq.1).and.(lconvection.eq.1)) &
           call convmix(itime)


  ! If middle of averaging period of output fields is reached, accumulated
  ! deposited mass radioactively decays
  !***********************************************************************

    if (DEP.and.(itime.eq.loutnext).and.(ldirect.gt.0)) then
      do ks=1,nspec
      do kp=1,maxpointspec_act
        if (decay(ks).gt.0.) then
          do nage=1,nageclass
            do l=1,nclassunc
  ! Mother output grid
              do jy=0,numygrid-1
                do ix=0,numxgrid-1
                  wetgridunc(ix,jy,ks,kp,l,nage)= &
                       wetgridunc(ix,jy,ks,kp,l,nage)* &
                       exp(-1.*outstep*decay(ks))
                  drygridunc(ix,jy,ks,kp,l,nage)= &
                       drygridunc(ix,jy,ks,kp,l,nage)* &
                       exp(-1.*outstep*decay(ks))
                end do
              end do
  ! Nested output grid
              if (nested_output.eq.1) then
                do jy=0,numygridn-1
                  do ix=0,numxgridn-1
                    wetgriduncn(ix,jy,ks,kp,l,nage)= &
                         wetgriduncn(ix,jy,ks,kp,l,nage)* &
                         exp(-1.*outstep*decay(ks))
                    drygriduncn(ix,jy,ks,kp,l,nage)= &
                         drygriduncn(ix,jy,ks,kp,l,nage)* &
                         exp(-1.*outstep*decay(ks))
                  end do
                end do
              endif
            end do
          end do
        endif
      end do
      end do
    endif

  !!! CHANGE: These lines may be switched on to check the conservation
  !!! of mass within FLEXPART
  !   if (itime.eq.loutnext) then
  !   do 247 ksp=1, nspec
  !   do 247 kp=1, maxpointspec_act
  !47         xm(ksp,kp)=0.

  !   do 249 ksp=1, nspec
  !     do 249 j=1,numpart
  !          if (ioutputforeachrelease.eq.1) then
  !            kp=npoint(j)
  !          else
  !            kp=1
  !          endif
  !       if (itra1(j).eq.itime) then
  !          xm(ksp,kp)=xm(ksp,kp)+xmass1(j,ksp)
  !         write(*,*) 'xmass: ',xmass1(j,ksp),j,ksp,nspec
  !       endif
  !49     continue
  !  do 248 ksp=1,nspec
  !  do 248 kp=1,maxpointspec_act
  !  xm_depw(ksp,kp)=0.
  !  xm_depd(ksp,kp)=0.
  !     do 248 nage=1,nageclass
  !       do 248 ix=0,numxgrid-1
  !         do 248 jy=0,numygrid-1
  !           do 248 l=1,nclassunc
  !              xm_depw(ksp,kp)=xm_depw(ksp,kp)
  !    +                  +wetgridunc(ix,jy,ksp,kp,l,nage)
  !48                 xm_depd(ksp,kp)=xm_depd(ksp,kp)
  !    +                  +drygridunc(ix,jy,ksp,kp,l,nage)
  !             do 246 ksp=1,nspec
  !46                    write(88,'(2i10,3e12.3)')
  !    +              itime,ksp,(xm(ksp,kp),kp=1,maxpointspec_act),
  !    +                (xm_depw(ksp,kp),kp=1,maxpointspec_act),
  !    +                (xm_depd(ksp,kp),kp=1,maxpointspec_act)
  !  endif
  !!! CHANGE



  ! Check whether concentrations are to be calculated
  !**************************************************

    if ((ldirect*itime.ge.ldirect*loutstart).and. &
         (ldirect*itime.le.ldirect*loutend)) then ! add to grid
      if (mod(itime-loutstart,loutsample).eq.0) then

  ! If we are exactly at the start or end of the concentration averaging interval,
  ! give only half the weight to this sample
  !*****************************************************************************

        if ((itime.eq.loutstart).or.(itime.eq.loutend)) then
          weight=0.5
        else
          weight=1.0
        endif
        outnum=outnum+weight
        call conccalc(itime,weight)
      endif


      if ((mquasilag.eq.1).and.(itime.eq.(loutstart+loutend)/2)) &
           call partoutput_short(itime)    ! dump particle positions in extremely compressed format


  ! Output and reinitialization of grid
  ! If necessary, first sample of new grid is also taken
  !*****************************************************

      if ((itime.eq.loutend).and.(outnum.gt.0.)) then
        if ((iout.le.3.).or.(iout.eq.5)) then
          call concoutput(itime,outnum,gridtotalunc, &
               wetgridtotalunc,drygridtotalunc)
          if (nested_output.eq.1) call concoutput_nest(itime,outnum)
          outnum=0.
        endif
        if ((iout.eq.4).or.(iout.eq.5)) call plumetraj(itime)
        if (iflux.eq.1) call fluxoutput(itime)
        write(*,45) itime,numpart,gridtotalunc,wetgridtotalunc, &
             drygridtotalunc
45      format(i9,' SECONDS SIMULATED: ',i8, &
             ' PARTICLES:    Uncertainty: ',3f7.3)
        if (ipout.ge.1) call partoutput(itime)    ! dump particle positions
        loutnext=loutnext+loutstep
        loutstart=loutnext-loutaver/2
        loutend=loutnext+loutaver/2
        if (itime.eq.loutstart) then
          weight=0.5
          outnum=outnum+weight
          call conccalc(itime,weight)
        endif


  ! Check, whether particles are to be split:
  ! If so, create new particles and attribute all information from the old
  ! particles also to the new ones; old and new particles both get half the
  ! mass of the old ones
  !************************************************************************

        if (ldirect*itime.ge.ldirect*itsplit) then
          n=numpart
          do j=1,numpart
            if (ldirect*itime.ge.ldirect*itrasplit(j)) then
              if (n.lt.maxpart) then
                n=n+1
                itrasplit(j)=2*(itrasplit(j)-itramem(j))+itramem(j)
                itrasplit(n)=itrasplit(j)
                itramem(n)=itramem(j)
                itra1(n)=itra1(j)
                idt(n)=idt(j)
                npoint(n)=npoint(j)
                nclass(n)=nclass(j)
                xtra1(n)=xtra1(j)
                ytra1(n)=ytra1(j)
                ztra1(n)=ztra1(j)
                uap(n)=uap(j)
                ucp(n)=ucp(j)
                uzp(n)=uzp(j)
                us(n)=us(j)
                vs(n)=vs(j)
                ws(n)=ws(j)
                cbt(n)=cbt(j)
                do ks=1,nspec
                  xmass1(j,ks)=xmass1(j,ks)/2.
                  xmass1(n,ks)=xmass1(j,ks)
                end do
              endif
            endif
          end do
          numpart=n
        endif
      endif
    endif


    if (itime.eq.ideltas) exit         ! almost finished

  ! Compute interval since radioactive decay of deposited mass was computed
  !************************************************************************

    if (itime.lt.loutnext) then
      ldeltat=itime-(loutnext-loutstep)
    else                                  ! first half of next interval
      ldeltat=itime-loutnext
    endif


  ! Loop over all particles
  !************************

    do j=1,numpart


  ! If integration step is due, do it
  !**********************************

      if (itra1(j).eq.itime) then

        if (ioutputforeachrelease.eq.1) then
            kp=npoint(j)
        else
            kp=1
        endif
  ! Determine age class of the particle
        itage=abs(itra1(j)-itramem(j))
        do nage=1,nageclass
          if (itage.lt.lage(nage)) exit
        end do

  ! Initialize newly released particle
  !***********************************

        if ((itramem(j).eq.itime).or.(itime.eq.0)) &
             call initialize(itime,idt(j),uap(j),ucp(j),uzp(j), &
             us(j),vs(j),ws(j),xtra1(j),ytra1(j),ztra1(j),cbt(j))

  ! Memorize particle positions
  !****************************

        xold=xtra1(j)
        yold=ytra1(j)
        zold=ztra1(j)

  ! Integrate Lagevin equation for lsynctime seconds
  !*************************************************

        call advance(itime,npoint(j),idt(j),uap(j),ucp(j),uzp(j), &
             us(j),vs(j),ws(j),nstop,xtra1(j),ytra1(j),ztra1(j),prob, &
             cbt(j))

  ! Calculate the gross fluxes across layer interfaces
  !***************************************************

        if (iflux.eq.1) call calcfluxes(nage,j,xold,yold,zold)


  ! Determine, when next time step is due
  ! If trajectory is terminated, mark it
  !**************************************

        if (nstop.gt.1) then
          if (linit_cond.ge.1) call initial_cond_calc(itime,j)
          itra1(j)=-999999999
        else
          itra1(j)=itime+lsynctime


  ! Dry deposition and radioactive decay for each species
  ! Also check maximum (of all species) of initial mass remaining on the particle;
  ! if it is below a threshold value, terminate particle
  !*****************************************************************************

          xmassfract=0.
          do ks=1,nspec
            if (decay(ks).gt.0.) then             ! radioactive decay
              decfact=exp(-real(abs(lsynctime))*decay(ks))
            else
              decfact=1.
            endif

            if (DRYDEPSPEC(ks)) then        ! dry deposition
              drydeposit(ks)=xmass1(j,ks)*prob(ks)*decfact
              xmass1(j,ks)=xmass1(j,ks)*(1.-prob(ks))*decfact
              if (decay(ks).gt.0.) then   ! correct for decay (see wetdepo)
                drydeposit(ks)=drydeposit(ks)* &
                     exp(real(abs(ldeltat))*decay(ks))
              endif
            else                           ! no dry deposition
              xmass1(j,ks)=xmass1(j,ks)*decfact
            endif


            if (mdomainfill.eq.0) then
              if (xmass(npoint(j),ks).gt.0.) &
                   xmassfract=max(xmassfract,real(npart(npoint(j)))* &
                   xmass1(j,ks)/xmass(npoint(j),ks))
            else
              xmassfract=1.
            endif
          end do

          if (xmassfract.lt.0.0001) then   ! terminate all particles carrying less mass
            itra1(j)=-999999999
          endif

  !        Sabine Eckhardt, June 2008
  !        don't create depofield for backward runs
          if (DRYDEP.AND.(ldirect.eq.1)) then
            call drydepokernel(nclass(j),drydeposit,real(xtra1(j)), &
                 real(ytra1(j)),nage,kp)
            if (nested_output.eq.1) call drydepokernel_nest( &
                 nclass(j),drydeposit,real(xtra1(j)),real(ytra1(j)), &
                 nage,kp)
          endif

  ! Terminate trajectories that are older than maximum allowed age
  !***************************************************************

          if (abs(itra1(j)-itramem(j)).ge.lage(nageclass)) then
            if (linit_cond.ge.1) &
                 call initial_cond_calc(itime+lsynctime,j)
            itra1(j)=-999999999
          endif
        endif

      endif

    end do

  end do


  ! Complete the calculation of initial conditions for particles not yet terminated
  !*****************************************************************************

  do j=1,numpart
    if (linit_cond.ge.1) call initial_cond_calc(itime,j)
  end do

  if (ipout.eq.2) call partoutput(itime)     ! dump particle positions

  if (linit_cond.ge.1) call initial_cond_output(itime)   ! dump initial cond. field

  close(104)

  ! De-allocate memory and end
  !***************************

  if (iflux.eq.1) then
      deallocate(flux)
  endif
  if (OHREA.eqv..TRUE.) then
      deallocate(OH_field,OH_field_height)
  endif
  if (ldirect.gt.0) then
  deallocate(drygridunc,wetgridunc)
  endif
  deallocate(gridunc)
  deallocate(xpoint1,xpoint2,ypoint1,ypoint2,zpoint1,zpoint2,xmass)
  deallocate(ireleasestart,ireleaseend,npart,kindz)
  deallocate(xmasssave)
  if (nested_output.eq.1) then
     deallocate(orooutn, arean, volumen)
     if (ldirect.gt.0) then
     deallocate(griduncn,drygriduncn,wetgriduncn)
     endif
  endif
  deallocate(outheight,outheighthalf)
  deallocate(oroout, area, volume)

end subroutine timemanager

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine coordtrafo

  !**********************************************************************
  !                                                                     *
  !             FLEXPART MODEL SUBROUTINE COORDTRAFO                    *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  !             AUTHOR:      G. WOTAWA                                  *
  !             DATE:        1994-02-07                                 *
  !             LAST UPDATE: 1996-05-18   A. STOHL                      *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION: This subroutine transforms x and y coordinates of      *
  ! particle release points to grid coordinates.                        *
  !                                                                     *
  !**********************************************************************

  use point_mod
  use par_mod
  use com_mod

  implicit none

  integer :: i,j,k

  if (numpoint.eq.0) goto 30

  ! TRANSFORM X- AND Y- COORDINATES OF STARTING POINTS TO GRID COORDINATES
  !***********************************************************************

  do i=1,numpoint
    xpoint1(i)=(xpoint1(i)-xlon0)/dx
    xpoint2(i)=(xpoint2(i)-xlon0)/dx
    ypoint1(i)=(ypoint1(i)-ylat0)/dy
    ypoint2(i)=(ypoint2(i)-ylat0)/dy
  end do

15   continue


  ! CHECK IF RELEASE POINTS ARE WITHIN DOMAIN
  !******************************************

  do i=1,numpoint
    if (sglobal.and.(ypoint1(i).lt.1.e-6)) ypoint1(i)=1.e-6
    if (nglobal.and.(ypoint2(i).gt.real(nymin1)-1.e-5)) &
         ypoint2(i)=real(nymin1)-1.e-5
  if ((ypoint1(i).lt.1.e-6).or.(ypoint1(i).ge.real(nymin1)-1.e-6) &
       .or.(ypoint2(i).lt.1.e-6).or.(ypoint2(i).ge.real(nymin1)-1.e-6) &
       .or.((.not.xglobal).and.((xpoint1(i).lt.1.e-6).or. &
       (xpoint1(i).ge.real(nxmin1)-1.e-6).or.(xpoint2(i).lt.1.e-6).or. &
       (xpoint2(i).ge.real(nxmin1)-1.e-6)))) then
      write(*,*) ' NOTICE: RELEASE POINT OUT OF DOMAIN DETECTED.'
      write(*,*) ' IT IS REMOVED NOW ... '
      if (i.ge.1000) then
         write(*,*) ' COMMENT: ',compoint(i)
      else
         write(*,*) ' COMMENT: ',compoint(1001)
      endif
      if (i.lt.numpoint) then
        do j=i+1,numpoint
          xpoint1(j-1)=xpoint1(j)
          ypoint1(j-1)=ypoint1(j)
          xpoint2(j-1)=xpoint2(j)
          ypoint2(j-1)=ypoint2(j)
          zpoint1(j-1)=zpoint1(j)
          zpoint2(j-1)=zpoint2(j)
          npart(j-1)=npart(j)
          kindz(j-1)=kindz(j)
          ireleasestart(j-1)=ireleasestart(j)
          ireleaseend(j-1)=ireleaseend(j)
          if (j.le.1000) compoint(j-1)=compoint(j)
          do k=1,nspec
            xmass(j-1,k)=xmass(j,k)
          end do
        end do
      endif

      numpoint=numpoint-1
      if (numpoint.gt.0) goto 15
    endif
  end do

30   if(numpoint.eq.0) then
    write(*,*) ' FLEXPART MODEL SUBROUTINE COORDTRAFO: ERROR ! '
    write(*,*) ' NO PARTICLE RELEASES ARE DEFINED!'
    write(*,*) ' CHECK FILE RELEASES...'
    stop
  endif

end subroutine coordtrafo

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readoutgrid

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the user specifications for the output grid.        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     4 June 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! dxout,dyout          grid distance                                         *
  ! numxgrid,numygrid,numzgrid    grid dimensions                              *
  ! outlon0,outlat0      lower left corner of grid                             *
  ! outheight(maxzgrid)  height levels of output grid [m]                      *
  !                                                                            *
  ! Constants:                                                                 *
  ! unitoutgrid          unit connected to file OUTGRID                        *
  !                                                                            *
  !*****************************************************************************

  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: i,j,stat
  real :: outhelp,xr,xr1,yr,yr1
  real,parameter :: eps=1.e-4



  ! Open the OUTGRID file and read output grid specifications
  !**********************************************************

  open(unitoutgrid,file=path(1)(1:length(1))//'OUTGRID',status='old', &
       err=999)


  call skplin(5,unitoutgrid)


  ! 1.  Read horizontal grid specifications
  !****************************************

  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f11.4)') outlon0
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f11.4)') outlat0
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,i5)') numxgrid
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,i5)') numygrid
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f12.5)') dxout
  call skplin(3,unitoutgrid)
  read(unitoutgrid,'(4x,f12.5)') dyout


  ! Check validity of output grid (shall be within model domain)
  !*************************************************************

  xr=outlon0+real(numxgrid)*dxout
  yr=outlat0+real(numygrid)*dyout
  xr1=xlon0+real(nxmin1)*dx
  yr1=ylat0+real(nymin1)*dy
  if ((outlon0+eps.lt.xlon0).or.(outlat0+eps.lt.ylat0) &
       .or.(xr.gt.xr1+eps).or.(yr.gt.yr1+eps)) then
    write(*,*) outlon0,outlat0
    write(*,*) xr1,yr1,xlon0,ylat0,xr,yr,dxout,dyout
    write(*,*) ' #### FLEXPART MODEL ERROR! PART OF OUTPUT    ####'
    write(*,*) ' #### GRID IS OUTSIDE MODEL DOMAIN. CHANGE    ####'
    write(*,*) ' #### FILE OUTGRID IN DIRECTORY               ####'
    write(*,'(a)') path(1)(1:length(1))
    stop
  endif

  ! 2. Count Vertical levels of output grid
  !****************************************
  j=0
100   j=j+1
    do i=1,3
      read(unitoutgrid,*,end=99)
    end do
    read(unitoutgrid,'(4x,f7.1)',end=99) outhelp
    if (outhelp.eq.0.) goto 99
    goto 100
99   numzgrid=j-1

    allocate(outheight(numzgrid) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
    allocate(outheighthalf(numzgrid) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'


  rewind(unitoutgrid)
  call skplin(29,unitoutgrid)

  ! 2. Vertical levels of output grid
  !**********************************

  j=0
1000   j=j+1
    do i=1,3
      read(unitoutgrid,*,end=990)
    end do
    read(unitoutgrid,'(4x,f7.1)',end=990) outhelp
    if (outhelp.eq.0.) goto 99
    outheight(j)=outhelp
    goto 1000
990   numzgrid=j-1


  ! Check whether vertical levels are specified in ascending order
  !***************************************************************

  do j=2,numzgrid
    if (outheight(j).le.outheight(j-1)) then
    write(*,*) ' #### FLEXPART MODEL ERROR! YOUR SPECIFICATION#### '
    write(*,*) ' #### OF OUTPUT LEVELS IS CORRUPT AT LEVEL    #### '
    write(*,*) ' #### ',j,'                              #### '
    write(*,*) ' #### PLEASE MAKE CHANGES IN FILE OUTGRID.    #### '
    endif
  end do

  ! Determine the half levels, i.e. middle levels of the output grid
  !*****************************************************************

  outheighthalf(1)=outheight(1)/2.
  do j=2,numzgrid
    outheighthalf(j)=(outheight(j-1)+outheight(j))/2.
  end do


  xoutshift=xlon0-outlon0
  youtshift=ylat0-outlat0
  close(unitoutgrid)

    allocate(oroout(0:numxgrid-1,0:numygrid-1) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
    allocate(area(0:numxgrid-1,0:numygrid-1) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
    allocate(volume(0:numxgrid-1,0:numygrid-1,numzgrid) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
    allocate(areaeast(0:numxgrid-1,0:numygrid-1,numzgrid) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
    allocate(areanorth(0:numxgrid-1,0:numygrid-1,numzgrid) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
  return


999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "OUTGRID"    #### '
  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
  write(*,*) ' #### xxx/flexpart/options                    #### '
  stop

end subroutine readoutgrid

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!*******************************************************************************
!   Include file for calculation of particle trajectories (Program FLEXPART)   *
!        This file contains the parameter statements used in FLEXPART          *
!                                                                              *
!        Author: A. Stohl                                                      *
!                                                                              *
!        1997                                                                  *
!                                                                              *
!        Update 15 August 2013 IP                                              *
!                                                                              *
!        Anne Tipka, Petra Seibert, 2021-02: implement new interpolation       *
!           for precipitation according to #295 using 2 additional fields      *
!                                                                              *
!*******************************************************************************

module par_mod

  implicit none

  !****************************************************************
  ! Parameters defining KIND parameter for double/single precision
  !****************************************************************

  integer,parameter :: dp=selected_real_kind(P=15)
  integer,parameter :: sp=selected_real_kind(6)

  !****************************************************************
  ! dep_prec sets the precision for deposition calculations (sp or 
  ! dp). sp is default, dp can be used for increased precision.
  !****************************************************************

  integer,parameter :: dep_prec=dp

  !****************************************************************
  ! Set to F to disable use of kernel for concentrations/deposition
  !****************************************************************

  logical, parameter :: lusekerneloutput=.true.

  !*********************************************************************
  ! Set to T to change output units to number of particles per grid cell
  !*********************************************************************
  logical, parameter :: lparticlecountoutput=.false.

  !***********************************************************
  ! number of directories/files used for FLEXPART input/output
  !***********************************************************

  integer,parameter :: numpath=4

  ! numpath                 Number of different pathnames for input/output files


  !*****************************
  ! Physical and other constants
  !*****************************

  real,parameter :: pi=3.14159265, r_earth=6.371e6, r_air=287.05, ga=9.81
  real,parameter :: cpa=1004.6, kappa=0.286, pi180=pi/180., vonkarman=0.4
  ! additional constants RLT Aug-2017
  real,parameter :: rgas=8.31447 
  real,parameter :: r_water=461.495

  ! pi                      number "pi"
  ! pi180                   pi/180.
  ! r_earth                 radius of earth [m]
  ! r_air                   individual gas constant for dry air [J/kg/K]
  ! ga                      gravity acceleration of earth [m/s**2]
  ! cpa                     specific heat for dry air
  ! kappa                   exponent of formula for potential temperature
  ! vonkarman               von Karman constant
  ! rgas                    universal gas constant [J/mol/K]
  ! r_water                 specific gas constant for water vapor [J/kg/K]

  real,parameter :: karman=0.40, href=15., convke=2.0
  real,parameter :: hmixmin=100., hmixmax=4500.
  !real,parameter :: d_trop=50., d_strat=0.1
  real :: d_trop=50., d_strat=0.1, fturbmeso=0.16 ! turbulence factors can change for different runs
  real,parameter :: rho_water=1000. !ZHG 2015 [kg/m3]
  real,parameter :: ratio_incloud=0.005   !MC 2024
  real,parameter :: wet_a=1.e-5, wet_b=0.8 !AT

  ! karman            Karman's constant
  ! href [m]          Reference height for dry deposition
  ! konvke            Relative share of kinetic energy used for parcel lifting
  ! hmixmin,hmixmax   Minimum and maximum allowed PBL height
  ! fturbmeso         the factor by which standard deviations of winds at grid
  !                   points surrounding the particle positions are scaled to
  !                   yield the scales for the mesoscale wind velocity fluctuations
  ! d_trop [m2/s]     Turbulent diffusivity for horiz components in the troposphere
  ! d_strat [m2/s]    Turbulent diffusivity for vertical component in the stratosphere
  ! ratio_incloud     MC 2024, dimensionless ratio that should be <= 1
  ! wet_a, wet_b      for wetscav=wet_a*prec**wet_b if no cloud found, but precipitation occurs

  
  real,parameter :: xmwml=18.016/28.960
                  ! ratio of molar weights of water vapor and dry air


  !****************************************************
  ! Constants related to the stratospheric ozone tracer
  !****************************************************

  real,parameter :: ozonescale=60., pvcrit=2.

  ! ozonescale              ppbv O3 per PV unit
  ! pvcrit                  PV level of the tropopause


  !****************************************************
  ! Shape parameters from Bagheri & Bonadonna, 2016
  !****************************************************
  real, parameter :: alpha2=0.77,beta2=0.63 ! eq.32

  !********************
  ! Some time constants
  !********************

  integer,parameter :: idiffnorm=10800, idiffmax=2*idiffnorm, minstep=1

  ! idiffnorm [s]           normal time interval between two wind fields
  ! idiffmax [s]            maximum time interval between two wind fields
  ! minstep [s]             minimum time step to be used within FLEXPART


  !*****************************************************************
  ! Parameters for polar stereographic projection close to the poles
  !*****************************************************************

  real,parameter :: switchnorth=75., switchsouth=-75.

  ! switchnorth    use polar stereographic grid north of switchnorth
  ! switchsouth    use polar stereographic grid south of switchsouth

  !*********************************
  ! Parmaters for GRIB file decoding
  !*********************************

  ! integer,parameter :: jpack=4*nxmax*nymax, jpunp=4*jpack
  ! integer,parameter :: jpack=4*361*181, jpunp=4*jpack
  ! jpack,jpunp             maximum dimensions needed for GRIB file decoding


  !*********************************************
  ! Maximum dimensions of the nested input grids
  !*********************************************

  integer,parameter :: maxnests=5

  ! nuvzmax,nwzmax     maximum dimension of (u,v) and (w) wind fields in z
  !                    direction (for fields on eta levels)
  ! nzmax              maximum dimension of wind fields in z direction
  !                    for the transformed Cartesian coordinates

  !**************************************
  ! Maximum dimensions of the output grid
  !**************************************
  integer,parameter :: nclassunc=1

  ! nclassunc               number of classes used to calculate the uncertainty
  !                         of the output

  ! Sabine Eckhardt, June, 2008
  ! the dimensions of the OUTGRID are now set dynamically during runtime
  ! maxxgrid,maxygrid,maxzgrid    maximum dimensions in x,y,z direction
  ! maxxgridn,maxygridn           maximum dimension of the nested grid
  !integer maxxgrid,maxygrid,maxzgrid,maxxgridn,maxygridn
  !integer,parameter :: maxxgrid=361,maxygrid=181,maxxgridn=0,maxygridn=0)


  !**************************************************
  ! Maximum number of particles, species, and similar
  !**************************************************

  real,parameter :: minmassfrac=0.0

  ! minmassfrac  Terminate particles carrying a lower fraction
  !                compared to their initial mass

  ! maxpoint is also set dynamically during runtime
  ! maxpoint     Maximum number of release locations

  ! ---------
  ! Sabine Eckhardt: change of landuse inventary numclass=13

  integer,parameter :: maxtable=1000, numclass=13
  integer,parameter :: numpf=1 ! number of precip fields original =1, new=3(AT and PS, #295)
  integer,parameter :: numwfmem=2 ! Serial version/MPI with 2 fields
  integer,parameter :: maxndia=1
  !integer,parameter :: numwfmem=3 ! MPI with 3 fields

  ! maxtable     Maximum number of chemical species that can be tabulated 
  ! numclass     Number of landuse classes available to FLEXPART
  ! maxndia      Maximum number of diameter classes of particles
  ! numpf        Number of precipitation fields (1 standard, 3 #295)
  ! numwfmem     Number of windfields kept in memory. 2 for serial version, 
  !              2 or 3 for MPI version

  !**************************************************************************
  ! Variables for LCM
  !**************************************************************************

  integer,parameter :: maxreagent=5      ! Max number of reagents
  integer,parameter :: maxrecsample=2000 ! Max number of receptors per sampling interval 

  !**************************************************************************
  ! dimension of the OH field
  !**************************************************************************
  
  integer,parameter :: maxxOH=72, maxyOH=46, maxzOH=7
  
  !**************************************************************************
  ! aerosol below-cloud scavenging removal polynomial constants for rain & snow
  !**************************************************************************

  ! AT (after Wang et al 2014, Table 8)
  ! rain
  real, parameter :: bclr_a(4) = &
      (/-6.2609, 0.682, 0.8676, 0.1282/)
  real, parameter :: bclr_b(7) = &
      (/-14.707, 51.043, -97.306, 97.946, -53.923, 15.311, -1.751/)
  real, parameter :: bclr_c(2) = &
      (/0.723, 0.0303/)
  real, parameter :: bclr_e(7) = &
      (/-0.6492, 9.3483, -21.929, 25.317, -15.395, 4.7242, -0.5766/)
  ! snow
  real, parameter :: bcls_a(7) = &
      (/-4.426, 1.394, -1.202, -3.2942, -1.9521, -0.4904, -0.0457/)
  real, parameter :: bcls_b(7) = &
      (/-4.3521, -0.7828, 12.768, -19.864, 13.618, -4.4350, 0.5551/)
  real, parameter :: bcls_c(7) = &
      (/0.5664, 0.0085, -0.1948, -0.6532, -0.5462, -0.1778, -0.0201/) 
  real, parameter :: bcls_e(7) = &
      (/0.5689, -0.0923, 0.0402, 1.4523, -2.078, 1.05, -0.1821/)

  ! Cloud parameters to set bottom and top of cloud in verttransform_ecmwf_cloud
  ! These will be converted to eta coordinates in verttransform if 
  ! wind_coord_type='ETA'

  integer, parameter :: max_cloudthck = 19000 !Maximum thickness of clouds
  integer, parameter :: min_cloudthck = 50    !Minimum thickness of clouds
  ! If clouds in convection regions are outside the following range, they will
  ! be fixed to lowconv_range in case of convp > 0.1
  ! or highconv_range otherwise
  integer, parameter :: conv_clrange(2) = (/ 3000, 6000 /)
  integer, parameter :: highconvp_clrange(2) = (/ 0, 10000 /)
  integer, parameter :: lowconvp_clrange(2) = (/ 500, 8000 /)
  real, parameter :: rhmin = 0.90 ! Condition for presence of clouds in the nested fields
          ! PS note that original by Sabine Eckhart was 80%
          ! PS however, for T<-20 C we consider saturation over ice
          ! PS so I think 90% should be enough

  !**************************************************************************
  ! Maximum number of particles to be released in a single atmospheric column
  ! for the domain-filling trajectories option
  !**************************************************************************

  integer,parameter :: maxcolumn=3000


  !*********************************
  ! Dimension of random number field
  !*********************************

  integer,parameter :: maxrand=6000000

  ! maxrand                 number of random numbers used
  

  !*****************************************************
  ! Number of clusters to be used for plume trajectories
  !*****************************************************

  integer,parameter :: ncluster=5

  !************************************
  ! Unit numbers for input/output files
  !************************************

  integer,parameter :: unitpath=1, unitcommand=1, unitageclasses=1, unitgrid=1
  integer,parameter :: unitavailab=1, unitreleases=88, unitpartout=93
  integer,parameter :: unitpartout_average=105, unitpartoptions=106
  integer,parameter :: unitrestart=106,unitheightlevels=107
  integer,parameter :: unitpartin=93, unitflux=98, unitouttraj=96
  integer,parameter :: unitvert=1, unitoro=1, unitpoin=1, unitreceptor=1
  integer,parameter :: unitreceptorout=2  
  integer,parameter :: unitoutgrid=97, unitoutgridppt=99, unitoutinfo=1
  integer,parameter :: unitspecies=1, unitoutrecept=91, unitoutreceptppt=92
  integer,parameter :: unitoutsatellite=108
  integer,parameter :: unitlsm=1, unitsfcdata=1, unitland=1, unitwesely=1
  integer,parameter :: unitOH=1
  integer,parameter :: unitdates=94, unitheader=90,unitheader_txt=100
  integer,parameter :: unitshortpart=95, unitprecip=101
  integer,parameter :: unitboundcond=89
  integer,parameter :: unittmp=101
! RLT
  integer,parameter :: unitoutfactor=102

  !******************************************************
  ! integer code for missing values, used in wet scavenging (PS, 2012)
  !******************************************************

  integer,parameter ::  icmv=-9999.

  ! Temporary parameter to switch off the gridfaction calculation in the wetdeposition 
  logical,parameter :: lgridfraction=.false. 

  ! Particle dump: one file per field or all in one netcdf file
  logical,parameter :: lpartoutputperfield=.false.

  ! To save memory, terminated particles can be overwritted, but this can cause overhead.
  ! set ispeed=1 to decrease this overhead, but increasing the memory footprint
  integer,parameter :: ispeed=1
end module par_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

module outg_mod

  implicit none

  real,allocatable, dimension (:) :: outheight
  real,allocatable, dimension (:) :: outheighthalf
  real,allocatable, dimension (:,:) :: oroout
  real,allocatable, dimension (:,:) :: orooutn
  real,allocatable, dimension (:,:) :: area
  real,allocatable, dimension (:,:) :: arean
  real,allocatable, dimension (:,:,:) :: volume
  real,allocatable, dimension (:,:,:) :: volumen
  real,allocatable, dimension (:,:,:) :: areaeast
  real,allocatable, dimension (:,:,:) :: areanorth
  real,allocatable, dimension (:,:,:) :: densityoutgrid
  real,allocatable, dimension (:,:,:) :: factor3d
  real,allocatable, dimension (:,:,:) :: grid
  real,allocatable, dimension (:,:) :: wetgrid
  real,allocatable, dimension (:,:) :: drygrid
  real,allocatable, dimension (:,:,:) :: gridsigma
  real,allocatable, dimension (:,:) :: drygridsigma
  real,allocatable, dimension (:,:) :: wetgridsigma
  real,allocatable, dimension (:) :: sparse_dump_r
  integer,allocatable, dimension (:) :: sparse_dump_i

end module outg_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readlanduse

  !*****************************************************************************
  !                                                                            *
  !      Reads the landuse inventory into memory and relates it to Leaf Area   *
  !      Index and roughness length.                                           *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 10 January 1994                                *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! i                       loop indices                                       *
  ! landinvent(1200,600,13) area fractions of 13 landuse categories            *
  ! LENGTH(numpath)         length of the path names                           *
  ! PATH(numpath)           contains the path names                            *
  ! unitland                unit connected with landuse inventory              *
  !                                                                            *
  ! -----                                                                      *
  ! Sabine Eckhardt, Dec 06 - new landuse inventary                            *
  ! after                                                                      *
  ! Belward, A.S., Estes, J.E., and Kline, K.D., 1999,                         *
  ! The IGBP-DIS 1-Km Land-Cover Data Set DISCover:                            *
  ! A Project Overview: Photogrammetric Engineering and Remote Sensing,        *
  ! v. 65, no. 9, p. 1013-1020                                                 *
  !                                                                            *
  ! LANDUSE CATEGORIES:                                                        *
  !                                                                            *
  ! 1	Urban land                                                             *
  ! 2	Agricultural land					               *
  ! 3	Range land					                       *
  ! 4	Deciduous forest			                               *
  ! 5	Coniferous forest		                                       *
  ! 6	Mixed forest including wetland                                         *
  ! 7	water, both salt and fresh                                             *
  ! 8	barren land mostly desert                                              *
  ! 9	nonforested wetland	                                               *
  ! 10 	mixed agricultural and range land		                       *
  ! 11 	rocky open areas with low growing shrubs                               *
  ! 12  ice                                                                    *
  ! 13  rainforest                                                             *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: ix,jy,i,k,lu_cat,lu_perc
  integer(kind=1) :: ilr
  integer(kind=1) :: ilr_buffer(2160000)
  integer :: il,irecread
  real :: rlr, r2lr


  ! Read landuse inventory
  !***********************
  ! The landuse information is saved in a compressed format and written
  ! out by records of the length of 1 BYTE. Each grid cell consists of 3
  ! Bytes, which include 3 landuse categories (val 1-13 and 16 percentage
  ! categories) So one half byte is used to store the Landusecat the other
  ! for the percentageclass in 6.25 steps (100/6.25=16)
  ! e.g.
  ! 4 3  percentage 4 = 4*6.25 => 25% landuse class 3
  ! 2 1  percentage 2 = 2*6.25 => 13% landuse class 1
  ! 1 12 percentage 1 = 1*6.26 => 6.25% landuse class 12


  write (*,*) 'reading: ',path(1)(1:length(1))
  open(unitland,file=path(1)(1:length(1)) &
       //'IGBP_int1.dat',status='old', &
       form='UNFORMATTED', err=998)
  read (unitland) (ilr_buffer(i),i=1,2160000)
  close(unitland)
  write (*,*) 'reading: '

  irecread=1
  do ix=1,1200
    do jy=1,600
  ! the 3 most abundant landuse categories in the inventory
  ! first half byte contains the landuse class
  ! second half byte contains the respective percentage
      do k=1,3
  ! 1 byte is read
        ilr=ilr_buffer(irecread)
        irecread=irecread+1
  ! as only signed integer values exist an unsigned value is constructed
        if (ilr.lt.0) then
           il=ilr+256
        else
           il=ilr
        endif
  ! dividing by 16 has the effect to get rid of the right half of the byte
  ! so just the left half remains, this corresponds to a shift right of 4
  ! bits
        rlr=real(il)/16.
        lu_cat=int(rlr)
  ! the left half of the byte is substracted from the whole in order to
  ! get only the right half of the byte
        r2lr=rlr-int(rlr)
  ! shift left by 4
        lu_perc=r2lr*16.
        landinvent(ix,jy,k)=lu_cat
        landinvent(ix,jy,k+3)=lu_perc
        if ((jy.lt.10).and.(ix.lt.10)) then
            write(*,*) 'reading: ', ix, jy, lu_cat, lu_perc
        endif
      end do
    end do
  end do

  ! Read relation landuse,z0
  !*****************************

  open(unitsurfdata,file=path(1)(1:length(1))//'surfdata.t', &
       status='old',err=999)

  do i=1,4
    read(unitsurfdata,*)
  end do
  do i=1,numclass
    read(unitsurfdata,'(45x,f15.3)') z0(i)
  end do
  close(unitsurfdata)

  return

  ! Issue error messages
  !*********************

998   write(*,*) ' #### FLEXPART ERROR! FILE CONTAINING          ####'
  write(*,*) ' #### LANDUSE INVENTORY DOES NOT EXIST         ####'
  stop

999   write(*,*) ' #### FLEXPART ERROR! FILE CONTAINING          ####'
  write(*,*) ' #### RELATION LANDUSE,z0 DOES NOT EXIST       ####'
  stop

end subroutine readlanduse

      subroutine readheader(filename,nxmax,numxgrid,nymax,numygrid,
     +nzmax,numzgrid,outlon0,outlat0,dxout,dyout,outheight,ibdate,
     +ibtime,loutstep,maxspec,nspec,maxageclass,nageclass,lage,
     +ireleasestart,ireleaseend,maxpoint,numpoint,xpoint,ypoint,
     +zpoint1,zpoint2,heightnn,area)

      parameter(pi=3.14159265,r_earth=6.371e6,pih=pi/180.)

      character filename*150,compoint(maxpoint)*45,species(maxspec)*7
      real outheight(nzmax),heightnn(nxmax,nymax,0:nzmax)
      integer ireleasestart(maxpoint),ireleaseend(maxpoint)
      integer npart(maxpoint),kind(maxpoint),lage(0:maxageclass)
      real xpoint(maxpoint),ypoint(maxpoint),zpoint1(maxpoint)
      real zpoint2(maxpoint),xmass(maxpoint,maxspec)
      real oro(nxmax,nymax),area(nxmax,nymax)
      logical debug

      debug=.FALSE.

      open(10,file=filename,form='unformatted',status='old')
      read(10) ibdate,ibtime

      if (debug) then 
      write(*,*) ibdate,ibtime
      endif

      read(10) loutstep,loutaver,loutsample
      read(10) outlon0,outlat0,numxgrid,numygrid,dxout,dyout

      if (debug) then
      write(*,*) outlon0,outlat0,numxgrid,numygrid,dxout,dyout
      endif

      read(10) numzgrid,(outheight(i),i=1,numzgrid)
      read(10) jjjjmmdd,ihmmss

      if (debug) then
      write(*,*) jjjjmmdd,ihmss
      endif
      
      read(10) nspec
      nspec=nspec/3
      do 8 n=1,nspec
        read(10) numzgrid,species(n)
        read(10) numzgrid,species(n)
8       read(10) numzgrid,species(n)


      read(10) numpoint
      do 13 i=1,numpoint
        read(10) ireleasestart(i),ireleaseend(i)

        read(10) xpoint(i),ypoint(i),xp2,yp2,zpoint1(i),zpoint2(i)
        read(10) npart(i),kind(i)
        read(10) compoint(i)
        do 13 j=1,nspec
          read(10)
          read(10)
13        read(10) xmass(i,j)
      read(10) method
      read(10) nageclass,(lage(i),i=1,nageclass)
      lage(0)=0

      if (debug) then
      write(*,*) (lage(i),i=0,nageclass)
      endif

      do 130 ix=1,numxgrid
130     read(10) (oro(ix,jy),jy=1,numygrid)

      close(10)
      if (debug) then
      write(*,*) (outheight(i),i=1,numzgrid)
      endif
      
      if (loutstep.lt.0) nspec=numpoint


c Calculate height, which is outheight plus topography
******************************************************

      do 150 ix=1,numxgrid
        do 150 jy=1,numygrid
          if (ltopo.eq.1) then
            heightnn (ix,jy,0) = oro(ix,jy)
          else
            heightnn (ix,jy,0) = 0.
          endif
          do 150 i=1,numzgrid
            if (ltopo.eq.1) then
              heightnn (ix,jy,i) = outheight(i) + oro(ix,jy)
            else
              heightnn (ix,jy,i) = outheight(i)
            endif
150         continue


C Determine area of each output grid box
****************************************

      do 140 jy=1,numygrid
        ylata=outlat0+(float(jy-1)+0.5)*dyout
        ylatp=ylata+0.5*dyout
        ylatm=ylata-0.5*dyout
        if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
          hzone=dyout*r_earth*pih
        else
          cosfact=cos(ylata*pih)*r_earth
          cosfactp=cos(ylatp*pih)*r_earth
          cosfactm=cos(ylatm*pih)*r_earth
          if (cosfactp.lt.cosfactm) then
            hzone=sqrt(r_earth**2-cosfactp**2)-
     +      sqrt(r_earth**2-cosfactm**2)
          else
            hzone=sqrt(r_earth**2-cosfactm**2)-
     +      sqrt(r_earth**2-cosfactp**2)
          endif
        endif
        gridarea=2.*pi*r_earth*hzone*dxout/360.
        do 140 ix=1,numxgrid
140       area(ix,jy)=gridarea


      end

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine gridcheck

  !**********************************************************************
  !                                                                     *
  !             FLEXPART MODEL SUBROUTINE GRIDCHECK                     *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  !             AUTHOR:      G. WOTAWA                                  *
  !             DATE:        1997-08-06                                 *
  !             LAST UPDATE: 1997-10-10                                 *
  !                                                                     *
  !             Update:      1999-02-08, global fields allowed, A. Stohl*
  !             CHANGE: 17/11/2005, Caroline Forster, GFS data          *
  !             CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with *
  !                                 ECMWF grib_api                      *
  !             CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
  !                                 ECMWF grib_api                      *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION:                                                        *
  !                                                                     *
  ! THIS SUBROUTINE DETERMINES THE GRID SPECIFICATIONS (LOWER LEFT      *
  ! LONGITUDE, LOWER LEFT LATITUDE, NUMBER OF GRID POINTS, GRID DIST-   *
  ! ANCE AND VERTICAL DISCRETIZATION OF THE ECMWF MODEL) FROM THE       *
  ! GRIB HEADER OF THE FIRST INPUT FILE. THE CONSISTANCY (NO CHANGES    *
  ! WITHIN ONE FLEXPART RUN) IS CHECKED IN THE ROUTINE "READWIND" AT    *
  ! ANY CALL.                                                           *
  !                                                                     *
  ! XLON0                geographical longitude of lower left gridpoint *
  ! YLAT0                geographical latitude of lower left gridpoint  *
  ! NX                   number of grid points x-direction              *
  ! NY                   number of grid points y-direction              *
  ! DX                   grid distance x-direction                      *
  ! DY                   grid distance y-direction                      *
  ! NUVZ                 number of grid points for horizontal wind      *
  !                      components in z direction                      *
  ! NWZ                  number of grid points for vertical wind        *
  !                      component in z direction                       *
  ! sizesouth, sizenorth give the map scale (i.e. number of virtual grid*
  !                      points of the polar stereographic grid):       *
  !                      used to check the CFL criterion                *
  ! UVHEIGHT(1)-         heights of gridpoints where u and v are        *
  ! UVHEIGHT(NUVZ)       given                                          *
  ! WHEIGHT(1)-          heights of gridpoints where w is given         *
  ! WHEIGHT(NWZ)                                                        *
  !                                                                     *
  !**********************************************************************

  use grib_api
  use par_mod
  use com_mod
  use conv_mod
  use cmapf_mod, only: stlmbr,stcm2p

  implicit none

  !HSO  parameters for grib_api
  integer :: ifile
  integer :: iret
  integer :: igrib
  real(kind=4) :: xaux1,xaux2,yaux1,yaux2
  real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in
  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
  !HSO  end
  integer :: ix,jy,i,ifn,ifield,j,k,iumax,iwmax,numskip
  real :: sizesouth,sizenorth,xauxa,pint
  real :: akm_usort(nwzmax)
  real,parameter :: eps=0.0001

  ! NCEP GFS
  real :: pres(nwzmax), help

  integer :: i179,i180,i181

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  integer :: isec1(8),isec2(3)
  real(kind=4) :: zsec4(jpunp)
  character(len=1) :: opt

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: gribFunction = 'gridcheckwind_gfs'
  !
  if (numbnests.ge.1) then
  write(*,*) ' ###########################################'
  write(*,*) ' FLEXPART ERROR SUBROUTINE GRIDCHECK:'
  write(*,*) ' NO NESTED WINDFIELDAS ALLOWED FOR GFS!      '
  write(*,*) ' ###########################################'
  stop
  endif

  iumax=0
  iwmax=0

  if(ideltas.gt.0) then
    ifn=1
  else
    ifn=numbwf
  endif
  !
  ! OPENING OF DATA FILE (GRIB CODE)
  !
5   call grib_open_file(ifile,path(3)(1:length(3)) &
         //trim(wfname(ifn)),'r',iret)
  if (iret.ne.GRIB_SUCCESS) then
    goto 999   ! ERROR DETECTED
  endif
  !turn on support for multi fields messages
  call grib_multi_support_on

  ifield=0
10   ifield=ifield+1
  !
  ! GET NEXT FIELDS
  !
  call grib_new_from_file(ifile,igrib,iret)
  if (iret.eq.GRIB_END_OF_FILE )  then
    goto 30    ! EOF DETECTED
  elseif (iret.ne.GRIB_SUCCESS) then
    goto 999   ! ERROR DETECTED
  endif

  !first see if we read GRIB1 or GRIB2
  call grib_get_int(igrib,'editionNumber',gribVer,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  if (gribVer.eq.1) then ! GRIB Edition 1

  !read the grib1 identifiers
  call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'indicatorOfTypeOfLevel',isec1(7),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',isec1(8),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !get the size and data of the values array
  call grib_get_real4_array(igrib,'values',zsec4,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  else ! GRIB Edition 2

  !read the grib2 identifiers
  call grib_get_int(igrib,'discipline',discipl,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterCategory',parCat,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterNumber',parNum,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'scaledValueOfFirstFixedSurface', &
       valSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !convert to grib1 identifiers
  isec1(6)=-1
  isec1(7)=-1
  isec1(8)=-1
  if ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.100)) then ! U
    isec1(6)=33          ! indicatorOfParameter
    isec1(7)=100         ! indicatorOfTypeOfLevel
    isec1(8)=valSurf/100 ! level, convert to hPa
  elseif ((parCat.eq.3).and.(parNum.eq.5).and.(typSurf.eq.1)) then ! TOPO
    isec1(6)=7           ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.1) &
       .and.(discipl.eq.2)) then ! LSM
    isec1(6)=81          ! indicatorOfParameter
    isec1(7)=1           ! indicatorOfTypeOfLevel
    isec1(8)=0
  endif

  if (isec1(6).ne.-1) then
  !  get the size and data of the values array
    call grib_get_real4_array(igrib,'values',zsec4,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
  endif

  endif ! gribVer

  if(ifield.eq.1) then

  !get the required fields from section 2
  !store compatible to gribex input
  call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
       isec2(2),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
       isec2(3),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
       xaux1in,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees', &
       xaux2in,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
       yaux1in,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_real8(igrib,'latitudeOfFirstGridPointInDegrees', &
       yaux2in,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  xaux1=xaux1in
  xaux2=xaux2in
  yaux1=yaux1in
  yaux2=yaux2in

  nxfield=isec2(2)
  ny=isec2(3)
  if((abs(xaux1).lt.eps).and.(xaux2.ge.359)) then ! NCEP DATA FROM 0 TO
    xaux1=-179.0                             ! 359 DEG EAST ->
    xaux2=-179.0+360.-360./real(nxfield)    ! TRANSFORMED TO -179
  endif                                      ! TO 180 DEG EAST
  if (xaux1.gt.180) xaux1=xaux1-360.0
  if (xaux2.gt.180) xaux2=xaux2-360.0
  if (xaux1.lt.-180) xaux1=xaux1+360.0
  if (xaux2.lt.-180) xaux2=xaux2+360.0
  if (xaux2.lt.xaux1) xaux2=xaux2+360.
  xlon0=xaux1
  ylat0=yaux1
  dx=(xaux2-xaux1)/real(nxfield-1)
  dy=(yaux2-yaux1)/real(ny-1)
  dxconst=180./(dx*r_earth*pi)
  dyconst=180./(dy*r_earth*pi)
  !HSO end edits


  ! Check whether fields are global
  ! If they contain the poles, specify polar stereographic map
  ! projections using the stlmbr- and stcm2p-calls
  !***********************************************************

    xauxa=abs(xaux2+dx-360.-xaux1)
    if (xauxa.lt.0.001) then
      nx=nxfield+1                 ! field is cyclic
      xglobal=.true.
      if (abs(nxshift).ge.nx) &
           stop 'nxshift in file par_mod is too large'
      xlon0=xlon0+real(nxshift)*dx
    else
      nx=nxfield
      xglobal=.false.
      if (nxshift.ne.0) &
           stop 'nxshift (par_mod) must be zero for non-global domain'
    endif
    nxmin1=nx-1
    nymin1=ny-1
    if (xlon0.gt.180.) xlon0=xlon0-360.
    xauxa=abs(yaux1+90.)
    if (xglobal.and.xauxa.lt.0.001) then
      sglobal=.true.               ! field contains south pole
  ! Enhance the map scale by factor 3 (*2=6) compared to north-south
  ! map scale
      sizesouth=6.*(switchsouth+90.)/dy
      call stlmbr(southpolemap,-90.,0.)
      call stcm2p(southpolemap,0.,0.,switchsouth,0.,sizesouth, &
           sizesouth,switchsouth,180.)
      switchsouthg=(switchsouth-ylat0)/dy
    else
      sglobal=.false.
      switchsouthg=999999.
    endif
    xauxa=abs(yaux2-90.)
    if (xglobal.and.xauxa.lt.0.001) then
      nglobal=.true.               ! field contains north pole
  ! Enhance the map scale by factor 3 (*2=6) compared to north-south
  ! map scale
      sizenorth=6.*(90.-switchnorth)/dy
      call stlmbr(northpolemap,90.,0.)
      call stcm2p(northpolemap,0.,0.,switchnorth,0.,sizenorth, &
           sizenorth,switchnorth,180.)
      switchnorthg=(switchnorth-ylat0)/dy
    else
      nglobal=.false.
      switchnorthg=999999.
    endif
  endif ! ifield.eq.1

  if (nxshift.lt.0) stop 'nxshift (par_mod) must not be negative'
  if (nxshift.ge.nxfield) stop 'nxshift (par_mod) too large'

  ! NCEP ISOBARIC LEVELS
  !*********************

  if((isec1(6).eq.33).and.(isec1(7).eq.100)) then ! check for U wind
    iumax=iumax+1
    pres(iumax)=real(isec1(8))*100.0
  endif


  i179=nint(179./dx)
  if (dx.lt.0.7) then
    i180=nint(180./dx)+1    ! 0.5 deg data
  else
    i180=nint(179./dx)+1    ! 1 deg data
  endif
  i181=i180+1


  ! NCEP TERRAIN
  !*************

  if((isec1(6).eq.007).and.(isec1(7).eq.001)) then
    do jy=0,ny-1
      do ix=0,nxfield-1
        help=zsec4(nxfield*(ny-jy-1)+ix+1)
        if(ix.le.i180) then
          oro(i179+ix,jy)=help
          excessoro(i179+ix,jy)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
        else
          oro(ix-i181,jy)=help
          excessoro(ix-i181,jy)=0.0 ! ISOBARIC SURFACES: SUBGRID TERRAIN DISREGARDED
        endif
      end do
    end do
  endif

  ! NCEP LAND SEA MASK
  !*******************

  if((isec1(6).eq.081).and.(isec1(7).eq.001)) then
    do jy=0,ny-1
      do ix=0,nxfield-1
        help=zsec4(nxfield*(ny-jy-1)+ix+1)
        if(ix.le.i180) then
          lsm(i179+ix,jy)=help
        else
          lsm(ix-i181,jy)=help
        endif
      end do
    end do
  endif

  call grib_release(igrib)

  goto 10                      !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !

  ! HSO
30   continue
  call grib_close_file(ifile)
  ! HSO end edits

  nuvz=iumax
  nwz =iumax
  nlev_ec=iumax

  if (nx.gt.nxmax) then
   write(*,*) 'FLEXPART error: Too many grid points in x direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) nx,nxmax
    stop
  endif

  if (ny.gt.nymax) then
   write(*,*) 'FLEXPART error: Too many grid points in y direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) ny,nymax
    stop
  endif

  if (nuvz.gt.nuvzmax) then
    write(*,*) 'FLEXPART error: Too many u,v grid points in z '// &
         'direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) nuvz,nuvzmax
    stop
  endif

  if (nwz.gt.nwzmax) then
    write(*,*) 'FLEXPART error: Too many w grid points in z '// &
         'direction.'
    write(*,*) 'Reduce resolution of wind fields.'
    write(*,*) 'Or change parameter settings in file par_mod.'
    write(*,*) nwz,nwzmax
    stop
  endif

  ! If desired, shift all grids by nxshift grid cells
  !**************************************************

  if (xglobal) then
    call shift_field_0(oro,nxfield,ny)
    call shift_field_0(lsm,nxfield,ny)
    call shift_field_0(excessoro,nxfield,ny)
  endif

  ! Output of grid info
  !********************

  write(*,*)
  write(*,*)
  write(*,'(a,2i7)') '# of vertical levels in NCEP data: ', &
       nuvz,nwz
  write(*,*)
  write(*,'(a)') 'Mother domain:'
  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
       xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range: ', &
       ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
  write(*,*)


  ! CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
  ! PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM

  numskip=nlev_ec-nuvz  ! number of ecmwf model layers not used
                        ! by trajectory model
  do i=1,nwz
    j=numskip+i
    k=nlev_ec+1+numskip+i
    akm_usort(nwz-i+1)=pres(nwz-i+1)
    bkm(nwz-i+1)=0.0
  end do

  !******************************
  ! change Sabine Eckhardt: akm should always be in descending order ... readwind adapted!
  !******************************
      do i=1,nwz
         if (akm_usort(1).gt.akm_usort(2)) then
            akm(i)=akm_usort(i)
         else
            akm(i)=akm_usort(nwz-i+1)
         endif
      end do

  !
  ! CALCULATION OF AKZ, BKZ
  ! AKZ,BKZ: model discretization parameters at the center of each model
  !     layer
  !
  ! Assign the 10 m winds to an artificial model level with akz=0 and bkz=1.0,
  ! i.e. ground level
  !*****************************************************************************

  do i=1,nuvz
     akz(i)=akm(i)
     bkz(i)=bkm(i)
  end do

  ! NOTE: In FLEXPART versions up to 4.0, the number of model levels was doubled
  ! upon the transformation to z levels. In order to save computer memory, this is
  ! not done anymore in the standard version. However, this option can still be
  ! switched on by replacing the following lines with those below, that are
  ! currently commented out. For this, similar changes are necessary in
  ! verttransform.f and verttranform_nests.f
  !*****************************************************************************

  nz=nuvz
  if (nz.gt.nzmax) stop 'nzmax too small'
  do i=1,nuvz
    aknew(i)=akz(i)
    bknew(i)=bkz(i)
  end do

  ! Switch on following lines to use doubled vertical resolution
  !*************************************************************
  !nz=nuvz+nwz-1
  !if (nz.gt.nzmax) stop 'nzmax too small'
  !do 100 i=1,nwz
  !  aknew(2*(i-1)+1)=akm(i)
  !00     bknew(2*(i-1)+1)=bkm(i)
  !do 110 i=2,nuvz
  !  aknew(2*(i-1))=akz(i)
  !10     bknew(2*(i-1))=bkz(i)
  ! End doubled vertical resolution


  ! Determine the uppermost level for which the convection scheme shall be applied
  ! by assuming that there is no convection above 50 hPa (for standard SLP)
  !*****************************************************************************

  do i=1,nuvz-2
    pint=akz(i)+bkz(i)*101325.
    if (pint.lt.5000.) goto 96
  end do
96   nconvlev=i
  if (nconvlev.gt.nconvlevmax-1) then
    nconvlev=nconvlevmax-1
    write(*,*) 'Attention, convection only calculated up to ', &
         akz(nconvlev)+bkz(nconvlev)*1013.25,' hPa'
  endif

  return

999   write(*,*)
  write(*,*) ' ###########################################'// &
       '###### '
  write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
  write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfname(ifn)
  write(*,*) ' ###########################################'// &
       '###### '
  write(*,*)
  write(*,'(a)') '!!! PLEASE INSERT A NEW CD-ROM AND   !!!'
  write(*,'(a)') '!!! PRESS ANY KEY TO CONTINUE...     !!!'
  write(*,'(a)') '!!! ...OR TERMINATE FLEXPART PRESSING!!!'
  write(*,'(a)') '!!! THE "X" KEY...                   !!!'
  write(*,*)
  read(*,'(a)') opt
  if(opt.eq.'X') then
    stop
  else
    goto 5
  endif

end subroutine gridcheck

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

real function obukhov(ps,tsurf,tdsurf,tlev,ustar,hf,plev)

  !********************************************************************
  !                                                                   *
  !                       Author: G. WOTAWA                           *
  !                       Date:   1994-06-27                          *
  !                                                                   *
  !  Update: A. Stohl, 2000-09-25, avoid division by zero by          *
  !  setting ustar to minimum value                                   *
  !                                                                   *
  !  CHANGE: 17/11/2005 Caroline Forster NCEP GFS version             *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !     This program calculates Obukhov scale height from surface     *
  !     meteorological data and sensible heat flux.                   *
  !                                                                   *
  !********************************************************************
  !                                                                   *
  !     INPUT:                                                        *
  !                                                                   *
  !     ps      surface pressure [Pa]                                 *
  !     tsurf   surface temperature [K]                               *
  !     tdsurf  surface dew point [K]                                 *
  !     tlev    temperature first model level [K]                     *
  !     ustar   scale velocity [m/s]                                  *
  !     hf      surface sensible heat flux [W/m2]                     *
  !     akm     ECMWF vertical discretization parameter               *
  !     bkm     ECMWF vertical discretization parameter               *
  !                                                                   *
  !********************************************************************

  use par_mod

  implicit none

  real :: ps,tsurf,tdsurf,tlev,ustar,hf,e,ew,tv,rhoa,plev
  real :: theta,thetastar


  e=ew(tdsurf)                           ! vapor pressure
  tv=tsurf*(1.+0.378*e/ps)               ! virtual temperature
  rhoa=ps/(r_air*tv)                      ! air density
  theta=tlev*(100000./plev)**(r_air/cpa) ! potential temperature
  if (ustar.le.0.) ustar=1.e-8
  thetastar=hf/(rhoa*cpa*ustar)           ! scale temperature
  if(abs(thetastar).gt.1.e-10) then
     obukhov=theta*ustar**2/(karman*ga*thetastar)
  else
     obukhov=9999                        ! zero heat flux
  endif
  if (obukhov.gt. 9999.) obukhov= 9999.
  if (obukhov.lt.-9999.) obukhov=-9999.

end function obukhov

!*******************************************************************************
!        Include file for particle diffusion model FLEXPART                    *
!        This file contains a global common block used by FLEXPART             *
!                                                                              *
!        Author: A. Stohl                                                      *
!                                                                              *
!        June 1996                                                             *
!                                                                              *
!        Last update: 9 August 2000                                            *
!                                                                              *
!*******************************************************************************

module com_mod

  use par_mod, only: dp, numpath, maxnests, maxageclass, maxspec, ni, &
       numclass, nymax, nxmax, maxcolumn, maxwf, nzmax, nxmaxn, nymaxn, &
       maxreceptor, maxpart, maxrand, nwzmax, nuvzmax

  implicit none

  !****************************************************************
  ! Variables defining where FLEXPART input/output files are stored
  !****************************************************************

  character :: path(numpath+2*maxnests)*120
  integer :: length(numpath+2*maxnests)

  ! path                    path names needed for trajectory model
  ! length                  length of path names needed for trajectory model


  !********************************************************
  ! Variables defining the general model run specifications
  !********************************************************

  integer :: ibdate,ibtime,iedate,ietime
  real(kind=dp) :: bdate,edate


  ! ibdate                  beginning date (YYYYMMDD)
  ! ibtime                  beginning time (HHMISS)
  ! iedate                  ending date (YYYYMMDD)
  ! ietime                  ending time (HHMISS)
  ! bdate                   beginning date of simulation (julian date)
  ! edate                   ending date of simulation (julian date)


  integer :: ldirect,ideltas

  ! ldirect                 1 for forward, -1 for backward simulation
  ! ideltas                 length of trajectory loop from beginning to
  !                    ending date (s)

  integer :: loutstep,loutaver,loutsample,method,lsynctime
  real :: outstep

  ! loutstep [s]            gridded concentration output every loutstep seconds
  ! loutaver [s]            concentration output is an average over [s] seconds
  ! loutsample [s]          sampling interval of gridded concentration output
  ! lsynctime [s]           synchronisation time of all particles
  ! method                  indicator which dispersion method is to be used
  ! outstep = real(abs(loutstep))

  real :: ctl,fine
  integer :: ifine,iout,ipout,ipin,iflux,mdomainfill
  integer :: mquasilag,nested_output,ind_source,ind_receptor
  integer :: ind_rel,ind_samp,ioutputforeachrelease,linit_cond
  logical :: turbswitch

  ! ctl      factor, by which time step must be smaller than Lagrangian time scale
  ! ifine    reduction factor for time step used for vertical wind
  !     Langevin equation for the vertical wind component
  ! ioutputforeachrelease Should each release be a seperate output field?
  ! iflux    flux calculation options: 1 calculation of fluxes, 2 no fluxes
  ! iout     output options: 1 conc. output (ng/m3), 2 mixing ratio (pptv), 3 both
  ! ipout    particle dump options: 0 no, 1 every output interval, 2 only at end
  ! ipin     read in particle positions from dumped file from a previous run
  ! fine     real(ifine)
  ! mdomainfill 0: normal run
  !        1: particles are initialized according to atmospheric mass distribution
  ! ind_source switches between different units for concentrations at the source
  !  NOTE that in backward simulations the release of computational particles
  !  takes place at the "receptor" and the sampling of particles at the "source".
  !     1= mass units
  !     2= mass mixing ratio units
  ! ind_receptor switches between different units for FLEXPART concentration at the receptor
  !     1= mass units
  !     2= mass mixing ratio units
  ! linit_cond  switch on the output of sensitivity to initial conditions for backward runs
  !     0=no, 1=mass unit, 2=mass mixing ratio unit
  ! mquasilag 0: normal run
  !      1: Particle position output is produced in a condensed format and particles are numbered
  ! nested_output: 0 no, 1 yes
  ! turbswitch              determines how the Markov chain is formulated

  ! ind_rel and ind_samp  are used within the code to change between mass and mass-mix (see readcommand.f)


  integer :: mintime,itsplit

  ! mintime                 minimum time step to be used by FLEXPART
  ! itsplit                 time constant for splitting particles

  integer :: lsubgrid,lconvection,lagespectra

  ! lsubgrid     1 if subgrid topography parameterization switched on, 2 if not
  ! lconvection  1 if convection parameterization switched on, 0 if not
  ! lagespectra  1 if age spectra calculation switched on, 2 if not


  integer :: nageclass,lage(maxageclass)

  ! nageclass               number of ageclasses for the age spectra calculation
  ! lage [s]                ageclasses for the age spectra calculation


  logical :: gdomainfill

  ! gdomainfill             .T., if domain-filling is global, .F. if not



  !*********************************************************************
  ! Variables defining the release locations, released species and their
  ! properties, etc.
  !*********************************************************************

  !change Sabine Eckhardt, only save the first 1000 identifier for releasepoints
  character :: compoint(1001)*45
  integer :: numpoint
  !sec, now dynamically allocated:
  ! ireleasestart(maxpoint),ireleaseend(maxpoint)
  !      real xpoint1(maxpoint),ypoint1(maxpoint)
  !real xpoint2(maxpoint),ypoint2(maxpoint)
  !real zpoint1(maxpoint),zpoint2(maxpoint)
  !integer*2 kindz(maxpoint)
  integer :: specnum(maxspec)
  !real xmass(maxpoint,maxspec)
  real :: decay(maxspec)
  real :: weta(maxspec),wetb(maxspec)
  real :: reldiff(maxspec),henry(maxspec),f0(maxspec)
  real :: density(maxspec),dquer(maxspec),dsigma(maxspec)
  real :: vsetaver(maxspec),cunningham(maxspec),weightmolar(maxspec)
  real :: vset(maxspec,ni),schmi(maxspec,ni),fract(maxspec,ni)
  real :: ri(5,numclass),rac(5,numclass),rcl(maxspec,5,numclass)
  real :: rgs(maxspec,5,numclass),rlu(maxspec,5,numclass)
  real :: rm(maxspec),dryvel(maxspec),kao(maxspec),ohreact(maxspec)
  ! se  it is possible to associate a species with a second one to make transfer from gas to aerosol
  integer :: spec_ass(maxspec)

  real :: area_hour(maxspec,24),point_hour(maxspec,24)
  real :: area_dow(maxspec,7),point_dow(maxspec,7)

  !integer npart(maxpoint)
  integer :: nspec,maxpointspec_act
  character(len=10) :: species(maxspec)


  ! compoint                comment, also "name" of each starting point
  ! numpoint                actual number of trajectory starting/ending points
  ! ireleasestart,ireleaseend [s] starting and ending time of each release
  ! xmass                   total mass emitted
  ! xpoint1,ypoint1         lower left coordinates of release area
  ! xpoint2,ypoint2         upper right coordinates of release area
  ! zpoint1,zpoint2         min./max. z-coordinates of release points
  ! kindz                   1: zpoint is in m agl, 2: zpoint is in m asl
  ! npart                   number of particles per release point
  ! nspec                   number of different species allowed for one release
  ! maxpointspec_act        number of releaspoints for which a different output shall be created
  ! species                 name of species
  ! decay                   decay constant of radionuclide

  ! WET DEPOSITION
  ! weta, wetb              parameters for determining wet scavenging coefficients

  ! GAS DEPOSITION
  ! reldiff                 diffusivitiy of species relative to diff. of H2O
  ! henry [M/atm]           Henry constant
  ! f0                      reactivity relative to that of O3
  ! ri [s/m]                stomatal resistance
  ! rcl [s/m]               lower canopy resistance
  ! rgs [s/m]               ground resistance
  ! rlu [s/m]               leaf cuticular resistance
  ! rm [s/m]                mesophyll resistance
  ! dryvel [m/s]            constant dry deposition velocity

  ! PARTICLE DEPOSITION
  ! density [kg/m3]         density of particles
  ! dquer [m]               mean diameter of particles
  ! dsigma                  dsigma=10 or dsigma=0.1 means that 68% of the
  !                    mass are between 0.1*dquer and 10*dquer

  ! fract                   mass fraction of each diameter interval
  ! vset [m/s]              gravitational settling velocity in ni intervals
  ! cunningham              Cunningham slip correction (strictly valid only near surface)
  ! vsetaver [m/s]          average gravitational settling velocity
  ! schmi                   Schmidt number**2/3 of each diameter interval
  ! weightmolar [g/mol]     molecular weight

  ! TIME VARIATION OF EMISSION
  ! area_hour, point_hour   daily variation of emission strengths for area and point sources
  ! area_dow, point_dow     day-of-week variation of emission strengths for area and point sources



  !**********************************************************
  ! Variables used for domain-filling trajectory calculations
  !**********************************************************

  integer :: nx_we(2),ny_sn(2)
  integer :: numcolumn
  integer :: numcolumn_we(2,0:nymax-1),numcolumn_sn(2,0:nxmax-1)
  real :: zcolumn_we(2,0:nymax-1,maxcolumn)
  real :: zcolumn_sn(2,0:nxmax-1,maxcolumn)
  real :: xmassperparticle
  real :: acc_mass_we(2,0:nymax-1,maxcolumn)
  real :: acc_mass_sn(2,0:nxmax-1,maxcolumn)

  ! nx_we(2)                x indices of western and eastern boundary of domain-filling
  ! ny_sn(2)                y indices of southern and northern boundary of domain-filling
  ! numcolumn_we            number of particles to be released within one column
  !                    at the western and eastern boundary surfaces
  ! numcolumn_sn            same as numcolumn_we, but for southern and northern domain boundary
  ! numcolumn               maximum number of particles to be released within a single
  !                    column
  ! zcolumn_we              altitudes where particles are to be released
  !                    at the western and eastern boundary surfaces
  ! zcolumn_sn              same as zcolumn_we, but for southern and northern domain boundary
  ! xmassperparticle        air mass per particle in the domain-filling traj. option
  ! acc_mass_we             mass that has accumulated at the western and eastern boundary;
  !                    if it exceeds xmassperparticle, a particle is released and
  !                    acc_mass_we is reduced accordingly
  ! acc_mass_sn             same as acc_mass_we, but for southern and northern domain boundary



  !******************************************************************************
  ! Variables associated with the ECMWF meteorological input data ("wind fields")
  !******************************************************************************

  integer :: numbwf,wftime(maxwf),lwindinterv
  character(len=255) :: wfname(maxwf),wfspec(maxwf)

  ! lwindinterv [s]         Interval between wind fields currently in memory
  ! numbwf                  actual number of wind fields
  ! wftime(maxwf) [s]       times relative to beginning time of wind fields
  ! wfname(maxwf)           file names of wind fields
  ! wfspec(maxwf)           specifications of wind field file, e.g. if on hard
  !                    disc or on tape

  integer :: memtime(2),memind(2)

  ! memtime [s]             validation times of wind fields in memory
  ! memind                  pointer to wind field, in order to avoid shuffling
  !                    of wind fields



  !****************************************************************************
  ! Variables defining actual size and geographical location of the wind fields
  !****************************************************************************

  integer :: nx,ny,nxmin1,nymin1,nxfield,nuvz,nwz,nz,nmixz,nlev_ec
  real :: dx,dy,xlon0,ylat0,dxconst,dyconst,height(nzmax)

  ! nx,ny,nz                actual dimensions of wind fields in x,y and z
  !                    direction, respectively
  ! nxmin1,nymin1           nx-1, ny-1, respectively
  ! nuvz,nwz                vertical dimension of original ECMWF data
  ! nxfield                 same as nx for limited area fields,
  !                    but for global fields nx=nxfield+1
  ! nmixz                   number of levels up to maximum PBL height (3500 m)

  ! nuvz is used for u,v components
  ! nwz is used for w components (staggered grid)
  ! nz is used for the levels in transformed coordinates (terrain-following Cartesian
  ! coordinates)

  ! nlev_ec  number of levels ECMWF model
  ! dx                      grid distance in x direction
  ! dy                      grid distance in y direction
  ! dxconst,dyconst         auxiliary variables for utransform,vtransform
  ! height                  heights of all levels
  ! xlon0                   geographical longitude and
  ! ylat0                   geographical latitude of lower left grid point



  !*************************************************
  ! Variables used for vertical model discretization
  !*************************************************

  real :: akm(nwzmax),bkm(nwzmax)
  real :: akz(nuvzmax),bkz(nuvzmax)
  real :: aknew(nzmax),bknew(nzmax)

  ! akm,bkm: coeffizients which regulate vertical discretization of ecmwf model
  !     (at the border of model layers)
  ! akz,bkz: model discretization coeffizients at the centre of the layers
  ! aknew,bknew model discretization coeffizients at the interpolated levels



  ! Fixed fields, unchangeable with time
  !*************************************

  real :: oro(0:nxmax-1,0:nymax-1)
  real :: excessoro(0:nxmax-1,0:nymax-1)
  real :: lsm(0:nxmax-1,0:nymax-1)
  real :: xlanduse(0:nxmax-1,0:nymax-1,numclass)

  ! oro [m]              orography of the ECMWF model
  ! excessoro            excess orography mother domain
  ! lsm                  land sea mask of the ECMWF model
  ! xlanduse [0-1]       area fractions in percent

  ! 3d fields
  !**********

  real :: uu(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: vv(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: uupol(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: vvpol(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: ww(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: tt(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: qv(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: pv(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: rho(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: drhodz(0:nxmax-1,0:nymax-1,nzmax,2)
  real :: tth(0:nxmax-1,0:nymax-1,nuvzmax,2)
  real :: qvh(0:nxmax-1,0:nymax-1,nuvzmax,2)
  real :: pplev(0:nxmax-1,0:nymax-1,nuvzmax,2)
  integer(kind=1) :: clouds(0:nxmax-1,0:nymax-1,nzmax,2)
  integer :: cloudsh(0:nxmax-1,0:nymax-1,2)

  ! uu,vv,ww [m/2]       wind components in x,y and z direction
  ! uupol,vvpol [m/s]    wind components in polar stereographic projection
  ! tt [K]               temperature data
  ! qv                   specific humidity data
  ! pv (pvu)             potential vorticity
  ! rho [kg/m3]          air density
  ! drhodz [kg/m2]       vertical air density gradient
  ! tth,qvh              tth,qvh on original eta levels
  ! clouds:   no cloud, no precipitation   0
  !      cloud, no precipitation      1
  !      rainout  conv/lsp dominated  2/3
  !      washout  conv/lsp dominated  4/5
  ! pplev for the GFS version

  ! 2d fields
  !**********

  real :: ps(0:nxmax-1,0:nymax-1,1,2)
  real :: sd(0:nxmax-1,0:nymax-1,1,2)
  real :: msl(0:nxmax-1,0:nymax-1,1,2)
  real :: tcc(0:nxmax-1,0:nymax-1,1,2)
  real :: u10(0:nxmax-1,0:nymax-1,1,2)
  real :: v10(0:nxmax-1,0:nymax-1,1,2)
  real :: tt2(0:nxmax-1,0:nymax-1,1,2)
  real :: td2(0:nxmax-1,0:nymax-1,1,2)
  real :: lsprec(0:nxmax-1,0:nymax-1,1,2)
  real :: convprec(0:nxmax-1,0:nymax-1,1,2)
  real :: sshf(0:nxmax-1,0:nymax-1,1,2)
  real :: ssr(0:nxmax-1,0:nymax-1,1,2)
  real :: surfstr(0:nxmax-1,0:nymax-1,1,2)
  real :: ustar(0:nxmax-1,0:nymax-1,1,2)
  real :: wstar(0:nxmax-1,0:nymax-1,1,2)
  real :: hmix(0:nxmax-1,0:nymax-1,1,2)
  real :: tropopause(0:nxmax-1,0:nymax-1,1,2)
  real :: oli(0:nxmax-1,0:nymax-1,1,2)
  real :: diffk(0:nxmax-1,0:nymax-1,1,2)

  ! ps                   surface pressure
  ! sd                   snow depth
  ! msl                  mean sea level pressure
  ! tcc                  total cloud cover
  ! u10                  10 meter u
  ! v10                  10 meter v
  ! tt2                  2 meter temperature
  ! td2                  2 meter dew point
  ! lsprec [mm/h]        large scale total precipitation
  ! convprec [mm/h]      convective precipitation
  ! sshf                 surface sensible heat flux
  ! ssr                  surface solar radiation
  ! surfstr              surface stress
  ! ustar [m/s]          friction velocity
  ! wstar [m/s]          convective velocity scale
  ! hmix  [m]            mixing height
  ! tropopause [m]       altitude of thermal tropopause
  ! oli [m]              inverse Obukhov length (1/L)
  ! diffk [m2/s]         diffusion coefficient at reference height


  real :: vdep(0:nxmax-1,0:nymax-1,maxspec,2)

  ! vdep [m/s]           deposition velocities


  !********************************************************************
  ! Variables associated with the ECMWF input data (nested wind fields)
  !********************************************************************

  ! NOTE: all nested variables have the same name as the variables used
  ! for the mother domain, except with a 'n' appended at the end
  !********************************************************************

  integer :: numbnests

  ! numbnests    number of nested grids

  character(len=255) :: wfnamen(maxnests,maxwf)
  character(len=18) :: wfspecn(maxnests,maxwf)

  ! wfnamen      nested wind field names
  ! wfspecn      specifications of wind field file, e.g. if on hard
  !         disc or on tape


  !*********************************************************************
  ! Variables characterizing size and location of the nested wind fields
  !*********************************************************************

  integer :: nxn(maxnests),nyn(maxnests)
  real :: dxn(maxnests),dyn(maxnests),xlon0n(maxnests),ylat0n(maxnests)

  ! nxn,nyn      actual dimensions of nested wind fields in x and y direction
  ! dxn,dyn      grid distances in x,y direction for the nested grids
  ! xlon0n       geographical longitude of lower left grid point of nested wind fields
  ! ylat0n       geographical latitude of lower left grid point of nested wind fields


  ! Nested fields, unchangeable with time
  !**************************************

  real :: oron(0:nxmaxn-1,0:nymaxn-1,maxnests)
  real :: excessoron(0:nxmaxn-1,0:nymaxn-1,maxnests)
  real :: lsmn(0:nxmaxn-1,0:nymaxn-1,maxnests)
  real :: xlandusen(0:nxmaxn-1,0:nymaxn-1,numclass,maxnests)


  ! 3d nested fields
  !*****************

  real :: uun(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: vvn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: wwn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: ttn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: qvn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: pvn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  integer(kind=1) :: cloudsn(0:nxmaxn-1,0:nymaxn-1,0:nzmax,2,maxnests)
  integer :: cloudsnh(0:nxmaxn-1,0:nymaxn-1,2,maxnests)
  real :: rhon(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: drhodzn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
  real :: tthn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,2,maxnests)
  real :: qvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,2,maxnests)

  ! 2d nested fields
  !*****************

  real :: psn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: sdn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: msln(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: tccn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: u10n(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: v10n(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: tt2n(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: td2n(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: lsprecn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: convprecn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: sshfn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: ssrn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: surfstrn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: ustarn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: wstarn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: hmixn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: tropopausen(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: olin(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: diffkn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
  real :: vdepn(0:nxmaxn-1,0:nymaxn-1,maxspec,2,maxnests)


  !*************************************************
  ! Certain auxiliary variables needed for the nests
  !*************************************************

  real :: xresoln(0:maxnests),yresoln(0:maxnests)

  ! xresoln, yresoln   Factors by which the resolutions in the nests
  !               are enhanced compared to mother grid

  real :: xln(maxnests),yln(maxnests),xrn(maxnests),yrn(maxnests)

  ! xln,yln,xrn,yrn    Corner points of nested grids in grid coordinates
  !               of mother grid


  !******************************************************
  ! Variables defining the polar stereographic projection
  !******************************************************

  logical :: xglobal,sglobal,nglobal
  real :: switchnorthg,switchsouthg

  !xglobal             T for global fields, F for limited area fields
  !sglobal             T if domain extends towards south pole
  !nglobal             T if domain extends towards north pole
  !switchnorthg,switchsouthg   same as parameters switchnorth,
  !                    switchsouth, but in grid units

  real :: southpolemap(9),northpolemap(9)

  !southpolemap,northpolemap   define stereographic projections
  !                    at the two poles


  !******************
  ! Landuse inventory
  ! Sabine Eckhardt Dec 06: change to new landuse inventary - 11 classes, 1200 x 600 global
  !******************

  integer(kind=1) :: landinvent(1200,600,6)
  real :: z0(numclass)

  ! landinvent         landuse inventory (numclass=11 classes)
  ! z0                  roughness length for the landuse classes



  !**************************************************************************
  ! Variables characterizing the output grid and containing the model results
  !**************************************************************************

  integer :: numxgrid,numygrid,numzgrid
  real :: dxout,dyout,outlon0,outlat0,xoutshift,youtshift
  integer :: numxgridn,numygridn
  real :: dxoutn,dyoutn,outlon0n,outlat0n,xoutshiftn,youtshiftn
  !real outheight(maxzgrid),outheighthalf(maxzgrid)
  logical :: DEP,DRYDEP,DRYDEPSPEC(maxspec),WETDEP,OHREA,ASSSPEC

  ! numxgrid,numygrid       number of grid points in x,y-direction
  ! numxgridn,numygridn     number of grid points in x,y-direction for nested output grid
  ! numzgrid                number of vertical levels of output grid
  ! dxout,dyout             grid distance of output grid
  ! dxoutn,dyoutn           grid distance of nested output grid
  ! outlon0,outlat0         lower left corner of output grid
  ! outlon0n,outlat0n       lower left corner of nested output grid
  ! xoutshift,youtshift     xlon0-outlon0, ylat0-outlat0
  ! xoutshiftn,youtshiftn   xlon0-outlon0n, ylat0-outlat0n
  ! outheight [m]           upper levels of the output grid
  ! outheighthalf [m]       half (middle) levels of the output grid cells
  ! DEP                     .true., if either dry or wet depos. is switched on
  ! DRYDEP                  .true., if dry deposition is switched on
  ! DRYDEPSPEC              .true., if dry deposition is switched on for that species
  ! WETDEP                  .true., if wet deposition is switched on
  ! OHREA                   .true., if OH reaction is switched on
  ! ASSSPEC                 .true., if there are two species asscoiated
  !                    (i.e. transfer of mass between these two occurs



  !  if output for each releasepoint shall be created maxpointspec=number of releasepoints
  !  else maxpointspec is 1 -> moved to unc_mod
  !  the OUTGRID is moved to the module outg_mod
  !******************************************************************************

  !real gridunc(0:maxxgrid-1,0:maxygrid-1,maxzgrid,maxspec,
  !    +             maxpointspec_act,nclassunc,maxageclass)
  !real griduncn(0:maxxgridn-1,0:maxygridn-1,maxzgrid,maxspec,
  !    +              maxpointspec_act,nclassunc,maxageclass)
  !real wetgridunc(0:maxxgrid-1,0:maxygrid-1,maxspec,
  !    +                maxpointspec_act,nclassunc,maxageclass)
  !real wetgriduncn(0:maxxgridn-1,0:maxygridn-1,maxspec,
  !    +ct                 maxpointspec,nclassunc,maxageclass)
  !real drygridunc(0:maxxgrid-1,0:maxygrid-1,maxspec,maxpointspec,
  !    +                nclassunc,maxageclass)
  !real drygriduncn(0:maxxgridn-1,0:maxygridn-1,maxspec,
  !    +                 maxpointspec,nclassunc,maxageclass)

  !real oroout(0:maxxgrid-1,0:maxygrid-1)
  !real orooutn(0:maxxgridn-1,0:maxygridn-1)
  !     real area(0:maxxgrid-1,0:maxygrid-1)
  !real arean(0:maxxgridn-1,0:maxygridn-1)
  !real volume(0:maxxgrid-1,0:maxygrid-1,maxzgrid)
  !real volumen(0:maxxgridn-1,0:maxygridn-1,maxzgrid)

  !real areaeast(0:maxxgrid-1,0:maxygrid-1,maxzgrid)
  !real areanorth(0:maxxgrid-1,0:maxygrid-1,maxzgrid)


  ! gridunc,griduncn        uncertainty of outputted concentrations
  ! wetgridunc,wetgriduncn  uncertainty of accumulated wet deposited mass on output grid
  ! drygridunc,drygriduncn  uncertainty of accumulated dry deposited mass on output grid
  ! oroout,orooutn [m]      height of model topography at output grid
  ! area,arean [m2]         area of each grid cell
  ! volume,volumen [m3]     volume of each grid cell
  ! ... field names with n at the end indicate a nested output grid


  !***********************************
  ! Variables defining receptor points
  !***********************************

  real :: xreceptor(maxreceptor),yreceptor(maxreceptor)
  real :: receptorarea(maxreceptor)
  real :: creceptor(maxreceptor,maxspec)
  character(len=16) :: receptorname(maxreceptor)
  integer :: numreceptor

  ! xreceptor,yreceptor     receptor position
  ! creceptor               concentrations at receptor points
  ! receptorarea            area of 1*1 grid cell at receptor point



  !***************************************
  ! Variables characterizing each particle
  !***************************************

  integer :: numpart,itra1(maxpart)
  integer :: npoint(maxpart),nclass(maxpart)
  integer :: idt(maxpart),itramem(maxpart),itrasplit(maxpart)
  integer :: numparticlecount

  real(kind=dp) :: xtra1(maxpart),ytra1(maxpart)
  real :: ztra1(maxpart),xmass1(maxpart,maxspec)

  ! numpart                 actual number of particles in memory
  ! itra1 (maxpart) [s]     temporal positions of the particles
  ! npoint(maxpart)         indicates the release point of each particle
  ! nclass (maxpart)        one of nclassunc classes to which the particle is attributed
  ! itramem (maxpart) [s]   memorized release times of the particles
  ! itrasplit (maxpart) [s] next time when particle is to be split into two
  ! idt(maxpart) [s]        time step to be used for next integration
  ! numparticlecount        counts the total number of particles that have been released
  ! xtra1,ytra1,ztra1       spatial positions of the particles
  ! xmass1 [kg]             particle masses



  !*******************************************************
  ! Info table on available chemical species/radionuclides
  !*******************************************************

  !character*10 specname(maxtable)
  !real decaytime(maxtable),wetscava(maxtable),wetscavb(maxtable)
  !real drydiff(maxtable),dryhenry(maxtable),dryactiv(maxtable)
  !real partrho(maxtable),partmean(maxtable),partsig(maxtable)
  !real dryvelo(maxtable),weightmol(maxtable),ohreact(maxtable)

  ! specname            Name of chemical species/radionuclide
  ! decaytime           Half time of radionuclides
  ! wetscava, wetscavb  Parameters for calculating scavenging coefficients
  ! drydiff             diffusivitiy of species relative to diff. of H2O
  ! dryhenry [M/atm]    Henry constant
  ! dryactiv            reactivity relative to that of O3
  ! partrho [kg/m3]     density of particles
  ! partmean [m]        mean diameter of particles
  ! partsig [m]         mean stand. deviation of particle diameter
  ! dryvelo [cm/s]      constant dry deposition velocity
  ! weightmol [g/mol]   molecular weight
  ! ohreact             OH reaction rate



  !********************
  ! Random number field
  !********************

  real :: rannumb(maxrand)

  ! rannumb                 field of normally distributed random numbers


end module com_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

function psih (z,l)

  !*****************************************************************************
  !                                                                            *
  !     Calculation of the stability correction term                           *
  !                                                                            *
  !     AUTHOR: Matthias Langer, adapted by Andreas Stohl (6 August 1993)      *
  !             Update: G. Wotawa, 11 October 1994                             *
  !                                                                            *
  !     Literature:                                                            *
  !     [1] C.A.Paulson (1970), A Mathematical Representation of Wind Speed    *
  !           and Temperature Profiles in the Unstable Atmospheric Surface     *
  !           Layer. J.Appl.Met.,Vol.9.(1970), pp.857-861.                     *
  !                                                                            *
  !     [2] A.C.M. Beljaars, A.A.M. Holtslag (1991), Flux Parameterization over*
  !           Land Surfaces for Atmospheric Models. J.Appl.Met. Vol. 30,pp 327-*
  !           341                                                              *
  !                                                                            *
  !     Variables:                                                             *
  !     L     = Monin-Obukhov-length [m]                                       *
  !     z     = height [m]                                                     *
  !     zeta  = auxiliary variable                                             *
  !                                                                            *
  !     Constants:                                                             *
  !     eps   = 1.2E-38, SUN-underflow: to avoid division by zero errors       *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  real :: psih,x,z,zeta,l
  real,parameter :: a=1.,b=0.667,c=5.,d=0.35,eps=1.e-20

  if ((l.ge.0).and.(l.lt.eps)) then
    l=eps
  else if ((l.lt.0).and.(l.gt.(-1.*eps))) then
    l=-1.*eps
  endif

  if ((log10(z)-log10(abs(l))).lt.log10(eps)) then
    psih=0.
  else
    zeta=z/l
    if (zeta.gt.0.) then
      psih = - (1.+0.667*a*zeta)**(1.5) - b*(zeta-c/d)*exp(-d*zeta) &
           - b*c/d + 1.
    else
      x=(1.-16.*zeta)**(.25)
      psih=2.*log((1.+x*x)/2.)
    end if
  end if

end function psih

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************
  implicit none

  character(len=11) :: speciesfn
  character(len=3)  :: aspec
  character(len=16) :: pspecies
  real :: pdecay, pweta_gas, pwetb_gas, preldiff, phenry, pf0, pdensity, pdquer
  real :: pdsigma, pdryvel, pweightmolar, pohcconst, pohdconst, pohnconst
  real :: pcrain_aero, pcsnow_aero, pccn_aero, pin_aero
  integer :: readerror, unitspecies, specnumber

! declare namelist
  namelist /species_params/ &
       pspecies, pdecay, pweta_gas, pwetb_gas, &
       pcrain_aero, pcsnow_aero, pccn_aero, pin_aero, &
       preldiff, phenry, pf0, pdensity, pdquer, &
       pdsigma, pdryvel, pweightmolar, pohcconst, pohdconst, pohnconst 

  unitspecies=4

  write(*,*) '    Species   |       |   WetDep(gas)   |    DryDep(gas)   |WetDep(below-C)| WetDep(in-C)|'//& 
             '     DryDepo(particles)  Altern| Radioact.  |     OH Reaction      |'

  write(*,*) '    Name      |molwght| A          B    | D    H        f0 | Crain   Csnow |  ccn    in  |' //&
             '   rho    dquer    dsig    vd  | Halflife[s]|   C**     D[T]  N*** |'

  write(*,*) '--------------|-------|-----------------|------------------|---------------|-------------|'//&
             '-------------------------------|------------|----------------------|'


! write(*,*) '    Specie    | Radioact.  | WetDep(gas)     |WetDep(below-C)| WetDep(in-C)|     DryDepo(gas)  |'//& 
!            '     DryDepo(particles)  Altern|       |     OH Reaction      |'
! write(*,*) '    Name      | Halflife[s]|  A         B    |  Crain  Csnow | ccn    in   |   D      H    f0  |' //&
!            '   rho    dquer    dsig    vd  |molwght|   C**     D[T]  N*** |'
! write(*,*) '--------------|------------|-----------------|---------------|-------------|-------------------|'//&
!            '-------------------------------|-------|----------------------|'

  do specnumber=1,100
  
  write (aspec,'(i0.3)') specnumber
  speciesfn='SPECIES_'//aspec
 
! write(*,*) 'Processing: ',speciesfn

  pspecies="" ! read failure indicator value
  pdecay=-9.9
  pweta_gas=-0.9E-09
  pwetb_gas=0.0
  pcrain_aero=-9.9
  pcsnow_aero=-9.9
  pccn_aero=-9.9
  pin_aero=-9.9
  preldiff=-9.9
  phenry=0.0
  pf0=0.0
  pdensity=-0.9E09
  pdquer=0.0
  pdsigma=0.0
  pdryvel=-9.99
  pohcconst=-9.9
  pohdconst=-9.9
  pohnconst=2.0
  pweightmolar=-9.9

! Open the SPECIES file and read species names and properties
!************************************************************
  open(unitspecies,file=speciesfn,status='old',form='formatted',err=998)
  read(unitspecies,species_params,err=998)
  close(unitspecies)
  
  write(*,45) specnumber,' ',pspecies,'|',pweightmolar,'|',pweta_gas,' ',pwetb_gas,'|', &
              preldiff,' ',phenry,' ',pf0,'|', &
              pcrain_aero,' ',pcsnow_aero,'|',pccn_aero,' ',pin_aero,'|', &
              pdensity,pdquer,pdsigma,pdryvel,'|',pdecay,'|',pohcconst,pohdconst,pohnconst,'|'

45 format(i3,a1,a11,a1,f7.1,a1,e8.1,a1,f8.2,a1, &
          f4.1,a1,e8.1,a1,f4.1,a1, &
          f7.1,a1,f7.1,a1,f6.1,a1,f6.1,a1, &
          e8.1,e9.1,f7.1,f7.2,a1,f12.1,a1,e8.1,f7.1,f7.1,a1)

!  write(*,45) specnumber,' ',pspecies,'|',pdecay,'|',pweta_gas,' ',pwetb_gas,'|',pcrain_aero,' ', &
!            pcsnow_aero,'|',pccn_aero,' ',pin_aero,'|',preldiff,' ',phenry,' ',pf0,'|', &
!             pdensity,pdquer,pdsigma,pdryvel,'|',pweightmolar,'|',pohcconst,pohdconst,pohnconst,'|'

!5 format(i3,a1,a11,a1,f12.1,a1,e8.1,a1,f8.2,a1,f7.1,a1,f7.1,a1,f6.1,a1,f6.1,a1,f5.1,a1,e8.1,a1,f4.1,a1, &
!         e8.1,e9.1,f7.1,f7.2,a1,f7.1,a1,e8.1,f7.1,f7.1,a1)
            
998 continue
enddo

write(*,*) '** unit [cm^3/molec/s] (in FLEXPART version 9.2 and below this had unit [cm3/s], note the unit is now changed!)'
write(*,*) '*** no unit'


end

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine clustering(xl,yl,zl,n,xclust,yclust,zclust,fclust,rms, &
       rmsclust,zrms)
  !                      i  i  i  i   o      o      o      o     o
  !   o      o
  !*****************************************************************************
  !                                                                            *
  !   This routine clusters the particle position into ncluster custers.       *
  !   Input are the longitudes (xl) and latitudes (yl) of the individual       *
  !   points, output are the cluster mean positions (xclust,yclust).           *
  !   Vertical positions are not directly used for the clustering.             *
  !                                                                            *
  !   For clustering, the procedure described in Dorling et al. (1992) is used.*
  !                                                                            *
  !   Dorling, S.R., Davies, T.D. and Pierce, C.E. (1992):                     *
  !   Cluster analysis: a technique for estimating the synoptic meteorological *
  !   controls on air and precipitation chemistry - method and applications.   *
  !   Atmospheric Environment 26A, 2575-2581.                                  *
  !                                                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     1 February 2002                                                        *
  !                                                                            *
  ! Variables:                                                                 *
  ! fclust          fraction of particles belonging to each cluster            *
  ! ncluster        number of clusters to be used                              *
  ! rms             total horizontal rms distance after clustering             *
  ! rmsclust        horizontal rms distance for each individual cluster        *
  ! zrms            total vertical rms distance after clustering               *
  ! xclust,yclust,  Cluster centroid positions                                 *
  ! zclust                                                                     *
  ! xl,yl,zl        particle positions                                         *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  integer :: n,i,j,l,nclust(maxpart),numb(ncluster),ncl
  real :: xl(n),yl(n),zl(n),xclust(ncluster),yclust(ncluster),x,y,z
  real :: zclust(ncluster),distance2,distances,distancemin,rms,rmsold
  real :: xav(ncluster),yav(ncluster),zav(ncluster),fclust(ncluster)
  real :: rmsclust(ncluster)
  real :: zdist,zrms



  if (n.lt.ncluster) return
  rmsold=-5.

  ! Convert longitude and latitude from degrees to radians
  !*******************************************************

  do i=1,n
    nclust(i)=i
    xl(i)=xl(i)*pi180
    yl(i)=yl(i)*pi180
  end do


  ! Generate a seed for each cluster
  !*********************************

  do j=1,ncluster
    zclust(j)=0.
    xclust(j)=xl(j*n/ncluster)
    yclust(j)=yl(j*n/ncluster)
  end do


  ! Iterative loop to compute the cluster means
  !********************************************

  do l=1,100

  ! Assign each particle to a cluster: criterion minimum distance to the
  ! cluster mean position
  !*********************************************************************


    do i=1,n
      distancemin=10.**10.
      do j=1,ncluster
        distances=distance2(yl(i),xl(i),yclust(j),xclust(j))
        if (distances.lt.distancemin) then
          distancemin=distances
          ncl=j
        endif
      end do
      nclust(i)=ncl
    end do


  ! Recalculate the cluster centroid position: convert to 3D Cartesian coordinates,
  ! calculate mean position, and re-project this point onto the Earth's surface
  !*****************************************************************************

    do j=1,ncluster
      xav(j)=0.
      yav(j)=0.
      zav(j)=0.
      rmsclust(j)=0.
      numb(j)=0
    end do
    rms=0.

    do i=1,n
      numb(nclust(i))=numb(nclust(i))+1
      distances=distance2(yl(i),xl(i), &
           yclust(nclust(i)),xclust(nclust(i)))

  ! rms is the total rms of all particles
  ! rmsclust is the rms for a particular cluster
  !*********************************************

      rms=rms+distances*distances
      rmsclust(nclust(i))=rmsclust(nclust(i))+distances*distances

  ! Calculate Cartesian 3D coordinates from longitude and latitude
  !***************************************************************

      x = cos(yl(i))*sin(xl(i))
      y = -1.*cos(yl(i))*cos(xl(i))
      z = sin(yl(i))
      xav(nclust(i))=xav(nclust(i))+x
      yav(nclust(i))=yav(nclust(i))+y
      zav(nclust(i))=zav(nclust(i))+z
    end do

    rms=sqrt(rms/real(n))


  ! Find the mean location in Cartesian coordinates
  !************************************************

    do j=1,ncluster
      if (numb(j).gt.0) then
        rmsclust(j)=sqrt(rmsclust(j)/real(numb(j)))
        xav(j)=xav(j)/real(numb(j))
        yav(j)=yav(j)/real(numb(j))
        zav(j)=zav(j)/real(numb(j))

  ! Project the point back onto Earth's surface
  !********************************************

        xclust(j)=atan2(xav(j),-1.*yav(j))
        yclust(j)=atan2(zav(j),sqrt(xav(j)*xav(j)+yav(j)*yav(j)))
      endif
    end do


  ! Leave the loop if the RMS distance decreases only slightly between 2 iterations
  !*****************************************************************************

    if ((l.gt.1).and.(abs(rms-rmsold)/rmsold.lt.0.005)) goto 99
    rmsold=rms

  end do

99   continue

  ! Convert longitude and latitude from radians to degrees
  !*******************************************************

  do i=1,n
    xl(i)=xl(i)/pi180
    yl(i)=yl(i)/pi180
    zclust(nclust(i))=zclust(nclust(i))+zl(i)
  end do

  do j=1,ncluster
    xclust(j)=xclust(j)/pi180
    yclust(j)=yclust(j)/pi180
    if (numb(j).gt.0) zclust(j)=zclust(j)/real(numb(j))
    fclust(j)=100.*real(numb(j))/real(n)
  end do

  ! Determine total vertical RMS deviation
  !***************************************

  zrms=0.
  do i=1,n
    zdist=zl(i)-zclust(nclust(i))
    zrms=zrms+zdist*zdist
  end do
  if (zrms.gt.0.) zrms=sqrt(zrms/real(n))

end subroutine clustering

!arrays changing with time, because of reading or transformation
   MODULE work_arrays
      INTEGER itime
      INTEGER ::  nspec=1
      REAL   , DIMENSION(:,:),ALLOCATABLE :: xmass0(:,:), xmass1(:,:) , xmass1_injected(:,:), xmass1_remaining(:,:)
      REAL   , DIMENSION(:,:),ALLOCATABLE :: xmass1_SG,xmass1_PG
      REAL   , DIMENSION(:,:),ALLOCATABLE :: xmass2 !mass of artificial tracer 
      integer, DIMENSION(:),  ALLOCATABLE :: vnpoint(:),vitramem(:)
      REAL   , DIMENSION(:),  ALLOCATABLE :: vxlon(:),vylat(:),vztra1(:),vtri(:),vhmixi(:),vtopo(:),vpvi(:),vtti(:),vqvi(:),vrhoi(:)
      REAL   , DIMENSION(:),  ALLOCATABLE ::  vxlon2,vxlon3
      INTEGER, DIMENSION(:),  ALLOCATABLE :: i_reach_strat(:), i_reach_400(:), i_reach_2PVU(:)
      INTEGER, DIMENSION(:),  ALLOCATABLE :: reach_strat(:), reach_400(:), reach_2PVU(:), flag_reach_strat(:), flag_over_400(:)
!      INTEGER, DIMENSION(:),  ALLOCATABLE :: ireach_strat(:), ireach_400(:), ireach_2PVU(:)
      INTEGER, DIMENSION(:),  ALLOCATABLE :: secs2_400(:), secs2_380(:), secs2_360(:), secs2_340(:)
      INTEGER, DIMENSION(:),  ALLOCATABLE ::  secs2_conventional(:), secs2_trop_FLEX(:),secs2_2PVU380(:),secs2_35PVU380(:)
      INTEGER ,DIMENSION(:),  allocatable :: ETOW(:),TOW(:),LMS(:),TTL(:),UT(:),STRAT(:),OW(:),MW(:)     
      LOGICAL, DIMENSION(:),  ALLOCATABLE :: l_reached_strat(:),l_reaching_strat(:),l_still_in_trop
      REAL   , DIMENSION(:),  ALLOCATABLE :: vtheta,vpres
      REAL   , DIMENSION(:),  ALLOCATABLE :: lat_in_strat,lat_went_strat
      REAL   , DIMENSION(:,:),ALLOCATABLE :: out_matrix 
      INTEGER, DIMENSION(:,:,:),  ALLOCATABLE :: this_source
      REAL   , DIMENSION(:),  ALLOCATABLE :: lon_down, lat_down
      INTEGER  :: nlon_down, nlat_down
      REAL   , DIMENSION(:,:),ALLOCATABLE ::   chi_30d_strat
      INTEGER, DIMENSION(:,:),  ALLOCATABLE :: N_1, N_0

     ! nspec=1

      
   END MODULE

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module restart_mod

  !*****************************************************************************
  !                                                                            *
  !    This module write variables to file for eventual restart, and reads     *
  !    these variables from file in case of restart                            *
  !                                                                            *
  !*****************************************************************************

  use particle_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use outgrid_mod
  use unc_mod
  use date_mod
#ifdef USE_NCF
  use netcdf_output_mod
#endif

  character(len=256) :: restart_filename1,restart_filename2,restart_filename3

contains

subroutine output_restart(itime,loutnext,lrecoutnext,outnum)

  implicit none

  integer, intent(in) :: itime,loutnext,lrecoutnext
  real, intent(in) :: outnum
  integer :: imax,i,j,jjjjmmdd,ihmmss,ipart,iwritten
  integer :: ks,kp,kz,nage,jy,ix,l,n
  real(kind=dp) :: jul
  character :: adate*8,atime*6


  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss

  restart_filename3 = restart_filename2
  restart_filename2 = restart_filename1
  restart_filename1 = path(2)(1:length(2))//'restart_'//adate//atime

  write(*,*) 'Writing Restart file:', trim(restart_filename1)

#ifdef ETA
!$OMP PARALLEL PRIVATE(i,j)
!$OMP DO
  do j=1,count%alive
    i=count%ialive(j)
    if (part(i)%alive) then
      call update_zeta_to_z(itime,i)
      call update_z_to_zeta(itime,i)
    endif
  end do
!$OMP END DO
!$OMP END PARALLEL
#endif

  open(unitrestart,file=restart_filename1,form='unformatted')

  !Get largest live particle number for allocation new start
  
  imax=0
  iwritten=0
  do ipart=1,count%allocated
    if ((ipout.gt.0).and.(n_average.gt.0)) then
      if((.not. part(ipart)%alive).and.(abs(part(ipart)%tend-itime).ge.ipoutfac*loutstep)) &
        cycle
    else
      if (.not. part(ipart)%alive) cycle
    endif
    if (ipart.gt.imax) imax=ipart
    iwritten=iwritten+1
  end do
  ! Write current time to file
  !***************************
  write(unitrestart) itime
  write(unitrestart) imax
  write(unitrestart) iwritten
  write(unitrestart) loutnext
  write(unitrestart) lrecoutnext
  write(unitrestart) outnum

  do ipart=1,imax
    if ((ipout.gt.0).and.(n_average.gt.0)) then
      if((.not. part(ipart)%alive).and.(abs(part(ipart)%tend-itime).ge.ipoutfac*loutstep)) &
        cycle
    else
      if (.not. part(ipart)%alive) cycle
    endif
    write(unitrestart) ipart
    write(unitrestart) part(ipart)%xlon,part(ipart)%ylat,part(ipart)%z, &
#ifdef ETA
      part(ipart)%zeta, &
#endif
      part(ipart)%npoint,part(ipart)%nclass,part(ipart)%idt,part(ipart)%tend, &
      part(ipart)%tstart,part(ipart)%alive,part(ipart)%turbvel%u, &
      part(ipart)%turbvel%v,part(ipart)%turbvel%w,part(ipart)%mesovel%u, &
      part(ipart)%mesovel%v,part(ipart)%mesovel%w,(mass(ipart,j),j=1,nspec), &
      (mass_init(ipart,j),j=1,nspec)
    if (wetdep) write(unitrestart) (wetdeposit(ipart,j),j=1,nspec)
    if (drydep) write(unitrestart) (drydeposit(ipart,j),j=1,nspec)
    if ((drybkdep).or.(wetbkdep)) write(unitrestart) (xscav_frac1(ipart,j),j=1,nspec)
  end do
  if (iout.gt.0) then
#ifdef USE_NCF
    if (lnetcdfout.eq.1) write(unitrestart) tpointer
#endif

    do ks=1,nspec
      do kp=1,maxpointspec_act
        do nage=1,nageclass
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              do l=1,nclassunc
                do kz=1,numzgrid
                  write(unitrestart) gridunc(ix,jy,kz,ks,kp,l,nage)
                end do
                if ((wetdep).and.(ldirect.gt.0)) then
                  write(unitrestart) wetgridunc(ix,jy,ks,kp,l,nage)
                endif
                if ((drydep).and.(ldirect.gt.0)) then
                  write(unitrestart) drygridunc(ix,jy,ks,kp,l,nage)
                endif
              end do
            end do
          end do
          if (nested_output.eq.1) then
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                do l=1,nclassunc
                  do kz=1,numzgrid
                    write(unitrestart) griduncn(ix,jy,kz,ks,kp,l,nage)
                  end do
                  if ((wetdep).and.(ldirect.gt.0)) then
                    write(unitrestart) wetgriduncn(ix,jy,ks,kp,l,nage)
                  endif
                  if ((drydep).and.(ldirect.gt.0)) then
                    write(unitrestart) drygriduncn(ix,jy,ks,kp,l,nage)
                  endif
                end do
              end do
            end do
          endif
          if (iflux.eq.1) then
            do kz=1,numzgrid
              do jy=0,numygridn-1
                do ix=0,numxgridn-1
                  do i=1,5
                    write(unitrestart) flux(i,ix,jy,kz,ks,kp,nage)
                  end do
                end do
              end do
            end do        
          endif
        end do
        if (linit_cond.gt.0) then
          do kz=1,numzgrid
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                write(unitrestart) init_cond(ix,jy,kz,ks,kp)
              end do 
            end do
          end do 
        endif
      end do
      if (numreceptor.gt.0) then 
        do n=1,numreceptor
          read(unitpartin) creceptor(n,ks)
        end do
      endif
    end do
  endif
  close(unitrestart)

  ! open(unit=1234, iostat=stat, file=restart_filename3, status='old')
  ! if(stat == 0) close(1234, status='delete')
end subroutine output_restart

subroutine readrestart

  !*****************************************************************************
  !                                                                            *
  !   This routine opens the particle dump file and reads all the particle     *
  !   positions and gridded information from a previous run to initialize      *
  !   the current run.                                                         *
  !                                                                            *
  !     Author: L. Bakels 2022                                                 *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer :: i,j,ipart,ios,iterminate
  integer :: id1,id2,it1,it2,imax
  integer :: ks,kp,kz,nage,jy,ix,l,n
  real(kind=dp) :: julin
  real :: a

  numparticlecount=0


  open(unitpartin,file=path(2)(1:length(2))//'restart.bin', &
       form='unformatted',err=9989)

  write(*,*) 'Reading Restart file:', path(2)(1:length(2))//'restart.bin'
  
  read(unitpartin,iostat=ios) itime_init
  read(unitpartin) imax ! count%alive
  read(unitpartin) numpart
  read(unitpartin) loutnext_init
  read(unitpartin) lrecoutnext_init
  read(unitpartin) outnum_init

  count%alive=numpart
  if (ipin.eq.1) then
    count%spawned=imax
  else
    count%spawned=numpart
  endif
  if (count%allocated.lt.imax) call alloc_particles(imax-count%allocated)
  do i=1,numpart
    read(unitpartin) ipart
    if (ipout.gt.0) ipart=i ! No need to keep dead particle spots when no part dump
    read(unitpartin) part(ipart)%xlon,part(ipart)%ylat,part(ipart)%z, &
#ifdef ETA
      part(ipart)%zeta, &
#endif
      part(ipart)%npoint,part(ipart)%nclass,part(ipart)%idt,part(ipart)%tend, &
      part(ipart)%tstart,part(ipart)%alive,part(ipart)%turbvel%u, &
      part(ipart)%turbvel%v,part(ipart)%turbvel%w,part(ipart)%mesovel%u, &
      part(ipart)%mesovel%v,part(ipart)%mesovel%w,(mass(ipart,j),j=1,nspec), &
      (mass_init(ipart,j),j=1,nspec)
    part(ipart)%spawned = .true.
    if (wetdep) read(unitpartin) (wetdeposit(ipart,j),j=1,nspec)
    if (drydep) read(unitpartin) (drydeposit(ipart,j),j=1,nspec)
    if ((drybkdep).or.(wetbkdep)) read(unitpartin) (xscav_frac1(ipart,j),j=1,nspec)

#ifdef ETA
    part(ipart)%etaupdate=.true.
    part(ipart)%meterupdate=.true.
#endif
  end do

  if (iout.gt.0) then 
#ifdef USE_NCF
    if (lnetcdfout.eq.1) read(unitpartin) tpointer
#endif
    do ks=1,nspec
      do kp=1,maxpointspec_act
        do nage=1,nageclass
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              do l=1,nclassunc
                do kz=1,numzgrid
                  read(unitpartin) gridunc(ix,jy,kz,ks,kp,l,nage)
                end do
                if ((wetdep).and.(ldirect.gt.0)) then
                  read(unitpartin) wetgridunc(ix,jy,ks,kp,l,nage)
                endif
                if ((drydep).and.(ldirect.gt.0)) then
                  read(unitpartin) drygridunc(ix,jy,ks,kp,l,nage)
                endif
              end do
            end do
          end do
          if (nested_output.eq.1) then
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                do l=1,nclassunc
                  do kz=1,numzgrid
                    read(unitpartin) griduncn(ix,jy,kz,ks,kp,l,nage)
                  end do
                  if ((wetdep).and.(ldirect.gt.0)) then
                    read(unitpartin) wetgriduncn(ix,jy,ks,kp,l,nage)
                  endif
                  if ((drydep).and.(ldirect.gt.0)) then
                    read(unitpartin) drygriduncn(ix,jy,ks,kp,l,nage)
                  endif
                end do
              end do
            end do
          endif
          if (iflux.eq.1) then
            do kz=1,numzgrid
              do jy=0,numygridn-1
                do ix=0,numxgridn-1
                  do i=1,5
                    read(unitpartin) flux(i,ix,jy,kz,ks,kp,nage)
                  end do
                end do
              end do
            end do        
          endif
        end do
        if (linit_cond.gt.0) then
          do kz=1,numzgrid
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                read(unitpartin) init_cond(ix,jy,kz,ks,kp)
              end do 
            end do
          end do 
        endif
      end do
      if (numreceptor.gt.0) then 
        do n=1,numreceptor
          read(unitpartin) creceptor(n,ks)
        end do
      endif
    end do
  endif
  close(unitpartin)

  iterminate=0
  do i=1,imax
    if ((part(i)%spawned .eqv. .true.) .and. (.not. part(i)%alive)) then
      if (part(i)%tstart.le.itime_init) then
        call terminate_particle(i,part(i)%tend)
        iterminate=iterminate+1
      endif
    endif
  end do

  call rewrite_ialive()
  !count%spawned=count%spawned-iterminate
  numpart=count%spawned
  
  julin=juldate(ibdate,ibtime)+real(itime_init,kind=dp)/86400._dp
  if (abs(julin-bdate).le.1.e-5) then
    write(*,*) ' #### FLEXPART ERROR: PLEASE KEEP IBDATE     #### '
    write(*,*) ' #### AND IBTIME INTACT FROM THE INITIAL RUN!#### '
    error stop
  endif
  call caldate(julin,id1,it1)
  call caldate(bdate,id2,it2)
  write(*,*) ' #### Restarting Flexpart from restart.bin.    #### '
  write(*,*) ' #### Original run started on                  #### '
  write(*,*) 'bdate: ',bdate,id2,it2
  write(*,*) ' #### Restarting run starts on                 #### '
  write(*,*) 'julin: ',julin,id1,it1

  return

9989   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE             #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'restart.bin'//'    #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS        #### '
  write(*,*) ' #### NAME DOES NOT EXISTS, RENAME THE APPROPRIATE #### '
  write(*,*) ' #### RESTART FILE TO restart.bin.                 #### '
end subroutine readrestart

end module restart_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine part0(dquer,dsigma,density,fract,schmi,cun,vsh)
  !                  i      i       i      o     o    o   o
  !*****************************************************************************
  !                                                                            *
  !      Calculation of time independent factors of the dry deposition of      *
  !      particles:                                                            *
  !      Log-Normal-distribution of mass [dM/dlog(dp)], unimodal               *
  !                                                                            *
  !      AUTHOR: Matthias Langer, adapted by Andreas Stohl, 13 November 1993   *
  !                                                                            *
  !      Literature:                                                           *
  !      [1]  Scire/Yamartino/Carmichael/Chang (1989),                         *
  !             CALGRID: A Mesoscale Photochemical Grid Model.                 *
  !             Vol II: User's Guide. (Report No.A049-1, June, 1989)           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! alpha            help variable                                             *
  ! cun              'slip-flow' correction after Cunningham                   *
  ! d01 [um]         upper diameter                                            *
  ! d02 [um]         lower diameter                                            *
  ! dc [m2/s]        coefficient of Brownian diffusion                         *
  ! delta            distance given in standard deviation units                *
  ! density [kg/m3]  density of the particle                                   *
  ! dmean            geometric mean diameter of interval                       *
  ! dquer [um]       geometric mass mean particle diameter                     *
  ! dsigma           e.g. dsigma=10 or dsigma=0.1 means that 68% of the mass   *
  !                  are between 0.1*dquer and 10*dquer                        *
  ! fract(ni)        mass fraction of each diameter interval                   *
  ! kn               Knudsen number                                            *
  ! ni               number of diameter intervals, for which deposition        *
  !                  is calculated                                             *
  ! schmidt          Schmidt number                                            *
  ! schmi            schmidt**2/3                                              *
  ! vsh [m/s]        gravitational settling velocity of the particle           *
  ! x01              normalized upper diameter                                 *
  ! x02              normalized lower diameter                                 *
  !                                                                            *
  ! Constants:                                                                 *
  ! g [m/s2]         Acceleration of gravity                                   *
  ! kb [J/K]         Stefan-Boltzmann constant                                 *
  ! lam [m]          mean free path of air molecules                           *
  ! myl [kg/m/s]     dynamical viscosity of air                                *
  ! nyl [m2/s]       kinematic viscosity of air                                *
  ! tr               reference temperature                                     *
  !                                                                            *
  ! Function:                                                                  *
  ! erf              calculates the integral of the Gauss function             *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  real,parameter :: tr=293.15

  integer :: i
  real :: dquer,dsigma,density,xdummy,d01,d02,delta,x01,x02,fract(ni)
  real :: dmean,alpha,cun,dc,schmidt,schmi(ni),vsh(ni),kn,erf
  real,parameter :: myl=1.81e-5,nyl=0.15e-4
  real,parameter :: lam=6.53e-8,kb=1.38e-23,eps=1.2e-38


  ! xdummy constant for all intervals
  !**********************************

  xdummy=sqrt(2.)*alog(dsigma)


  ! particles diameters are split up to ni intervals between
  ! dquer-3*dsigma and dquer+3*dsigma
  !*********************************************************

  delta=6./real(ni)

  d01=dquer*dsigma**(-3)
  do i=1,ni
    d02=d01
    d01=dquer*dsigma**(-3.+delta*real(i))
    x01=alog(d01/dquer)/xdummy
    x02=alog(d02/dquer)/xdummy


  ! Area under Gauss-function is calculated and gives mass fraction of interval
  !****************************************************************************

    fract(i)=0.5*(erf(x01)-erf(x02))


  ! Geometric mean diameter of interval in [m]
  !*******************************************

    dmean=1.E-6*exp(0.5*alog(d01*d02))


  ! Calculation of time independent parameters of each interval
  !************************************************************

    kn=2.*lam/dmean
    if ((-1.1/kn).le.log10(eps)*log(10.)) then
      alpha=1.257
    else
      alpha=1.257+0.4*exp(-1.1/kn)
    endif
    cun=1.+alpha*kn
    dc=kb*tr*cun/(3.*pi*myl*dmean)
    schmidt=nyl/dc
    schmi(i)=schmidt**(-2./3.)
    vsh(i)=ga*density*dmean*dmean*cun/(18.*myl)

  end do

end subroutine part0

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

program flexpart

  !*****************************************************************************
  !                                                                            *
  !     This is the Lagrangian Particle Dispersion Model FLEXPART.             *
  !     The main program manages the reading of model run specifications, etc. *
  !     All actual computing is done within subroutine timemanager.            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     18 May 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod
  use conv_mod

  implicit none

  integer :: i,j,ix,jy,inest
  integer :: idummy = -320

  ! Generate a large number of random numbers
  !******************************************

  do i=1,maxrand-1,2
    call gasdev1(idummy,rannumb(i),rannumb(i+1))
  end do
  call gasdev1(idummy,rannumb(maxrand),rannumb(maxrand-1))

  ! Print the GPL License statement
  !*******************************************************
  print*,'Welcome to FLEXPART Version 9.0'
  print*,'FLEXPART is free software released under the GNU Genera'// &
       'l Public License.'

  ! Read the pathnames where input/output files are stored
  !*******************************************************

  call readpaths

  ! Read the user specifications for the current model run
  !*******************************************************

  call readcommand


  ! Read the age classes to be used
  !********************************

  call readageclasses


  ! Read, which wind fields are available within the modelling period
  !******************************************************************

  call readavailable


  ! Read the model grid specifications,
  ! both for the mother domain and eventual nests
  !**********************************************

  call gridcheck
  call gridcheck_nests


  ! Read the output grid specifications
  !************************************

  call readoutgrid
  if (nested_output.eq.1) call readoutgrid_nest


  ! Read the receptor points for which extra concentrations are to be calculated
  !*****************************************************************************

  call readreceptors


  ! Read the physico-chemical species property table
  !*************************************************
  !SEC: now only needed SPECIES are read in readreleases.f
  !call readspecies


  ! Read the landuse inventory
  !***************************

  call readlanduse


  ! Assign fractional cover of landuse classes to each ECMWF grid point
  !********************************************************************

  call assignland



  ! Read the coordinates of the release locations
  !**********************************************

  call readreleases

  ! Read and compute surface resistances to dry deposition of gases
  !****************************************************************

  call readdepo


  ! Convert the release point coordinates from geografical to grid coordinates
  !***************************************************************************

  call coordtrafo


  ! Initialize all particles to non-existent
  !*****************************************

  do j=1,maxpart
    itra1(j)=-999999999
  end do

  ! For continuation of previous run, read in particle positions
  !*************************************************************

  if (ipin.eq.1) then
    call readpartpositions
  else
    numpart=0
    numparticlecount=0
  endif


  ! Calculate volume, surface area, etc., of all output grid cells
  ! Allocate fluxes and OHfield if necessary
  !***************************************************************

  call outgrid_init
  if (nested_output.eq.1) call outgrid_init_nest


  ! Read the OH field
  !******************

  if (OHREA.eqv..TRUE.) &
       call readOHfield

  ! Write basic information on the simulation to a file "header"
  ! and open files that are to be kept open throughout the simulation
  !******************************************************************

  call writeheader
  if (nested_output.eq.1) call writeheader_nest
  open(unitdates,file=path(2)(1:length(2))//'dates')
  call openreceptors
  if ((iout.eq.4).or.(iout.eq.5)) call openouttraj


  ! Releases can only start and end at discrete times (multiples of lsynctime)
  !***************************************************************************

  do i=1,numpoint
    ireleasestart(i)=nint(real(ireleasestart(i))/ &
         real(lsynctime))*lsynctime
    ireleaseend(i)=nint(real(ireleaseend(i))/ &
         real(lsynctime))*lsynctime
  end do


  ! Initialize cloud-base mass fluxes for the convection scheme
  !************************************************************

  do jy=0,nymin1
    do ix=0,nxmin1
      cbaseflux(ix,jy)=0.
    end do
  end do
  do inest=1,numbnests
    do jy=0,nyn(inest)-1
      do ix=0,nxn(inest)-1
        cbasefluxn(ix,jy,inest)=0.
      end do
    end do
  end do


  ! Calculate particle trajectories
  !********************************

  call timemanager


  write(*,*) 'CONGRATULATIONS: YOU HAVE SUCCESSFULLY COMPLETED A FLE&
       &XPART MODEL RUN!'

end program flexpart

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!##################################################################
!##################################################################
!######                                                      ######
!######                     Developed by                     ######
!######     Center for Analysis and Prediction of Storms     ######
!######                University of Oklahoma                ######
!######                                                      ######
!##################################################################
!##################################################################
module qvsat_mod
  
  implicit none
  private

  public :: f_qvsat, ew

contains

real function f_qvsat( p, t )

  !PURPOSE:
  !
  !Calculate the saturation specific humidity using enhanced Teten's
  !formula.
  !
  !AUTHOR: Yuhe Liu
  !01/08/1998
  !
  !MODIFICATION HISTORY:
  !
  !INPUT :
  !  p        Pressure (Pascal)
  !  t        Temperature (K)
  !OUTPUT:
  !  f_qvsat  Saturation water vapor specific humidity (kg/kg).
  !
  !Variable Declarations.
  !

  implicit none

  real :: p         ! Pressure (Pascal)
  real :: t         ! Temperature (K)
  real :: fespt

  real,parameter ::  rd     = 287.0 ! Gas constant for dry air  (m**2/(s**2*K))
  real,parameter ::  rv     = 461.0 ! Gas constant for water vapor  (m**2/(s**2*K)).
  real,parameter ::  rddrv  = rd/rv


  ! Change by A. Stohl to save computation time:
  ! IF ( t.ge.273.15 ) THEN     ! for water
  if ( t.ge.253.15 ) then      ! modification Petra Seibert
                               ! (supercooled water may be present)
    fespt=f_esl(p,t)
  else
    fespt=f_esi(p,t)
  endif

!!$  f_qvsat = rddrv * fespt / (p-(1.0-rddrv)*fespt)      !old
  if (p-(1.0-rddrv)*fespt == 0.) then                     !bugfix
     f_qvsat = 1.
  else
     f_qvsat = rddrv * fespt / (p-(1.0-rddrv)*fespt)
  end if

  return
end function f_qvsat


real function f_esl( p, t )
  ! Saturation water vapor pressure over liquid water
  implicit none

  real :: p         ! Pressure (Pascal)
  real :: t         ! Temperature (K)
  real :: f

  !#######################################################################
  !
  !Saturation specific humidity parameters used in enhanced Teten's
  !formula. (See A. Buck, JAM 1981)
  !
  !#######################################################################

  real,parameter ::  satfwa = 1.0007
  real,parameter ::  satfwb = 3.46e-8  ! for p in Pa

  real,parameter ::  satewa = 611.21   ! es in Pa
  real,parameter ::  satewb = 17.502
  real,parameter ::  satewc = 32.18

  real,parameter ::  satfia = 1.0003
  real,parameter ::  satfib = 4.18e-8  ! for p in Pa

  real,parameter ::  sateia = 611.15   ! es in Pa
  real,parameter ::  sateib = 22.452
  real,parameter ::  sateic = 0.6

  f = satfwa + satfwb * p
  f_esl = f * satewa * exp( satewb*(t-273.15)/(t-satewc) )

  return
end function f_esl

real function f_esi( p, t )
  ! Saturation water vapor pressure over ice (Pa)
  implicit none

  real :: p         ! Pressure (Pascal)
  real :: t         ! Temperature (K)
  real :: f

  !#######################################################################
  !
  !Saturation specific humidity parameters used in enhanced Teten's
  !formula. (See A. Buck, JAM 1981)
  !
  !#######################################################################
  !
  real,parameter ::  satfwa = 1.0007
  real,parameter ::  satfwb = 3.46e-8  ! for p in Pa

  real,parameter ::  satewa = 611.21   ! es in Pa
  real,parameter ::  satewb = 17.502
  real,parameter ::  satewc = 32.18

  real,parameter ::  satfia = 1.0003
  real,parameter ::  satfib = 4.18e-8  ! for p in Pa

  real,parameter ::  sateia = 611.15   ! es in Pa
  real,parameter ::  sateib = 22.452
  real,parameter ::  sateic = 0.6

  f = satfia + satfib * p
  f_esi = f * sateia * exp( sateib*(t-273.15)/(t-sateic) )

  return
end function f_esi

real function ew(x,p) ! p is not used

  !****************************************************************
  !SAETTIGUNGSDAMPFDRUCK UEBER WASSER IN PA. X IN KELVIN.
  !NACH DER GOFF-GRATCH-FORMEL.
  !****************************************************************

  implicit none

  real :: x, y, a, p , c, d

  ew=0.
  if(x.le.0.) error stop 'sorry: t not in [k]'
  ! Formula of Goff and Gratch (after Murray, 1966)
  ! if (x.lt.273.15) then
  ! ! Above ice
  !   a = 273.15/x
  !   y = -20.947031*a - 3.56654*log(a) - 2.01889049/a
  !   ew = 5.75185606E10*exp(y)
  ! else
  ! ! Above water
  !   a = 373.15/x 
  !   y = -18.1972839*a + 5.02808*log(a) - 70242.1852*exp(-26.1205253/a) + &
  !     58.0691913*exp(-8.03945282*a)
  !   ew = 7.95357242E10*exp(y)
  ! endif

  ! ! Formula of Magnus (after Murray, 1966)
  ! if (x.lt.273.15) then
  ! ! Above ice
  !   ew = 6.1078*exp(21.8745584*(x-273.15)/(x-7.66))
  ! else 
  ! ! Above water
  !   ew = 6.1078*exp(17.2693882*(x-273.15)/(x-35.86))
  ! endif

  ! Formula of Buck 1981
  ! ew = f_qvsat(p,x)

  ! ! Original
  y=373.16/x
  a=-7.90298*(y-1.)
  a=a+(5.02808*0.43429*alog(y))
  c=(1.-(1./y))*11.344
  c=-1.+(10.**c)
  c=-1.3816*c/(10.**7)
  d=(1.-y)*3.49149
  d=-1.+(10.**d)
  d=8.1328*d/(10.**3)
  y=a+c+d
  ew=101324.6*(10.**y)       ! Saettigungsdampfdruck in Pa

end function ew

end module qvsat_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module receptor_mod

  !*****************************************************************************
  !                                                                            *
  !    This module contains variables and subroutines for  calculating         *
  !    receptor concentrations and writing these to file                       *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use point_mod
  use particle_mod
  use date_mod
  use windfields_mod,      only: rho, prs, height, nzmax, nz !, qv
#if USE_NCF
  use receptor_netcdf_mod, only: nc_id, concvar_id, uncvar_id, &
                                recnamevar_id, timevar_id, &
                                reclonvar_id, reclatvar_id, recaltvar_id, &
                                nnvar_id, xkvar_id, rpointer, &
                                ncsat_id, satvar_id, satuncvar_id, &
                                satnamevar_id, sattimevar_id, &
                                satlonvar_id, satlatvar_id, sataltvar_id, &
                                satnnvar_id, satxkvar_id, spointer, sat_name, &
                                receptor_output_netcdf, write_receptor_netcdf, &
                                satellite_output_netcdf, write_satellite_netcdf, &
                                close_receptor_netcdf, close_satellite_netcdf
#endif
  use binary_output_mod,  only: receptorout_init_binary, write_receptor_binary, &
                                satelliteout_init_binary, write_satellite_binary

  implicit none

  contains

 
  subroutine alloc_receptor

  !*****************************************************************************
  !                                                                            *
  !    This routine allocates variables for receptor concentrations            *
  !                                                                            *
  !*****************************************************************************

    implicit none

    if (numreceptor.gt.0) then
      allocate( creceptor(nspec,maxrecsample) )
      allocate( crecuncert(nspec,maxrecsample) )
      allocate( nnreceptor(maxrecsample) )
      allocate( xkreceptor(maxrecsample) )
      creceptor(:,:)=0.
      crecuncert(:,:)=0.
      nnreceptor(:)=0.
      xkreceptor(:)=0.
    endif

  end subroutine alloc_receptor


  subroutine receptoroutput(itime,lrecoutstart,lrecoutend,lrecoutnext,recoutnum,recoutnumsat)

  !*****************************************************************************
  !                                                                            *
  !    Output concentrations at receptors                                      *
  !                                                                            *
  !    Author: R. Thompson, Sep-2023                                           *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************

    use omp_lib, only: OMP_GET_MAX_THREADS, OMP_GET_THREAD_NUM

    implicit none

    integer   :: itime, lrecoutstart, lrecoutend, lrecoutnext
    real, dimension(maxrecsample) :: recoutnum
    real, dimension(nlayermax,maxrecsample) :: recoutnumsat
    real      :: weight
    real(kind=dp) :: jul
    character(len=256) :: fn, fnsat
    character :: adate*8, atime*6
    integer   :: jjjjmmdd, ihmmss
    integer   :: numsatlayer, nchar, ks_start
    integer   :: n, nn, nr, ix, jy, ixp, jyp, indz, indzp, il, ind, ks, k, kz
    real      :: ddx, ddy, rddx, rddy, p1, p2, p3, p4, dz1, dz2, dz
    real      :: rhoi, zmid
    real, dimension(2) :: rho_p
    real, dimension(:), allocatable        :: densityoutrecept
    real, dimension(:,:), allocatable      :: nnrec, xkrec, altrec
    real, dimension(:), allocatable        :: lonrec, latrec
    integer, dimension(:), allocatable     :: timerec
    real, dimension(:,:,:), allocatable    :: crec, cunc
    character(len=16), dimension(:), allocatable :: namerec
    character(len=24), dimension(:), allocatable :: namesatrec
    real, dimension(:,:,:), allocatable    :: nnrec_omp, xkrec_omp, altrec_omp
    real, dimension(:,:), allocatable      :: lonrec_omp, latrec_omp
    integer, dimension(:,:), allocatable   :: timerec_omp
    real, dimension(:,:,:,:), allocatable  :: crec_omp, cunc_omp
    character(len=16), dimension(:,:), allocatable :: namerec_omp
    character(len=24), dimension(:,:), allocatable :: namesatrec_omp
    integer, dimension(:), allocatable     :: nr_omp
    real, parameter :: weightair=28.97
    integer, parameter :: unitoutrecdates=109
    logical :: lexist
    integer :: nthreads, thread, ithread


    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif

    if (mod(itime-lrecoutstart,lrecoutsample).eq.0) then
      if ((itime.eq.lrecoutstart).or.(itime.eq.lrecoutend)) then
        weight=0.5
      else
        weight=1.0
      endif
      call receptorcalc(itime,weight,lrecoutstart,lrecoutend,recoutnum,recoutnumsat)
    endif

    !! testing
    print*, 'receptor_mod: itime, lrecoutstart, lrecoutend = ',itime, lrecoutstart, lrecoutend

    if ((itime.eq.lrecoutend).and.(any(recoutnum.gt.0.).or.any(recoutnumsat.gt.0.))) then

      ! output receptor concentrations
      !*******************************

      if ((iout.le.3.).or.(iout.eq.5)) then

        ! Determine current date for output in dates_receptor file
        !**********************************************************

        jul=bdate+dble(float(itime))/86400.
        call caldate(jul,jjjjmmdd,ihmmss)
        write(adate,'(i8.8)') jjjjmmdd
        write(atime,'(i6.6)') ihmmss

        inquire(file=path(2)(1:length(2))//'dates_receptors',exist=lexist)
        if (.not.lexist) then
          ! initialize dates output file
          open(unitoutrecdates,file=path(2)(1:length(2))//'dates_receptors',STATUS='REPLACE')
          close(unitoutrecdates)
        endif
        open(unitoutrecdates,file=path(2)(1:length(2))//'dates_receptors', &
              ACCESS='APPEND', STATUS='OLD')
        write(unitoutrecdates,'(a)') adate//atime
        close(unitoutrecdates)

        ! For netcdf output open files and get variable info
        !***************************************************

        if (lnetcdfout.eq.1) then
#ifdef USE_NCF
          if (numreceptor.gt.0) then
            call receptor_output_netcdf()
          endif
          if (numsatreceptor.gt.0) then
            call satellite_output_netcdf()
          endif
#endif
        endif

        !! testing
!        print*, 'receptor_mod: concvar_id = ',concvar_id
!        print*, 'receptor_mod: satvar_id = ',satvar_id


        ! Initialize variables
        !*********************

#if (defined _OPENMP)
        nthreads=OMP_GET_MAX_THREADS()
#else
        nthreads=1
#endif

        !! testing
!        print*, 'receptor_mod: nthread = ',nthreads

        allocate(densityoutrecept(nlayermax))
        allocate(nnrec(maxrecsample,nlayermax),&
                 xkrec(maxrecsample,nlayermax),&
                 lonrec(maxrecsample),&
                 latrec(maxrecsample),&
                 altrec(maxrecsample,nlayermax),&
                 namerec(maxrecsample),&
                 namesatrec(maxrecsample),&
                 timerec(maxrecsample),&
                 crec(nspec,maxrecsample,nlayermax),&
                 cunc(nspec,maxrecsample,nlayermax))
        allocate(nnrec_omp(maxrecsample,nlayermax,nthreads),&
                 xkrec_omp(maxrecsample,nlayermax,nthreads),&
                 lonrec_omp(maxrecsample,nthreads),&
                 latrec_omp(maxrecsample,nthreads),&
                 altrec_omp(maxrecsample,nlayermax,nthreads),&
                 namerec_omp(maxrecsample,nthreads),&
                 namesatrec_omp(maxrecsample,nthreads),&
                 timerec_omp(maxrecsample,nthreads),&
                 crec_omp(nspec,maxrecsample,nlayermax,nthreads),&
                 cunc_omp(nspec,maxrecsample,nlayermax,nthreads))
        allocate(nr_omp(nthreads))
        nnrec(:,:)=0.
        xkrec(:,:)=0.
        crec(:,:,:)=0.
        cunc(:,:,:)=0.
        nnrec_omp(:,:,:)=0.
        xkrec_omp(:,:,:)=0.
        crec_omp(:,:,:,:)=0.
        cunc_omp(:,:,:,:)=0.
        nr_omp(:)=0

        ! Loop over general receptors
        !**************************** 
 
        write(*,fmt='(A,1X,I8,1X,A,1X,I3)') 'Number of receptors output at itime ',itime,'is',numcurrec

!$OMP PARALLEL &
!$OMP PRIVATE(n,k,nn,nr,ix,jy,ixp,jyp,ddx,ddy,rddx,rddy,p1,p2,p3,p4,indz,indzp,il,dz1,dz2,dz, &
!$OMP         ind,rho_p,rhoi,densityoutrecept,ks,thread) 

#if (defined _OPENMP)
        thread=OMP_GET_THREAD_NUM()+1 ! Starts with 1
#else
        thread=1
#endif

        nr=0
!$OMP DO
        do k=1,numcurrec

          if (cpointer(k).eq.0.) cycle

          ! number of the receptor
          n=cpointer(k)

          ! counter of receptor values this time interval
          nr=nr+1
          nr_omp(thread)=nr
          
          !! testing
!          print*, 'receptor_mod: n, thread, nr, cpointer(k), rpointer = ',n, thread, nr, cpointer(k), rpointer

          if (((.not.llcmoutput).and.(iout.eq.2)).or.&
              (llcmoutput.and.((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)))) then

            ! Compute air density
            !*********************

            ix=int(xreceptor(n))
            jy=int(yreceptor(n))
            ixp=ix+1
            jyp=jy+1
            ddx=xreceptor(n)-float(ix)
            ddy=yreceptor(n)-float(jy)
            rddx=1.-ddx
            rddy=1.-ddy
            p1=rddx*rddy
            p2=ddx*rddy
            p3=rddx*ddy
            p4=ddx*ddy

            indz=nzmax-1
            indzp=nzmax
            do il=2,nzmax
              if (height(il).gt.zreceptor(n)) then
                indz=il-1
                indzp=il
                exit
              endif
            end do

            dz1=zreceptor(n)-height(indz)
            dz2=height(indzp)-zreceptor(n)
            dz=1./(dz1+dz2)

            ! Take density from 2nd wind field in memory
            !********************************************

            do ind=indz,indzp
              ! assume moist air density
              rho_p(ind-indz+1)=p1*rho(ix ,jy ,ind,2) + &
                                p2*rho(ixp,jy ,ind,2) + &
                                p3*rho(ix ,jyp,ind,2) + &
                                p4*rho(ixp,jyp,ind,2)
              ! dry air density             
!              rho_p(ind-indz+1)= &
!                 p1*rho(ix ,jy ,ind,2)*(1. - qv(ix ,jy ,ind,2)) + &
!                 p2*rho(ixp,jy ,ind,2)*(1. - qv(ixp,jy ,ind,2)) + &
!                 p3*rho(ix ,jyp,ind,2)*(1. - qv(ix ,jyp,ind,2)) + &
!                 p4*rho(ixp,jyp,ind,2)*(1. - qv(ixp,jyp,ind,2))
            end do
            rhoi=(dz1*rho_p(2)+dz2*rho_p(1))*dz

            if (.not.llcmoutput) then
              densityoutrecept(1)=1./rhoi
            else
              densityoutrecept(1)=rhoi
            endif

          else 

            ! no multiplication or division by air density
            densityoutrecept(1)=1.

          endif ! llcmoutput

          ! Write receptor output
          !**********************
          ! llcmoutput = true: creceptor = m_spec/m_air
          ! llcmoutput = false: creceptor = m_spec/V                   

          if (recoutnum(k).gt.0.) then
            do ks = ks_start,nspec
              ! write mass concentration
              if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
                ! concentration (ng/m3)
                crec_omp(ks,nr,1,thread)=creceptor(ks,k)*1.E12*densityoutrecept(1)/recoutnum(k)
                cunc_omp(ks,nr,1,thread)=crecuncert(ks,k)*1.E12*densityoutrecept(1)/recoutnum(k)
              else if (iout.eq.2) then
                ! mixing ratio (ppt)
                ! note: for iout=3 (both conc and mixing ratio) only output conc at receptors
                crec_omp(ks,nr,1,thread)=creceptor(ks,k)*1.E12*densityoutrecept(1)* &
                              weightair/weightmolar(ks)/recoutnum(k)
                cunc_omp(ks,nr,1,thread)=crecuncert(ks,k)*1.E12*densityoutrecept(1)* &
                              weightair/weightmolar(ks)/recoutnum(k)
              endif
            end do
            nnrec_omp(nr,1,thread)=nnreceptor(k)/recoutnum(k)
            xkrec_omp(nr,1,thread)=xkreceptor(k)/recoutnum(k)
          else
            ! no particles found in kernel for this receptor
            crec_omp(:,nr,1,thread)=-999.
            cunc_omp(:,nr,1,thread)=-999.
            nnrec_omp(nr,1,thread)=-999.
            xkrec_omp(nr,1,thread)=-999.
          endif
          lonrec_omp(nr,thread)=xreceptor(n)*dx+xlon0
          latrec_omp(nr,thread)=yreceptor(n)*dy+ylat0
          altrec_omp(nr,1,thread)=zreceptor(n)
          if ( lrecregular ) then
            timerec_omp(nr,thread)=itime
          else
            timerec_omp(nr,thread)=treceptor(n)
          endif
          namerec_omp(nr,thread)=receptorname(n)

        end do ! numcurrec
!$OMP END DO
!$OMP END PARALLEL

        ! concatentate from all threads
        nr=1
        do ithread=1,nthreads
          !! testing
!          print*, 'receptor_mod: nr_omp(ithread) = ',nr_omp(ithread)
          if (nr_omp(ithread).eq.0) cycle
          crec(:,nr:(nr+nr_omp(ithread)-1),1)=crec_omp(:,1:nr_omp(ithread),1,ithread)
          cunc(:,nr:(nr+nr_omp(ithread)-1),1)=cunc_omp(:,1:nr_omp(ithread),1,ithread)
          nnrec(nr:(nr+nr_omp(ithread)-1),1)=nnrec_omp(1:nr_omp(ithread),1,ithread)
          xkrec(nr:(nr+nr_omp(ithread)-1),1)=xkrec_omp(1:nr_omp(ithread),1,ithread)
          lonrec(nr:(nr+nr_omp(ithread)-1))=lonrec_omp(1:nr_omp(ithread),ithread)
          latrec(nr:(nr+nr_omp(ithread)-1))=latrec_omp(1:nr_omp(ithread),ithread)
          altrec(nr:(nr+nr_omp(ithread)-1),1)=altrec_omp(1:nr_omp(ithread),1,ithread)
          timerec(nr:(nr+nr_omp(ithread)-1))=timerec_omp(1:nr_omp(ithread),ithread)
          namerec(nr:(nr+nr_omp(ithread)-1))=namerec_omp(1:nr_omp(ithread),ithread)
          nr=nr+nr_omp(ithread)
          !! testing
!          print*, 'receptor_mod: nr = ',nr
        end do

        ! total number of receptors to write this interval
        nr=nr-1

        ! write receptor output this time interval
        if (nr.gt.0) then
          if (lnetcdfout.eq.1) then
#if USE_NCF
            call write_receptor_netcdf(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namerec,nr)
#endif
          else
            call write_receptor_binary(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namerec,nr)
          endif
        endif
        ! advance output index
        rpointer=rpointer+nr
        
        !! testing
!        print*, 'receptor_mod: nr_omp = ',nr_omp
!        print*, 'receptor_mod: rpointer = ',rpointer

        ! Loop over satellites
        !*********************

        nnrec(:,:)=0.
        xkrec(:,:)=0.
        crec(:,:,:)=0.
        cunc(:,:,:)=0.
        nnrec_omp(:,:,:)=0.
        xkrec_omp(:,:,:)=0.
        crec_omp(:,:,:,:)=0.
        cunc_omp(:,:,:,:)=0.
        nr_omp(:)=0

        write(*,fmt='(A,1X,I8,1X,A,1X,I3)') 'Number of satellite receptors output at itime ',itime,'is',numcursat

!$OMP PARALLEL &
!$OMP PRIVATE(n,nr,nn,nchar,k,ix,jy,ixp,jyp,ddx,ddy,rddx,rddy,p1,p2,p3,p4,kz,numsatlayer,zmid,indz,indzp, &
!$OMP         il,dz1,dz2,dz,ind,rho_p,rhoi,densityoutrecept,ks,thread)

#if (defined _OPENMP)
        thread=OMP_GET_THREAD_NUM()+1 ! Starts with 1
#else
        thread=1
#endif

        nr=0
!$OMP DO
        do k=1,numcursat

          if (csatpointer(k).eq.0) cycle

          ! number of satellite receptor
          n=csatpointer(k)

          ! counter of receptor values this time interval
          nr=nr+1
          nr_omp(thread)=nr

          !! testing
!          print*, 'receptor_mod: n, thread, nr, csatpointer(k) = ',n, thread, nr, csatpointer(k)

          ! get actual number vertical layers for this retrieval
          do nn=1,numsatellite
            nchar=len_trim(sat_name(nn))
            if (satellitename(n)(1:nchar).eq.trim(sat_name(nn))) then
              numsatlayer=nnsatlayer(nn)
              exit
            endif
          end do

          if (.not.llcmoutput) then

            ! Compute air density
            !*********************

            ix=int(xsatellite(n))
            jy=int(ysatellite(n))
            ixp=ix+1
            jyp=jy+1
            ddx=xsatellite(n)-float(ix)
            ddy=ysatellite(n)-float(jy)
            rddx=1.-ddx
            rddy=1.-ddy
            p1=rddx*rddy
            p2=ddx*rddy
            p3=rddx*ddy
            p4=ddx*ddy

            do kz=1,numsatlayer
  
              zmid=0.5*(zsatellite(kz,n)+zsatellite(kz+1,n))
              indz=nzmax-1
              indzp=nzmax
              do il=2,nzmax
                if (height(il).gt.zmid) then
                  indz=il-1
                  indzp=il
                  exit
                endif
              end do

              dz1=zmid-height(indz)
              dz2=height(indzp)-zmid
              dz=1./(dz1+dz2)

              ! Take density from 2nd wind field in memory
              !********************************************

              do ind=indz,indzp
                ! assume moist air density
                rho_p(ind-indz+1)=p1*rho(ix ,jy ,ind,2) + &
                                  p2*rho(ixp,jy ,ind,2) + &
                                  p3*rho(ix ,jyp,ind,2) + &
                                  p4*rho(ixp,jyp,ind,2)
                ! dry air density             
!                rho_p(ind-indz+1)= &
!                   p1*rho(ix ,jy ,ind,2)*(1. - qv(ix ,jy ,ind,2)) + &
!                   p2*rho(ixp,jy ,ind,2)*(1. - qv(ixp,jy ,ind,2)) + &
!                   p3*rho(ix ,jyp,ind,2)*(1. - qv(ix ,jyp,ind,2)) + &
!                   p4*rho(ixp,jyp,ind,2)*(1. - qv(ixp,jyp,ind,2))
              end do
              rhoi=(dz1*rho_p(2)+dz2*rho_p(1))*dz
              densityoutrecept(kz)=1./rhoi
 
            end do ! numsatlayer  

          else

            ! no normalization by density
            densityoutrecept(:)=1.

          endif ! llcmoutput

          ! Write receptor output
          !**********************

          do kz=1,numsatlayer
            if (recoutnumsat(kz,k).gt.0.) then
              do ks = ks_start,nspec
                ! only mixing ratio (ppt) for satellites
                crec_omp(ks,nr,kz,thread)=csatellite(ks,kz,k)*1.E12*densityoutrecept(kz)* &
                              weightair/weightmolar(ks)/recoutnumsat(kz,k)
                cunc_omp(ks,nr,kz,thread)=csatuncert(ks,kz,k)*1.E12*densityoutrecept(kz)* &
                              weightair/weightmolar(ks)/recoutnumsat(kz,k)
              end do
              nnrec_omp(nr,kz,thread)=nnsatellite(kz,k)/recoutnumsat(kz,k)
              xkrec_omp(nr,kz,thread)=xksatellite(kz,k)/recoutnumsat(kz,k)
            else
              crec_omp(:,nr,kz,thread)=-999.
              cunc_omp(:,nr,kz,thread)=-999.
              nnrec_omp(nr,kz,thread)=-999.
              xkrec_omp(nr,kz,thread)=-999.
            endif
          end do
          lonrec_omp(nr,thread)=xsatellite(n)*dx+xlon0
          latrec_omp(nr,thread)=ysatellite(n)*dy+ylat0
          altrec_omp(nr,:,thread)=zsatellite(:,n)
          timerec_omp(nr,thread)=tsatellite(n)
          namesatrec_omp(nr,thread)=satellitename(n)

        end do ! numcursat
!$OMP END DO
!$OMP END PARALLEL

        ! concatentate from all threads
        nr=1
        do ithread=1,nthreads
          !! testing
!          print*, 'receptor_mod: satellites, nr_omp(ithread) = ',nr_omp(ithread)
          if (nr_omp(ithread).eq.0) cycle
          crec(:,nr:nr+nr_omp(ithread)-1,:)=crec_omp(:,1:nr_omp(ithread),:,ithread)
          cunc(:,nr:nr+nr_omp(ithread)-1,:)=cunc_omp(:,1:nr_omp(ithread),:,ithread)
          nnrec(nr:nr+nr_omp(ithread)-1,:)=nnrec_omp(1:nr_omp(ithread),:,ithread)
          xkrec(nr:nr+nr_omp(ithread)-1,:)=xkrec_omp(1:nr_omp(ithread),:,ithread)
          lonrec(nr:nr+nr_omp(ithread)-1)=lonrec_omp(1:nr_omp(ithread),ithread)
          latrec(nr:nr+nr_omp(ithread)-1)=latrec_omp(1:nr_omp(ithread),ithread)
          altrec(nr:nr+nr_omp(ithread)-1,:)=altrec_omp(1:nr_omp(ithread),:,ithread)
          timerec(nr:nr+nr_omp(ithread)-1)=timerec_omp(1:nr_omp(ithread),ithread)
          namesatrec(nr:nr+nr_omp(ithread)-1)=namesatrec_omp(1:nr_omp(ithread),ithread)
          nr=nr+nr_omp(ithread)
          !! testing
!          print*, 'receptor_mod: satellites, nr = ',nr
        end do

        ! total number of receptors to write this interval
        nr=nr-1

        ! write satellite output this time interval
        if (nr.gt.0) then
          if (lnetcdfout.eq.1) then
#if USE_NCF
            call write_satellite_netcdf(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namesatrec,nr)
#endif  
          else
            call write_satellite_binary(crec,cunc,nnrec,xkrec,lonrec,latrec,altrec,timerec,namesatrec,nr)
          endif
        endif
        ! advance output index
        spointer=spointer+nr

        !! testing
        print*, 'receptor_mod: satellites, nr = ',nr
        print*, 'receptor_mod: spointer = ',spointer

        ! close files
        if (lnetcdfout.eq.1) then
#ifdef USE_NCF
          if (numreceptor.gt.0) then
            call close_receptor_netcdf
          endif
          if (numsatreceptor.gt.0) then
            call close_satellite_netcdf
          endif
#endif
        endif

        deallocate(densityoutrecept)
        deallocate(crec,cunc,nnrec,xkrec)
        deallocate(crec_omp,cunc_omp,nnrec_omp,xkrec_omp)
        deallocate(lonrec,latrec,altrec,timerec,namerec,namesatrec)
        deallocate(lonrec_omp,latrec_omp,altrec_omp,timerec_omp,namesatrec_omp)
        deallocate(nr_omp)

        ! End of receptor output
        !***********************

        recoutnum(:)=0.
        recoutnumsat(:,:)=0.

      endif ! output receptor conc

    endif ! receptor output

    if (itime.eq.lrecoutend) then

      ! Reinitialize
      !*************
 
      creceptor(:,:)=0.
      crecuncert(:,:)=0.
      nnreceptor(:)=0.
      xkreceptor(:)=0.
      if (numsatellite.gt.0) then
        csatellite(:,:,:)=0.
        csatuncert(:,:,:)=0.
        nnsatellite(:,:)=0.
        xksatellite(:,:)=0.
      endif

      recoutnum(:)=0.
      recoutnumsat(:,:)=0.

      ! Update output timesteps
      !************************
      lrecoutnext=lrecoutnext+lrecoutstep
      lrecoutstart=lrecoutnext-lrecoutaver/2
      lrecoutend=lrecoutnext+lrecoutaver/2

      if (itime.eq.lrecoutstart) then
        weight=0.5
        call receptorcalc(itime,weight,lrecoutstart,lrecoutend,recoutnum,recoutnumsat)
      endif

    endif 

  end subroutine receptoroutput


  subroutine receptorcalc(itime,weight,lrecoutstart,lrecoutend,recoutnum,recoutnumsat)

  !*****************************************************************************
  !                                                                            *
  !     Calculation of the concentrations at receptor points using the         *
  !     kernel method                                                          *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     Modifications:                                                         * 
  !       Sep-2023, R. Thompson: added option for domain filling mode          *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer :: itime, itage, lrecoutstart, lrecoutend
    real, dimension(maxrecsample) :: recoutnum
    real, dimension(nlayermax,maxrecsample) :: recoutnumsat
    real    :: weight
    real    :: xd, yd, zd, hx, hy, hz, h, r2, xkern
    real, dimension(nspec) :: conc 
    real, dimension(:,:), allocatable :: unc 
    integer :: n, j, k, ks, kz, i, nn, ks_start, nchar, numsatlayer
    real    :: hxmax, hymax, hzmax, hxsat, hysat, rec_ff, xksum, eta, zmid
    real, parameter :: factor=.596831  ! 15/(8*pi)
    real, parameter :: zref=2000.      ! normalizing height for calculating eta
    integer, parameter :: jmax=4000    ! max number of particles in kernel

    ! initialization
    !***************

    if (llcmoutput) then
      ks_start=2
    else
      ks_start=1
    endif
    allocate(unc(nspec,jmax))

    ! hxmax and hymax in degrees, hzmax in metres
    !********************************************

    if (mdomainfill.ne.1) then
      hxmax=6.0
      hymax=4.0
      hzmax=150.
    else
      hxmax=2.0
      hymax=1.5
      hzmax=300.
      hxsat=1.75
      hysat=1.25
    endif

    ! convert h-values to grid coordinates
    !*************************************

    hxmax=hxmax/dx
    hymax=hymax/dy
    hxsat=hxsat/dx
    hysat=hysat/dy

    ! Loop over receptors
    !********************

    ! pointer for creceptor, xkreceptor and nnreceptor
    numcurrec=0
    cpointer(:)=0
    k=0

    do n=1,numreceptor

      if ((.not.lrecregular).and.((treceptor(n).lt.lrecoutstart).or. &
           (treceptor(n).ge.lrecoutend))) cycle  ! skip if not in current sampling time interval

      ! update pointer
      k=k+1
      if (k.gt.maxrecsample) then
        write(*,*) 'FLEXPART ERROR in receptorcalc: maxrecsample too small'
        error stop
      endif
      cpointer(k)=n

      !! testing
!      print*, 'receptorcalc: n, receptorname(n) = ',n, receptorname(n)

      ! Reset concentrations for new receptor
      conc(:)=0.
      unc(:,:)=0.
      xksum=0.
      j=0

      if (zreceptor(n).lt.hzmax) then
        rec_ff=0.5 + 0.9375*(zreceptor(n)/hzmax) - &
                 0.625*(zreceptor(n)/hzmax)**3 + &
                 0.1875*(zreceptor(n)/hzmax)**5
        rec_ff=1./rec_ff
      else
        rec_ff=1.
      endif
      h=hxmax*hymax*hzmax

      !! testing
!      print*, 'receptorcalc: rec_ff = ',rec_ff

      ! Estimate concentration at receptor
      !***********************************

!$OMP PARALLEL &
!$OMP PRIVATE(i,itage,hz,zd,hx,xd,hy,yd,h,r2,xkern,ks) &
!$OMP SHARED(j,unc,conc) &
!$OMP REDUCTION(+:xksum,xkreceptor,nnreceptor)

!$OMP DO
      do i=1,count%alive

        if (mdomainfill.ne.1) then

          ! not domain filling run so consider age of particle
          itage=abs(itime-part(i)%tstart)

          hz=min(50.+0.3*sqrt(real(itage)),hzmax)
          zd=part(i)%z/hz
          if (zd.gt.1.) cycle           ! save computing time

          hx=min((0.29+2.222e-3*sqrt(real(itage)))*dx+ &
               real(itage)*1.2e-5,hxmax)                     ! 80 km/day
          xd=(part(i)%xlon-xreceptor(n))/hx
          if (xd*xd.gt.1.) cycle        ! save computing time

          hy=min((0.18+1.389e-3*sqrt(real(itage)))*dy+ &
               real(itage)*7.5e-6,hymax)                     ! 80 km/day
          yd=(part(i)%ylat-yreceptor(n))/hy
          if (yd*yd.gt.1.) cycle        ! save computing time
          h=hx*hy*hz

          r2=xd*xd+yd*yd+zd*zd
          if (r2.ge.1.) cycle           ! save computing time
          xkern=2.*factor*(1.-r2)       ! parabolic kernel

        else

          ! domain filling run 
          xd=(part(i)%xlon-xreceptor(n))/hxmax
          if (xd*xd.gt.1) cycle         ! save computing time

          yd=(part(i)%ylat-yreceptor(n))/hymax
          if (yd*yd.gt.1.) cycle        ! save computing time

          zd=(part(i)%z-zreceptor(n))/hzmax
          if (zd*zd.gt.1.) cycle        ! save computing time

          r2=xd*xd+yd*yd+zd*zd
          if (r2.ge.1.) cycle           ! save computing time
          xkern=rec_ff*factor*(1.-r2)   ! parabolic kernel

        endif ! mdomainfill

        ! counter of particles used in conc calculation
        ! note: use of atomic may not be efficient, alternative split unc, j over threads
        ! and combine all threads after end of parallel section, need to save j from each thread
!$OMP ATOMIC
        j=j+1
        if (j.gt.jmax) then
          write(*,*) 'FLEXPART ERROR in receptorcalc: size of jmax too small'
          error stop
        endif

        do ks=ks_start,nspec
          if (llcmoutput) then
            ! special case LCM output use mass ratio species to airtracer
            ! species 1 is always airtracer
            conc(ks)=conc(ks) + mass(i,ks)/mass(i,1) * &
                      weight * xkern
            unc(ks,j)=mass(i,ks)/mass(i,1)
          else
            ! normal case
            conc(ks)=conc(ks) + mass(i,ks) * &
                       weight * xkern/h/receptorarea(n)
            unc(ks,j)=mass(i,ks)/h/receptorarea(n)
          endif
        end do
        nnreceptor(k)=nnreceptor(k) + 1.
        xkreceptor(k)=xkreceptor(k) + xkern
        xksum=xksum + xkern

      end do ! count%alive
!$OMP END DO
!$OMP END PARALLEL

!$OMP PARALLEL IF(nspec>99) PRIVATE(ks)
!$OMP DO
      do ks=ks_start,nspec
        if (conc(ks).gt.0.) then
          ! only do if conc could be calculated for this receptor at this time
          creceptor(ks,k)=creceptor(ks,k) + conc(ks)/xksum
          crecuncert(ks,k)=crecuncert(ks,k) + &
                               sqrt(sum((unc(ks,1:j)-conc(ks)/xksum/weight)**2)/real(j))
        endif
      end do
!$OMP END DO
!$OMP END PARALLEL
      if (any(conc(:).gt.0.)) then
        recoutnum(k)=recoutnum(k)+weight
      endif

      ! update number receptors this time interval
      numcurrec=k

      !! testing
!      print*, 'receptorcalc: j, conc, xksum = ',j, conc(2), xksum
!      print*, 'receptorcalc: n, k, cpointer(k) = ',n, k, cpointer(k)
!      print*, 'receptorcalc: nnreceptor(k) = ',nnreceptor(k)
!      print*, 'receptorcalc: xkreceptor(k) = ',xkreceptor(k)
!      print*, 'receptorcalc: creceptor(2,k) = ',creceptor(2,k)
!      print*, 'receptorcalc: crecuncert(2,k) = ',crecuncert(2,k)

    end do ! numreceptor

    ! Loop over satellites
    !*********************

    ! pointer for csatellite, xksatellite and nnsatellite
    numcursat=0
    csatpointer(:)=0
    k=0

    do n=1,numsatreceptor

      if ((tsatellite(n).lt.lrecoutstart).or. &
           (tsatellite(n).ge.lrecoutend)) cycle  ! skip if not in current sampling time interval
   
       !! testing
!       print*, 'receptorcalc: lrecoutstart, lrecoutend, tsatellite(n) = ',lrecoutstart, lrecoutend, tsatellite(n)

      ! update pointer
      k=k+1
      if (k.gt.maxrecsample) then
        write(*,*) 'FLEXPART ERROR in receptorcalc: maxrecsample too small'
        error stop
      endif
      csatpointer(k)=n

      ! get actual number vertical layers for this retrieval
      do nn=1,numsatellite
        nchar=len_trim(sat_name(nn))
        if (satellitename(n)(1:nchar).eq.trim(sat_name(nn))) then
          numsatlayer=nnsatlayer(nn)
          exit
        endif
      end do

      !! testing
!      print*, 'receptorcalc: n, satellitename(n) = ',n, satellitename(n)

      do kz=1,numsatlayer

        ! Reset concentrations for new receptor
        conc(:)=0.
        unc(:,:)=0.
        xksum=0.
        j=0

        ! height of layer
        hz=zsatellite(kz+1,n)-zsatellite(kz,n)

        ! rare cases when 2 satellite pressure layers fall in same meteo layer
        ! set minimum height between layers 
        hz=max(200.,hz)

        ! midpoint of layer
        zmid=zsatellite(kz,n)+0.5*hz

        ! factor by which to expand horizontal threshhold
        ! as expect particle density to decrease with altitude
        eta=max(1.,sqrt(0.5*zmid/zref))

        h=hxsat*hysat*(0.5*hz)

        !! testing
!        print*, 'zmid, hz, eta =',zmid, hz, eta

!$OMP PARALLEL &
!$OMP PRIVATE(i,zd,xd,yd,r2,xkern,ks) &
!$OMP SHARED(j,unc,conc) &
!$OMP REDUCTION(+:xksum,xksatellite,nnsatellite)

!$OMP DO
        do i=1,count%alive

          ! sample satellite retrievals for domain-filling and 
          ! non-domain-filling modes in the same way

          zd=(part(i)%z-zmid)/(0.5*hz)
          if (zd*zd.gt.1.) cycle        ! save computing time

          xd=(part(i)%xlon-xsatellite(n))/(eta*hxsat)
          if (xd*xd.gt.1) cycle         ! save computing time

          yd=(part(i)%ylat-ysatellite(n))/(eta*hysat)
          if (yd*yd.gt.1.) cycle        ! save computing time

          r2=xd*xd+yd*yd+zd*zd
          if (r2.ge.1.) cycle           ! save computing time

          xkern=factor*(1.-r2)          ! parabolic kernel

          ! counter of particles used in conc calculation
!$OMP ATOMIC
          j=j+1
          if (j.gt.jmax) then
            write(*,*) 'FLEXPART ERROR in receptorcalc: size of jmax too small'
            error stop
          endif

          do ks=ks_start,nspec
            if (llcmoutput) then
              ! special case LCM output use mass ratio species to airtracer
              ! species 1 is always airtracer
              conc(ks)=conc(ks) + mass(i,ks)/mass(i,1) * &
                        weight * xkern
              unc(ks,j)=mass(i,ks)/mass(i,1)
            else
              ! normal case
              conc(ks)=conc(ks) + mass(i,ks) * &
                         weight * xkern/h/satellitearea(n)
              unc(ks,j)=mass(i,ks)/h/satellitearea(n)
            endif
          end do
          nnsatellite(kz,k)=nnsatellite(kz,k) + 1.
          xksatellite(kz,k)=xksatellite(kz,k) + xkern
          xksum=xksum + xkern

        end do ! count%alive
!$OMP END DO
!$OMP END PARALLEL

!$OMP PARALLEL IF(nspec>99) PRIVATE(ks)
!$OMP DO
        do ks=ks_start,nspec
          if (conc(ks).gt.0.) then
            ! only do if conc could be calculated for this receptor and time
            csatellite(ks,kz,k)=csatellite(ks,kz,k) + conc(ks)/xksum
            csatuncert(ks,kz,k)=csatuncert(ks,kz,k) + &
                                 sqrt(sum((unc(ks,1:j)-conc(ks)/xksum/weight)**2)/real(j))
          endif
        end do
!$OMP END DO
!$OMP END PARALLEL
        if (any(conc(:).gt.0.)) then
          recoutnumsat(kz,k)=recoutnumsat(kz,k)+weight
        endif

        !! testing
!        print*, 'receptorcalc: for satellite: j, conc, xksum = ',j, conc(2), xksum
!        print*, 'receptorcalc: n, k, csatpointer(k) = ',n, k, csatpointer(k)
!        print*, 'receptorcalc: nnsatellite(:,k) = ',nnsatellite(:,k)
!        print*, 'receptorcalc: xksatellite(:,k) = ',xksatellite(:,k)

      end do ! numsatlayer

      ! update current number of satellite receptors this time interval
      numcursat=k

    end do ! numsatreceptor

  end subroutine receptorcalc


end module receptor_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine calcpar_nests(n,uuhn,vvhn,pvhn)
  !                         i  i    i    o
  !*****************************************************************************
  !                                                                            *
  !     Computation of several boundary layer parameters needed for the        *
  !     dispersion calculation and calculation of dry deposition velocities.   *
  !     All parameters are calculated over the entire grid.                    *
  !     This routine is similar to calcpar, but is used for the nested grids.  *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     8 February 1999                                                        *
  !                                                                            *
  ! ------------------------------------------------------------------         *
  !     Petra Seibert, Feb 2000:                                               *
  !     convection scheme:                                                     *
  !     new variables in call to richardson                                    *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:
  !   Variables tth and qvh (on eta coordinates) in common block
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! n                  temporal index for meteorological fields (1 to 3)       *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !                                                                            *
  ! Functions:                                                                 *
  ! scalev             computation of ustar                                    *
  ! obukhov            computatio of Obukhov length                            *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: n,ix,jy,i,l,kz,lz,kzmin
  real :: ttlev(nuvzmax),qvlev(nuvzmax),obukhov,scalev,ol,hmixplus
  real :: ulev(nuvzmax),vlev(nuvzmax),ew,rh,vd(maxspec),subsceff,ylat
  real :: altmin,tvold,pold,zold,pint,tv,zlev(nuvzmax)
  real :: uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: pvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real,parameter :: const=r_air/ga


  ! Loop over all nests
  !********************

  do l=1,numbnests

  ! Loop over entire grid
  !**********************

  do jy=0,nyn(l)-1

  ! Set minimum height for tropopause
  !**********************************

    ylat=ylat0n(l)+real(jy)*dyn(l)
    if ((ylat.ge.-20.).and.(ylat.le.20.)) then
      altmin = 5000.
    else
      if ((ylat.gt.20.).and.(ylat.lt.40.)) then
        altmin=2500.+(40.-ylat)*125.
      else if ((ylat.gt.-40.).and.(ylat.lt.-20.)) then
        altmin=2500.+(40.+ylat)*125.
      else
        altmin=2500.
      endif
    endif

    do ix=0,nxn(l)-1

  ! 1) Calculation of friction velocity
  !************************************

      ustarn(ix,jy,1,n,l)=scalev(psn(ix,jy,1,n,l),tt2n(ix,jy,1,n,l), &
           td2n(ix,jy,1,n,l),surfstrn(ix,jy,1,n,l))

  ! 2) Calculation of inverse Obukhov length scale
  !***********************************************

      ol=obukhov(psn(ix,jy,1,n,l),tt2n(ix,jy,1,n,l), &
           td2n(ix,jy,1,n,l),tthn(ix,jy,2,n,l),ustarn(ix,jy,1,n,l), &
           sshfn(ix,jy,1,n,l),akm,bkm)
      if (ol.ne.0.) then
        olin(ix,jy,1,n,l)=1./ol
      else
        olin(ix,jy,1,n,l)=99999.
      endif


  ! 3) Calculation of convective velocity scale and mixing height
  !**************************************************************

      do i=1,nuvz
        ulev(i)=uuhn(ix,jy,i,l)
        vlev(i)=vvhn(ix,jy,i,l)
        ttlev(i)=tthn(ix,jy,i,n,l)
        qvlev(i)=qvhn(ix,jy,i,n,l)
      end do

      call richardson(psn(ix,jy,1,n,l),ustarn(ix,jy,1,n,l),ttlev, &
           qvlev,ulev,vlev,nuvz,akz,bkz,sshfn(ix,jy,1,n,l), &
           tt2n(ix,jy,1,n,l),td2n(ix,jy,1,n,l),hmixn(ix,jy,1,n,l), &
           wstarn(ix,jy,1,n,l),hmixplus)

      if(lsubgrid.eq.1) then
        subsceff=min(excessoron(ix,jy,l),hmixplus)
      else
        subsceff=0
      endif
  !
  ! CALCULATE HMIX EXCESS ACCORDING TO SUBGRIDSCALE VARIABILITY AND STABILITY
  !
      hmixn(ix,jy,1,n,l)=hmixn(ix,jy,1,n,l)+subsceff
      hmixn(ix,jy,1,n,l)=max(hmixmin,hmixn(ix,jy,1,n,l)) ! minim PBL height
      hmixn(ix,jy,1,n,l)=min(hmixmax,hmixn(ix,jy,1,n,l)) ! maxim PBL height


  ! 4) Calculation of dry deposition velocities
  !********************************************

      if (DRYDEP) then
        z0(4)=0.016*ustarn(ix,jy,1,n,l)*ustarn(ix,jy,1,n,l)/ga
        z0(9)=0.016*ustarn(ix,jy,1,n,l)*ustarn(ix,jy,1,n,l)/ga

  ! Calculate relative humidity at surface
  !***************************************
        rh=ew(td2n(ix,jy,1,n,l))/ew(tt2n(ix,jy,1,n,l))

        call getvdep_nests(n,ix,jy,ustarn(ix,jy,1,n,l), &
             tt2n(ix,jy,1,n,l),psn(ix,jy,1,n,l),1./olin(ix,jy,1,n,l), &
             ssrn(ix,jy,1,n,l),rh,lsprecn(ix,jy,1,n,l)+ &
             convprecn(ix,jy,1,n,l),sdn(ix,jy,1,n,l),vd,l)

        do i=1,nspec
          vdepn(ix,jy,i,n,l)=vd(i)
        end do

      endif

  !******************************************************
  ! Calculate height of thermal tropopause (Hoinka, 1997)
  !******************************************************

  ! 1) Calculate altitudes of ECMWF model levels
  !*********************************************

      tvold=tt2n(ix,jy,1,n,l)*(1.+0.378*ew(td2n(ix,jy,1,n,l))/ &
           psn(ix,jy,1,n,l))
      pold=psn(ix,jy,1,n,l)
      zold=0.
      do kz=2,nuvz
        pint=akz(kz)+bkz(kz)*psn(ix,jy,1,n,l)  ! pressure on model layers
        tv=tthn(ix,jy,kz,n,l)*(1.+0.608*qvhn(ix,jy,kz,n,l))

        if (abs(tv-tvold).gt.0.2) then
         zlev(kz)=zold+const*log(pold/pint)*(tv-tvold)/log(tv/tvold)
        else
          zlev(kz)=zold+const*log(pold/pint)*tv
        endif
        tvold=tv
        pold=pint
        zold=zlev(kz)
      end do

  ! 2) Define a minimum level kzmin, from which upward the tropopause is
  !    searched for. This is to avoid inversions in the lower troposphere
  !    to be identified as the tropopause
  !************************************************************************

      do kz=1,nuvz
        if (zlev(kz).ge.altmin) then
          kzmin=kz
          goto 45
        endif
      end do
45    continue

  ! 3) Search for first stable layer above minimum height that fulfills the
  !    thermal tropopause criterion
  !************************************************************************

      do kz=kzmin,nuvz
        do lz=kz+1,nuvz
          if ((zlev(lz)-zlev(kz)).gt.2000.) then
            if (((tthn(ix,jy,kz,n,l)-tthn(ix,jy,lz,n,l))/ &
                 (zlev(lz)-zlev(kz))).lt.0.002) then
              tropopausen(ix,jy,1,n,l)=zlev(kz)
              goto 51
            endif
            goto 50
          endif
        end do
50      continue
      end do
51    continue


    end do
  end do


    call calcpv_nests(l,n,uuhn,vvhn,pvhn)

  end do


end subroutine calcpar_nests

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module point_mod

  implicit none

  integer, allocatable, dimension (:) :: ireleasestart
  integer, allocatable, dimension (:) :: ireleaseend
  integer, allocatable, dimension (:) :: npart
  integer*2, allocatable, dimension (:) :: kindz

  real,allocatable, dimension (:) :: xpoint1
  real,allocatable, dimension (:) :: xpoint2
  real,allocatable, dimension (:) :: ypoint1
  real,allocatable, dimension (:) :: ypoint2
  real,allocatable, dimension (:) :: zpoint1
  real,allocatable, dimension (:) :: zpoint2

  real,allocatable, dimension (:,:) :: xmass
  real,allocatable, dimension (:) :: rho_rel

  real ::      &
    dx,        & ! grid distance in x direction
    dy,        & ! grid distance in y direction
    xlon0,     & ! geographical longitude and
    ylat0        ! geographical latitude of lower left grid point

contains

subroutine coordtrafo(nxmin1,nymin1)

  !**********************************************************************
  !                                                                     *
  !             FLEXPART MODEL SUBROUTINE COORDTRAFO                    *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  !             AUTHOR:      G. WOTAWA                                  *
  !             DATE:        1994-02-07                                 *
  !             LAST UPDATE: 1996-05-18   A. STOHL                      *
  !                                                                     *
  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION: This subroutine transforms x and y coordinates of      *
  ! particle release points to grid coordinates.                        *
  !                                                                     *
  !**********************************************************************

  use par_mod
  use com_mod

  implicit none
  integer,intent(in) ::   &
    nxmin1,               & ! nx-1
    nymin1                  ! ny-1
  integer :: i,j,k
  real :: yrspc ! small real number relative to x

  if((ipin.eq.3).or.(ipin.eq.4)) return ! Not necessary when using part_ic.nc
  
  if(numpoint.eq.0) then
    write(*,*) ' FLEXPART MODEL SUBROUTINE COORDTRAFO: ERROR ! '
    write(*,*) ' NO PARTICLE RELEASES ARE DEFINED!'
    write(*,*) ' CHECK FILE RELEASES...'
    error stop
  endif

  ! TRANSFORM X- AND Y- COORDINATES OF STARTING POINTS TO GRID COORDINATES
  !***********************************************************************

  do i=1,numpoint
    xpoint1(i)=(xpoint1(i)-xlon0)/dx
    xpoint2(i)=(xpoint2(i)-xlon0)/dx
    ypoint1(i)=(ypoint1(i)-ylat0)/dy
    ypoint2(i)=(ypoint2(i)-ylat0)/dy
  end do

15   continue


  ! CHECK IF RELEASE POINTS ARE WITHIN DOMAIN
  !******************************************
  
  yrspc = spacing(real(nymin1,kind=sp))
  
  do i=1,numpoint
    if (sglobal.and.(ypoint1(i).lt.1.e-6)) ypoint1(i)=1.e-6
    if (nglobal.and.(ypoint2(i).gt.real(nymin1,kind=dp)-1.e-5)) &
         ypoint2(i)=real(nymin1,kind=dp)-10.*yrspc
    if ((ypoint1(i).lt.1.e-6).or.(ypoint1(i).ge.real(nymin1,kind=dp)-1.e-6) &
       .or.(ypoint2(i).lt.1.e-6).or.(ypoint2(i).ge.real(nymin1,kind=dp)-yrspc) &
       .or.((.not.xglobal).and.((xpoint1(i).lt.1.e-6).or. &
       (xpoint1(i).ge.real(nxmin1,kind=dp)-1.e-6).or.(xpoint2(i).lt.1.e-6).or. &
       (xpoint2(i).ge.real(nxmin1,kind=dp)-1.e-6)))) then
      write(*,*) ' NOTICE: RELEASE POINT OUT OF DOMAIN DETECTED.'
      write(*,*) ' IT IS REMOVED NOW ... '
      if (i.le.1000) then
         write(*,*) ' COMMENT: ',compoint(i)
      else
         write(*,*) ' COMMENT: ',compoint(1001)
      endif
      if (i.lt.numpoint) then
        do j=i+1,numpoint
          xpoint1(j-1)=xpoint1(j)
          ypoint1(j-1)=ypoint1(j)
          xpoint2(j-1)=xpoint2(j)
          ypoint2(j-1)=ypoint2(j)
          zpoint1(j-1)=zpoint1(j)
          zpoint2(j-1)=zpoint2(j)
          npart(j-1)=npart(j)
          kindz(j-1)=kindz(j)
          ireleasestart(j-1)=ireleasestart(j)
          ireleaseend(j-1)=ireleaseend(j)
          if (j.le.1000) compoint(j-1)=compoint(j)
          do k=1,nspec
            xmass(j-1,k)=xmass(j,k)
          end do
        end do
      endif

      numpoint=numpoint-1
      if (numpoint.gt.0) goto 15
    endif
  end do

  if(numpoint.eq.0) then
    write(*,*) ' FLEXPART MODEL SUBROUTINE COORDTRAFO: ERROR ! '
    write(*,*) ' NO PARTICLE RELEASES ARE DEFINED!'
    write(*,*) ' CHECK FILE RELEASES...'
    error stop
  endif
end subroutine coordtrafo

end module point_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

!*******************************************************************************
!   Include file for calculation of particle trajectories (Program FLEXPART)   *
!        This file contains the parameter statements used in FLEXPART          *
!                                                                              *
!        Author: A. Stohl                                                      *
!                                                                              *
!        1997                                                                  *
!                                                                              *
!        Last update 10 August 2000                                            *
!                                                                              *
!*******************************************************************************

module par_mod

  implicit none

  !****************************************************************
  ! Parameter defining KIND parameter for "double precision"
  !****************************************************************

  integer,parameter :: dp=selected_real_kind(P=15)


  !***********************************************************
  ! Number of directories/files used for FLEXPART input/output
  !***********************************************************

  integer,parameter :: numpath=4

  ! numpath                 Number of different pathnames for input/output files


  !*****************************
  ! Physical and other constants
  !*****************************

  real,parameter :: pi=3.14159265, r_earth=6.371e6, r_air=287.05, ga=9.81
  real,parameter :: cpa=1004.6, kappa=0.286, pi180=pi/180., vonkarman=0.4

  ! pi                      number "pi"
  ! pi180                   pi/180.
  ! r_earth                 radius of earth [m]
  ! r_air                   individual gas constant for dry air [J/kg/K]
  ! ga                      gravity acceleration of earth [m/s**2]
  ! cpa                     specific heat for dry air
  ! kappa                   exponent of formula for potential temperature
  ! vonkarman               von Karman constant

  real,parameter :: karman=0.40, href=15., convke=2.0
  real,parameter :: hmixmin=100., hmixmax=4500., turbmesoscale=0.16
  real,parameter :: d_trop=50., d_strat=0.1

  ! karman                  Karman's constant
  ! href [m]                Reference height for dry deposition
  ! konvke                  Relative share of kinetic energy used for parcel lifting
  ! hmixmin,hmixmax         Minimum and maximum allowed PBL height
  ! turbmesoscale           the factor by which standard deviations of winds at grid
  !                    points surrounding the particle positions are scaled to
  !                    yield the scales for the mesoscale wind velocity fluctuations
  ! d_trop [m2/s]           Turbulent diffusivity for horizontal components in the troposphere
  ! d_strat [m2/s]          Turbulent diffusivity for vertical component in the stratosphere

  real,parameter :: xmwml=18.016/28.960

  ! xmwml   ratio of molar weights of water vapor and dry air
  !****************************************************
  ! Constants related to the stratospheric ozone tracer
  !****************************************************

  real,parameter :: ozonescale=60., pvcrit=2.0

  ! ozonescale              ppbv O3 per PV unit
  ! pvcrit                  PV level of the tropopause



  !********************
  ! Some time constants
  !********************

  integer,parameter :: idiffnorm=10800, idiffmax=2*idiffnorm, minstep=1

  ! idiffnorm [s]           normal time interval between two wind fields
  ! idiffmax [s]            maximum time interval between two wind fields
  ! minstep [s]             minimum time step to be used within FLEXPART


  !*****************************************************************
  ! Parameters for polar stereographic projection close to the poles
  !*****************************************************************

  real,parameter :: switchnorth=75., switchsouth=-75.

  ! switchnorth    use polar stereographic grid north of switchnorth
  ! switchsouth    use polar stereographic grid south of switchsouth


  !*********************************************
  ! Maximum dimensions of the input mother grids
  !*********************************************

  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92
  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=61,nwzmax=61,nzmax=61
  integer,parameter :: nxmax=721,nymax=361,nuvzmax=64,nwzmax=64,nzmax=64
  !integer,parameter :: nxshift=359  ! for ECMWF
  integer,parameter :: nxshift=0     ! for GFS

  integer,parameter :: nconvlevmax = nuvzmax-1
  integer,parameter :: na = nconvlevmax+1


  ! nxmax,nymax        maximum dimension of wind fields in x and y
  !                    direction, respectively
  ! nuvzmax,nwzmax     maximum dimension of (u,v) and (w) wind fields in z
  !                    direction (for fields on eta levels)
  ! nzmax              maximum dimension of wind fields in z direction
  !                    for the transformed Cartesian coordinates
  ! nxshift            for global grids (in x), the grid can be shifted by
  !                    nxshift grid points, in order to accomodate nested
  !                    grids, and output grids overlapping the domain "boundary"
  !                    nxshift must not be negative; "normal" setting would be 0
  ! ntracermax         maximum number of tracer species in convection
  ! nconvlevmax        maximum number of levels for convection
  ! na                 parameter used in Emanuel's convect subroutine


  !*********************************************
  ! Maximum dimensions of the nested input grids
  !*********************************************

  integer,parameter :: maxnests=0, nxmaxn=0, nymaxn=0
  !integer,parameter :: maxnests=1,nxmaxn=251,nymaxn=151

  ! maxnests                maximum number of nested grids
  ! nxmaxn,nymaxn           maximum dimension of nested wind fields in
  !                         x and y direction, respectively


  !*********************************
  ! Parmaters for GRIB file decoding
  !*********************************

  integer,parameter :: jpack=4*nxmax*nymax, jpunp=4*jpack

  ! jpack,jpunp             maximum dimensions needed for GRIB file decoding


  !**************************************
  ! Maximum dimensions of the output grid
  !**************************************

  !integer,parameter :: maxageclass=1,maxzgrid=10,nclassunc=1
  integer,parameter :: maxageclass=1,nclassunc=1

  ! nclassunc               number of classes used to calculate the uncertainty
  !                         of the output
  ! maxageclass             maximum number of age classes used for output

  ! Sabine Eckhardt, June, 2008
  ! the dimensions of the OUTGRID are now set dynamically during runtime
  ! maxxgrid,maxygrid,maxzgrid    maximum dimensions in x,y,z direction
  ! maxxgridn,maxygridn           maximum dimension of the nested grid
  !integer maxxgrid,maxygrid,maxzgrid,maxxgridn,maxygridn
  !integer,parameter :: maxxgrid=361,maxygrid=181,maxxgridn=0,maxygridn=0)

  integer,parameter :: maxreceptor=200

  ! maxreceptor             maximum number of receptor points


  !**************************************************
  ! Maximum number of particles, species, and similar
  !**************************************************

  integer,parameter :: maxpart=2000000
  integer,parameter :: maxspec=1


  ! maxpart                 Maximum number of particles
  ! maxspec                 Maximum number of chemical species per release

  ! maxpoint is also set dynamically during runtime
  ! maxpoint                Maximum number of release locations

  ! ---------
  ! Sabine Eckhardt: change of landuse inventary numclass=13
  ! ---------
  integer,parameter :: maxwf=50000, maxtable=1000, numclass=13, ni=11

  ! maxwf                   maximum number of wind fields to be used for simulation
  ! maxtable                Maximum number of chemical species that can be
  !                         tabulated for FLEXPART
  ! numclass                Number of landuse classes available to FLEXPART
  ! ni                      Number of diameter classes of particles

  !**************************************************************************
  ! dimension of the OH field
  !**************************************************************************
  integer,parameter :: maxxOH=72, maxyOH=46, maxzOH=7

  !**************************************************************************
  ! Maximum number of particles to be released in a single atmospheric column
  ! for the domain-filling trajectories option
  !**************************************************************************

  integer,parameter :: maxcolumn=3000


  !*********************************
  ! Dimension of random number field
  !*********************************

  integer,parameter :: maxrand=2000000

  ! maxrand                 number of random numbers used


  !*****************************************************
  ! Number of clusters to be used for plume trajectories
  !*****************************************************

  integer,parameter :: ncluster=5

  !************************************
  ! Unit numbers for input/output files
  !************************************

  integer,parameter :: unitpath=1, unitcommand=1, unitageclasses=1, unitgrid=1
  integer,parameter :: unitavailab=1, unitreleases=88, unitpartout=93
  integer,parameter :: unitpartin=93, unitflux=98, unitouttraj=96
  integer,parameter :: unitvert=1, unitoro=1, unitpoin=1, unitreceptor=1
  integer,parameter :: unitoutgrid=97, unitoutgridppt=99, unitoutinfo=1
  integer,parameter :: unitspecies=1, unitoutrecept=91, unitoutreceptppt=92
  integer,parameter :: unitlsm=1, unitsurfdata=1, unitland=1, unitwesely=1
  integer,parameter :: unitOH=1
  integer,parameter :: unitdates=94, unitheader=90, unitshortpart=95
  integer,parameter :: unitboundcond=89

end module par_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module mean_mod
  public

! Interface to select single or double precision version of the 'mean'
! function from type of input arguments ("function overloading")
!********************************************************************
  interface mean
    module procedure mean_sp
    module procedure mean_dp
    module procedure mean_mixed_dss
    module procedure mean_mixed_dsd

  end interface mean

contains

  subroutine mean_sp(x_sp,xm,xs,number)

!*****************************************************************************
!                                                                            *
!  This subroutine calculates mean and standard deviation of a given element.*
!                                                                            *
!      AUTHOR: Andreas Stohl, 25 January 1994                                *
!                                                                            *
!      Single precision version ESO 2016                                     *
!*****************************************************************************
!                                                                            *
! Variables:                                                                 *
! x_sp(number)        field of input data                                    *
! xm                  mean                                                   *
! xs                  standard deviation                                     *
! number              number of elements of field x_sp                       *
!                                                                            *
! Constants:                                                                 *
! eps                 tiny number                                            *
!                                                                            *
!*****************************************************************************

    use par_mod, only: sp

    implicit none

    ! integer :: number,i
    ! real(sp) :: x_sp(number),xm,xs,xl,xq,xaux
    ! real(sp),parameter :: eps=1.0e-30

    integer,intent(in) :: number
    real(sp), intent(in) :: x_sp(number)
    real(sp), intent(out) ::xm,xs
    real(sp) :: xl,xq,xaux
    real(sp),parameter :: eps=1.0e-30
    integer :: i

    xl=0.
    xq=0.
    do i=1,number
      xl=xl+x_sp(i)
      xq=xq+x_sp(i)*x_sp(i)
    end do

    xm=xl/real(number,kind=sp)

    xaux=xq-xl*xl/real(number,kind=sp)

    if (xaux.lt.eps) then
      xs=0.
    else
      xs=sqrt(xaux/real(number-1,kind=sp))
    endif

  end subroutine mean_sp

  subroutine mean_dp(x_dp,xm,xs,number)

!*****************************************************************************
!                                                                            *
!  This subroutine calculates mean and standard deviation of a given element.*
!                                                                            *
!      AUTHOR: Andreas Stohl, 25 January 1994                                *
!                                                                            *
!      Double precision version ESO 2016                                     *
!*****************************************************************************
!                                                                            *
! Variables:                                                                 *
! x_dp(number)        field of input data                                    *
! xm                  mean                                                   *
! xs                  standard deviation                                     *
! number              number of elements of field x_dp                       *
!                                                                            *
! Constants:                                                                 *
! eps                 tiny number                                            *
!                                                                            *
!*****************************************************************************

    use par_mod, only: dp

    implicit none

    integer,intent(in) :: number
    real(dp), intent(in) :: x_dp(number)
    real(dp), intent(out) ::xm,xs
    real(dp) :: xl,xq,xaux
    real(dp),parameter :: eps=1.0e-30
    integer :: i

    xl=0._dp
    xq=0._dp
    do i=1,number
      xl=xl+x_dp(i)
      xq=xq+x_dp(i)*x_dp(i)
    end do

    xm=xl/real(number,kind=dp)

    xaux=xq-xl*xl/real(number,kind=dp)

    if (xaux.lt.eps) then
      xs=0._dp
    else
      xs=sqrt(xaux/real(number-1,kind=dp))
    endif

  end subroutine mean_dp

  subroutine mean_mixed_dss(x_dp,xm,xs,number)

!*****************************************************************************
!                                                                            *
!  This subroutine calculates mean and standard deviation of a given element.*
!                                                                            *
!      AUTHOR: Andreas Stohl, 25 January 1994                                *
!                                                                            *
!      Mixed precision version ESO 2016 (dp in, sp out, sp out)              *
!*****************************************************************************
!                                                                            *
! Variables:                                                                 *
! x_dp(number)        field of input data                                    *
! xm                  mean                                                   *
! xs                  standard deviation                                     *
! number              number of elements of field x_dp                       *
!                                                                            *
! Constants:                                                                 *
! eps                 tiny number                                            *
!                                                                            *
!*****************************************************************************

    use par_mod, only: sp,dp

    implicit none

    integer,intent(in) :: number
    real(dp), intent(in) :: x_dp(number)
    real(sp), intent(out) ::xm,xs
    real(sp) :: xl,xq,xaux
    real(sp),parameter :: eps=1.0e-30
    integer :: i

    xl=0._sp
    xq=0._sp
    do i=1,number
      xl=xl+real(x_dp(i),kind=sp)
      xq=xq+real(x_dp(i),kind=sp)*real(x_dp(i),kind=sp)
    end do

    xm=xl/real(number,kind=sp)

    xaux=xq-xl*xl/real(number,kind=sp)

    if (xaux.lt.eps) then
      xs=0._sp
    else
      xs=sqrt(xaux/real(number-1,kind=sp))
    endif

  end subroutine mean_mixed_dss

  subroutine mean_mixed_dsd(x_dp,xm,xs_dp,number)

!*****************************************************************************
!                                                                            *
!  This subroutine calculates mean and standard deviation of a given element.*
!                                                                            *
!      AUTHOR: Andreas Stohl, 25 January 1994                                *
!                                                                            *
!      Mixed precision version ESO 2016 (dp in, sp out, dp out)              *
!*****************************************************************************
!                                                                            *
! Variables:                                                                 *
! x_dp(number)        field of input data                                    *
! xm                  mean                                                   *
! xs_dp               standard deviation                                     *
! number              number of elements of field x_dp                       *
!                                                                            *
! Constants:                                                                 *
! eps                 tiny number                                            *
!                                                                            *
!*****************************************************************************

    use par_mod, only: sp,dp

    implicit none

    integer,intent(in) :: number
    real(dp), intent(in) :: x_dp(number)
    real(sp), intent(out) ::xm
    real(dp), intent(out) ::xs_dp
    real(dp) :: xl,xq,xaux
    real(dp),parameter :: eps=1.0e-30_dp
    integer :: i

    xl=0._dp
    xq=0._dp
    do i=1,number
      xl=xl+x_dp(i)
      xq=xq+x_dp(i)*x_dp(i)
    end do

    xm=real(xl,kind=sp)/real(number,kind=sp)

    xaux=xq-xl*xl/real(number,kind=dp)

    if (xaux.lt.eps) then
      xs_dp=0._dp
    else
      xs_dp=sqrt(xaux/real(number-1,kind=dp))
    endif

  end subroutine mean_mixed_dsd

end module mean_mod

    subroutine readheader10f(filename, &
    nxmax,numxgrid,nymax,numygrid,nzmax,numzgrid, &
    outlon0,outlat0,dxout,dyout,outheight,ibdate, &
    ibtime,loutstep,maxspec,nspec,maxageclass,nageclass,lage, &
    ireleasestart,ireleaseend,maxpoint,numpoint,xpoint,ypoint, &
    zpoint1,zpoint2,heightnn,area)

    parameter(pi=3.14159265,r_earth=6.371e6,pih=pi/180.)

    character filename*150,compoint(maxpoint)*45,species(maxspec)*7
    real :: outheight(nzmax),heightnn(nxmax,nymax,0:nzmax)
! eal outheight(0:nzmax),heightnn(nxmax,nymax,0:nzmax) !v8.2
    integer :: ireleasestart(maxpoint),ireleaseend(maxpoint)
    integer :: npart(maxpoint),kind(maxpoint),lage(0:maxageclass)
    real :: xpoint(maxpoint),ypoint(maxpoint),zpoint1(maxpoint)
    real :: zpoint2(maxpoint),xmass(maxpoint,maxspec)
    real :: oro(nxmax,nymax),area(nxmax,nymax)
          
    character(len=256) :: pathfile, flexversion
    
    integer :: verbosity

    verbosity=1

    if (verbosity.gt.0) then
    print*,'subroutine readheader10f'
    endif 
    
    if (verbosity.gt.0) then
        print*,'intent in:'
        print*,'nxmax=', nxmax
        print*,'nymax=', nymax
        print*,'nzmax=', nzmax    
    endif
 



    open(10,file=filename,form='unformatted',status='old')

          
! 76
    if (verbosity.gt.0) then
    print*,'! Open header output file: '
    print*, '**********************************************'
    print*, filename    
    endif
    
    read(10) ibdate,ibtime, flexversion

    if (verbosity.gt.0) then
    write(*,*) '! Write the header information'
    print*, '**********************************************'
    print*,'(ibdate,ibtime if fwd. -- iedate,ietime if bwd.)'
    write(*,*) 'date,time=',ibdate,ibtime
    print*, 'flexversion=',flexversion
    endif
    
! 85
    read(10) loutstep,loutaver,loutsample
    if (verbosity.gt.0) then
    print*,' info on output interval, averaging time, sampling time' 
    print*, '**********************************************'
    print*,'loutstep, aver, sample=',loutstep,loutaver,loutsample
    endif

!87
    read(10) outlon0,outlat0,numxgrid,numygrid,dxout,dyout
    if (verbosity.gt.0) then
    print*, 'information on output grid setup'
    print*, '**********************************************'
    write(*,*) 'outlon0,outlat0,numxgrid,numygrid,dxout,dyout'
    write(*,*) outlon0,outlat0,numxgrid,numygrid,dxout,dyout
    endif

    read(10) numzgrid,(outheight(i),i=1,numzgrid)
    if (verbosity.gt.0) then  
    write(*,*) 'numzgrid=', numzgrid
!    write(*,*) 'outheight=', outheight
        print*,'outheight='
        do i=1,numzgrid
        print*, i, outheight(i)
        end do   
    endif 

    read(10) jjjjmmdd,ihmmss
    if (verbosity.gt.0) then
    write(*,*) 'jjjjmmdd,ihmmss=',jjjjmmdd,ihmss
    endif

  ! Write number of species, and name for each species (+extra name for depositions)
  ! Indicate the dimension of the fields (i.e., 1 for deposition fields, numzgrid for
  ! concentration fields
  !*****************************************************************************
    if (verbosity.gt.0) then
    print*, 'information on species'
    print*, '**********************************************'    
    endif 
! 102  3*nspec,maxpointspec_act implicit?
    read(10) nspec, maxpointspec_act
    if (verbosity.gt.0) then
    print*,'3*nspec,maxpointspec_act=',nspec,maxpointspec_act
    endif
    nspec=nspec/3
    do 8 n=1,nspec
        read(10) numzgrid,species(n)
        if (verbosity.gt.0) then
        print*,'numzgrid,species(n)',numzgrid,species(n)
        endif
        read(10) numzgrid,species(n)
        if (verbosity.gt.0) then
        print*,'numzgrid,species(n)',numzgrid,species(n)
        endif
        read(10) numzgrid,species(n)
        if (verbosity.gt.0) then
        print*,'numzgrid,species(n)',numzgrid,species(n)
        endif
    8 END DO

    if (verbosity.gt.0) then
    print*, 'information on release points:'
    print*, '**********************************************'    
    endif
    
    read(10) numpoint !l113
    if (verbosity.gt.0) then
    print*,'numpoint=',numpoint
    endif

    do 13 i=1,numpoint
        read(10) ireleasestart(i),ireleaseend(i)
        read(10) xpoint(i),ypoint(i),xp2,yp2,zpoint1(i),zpoint2(i)
        read(10) npart(i),kind(i)
        read(10) compoint(i)
        do 13 j=1,nspec
            read(10)
            read(10)
            read(10) xmass(i,j)
    13 END DO
    
    


    if (verbosity.gt.0) then
    print*,'! Write information on some model switches'
    print*, '**********************************************'
    
    endif
    read(10) method,lsubgrid,lconvection,ind_source,ind_receptor
    if (verbosity.gt.0) then
    print*,'method,lsubgrid,lconvection,ind_source,ind_receptor'
    print*,method,lsubgrid,lconvection,ind_source,ind_receptor
    endif


  ! Write age class information
  !****************************
    read(10) nageclass,(lage(i),i=1,nageclass)
    lage(0)=0
    if (verbosity.gt.0) then
    print*,'!Write age class information'
    print*, '**********************************************'
    endif
    if (verbosity.gt.0) then
    print*,'nageclass=',nageclass
    write(*,*) 'lage(0:nageclass)=', (lage(i),i=0,nageclass)
    endif
    

  ! Write topography to output file
  !********************************

    
    do 130 ix=1,numxgrid
        read(10) (oro(ix,jy),jy=1,numygrid)
    130 END DO
    
    if (verbosity.gt.0) then
    print*,'!Write topography to output file' 
    print*, '**********************************************'
    
    print*,'(oro(ix,jy)'
    print*,'numxgrid,numygrid=',numxgrid,numygrid
    print*,'nxmax,nymax=',nxmax,nymax
    endif      
    close(10)



! rite(*,*) (outheight(i),i=1,numzgrid)
! f (loutstep.lt.0) nspec=numpoint

    if (verbosity.gt.0) then
    print*,' !if (loutstep < 0) nspec=numpoint'
    print*,'outheight(0)=0. ???'
    endif
    
! Calculate height, which is outheight plus topography
!*****************************************************

    if (verbosity.gt.0) then     
    print*,'Calculate height, which is outheight plus topography'
    print*, '**********************************************'
    endif 

    do 150 ix=1,numxgrid
        do 150 jy=1,numygrid
            if (ltopo == 1) then
                heightnn (ix,jy,0) = oro(ix,jy)
            else
                heightnn (ix,jy,0) = 0.
            endif
            do 150 i=1,numzgrid
                if (ltopo == 1) then
                    heightnn (ix,jy,i) = outheight(i) + oro(ix,jy)
                else
                    heightnn (ix,jy,i) = outheight(i)
                endif
    150 END DO

    if (verbosity.gt.0) then
    print*,'C Determine area of each output grid box'
    endif

! Determine area of each output grid box
!***************************************

    do 140 jy=1,numygrid
        ylata=outlat0+(float(jy-1)+0.5)*dyout
        ylatp=ylata+0.5*dyout
        ylatm=ylata-0.5*dyout
        if ((ylatm < 0) .AND. (ylatp > 0.)) then
            hzone=dyout*r_earth*pih
        else
            cosfact=cos(ylata*pih)*r_earth
            cosfactp=cos(ylatp*pih)*r_earth
            cosfactm=cos(ylatm*pih)*r_earth
            if (cosfactp < cosfactm) then
                hzone=sqrt(r_earth**2-cosfactp**2)- &
                sqrt(r_earth**2-cosfactm**2)
            else
                hzone=sqrt(r_earth**2-cosfactm**2)- &
                sqrt(r_earth**2-cosfactp**2)
            endif
        endif
        gridarea=2.*pi*r_earth*hzone*dxout/360.
        do 140 ix=1,numxgrid
            area(ix,jy)=gridarea
    140 END DO
    if (verbosity.gt.0) then  
    print*,'end subroutine readheader10f'
    endif
    end subroutine readheader10f

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readreleases

  !*****************************************************************************
  !                                                                            *
  !     This routine reads the release point specifications for the current    *
  !     model run. Several release points can be used at the same time.        *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     18 May 1996                                                            *
  !                                                                            *
  !     Update: 29 January 2001                                                *
  !     Release altitude can be either in magl or masl                         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! decay               decay constant of species                              *
  ! dquer [um]          mean particle diameters                                *
  ! dsigma              e.g. dsigma=10 or dsigma=0.1 means that 68% of the mass*
  !                     are between 0.1*dquer and 10*dquer                     *
  ! ireleasestart, ireleaseend [s] starting time and ending time of each       *
  !                     release                                                *
  ! kindz               1: zpoint is in m agl, 2: zpoint is in m asl, 3: zpoint*
  !                     is in hPa                                              *
  ! npart               number of particles to be released                     *
  ! nspec               number of species to be released                       *
  ! density [kg/m3]     density of the particles                               *
  ! rm [s/m]            Mesophyll resistance                                   *
  ! species             name of species                                        *
  ! xmass               total mass of each species                             *
  ! xpoint1,ypoint1     geograf. coordinates of lower left corner of release   *
  !                     area                                                   *
  ! xpoint2,ypoint2     geograf. coordinates of upper right corner of release  *
  !                     area                                                   *
  ! weta, wetb          parameters to determine the wet scavenging coefficient *
  ! zpoint1,zpoint2     height range, over which release takes place           *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use xmass_mod
  use par_mod
  use com_mod

  implicit none

  integer :: numpartmax,i,j,id1,it1,id2,it2,specnum_rel,idum,stat
  real :: vsh(ni),fracth(ni),schmih(ni),releaserate,xdum,cun
  real(kind=dp) :: jul1,jul2,juldate
  character(len=50) :: line
  logical :: old

  !sec, read release to find how many releasepoints should be allocated

  open(unitreleases,file=path(1)(1:length(1))//'RELEASES',status='old', &
       err=999)

  ! Check the format of the RELEASES file (either in free format,
  ! or using a formatted mask)
  ! Use of formatted mask is assumed if line 10 contains the word 'DIRECTION'
  !**************************************************************************

  call skplin(12,unitreleases)
  read (unitreleases,901) line
901   format (a)
  if (index(line,'Total') .eq. 0) then
    old = .false.
  else
    old = .true.
  endif
  rewind(unitreleases)


  ! Skip first 11 lines (file header)
  !**********************************

  call skplin(11,unitreleases)


  read(unitreleases,*,err=998) nspec
  if (old) call skplin(2,unitreleases)
  do i=1,nspec
    read(unitreleases,*,err=998) specnum_rel
    if (old) call skplin(2,unitreleases)
  end do

  numpoint=0
100   numpoint=numpoint+1
  read(unitreleases,*,end=25)
  read(unitreleases,*,err=998,end=25) idum,idum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) idum,idum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xdum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xdum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xdum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xdum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) idum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xdum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xdum
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) idum
  if (old) call skplin(2,unitreleases)
  do i=1,nspec
    read(unitreleases,*,err=998) xdum
    if (old) call skplin(2,unitreleases)
  end do
  !save compoint only for the first 1000 release points
  read(unitreleases,'(a40)',err=998) compoint(1)(1:40)
  if (old) call skplin(1,unitreleases)

  goto 100

25   numpoint=numpoint-1

  !allocate memory for numpoint releaspoint
    allocate(ireleasestart(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(ireleaseend(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(xpoint1(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(xpoint2(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(ypoint1(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(ypoint2(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(zpoint1(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(zpoint2(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(kindz(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(xmass(numpoint,maxspec) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(rho_rel(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(npart(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
    allocate(xmasssave(numpoint) &
         ,stat=stat)
    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'

   write (*,*) ' Releasepoints allocated: ', numpoint

   do i=1,numpoint
     xmasssave(i)=0.
   end do

  !now save the information
  DEP=.false.
  DRYDEP=.false.
  WETDEP=.false.
  OHREA=.false.
  do i=1,maxspec
    DRYDEPSPEC(i)=.false.
  end do

  rewind(unitreleases)


  ! Skip first 11 lines (file header)
  !**********************************

  call skplin(11,unitreleases)


  ! Assign species-specific parameters needed for physical processes
  !*************************************************************************

  read(unitreleases,*,err=998) nspec
  if (nspec.gt.maxspec) goto 994
  if (old) call skplin(2,unitreleases)
  do i=1,nspec
    read(unitreleases,*,err=998) specnum_rel
    if (old) call skplin(2,unitreleases)
    call readspecies(specnum_rel,i)

  ! For backward runs, only 1 species is allowed
  !*********************************************

  !if ((ldirect.lt.0).and.(nspec.gt.1)) then
  !write(*,*) '#####################################################'
  !write(*,*) '#### FLEXPART MODEL SUBROUTINE READRELEASES:     ####'
  !write(*,*) '#### FOR BACKWARD RUNS, ONLY 1 SPECIES IS ALLOWED####'
  !write(*,*) '#####################################################'
  !  stop
  !endif

  ! Molecular weight
  !*****************

    if (((iout.eq.2).or.(iout.eq.3)).and. &
         (weightmolar(i).lt.0.)) then
      write(*,*) 'For mixing ratio output, valid molar weight'
      write(*,*) 'must be specified for all simulated species.'
      write(*,*) 'Check table SPECIES or choose concentration'
      write(*,*) 'output instead if molar weight is not known.'
      stop
    endif


  ! Radioactive decay
  !******************

    decay(i)=0.693147/decay(i) !conversion half life to decay constant


  ! Dry deposition of gases
  !************************

    if (reldiff(i).gt.0.) &
         rm(i)=1./(henry(i)/3000.+100.*f0(i))    ! mesophyll resistance

  ! Dry deposition of particles
  !****************************

    vsetaver(i)=0.
    cunningham(i)=0.
    dquer(i)=dquer(i)*1000000.         ! Conversion m to um
    if (density(i).gt.0.) then                  ! Additional parameters
     call part0(dquer(i),dsigma(i),density(i),fracth,schmih,cun,vsh)
      do j=1,ni
        fract(i,j)=fracth(j)
        schmi(i,j)=schmih(j)
        vset(i,j)=vsh(j)
        cunningham(i)=cunningham(i)+cun*fract(i,j)
        vsetaver(i)=vsetaver(i)-vset(i,j)*fract(i,j)
      end do
      write(*,*) 'Average setting velocity: ',i,vsetaver(i)
    endif

  ! Dry deposition for constant deposition velocity
  !************************************************

    dryvel(i)=dryvel(i)*0.01         ! conversion to m/s

  ! Check if wet deposition or OH reaction shall be calculated
  !***********************************************************
    if (weta(i).gt.0.)  then
      WETDEP=.true.
      write (*,*) 'Wetdeposition switched on: ',weta(i),i
    endif
    if (ohreact(i).gt.0) then
      OHREA=.true.
      write (*,*) 'OHreaction switched on: ',ohreact(i),i
    endif


    if ((reldiff(i).gt.0.).or.(density(i).gt.0.).or. &
         (dryvel(i).gt.0.)) then
      DRYDEP=.true.
      DRYDEPSPEC(i)=.true.
    endif

  end do

    if (WETDEP.or.DRYDEP) DEP=.true.

  ! Read specifications for each release point
  !*******************************************

  numpoint=0
  numpartmax=0
  releaserate=0.
1000   numpoint=numpoint+1
  read(unitreleases,*,end=250)
  read(unitreleases,*,err=998,end=250) id1,it1
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) id2,it2
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xpoint1(numpoint)
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) ypoint1(numpoint)
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) xpoint2(numpoint)
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) ypoint2(numpoint)
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) kindz(numpoint)
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) zpoint1(numpoint)
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) zpoint2(numpoint)
  if (old) call skplin(2,unitreleases)
  read(unitreleases,*,err=998) npart(numpoint)
  if (old) call skplin(2,unitreleases)
  do i=1,nspec
    read(unitreleases,*,err=998) xmass(numpoint,i)
    if (old) call skplin(2,unitreleases)
  end do
  !save compoint only for the first 1000 release points
  if (numpoint.le.1000) then
    read(unitreleases,'(a40)',err=998) compoint(numpoint)(1:40)
  else
    read(unitreleases,'(a40)',err=998) compoint(1001)(1:40)
  endif
  if (old) call skplin(1,unitreleases)
  if (numpoint.le.1000) then
    if((xpoint1(numpoint).eq.0.).and.(ypoint1(numpoint).eq.0.).and. &
         (xpoint2(numpoint).eq.0.).and.(ypoint2(numpoint).eq.0.).and. &
         (compoint(numpoint)(1:8).eq.'        ')) goto 250
  else
    if((xpoint1(numpoint).eq.0.).and.(ypoint1(numpoint).eq.0.).and. &
         (xpoint2(numpoint).eq.0.).and.(ypoint2(numpoint).eq.0.)) goto 250
  endif


  ! If a release point contains no particles, stop and issue error message
  !***********************************************************************

  if (npart(numpoint).eq.0) then
    write(*,*) 'FLEXPART MODEL ERROR'
    write(*,*) 'RELEASES file is corrupt.'
    write(*,*) 'At least for one release point, there are zero'
    write(*,*) 'particles released. Make changes to RELEASES.'
    stop
  endif

  ! Check whether x coordinates of release point are within model domain
  !*********************************************************************

   if (xpoint1(numpoint).lt.xlon0) &
        xpoint1(numpoint)=xpoint1(numpoint)+360.
   if (xpoint1(numpoint).gt.xlon0+(nxmin1)*dx) &
        xpoint1(numpoint)=xpoint1(numpoint)-360.
   if (xpoint2(numpoint).lt.xlon0) &
        xpoint2(numpoint)=xpoint2(numpoint)+360.
   if (xpoint2(numpoint).gt.xlon0+(nxmin1)*dx) &
        xpoint2(numpoint)=xpoint2(numpoint)-360.

  ! Determine relative beginning and ending times of particle release
  !******************************************************************

  jul1=juldate(id1,it1)
  jul2=juldate(id2,it2)
  if (jul1.gt.jul2) then
    write(*,*) 'FLEXPART MODEL ERROR'
    write(*,*) 'Release stops before it begins.'
    write(*,*) 'Make changes to file RELEASES.'
    stop
  endif
  if (mdomainfill.eq.0) then   ! no domain filling
    if (ldirect.eq.1) then
      if ((jul1.lt.bdate).or.(jul2.gt.edate)) then
        write(*,*) 'FLEXPART MODEL ERROR'
        write(*,*) 'Release starts before simulation begins or ends'
        write(*,*) 'after simulation stops.'
        write(*,*) 'Make files COMMAND and RELEASES consistent.'
        stop
      endif
      ireleasestart(numpoint)=int((jul1-bdate)*86400.)
      ireleaseend(numpoint)=int((jul2-bdate)*86400.)
    else if (ldirect.eq.-1) then
      if ((jul1.lt.edate).or.(jul2.gt.bdate)) then
        write(*,*) 'FLEXPART MODEL ERROR'
        write(*,*) 'Release starts before simulation begins or ends'
        write(*,*) 'after simulation stops.'
        write(*,*) 'Make files COMMAND and RELEASES consistent.'
        stop
      endif
      ireleasestart(numpoint)=int((jul1-bdate)*86400.)
      ireleaseend(numpoint)=int((jul2-bdate)*86400.)
    endif
  endif


  ! Check, whether the total number of particles may exceed totally allowed
  ! number of particles at some time during the simulation
  !************************************************************************

  ! Determine the release rate (particles per second) and total number
  ! of particles released during the simulation
  !*******************************************************************

  if (ireleasestart(numpoint).ne.ireleaseend(numpoint)) then
    releaserate=releaserate+real(npart(numpoint))/ &
         real(ireleaseend(numpoint)-ireleasestart(numpoint))
  else
    releaserate=99999999
  endif
  numpartmax=numpartmax+npart(numpoint)
  goto 1000


250   close(unitreleases)

  write (*,*) ' Particles allocated for this run: ',maxpart, ', released in simulation: ',  numpartmax
  numpoint=numpoint-1

  if (ioutputforeachrelease.eq.1) then
    maxpointspec_act=numpoint
  else
    maxpointspec_act=1
  endif

  if (releaserate.gt. &
       0.99*real(maxpart)/real(lage(nageclass))) then
    if (numpartmax.gt.maxpart) then
  write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL SUBROUTINE READRELEASES:     ####'
  write(*,*) '####                                             ####'
  write(*,*) '####WARNING - TOTAL NUMBER OF PARTICLES SPECIFIED####'
  write(*,*) '#### IN FILE "RELEASES" MAY AT SOME POINT DURING ####'
  write(*,*) '#### THE SIMULATION EXCEED THE MAXIMUM ALLOWED   ####'
  write(*,*) '#### NUMBER (MAXPART).IF RELEASES DO NOT OVERLAP,####'
  write(*,*) '#### FLEXPART CAN POSSIBLY COMPLETE SUCCESSFULLY.####'
  write(*,*) '#### HOWEVER, FLEXPART MAY HAVE TO STOP          ####'
  write(*,*) '#### AT SOME TIME DURING THE SIMULATION. PLEASE  ####'
  write(*,*) '#### MAKE SURE THAT YOUR SETTINGS ARE CORRECT.   ####'
  write(*,*) '#####################################################'
      write(*,*) 'Maximum release rate may be: ',releaserate, &
           ' particles per second'
      write(*,*) 'Maximum allowed release rate is: ', &
           real(maxpart)/real(lage(nageclass)),' particles per second'
      write(*,*) &
           'Total number of particles released during the simulation is: ', &
           numpartmax
      write(*,*) 'Maximum allowed number of particles is: ',maxpart
    endif
  endif

  return

994   write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL SUBROUTINE READRELEASES:     ####'
  write(*,*) '####                                             ####'
  write(*,*) '#### ERROR - MAXIMUM NUMBER OF EMITTED SPECIES IS####'
  write(*,*) '#### TOO LARGE. PLEASE REDUCE NUMBER OF SPECIES. ####'
  write(*,*) '#####################################################'
  stop

998   write(*,*) '#####################################################'
  write(*,*) '#### FLEXPART MODEL SUBROUTINE READRELEASES:     ####'
  write(*,*) '####                                             ####'
  write(*,*) '#### FATAL ERROR - FILE "RELEASES" IS            ####'
  write(*,*) '#### CORRUPT. PLEASE CHECK YOUR INPUTS FOR       ####'
  write(*,*) '#### MISTAKES OR GET A NEW "RELEASES"-           ####'
  write(*,*) '#### FILE ...                                    ####'
  write(*,*) '#####################################################'
  stop


999   write(*,*) '#####################################################'
  write(*,*) '   FLEXPART MODEL SUBROUTINE READRELEASES: '
  write(*,*)
  write(*,*) 'FATAL ERROR - FILE CONTAINING PARTICLE RELEASE POINTS'
  write(*,*) 'POINTS IS NOT AVAILABLE OR YOU ARE NOT'
  write(*,*) 'PERMITTED FOR ANY ACCESS'
  write(*,*) '#####################################################'
  stop

end subroutine readreleases

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  ! This module contains all subroutines computing the vertical coordinate     *
  ! transformation of the meteorological input data (L. Bakels 2021)           *
  !                                                                            *
  !*****************************************************************************

module verttransform_mod
  use par_mod
  use com_mod
  use qvsat_mod
  use cmapf_mod, only: cc2gll
  use windfields_mod

  implicit none

contains

subroutine verttransform_ecmwf(n,uuh,vvh,wwh,pvh)
  !                              i  i   i   i   i
  !*****************************************************************************
  !                                                                            *
  !     This subroutine transforms temperature, dew point temperature and      *
  !     wind components from eta to meter coordinates.                         *
  !     The vertical wind component is transformed from Pa/s to m/s using      *
  !     the conversion factor pinmconv.                                        *
  !     In addition, this routine calculates vertical density gradients        *
  !     needed for the parameterization of the turbulent velocities.           *
  !                                                                            *
  !     Author: A. Stohl, G. Wotawa                                            *
  !                                                                            *
  !     12 August 1996                                                         *
  !     Update: 16 January 1998                                                *
  !*****************************************************************************
  !  CHANGES                                                                   *
  !                                                                            *
  !     Major update: 17 February 1999                                         *
  !     by G. Wotawa                                                           *
  !                                                                            *
  !     - Vertical levels for u, v and w are put together                      *
  !     - Slope correction for vertical velocity: Modification of calculation  *
  !       procedure                                                            *
  !                                                                            *
  !  Changes, Bernd C. Krueger, Feb. 2001:                                     *
  !   Variables tth and qvh (on eta coordinates) from common block             *
  !                                                                            *
  ! Sabine Eckhardt, March 2007                                                *
  ! added the variable cloud for use with scavenging - descr. in com_mod       *
  !                                                                            *
  ! Unified ECMWF and GFS builds                                               *
  ! Marian Harustak, 12.5.2017                                                 *
  !     - Renamed from verttransform to verttransform_ecmwf                    *
  !                                                                            *
  ! Date: 2017-05-30 modification of a bug in ew. Don Morton (CTBTO project)   *
  !                                                                            *
  ! Lucie Bakels, 2022                                                         *
  !    - Separated the code into subroutines                                   *
  !    - In case of wind_coord_type='ETA': keep ECMWF vertical winds in eta    *
  !      coordinates                                                           *
  !    - OpenMP parallelisation                                                *
  !                                                                            *
  !  Petra Seibert, Anne Philipp, 2019-05-02: implement wetdepo quickfix       *
  !  Petra Seibert, Anne Tipka, 2020-11-19: reimplement in latest version      *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! Note PS, AT 2021-01-29: all these fields are 0:nxmax-1,0:nymax-1 !!        *
  ! nx,ny,nz                        field dimensions in x,y and z direction    *
  ! icloudbot(0:nxmax,0:nymax,numwfmem) cloud bottom field for wet deposition  * 
  ! icloudtop(0:nxmax,0:nymax,numwfmem) cloud thickness for wet deposition    *
  ! uu(0:nxmax,0:nymax,nzmax,numwfmem)     wind components in x-direction [m/s]*
  ! vv(0:nxmax,0:nymax,nzmax,numwfmem)     wind components in y-direction [m/s]*
  ! ww(0:nxmax,0:nymax,nzmax,numwfmem)     wind components in z-direction      *
  !                                          [deltaeta/s]                      *
  ! tt(0:nxmax,0:nymax,nzmax,numwfmem)     temperature [K]                     *
  ! pv(0:nxmax,0:nymax,nzmax,numwfmem)     potential voriticity (pvu)          *
  ! ps(0:nxmax,0:nymax,numwfmem)           surface pressure [Pa]               *
  !                                                                            *
  !*****************************************************************************

  implicit none

  integer, intent(in) :: n
  real,intent(in),dimension(0:nxmax-1,0:nymax-1,nuvzmax) :: uuh,vvh,pvh
  real,intent(in),dimension(0:nxmax-1,0:nymax-1,nwzmax) :: wwh

  real,dimension(0:nxmax-1,0:nymax-1,nuvzmax) :: rhoh
  real,dimension(0:nxmax-1,0:nymax-1,nzmax) :: pinmconv
  real,dimension(0:nxmax-1,0:nymax-1,nuvzmax) :: prsh

  logical :: init = .true.

  !*************************************************************************
  ! If verttransform is called the first time, initialize heights of the   *
  ! z levels in meter. The heights are the heights of model levels, where  *
  ! u,v,T and qv are given, and of the interfaces, where w is given. So,   *
  ! the vertical resolution in the z system is doubled. As reference point,*
  ! the lower left corner of the grid is used.                             *
  ! Unlike in the eta system, no difference between heights for u,v and    *
  ! heights for w exists.                                                  *
  !*************************************************************************


  !eso measure CPU time
  !  call mpif_mtime('verttransform',0)

  if (init) then

  ! Search for a point with high surface pressure (i.e. not above significant topography)
  ! Then, use this point to construct a reference z profile, to be used at all times
  !*****************************************************************************
    call verttransform_init(n)

  ! Do not repeat initialization of the Cartesian z grid
  !*****************************************************

    init=.false.
  endif


  ! Compute heights of eta levels and their respective pressure and density fields
  !*******************************************************************************
  call verttransform_ecmwf_heights(nxmin1,nymin1,tt2(0:nxmin1,0:nymin1,1,n), &
    td2(0:nxmin1,0:nymin1,1,n),ps(0:nxmin1,0:nymin1,1,n),qvh(0:nxmin1,0:nymin1,:,n), &
    tth(0:nxmin1,0:nymin1,:,n),prsh(0:nxmin1,0:nymin1,:), &
    rhoh(0:nxmin1,0:nymin1,:),pinmconv(0:nxmin1,0:nymin1,:), &
    etauvheight(0:nxmin1,0:nymin1,:,n),etawheight(0:nxmin1,0:nymin1,:,n))

  ! Transform the wind fields to the internal coordinate system and save the native ETA 
  ! fields when case wind_coord_type==ETA
  !*************************************************************
  call verttransform_ecmwf_windfields(n,nxmin1,nymin1, &
    uuh(0:nxmin1,0:nymin1,1:nuvzmax), &
    vvh(0:nxmin1,0:nymin1,1:nuvzmax),wwh(0:nxmin1,0:nymin1,1:nwzmax), &
    pvh(0:nxmin1,0:nymin1,1:nuvzmax),rhoh(0:nxmin1,0:nymin1,1:nuvzmax), &
    prsh(0:nxmin1,0:nymin1,1:nuvzmax),pinmconv(0:nxmin1,0:nymin1,1:nzmax))

  ! If north or south pole is in the domain, calculate wind velocities in polar
  ! stereographic coordinates
  !*******************************************************************
  call verttransform_ecmwf_polar(n)

  ! Create cloud fields
  !*********************
#ifdef ETA
    call verttransform_ecmwf_cloud(lcw,lcwsum,nxmin1,nymin1, &
      ctwc(0:nxmin1,0:nymin1,n), &
      clwc(0:nxmin1,0:nymin1,:,n), &
      ciwc(0:nxmin1,0:nymin1,:,n), &
      icloudbot(0:nxmin1,0:nymin1,n), &
      icloudtop(0:nxmin1,0:nymin1,n), &
      lsprec(0:nxmin1,0:nymin1,1,:,n), &
      convprec(0:nxmin1,0:nymin1,1,:,n), &
      rhoeta(0:nxmin1,0:nymin1,:,n), &
      tteta(0:nxmin1,0:nymin1,:,n), &
      qv(0:nxmin1,0:nymin1,:,n), &
      etauvheight(0:nxmin1,0:nymin1,:,n), &
      etawheight(0:nxmin1,0:nymin1,:,n))
#else
    call verttransform_ecmwf_cloud(lcw,lcwsum,nxmin1,nymin1, &
      ctwc(0:nxmin1,0:nymin1,n),clwc(0:nxmin1,0:nymin1,:,n), &
      ciwc(0:nxmin1,0:nymin1,:,n), &
      icloudbot(0:nxmin1,0:nymin1,n), icloudtop(0:nxmin1,0:nymin1,n), &
      lsprec(0:nxmin1,0:nymin1,1,:,n),convprec(0:nxmin1,0:nymin1,1,:,n), &
      rho(0:nxmin1,0:nymin1,:,n), tt(0:nxmin1,0:nymin1,:,n), &
      qv(0:nxmin1,0:nymin1,:,n), etauvheight(0:nxmin1,0:nymin1,:,n), &
      etawheight(0:nxmin1,0:nymin1,:,n)) 
#endif
end subroutine verttransform_ecmwf

subroutine verttransform_nest(n,uuhn,vvhn,wwhn,pvhn)
  !                            i   i    i    i   i
  !*****************************************************************************
  !                                                                            *
  !     This subroutine transforms temperature, dew point temperature and      *
  !     wind components from eta to meter coordinates.                         *
  !     The vertical wind component is transformed from Pa/s to m/s using      *
  !     the conversion factor pinmconv.                                        *
  !     In addition, this routine calculates vertical density gradients        *
  !     needed for the parameterization of the turbulent velocities.           *
  !     It is similar to verttransform, but makes the transformations for      *
  !     the nested grids.                                                      *
  !                                                                            *
  !     Author: A. Stohl, G. Wotawa                                            *
  !                                                                            *
  !     12 August 1996                                                         *
  !     Update: 16 January 1998                                                *
  !                                                                            *
  !*****************************************************************************
  !  CHANGES                                                                   *
  !     Major update: 17 February 1999                                         *
  !     by G. Wotawa                                                           *
  !                                                                            *
  !     - Vertical levels for u, v and w are put together                      *
  !     - Slope correction for vertical velocity: Modification of calculation  *
  !       procedure                                                            *
  !                                                                            *
  !  Bernd C. Krueger, Feb. 2001:                                              *
  !   Variables tthn and qvhn (on eta coordinates) from common block           *
  !                                                                            *
  ! Sabine Eckhardt, March 2007:                                               *
  ! added the variable cloud for use with scavenging - descr. in com_mod       *
  ! PS/AT 2018/-21: variable "cloud" is replaced by quickfix, see below        * 
  !                                                                            *
  ! ESO, 2016                                                                  *
  ! -note that divide-by-zero occurs when nxmaxn,nymaxn etc. are larger than   *
  !  the actual field dimensions                                               *
  !                                                                            *
  ! Don Morton, 2017-05-30:                                                    *
  !   modification of a bug in ew. Don Morton (CTBTO project)                  *
  !                                                                            *
  !  undocumented modifications by NILU for v10                                *
  !                                                                            *
  !  Petra Seibert, 2018-06-13:                                                *
  !   - put back SAVE attribute for INIT, just to be safe                      *
  !   - minor changes, most of them just cosmetics                             *
  !   for details see changelog.txt in branch unive                            *
  !                                                                            *
  !  Petra Seibert, Anne Philipp, 2019-05-02: implement wetdepo quickfix       *
  !  Petra Seibert, Anne Tipka, 2020-11-19: reimplement in latest version      *
  !                                                                            *
  ! ****************************************************************************
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! Note PS, AT 2021-01-29: all these fields are 0:nxmaxn-1,0:nymaxn-1 !!      *
  ! nxn,nyn,nuvz,nwz                field dimensions in x,y and z direction    *
  ! icloudbot                       cloud bottom field for wet deposition      *
  ! icloudtop                      cloud thickness for wet deposition         *
  ! uun                             wind components in x-direction [m/s]       *
  ! vvn                             wind components in y-direction [m/s]       *
  ! wwn                             wind components in z-direction [deltaeta/s]*
  ! ttn                             temperature [K]                            *
  ! pvn                             potential vorticity (pvu)                  *
  ! psn                             surface pressure [Pa]                      *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real,intent(in),dimension(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numbnests) :: &
    uuhn,vvhn,pvhn
  real,intent(in),dimension(0:nxmaxn-1,0:nymaxn-1,nwzmax,numbnests) :: wwhn

  real,dimension(0:nxmaxn-1,0:nymaxn-1,nuvzmax) :: rhohn,prshn
  real,dimension(0:nxmaxn-1,0:nymaxn-1,nzmax) :: pinmconv

  integer :: nxm1, nym1
  integer :: n,l


  ! Loop over all nests
  !********************

  do l=1,numbnests
    nxm1=nxn(l)-1
    nym1=nyn(l)-1
    if (nxm1.lt.1 .or. nym1.lt.1 ) cycle
    call verttransform_ecmwf_heights(nxm1,nym1, &
      tt2n(0:nxm1,0:nym1,1,n,l),td2n(0:nxm1,0:nym1,1,n,l),psn(0:nxm1,0:nym1,1,n,l), &
      qvhn(0:nxm1,0:nym1,:,n,l),tthn(0:nxm1,0:nym1,:,n,l),prshn(0:nxm1,0:nym1,:), &
      rhohn(0:nxm1,0:nym1,:),pinmconv(0:nxm1,0:nym1,:), &
      etauvheightn(0:nxm1,0:nym1,:,n,l),etawheightn(0:nxm1,0:nym1,:,n,l))

    call verttransform_ecmwf_windfields_nest(l,n,uuhn,vvhn,wwhn,pvhn, &
                                                        rhohn,prshn,pinmconv)

    ! Create cloud fields
    !*********************

#ifdef ETA
    call verttransform_ecmwf_cloud(lcw_nest(l),lcwsum_nest(l),nxm1,nym1,&
      ctwcn(0:nxm1,0:nym1,n,l), clwcn(0:nxm1,0:nym1,:,n,l), ciwcn(0:nxm1,0:nym1,:,n,l), &
      icloudbotn(0:nxm1,0:nym1,n,l), icloudtopn(0:nxm1,0:nym1,n,l), &
      lsprecn(0:nxm1,0:nym1,1,:,n,l),convprecn(0:nxm1,0:nym1,1,:,n,l), &
      rhoetan(0:nxm1,0:nym1,:,n,l),ttetan(0:nxm1,0:nym1,:,n,l), &
      qvn(0:nxm1,0:nym1,:,n,l), etauvheightn(0:nxm1,0:nym1,:,n,l), &
      etawheightn(0:nxm1,0:nym1,:,n,l))
#else
    call verttransform_ecmwf_cloud(lcw_nest(l),lcwsum_nest(l),nxm1,nym1,&
      ctwcn(0:nxm1,0:nym1,n,l), clwcn(0:nxm1,0:nym1,:,n,l), ciwcn(0:nxm1,0:nym1,:,n,l), &
      icloudbotn(0:nxm1,0:nym1,n,l), icloudtopn(0:nxm1,0:nym1,n,l), &
      lsprecn(0:nxm1,0:nym1,1,:,n,l),convprecn(0:nxm1,0:nym1,1,:,n,l), &
      rhon(0:nxm1,0:nym1,:,n,l),ttn(0:nxm1,0:nym1,:,n,l), &
      qvn(0:nxm1,0:nym1,:,n,l), etauvheightn(0:nxm1,0:nym1,:,n,l), &
      etawheightn(0:nxm1,0:nym1,:,n,l))
#endif
      
  end do ! end loop over nests
end subroutine verttransform_nest

subroutine verttransform_init(n)
  implicit none

  integer, intent(in) :: n
  real ::  tvold,pold,pint,tv
  integer :: ix,jy,kz,ixm,jym
  real,parameter :: const=r_air/ga

  if ((ipin.eq.1).or.(ipin.eq.4)) then
    call read_heightlevels(height,nmixz)
    return
  endif

  jym=nymin1
  ixm=0
  loop1: do jy=0,nymin1
    do ix=0,nxmin1
      if (ps(ix,jy,1,n).gt.100000.) then
        ixm=ix
        jym=jy
        exit loop1
      endif
    end do
  end do loop1

  tvold=tt2(ixm,jym,1,n)*(1.+0.378*ew(td2(ixm,jym,1,n),ps(ixm,jym,1,n))/ &
       ps(ixm,jym,1,n))
  pold=ps(ixm,jym,1,n)
  height(1)=0.

  do kz=2,nuvz
    pint=akz(kz)+bkz(kz)*ps(ixm,jym,1,n)
    tv=tth(ixm,jym,kz,n)*(1.+0.608*qvh(ixm,jym,kz,n))

    if (abs(tv-tvold).gt.0.2) then
      height(kz)= height(kz-1)+const*log(pold/pint)*(tv-tvold)/log(tv/tvold)
    else
      height(kz)=height(kz-1)+const*log(pold/pint)*tv
    endif

    tvold=tv
    pold=pint
  end do

  ! Determine highest levels that can be within PBL
  !************************************************

  do kz=1,nz
    if (height(kz).gt.hmixmax) then
      nmixz=kz
      exit
    endif
  end do

  if (loutrestart.ne.-1) then
    call output_heightlevels(height,nmixz)
  endif
end subroutine verttransform_init

subroutine output_heightlevels(height_tmp,nmixz_tmp)
  implicit none

  real,intent(in) :: height_tmp(nzmax)
  integer,intent(in) :: nmixz_tmp
  integer :: kz
  character(len=256) :: heightlevels_filename

  heightlevels_filename = path(2)(1:length(2))//'heightlevels.bin'

  write(*,*) 'Writing Initialised heightlevels to file:', trim(heightlevels_filename)
  
  open(unitheightlevels,file=trim(heightlevels_filename),form='unformatted')

  write(unitheightlevels) nmixz_tmp

  do kz=1,nz
    write(unitheightlevels) height_tmp(kz)
  end do
  close(unitheightlevels)
end subroutine output_heightlevels

subroutine read_heightlevels(height_tmp,nmixz_tmp)
  implicit none

  real,intent(out) :: height_tmp(nzmax)
  integer,intent(out) :: nmixz_tmp
  integer :: kz,ios
  character(len=256) :: heightlevels_filename

  heightlevels_filename = path(2)(1:length(2))//'heightlevels.bin'

  write(*,*) 'Reading heightlevels from file:', trim(heightlevels_filename)
  
  open(unitheightlevels,file=trim(heightlevels_filename),form='unformatted',err=9988)

  read(unitheightlevels,iostat=ios) nmixz_tmp

  do kz=1,nz
    read(unitheightlevels) height_tmp(kz)
  end do
  close(unitheightlevels)

  return

9988   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE             #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'heightlevels.bin'//'    #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS        #### '
  write(*,*) ' #### NAME DOES NOT EXISTS, REMOVE call read_heightlevels #### '
  write(*,*) ' #### FROM VERTTRANSFORM_MOD.                 #### '
end subroutine read_heightlevels

subroutine verttransform_ecmwf_windfields(n,nxlim,nylim,uuh,vvh,wwh,pvh,rhoh,prsh,pinmconv)
  implicit none

  integer,intent(in) :: n,nxlim,nylim
  real,intent(in),dimension(0:nxlim,0:nylim,nuvzmax) :: uuh,vvh,pvh
  real,intent(in),dimension(0:nxlim,0:nylim,nwzmax) :: wwh
  real,intent(in),dimension(0:nxlim,0:nylim,nuvzmax) :: rhoh
  real,intent(in),dimension(0:nxlim,0:nylim,nzmax) :: pinmconv
  ! RLT added pressure
  real,intent(in),dimension(0:nxlim,0:nylim,nuvzmax) :: prsh

  !real,dimension(0:nxmax-1,0:nymax-1) ::  dpdeta

  real,dimension(0:nylim) :: cosf

  integer,dimension(0:nxlim,0:nylim,nzmax) :: idx,idxw

  integer :: ix,jy,kz,iz,ixp,jyp,ix1,jy1
  real :: dz1,dz2,dz,dpdeta
  real :: dzdx,dzdy
  real :: dzdx1,dzdx2,dzdy1,dzdy2

  ! Copy fields for ETA coordinate interpolations
#ifdef ETA
!$OMP PARALLEL PRIVATE(ix,jy,kz)
!$OMP WORKSHARE
  uueta(0:nxlim,0:nylim,:,n) = uuh(0:nxlim,0:nylim,:)
  vveta(0:nxlim,0:nylim,:,n) = vvh(0:nxlim,0:nylim,:)
  tteta(0:nxlim,0:nylim,:,n) = tth(0:nxlim,0:nylim,:,n)
  qv(0:nxlim,0:nylim,:,n)    = qvh(0:nxlim,0:nylim,:,n)
  pveta(0:nxlim,0:nylim,:,n) = pvh(0:nxlim,0:nylim,:)
  rhoeta(0:nxlim,0:nylim,:,n) = rhoh(0:nxlim,0:nylim,:)
  prseta(0:nxlim,0:nylim,:,n) = prsh(0:nxlim,0:nylim,:)

  forall (ix=0:nxlim,jy=0:nylim,kz=2:nz-1)
    drhodzeta(ix,jy,kz,n)= &
         (rhoh(ix,jy,kz+1)-rhoh(ix,jy,kz-1))/ &
         (height(kz+1)-height(kz-1)) 
         ! Note that this is still in SI units and not in eta
  end forall
  drhodzeta(0:nxlim,0:nylim,1,n)=(rhoh(0:nxlim,0:nylim,2)-rhoh(0:nxlim,0:nylim,1))/(height(2)-height(1))
  drhodzeta(0:nxlim,0:nylim,nz,n)=drhodzeta(0:nxlim,0:nylim,nz-1,n)

  ! Convert w from Pa/s to eta/s, following FLEXTRA
  !************************************************
  ! z=1
  wweta(0:nxlim,0:nylim,1,n)=wwh(0:nxlim,0:nylim,1)/ &
    ((akm(2)-akm(1)+(bkm(2)-bkm(1))*ps(0:nxlim,0:nylim,1,n))/ &
        (wheight(2)-wheight(1)))
  ! z=nuvz-1
  wweta(0:nxlim,0:nylim,nuvz-1,n)=wwh(0:nxlim,0:nylim,nuvz-1)/ &
    ((akm(nuvz-1)-akm(nuvz-2)+(bkm(nuvz-1)-bkm(nuvz-2))*ps(0:nxlim,0:nylim,1,n))/ &
        (wheight(nuvz-1)-wheight(nuvz-2)))
  ! 1<z<nuvz-1
  forall (ix=0:nxlim,jy=0:nylim,kz=2:nuvz-2)
    wweta(ix,jy,kz,n)=wwh(ix,jy,kz)/ &
      ((akm(kz+1)-akm(kz-1)+(bkm(kz+1)-bkm(kz-1))*ps(ix,jy,1,n))/ &
        (wheight(kz+1)-wheight(kz-1)))
  end forall
!$OMP END WORKSHARE NOWAIT

  if (lcw) then
!$OMP DO
    do kz=1,nz
      clwc(0:nxlim,0:nylim,kz,n)=clwch(0:nxlim,0:nylim,kz,n)
      if (.not. lcwsum) ciwc(0:nxlim,0:nylim,kz,n)=ciwch(0:nxlim,0:nylim,kz,n)
    end do
!$OMP END DO
  endif
!$OMP END PARALLEL
#endif

!$OMP PARALLEL PRIVATE(jy,ix,iz,kz,dz1,dz2,dz,ix1,jy1,ixp,jyp,dzdx1,dzdx2,dzdx, &
!$OMP dzdy1,dzdy2,dzdy,dpdeta)
  ! Finding the index in eta levels (uv and w) that correspond to
  ! a certain height level in meters
  !**************************************************************
!$OMP WORKSHARE
  idx(0:nxlim,0:nylim,1:2)=2
  idxw(0:nxlim,0:nylim,1:2)=2
!$OMP END WORKSHARE

!$OMP DO
  do jy=0,nylim
    do iz=2,nz-1
      do ix=0,nxlim
        idx(ix,jy,iz)=idx(ix,jy,iz-1)
        idxw(ix,jy,iz)=idxw(ix,jy,iz-1)

        ! height in meters that corresponds to the eta w level
        innwz: do kz=idxw(ix,jy,iz),nuvz
          if ((idxw(ix,jy,iz).le.kz).and. &
            (height(iz).gt.etawheight(ix,jy,kz-1,n)).and. &
            (height(iz).le.etawheight(ix,jy,kz,n))) then
            idxw(ix,jy,iz)=kz
            exit innwz
          endif
        enddo innwz

        ! height in meters that corresponds to the eta uv level
        if(height(iz).gt.etauvheight(ix,jy,nuvz,n)) then
          cycle
        else
          innuvz: do kz=idx(ix,jy,iz),nuvz
            if ((idx(ix,jy,iz).le.kz).and. &
              (height(iz).gt.etauvheight(ix,jy,kz-1,n)).and. &
              (height(iz).le.etauvheight(ix,jy,kz,n))) then
              idx(ix,jy,iz)=kz
              exit innuvz
            endif
          enddo innuvz
        endif
      end do
    end do
  end do
!$OMP END DO NOWAIT

  ! Setting upper and lower levels
!$OMP WORKSHARE
  uu(0:nxlim,0:nylim,1,n)=uuh(0:nxlim,0:nylim,1)
  uu(0:nxlim,0:nylim,nz,n)=uuh(0:nxlim,0:nylim,nuvz)
  vv(0:nxlim,0:nylim,1,n)=vvh(0:nxlim,0:nylim,1)
  vv(0:nxlim,0:nylim,nz,n)=vvh(0:nxlim,0:nylim,nuvz)
  tt(0:nxlim,0:nylim,1,n)=tth(0:nxlim,0:nylim,1,n)
  tt(0:nxlim,0:nylim,nz,n)=tth(0:nxlim,0:nylim,nuvz,n)
  pv(0:nxlim,0:nylim,1,n)=pvh(0:nxlim,0:nylim,1)
  pv(0:nxlim,0:nylim,nz,n)=pvh(0:nxlim,0:nylim,nuvz)
#ifndef ETA
  qv(0:nxlim,0:nylim,1,n)=qvh(0:nxlim,0:nylim,1,n)
  qv(0:nxlim,0:nylim,nz,n)=qvh(0:nxlim,0:nylim,nuvz,n)
#endif
  rho(0:nxlim,0:nylim,1,n)=rhoh(0:nxlim,0:nylim,1)
  rho(0:nxlim,0:nylim,nz,n)=rhoh(0:nxlim,0:nylim,nuvz)
  ! RLT add pressure
  prs(0:nxlim,0:nylim,1,n)=prsh(0:nxlim,0:nylim,1)
  prs(0:nxlim,0:nylim,nz,n)=prsh(0:nxlim,0:nylim,nuvz)
  ! RLT
  ww(0:nxlim,0:nylim,1,n)=wwh(0:nxlim,0:nylim,1)*pinmconv(0:nxlim,0:nylim,1)
  ww(0:nxlim,0:nylim,nz,n)=wwh(0:nxlim,0:nylim,nwz)*pinmconv(0:nxlim,0:nylim,nz)
  forall (jy=0:nylim) 
    cosf(jy)=1./cos((real(jy)*dy+ylat0)*pi180) ! Needed in slope computations
  end forall
!$OMP END WORKSHARE NOWAIT

#ifndef ETA
  if (lcw) then !hg adding the cloud water 
!$OMP WORKSHARE
    clwc(0:nxlim,0:nylim,1,n)=clwch(0:nxlim,0:nylim,1,n)
    clwc(0:nxlim,0:nylim,nz,n)=clwch(0:nxlim,0:nylim,nuvz,n)
!$OMP END WORKSHARE NOWAIT
    if (.not. lcwsum) then
!$OMP WORKSHARE
      ciwc(0:nxlim,0:nylim,1,n)=ciwch(0:nxlim,0:nylim,1,n)
      ciwc(0:nxlim,0:nylim,nz,n)=ciwch(0:nxlim,0:nylim,nuvz,n) 
!$OMP END WORKSHARE NOWAIT
    endif
  endif
#endif

!$OMP BARRIER

!$OMP DO
  do iz=2,nz-1
    do jy=0,nylim
      do ix=0,nxlim
        ! Levels, where uv is given
        !*************************
        if (height(iz).gt.etauvheight(ix,jy,nuvz,n)) then
          uu(ix,jy,iz,n)=uu(ix,jy,nz,n)
          vv(ix,jy,iz,n)=vv(ix,jy,nz,n)
          tt(ix,jy,iz,n)=tt(ix,jy,nz,n)
          pv(ix,jy,iz,n)=pv(ix,jy,nz,n)
          rho(ix,jy,iz,n)=rho(ix,jy,nz,n)
          prs(ix,jy,iz,n)=prs(ix,jy,nz,n)   ! RLT
#ifndef ETA
          qv(ix,jy,iz,n)=qv(ix,jy,nz,n)
          !hg adding the cloud water
          if (lcw) then
            clwc(ix,jy,iz,n)=clwc(ix,jy,nz,n)
            if (.not.lcwsum) ciwc(ix,jy,iz,n)=ciwc(ix,jy,nz,n)
          end if
#endif
        else
          kz=idx(ix,jy,iz)
          dz1=height(iz)-etauvheight(ix,jy,kz-1,n)
          dz2=etauvheight(ix,jy,kz,n)-height(iz)
          dz=dz1+dz2
          uu(ix,jy,iz,n)=(uuh(ix,jy,kz-1)*dz2+uuh(ix,jy,kz)*dz1)/dz
          vv(ix,jy,iz,n)=(vvh(ix,jy,kz-1)*dz2+vvh(ix,jy,kz)*dz1)/dz
          tt(ix,jy,iz,n)=(tth(ix,jy,kz-1,n)*dz2 &
               +tth(ix,jy,kz,n)*dz1)/dz
          pv(ix,jy,iz,n)=(pvh(ix,jy,kz-1)*dz2+pvh(ix,jy,kz)*dz1)/dz
          rho(ix,jy,iz,n)=(rhoh(ix,jy,kz-1)*dz2+rhoh(ix,jy,kz)*dz1)/dz
          ! RLT add pressure
          prs(ix,jy,iz,n)=(prsh(ix,jy,kz-1)*dz2+prsh(ix,jy,kz)*dz1)/dz
#ifndef ETA
          qv(ix,jy,iz,n)=(qvh(ix,jy,kz-1,n)*dz2+qvh(ix,jy,kz,n)*dz1)/dz
          !hg adding the cloud water
          if  (lcw) then
            clwc(ix,jy,iz,n)= &
              (clwch(ix,jy,kz-1,n)*dz2+clwch(ix,jy,kz,n)*dz1)/dz
            if (.not.lcwsum) ciwc(ix,jy,iz,n)= &
              (ciwch(ix,jy,kz-1,n)*dz2+ciwch(ix,jy,kz,n)*dz1)/dz
          end if
#endif
        endif
        ! Levels, where w is given
        !*************************
        kz=idxw(ix,jy,iz)

        dz1=height(iz)-etawheight(ix,jy,kz-1,n)
        dz2=etawheight(ix,jy,kz,n)-height(iz)
        dz=dz1+dz2
        ww(ix,jy,iz,n)=(wwh(ix,jy,kz-1)*pinmconv(ix,jy,kz-1)*dz2 &
             +wwh(ix,jy,kz)*pinmconv(ix,jy,kz)*dz1)/dz

        !****************************************************************
        ! Compute slope of eta levels in windward direction and resulting
        ! vertical wind correction
        !****************************************************************
        ix1=ix-1
        jy1=jy-1
        ixp=ix+1
        jyp=jy+1
        if ((jy.eq.nylim).or.(jy.eq.0)) then
          cycle
        else if ((.not.xglobal).and.((ix.eq.nxlim).or.(ix.eq.0))) then
          cycle
        else if (ix.eq.nxlim) then
          ixp=0
        else if (ix.eq.0) then
          ix1=nxlim
        endif
        kz=idx(ix,jy,iz)
        dz1=height(iz)-etauvheight(ix,jy,kz-1,n)
        dz2=etauvheight(ix,jy,kz,n)-height(iz)
        dz=dz1+dz2
        
        dzdx1=(etauvheight(ixp,jy,kz-1,n)-etauvheight(ix1,jy,kz-1,n))*0.5
        dzdx2=(etauvheight(ixp,jy,kz,n)-etauvheight(ix1,jy,kz,n))*0.5

        dzdx=(dzdx1*dz2+dzdx2*dz1)/dz

        dzdy1=(etauvheight(ix,jyp,kz-1,n)-etauvheight(ix,jy1,kz-1,n))*0.5
        dzdy2=(etauvheight(ix,jyp,kz,n)-etauvheight(ix,jy1,kz,n))*0.5
        dzdy=(dzdy1*dz2+dzdy2*dz1)/dz

        ww(ix,jy,iz,n)=ww(ix,jy,iz,n) + dzdx*uu(ix,jy,iz,n)*dxconst*cosf(jy) &
                                      + dzdy*vv(ix,jy,iz,n)*dyconst
      end do
    end do
  end do
!$OMP END DO

!$OMP WORKSHARE
  ! Compute density gradients
  !**************************
  drhodz(0:nxlim,0:nylim,nz,n)=drhodz(0:nxlim,0:nylim,nz-1,n)
  drhodz(0:nxlim,0:nylim,1,n)=(rho(0:nxlim,0:nylim,2,n)-rho(0:nxlim,0:nylim,1,n))/ &
    (height(2)-height(1))
  forall (ix=0:nxlim,jy=0:nylim,iz=2:nz-1)
    drhodz(ix,jy,iz,n)=(rho(ix,jy,iz+1,n)-rho(ix,jy,iz-1,n))/ &
      (height(iz+1)-height(iz-1))
  end forall
!$OMP END WORKSHARE
!$OMP END PARALLEL

end subroutine verttransform_ecmwf_windfields

subroutine verttransform_ecmwf_polar(n)
  implicit none

  integer, intent(in) :: n

  integer :: ix,jy,iz
  real :: xlon,ylat,xlonr
  real :: uuaux,vvaux,uupolaux,vvpolaux,ddpol,ffpol,wdummy

  if (nglobal) then
!$OMP PARALLEL PRIVATE(iz,jy,ix,xlon,ylat)
!$OMP DO
    do iz=1,nz
      do jy=int(switchnorthg)-2,nymin1
        ylat=ylat0+real(jy)*dy
        do ix=0,nxmin1
          xlon=xlon0+real(ix)*dx
          call cc2gll(northpolemap,ylat,xlon,uu(ix,jy,iz,n), &
               vv(ix,jy,iz,n),uupol(ix,jy,iz,n), &
               vvpol(ix,jy,iz,n))
#ifdef ETA
          call cc2gll(northpolemap,ylat,xlon,uueta(ix,jy,iz,n), &
               vveta(ix,jy,iz,n),uupoleta(ix,jy,iz,n), &
               vvpoleta(ix,jy,iz,n))
#endif
        end do
      end do
    end do
!$OMP END DO
!$OMP END PARALLEL

!$OMP PARALLEL PRIVATE(iz,jy,ix,xlon,xlonr,ffpol,ddpol,uuaux,vvaux,uupolaux, &
!$OMP wdummy,vvpolaux)
!$OMP DO
    do iz=1,nz

  ! CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
  !
  !   AMSnauffer Nov 18 2004 Added check for case vv=0
  !
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uu(nx/2-1,nymin1,iz,n)**2+ &
           vv(nx/2-1,nymin1,iz,n)**2)
      if (vv(nx/2-1,nymin1,iz,n).lt.0.) then
        ddpol=atan(uu(nx/2-1,nymin1,iz,n)/ &
             vv(nx/2-1,nymin1,iz,n))-xlonr
      else if (vv(nx/2-1,nymin1,iz,n).gt.0.) then
        ddpol=pi+atan(uu(nx/2-1,nymin1,iz,n)/ &
             vv(nx/2-1,nymin1,iz,n))-xlonr
      else
        ddpol=pi*0.5-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.*pi+ddpol
      if(ddpol.gt.2.*pi) ddpol=ddpol-2.*pi

      ! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.
      xlonr=xlon*pi/180.
      ylat=90.
      uuaux=-ffpol*sin(xlonr+ddpol)
      vvaux=-ffpol*cos(xlonr+ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux, &
           vvpolaux)


      ! Fix: Set W at pole to the zonally averaged W of the next equator-
      ! ward parallel of latitude
      wdummy=0.
      jy=ny-2
      do ix=0,nxmin1
        wdummy=wdummy+ww(ix,jy,iz,n)
      end do
      wdummy=wdummy/real(nx)
      jy=nymin1
      do ix=0,nxmin1
        ww(ix,jy,iz,n)=wdummy
        uupol(ix,jy,iz,n)=uupolaux
        vvpol(ix,jy,iz,n)=vvpolaux
      end do

#ifdef ETA
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uueta(nx/2-1,nymin1,iz,n)**2+ &
           vveta(nx/2-1,nymin1,iz,n)**2)
      if (vveta(nx/2-1,nymin1,iz,n).lt.0.) then
        ddpol=atan(uueta(nx/2-1,nymin1,iz,n)/ &
             vveta(nx/2-1,nymin1,iz,n))-xlonr
      else if (vveta(nx/2-1,nymin1,iz,n).gt.0.) then
        ddpol=pi+atan(uueta(nx/2-1,nymin1,iz,n)/ &
             vveta(nx/2-1,nymin1,iz,n))-xlonr
      else
        ddpol=pi*0.5-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
      if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.0
      xlonr=xlon*pi/180.
      ylat=90.0
      uuaux=-ffpol*sin(xlonr+ddpol)
      vvaux=-ffpol*cos(xlonr+ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux, &
           vvpolaux)

      wdummy=0.
      jy=ny-2
      do ix=0,nxmin1
        wdummy=wdummy+wweta(ix,jy,iz,n)
      end do
      wdummy=wdummy/real(nx)
      jy=nymin1
      do ix=0,nxmin1
        wweta(ix,jy,iz,n)=wdummy
        uupoleta(ix,jy,iz,n)=uupolaux
        vvpoleta(ix,jy,iz,n)=vvpolaux
      end do

#endif
    end do
!$OMP END DO
!$OMP END PARALLEL


  ! Fix: Set W at pole to the zonally averaged W of the next equator-
  ! ward parallel of latitude

    ! do iz=1,nz
    !   wdummy=0.
    !   jy=ny-2
    !   do ix=0,nxmin1
    !     wdummy=wdummy+ww(ix,jy,iz,n)
    !   end do
    !   wdummy=wdummy/real(nx)
    !   jy=nymin1
    !   do ix=0,nxmin1
    !     ww(ix,jy,iz,n)=wdummy
    !   end do
    ! end do

! #ifdef ETA
!     do iz=1,nz
!       wdummy=0.
!       jy=ny-2
!       do ix=0,nxmin1
!         wdummy=wdummy+wweta(ix,jy,iz,n)
!       end do
!       wdummy=wdummy/real(nx)
!       jy=nymin1
!       do ix=0,nxmin1
!         wweta(ix,jy,iz,n)=wdummy
!       end do
!     end do
! #endif

  endif


  ! If south pole is in the domain, calculate wind velocities in polar
  ! stereographic coordinates
  !*******************************************************************

  if (sglobal) then
!$OMP PARALLEL PRIVATE(iz,jy,ix,xlon,ylat)
!$OMP DO
    do iz=1,nz
      do jy=0,int(switchsouthg)+3
        ylat=ylat0+real(jy)*dy
        do ix=0,nxmin1
          xlon=xlon0+real(ix)*dx
          call cc2gll(southpolemap,ylat,xlon,uu(ix,jy,iz,n), &
               vv(ix,jy,iz,n),uupol(ix,jy,iz,n), &
               vvpol(ix,jy,iz,n))
#ifdef ETA
          call cc2gll(southpolemap,ylat,xlon,uueta(ix,jy,iz,n), &
               vveta(ix,jy,iz,n),uupoleta(ix,jy,iz,n), &
               vvpoleta(ix,jy,iz,n))
#endif
        end do
      end do
    end do
!$OMP END DO
!$OMP END PARALLEL

!$OMP PARALLEL PRIVATE(iz,jy,ix,xlon,xlonr,ffpol,ddpol,uuaux,vvaux,uupolaux, &
!$OMP wdummy,vvpolaux)
!$OMP DO
    do iz=1,nz

  ! CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
  !
  !   AMSnauffer Nov 18 2004 Added check for case vv=0
  !
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uu(nx/2-1,0,iz,n)**2+ &
           vv(nx/2-1,0,iz,n)**2)
      if (vv(nx/2-1,0,iz,n).lt.0.) then
        ddpol=atan(uu(nx/2-1,0,iz,n)/ &
             vv(nx/2-1,0,iz,n))+xlonr
      else if (vv(nx/2-1,0,iz,n).gt.0.) then
        ddpol=pi+atan(uu(nx/2-1,0,iz,n)/ &
             vv(nx/2-1,0,iz,n))+xlonr
      else
        ddpol=pi*0.5-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.*pi+ddpol
      if(ddpol.gt.2.*pi) ddpol=ddpol-2.*pi

  ! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.
      xlonr=xlon*pi/180.
      ylat=-90.
      uuaux=+ffpol*sin(xlonr-ddpol)
      vvaux=-ffpol*cos(xlonr-ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux, &
           vvpolaux)

    ! Fix: Set W at pole to the zonally averaged W of the next equator-
    ! ward parallel of latitude
      wdummy=0.
      jy=1
      do ix=0,nxmin1
        wdummy=wdummy+ww(ix,jy,iz,n)
      end do
      wdummy=wdummy/real(nx)
      jy=0
      do ix=0,nxmin1
        ww(ix,jy,iz,n)=wdummy
        uupol(ix,jy,iz,n)=uupolaux
        vvpol(ix,jy,iz,n)=vvpolaux
      end do

#ifdef ETA
  ! CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
  !
  !   AMSnauffer Nov 18 2004 Added check for case vv=0
  !
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uueta(nx/2-1,0,iz,n)**2+ &
           vveta(nx/2-1,0,iz,n)**2)
      if (vveta(nx/2-1,0,iz,n).lt.0.) then
        ddpol=atan(uueta(nx/2-1,0,iz,n)/ &
             vveta(nx/2-1,0,iz,n))+xlonr
      else if (vveta(nx/2-1,0,iz,n).gt.0.) then
        ddpol=pi+atan(uueta(nx/2-1,0,iz,n)/ &
             vveta(nx/2-1,0,iz,n))+xlonr
      else
        ddpol=pi*0.5-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
      if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.0
      xlonr=xlon*pi/180.
      ylat=-90.0
      uuaux=+ffpol*sin(xlonr-ddpol)
      vvaux=-ffpol*cos(xlonr-ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux, &
           vvpolaux)

      wdummy=0.
      jy=1
      do ix=0,nxmin1
        wdummy=wdummy+wweta(ix,jy,iz,n)
      end do
      wdummy=wdummy/real(nx)
      jy=0
      do ix=0,nxmin1
        wweta(ix,jy,iz,n)=wdummy
        uupoleta(ix,jy,iz,n)=uupolaux
        vvpoleta(ix,jy,iz,n)=vvpolaux
      end do
#endif
    end do
!$OMP END DO
!$OMP END PARALLEL
  endif
end subroutine verttransform_ecmwf_polar

subroutine verttransform_ecmwf_cloud(lcw_tmp,lcwsum_tmp,nxlim,nylim,&
  ctwc_tmp,clwc_tmp,ciwc_tmp,icloudbot_tmp,icloudtop_tmp,lsprec_tmp,convprec_tmp,rho_tmp, &
  tt_tmp,qv_tmp,uvzlev,wzlev)
  implicit none

  logical,intent(in) :: lcw_tmp,lcwsum_tmp
  integer, intent(in) :: nxlim,nylim
  real,intent(out) :: ctwc_tmp(0:nxlim,0:nylim)

  real,intent(inout) :: clwc_tmp(0:nxlim,0:nylim,nzmax)
  real,intent(in) :: ciwc_tmp(0:nxlim,0:nylim,nzmax)
  real,intent(in) :: lsprec_tmp(0:nxlim,0:nylim,numpf),convprec_tmp(0:nxlim,0:nylim,numpf)
  real,intent(in),dimension(0:nxlim,0:nylim,nzmax) :: rho_tmp,tt_tmp,qv_tmp
  real,intent(in),dimension(0:nxlim,0:nylim,nzmax) :: uvzlev,wzlev

  integer,intent(out) :: icloudbot_tmp(0:nxlim,0:nylim), icloudtop_tmp(0:nxlim,0:nylim)

  integer :: ix,jy

  ! converted parameters for eta coordinates:
  integer :: max_cloudthck_eta
  integer, dimension(2) :: conv_clrange_eta,highconvp_clrange_eta,lowconvp_clrange_eta
  
  ! AT, PS: for v11, we add back the quick fix to interpolate clouds in 
  !   interpol_rain developed by PS for v8 and extend it to using 
  !   cloud water fields (in apply_cloud_bounds)


! !$OMP PARALLEL PRIVATE(ix,jy,kz,k,lsp,convp,prec, &
! !$OMP max_cloudthck_eta,conv_clrange_eta,conv_clrange_eta,highconvp_clrange_eta, &
! $OMP highconvp_clrange_eta,lowconvp_clrange_eta,lowconvp_clrange_eta) REDUCTION(+:ctwc_tmp)
! !$OMP DO SCHEDULE(dynamic,max(1,nylim/50))
    
  do jy=0,nylim
    do ix=0,nxlim

#ifdef ETA
      call convert_cloud_params(ix,jy,nxlim,nylim,max_cloudthck_eta,conv_clrange_eta, &
        highconvp_clrange_eta,lowconvp_clrange_eta,uvzlev)
#endif

      icloudbot_tmp(ix,jy) = icmv 

      ! Find the bottom and top of clouds in grid cell ix, jy
      call identify_cloud(ix,jy,lcw_tmp,lcwsum_tmp,nxlim,nylim, &
        ctwc_tmp,clwc_tmp,ciwc_tmp,icloudbot_tmp,icloudtop_tmp,rho_tmp, &
        tt_tmp,qv_tmp,uvzlev,wzlev)

      ! Adjust clouds according to minimum thickness, height, lower level, etc.
      call apply_cloud_bounds(ix,jy,nxlim,nylim,lsprec_tmp,convprec_tmp,uvzlev, &
        icloudbot_tmp,icloudtop_tmp,max_cloudthck_eta,conv_clrange_eta, &
        highconvp_clrange_eta,lowconvp_clrange_eta)
    enddo ! ix loop
  enddo ! jy loop
end subroutine verttransform_ecmwf_cloud

subroutine convert_cloud_params(ix,jy,nxlim,nylim,max_cloudthck_eta,conv_clrange_eta, &
  highconvp_clrange_eta,lowconvp_clrange_eta,uvzlev)

  implicit none

  integer, intent(in) :: ix,jy,nxlim,nylim
  real,intent(in),dimension(0:nxlim,0:nylim,nzmax) :: uvzlev

  ! converted parameters for eta coordinates:
  integer,intent(out) :: max_cloudthck_eta
  integer, dimension(2),intent(out) :: conv_clrange_eta,highconvp_clrange_eta, &
    lowconvp_clrange_eta
  integer :: i, kz


  ! Convert cloud parameters to eta coords.
  ! Reverse sign when using eta (eta:1-0, meter:0-max)
  max_cloudthck_eta=int(uvheight(nz)*eta_convert)
  conv_clrange_eta=int(uvheight(nz)*eta_convert)
  highconvp_clrange_eta=int(uvheight(nz)*eta_convert)
  lowconvp_clrange_eta=int(uvheight(nz)*eta_convert)
  do kz=1,nz
    if (uvzlev(ix,jy,kz).gt.max_cloudthck) then
      max_cloudthck_eta=int(uvheight(kz)*eta_convert)
      exit
    endif
  end do
  do i=1,2
    do kz=1,nz
      if (uvzlev(ix,jy,kz).gt.conv_clrange(i)) then 
        conv_clrange_eta(i)=int(uvheight(kz)*eta_convert)
        exit
      endif
    end do
    do kz=1,nz
      if (uvzlev(ix,jy,kz).gt.highconvp_clrange(i)) then 
        highconvp_clrange_eta(i)=int(uvheight(kz)*eta_convert)
        exit
      endif
    end do
    do kz=1,nz
      if (uvzlev(ix,jy,kz).gt.lowconvp_clrange(i)) then 
        lowconvp_clrange_eta(i)=int(uvheight(kz)*eta_convert)
        exit
      endif
    end do
  end do
end subroutine convert_cloud_params

subroutine identify_cloud(ix,jy,lcw_tmp,lcwsum_tmp,nxlim,nylim, &
  ctwc_tmp,clwc_tmp,ciwc_tmp,icloudbot_tmp,icloudtop_tmp,rho_tmp, &
  tt_tmp,qv_tmp,uvzlev,wzlev)

  implicit none

  logical,intent(in) :: lcw_tmp,lcwsum_tmp
  integer, intent(in) :: ix,jy,nxlim,nylim
  real,intent(out) :: ctwc_tmp(0:nxlim,0:nylim)

  real,intent(inout) :: clwc_tmp(0:nxlim,0:nylim,nzmax)
  real,intent(in) :: ciwc_tmp(0:nxlim,0:nylim,nzmax)
  real,intent(in),dimension(0:nxlim,0:nylim,nzmax) :: rho_tmp,tt_tmp,qv_tmp
  real,intent(in),dimension(0:nxlim,0:nylim,nzmax) :: uvzlev,wzlev

  integer,intent(out) :: icloudbot_tmp(0:nxlim,0:nylim), icloudtop_tmp(0:nxlim,0:nylim)

  integer :: kz
  real :: pressure,rh
  real :: clw

  !*******************************************************************************
  if (lcw_tmp) then ! identify clouds based on cloud water content
  !*******************************************************************************

    ctwc_tmp(ix,jy) = 0. ! initialise cloud total water content
    if (.not.lcwsum_tmp) clwc_tmp(ix,jy,:) = clwc_tmp(ix,jy,:) + ciwc_tmp(ix,jy,:)
    do kz = 1,nz-1 ! Changed order of loop to prevent ETA computation to be done unnecessarily

      ! vertically integrate cloud water and determine cloud bottom, top
      ! cloud water per cell in kg / m2
      ! calculate cloud water mass per area: kgCW/kgAIR * kgAIR/m3 * m = kgCW/m2
      
      ! assuming rho is in kg/m3 and hz in m gives: kg/kg * kg/m3 *m3/kg /m = m2/m3
#ifdef ETA
      clw = clwc_tmp(ix,jy,kz)*rho_tmp(ix,jy,kz)*(uvzlev(ix,jy,kz+1)-uvzlev(ix,jy,kz))
#else
      clw = clwc_tmp(ix,jy,kz)*rho_tmp(ix,jy,kz)*(height(kz+1)-height(kz)) 
#endif
      ! Add this layer to column cloud water [m3/m3]
      ctwc_tmp(ix,jy) = ctwc_tmp(ix,jy)+clw ! kg / m2 (or eta) in column

      if (clw .gt. 0.) then ! cloud layer - maybe use threshold?
#ifdef ETA
        if (icloudbot_tmp(ix,jy) .eq. icmv) & !cloud bottom set to first cloud instance
          icloudbot_tmp(ix,jy) = int(uvheight(kz)*eta_convert)
        icloudtop_tmp(ix,jy) = int(uvheight(kz)*eta_convert) !After the loop, icloudtop will be the top
#else
        if (icloudbot_tmp(ix,jy) .eq. icmv) &
            icloudbot_tmp(ix,jy) = (height(kz))
          icloudtop_tmp(ix,jy) = (height(kz))
#endif
      endif
    end do

  !**************************************************************************
  else       ! identify clouds using relative humidity
  !**************************************************************************
    do kz = 1,nz-1 ! Changed order of loop to prevent ETA computation to be done unnecessarily
      pressure=rho_tmp(ix,jy,kz)*r_air*tt_tmp(ix,jy,kz)
      rh=qv_tmp(ix,jy,kz)/f_qvsat(pressure,tt_tmp(ix,jy,kz))
      ! PS if (prec.gt.0.01) print*,'relhum',prec,kz,rh,height(kz)
      if (rh .ge. rhmin) then
#ifdef ETA
        if (icloudbot_tmp(ix,jy) .eq. icmv) then
          icloudbot_tmp(ix,jy)=int(uvheight(kz)*eta_convert)
        endif
        icloudtop_tmp(ix,jy)=int(uvheight(kz) *eta_convert)
#else
        if (icloudbot_tmp(ix,jy) .eq. icmv) then
          icloudbot_tmp(ix,jy)=(height(kz))
        endif
        icloudtop_tmp(ix,jy)=(height(kz))
#endif

      endif
    end do
!**************************************************************************
  endif ! lcw true/false
!**************************************************************************
end subroutine identify_cloud

subroutine apply_cloud_bounds(ix,jy,nxlim,nylim,lsprec_tmp,convprec_tmp,uvzlev, &
  icloudbot_tmp,icloudtop_tmp,max_cloudthck_eta,conv_clrange_eta, &
  highconvp_clrange_eta,lowconvp_clrange_eta)
  
  implicit none

  integer, intent(in) :: ix,jy,nxlim,nylim

  real,intent(in) :: lsprec_tmp(0:nxlim,0:nylim,numpf),convprec_tmp(0:nxlim,0:nylim,numpf)
  real,intent(in),dimension(0:nxlim,0:nylim,nzmax) :: uvzlev

  ! converted parameters for eta coordinates:
  integer,intent(in) :: max_cloudthck_eta
  integer,intent(in),dimension(2) :: conv_clrange_eta,highconvp_clrange_eta,lowconvp_clrange_eta

  integer,intent(inout) :: icloudbot_tmp(0:nxlim,0:nylim), icloudtop_tmp(0:nxlim,0:nylim)

  integer :: icloudtop_old, min_cloudtop
  integer :: kz
  real :: lsp,convp,prec
  logical lconvectprec


  real,parameter :: precmin = 0.002 ! minimum prec in mm/h for cloud diagn.


  ! memorise icloudtop
  icloudtop_old = icloudtop_tmp(ix,jy)
  ! top level, kz=nz-1
  ! limit cloud top to 19 km:
#ifdef ETA
  ! Enforce maximum cloudtop height in eta coords
  if (icloudbot_tmp(ix,jy) .eq. icmv) then !Can we skip to the next gridcell?
    icloudtop_tmp(ix,jy)=icmv
  else if (icloudtop_tmp(ix,jy) .lt. max_cloudthck_eta) then
    icloudtop_tmp(ix,jy) = max_cloudthck_eta
  endif

  ! To compute the minimum thickness in eta coordinates, this needs
  ! to be computed from the bottom level:
  ! 1) Convert icloudbot_tmp to meter coordinates
  ! 2) Add the min_cloudthck to the icloudbot_tmp(meter)
  ! 3) Convert this back to eta coordinates (min_cloudtop(eta))
  ! 4) Check if our cloudtop is higher (lower eta) than this minimum
  do kz=1,nz
    if (int(uvheight(kz)*eta_convert).le.icloudbot_tmp(ix,jy)) then
      min_cloudtop = uvzlev(ix,jy,kz)+min_cloudthck ! In meters
      exit
    endif
  end do
  do kz=1,nz
    if (int(uvzlev(ix,jy,kz)).gt.min_cloudtop) then ! back to eta
      min_cloudtop=int(uvheight(kz)*eta_convert)
      exit
    endif
  enddo
  ! PS  get rid of too thin clouds   
  if (icloudtop_tmp(ix,jy) .gt. min_cloudtop) then
    icloudbot_tmp(ix,jy)=icmv
    icloudtop_tmp(ix,jy)=icmv
  endif
  ! PS implement a rough fix for badly represented convection
  ! PS is based on looking at a limited set of comparison data
  lsp=  sum(   lsprec_tmp(ix,jy,:) )
  convp=sum( convprec_tmp(ix,jy,:) )
  prec=lsp+convp
  if (lsp.gt.convp) then !  prectype='lsp'
    lconvectprec = .false.
  else ! prectype='cp '
    lconvectprec = .true.
  endif
  if (lconvectprec .and. prec .gt. precmin .and.  &
    (icloudtop_old .gt. conv_clrange_eta(2) .or. &
      icloudbot_tmp(ix,jy) .lt. conv_clrange_eta(1)) ) then
    if (convp .lt. 0.1) then
      icloudbot_tmp(ix,jy) = lowconvp_clrange_eta(1)
      icloudtop_tmp(ix,jy) = lowconvp_clrange_eta(2)
    else
      icloudbot_tmp(ix,jy) = highconvp_clrange_eta(1)
      icloudtop_tmp(ix,jy) = highconvp_clrange_eta(2)
    endif
  endif

  !---------------------------------------------------------------------------------------
#else
  if (icloudbot_tmp(ix,jy) .eq. icmv) then ! if no bottom found, no top either
    icloudtop_tmp(ix,jy)=icmv
  else if (icloudtop_tmp(ix,jy) .gt. max_cloudthck) then ! max cloud height
    icloudtop_tmp(ix,jy) = max_cloudthck
  endif
 ! PS  get rid of too thin clouds
  if (icloudtop_tmp(ix,jy) .lt. icloudbot_tmp(ix,jy) + min_cloudthck) then
    icloudbot_tmp(ix,jy)=icmv
    icloudtop_tmp(ix,jy)=icmv
  endif
  ! PS implement a rough fix for badly represented convection
  ! PS is based on looking at a limited set of comparison data
  lsp=  sum(   lsprec_tmp(ix,jy,:) )
  convp=sum( convprec_tmp(ix,jy,:) )
  prec=lsp+convp
  if (lsp.gt.convp) then !  prectype='lsp'
    lconvectprec = .false.
  else ! prectype='cp '
    lconvectprec = .true.
  endif
  if (lconvectprec .and. prec .gt. precmin .and.  &
    (icloudtop_old .lt. conv_clrange(2) .or. &
      icloudbot_tmp(ix,jy) .gt. conv_clrange(1)) ) then
    if (convp .lt. 0.1) then
      icloudbot_tmp(ix,jy) = lowconvp_clrange(1)
      icloudtop_tmp(ix,jy) = lowconvp_clrange(2)
    else
      icloudbot_tmp(ix,jy) = highconvp_clrange(1)
      icloudtop_tmp(ix,jy) = highconvp_clrange(2)
    endif
  endif
#endif
end subroutine apply_cloud_bounds

subroutine verttransform_gfs(n,uuh,vvh,wwh,pvh)
  !                          i  i   i   i   i
  !*****************************************************************************
  !                                                                            *
  !     This subroutine transforms temperature, dew point temperature and      *
  !     wind components from eta to meter coordinates.                         *
  !     The vertical wind component is transformed from Pa/s to m/s using      *
  !     the conversion factor pinmconv.                                        *
  !     In addition, this routine calculates vertical density gradients        *
  !     needed for the parameterization of the turbulent velocities.           *
  !                                                                            *
  !     Author: A. Stohl, G. Wotawa                                            *
  !                                                                            *
  !     12 August 1996                                                         *
  !     Update: 16 January 1998                                                *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************
  !  CHANGES                                                                   *
  !     Major update: 17 February 1999                                         *
  !     by G. Wotawa                                                           *
  !                                                                            *
  !     - Vertical levels for u, v and w are put together                      *
  !     - Slope correction for vertical velocity: Modification of calculation  *
  !       procedure                                                            *
  !                                                                            *
  !  Bernd C. Krueger, Feb. 2001:                                              *
  !   Variables tth and qvh (on eta coordinates) from common block             *
  !                                                                            *
  ! Sabine Eckhardt, March 2007:                                               *
  ! added the variable cloud for use with scavenging - descr. in com_mod       *
  ! PS/AT 2018/-21: variable "cloud" is replaced by quickfix, see below        * 
  !                                                                            *
  ! Unified ECMWF and GFS builds                                               *
  ! Marian Harustak, 12.5.2017                                                 *
  !     - Renamed from verttransform to verttransform_ecmwf                    *
  !                                                                            *
  !  undocumented modifications by NILU for v10                                *
  !                                                                            *
  !  Petra Seibert, 2018-06-13:                                                *
  !   - put back SAVE attribute for INIT, just to be safe                      *
  !   - minor changes, most of them just cosmetics                             *
  !   for details see changelog.txt in branch unive                            *
  !                                                                            *
  !  Petra Seibert, Anne Philipp, 2019-05-02: implement wetdepo quickfix       *
  !  Petra Seibert, Anne Tipka, 2020-11-19: reimplement in latest version      *
  !                                                                            *
  ! ****************************************************************************

  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! Note PS, AT 2021-01-29: all these fields are 0:nxmax-1,0:nymax-1 !!        *
  ! nx,ny,nz                        field dimensions in x,y and z direction    *
  ! icloudbot(0:nxmax,0:nymax,numwfmem) cloud bottom field for wet deposition  * 
  ! icloudtop(0:nxmax,0:nymax,numwfmem) cloud thickness for wet deposition    *
  ! uu(0:nxmax,0:nymax,nzmax,numwfmem)     wind components in x-direction [m/s]*
  ! vv(0:nxmax,0:nymax,nzmax,numwfmem)     wind components in y-direction [m/s]*
  ! ww(0:nxmax,0:nymax,nzmax,numwfmem)     wind components in z-direction      *
  !                                          [deltaeta/s]                      *
  ! tt(0:nxmax,0:nymax,nzmax,numwfmem)     temperature [K]                     *
  ! pv(0:nxmax,0:nymax,nzmax,numwfmem)     potential voriticity (pvu)          *
  ! ps(0:nxmax,0:nymax,numwfmem)           surface pressure [Pa]               *
  !                                                                            *
  !*****************************************************************************

  implicit none

  real,intent(in),dimension(0:nxmax-1,0:nymax-1,nuvzmax) :: uuh,vvh,pvh
  real,intent(in),dimension(0:nxmax-1,0:nymax-1,nwzmax)  :: wwh

  real,dimension(0:nxmax-1,0:nymax-1,nzmax) :: uvwzlev
  real,dimension(nuvzmax) :: rhoh
  real,dimension(nwzmax) :: wzlev
  real,dimension(nzmax) :: pinmconv

! local array introduced in v10 by ?? to achieve better loop order (PS)
  integer,dimension(0:nxmax-1,0:nymax-1) :: idx

  integer :: icloudtop_old
  integer :: ix,jy,kz,iz,n,kmin,kl,klp,ix1,jy1,ixp,jyp,ixm,jym,kz_inv
  real :: clw ! cloud water in kg / m2 in a grid cell
  real :: pressure,rh,lsp,convp,prec

  real :: pint,tv,tvold,pold,dz1,dz2,dz,ui,vi
  real :: xlon,ylat,xlonr,dzdx,dzdy
  real :: dzdx1,dzdx2,dzdy1,dzdy2,cosf
  real :: uuaux,vvaux,uupolaux,vvpolaux,ddpol,ffpol,wdummy
  
  real,parameter :: const=r_air/ga
  real,parameter :: precmin = 0.002 ! minimum prec in mm/h for cloud diagnostics

  logical lconvectprec
  logical, save :: init = .true. !PS 2018-06-13: add back save attribute

  ! NCEP version
  integer :: llev, i

  integer :: rank_thread , nr_threads 


  !*************************************************************************
  ! If verttransform is called the first time, initialize heights of the   *
  ! z levels in meter. The heights are the heights of model levels, where  *
  ! u,v,T and qv are given.                                                *
  !*************************************************************************

  if (init) then

  ! Search for a point with high surface pressure (i.e. not above significant topography)
  ! Then, use this point to construct a reference z profile, to be used at all times
  !*****************************************************************************
    call verttransform_init(n)
  
  ! Do not repeat initialization of the Cartesian z grid
  !*****************************************************

    init=.false.

  endif


  ! Loop over the whole grid
  !*************************
!$OMP DO
  do jy=0,nymin1
    do ix=0,nxmin1


!   if ((jy.eq.0).and.(ix.eq.0)) print*, 'in loop 1' 

  ! NCEP version: find first level above ground
      llev = 0
      do i=1,nuvz
        if (ps(ix,jy,1,n).lt.akz(i)) llev=i
      enddo
       llev = llev+1
       if (llev.gt.nuvz-2) llev = nuvz-2
  !     if (llev.eq.nuvz-2) write(*,*) 'verttransform
  !    +WARNING: LLEV eq NUZV-2'
  ! NCEP version


  ! compute height of pressure levels above ground
  !***********************************************

      tvold=tth(ix,jy,llev,n)*(1.+0.608*qvh(ix,jy,llev,n))
      pold=akz(llev)
      wzlev(llev)=0.
      uvwzlev(ix,jy,llev)=0.
      rhoh(llev)=pold/(r_air*tvold)

!    if ((jy.eq.0).and.(ix.eq.0)) print*, 'in loop 2'

      do kz=llev+1,nuvz
        pint=akz(kz)+bkz(kz)*ps(ix,jy,1,n)
        tv=tth(ix,jy,kz,n)*(1.+0.608*qvh(ix,jy,kz,n))
        rhoh(kz)=pint/(r_air*tv)

        if (abs(tv-tvold).gt.0.2) then
          uvwzlev(ix,jy,kz)=uvwzlev(ix,jy,kz-1)+const*log(pold/pint)* &
          (tv-tvold)/log(tv/tvold)
        else
          uvwzlev(ix,jy,kz)=uvwzlev(ix,jy,kz-1)+const*log(pold/pint)*tv
        endif
        wzlev(kz)=uvwzlev(ix,jy,kz)

        tvold=tv
        pold=pint
      enddo

  ! pinmconv=(h2-h1)/(p2-p1)
! if ((jy.eq.0).and.(ix.eq.0)) print*, 'in loop 3'

      pinmconv(llev)=(uvwzlev(ix,jy,llev+1)-uvwzlev(ix,jy,llev))/ &
           ((aknew(llev+1)+bknew(llev+1)*ps(ix,jy,1,n))- &
           (aknew(llev)+bknew(llev)*ps(ix,jy,1,n)))
      do kz=llev+1,nz-1
        pinmconv(kz)=(uvwzlev(ix,jy,kz+1)-uvwzlev(ix,jy,kz-1))/ &
             ((aknew(kz+1)+bknew(kz+1)*ps(ix,jy,1,n))- &
             (aknew(kz-1)+bknew(kz-1)*ps(ix,jy,1,n)))
      enddo
      pinmconv(nz)=(uvwzlev(ix,jy,nz)-uvwzlev(ix,jy,nz-1))/ &
           ((aknew(nz)+bknew(nz)*ps(ix,jy,1,n))- &
           (aknew(nz-1)+bknew(nz-1)*ps(ix,jy,1,n)))


  ! Levels, where u,v,t and q are given
  !************************************
! if ((jy.eq.0).and.(ix.eq.0)) print*, 'in loop 4'


      uu(ix,jy,1,n)=uuh(ix,jy,llev)
      vv(ix,jy,1,n)=vvh(ix,jy,llev)
      tt(ix,jy,1,n)=tth(ix,jy,llev,n)
      qv(ix,jy,1,n)=qvh(ix,jy,llev,n)

      
  ! IP & SEC, 201812 add clouds
      if (lcw) then
         clwc(ix,jy,1,n)=clwch(ix,jy,llev,n)
      endif 
      pv(ix,jy,1,n)=pvh(ix,jy,llev)
      rho(ix,jy,1,n)=rhoh(llev)
      pplev(ix,jy,1,n)=akz(llev)
      uu(ix,jy,nz,n)=uuh(ix,jy,nuvz)
      vv(ix,jy,nz,n)=vvh(ix,jy,nuvz)
      tt(ix,jy,nz,n)=tth(ix,jy,nuvz,n)
      qv(ix,jy,nz,n)=qvh(ix,jy,nuvz,n)
  ! IP & SEC, 201812 add clouds

   
      if (lcw) then
         clwc(ix,jy,nz,n)=clwch(ix,jy,nuvz,n)
      endif
      pv(ix,jy,nz,n)=pvh(ix,jy,nuvz)
      rho(ix,jy,nz,n)=rhoh(nuvz)
      pplev(ix,jy,nz,n)=akz(nuvz)
      kmin=llev+1

       
      do iz=2,nz-1
        do kz=kmin,nuvz
          ! print*, 'in loop 4.3.1', jy, ix, iz, kz  
          if (height(iz).gt.uvwzlev(ix,jy,nuvz)) then 
            uu(ix,jy,iz,n)=uu(ix,jy,nz,n)
            vv(ix,jy,iz,n)=vv(ix,jy,nz,n)
            tt(ix,jy,iz,n)=tt(ix,jy,nz,n)
            qv(ix,jy,iz,n)=qv(ix,jy,nz,n)
  ! IP & SEC, 201812 add clouds
            if (lcw) then
               clwc(ix,jy,iz,n)=clwc(ix,jy,nz,n)
            endif
            pv(ix,jy,iz,n)=pv(ix,jy,nz,n)
            rho(ix,jy,iz,n)=rho(ix,jy,nz,n)
            pplev(ix,jy,iz,n)=pplev(ix,jy,nz,n)
            exit
          endif
          if ((height(iz).gt.uvwzlev(ix,jy,kz-1)).and. &
           (height(iz).le.uvwzlev(ix,jy,kz))) then
            !real,dimension(0:nxmax-1,0:nymax-1,nzmax) :: uvwzlev
            dz1=height(iz)-uvwzlev(ix,jy,kz-1)
            dz2=uvwzlev(ix,jy,kz)-height(iz)
            dz=dz1+dz2
            uu(ix,jy,iz,n)=(uuh(ix,jy,kz-1)*dz2+uuh(ix,jy,kz)*dz1)/dz
            vv(ix,jy,iz,n)=(vvh(ix,jy,kz-1)*dz2+vvh(ix,jy,kz)*dz1)/dz
            tt(ix,jy,iz,n)=(tth(ix,jy,kz-1,n)*dz2+tth(ix,jy,kz,n)*dz1)/dz
            qv(ix,jy,iz,n)=(qvh(ix,jy,kz-1,n)*dz2+qvh(ix,jy,kz,n)*dz1)/dz

  ! IP & SEC, 201812 add clouds
            if (lcw) then
              clwc(ix,jy,iz,n)= &
                (clwch(ix,jy,kz-1,n)*dz2+clwch(ix,jy,kz,n)*dz1)/dz
            endif
            pv(ix,jy,iz,n)=(pvh(ix,jy,kz-1)*dz2+pvh(ix,jy,kz)*dz1)/dz

            rho(ix,jy,iz,n)=(rhoh(kz-1)*dz2+rhoh(kz)*dz1)/dz

            pplev(ix,jy,iz,n)=(akz(kz-1)*dz2+akz(kz)*dz1)/dz

          endif
        enddo
      enddo

 
  ! Interpolation of vertical motion (levels where w is given)
  !***********************************************************

      ww(ix,jy,1,n)=wwh(ix,jy,llev)*pinmconv(llev)
      ww(ix,jy,nz,n)=wwh(ix,jy,nwz)*pinmconv(nz)
      kmin=llev+1
      do iz=2,nz
        do kz=kmin,nwz
          if ((height(iz).gt.wzlev(kz-1)).and. &
           (height(iz).le.wzlev(kz))) then
            dz1=height(iz)-wzlev(kz-1)
            dz2=wzlev(kz)-height(iz)
            dz=dz1+dz2
            ww(ix,jy,iz,n)=(wwh(ix,jy,kz-1)*pinmconv(kz-1)*dz2 &
              +wwh(ix,jy,kz)*pinmconv(kz)*dz1)/dz
          endif
        enddo
      enddo

!if ((jy.eq.0).and.(ix.eq.0)) print*, 'in loop 6'
  ! Compute density gradients at intermediate levels
  !*************************************************

      drhodz(ix,jy,1,n)=(rho(ix,jy,2,n)-rho(ix,jy,1,n))/(height(2)-height(1))
      do kz=2,nz-1
        drhodz(ix,jy,kz,n)=(rho(ix,jy,kz+1,n)-rho(ix,jy,kz-1,n))/ &
          (height(kz+1)-height(kz-1))
      enddo
      drhodz(ix,jy,nz,n)=drhodz(ix,jy,nz-1,n)

    !if ((jy.eq.0).and.(ix.eq.0)) 


    enddo
  enddo
!$OMP END DO

  !****************************************************************
  ! Compute slope of eta levels in windward direction and resulting
  ! vertical wind correction
  !****************************************************************


!$OMP DO
  do jy=1,ny-2
    cosf=cos((real(jy)*dy+ylat0)*pi180)

    do ix=1,nx-2
   ! print*, '1] slope of eta levels jy, ix=',jy, ix 

   !if ((jy.le.2).and.(ix.eq.1)) print*, 'in eta loop 1'

  ! NCEP version: find first level above ground
      llev = 0
      do i=1,nuvz
       if (ps(ix,jy,1,n).lt.akz(i)) llev=i
      end do
      llev = llev+1

!if ((jy.le.2).and.(ix.eq.1)) print*, 'in eta loop 2'


      if (llev.gt.nuvz-2) llev = nuvz-2
  !     if (llev.eq.nuvz-2) write(*,*) 'verttransform
  !    +WARNING: LLEV eq NUZV-2'
  ! NCEP version

      kmin=llev+1

      !if ((jy.le.3).and.(ix.gt.250)) print*, 'in eta loop 3'

      do iz=2,nz-1

        ui=uu(ix,jy,iz,n)*dxconst/cosf
        vi=vv(ix,jy,iz,n)*dyconst

        klp=nz+1
        do kz=kmin,nz
 
          if ((height(iz).gt.uvwzlev(ix,jy,kz-1)).and. &
          (height(iz).le.uvwzlev(ix,jy,kz))) then
            dz1=height(iz)-uvwzlev(ix,jy,kz-1)
            dz2=uvwzlev(ix,jy,kz)-height(iz)
            dz=dz1+dz2
            kl=kz-1
            klp=kz
            exit
          endif

        enddo

        if (klp.eq.nz+1) then
          klp=nz
          kl=nz-1

         ! real,dimension(0:nxmax-1,0:nymax-1,nzmax) :: uvwzlev
         
          dz1=uvwzlev(ix,jy,klp)-uvwzlev(ix,jy,kl)


          dz2=0.
        endif

        ix1=ix-1
        jy1=jy-1
        ixp=ix+1
        jyp=jy+1

        dzdx1=(uvwzlev(ixp,jy,kl)-uvwzlev(ix1,jy,kl))*0.5
        dzdx2=(uvwzlev(ixp,jy,klp)-uvwzlev(ix1,jy,klp))*0.5
        dzdx=(dzdx1*dz2+dzdx2*dz1)/dz

        dzdy1=(uvwzlev(ix,jyp,kl)-uvwzlev(ix,jy1,kl))*0.5
        dzdy2=(uvwzlev(ix,jyp,klp)-uvwzlev(ix,jy1,klp))*0.5
        dzdy=(dzdy1*dz2+dzdy2*dz1)/dz

        ww(ix,jy,iz,n)=ww(ix,jy,iz,n)+(dzdx*ui+dzdy*vi)

      enddo ! z

      !if ((jy.le.3).and.(ix.eq.1)) print*, 'in eta loop end z jy=',jy


    enddo


  enddo
!$OMP END DO


  ! If north pole is in the domain, calculate wind velocities in polar
  ! stereographic coordinates
  !*******************************************************************

  if (nglobal) then
    do iz=1,nz
      do jy=int(switchnorthg)-2,nymin1
        ylat=ylat0+real(jy)*dy
        do ix=0,nxmin1
          xlon=xlon0+real(ix)*dx
          call cc2gll(northpolemap,ylat,xlon,uu(ix,jy,iz,n), &
               vv(ix,jy,iz,n),uupol(ix,jy,iz,n),vvpol(ix,jy,iz,n))
        enddo
      enddo
    enddo


    do iz=1,nz

      ! CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uu(nx/2-1,nymin1,iz,n)**2+vv(nx/2-1,nymin1,iz,n)**2)
      if (vv(nx/2-1,nymin1,iz,n).lt.0.) then
        ddpol=atan(uu(nx/2-1,nymin1,iz,n)/vv(nx/2-1,nymin1,iz,n))-xlonr
      elseif (vv(nx/2-1,nymin1,iz,n).gt.0.) then
        ddpol=pi+atan(uu(nx/2-1,nymin1,iz,n)/vv(nx/2-1,nymin1,iz,n))-xlonr
      else
        ddpol=pi*0.5-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.*pi+ddpol
      if(ddpol.gt.2.*pi) ddpol=ddpol-2.*pi

      ! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.
      xlonr=xlon*pi/180.
      ylat=90.
      uuaux=-ffpol*sin(xlonr+ddpol)
      vvaux=-ffpol*cos(xlonr+ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux,vvpolaux)
      jy=nymin1
      do ix=0,nxmin1
        uupol(ix,jy,iz,n)=uupolaux
        vvpol(ix,jy,iz,n)=vvpolaux
      enddo
      
    enddo


    ! Fix: Set W (vertical wind) at pole to the zonally averaged W of the next 
    ! equator-ward parallel 


    do iz=1,nz
      wdummy=0.
      jy=ny-2
      do ix=0,nxmin1
        wdummy=wdummy+ww(ix,jy,iz,n)
      enddo
      wdummy=wdummy/real(nx)
      jy=nymin1
      do ix=0,nxmin1
        ww(ix,jy,iz,n)=wdummy
      enddo
    enddo

  endif


  ! If south pole is in the domain, calculate wind velocities in polar
  ! stereographic coordinates
  !*******************************************************************

  if (sglobal) then
    do iz=1,nz
      do jy=0,int(switchsouthg)+3
        ylat=ylat0+real(jy)*dy
        do ix=0,nxmin1
          xlon=xlon0+real(ix)*dx
          call cc2gll(southpolemap,ylat,xlon,uu(ix,jy,iz,n), &
            vv(ix,jy,iz,n),uupol(ix,jy,iz,n),vvpol(ix,jy,iz,n))
        enddo
      enddo
    enddo

    do iz=1,nz

      ! CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uu(nx/2-1,0,iz,n)**2+vv(nx/2-1,0,iz,n)**2)
      if (vv(nx/2-1,0,iz,n).lt.0.) then
        ddpol=atan(uu(nx/2-1,0,iz,n)/vv(nx/2-1,0,iz,n))+xlonr
      elseif (vv(nx/2-1,0,iz,n).gt.0.) then
        ddpol=pi+atan(uu(nx/2-1,0,iz,n)/vv(nx/2-1,0,iz,n))-xlonr
      else
        ddpol=pi*0.5-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.*pi+ddpol
      if(ddpol.gt.2.*pi) ddpol=ddpol-2.*pi

      ! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.
      xlonr=xlon*pi/180.
      ylat=-90.
      uuaux=+ffpol*sin(xlonr-ddpol)
      vvaux=-ffpol*cos(xlonr-ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux,vvpolaux)

      jy=0
      do ix=0,nxmin1
        uupol(ix,jy,iz,n)=uupolaux
        vvpol(ix,jy,iz,n)=vvpolaux
      enddo
      
    enddo


    ! Fix: Set W at pole to the zonally averaged W of the next equator-
    ! ward parallel of latitude

    do iz=1,nz
      wdummy=0.
      jy=1
      do ix=0,nxmin1
        wdummy=wdummy+ww(ix,jy,iz,n)
      end do
      wdummy=wdummy/real(nx)
      jy=0
      do ix=0,nxmin1
        ww(ix,jy,iz,n)=wdummy
      enddo
    enddo
    
  endif


  ! PS, AT: for v10.5, we add back the quick fix to interpolate clouds in 
  !   interpol_rain.f90 developed by PS for v8 and extend it to using 
  !   cloud water fields

  !*******************************************************************************
  if (lcw) then ! identify clouds based on cloud water content
  !*******************************************************************************

    write(*,*) 'Global NCEP fields: using cloud water'
    
    ctwc(:,:,n)=0. ! initialise cloud total water content

    ! If water/ice are read separately into clwc and ciwc, store sum in clwc
    if (.not. lcwsum) clwc(:,:,:,n) = clwc(:,:,:,n) + ciwc(:,:,:,n)

    do kz = 1,nz-1
      do jy=0,nymin1
        do ix=0,nxmin1
          if (kz .eq. 1) then
            icloudbot(ix,jy,n) = icmv
!!          icloudtop=icmv ! this is just a local variable
!           we will use icloudtop as workspace for cloud top
          endif

          ! vertically integrate cloud water and determine cloud bottom, top
          ! cloud water per cell in kg / m2
          ! calculate cloud water mass per area: kgCW/kgAIR * kgAIR/m3 * m = kgCW/m2

          clw = clwc(ix,jy,kz,n)*rho(ix,jy,kz,n)*(height(kz+1)-height(kz)) 
          ! Add this layer to column cloud water [m3/m3]
          ctwc(ix,jy,n) = ctwc(ix,jy,n)+clw ! kg / m2 in column

          if (clw .gt. 0.) then ! cloud layer - maybe use threshold?
            if (icloudbot(ix,jy,n) .eq. icmv) &
              icloudbot(ix,jy,n) = nint(height(kz))
            icloudtop(ix,jy,n) = nint(height(kz))
          endif

          if (kz .eq. nz-1) then ! top level
            ! memorise icloudtop
            icloudtop_old = icloudtop(ix,jy,n)
            ! limit cloud top to 19 km:
            if (icloudtop(ix,jy,n) .gt. 19000) icloudtop(ix,jy,n) = 19000 
            if (icloudbot(ix,jy,n) .eq. icmv) then
              icloudtop(ix,jy,n) = icmv
            endif

           ! PS  get rid of too thin clouds      
            if (icloudtop(ix,jy,n) .lt. 50) then
              icloudbot(ix,jy,n)=icmv
              icloudtop(ix,jy,n)=icmv
            endif
            
            ! PS implement a rough fix for badly represented convection
            ! PS is based on looking at a limited set of comparison data
            lsp=  sum(   lsprec(ix,jy,1,:,n) )
            convp=sum( convprec(ix,jy,1,:,n) )
            prec=lsp+convp
            if (lsp.gt.convp) then !  prectype='lsp'
              lconvectprec = .false.
            else ! prectype='cp '
              lconvectprec = .true.
            endif
            if (lconvectprec .and. prec .gt. precmin .and.  &
              (icloudtop_old .lt. 6000 .or. icloudbot(ix,jy,n) .gt. 3000) ) then
              if (convp .lt. 0.1) then
                icloudbot(ix,jy,n) = 500
                icloudtop(ix,jy,n) =         8000
              else
                icloudbot(ix,jy,n) = 0
                icloudtop(ix,jy,n) =      10000
              endif
            endif
          endif ! end top level

        enddo ! ix loop
      enddo ! jy loop
    enddo ! kz loop


!**************************************************************************
  else       ! identify clouds using relative humidity
!**************************************************************************
!   clouds occur where rh>90% (using rh_ice for T<-20 deg C)

    write(*,*) 'NCEP fields: using relative humidity for cloud &
        &identification'
    do kz = 1,nz-1
      do jy=0,nymin1
        do ix=0,nxmin1

!PS       note that original by Sabine Eckhart was 80%
!PS       however, for T<-20 C we consider saturation over ice
!PS       so I think 90% should be enough          
          if (kz .eq. 1) then
            icloudbot(ix,jy,n) = icmv
!!          icloudtop=icmv ! this is just a local variable
!           we will use icloudtop as workspace for cloud top
          endif
!98        do kz=1,nz
          pressure=rho(ix,jy,kz,n)*r_air*tt(ix,jy,kz,n)
          rh=qv(ix,jy,kz,n)/f_qvsat(pressure,tt(ix,jy,kz,n))
!PS            if (prec.gt.0.01) print*,'relhum',prec,kz,rh,height(kz)
          if (rh .ge. rhmin) then
            if (icloudbot(ix,jy,n) .eq. icmv) then
              icloudbot(ix,jy,n)=nint(height(kz))! use int to save memory
            endif
            icloudtop(ix,jy,n)=nint(height(kz)) ! use int to save memory
          endif
!          enddo

!PS/AT 2021: in this version, we skip the iteration with smaller rhmin
!PS try to get a cloud thicker than 50 m 
!PS if there is at least .01 mm/h  - changed to 0.002 and put into
!PS parameter precpmin        
!          if ((icloudbot(ix,jy,n) .eq. icmv .or. &
!            icloudtop-icloudbot(ix,jy,n) .lt. 50) .and. prec .gt. precmin) then
!              rhmin = rhmin - 0.05
!              if (rhmin .ge. 0.30) goto 98 ! give up for <= 25% rel.hum.
!          endif
!          if (icloudtop .ne. icmv) then
!            icloudtop(ix,jy,n) = icloudtop-icloudbot(ix,jy,n)
!          else
!            icloudtop(ix,jy,n) = icmv
!          endif
    
          if (kz .eq. nz-1) then ! top level
          
            ! memorise icloudtop
            icloudtop_old = icloudtop(ix,jy,n)
            ! limit cloud top to 19 km:
            if (icloudtop(ix,jy,n) .gt. 19000) icloudtop(ix,jy,n) = 19000 
            if (icloudbot(ix,jy,n) .ne. icmv) then
              icloudtop(ix,jy,n) = icloudtop(ix,jy,n)-icloudbot(ix,jy,n)
            else
              icloudtop(ix,jy,n) = icmv
            endif

           ! PS  get rid of too thin clouds      
            if (icloudtop(ix,jy,n) .lt. 50) then
              icloudbot(ix,jy,n)=icmv
              icloudtop(ix,jy,n)=icmv
            endif
            
            ! PS implement a rough fix for badly represented convection
            ! PS is based on looking at a limited set of comparison data
            lsp=  sum(   lsprec(ix,jy,1,:,n) )
            convp=sum( convprec(ix,jy,1,:,n) )
            prec=lsp+convp
            if (lsp.gt.convp) then !  prectype='lsp'
              lconvectprec = .false.
            else ! prectype='cp '
              lconvectprec = .true.
            endif
            if (lconvectprec .and. prec .gt. precmin .and.  &
              (icloudtop_old .lt. 6000 .or. icloudbot(ix,jy,n) .gt. 3000) ) then
              if (convp .lt. 0.1) then
                icloudbot(ix,jy,n) = 500
                icloudtop(ix,jy,n) = 8000
              endif
            else
              icloudbot(ix,jy,n) = 0
              icloudtop(ix,jy,n) = 10000
            endif
            
          endif ! end top level

        enddo ! ix loop
      enddo ! jy loop
    enddo ! kz loop

!**************************************************************************
  endif ! lcw true/false
!**************************************************************************

end subroutine verttransform_gfs

subroutine verttransform_ecmwf_heights(nxlim,nylim, &
  tt2_tmp,td2_tmp,ps_tmp,qvh_tmp,tth_tmp,prsh_tmp, &
  rhoh_tmp,pinmconv,uvzlev,wzlev)

  implicit none

  integer, intent(in) :: nxlim,nylim
  real,intent(in),dimension(0:nxlim,0:nylim) :: tt2_tmp,td2_tmp,ps_tmp
  real,intent(in),dimension(0:nxlim,0:nylim,nuvzmax) :: qvh_tmp,tth_tmp
  real,intent(out),dimension(0:nxlim,0:nylim,nuvzmax) :: rhoh_tmp,prsh_tmp
  real,intent(out),dimension(0:nxlim,0:nylim,nzmax) :: pinmconv
  real,intent(out),dimension(0:nxlim,0:nylim,nuvzmax) :: uvzlev,wzlev
  !real,dimension(0:nxlim,0:nylim) :: tvold,pold,pint,tv
  real :: tvold,pold,pint,tv
  real,parameter :: const=r_air/ga
  integer :: ix,jy,kz

  ! Loop over the whole grid
  !*************************
!$OMP PARALLEL PRIVATE(jy,ix,pint,tv,tvold,pold,kz)
!$OMP DO
  do jy=0,nylim
    do ix=0,nxlim
      tvold=tt2_tmp(ix,jy)*(1.+0.378*ew(td2_tmp(ix,jy),ps_tmp(ix,jy))/ &
           ps_tmp(ix,jy))
      pold=ps_tmp(ix,jy)
      uvzlev(ix,jy,1)=0.
      wzlev(ix,jy,1)=0.
      rhoh_tmp(ix,jy,1)=pold/(r_air*tvold)
      prsh_tmp(ix,jy,1)=ps_tmp(ix,jy)

      do kz=2,nuvz
        pint=akz(kz)+bkz(kz)*ps_tmp(ix,jy)
        prsh_tmp(ix,jy,kz)=pint
        tv=tth_tmp(ix,jy,kz)*(1.+0.608*qvh_tmp(ix,jy,kz))
        rhoh_tmp(ix,jy,kz)=pint/(r_air*tv)

        if (abs(tv-tvold).gt.0.2) then
          uvzlev(ix,jy,kz)=uvzlev(ix,jy,kz-1)+const* &
               log(pold/pint)*(tv-tvold)/log(tv/tvold)
        else
          uvzlev(ix,jy,kz)=uvzlev(ix,jy,kz-1)+const* &
               log(pold/pint)*tv
        endif

        tvold=tv
        pold=pint

      end do

      do kz=2,nwz-1
        wzlev(ix,jy,kz)=(uvzlev(ix,jy,kz+1)+uvzlev(ix,jy,kz))*0.5
      end do
      wzlev(ix,jy,nwz)=wzlev(ix,jy,nwz-1)+ &
           uvzlev(ix,jy,nuvz)-uvzlev(ix,jy,nuvz-1)


      pinmconv(ix,jy,1)=(uvzlev(ix,jy,2))/ &
           ((aknew(2)+bknew(2)*ps_tmp(ix,jy))- &
           (aknew(1)+bknew(1)*ps_tmp(ix,jy)))
      do kz=2,nz-1
        pinmconv(ix,jy,kz)=(uvzlev(ix,jy,kz+1)-uvzlev(ix,jy,kz-1))/ &
             ((aknew(kz+1)+bknew(kz+1)*ps_tmp(ix,jy))- &
             (aknew(kz-1)+bknew(kz-1)*ps_tmp(ix,jy)))
      end do
      pinmconv(ix,jy,nz)=(uvzlev(ix,jy,nz)-uvzlev(ix,jy,nz-1))/ &
           ((aknew(nz)+bknew(nz)*ps_tmp(ix,jy))- &
           (aknew(nz-1)+bknew(nz-1)*ps_tmp(ix,jy)))
    end do
  end do
!$OMP END DO
!$OMP END PARALLEL

  ! pold(:,:)=ps_tmp(:,:)
  ! uvzlev(:,:,1)=0.
  ! wzlev(:,:,1)=0.
  ! rhoh_tmp(:,:,1)=pold(:,:)/(r_air*tvold(:,:))
  ! prsh_tmp(:,:,1)=ps_tmp(:,:)

  ! Compute heights of eta levels
  !******************************

  ! do kz=2,nuvz
  !   pint(:,:)=akz(kz)+bkz(kz)*ps_tmp(:,:)
  !   prsh_tmp(:,:,kz)=pint(:,:)
  !   tv(:,:)=tth_tmp(:,:,kz)*(1.+0.608*qvh_tmp(:,:,kz))
  !   rhoh_tmp(:,:,kz)=pint(:,:)/(r_air*tv(:,:))

  !   where (abs(tv(:,:)-tvold(:,:)).gt.0.2) 
  !     uvzlev(:,:,kz)=uvzlev(:,:,kz-1)+const*&
  !          &log(pold(:,:)/pint(:,:))* &
  !          (tv(:,:)-tvold(:,:))/&
  !          &log(tv(:,:)/tvold(:,:))
  !   elsewhere
  !     uvzlev(:,:,kz)=uvzlev(:,:,kz-1)+const*&
  !          &log(pold(:,:)/pint(:,:))*tv(:,:)
  !   endwhere

  !   tvold(:,:)=tv(:,:)
  !   pold(:,:)=pint(:,:)

  ! end do

  ! do kz=2,nwz-1
  !   wzlev(:,:,kz)=(uvzlev(:,:,kz+1)+uvzlev(:,:,kz))/2.
  ! end do
  ! wzlev(:,:,nwz)=wzlev(:,:,nwz-1)+ &
  !      uvzlev(:,:,nuvz)-uvzlev(:,:,nuvz-1)


  ! pinmconv(:,:,1)=(uvzlev(:,:,2))/ &
  !      ((aknew(2)+bknew(2)*ps_tmp(:,:))- &
  !      (aknew(1)+bknew(1)*ps_tmp(:,:)))
  ! do kz=2,nz-1
  !   pinmconv(:,:,kz)=(uvzlev(:,:,kz+1)-uvzlev(:,:,kz-1))/ &
  !        ((aknew(kz+1)+bknew(kz+1)*ps_tmp(:,:))- &
  !        (aknew(kz-1)+bknew(kz-1)*ps_tmp(:,:)))
  ! end do
  ! pinmconv(:,:,nz)=(uvzlev(:,:,nz)-uvzlev(:,:,nz-1))/ &
  !      ((aknew(nz)+bknew(nz)*ps_tmp(:,:))- &
  !      (aknew(nz-1)+bknew(nz-1)*ps_tmp(:,:)))
end subroutine verttransform_ecmwf_heights

subroutine verttransform_ecmwf_windfields_nest(l,n, &
  uuhn,vvhn,wwhn,pvhn,rhohn,prshn,pinmconv)

  implicit none

  integer,intent(in) :: l,n
  real,intent(in),dimension(0:nxmaxn-1,0:nymaxn-1,nuvzmax,numbnests) :: &
    uuhn,vvhn,pvhn
  real,intent(in),dimension(0:nxmaxn-1,0:nymaxn-1,nwzmax,numbnests) :: wwhn
  real,intent(in),dimension(0:nxmaxn-1,0:nymaxn-1,nuvzmax) :: rhohn
  real,intent(in),dimension(0:nxmaxn-1,0:nymaxn-1,nuvzmax) :: prshn
  real,intent(in),dimension(0:nxmaxn-1,0:nymaxn-1,nzmax) :: pinmconv
  real,dimension(0:nymaxn-1) :: cosf

  integer,dimension(0:nxmaxn-1,0:nymaxn-1) :: idx

  integer :: ix,jy,kz,iz,ix1,jy1,ixp,jyp

  real :: dz1,dz2,dz,dpdeta
  real :: dzdx,dzdy
  real :: dzdx1,dzdx2,dzdy1,dzdy2
  integer :: nxm1, nym1

  nxm1=nxn(l)-1 
  nym1=nyn(l)-1 

  ! Levels, where u,v,t and q are given
  !************************************
!$OMP PARALLEL PRIVATE(jy,ix,kz,dz1,dz2,dz,ix1,jy1,ixp,jyp,dzdx1,dzdx2,dzdx, &
!$OMP dzdy1,dzdy2,dzdy,dpdeta)

!$OMP DO
  do jy=0,nym1
    do ix=0,nxm1
      uun(ix,jy,1,n,l)=uuhn(ix,jy,1,l)
      vvn(ix,jy,1,n,l)=vvhn(ix,jy,1,l)
      ttn(ix,jy,1,n,l)=tthn(ix,jy,1,n,l)
#ifndef ETA
      qvn(ix,jy,1,n,l)=qvhn(ix,jy,1,n,l)
#endif
      if (lcw_nest(l)) then
        clwcn(ix,jy,1,n,l)=clwchn(ix,jy,1,n,l)
        if (.not.lcwsum_nest(l)) ciwcn(ix,jy,1,n,l)=ciwchn(ix,jy,1,n,l)
      end if
      pvn(ix,jy,1,n,l)=pvhn(ix,jy,1,l)
      rhon(ix,jy,1,n,l)=rhohn(ix,jy,1)
      prsn(ix,jy,1,n,l)=prshn(ix,jy,1)

      uun(ix,jy,nz,n,l)=uuhn(ix,jy,nuvz,l)
      vvn(ix,jy,nz,n,l)=vvhn(ix,jy,nuvz,l)
      ttn(ix,jy,nz,n,l)=tthn(ix,jy,nuvz,n,l)
#ifndef ETA
      qvn(ix,jy,nz,n,l)=qvhn(ix,jy,nuvz,n,l)
      if (lcw_nest(l)) then
        clwcn(ix,jy,nz,n,l)=clwchn(ix,jy,nuvz,n,l)
        if (.not.lcwsum_nest(l)) ciwcn(ix,jy,nz,n,l)=ciwchn(ix,jy,nuvz,n,l)
      endif
#endif
      pvn(ix,jy,nz,n,l)=pvhn(ix,jy,nuvz,l)
      rhon(ix,jy,nz,n,l)=rhohn(ix,jy,nuvz)
      prsn(ix,jy,nz,n,l)=prshn(ix,jy,nuvz)

      idx(ix,jy)=2
    enddo
  enddo
!$OMP END DO

  do iz=2,nz-1
!$OMP DO SCHEDULE(dynamic)
    do jy=0,nym1
      do ix=0,nxm1
        if(height(iz).gt.etauvheightn(ix,jy,nuvz,n,l)) then
          uun(ix,jy,iz,n,l)=uun(ix,jy,nz,n,l)
          vvn(ix,jy,iz,n,l)=vvn(ix,jy,nz,n,l)
          ttn(ix,jy,iz,n,l)=ttn(ix,jy,nz,n,l)
          pvn(ix,jy,iz,n,l)=pvn(ix,jy,nz,n,l)
#ifndef ETA
          qvn(ix,jy,iz,n,l)=qvn(ix,jy,nz,n,l)
          !hg adding the cloud water
          if (lcw_nest(l)) then
            clwcn(ix,jy,iz,n,l)=clwcn(ix,jy,nz,n,l)
            if (.not.lcwsum_nest(l)) ciwcn(ix,jy,iz,n,l)=ciwcn(ix,jy,nz,n,l)
          endif
#endif
          rhon(ix,jy,iz,n,l)=rhon(ix,jy,nz,n,l)
          prsn(ix,jy,iz,n,l)=prsn(ix,jy,nz,n,l)
        else
          innuvz: do kz=idx(ix,jy),nuvz
            if ((idx(ix,jy).lt.kz).and. & 
              (height(iz).gt.etauvheightn(ix,jy,kz-1,n,l)).and. &
              (height(iz).le.etauvheightn(ix,jy,kz,n,l))) then
              idx(ix,jy)=kz
              exit innuvz
            endif
          enddo innuvz
        endif

        if(height(iz).le.etauvheightn(ix,jy,nuvz,n,l)) then
          kz=idx(ix,jy)
          dz1=height(iz)-etauvheightn(ix,jy,kz-1,n,l)
          dz2=etauvheightn(ix,jy,kz,n,l)-height(iz)
          dz=dz1+dz2
          uun(ix,jy,iz,n,l)=(uuhn(ix,jy,kz-1,l)*dz2+uuhn(ix,jy,kz,l)*dz1)/dz
          vvn(ix,jy,iz,n,l)=(vvhn(ix,jy,kz-1,l)*dz2+vvhn(ix,jy,kz,l)*dz1)/dz
          ttn(ix,jy,iz,n,l)=(tthn(ix,jy,kz-1,n,l)*dz2 &
               +tthn(ix,jy,kz,n,l)*dz1)/dz
          pvn(ix,jy,iz,n,l)=(pvhn(ix,jy,kz-1,l)*dz2+pvhn(ix,jy,kz,l)*dz1)/dz
#ifndef ETA
          qvn(ix,jy,iz,n,l)=(qvhn(ix,jy,kz-1,n,l)*dz2 &
               +qvhn(ix,jy,kz,n,l)*dz1)/dz
          !hg adding the cloud water
          if (lcw_nest(l)) then
            clwcn(ix,jy,iz,n,l)=(clwchn(ix,jy,kz-1,n,l)*dz2+clwchn(ix,jy,kz,n,l)*dz1)/dz
            if (.not.lcwsum_nest(l)) ciwcn(ix,jy,iz,n,l) = &
              (ciwchn(ix,jy,kz-1,n,l)*dz2+ciwchn(ix,jy,kz,n,l)*dz1)/dz
          end if
#endif
          rhon(ix,jy,iz,n,l)=(rhohn(ix,jy,kz-1)*dz2+rhohn(ix,jy,kz)*dz1)/dz
          prsn(ix,jy,iz,n,l)=(prshn(ix,jy,kz-1)*dz2+prshn(ix,jy,kz)*dz1)/dz
        endif
      enddo
    enddo
!$OMP END DO
!$OMP BARRIER
  enddo

  ! Interpolation of vertical motion (levels where w is given)
  !***********************************************************

!$OMP DO
  do jy=0,nym1
    do ix=0,nxm1
      idx(ix,jy)=2
      wwn(ix,jy,1,n,l)=wwhn(ix,jy,1,l)*pinmconv(ix,jy,1)
      wwn(ix,jy,nz,n,l)=wwhn(ix,jy,nwz,l)*pinmconv(ix,jy,nz)
    enddo
  enddo
!$OMP END DO

  do iz=2,nz-1
!$OMP DO SCHEDULE(dynamic)
    do jy=0,nym1
      do ix=0,nxm1

        inn: do kz=idx(ix,jy),nwz
          if((idx(ix,jy).le.kz) .and. &
            (height(iz).gt.etawheightn(ix,jy,kz-1,n,l)).and. &
            (height(iz).le.etawheightn(ix,jy,kz,n,l))) then
            idx(ix,jy)=kz
            exit inn
          endif
        enddo inn

        kz=idx(ix,jy)
        dz1=height(iz)-etawheightn(ix,jy,kz-1,n,l)
        dz2=etawheightn(ix,jy,kz,n,l)-height(iz)
        dz=dz1+dz2
        wwn(ix,jy,iz,n,l)=(wwhn(ix,jy,kz-1,l)*pinmconv(ix,jy,kz-1)*dz2 &
             +wwhn(ix,jy,kz,l)*pinmconv(ix,jy,kz)*dz1)/dz
        drhodzn(ix,jy,iz,n,l)=(rhon(ix,jy,iz+1,n,l)-rhon(ix,jy,iz-1,n,l))/ &
             (height(iz+1)-height(iz-1))
      enddo
    enddo
!$OMP END DO
!$OMP BARRIER
  enddo

  ! Compute density gradients at intermediate levels
  !*************************************************
!$OMP DO
  do jy=0,nym1
    do ix=0,nxm1
      drhodzn(ix,jy,nz,n,l)=drhodzn(ix,jy,nz-1,n,l)
      drhodzn(ix,jy,1,n,l)=(rhon(ix,jy,2,n,l)-rhon(ix,jy,1,n,l))/ &
           (height(2)-height(1))
    end do
  end do
!$OMP END DO

  !****************************************************************
  ! Compute slope of eta levels in windward direction and resulting
  ! vertical wind correction
  !****************************************************************

!$OMP DO
  do jy=1,nyn(l)-2
    cosf(jy)=1./cos((real(jy)*dyn(l)+ylat0n(l))*pi180)
    do ix=1,nxn(l)-2
      idx(ix,jy)=2
    enddo
  enddo
!$OMP END DO

  do iz=2,nz-1
!$OMP DO SCHEDULE(guided)
    do jy=1,nyn(l)-2
      do ix=1,nxn(l)-2

        inneta: do kz=idx(ix,jy),nz
          if((idx(ix,jy).le.kz).and. &
            (height(iz).gt.etauvheightn(ix,jy,kz-1,n,l)).and. &
            (height(iz).le.etauvheightn(ix,jy,kz,n,l))) then
            idx(ix,jy)=kz
            exit inneta
          endif
        enddo inneta

        kz=idx(ix,jy)
        dz1=height(iz)-etauvheightn(ix,jy,kz-1,n,l)
        dz2=etauvheightn(ix,jy,kz,n,l)-height(iz)
        dz=dz1+dz2
        ix1=ix-1
        jy1=jy-1
        ixp=ix+1
        jyp=jy+1

        dzdx1=(etauvheightn(ixp,jy,kz-1,n,l)-etauvheightn(ix1,jy,kz-1,n,l))*0.5
        dzdx2=(etauvheightn(ixp,jy,kz,n,l)-etauvheightn(ix1,jy,kz,n,l))*0.5
        dzdx=(dzdx1*dz2+dzdx2*dz1)/dz

        dzdy1=(etauvheightn(ix,jyp,kz-1,n,l)-etauvheightn(ix,jy1,kz-1,n,l))*0.5
        dzdy2=(etauvheightn(ix,jyp,kz,n,l)-etauvheightn(ix,jy1,kz,n,l))*0.5
        dzdy=(dzdy1*dz2+dzdy2*dz1)/dz

        wwn(ix,jy,iz,n,l)=wwn(ix,jy,iz,n,l) + &
          (dzdx*uun(ix,jy,iz,n,l)*dxconst*xresoln(l)*cosf(jy)+ &
          dzdy*vvn(ix,jy,iz,n,l)*dyconst*yresoln(l))

      enddo
    enddo
!$OMP END DO
!$OMP BARRIER
  enddo

  ! Keep original fields if wind_coord_type==ETA
#ifdef ETA
!$OMP DO

    do kz=1,nz
      do jy=0,nym1
        do ix=0,nxm1
          uuetan(ix,jy,kz,n,l) = uuhn(ix,jy,kz,l)
          vvetan(ix,jy,kz,n,l) = vvhn(ix,jy,kz,l)
          ttetan(ix,jy,kz,n,l) = tthn(ix,jy,kz,n,l)
          qvn(ix,jy,kz,n,l) = qvhn(ix,jy,kz,n,l)
          pvetan(ix,jy,kz,n,l) = pvhn(ix,jy,kz,l)
          rhoetan(ix,jy,kz,n,l) = rhohn(ix,jy,kz)
          prsetan(ix,jy,kz,n,l) = prshn(ix,jy,kz)
          ! eq A11 from Mid-latitude atmospheric dynamics by Jonathan E. Martin
          ! tvirtualn(ix,jy,kz,n,l)=ttetan(ix,jy,kz,n,l)* &  
          !   ((qvn(ix,jy,kz,n,l)+0.622)/(0.622*qvn(ix,jy,kz,n,l)+0.622))
          if ((kz.gt.1).and.(kz.lt.nz)) drhodzetan(ix,jy,kz,n,l)= &
            (rhohn(ix,jy,kz+1)-rhohn(ix,jy,kz-1))/(height(kz+1)-height(kz-1))
          if (lcw) then
            clwcn(ix,jy,kz,n,l)=clwchn(ix,jy,kz,n,l)
            if (.not.lcwsum_nest(l)) ciwcn(ix,jy,kz,n,l)=ciwchn(ix,jy,kz,n,l)
          endif
        end do
      end do
    end do
!$OMP END DO

!$OMP DO
    do jy=0,nym1
      do ix=0,nxm1
        drhodzetan(ix,jy,1,n,l)=(rhoetan(ix,jy,2,n,l)-rhoetan(ix,jy,1,n,l))/ &
             (height(2)-height(1))
        drhodzetan(ix,jy,nz,n,l)=drhodzetan(ix,jy,nz-1,n,l)
        ! tvirtualn(ix,jy,1,n,l)=tt2n(ix,jy,1,n,l)* &
        !   (1.+0.378*ew(td2n(ix,jy,1,n,l),psn(ix,jy,1,n,l))/ps(ix,jy,1,n,l))
        
        ! Convert w from Pa/s to eta/s, following FLEXTRA
        !************************************************
        do kz=1,nuvz-1
          if (kz.eq.1) then
            dpdeta=(akm(kz+1)-akm(kz)+(bkm(kz+1)-bkm(kz))*ps(ix,jy,1,n))/ &
              (wheight(kz+1)-wheight(kz))
          else if (kz.eq.nuvz-1) then
            dpdeta=(akm(kz)-akm(kz-1)+(bkm(kz)-bkm(kz-1))*ps(ix,jy,1,n))/ &
              (wheight(kz)-wheight(kz-1))
          else
            dpdeta=(akm(kz+1)-akm(kz-1)+(bkm(kz+1)-bkm(kz-1))*ps(ix,jy,1,n))/ &
              (wheight(kz+1)-wheight(kz-1))
          endif
          wwetan(ix,jy,kz,n,l)=wwhn(ix,jy,kz,l)/dpdeta
        enddo
        wwetan(ix,jy,nuvz,n,l)=wwetan(ix,jy,nuvz-1,n,l)
      enddo
    enddo 
!$OMP END DO
#endif
!$OMP END PARALLEL
end subroutine verttransform_ecmwf_windfields_nest

end module verttransform_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readwind_nests(indj,n,uuhn,vvhn,wwhn)
  !                           i   i  o    o    o
  !*****************************************************************************
  !                                                                            *
  !     This routine reads the wind fields for the nested model domains.       *
  !     It is similar to subroutine readwind, which reads the mother domain.   *
  !                                                                            *
  !     Authors: A. Stohl, G. Wotawa                                           *
  !                                                                            *
  !     8 February 1999                                                        *
  !                                                                            *
  !     Last update: 17 October 2000, A. Stohl                                 *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:                                     *
  !        Variables tthn and qvhn (on eta coordinates) in common block        *
  !  CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with ECMWF grib_api    *
  !  CHANGE: 03/12/2008, Harald Sodemann, update to f90 with ECMWF grib_api    *
  !*****************************************************************************

  use grib_api
  use par_mod
  use com_mod

  implicit none

  !HSO  parameters for grib_api
  integer :: ifile
  integer :: iret
  integer :: igrib
  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
  integer :: gotGrid
  !HSO  end

  real :: uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
  real :: wwhn(0:nxmaxn-1,0:nymaxn-1,nwzmax,maxnests)
  integer :: indj,i,j,k,n,levdiff2,ifield,iumax,iwmax,l

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  ! dimension of isec2 at least (22+n), where n is the number of parallels or
  ! meridians in a quasi-regular (reduced) Gaussian or lat/long grid

  ! dimension of zsec2 at least (10+nn), where nn is the number of vertical
  ! coordinate parameters

  integer :: isec1(56),isec2(22+nxmaxn+nymaxn)
  real(kind=4) :: zsec4(jpunp)
  real(kind=8) :: xauxin,yauxin
  real(kind=4) :: xaux,yaux,xaux0,yaux0
  real :: ewss(0:nxmaxn-1,0:nymaxn-1),nsss(0:nxmaxn-1,0:nymaxn-1)
  real :: plev1,pmean,tv,fu,hlev1,ff10m,fflev1

  logical :: hflswitch,strswitch

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: gribFunction = 'readwind_nests'

  do l=1,numbnests
    hflswitch=.false.
    strswitch=.false.
    levdiff2=nlev_ec-nwz+1
    iumax=0
    iwmax=0

    ifile=0
    igrib=0
    iret=0

  !
  ! OPENING OF DATA FILE (GRIB CODE)
  !

5   call grib_open_file(ifile,path(numpath+2*(l-1)+1) &
         (1:length(numpath+2*(l-1)+1))//trim(wfnamen(l,indj)),'r')
  if (iret.ne.GRIB_SUCCESS) then
    goto 888   ! ERROR DETECTED
  endif
  !turn on support for multi fields messages */
  !call grib_multi_support_on

    gotGrid=0
    ifield=0
10   ifield=ifield+1
  !
  ! GET NEXT FIELDS
  !
  call grib_new_from_file(ifile,igrib,iret)
  if (iret.eq.GRIB_END_OF_FILE)  then
    goto 50    ! EOF DETECTED
  elseif (iret.ne.GRIB_SUCCESS) then
    goto 888   ! ERROR DETECTED
  endif

  !first see if we read GRIB1 or GRIB2
  call grib_get_int(igrib,'editionNumber',gribVer,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  if (gribVer.eq.1) then ! GRIB Edition 1

  !print*,'GRiB Edition 1'
  !read the grib2 identifiers
  call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',isec1(8),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !change code for etadot to code for omega
  if (isec1(6).eq.77) then
    isec1(6)=135
  endif

  else

  !print*,'GRiB Edition 2'
  !read the grib2 identifiers
  call grib_get_int(igrib,'discipline',discipl,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterCategory',parCat,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterNumber',parNum,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',valSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !print*,discipl,parCat,parNum,typSurf,valSurf

  !convert to grib1 identifiers
  isec1(6)=-1
  isec1(7)=-1
  isec1(8)=-1
  isec1(8)=valSurf     ! level
  if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! T
    isec1(6)=130         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105)) then ! U
    isec1(6)=131         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105)) then ! V
    isec1(6)=132         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! Q
    isec1(6)=133         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1)) then !SP
    isec1(6)=134         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
    isec1(6)=135         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
    isec1(6)=151         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103)) then ! 10U
    isec1(6)=165         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103)) then ! 10V
    isec1(6)=166         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103)) then ! 2T
    isec1(6)=167         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103)) then ! 2D
    isec1(6)=168         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
    isec1(6)=141         ! indicatorOfParameter
  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
    isec1(6)=164         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
    isec1(6)=142         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
    isec1(6)=143         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SHF
    isec1(6)=146         ! indicatorOfParameter
  elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
    isec1(6)=176         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
    isec1(6)=180         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
    isec1(6)=181         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
    isec1(6)=129         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
    isec1(6)=160         ! indicatorOfParameter
  elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
       (typSurf.eq.1)) then ! LSM
    isec1(6)=172         ! indicatorOfParameter
  else
    print*,'***ERROR: undefined GRiB2 message found!',discipl, &
         parCat,parNum,typSurf
  endif

  endif

  !HSO  get the size and data of the values array
  if (isec1(6).ne.-1) then
    call grib_get_real4_array(igrib,'values',zsec4,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
  endif

  !HSO  get the required fields from section 2 in a gribex compatible manner
  if(ifield.eq.1) then
  call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
       isec2(2),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
       isec2(3),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'numberOfVerticalCoordinateValues', &
       isec2(12))
  call grib_check(iret,gribFunction,gribErrorMsg)
  ! CHECK GRID SPECIFICATIONS
  if(isec2(2).ne.nxn(l)) stop &
       'READWIND: NX NOT CONSISTENT FOR A NESTING LEVEL'
  if(isec2(3).ne.nyn(l)) stop &
       'READWIND: NY NOT CONSISTENT FOR A NESTING LEVEL'
  if(isec2(12)/2-1.ne.nlev_ec) stop 'READWIND: VERTICAL DISCRET&
       &IZATION NOT CONSISTENT FOR A NESTING LEVEL'
  endif ! ifield

  !HSO  get the second part of the grid dimensions only from GRiB1 messages
  if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
    call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
         xauxin,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
         yauxin,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    xaux=xauxin
    yaux=yauxin
    xaux0=xlon0n(l)
    yaux0=ylat0n(l)
    if(xaux.lt.0.) xaux=xaux+360.
    if(yaux.lt.0.) yaux=yaux+360.
    if(xaux0.lt.0.) xaux0=xaux0+360.
    if(yaux0.lt.0.) yaux0=yaux0+360.
    if(xaux.ne.xaux0) &
         stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT FOR A NES&
         &TING LEVEL'
    if(yaux.ne.yaux0) &
         stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT FOR A NEST&
         &ING LEVEL'
    gotGrid=1
  endif

    do j=0,nyn(l)-1
      do i=0,nxn(l)-1
        k=isec1(8)
        if(isec1(6).eq.130) tthn(i,j,nlev_ec-k+2,n,l)= &!! TEMPERATURE
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.131) uuhn(i,j,nlev_ec-k+2,l)= &!! U VELOCITY
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.132) vvhn(i,j,nlev_ec-k+2,l)= &!! V VELOCITY
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.133) then                         !! SPEC. HUMIDITY
          qvhn(i,j,nlev_ec-k+2,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if (qvhn(i,j,nlev_ec-k+2,n,l) .lt. 0.) &
               qvhn(i,j,nlev_ec-k+2,n,l) = 0.
  !          this is necessary because the gridded data may contain
  !          spurious negative values
        endif
        if(isec1(6).eq.134) psn(i,j,1,n,l)= &!! SURF. PRESS.
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.135) wwhn(i,j,nlev_ec-k+1,l)= &!! W VELOCITY
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.141) sdn(i,j,1,n,l)= &!! SNOW DEPTH
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.151) msln(i,j,1,n,l)= &!! SEA LEVEL PRESS.
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.164) tccn(i,j,1,n,l)= &!! CLOUD COVER
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.165) u10n(i,j,1,n,l)= &!! 10 M U VELOCITY
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.166) v10n(i,j,1,n,l)= &!! 10 M V VELOCITY
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.167) tt2n(i,j,1,n,l)= &!! 2 M TEMPERATURE
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.168) td2n(i,j,1,n,l)= &!! 2 M DEW POINT
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.142) then                         !! LARGE SCALE PREC.
          lsprecn(i,j,1,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if (lsprecn(i,j,1,n,l).lt.0.) lsprecn(i,j,1,n,l)=0.
        endif
        if(isec1(6).eq.143) then                         !! CONVECTIVE PREC.
          convprecn(i,j,1,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if (convprecn(i,j,1,n,l).lt.0.) convprecn(i,j,1,n,l)=0.
        endif
        if(isec1(6).eq.146) sshfn(i,j,1,n,l)= &!! SENS. HEAT FLUX
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if((isec1(6).eq.146).and. &
             (zsec4(nxn(l)*(nyn(l)-j-1)+i+1).ne.0.)) hflswitch=.true.    ! Heat flux available
        if(isec1(6).eq.176) then                         !! SOLAR RADIATION
          ssrn(i,j,1,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if (ssrn(i,j,1,n,l).lt.0.) ssrn(i,j,1,n,l)=0.
        endif
        if(isec1(6).eq.180) ewss(i,j)= &!! EW SURFACE STRESS
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.181) nsss(i,j)= &!! NS SURFACE STRESS
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(((isec1(6).eq.180).or.(isec1(6).eq.181)).and. &
             (zsec4(nxn(l)*(nyn(l)-j-1)+i+1).ne.0.)) strswitch=.true.    ! stress available
        if(isec1(6).eq.129) oron(i,j,l)= &!! ECMWF OROGRAPHY
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
        if(isec1(6).eq.160) excessoron(i,j,l)= &!! STANDARD DEVIATION OF OROGRAPHY
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.172) lsmn(i,j,l)= &!! ECMWF LAND SEA MASK
             zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
        if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
        if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+1)

      end do
    end do

  call grib_release(igrib)
  goto 10                      !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !
50   call grib_close_file(ifile)

  !error message if no fields found with correct first longitude in it
  if (gotGrid.eq.0) then
    print*,'***ERROR: input file needs to contain GRiB1 formatted'// &
         'messages'
    stop
  endif

  if(levdiff2.eq.0) then
    iwmax=nlev_ec+1
    do i=0,nxn(l)-1
      do j=0,nyn(l)-1
        wwhn(i,j,nlev_ec+1,l)=0.
      end do
    end do
  endif

  do i=0,nxn(l)-1
    do j=0,nyn(l)-1
      surfstrn(i,j,1,n,l)=sqrt(ewss(i,j)**2+nsss(i,j)**2)
    end do
  end do

  if ((.not.hflswitch).or.(.not.strswitch)) then
    write(*,*) 'WARNING: No flux data contained in GRIB file ', &
         wfnamen(l,indj)

  ! CALCULATE USTAR AND SSHF USING THE PROFILE METHOD
  ! As ECMWF has increased the model resolution, such that now the first model
  ! level is at about 10 m (where 10-m wind is given), use the 2nd ECMWF level
  ! (3rd model level in FLEXPART) for the profile method
  !***************************************************************************

    do i=0,nxn(l)-1
      do j=0,nyn(l)-1
        plev1=akz(3)+bkz(3)*psn(i,j,1,n,l)
        pmean=0.5*(psn(i,j,1,n,l)+plev1)
        tv=tthn(i,j,3,n,l)*(1.+0.61*qvhn(i,j,3,n,l))
        fu=-r_air*tv/ga/pmean
        hlev1=fu*(plev1-psn(i,j,1,n,l))   ! HEIGTH OF FIRST MODEL LAYER
        ff10m= sqrt(u10n(i,j,1,n,l)**2+v10n(i,j,1,n,l)**2)
        fflev1=sqrt(uuhn(i,j,3,l)**2+vvhn(i,j,3,l)**2)
        call pbl_profile(psn(i,j,1,n,l),td2n(i,j,1,n,l),hlev1, &
             tt2n(i,j,1,n,l),tthn(i,j,3,n,l),ff10m,fflev1, &
             surfstrn(i,j,1,n,l),sshfn(i,j,1,n,l))
        if(sshfn(i,j,1,n,l).gt.200.) sshfn(i,j,1,n,l)=200.
        if(sshfn(i,j,1,n,l).lt.-400.) sshfn(i,j,1,n,l)=-400.
      end do
    end do
  endif


  ! Assign 10 m wind to model level at eta=1.0 to have one additional model
  ! level at the ground
  ! Specific humidity is taken the same as at one level above
  ! Temperature is taken as 2 m temperature
  !**************************************************************************

    do i=0,nxn(l)-1
      do j=0,nyn(l)-1
        uuhn(i,j,1,l)=u10n(i,j,1,n,l)
        vvhn(i,j,1,l)=v10n(i,j,1,n,l)
        qvhn(i,j,1,n,l)=qvhn(i,j,2,n,l)
        tthn(i,j,1,n,l)=tt2n(i,j,1,n,l)
      end do
    end do

    if(iumax.ne.nuvz-1) stop &
         'READWIND: NUVZ NOT CONSISTENT FOR A NESTING LEVEL'
    if(iwmax.ne.nwz) stop &
         'READWIND: NWZ NOT CONSISTENT FOR A NESTING LEVEL'

  end do

  return
888   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfnamen(l,indj),' FOR NESTING LEVEL  #### '
  write(*,*) ' #### ',l,' IS NOT GRIB FORMAT !!!           #### '
  stop 'Execution terminated'


999   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### '
  write(*,*) ' #### ',wfnamen(l,indj),'                    #### '
  write(*,*) ' #### CANNOT BE OPENED FOR NESTING LEVEL ',l,'####'

end subroutine readwind_nests

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module totals_mod

  !*****************************************************************************
  !                                                                            *
  !    This module contains variables and subroutines for injecting mass       *
  !    into particles based on gridded emissions estimates                     *
  !                                                                            *
  !*****************************************************************************

  use netcdf
  use par_mod,           only: dp
  use com_mod
  use netcdf_output_mod, only: nf90_err

  implicit none

    character(len=256) :: fn_totals
    integer            :: nc_id, specdim_id, reagdim_id, timedim_id, nchardim_id
    integer            :: time_id, spec_id, cl_id, emis_id, efld_id, eres_id, mass_id
    real(kind=dp), dimension(:,:), allocatable :: chem_loss
    real(kind=dp), dimension(:), allocatable   :: tot_mass
    real(kind=dp), dimension(:), allocatable   :: tot_em_up
    real(kind=dp), dimension(:), allocatable   :: tot_em_res
    real(kind=dp), dimension(:), allocatable   :: tot_em_field

  contains

  subroutine alloc_totals

  !*****************************************************************************
  !                                                                            *
  !    Allocate variables for totals                                           *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer :: stat

    allocate(chem_loss(nreagent,nspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate totals arrays"
    chem_loss(:,:)=0.

    allocate( tot_mass(nspec) )
    allocate( tot_em_up(nspec) )
    allocate( tot_em_field(nspec) )
    allocate( tot_em_res(nspec) )

  end subroutine alloc_totals

  subroutine totals_init()

  !*****************************************************************************
  !                                                                            *
  !    This subroutine initializes the totals output                           *
  !                                                                            *
  !    Author: S. Henne                                                        *
  !    Adapted by R. Thompson for v11, Feb-2024                                *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=10)  :: time
    character(len=8)   :: date
    character(len=5)   :: zone
    character(len=8)   :: adate
    character(len=6)   :: atime
    character(len=32)  :: timeunit
    character(len=256) :: host_name, login_name
    integer :: ks

    ! get string of start time
    write(adate,'(i8.8)') ibdate
    write(atime,'(i6.6)') ibtime
    timeunit = 'seconds since '//adate(1:4)//'-'//adate(5:6)// &
                 '-'//adate(7:8)//' '//atime(1:2)//':'//atime(3:4)

    ! get run info 
    call date_and_time(date,time,zone)
    call getlog(login_name)
    call hostnm(host_name)

    ! file name
    fn_totals=trim(path(2)(1:length(2)))//'totals.nc'

    ! open new file handle
    call nf90_err( nf90_create(trim(fn_totals), cmode=nf90_hdf5, ncid=nc_id) )

    ! define dimensions
    !******************

    call nf90_err( nf90_def_dim(nc_id, "species", nspec, specdim_id) )
    call nf90_err( nf90_def_dim(nc_id, "reagents", nreagent, reagdim_id) )
    call nf90_err( nf90_def_dim(nc_id, "time", nf90_unlimited, timedim_id) )
    call nf90_err( nf90_def_dim(nc_id, "nchar", 10, nchardim_id) )

    ! define variables
    !*****************

    ! time
    call nf90_err( nf90_def_var(nc_id, 'time', nf90_int, (/ timedim_id /), time_id) )
    call nf90_err( nf90_put_att(nc_id, time_id, 'units', timeunit) )
    ! species names
    call nf90_err( nf90_def_var(nc_id, 'species', nf90_char, (/ nchardim_id, specdim_id /), spec_id) )
    call nf90_err( nf90_put_att(nc_id, spec_id, 'long_name', 'Species names') )
    ! total masses
    call nf90_err( nf90_def_var(nc_id, 'mass', nf90_double, (/ specdim_id, timedim_id /), mass_id) )
    call nf90_err( nf90_put_att(nc_id, mass_id, 'units', 'kg') )
    call nf90_err( nf90_put_att(nc_id, mass_id, 'long_name', 'Total global mass') )
    ! emission uptake
    call nf90_err( nf90_def_var(nc_id, 'emissions', nf90_double, (/ specdim_id, timedim_id /), emis_id) )
    call nf90_err( nf90_put_att(nc_id, emis_id, 'units', 'kg s-1') )
    call nf90_err( nf90_put_att(nc_id, emis_id, 'long_name', 'Actual emission flux') )
    ! emission field
    call nf90_err( nf90_def_var(nc_id, 'em_field', nf90_double, (/ specdim_id, timedim_id /), efld_id) )
    call nf90_err( nf90_put_att(nc_id, efld_id, 'units', 'kg s-1') )
    call nf90_err(  nf90_put_att(nc_id, efld_id, 'long_name', 'Emission flux in fields') )
    ! emission residual
    call nf90_err( nf90_def_var(nc_id, 'em_res', nf90_double, (/ specdim_id, timedim_id /), eres_id) )
    call nf90_err( nf90_put_att(nc_id, eres_id, 'units', 'kg') )
    call nf90_err( nf90_put_att(nc_id, eres_id, 'long_name', 'Emission residuals') )
    ! chemical loss
    call nf90_err( nf90_def_var(nc_id, 'chem_loss', nf90_double, (/ reagdim_id, specdim_id, timedim_id /), cl_id) )
    call nf90_err( nf90_put_att(nc_id, cl_id, 'units', 'kg s-1') )
    call nf90_err( nf90_put_att(nc_id, cl_id, 'long_name', 'Mass loss through chemical reactions') )

    ! write global attributes
    !************************

    call nf90_err( nf90_put_att(nc_id, nf90_global, 'title', 'FLEXPART total mass and flux output') )
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'source', trim(flexversion)//' model output') )
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'history', date(1:4)//'-'//date(5:6)// &
       '-'//date(7:8)//' '//time(1:2)//':'//time(3:4)//' '//zone//'  created by '//  &
       trim(login_name)//' on '//trim(host_name)) )
    call nf90_err( nf90_put_att(nc_id, nf90_global, 'references', &
       'Stohl et al., Atmos. Chem. Phys., 2005, doi:10.5194/acp-5-2461-200;'//&
       'Henne et al., in Lagrangian Modeling of the Atmosphere, 2012, doi:10.1029/2012GM001247') )

    ! end definition of file 
    call nf90_err( nf90_enddef(nc_id) )

    ! write species info
    do ks=1,nspec
      print*, 'totals: species = ',trim(species(ks))
      call nf90_err( nf90_put_var(nc_id, spec_id, species(ks), (/1,ks/), (/10,1/)) )
    end do

    ! close file
    call nf90_err( nf90_close(nc_id) )

  end subroutine totals_init


  subroutine totals_write(itime)

  !*****************************************************************************
  !                                                                            *
  !    This subroutine writes the totals to file                               *
  !                                                                            *
  !    Author: S. Henne                                                        *
  !    Adapted by R. Thompson for v11, Feb-2024                                *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer :: itime, tidx
    integer :: var_id

    ! open file
    call nf90_err( nf90_open(trim(fn_totals), nf90_write, nc_id) )

    ! get length of time dimension -> increase index by one to write new data
    call nf90_err( nf90_inq_dimid(nc_id, "time", timedim_id) )
    call nf90_err( nf90_inquire_dimension(nc_id, timedim_id, len=tidx) )
    tidx = tidx + 1

    ! add to time variable
    call nf90_err( nf90_inq_varid(nc_id, "time", time_id) )
    call nf90_err( nf90_put_var(nc_id, time_id, itime, (/ tidx /)) )

    ! write variables
    !****************

    call nf90_err( nf90_inq_varid(nc_id, "mass", var_id) )
    call nf90_err( nf90_put_var(nc_id, var_id, tot_mass(1:nspec), (/ 1, tidx /), (/ nspec, 1/)) )

    call nf90_err( nf90_inq_varid(nc_id, "emissions", var_id) )
    call nf90_err( nf90_put_var(nc_id, var_id, tot_em_up(1:nspec)/real(lsynctime), &
                    (/ 1, tidx /), (/ nspec, 1/)) )

    call nf90_err( nf90_inq_varid(nc_id, "em_field", var_id) )
    call nf90_err( nf90_put_var(nc_id, var_id, tot_em_field(1:nspec)/real(lsynctime), &
                    (/ 1, tidx /), (/ nspec, 1/)) )

    ! em_res accumulated over all time steps (units kg) -> no division by lsynctime
    call nf90_err( nf90_inq_varid(nc_id, "em_res", var_id) )
    call nf90_err( nf90_put_var(nc_id, var_id, tot_em_res(1:nspec),  &
                    (/ 1, tidx /), (/ nspec, 1/)) )

    if (nreagent.gt.0) then
      call nf90_err( nf90_inq_varid(nc_id, "chem_loss", var_id) )
      call nf90_err( nf90_put_var(nc_id, var_id, chem_loss(1:nreagent,1:nspec)/real(lsynctime),   &
                      (/ 1, 1, tidx /), (/ nreagent, nspec, 1/)) )
    endif

    call nf90_err( nf90_close(nc_id) )

  end subroutine totals_write

end module totals_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

real function psim(z,al)

  !**********************************************************************
  !                                                                     *
  ! DESCRIPTION: CALCULATION OF THE STABILITY CORRECTION FUNCTION FOR   *
  !              MOMENTUM AS FUNCTION OF HEIGHT Z AND OBUKHOV SCALE     *
  !              HEIGHT L                                               *
  !                                                                     *
  !**********************************************************************

  use par_mod

  implicit none

  real :: z,al,zeta,x,a1,a2

  zeta=z/al
  if(zeta.le.0.) then
  ! UNSTABLE CASE
    x=(1.-15.*zeta)**0.25
    a1=((1.+x)/2.)**2
    a2=(1.+x**2)/2.
    psim=log(a1*a2)-2.*atan(x)+pi/2.
  else
  ! STABLE CASE
    psim=-4.7*zeta
  endif

end function psim

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

function raerod (l,ust,z0)

  !*****************************************************************************
  !                                                                            *
  !     Calculation of the aerodynamical resistance ra from ground up to href  *
  !                                                                            *
  !     AUTHOR: Matthias Langer, modified by Andreas Stohl (6 August 1993)     *
  !                                                                            *
  !     Literature:                                                            *
  !     [1]  Hicks/Baldocchi/Meyers/Hosker/Matt (1987), A Preliminary          *
  !             Multiple Resistance Routine for Deriving Dry Deposition        *
  !             Velocities from Measured Quantities.                           *
  !             Water, Air and Soil Pollution 36 (1987), pp.311-330.           *
  !     [2]  Scire/Yamartino/Carmichael/Chang (1989),                          *
  !             CALGRID: A Mesoscale Photochemical Grid Model.                 *
  !             Vol II: User's Guide. (Report No.A049-1, June, 1989)           *
  !                                                                            *
  !     Variable list:                                                         *
  !     L     = Monin-Obukhov-length [m]                                       *
  !     ust   = friction velocity [m/sec]                                      *
  !     z0    = surface roughness length [m]                                   *
  !     href  = reference height [m], for which deposition velocity is         *
  !             calculated                                                     *
  !                                                                            *
  !     Constants:                                                             *
  !     karman    = von Karman-constant (~0.4)                                 *
  !     ramin = minimum resistence of ra (1 s/m)                               *
  !                                                                            *
  !     Subprograms and functions:                                             *
  !     function psih (z/L)                                                    *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  real :: l,psih,raerod,ust,z0

  raerod=(alog(href/z0)-psih(href,l)+psih(z0,l))/(karman*ust)

end function raerod

!*******************************************************************************
!        Include file for particle diffusion model FLEXPART                    *
!        This file contains a global common block used by FLEXPART             *
!                                                                              *
!        Author: A. Stohl                                                      *
!                                                                              *
!        June 1996                                                             *
!                                                                              *
!        Update: 15 August 2013 IP                                             *
!        PS 19 Nov 2020: correct comment about lcw                             *
!        Anne Tipka, Petra Seibert 2021-02: implement new interpolation        *
!           for precipitation according to #295 using 2 additional fields      *
!                                                                              *
!*******************************************************************************

module com_mod

  use par_mod, only: dp, numpath, maxnests, maxndia, &
       numclass, maxcolumn, maxrand, numwfmem, numpf, &
       maxreagent, maxrecsample

  implicit none

  ! Partoptions derived type. This decides which fields are being computed and output
  !**********************************************************************************
  type :: particleoptions
    character(2) :: name
    character(28) :: long_name
    character(7) :: short_name
    logical :: print
    logical :: average=.false.
    integer :: i_average=0
    integer :: ncid
  end type particleoptions

  integer :: num_partopt=34
  integer :: n_average
  type(particleoptions),allocatable :: partopt(:)

  !****************************************************************
  ! Variables defining where FLEXPART input/output files are stored
  !****************************************************************

  character :: path(numpath+2*maxnests)*120
  integer :: length(numpath+2*maxnests)
  character(len=256) :: pathfile, flexversion, flexversion_major, arg1, arg2
  character(len=256) :: ohfields_path
  character(len=256) :: gitversion
  
  ! path                    path names needed for trajectory model
  ! length                  length of path names needed for trajectory model
  ! pathfile                file where pathnames are stored
  ! flexversion             version of flexpart (descriptive long string)
  ! flexversion_major       version of flexpart (major version number)
  ! arg                     input arguments from launch at command line
  ! ohfields_path           path to binary files for OH fields

  !********************************************************
  ! Variables defining the general model run specifications
  !********************************************************

  integer :: ibdate,ibtime,iedate,ietime,itime_init,loutnext_init,lrecoutnext_init
  real :: outnum_init
  real(kind=dp) :: bdate,edate


  ! ibdate                  beginning date (YYYYMMDD)
  ! ibtime                  beginning time (HHMISS)
  ! iedate                  ending date (YYYYMMDD)
  ! ietime                  ending time (HHMISS)
  ! itime_init              starting time in [s] in case of a restart
  ! bdate                   beginning date of simulation (julian date)
  ! edate                   ending date of simulation (julian date)
  ! outnum_init             concentration calculation sample number after restart
  ! loutnext_init           first writing time after restart


  integer :: ldirect,ideltas

  ! ldirect                 1 for forward, -1 for backward simulation
  ! ideltas                 length of trajectory loop from beginning to
  !                    ending date (s)

  integer :: loutstep,loutaver,loutsample,loutrestart,method,lsynctime
  integer :: lrecoutstep,lrecoutaver,lrecoutsample
  real :: outstep

  ! loutstep [s]            gridded concentration output every loutstep seconds
  ! loutaver [s]            concentration output is an average over [s] seconds
  ! loutsample [s]          sampling interval of gridded concentration output
  ! lrecoutstep [s]         receptor concentration output every loutstep seconds
  ! lrecoutaver [s]         receptor concentration output is an average over [s] seconds
  ! lrecoutsample [s]       sampling interval of receptor concentration output
  ! loutrestart [s]         time interval for writing restart files
  ! lsynctime [s]           synchronisation time of all particles
  ! method                  indicator which dispersion method is to be used
  ! outstep = real(abs(loutstep))

  real :: ctl,fine
  integer :: ifine,iout,ipout,ipin,iflux,mdomainfill,ipoutfac
  integer :: mquasilag,nested_output,ind_source,ind_receptor,nxshift
  integer :: ind_rel,ind_samp,ioutputforeachrelease,linit_cond,sfc_only
  integer :: surf_only ! deprecated
  logical :: turbswitch
  integer :: cblflag !added by mc for cbl
  logical :: llcmoutput

  ! ctl      factor, by which time step must be smaller than Lagrangian time scale
  ! ifine    reduction factor for time step used for vertical wind
  !     Langevin equation for the vertical wind component
  ! ioutputforeachrelease Should each release be a seperate output field?
  ! iflux    flux calculation options: 1 calculation of fluxes, 2 no fluxes
  ! iout     output options: 1 conc. output (ng/m3), 2 mixing ratio (pptv), 3 both
  ! ipout    particle dump options: 0 no, 1 every output interval, 2 only at end
  ! ipoutfac increase particle dump interval by factor (default 1)
  ! ipin     read in particle positions from dumped file from a previous run
  ! fine     real(ifine)
  ! mdomainfill 0: normal run
  !        1: particles are initialized according to atmospheric mass distribution
  ! ind_source switches between different units for concentrations at the source
  !  NOTE that in backward simulations the release of computational particles
  !  takes place at the "receptor" and the sampling of particles at the "source".
  !     1= mass units
  !     2= mass mixing ratio units
  ! ind_receptor switches between different units for FLEXPART concentration at the receptor
  !     1= mass units
  !     2= mass mixing ratio units
  ! linit_cond  switch on the output of sensitivity to initial conditions for backward runs
  !     0=no, 1=mass unit, 2=mass mixing ratio unit
  ! mquasilag 0: normal run
  !      1: Particle position output is produced in a condensed format and particles are numbered
  ! sfc_only   switch output in grid_time files for surface only or full vertical resolution
  !      0=no (full vertical resolution), 1=yes (surface only)
  ! nested_output: 0 no, 1 yes
  ! turbswitch              determines how the Markov chain is formulated
  ! nxshift            for global grids (in x), the grid can be shifted by
  !                    nxshift grid points, in order to accomodate nested
  !                    grids, and output grids overlapping the domain "boundary"
  !                    nxshift must not be negative; "normal" setting would be 0

  ! ind_rel and ind_samp  are used within the code to change between mass and mass-mix (see readcommand.f)
  ! cblflag !: 1 activate cbl skewed pdf routines with bi-gaussina pdf whan OL<0 added by mc
  ! llcmoutput  switch for LCM output (uses mass ratio of species to air tracer) or normal output


  integer :: mintime,itsplit

  ! mintime                 minimum time step to be used by FLEXPART
  ! itsplit                 time constant for splitting particles

  integer :: lsubgrid,lconvection,lturbulence,lagespectra

  ! lsubgrid     1 if subgrid topography parameterization switched on, 2 if not
  ! lconvection  1 if convection parameterization switched on, 0 if not
  ! lturbulence  1 if turbulence parameterization switched on, 0 if not
  ! lagespectra  1 if age spectra calculation switched on, 2 if not

  ! mesoscale turbulence is found to give issues, so turned off by default
  !***********************************************************************
  logical :: lmesoscale_turb=.false.

  integer :: lnetcdfout
  ! lnetcdfout   1 for netcdf grid output, 0 if not. Set in COMMAND (namelist input)

  integer :: linversionout
  ! linversionout 1 for one grid_time output file for each release containing all timesteps

  integer :: nageclass
  integer,allocatable,dimension(:) :: lage

  ! nageclass               number of ageclasses for the age spectra calculation
  ! lage [s]                ageclasses for the age spectra calculation

 !ESO: Disable settling if more than 1 species per release point
  logical :: lsettling=.true.

  logical :: gdomainfill
  ! gdomainfill             .T., if domain-filling is global, .F. if not

  logical :: lcw=.false. ! ZHG Sep 2015 ! AT renamed
  ! whether or not cloud water data found in GRIB, overwritten if CW is found

  logical :: lcwsum=.false. ! ESO Dec 2015 ! AT renamed
  ! whether or not both clwc and ciwc are present (if so they are summed)

  logical :: lprecint ! AT, PS 2021
  ! true if new interpolation using additional precip fields is used
    
  logical,dimension(maxnests) :: lcw_nest=.false.
  logical,dimension(maxnests) :: lcwsum_nest=.false.
  logical,dimension(maxnests) :: lprecintn
 
  !NIK 16.02.2015
  integer(selected_int_kind(16)),allocatable,dimension(:) :: icnt_belowcld, &
       &icnt_incld

  !*********************************************************************
  ! Variables defining the release locations, released species and their
  ! properties, etc.
  !*********************************************************************

  !change Sabine Eckhardt, only save the first 1000 identifier for releasepoints
  character :: compoint(1001)*45
  integer :: numpoint
  !sec, now dynamically allocated:
  ! ireleasestart(maxpoint),ireleaseend(maxpoint)
  !      real xpoint1(maxpoint),ypoint1(maxpoint)
  !real xpoint2(maxpoint),ypoint2(maxpoint)
  !real zpoint1(maxpoint),zpoint2(maxpoint)
  !integer*2 kindz(maxpoint)
  integer,allocatable,dimension(:) :: specnum
  !real xmass(maxpoint,maxspec)
  real,allocatable,dimension(:) :: decay
  real,allocatable,dimension(:) :: weta_gas,wetb_gas
  real,allocatable,dimension(:) :: crain_aero,csnow_aero
! NIK: 31.01.2013- parameters for in-cloud scavening
  real,allocatable,dimension(:) :: ccn_aero,in_aero
  real,allocatable,dimension(:) :: reldiff,henry,f0
  real,allocatable,dimension(:) :: density,dquer,dsigma
  integer,allocatable,dimension(:) :: ndia
  real,allocatable,dimension(:) :: vsetaver,cunningham,weightmolar
  real,allocatable,dimension(:,:) :: vset,schmi,fract
  real,allocatable,dimension(:,:) :: ri,rac
  real,allocatable,dimension(:,:,:) :: rcl,rgs,rlu
  real,allocatable,dimension(:) :: rm,dryvel
  ! Daria Tatsii: species shape properties
  real,allocatable,dimension(:) :: Fn,Fs ! Newton and Stokes' regime
  real,allocatable,dimension(:) :: ks1,ks2,kn2
  integer,allocatable,dimension(:) :: ishape,orient
  ! chemical reagent variables
  character(len=256) :: reag_path(maxreagent)
  character(len=16)  :: reagents(maxreagent), reag_unit(maxreagent)
  integer :: reag_hourly(maxreagent), nreagent  
  ! reaction rates
  real,allocatable,dimension(:,:) :: reaccconst,reacdconst,reacnconst
  ! emissions variables for LCM
  character(len=256),allocatable,dimension(:) :: emis_path,emis_file,emis_name
  integer,allocatable,dimension(:) :: emis_unit
  real,allocatable,dimension(:) :: emis_coeff

  real,allocatable,dimension(:,:) :: area_hour,point_hour
  real,allocatable,dimension(:,:) :: area_dow,point_dow

  !integer npart(maxpoint)
  integer :: nspec,maxpointspec_act
  character(len=10),allocatable,dimension(:) :: species


  ! compoint                comment, also "name" of each starting point
  ! numpoint                actual number of trajectory starting/ending points
  ! ireleasestart,ireleaseend [s] starting and ending time of each release
  ! xmass                   total mass emitted
  ! xpoint1,ypoint1         lower left coordinates of release area
  ! xpoint2,ypoint2         upper right coordinates of release area
  ! zpoint1,zpoint2         min./max. z-coordinates of release points
  ! kindz                   1: zpoint is in m agl, 2: zpoint is in m asl
  ! npart                   number of particles per release point
  ! nspec                   number of different species allowed for one release
  ! maxpointspec_act        number of releaspoints for which a different output shall be created
  ! species                 name of species
  ! decay                   decay constant of radionuclide

  ! WET DEPOSITION
  ! weta_gas, wetb_gas     parameters for below-cloud wet scavenging coefficients (gasses)
  ! crain_aero, csnow_aero parameters for below-cloud wet scavenging coefficients (aerosols)
  ! ccn_aero, cin_aero     parameters for in-cloud wet scavenging coefficients (aerosols)

  ! GAS DEPOSITION
  ! reldiff                 diffusivitiy of species relative to diff. of H2O
  ! henry [M/atm]           Henry constant
  ! f0                      reactivity relative to that of O3
  ! ri [s/m]                stomatal resistance
  ! rcl [s/m]               lower canopy resistance
  ! rgs [s/m]               ground resistance
  ! rlu [s/m]               leaf cuticular resistance
  ! rm [s/m]                mesophyll resistance
  ! dryvel [m/s]            constant dry deposition velocity

  ! PARTICLE DEPOSITION
  ! density [kg/m3]         density of particles
  ! dquer [m]               mean diameter of particles
  ! dsigma                  dsigma=10 or dsigma=0.1 means that 68% of the
  !                         mass are between 0.1*dquer and 10*dquer

  ! fract                   mass fraction of each diameter interval
  ! vset [m/s]              gravitational settling velocity in ni intervals
  ! cunningham              Cunningham slip correction (strictly valid only near surface)
  ! vsetaver [m/s]          average gravitational settling velocity
  ! schmi                   Schmidt number**2/3 of each diameter interval
  ! weightmolar [g/mol]     molecular weight

  ! TIME VARIATION OF EMISSION
  ! area_hour, point_hour   daily variation of emission strengths for area and point sources
  ! area_dow, point_dow     day-of-week variation of emission strengths for area and point sources

  !******************************************************************************
  ! Variables associated with the ECMWF meteorological input data ("wind fields")
  !******************************************************************************

  integer :: memtime(numwfmem),memind(3),lwindinterv ! eso: or memind(numwfmem) 

  ! memtime [s]             validation times of wind fields in memory
  ! memind                  pointer to wind field, in order to avoid shuffling
  !                         of wind fields
  ! lwindinterv [s]         Interval between wind fields currently in memory

  !********************************************************************
  ! Variables associated with the ECMWF input data (nested wind fields)
  !********************************************************************

  ! NOTE: all nested variables have the same name as the variables used
  ! for the mother domain, except with a 'n' appended at the end
  !********************************************************************

  integer :: numbnests, nxmaxn, nymaxn

  ! nxmax,nymax        maximum dimension of wind fields in x and y
  !                    direction, respectively
  ! numbnests    number of nested grids

  !******************************************************
  ! Variables defining the polar stereographic projection
  !******************************************************

  logical :: xglobal,sglobal,nglobal
  real :: switchnorthg,switchsouthg

  !xglobal             T for global fields, F for limited area fields
  !sglobal             T if domain extends towards south pole
  !nglobal             T if domain extends towards north pole
  !switchnorthg,switchsouthg   same as parameters switchnorth,
  !                    switchsouth, but in grid units

  real :: southpolemap(9),northpolemap(9)

  !southpolemap,northpolemap   define stereographic projections
  !                    at the two poles


  !******************
  ! Landuse inventory
  ! Sabine Eckhardt Dec 06: change to new landuse inventary - 11 classes, 1200 x 600 global
  !******************

  integer(kind=1) :: landinvent(1200,600,6)
  real :: z0(numclass)

! !$OMP THREADPRIVATE (z0)

  ! landinvent         landuse inventory (numclass=11 classes)
  ! z0                  roughness length for the landuse classes



  !**************************************************************************
  ! Variables characterizing the output grid and containing the model results
  !**************************************************************************

  integer :: numxgrid,numygrid,numzgrid
  real :: dxout,dyout,outlon0,outlat0,xoutshift,youtshift
  integer :: numxgridn,numygridn
  real :: dxoutn,dyoutn,outlon0n,outlat0n,xoutshiftn,youtshiftn
  !real outheight(maxzgrid),outheighthalf(maxzgrid)

  logical :: DEP,DRYDEP,WETDEP,CLREA,ASSSPEC,LDECAY,LEMIS
  logical,allocatable,dimension(:) :: DRYDEPSPEC,WETDEPSPEC
  logical :: DRYBKDEP,WETBKDEP

  ! numxgrid,numygrid       number of grid points in x,y-direction
  ! numxgridn,numygridn     number of grid points in x,y-direction for nested output grid
  ! numzgrid                number of vertical levels of output grid
  ! dxout,dyout             grid distance of output grid
  ! dxoutn,dyoutn           grid distance of nested output grid
  ! outlon0,outlat0         lower left corner of output grid
  ! outlon0n,outlat0n       lower left corner of nested output grid
  ! xoutshift,youtshift     xlon0-outlon0, ylat0-outlat0
  ! xoutshiftn,youtshiftn   xlon0-outlon0n, ylat0-outlat0n
  ! outheight [m]           upper levels of the output grid
  ! outheighthalf [m]       half (middle) levels of the output grid cells
  ! DEP                     .true., if either dry or wet depos. is switched on
  ! DRYDEP                  .true., if dry deposition is switched on
  ! DRYDEPSPEC              .true., if dry deposition is switched on for that species
  ! WETDEP                  .true., if wet deposition is switched on
  ! WETDEPSPEC              .true., if wet deposition is switched on for that species
  ! CLREA                   .true., if chemical reactions is switched on
  ! ASSSPEC                 .true., if there are two species asscoiated
  ! DRYBKDEP,WETBKDEP        .true., for bkwd runs, where mass deposited and source regions is calculated - either for dry or for wet deposition
  !                    (i.e. transfer of mass between these two occurs
  ! LEMIS                   .true., if particle mass should change due to surface fluxes

  !  if output for each releasepoint shall be created maxpointspec=number of releasepoints
  !  else maxpointspec is 1 -> moved to unc_mod
  !  the OUTGRID is moved to the module outgrid_mod
  !******************************************************************************

  ! gridunc,griduncn        uncertainty of outputted concentrations
  ! wetgridunc,wetgriduncn  uncertainty of accumulated wet deposited mass on output grid
  ! drygridunc,drygriduncn  uncertainty of accumulated dry deposited mass on output grid
  ! oroout,orooutn [m]      height of model topography at output grid
  ! area,arean [m2]         area of each grid cell
  ! volume,volumen [m3]     volume of each grid cell
  ! ... field names with n at the end indicate a nested output grid


  !***********************************
  ! Variables defining receptor points
  !***********************************

  ! general receptors
  real, allocatable, dimension(:) :: xreceptor,yreceptor,zreceptor
  integer, allocatable, dimension(:) :: treceptor
  real, allocatable, dimension(:) :: receptorarea
  real, allocatable, dimension(:,:) :: creceptor,crecuncert
  real, allocatable, dimension(:) :: xkreceptor,nnreceptor
  character(len=16), allocatable, dimension(:) :: receptorname
  integer :: cpointer(maxrecsample)
  integer :: numreceptor, numcurrec
  logical :: lrecregular

  ! satellite receptors
  real, allocatable, dimension(:) :: xsatellite,ysatellite
  integer, allocatable, dimension(:) :: tsatellite
  real, allocatable, dimension(:) :: satellitearea
  real, allocatable, dimension(:,:) :: zsatellite
  real, allocatable, dimension(:,:,:) :: csatellite, csatuncert
  real, allocatable, dimension(:,:)   :: xksatellite, nnsatellite
  character(len=24), allocatable, dimension(:) :: satellitename
  integer :: numsatreceptor, nlayermax, numsatellite, numcursat
  integer, allocatable, dimension(:) :: nnsatlayer
  integer :: csatpointer(maxrecsample)

  ! xreceptor,yreceptor,zreceptor     receptor position
  ! creceptor                         concentrations at receptor points
  ! receptorarea                      area of 1*1 grid cell at receptor point
  ! numreceptor                       number of receptors (non-satellite)
  ! numcurrec                         number of receptors in current time interval (updated each time interval)
  ! lrecregular                       logical if receptor output should be at regular intervals (and not according to RECEPTORS namelist)
  ! numsatreceptor                    number of satellite receptors (aka. retrievals)
  ! numcursat                         number of satellite receptors in current time interval (updated each time interval)
  ! numsatellite                      number of satellite instruments
  ! nlayermax                         max number of vertical layers in satellite retrievals
  ! nnsatlayer                        actual number of vertical layers for each satellite

  !***************************************
  ! Variables characterizing each particle
  !***************************************

  integer :: numpart=0
  integer :: numparticlecount
  integer :: maxspec ! Number of chemical species per release
  !integer :: maxndia ! Number of diameter bins (now set in par_mod.f90)
  !real, allocatable, dimension(:,:) :: xscav_frac1

  !****************************************************************
  ! Variables used for writing out interval averages for partoutput
  !****************************************************************

  integer, allocatable, dimension(:) :: npart_av
  real, allocatable, dimension(:) :: part_av_cartx,part_av_carty,part_av_cartz,part_av_z,part_av_topo
  real, allocatable, dimension(:) :: part_av_pv,part_av_qv,part_av_tt,part_av_rho,part_av_tro,part_av_hmix
  real, allocatable, dimension(:) :: part_av_uu,part_av_vv,part_av_energy

  !CGZ-lifetime
  real, allocatable, dimension(:,:) ::checklifetime, species_lifetime
  !CGZ-lifetime

  ! numpart                 actual number of particles in memory
  ! itra1 (maxpart) [s]     temporal positions of the particles
  ! npoint(maxpart)         indicates the release point of each particle
  ! nclass (maxpart)        one of nclassunc classes to which the particle is attributed
  ! itramem (maxpart) [s]   memorized release times of the particles
  ! itrasplit (maxpart) [s] next time when particle is to be split into two
  ! idt(maxpart) [s]        time step to be used for next integration
  ! numparticlecount        counts the total number of particles that have been released
  ! xtra1,ytra1,ztra1       spatial positions of the particles
  ! xmass1 [kg]             particle masses
  ! xscav_frac1             fraction of particle masse which has been scavenged at receptor
 


  !*******************************************************
  ! Info table on available chemical species/radionuclides
  !*******************************************************

  !character*10 specname(maxtable)
  !real decaytime(maxtable),wetscava(maxtable),wetscavb(maxtable)
  !real drydiff(maxtable),dryhenry(maxtable),dryactiv(maxtable)
  !real partrho(maxtable),partmean(maxtable),partsig(maxtable)
  !real dryvelo(maxtable),weightmol(maxtable),ohreact(maxtable)

  ! specname            Name of chemical species/radionuclide
  ! decaytime           Half time of radionuclides
  ! wetscava, wetscavb  Parameters for calculating scavenging coefficients
  ! drydiff             diffusivitiy of species relative to diff. of H2O
  ! dryhenry [M/atm]    Henry constant
  ! dryactiv            reactivity relative to that of O3
  ! partrho [kg/m3]     density of particles
  ! partmean [m]        mean diameter of particles
  ! partsig [m]         mean stand. deviation of particle diameter
  ! dryvelo [cm/s]      constant dry deposition velocity
  ! weightmol [g/mol]   molecular weight
  ! ohreact             OH reaction rate


  !********************
  ! Random number field
  !********************

  real :: rannumb(maxrand+2)

  ! rannumb                 field of normally distributed random numbers
  
  !********************************************************************
  ! variables to control stability of CBL scheme under variation 
  ! of statistics in time and space 
  !********************************************************************
  integer :: sum_nan_count(3600),maxtl=1200
  integer,allocatable,dimension(:) :: nan_count
  !added by mc , note that for safety sum_nan_count(N) with N>maxtl

  !********************************************************************
  ! variables to test well-mixed state of CBL scheme not to be included in final release
  !********************************************************************
  real :: well_mixed_vector(50),h_well,well_mixed_norm,avg_air_dens(50),avg_ol,avg_wst,avg_h 
  ! modified by mc to test well-mixed for cbl

  !********************
  ! Verbosity, testing flags, namelist I/O
  !********************   
  logical :: debug_mode=.false.
  integer :: verbosity=0
  integer :: info_flag=0
  integer :: count_clock, count_clock0,  count_rate, count_max
  real    :: tins
  logical, parameter :: nmlout=.true.

  !**************************************************************
  ! These variables are used to avoid having separate versions of
  ! files in cases where differences with MPI version are minor (eso)
  !*****************************************************************
  integer :: mpi_mode=0 ! .gt. 0 if running MPI version
  logical :: lroot=.true. ! true if serial version, or if MPI .and. root process
  
  logical, parameter :: interpolhmix=.false. ! true if the hmix shall be interpolated

  integer :: numthreads,numthreads_grid  ! number of available threads in parallel sections
  !integer :: nclassunc2, nrecclunc, ngriclunc

  ! Set maximum number of threads for doing grid computations in COMMAND
  ! Recommended to set this to max 16
  ! High numbers create more overhead and a larger memory footprint
  !***********************************************************************
  integer :: maxthreadgrid

  !*******************************************************************************
  ! Maximum output of each partoutput NetCDF-4 file in Mb 
  ! before a new one is created
  !*******************************************************************************

  integer :: maxfilesize

  ! This flag sets all vertical interpolation to logarithmic instead of linear
  !***************************************************************************
  integer :: logvertinterp
  logical :: log_interpol=.false.

  !*********************************************************
  !LB 04.05.2021, simple timing of IO and total running time
  !*********************************************************
  real :: s_readwind=0, s_writepartav=0, s_writepart=0, s_temp=0, s_total=0, s_firstt=0
  real, parameter :: eta_convert=1000000., zfac=100.


contains

  subroutine alloc_com
    implicit none
    integer :: stat

    allocate( icnt_belowcld(maxspec),icnt_incld(maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate cnt_belowcld or icnt_incld"
    allocate( specnum(maxspec),decay(maxspec),weta_gas(maxspec), &
      wetb_gas(maxspec),crain_aero(maxspec),csnow_aero(maxspec), &
      ccn_aero(maxspec),in_aero(maxspec),ndia(maxspec), &
      reldiff(maxspec),henry(maxspec),f0(maxspec),density(maxspec), &
      dquer(maxspec),dsigma(maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate particle property arrays 1"
    allocate( vsetaver(maxspec),cunningham(maxspec), &
      weightmolar(maxspec),ri(5,numclass),rac(5,numclass), &
      rcl(maxspec,5,numclass),rgs(maxspec,5,numclass), &
      rlu(maxspec,5,numclass),rm(maxspec),dryvel(maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate particle property arrays 2"
    allocate( Fn(maxspec),Fs(maxspec),ks1(maxspec),ks2(maxspec), &
      kn2(maxspec),ishape(maxspec),orient(maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate particle shape arrays"
    allocate( area_hour(maxspec,24),point_hour(maxspec,24), &
      area_dow(maxspec,7),point_dow(maxspec,7), &
      species(maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate species arrays"
    allocate( DRYDEPSPEC(maxspec),WETDEPSPEC(maxspec),stat=stat)
    if (stat.ne.0) error stop "Could not allocate DRYDEPSPEC or WETDEPSPEC"
!    allocate( creceptor(numreceptor,maxspec),stat=stat)
!    if (stat.ne.0) error stop "Could not allocate creceptor"

    icnt_belowcld=0
    icnt_incld=0
  end subroutine alloc_com

  subroutine alloc_com_ndia
    implicit none
    integer :: stat

    allocate(vset(maxspec,maxndia),schmi(maxspec,maxndia),fract(maxspec,maxndia),stat=stat)
    if (stat.ne.0) error stop "Could not allocate vset,schmi or fract"
  end subroutine alloc_com_ndia

  subroutine dealloc_com
    deallocate(icnt_belowcld,icnt_incld,specnum,decay,weta_gas,wetb_gas, &
      crain_aero,csnow_aero,ccn_aero,in_aero,reldiff,henry,f0,density,dquer, &
      dsigma,ndia,vsetaver,cunningham,weightmolar,vset,schmi,fract,ri,rac,rcl, &
      rgs,rlu,rm,dryvel,Fn,Fs,ks1,ks2,kn2,ishape, &
      orient,area_hour,point_hour,area_dow,point_dow,species)
    deallocate(DRYDEPSPEC,WETDEPSPEC)
    deallocate(creceptor,xreceptor,yreceptor,receptorarea,receptorname)
    deallocate(lage)
  end subroutine dealloc_com

  subroutine mpi_alloc_part(nmpart)
  !*******************************************************************************    
  ! Dynamic allocation of arrays
  !
  ! For FLEXPART version 9.2 and earlier these arrays were statically declared
  ! with size maxpart. This function is introduced so that the MPI version
  ! can declare these arrays with smaller size ("maxpart per process"), while
  ! the serial version allocate at run-time with size maxpart 
  !
  !*******************************************************************************
    implicit none 

    integer, intent(in) :: nmpart ! maximum number of particles (per process)

    if (ipout.eq.3) then
      allocate(npart_av(nmpart),part_av_cartx(nmpart),part_av_carty(nmpart),&
           & part_av_cartz(nmpart),part_av_z(nmpart),part_av_topo(nmpart))
      allocate(part_av_pv(nmpart),part_av_qv(nmpart),part_av_tt(nmpart),&
           & part_av_rho(nmpart),part_av_tro(nmpart),part_av_hmix(nmpart))
      allocate(part_av_uu(nmpart),part_av_vv(nmpart),part_av_energy(nmpart))
    end if

  end subroutine mpi_alloc_part

  subroutine update_gitversion(gitversion_tmp)
    character(len=256) :: gitversion_tmp
    gitversion=gitversion_tmp
  end subroutine
end module com_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine partoutput(itime)
  !                        i
  !*****************************************************************************
  !                                                                            *
  !     Dump all particle positions                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     12 March 1999                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,i,j,jjjjmmdd,ihmmss
  integer :: ix,jy,ixp,jyp,indexh,m,il,ind,indz,indzp
  real :: xlon,ylat
  real :: dt1,dt2,dtt,ddx,ddy,rddx,rddy,p1,p2,p3,p4,dz1,dz2,dz
  real :: topo,hm(2),hmixi,pv1(2),pvprof(2),pvi,qv1(2),qvprof(2),qvi
  real :: tt1(2),ttprof(2),tti,rho1(2),rhoprof(2),rhoi
  real :: tr(2),tri
  character :: adate*8,atime*6


  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss


  ! Some variables needed for temporal interpolation
  !*************************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)

  ! Open output file and write the output
  !**************************************

  if (ipout.eq.1) then
    open(unitpartout,file=path(2)(1:length(2))//'partposit_'//adate// &
         atime,form='unformatted')
  else
    open(unitpartout,file=path(2)(1:length(2))//'partposit_end', &
         form='unformatted')
  endif

  ! Write current time to file
  !***************************

  write(unitpartout) itime
  do i=1,numpart

  ! Take only valid particles
  !**************************

    if (itra1(i).eq.itime) then
      xlon=xlon0+xtra1(i)*dx
      ylat=ylat0+ytra1(i)*dy

  !*****************************************************************************
  ! Interpolate several variables (PV, specific humidity, etc.) to particle position
  !*****************************************************************************

      ix=xtra1(i)
      jy=ytra1(i)
      ixp=ix+1
      jyp=jy+1
      ddx=xtra1(i)-real(ix)
      ddy=ytra1(i)-real(jy)
      rddx=1.-ddx
      rddy=1.-ddy
      p1=rddx*rddy
      p2=ddx*rddy
      p3=rddx*ddy
      p4=ddx*ddy

  ! Topography
  !***********

      topo=p1*oro(ix ,jy) &
           + p2*oro(ixp,jy) &
           + p3*oro(ix ,jyp) &
           + p4*oro(ixp,jyp)

  ! Potential vorticity, specific humidity, temperature, and density
  !*****************************************************************

      do il=2,nz
        if (height(il).gt.ztra1(i)) then
          indz=il-1
          indzp=il
          goto 6
        endif
      end do
6     continue

      dz1=ztra1(i)-height(indz)
      dz2=height(indzp)-ztra1(i)
      dz=1./(dz1+dz2)


      do ind=indz,indzp
        do m=1,2
          indexh=memind(m)

  ! Potential vorticity
          pv1(m)=p1*pv(ix ,jy ,ind,indexh) &
               +p2*pv(ixp,jy ,ind,indexh) &
               +p3*pv(ix ,jyp,ind,indexh) &
               +p4*pv(ixp,jyp,ind,indexh)
  ! Specific humidity
          qv1(m)=p1*qv(ix ,jy ,ind,indexh) &
               +p2*qv(ixp,jy ,ind,indexh) &
               +p3*qv(ix ,jyp,ind,indexh) &
               +p4*qv(ixp,jyp,ind,indexh)
  ! Temperature
          tt1(m)=p1*tt(ix ,jy ,ind,indexh) &
               +p2*tt(ixp,jy ,ind,indexh) &
               +p3*tt(ix ,jyp,ind,indexh) &
               +p4*tt(ixp,jyp,ind,indexh)
  ! Density
          rho1(m)=p1*rho(ix ,jy ,ind,indexh) &
               +p2*rho(ixp,jy ,ind,indexh) &
               +p3*rho(ix ,jyp,ind,indexh) &
               +p4*rho(ixp,jyp,ind,indexh)
        end do
        pvprof(ind-indz+1)=(pv1(1)*dt2+pv1(2)*dt1)*dtt
        qvprof(ind-indz+1)=(qv1(1)*dt2+qv1(2)*dt1)*dtt
        ttprof(ind-indz+1)=(tt1(1)*dt2+tt1(2)*dt1)*dtt
        rhoprof(ind-indz+1)=(rho1(1)*dt2+rho1(2)*dt1)*dtt
      end do
      pvi=(dz1*pvprof(2)+dz2*pvprof(1))*dz
      qvi=(dz1*qvprof(2)+dz2*qvprof(1))*dz
      tti=(dz1*ttprof(2)+dz2*ttprof(1))*dz
      rhoi=(dz1*rhoprof(2)+dz2*rhoprof(1))*dz

  ! Tropopause and PBL height
  !**************************

      do m=1,2
        indexh=memind(m)

  ! Tropopause
        tr(m)=p1*tropopause(ix ,jy ,1,indexh) &
             + p2*tropopause(ixp,jy ,1,indexh) &
             + p3*tropopause(ix ,jyp,1,indexh) &
             + p4*tropopause(ixp,jyp,1,indexh)

  ! PBL height
        hm(m)=p1*hmix(ix ,jy ,1,indexh) &
             + p2*hmix(ixp,jy ,1,indexh) &
             + p3*hmix(ix ,jyp,1,indexh) &
             + p4*hmix(ixp,jyp,1,indexh)
      end do

      hmixi=(hm(1)*dt2+hm(2)*dt1)*dtt
      tri=(tr(1)*dt2+tr(2)*dt1)*dtt


  ! Write the output
  !*****************

      write(unitpartout) npoint(i),xlon,ylat,ztra1(i), &
           itramem(i),topo,pvi,qvi,rhoi,hmixi,tri,tti, &
           (xmass1(i,j),j=1,nspec)
    endif
  end do
  write(unitpartout) -99999,-9999.9,-9999.9,-9999.9,-99999, &
       -9999.9,-9999.9,-9999.9,-9999.9,-9999.9,-9999.9,-9999.9, &
       (-9999.9,j=1,nspec)


  close(unitpartout)

end subroutine partoutput

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine gridcheck_nests

  !*****************************************************************************
  !                                                                            *
  !     This routine checks the grid specification for the nested model        *
  !     domains. It is similar to subroutine gridcheck, which checks the       *
  !     mother domain.                                                         *
  !                                                                            *
  !     Authors: A. Stohl, G. Wotawa                                           *
  !                                                                            *
  !     8 February 1999                                                        *
  !                                                                            *
  !*****************************************************************************
  !  CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with ECMWF grib_api    *
  !  CHANGE: 03/12/2008, Harald Sodemann, change to f90 grib_api               *
  !*****************************************************************************

  use grib_api
  use par_mod
  use com_mod

  implicit none

  !HSO  parameters for grib_api
  integer :: ifile
  integer :: iret
  integer :: igrib
  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
  integer :: gotGrib
  !HSO  end
  integer :: i,j,k,l,ifn,ifield,iumax,iwmax,numskip,nlev_ecn
  integer :: nuvzn,nwzn
  real :: akmn(nwzmax),bkmn(nwzmax),akzn(nuvzmax),bkzn(nuvzmax)
  real(kind=4) :: xaux1,xaux2,yaux1,yaux2
  real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in

  ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

  ! dimension of isec2 at least (22+n), where n is the number of parallels or
  ! meridians in a quasi-regular (reduced) Gaussian or lat/long grid

  ! dimension of zsec2 at least (10+nn), where nn is the number of vertical
  ! coordinate parameters

  integer :: isec1(56),isec2(22+nxmaxn+nymaxn)
  real(kind=4) :: zsec2(60+2*nuvzmax),zsec4(jpunp)

  !HSO  grib api error messages
  character(len=24) :: gribErrorMsg = 'Error reading grib file'
  character(len=20) :: gribFunction = 'gridcheck_nests'

  xresoln(0)=1.       ! resolution enhancement for mother grid
  yresoln(0)=1.       ! resolution enhancement for mother grid

  ! Loop about all nesting levels
  !******************************

  do l=1,numbnests

    iumax=0
    iwmax=0

    if(ideltas.gt.0) then
      ifn=1
    else
      ifn=numbwf
    endif
  !
  ! OPENING OF DATA FILE (GRIB CODE)
  !
  ifile=0
  igrib=0
  iret=0

5   call grib_open_file(ifile,path(numpath+2*(l-1)+1) &
         (1:length(numpath+2*(l-1)+1))//trim(wfnamen(l,ifn)),'r',iret)
  if (iret.ne.GRIB_SUCCESS) then
    goto 999   ! ERROR DETECTED
  endif
  !turn on support for multi fields messages
  !call grib_multi_support_on

  gotGrib=0
  ifield=0
10   ifield=ifield+1

  !
  ! GET NEXT FIELDS
  !
  call grib_new_from_file(ifile,igrib,iret)
  if (iret.eq.GRIB_END_OF_FILE)  then
    goto 30    ! EOF DETECTED
  elseif (iret.ne.GRIB_SUCCESS) then
    goto 999   ! ERROR DETECTED
  endif

  !first see if we read GRIB1 or GRIB2
  call grib_get_int(igrib,'editionNumber',gribVer,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  if (gribVer.eq.1) then ! GRIB Edition 1

  !print*,'GRiB Edition 1'
  !read the grib2 identifiers
  call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',isec1(8),iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !change code for etadot to code for omega
  if (isec1(6).eq.77) then
    isec1(6)=135
  endif

  !print*,isec1(6),isec1(8)

  else

  !print*,'GRiB Edition 2'
  !read the grib2 identifiers
  call grib_get_int(igrib,'discipline',discipl,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterCategory',parCat,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'parameterNumber',parNum,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)
  call grib_get_int(igrib,'level',valSurf,iret)
  call grib_check(iret,gribFunction,gribErrorMsg)

  !print*,discipl,parCat,parNum,typSurf,valSurf

  !convert to grib1 identifiers
  isec1(6)=-1
  isec1(7)=-1
  isec1(8)=-1
  isec1(8)=valSurf     ! level
  if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! T
    isec1(6)=130         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105)) then ! U
    isec1(6)=131         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105)) then ! V
    isec1(6)=132         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! Q
    isec1(6)=133         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1)) then !SP
    isec1(6)=134         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
    isec1(6)=135         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
    isec1(6)=151         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103)) then ! 10U
    isec1(6)=165         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103)) then ! 10V
    isec1(6)=166         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103)) then ! 2T
    isec1(6)=167         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103)) then ! 2D
    isec1(6)=168         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
    isec1(6)=141         ! indicatorOfParameter
  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
    isec1(6)=164         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
    isec1(6)=142         ! indicatorOfParameter
  elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
    isec1(6)=143         ! indicatorOfParameter
  elseif ((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SHF
    isec1(6)=146         ! indicatorOfParameter
  elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
    isec1(6)=176         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
    isec1(6)=180         ! indicatorOfParameter
  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
    isec1(6)=181         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
    isec1(6)=129         ! indicatorOfParameter
  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
    isec1(6)=160         ! indicatorOfParameter
  elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
       (typSurf.eq.1)) then ! LSM
    isec1(6)=172         ! indicatorOfParameter
  else
    print*,'***ERROR: undefined GRiB2 message found!',discipl, &
         parCat,parNum,typSurf
  endif

  endif

  !get the size and data of the values array
  if (isec1(6).ne.-1) then
    call grib_get_real4_array(igrib,'values',zsec4,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
  endif

  !HSO  get the required fields from section 2 in a gribex compatible manner
  if (ifield.eq.1) then
    call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
         isec2(2),iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
         isec2(3),iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_int(igrib,'numberOfVerticalCoordinateValues', &
         isec2(12),iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
  !HSO    get the size and data of the vertical coordinate array
    call grib_get_real4_array(igrib,'pv',zsec2,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)

    nxn(l)=isec2(2)
    nyn(l)=isec2(3)
    nlev_ecn=isec2(12)/2-1
  endif ! ifield

  !HSO  get the second part of the grid dimensions only from GRiB1 messages
  if ((gribVer.eq.1).and.(gotGrib.eq.0)) then
    call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
         xaux1in,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees', &
         xaux2in,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees', &
         yaux1in,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    call grib_get_real8(igrib,'latitudeOfFirstGridPointInDegrees', &
         yaux2in,iret)
    call grib_check(iret,gribFunction,gribErrorMsg)
    xaux1=xaux1in
    xaux2=xaux2in
    yaux1=yaux1in
    yaux2=yaux2in
    if(xaux1.gt.180) xaux1=xaux1-360.0
    if(xaux2.gt.180) xaux2=xaux2-360.0
    if(xaux1.lt.-180) xaux1=xaux1+360.0
    if(xaux2.lt.-180) xaux2=xaux2+360.0
    if (xaux2.lt.xaux1) xaux2=xaux2+360.
    xlon0n(l)=xaux1
    ylat0n(l)=yaux1
    dxn(l)=(xaux2-xaux1)/real(nxn(l)-1)
    dyn(l)=(yaux2-yaux1)/real(nyn(l)-1)
    gotGrib=1
  endif ! ifield.eq.1

  k=isec1(8)
  if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
  if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+1)

  if(isec1(6).eq.129) then
    do j=0,nyn(l)-1
      do i=0,nxn(l)-1
        oron(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
      end do
    end do
  endif
  if(isec1(6).eq.172) then
    do j=0,nyn(l)-1
      do i=0,nxn(l)-1
        lsmn(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
      end do
    end do
  endif
  if(isec1(6).eq.160) then
    do j=0,nyn(l)-1
      do i=0,nxn(l)-1
        excessoron(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
      end do
    end do
  endif

  call grib_release(igrib)
  goto 10                 !! READ NEXT LEVEL OR PARAMETER
  !
  ! CLOSING OF INPUT DATA FILE
  !

30   call grib_close_file(ifile)

  !error message if no fields found with correct first longitude in it
  if (gotGrib.eq.0) then
    print*,'***ERROR: input file needs to contain GRiB1 formatted'// &
         'messages'
    stop
  endif

  nuvzn=iumax
  nwzn=iwmax
  if(nuvzn.eq.nlev_ec) nwzn=nlev_ecn+1

  if (nxn(l).gt.nxmaxn) then
  write(*,*) 'FLEXPART error: Too many grid points in x direction.'
  write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
  write(*,*) 'for nesting level ',l
  write(*,*) 'Or change parameter settings in file par_mod.'
  write(*,*) nxn(l),nxmaxn
  stop
  endif

  if (nyn(l).gt.nymaxn) then
  write(*,*) 'FLEXPART error: Too many grid points in y direction.'
  write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
  write(*,*) 'for nesting level ',l
  write(*,*) 'Or change parameter settings in file par_mod.'
  write(*,*) nyn(l),nymaxn
  stop
  endif

  if ((nuvzn.gt.nuvzmax).or.(nwzn.gt.nwzmax)) then
  write(*,*) 'FLEXPART error: Nested wind fields have too many'// &
       'vertical levels.'
  write(*,*) 'Problem was encountered for nesting level ',l
  stop
  endif


  ! Output of grid info
  !********************

  write(*,'(a,i2)') 'Nested domain #: ',l
  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
       xlon0n(l),' to ',xlon0n(l)+(nxn(l)-1)*dxn(l), &
       '   Grid distance: ',dxn(l)
  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range: ', &
       ylat0n(l),' to ',ylat0n(l)+(nyn(l)-1)*dyn(l), &
       '   Grid distance: ',dyn(l)
  write(*,*)

  ! Determine, how much the resolutions in the nests are enhanced as
  ! compared to the mother grid
  !*****************************************************************

  xresoln(l)=dx/dxn(l)
  yresoln(l)=dy/dyn(l)

  ! Determine the mother grid coordinates of the corner points of the
  ! nested grids
  ! Convert first to geographical coordinates, then to grid coordinates
  !********************************************************************

  xaux1=xlon0n(l)
  xaux2=xlon0n(l)+real(nxn(l)-1)*dxn(l)
  yaux1=ylat0n(l)
  yaux2=ylat0n(l)+real(nyn(l)-1)*dyn(l)

  xln(l)=(xaux1-xlon0)/dx
  xrn(l)=(xaux2-xlon0)/dx
  yln(l)=(yaux1-ylat0)/dy
  yrn(l)=(yaux2-ylat0)/dy


  if ((xln(l).lt.0.).or.(yln(l).lt.0.).or. &
       (xrn(l).gt.real(nxmin1)).or.(yrn(l).gt.real(nymin1))) then
    write(*,*) 'Nested domain does not fit into mother domain'
    write(*,*) 'For global mother domain fields, you can shift'
    write(*,*) 'shift the mother domain into x-direction'
    write(*,*) 'by setting nxshift (file par_mod) to a'
    write(*,*) 'positive value. Execution is terminated.'
    stop
  endif


  ! CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
  ! PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM

  numskip=nlev_ecn-nuvzn ! number of ecmwf model layers not used by FLEXPART
  do i=1,nwzn
    j=numskip+i
    k=nlev_ecn+1+numskip+i
    akmn(nwzn-i+1)=zsec2(j)
    bkmn(nwzn-i+1)=zsec2(k)
  end do

  !
  ! CALCULATION OF AKZ, BKZ
  ! AKZ,BKZ: model discretization parameters at the center of each model
  !     layer
  !
  ! Assign the 10 m winds to an artificial model level with akz=0 and bkz=1.0,
  ! i.e. ground level
  !*****************************************************************************

    akzn(1)=0.
    bkzn(1)=1.0
    do i=1,nuvzn
      akzn(i+1)=0.5*(akmn(i+1)+akmn(i))
      bkzn(i+1)=0.5*(bkmn(i+1)+bkmn(i))
    end do
    nuvzn=nuvzn+1

  ! Check, whether the heights of the model levels of the nested
  ! wind fields are consistent with those of the mother domain.
  ! If not, terminate model run.
  !*************************************************************

    do i=1,nuvz
      if ((akzn(i).ne.akz(i)).or.(bkzn(i).ne.bkz(i))) then
  write(*,*) 'FLEXPART error: The wind fields of nesting level',l
  write(*,*) 'are not consistent with the mother domain:'
  write(*,*) 'Differences in vertical levels detected.'
        stop
      endif
    end do

    do i=1,nwz
      if ((akmn(i).ne.akm(i)).or.(bkmn(i).ne.bkm(i))) then
  write(*,*) 'FLEXPART error: The wind fields of nesting level',l
  write(*,*) 'are not consistent with the mother domain:'
  write(*,*) 'Differences in vertical levels detected.'
        stop
      endif
    end do

  end do

  return

999   write(*,*)
  write(*,*) ' ###########################################'// &
       '###### '
  write(*,*) '                FLEXPART SUBROUTINE GRIDCHECK:'
  write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfnamen(l,ifn)
  write(*,*) ' FOR NESTING LEVEL ',k
  write(*,*) ' ###########################################'// &
       '###### '
  stop

end subroutine gridcheck_nests

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  !   L. Bakels 2022: This module contains the timemanager                     *
  !                                                                            *
  !*****************************************************************************

module timemanager_mod

implicit none

contains

subroutine timemanager

  !*****************************************************************************
  !                                                                            *
  ! Handles the computation of trajectories, i.e. determines which             *
  ! trajectories have to be computed at what time.                             *
  ! Manages dry+wet deposition routines, radioactive decay and the computation *
  ! of concentrations.                                                         *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     20 May 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:                                     *
  !        Call of convmix when new windfield is read                          *
  !------------------------------------                                        *
  !  Changes Petra Seibert, Sept 2002                                          *
  !     fix wet scavenging problem                                             *
  !     Code may not be correct for decay of deposition!                       *
  !  Changes Petra Seibert, Nov 2002                                           *
  !     call convection BEFORE new fields are read in BWD mode                 *
  !  Changes Caroline Forster, Feb 2005                                        *
  !   new interface between flexpart and convection scheme                     *
  !   Emanuel's latest subroutine convect43c.f is used                         *
  !  Changes Stefan Henne, Harald Sodemann, 2013-2014                          *
  !   added netcdf output code                                                 *
  !  Changes Espen Sollum 2014                                                 *
  !   For compatibility with MPI version,                                      *
  !   variables uap,ucp,uzp,us,vs,ws,cbt now in module com_mod                 *
  !  Unified ECMWF and GFS builds                                              *
  !   Marian Harustak, 12.5.2017                                               *
  !  Changes L Bakels 2022: - OpenMP parallelisation                           *
  !                         - converting input to ETA coordinates              *
  !                         - spawning particles from part_ic.nc               *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! DEP                .true. if either wet or dry deposition is switched on   *
  ! decay(maxspec) [1/s] decay constant for radioactive decay                  *
  ! DRYDEP             .true. if dry deposition is switched on                 *
  ! ideltas [s]        modelling period                                        *
  ! itime [s]          actual temporal position of calculation                 *
  ! ldeltat [s]        time since computation of radioact. decay of depositions*
  ! loutaver [s]       averaging period for concentration calculations         *
  ! loutend [s]        end of averaging for concentration calculations         *
  ! loutnext [s]       next time at which output fields shall be centered      *
  ! loutsample [s]     sampling interval for averaging of concentrations       *
  ! loutstart [s]      start of averaging for concentration calculations       *
  ! loutstep [s]       time interval for which concentrations shall be         *
  !                    calculated                                              *
  ! loutrestart [s]    time interval for which restart files will be produced  *
  ! npoint             index, which starting point the trajectory has          *
  !                    starting positions of trajectories                      *
  ! nstop              serves as indicator for fate of particles               *
  !                    in the particle loop                                    *
  ! nstop1             serves as indicator for wind fields (see getfields)     *
  ! outnum             number of samples for each concentration calculation    *
  ! recoutnum          number of samples for each receptor calculation         *
  ! recoutnumsat       number of samples for each satellite calculation        *
  ! prob               probability of absorption at ground due to dry          *
  !                    deposition                                              *
  ! WETDEP             .true. if wet deposition is switched on                 *
  ! weight             weight for each concentration sample (1/2 or 1)         *
  !                                                                            *
  !*****************************************************************************
  ! openmp change
  use omp_lib
  ! openmp change end
  use unc_mod
  use point_mod
  use xmass_mod
  use flux_mod
  use outgrid_mod
!  use ohr_mod
  use par_mod
  use com_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif
  use particle_mod
  use conv_mod
  use windfields_mod
  use advance_mod, only: advance
  use drydepo_mod
  use wetdepo_mod
  use plume_mod
  use initialise_mod
  use getfields_mod
  use output_mod
  use restart_mod
  use interpol_mod, only: alloc_interpol,dealloc_interpol
#ifdef USE_NCF
  use chemistry_mod
  use initdomain_mod
  use receptor_netcdf_mod, only: readreceptors_satellite, verttransform_satellite
  use emissions_mod
  use totals_mod
#endif
  use receptor_mod, only: receptoroutput

  implicit none
  real, parameter ::        &
    e_inv = 1.0/exp(1.0)  
  integer ::                &
    j,i,                    & ! loop variables
    iterminate,             & ! Keep track of terminated particles per timestep
    ks,                     & ! loop variable species
    kp,                     & ! loop variable for maxpointspec_act
    itime=0,                & ! time index
    nstop1,                 & ! windfield existence flag
    loutnext,               & ! following timestep
    loutstart,loutend,      & ! concentration calculation starting and ending time
    lrecoutnext,            & ! following timestep for receptor output
    lrecoutstart,lrecoutend,& ! receptor calculation interval start and end time
    ldeltat,                & ! radioactive decay time
    itage,nage,inage,       & ! related to age classes
    i_nan=0,ii_nan,total_nan_intl=0, &  !added by mc to check instability in CBL scheme 
    stat,                   & ! Check if allocation was successful
    thread                    ! openmp thread number
  ! logical ::                &
  !   active_per_rel(maxpoint)  ! are there particles active in each release
  real ::                   &
    filesize!(maxpoint)        ! Keeping track of the size of the particledump output, so it can be splitted
  ! real(kind=dp) ::          &
  !   jul
  ! integer ::                &
  !   jjjjmmdd,ihmmss
  real ::                   &
    outnum,                 & ! number of samples for grid concentration calculation
    prob_rec(maxspec),      & ! dry deposition related
    xmassfract                ! dry deposition related
  real(dep_prec),allocatable,dimension(:) ::         &
    drytmp       ! dry deposition related
  logical :: itsopen
  real, dimension(maxrecsample) :: recoutnum ! number of samples for receptor calculation
  real, allocatable, dimension(:,:) :: recoutnumsat ! number of samples for satellite receptor calculation

  ! First output for time 0
  !************************
  if (itime_init.ne.0) then
    loutnext=loutnext_init
    lrecoutnext=lrecoutnext_init
    outnum=outnum_init
  else
    loutnext=loutstep/2
    lrecoutnext=lrecoutstep/2
    outnum=0.
  endif
  recoutnum(:)=0.
!  recoutnumsat(:,:)=0.
  loutstart=loutnext-loutaver/2
  loutend=loutnext+loutaver/2
  lrecoutstart=lrecoutnext-lrecoutaver/2
  lrecoutend=lrecoutnext+lrecoutaver/2

  ! Initialise the nan count for CBL option
  !****************************************
  sum_nan_count(:) = 0
  nan_count(:) = 0

  !**********************************************************************
  ! Loop over the whole modelling period in time steps of mintime seconds
  !**********************************************************************

  write(*,46) float(itime)/3600,itime,numpart
46      format(' Simulated ',f7.1,' hours (',i13,' s), ',i13, ' particles')

  filesize=0.
  ! active_per_rel=.false.
  
  do itime=itime_init,ideltas,lsynctime

  ! Computation of wet deposition, OH reaction and mass transfer
  ! between two species every lsynctime seconds
  ! maybe wet depo frequency can be relaxed later but better be on safe side
  ! wetdepo must be called BEFORE new fields are read in but should not
  ! be called in the very beginning before any fields are loaded, or
  ! before particles are in the system
  ! Code may not be correct for decay of deposition
  ! changed by Petra Seibert 9/02
  !********************************************************************

  ! Write basic information on the simulation to a file "header" for the
  ! first time step and open files that are to be kept open throughout 
  ! the simulation.
  ! In addition, open new particle dump files if required and keep track
  ! of the size of these files.
  !*********************************************************************
    
    write(*,*) 'Time: ', itime, 'seconds. Total spawned:',count%spawned, 'alive:',count%alive, 'terminated:',count%terminated

    if (itime.eq.itime_init) then
      call SYSTEM_CLOCK(count_clock, count_rate, count_max)
      s_firstt = real(count_clock)/real(count_rate)
    endif

    call init_output(itime,filesize)

  ! Get necessary wind fields if not available
  !*******************************************
    call getfields(itime,nstop1) !OMP on verttransform_ecmwf and readwind_ecmwf, getfields_mod.f90
    if (nstop1.gt.1) error stop 'NO METEO FIELDS AVAILABLE'

  ! In case of ETA coordinates being read from file, convert the z positions to zeta
  !*********************************************************************************
#ifdef ETA
    if ((itime.eq.itime_init).and.((ipin.eq.1).or.(ipin.eq.3).or.(ipin.eq.4))) then 
      
      if (count%allocated.le.0) error stop 'Something is going wrong reading the old particle file! &
        &No particles found.'
!$OMP PARALLEL PRIVATE(i)
!$OMP DO
      do i=1,count%allocated ! Also includes particles that are not spawned yet
        ! If kindz>1, vertical positions computation
        if (ipin.eq.3 .or. ipin.eq.4) call kindz_to_z(i) 
#ifdef ETA
        call z_to_zeta(itime,part(i)%xlon,part(i)%ylat,part(i)%z,part(i)%zeta)
        part(i)%etaupdate = .true.
        part(i)%meterupdate = .true.
#endif
      end do
!$OMP END DO
!$OMP END PARALLEL
    endif
#endif

    if (WETDEP .and. (itime.ne.0) .and. (numpart.gt.0)) then
      call wetdepo(itime,lsynctime,loutnext)
    endif

  ! compute chemical losses 
  !************************
#ifdef USE_NCF
    if (CLREA .and. (itime.ne.0) .and. (numpart.gt.0)) then
      call chemreaction(itime)
    endif
#endif

  ! compute convection for backward runs
  !*************************************

    if ((ldirect.eq.-1).and.(lconvection.eq.1).and.(itime.lt.0)) then
      call convmix(itime)
    endif

  ! Get chemical fields if not available 
  !*************************************
#ifdef USE_NCF
    if (CLREA) then
      call getchemfield(itime)
      call getchemhourly(itime)
    endif
#endif
        
  ! Get emission fields if not available
  !*************************************

#ifdef USE_NCF
    if (LEMIS.and.mdomainfill.eq.1) then
      call getemissions(itime)
    endif
#endif

  ! Read satellite receptors
  !*************************

#ifdef USE_NCF
  call readreceptors_satellite(itime)
#endif
  if (.not.allocated(recoutnumsat)) then
    allocate(recoutnumsat(nlayermax,maxrecsample))
    recoutnumsat(:,:)=0.
  endif

  ! Release particles
  !******************
    if (mdomainfill.ge.1) then
      if (itime.eq.itime_init) then 
        if (llcmoutput) then  
#ifdef USE_NCF
          call init_domainfill_ncf
#else
          call init_domainfill
#endif
        else
          call init_domainfill
        endif
        if (ipin.eq.2) then
          ! Particles initialized from partoutput
#ifdef ETA
!$OMP PARALLEL PRIVATE(i,j)
!$OMP DO
          do i=1,count%alive
            j=count%ialive(i)
            call update_z_to_zeta(itime,j)
          end do
!$OMP END DO
!$OMP END PARALLEL
#endif
        endif
      else 
        call boundcond_domainfill(itime,loutend)
      endif
    else if ((ipin.eq.3).or.(ipin.eq.4)) then
      ! If reading from user defined initial conditions, check which particles are 
      ! to be activated
      if (count%allocated.le.0) error stop 'Something is going wrong reading the part_ic.nc file!'

      do i=1,count%allocated
        if (.not. part(i)%alive) then
          if (ldirect.lt.0) then
            if ((part(i)%tstart.le.itime).and.(part(i)%tstart.gt.itime+lsynctime)) then
              call spawn_particle(itime,i)
              call init_mass_conversion(i,part(i)%npoint)
            endif
          else if ((part(i)%tstart.ge.itime).and.(part(i)%tstart.lt.itime+lsynctime)) then
            call spawn_particle(itime,i)
            call init_mass_conversion(i,part(i)%npoint)
          endif
        endif
      end do

#ifdef ETA
!$OMP PARALLEL PRIVATE(i,j)
!$OMP DO
      do i=1,count%alive
        j=count%ialive(i)
        if (part(j)%tstart.eq.itime) then
          call update_z_to_zeta(itime,j)
        end if
      end do
!$OMP END DO
!$OMP END PARALLEL
#endif
      call get_totalpart_num(numpart)
    else
      call releaseparticles(itime)
    endif

  ! Inject emissions
  !*****************

#ifdef USE_NCF
    if (LEMIS.and.mdomainfill.eq.1) then
      call emissions(itime)
    endif
#endif

  ! Compute convective mixing for forward runs
  ! for backward runs it is done before next windfield is read in
  !**************************************************************
    if ((ldirect.eq.1).and.(lconvection.eq.1)) then
      call convmix(itime) !OMP (not the nested part yet), conv_mod.f90
    endif

  ! If middle of averaging period of output fields is reached, accumulated
  ! deposited mass radioactively decays
  !***********************************************************************
    if (DEP.and.(itime.eq.loutnext).and.(ldirect.gt.0)) call deposit_decay() !OMP, unc_mod.f90 (needs test)


  ! Is the time within the computation interval, if not, skip
  !************************************************************
    if ((ldirect*itime.ge.ldirect*loutstart).and.(ldirect*itime.le.ldirect*loutend)) then
      call SYSTEM_CLOCK(count_clock, count_rate, count_max)
      s_temp = (count_clock - count_clock0)/real(count_rate)
      ! If it is not time yet to write outputs, skip
      !***********************************************
      if ((itime.eq.loutend).and.(outnum.gt.0).and.(itime.ne.0)) then

        if ((iout.eq.4).or.(iout.eq.5)) call plumetraj(itime)
        if (iflux.eq.1) call fluxoutput(itime)
        if (ipout.eq.1) then
          if (mod(itime,ipoutfac*loutstep).eq.0) then

            call output_particles(itime)!,active_per_rel) ! dump particle positions
          endif
        endif
      endif
      ! Check whether concentrations are to be calculated and outputted
      !****************************************************************
      call output_conc(itime,loutstart,loutend,loutnext,outnum)
      call SYSTEM_CLOCK(count_clock, count_rate, count_max)
      s_writepart = s_writepart + ((count_clock - count_clock0)/real(count_rate)-s_temp)
    endif

  ! Check whether receptor concentrations are to be calculated
  !***********************************************************

    if ((ldirect*itime.ge.ldirect*lrecoutstart).and. &
          ((numreceptor.gt.0.).or.(numsatreceptor.gt.0)).and. &
          (ldirect*itime.le.ldirect*lrecoutend)) then
      call receptoroutput(itime,lrecoutstart,lrecoutend,lrecoutnext,recoutnum,recoutnumsat)
    endif

  ! Writing restart file
  !*********************
    if ((itime.ne.itime_init).and.(loutrestart.ne.-1).and.(mod(itime,loutrestart).eq.0)) then
      call output_restart(itime,loutnext,lrecoutnext,0.)
    endif

    if (itime.eq.ideltas) exit         ! almost finished

  ! Compute interval since radioactive decay of deposited mass was computed
  !************************************************************************

    if (itime.lt.loutnext) then
      ldeltat=itime-(loutnext-loutstep)
    else                                  ! first half of next interval
      ldeltat=itime-loutnext
    endif


  ! Loop over all particles
  !************************
  ! Various variables for testing reason of CBL scheme, by mc
    well_mixed_vector=0. !erase vector to test well mixed condition: modified by mc
    well_mixed_norm=0.   !erase normalization to test well mixed condition: modified by mc
    avg_ol=0.
    avg_wst=0.
    avg_h=0.
    avg_air_dens=0.  !erase vector to obtain air density at particle positions: modified by mc
  !-----------------------------------------------------------------------------

  ! openmp change
  ! LB, openmp following CTM version
!$OMP PARALLEL PRIVATE(prob_rec,inage,nage,itage,ks,kp,thread,j,i,xmassfract)

#if (defined _OPENMP)
    thread = OMP_GET_THREAD_NUM() ! Starts with 0
#else
    thread = 0
#endif

!$OMP DO SCHEDULE(dynamic,max(1,numpart/1000))
! SCHEDULE(dynamic, max(1,numpart/1000))
!max(1,int(real(numpart)/numthreads/20.)))
    do i=1,count%alive

      j=count%ialive(i)

  ! If integration step is due, do it
  !**********************************
  ! Determine age class of the particle
  !************************************
      itage=abs(itime-part(j)%tstart)
      nage=1
      if (lagespectra.eq.1) then
        do inage=1,nageclass
          nage=inage
          if (itage.lt.lage(nage)) exit
        end do
      endif

  ! Initialize newly released particle
  !***********************************
      if ((part(j)%tstart.eq.itime).or.(itime.eq.0)) then
#ifdef ETA
        call update_zeta_to_z(itime, j)
#endif
        call init_particle(itime,j,thread)
      endif

  ! Memorize particle positions
  !****************************
      part(j)%xlon_prev=part(j)%xlon
      part(j)%ylat_prev=part(j)%ylat
      part(j)%z_prev=part(j)%z
#ifdef ETA
      part(j)%zeta_prev=part(j)%zeta
#endif

  ! RECEPTOR: dry/wet depovel
  !****************************
  ! Before the particle is moved 
  ! the calculation of the scavenged mass shall only be done once after release
  ! xscav_frac1 was initialised with a negative value

      if  (DRYBKDEP) then
        do ks=1,nspec
          if  ((xscav_frac1(j,ks).lt.0)) then
#ifdef ETA
            call update_zeta_to_z(itime,j)
#endif
            call get_vdep_prob(itime,real(part(j)%xlon),real(part(j)%ylat), &
              real(part(j)%z),prob_rec,thread+1)
            if (DRYDEPSPEC(ks)) then        ! dry deposition
              xscav_frac1(j,ks)=prob_rec(ks)
            else
              mass(j,ks)=0.
              xscav_frac1(j,ks)=0.
            endif
          endif
        enddo
      endif

  ! Integrate Langevin equation for lsynctime seconds
  !*************************************************

      call advance(itime,j,thread)

      if (part(j)%nstop.eqv..true.) cycle
      if (n_average.gt.0) call partpos_avg(itime,j)

  ! Calculate the gross fluxes across layer interfaces
  !***************************************************
      if (iflux.eq.1) call calcfluxes(itime,nage,j,real(part(j)%xlon_prev), &
        real(part(j)%ylat_prev),real(part(j)%z_prev),thread+1)
    end do
!$OMP END DO
!$OMP END PARALLEL

#ifdef _OPENMP
  call omp_set_num_threads(numthreads_grid)
#endif

  ! Terminating particles flagged in advance call
  iterminate=0
  do i=1,count%allocated
    if ((part(i)%nstop).and.(part(i)%alive)) then
      call terminate_particle(i,itime)
      iterminate=iterminate+1
    endif
  end do
  if (iterminate.gt.0) call rewrite_ialive()

  if (DRYDEP.or.WETDEP.or.LDECAY.or.(lagespectra.eq.1)) then
!$OMP PARALLEL PRIVATE(prob_rec,nage,inage,itage,ks,kp,thread,i,j,xmassfract,drytmp)

!num_threads(numthreads_grid)

#if (defined _OPENMP)
    thread = OMP_GET_THREAD_NUM() ! Starts with 0
#else
    thread = 0
#endif
  if (DRYDEP) then
    allocate( drytmp(maxspec),stat=stat )
    if (stat.ne.0) write(*,*)'ERROR: could not allocate drytmp inside of OMP loop'
  endif

!$OMP DO SCHEDULE(static)
!, max(1,numpart/1000))
! SCHEDULE(dynamic, max(1,numpart/1000))
!max(1,int(real(numpart)/numthreads/20.)))
    do i=1,count%alive

      j=count%ialive(i)

  ! If integration step is due, do it
  !**********************************
  ! Determine age class of the particle
  !************************************
      itage=abs(itime-part(j)%tstart)
      nage=1
      if (lagespectra.eq.1) then
        do inage=1,nageclass
          nage=inage
          if (itage.lt.lage(nage)) exit
        end do
      endif

! Dry deposition and radioactive decay for each species
! Also check maximum (of all species) of initial mass remaining on the particle;
! if it is below a threshold value, terminate particle
!*****************************************************************************
      if (DRYDEP.or.WETDEP.or.LDECAY) then
        xmassfract=0.
        do ks=1,nspec

          if (DRYDEPSPEC(ks)) then     ! dry deposition (and radioactive decay)

            call drydepo_massloss(j,ks,ldeltat,drytmp(ks))

          else if (decay(ks).gt.0.) then  ! no dry depo, but radioactive decay

            mass(j,ks) = mass(j,ks) * &
              exp( -real(abs(lsynctime)) * decay(ks) )

          endif

    ! Skip check on mass fraction when npoint represents particle number
          if (mdomainfill.eq.0.and.mquasilag.eq.0) then
            if (ipin.eq.3 .or. ipin.eq.4) then 
              if (mass_init(j,ks).gt.0) &
                xmassfract = max( xmassfract, &
                                  mass(j,ks) / mass_init(j,ks) )
            else if (xmass(part(j)%npoint,ks).gt.0.) then
              xmassfract = max( xmassfract, real( npart(part(j)%npoint) ) * &
                mass(j,ks) /  xmass(part(j)%npoint,ks) )
            endif
          else
            xmassfract=1.0
          end if

        end do
        
        if (xmassfract.le.minmassfrac) then 
          ! flag all particles carrying less mass for termination after parallel region
          part(j)%nstop=.true.
        endif
      endif
!        Sabine Eckhardt, June 2008
!        don't create depofield for backward runs
      if (DRYDEP.AND.(ldirect.eq.1).and.(iout.ne.0)) then

        if (ioutputforeachrelease.eq.1) then
            kp=part(j)%npoint
        else
            kp=1
        endif

        call drydepokernel(part(j)%nclass,drytmp,real(part(j)%xlon), &
             real(part(j)%ylat),nage,kp,thread+1)
        if (nested_output.eq.1) call drydepokernel_nest( &
             part(j)%nclass,drytmp,real(part(j)%xlon),real(part(j)%ylat), &
             nage,kp,thread+1)
      endif

  ! Terminate trajectories that are older than maximum allowed age
  !***************************************************************
      if (lagespectra.eq.1) then
        if ((part(j)%alive).and.(abs(itime-part(j)%tstart).ge.lage(nageclass))) then
          if (linit_cond.ge.1) call initcond_calc(itime+lsynctime,j,thread+1)
          ! flag all particles for termination after parallel region
          part(j)%nstop=.true.
        endif
      endif
    end do !loop over particles

!$OMP END DO
    if (DRYDEP) deallocate(drytmp)
!$OMP END PARALLEL
  
    ! Terminating particles flagged due to insufficient mass or exceeded max age
    iterminate=0
    do i=1,count%allocated
      if ((part(i)%nstop).and.(part(i)%alive)) then
        call terminate_particle(i,itime)
        iterminate=iterminate+1
      endif
    end do
    if (iterminate.gt.0) call rewrite_ialive()

  endif !(DRYDEP.or.WETDEP.or.LDECAY.or.(lagespectra.eq.1))

#ifdef _OPENMP
  call omp_set_num_threads(numthreads)
#endif
  ! OpenMP Reduction for dynamically allocated arrays. This is done manually since this
  ! is not yet supported in most OpenMP versions
  !************************************************************************************
#ifdef _OPENMP
    if (iflux.eq.1) then
      do i=1,numthreads
        flux(:,:,:,:,:,:,:)=flux(:,:,:,:,:,:,:)+flux_omp(:,:,:,:,:,:,:,i)
        flux_omp(:,:,:,:,:,:,:,i)=0.
      end do
    endif
    if (linit_cond.ge.1) then
      do i=1,numthreads_grid
        init_cond(:,:,:,:,:)=init_cond(:,:,:,:,:)+init_cond_omp(:,:,:,:,:,i)
        init_cond_omp(:,:,:,:,:,i)=0.
      end do
    endif
    if (DRYDEP.AND.(ldirect.eq.1).and.(iout.ne.0)) then
      do i=1,numthreads_grid
        drygridunc(:,:,:,:,:,:)=drygridunc(:,:,:,:,:,:)+gridunc_omp(:,:,1,:,:,:,:,i)
        gridunc_omp(:,:,1,:,:,:,:,i)=0.
      end do
      if (nested_output.eq.1) then
        do i=1,numthreads_grid
          drygriduncn(:,:,:,:,:,:)=drygriduncn(:,:,:,:,:,:)+griduncn_omp(:,:,1,:,:,:,:,i)
          griduncn_omp(:,:,1,:,:,:,:,i)=0.
        end do
      endif
    endif
#endif
  ! write(*,*) 'DRYGRIDUNC:',sum(drygridunc),drygridunc(20,270,1,1,1,1),drygridunc(19,269,1,1,1,1)
  ! Counter of "unstable" particle velocity during a time scale of
  ! maximumtl=20 minutes (defined in com_mod)
  !***************************************************************
    
    total_nan_intl=0
    i_nan=i_nan+1 ! added by mc to count nan during a time of maxtl (i.e. maximum tl fixed here to 20 minutes, see com_mod)
    do i=1,numthreads
      sum_nan_count(i_nan)=sum_nan_count(i_nan)+nan_count(i)
    end do
    if (i_nan > maxtl/lsynctime) i_nan=1 !lsynctime must be <= maxtl
    do ii_nan=1, (maxtl/lsynctime) 
      total_nan_intl=total_nan_intl+sum_nan_count(ii_nan)
    end do
  ! Output to keep track of the numerical instabilities in CBL simulation and if
  ! they are compromising the final result (or not)
    if (cblflag.eq.1) print *,j,itime,'nan_synctime',sum_nan_count(i_nan),'nan_tl',total_nan_intl  

    if (itime.eq.itime_init) then
      call SYSTEM_CLOCK(count_clock, count_rate, count_max)
      s_firstt = real(count_clock)/real(count_rate) - s_firstt
    endif

    ! Output totals
    !**************

#ifdef USE_NCF
    if ((mdomainfill.eq.1).and.(llcmoutput)) then
      do ks=1,nspec
        tot_mass(ks)=sum(real(mass(1:count%alive,ks),kind=dp))
      end do
      call totals_write(itime)
    endif
#endif

  end do

  ! Complete the calculation of initial conditions for particles not yet terminated
  !*****************************************************************************
  call finalise_output(itime)

  ! Output residual emissions
  !**************************

#ifdef USE_NCF
  if (LEMIS.and.(ipout.eq.2)) then
    call em_res_write
  endif
#endif

  ! De-allocate memory and end
  !***************************
  call dealloc_all_particles
  call dealloc_windfields
  call dealloc_domainfill
  call dealloc_drydepo
  call dealloc_convect
  call dealloc_getfields
  call dealloc_interpol
  call dealloc_random
  if (numbnests.ge.1) call dealloc_windfields_nest
  if (iflux.eq.1) deallocate(flux)
  if (ipin.ne.3 .and. ipin.ne.4) deallocate(xmasssave)
  if (CLREA) then
    deallocate(CL_field,lonCL,latCL,altCL)
  endif
  deallocate(reaccconst,reacdconst,reacnconst)
  deallocate(emis_path,emis_file,emis_name,emis_unit,emis_coeff)
  if (lnetcdfout.eq.1) then
#ifdef USE_NCF
    call dealloc_netcdf
    if (LEMIS) then
      deallocate(em_field,em_res,em_area,mass_field)
    endif
#endif 
  else
    inquire(unit=unitoutrecept, opened=itsopen)
    if (itsopen) close(unitoutrecept)
    inquire(unit=unitoutreceptppt, opened=itsopen)
    if (itsopen) close(unitoutreceptppt)
    inquire(unit=unitoutsatellite, opened=itsopen)
    if (itsopen) close(unitoutsatellite)
  endif
  deallocate(xpoint1,xpoint2,ypoint1,ypoint2,zpoint1,zpoint2)
  deallocate(xmass)
  deallocate(ireleasestart,ireleaseend,npart,kindz)
  deallocate(nan_count)
  if (ipout.ne.0) deallocate( partopt )
  if (iout.ne.0) then
    deallocate(outheight,outheighthalf)
    deallocate(oroout, area, volume)
    deallocate(gridunc)
    deallocate(gridcnt)
#ifdef _OPENMP
    deallocate(gridunc_omp)
    deallocate(gridcnt_omp)
#endif
    if (ldirect.gt.0) then
      deallocate(drygridunc,wetgridunc)
#ifdef _OPENMP
      deallocate(drygridunc_omp,wetgridunc_omp)
#endif
    endif
    if (nested_output.eq.1) then
      deallocate(orooutn, arean, volumen)
      if (ldirect.gt.0) then
        deallocate(griduncn,drygriduncn,wetgriduncn)
#ifdef _OPENMP
        deallocate(griduncn_omp,drygriduncn_omp,wetgriduncn_omp)
#endif
      endif
    endif
  endif
end subroutine timemanager

end module timemanager_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

!##################################################################
!##################################################################
!######                                                      ######
!######                     Developed by                     ######
!######     Center for Analysis and Prediction of Storms     ######
!######                University of Oklahoma                ######
!######                                                      ######
!##################################################################
!##################################################################

function f_qvsat( p, t )

  !PURPOSE:
  !
  !Calculate the saturation specific humidity using enhanced Teten's
  !formula.
  !
  !AUTHOR: Yuhe Liu
  !01/08/1998
  !
  !MODIFICATION HISTORY:
  !
  !INPUT :
  !  p        Pressure (Pascal)
  !  t        Temperature (K)
  !OUTPUT:
  !  f_qvsat  Saturation water vapor specific humidity (kg/kg).
  !
  !Variable Declarations.
  !

  implicit none

  real :: p         ! Pressure (Pascal)
  real :: t         ! Temperature (K)
  real :: f_qvsat   ! Saturation water vapor specific humidity (kg/kg)
  real :: f_esl,f_esi,fespt

  real,parameter ::  rd     = 287.0 ! Gas constant for dry air  (m**2/(s**2*K))
  real,parameter ::  rv     = 461.0 ! Gas constant for water vapor  (m**2/(s**2*K)).
  real,parameter ::  rddrv  = rd/rv


  ! Change by A. Stohl to save computation time:
  ! IF ( t.ge.273.15 ) THEN     ! for water
  if ( t.ge.253.15 ) then      ! modification Petra Seibert
                               ! (supercooled water may be present)
    fespt=f_esl(p,t)
  else
    fespt=f_esi(p,t)
  endif

!!$  f_qvsat = rddrv * fespt / (p-(1.0-rddrv)*fespt)      !old
  if (p-(1.0-rddrv)*fespt == 0.) then                     !bugfix
     f_qvsat = 1.
  else
     f_qvsat = rddrv * fespt / (p-(1.0-rddrv)*fespt)
  end if

  return
end function f_qvsat


function f_esl( p, t )

  implicit none

  real :: p         ! Pressure (Pascal)
  real :: t         ! Temperature (K)
  real :: f_esl     ! Saturation water vapor pressure over liquid water

  real :: f

  !#######################################################################
  !
  !Saturation specific humidity parameters used in enhanced Teten's
  !formula. (See A. Buck, JAM 1981)
  !
  !#######################################################################

  real,parameter ::  satfwa = 1.0007
  real,parameter ::  satfwb = 3.46e-8  ! for p in Pa

  real,parameter ::  satewa = 611.21   ! es in Pa
  real,parameter ::  satewb = 17.502
  real,parameter ::  satewc = 32.18

  real,parameter ::  satfia = 1.0003
  real,parameter ::  satfib = 4.18e-8  ! for p in Pa

  real,parameter ::  sateia = 611.15   ! es in Pa
  real,parameter ::  sateib = 22.452
  real,parameter ::  sateic = 0.6

  f = satfwa + satfwb * p
  f_esl = f * satewa * exp( satewb*(t-273.15)/(t-satewc) )

  return
end function f_esl

function f_esi( p, t )

  implicit none

  real :: p         ! Pressure (Pascal)
  real :: t         ! Temperature (K)
  real :: f_esi     ! Saturation water vapor pressure over ice (Pa)

  real :: f

  !#######################################################################
  !
  !Saturation specific humidity parameters used in enhanced Teten's
  !formula. (See A. Buck, JAM 1981)
  !
  !#######################################################################
  !
  real,parameter ::  satfwa = 1.0007
  real,parameter ::  satfwb = 3.46e-8  ! for p in Pa

  real,parameter ::  satewa = 611.21   ! es in Pa
  real,parameter ::  satewb = 17.502
  real,parameter ::  satewc = 32.18

  real,parameter ::  satfia = 1.0003
  real,parameter ::  satfib = 4.18e-8  ! for p in Pa

  real,parameter ::  sateia = 611.15   ! es in Pa
  real,parameter ::  sateib = 22.452
  real,parameter ::  sateic = 0.6

  f = satfia + satfib * p
  f_esi = f * sateia * exp( sateib*(t-273.15)/(t-sateic) )

  return
end function f_esi

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module xmass_mod
  
  implicit none
  
  real,allocatable, dimension (:) :: xmasssave
  
end module xmass_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readdepo

  !*****************************************************************************
  !                                                                            *
  !  Reads dry deposition parameters needed by the procedure of Wesely (1989). *
  !  Wesely (1989): Parameterization of surface resistances to gaseous         *
  !  dry deposition in regional-scale numerical models.                        *
  !  Atmos. Environ. 23, 1293-1304.                                            *
  !                                                                            *
  !                                                                            *
  !      AUTHOR: Andreas Stohl, 19 May 1995                                    *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! rcl(maxspec,5,9) [s/m] Lower canopy resistance                             *
  ! rgs(maxspec,5,9) [s/m] Ground resistance                                   *
  ! rlu(maxspec,5,9) [s/m] Leaf cuticular resistance                           *
  ! rm(maxspec) [s/m]      Mesophyll resistance, set in readreleases           *
  ! ri(maxspec) [s/m]      Stomatal resistance                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  ! FOR THIS SUBROUTINE, numclass=9 IS ASSUMED
  !*******************************************

  real :: rluh(5,numclass),rgssh(5,numclass),rgsoh(5,numclass)
  real :: rclsh(5,numclass),rcloh(5,numclass)
  integer :: i,j,ic


  ! Read deposition constants related with landuse and seasonal category
  !*********************************************************************
  open(unitwesely,file=path(1)(1:length(1))//'surfdepo.t', &
       status='old',err=999)

  do i=1,16
    read(unitwesely,*)
  end do
  do i=1,5
    read(unitwesely,*)
    read(unitwesely,'(8x,13f8.0)') (ri(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rluh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rac(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rgssh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rgsoh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rclsh(i,j),j=1,numclass)
    read(unitwesely,'(8x,13f8.0)') (rcloh(i,j),j=1,numclass)
  end do

  ! TEST
  ! do 31 i=1,5
  !   ri(i,13)=ri(i,5)
  !   rluh(i,13)=rluh(i,5)
  !   rac(i,13)=rac(i,5)
  !   rgssh(i,13)=rgssh(i,5)
  !   rgsoh(i,13)=rgsoh(i,5)
  !   rclsh(i,13)=rclsh(i,5)
  !   rcloh(i,13)=rcloh(i,5)
  !31             continue
  ! TEST
  ! Sabine Eckhardt, Dec 06, set resistances of 9999 to 'infinite' (1E25)
  do i=1,5
    do j=1,numclass
      if    (ri(i,j).eq.9999.)    ri(i,j)=1.E25
      if  (rluh(i,j).eq.9999.)  rluh(i,j)=1.E25
      if   (rac(i,j).eq.9999.)   rac(i,j)=1.E25
      if (rgssh(i,j).eq.9999.) rgssh(i,j)=1.E25
      if (rgsoh(i,j).eq.9999.) rgsoh(i,j)=1.E25
      if (rclsh(i,j).eq.9999.) rclsh(i,j)=1.E25
      if (rcloh(i,j).eq.9999.) rcloh(i,j)=1.E25
    end do
  end do



  do i=1,5
    do j=1,numclass
      ri(i,j)=max(ri(i,j),0.001)
      rluh(i,j)=max(rluh(i,j),0.001)
      rac(i,j)=max(rac(i,j),0.001)
      rgssh(i,j)=max(rgssh(i,j),0.001)
      rgsoh(i,j)=max(rgsoh(i,j),0.001)
      rclsh(i,j)=max(rclsh(i,j),0.001)
      rcloh(i,j)=max(rcloh(i,j),0.001)
    end do
  end do
  close(unitwesely)


  ! Compute additional parameters
  !******************************

  do ic=1,nspec
    if (reldiff(ic).gt.0.) then     ! gas is dry deposited
      do i=1,5
        do j=1,numclass
          rlu(ic,i,j)=rluh(i,j)/(1.e-5*henry(ic)+f0(ic))
          rgs(ic,i,j)=1./(henry(ic)/(10.e5*rgssh(i,j))+f0(ic)/ &
               rgsoh(i,j))
          rcl(ic,i,j)=1./(henry(ic)/(10.e5*rclsh(i,j))+f0(ic)/ &
               rcloh(i,j))
        end do
      end do
    endif
  end do


  return


999   write(*,*) '### FLEXPART ERROR! FILE              ###'
  write(*,*) '### surfdepo.t DOES NOT EXIST.        ###'
  stop

end subroutine readdepo

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine outgrid_init_nest

  !*****************************************************************************
  !                                                                            *
  !  This routine calculates, for each grid cell of the output nest, the       *
  !  volume and the surface area.                                              *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !    30 August 2004                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! arean              surface area of all output nest cells                   *
  ! volumen            volumes of all output nest cells                        *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: ix,jy,kz,ks,kp,nage,l,iix,jjy,ixp,jyp,i1,j1,j,ngrid
  integer :: stat
  real :: ylat,gridarea,ylatp,ylatm,hzone,cosfactm,cosfactp
  real :: xlon,xl,yl,ddx,ddy,rddx,rddy,p1,p2,p3,p4,xtn,ytn,oroh
  real,parameter :: eps=nxmax/3.e5



  ! gridunc,griduncn        uncertainty of outputted concentrations
  allocate(griduncn(0:numxgridn-1,0:numygridn-1,numzgrid,maxspec, &
       maxpointspec_act,nclassunc,maxageclass),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc'

  if (ldirect.gt.0) then
  allocate(wetgriduncn(0:numxgridn-1,0:numygridn-1,maxspec, &
       maxpointspec_act,nclassunc,maxageclass),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc'
  allocate(drygriduncn(0:numxgridn-1,0:numygridn-1,maxspec, &
       maxpointspec_act,nclassunc,maxageclass),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR:could not allocate nested gridunc'
  endif

  ! Compute surface area and volume of each grid cell: area, volume;
  ! and the areas of the northward and eastward facing walls: areaeast, areanorth
  !***********************************************************************

  do jy=0,numygridn-1
    ylat=outlat0n+(real(jy)+0.5)*dyoutn
    ylatp=ylat+0.5*dyoutn
    ylatm=ylat-0.5*dyoutn
    if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
      hzone=dyoutn*r_earth*pi180
    else

  ! Calculate area of grid cell with formula M=2*pi*R*h*dx/360,
  ! see Netz, Formeln der Mathematik, 5. Auflage (1983), p.90
  !************************************************************

      cosfactp=cos(ylatp*pi180)
      cosfactm=cos(ylatm*pi180)
      if (cosfactp.lt.cosfactm) then
        hzone=sqrt(1-cosfactp**2)- &
             sqrt(1-cosfactm**2)
        hzone=hzone*r_earth
      else
        hzone=sqrt(1-cosfactm**2)- &
             sqrt(1-cosfactp**2)
        hzone=hzone*r_earth
      endif
    endif



  ! Surface are of a grid cell at a latitude ylat
  !**********************************************

    gridarea=2.*pi*r_earth*hzone*dxoutn/360.

    do ix=0,numxgridn-1
      arean(ix,jy)=gridarea

  ! Volume = area x box height
  !***************************

      volumen(ix,jy,1)=arean(ix,jy)*outheight(1)
      do kz=2,numzgrid
        volumen(ix,jy,kz)=arean(ix,jy)*(outheight(kz)-outheight(kz-1))
      end do
    end do
  end do


  !**************************************************************************
  ! Determine average height of model topography in nesteed output grid cells
  !**************************************************************************

  ! Loop over all output grid cells
  !********************************

  do jjy=0,numygridn-1
    do iix=0,numxgridn-1
      oroh=0.

  ! Take 100 samples of the topography in every grid cell
  !******************************************************

      do j1=1,10
        ylat=outlat0n+(real(jjy)+real(j1)/10.-0.05)*dyoutn
        yl=(ylat-ylat0)/dy
        do i1=1,10
          xlon=outlon0n+(real(iix)+real(i1)/10.-0.05)*dxoutn
          xl=(xlon-xlon0)/dx

  ! Determine the nest we are in
  !*****************************

          ngrid=0
          do j=numbnests,1,-1
            if ((xl.gt.xln(j)+eps).and.(xl.lt.xrn(j)-eps).and. &
                 (yl.gt.yln(j)+eps).and.(yl.lt.yrn(j)-eps)) then
              ngrid=j
              goto 43
            endif
          end do
43        continue

  ! Determine (nested) grid coordinates and auxiliary parameters used for interpolation
  !*****************************************************************************

          if (ngrid.gt.0) then
            xtn=(xl-xln(ngrid))*xresoln(ngrid)
            ytn=(yl-yln(ngrid))*yresoln(ngrid)
            ix=int(xtn)
            jy=int(ytn)
            ddy=ytn-real(jy)
            ddx=xtn-real(ix)
          else
            ix=int(xl)
            jy=int(yl)
            ddy=yl-real(jy)
            ddx=xl-real(ix)
          endif
          ixp=ix+1
          jyp=jy+1
          rddx=1.-ddx
          rddy=1.-ddy
          p1=rddx*rddy
          p2=ddx*rddy
          p3=rddx*ddy
          p4=ddx*ddy

          if (ngrid.gt.0) then
            oroh=oroh+p1*oron(ix ,jy ,ngrid) &
                 + p2*oron(ixp,jy ,ngrid) &
                 + p3*oron(ix ,jyp,ngrid) &
                 + p4*oron(ixp,jyp,ngrid)
          else
            oroh=oroh+p1*oro(ix ,jy) &
                 + p2*oro(ixp,jy) &
                 + p3*oro(ix ,jyp) &
                 + p4*oro(ixp,jyp)
          endif
        end do
      end do

  ! Divide by the number of samples taken
  !**************************************

      orooutn(iix,jjy)=oroh/100.
    end do
  end do



  !*******************************
  ! Initialization of output grids
  !*******************************

  do kp=1,maxpointspec_act
  do ks=1,nspec
    do nage=1,nageclass
      do jy=0,numygridn-1
        do ix=0,numxgridn-1
          do l=1,nclassunc
  ! Deposition fields
            if (ldirect.gt.0) then
              wetgriduncn(ix,jy,ks,kp,l,nage)=0.
              drygriduncn(ix,jy,ks,kp,l,nage)=0.
            endif
  ! Concentration fields
            do kz=1,numzgrid
              griduncn(ix,jy,kz,ks,kp,l,nage)=0.
            end do
          end do
        end do
      end do
    end do
  end do
  end do


end subroutine outgrid_init_nest

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

program flexpart

  !*****************************************************************************
  !                                                                            *
  !     This is the Lagrangian Particle Dispersion Model FLEXPART.             *
  !     The main program manages the reading of model run specifications, etc. *
  !     All actual computing is done within subroutine timemanager.            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     18 May 1996                                                            *
  !                                                                            *
  !*****************************************************************************
  ! Changes:                                                                   *
  !   Unified ECMWF and GFS builds                                             *
  !   Marian Harustak, 12.5.2017                                               *
  !     (moved to read_options_and_initialise_flexpart by LB)                  *
  !     - Added detection of metdata format using gributils routines           *
  !     - Distinguished calls to ecmwf/gfs gridcheck versions based on         *
  !       detected metdata format                                              *
  !     - Passed metdata format down to timemanager                            *
  !   L. Bakels 2022                                                           *
  !     - OpenMP parallelisation                                               *
  !     - Added input options                                                  *
  !     - Restructuring into subroutines (below)                               *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************
  use par_mod
  use com_mod
  use timemanager_mod
  use output_mod

  implicit none

  integer :: i
  real :: s_timemanager
  character(len=256) ::   &
    inline_options          ! pathfile, flexversion, arg2
  character(len=256) :: gitversion_tmp="undefined"

  ! Keeping track of the total running time of FLEXPART, printed out at the end.
  !*****************************************************************************
  CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
  s_total = (count_clock - count_clock0)/real(count_rate)

  ! FLEXPART version string
  flexversion_major = '11' ! Major version number, also used for species file names

  flexversion='Version '//trim(flexversion_major)//'.0 (2023-07-11)'
  verbosity=0

  call update_gitversion(gitversion_tmp)
  ! Read the pathnames where input/output files are stored
  !*******************************************************

  inline_options='none'
  select case (iargc())
  case (2)
    call getarg(1,arg1)
    pathfile=arg1
    call getarg(2,arg2)
    inline_options=arg2
  case (1)
    call getarg(1,arg1)
    pathfile=arg1
    if (arg1(1:1).eq.'-') then
      write(pathfile,'(a11)') './pathnames'
      inline_options=arg1 
    endif
  case (0)
    write(pathfile,'(a11)') './pathnames'
  end select

  ! Print the GPL License statement
  !******************************************************
  print*,'Welcome to FLEXPART ', trim(flexversion)
  print*,"Git: ", trim(gitversion)
  print*,'FLEXPART is free software released under the GNU General Public License.'
#ifdef ETA
  write(*,*) 'FLEXPART is running with ETA coordinates.'
#else
  write(*,*) 'FLEXPART is running with METER coordinates.'
#endif

  ! Reading user specified options, allocating fields and checking bounds
  !**********************************************************************
  call read_options_and_initialise_flexpart

  ! Inform whether output kernel is used or not
  !*********************************************
  if (lroot) then
    if (.not.lusekerneloutput) then
      write(*,*) "Concentrations are calculated without using kernel"
    else
      write(*,*) "Concentrations are calculated using kernel"
    end if
  end if

  if (lturbulence.eq.0) write(*,*) 'WARNING: turbulence switched off.'
  if (lmesoscale_turb) write(*,*) 'WARNING: mesoscale turbulence switched on.'
  if (log_interpol) write(*,*) 'WARNING: using logarithmical vertical interpolation.'
  ! Calculate particle trajectories
  !********************************
  CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
  s_timemanager = (count_clock - count_clock0)/real(count_rate)

  call timemanager

  CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
  s_timemanager = (count_clock - count_clock0)/real(count_rate) - s_timemanager

  CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
  s_total = (count_clock - count_clock0)/real(count_rate) - s_total
  
  if (verbosity.gt.0) then
! NIK 16.02.2005 
    do i=1,nspec
      if (icnt_incld(i).gt.0) then
         write(*,*) '**********************************************'
         write(*,*) 'Scavenging statistics for species ', species(i), ':'
         write(*,*) 'Total number of occurences of below-cloud scavenging', &
           & icnt_belowcld(i)
         write(*,*) 'Total number of occurences of in-cloud    scavenging', &
           & icnt_incld(i)
         write(*,*) '**********************************************'
      endif
    end do
  endif
  
  write(*,*) 'Read wind fields: ', s_readwind, ' seconds'
  write(*,*) 'Timemanager: ', s_timemanager, ' seconds,', 'first timestep: ',s_firstt, 'seconds'
  write(*,*) 'Write particle files: ', s_writepart, ' seconds'
  write(*,*) 'Total running time: ', s_total, ' seconds'
  write(*,*) 'tps,io,tot: ', (s_timemanager-s_firstt)/4.,(s_readwind+s_writepart)/5.,s_total
  write(*,*) 'CONGRATULATIONS: YOU HAVE SUCCESSFULLY COMPLETED A FLE&
       &XPART MODEL RUN!'

end program flexpart


subroutine read_options_and_initialise_flexpart

  !*****************************************************************************
  !                                                                            *
  !   Moved from main flexpart program:                                        *
  !   Reading all option files, initialisation of random numbers, and          *
  !   allocating memory for windfields, grids, etc.                            *
  !                                                                            *
  !   L. Bakels 2022                                                           *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use random_mod
  use par_mod
  use com_mod
  use conv_mod
  use class_gribfile_mod
  use readoptions_mod
  use windfields_mod
  use plume_mod
  use initialise_mod
  use drydepo_mod
  use getfields_mod
  use interpol_mod,         only: alloc_interpol
  use outgrid_mod
  use binary_output_mod
  use omp_lib,              only: OMP_GET_MAX_THREADS
#ifdef USE_NCF
  use chemistry_mod,        only: readreagents
  use totals_mod
  use receptor_netcdf_mod,  only: read_satellite_info, receptorout_init
#endif
  use receptor_mod,         only: alloc_receptor

  implicit none

  integer ::              &
    inest                   ! loop variable for nested gridcells
  integer ::              &
    j,                    & ! loop variable for random numbers
    stat,                 & ! Check if allocation was successful
    idummy=-320             ! dummy value used by the random routine


  ! Read pathnames from file in working director that specify I/O directories
  !**************************************************************************
  call readpaths
  
  ! Read the user specifications for the current model run
  !*******************************************************
  call readcommand

  ! Reading the number of threads available and print them for user
  !****************************************************************
#ifdef _OPENMP
    numthreads = OMP_GET_MAX_THREADS()
    numthreads_grid = min(numthreads,maxthreadgrid)
    !numthreads = min(40,numthreads)
#else
    numthreads = 1
    numthreads_grid = 1
#endif

  if (numthreads.gt.1) then
    write(*,*)
    write(*,*) "*********** WARNING  **********************************"
    write(*,*) "* FLEXPART running in parallel mode                   *"
    write(*,*) "* Number of uncertainty classes in                    *"
    write(*,901) " * set to number of threads:            ", &
      numthreads_grid, "          *" 
    write(*,901) " * All other computations are done with ",&
      numthreads, " threads. *"
    write(*,*) "*******************************************************"
    write(*,*)
901 format (a,i5,a)
  endif

  call alloc_random(numthreads)

  ! Generate a large number of random numbers
  !******************************************
  do j=1,maxrand-1,2
    call gasdev1(idummy,rannumb(j),rannumb(j+1))
  end do
  call gasdev1(idummy,rannumb(maxrand),rannumb(maxrand-1))

  ! Read the age classes to be used
  !********************************
  call readageclasses

  ! ! Allocate memory for windfields
  ! !*******************************
  ! call alloc_windfields
  ! if (numbnests.ge.1) then
  !   ! If nested wind fields are used, allocate arrays
  !   !************************************************
  !   call alloc_windfields_nest
  ! endif

  ! Read, which wind fields are available within the modelling period
  !******************************************************************
  call readavailable

  ! Detect metdata format
  !**********************
  call detectformat

  if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
    print *,'ECMWF metdata detected'
    if (nxshift.eq.-9999) nxshift=359
  elseif (metdata_format.eq.GRIBFILE_CENTRE_NCEP) then
    print *,'NCEP metdata detected'
    if (nxshift.eq.-9999) nxshift=0
  else
    error stop 'Unknown metdata format'
  endif
  write(*,*) 'NXSHIFT is set to', nxshift

  ! Read the model grid specifications,
  ! both for the mother domain and eventual nests
  !**********************************************
  if (metdata_format.eq.GRIBFILE_CENTRE_ECMWF) then
    call gridcheck_ecmwf
  else 
    call gridcheck_gfs
  endif

  ! Set the upper level for where the convection will be working
  !*************************************************************
  call set_conv_top

  if (numbnests.ge.1) then
  ! If nested wind fields are used, allocate arrays
  !************************************************
    call alloc_nest_properties
    call gridcheck_nest
  endif

  ! Read the output grid specifications if requested by user
  !*********************************************************
  if (iout.ne.0) then
    call readoutgrid

    if (nested_output.eq.1) then
      call readoutgrid_nest
    endif
  endif

  ! Read the receptor points for which extra concentrations are to be calculated
  !*****************************************************************************
  numreceptor=0
  numsatreceptor=0
  nlayermax=1
#ifdef USE_NCF
  call read_satellite_info
#endif
  call readreceptors

  ! Read the landuse inventory
  !***************************
  call readlanduse ! CHECK ETA

  ! Read chemical reagent information
  !**********************************
  ! default settings
  nreagent=0
  reagents(:)=""
#ifdef USE_NCF
  call readreagents
#endif 

  ! For continuation of previous run or from user defined initial 
  ! conditions, read in particle positions
  !*************************************************************************
  call initialise_particles

  ! Initialize variables for totals calculations
  !*********************************************
#ifdef USE_NCF
  call alloc_totals
  call totals_init
#endif 

  ! Convert the release point coordinates from geografical to grid coordinates
  !***************************************************************************
  call coordtrafo(nxmin1,nymin1)

  ! Read and compute surface resistances to dry deposition of gases
  !****************************************************************
  call readdepo

  ! Allocate dry deposition fields if necessary
  !*********************************************
  call alloc_drydepo
  call alloc_convect
  call alloc_getfields
  call alloc_interpol
#ifdef USE_NCF
  if (lnetcdfout.eq.1) call alloc_netcdf
#endif 

  ! Assign fractional cover of landuse classes to each ECMWF grid point
  !********************************************************************
  call assignland

  ! Calculate volume, surface area, etc., of all output grid cells
  !***************************************************************
  if (iout.ne.0) then
    call outgrid_init
    if (nested_output.eq.1) call outgrid_init_nest ! CHECK ETA
  endif

  ! Initialize receptor output
  !***************************

  call alloc_receptor
  if (lnetcdfout.eq.1) then
#ifdef USE_NCF
    call receptorout_init
#endif  
  else
    call receptorout_init_binary
  endif

  if ((iout.eq.4).or.(iout.eq.5)) call openouttraj ! CHECK ETA


  ! Initialize cloud-base mass fluxes for the convection scheme
  !************************************************************
  if (lconvection.eq.1) then
    cbaseflux(0:nxmin1,0:nymin1,:)=0.
    do inest=1,numbnests
      cbasefluxn(0:nxn(inest)-1,0:nyn(inest)-1,inest,:)=0.
    end do
  endif

  ! Allocating nan_count for CBL option
  !************************************
  allocate(nan_count(numthreads), stat=stat)
  if (stat.ne.0) error stop "Could not allocate nan_count"

end subroutine read_options_and_initialise_flexpart

subroutine initialise_particles

  !*****************************************************************************
  !                                                                            *
  !   This subroutine handles the different forms of starting FLEXPART         *
  !   depending on IPIN (set in COMMAND)                                       *
  !                                                                            *
  !   IPIN=0: this routine is not called and particles are read from the       *
  !           RELEASE option file                                              *
  !   IPIN=1: restarting from a restart.bin file, written by a previous run    *
  !   IPIN=2: restarting from a partoutput_xxx.nc file written by a previous   *
  !           run, depending on what PARTOPTIONS the user has chosen, this     *
  !           option might not be possible to use                              *
  !   IPIN=3: starting a run from a user defined initial particle conditions,  *
  !           more on how to create such a file can be found in the manual     *
  !   IPIN=4: restarting a run, while also reading in the initial particle     *
  !           conditions                                                       *
  !                                                                            *
  !   Author: L. Bakels 2022                                                   *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use com_mod
  use initialise_mod
#ifdef USE_NCF  
  use netcdf_output_mod
#endif
  use readoptions_mod
  use restart_mod
  use settling_mod

  implicit none

  integer :: i
  ! logical :: l_lookup=.false.

  ! Read the coordinates of the release locations
  !**********************************************
  itime_init=0

  if (ipin.le.2) then 
    call readreleases
    ! needs to be called after maxspec is defined in readreleases or readinitconditions
    if (ipout.ne.0) call readpartoptions 
  else
#ifdef USE_NCF
    call readinitconditions_netcdf
#else
    error stop 'Compile with netCDF if you would like to use the ipin=3,4 options.'
#endif
  endif

  if (iout.ne.0) then
    call alloc_grid
    call alloc_grid_unc
    if (nested_output.eq.1) call alloc_grid_unc_nest
  endif
  
  if ((ipin.eq.1).or.(ipin.eq.4)) then ! Restarting from restart.bin file
    call readrestart
  else if (ipin.eq.2) then ! Restarting from netcdf partoutput file
#ifdef USE_NCF
    call readpartpositions
#else
    error stop 'Compile with netCDF if you want to use the ipin=2 option.'
#endif
  else if (ipin.eq.0) then
    ! Releases can only start and end at discrete times (multiples of lsynctime)
    !***************************************************************************
    do i=1,numpoint
      ireleasestart(i)=nint(real(ireleasestart(i))/real(lsynctime))*lsynctime
      ireleaseend(i)=nint(real(ireleaseend(i))/real(lsynctime))*lsynctime
    end do
    numpart=0
    numparticlecount=0
  endif

  ! ! Initialise look-up table for drag coefficients when necessary
  ! !**************************************************************
  ! if (lsettling) then
  !   do i=1,nspec
  !     if (ishape(i).eq.0) l_lookup=.true.
  !   end do
  !   if (l_lookup) call init_dragcoeff_lookup()
  ! endif

end subroutine initialise_particles

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine openreceptors

  !*****************************************************************************
  !                                                                            *
  !  This routine opens the receptor output files and writes out the receptor  *
  !  names and the receptor locations. The receptor output files are not       *
  !  closed, but kept open throughout the simulation. Concentrations are       *
  !  continuously  dumped to these files.                                      *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     7 August 2002                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! numreceptor            actual number of receptor points specified          *
  ! receptornames          names of the receptor points                        *
  ! xreceptor,yreceptor    coordinates of the receptor points                  *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: j

  ! Open output file for receptor points and write out a short header
  ! containing receptor names and locations
  !******************************************************************

  if (numreceptor.ge.1) then           ! do it only if receptors are specified

  ! Concentration output
  !*********************

    if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
      open(unitoutrecept,file=path(2)(1:length(2))//'receptor_conc', &
           form='unformatted',err=997)
      write(unitoutrecept) (receptorname(j),j=1,numreceptor)
      write(unitoutrecept) (xreceptor(j)*dx+xlon0, &
           yreceptor(j)*dy+ylat0,j=1,numreceptor)
    endif

  ! Mixing ratio output
  !********************

    if ((iout.eq.2).or.(iout.eq.3)) then
      open(unitoutreceptppt,file=path(2)(1:length(2))//'receptor_pptv', &
           form='unformatted',err=998)
      write(unitoutreceptppt) (receptorname(j),j=1,numreceptor)
      write(unitoutreceptppt) (xreceptor(j)*dx+xlon0, &
           yreceptor(j)*dy+ylat0,j=1,numreceptor)
    endif
  endif

  return


997   write(*,*) ' #### FLEXPART MODEL ERROR! THE FILE           #### '
  write(*,*) ' ####              receptor_conc               #### '
  write(*,*) ' #### CANNOT BE OPENED.                        #### '
  stop

998   write(*,*) ' #### FLEXPART MODEL ERROR! THE FILE           #### '
  write(*,*) ' ####              receptor_pptv               #### '
  write(*,*) ' #### CANNOT BE OPENED.                        #### '
  stop

end subroutine openreceptors

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

!  Taken from Press et al., Numerical Recipes

module random_mod
  
  implicit none

  integer, parameter :: ran1_ntab=32
  integer, allocatable :: ran1_iv(:,:), ran1_iy(:)

  integer, allocatable :: gasdev_iset(:)
  real, allocatable :: gasdev_gset(:)

  integer, allocatable :: ran3_iff(:)
  integer, allocatable :: ran3_inext(:),ran3_inextp(:)
  integer, allocatable :: ma(:,:)

  integer, allocatable :: iseed1(:), iseed2(:)

contains
  
  subroutine alloc_random(num_threads)

    implicit none

    integer :: num_threads, i,stat

    allocate(ran1_iv(ran1_ntab,0:num_threads-1),ran1_iy(0:num_threads-1), stat=stat)
    if (stat.ne.0) error stop "Could not allocate ran1_iv"
    allocate(gasdev_iset(0:num_threads-1),gasdev_gset(0:num_threads-1), stat=stat)
    if (stat.ne.0) error stop "Could not allocate gasdev_iset"
    allocate(ran3_iff(0:num_threads-1),ran3_inext(0:num_threads-1),ran3_inextp(0:num_threads-1), stat=stat)
    if (stat.ne.0) error stop "Could not allocate ran3_iff"
    allocate(ma(55,0:num_threads-1), stat=stat)
    if (stat.ne.0) error stop "Could not allocate ma"
    allocate(iseed1(0:num_threads-1),iseed2(0:num_threads-1), stat=stat)
    if (stat.ne.0) error stop "Could not allocate iseed1"

    do i=0,num_threads-1
      iseed1(i) = -7-i
      iseed2(i) = -88-i
    end do
    ran3_iff(0:num_threads-1)=0
    ran1_iv(:,0:num_threads-1)=0
    ran1_iy(0:num_threads-1)=0
    gasdev_iset(0:num_threads-1)=0
    gasdev_gset(0:num_threads-1)=0
  end subroutine alloc_random

  subroutine dealloc_random()

    deallocate(ran1_iv,ran1_iy)
    deallocate(gasdev_iset,gasdev_gset)
    deallocate(ran3_iff,ran3_inext,ran3_inextp)
    deallocate(ma)
    deallocate(iseed1,iseed2)
  end subroutine dealloc_random

  function ran1(idum,ithread)

    implicit none

    integer :: idum,ithread
    real    :: ran1
    integer,parameter :: ia=16807, im=2147483647, iq=127773, ir=2836
    integer,parameter :: ndiv=1+(im-1)/ran1_ntab
    real,parameter    :: am=1./im, eps=1.2e-7, rnmx=1.-eps
    integer :: j, k

    if (idum.le.0.or.ran1_iy(ithread).eq.0) then
      idum=max(-idum,1)
      do j=ran1_ntab+8,1,-1
        k=idum/iq
        idum=ia*(idum-k*iq)-ir*k
        if (idum.lt.0) idum=idum+im
        if (j.le.ran1_ntab) ran1_iv(j,ithread)=idum
      enddo
      ran1_iy(ithread)=ran1_iv(1,ithread)
    endif
    k=idum/iq
    idum=ia*(idum-k*iq)-ir*k
    if (idum.lt.0) idum=idum+im
    j=1+ran1_iy(ithread)/ndiv
    ran1_iy(ithread)=ran1_iv(j,ithread)
    ran1_iv(j,ithread)=idum
    ran1=min(am*ran1_iy(ithread),rnmx)
  end function ran1


  function gasdev(idum,ithread)

    implicit none

    integer :: idum,ithread
    real    :: gasdev, fac, r, v1, v2

    if (gasdev_iset(ithread).eq.0) then
1     v1=2.*ran3(idum,ithread)-1.
      v2=2.*ran3(idum,ithread)-1.
      r=v1**2+v2**2
      if(r.ge.1.0 .or. r.eq.0.0) go to 1
      fac=sqrt(-2.*log(r)/r)
      gasdev_gset(ithread)=v1*fac
      gasdev=v2*fac
      gasdev_iset(ithread)=1
    else
      gasdev=gasdev_gset(ithread)
      gasdev_iset(ithread)=0
    endif
  end function gasdev


  subroutine gasdev1(idum,random1,random2)

    implicit none

    integer :: idum
    real :: random1, random2, fac, v1, v2, r

1   v1=2.*ran3(idum,0)-1.
    v2=2.*ran3(idum,0)-1.
    r=v1**2+v2**2
    if(r.ge.1.0 .or. r.eq.0.0) go to 1
    fac=sqrt(-2.*log(r)/r)
    random1=v1*fac
    random2=v2*fac
! Limit the random numbers to lie within the interval -3 and +3
!**************************************************************
    if (random1.lt.-3.) random1=-3.
    if (random2.lt.-3.) random2=-3.
    if (random1.gt.3.) random1=3.
    if (random2.gt.3.) random2=3.
  end subroutine gasdev1


  function ran3(idum,ithread)

    implicit none

    integer :: idum,ithread
    real :: ran3

    integer,parameter :: mbig=1000000000, mseed=161803398, mz=0
    real,parameter    :: fac=1./mbig
    integer :: i,ii,k
    integer :: mj,mk

    if(idum.lt.0 .or. ran3_iff(ithread).eq.0)then
      ran3_iff(ithread)=1
      mj=mseed-iabs(idum)
      mj=mod(mj,mbig)
      ma(55,ithread)=mj
      mk=1
      do i=1,54
        ii=mod(21*i,55)
        ma(ii,ithread)=mk
        mk=mj-mk
        if(mk.lt.mz)mk=mk+mbig
        mj=ma(ii,ithread)
      end do
      do k=1,4
        do i=1,55
          ma(i,ithread)=ma(i,ithread)-ma(1+mod(i+30,55),ithread)
          if(ma(i,ithread).lt.mz) ma(i,ithread)=ma(i,ithread)+mbig
        end do
      end do
      ran3_inext(ithread)=0
      ran3_inextp(ithread)=31
      idum=1
    endif
    ran3_inext(ithread)=ran3_inext(ithread)+1
    if(ran3_inext(ithread).eq.56) ran3_inext(ithread)=1
    ran3_inextp(ithread)=ran3_inextp(ithread)+1
    if(ran3_inextp(ithread).eq.56) ran3_inextp(ithread)=1
    mj=ma(ran3_inext(ithread),ithread)-ma(ran3_inextp(ithread),ithread)
    if(mj.lt.mz)mj=mj+mbig
    ma(ran3_inext(ithread),ithread)=mj
    ran3=mj*fac
  end function ran3
!  (C) Copr. 1986-92 Numerical Recipes Software US.

end module random_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine centerofmass(xl,yl,n,xcenter,ycenter)
  !                        i  i  i    o       o
  !*****************************************************************************
  !                                                                            *
  !   This routine calculates the center of mass of n points on the Earth.     *
  !   Input are the longitudes (xl) and latitudes (yl) of the individual       *
  !   points, output is the longitude and latitude of the centre of mass.      *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 January 2002                                                        *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  integer :: n,l
  real :: xl(n),yl(n),xll,yll,xav,yav,zav,x,y,z,xcenter,ycenter


  xav=0.
  yav=0.
  zav=0.

  do l=1,n

  ! Convert longitude and latitude from degrees to radians
  !*******************************************************

    xll=xl(l)*pi180
    yll=yl(l)*pi180

  ! Calculate 3D coordinates from longitude and latitude
  !*****************************************************

    x = cos(yll)*sin(xll)
    y = -1.*cos(yll)*cos(xll)
    z = sin(yll)


  ! Find the mean location in Cartesian coordinates
  !************************************************

    xav=xav+x
    yav=yav+y
    zav=zav+z
  end do

  xav=xav/real(n)
  yav=yav/real(n)
  zav=zav/real(n)


  ! Project the point back onto Earth's surface
  !********************************************

  xcenter=atan2(xav,-1.*yav)
  ycenter=atan2(zav,sqrt(xav*xav+yav*yav))

  ! Convert back to degrees
  !************************

  xcenter=xcenter/pi180
  ycenter=ycenter/pi180

end subroutine centerofmass

  !*****************************************************************************
  !                                                                            *
  ! L. Bakels 2021: This module contains dry deposition related subroutines    *
  !                                                                            *
  !*****************************************************************************

module wetdepo_mod
  use point_mod
  use par_mod
  use com_mod
  use particle_mod

  implicit none

contains

subroutine wetdepo(itime,ltsample,loutnext)
  !                  i      i        i
  !*****************************************************************************
  !                                                                            *
  ! Calculation of wet deposition using the concept of scavenging coefficients.*
  ! For lack of detailed information, washout and rainout are jointly treated. *
  ! It is assumed that precipitation does not occur uniformly within the whole *
  ! grid cell, but that only a fraction of the grid cell experiences rainfall. *
  ! This fraction is parameterized from total cloud cover and rates of large   *
  ! scale and convective precipitation.                                        *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    1 December 1996                                                         *
  !                                                                            *
  ! Correction by Petra Seibert, Sept 2002:                                    *
  ! use centred precipitation data for integration                             *
  ! Code may not be correct for decay of deposition!                           *
  !                                                                            *
  ! 2021 Andreas Plach: - moved backward wet depo. calc. here from timemanager *
  !                     - bugfix in-cloud scavenging                           *
  !                                                                            *
  ! PS, AP 2021: followed up on some variable renaming and                     *
  !                corrected get_wetscav subroutine parameter list             *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ix,jy              indices of output grid cell for each particle           *
  ! itime [s]          actual simulation time [s]                              *
  ! jpart              particle index                                          *
  ! ldeltat [s]        interval since radioactive decay was computed           *
  ! loutnext [s]       time for which gridded deposition is next output        *
  ! loutstep [s]       interval at which gridded deposition is output          *
  ! ltsample [s]       interval over which mass is deposited                   *
  ! wetdeposit         mass that is wet deposited                              *
  ! wetgrid            accumulated deposited mass on output grid               *
  ! wetscav            scavenging coefficient                                  *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************
#ifdef _OPENMP
  use omp_lib
#endif
  use unc_mod

  implicit none

  integer :: i,jpart,itime,ltsample,loutnext,ldeltat
  integer :: itage,nage,inage,ithread,thread
  integer :: ks, kp, stat
  real :: gridfract,wetscav,restmass
  real,allocatable,dimension(:) :: wettmp
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled

  ! Compute interval since radioactive decay of deposited mass was computed
  !************************************************************************

  if (itime.le.loutnext) then
    ldeltat=itime-(loutnext-loutstep)
  else                                  ! first half of next interval
    ldeltat=itime-loutnext
  endif

  ! Loop over all particles
  !************************

#ifdef _OPENMP
  call omp_set_num_threads(numthreads_grid)
#endif

!$OMP PARALLEL PRIVATE(jpart,itage,nage,inage,ks,kp,thread,wetscav,wettmp, &
!$OMP restmass, gridfract)

#if (defined _OPENMP)
    thread = OMP_GET_THREAD_NUM() ! Starts with 0
#else
    thread = 0
#endif

  allocate( wettmp(nspec),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate wettmp inside of OMP loop'

!$OMP DO 
  do i=1,count%alive

    jpart=count%ialive(i)
    
  ! Determine age class of the particle - nage is used for the kernel
  !******************************************************************
    itage=abs(itime-part(jpart)%tstart)
    nage=1
    if (lagespectra.eq.1) then
      do inage=1,nageclass
        nage=inage
        if (itage.lt.lage(nage)) exit
      end do
    endif

    do ks=1,nspec      ! loop over species

      if (.not. WETDEPSPEC(ks)) cycle 

  !**************************************************
  ! CALCULATE DEPOSITION 
  !**************************************************

      call get_wetscav(itime,jpart,ks,gridfract,wetscav)

      if (WETBKDEP) then
        if ((xscav_frac1(jpart,ks).lt.-0.1)) then   ! particle marked as starting particle
          if (wetscav.gt.0.) then
             xscav_frac1(jpart,ks)=wetscav*(zpoint2(part(jpart)%npoint)-&
               zpoint1(part(jpart)%npoint))*gridfract
          else
            mass(jpart,ks)=0.
            xscav_frac1(jpart,ks)=0.
          endif
        endif
      endif

      if (wetscav.gt.0.) then
        wettmp(ks)=mass(jpart,ks)* &
             (1.-exp(-wetscav*abs(ltsample)))*gridfract  ! wet deposition

      else ! if no scavenging
        wettmp(ks)=0.
      endif
      wetdeposit(jpart,ks)=wetdeposit(jpart,ks)+wettmp(ks)
      restmass = mass(jpart,ks)-wettmp(ks)
      if (ioutputforeachrelease.eq.1) then
        kp=part(jpart)%npoint
      else
        kp=1
      endif
      if (restmass .gt. smallnum) then
        mass(jpart,ks)=restmass
      else
        mass(jpart,ks)=0.
      endif
  !   Correct deposited mass to the last time step when radioactive decay of
  !   gridded deposited mass was calculated
      if (decay(ks).gt.0.) then
        wettmp(ks)=wettmp(ks)*exp(abs(ldeltat)*decay(ks))
      endif

    end do ! loop over species

    !************************************************************************
    ! Sabine Eckhardt, June 2008 create deposition only for forward runs
    ! Add the wet deposition to accumulated amount on output grid 
    !                                      and nested output grid

    if ((ldirect.eq.1).and.(iout.ne.0)) then !OMP reduction necessary for wetgridunc
      call wetdepokernel(part(jpart)%nclass,wettmp,real(part(jpart)%xlon), &
           real(part(jpart)%ylat),nage,kp,thread+1)
      if (nested_output.eq.1) call wetdepokernel_nest(part(jpart)%nclass, &
           wettmp,real(part(jpart)%xlon),real(part(jpart)%ylat),nage,kp,thread+1)
    endif

  end do ! all particles

!$OMP END DO
  deallocate(wettmp)
!$OMP END PARALLEL

#ifdef _OPENMP
  call omp_set_num_threads(numthreads)
#endif

#ifdef _OPENMP
    if ((ldirect.eq.1).and.(iout.ne.0)) then
      do ithread=1,numthreads_grid
        wetgridunc(:,:,:,:,:,:)=wetgridunc(:,:,:,:,:,:)+gridunc_omp(:,:,1,:,:,:,:,ithread)
        gridunc_omp(:,:,1,:,:,:,:,ithread)=0.
      end do
      if (nested_output.eq.1) then
        do ithread=1,numthreads_grid
          wetgriduncn(:,:,:,:,:,:)=wetgriduncn(:,:,:,:,:,:)+griduncn_omp(:,:,1,:,:,:,:,ithread)
          griduncn_omp(:,:,1,:,:,:,:,ithread)=0.
        end do
      endif
    endif
#endif

end subroutine wetdepo

subroutine get_wetscav(itime,jpart,ks,gridfract,wetscav)
  !                      i      i        i       i    i    o         o
  !*****************************************************************************
  !                                                                            *
  ! Calculation of wet deposition using the concept of scavenging coefficients.*
  ! For lack of detailed information, washout and rainout are jointly treated. *
  ! It is assumed that precipitation does not occur uniformly within the whole *
  ! grid cell, but that only a fraction of the grid cell experiences rainfall. *
  ! This fraction is parameterized from total cloud cover and rates of large   *
  ! scale and convective precipitation.                                        *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    1 December 1996                                                         *
  !                                                                            *
  ! Correction by Petra Seibert, Sept 2002:                                    *
  ! use centred precipitation data for integration                             *
  ! Code may not be correct for decay of deposition!                           *
  !                                                                            *
  ! ZHG, for v10: use below-cloud scavenging according to Laakso et al (2003)  *
  !   and Kyro et al (2009) as described in Grytte et al (2017, GMD)           *
  !                                                                            *
  ! PS, AP 04/2019: - put back temporal interpolation of rain, from v10.01     *
  !                 - tansferred BCSCHEME parameters to par_mod.f90            *
  !                 - added call to rain interpolation subroutine with new     *
  !                    interpolation for rain and all cloud params             *
  !                 - cleaned up scavenging determination algorithm            *
  !                 - added new below-cloud scavenging scheme                  *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! cc [0-1]           total cloud cover                                       *
  ! convp [mm/h]       convective precipitation rate                           *
  ! grfraction [0-1]   fraction of grid, for which precipitation occurs        *
  ! ix,jy              indices of output grid cell for each particle           *
  ! itime [s]          actual simulation time [s]                              *
  ! jpart              particle index                                          *
  ! lfr, cfr           area fraction covered by precipitation for large scale  *
  !                    and convective precipitation (dependent on prec. rate)  *
  ! loutnext [s]       time for which gridded deposition is next output        *
  ! loutstep [s]       interval at which gridded deposition is output          *
  ! lsp [mm/h]         large-scale precipitation rate                          *
  ! ltsample [s]       interval over which mass is deposited                   *
  ! prec [mm/h]        precipitation rate in subgrid, where precipitation occurs*
  ! wetgrid            accumulated deposited mass on output grid               *
  ! wetscav            scavenging coefficient                                  *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use interpol_mod
  use windfields_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif

  implicit none

  integer,intent(in) :: jpart,itime,ks
  real,intent(out) :: gridfract,wetscav

  integer :: hz,interp_time, n,i,j,kz
  integer(kind=1) :: clouds_v
  integer(selected_int_kind(16)), dimension(nspec) :: blc_count, inc_count

  integer :: indcloud
  integer :: icbot,ictop
  real :: t_particle, si, cl, cle ! in cloud scavenging
  real :: lsp,convp,cc,prec
  !save lfr,cfr
  real :: xts,yts

  real, parameter :: precsub = 0.01 ! minimum precip rate (mm/h)

  real :: f

  logical :: readclouds_this_nest

  wetscav=0.

  ! Interpolate large-scale precipitation, convective precipitation,
  ! total cloud cover, particle temperature, cloud water content, 
  ! cloud bottom and top 
  !********************************************************************
  interp_time=itime

  xts=real(part(jpart)%xlon)
  yts=real(part(jpart)%ylat)

  ! Determine which nesting level to be used
  !*****************************************
  readclouds_this_nest=.false.

  call find_ngrid(xts,yts)
  if ( (ngrid.gt.0) ) then
    if (lcw_nest(ngrid)) readclouds_this_nest=.true.
  endif

  ! If point at border of grid -> small displacement into grid
  !***********************************************************
  if (ngrid.le.0) then
    if (xts.ge.real(nx-1)) xts=real(nx-1)-0.00001
    if (yts.ge.real(ny-1)) yts=real(ny-1)-0.00001
  else
    if (xts.ge.real(nx-1)) xts=real(nx-1)-0.00001
    if (yts.ge.real(ny-1)) yts=real(ny-1)-0.00001
  endif

  call find_grid_indices(xts,yts)
  call find_grid_distances(xts,yts)
  
#ifdef ETA
  call update_zeta_to_z(itime,jpart)
  call find_z_level_eta_uv(real(part(jpart)%zeta))
  kz=induv
#else
  call find_z_level_meters(real(part(jpart)%z))
  kz=indz
#endif
  
  ! Interpolate cloud information
  call interpol_rain(itime,kz,lsp,convp,cc,t_particle,cl,icbot,ictop,icmv)
  ! cc = total cloud cover
  ! cl = ctwc

! If total precipitation is less than precsub=0.01 mm/h - no scavenging
! Note: original PS version (in order avoid step at 0.01)
!-----------------------------------------------------------------------
  prec = lsp+convp
  if (prec .le. precsub) then
    return
  endif

  ! Remove the minimum 0.01 from the large scale precipitation (lsp) and 
  ! convective precipitation (convp). Why 0.01???
  f = (prec-precsub)/prec
  lsp   = f*lsp
  convp = f*convp

  if (abs(memtime(1)-interp_time) .lt. abs(memtime(2)-interp_time)) then
    n=memind(1)
  else
    n=memind(2)
  endif

  ! if particle is above the clouds no scavenging is done
  !------------------------------------------------------
  ! PS: part of 2011/2012 fix 
  ! NOTE this is just for z coordinate
  ! Reverse sign for eta
#ifdef ETA
  if   (part(jpart)%zeta .gt. real(ictop)/eta_convert) then
    if (part(jpart)%zeta .le. real(icbot)/eta_convert) then
#else
  if   (part(jpart)%z .le. real(ictop)) then
    if (part(jpart)%z .gt. real(icbot)) then
#endif
      indcloud = 2 ! in-cloud
    else
      indcloud = 1 ! below-cloud
    endif
  elseif (ictop .eq. icmv) then
    indcloud = 0 ! no cloud found, use old scheme
  else
    return ! above cloud
  endif

  ! 1) Parameterization of the the area fraction of the grid cell where the
  !    precipitation occurs: the absolute limit is the total cloud cover, but
  !    for low precipitation rates, an even smaller fraction of the grid cell
  !    is used. Large scale precipitation occurs over larger areas than
  !    convective precipitation.
  !**************************************************************************
  call get_gridfract(lsp,convp,cc,gridfract)

  ! 2) Computation of precipitation rate in sub-grid cell
  !******************************************************
  prec=(lsp+convp)/gridfract

  ! 3) Computation of scavenging coefficients for all species
  !**********************************************************
  !-------------------------------------------------------
  if (indcloud .eq. 0) then ! NO CLOUD FOUND
  !-------------------------------------------------------
  ! Note: more complex formulation using H or particle diametre
  !       may be introduced later
    wetscav=wet_a*prec**wet_b

  !-------------------------------------------------------
  else if (indcloud .eq. 1) then ! BELOW CLOUD SCAVENGING
  !-------------------------------------------------------
    if (dquer(ks).le.0. .and. &
      weta_gas(ks).gt.0. .and. wetb_gas(ks).gt.0.) then
      ! gas: if positive below-cloud parameters (A or B), and dquer<=0
      call get_wetscav_belowcld_gas(ks,prec,wetscav)

    else if (dquer(ks).gt.0. .and. &
      (crain_aero(ks).gt.0. .or. csnow_aero(ks).gt.0.)) then
      ! aerosols: if positive below-cloud parameters (Crain/Csnow or B), and dquer>0
      
      if (t_particle .ge. 273. .and. crain_aero(ks).gt.0.) then ! Rain:
        call get_wetscav_belowcld_aerosol_rain(ks,prec,wetscav)
      
      else if (t_particle .lt. 273. .and. csnow_aero(ks).gt.0.) then ! Snow:
        call get_wetscav_belowcld_aerosol_snow(ks,prec,wetscav)
      !else ????????
      endif      
    endif ! gas or particle
    ! positive below-cloud scavenging parameters given in Species file
    ! end below cloud scavening
  !---------------------------------------------------------
  elseif (indcloud .eq. 2) then !  IN CLOUD SCAVENGING
  !---------------------------------------------------------

    ! if negative coefficients (turned off) set to zero for use in equation
    if (ccn_aero(ks).lt.0.) ccn_aero(ks)=0.
    if (in_aero(ks).lt.0.) in_aero(ks)=0.

    if (dquer(ks).gt.0) then !aerosol
      call get_wetscav_incld_aerosol(ks,gridfract,prec,cl,cc,t_particle,wetscav)
    else !gas
      call get_wetscav_incld_gas(ks,gridfract,prec,cl,cc,t_particle,wetscav)
    endif
!---------------------------------------------------------
  endif ! incloud
!---------------------------------------------------------

end subroutine get_wetscav

subroutine get_wetscav_belowcld_gas(ks,prec,wetscav)
  implicit none

  integer,intent(in) :: ks ! Species index
  real, intent(in) :: prec ! precipitation in sub-grid cell
  real, intent(out) :: wetscav ! scavenging coefficient

  ! Sum number of particles below the cloud
  icnt_belowcld(ks)=icnt_belowcld(ks)+1
  !weta_gas and wetb_gas are set in the SPECIES file
  wetscav=weta_gas(ks)*prec**wetb_gas(ks)
end subroutine get_wetscav_belowcld_gas

subroutine get_wetscav_belowcld_aerosol_rain(ks,prec,wetscav)
  implicit none

  integer,intent(in) :: ks ! Species index
  real, intent(in) :: prec ! precipitation in sub-grid cell
  real, intent(out) :: wetscav ! scavenging coefficient


  real :: dquer_m, ldquer
  real :: wetscavlim, logAd, B

  ! Sum number of particles below the cloud
  icnt_belowcld(ks)=icnt_belowcld(ks)+1

  ! NIK 17.02.2015: local conversion particle diameter from um 
  ! (SPECIES file, readspecies) to meter
  dquer_m = dquer(ks)*1.e-6

  ! The parameterizations used by HG scheme are valid only for d < 10 um
  ! Therefore, locally the diametre is clipped. However, settling and dry dep
  ! are still calculated with the original diametre
  ! TODO check whether warning is written by readrelease for d > 10 um
  dquer_m = min( 10.e-6, dquer_m )

  ! PS note that solid precip is usually expected for T<Tf, not T<273
  ! also, if freezing/melting point is desired, why not 273.2?

  ! AT parameterization after WANG ET AL 2014   
  !    unit of dquer is in um
  !    unit of precip is in mm/h
  ! Wang et al. 2014: eq 6+7
  ldquer = log10(dquer(ks))
  if (dquer(ks) .le. 2.) then
   logAd = bclr_a(1)              + &
           bclr_a(2) * ldquer     + &
           bclr_a(3) * ldquer**2. + & 
           bclr_a(4) * ldquer**3.
     
   B     = bclr_c(1) + bclr_c(2)*ldquer
    
  else ! dquer .gt. 2.
   logAd = bclr_b(1)              + &
           bclr_b(2) * ldquer     + &
           bclr_b(3) * ldquer**2. + &
           bclr_b(4) * ldquer**3. + &
           bclr_b(5) * ldquer**4. + &
           bclr_b(6) * ldquer**5. + &
           bclr_b(7) * ldquer**6.
            
   B    = bclr_e(1)              + &
          bclr_e(2) * ldquer     + &
          bclr_e(3) * ldquer**2. + &
          bclr_e(4) * ldquer**3. + &
          bclr_e(5) * ldquer**4. + &
          bclr_e(6) * ldquer**5. + &
          bclr_e(7) * ldquer**6.

  endif ! dquer

  ! Wang et al. 2014: eq. 4
  wetscav = 10**(logAd+B*log10(prec))           

end subroutine get_wetscav_belowcld_aerosol_rain

subroutine get_wetscav_belowcld_aerosol_snow(ks,prec,wetscav)
  implicit none

  integer,intent(in) :: ks ! Species index
  real, intent(in) :: prec ! precipitation in sub-grid cell
  real, intent(out) :: wetscav ! scavenging coefficient


  real :: dquer_m, ldquer
  real :: wetscavlim, logAd, B

  ! Sum number of particles below the cloud
  icnt_belowcld(ks)=icnt_belowcld(ks)+1

  ! NIK 17.02.2015: local conversion particle diameter from um 
  ! (SPECIES file, readspecies) to meter
  dquer_m = dquer(ks)*1.e-6

  ! The parameterizations used by HG scheme are valid only for d < 10 um
  ! Therefore, locally the diametre is clipped. However, settling and dry dep
  ! are still calculated with the original diametre
  ! TODO check whether warning is written by readrelease for d > 10 um
  dquer_m = min( 10.e-6, dquer_m )

  ! AT parameterization after WANG ET AL 2014   
  !    unit of dquer is in um
  !    unit of precip is in mm/h
  ldquer = log10(dquer(ks))
  ! Wang et al. 2014: eq. 8+9
  if (dquer(ks) .le. 1.44) then   
   logAd = bcls_a(1)               + &
           bcls_a(2)  * ldquer     + &
           bcls_a(3)  * ldquer**2. + &
           bcls_a(4)  * ldquer**3. + &
           bcls_a(5)  * ldquer**4. + &
           bcls_a(6)  * ldquer**5. + &
           bcls_a(7)  * ldquer**6.
     
   B     = bcls_c(1)              + &
           bcls_c(2) * ldquer     + &
           bcls_c(3) * ldquer**2. + &
           bcls_c(4) * ldquer**3. + &
           bcls_c(5) * ldquer**4. + &
           bcls_c(6) * ldquer**5. + &
           bcls_c(7) * ldquer**6.
     
  else ! dquer .gt. 1.44
   logAd = bcls_b(1)              + &
           bcls_b(2) * ldquer     + &
           bcls_b(3) * ldquer**2. + &
           bcls_b(4) * ldquer**3. + &
           bcls_b(5) * ldquer**4. + &
           bcls_b(6) * ldquer**5. + &
           bcls_b(7) * ldquer**6.
             
   B    = bcls_e(1)              + &
          bcls_e(2) * ldquer     + &
          bcls_e(3) * ldquer**2. + &
          bcls_e(4) * ldquer**3. + &
          bcls_e(5) * ldquer**4. + &
          bcls_e(6) * ldquer**5. + &
          bcls_e(7) * ldquer**6.
   
  endif ! dquer

  ! Wang et al. 2014: eq. 4
  wetscav = 10**(logAd+B*log10(prec))

end subroutine get_wetscav_belowcld_aerosol_snow

subroutine get_wetscav_incld_aerosol(ks,gridfract,prec,cl,cc,t_particle,wetscav)
  implicit none

  integer,intent(in) :: ks
  real,intent(in) :: gridfract
  real,intent(in) :: t_particle ! temperature
  real, intent(in) :: prec,cc ! precipitation in sub-grid cell
  real, intent(inout) :: cl ! scavenging coefficient
  real,intent(out) :: wetscav

  real :: frac_act,si

  ! NIK 13 may 2015: do only if in-cloud aerosol scavenging parameters > 0
  ! (all defined in SPECIES)
  if (ccn_aero(ks)+in_aero(ks) .le. 0.) return

  icnt_incld(ks)=icnt_incld(ks)+1

  ! Compute cloud liquid and ice water
  call get_cloud_liquid(gridfract,prec,cc,cl)
  ! Compute actived fraction based on the temperature (rain vs. snow )
  call get_activated_frac(ks,t_particle, frac_act)
  !ZHG Use the activated fraction and the liqid water to calculate the washout
  si= frac_act/cl
  ! scavenging coefficient based on Hertel et al 1995 - 
  ! using si (S_i in paper) for both gas and aerosol

  ! wetscav = ratio_incloud*si*prec/3.6E6/cloud_thickness
  ! cloud_thickness cancels out since cl is computed without
  wetscav=ratio_incloud*si* prec/3.6E6 ! mm/h -> m/s
end subroutine get_wetscav_incld_aerosol

subroutine get_wetscav_incld_gas(ks,gridfract,prec,cl,cc,t_particle,wetscav)
  implicit none

  integer,intent(in) :: ks
  real,intent(in) :: gridfract
  real,intent(in) :: t_particle ! temperature
  real, intent(in) :: prec,cc ! precipitation in sub-grid cell
  real, intent(inout) :: cl ! scavenging coefficient
  real,intent(out) :: wetscav

  real :: frac_act,si,cle
  ! NIK 13 may 2015: do only if in-cloud aerosol scavenging parameters > 0
  ! and Henry's constant > 0 (all defined in SPECIES)
  if (ccn_aero(ks)+in_aero(ks)+henry(ks) .le. 0.) return

  icnt_incld(ks)=icnt_incld(ks)+1

  ! Compute cloud liquid and ice water
  call get_cloud_liquid(gridfract,prec,cc,cl)
  ! Compute actived fraction based on the temperature (rain vs. snow )
  call get_activated_frac(ks,t_particle, frac_act)

  !ZHG Use the activated fraction and the liqid water to calculate the washout
  cle=(1.-cl)/(henry(ks)*(r_air/3500.)*t_particle) + cl
  si=1./cle
  ! scavenging coefficient based on Hertel et al 1995 - 
  ! using si (S_i in paper) for both gas and aerosol

  ! wetscav = ratio_incloud*si*prec/3.6E6/cloud_thickness
  ! cloud_thickness cancels out since cl is computed without
  wetscav=ratio_incloud*si* prec/3.6E6 ! mm/h -> m/s
end subroutine get_wetscav_incld_gas

subroutine get_activated_frac(ks,t_particle,frac_act)
  implicit none
  integer, intent(in) :: ks
  real, intent(in) :: t_particle
  real, intent(out) :: frac_act
  real :: frac_liq, frac_ice
  ! AT use of correct Kelvin temperature for T_ice; after ECMWF
  if (t_particle .le. 250.16) then ! ice 
    frac_liq=0.
    frac_ice=1.
  ! AT use of correct Kelvin temperature for T_liquid; after ECMWF        
  elseif (t_particle .ge. 273.16) then ! liquid
    frac_liq=1.
    frac_ice=0.
  else ! mixed cloud
    ! Use exact value for the melting point and ice threshold as in ECMWF/IFS            
    frac_liq= ((t_particle-250.16)/(273.16-250.16))**2.
    frac_ice = max(0., 1. - frac_liq)
  endif
  frac_act = frac_liq*ccn_aero(ks) + frac_ice*in_aero(ks)
end subroutine get_activated_frac

subroutine get_gridfract(lsp,convp,cc,gridfract)
  ! 1) Parameterization of the the area fraction of the grid cell where the
  !    precipitation occurs: the absolute limit is the total cloud cover, but
  !    for low precipitation rates, an even smaller fraction of the grid cell
  !    is used. Large scale precipitation occurs over larger areas than
  !    convective precipitation.
  !**************************************************************************
  implicit none

  real,intent(in) :: lsp,cc,convp
  real, intent(out) :: gridfract
  ! Where do these numbers come from?
  real, parameter :: lfr(5) = (/ 0.5,0.65,0.8,0.9,0.95/)
  real, parameter :: cfr(5) = (/ 0.4,0.55,0.7,0.8,0.9 /)
  integer :: i, j

  if (.not. lgridfraction) then
    gridfract=1.0
    return
  endif

  if (lsp.gt.20.) then
    i=5
  else if (lsp.gt.8.) then
    i=4
  else if (lsp.gt.3.) then
    i=3
  else if (lsp.gt.1.) then
    i=2
  else
    i=1
  endif

  if (convp.gt.20.) then
    j=5
  else if (convp.gt.8.) then
    j=4
  else if (convp.gt.3.) then
    j=3
  else if (convp.gt.1.) then
    j=2
  else
    j=1
  endif

  ! In the future, we may differentiate the gridfract for lsp and convp
  ! for now they are still mixed
  gridfract=max( 0.05, cc* (lsp*lfr(i) + convp*cfr(j)) / (lsp+convp))
end subroutine get_gridfract

subroutine get_cloud_liquid(gridfract,prec,cc,cl)
  use interpol_mod

  implicit none

  real, intent(in) :: prec,cc,gridfract ! precipitation in sub-grid cell
  real, intent(inout) :: cl ! scavenging coefficient
  !ZHG 2015 use cloud liquid & ice water (CLWC+CIWC) from ECMWF

  ! MC -- Integrated water content:
  ! CTWC = SUM(CLWC * rho_water * cloud_thickness) [kg/kg * kg/m3 * m]
  ! -> Average water content: cl = CTWC/rho_water/cloud_thickness [m3(water)/m3(cloud)]

  ! Note that cloud_thickness is not included, since this will cancel out when
  ! computing the wetscavenging: Wetscav=ratio_incloud*S_i*(prec/3.6E6)/cloud_thickness
  !                              S_i=1/cl
  ! Mother grid
  if (ngrid.le.0) then
    if (lcw) then
      if (lgridfraction) then
        cl=cl/rho_water*(gridfract/cc)
      else
        cl=cl/rho_water ! Grythe et al. eq (1), no cloud_thickness since this will cancel out later
      endif
      ! cl = cl*(gridfract/cc)
      ! A.Plach 2021 cl should not become too small
      ! cl=max(0.2*prec**0.36, cl*(gridfract/cc))
    else ! no cloud water available, use parameterisation for cloud water [m2/m3]
      cl=0.2*prec**0.36 !max(0.2*prec**0.36, cl*(gridfract/cc))
      ! ZHG updated parameterization to better reproduce the values from ECMWF
      ! cl = 1.E6*2E-7*prec**0.36 ! SEC ECMWF new, is also suitable for GFS
      ! SEC test:
      ! cl=1.E6*1.E-7*prec**0.3  ! SEC GFS new
      ! cl=     2.E-7*prec**0.36 ! Andreas
      ! cl=    1.6E-6*prec**0.36 ! Henrik
    endif
  else
    if (lcw_nest(ngrid)) then
      if (lgridfraction) then
        cl=cl/rho_water*(gridfract/cc)
      else
        cl=cl/rho_water ! Grythe et al. eq (1), no cloud_thickness since this will cancel out later
      endif
      !cl = cl*(gridfract/cc)
    else
      cl=0.2*prec**0.36
    endif
  endif
end subroutine get_cloud_liquid

subroutine wetdepokernel(nunc,deposit,x,y,nage,kp,thread)
  !                          i      i    i i  i
  !*****************************************************************************
  !                                                                            *
  !     Attribution of the deposition from an individual particle to the       *
  !     deposition fields using a uniform kernel with bandwidths dxout and dyout.*
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     26 December 1996                                                       *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nunc             uncertainty class of the respective particle              *
  ! nage             age class of the respective particle                      *
  ! deposit          amount (kg) to be deposited                               *
  !                                                                            *
  !*****************************************************************************
  ! Changes:
  ! eso 10/2016: Added option to disregard kernel 
  ! 
  !*****************************************************************************

  use unc_mod

  implicit none

  integer,intent(in) :: thread
  real :: x,y,deposit(maxspec),ddx,ddy,xl,yl,wx,wy,w
  integer :: ix,jy,ixp,jyp,nunc,nage,ks,kp

  xl=(x*dx+xoutshift)/dxout
  yl=(y*dy+youtshift)/dyout
  ix=int(xl)
  jy=int(yl)
  ddx=xl-real(ix)                   ! distance to left cell border
  ddy=yl-real(jy)                   ! distance to lower cell border

  if (ddx.gt.0.5) then
    ixp=ix+1
    wx=1.5-ddx
  else
    ixp=ix-1
    wx=0.5+ddx
  endif

  if (ddy.gt.0.5) then
    jyp=jy+1
    wy=1.5-ddy
  else
    jyp=jy-1
    wy=0.5+ddy
  endif

  ! If no kernel is used, direct attribution to grid cell
  !******************************************************

  if (.not.lusekerneloutput) then
    do ks=1,nspec
      if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
           (jy.le.numygrid-1)) then
#ifdef _OPENMP
        gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)= &
             gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)
#else
        wetgridunc(ix,jy,ks,kp,nunc,nage)= &
             wetgridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)
#endif
      end if
    end do
  else ! use kernel 
    
  ! Determine mass fractions for four grid points
  !**********************************************

  do ks=1,nspec

    if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
       (jy.le.numygrid-1)) then
      w=wx*wy
#ifdef _OPENMP
      gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)= &
           gridunc_omp(ix,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgridunc(ix,jy,ks,kp,nunc,nage)= &
           wetgridunc(ix,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

    if ((ixp.ge.0).and.(jyp.ge.0).and.(ixp.le.numxgrid-1).and. &
       (jyp.le.numygrid-1)) then
      w=(1.-wx)*(1.-wy)
#ifdef _OPENMP
      gridunc_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)= &
           gridunc_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgridunc(ixp,jyp,ks,kp,nunc,nage)= &
           wetgridunc(ixp,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

    if ((ixp.ge.0).and.(jy.ge.0).and.(ixp.le.numxgrid-1).and. &
       (jy.le.numygrid-1)) then
      w=(1.-wx)*wy
#ifdef _OPENMP
      gridunc_omp(ixp,jy,1,ks,kp,nunc,nage,thread)= &
           gridunc_omp(ixp,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgridunc(ixp,jy,ks,kp,nunc,nage)= &
           wetgridunc(ixp,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

    if ((ix.ge.0).and.(jyp.ge.0).and.(ix.le.numxgrid-1).and. &
       (jyp.le.numygrid-1)) then
      w=wx*(1.-wy)
#ifdef _OPENMP
      gridunc_omp(ix,jyp,1,ks,kp,nunc,nage,thread)= &
           gridunc_omp(ix,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgridunc(ix,jyp,ks,kp,nunc,nage)= &
           wetgridunc(ix,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

  end do
  end if
end subroutine wetdepokernel

subroutine wetdepokernel_nest(nunc,deposit,x,y,nage,kp,thread)
  !                           i    i       i i i    i
  !*****************************************************************************
  !                                                                            *
  !     Attribution of the deposition from an individual particle to the       *
  !     nested deposition fields using a uniform kernel with bandwidths        *
  !     dxoutn and dyoutn.                                                     *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     26 December 1996                                                       *
  !                                                                            *
  !      2 September 2004: Adaptation from wetdepokernel.                      *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nunc             uncertainty class of the respective particle              *
  ! nage             age class of the respective particle                      *
  ! deposit          amount (kg) to be deposited                               *
  !                                                                            *
  !*****************************************************************************

  use unc_mod

  implicit none

  integer,intent(in) :: thread
  real :: x,y,deposit(maxspec),ddx,ddy,xl,yl,wx,wy,w
  integer :: ix,jy,ixp,jyp,ks,kp,nunc,nage

  xl=(x*dx+xoutshiftn)/dxoutn
  yl=(y*dy+youtshiftn)/dyoutn

  ! old:
  ! ix=int(xl) 
  ! jy=int(yl)

  ! ESO: for xl,yl in range <-.5,-1> we get ix,jy=0 and thus negative
  ! wx,wy as the int function rounds upwards for negative numbers.
  ! Either use the floor function, or (perhaps more correctly?) use "(xl.gt.-0.5)" 
  ! in place of "(ix.ge.0)" and similar for the upper boundary.

  ! new:
  ix=floor(xl)
  jy=floor(yl)

  ddx=xl-real(ix)                   ! distance to left cell border
  ddy=yl-real(jy)                   ! distance to lower cell border


  if (ddx.gt.0.5) then
    ixp=ix+1
    wx=1.5-ddx
  else
    ixp=ix-1
    wx=0.5+ddx
  endif

  if (ddy.gt.0.5) then
    jyp=jy+1
    wy=1.5-ddy
  else
    jyp=jy-1
    wy=0.5+ddy
  endif

  ! Determine mass fractions for four grid points
  !**********************************************

  do ks=1,nspec
    if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgridn-1).and. &
         (jy.le.numygridn-1)) then
      w=wx*wy
#ifdef _OPENMP
      griduncn_omp(ix,jy,1,ks,kp,nunc,nage,thread)= &
           griduncn_omp(ix,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgriduncn(ix,jy,ks,kp,nunc,nage)= &
           wetgriduncn(ix,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

    if ((ixp.ge.0).and.(jyp.ge.0).and.(ixp.le.numxgridn-1).and. &
         (jyp.le.numygridn-1)) then
      w=(1.-wx)*(1.-wy)
#ifdef _OPENMP
      griduncn_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)= &
           griduncn_omp(ixp,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgriduncn(ixp,jyp,ks,kp,nunc,nage)= &
           wetgriduncn(ixp,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

    if ((ixp.ge.0).and.(jy.ge.0).and.(ixp.le.numxgridn-1).and. &
         (jy.le.numygridn-1)) then
      w=(1.-wx)*wy
#ifdef _OPENMP
      griduncn_omp(ixp,jy,1,ks,kp,nunc,nage,thread)= &
           griduncn_omp(ixp,jy,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgriduncn(ixp,jy,ks,kp,nunc,nage)= &
           wetgriduncn(ixp,jy,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

    if ((ix.ge.0).and.(jyp.ge.0).and.(ix.le.numxgridn-1).and. &
         (jyp.le.numygridn-1)) then
      w=wx*(1.-wy)
#ifdef _OPENMP
      griduncn_omp(ix,jyp,1,ks,kp,nunc,nage,thread)= &
           griduncn_omp(ix,jyp,1,ks,kp,nunc,nage,thread)+deposit(ks)*w
#else
      wetgriduncn(ix,jyp,ks,kp,nunc,nage)= &
           wetgriduncn(ix,jyp,ks,kp,nunc,nage)+deposit(ks)*w
#endif
    endif

  end do
end subroutine wetdepokernel_nest

subroutine writeprecip(itime,imem)

  !*****************************************************************************
  !                                                                            *
  !  This routine produces a file containing total precipitation for each      *
  !  releases point.                                                           *
  !                                                                            *
  !     Author: S. Eckhardt                                                    * 
  !     7 Mai 2017                                                             *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod
  use date_mod
  use windfields_mod

  implicit none

  integer :: jjjjmmdd,ihmmss,itime,i
  real(kind=dp) :: jul
  character :: adate*8,atime*6

  integer :: ix,jy,imem
  real :: xp1,yp1

  
  if (itime.eq.0) then
      open(unitprecip,file=path(2)(1:length(2))//'wetscav_precip.txt', &
       form='formatted',err=998)
  else
      open(unitprecip,file=path(2)(1:length(2))//'wetscav_precip.txt', &
       ACCESS='APPEND',form='formatted',err=998)
  endif

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss

  do i=1,numpoint
    xp1=xpoint1(i)*dx+xlon0 !lat, long (real) coord
    yp1=ypoint1(i)*dy+ylat0 !lat, long (real) coord
    ix=int((xpoint1(i)+xpoint2(i))*0.5)
    jy=int((ypoint1(i)+ypoint2(i))*0.5)
    write(unitprecip,*)  jjjjmmdd, ihmmss,xp1,yp1, & 
      sum(lsprec(ix,jy,1,:,imem)),sum(convprec(ix,jy,1,:,imem))
 !time is the same as in the ECMWF windfield
! units mm/h, valid for the time given in the windfield
  enddo

  close(unitprecip)

  return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'header_txt'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  error stop
end subroutine writeprecip

end module wetdepo_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine calcmatrix(lconv,delt,cbmf)
  !                        o    i    o
  !*****************************************************************************
  !                                                                            *
  !  This subroutine calculates the matrix describing convective               *
  !  redistribution of mass in a grid column, using the subroutine             *
  !  convect43c.f provided by Kerry Emanuel.                                   *
  !                                                                            *
  !  Petra Seibert, Bernd C. Krueger, 2000-2001                                *
  !                                                                            *
  !  changed by C. Forster, November 2003 - February 2004                      *
  !  array fmassfrac(nconvlevmax,nconvlevmax) represents                       *
  !  the convective redistribution matrix for the particles                    *
  !                                                                            *
  !  Changes by C. Forster, November 2005, NCEP GFS version                    *
  !                                                                            *
  !  lconv        indicates whether there is convection in this cell, or not   *
  !  delt         time step for convection [s]                                 *
  !  cbmf         cloud base mass flux                                         *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use conv_mod

  implicit none

  real :: rlevmass,summe

  integer :: iflag, k, kk, kuvz

  !1-d variables for convection
  !variables for redistribution matrix
  real :: cbmfold, precip, qprime
  real :: tprime, wd, f_qvsat
  real :: delt,cbmf
  logical :: lconv

  lconv = .false.


  ! calculate pressure at eta levels for use in convect
  ! and assign temp & spec. hum. to 1D workspace
  ! -------------------------------------------------------

  ! pconv(1) is the pressure at the first level above ground
  ! phconv(k) is the pressure between levels k-1 and k
  ! dpr(k) is the pressure difference "around" tconv(k)
  ! phconv(kmax) must also be defined 1/2 level above pconv(kmax)
  ! Therefore, we define k = kuvz-1 and let kuvz start from 2
  ! top layer cannot be used for convection because p at top of this layer is
  ! not given

  phconv(1) = psconv
  do kuvz = 2,nuvz
    k = kuvz-1
    phconv(kuvz) =  0.5*(pconv(kuvz)+pconv(k))
    dpr(k) = phconv(k) - phconv(kuvz)
    qsconv(k) = f_qvsat( pconv(k), tconv(k) )
  ! initialize mass fractions
    do kk=1,nconvlev
      fmassfrac(k,kk)=0.
    enddo
  end do

  !note that Emanuel says it is important
  !a. to set this =0. every grid point
  !b. to keep this value in the calling programme in the iteration

  ! CALL CONVECTION
  !******************

    cbmfold = cbmf
  ! Convert pressures to hPa, as required by Emanuel scheme
  !********************************************************
!!$    do k=1,nconvlev     !old
    do k=1,nconvlev+1      !bugfix
      pconv_hpa(k)=pconv(k)/100.
      phconv_hpa(k)=phconv(k)/100.
    end do
    phconv_hpa(nconvlev+1)=phconv(nconvlev+1)/100.
    call convect(nconvlevmax, nconvlev, delt, iflag, &
         precip, wd, tprime, qprime, cbmf)

  ! do not update fmassfrac and cloudbase massflux
  ! if no convection takes place or
  ! if a CFL criterion is violated in convect43c.f
   if (iflag .ne. 1 .and. iflag .ne. 4) then
     cbmf=cbmfold
     goto 200
   endif

  ! do not update fmassfrac and cloudbase massflux
  ! if the old and the new cloud base mass
  ! fluxes are zero
   if (cbmf.le.0..and.cbmfold.le.0.) then
     cbmf=cbmfold
     goto 200
   endif

  ! Update fmassfrac
  ! account for mass displaced from level k to level k

   lconv = .true.
    do k=1,nconvtop
      rlevmass = dpr(k)/ga
      summe = 0.
      do kk=1,nconvtop
        fmassfrac(k,kk) = delt*fmass(k,kk)
        summe = summe + fmassfrac(k,kk)
      end do
      fmassfrac(k,k)=fmassfrac(k,k) + rlevmass - summe
    end do

200   continue

end subroutine calcmatrix

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later
module cbl_mod
    
    implicit none

    private :: cuberoot

    public :: cbl,reinit_particle,init_cbl_vel
    
contains

subroutine cbl(wp,zp,wst,h,rhoa,rhograd,sigmaw,dsigmawdz,tlw,ptot,Q,phi,ath,bth,ol,flagrein)
!                i  i i  i   i  i    i     i       i         i   o   o   o   o    o  i    o
     
    use par_mod, only:pi
    use com_mod, only:ldirect
    
    implicit none

!*******************************************************************************
! CBL skewed vertical profiles and formulation of LHH 1996 with profile of w^3
! from LHB 2000 
! LHH formulation has been modified to account for variable density profiles 
! and backward in time or forward in time simulations 
! see Cassiani et al. BLM 2014 doi  for explanations and references  
!*******************************************************************************

    real :: usurad2,usurad2p,C0,costluar4,eps 
    parameter  (usurad2=0.7071067812,usurad2p=0.3989422804,C0=3,costluar4=0.66667,eps=0.000001)

       
    integer :: flagrein
    real :: wp,zp,wst,h,dens,ddens,sigmaw,dsigmawdz,tlw,rhoa,rhograd
    real ::fluarw,fluarw2
    real ::w3,w2
    real ::dw3,dw2
    real ::wb,wa
    real ::deltawa,deltawb
    real ::wold,wold2
    real ::pa,pb,alfa
    real ::Phi,Q,ptot  
    real :: timedir
    real ::ol,transition   
    

    real :: &
    erf, &
    aperfa, &
    aperfb, &
    ath, &
    bth

    real ::  &
    z, &    
    skew, &
    skew2, &
    radw2, &
    rluarw, &
    xluarw, &
    aluarw, &
    bluarw, &
    sigmawa, &
    sigmawb, &
    dskew, &
    dradw2, &
    dfluarw, &
    drluarw, &
    dxluarw, &
    daluarw, &
    dbluarw, &
    dsigmawa, &
    dsigmawb, &
    dwa, &
    dwb, &
    sigmawa2, &
    sigmawb2
    
    
    dens=rhoa      !put to 1 for test constant density simulation
    ddens=rhograd  !put to 0 for test constant density simulation
             
    
    timedir=ldirect !ldirect contains direction of time forward (1) or backward(-1)
    ! assegnazione z 
    z=(zp/h)
    
    ! stability transition function see Cassiani et al(2015) BLM
    transition=1.
    !if (ol.lt.-50) transition=((sin(((ol+100.)/100.)*pi))-1.)/2.
    if (-h/ol.lt.15) transition=((sin((((-h/ol)+10.)/10.)*pi)))*0.5+0.5

    ! momento secondo 
    
    w2=(sigmaw*sigmaw)
    dw2=(2.*sigmaw*dsigmawdz)
    

    !=================== dissipazione =======================================
    
    alfa=2.*w2/(C0*tlw)

    !========================================================================
    
    wold=timedir*wp
    
    !=========================================================================
    !------------------------------ momento terzo ============================
                                
    w3=((1.2*z*((1.-z)**(3./2.)))+eps)*(wst**3)*transition
    dw3=(1.2*(((1.-z)**(3./2.))+z*1.5*((1.-z)**(1./2.))*(-1.)))*(wst**3)*(1./h)*transition

!===========================================================================0
   
    skew=w3/(w2**1.5)
    skew2=skew*skew
    dskew=(dw3*w2**(1.5)-w3*1.5*w2**0.5*dw2)/w2**3
    radw2=w2**0.5
    dradw2=0.5*w2**(-0.5)*dw2
    !costluar4=0.66667  ! costante da LHH
    fluarw=costluar4*(cuberoot(skew))   !skew**(1./3.)
    fluarw2=fluarw*fluarw
    
    if (skew.ne.0) then
      
        dfluarw=costluar4*(1./3.)*cuberoot(skew**(-2.))*dskew
    
        rluarw=(1.+fluarw2)**3.*skew2/((3.+fluarw2)**2.*fluarw2)  !-> r
        xluarw=(1.+fluarw2)**1.5*skew/((3.+fluarw2)*fluarw)    !----> r^1/2
        
        drluarw=( ((3.*(1.+fluarw2)**2*(2.*fluarw*dfluarw)*skew2)+ &
            (1.+fluarw2)**3*2.*skew*dskew) *(3.+fluarw2)**2.*fluarw2 - &
            (1.+fluarw2)**3*skew2* &
            ( (2.*(3.+fluarw2)*(2.*fluarw*dfluarw)*fluarw2) + &
            (3.+fluarw2)**2*2.*fluarw*dfluarw) )/ &
            (((3.+fluarw2)**2.*fluarw2)**2)
                                     
        dxluarw=( ((1.5*(1.+fluarw2)**0.5*(2.*fluarw*dfluarw)*skew)+ &
            (1.+fluarw2)**1.5*dskew) *(3.+fluarw2)*fluarw - &
            (1.+fluarw2)**1.5*skew* &
            (3.*dfluarw+3*fluarw2*dfluarw) )/ &
            (((3.+fluarw2)*fluarw)**2)
    
    else        
        dfluarw=0.
        rluarw=0.
        drluarw=0.
        xluarw=0.
        dxluarw=0.
    end if



   aluarw=0.5*(1.-xluarw/(4.+rluarw)**0.5)
   bluarw=1.-aluarw

   daluarw=-0.5*(  (dxluarw*(4.+rluarw)**0.5) - &
           (0.5*xluarw*(4.+rluarw)**(-0.5)*drluarw) ) &
           /(4.+rluarw) 
   dbluarw=-daluarw
   
   sigmawa=radw2*(bluarw/(aluarw*(1.+fluarw2)))**0.5
   sigmawb=radw2*(aluarw/(bluarw*(1.+fluarw2)))**0.5

   dsigmawa=dradw2*(bluarw/(aluarw*(1.+fluarw2)))**0.5+ &
            radw2*( &
            (0.5*(bluarw/(aluarw*(1.+fluarw2)))**(-0.5))      * &
            ( &
            (dbluarw*(aluarw*(1.+fluarw2))- &
            bluarw*(daluarw*(1.+fluarw2)+aluarw*2.*fluarw*dfluarw)) &
            /((aluarw*(1.+fluarw2))**2) &
            ) &
            )
  dsigmawb=dradw2*(aluarw/(bluarw*(1.+fluarw2)))**0.5+ &
           radw2*( &
           (0.5*(aluarw/(bluarw*(1.+fluarw2)))**(-0.5))      * &
           ( &
           (daluarw*(bluarw*(1.+fluarw2))- &
           aluarw*(dbluarw*(1.+fluarw2)+bluarw*2.*fluarw*dfluarw)) &
           /((bluarw*(1.+fluarw2))**2) &
           ) &
           )
    
           wa=(fluarw*sigmawa)
           wb=(fluarw*sigmawb)
           dwa=dfluarw*sigmawa+fluarw*dsigmawa
           dwb=dfluarw*sigmawb+fluarw*dsigmawb

           deltawa=wold-wa
           deltawb=wold+wb
           wold2=wold*wold
           sigmawa2=sigmawa*sigmawa
           sigmawb2=sigmawb*sigmawb
                            
           if (abs(deltawa).gt.6.*sigmawa.and.abs(deltawb).gt.6.*sigmawb) flagrein=1

           pa=(usurad2p*(1./sigmawa))*(exp(-(0.5*((deltawa/sigmawa)**2.))))
           pb=(usurad2p*(1./sigmawb))*(exp(-(0.5*((deltawb/sigmawb)**2.))))
                                    
           ptot=dens*aluarw*pa+dens*bluarw*pb
                               
           aperfa=deltawa*usurad2/sigmawa
           aperfb=deltawb*usurad2/sigmawb

           Phi=-0.5* &
               (aluarw*dens*dwa+dens*wa*daluarw+aluarw*wa*ddens)*erf(aperfa) &
               +sigmawa*(aluarw*dens*dsigmawa*(wold2/sigmawa2+1.)+ &
               sigmawa*dens*daluarw+sigmawa*ddens*aluarw+ &
               aluarw*wold*dens/sigmawa2*(sigmawa*dwa-wa*dsigmawa))*pa &
               +0.5* &
               (bluarw*dens*dwb+wb*dens*dbluarw+wb*bluarw*ddens)*erf(aperfb) &
               +sigmawb*(bluarw*dens*dsigmawb*(wold2/sigmawb2+1.)+ &
               sigmawb*dens*dbluarw+sigmawb*ddens*bluarw+ &
               bluarw*wold*dens/sigmawb2*(-sigmawb*dwb+wb*dsigmawb))*pb

               Q=timedir*((aluarw*dens*deltawa/sigmawa2)*pa+ &
               (bluarw*dens*deltawb/sigmawb2)*pb)

               ath=(1./ptot)*(-(C0/2.)*alfa*Q+phi)
               bth=sqrt(C0*alfa)
              !bth=sngl(sigmaw*sqrt(2.*tlw))

    return
end subroutine cbl

function cuberoot(x) result(y)
    
    implicit none

    real, intent(in) :: x
    real :: y 
    real, parameter :: third=0.333333333

    y=sign((abs(x))**third,x)
end function cuberoot

subroutine reinit_particle(zp,wst,h,sigmaw,wp,nrand,ol)
!                                      i   i  i   i  i    io  io    i 

!******************************************************************************
! CBL skewed vertical profiles and formulation of LHH 1996 with profile of w^3
! from lHB 2000 
! LHH formulation has been modified to account for variable density profiles 
! and backward in time or forward in time simulations
! This routine re-initialize particle velocity if a numerical instability 
! in the cbl scheme generated a NaN value 
! The particle velocity is extracted from the updraft and downdraft 
! distribution as required  
! The re-initialization si not perfect 
! See e.g. Cassiani et al(2015) BLM           
!******************************************************************************
  use par_mod, only:pi
  use com_mod, only:ldirect,rannumb

  implicit none


  real :: usurad2,usurad2p,C0,costluar4,eps 
  parameter  (usurad2=0.7071067812,usurad2p=0.3989422804,C0=2,costluar4=0.66667,eps=0.000001)

  integer nrand
  real :: wp,zp,wst,h,sigmaw,dcas1 !,ran3,gasdev
  real :: w3,w2
  real ::  z, &    
       skew, &
       skew2, &
       radw2, &
       fluarw,fluarw2, &
       rluarw, &
       xluarw, &
       aluarw, &
       bluarw, &
       sigmawa, &
       sigmawb, &  
       wb,wa 
  real timedir
  real ol,transition

!---------------------------------------------------------------------------  
!timedir direction of time forward (1) or backward(-1)
  nrand=nrand+1
  dcas1=rannumb(nrand)
  timedir=ldirect 
  z=zp/h
  transition=1.

  if (-h/ol.lt.15) transition=((sin((((-h/ol)+10.)/10.)*pi)))*0.5+0.5

  w2=sigmaw*sigmaw  
  w3=(((1.2*z*((1.-z)**(3./2.)))+eps)*wst**3)*transition 
  skew=w3/(w2**1.5)
  skew2=skew*skew
  radw2=sqrt(w2) !sigmaw

  fluarw=costluar4*skew**0.333333333333333
  fluarw2=fluarw*fluarw
  rluarw=(1.+fluarw2)**3.*skew2/((3.+fluarw2)**2.*fluarw2)  !-> r
  xluarw=rluarw**0.5 !(1.+fluarw2)**1.5*skew/((3.+fluarw2)*fluarw)    !----> r^1/2

  aluarw=0.5*(1.-xluarw/(4.+rluarw)**0.5)
  bluarw=1.-aluarw

  sigmawa=radw2*(bluarw/(aluarw*(1.+fluarw2)))**0.5
  sigmawb=radw2*(aluarw/(bluarw*(1.+fluarw2)))**0.5

  wa=(fluarw*sigmawa)
  wb=(fluarw*sigmawb)



  if ((sign(1.,wp)*timedir).gt.0) then !updraft   
100 wp=(dcas1*sigmawa+wa)
    if (wp.lt.0)  then
      nrand=nrand+1
      dcas1=rannumb(nrand)
      goto 100
    end if
    wp=wp*timedir
  else if ((sign(1.,wp)*timedir).lt.0) then !downdraft    
101 wp=(dcas1*sigmawb-wb)
    if (wp.gt.0)  then 
      nrand=nrand+1
      dcas1=rannumb(nrand)
      goto 101
    end if
    wp=wp*timedir
  end if

  return
end subroutine reinit_particle

subroutine init_cbl_vel(idum,zp,wst,h,sigmaw,wp,ol,ithread)
  !                              i/o   i  i   i  i     i  o   i  

  use par_mod, only:pi
  use com_mod, only:ldirect
  use random_mod, only: gasdev, ran3

  implicit none
  !===============================================================================
  ! CBL skewed vertical profiles and formulation of LHH 1996 with profile of w3
  ! from LHB 2000
  ! LHH formulation has been modified to account for variable density profiles and
  ! backward in time or forward in time simulations
  ! see Cassiani et al. BLM 2014 doi  for explanations and references
  !===============================================================================

  integer,intent(in) :: ithread
  real :: usurad2,usurad2p,C0,costluar4,eps 
  parameter  (usurad2=0.7071067812,usurad2p=0.3989422804,C0=2,costluar4=0.66667,eps=0.000001)

  
  real :: wp,zp,wst,h,sigmaw,dcas,dcas1!,ran3,gasdev
  real :: w3,w2
  real ::  z, &    
       skew, &
       skew2, &
       radw2, &
       fluarw,fluarw2, &
       rluarw, &
       xluarw, &
       aluarw, &
       bluarw, &
       sigmawa, &
       sigmawb, &  
       wb,wa 
  real timedir
  real ol, transition
  integer :: idum
  
  !---------------------------------------------------------------------------  
  timedir=ldirect !direction of time forward (1) or backward(-1)
  z=zp/h


  transition=1.
  if (-h/ol.lt.15) transition=((sin((((-h/ol)+10.)/10.)*pi)))*0.5+0.5  !see also in cbl.f90

  w2=sigmaw*sigmaw
  w3=(((1.2*z*((1.-z)**(3./2.)))+eps)*wst**3) *transition

  skew=w3/(w2**1.5)
  skew2=skew*skew

  radw2=sqrt(w2) !sigmaw

  fluarw=costluar4*skew**0.333333333333333
  fluarw2=fluarw*fluarw
  rluarw=(1.+fluarw2)**3.*skew2/((3.+fluarw2)**2.*fluarw2)  !-> r
  xluarw=rluarw**0.5 !----> r^1/2

  aluarw=0.5*(1.-xluarw/(4.+rluarw)**0.5)
  bluarw=1.-aluarw

  sigmawa=radw2*(bluarw/(aluarw*(1.+fluarw2)))**0.5
  sigmawb=radw2*(aluarw/(bluarw*(1.+fluarw2)))**0.5

  wa=(fluarw*sigmawa)
  wb=(fluarw*sigmawb)

  dcas=ran3(idum,ithread) 

  if (dcas.le.aluarw) then
    dcas1=gasdev(idum,ithread)
    wp=timedir*(dcas1*sigmawa+wa)
  else
    dcas1=gasdev(idum,ithread)
    wp=timedir*(dcas1*sigmawb-wb)
  end if

  return
end subroutine init_cbl_vel

end module cbl_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine partdep(nc,density,fract,schmi,vset,ra,ustar,nyl,vdep)
  !                   i     i      i     i    i   i    i    i  i/o
  !*****************************************************************************
  !                                                                            *
  !      Calculation of the dry deposition velocities of particles.            *
  !      This routine is based on Stokes' law for considering settling and     *
  !      assumes constant dynamic viscosity of the air.                        *
  !                                                                            *
  !     AUTHOR: Andreas Stohl, 12 November 1993                                *
  !                            Update: 20 December 1996                        *
  !                                                                            *
  !     Literature:                                                            *
  !     [1]  Hicks/Baldocchi/Meyers/Hosker/Matt (1987), A Preliminary          *
  !             Multiple Resistance Routine for Deriving Dry Deposition        *
  !             Velocities from Measured Quantities.                           *
  !             Water, Air and Soil Pollution 36 (1987), pp.311-330.           *
  !     [2]  Slinn (1982), Predictions for Particle Deposition to              *
  !             Vegetative Canopies. Atm.Env.16-7 (1982), pp.1785-1794.        *
  !     [3]  Slinn/Slinn (1980),  Predictions for Particle Deposition on       *
  !             Natural Waters. Atm.Env.14 (1980), pp.1013-1016.               *
  !     [4]  Scire/Yamartino/Carmichael/Chang (1989),                          *
  !             CALGRID: A Mesoscale Photochemical Grid Model.                 *
  !             Vol II: User's Guide. (Report No.A049-1, June, 1989)           *
  !     [5]  Langer M. (1992): Ein einfaches Modell zur Abschaetzung der       *
  !             Depositionsgeschwindigkeit von Teilchen und Gasen.             *
  !             Internal report.                                               *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! alpha                help variable                                         *
  ! fract(nc,ni)         mass fraction of each diameter interval               *
  ! lpdep(nc)            1 for particle deposition, 0 else                     *
  ! nc                   actual number of chemical components                  *
  ! ni                   number of diameter intervals, for which vdepj is calc.*
  ! rdp [s/m]            deposition layer resistance                           *
  ! ra [s/m]             aerodynamical resistance                              *
  ! schmi(nc,ni)         Schmidt number**2/3 of each diameter interval         *
  ! stokes               Stokes number                                         *
  ! ustar [m/s]          friction velocity                                     *
  ! vdep(nc) [m/s]       deposition velocities of all components               *
  ! vdepj [m/s]          help, deposition velocity of 1 interval               *
  ! vset(nc,ni)          gravitational settling velocity of each interval      *
  !                                                                            *
  ! Constants:                                                                 *
  ! nc                   number of chemical species                            *
  ! ni                   number of diameter intervals, for which deposition    *
  !                      is calculated                                         *
  !                                                                            *
  !*****************************************************************************

  use par_mod

  implicit none

  real :: density(maxspec),schmi(maxspec,ni),fract(maxspec,ni)
  real :: vset(maxspec,ni)
  real :: vdep(maxspec),stokes,vdepj,rdp,ustar,alpha,ra,nyl
  real,parameter :: eps=1.e-5
  integer :: ic,j,nc


  do ic=1,nc                  ! loop over all species
    if (density(ic).gt.0.) then
      do j=1,ni              ! loop over all diameter intervals
        if (ustar.gt.eps) then

  ! Stokes number for each diameter interval
  !*****************************************

          stokes=vset(ic,j)/ga*ustar*ustar/nyl
          alpha=-3./stokes

  ! Deposition layer resistance
  !****************************

          if (alpha.le.log10(eps)) then
            rdp=1./(schmi(ic,j)*ustar)
          else
           	rdp=1./((schmi(ic,j)+10.**alpha)*ustar)
          endif
          vdepj=vset(ic,j)+1./(ra+rdp+ra*rdp*vset(ic,j))
        else
          vdepj=vset(ic,j)
        endif

  ! deposition velocities of each interval are weighted with mass fraction
  !***********************************************************************

        vdep(ic)=vdep(ic)+vdepj*fract(ic,j)
      end do
    endif
  end do

end subroutine partdep

    program flex_read_compare

    parameter(nxmax=720,nymax=360,nzmax=40,maxtime=10)
    parameter(maxpoint=1,maxspec=1,maxageclass=1)

    double precision :: jul,julstart,juldate
    real :: outheight(nzmax)
    integer :: ireleasestart(maxpoint),ireleaseend(maxpoint)
    integer :: lage(0:maxageclass)
    real :: xpoint(maxpoint),ypoint(maxpoint),zpoint1(maxpoint)
    real :: zpoint2(maxpoint)
    integer :: ireldate(maxspec),ireltime(maxspec)

    real :: grid(0:nxmax-1,0:nymax-1,nzmax,maxspec,maxageclass)
    real :: grid_reference(0:nxmax-1,0:nymax-1,nzmax,maxspec,maxageclass)
    real :: grid_diff(0:nxmax-1,0:nymax-1,nzmax,maxspec,maxageclass)
    real :: footprint(0:nxmax-1,0:nymax-1)
    real :: footprint_total(0:nxmax-1,0:nymax-1,maxspec)
    real :: area(0:nxmax-1,0:nymax-1)
    real :: heightnn(0:nxmax-1,0:nymax-1,0:nzmax)
    real :: smallnum,r_sparse_dump(5000000)
    integer :: i_sparse_dump(5000000)
    parameter(smallnum=1.e-38)

    character dirname*120, dirname_reference*120 
    logical ::  dirnameisarg
    character filename_reference*150,filename*150,fileout*150,aday*8,atime*6
    character(250) :: filegrid, filegrid_reference 
          
    logical :: sp_zer

    real :: sizegrid_m
    real :: sum_grid, sum_sum_grid
    real :: max_grid, max_max_grid
    real :: maxdiff, diff_tolerance 
    character(4) :: grid_magnitude

!    grid_magnitude='time'
    grid_magnitude='conc'
!    grid_magnitude='pptv'
    maxdiff=0.0  
    
    dirnameisarg= .FALSE. 
    ! print*, iargc()
    select case (iargc())
    case (3)
      call getarg(1,dirname)
      len=index(dirname,' ')-1
      call getarg(2,dirname_reference)
      len_reference=index(dirname_reference,' ')-1
      call getarg(3,grid_magnitude)
    case (2)
      !dirnameisarg= .TRUE. 
      call getarg(1,dirname)
      len=index(dirname,' ')-1
      call getarg(2,grid_magnitude)
    case (1)
      call getarg(1,grid_magnitude)
    case (0)
      grid_magnitude='time'
    print*,'Error: argument absent'
    stop 2
    end select
    print*, "grid_magnitude=", grid_magnitude

!    if ( .NOT. dirnameisarg) then
    !******************
!!        print*, " Read dirlist "
    !******************
!!        open(15,file='dirlist')
!!        200 read(15,'(a)',end=199) dirname_reference
!!       len_reference=index(dirname_reference,' ')-1
!    endif


     print*, 'dirname input: ', dirname
     print*, 'dirname reference: ', dirname_reference
     

!      do 50 mother_or_nest=1,2
    do 50 mother_or_nest=1,1

    !*********************************
    ! Read FLEXPART header information
    !*********************************

        if (mother_or_nest == 1) then
            filename=dirname_reference(1:len_reference)//'header'
        else if (mother_or_nest == 2) then
            filename=dirname_reference(1:len_reference)//'header_nest'
        endif
        call readheader(filename,nxmax,numxgrid,nymax,numygrid,nzmax, &
        numzgrid,outlon0,outlat0,dxout,dyout,outheight,ibdate,ibtime, &
        loutstep,maxspec,nspec,maxageclass,nageclass,lage,ireleasestart, &
        ireleaseend,maxpoint,numpoint,xpoint,ypoint,zpoint1,zpoint2, &
        heightnn,area)

        print*, 'ireleasestart, ireleaseend ',ireleasestart, ireleaseend


        if (mother_or_nest == 1) then
            filename=dirname(1:len)//'header'
        else if (mother_or_nest == 2) then
            filename=dirname(1:len)//'header_nest'
        endif
        call readheader(filename,nxmax,numxgrid,nymax,numygrid,nzmax, &
        numzgrid,outlon0,outlat0,dxout,dyout,outheight,ibdate,ibtime, &
        loutstep,maxspec,nspec,maxageclass,nageclass,lage,ireleasestart, &
        ireleaseend,maxpoint,numpoint,xpoint,ypoint,zpoint1,zpoint2, &
        heightnn,area)

        print*, 'ireleasestart, ireleaseend ',ireleasestart, ireleaseend
        !STOP


        write(*,*) 'nspec',nspec
        julstart=juldate(ibdate,ibtime)
        do 30 k=1,nspec
            jul=julstart+dble(float(ireleaseend(k))/86400.)
            call caldate(jul,ireldate(k),ireltime(k))
            print*,'ireldate',ireldate(k)
            print*,'ireltime',ireltime(k)
        30 END DO

        max_max_grid=0
        max_grid=0
        sum_grid=0
        sum_sum_grid=0
        sizegrid_m=0

    ! rint*, 'init sizegrid_m=', sizegrid_m !=0

        do 70 k=1,nspec
            do 70 ix=0,numxgrid-1
                do 70 jy=0,numygrid-1
                    footprint_total(ix,jy,k)=0.
        70 END DO

    !******************************************
    ! Loop about all times, given in file dates
    !******************************************
        !print*,'> open dates'
        
        open(20,file=dirname(1:len)//'dates',form='formatted', &
        status='old')
        it=0
        print*,'> loop on dates'
        100 read(20,'(i8,i6)',end=99) inday,intime
        write(aday,'(i8.8)') inday
        write(atime,'(i6.6)') intime
        it=it+1
                 
        if (mother_or_nest == 1) then
            !filegrid=dirname(1:len)//'/grid_conc_'//aday//atime//'_001'
            filegrid=dirname(1:len)//'/grid_'//grid_magnitude//'_' &
            //aday//atime//'_001'

            filegrid_reference=dirname_reference(1:len_reference)//'/grid_'//grid_magnitude//'_' &
            //aday//atime//'_001'

            fileout=dirname(1:len)//'footprint_'//aday//atime//'_001'
        else
            filegrid=dirname(1:len)//'grid_time_nest_'//aday//atime//'_001'
            fileout=dirname(1:len)//'footprint_nest_'//aday//atime//'_001'
        endif

    ! rite(*,*) filegrid
        print*, 'read filegrid input=', filegrid
        call readgrid(filegrid_reference,itime,nxmax,numxgrid,nymax,numygrid, &
        nzmax,numzgrid,maxspec,nspec,maxageclass,nageclass,grid_reference, &
        lage)

        print*, 'read filegrid reference=', filegrid_reference
        call readgrid(filegrid,itime,nxmax,numxgrid,nymax,numygrid, &
        nzmax,numzgrid,maxspec,nspec,maxageclass,nageclass,grid, &
        lage)




        grid_diff=grid_reference-grid

        print*, 'sum(reference - input)=', sum(grid_diff) 
        print*, 'sum(reference - input)=', sum(grid_reference-grid) 

        maxdiff = max(maxdiff,  sum(grid_reference-grid) )
        print*,'maxdiff =',maxdiff
        

        !diff_tolerance= max(sum(grid_reference)/sum(grid) , sum(grid)/sum(grid_reference)  )
        !if  (sum(abs(grid_diff)) > 1 ) then
        if  (sum(abs(grid_diff)) > sum(abs(grid))/100  ) then
           print*, 'fail! sum(abs(grid_diff)) > 1 '
           stop 1
        endif


        
        !print*, 'stop!'
        !stop


        print*, 'read grid:'
        print*, 'maxval(grid)=', maxval(grid)

        print*, 'sum(grid)=', sum(grid)
    !***************************************
    ! Display read values
    !***************************************
    ! izegrid_m=sizegrid_m+sum(grid)


        sum_grid=sum(grid)
        max_grid=maxval(grid)

        print*, 'max_max_grid,max_grid', max_max_grid, max_grid
        max_max_grid=max(max_max_grid,max_grid)
        sum_sum_grid=sum_sum_grid+sum_grid

        print*, 'sum_grid=',sum_grid !sum(grid)
        print*, 'max_grid=', max_grid !  maxval(grid)
        print*, 'part total', it, aday, atime
    ! rint*, 'sum sum(grid)=', sum_sum_grid
    ! rint*, 'max maxval(grid)=', max_max_grid
        print*, 'sum_sum_grid=', sum_sum_grid
        print*, 'max_max_grid=', max_max_grid
    ! rint*, 'sizegrid_m=', sizegrid_m


        goto 100 !read dates
        99 close(20)


    50 END DO

!    if ( .NOT. dirnameisarg) then
!!        goto 200 !read(15, dirlist
!!        199 close(15) !dirlist
!    endif


    print*, 'for all times'
    print*, 'sum sum(grid)=', sum_sum_grid
    print*, 'max maxval(grid)=', max_max_grid

!    print*, 'sum_sum_grid_out=',sum_sum_grid
!    print*, 'max_max_grid_out=',max_max_grid
    END PROGRAM

module interpol_mod

  use par_mod, only: nzmax, maxspec

  implicit none

  real :: uprof(nzmax),vprof(nzmax),wprof(nzmax)
  real :: usigprof(nzmax),vsigprof(nzmax),wsigprof(nzmax)
  real :: rhoprof(nzmax),rhogradprof(nzmax)

  real :: u,v,w,usig,vsig,wsig,pvi

  real :: p1,p2,p3,p4,ddx,ddy,rddx,rddy,dtt,dt1,dt2
  integer :: ix,jy,ixp,jyp,ngrid,indz,indzp
  logical :: depoindicator(maxspec)
  logical :: indzindicator(nzmax)

end module interpol_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  !    This module contains variables and subroutines for  calculating         *
  !    chemical loss of species                                                *
  !                                                                            *
  !*****************************************************************************

module chemistry_mod

  use netcdf
  use par_mod
  use com_mod
  use date_mod
  use windfields_mod,    only: rho,nxmax,nymax,nzmax
  use totals_mod,        only: chem_loss
  use netcdf_output_mod, only: nf90_err

  ! reagent field variables 

  implicit none

  integer, allocatable, dimension(:)      :: nxCL, nyCL, nzCL
  integer                                 :: nxjr, nyjr
  real, allocatable, dimension(:,:)       :: lonCL, latCL, altCL
  real, allocatable, dimension(:)         :: dxCL, dyCL
  real                                    :: dxjr, dyjr
  real, allocatable, dimension(:,:,:,:,:) :: CL_field           ! chemical loss fields at input resolution
  real, allocatable, dimension(:,:,:,:)   :: clfield_cur        ! chemical loss fields current hour
  integer, dimension(2)                   :: memCLtime          ! time of fields in memory (sec)  
  integer                                 :: curCLhour          ! current hour since start of simulation
  real(kind=dp)                           :: memCLday           ! current day of simulation
  real(kind=dp), dimension(2)             :: CL_time            ! julian date of fields in memory
  real, allocatable, dimension(:,:)       :: jrate_average      ! daily average actinic flux 
  real, allocatable, dimension(:)         :: lonjr, latjr

  private :: zenithangle, photo_O1D

  contains

  subroutine readreagents()

  !*****************************************************************************
  !                                                                            *
  !   This routine reads names and input paths of chemical reagents            *
  !                                                                            *
  !   Author: R. Thompson, Sep 2023                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! preagent              Reagent name                                         *
  ! preag_path            Path to reagent fields                               *
  ! phourly               Logical for hourly interpolate (0 = no, 1 = yes)     *
  !                                                                            *
  !*****************************************************************************

    implicit none

    character(len=256) :: preag_path
    character(len=16)  :: preagent, punit
    integer :: phourly
    integer,parameter :: unitreagents=2, unitreagentsout=3
    integer :: readerror
    integer :: j

    ! declare namelist
    namelist /reagent_params/ &
         preagent, preag_path, phourly, punit

    preagent="" ! read failure indicator value
    preag_path=""
    punit=""
    phourly=0
    reag_hourly(:)=0

    open(unitreagents,file=path(1)(1:length(1))//'REAGENTS',status='old',form='formatted',iostat=readerror)
    if (readerror.ne.0) then
      ! no REAGENTS file
      nreagent=0
      go to 999
    endif

    ! prepare namelist output if requested
    if (nmlout.and.lroot) then
      open(unitreagentsout,file=path(2)(1:length(2))//'REAGENTS.namelist',access='append',status='replace',iostat=readerror)
      if (readerror.ne.0) then
        write(*,*) '#### FLEXPART MODEL ERROR CANNOT CREATE FILE:   ####'
        write(*,*) '#### ',path(2)(1:length(2))//'REAGENTS.namelist ####'
      endif
    endif

    ! try namelist input
    read(unitreagents,reagent_params,iostat=readerror)
    close(unitreagents)
    if (readerror.ne.0) then
      ! not namelist format
      nreagent=0
      go to 999
    endif

    ! namelist input
    open(unitreagents,file=path(1)(1:length(1))//'REAGENTS',status='old',form='formatted',iostat=readerror)
    j=0
    do while (readerror.eq.0)
      j=j+1
      if (j.gt.maxreagent) then
        write(*,*) ' #### FLEXPART MODEL ERROR! TOO MANY REAGENTS #### '
        write(*,*) ' #### MAXIMUM NUMBER IS ',maxreagent,'        #### '
        write(*,*) ' #### PLEASE MAKE CHANGES IN FILE REAGENTS    #### '
        stop
      endif
      read(unitreagents,reagent_params,iostat=readerror)
      reagents(j)=preagent
      reag_path(j)=preag_path
      reag_hourly(j)=phourly
      reag_unit(j)=punit
      ! namelist output
      if (nmlout.and.lroot) then
        write(unitreagentsout,nml=reagent_params)
      endif
    end do
    nreagent=j-1
    if (lroot) then
      write(*,*) 'Number of reagents: ',nreagent
      write(*,*) 'Reagent names: ',reagents(1:nreagent)
      write(*,*) 'Reagent units: ',reag_unit(1:nreagent)
    endif
    close(unitreagents)
    close(unitreagentsout)

999 continue ! no reagents file

  end subroutine readreagents

  subroutine getchemfield(itime)

  !*****************************************************************************
  !                                                                            *
  !    This routine reads the chemical reagent fields into memory              *
  !                                                                            *
  !    Author: Rona Thompson, Sep 2023                                         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! itime            time since start of simulation in sec                     *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer          :: itime
    integer          :: jjjjmmdd, hhmmss, mm, eomday
    integer          :: nr, memid
    real(kind=dp)    :: jd, jdmid
    character(len=2) :: amonth
    character(len=256):: CL_name, jr_name
    logical          :: lexist

    print*, 'getchemfield: ldirect*memCLtime(1) = ',ldirect*memCLtime(1)
    print*, 'getchemfield: ldirect*memCLtime(2) = ',ldirect*memCLtime(2)

    ! Check fields are available for the current time step
    !*****************************************************

    if ((ldirect*memCLtime(1).le.ldirect*itime).and. &
         (ldirect*memCLtime(2).gt.ldirect*itime)) then

      ! The rightfields are already in memory -> don't do anything
      return 

    else if ((ldirect*memCLtime(2).le.ldirect*itime).and. &
         (memCLtime(2).ne.0.)) then

      ! Current time is after 2nd chem field
      !*************************************

      write(*,*) 'Updating CL fields... '

      memCLtime(1)=memCLtime(2)  ! time in sec
      CL_time(1)=CL_time(2)      ! julian date
      memid=2

      ! Get date/time of next chem field 
      !*********************************
      ! assumes fields are monthly
     
      call caldate(CL_time(1), jjjjmmdd, hhmmss)
      eomday=calceomday(jjjjmmdd/100)
      memCLtime(2)=memCLtime(1)+ldirect*eomday*24*3600   ! time in sec
      CL_time(2)=CL_time(1)+real(ldirect*eomday,kind=dp) ! julian date 
      write(*,*) 'getchemfield: memCLtime = ',memCLtime(1), memCLtime(2)
      write(*,*) 'getchemfield: CL_time = ',CL_time(1), CL_time(2)
      call caldate(CL_time(2), jjjjmmdd,hhmmss)
      mm=int((jjjjmmdd-(jjjjmmdd/10000)*10000)/100)
      write(amonth,'(I2.2)') mm

      do nr=1,nreagent

        write(*,*) 'Updating CL field for: ',trim(reagents(nr))

        CL_field(:,:,:,nr,1)=CL_field(:,:,:,nr,2)

        ! Read new chem field and store in 2nd position
        !**********************************************

        write(CL_name,'(A)') trim(reag_path(nr))//trim(reagents(nr))//'_'//amonth//'.nc'
        inquire(file=CL_name,exist=lexist)
        if (lexist) then
          write(*,*) 'Reading CL field: ',CL_name
          call readchemfield(CL_name, memid, nr)
        else
          write(*,*) '#### FLEXPART ERROR                ####'
          write(*,*) '#### CHEMISTRY FIELD NOT FOUND     ####'
          write(*,*) '#### '//trim(CL_name)//' ####'
          error stop
        endif

      end do ! nreagent

    else

      ! No chem field in memory that can be used
      !******************************************  

      write(*,*) 'Reading two new CL fields...'

      ! Get date/time of both chem fields 
      !**********************************
      ! assumes fields are monthly

      do memid=1,2
        if (memid.eq.1) then
          jd=bdate+real(ldirect*itime,kind=dp)/86400._dp
          call caldate(jd, jjjjmmdd, hhmmss)
          ! middle of month day
          jdmid=juldate(int(jjjjmmdd/100)*100+15,0) 
          !! testing
          print*, 'getchemfield: jjjjmmdd, jjjjmmdd_mid = ',jjjjmmdd, int(jjjjmmdd/100)*100+15
          ! julian date of fields
          if (ldirect.gt.0) then
            if (jd.ge.jdmid) then
              ! use current month
              CL_time(memid)=jdmid 
            else
              ! use last month
              eomday=calceomday(jjjjmmdd/100)
              CL_time(memid)=jdmid-real(eomday,kind=dp)
            endif
          else
            if (jd.ge.jdmid) then
              ! use next month
              CL_time(memid)=jdmid+real(eomday,kind=dp)
            else
              ! use current month
              CL_time(memid)=jdmid
            endif
          endif
        else
          call caldate(jd, jjjjmmdd, hhmmss)
          eomday=calceomday(jjjjmmdd/100)
          CL_time(memid)=CL_time(memid-1)+real(ldirect*eomday,kind=dp)
        endif
        ! time of field in seconds from start
        memCLtime(memid)=int((CL_time(memid)-bdate)*86400._dp)

        write(*,*) 'getchemfield: memid, memCLtime = ',memCLtime(memid)
        write(*,*) 'getchemfield: memid, CL_time = ',CL_time(memid)

        call caldate(CL_time(memid), jjjjmmdd, hhmmss)
        mm=int((jjjjmmdd-(jjjjmmdd/10000)*10000)/100)
        write(amonth,'(I2.2)') mm

        do nr=1,nreagent

          write(*,*) 'Reading two new CL fields for: ',trim(reagents(nr))

          ! Read new chem field
          !********************

          write(CL_name,'(A)') trim(reag_path(nr))//trim(reagents(nr))//'_'//amonth//'.nc'
          inquire(file=CL_name,exist=lexist)
          if (lexist) then
            write(*,*) 'Reading CL field: ',CL_name
            call readchemfield(CL_name, memid, nr)
          else
            write(*,*) '#### FLEXPART ERROR                ####'
            write(*,*) '#### CHEMISTRY FIELD NOT FOUND     ####'
            write(*,*) '#### '//trim(CL_name)//' ####'
            error stop
          endif
 
        end do ! nreagent

      end do ! memid
      
    endif ! update hourly fields


  end subroutine getchemfield


  subroutine readchemfield(CL_name,memid,nr)

  !*****************************************************************************
  !                                                                            *
  !    Reads the chemical reagent fields into memory                           *
  !                                                                            *
  !    Author: Rona Thompson, Sep 2023                                         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! CL_name           name of chemical reagent file                            *
  ! memid             time index to chemical field variable                    *
  ! nr                reagent index to chemical field variable                 *
  !                                                                            * 
  !*****************************************************************************

    implicit none

    character(len=256) :: CL_name
    integer            :: memid,nr,len
    integer            :: ncid,dimid,varid

    ! Read netcdf file
    !******************

    ! open file
    call nf90_err( nf90_open(trim(CL_name),nf90_NOWRITE,ncid) )

    ! longitude
    call nf90_err( nf90_inq_dimid(ncid,'lon',dimid) )
    call nf90_err( nf90_inquire_dimension(ncid,dimid,len=len) )
    if (.not.allocated(lonCL)) then
      allocate(nxCL(nreagent))
      allocate(dxCL(nreagent))
      allocate(lonCL(nxmax,nreagent))
    endif
    nxCL(nr)=len
    call nf90_err( nf90_inq_varid(ncid,'lon',varid) )
    call nf90_err( nf90_get_var(ncid,varid,lonCL(1:nxCL(nr),nr)) )
    dxCL(nr)=abs(lonCL(2,nr)-lonCL(1,nr))

    ! latitude
    call nf90_err( nf90_inq_dimid(ncid,'lat',dimid) )
    call nf90_err( nf90_inquire_dimension(ncid,dimid,len=len) )
    if (.not.allocated(latCL)) then
      allocate(nyCL(nreagent))
      allocate(dyCL(nreagent))
      allocate(latCL(nymax,nreagent))
    endif
    nyCL(nr)=len
    call nf90_err( nf90_inq_varid(ncid,'lat',varid) )
    call nf90_err( nf90_get_var(ncid,varid,latCL(1:nyCL(nr),nr)) )
    dyCL(nr)=abs(latCL(2,nr)-latCL(1,nr))

    ! altitude
    call nf90_err( nf90_inq_dimid(ncid,'lev',dimid) )
    call nf90_err( nf90_inquire_dimension(ncid,dimid,len=len) )
    if (.not.allocated(altCL)) then
      allocate(nzCL(nreagent))
      allocate(altCL(nzmax,nreagent))
    endif
    nzCL(nr)=len
    call nf90_err( nf90_inq_varid(ncid,'lev',varid) )
    call nf90_err( nf90_get_var(ncid,varid,altCL(1:nzCL(nr),nr)) )

    ! chemical field
    call nf90_err( nf90_inq_varid(ncid,trim(reagents(nr)),varid) )
    if (.not.allocated(CL_field)) then
      allocate(CL_field(nxmax,nymax,nzmax,nreagent,2))
      allocate(clfield_cur(nxmax,nymax,nzmax,nreagent))
    endif
    call nf90_err( nf90_get_var(ncid,varid,CL_field(1:nxCL(nr),1:nyCL(nr),1:nzCL(nr),nr,memid)) )

    ! close file
    call nf90_err( nf90_close(ncid) )

    !! testing
!    print*, 'readchemfield: nxCL, nyCL, nzCL = ',nxCL(nr), nyCL(nr), nzCL(nr)
!    print*, 'readchemfield: lonCL = ',lonCL(1:nxCL(nr),nr)
!    print*, 'readchemfield: latCL = ',latCL(1:nyCL(nr),nr)

    return

  end subroutine readchemfield

  subroutine getchemhourly(itime)

  !*****************************************************************************
  !                                                                            *
  !    This routine interpolates the chemistry fields to current hour and      *
  !    if required using information on solar zenith angle                     *
  !                                                                            *
  !    Author: Rona Thompson, Mar 2024                                         *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]            actual simulation time [s]                            *
  !                                                                            *
  !*****************************************************************************

    use point_mod,      only: xlon0, ylat0, dx, dy
    use windfields_mod, only : height, nz

    implicit none

    integer            :: itime, curhour, interp_time
    integer            :: nr, kz, ix, jy, ixm, jym, ixp, jyp, indz, indzm, ii
    real               :: dt1, dt2, dtt, sza, jrate, r
    real, dimension(2) :: r1
    real               :: dz1, dz2, dz, ddx, ddy, rddx, rddy, p1, p2, p3, p4
    integer            :: jjjjmmdd, hhmmss, hh
    real(kind=dp)      :: jul, curday
    real, parameter    :: avog = 6.02214e23 ! Avogadro constant (1/mol)
    !! testing
    character(len=4) :: atime
    real, dimension(nxCL(1),nyCL(1)) :: jscalar
    character(len=20) :: frmt

    !! testing
    jscalar(:,:)=0.

    ! current hour of simulation
    curhour=itime/3600
    write(*,*) 'getchemhourly: curhour, curCLhour = ',curhour, curCLhour

    if ((ldirect*curCLhour.eq.ldirect*curhour).and.(ldirect*itime.gt.0)) then
      ! chemical field is for current hour -> don't do anything
      return
    else

      ! interpolate chemical field
      !*****************************

      jul=bdate+real(itime,kind=dp)/86400._dp
      call caldate(jul,jjjjmmdd,hhmmss)
      ! interpolate to middle of hour
      curCLhour=curhour
      interp_time=curhour*3600+1800
      dt1=float(interp_time-memCLtime(1))
      dt2=float(memCLtime(2)-interp_time)
      dtt=1./(dt1+dt2)

      if (any(reag_hourly.gt.0)) then
        ! interpolate using rate of O3 + hv -> O1D 
        ! check if daily mean rate exists for current day
        ! note: assume that all chemical fields using hourly interpolation
        ! are on the same grid
        do nr=1,nreagent
          if (reag_hourly(nr).gt.0) exit
        end do
        curday=bdate+real(itime,kind=dp)/86400._dp
        curday=floor(curday)
        write(*,*) 'getchemhourly: curday, memCLday = ',curday, memCLday
        if (memCLday.ne.curday) then
          if (.not.allocated(jrate_average)) then
            allocate(jrate_average(nxCL(1),nyCL(1)))
          endif
          memCLday=curday
          jrate_average(:,:)=0.
!$OMP PARALLEL &
!$OMP PRIVATE(jy,ix,hh,sza,jrate) &
!$OMP REDUCTION(+:jrate_average)
!$OMP DO
          do jy=1,nyCL(nr)
            do ix = 1,nxCL(nr)
              do hh=0,23
                sza=zenithangle(latCL(jy,nr),lonCL(ix,nr),jjjjmmdd,hh*10000)
                jrate=photo_O1D(sza)
                jrate_average(ix,jy)=jrate_average(ix,jy)+jrate
              end do
            end do
          end do
!$OMP END DO
!$OMP END PARALLEL
          jrate_average=jrate_average/24.
        end if
        !! testing
!        print*, 'getchemhourly: range(jrate_average) = ',minval(jrate_average),maxval(jrate_average)
      endif

      ! loop over reagents
      do nr=1,nreagent

        write(*,*) 'Interpolating fields for reagent: ',reagents(nr)
        clfield_cur(:,:,:,nr)=(dt2*CL_field(:,:,:,nr,1) + dt1*CL_field(:,:,:,nr,2))*dtt

        if (reag_unit(nr).eq.'mol/mol') then
          ! convert to molecule/cm3
!$OMP PARALLEL &
!$OMP PRIVATE(kz,ix,jy,indz,indzm,ixm,jym,ixp,jyp,ddx,ddy,rddx,rddy,&
!$OMP p1,p2,p3,p4,r1,ii,dz1,dz2,dz,r)
!$OMP DO
          do kz=1,nzCL(nr)
            ! assume chem fields vertical coordinate is in meters
            indzm=nz-1
            do indz=1,nz
              if (height(indz).gt.altCL(kz,nr)) then
                indzm=indz-1
                exit
              endif
            end do
            dz1=altCL(kz,nr)-height(indzm)
            dz2=height(indz)-altCL(kz,nr)
            dz=1./(dz1+dz2)
            do jy=1,nyCL(nr)
              jym=int((latCL(jy,nr)-ylat0)/dy)
              jyp=jym+1
              ddy=(latCL(jy,nr)-ylat0)/dy-real(jym)
              rddy=1.-ddy
              do ix=1,nxCL(nr)
                ixm=int((lonCL(ix,nr)-xlon0)/dx)
                ixp=ixm+1
                ddx=(lonCL(ix,nr)-xlon0)/dx-real(ixm)
                rddx=1.-ddx
                p1=rddx*rddy
                p2=ddx*rddy
                p3=rddx*ddy
                p4=ddx*ddy
                ! take density from first field (accurate enough)
                do ii=1,2
                  indz=indzm+ii-1
                  r1(ii)=p1*rho(ixm,jym,indz,1)+&
                         p2*rho(ixp,jym,indz,1)+&
                         p3*rho(ixm,jyp,indz,1)+&
                         p4*rho(ixp,jyp,indz,1)
                end do
                r=(dz2*r1(1)+dz1*r1(2))*dz
                ! vmr*Avog*P/(RT)/1e6
                ! using P/T = rho*rair
                clfield_cur(ix,jy,kz,nr)=clfield_cur(ix,jy,kz,nr)*avog*r*r_air/rgas/1.e6 
              end do
            end do
          end do
!$OMP END DO
!$OMP END PARALLEL
        endif

        if (reag_hourly(nr).gt.0) then
          ! interpolate using rate of O3 + hv -> O1D 
!$OMP PARALLEL &
!$OMP PRIVATE(kz,jy,ix,sza,jrate) 
!$OMP DO
          do kz=1,nzCL(nr)
            do jy=1,nyCL(nr)
              do ix=1,nxCL(nr)
                ! solar zenith angle
                sza=zenithangle(latCL(jy,nr),lonCL(ix,nr),jjjjmmdd,hhmmss)
                ! calculate J(O1D) (jrate)
                jrate=photo_O1D(sza)
                ! hourly correction
                if (jrate_average(ix,jy).ne.0) then
                  clfield_cur(ix,jy,kz,nr)=clfield_cur(ix,jy,kz,nr)*jrate/jrate_average(ix,jy)
                  !! testing
!                  jscalar(ix,jy)=jrate/jrate_average(ix,jy)
                endif
              end do
            end do
          end do
!$OMP END DO
!$OMP END PARALLEL
        endif ! reag_hourly
      end do ! nreagent
    endif ! curhour

    !! testing
!    write(atime,fmt='(I4.4)') curhour
!    write(frmt,fmt='(A,I4,A)') '(',nxCL(1),'(E14.6))'
!    open(600,file=path(2)(1:length(2))//'jscalar_'//atime//'.txt',action='write',status='replace')
!    do jy=1,nyCL(1)
!      write(600,fmt=frmt) jscalar(:,jy)
!    end do
!    close(600)
    !!

  end subroutine getchemhourly


  subroutine chemreaction(itime)

  !*****************************************************************************
  !                                                                            *
  !    This routine computes the chemical loss of each species and updates     *
  !    the particle mass                                                       *
  !                                                                            *
  !    Author: Rona Thompson, Sep 2023                                         *
  !    updated for v11, Jan 2024                                               *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]            actual simulation time [s]                            *
  !                                                                            *
  !*****************************************************************************

    use particle_mod,   only: count, part, mass
    use point_mod,      only: xlon0, ylat0, dx, dy
    use windfields_mod, only: xresoln, yresoln, xln, yln, xrn, yrn, height, tt, nz
    use omp_lib

    implicit none

    integer               :: jpart,itime
    integer               :: ii,i,j,ks,ix,jy,kz,jrx,jry,nr
    integer               :: ngrid,interp_time,n,indz
    integer               :: jjjjmmdd,hhmmss,mm,hh,m1,m2
    integer               :: clx,cly,clz,clzm,ithread
    real, dimension(nzmax) :: altCLtop
    real, dimension(2)    :: cl_tmp
    real                  :: xlon,ylat
    real                  :: xtn,ytn
    real                  :: dt1,dt2,dtt,dtt1,dtt2,dttt,dz1,dz2,dzz
    real                  :: restmass,clreacted,cl_cur
    real                  :: jrate,jrate_cur,sza
    real                  :: clrate,temp
    real, parameter       :: smallnum = tiny(0.0) ! smallest number that can be handled
    real(kind=dp)         :: jul
    real                  :: lonjrx,latjry
#ifdef _OPENMP
    real(kind=dp), allocatable, dimension(:,:,:) :: chem_loss_tmp
#endif

    ! use middle of synchronisation time step
    interp_time=nint(itime+0.5*lsynctime)
    dtt1=float(interp_time-memtime(1))
    dtt2=float(memtime(2)-interp_time)
    dttt=1./(dtt1+dtt2)

    ! initialization
    chem_loss(:,:)=0d0

#ifdef _OPENMP
    allocate( chem_loss_tmp(nreagent,nspec,numthreads) )
    chem_loss_tmp(:,:,:) = 0d0
#endif

    ! Loop over particles
    !*****************************************

!$OMP PARALLEL &
!$OMP PRIVATE(ii,jpart,ngrid,j,xtn,ytn,ix,jy, &
!$OMP   xlon,ylat,clx,cly,clz,clzm,kz,altCLtop,dz1,dz2,dzz,nr,i, &
!$OMP   cl_cur,indz,temp,ks,clrate,restmass,clreacted,ithread) 

#ifdef _OPENMP
    ithread = OMP_GET_THREAD_NUM()+1 ! Starts with 1
#else
    ithread = 1
#endif

!$OMP DO
    do ii=1,count%alive

      jpart=count%ialive(ii)
      ! Determine which nesting level to be used
      ngrid=0
      do j=numbnests,1,-1 ! check if need +/- dxn below
        if ((part(jpart)%xlon.gt.xln(j)).and.(part(jpart)%xlon.lt.xrn(j)).and. &
             (part(jpart)%ylat.gt.yln(j)).and.(part(jpart)%ylat.lt.yrn(j))) then
          ngrid=j
          exit
        endif
      end do

      ! Determine nested grid coordinates
      if (ngrid.gt.0) then
        xtn=(real(part(jpart)%xlon)-xln(ngrid))*xresoln(ngrid)
        ytn=(real(part(jpart)%ylat)-yln(ngrid))*yresoln(ngrid)
        ix=int(xtn)
        jy=int(ytn)
      else
        ix=int(part(jpart)%xlon)
        jy=int(part(jpart)%ylat)
      endif

      ! Get CL from nearest grid-cell for current hour
      !***********************************************

      ! world coordinates
      xlon=real(part(jpart)%xlon)*dx+xlon0
      if (xlon.gt.180.) then
        xlon=xlon-360.
      endif
      ylat=real(part(jpart)%ylat)*dy+ylat0
      if (ylat.gt.90.) then
        ylat=90.
      endif

      do nr=1,nreagent

        ! get position in the chem field
        ! assumes chem field dimensions given as grid midpoints
        clx=min(nxCL(nr),int((xlon-(lonCL(1,nr)-0.5*dxCL(nr)))/dxCL(nr))+1)
        cly=min(nyCL(nr),int((ylat-(latCL(1,nr)-0.5*dyCL(nr)))/dyCL(nr))+1)   

        ! get the level of the chem field for the particle
        ! z is the z-coord of the trajectory above model orography in metres
        ! altCL is the height of the centre of the level in the chem field above orography
        do kz=2,nzCL(nr)
          altCLtop(kz-1)=altCL(kz-1,nr)+0.5*(altCL(kz,nr)-altCL(kz-1,nr))
        end do
        altCLtop(nzCL(nr))=altCL(nzCL(nr),nr)+0.5*(altCL(nzCL(nr),nr)-altCL(nzCL(nr)-1,nr))
        clzm=nzCL(nr)-1
        do clz=1,nzCL(nr)
          if (real(part(jpart)%z).lt.altCLtop(clz)) then
            clzm=clz-1
            exit
          endif
        end do
        clz=min(nzCL(nr),clz)
        if (clzm.eq.0 ) then
          dz1=1.
          dz2=1.
          clzm=clz
        else
          dz1=real(part(jpart)%z)-altCL(clzm,nr)
          dz2=altCL(clz,nr)-real(part(jpart)%z)
        endif
        if (dz1.eq.(-1.*dz2)) then
          dz1=1.
          dz2=1.
        endif
        dzz=1./(dz1+dz2)

        !! testing
!        if(ii.lt.100) print*, 'chemreaction: nr, clx, cly, clz, clzm = ',nr, clx, cly, clz, clzm

        ! chem reagent for particle time and location 
        cl_cur=(dz2*clfield_cur(clx,cly,clzm,nr) + &
                dz1*clfield_cur(clx,cly,clz,nr))*dzz

        ! Compute chemical loss
        !**********************

        if (cl_cur.gt.smallnum) then
          indz=nz
          do kz=2,nz
            if (height(kz).gt.part(jpart)%z) then
              indz=kz-1
              exit
            endif
          end do
          temp=(tt(ix,jy,indz,1)*dtt2 &
                 + tt(ix,jy,indz,2)*dtt1)*dttt
          do ks=1,nspec
            if (reaccconst(nr,ks).gt.0.) then
              ! k = CT^Nexp(-D/T)[reagent]
              clrate=reaccconst(nr,ks)*(temp**reacnconst(nr,ks))*exp(-1.*reacdconst(nr,ks)/temp)*cl_cur
              ! new particle mass
              restmass=mass(jpart,ks)*exp(-1.*clrate*abs(lsynctime))
              if (restmass.gt.smallnum) then
                clreacted=mass(jpart,ks)-restmass
                mass(jpart,ks)=restmass
              else
                clreacted=mass(jpart,ks)
                mass(jpart,ks)=0.
              endif
#ifdef _OPENMP
              chem_loss_tmp(nr,ks,ithread)=chem_loss_tmp(nr,ks,ithread)+real(clreacted,kind=dp)
#else
              chem_loss(nr,ks)=chem_loss(nr,ks)+real(clreacted,kind=dp)
#endif
            endif
          end do  ! nspec
        endif   

      end do  ! nreagent

    end do  ! loop over all particles
!$OMP END DO

!$OMP END PARALLEL

#ifdef _OPENMP
  do ithread=1,numthreads
    chem_loss(:,:) = chem_loss(:,:)+chem_loss_tmp(:,:,ithread)
  end do
  deallocate( chem_loss_tmp )
#endif

  end subroutine chemreaction


  function photo_O1D(sza) result(jrate)

  !*****************************************************************************
  !                                                                            *
  !    Calculates J(O1D) photolysis rate based on solar zenith angle           *
  !                                                                            *
  !    Ref: Hamer, P. D., et al. Atmos. Chem. Phys. 2015
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  !    INPUT:                                                                  *
  !    sza        solar zenith angle (degrees)                                 *
  !                                                                            *
  !    OUTPUT:                                                                 *
  !    photo_O1D  J(O1D) photoylsis rate                                       *
  !                                                                            *
  !*****************************************************************************

    implicit none

    real, intent(in)  :: sza
    real :: sun, jrate
    real, parameter :: pi=3.1415927

    sun=sza*pi/180.
    if (sun.le.(pi/2.)) then
      sun=cos(sun)
    else
      sun=0.
    endif

    jrate=(8.978e-5*(sun**1.436)*exp(-0.936/sun))

  end function photo_O1D


  function zenithangle(ylat,xlon,jjjjmmdd,hhmmss) result(sza)

  !*****************************************************************************
  !                                                                            *
  !    This function returns the sinus of solar elevation as a function        *
  !    of geographic longitde, latitude and GMT-Time.                          *
  !                                                                            *
  !    Author: G. Wotawa, Nov 1993                                             *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  !     INPUT:                                                                 *
  !                                                                            *
  !            ylat          geographical latitude  [DEG]                      *
  !            xlon          geographical longitude [DEG]                      *
  !            jjjj          Year                                              *
  !            mm            Month                                             *
  !            dd            Day                                               *
  !            hh            Hour                                              *
  !            minute        Minute                                            *
  !                                                                            *
  !*****************************************************************************

    implicit none

    integer,       intent(in)  :: jjjjmmdd,hhmmss
    real,          intent(in)  :: ylat,xlon
    real    :: sza
    integer :: jjjj,mm,id,iu,minute 
    integer :: ndaynum
    real :: sinsol,solelev
    real :: rnum,rylat,ttime,dekl,rdekl,eq
    real,parameter :: pi=3.1415927

    jjjj=jjjjmmdd/10000
    mm=jjjjmmdd/100-jjjj*100
    id=jjjjmmdd-jjjj*10000-mm*100
    iu=hhmmss/10000
    minute=hhmmss/100-100*iu

    ndaynum=31*(mm-1)+id
    if(mm.gt.2) ndaynum=ndaynum-int(0.4*mm+2.3)
    if((mm.gt.2).and.(jjjj/4*4.eq.jjjj)) ndaynum=ndaynum+1

    rnum=2.*pi*ndaynum/365.
    rylat=pi*ylat/180.
    ttime=real(iu)+real(minute)/60.

    dekl=0.396+3.631*sin(rnum)+0.038*sin(2.*rnum)+0.077*sin(3.*rnum)- &
         22.97*cos(rnum)-0.389*cos(2.*rnum)-0.158*cos(3.*rnum)
    rdekl=pi*dekl/180.

    eq=(0.003-7.343*sin(rnum)-9.47*sin(2.*rnum)- &
         0.329*sin(3.*rnum)-0.196*sin(4.*rnum)+ &
         0.552*cos(rnum)-3.020*cos(2.*rnum)- &
         0.076*cos(3.*rnum)-0.125*cos(4.*rnum))/60.
    sinsol=sin(rylat)*sin(rdekl)+cos(rylat)*cos(rdekl)* &
         cos((ttime-12.+xlon/15.+eq)*pi/12.)
    ! Calculate the maximum solar elevation on that day
    !sinsol=sin(rylat)*sin(rdekl)+cos(rylat)*cos(rdekl)*
    !    &       cos((eq)*pi/12.)
    solelev=asin(sinsol)*180./pi
    sza=90.-solelev

  end function zenithangle


end module chemistry_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine concoutput_nest(itime,outnum)
  !                        i     i
  !*****************************************************************************
  !                                                                            *
  !     Output of the concentration grid and the receptor concentrations.      *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1995                                                            *
  !                                                                            *
  !     13 April 1999, Major update: if output size is smaller, dump output    *
  !                    in sparse matrix format; additional output of           *
  !                    uncertainty                                             *
  !                                                                            *
  !     05 April 2000, Major update: output of age classes; output for backward*
  !                    runs is time spent in grid cell times total mass of     *
  !                    species.                                                *
  !                                                                            *
  !     17 February 2002, Appropriate dimensions for backward and forward runs *
  !                       are now specified in file par_mod                    *
  !                                                                            *
  !     June 2006, write grid in sparse matrix with a single write command     *
  !                in order to save disk space                                 *
  !                                                                            *
  !     2008 new sparse matrix format                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! outnum          number of samples                                          *
  ! ncells          number of cells with non-zero concentrations               *
  ! sparse          .true. if in sparse matrix format, else .false.            *
  ! tot_mu          1 for forward, initial mass mixing ration for backw. runs  *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use point_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  real(kind=dp) :: jul
  integer :: itime,i,ix,jy,kz,ks,kp,l,iix,jjy,kzz,nage,jjjjmmdd,ihmmss
  integer :: sp_count_i,sp_count_r
  real :: sp_fact
  real :: outnum,densityoutrecept(maxreceptor),xl,yl

  !real densityoutgrid(0:numxgrid-1,0:numygrid-1,numzgrid),
  !    +grid(0:numxgrid-1,0:numygrid-1,numzgrid,maxspec,maxpointspec_act,
  !    +    maxageclass)
  !real wetgrid(0:numxgrid-1,0:numygrid-1,maxspec,maxpointspec_act,
  !    +       maxageclass)
  !real drygrid(0:numxgrid-1,0:numygrid-1,maxspec,
  !    +       maxpointspec_act,maxageclass)
  !real gridsigma(0:numxgrid-1,0:numygrid-1,numzgrid,maxspec,
  !    +       maxpointspec_act,maxageclass),
  !    +     drygridsigma(0:numxgrid-1,0:numygrid-1,maxspec,
  !    +     maxpointspec_act,maxageclass),
  !    +     wetgridsigma(0:numxgrid-1,0:numygrid-1,maxspec,
  !    +     maxpointspec_act,maxageclass)
  !real factor(0:numxgrid-1,0:numygrid-1,numzgrid)
  !real sparse_dump_r(numxgrid*numygrid*numzgrid)
  !integer sparse_dump_i(numxgrid*numygrid*numzgrid)

  !real sparse_dump_u(numxgrid*numygrid*numzgrid)
  real :: auxgrid(nclassunc)
  real :: halfheight,dz,dz1,dz2,tot_mu(maxspec,maxpointspec_act)
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  real,parameter :: weightair=28.97
  logical :: sp_zer
  character :: adate*8,atime*6
  character(len=3) :: anspec


  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss


  ! For forward simulations, output fields have dimension MAXSPEC,
  ! for backward simulations, output fields have dimension MAXPOINT.
  ! Thus, make loops either about nspec, or about numpoint
  !*****************************************************************


    if (ldirect.eq.1) then
       do ks=1,nspec
         do kp=1,maxpointspec_act
           tot_mu(ks,kp)=1
         end do
       end do
   else
      do ks=1,nspec
             do kp=1,maxpointspec_act
               tot_mu(ks,kp)=xmass(kp,ks)
             end do
      end do
    endif


  !*******************************************************************
  ! Compute air density: sufficiently accurate to take it
  ! from coarse grid at some time
  ! Determine center altitude of output layer, and interpolate density
  ! data to that altitude
  !*******************************************************************

  do kz=1,numzgrid
    if (kz.eq.1) then
      halfheight=outheight(1)/2.
    else
      halfheight=(outheight(kz)+outheight(kz-1))/2.
    endif
    do kzz=2,nz
      if ((height(kzz-1).lt.halfheight).and. &
           (height(kzz).gt.halfheight)) goto 46
    end do
46   kzz=max(min(kzz,nz),2)
    dz1=halfheight-height(kzz-1)
    dz2=height(kzz)-halfheight
    dz=dz1+dz2
    do jy=0,numygridn-1
      do ix=0,numxgridn-1
        xl=outlon0n+real(ix)*dxoutn
        yl=outlat0n+real(jy)*dyoutn
        xl=(xl-xlon0)/dx
        yl=(yl-ylat0)/dy
        iix=max(min(nint(xl),nxmin1),0)
        jjy=max(min(nint(yl),nymin1),0)
        densityoutgrid(ix,jy,kz)=(rho(iix,jjy,kzz,2)*dz1+ &
             rho(iix,jjy,kzz-1,2)*dz2)/dz
      end do
    end do
  end do

    do i=1,numreceptor
      xl=xreceptor(i)
      yl=yreceptor(i)
      iix=max(min(nint(xl),nxmin1),0)
      jjy=max(min(nint(yl),nymin1),0)
      densityoutrecept(i)=rho(iix,jjy,1,2)
    end do


  ! Output is different for forward and backward simulations
    do kz=1,numzgrid
      do jy=0,numygridn-1
        do ix=0,numxgridn-1
          if (ldirect.eq.1) then
            factor3d(ix,jy,kz)=1.e12/volumen(ix,jy,kz)/outnum
          else
            factor3d(ix,jy,kz)=real(abs(loutaver))/outnum
          endif
        end do
      end do
    end do

  !*********************************************************************
  ! Determine the standard deviation of the mean concentration or mixing
  ! ratio (uncertainty of the output) and the dry and wet deposition
  !*********************************************************************

  do ks=1,nspec

  write(anspec,'(i3.3)') ks
  if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then
    if (ldirect.eq.1) then
      open(unitoutgrid,file=path(2)(1:length(2))//'grid_conc_nest_' &
           //adate// &
           atime//'_'//anspec,form='unformatted')
    else
      open(unitoutgrid,file=path(2)(1:length(2))//'grid_time_nest_' &
           //adate// &
           atime//'_'//anspec,form='unformatted')
    endif
     write(unitoutgrid) itime
   endif

  if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio
   open(unitoutgridppt,file=path(2)(1:length(2))//'grid_pptv_nest_' &
        //adate// &
        atime//'_'//anspec,form='unformatted')

    write(unitoutgridppt) itime
  endif

  do kp=1,maxpointspec_act
  do nage=1,nageclass

    do jy=0,numygridn-1
      do ix=0,numxgridn-1

  ! WET DEPOSITION
        if ((WETDEP).and.(ldirect.gt.0)) then
            do l=1,nclassunc
              auxgrid(l)=wetgriduncn(ix,jy,ks,kp,l,nage)
            end do
            call mean(auxgrid,wetgrid(ix,jy), &
                 wetgridsigma(ix,jy),nclassunc)
  ! Multiply by number of classes to get total concentration
            wetgrid(ix,jy)=wetgrid(ix,jy) &
                 *nclassunc
  ! Calculate standard deviation of the mean
            wetgridsigma(ix,jy)= &
                 wetgridsigma(ix,jy)* &
                 sqrt(real(nclassunc))
        endif

  ! DRY DEPOSITION
        if ((DRYDEP).and.(ldirect.gt.0)) then
            do l=1,nclassunc
              auxgrid(l)=drygriduncn(ix,jy,ks,kp,l,nage)
            end do
            call mean(auxgrid,drygrid(ix,jy), &
                 drygridsigma(ix,jy),nclassunc)
  ! Multiply by number of classes to get total concentration
            drygrid(ix,jy)=drygrid(ix,jy)* &
                 nclassunc
  ! Calculate standard deviation of the mean
            drygridsigma(ix,jy)= &
                 drygridsigma(ix,jy)* &
                 sqrt(real(nclassunc))
        endif

  ! CONCENTRATION OR MIXING RATIO
        do kz=1,numzgrid
            do l=1,nclassunc
              auxgrid(l)=griduncn(ix,jy,kz,ks,kp,l,nage)
            end do
            call mean(auxgrid,grid(ix,jy,kz), &
                 gridsigma(ix,jy,kz),nclassunc)
  ! Multiply by number of classes to get total concentration
            grid(ix,jy,kz)= &
                 grid(ix,jy,kz)*nclassunc
  ! Calculate standard deviation of the mean
            gridsigma(ix,jy,kz)= &
                 gridsigma(ix,jy,kz)* &
                 sqrt(real(nclassunc))
        end do
      end do
    end do


  !*******************************************************************
  ! Generate output: may be in concentration (ng/m3) or in mixing
  ! ratio (ppt) or both
  ! Output the position and the values alternated multiplied by
  ! 1 or -1, first line is number of values, number of positions
  ! For backward simulations, the unit is seconds, stored in grid_time
  !*******************************************************************

  ! Concentration output
  !*********************
  if ((iout.eq.1).or.(iout.eq.3).or.(iout.eq.5)) then

  ! Wet deposition
         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
         if ((ldirect.eq.1).and.(WETDEP)) then
         do jy=0,numygridn-1
            do ix=0,numxgridn-1
  !oncentraion greater zero
              if (wetgrid(ix,jy).gt.smallnum) then
                 if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)=ix+jy*numxgridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact*1.e12*wetgrid(ix,jy)/arean(ix,jy)
  !                sparse_dump_u(sp_count_r)=
  !+                1.e12*wetgridsigma(ix,jy,ks,kp,nage)/area(ix,jy)
              else ! concentration is zero
                  sp_zer=.true.
              endif
            end do
         end do
         else
            sp_count_i=0
            sp_count_r=0
         endif
         write(unitoutgrid) sp_count_i
         write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
         write(unitoutgrid) sp_count_r
         write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)
  !       write(unitoutgrid) sp_count_u
  !       write(unitoutgrid) (sparse_dump_u(i),i=1,sp_count_r)

  ! Dry deposition
         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
         if ((ldirect.eq.1).and.(DRYDEP)) then
          do jy=0,numygridn-1
            do ix=0,numxgridn-1
              if (drygrid(ix,jy).gt.smallnum) then
                 if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)=ix+jy*numxgridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*drygrid(ix,jy)/arean(ix,jy)
  !                sparse_dump_u(sp_count_r)=
  !+                1.e12*drygridsigma(ix,jy,ks,kp,nage)/area(ix,jy)
              else ! concentration is zero
                  sp_zer=.true.
              endif
            end do
          end do
         else
            sp_count_i=0
            sp_count_r=0
         endif
         write(unitoutgrid) sp_count_i
         write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
         write(unitoutgrid) sp_count_r
         write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)
  !       write(*,*) sp_count_u
  !       write(unitoutgrid) (sparse_dump_u(i),i=1,sp_count_r)



  ! Concentrations
         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
          do kz=1,numzgrid
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn+kz*numxgridn*numygridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                   endif
                   sp_count_r=sp_count_r+1
                   sparse_dump_r(sp_count_r)= &
                        sp_fact* &
                        grid(ix,jy,kz)* &
                        factor3d(ix,jy,kz)/tot_mu(ks,kp)
  !                 if ((factor(ix,jy,kz)/tot_mu(ks,kp)).eq.0)
  !    +              write (*,*) factor(ix,jy,kz),tot_mu(ks,kp),ks,kp
  !                sparse_dump_u(sp_count_r)=
  !+               ,gridsigma(ix,jy,kz,ks,kp,nage)*
  !+               factor(ix,jy,kz)/tot_mu(ks,kp)
              else ! concentration is zero
                  sp_zer=.true.
              endif
              end do
            end do
          end do
         write(unitoutgrid) sp_count_i
         write(unitoutgrid) (sparse_dump_i(i),i=1,sp_count_i)
         write(unitoutgrid) sp_count_r
         write(unitoutgrid) (sparse_dump_r(i),i=1,sp_count_r)
  !       write(unitoutgrid) sp_count_u
  !       write(unitoutgrid) (sparse_dump_u(i),i=1,sp_count_r)



    endif !  concentration output

  ! Mixing ratio output
  !********************

  if ((iout.eq.2).or.(iout.eq.3)) then      ! mixing ratio

  ! Wet deposition
         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
         if ((ldirect.eq.1).and.(WETDEP)) then
          do jy=0,numygridn-1
            do ix=0,numxgridn-1
                if (wetgrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*wetgrid(ix,jy)/arean(ix,jy)
  !                sparse_dump_u(sp_count_r)=
  !    +            ,1.e12*wetgridsigma(ix,jy,ks,kp,nage)/area(ix,jy)
              else ! concentration is zero
                  sp_zer=.true.
              endif
            end do
          end do
         else
           sp_count_i=0
           sp_count_r=0
         endif
         write(unitoutgridppt) sp_count_i
         write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
         write(unitoutgridppt) sp_count_r
         write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)
  !       write(unitoutgridppt) sp_count_u
  !       write(unitoutgridppt) (sparse_dump_u(i),i=1,sp_count_r)


  ! Dry deposition
         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
         if ((ldirect.eq.1).and.(DRYDEP)) then
          do jy=0,numygridn-1
            do ix=0,numxgridn-1
                if (drygrid(ix,jy).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*drygrid(ix,jy)/arean(ix,jy)
  !                sparse_dump_u(sp_count_r)=
  !    +            ,1.e12*drygridsigma(ix,jy,ks,kp,nage)/area(ix,jy)
              else ! concentration is zero
                  sp_zer=.true.
              endif
            end do
          end do
         else
           sp_count_i=0
           sp_count_r=0
         endif
         write(unitoutgridppt) sp_count_i
         write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
         write(unitoutgridppt) sp_count_r
         write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)
  !       write(unitoutgridppt) sp_count_u
  !       write(unitoutgridppt) (sparse_dump_u(i),i=1,sp_count_r)


  ! Mixing ratios
         sp_count_i=0
         sp_count_r=0
         sp_fact=-1.
         sp_zer=.true.
          do kz=1,numzgrid
            do jy=0,numygridn-1
              do ix=0,numxgridn-1
                if (grid(ix,jy,kz).gt.smallnum) then
                  if (sp_zer.eqv..true.) then ! first non zero value
                    sp_count_i=sp_count_i+1
                    sparse_dump_i(sp_count_i)= &
                         ix+jy*numxgridn+kz*numxgridn*numygridn
                    sp_zer=.false.
                    sp_fact=sp_fact*(-1.)
                 endif
                 sp_count_r=sp_count_r+1
                 sparse_dump_r(sp_count_r)= &
                      sp_fact* &
                      1.e12*grid(ix,jy,kz) &
                      /volumen(ix,jy,kz)/outnum* &
                      weightair/weightmolar(ks)/densityoutgrid(ix,jy,kz)
  !                sparse_dump_u(sp_count_r)=
  !+              ,1.e12*gridsigma(ix,jy,kz,ks,kp,nage)/volume(ix,jy,kz)/
  !+              outnum*weightair/weightmolar(ks)/
  !+              densityoutgrid(ix,jy,kz)
              else ! concentration is zero
                  sp_zer=.true.
              endif
              end do
            end do
          end do
         write(unitoutgridppt) sp_count_i
         write(unitoutgridppt) (sparse_dump_i(i),i=1,sp_count_i)
         write(unitoutgridppt) sp_count_r
         write(unitoutgridppt) (sparse_dump_r(i),i=1,sp_count_r)
  !       write(unitoutgridppt) sp_count_u
  !       write(unitoutgridppt) (sparse_dump_u(i),i=1,sp_count_r)

      endif ! output for ppt

  end do
  end do

    close(unitoutgridppt)
    close(unitoutgrid)

  end do



  ! Reinitialization of grid
  !*************************

  do ks=1,nspec
  do kp=1,maxpointspec_act
    do i=1,numreceptor
      creceptor(i,ks)=0.
    end do
    do jy=0,numygridn-1
      do ix=0,numxgridn-1
        do l=1,nclassunc
          do nage=1,nageclass
            do kz=1,numzgrid
              griduncn(ix,jy,kz,ks,kp,l,nage)=0.
            end do
          end do
        end do
      end do
    end do
  end do
  end do


end subroutine concoutput_nest

    program flexpartread

    parameter(nxmax=720,nymax=360,nzmax=40,maxtime=10)
    parameter(maxpoint=1,maxspec=1,maxageclass=1)

    double precision :: jul,julstart,juldate
    real :: outheight(nzmax)
    integer :: ireleasestart(maxpoint),ireleaseend(maxpoint)
    integer :: lage(0:maxageclass)
    real :: xpoint(maxpoint),ypoint(maxpoint),zpoint1(maxpoint)
    real :: zpoint2(maxpoint)
    integer :: ireldate(maxspec),ireltime(maxspec)

    real :: grid(0:nxmax-1,0:nymax-1,nzmax,maxspec,maxageclass)
    real :: footprint(0:nxmax-1,0:nymax-1)
    real :: footprint_total(0:nxmax-1,0:nymax-1,maxspec)
    real :: area(0:nxmax-1,0:nymax-1)
    real :: heightnn(0:nxmax-1,0:nymax-1,0:nzmax)
    real :: smallnum,r_sparse_dump(5000000)
    integer :: i_sparse_dump(5000000)
    parameter(smallnum=1.e-38)

    character dirname*120
    logical ::  dirnameisarg
    character filename*150,fileout*150,aday*8,atime*6
    character(250) :: filegrid
          
    logical :: sp_zer
    logical :: debug=.FALSE.
    
    real :: sizegrid_m
    real :: sum_grid, sum_sum_grid
    real :: max_grid, max_max_grid
    !character(4) :: grid_magnitude
    character(6) :: grid_magnitude

        max_max_grid=0
        max_grid=0
        sum_grid=0
        sum_sum_grid=0
        sizegrid_m=0


    grid_magnitude='time'
    grid_magnitude='conc'
    grid_magnitude='pptv'

    dirnameisarg= .FALSE. 

    if (debug) then
      print*, 'iargc', iargc()
    endif

    select case (iargc())
    case (3)
    debug=.TRUE.
    dirnameisarg= .TRUE. 
    call getarg(1,dirname)
    len=index(dirname,' ')-1
    call getarg(2,grid_magnitude)

    case (2)
    dirnameisarg= .TRUE. 
    call getarg(1,dirname)
    len=index(dirname,' ')-1
    call getarg(2,grid_magnitude)
    case (1)
    call getarg(1,grid_magnitude)
    case (0)
    grid_magnitude='time'
    end select
    if (debug) then
    print*, grid_magnitude
    endif
    
    if ( .NOT. dirnameisarg) then
    !******************
        print*, " Read CONTROL file "
    !******************
        open(15,file='dirlist')
        200 read(15,'(a)',end=199) dirname
        len=index(dirname,' ')-1
    endif

!      do 50 mother_or_nest=1,2
    do 50 mother_or_nest=1,1

    !*********************************
    ! Read FLEXPART header information
    !*********************************

        if (mother_or_nest == 1) then
            filename=dirname(1:len)//'header'
        else if (mother_or_nest == 2) then
            filename=dirname(1:len)//'header_nest'
        endif
        call readheader(filename,nxmax,numxgrid,nymax,numygrid,nzmax, &
        numzgrid,outlon0,outlat0,dxout,dyout,outheight,ibdate,ibtime, &
        loutstep,maxspec,nspec,maxageclass,nageclass,lage,ireleasestart, &
        ireleaseend,maxpoint,numpoint,xpoint,ypoint,zpoint1,zpoint2, &
        heightnn,area)

        if (debug) then
          !write(*,*) 'nspec',nspec
          write(*,*) 'simulation starts ', ibdate,ibtime
          write(*,*) 'releases:'
        endif

        julstart=juldate(ibdate,ibtime)
        do 30 k=1,nspec
            jul=julstart+dble(float(ireleaseend(k))/86400.)
            call caldate(jul,ireldate(k),ireltime(k))
!            print*,'ireldate',ireldate(k)
!             print*,'ireltime',ireltime(k)
             if (debug) then 
             print*, k, 'ireldate, ireltime',ireldate(k), ireltime(k)
             endif
             call caldate(julstart+dble(float(ireleasestart(k))/86400.) &
             ,irelds,irelts)
             if (debug) then
             print*, k,irelds,irelts 
             print*, k,xpoint(k),ypoint(k),zpoint1(k),zpoint2(k) 
             !print*, k,irelds,irelts 
             endif 

        30 END DO
        

    ! rint*, 'init sizegrid_m=', sizegrid_m !=0

        do 70 k=1,nspec
            do 70 ix=0,numxgrid-1
                do 70 jy=0,numygrid-1
                    footprint_total(ix,jy,k)=0.
        70 END DO

    !******************************************
    ! Loop about all times, given in file dates
    !******************************************
        if (debug) then
          print*,'> open dates'
        endif

        open(20,file=dirname(1:len)//'dates',form='formatted', &
        status='old')
        it=0
        100 read(20,'(i8,i6)',end=99) inday,intime
        write(aday,'(i8.8)') inday
        write(atime,'(i6.6)') intime
        it=it+1

        if (debug) then
!         print*, 'it, aday, atime', it, aday, atime
         print*, 'i, day, time', it, inday, intime
         endif
                 
        if (mother_or_nest == 1) then
                        
        ! ilegrid=dirname(1:len)//'/grid_time_'//aday//atime//'_001'
            filegrid=dirname(1:len)//'/grid_conc_'//aday//atime//'_001'
        ! ilegrid=dirname(1:len)//'/grid_pptv_'//aday//atime//'_001'
                        
    !        filegrid=dirname(1:len)//'/grid_'//grid_magnitude//'_' &
            filegrid=dirname(1:len)//'/grid_'//trim(grid_magnitude)//'_' &
            //aday//atime//'_001'
            fileout=dirname(1:len)//'footprint_'//aday//atime//'_001'
        else
            filegrid=dirname(1:len)//'grid_time_nest_'//aday//atime//'_001'
            fileout=dirname(1:len)//'footprint_nest_'//aday//atime//'_001'
        endif

    !    print*, 'filegrid=', filegrid

        call readgrid(filegrid,itime,nxmax,numxgrid,nymax,numygrid, &
        nzmax,numzgrid,maxspec,nspec,maxageclass,nageclass,grid, &
        lage)

        !print*, 'read grid:'
        !print*, 'maxval(grid)=', maxval(grid)
        !print*, 'sum(grid)=', sum(grid)
        !print*, 'max, sum                 ', maxval(grid), sum(grid)

    !***************************************
    ! Display read values
    !***************************************
    ! izegrid_m=sizegrid_m+sum(grid)


        sum_grid=sum(grid)
        max_grid=maxval(grid)

        if (debug) then
          print*, 'max, sum                 ', max_grid, sum_grid
        endif

        max_max_grid=max(max_max_grid,max_grid)
        sum_sum_grid=sum_sum_grid+sum_grid
!        print*, 'max_max_grid,max_grid', max_max_grid, max_grid
        if (debug) then
          print*, 'max_max_grid,sum_sum_grid', max_max_grid, sum_sum_grid
          !print*,
        endif 
!        print*, 'sum_grid=',sum_grid !sum(grid)
!        print*, 'max_grid=', max_grid !  maxval(grid)
!        print*, 'part total', it, aday, atime
!        print*, 'sum_sum_grid=', sum_sum_grid
!        print*, 'max_max_grid=', max_max_grid

        if (0 == 1) then
        !****************************************
        ! Write out footprint files for each date
        !****************************************
                   
            open(97,file=fileout,form='unformatted')
            write(97) itime

        ! Add contributions from this time step to gridded field
        !*******************************************************

            do 80 k=1,nspec
                do 202 ix=0,numxgrid-1
                    do 202 jy=0,numygrid-1
                        footprint(ix,jy)=0.
                        do 202 nage=1,nageclass
                            footprint(ix,jy)=footprint(ix,jy)+ &
                            grid(ix,jy,1,k,nage)
                            footprint_total(ix,jy,k)=footprint_total(ix,jy,k)+ &
                            grid(ix,jy,1,k,nage)
                202 END DO


                n_sp_count_i=0
                n_sp_count_r=0
                sp_fact=-1.
                sp_zer= .TRUE. 
                do 135 jy=0,numygrid-1
                    do 135 ix=0,numxgrid-1
                        if (footprint(ix,jy) > smallnum) then
                            if (sp_zer) then ! first non zero value
                                n_sp_count_i=n_sp_count_i+1
                                i_sparse_dump(n_sp_count_i)= &
                                ix+jy*numxgrid+1*numxgrid*numygrid   ! vertical level is 1
                                sp_zer= .FALSE. 
                                sp_fact=sp_fact*(-1)
                            endif
                            n_sp_count_r=n_sp_count_r+1
                            r_sparse_dump(n_sp_count_r)=sp_fact*footprint(ix,jy)
                        else ! concentration is zero
                            sp_zer= .TRUE. 
                        endif
                135 END DO

            ! First, zero wet and dry depo
                write(97) 0
                write(97)
                write(97) 0
                write(97)
                write(97) 0
                write(97)
                write(97) 0
                write(97)

                write(97) n_sp_count_i
                write(97) (i_sparse_dump(i),i=1,n_sp_count_i)
                write(97) n_sp_count_r
                write(97) (r_sparse_dump(i),i=1,n_sp_count_r)

            80 END DO
            close(97)
        endif ! Write out footprint files for each date

        goto 100 !read dates
        99 close(20)


        if  (0 == 1) then
        ! relic
    ! Dump time-integrated footprint
    !*******************************
            if (mother_or_nest == 1) then
                fileout=dirname(1:len)//'footprint_total'//'_001'
            else
                fileout=dirname(1:len)//'footprint_total_nest'//'_001'
            endif

            open(97,file=fileout,form='unformatted')
            write(97) itime

            do 180 k=1,nspec
                n_sp_count_i=0
                n_sp_count_r=0
                sp_fact=-1.
                sp_zer= .TRUE. 
                do 145 jy=0,numygrid-1
                    do 145 ix=0,numxgrid-1
                        if (footprint_total(ix,jy,k) > smallnum) then
                            if (sp_zer) then ! first non zero value
                                n_sp_count_i=n_sp_count_i+1
                                i_sparse_dump(n_sp_count_i)= &
                                ix+jy*numxgrid+1*numxgrid*numygrid   ! vertical level is 1
                                sp_zer= .FALSE. 
                                sp_fact=sp_fact*(-1)
                            endif
                            n_sp_count_r=n_sp_count_r+1
                            r_sparse_dump(n_sp_count_r)= &
                            sp_fact*footprint_total(ix,jy,k)
                        else ! concentration is zero
                            sp_zer= .TRUE. 
                        endif
                145 END DO

            ! First, zero wet and dry depo
                write(97) 0
                write(97)
                write(97) 0
                write(97)
                write(97) 0
                write(97)
                write(97) 0
                write(97)

                write(97) n_sp_count_i
                write(97) (i_sparse_dump(i),i=1,n_sp_count_i)
                write(97) n_sp_count_r
                write(97) (r_sparse_dump(i),i=1,n_sp_count_r)

            180 END DO
            close(97)
        endif ! write footprint total

    50 END DO

    if ( .NOT. dirnameisarg) then
        goto 200 !read(15, dirlist
        199 close(15) !dirlist
    endif

! ax_max_grid=max(max_max_grid,max_grid)
! um_sum_grid=sum_sum_grid+sum_grid
    if (debug) then

    print*, 'for all times'
    print*, 'sum sum(grid)=', sum_sum_grid
    print*, 'max maxval(grid)=', max_max_grid
    endif 
    !if (debug) then

    !print*, 'max:', max_max_grid, 'sum:', sum_sum_grid 
    print*, 'max:', max_max_grid, 'mean:', sum_sum_grid/numxgrid/numygrid/numzgrid
    !print*, numxgrid*numygrid*numzgrid
    !print*, nxmax,numxgrid,nymax,numygrid,nzmax, numzgrid 

!    print*, 'sum_sum_grid_out=',sum_sum_grid
!    print*, 'max_max_grid_out=',max_max_grid
    END PROGRAM

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine initialize(itime,ldt,up,vp,wp, &
       usigold,vsigold,wsigold,xt,yt,zt,icbt)
  !                        i    i   o  o  o
  !        o       o       o    i  i  i   o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of trajectories utilizing a zero-acceleration scheme. The time*
  !  step is determined by the Courant-Friedrichs-Lewy (CFL) criterion. This   *
  !  means that the time step must be so small that the displacement within    *
  !  this time step is smaller than 1 grid distance. Additionally, a temporal  *
  !  CFL criterion is introduced: the time step must be smaller than the time  *
  !  interval of the wind fields used for interpolation.                       *
  !  For random walk simulations, these are the only time step criteria.       *
  !  For the other options, the time step is also limited by the Lagrangian    *
  !  time scale.                                                               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     16 December 1997                                                       *
  !                                                                            *
  !  Literature:                                                               *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! h [m]              Mixing height                                           *
  ! lwindinterv [s]    time interval between two wind fields                   *
  ! itime [s]          current temporal position                               *
  ! ldt [s]            Suggested time step for next integration                *
  ! ladvance [s]       Total integration time period                           *
  ! rannumb(maxrand)   normally distributed random variables                   *
  ! up,vp,wp           random velocities due to turbulence                     *
  ! usig,vsig,wsig     uncertainties of wind velocities due to interpolation   *
  ! usigold,vsigold,wsigold  like usig, etc., but for the last time step       *
  ! xt,yt,zt           Next time step's spatial position of trajectory         *
  !                                                                            *
  !                                                                            *
  ! Constants:                                                                 *
  ! cfl                factor, by which the time step has to be smaller than   *
  !                    the spatial CFL-criterion                               *
  ! cflt               factor, by which the time step has to be smaller than   *
  !                    the temporal CFL-criterion                              *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use interpol_mod
  use hanna_mod

  implicit none

  integer :: itime
  integer :: ldt,nrand
  integer(kind=2) :: icbt
  real :: zt,dz,dz1,dz2,up,vp,wp,usigold,vsigold,wsigold,ran3
  real(kind=dp) :: xt,yt
  save idummy

  integer :: idummy = -7

  icbt=1           ! initialize particle to "no reflection"

  nrand=int(ran3(idummy)*real(maxrand-1))+1


  !******************************
  ! 2. Interpolate necessary data
  !******************************

  ! Compute maximum mixing height around particle position
  !*******************************************************

  ix=int(xt)
  jy=int(yt)
  ixp=ix+1
  jyp=jy+1

  h=max(hmix(ix ,jy ,1,memind(1)), &
       hmix(ixp,jy ,1,memind(1)), &
       hmix(ix ,jyp,1,memind(1)), &
       hmix(ixp,jyp,1,memind(1)), &
       hmix(ix ,jy ,1,memind(2)), &
       hmix(ixp,jy ,1,memind(2)), &
       hmix(ix ,jyp,1,memind(2)), &
       hmix(ixp,jyp,1,memind(2)))

  zeta=zt/h


  !*************************************************************
  ! If particle is in the PBL, interpolate once and then make a
  ! time loop until end of interval is reached
  !*************************************************************

  if (zeta.le.1.) then

    call interpol_all(itime,real(xt),real(yt),zt)


  ! Vertical interpolation of u,v,w,rho and drhodz
  !***********************************************

  ! Vertical distance to the level below and above current position
  ! both in terms of (u,v) and (w) fields
  !****************************************************************

    dz1=zt-height(indz)
    dz2=height(indzp)-zt
    dz=1./(dz1+dz2)

    u=(dz1*uprof(indzp)+dz2*uprof(indz))*dz
    v=(dz1*vprof(indzp)+dz2*vprof(indz))*dz
    w=(dz1*wprof(indzp)+dz2*wprof(indz))*dz


  ! Compute the turbulent disturbances

  ! Determine the sigmas and the timescales
  !****************************************

    if (turbswitch) then
      call hanna(zt)
    else
      call hanna1(zt)
    endif


  ! Determine the new diffusivity velocities
  !*****************************************

    if (nrand+2.gt.maxrand) nrand=1
    up=rannumb(nrand)*sigu
    vp=rannumb(nrand+1)*sigv
    wp=rannumb(nrand+2)
    if (.not.turbswitch) wp=wp*sigw


  ! Determine time step for next integration
  !*****************************************

    if (turbswitch) then
      ldt=int(min(tlw,h/max(2.*abs(wp*sigw),1.e-5), &
           0.5/abs(dsigwdz),600.)*ctl)
    else
      ldt=int(min(tlw,h/max(2.*abs(wp),1.e-5),600.)*ctl)
    endif
    ldt=max(ldt,mintime)


    usig=(usigprof(indzp)+usigprof(indz))/2.
    vsig=(vsigprof(indzp)+vsigprof(indz))/2.
    wsig=(wsigprof(indzp)+wsigprof(indz))/2.

  else



  !**********************************************************
  ! For all particles that are outside the PBL, make a single
  ! time step. Only horizontal turbulent disturbances are
  ! calculated. Vertical disturbances are reset.
  !**********************************************************


  ! Interpolate the wind
  !*********************

    call interpol_wind(itime,real(xt),real(yt),zt)


  ! Compute everything for above the PBL

  ! Assume constant turbulent perturbations
  !****************************************

    ldt=abs(lsynctime)

    if (nrand+1.gt.maxrand) nrand=1
    up=rannumb(nrand)*0.3
    vp=rannumb(nrand+1)*0.3
    nrand=nrand+2
    wp=0.
    sigw=0.

  endif

  !****************************************************************
  ! Add mesoscale random disturbances
  ! This is done only once for the whole lsynctime interval to save
  ! computation time
  !****************************************************************


  ! It is assumed that the average interpolation error is 1/2 sigma
  ! of the surrounding points, autocorrelation time constant is
  ! 1/2 of time interval between wind fields
  !****************************************************************

  if (nrand+2.gt.maxrand) nrand=1
  usigold=rannumb(nrand)*usig
  vsigold=rannumb(nrand+1)*vsig
  wsigold=rannumb(nrand+2)*wsig

end subroutine initialize

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

  !*****************************************************************************
  !                                                                            *
  !   L. Bakels 2021: This module contains subroutines related to the          *
  !                   initialisation of the particles                          *
  !                                                                            *
  !*****************************************************************************

module initialise_mod

  use com_mod
  use par_mod
  use date_mod
  use particle_mod
  use windfields_mod
  use random_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif
#ifdef USE_NCF
  use netcdf_output_mod
#endif

  implicit none

  !**********************************************************
  ! Variables used for domain-filling trajectory calculations
  !**********************************************************

  integer ::    &
    nx_we(2),   & ! x indices of western and eastern boundary of domain-filling.
    ny_sn(2),   & ! y indices of southern and northern boundary of domain-filling.
    numcolumn     ! Maximum number of particles to be released within a single column.
  integer,allocatable,dimension(:,:) :: &
    numcolumn_we,   & ! Number of particles to be released within one column
                      ! at the western and eastern boundary surfaces.
    numcolumn_sn      ! Same as numcolumn_we, but for southern and northern domain boundary.
  real,allocatable,dimension(:,:,:) ::  &
    zcolumn_we,     & ! Altitudes where particles are to be released
                      ! at the western and eastern boundary surfaces.
    zcolumn_sn,     & ! Same as zcolumn_we, but for southern and northern domain boundary.
    acc_mass_we,    & ! Mass that has accumulated at the western and eastern boundary;
                      ! if it exceeds xmassperparticle, a particle is released and
                      ! acc_mass_we is reduced accordingly.
    acc_mass_sn       ! Same as acc_mass_we, but for southern and northern domain boundary
  real ::           &
    xmassperparticle  ! Air mass per particle in the domain-filling traj. option.

contains

subroutine alloc_domainfill
  implicit none
  allocate(numcolumn_we(2,0:nymax-1),numcolumn_sn(2,0:nxmax-1))
  allocate(zcolumn_we(2,0:nymax-1,maxcolumn),zcolumn_sn(2,0:nxmax-1,maxcolumn), &
    acc_mass_we(2,0:nymax-1,maxcolumn),acc_mass_sn(2,0:nxmax-1,maxcolumn))              
end subroutine alloc_domainfill

subroutine dealloc_domainfill
  if (mdomainfill.lt.1) return
  deallocate(numcolumn_we,numcolumn_sn,zcolumn_sn,zcolumn_we,acc_mass_sn, &
    acc_mass_we)
end subroutine dealloc_domainfill

subroutine releaseparticles(itime)
  !                              o
  !*****************************************************************************
  !                                                                            *
  !     This subroutine releases particles from the release locations.         *
  !                                                                            *
  !     It searches for a "vacant" storage space and assigns all particle      *
  !     information to that space. A space is vacant either when no particle   *
  !     is yet assigned to it, or when it's particle is expired and, thus,     *
  !     the storage space is made available to a new particle.                 *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     29 June 2002                                                           *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]            current time                                          *
  ! ireleasestart, ireleaseend          start and end times of all releases    *
  ! npart(maxpoint)      number of particles to be released in total           *
  ! numrel               number of particles to be released during this time   *
  !                      step                                                  *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use xmass_mod
  use output_mod
  use interpol_mod

  implicit none

  !real xaux,yaux,zaux,ran1,rfraction,xmasssave(maxpoint)
  real :: xaux,yaux,zaux,rfraction
  real :: xlonav,timecorrect(maxspec)
  real :: average_timecorrect
  integer :: itime,numrel,i,j,k,ipart,minpart
  integer :: istart,iend,totpart,iterm_index
  integer :: nweeks,ndayofweek,nhour,jjjjmmdd,ihmmss,mm
  real(kind=dp) :: julmonday,jul,jullocal,juldiff

  integer :: idummy = -7
  !save idummy,xmasssave
  !data idummy/-7/,xmasssave/maxpoint*0./

  real :: eps
  eps=nxmax/3.e5


  ! Determine the actual date and time in Greenwich 
  ! (i.e., UTC + correction for daylight savings time)
  !***************************************************

  julmonday=juldate(19000101,0)          ! this is a Monday
  jul=bdate+real(itime,kind=dp)/86400._dp    ! this is the current day
  call caldate(jul,jjjjmmdd,ihmmss)
  mm=(jjjjmmdd-10000*(jjjjmmdd/10000))/100
  if ((mm.ge.4).and.(mm.le.9)) jul=jul+1._dp/24._dp   ! daylight savings time


  ! For every release point, check whether we are in the release time interval
  !***************************************************************************
  ! First allocate all particles that are going to be in the simulation
  ! If ipin==0,1, and ipout==0, then dead particles can be overwritten to save memory
  if (ipin.gt.1 .or. ipout.ne.0 .or. ispeed.eq.1) then
    if (itime.eq.0) then
      totpart=0
      do i=1,numpoint
        totpart = totpart+npart(i)
      end do
      call alloc_particles(totpart)
    else if (itime.eq.itime_init) then !From restart point only allocate particles that are yet to be born
      totpart=0
      do i=1,numpoint
        totpart = totpart+npart(i)
      end do
      if (totpart.gt.count%allocated) call alloc_particles(totpart-count%allocated)
    end if 
  endif

  call get_totalpart_num(istart)
  if (ipin.le.1 .and. ipout.eq.0 .and. ispeed.eq.0) call rewrite_iterm()
  minpart=1
  do i=1,numpoint
    if ((itime.ge.ireleasestart(i)).and. &! are we within release interval?
         (itime.le.ireleaseend(i))) then

  ! Determine the local day and time
  !*********************************

      xlonav=xlon0+(xpoint2(i)+xpoint1(i))*0.5*dx  ! longitude needed to determine local time
      if (xlonav.lt.-180.) xlonav=xlonav+360.
      if (xlonav.gt.180.) xlonav=xlonav-360.
      jullocal=jul+real(xlonav,kind=dp)/360._dp   ! correct approximately for time zone to obtain local time

      juldiff=jullocal-julmonday
      nweeks=int(juldiff/7._dp)
      juldiff=juldiff-real(nweeks,kind=dp)*7._dp
      ndayofweek=int(juldiff)+1              ! this is the current day of week, starting with Monday
      nhour=nint((juldiff-real(ndayofweek-1,kind=dp))*24._dp)    ! this is the current hour
      if (nhour.eq.0) then
        nhour=24
        ndayofweek=ndayofweek-1
        if (ndayofweek.eq.0) ndayofweek=7
      endif

  ! Calculate a species- and time-dependent correction factor, distinguishing between
  ! area (those with release starting at surface) and point (release starting above surface) sources
  ! Also, calculate an average time correction factor (species independent)
  !*****************************************************************************
      average_timecorrect=0.
      do k=1,nspec
        if(abs(xpoint2(i)-xpoint1(i)).lt.1.E-4.and.abs(ypoint2(i)-ypoint1(i)).lt.1.E-4) then
  !        if (zpoint1(i).gt.0.5) then      ! point source
          timecorrect(k)=point_hour(k,nhour)*point_dow(k,ndayofweek)
        else                             ! area source
          timecorrect(k)=area_hour(k,nhour)*area_dow(k,ndayofweek)
        endif
        average_timecorrect=average_timecorrect+timecorrect(k)
      end do
      average_timecorrect=average_timecorrect/real(nspec)

  ! Determine number of particles to be released this time; at start and at end of release,
  ! only half the particles are released
  !*****************************************************************************

      if (ireleasestart(i).ne.ireleaseend(i)) then
        rfraction=abs(real(npart(i))*real(lsynctime)/ &
             real(ireleaseend(i)-ireleasestart(i)))
        if ((itime.eq.ireleasestart(i)).or. &
             (itime.eq.ireleaseend(i))) rfraction=rfraction*0.5

  ! Take the species-average time correction factor in order to scale the
  ! number of particles released this time
  !**********************************************************************
        rfraction=rfraction*average_timecorrect

        rfraction=rfraction+xmasssave(i)  ! number to be released at this time
        numrel=int(rfraction)
        xmasssave(i)=rfraction-real(numrel)
      else
        numrel=npart(i)
      endif

      xaux=xpoint2(i)-xpoint1(i)
      yaux=ypoint2(i)-ypoint1(i)
      zaux=zpoint2(i)-zpoint1(i)

      if (ipin.le.1 .and. ipout.eq.0 .and. ispeed.eq.0 ) then
        call rewrite_iterm()
        totpart = numrel-count%iterm_max
        if (totpart.gt.0) call alloc_particles(totpart)
        call rewrite_iterm()
        iterm_index=1
      endif
      do j=1,numrel             ! loop over particles to be released this time
        call get_newpart_index(ipart,iterm_index)
        call spawn_particle(itime, ipart)

  ! Particle coordinates are determined by using a random position within the release volume
  !*****************************************************************************

  ! Determine horizontal particle position
  !***************************************
        call set_xlon(ipart,real(xpoint1(i)+ran1(idummy,0)*xaux,kind=dp))
        if (xglobal) then
          if (part(ipart)%xlon.gt.real(nxmin1,kind=dp)) &
            call set_xlon(ipart,-real(nxmin1,kind=dp))
          if (part(ipart)%xlon.lt.0.) &
            call set_xlon(ipart,real(nxmin1,kind=dp))
        endif
        call set_ylat(ipart,real(ypoint1(i)+ran1(idummy,0)*yaux,kind=dp))

  ! Assign mass to particle: Total mass divided by total number of particles.
  ! Time variation has partly been taken into account already by a species-average
  ! correction factor, by which the number of particles released this time has been
  ! scaled. Adjust the mass per particle by the species-dependent time correction factor
  ! divided by the species-average one
  ! for the scavenging calculation the mass needs to be multiplied with rho of the particle layer and
  ! divided by the sum of rho of all particles.
  !*****************************************************************************
        do k=1,nspec
          mass(ipart,k)=xmass(i,k)/real(npart(i)) &
                *timecorrect(k)/average_timecorrect
          mass_init(ipart,k)=mass(ipart,k)
        end do
  ! Assign certain properties to particle
  !**************************************
        part(ipart)%nclass=min(int(ran1(idummy,0)*real(nclassunc))+1, &
             nclassunc)
        numparticlecount=numparticlecount+1
        if (mquasilag.eq.0) then
          part(ipart)%npoint=i
        else
          part(ipart)%npoint=numparticlecount
        endif
        part(ipart)%idt=mintime               ! first time step

        ! Determine vertical particle position
        !*************************************
        call set_z(ipart,zpoint1(i)+ran1(idummy,0)*zaux)
        ! Interpolation of topography and density
        !****************************************

        ! Transform the verticle particle position from pressure or sea level to above ground
        ! if necessary
        !************************************************************************************
        call kindz_to_z(ipart)
#ifdef ETA
        call z_to_zeta(itime,part(ipart)%xlon,part(ipart)%ylat,part(ipart)%z,part(ipart)%zeta)
        part(ipart)%etaupdate = .true. ! The z(meter) coordinate is up to date
        part(ipart)%meterupdate = .true.
#endif
        
        call init_mass_conversion(ipart,i)

        call get_totalpart_num(numpart)

      end do  ! numrel 
    endif ! releasepoint
  end do ! numpoint

  if (ipin.le.1 .and. ipout.eq.0 .and. ispeed.eq.0 ) call rewrite_iterm()

  call get_totalpart_num(iend)

  ! NetCDF only: write initial positions of new particles
! #ifdef USE_NCF
!   if ((iend-istart.gt.0).and.(ipout.ge.1)) then 
!     call wrt_part_initialpos(itime,istart,iend)
!     call output_particles(itime,.true.)
!   endif
! #endif
  return

! 996   continue
!   write(*,*) '#####################################################'
!   write(*,*) '#### FLEXPART MODEL SUBROUTINE RELEASEPARTICLES: ####'
!   write(*,*) '####                                             ####'
!   write(*,*) '#### ERROR - TOTAL NUMBER OF PARTICLES REQUIRED  ####'
!   write(*,*) '#### EXCEEDS THE MAXIMUM ALLOWED NUMBER. REDUCE  ####'
!   write(*,*) '#### EITHER NUMBER OF PARTICLES PER RELEASE POINT####'
!   write(*,*) '#### OR REDUCE NUMBER OF RELEASE POINTS.         ####'
!   write(*,*) '#####################################################'
!   stop

end subroutine releaseparticles

subroutine kindz_to_z(ipart)
  use point_mod
  use xmass_mod
  use output_mod
  use interpol_mod

  implicit none

  integer,intent(in) :: ipart
  integer :: kz
  real :: dp1,dp2,press,presspart,pressold,topo,r,t
  real,parameter :: eps2=1.e-6


  ! Determine the nest we are in
  !*****************************
  call find_ngrid(part(ipart)%xlon,part(ipart)%ylat)

  ! Determine (nested) grid coordinates and auxiliary parameters used for interpolation
  !*****************************************************************************
  call find_grid_indices(real(part(ipart)%xlon),real(part(ipart)%ylat))
  call find_grid_distances(real(part(ipart)%xlon),real(part(ipart)%ylat))


  if (kindz(part(ipart)%npoint).eq.1) return ! Nothing needs to happen

  ! If starting height is in pressure coordinates, retrieve pressure profile and 
  ! convert zpart1 to meters
  !*****************************************************************************

  if (kindz(part(ipart)%npoint).eq.3) then
    presspart=real(part(ipart)%z)
    do kz=1,nz
      if (ngrid.gt.0) then
        r=p1*rhon(ix ,jy ,kz,2,ngrid) &
             +p2*rhon(ixp,jy ,kz,2,ngrid) &
             +p3*rhon(ix ,jyp,kz,2,ngrid) &
             +p4*rhon(ixp,jyp,kz,2,ngrid)
        t=p1*ttn(ix ,jy ,kz,2,ngrid) &
             +p2*ttn(ixp,jy ,kz,2,ngrid) &
             +p3*ttn(ix ,jyp,kz,2,ngrid) &
             +p4*ttn(ixp,jyp,kz,2,ngrid)
      else
        r=p1*rho(ix ,jy ,kz,2) &
             +p2*rho(ixp,jy ,kz,2) &
             +p3*rho(ix ,jyp,kz,2) &
             +p4*rho(ixp,jyp,kz,2)
        t=p1*tt(ix ,jy ,kz,2) &
             +p2*tt(ixp,jy ,kz,2) &
             +p3*tt(ix ,jyp,kz,2) &
             +p4*tt(ixp,jyp,kz,2)
      endif
      press=r*r_air*t/100.
      if (kz.eq.1) pressold=press

      if (press.lt.presspart) then
        if (kz.eq.1) then
          call set_z(ipart,height(1)*0.5)
        else
          dp1=pressold-presspart
          dp2=presspart-press
          call set_z(ipart,(height(kz-1)*dp2+height(kz)*dp1) &
               /(dp1+dp2))
        endif
        exit
      endif
      pressold=press
    end do

  ! If release positions are given in meters above sea level, subtract the
  ! topography from the starting height
  !***********************************************************************

  else if (kindz(part(ipart)%npoint).eq.2) then
    if (ngrid.gt.0) then
      topo=p1*oron(ix ,jy ,ngrid) &
           + p2*oron(ixp,jy ,ngrid) &
           + p3*oron(ix ,jyp,ngrid) &
           + p4*oron(ixp,jyp,ngrid)
    else
      topo=p1*oro(ix ,jy) &
           + p2*oro(ixp,jy) &
           + p3*oro(ix ,jyp) &
           + p4*oro(ixp,jyp)
    endif
    call update_z(ipart,-topo)
  endif
  if (part(ipart)%z.lt.eps2) call set_z(ipart,eps2)   ! Minimum starting height is eps2
  if (part(ipart)%z.gt.height(nz)-0.5) &
    call set_z(ipart,height(nz)-0.5) ! Maximum starting height is uppermost level - 0.5 meters

  if (ipin.eq.3 .or. ipin.eq.4) then
    if (part(ipart)%z.gt.zpoint2(part(ipart)%npoint)) &
      zpoint2(part(ipart)%npoint)=real(part(ipart)%z)
    if (part(ipart)%z.lt.zpoint1(part(ipart)%npoint)) &
      zpoint1(part(ipart)%npoint)=real(part(ipart)%z)
  endif    

end subroutine kindz_to_z

subroutine init_mass_conversion(ipart,ipoint)
  ! For special simulations, multiply particle concentration air density;
  ! Simply take the 2nd field in memory to do this (accurate enough)
  !***********************************************************************
  !AF IND_SOURCE switches between different units for concentrations at the source
  !Af    NOTE that in backward simulations the release of particles takes place at the
  !Af         receptor and the sampling at the source.
  !Af          1="mass"
  !Af          2="mass mixing ratio"
  !Af IND_RECEPTOR switches between different units for concentrations at the receptor
  !Af          1="mass"
  !Af          2="mass mixing ratio"
  !            3 = wet deposition in outputfield
  !            4 = dry deposition in outputfield

  !Af switches for the releasefile:
  !Af IND_REL =  1 : xmass * rho
  !Af IND_REL =  0 : xmass * 1

  !Af ind_rel is defined in readcommand.f
  use point_mod
  use xmass_mod
  use interpol_mod

  implicit none

  integer,intent(in) :: ipart,ipoint
  integer :: n
  real :: rhoaux(2),rhoout
  real :: dz1,dz2


  if ((ind_rel .eq. 1).or.(ind_rel .eq. 3).or.(ind_rel .eq. 4)) then

    ! Interpolate the air density, horizontal values are computed in kindz_to_z
    !**************************************************************************
    call find_z_level_meters(real(part(ipart)%z))
    call find_vert_vars_lin(height,real(part(ipart)%z),indz,dz1,dz2,lbounds)

    if (ngrid.gt.0) then
      do n=1,2
        rhoaux(n)=p1*rhon(ix ,jy ,indz+n-1,2,ngrid) &
             +p2*rhon(ixp,jy ,indz+n-1,2,ngrid) &
             +p3*rhon(ix ,jyp,indz+n-1,2,ngrid) &
             +p4*rhon(ixp,jyp,indz+n-1,2,ngrid)
      end do
    else
      do n=1,2
        rhoaux(n)=p1*rho(ix ,jy ,indz+n-1,2) &
             +p2*rho(ixp,jy ,indz+n-1,2) &
             +p3*rho(ix ,jyp,indz+n-1,2) &
             +p4*rho(ixp,jyp,indz+n-1,2)
      end do
    endif
    rhoout=dz2*rhoaux(1)+dz1*rhoaux(2)
    rho_rel(ipoint)=rhoout


    ! Multiply "mass" (i.e., mass mixing ratio in forward runs) with density
    !***********************************************************************
    mass(ipart,:)=mass(ipart,:)*rhoout
    mass_init(ipart,:)=mass(ipart,:)
  endif
end subroutine init_mass_conversion

subroutine readpartpositions

  !*****************************************************************************
  !                                                                            *
  !   This routine opens the particle dump file and reads all the particle     *
  !   positions from a previous run to initialize the current run.             *
  !                                                                            *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 March 2000                                                          *
  !                                                                            *
  !  Changes                                                                   *
  !     2022, L. Bakels: NetCDF option for reading particle information        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  !*****************************************************************************
  implicit none

  integer :: ibdatein,ibtimein,nspecin,itimein,numpointin,i,j,lix,ios
  integer :: id1,id2,it1,it2
  real :: xlonin,ylatin,topo,hmixi,pvi,qvi,rhoi,tri,tti
  character :: specin*7
  real(kind=dp) :: julin,julpartin

  integer :: idummy = -8

  numparticlecount=0

  ! Open header file of dumped particle data
  !*****************************************
#ifdef USE_NCF
    call readpartpositions_netcdf(ibtime,ibdate)
    call get_totalpart_num(numpart)
    numparticlecount=numpart
    return
#endif

  open(unitpartin,file=path(2)(1:length(2))//'header', &
       form='unformatted',err=998)

  read(unitpartin) ibdatein,ibtimein
  read(unitpartin)
  read(unitpartin)

  read(unitpartin)
  read(unitpartin)
  read(unitpartin) nspecin
  nspecin=nspecin/3
  if ((ldirect.eq.1).and.(nspec.ne.nspecin)) then
    write(*,*) ' #### FLEXPART MODEL ERROR IN READPARTPOSITIONS#### '
    write(*,*) ' #### THE NUMBER OF SPECIES TO BE READ IN DOES #### '
    write(*,*) ' #### NOT AGREE WITH CURRENT SETTINGS!         #### '
    stop
  end if

  do i=1,nspecin
    read(unitpartin)
    read(unitpartin)
    read(unitpartin) j,specin
    if ((ldirect.eq.1).and.(species(i)(1:7).ne.specin)) then
      write(*,*) ' #### FLEXPART MODEL ERROR IN READPARTPOSITIONS#### '
      write(*,*) ' #### SPECIES NAMES TO BE READ IN DO NOT       #### '
      write(*,*) ' #### AGREE WITH CURRENT SETTINGS!             #### '
      stop
    end if
  end do

  read(unitpartin) numpointin
  if (numpointin.ne.numpoint) then
    write(*,*) ' #### FLEXPART MODEL WARNING IN READPARTPOSITIONS#### '
    write(*,*) ' #### NUMBER OF RELEASE LOCATIONS DOES NOT     #### '
    write(*,*) ' #### AGREE WITH CURRENT SETTINGS!             #### '
  end if 
  do i=1,numpointin
    read(unitpartin)
    read(unitpartin)
    read(unitpartin)
    read(unitpartin)
    do j=1,nspec
      read(unitpartin)
      read(unitpartin)
      read(unitpartin)
    end do
  end do
  read(unitpartin)
  read(unitpartin)

  do lix=0,numxgrid-1
    read(unitpartin)
  end do


  ! Open data file of dumped particle data
  !***************************************

  close(unitpartin)
  open(unitpartin,file=path(2)(1:length(2))//'partposit_end', &
       form='unformatted',err=998)
  

  do 
    read(unitpartin,iostat=ios) itimein
    if (ios.lt.0) exit
    i=0
    do
      i=i+1
      read(unitpartin) part(i)%npoint,xlonin,ylatin,part(i)%z,part(i)%tstart, &
           topo,pvi,qvi,rhoi,hmixi,tri,tti,(mass(i,j),j=1,nspec)
      ! For switching coordinates: this happens in timemanager.f90 after the first fields are read
      if (xlonin.eq.-9999.9) exit
      call set_xlon(i,real((xlonin-xlon0)/dx,kind=dp))
      call set_ylat(i,real((ylatin-ylat0)/dy,kind=dp))
      numparticlecount=max(numparticlecount,part(i)%npoint)
    end do
  end do

  numpart=i-1

  close(unitpartin)

  julin=juldate(ibdatein,ibtimein)+real(itimein,kind=dp)/86400._dp
  if (abs(julin-bdate).gt.1.e-5) then
    write(*,*) ' #### FLEXPART MODEL ERROR IN READPARTPOSITIONS#### '
    write(*,*) ' #### ENDING TIME OF PREVIOUS MODEL RUN DOES   #### '
    write(*,*) ' #### NOT AGREE WITH STARTING TIME OF THIS RUN.#### '
    call caldate(julin,id1,it1)
    call caldate(bdate,id2,it2)
    write(*,*) 'julin: ',julin,id1,it1
    write(*,*) 'bdate: ',bdate,id2,it2
    stop
  end if
  do i=1,numpart
    julpartin=juldate(ibdatein,ibtimein)+ &
         real(part(i)%tstart,kind=dp)/86400._dp
    part(i)%nclass=min(int(ran1(idummy,0)*real(nclassunc))+1, &
         nclassunc)
    part(i)%idt=mintime
    part(i)%tstart=nint((julpartin-bdate)*86400.)
  end do

  return

998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
  write(*,*) ' #### '//path(2)(1:length(2))//'partposit'//' #### '
  write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
  write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
  write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
  stop

end subroutine readpartpositions

subroutine init_particle(itime,ipart,ithread)
  !                        i    i   o  o  o
  !        o       o       o    i  i  i   o
  !*****************************************************************************
  !                                                                            *
  !  Calculation of trajectories utilizing a zero-acceleration scheme. The time*
  !  step is determined by the Courant-Friedrichs-Lewy (CFL) criterion. This   *
  !  means that the time step must be so small that the displacement within    *
  !  this time step is smaller than 1 grid distance. Additionally, a temporal  *
  !  CFL criterion is introduced: the time step must be smaller than the time  *
  !  interval of the wind fields used for interpolation.                       *
  !  For random walk simulations, these are the only time step criteria.       *
  !  For the other options, the time step is also limited by the Lagrangian    *
  !  time scale.                                                               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     16 December 1997                                                       *
  !                                                                            *
  !  Literature:                                                               *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! h [m]              Mixing height                                           *
  ! lwindinterv [s]    time interval between two wind fields                   *
  ! itime [s]          current temporal position                               *
  ! ldt [s]            Suggested time step for next integration                *
  ! ladvance [s]       Total integration time period                           *
  ! rannumb(maxrand)   normally distributed random variables                   *
  ! usig,vsig,wsig     uncertainties of wind velocities due to interpolation   *
  ! xt,yt,zt           Next time step's spatial position of trajectory         *
  !                                                                            *
  !                                                                            *
  ! Constants:                                                                 *
  ! cfl                factor, by which the time step has to be smaller than   *
  !                    the spatial CFL-criterion                               *
  ! cflt               factor, by which the time step has to be smaller than   *
  !                    the temporal CFL-criterion                              *
  !                                                                            *
  !*****************************************************************************

  use turbulence_mod
  use random_mod, only: ran3
  use omp_lib
  use interpol_mod
  use cbl_mod

  implicit none

  integer,intent(in) ::  &
    ithread,             & ! OMP thread starting at 0
    itime,               &
    ipart
  integer :: nrand
  real :: dummy1,dummy2
  real :: xt,yt,zt,zteta

  ! ! Initialise scavenging for backward runs
  ! !****************************************
  ! if (DRYBKDEP.or.WETBKDEP) then ! if there is no scavenging in wetdepo it will be set to 0
  !   do k=1,nspec
  !     xscav_frac1(ipart,k)=-1.
  !   end do
  ! endif


  part(ipart)%icbt=1           ! initialize particle to no "reflection"

  nrand=int(ran3(iseed1(ithread),ithread)*real(maxrand-1))+1

  xt = real(part(ipart)%xlon)
  yt = real(part(ipart)%ylat)
  zt = real(part(ipart)%z)
#ifdef ETA
  zteta = real(part(ipart)%zeta)
#else
  zteta = 0.
#endif

  !******************************
  ! 2. Interpolate necessary data
  !******************************

  ! Where in the grid? Stereographic (ngrid<0) or nested (ngrid>0)
  !***************************************************************
  call find_ngrid(xt,yt)
  ! Compute maximum mixing height around particle position
  !*******************************************************
  call find_grid_indices(xt,yt)

  ! If part_ic.nc is used, convert particle mass to mixing mass in forward,
  ! or internal mass conversion for wet and dry backward depostion.
  !************************************************************************
  if ((iout.eq.4).or.(iout.eq.5)) call init_mass_conversion(ipart,part(ipart)%npoint)
  
  h=max(hmix(ix ,jy,1,memind(1)), &
       hmix(ixp,jy ,1,memind(1)), &
       hmix(ix ,jyp,1,memind(1)), &
       hmix(ixp,jyp,1,memind(1)), &
       hmix(ix ,jy ,1,memind(2)), &
       hmix(ixp,jy ,1,memind(2)), &
       hmix(ix ,jyp,1,memind(2)), &
       hmix(ixp,jyp,1,memind(2)))

  zeta=zt/h


  !*************************************************************
  ! If particle is in the PBL, interpolate once and then make a
  ! time loop until end of interval is reached
  !*************************************************************

  if (zeta.le.1.) then

    call interpol_pbl(itime,xt,yt,zt,zteta,ithread+1)

  ! Vertical interpolation of u,v,w,rho and drhodz
  !***********************************************

  ! Vertical distance to the level below and above current position
  ! both in terms of (u,v) and (w) fields
  !****************************************************************
    call interpol_pbl_short(zt,dummy1,dummy2,ithread+1)

  ! Compute the turbulent disturbances

  ! Determine the sigmas and the timescales
  !****************************************

    if (turbswitch) then
      call hanna(zt)
    else
      call hanna1(zt)
    endif


  ! Determine the new diffusivity velocities
  !*****************************************

    if (nrand+2.gt.maxrand) nrand=1
    part(ipart)%turbvel%u=rannumb(nrand)*sigu
    part(ipart)%turbvel%v=rannumb(nrand+1)*sigv
    part(ipart)%turbvel%w=rannumb(nrand+2)
    if (.not.turbswitch) then     ! modified by mc
      part(ipart)%turbvel%w=part(ipart)%turbvel%w*sigw
    else if (cblflag.eq.1) then   ! modified by mc
      if(-h/ol.gt.5) then
  !if (ol.lt.0.) then
  !if (ol.gt.0.) then !by mc : only for test correct is lt.0
        call init_cbl_vel( &
          iseed1(ithread),zt,wst,h,sigw,part(ipart)%turbvel%w,ol,ithread)
      else
        part(ipart)%turbvel%w=part(ipart)%turbvel%w*sigw
      end if
    end if


  ! Determine time step for next integration
  !*****************************************

    if (turbswitch) then
      part(ipart)%idt = int( &
        min(tlw, &
          h/max(2.*abs(part(ipart)%turbvel%w*sigw),1.e-5), &
          0.5/abs(dsigwdz), &
          600.) &
        *ctl)
    else
      part(ipart)%idt = int( &
        min(tlw, &
          h/max(2.*abs(part(ipart)%turbvel%w),1.e-5), &
          600.) &
        *ctl)
    endif
    part(ipart)%idt=max(part(ipart)%idt,mintime)

    ! call interpol_average()
    ! usig=(usigprof(indzp)+usigprof(indz))/2.
    ! vsig=(vsigprof(indzp)+vsigprof(indz))/2.
    ! wsig=(wsigprof(indzp)+wsigprof(indz))/2.

    ! wsigeta=(wsigprofeta(indzpeta)+wsigprofeta(indzeta))/2.

  else



  !**********************************************************
  ! For all particles that are outside the PBL, make a single
  ! time step. Only horizontal turbulent disturbances are
  ! calculated. Vertical disturbances are reset.
  !**********************************************************


  ! Interpolate the wind
  !*********************

    call interpol_wind(itime,xt,yt,zt,zteta)


  ! Compute everything for above the PBL

  ! Assume constant turbulent perturbations
  !****************************************

    part(ipart)%idt=abs(lsynctime)

    if (nrand+1.gt.maxrand) nrand=1
    part(ipart)%turbvel%u=rannumb(nrand)*0.3
    part(ipart)%turbvel%v=rannumb(nrand+1)*0.3
    nrand=nrand+2
    part(ipart)%turbvel%w=0.
    sigw=0.

  endif

  !****************************************************************
  ! Add mesoscale random disturbances
  ! This is done only once for the whole lsynctime interval to save
  ! computation time
  !****************************************************************


  ! It is assumed that the average interpolation error is 1/2 sigma
  ! of the surrounding points, autocorrelation time constant is
  ! 1/2 of time interval between wind fields
  !****************************************************************
  if (lmesoscale_turb) then
    call interpol_mesoscale(xt,yt,zt,zteta)
    if (nrand+2.gt.maxrand) nrand=1
    part(ipart)%mesovel%u=rannumb(nrand)*usig
    part(ipart)%mesovel%v=rannumb(nrand+1)*vsig
#ifdef ETA
    part(ipart)%mesovel%w=rannumb(nrand+2)*wsigeta
#else
    part(ipart)%mesovel%w=rannumb(nrand+2)*wsig
#endif
  endif
end subroutine init_particle

subroutine init_domainfill
  !
  !*****************************************************************************
  !                                                                            *
  ! Initializes particles equally distributed over the first release location  *
  ! specified in file RELEASES. This box is assumed to be the domain for doing *
  ! domain-filling trajectory calculations.                                    *
  ! All particles carry the same amount of mass which alltogether comprises the*
  ! mass of air within the box.                                                *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     15 October 2002                                                        *
  !                                                                            *
  !  Changes                                                                   *
  !     2022, L. Bakels: OpenMP parallelisation                                *
  !     2023, L. Bakels: smooth vertical particle distribution instead of      *
  !                      distributing particles on fixed vertical layers       *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! numparticlecount    consecutively counts the number of particles released  *
  ! nx_we(2)       grid indices for western and eastern boundary of domain-    *
  !                filling trajectory calculations                             *
  ! ny_sn(2)       grid indices for southern and northern boundary of domain-  *
  !                filling trajectory calculations                             *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use particle_mod

  implicit none

  integer :: j,kz,lix,ljy,ncolumn,numparttot,stat,iterminate
  real :: ylat,ylatp,ylatm,hzone
  real :: cosfactm,cosfactp,deltacol,dz1,dz2,dz,pnew,pnew_temp,fractus
  real,parameter :: pih=pi/180.
  real :: colmasstotal,zposition
  real,allocatable,dimension(:) :: pp

  integer :: ixm,ixp,jym,jyp,indzm,indzh,indzp,i,jj,ii
  ! integer :: alive_tmp,allocated_tmp,spawned_tmp,terminated_tmp
  real :: pvpart,ddx,ddy,rddx,rddy,p1,p2,p3,p4,y1(2)
  integer :: idummy = -11

  real :: height_tmp

  logical :: deall

  real,allocatable,dimension(:)   :: gridarea !
  real,allocatable,dimension(:,:) :: colmass !

  ! Determine the release region (only full grid cells), over which particles
  ! shall be initialized
  ! Use 2 fields for west/east and south/north boundary
  !**************************************************************************
  call alloc_domainfill

  nx_we(1)=max(int(xpoint1(1)),0)
  nx_we(2)=min((ceiling(xpoint2(1))),nxmin1)
  ny_sn(1)=max(int(ypoint1(1)),0)
  ny_sn(2)=min((ceiling(ypoint2(1))),nymin1)

  ! For global simulations (both global wind data and global domain-filling),
  ! set a switch, such that no boundary conditions are used
  !**************************************************************************
  if (xglobal.and.sglobal.and.nglobal) then
    if ((nx_we(1).eq.0).and.(nx_we(2).eq.nxmin1).and. &
         (ny_sn(1).eq.0).and.(ny_sn(2).eq.nymin1)) then
      gdomainfill=.true.
    else
      gdomainfill=.false.
    endif
  endif
  write(*,*) 'Global domain: ', gdomainfill

  ! Exit here if resuming a run from particle dump
  !***********************************************
  if (gdomainfill.and.ipin.ne.0) return

  ! Allocate grid and column mass
  !*******************************
  allocate(gridarea(0:nymax-1),colmass(0:nxmax-1,0:nymax-1),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate gridarea or colmass'

  ! Do not release particles twice (i.e., not at both in the leftmost and rightmost
  ! grid cell) for a global domain
  !*****************************************************************************
  if (xglobal) nx_we(2)=min(nx_we(2),nx-2)


  ! Calculate area of grid cell with formula M=2*pi*R*h*dx/360,
  ! see Netz, Formeln der Mathematik, 5. Auflage (1983), p.90
  !************************************************************
  ! First for the south pole
  
  if (sglobal) then
    ylat=ylat0
    ylatp=ylat+0.5*dy
    ylatm=ylat
    cosfactm=0.
    cosfactp=cos(ylatp*pih)*r_earth
    hzone=sqrt(r_earth**2-cosfactm**2)- &
         sqrt(r_earth**2-cosfactp**2)
    gridarea(0)=2.*pi*r_earth*hzone*dx/360.
  endif

  ! Do the same for the north pole

  if (nglobal) then
    ylat=ylat0+real(nymin1)*dy
    ylatp=ylat
    ylatm=ylat-0.5*dy
    cosfactp=0.
    cosfactm=cos(ylatm*pih)*r_earth
    hzone=sqrt(r_earth**2-cosfactp**2)- &
         sqrt(r_earth**2-cosfactm**2)
    gridarea(nymin1)=2.*pi*r_earth*hzone*dx/360.
  endif



  ! Allocate memory for storing the particles
  !******************************************
  call alloc_particles(int(npart(1)*1.1)) ! A bit more to avoid single part alloc

  ! Initialise total particle number
  numparttot=0
  ! Initialise max column number
  numcolumn=0

  ! Initialise the sum over the total mass of the atmosphere
  colmasstotal=0.

!$OMP PARALLEL PRIVATE(ljy,ylat,ylatp,ylatm,hzone,cosfactp,cosfactm,pp,lix) &
!$OMP REDUCTION(+:colmasstotal)
  
  allocate( pp(nzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate pp inside of OMP loop'

!$OMP DO
  do ljy=ny_sn(1),ny_sn(2)      ! loop about latitudes
    ylat=ylat0+real(ljy)*dy
    ylatp=ylat+0.5*dy
    ylatm=ylat-0.5*dy
    if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
      hzone=1./dyconst
    else
      cosfactp=cos(ylatp*pih)*r_earth
      cosfactm=cos(ylatm*pih)*r_earth
      if (cosfactp.lt.cosfactm) then
        hzone=sqrt(r_earth**2-cosfactp**2)- &
             sqrt(r_earth**2-cosfactm**2)
      else
        hzone=sqrt(r_earth**2-cosfactm**2)- &
             sqrt(r_earth**2-cosfactp**2)
      endif
    endif
    gridarea(ljy)=2.*pi*r_earth*hzone*dx/360.
  end do
!$OMP END DO
!$OMP BARRIER

  ! Calculate total mass of each grid column and of the whole atmosphere
  !*********************************************************************
!$OMP DO 
  do ljy=ny_sn(1),ny_sn(2)          ! loop about latitudes
    do lix=nx_we(1),nx_we(2)      ! loop about longitudes
      pp(1)=prs(lix,ljy,1,1) !rho(lix,ljy,1,1)*r_air*tt(lix,ljy,1,1)
      pp(nz)=prs(lix,ljy,nz,1) !rho(lix,ljy,nz,1)*r_air*tt(lix,ljy,nz,1)
      colmass(lix,ljy)=(pp(1)-pp(nz))/ga*gridarea(ljy)
      colmasstotal=colmasstotal+colmass(lix,ljy)
    end do
  end do
!$OMP END DO
  deallocate(pp)
!$OMP END PARALLEL

  write(*,*) 'Atm. mass: ',colmasstotal

  allocate( pp(nzmax),stat=stat)
  if (stat.ne.0) write(*,*)'ERROR: could not allocate pp'

  if (ipin.eq.0) numpart=0

  ! Determine the particle positions
  !*********************************
  iterminate=0
  do ljy=ny_sn(1),ny_sn(2)      ! loop about latitudes
    ylat=ylat0+real(ljy)*dy
    do lix=nx_we(1),nx_we(2)      ! loop about longitudes
      ncolumn=nint(0.999*real(npart(1))*colmass(lix,ljy)/colmasstotal)
      if (ncolumn.eq.0) cycle
      if (ncolumn.gt.numcolumn) numcolumn=ncolumn

  ! Calculate pressure at the altitudes of model surfaces, using the air density
  ! information, which is stored as a 3-d field
  !*****************************************************************************

      pp(:)=prs(lix,ljy,:,1)!rho(lix,ljy,kz,1)*r_air*tt(lix,ljy,kz,1)


      deltacol=(pp(1)-pp(nz))/real(ncolumn)
      pnew=pp(1)+deltacol*0.5
      jj=0
      do j=1,ncolumn ! looping over the number of particles within the column

        ! For columns with many particles (i.e. around the equator), distribute
        ! the particles equally (1 on a random position within the deltacol range), 
        ! for columns with few particles (i.e. around the poles), 
        ! distribute the particles randomly
        !***********************************************************************

        if ((ncolumn.gt.20).and.(ncolumn-j.gt.20)) then
          pnew_temp=pnew-ran1(idummy,0)*deltacol
          pnew=pnew-deltacol
        else if ((ncolumn.gt.20).and.(ncolumn-j.le.20)) then
          ! When only few particles are left, distribute them randomly above pnew
          pnew_temp=pnew-ran1(idummy,0)*(pnew-pp(nz))
        else
          pnew_temp=pp(1)-ran1(idummy,0)*(pp(1)-pp(nz))
        endif

        do kz=1,nz-1
          if ((pp(kz).ge.pnew_temp).and.(pp(kz+1).lt.pnew_temp)) then
            dz1=log(pnew_temp)-log(pp(kz))
            dz=1./log(pp(kz+1)/pp(kz))

            ! Assign particle position
            !*************************
            ! Do the following steps only if particles are not read in 
            ! from previous model run
            !**********************************************************
            if (ipin.eq.0) then
              ! First spawn the particle into existence
              !****************************************
              jj=jj+1
              !THIS WILL CAUSE PROBLEMS WITH OMP! because of dynamical allocation
              call spawn_particle(0,numpart+jj)
              call set_xlon(numpart+jj,real(real(lix)-0.5+ran1(idummy,0),kind=dp))
              if (lix.eq.0) call set_xlon(numpart+jj,real(ran1(idummy,0),kind=dp))
              if (lix.eq.nxmin1) &
                call set_xlon(numpart+jj,real(real(nxmin1)-ran1(idummy,0),kind=dp))
              call set_ylat(numpart+jj,real(real(ljy)-0.5+ran1(idummy,0),kind=dp))
              ! Logarithmic distribution of particles along pressure levels:
              ! hx=h1+(h2-h1)/log(p2/p1)*log(px/p1)
              height_tmp=height(kz)+(height(kz+1)-height(kz))*dz*dz1
              call set_z(numpart+jj,height_tmp)
              if (real(part(numpart+jj)%z).gt.height(nz)-0.5) &
                call set_z(numpart+jj, height(nz)-0.5)
#ifdef ETA
              call update_z_to_zeta(0, numpart+jj)
#endif
              ! Interpolate PV to the particle position
              !****************************************
              ixm=int(part(numpart+jj)%xlon)
              jym=int(part(numpart+jj)%ylat)
              ixp=ixm+1
              jyp=jym+1
              ddx=real(part(numpart+jj)%xlon)-real(ixm)
              ddy=real(part(numpart+jj)%ylat)-real(jym)
              rddx=1.-ddx
              rddy=1.-ddy
              p1=rddx*rddy
              p2=ddx*rddy
              p3=rddx*ddy
              p4=ddx*ddy

              !***********************************************
              indzm=nz-1
              indzp=nz
              do i=2,nz
                if (real(height(i),kind=dp).gt.part(numpart+jj)%z) then
                  indzm=i-1
                  indzp=i
                  exit
                endif
              end do
              dz1=real(part(numpart+jj)%z)-height(indzm)
              dz2=height(indzp)-real(part(numpart+jj)%z)
              dz=1./(dz1+dz2)
              do ii=1,2
                indzh=indzm+ii-1
                y1(ii)=p1*pv(ixm,jym,indzh,1) &
                     + p2*pv(ixp,jym,indzh,1) &
                     + p3*pv(ixm,jyp,indzh,1) &
                     + p4*pv(ixp,jyp,indzh,1)
              end do
              pvpart=(dz2*y1(1)+dz1*y1(2))*dz
              if (ylat.lt.0.) pvpart=-1.*pvpart


              ! For domain-filling option 2 (stratospheric O3), 
              ! do the rest only in the stratosphere
              !************************************************

              if (((part(numpart+jj)%z.gt.3000.).and. &
                   (pvpart.gt.pvcrit)).or.(mdomainfill.eq.1)) then

                ! Assign certain properties to the particle
                !******************************************
                part(numpart+jj)%nclass=min( &
                  int(ran1(idummy,0)*real(nclassunc))+1,nclassunc)
                numparticlecount=numparticlecount+1
                part(numpart+jj)%npoint=numparticlecount
                part(numpart+jj)%idt=mintime
                mass(numpart+jj,1)=colmass(lix,ljy)/real(ncolumn)
                if (mdomainfill.eq.2) mass(numpart+jj,1)= &
                     mass(numpart+jj,1)*pvpart*48./29.*ozonescale/10.**9
                mass_init(numpart+jj,1)=mass(numpart+jj,1)
              else
                call terminate_particle(numpart+jj, 0)
                jj=jj-1
                iterminate=iterminate+1
              endif
            endif
          endif
        end do
      end do
      numparttot=numparttot+ncolumn
      if (ipin.eq.0) numpart=numpart+jj
    end do
  end do


  ! alive_tmp=count%alive
  ! spawned_tmp=count%spawned
  ! terminated_tmp=count%terminated

! !$OMP PARALLEL PRIVATE(j) REDUCTION(+:alive_tmp,spawned_tmp,allocated_tmp,terminated_tmp)
 
  ! Make sure that all particles are within domain
  !***********************************************
! !$OMP DO
  do j=1,numpart
    if ((part(j)%xlon.lt.0.).or.(part(j)%xlon.ge.real(nxmin1,kind=dp)).or. &
         (part(j)%ylat.lt.0.).or.(part(j)%ylat.ge.real(nymin1,kind=dp))) then
      call terminate_particle(j,0) ! Cannot be within an OMP region
      iterminate=iterminate+1
      ! alive_tmp=alive_tmp-1
      ! terminated_tmp=terminated_tmp+1
    endif
  end do

  if (iterminate.gt.0) call rewrite_ialive()
! !$OMP END DO
! !$OMP END PARALLEL

  ! count%alive=alive_tmp
  ! count%spawned=spawned_tmp
  ! count%terminated=terminated_tmp
  ! Check whether numpart is really smaller than maxpart
  !*****************************************************

  ! ! ESO :TODO: this warning need to be moved further up, else out-of-bounds error earlier
  !   if (numpart.gt.maxpart) then
  !     write(*,*) 'numpart too large: change source in init_atm_mass.f'
  !     write(*,*) 'numpart: ',numpart,' maxpart: ',maxpart
  !   endif


  xmassperparticle=colmasstotal/real(numparttot)


  ! For boundary conditions, we need fewer particle release heights per column,
  ! because otherwise it takes too long until enough mass has accumulated to
  ! release a particle at the boundary (would take dx/u seconds), leading to
  ! relatively large position errors of the order of one grid distance.
  ! It's better to release fewer particles per column, but to do so more often.
  ! Thus, use on the order of nz starting heights per column.
  ! We thus repeat the above to determine fewer starting heights, that are
  ! used furtheron in subroutine boundcond_domainfill.f.
  !****************************************************************************

  fractus=real(numcolumn)/real(nz)
  write(*,*) 'Total number of particles at model start: ',numpart
  write(*,*) 'Maximum number of particles per column: ',numcolumn
  write(*,*) 'If ',fractus,' <1, better use more particles'
  fractus=sqrt(max(fractus,1.))*0.5

  do ljy=ny_sn(1),ny_sn(2)      ! loop about latitudes
    do lix=nx_we(1),nx_we(2)      ! loop about longitudes
      ncolumn=nint(0.999/fractus*real(npart(1))*colmass(lix,ljy) &
           /colmasstotal)
      if (ncolumn.gt.maxcolumn) stop 'maxcolumn too small'
      if (ncolumn.eq.0) cycle


  ! Memorize how many particles per column shall be used for all boundaries
  ! This is further used in subroutine boundcond_domainfill.f
  ! Use 2 fields for west/east and south/north boundary
  !************************************************************************

      if (lix.eq.nx_we(1)) numcolumn_we(1,ljy)=ncolumn
      if (lix.eq.nx_we(2)) numcolumn_we(2,ljy)=ncolumn
      if (ljy.eq.ny_sn(1)) numcolumn_sn(1,lix)=ncolumn
      if (ljy.eq.ny_sn(2)) numcolumn_sn(2,lix)=ncolumn

  ! Calculate pressure at the altitudes of model surfaces, using the air density
  ! information, which is stored as a 3-d field
  !*****************************************************************************

      do kz=1,nz
        pp(kz)=prs(lix,ljy,kz,1) !rho(lix,ljy,kz,1)*r_air*tt(lix,ljy,kz,1)
      end do

  ! Determine the reference starting altitudes
  !*******************************************

      deltacol=(pp(1)-pp(nz))/real(ncolumn)
      pnew=pp(1)+deltacol*0.5
      do j=1,ncolumn
        pnew=pnew-deltacol
        do kz=1,nz-1
          if ((pp(kz).ge.pnew).and.(pp(kz+1).lt.pnew)) then
            dz1=pp(kz)-pnew
            dz2=pnew-pp(kz+1)
            dz=1./(dz1+dz2)
            zposition=(height(kz)*dz2+height(kz+1)*dz1)*dz
            if (zposition.gt.height(nz)-0.5) zposition=height(nz)-0.5

  ! Memorize vertical positions where particles are introduced
  ! This is further used in subroutine boundcond_domainfill.f
  !***********************************************************

            if (lix.eq.nx_we(1)) zcolumn_we(1,ljy,j)=zposition
            if (lix.eq.nx_we(2)) zcolumn_we(2,ljy,j)=zposition
            if (ljy.eq.ny_sn(1)) zcolumn_sn(1,lix,j)=zposition
            if (ljy.eq.ny_sn(2)) zcolumn_sn(2,lix,j)=zposition

  ! Initialize mass that has accumulated at boundary to zero
  !*********************************************************

            acc_mass_we(1,ljy,j)=0.
            acc_mass_we(2,ljy,j)=0.
            acc_mass_sn(1,ljy,j)=0.
            acc_mass_sn(2,ljy,j)=0.
          endif
        end do
      end do
    end do
  end do

  ! If there were more particles allocated than used,
  ! Deallocate unused memory and update numpart
  !**************************************************
  deall=.false.
  do i=numpart, 1, -1
    if (.not. part(i)%alive) then
      deall=.true.
      numpart = numpart - 1
    else
      exit
    endif
  end do

  if (deall) call dealloc_particle(numpart) !Deallocates everything above numpart (F2008)


  ! If particles shall be read in to continue an existing run,
  ! then the accumulated masses at the domain boundaries must be read in, too.
  ! This overrides any previous calculations.
  !***************************************************************************

  if ((ipin.eq.1).and.(.not.gdomainfill)) then
    open(unitboundcond,file=path(2)(1:length(2))//'boundcond.bin', &
         form='unformatted')
    read(unitboundcond) numcolumn_we,numcolumn_sn, &
         zcolumn_we,zcolumn_sn,acc_mass_we,acc_mass_sn
    close(unitboundcond)
  endif

  deallocate(gridarea,colmass)
end subroutine init_domainfill

subroutine boundcond_domainfill(itime,loutend)
  !                                  i      i
  !*****************************************************************************
  !                                                                            *
  ! Particles are created by this subroutine continuously throughout the       *
  ! simulation at the boundaries of the domain-filling box.                    *
  ! All particles carry the same amount of mass which alltogether comprises the*
  ! mass of air within the box, which remains (more or less) constant.         *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     16 October 2002                                                        *
  !                                                                            *
  !  Changes                                                                   *
  !     2022, L. Bakels: OpenMP parallelisation                                *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nx_we(2)       grid indices for western and eastern boundary of domain-    *
  !                filling trajectory calculations                             *
  ! ny_sn(2)       grid indices for southern and northern boundary of domain-  *
  !                filling trajectory calculations                             *
  !                                                                            *
  !*****************************************************************************

  use point_mod
#ifdef _OPENMP
  use omp_lib
#endif
  implicit none

  real :: dz,dz1,dz2,dt1,dt2,dtt,ylat,cosfact,accmasst
  integer :: itime,ii,indz,indzp,i,loutend,numparticlecount_tmp
  integer :: j,k,ix,jy,m,indzh,indexh,ipart,mmass,ithread
  integer :: numactiveparticles,iterminate

  real :: windl(2),rhol(2)
  real :: windhl(2),rhohl(2)
  real :: windx,rhox
  real :: deltaz,boundarea,fluxofmass

  integer :: ixm,ixp,jym,jyp,indzm,mm,iterm_index
  real :: pvpart,ddx,ddy,rddx,rddy,p1,p2,p3,p4,y1(2),yh1(2)

  integer :: idummy = -11


  ! If domain-filling is global, no boundary conditions are needed
  !***************************************************************

  if (gdomainfill) return

  ! Determine auxiliary variables for time interpolation
  !*****************************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)

  numactiveparticles=0
  numparticlecount_tmp=numparticlecount
  accmasst=0.
  ! Terminate trajectories that have left the domain, if domain-filling
  ! trajectory calculation domain is not global
  !********************************************************************
  if (ipin.le.1 .and. ipout.eq.0 .and. ispeed.eq.0) call rewrite_iterm()

  iterminate=0
  do i=1,count%allocated
    if (.not. part(i)%alive) cycle

    if ((part(i)%ylat.gt.real(ny_sn(2))).or.(part(i)%ylat.lt.real(ny_sn(1)))) then
      call terminate_particle(i,itime)
      iterminate=iterminate+1
    endif
    if (((.not.xglobal).or.(nx_we(2).ne.(nx-2))).and. &
         ((part(i)%xlon.lt.real(nx_we(1))).or. &
         (part(i)%xlon.gt.real(nx_we(2))))) then
      call terminate_particle(i,itime)
      iterminate=iterminate+1
    endif
    if (part(i)%alive) numactiveparticles = numactiveparticles+1
  end do
  if (iterminate.gt.0) call rewrite_ialive()
  !***************************************
  ! Western and eastern boundary condition
  !***************************************

  ! Loop from south to north
  !*************************
! OMP doesn't work here yet because particles are being spawned inside of the loop
! !$OMP PARALLEL PRIVATE(i,jy,k,j,ii,deltaz,boundarea,indz,indzp,indexh,windl,rhol, &
! !$OMP windhl,rhohl,windx,rhox,fluxofmass,mmass,ixm,jym,ixp,jyp,ddx,ddy,rddx, &
! !$OMP rddy,p1,p2,p3,p4,indzm,mm,indzh,pvpart,ylat,ix,cosfact,ipart) &
! !$OMP REDUCTION(+:numactiveparticles,numparticlecount_tmp,accmasst)

! #ifdef _OPENMP
!   ithread = OMP_GET_THREAD_NUM()
! #else
!   ithread = 0
! #endif
  ithread=0
  iterm_index=1
! !$OMP DO
  do jy=ny_sn(1),ny_sn(2)

  ! Loop over western (index 1) and eastern (index 2) boundary
  !***********************************************************

    do k=1,2

  ! Loop over all release locations in a column
  !********************************************

      do j=1,numcolumn_we(k,jy)

  ! Determine, for each release location, the area of the corresponding boundary
  !*****************************************************************************

        if (j.eq.1) then
          deltaz=(zcolumn_we(k,jy,2)+zcolumn_we(k,jy,1))*0.5
        else if (j.eq.numcolumn_we(k,jy)) then
  ! In order to avoid taking a very high column for very many particles,
  ! use the deltaz from one particle below instead
          deltaz=(zcolumn_we(k,jy,j)-zcolumn_we(k,jy,j-2))*0.5
        else
          deltaz=(zcolumn_we(k,jy,j+1)-zcolumn_we(k,jy,j-1))*0.5
        endif
        if ((jy.eq.ny_sn(1)).or.(jy.eq.ny_sn(2))) then
          boundarea=deltaz*111198.5/2.*dy
        else
          boundarea=deltaz*111198.5*dy
        endif


  ! Interpolate the wind velocity and density to the release location
  !******************************************************************

  ! Determine the model level below the release position
  !*****************************************************
        indz=nz-1
        indzp=nz
        do i=2,nz
          if (height(i).gt.zcolumn_we(k,jy,j)) then
            indz=i-1
            indzp=i
            exit
          endif
        end do

  ! Vertical distance to the level below and above current position
  !****************************************************************

        dz1=zcolumn_we(k,jy,j)-height(indz)
        dz2=height(indzp)-zcolumn_we(k,jy,j)
        dz=1./(dz1+dz2)

  ! Vertical and temporal interpolation
  !************************************

        do m=1,2
          indexh=memind(m)
          do ii=1,2
            indzh=indz+ii-1
            windl(ii)=uu(nx_we(k),jy,indzh,indexh)
            rhol(ii)=rho(nx_we(k),jy,indzh,indexh)
          end do

          windhl(m)=(dz2*windl(1)+dz1*windl(2))*dz
          rhohl(m)=(dz2*rhol(1)+dz1*rhol(2))*dz
        end do

        windx=(windhl(1)*dt2+windhl(2)*dt1)*dtt
        rhox=(rhohl(1)*dt2+rhohl(2)*dt1)*dtt

  ! Calculate mass flux
  !********************

        fluxofmass=windx*rhox*boundarea*real(lsynctime)


  ! If the mass flux is directed into the domain, add it to previous mass fluxes;
  ! if it is out of the domain, set accumulated mass flux to zero
  !******************************************************************************

        if (k.eq.1) then
          if (fluxofmass.ge.0.) then
            acc_mass_we(k,jy,j)=acc_mass_we(k,jy,j)+fluxofmass
          else
            acc_mass_we(k,jy,j)=0.
          endif
        else
          if (fluxofmass.le.0.) then
            acc_mass_we(k,jy,j)=acc_mass_we(k,jy,j)+abs(fluxofmass)
          else
            acc_mass_we(k,jy,j)=0.
          endif
        endif
        accmasst=accmasst+acc_mass_we(k,jy,j)

  ! If the accumulated mass exceeds half the mass that each particle shall carry,
  ! one (or more) particle(s) is (are) released and the accumulated mass is
  ! reduced by the mass of this (these) particle(s)
  !******************************************************************************

        if (acc_mass_we(k,jy,j).ge.xmassperparticle*0.5) then
          mmass=int((acc_mass_we(k,jy,j)+xmassperparticle*0.5)/ &
               xmassperparticle)
          acc_mass_we(k,jy,j)=acc_mass_we(k,jy,j)- &
               real(mmass)*xmassperparticle
        else
          mmass=0
        endif

        do m=1,mmass
          !THIS WILL CAUSE PROBLEMS WITH OMP! because of dynamical allocation
          call get_newpart_index(ipart,iterm_index)
          call spawn_particle(itime, ipart)

  ! Assign particle positions
  !**************************

          call set_xlon(ipart,real(nx_we(k),kind=dp))
          if (jy.eq.ny_sn(1)) then
            call set_ylat(ipart,real(real(jy)+0.5*ran1(idummy,ithread),kind=dp))
          else if (jy.eq.ny_sn(2)) then
            call set_ylat(ipart,real(real(jy)-0.5*ran1(idummy,ithread),kind=dp))
          else
            call set_ylat(ipart,real(real(jy)+(ran1(idummy,ithread)-.5),kind=dp))
          endif
          if (j.eq.1) then
            call set_z(ipart,zcolumn_we(k,jy,1)+(zcolumn_we(k,jy,2)- &
                 zcolumn_we(k,jy,1))/4.)
          else if (j.eq.numcolumn_we(k,jy)) then
            call set_z(ipart,(2.*zcolumn_we(k,jy,j)+ &
                 zcolumn_we(k,jy,j-1)+height(nz))/4.)
          else
            call set_z(ipart,zcolumn_we(k,jy,j-1)+ran1(idummy,ithread)* &
                 (zcolumn_we(k,jy,j+1)-zcolumn_we(k,jy,j-1)))
          endif
#ifdef ETA
          call update_z_to_zeta(itime, ipart)
#endif
  ! Interpolate PV to the particle position
  !****************************************
          ixm=int(part(ipart)%xlon)
          jym=int(part(ipart)%ylat)
          ixp=ixm+1
          jyp=jym+1
          ddx=real(part(ipart)%xlon)-real(ixm)
          ddy=real(part(ipart)%ylat)-real(jym)
          rddx=1.-ddx
          rddy=1.-ddy
          p1=rddx*rddy
          p2=ddx*rddy
          p3=rddx*ddy
          p4=ddx*ddy
          indzm=nz-1
          indzp=nz
          do i=2,nz
            if (real(height(i),kind=dp).gt.part(ipart)%z) then
              indzm=i-1
              indzp=i
              exit
            endif
          end do
          dz1=real(part(ipart)%z)-height(indzm)
          dz2=height(indzp)-real(part(ipart)%z)
          dz=1./(dz1+dz2)
          do mm=1,2
            indexh=memind(mm)
            do ii=1,2
              indzh=indzm+ii-1
              y1(ii)=p1*pv(ixm,jym,indzh,indexh) &
                   +p2*pv(ixp,jym,indzh,indexh) &
                   +p3*pv(ixm,jyp,indzh,indexh) &
                   +p4*pv(ixp,jyp,indzh,indexh)
            end do
            yh1(mm)=(dz2*y1(1)+dz1*y1(2))*dz
          end do
          pvpart=(yh1(1)*dt2+yh1(2)*dt1)*dtt
          ylat=ylat0+real(part(ipart)%ylat)*dy
          if (ylat.lt.0.) pvpart=-1.*pvpart


  ! For domain-filling option 2 (stratospheric O3), do the rest only in the stratosphere
  !*****************************************************************************

          if (((part(ipart)%z.gt.3000.).and. &
               (pvpart.gt.pvcrit)).or.(mdomainfill.eq.1)) then
            part(ipart)%nclass=min(int(ran1(idummy,ithread)* &
                 real(nclassunc))+1,nclassunc)
            numactiveparticles=numactiveparticles+1
            numparticlecount_tmp=numparticlecount_tmp+1
            part(ipart)%npoint=numparticlecount_tmp
            part(ipart)%idt=mintime
            part(ipart)%tstart=itime
            mass(ipart,1)=xmassperparticle
            if (mdomainfill.eq.2) mass(ipart,1)= &
                 mass(ipart,1)*pvpart*48./29.*ozonescale/10.**9
            mass_init(ipart,1)=mass(ipart,1)
          else
            stop 'boundcond_domainfill error: look into original to understand what should happen here'
          endif
        end do ! particles
      end do ! release locations in column
    end do ! western and eastern boundary
  end do ! south to north
! !$OMP END DO

  !*****************************************
  ! Southern and northern boundary condition
  !*****************************************

  ! Loop from west to east
  !***********************
! !$OMP DO
  do ix=nx_we(1),nx_we(2)

  ! Loop over southern (index 1) and northern (index 2) boundary
  !*************************************************************

    do k=1,2
      ylat=ylat0+real(ny_sn(k))*dy
      cosfact=cos(ylat*pi180)

  ! Loop over all release locations in a column
  !********************************************

      do j=1,numcolumn_sn(k,ix)

  ! Determine, for each release location, the area of the corresponding boundary
  !*****************************************************************************

        if (j.eq.1) then
          deltaz=(zcolumn_sn(k,ix,2)+zcolumn_sn(k,ix,1))*0.5
        else if (j.eq.numcolumn_sn(k,ix)) then
  !        deltaz=height(nz)-(zcolumn_sn(k,ix,j-1)+
  !    +        zcolumn_sn(k,ix,j))/2.
  ! In order to avoid taking a very high column for very many particles,
  ! use the deltaz from one particle below instead
          deltaz=(zcolumn_sn(k,ix,j)-zcolumn_sn(k,ix,j-2))*0.5
        else
          deltaz=(zcolumn_sn(k,ix,j+1)-zcolumn_sn(k,ix,j-1))*0.5
        endif
        if ((ix.eq.nx_we(1)).or.(ix.eq.nx_we(2))) then
          boundarea=deltaz*111198.5*0.5*cosfact*dx
        else
          boundarea=deltaz*111198.5*cosfact*dx
        endif


  ! Interpolate the wind velocity and density to the release location
  !******************************************************************

  ! Determine the model level below the release position
  !*****************************************************
        indz=nz-1
        indzp=nz
        do i=2,nz
          if (height(i).gt.zcolumn_sn(k,ix,j)) then
            indz=i-1
            indzp=i
            exit
          endif
        end do

  ! Vertical distance to the level below and above current position
  !****************************************************************

        dz1=zcolumn_sn(k,ix,j)-height(indz)
        dz2=height(indzp)-zcolumn_sn(k,ix,j)
        dz=1./(dz1+dz2)

  ! Vertical and temporal interpolation
  !************************************

        do m=1,2
          indexh=memind(m)
          do ii=1,2
            indzh=indz+ii-1
            windl(ii)=vv(ix,ny_sn(k),indzh,indexh)
            rhol(ii)=rho(ix,ny_sn(k),indzh,indexh)
          end do

          windhl(m)=(dz2*windl(1)+dz1*windl(2))*dz
          rhohl(m)=(dz2*rhol(1)+dz1*rhol(2))*dz
        end do

        windx=(windhl(1)*dt2+windhl(2)*dt1)*dtt
        rhox=(rhohl(1)*dt2+rhohl(2)*dt1)*dtt

  ! Calculate mass flux
  !********************

        fluxofmass=windx*rhox*boundarea*real(lsynctime)

  ! If the mass flux is directed into the domain, add it to previous mass fluxes;
  ! if it is out of the domain, set accumulated mass flux to zero
  !******************************************************************************

        if (k.eq.1) then
          if (fluxofmass.ge.0.) then
            acc_mass_sn(k,ix,j)=acc_mass_sn(k,ix,j)+fluxofmass
          else
            acc_mass_sn(k,ix,j)=0.
          endif
        else
          if (fluxofmass.le.0.) then
            acc_mass_sn(k,ix,j)=acc_mass_sn(k,ix,j)+abs(fluxofmass)
          else
            acc_mass_sn(k,ix,j)=0.
          endif
        endif
        accmasst=accmasst+acc_mass_sn(k,ix,j)

  ! If the accumulated mass exceeds half the mass that each particle shall carry,
  ! one (or more) particle(s) is (are) released and the accumulated mass is
  ! reduced by the mass of this (these) particle(s)
  !******************************************************************************

        if (acc_mass_sn(k,ix,j).ge.xmassperparticle*0.5) then
          mmass=int((acc_mass_sn(k,ix,j)+xmassperparticle*0.5)/ &
               xmassperparticle)
          acc_mass_sn(k,ix,j)=acc_mass_sn(k,ix,j)- &
               real(mmass)*xmassperparticle
        else
          mmass=0
        endif

        do m=1,mmass
          call get_newpart_index(ipart,iterm_index)
          call spawn_particle(itime, ipart)
  
  ! Assign particle positions
  !**************************
          call set_ylat(ipart,real(ny_sn(k),kind=dp))
          if (ix.eq.nx_we(1)) then
            call set_xlon(ipart,real(real(ix)+0.5*ran1(idummy,ithread),kind=dp))
          else if (ix.eq.nx_we(2)) then
            call set_xlon(ipart,real(real(ix)-0.5*ran1(idummy,ithread),kind=dp))
          else
            call set_xlon(ipart,real(real(ix)+(ran1(idummy,ithread)-.5),kind=dp))
          endif
          if (j.eq.1) then
            call set_z(ipart,zcolumn_sn(k,ix,1)+(zcolumn_sn(k,ix,2)- &
                 zcolumn_sn(k,ix,1))/4.)
          else if (j.eq.numcolumn_sn(k,ix)) then
            call set_z(ipart,(2.*zcolumn_sn(k,ix,j)+ &
                 zcolumn_sn(k,ix,j-1)+height(nz))/4.)
          else
            call set_z(ipart,zcolumn_sn(k,ix,j-1)+ran1(idummy,ithread)* &
                 (zcolumn_sn(k,ix,j+1)-zcolumn_sn(k,ix,j-1)))
          endif
#ifdef ETA
          call update_z_to_zeta(itime, ipart)
#endif
  ! Interpolate PV to the particle position
  !****************************************
          ixm=int(part(ipart)%xlon)
          jym=int(part(ipart)%ylat)
          ixp=ixm+1
          jyp=jym+1
          ddx=real(part(ipart)%xlon)-real(ixm)
          ddy=real(part(ipart)%ylat)-real(jym)
          rddx=1.-ddx
          rddy=1.-ddy
          p1=rddx*rddy
          p2=ddx*rddy
          p3=rddx*ddy
          p4=ddx*ddy
          indzm=nz-1
          indzp=nz
          do i=2,nz
            if (real(height(i),kind=dp).gt.part(ipart)%z) then
              indzm=i-1
              indzp=i
              exit
            endif
          end do
          dz1=real(part(ipart)%z)-height(indzm)
          dz2=height(indzp)-real(part(ipart)%z)
          dz=1./(dz1+dz2)
          do mm=1,2
            indexh=memind(mm)
            do ii=1,2
              indzh=indzm+ii-1
              y1(ii)=p1*pv(ixm,jym,indzh,indexh) &
                   +p2*pv(ixp,jym,indzh,indexh) &
                   +p3*pv(ixm,jyp,indzh,indexh) &
                   +p4*pv(ixp,jyp,indzh,indexh)
            end do
            yh1(mm)=(dz2*y1(1)+dz1*y1(2))*dz
          end do
          pvpart=(yh1(1)*dt2+yh1(2)*dt1)*dtt
          if (ylat.lt.0.) pvpart=-1.*pvpart


  ! For domain-filling option 2 (stratospheric O3), do the rest only in the stratosphere
  !*****************************************************************************

          if (((part(ipart)%z.gt.3000.).and. &
               (pvpart.gt.pvcrit)).or.(mdomainfill.eq.1)) then
            part(ipart)%nclass=min(int(ran1(idummy,ithread)* &
                 real(nclassunc))+1,nclassunc)
            numactiveparticles=numactiveparticles+1
            numparticlecount_tmp=numparticlecount_tmp+1
            part(ipart)%npoint=numparticlecount_tmp
            part(ipart)%idt=mintime
            mass(ipart,1)=xmassperparticle
            if (mdomainfill.eq.2) mass(ipart,1)= &
                 mass(ipart,1)*pvpart*48./29.*ozonescale/10.**9
            mass_init(ipart,1)=mass(ipart,1)
          else
            stop 'boundcond_domainfill error: look into original to understand what should happen here'
          endif
        end do ! particles
      end do ! releases per column
    end do ! east west
  end do ! north south
! !$OMP END DO
! !$OMP END PARALLEL
  if (ipin.le.1 .and. ipout.eq.0 .and. ispeed.eq.0) call rewrite_iterm()
  numparticlecount = numparticlecount_tmp
  ! If particles shall be dumped, then accumulated masses at the domain boundaries
  ! must be dumped, too, to be used for later runs
  !*****************************************************************************

  if ((ipout.gt.0).and.(itime.eq.loutend)) then
    open(unitboundcond,file=path(2)(1:length(2))//'boundcond.bin', &
         form='unformatted')
    write(unitboundcond) numcolumn_we,numcolumn_sn, &
         zcolumn_we,zcolumn_sn,acc_mass_we,acc_mass_sn
    close(unitboundcond)
  endif
end subroutine boundcond_domainfill

end module initialise_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine verttransform(n,uuh,vvh,wwh,pvh)
  !                         i  i   i   i   i
  !*****************************************************************************
  !                                                                            *
  !     This subroutine transforms temperature, dew point temperature and      *
  !     wind components from eta to meter coordinates.                         *
  !     The vertical wind component is transformed from Pa/s to m/s using      *
  !     the conversion factor pinmconv.                                        *
  !     In addition, this routine calculates vertical density gradients        *
  !     needed for the parameterization of the turbulent velocities.           *
  !                                                                            *
  !     Author: A. Stohl, G. Wotawa                                            *
  !                                                                            *
  !     12 August 1996                                                         *
  !     Update: 16 January 1998                                                *
  !                                                                            *
  !     Major update: 17 February 1999                                         *
  !     by G. Wotawa                                                           *
  !     CHANGE 17/11/2005 Caroline Forster, NCEP GFS version                   *
  !                                                                            *
  !   - Vertical levels for u, v and w are put together                        *
  !   - Slope correction for vertical velocity: Modification of calculation    *
  !     procedure                                                              *
  !                                                                            *
  !*****************************************************************************
  !  Changes, Bernd C. Krueger, Feb. 2001:
  !   Variables tth and qvh (on eta coordinates) from common block
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! nx,ny,nz                        field dimensions in x,y and z direction    *
  ! uu(0:nxmax,0:nymax,nzmax,2)     wind components in x-direction [m/s]       *
  ! vv(0:nxmax,0:nymax,nzmax,2)     wind components in y-direction [m/s]       *
  ! ww(0:nxmax,0:nymax,nzmax,2)     wind components in z-direction [deltaeta/s]*
  ! tt(0:nxmax,0:nymax,nzmax,2)     temperature [K]                            *
  ! pv(0:nxmax,0:nymax,nzmax,2)     potential voriticity (pvu)                 *
  ! ps(0:nxmax,0:nymax,2)           surface pressure [Pa]                      *
  ! clouds(0:nxmax,0:nymax,0:nzmax,2) cloud field for wet deposition           *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use cmapf_mod

  implicit none

  integer :: ix,jy,kz,iz,n,kmin,kl,klp,ix1,jy1,ixp,jyp,ixm,jym
  integer :: rain_cloud_above,kz_inv
  real :: f_qvsat,pressure
  real :: rh,lsp,convp
  real :: uvzlev(nuvzmax),rhoh(nuvzmax),pinmconv(nzmax)
  real :: ew,pint,tv,tvold,pold,dz1,dz2,dz,ui,vi
  real :: xlon,ylat,xlonr,dzdx,dzdy
  real :: dzdx1,dzdx2,dzdy1,dzdy2
  real :: uuaux,vvaux,uupolaux,vvpolaux,ddpol,ffpol,wdummy
  real :: uuh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: vvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: pvh(0:nxmax-1,0:nymax-1,nuvzmax)
  real :: wwh(0:nxmax-1,0:nymax-1,nwzmax)
  real :: wzlev(nwzmax),uvwzlev(0:nxmax-1,0:nymax-1,nzmax)
  real,parameter :: const=r_air/ga

  ! NCEP version
  integer :: llev, i

  logical :: init = .true.


  !*************************************************************************
  ! If verttransform is called the first time, initialize heights of the   *
  ! z levels in meter. The heights are the heights of model levels, where  *
  ! u,v,T and qv are given, and of the interfaces, where w is given. So,   *
  ! the vertical resolution in the z system is doubled. As reference point,*
  ! the lower left corner of the grid is used.                             *
  ! Unlike in the eta system, no difference between heights for u,v and    *
  ! heights for w exists.                                                  *
  !*************************************************************************

  if (init) then

  ! Search for a point with high surface pressure (i.e. not above significant topography)
  ! Then, use this point to construct a reference z profile, to be used at all times
  !*****************************************************************************

    do jy=0,nymin1
      do ix=0,nxmin1
        if (ps(ix,jy,1,n).gt.100000.) then
          ixm=ix
          jym=jy
          goto 3
        endif
      end do
    end do
3   continue


    tvold=tt2(ixm,jym,1,n)*(1.+0.378*ew(td2(ixm,jym,1,n))/ &
         ps(ixm,jym,1,n))
    pold=ps(ixm,jym,1,n)
    height(1)=0.

    do kz=2,nuvz
      pint=akz(kz)+bkz(kz)*ps(ixm,jym,1,n)
      tv=tth(ixm,jym,kz,n)*(1.+0.608*qvh(ixm,jym,kz,n))


  ! NOTE: In FLEXPART versions up to 4.0, the number of model levels was doubled
  ! upon the transformation to z levels. In order to save computer memory, this is
  ! not done anymore in the standard version. However, this option can still be
  ! switched on by replacing the following lines with those below, that are
  ! currently commented out.
  ! Note that two more changes are necessary in this subroutine below.
  ! One change is also necessary in gridcheck.f, and another one in verttransform_nests.
  !*****************************************************************************

      if (abs(tv-tvold).gt.0.2) then
        height(kz)= &
             height(kz-1)+const*log(pold/pint)* &
             (tv-tvold)/log(tv/tvold)
      else
        height(kz)=height(kz-1)+ &
             const*log(pold/pint)*tv
      endif

  ! Switch on following lines to use doubled vertical resolution
  !*************************************************************
  !    if (abs(tv-tvold).gt.0.2) then
  !      height((kz-1)*2)=
  !    +      height(max((kz-2)*2,1))+const*log(pold/pint)*
  !    +      (tv-tvold)/log(tv/tvold)
  !    else
  !      height((kz-1)*2)=height(max((kz-2)*2,1))+
  !    +      const*log(pold/pint)*tv
  !    endif
  ! End doubled vertical resolution

      tvold=tv
      pold=pint
    end do


  ! Switch on following lines to use doubled vertical resolution
  !*************************************************************
  !  do 7 kz=3,nz-1,2
  !    height(kz)=0.5*(height(kz-1)+height(kz+1))
  !  height(nz)=height(nz-1)+height(nz-1)-height(nz-2)
  ! End doubled vertical resolution


  ! Determine highest levels that can be within PBL
  !************************************************

    do kz=1,nz
      if (height(kz).gt.hmixmax) then
        nmixz=kz
        goto 9
      endif
    end do
9   continue

  ! Do not repeat initialization of the Cartesian z grid
  !*****************************************************

    init=.false.

  endif


  ! Loop over the whole grid
  !*************************

  do jy=0,nymin1
    do ix=0,nxmin1

  ! NCEP version: find first level above ground
      llev = 0
      do i=1,nuvz
       if (ps(ix,jy,1,n).lt.akz(i)) llev=i
      end do
       llev = llev+1
       if (llev.gt.nuvz-2) llev = nuvz-2
  !     if (llev.eq.nuvz-2) write(*,*) 'verttransform
  !    +WARNING: LLEV eq NUZV-2'
  ! NCEP version


  ! compute height of pressure levels above ground
  !***********************************************

      tvold=tth(ix,jy,llev,n)*(1.+0.608*qvh(ix,jy,llev,n))
      pold=akz(llev)
      uvzlev(llev)=0.
      wzlev(llev)=0.
      uvwzlev(ix,jy,llev)=0.
      rhoh(llev)=pold/(r_air*tvold)

      do kz=llev+1,nuvz
        pint=akz(kz)+bkz(kz)*ps(ix,jy,1,n)
        tv=tth(ix,jy,kz,n)*(1.+0.608*qvh(ix,jy,kz,n))
        rhoh(kz)=pint/(r_air*tv)

        if (abs(tv-tvold).gt.0.2) then
          uvzlev(kz)=uvzlev(kz-1)+const*log(pold/pint)* &
               (tv-tvold)/log(tv/tvold)
        else
          uvzlev(kz)=uvzlev(kz-1)+const*log(pold/pint)*tv
        endif
        wzlev(kz)=uvzlev(kz)
        uvwzlev(ix,jy,kz)=uvzlev(kz)

        tvold=tv
        pold=pint
      end do


  ! Switch on following lines to use doubled vertical resolution
  ! Switch off the three lines above.
  !*************************************************************
  !22          uvwzlev(ix,jy,(kz-1)*2)=uvzlev(kz)
  !     do 23 kz=2,nwz
  !23          uvwzlev(ix,jy,(kz-1)*2+1)=wzlev(kz)
  ! End doubled vertical resolution

  ! pinmconv=(h2-h1)/(p2-p1)

      pinmconv(llev)=(uvwzlev(ix,jy,llev+1)-uvwzlev(ix,jy,llev))/ &
           ((aknew(llev+1)+bknew(llev+1)*ps(ix,jy,1,n))- &
           (aknew(llev)+bknew(llev)*ps(ix,jy,1,n)))
      do kz=llev+1,nz-1
        pinmconv(kz)=(uvwzlev(ix,jy,kz+1)-uvwzlev(ix,jy,kz-1))/ &
             ((aknew(kz+1)+bknew(kz+1)*ps(ix,jy,1,n))- &
             (aknew(kz-1)+bknew(kz-1)*ps(ix,jy,1,n)))
      end do
      pinmconv(nz)=(uvwzlev(ix,jy,nz)-uvwzlev(ix,jy,nz-1))/ &
           ((aknew(nz)+bknew(nz)*ps(ix,jy,1,n))- &
           (aknew(nz-1)+bknew(nz-1)*ps(ix,jy,1,n)))


  ! Levels, where u,v,t and q are given
  !************************************

      uu(ix,jy,1,n)=uuh(ix,jy,llev)
      vv(ix,jy,1,n)=vvh(ix,jy,llev)
      tt(ix,jy,1,n)=tth(ix,jy,llev,n)
      qv(ix,jy,1,n)=qvh(ix,jy,llev,n)
      pv(ix,jy,1,n)=pvh(ix,jy,llev)
      rho(ix,jy,1,n)=rhoh(llev)
      pplev(ix,jy,1,n)=akz(llev)
      uu(ix,jy,nz,n)=uuh(ix,jy,nuvz)
      vv(ix,jy,nz,n)=vvh(ix,jy,nuvz)
      tt(ix,jy,nz,n)=tth(ix,jy,nuvz,n)
      qv(ix,jy,nz,n)=qvh(ix,jy,nuvz,n)
      pv(ix,jy,nz,n)=pvh(ix,jy,nuvz)
      rho(ix,jy,nz,n)=rhoh(nuvz)
      pplev(ix,jy,nz,n)=akz(nuvz)
      kmin=llev+1
      do iz=2,nz-1
        do kz=kmin,nuvz
          if(height(iz).gt.uvzlev(nuvz)) then
            uu(ix,jy,iz,n)=uu(ix,jy,nz,n)
            vv(ix,jy,iz,n)=vv(ix,jy,nz,n)
            tt(ix,jy,iz,n)=tt(ix,jy,nz,n)
            qv(ix,jy,iz,n)=qv(ix,jy,nz,n)
            pv(ix,jy,iz,n)=pv(ix,jy,nz,n)
            rho(ix,jy,iz,n)=rho(ix,jy,nz,n)
            pplev(ix,jy,iz,n)=pplev(ix,jy,nz,n)
            goto 30
          endif
          if ((height(iz).gt.uvzlev(kz-1)).and. &
               (height(iz).le.uvzlev(kz))) then
           dz1=height(iz)-uvzlev(kz-1)
           dz2=uvzlev(kz)-height(iz)
           dz=dz1+dz2
           uu(ix,jy,iz,n)=(uuh(ix,jy,kz-1)*dz2+uuh(ix,jy,kz)*dz1)/dz
           vv(ix,jy,iz,n)=(vvh(ix,jy,kz-1)*dz2+vvh(ix,jy,kz)*dz1)/dz
           tt(ix,jy,iz,n)=(tth(ix,jy,kz-1,n)*dz2 &
                +tth(ix,jy,kz,n)*dz1)/dz
           qv(ix,jy,iz,n)=(qvh(ix,jy,kz-1,n)*dz2 &
                +qvh(ix,jy,kz,n)*dz1)/dz
           pv(ix,jy,iz,n)=(pvh(ix,jy,kz-1)*dz2+pvh(ix,jy,kz)*dz1)/dz
           rho(ix,jy,iz,n)=(rhoh(kz-1)*dz2+rhoh(kz)*dz1)/dz
           pplev(ix,jy,iz,n)=(akz(kz-1)*dz2+akz(kz)*dz1)/dz
          endif
        end do
30      continue
      end do


  ! Levels, where w is given
  !*************************

      ww(ix,jy,1,n)=wwh(ix,jy,llev)*pinmconv(llev)
      ww(ix,jy,nz,n)=wwh(ix,jy,nwz)*pinmconv(nz)
      kmin=llev+1
      do iz=2,nz
        do kz=kmin,nwz
          if ((height(iz).gt.wzlev(kz-1)).and. &
               (height(iz).le.wzlev(kz))) then
           dz1=height(iz)-wzlev(kz-1)
           dz2=wzlev(kz)-height(iz)
           dz=dz1+dz2
           ww(ix,jy,iz,n)=(wwh(ix,jy,kz-1)*pinmconv(kz-1)*dz2 &
                +wwh(ix,jy,kz)*pinmconv(kz)*dz1)/dz

          endif
        end do
      end do


  ! Compute density gradients at intermediate levels
  !*************************************************

      drhodz(ix,jy,1,n)=(rho(ix,jy,2,n)-rho(ix,jy,1,n))/ &
           (height(2)-height(1))
      do kz=2,nz-1
        drhodz(ix,jy,kz,n)=(rho(ix,jy,kz+1,n)-rho(ix,jy,kz-1,n))/ &
             (height(kz+1)-height(kz-1))
      end do
      drhodz(ix,jy,nz,n)=drhodz(ix,jy,nz-1,n)

    end do
  end do


  !****************************************************************
  ! Compute slope of eta levels in windward direction and resulting
  ! vertical wind correction
  !****************************************************************

  do jy=1,ny-2
    do ix=1,nx-2

  ! NCEP version: find first level above ground
      llev = 0
      do i=1,nuvz
       if (ps(ix,jy,1,n).lt.akz(i)) llev=i
      end do
       llev = llev+1
       if (llev.gt.nuvz-2) llev = nuvz-2
  !     if (llev.eq.nuvz-2) write(*,*) 'verttransform
  !    +WARNING: LLEV eq NUZV-2'
  ! NCEP version

      kmin=llev+1
      do iz=2,nz-1

        ui=uu(ix,jy,iz,n)*dxconst/cos((real(jy)*dy+ylat0)*pi180)
        vi=vv(ix,jy,iz,n)*dyconst

        do kz=kmin,nz
          if ((height(iz).gt.uvwzlev(ix,jy,kz-1)).and. &
               (height(iz).le.uvwzlev(ix,jy,kz))) then
            dz1=height(iz)-uvwzlev(ix,jy,kz-1)
            dz2=uvwzlev(ix,jy,kz)-height(iz)
            dz=dz1+dz2
            kl=kz-1
            klp=kz
            goto 47
          endif
        end do

47      ix1=ix-1
        jy1=jy-1
        ixp=ix+1
        jyp=jy+1

        dzdx1=(uvwzlev(ixp,jy,kl)-uvwzlev(ix1,jy,kl))/2.
        dzdx2=(uvwzlev(ixp,jy,klp)-uvwzlev(ix1,jy,klp))/2.
        dzdx=(dzdx1*dz2+dzdx2*dz1)/dz

        dzdy1=(uvwzlev(ix,jyp,kl)-uvwzlev(ix,jy1,kl))/2.
        dzdy2=(uvwzlev(ix,jyp,klp)-uvwzlev(ix,jy1,klp))/2.
        dzdy=(dzdy1*dz2+dzdy2*dz1)/dz

        ww(ix,jy,iz,n)=ww(ix,jy,iz,n)+(dzdx*ui+dzdy*vi)

      end do

    end do
  end do


  ! If north pole is in the domain, calculate wind velocities in polar
  ! stereographic coordinates
  !*******************************************************************

  if (nglobal) then
    do jy=int(switchnorthg)-2,nymin1
      ylat=ylat0+real(jy)*dy
      do ix=0,nxmin1
        xlon=xlon0+real(ix)*dx
        do iz=1,nz
          call cc2gll(northpolemap,ylat,xlon,uu(ix,jy,iz,n), &
               vv(ix,jy,iz,n),uupol(ix,jy,iz,n), &
               vvpol(ix,jy,iz,n))
        end do
      end do
    end do


    do iz=1,nz

  ! CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uu(nx/2-1,nymin1,iz,n)**2+ &
           vv(nx/2-1,nymin1,iz,n)**2)
      if(vv(nx/2-1,nymin1,iz,n).lt.0.) then
        ddpol=atan(uu(nx/2-1,nymin1,iz,n)/ &
             vv(nx/2-1,nymin1,iz,n))-xlonr
      elseif (vv(nx/2-1,nymin1,iz,n).gt.0.) then
        ddpol=pi+atan(uu(nx/2-1,nymin1,iz,n)/ &
             vv(nx/2-1,nymin1,iz,n))-xlonr
      else
        ddpol=pi/2-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
      if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

  ! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.0
      xlonr=xlon*pi/180.
      ylat=90.0
      uuaux=-ffpol*sin(xlonr+ddpol)
      vvaux=-ffpol*cos(xlonr+ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux, &
           vvpolaux)

      jy=nymin1
      do ix=0,nxmin1
        uupol(ix,jy,iz,n)=uupolaux
        vvpol(ix,jy,iz,n)=vvpolaux
      end do
    end do


  ! Fix: Set W at pole to the zonally averaged W of the next equator-
  ! ward parallel of latitude

  do iz=1,nz
      wdummy=0.
      jy=ny-2
      do ix=0,nxmin1
        wdummy=wdummy+ww(ix,jy,iz,n)
      end do
      wdummy=wdummy/real(nx)
      jy=nymin1
      do ix=0,nxmin1
        ww(ix,jy,iz,n)=wdummy
      end do
  end do

  endif


  ! If south pole is in the domain, calculate wind velocities in polar
  ! stereographic coordinates
  !*******************************************************************

  if (sglobal) then
    do jy=0,int(switchsouthg)+3
      ylat=ylat0+real(jy)*dy
      do ix=0,nxmin1
        xlon=xlon0+real(ix)*dx
        do iz=1,nz
          call cc2gll(southpolemap,ylat,xlon,uu(ix,jy,iz,n), &
               vv(ix,jy,iz,n),uupol(ix,jy,iz,n), &
               vvpol(ix,jy,iz,n))
        end do
      end do
    end do

    do iz=1,nz

  ! CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
      xlon=xlon0+real(nx/2-1)*dx
      xlonr=xlon*pi/180.
      ffpol=sqrt(uu(nx/2-1,0,iz,n)**2+ &
           vv(nx/2-1,0,iz,n)**2)
      if(vv(nx/2-1,0,iz,n).lt.0.) then
        ddpol=atan(uu(nx/2-1,0,iz,n)/ &
             vv(nx/2-1,0,iz,n))+xlonr
      elseif (vv(nx/2-1,0,iz,n).gt.0.) then
        ddpol=pi+atan(uu(nx/2-1,0,iz,n)/ &
             vv(nx/2-1,0,iz,n))-xlonr
      else
        ddpol=pi/2-xlonr
      endif
      if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
      if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

  ! CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
      xlon=180.0
      xlonr=xlon*pi/180.
      ylat=-90.0
      uuaux=+ffpol*sin(xlonr-ddpol)
      vvaux=-ffpol*cos(xlonr-ddpol)
      call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux, &
           vvpolaux)

      jy=0
      do ix=0,nxmin1
        uupol(ix,jy,iz,n)=uupolaux
        vvpol(ix,jy,iz,n)=vvpolaux
      end do
    end do


  ! Fix: Set W at pole to the zonally averaged W of the next equator-
  ! ward parallel of latitude

    do iz=1,nz
      wdummy=0.
      jy=1
      do ix=0,nxmin1
        wdummy=wdummy+ww(ix,jy,iz,n)
      end do
      wdummy=wdummy/real(nx)
      jy=0
      do ix=0,nxmin1
        ww(ix,jy,iz,n)=wdummy
      end do
    end do
  endif


  !   write (*,*) 'initializing clouds, n:',n,nymin1,nxmin1,nz
  !   create a cloud and rainout/washout field, clouds occur where rh>80%
  !   total cloudheight is stored at level 0
  do jy=0,nymin1
    do ix=0,nxmin1
      rain_cloud_above=0
      lsp=lsprec(ix,jy,1,n)
      convp=convprec(ix,jy,1,n)
      cloudsh(ix,jy,n)=0
      do kz_inv=1,nz-1
         kz=nz-kz_inv+1
         pressure=rho(ix,jy,kz,n)*r_air*tt(ix,jy,kz,n)
         rh=qv(ix,jy,kz,n)/f_qvsat(pressure,tt(ix,jy,kz,n))
         clouds(ix,jy,kz,n)=0
         if (rh.gt.0.8) then ! in cloud
            if ((lsp.gt.0.01).or.(convp.gt.0.01)) then ! cloud and precipitation
               rain_cloud_above=1
               cloudsh(ix,jy,n)=cloudsh(ix,jy,n)+ &
                    height(kz)-height(kz-1)
               if (lsp.ge.convp) then
                  clouds(ix,jy,kz,n)=3 ! lsp dominated rainout
               else
                  clouds(ix,jy,kz,n)=2 ! convp dominated rainout
               endif
            else ! no precipitation
                  clouds(ix,jy,kz,n)=1 ! cloud
            endif
         else ! no cloud
            if (rain_cloud_above.eq.1) then ! scavenging
               if (lsp.ge.convp) then
                  clouds(ix,jy,kz,n)=5 ! lsp dominated washout
               else
                  clouds(ix,jy,kz,n)=4 ! convp dominated washout
               endif
            endif
         endif
      end do
    end do
  end do


end subroutine verttransform

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine ohreaction(itime,ltsample,loutnext)
  !                     i      i        i
  !*****************************************************************************
  !                                                                            *
  !                                                                            *
  !    Author: S. Eckhardt                                                     *
  !                                                                            *
  !    June 2007                                                               *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************
  ! Variables:                                                                 *
  ! ix,jy              indices of output grid cell for each particle           *
  ! itime [s]          actual simulation time [s]                              *
  ! jpart              particle index                                          *
  ! ldeltat [s]        interval since radioactive decay was computed           *
  ! loutnext [s]       time for which gridded deposition is next output        *
  ! loutstep [s]       interval at which gridded deposition is output          *
  ! oh_average [mol/m^3]   OH Concentration                                    *
  ! ltsample [s]       interval over which mass is deposited                   *
  !                                                                            *
  !*****************************************************************************

  use oh_mod
  use par_mod
  use com_mod

  implicit none

  integer :: jpart,itime,ltsample,loutnext,ldeltat,j,k,ix,jy
  integer :: ngrid,il,interp_time,n,mm,indz,i
  integer :: jjjjmmdd,ihmmss,OHx,OHy,dOHx,dOHy,OHz
  real :: xtn,ytn,oh_average
  !real oh_diurn_var,sum_ang
  !real zenithangle, ang
  real :: restmass,ohreacted,OHinc
  real :: xlon, ylat, gas_const, act_energy
  real :: ohreact_temp_corr, act_temp
  real,parameter :: smallnum = tiny(0.0) ! smallest number that can be handled
  real(kind=dp) :: jul

  ! Compute interval since radioactive decay of deposited mass was computed
  !************************************************************************

  gas_const=8.314 ! define gas constant
  act_energy=10000 ! activation energy

  !write(*,*) 'OH reaction n:',n,ohreact(1)
  if (itime.le.loutnext) then
    ldeltat=itime-(loutnext-loutstep)
  else                                  ! first half of next interval
    ldeltat=itime-loutnext
  endif


    dOHx=360/(maxxOH-1)
    dOHy=180/(maxyOH-1)

    jul=bdate+real(itime,kind=dp)/86400._dp
    call caldate(jul,jjjjmmdd,ihmmss)
    mm=int((jjjjmmdd-(jjjjmmdd/10000)*10000)/100)

    do jpart=1,numpart

  ! Determine which nesting level to be used
  !*****************************************

    ngrid=0
    do j=numbnests,1,-1
      if ((xtra1(jpart).gt.xln(j)).and.(xtra1(jpart).lt.xrn(j)).and. &
           (ytra1(jpart).gt.yln(j)).and.(ytra1(jpart).lt.yrn(j))) then
        ngrid=j
        goto 23
      endif
    end do
23   continue


  ! Determine nested grid coordinates
  !**********************************

    if (ngrid.gt.0) then
      xtn=(xtra1(jpart)-xln(ngrid))*xresoln(ngrid)
      ytn=(ytra1(jpart)-yln(ngrid))*yresoln(ngrid)
      ix=int(xtn)
      jy=int(ytn)
    else
      ix=int(xtra1(jpart))
      jy=int(ytra1(jpart))
    endif

  n=2
  if (abs(memtime(1)-interp_time).lt.abs(memtime(2)-interp_time)) &
       n=1

  do i=2,nz
    if (height(i).gt.ztra1(jpart)) then
      indz=i-1
      goto 6
    endif
  end do
6   continue

  ! The concentration from the nearest available gridcell is taken
  ! get OH concentration for the specific month and solar angle

  !  write(*,*) OH_field(1,1,1,1),OH_field(10,1,1,10)
  !  write(*,*) OH_field(1,maxxOH-1,maxyOH-1,1)
  !  write(*,*) OH_field(10,maxxOH-1,maxyOH-1,10)
  !  write(*,*) OH_field_height(1,10,4,1),OH_field_height(10,4,10,10)
  !  write(*,*) OH_field_height(1,maxxOH-1,maxyOH-1,1)
  !  write(*,*) OH_field_height(10,maxxOH-1,maxyOH-1,10)
    interp_time=nint(itime-0.5*ltsample)

  ! World coordinates
    xlon=xtra1(jpart)*dx+xlon0
    if (xlon.gt.180) then
       xlon=xlon-360
    endif
    ylat=ytra1(jpart)*dy+ylat0
  ! get position in the OH field - assume that the OH field is global
    OHx=(180+xlon-1)/dOHx
    OHy=(90+ylat-1)/dOHy
  !  sum_ang=0
  ! get the level of the OH height field were the actual particle is in
  ! ztra1 is the z-coordinate of the trajectory above model orography in m
  ! OH_field_height is the heigth of the OH field above orography
      OHz=maxzOH
  ! assume equally distrib. OH field, OH_field_height gives the middle of
  ! the z coordinate
      OHinc=(OH_field_height(3)-OH_field_height(2))/2
      do il=2,maxzOH+1
        if ((OH_field_height(il-1)+OHinc).gt.ztra1(jpart)) goto 26
      end do
26     continue

     OHz=il-1
  !   loop was not interrupted il would be 8 (9-1)
     if (OHz.gt.maxzOH) OHz=7
  !   write (*,*) 'OH height: '
  !    +        ,ztra1(jpart),jpart,OHz,OH_field_height(OHz),OHinc,
  !    +        OH_field_height

    oh_average=OH_field(mm,OHx,OHy,OHz)
    if (oh_average.gt.smallnum) then
  !**********************************************************
  ! if there is noOH concentration no reaction
  ! for performance reason take average concentration and
  ! ignore diurnal variation
  ! do 28 il=1,24
  !      ang=70-zenithangle(ylat,xlon,jul+(24-il)/24.)
  !      if (ang.lt.0) then
  !          ang=0
  !      endif
  !      sum_ang=sum_ang+ang
  !28         enddo
  !    oh_diurn_var=(ang/sum_ang)*(oh_average*24)
  !    oh_average=oh_diurn_var
  !**********************************************************


  !    Computation of the OH reaction
  !**********************************************************
    act_temp=tt(ix,jy,indz,n)

    do k=1,nspec                                  ! loop over species
      if (ohreact(k).gt.0.) then
        ohreact_temp_corr=ohreact(k)*oh_average* &
             exp((act_energy/gas_const)*(1/298.15-1/act_temp))
        ohreacted=xmass1(jpart,k)* &
             (1.-exp(-1*ohreact_temp_corr*abs(ltsample)))
  !      new particle mass:
        restmass = xmass1(jpart,k)-ohreacted
        if (restmass .gt. smallnum) then
          xmass1(jpart,k)=restmass
  !   write (104) xlon,ylat,ztra1(jpart),k,oh_diurn_var,jjjjmmdd,
  !    +               ihmmss,restmass,ohreacted
        else
          xmass1(jpart,k)=0.
        endif
  !      write (*,*) 'restmass: ',restmass
      else
        ohreacted=0.
      endif
    end do

  endif
  !endif OH concentration gt 0
    end do
  !continue loop over all particles

end subroutine ohreaction

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later

module flux_mod

  ! flux eastward, westward, northward, southward, upward and downward
  ! fluxes of all species and all ageclasses
  ! areaeast,areanorth [m2] side areas of each grid cell
  use outgrid_mod
  use par_mod
  use com_mod
  use windfields_mod

  implicit none

  !Moved to outgrid_mod, because of dependencies
  ! real,allocatable, dimension (:,:,:,:,:,:,:) :: flux 

  !1 fluxw west - east
  !2 fluxe east - west
  !3 fluxs south - north
  !4 fluxn north - south
  !5 fluxu upward
  !6 fluxd downward
  !real,allocatable, dimension (:,:,:) :: areanorth
  !real,allocatable, dimension (:,:,:) :: areaeast

contains

subroutine calcfluxes(itime,nage,jpart,xold,yold,zold,thread)
  !                       i     i    i    i    i
  !*****************************************************************************
  !                                                                            *
  !     Calculation of the gross fluxes across horizontal, eastward and        *
  !     northward facing surfaces. The routine calculates the mass flux        *
  !     due to the motion of only one particle. The fluxes of subsequent calls *
  !     to this subroutine are accumulated until the next output is due.       *
  !     Upon output, flux fields are re-set to zero in subroutine fluxoutput.f.*
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     04 April 2000                                                          *
  !                                                                            *
  !     Changes                                                                *
  !        2021 L. Bakels: OpenMP parallelisation                              *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  !                                                                            *
  ! nage                  Age class of the particle considered                 *
  ! jpart                 Index of the particle considered                     *
  ! xold,yold,zold        "Memorized" old positions of the particle            *
  !                                                                            *
  !*****************************************************************************
  
  use particle_mod
#ifdef ETA
  use coord_ecmwf_mod
#endif

  implicit none
  integer, intent(in) :: thread ! for OMP, number of thread
  integer :: itime,jpart,nage,ixave,jyave,kz,kzave,kp
  integer :: k,k1,k2,ix,ix1,ix2,ixs,jy,jy1,jy2
  real :: xold,yold,zold,xmean,ymean


  ! Determine average positions
  !****************************

  if ((ioutputforeachrelease.eq.1).and.(mdomainfill.eq.0)) then
     kp=part(jpart)%npoint
  else
     kp=1
  endif

#ifdef ETA
  call update_zeta_to_z(itime,jpart)
#endif
  xmean=(xold+real(part(jpart)%xlon))*0.5
  ymean=(yold+real(part(jpart)%ylat))*0.5

  ixave=int((xmean*dx+xoutshift)/dxout)
  jyave=int((ymean*dy+youtshift)/dyout)
  do kz=1,numzgrid                ! determine height of cell
    if (outheight(kz).gt.part(jpart)%z) exit
  end do
  kzave=kz


  ! Determine vertical fluxes
  !**************************

  if ((ixave.ge.0).and.(jyave.ge.0).and.(ixave.le.numxgrid-1).and. &
       (jyave.le.numygrid-1)) then
    do kz=1,numzgrid                ! determine height of cell
      if (outheighthalf(kz).gt.zold) exit
    end do
    k1=min(numzgrid,kz)
    do kz=1,numzgrid                ! determine height of cell
      if (outheighthalf(kz).gt.part(jpart)%z) exit
    end do
    k2=min(numzgrid,kz)

    do k=1,nspec
      do kz=k1,k2-1
#ifdef _OPENMP
        flux_omp(5,ixave,jyave,kz,k,kp,nage,thread)= &
             flux_omp(5,ixave,jyave,kz,k,kp,nage,thread)+ &
             mass(jpart,k)
#else
        flux(5,ixave,jyave,kz,k,kp,nage)= &
             flux(5,ixave,jyave,kz,k,kp,nage)+ &
             mass(jpart,k)
#endif
      end do
      do kz=k2,k1-1
#ifdef _OPENMP
        flux_omp(6,ixave,jyave,kz,k,kp,nage,thread)= &
             flux_omp(6,ixave,jyave,kz,k,kp,nage,thread)+ &
             mass(jpart,k)
#else
        flux(6,ixave,jyave,kz,k,kp,nage)= &
             flux(6,ixave,jyave,kz,k,kp,nage)+ &
             mass(jpart,k)
#endif
      end do
    end do
  endif


  ! Determine west-east fluxes (fluxw) and east-west fluxes (fluxe)
  !****************************************************************

  if ((kzave.le.numzgrid).and.(jyave.ge.0).and. &
       (jyave.le.numygrid-1)) then

  ! 1) Particle does not cross domain boundary

    if (abs(xold-part(jpart)%xlon).lt.real(nx)*0.5) then
      ix1=int((xold*dx+xoutshift)/dxout+0.5)
      ix2=int((part(jpart)%xlon*dx+xoutshift)/dxout+0.5)
      do k=1,nspec
        do ix=ix1,ix2-1
          if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
#ifdef _OPENMP
            flux_omp(1,ix,jyave,kzave,k,kp,nage,thread)= &
                 flux_omp(1,ix,jyave,kzave,k,kp,nage,thread) &
                 +mass(jpart,k)
#else
            flux(1,ix,jyave,kzave,k,kp,nage)= &
                 flux(1,ix,jyave,kzave,k,kp,nage) &
                 +mass(jpart,k)
#endif
          endif
        end do
        do ix=ix2,ix1-1
          if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
#ifdef _OPENMP
            flux_omp(2,ix,jyave,kzave,k,kp,nage,thread)= &
                 flux_omp(2,ix,jyave,kzave,k,kp,nage,thread) &
                 +mass(jpart,k)
#else
            flux(2,ix,jyave,kzave,k,kp,nage)= &
                 flux(2,ix,jyave,kzave,k,kp,nage) &
                 +mass(jpart,k)
#endif
          endif
        end do
      end do

  ! 2) Particle crosses domain boundary: use cyclic boundary condition
  !    and attribute flux to easternmost grid row only (approximation valid
  !    for relatively slow motions compared to output grid cell size)

    else
      ixs=int(((real(nxmin1)-1.e5)*dx+xoutshift)/dxout)
      if ((ixs.ge.0).and.(ixs.le.numxgrid-1)) then
        if (xold.gt.part(jpart)%xlon) then       ! west-east flux
          do k=1,nspec
#ifdef _OPENMP
            flux_omp(1,ixs,jyave,kzave,k,kp,nage,thread)= &
                 flux_omp(1,ixs,jyave,kzave,k,kp,nage,thread) &
                 +mass(jpart,k)
#else
            flux(1,ixs,jyave,kzave,k,kp,nage)= &
                 flux(1,ixs,jyave,kzave,k,kp,nage) &
                 +mass(jpart,k)
#endif
          end do
        else                                 ! east-west flux
          do k=1,nspec
#ifdef _OPENMP
            flux_omp(2,ixs,jyave,kzave,k,kp,nage,thread)= &
                 flux_omp(2,ixs,jyave,kzave,k,kp,nage,thread) &
                 +mass(jpart,k)
#else
            flux(2,ixs,jyave,kzave,k,kp,nage)= &
                 flux(2,ixs,jyave,kzave,k,kp,nage) &
                 +mass(jpart,k)
#endif
          end do
        endif
      endif
    endif
  endif


  ! Determine south-north fluxes (fluxs) and north-south fluxes (fluxn)
  !********************************************************************

  if ((kzave.le.numzgrid).and.(ixave.ge.0).and. &
       (ixave.le.numxgrid-1)) then
    jy1=int((yold*dy+youtshift)/dyout+0.5)
    jy2=int((part(jpart)%ylat*dy+youtshift)/dyout+0.5)

    do k=1,nspec
      do jy=jy1,jy2-1
        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
#ifdef _OPENMP
          flux_omp(3,ixave,jy,kzave,k,kp,nage,thread)= &
               flux_omp(3,ixave,jy,kzave,k,kp,nage,thread) &
               +mass(jpart,k)
#else
          flux(3,ixave,jy,kzave,k,kp,nage)= &
               flux(3,ixave,jy,kzave,k,kp,nage) &
               +mass(jpart,k)
#endif
        endif
      end do
      do jy=jy2,jy1-1
        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
#ifdef _OPENMP
          flux_omp(4,ixave,jy,kzave,k,kp,nage,thread)= &
               flux_omp(4,ixave,jy,kzave,k,kp,nage,thread) &
               +mass(jpart,k)
#else
          flux(4,ixave,jy,kzave,k,kp,nage)= &
               flux(4,ixave,jy,kzave,k,kp,nage) &
               +mass(jpart,k)
#endif
        endif
      end do
    end do
  endif
end subroutine calcfluxes

subroutine fluxoutput(itime)
  !                        i
  !*****************************************************************************
  !                                                                            *
  !     Output of the gridded fluxes.                                          *
  !     Eastward, westward, northward, southward, upward and downward gross    *
  !     fluxes are written to output file in either sparse matrix or grid dump *
  !     format, whichever is more efficient.                                   *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     04 April 2000                                                          *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! ncellse         number of cells with non-zero values for eastward fluxes   *
  ! sparsee         .true. if in sparse matrix format, else .false.            *
  !                                                                            *
  !*****************************************************************************
  use date_mod
  
  implicit none

  real(kind=dp) :: jul
  integer :: itime,ix,jy,kz,k,nage,jjjjmmdd,ihmmss,kp,i
  integer :: ncellse(maxspec,nageclass),ncellsw(maxspec,nageclass)
  integer :: ncellss(maxspec,nageclass),ncellsn(maxspec,nageclass)
  integer :: ncellsu(maxspec,nageclass),ncellsd(maxspec,nageclass)
  logical :: sparsee(maxspec,nageclass),sparsew(maxspec,nageclass)
  logical :: sparses(maxspec,nageclass),sparsen(maxspec,nageclass)
  logical :: sparseu(maxspec,nageclass),sparsed(maxspec,nageclass)
  character :: adate*8,atime*6


  ! Determine current calendar date, needed for the file name
  !**********************************************************

  jul=bdate+real(itime,kind=dp)/86400._dp
  call caldate(jul,jjjjmmdd,ihmmss)
  write(adate,'(i8.8)') jjjjmmdd
  write(atime,'(i6.6)') ihmmss


  open(unitflux,file=path(2)(1:length(2))//'grid_flux_'//adate// &
       atime,form='unformatted')

  !**************************************************************
  ! Check, whether output of full grid or sparse matrix format is
  ! more efficient in terms of storage space. This is checked for
  ! every species and for every age class
  !**************************************************************

  do k=1,nspec
    do nage=1,nageclass
      ncellse(k,nage)=0
      ncellsw(k,nage)=0
      ncellsn(k,nage)=0
      ncellss(k,nage)=0
      ncellsu(k,nage)=0
      ncellsd(k,nage)=0
    end do
  end do

  do k=1,nspec
  do kp=1,maxpointspec_act
    do nage=1,nageclass
      do jy=0,numygrid-1
        do ix=0,numxgrid-1
          do kz=1,numzgrid
            if (flux(2,ix,jy,kz,k,kp,nage).gt.0) ncellse(k,nage)= &
                 ncellse(k,nage)+1
            if (flux(1,ix,jy,kz,k,kp,nage).gt.0) ncellsw(k,nage)= &
                 ncellsw(k,nage)+1
            if (flux(4,ix,jy,kz,k,kp,nage).gt.0) ncellsn(k,nage)= &
                 ncellsn(k,nage)+1
            if (flux(3,ix,jy,kz,k,kp,nage).gt.0) ncellss(k,nage)= &
                 ncellss(k,nage)+1
            if (flux(5,ix,jy,kz,k,kp,nage).gt.0) ncellsu(k,nage)= &
                 ncellsu(k,nage)+1
            if (flux(6,ix,jy,kz,k,kp,nage).gt.0) ncellsd(k,nage)= &
                 ncellsd(k,nage)+1
          end do
        end do
      end do
    end do
  end do
  end do

  ! Output in sparse matrix format more efficient, if less than
  ! 2/5 of all cells contains concentrations>0
  !************************************************************

  do k=1,nspec
    do nage=1,nageclass
      if (4*ncellse(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsee(k,nage)=.true.
      else
        sparsee(k,nage)=.false.
      endif
      if (4*ncellsw(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsew(k,nage)=.true.
      else
        sparsew(k,nage)=.false.
      endif
      if (4*ncellsn(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsen(k,nage)=.true.
      else
        sparsen(k,nage)=.false.
      endif
      if (4*ncellss(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparses(k,nage)=.true.
      else
        sparses(k,nage)=.false.
      endif
      if (4*ncellsu(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparseu(k,nage)=.true.
      else
        sparseu(k,nage)=.false.
      endif
      if (4*ncellsd(k,nage).lt.numxgrid*numygrid*numzgrid) then
        sparsed(k,nage)=.true.
      else
        sparsed(k,nage)=.false.
      endif
    end do
  end do



  ! Flux output: divide by area and time to get flux in ng/m2/s
  !************************************************************

  write(unitflux) itime
  do k=1,nspec
  do kp=1,maxpointspec_act
    do nage=1,nageclass

      if (sparsee(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(2,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(2,ix,jy,kz,k,kp,nage)/areaeast(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(2,ix,jy,kz,k,kp,nage)/ &
                 areaeast(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparsew(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(1,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(1,ix,jy,kz,k,kp,nage)/areaeast(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(1,ix,jy,kz,k,kp,nage)/ &
                 areaeast(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparses(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(3,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(3,ix,jy,kz,k,kp,nage)/areanorth(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(3,ix,jy,kz,k,kp,nage)/ &
                 areanorth(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparsen(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1 ! north
              if (flux(4,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(4,ix,jy,kz,k,kp,nage)/areanorth(ix,jy,kz)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(4,ix,jy,kz,k,kp,nage)/ &
                 areanorth(ix,jy,kz)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparseu(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(5,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(5,ix,jy,kz,k,kp,nage)/area(ix,jy)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(5,ix,jy,kz,k,kp,nage)/ &
                 area(ix,jy)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

      if (sparsed(k,nage)) then
        write(unitflux) 1
        do kz=1,numzgrid
          do jy=0,numygrid-1
            do ix=0,numxgrid-1
              if (flux(6,ix,jy,kz,k,kp,nage).gt.0.) write(unitflux) &
                   ix+jy*numxgrid+kz*numxgrid*numygrid,1.e12* &
                   flux(6,ix,jy,kz,k,kp,nage)/area(ix,jy)/outstep
            end do
          end do
        end do
        write(unitflux) -999,999.
      else
        write(unitflux) 2
        do kz=1,numzgrid
          do ix=0,numxgrid-1
            write(unitflux) (1.e12*flux(6,ix,jy,kz,k,kp,nage)/ &
                 area(ix,jy)/outstep,jy=0,numygrid-1)
          end do
        end do
      endif

    end do
  end do
  end do


  close(unitflux)

  write(*,*) 'Flux:', itime, flux(:,1,1,1,1,1,1)
  ! Reinitialization of grid
  !*************************

  do k=1,nspec
  do kp=1,maxpointspec_act
    do jy=0,numygrid-1
      do ix=0,numxgrid-1
          do kz=1,numzgrid
            do nage=1,nageclass
              do i=1,6
                flux(i,ix,jy,kz,k,kp,nage)=0.
#ifdef _OPENMP
                flux_omp(i,ix,jy,kz,k,kp,nage,:)=0.
#endif
              end do
            end do
          end do
      end do
    end do
  end do
  end do
end subroutine fluxoutput

end module flux_mod

! SPDX-FileCopyrightText: FLEXPART 1998-2019, see flexpart_license.txt
! SPDX-License-Identifier: GPL-3.0-or-later
module settling_mod
  
  implicit none

  integer :: re_nsteps ! Number of Reynolds number table points
  ! real, allocatable ,dimension(:) :: re_lookup, cd_lookup


  private :: viscosity
  public :: get_settling
contains

! subroutine init_dragcoeff_lookup()
!   implicit none
!   !*****************************
!   ! Clift and Guavin 1971 model*
!   !*****************************
!   real :: re_min, re_max ! Range of Reynolds numbers
!   integer :: i

!   re_nsteps=1000

!   allocate (re_lookup(re_nsteps), cd_lookup(re_nsteps))

!   ! Reynolds numbers range between 0.2 and 8000. 
!   ! Below this range, the approx of re/24 is sufficient and above 8000, the 
!   ! full equation is executed during run-time.
!   ! logarithmic spacing with a 1000 steps gives a maximum deviation of drag_coeff of
!   ! 0.07% as compared to using the full equation (mean=0.0037% deviation)
!   !**********************************************************************
!   re_min=log10(0.02)
!   re_max=log10(8000.)
!   do i=1,re_nsteps
!     re_lookup(i) = 10.**((re_max-re_min) * real(i-1) / real(re_nsteps-1) + re_min)
!   end do

!   ! Computing drag coefficients
!   !****************************
!   cd_lookup=(24.0/re_lookup)*(1+0.15*(re_lookup**0.687))+ &
!       0.42/(1.0+42500.0/(re_lookup**1.16))

! end subroutine init_dragcoeff_lookup

! subroutine find_dragcoeff(reynolds, c_drag)
!   implicit none
!   real, intent(in) :: reynolds
!   real, intent(out) :: c_drag
!   integer :: i, i_re, minsteps
!   real :: dre,dre1,dre2
!   ! This lookup table is extremely slow. For now it will just return
!   ! the function instead.


!   ! If reynolds<0.2, approximation 24/reynolds is valid
!   ! 24/reynolds makes up >99% of all components
!   !****************************************************
!   if (reynolds.le.0.02) then
!     c_drag=(24.0/reynolds)

!   else if (reynolds.gt.8000) then ! Outside of lookup table range
!     c_drag=(24.0/reynolds)*(1+0.15*(reynolds**0.687))+ &
!       0.42/(1.0+42500.0/(reynolds**1.16))

!   else
!     ! Linear search for correct indices in lookup table
!     !**************************************************
!     i_re = re_nsteps
!     do i = 0, re_nsteps
!       if (re_lookup(i).ge.reynolds) then
!         i_re=i
!         exit
!       endif
!     end do

!     ! Linear interpolation (maybe also do logarithmic?)
!     !*********************
!     if (i_re.eq.re_nsteps) then
!       c_drag=cd_lookup(re_nsteps)
!     else if (i_re.eq.1) then
!       c_drag=cd_lookup(1)
!     else
!       dre=1./(cd_lookup(i_re+1)-cd_lookup(i_re))
!       dre1=(reynolds-re_lookup(i_re))*dre
!       dre2=(re_lookup(i_re+1)-reynolds)*dre
!       c_drag=dre1*cd_lookup(i_re+1)+dre2*cd_lookup(i_re)
!     endif
!   endif

! end subroutine

subroutine get_settling(xt,yt,zt,nsp,settling)
  !                          i   i  i  i   i     o
  !*****************************************************************************
  !                                                                            *
  !  This subroutine calculates particle settling velocity.                    *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    May 2010                                                                *
  !                                                                            *
  !  Improvement over traditional settling calculation in FLEXPART:            *
  !  generalize to higher Reynolds numbers and also take into account the      *
  !  temperature dependence of dynamic viscosity.                              *
  !                                                                            *
  !  Based on:                                                                 *
  !  Naeslund E., and Thaning, L. (1991): On the settling velocity in a        *
  !  nonstationary atmosphere, Aerosol Science and Technology 14, 247-256.     *
  !                                                                            *
  !  Changes                                                                   *
  !     Daria Tatsii 2022: implementation of shape factor according to         *
  !                        Bagheri & Bonadonna 2016                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! xt,yt,zt           coordinates position for which wind data shall be cal-  *
  !                    culated                                                 *
  !                                                                            *
  ! Constants:                                                                 *
  ! dfdr               fluid density/particle density                          *
  ! Veq [m^3]           equivalent volume of a sphere                          *
  ! dcyl [m]           diameter of a cylinder (fiber)                          * 
  ! f                  flatness parameters, S/I                               *
  ! e                  elongation parameters, I/L                              *
  ! Fs                 Stokes form factor, f e^1.3                             *
  ! Fn                 Newton's  form factor                                   *
  ! Ks                 Stokes' drag correction                                 * 
  ! vsp                help variable                                           *
  ! x                  aspect ratio of cylinder height to its diameter         *
  !                                                                            *
  ! Variables:                                                                 *
  ! c_d                drag coefficient                                        *
  ! settling [m/s]     settling velocity                                       *
   !*****************************************************************************

  use par_mod
  use com_mod
  use windfields_mod

  implicit none

  integer, intent(in) :: nsp
  real, intent(in) :: xt, yt, zt
  real, intent(out) :: settling
  integer :: indz

  ! Auxiliary variables needed for interpolation
  real :: dz1,dz2,dz
  real :: rho1(2),tt1(2),temperature,airdens,vis_dyn,vis_kin
  real :: settling_old,reynolds,c_d
  integer :: i,n,nix,njy,indzh

  ! Variables needed for drag coefficient calculation
  real :: dfdr,kn,ks,alpha1,beta1,kn1

  !*****************************************************************************
  ! 1. Interpolate temperature and density: nearest neighbor interpolation sufficient
  !*****************************************************************************

  nix=int(xt)
  njy=int(yt)

  ! Determine the level below the current position for u,v
  !*******************************************************
  indz=nz-1
  do i=2,nz
    if (height(i).gt.zt) then
      indz=i-1
      exit
    endif
  end do

  ! Vertical distance to the level below and above current position
  !****************************************************************

  dz=1./(height(indz+1)-height(indz))
  dz1=(zt-height(indz))*dz
  dz2=(height(indz+1)-zt)*dz


  ! Bilinear horizontal interpolation
  !**********************************

  ! Loop over 2 levels
  !*******************

  do n=1,2
    indzh=indz+n-1
    rho1(n)=rho(nix,njy,indzh,1)
    tt1(n)=tt(nix,njy,indzh,1)
  end do


  ! Linear vertical interpolation
  !******************************

  temperature=dz2*tt1(1)+dz1*tt1(2)
  airdens=dz2*rho1(1)+dz1*rho1(2)

  vis_dyn=viscosity(temperature)
  vis_kin=vis_dyn/airdens

  reynolds=dquer(nsp)/1.e6*abs(vsetaver(nsp))/vis_kin

  ! Iteration to determine both Reynolds number and settling velocity
  !******************************************************************

  settling_old=vsetaver(nsp)    ! initialize iteration with Stokes' law to define settling velocity of a sphere, constant viscosity estimate

  if (ishape(nsp).eq.0) then
    do i=1,20    ! do a few iterations

      ! if (reynolds.lt.1.917) then
      !   c_d=24./reynolds
      ! else if (reynolds.lt.500.) then
      !   c_d=18.5/(reynolds**0.6)
      ! else
      !   c_d=0.44
      ! endif

      ! Clift and Guavin 1971 model

      ! call find_dragcoeff(reynolds, c_d)

      ! If reynolds<0.2, approximation 24/reynolds is valid
      ! 24/reynolds makes up >99% of all components
      !****************************************************
      if (reynolds.le.0.02) then
        c_d=(24.0/reynolds)

      else
        c_d=(24.0/reynolds)*(1+0.15*(reynolds**0.687))+ &
          0.42/(1.0+42500.0/(reynolds**1.16))
      endif

      settling=-1.* &
           sqrt(4*ga*dquer(nsp)/1.e6*density(nsp)*cunningham(nsp)/ &
           (3.*c_d*airdens))

      if (abs((settling-settling_old)/settling).lt.0.01) exit  ! stop iteration

      reynolds=dquer(nsp)/1.e6*abs(settling)/vis_kin
      settling_old=settling
    end do

  else ! Drag coefficient scheme by Bagheri & Bonadonna, 2016 to define settling velocities of other shapes (by D.Tatsii)

    ! Orientation of particles
    !*************************
    if (orient(nsp).eq.0) then
      ! Horizontal orientation
      ks=ks2(nsp)  ! B&B Figure 12 k_(s,max)
      kn=kn2(nsp)
    else if (orient(nsp).eq.1) then 
      ! Random orientation
      dfdr=density(nsp)/airdens

      alpha1=0.45+10.0/(exp(2.5*log10(dfdr))+30.0)
      beta1=1.-37.0/(exp(3.0*log10(dfdr))+100.0)
      ks=ks1(nsp)
      kn=10.**(alpha1*(-log10(Fn(nsp)))**beta1)
    else
      ! The average of random and horizontal orientation
      dfdr=density(nsp)/airdens

      alpha1=0.45+10.0/(exp(2.5*log10(dfdr))+30.0)
      beta1=1.-37.0/(exp(3.0*log10(dfdr))+100.0)
      kn1=10.**(alpha1*(-log10(Fn(nsp)))**beta1)
      ks=(ks1(nsp)+ks2(nsp))*0.5
      kn=(kn1+kn2(nsp))*0.5
    endif

    do i=1,20
      c_d=(24.*ks/reynolds)*(1.+0.125*((reynolds*kn/ks)**(2./3.)))+ &
        (0.46*kn/(1.+5330./(reynolds*kn/ks)))

      settling=-1.* &
              sqrt(4.*ga*dquer(nsp)/1.e6*density(nsp)*cunningham(nsp)/ &
              (3.*c_d*airdens))

      if (abs((settling-settling_old)/settling).lt.0.01) exit

      reynolds=dquer(nsp)/1.e6*abs(settling)/vis_kin
      settling_old=settling
    end do
  endif
end subroutine get_settling

real function viscosity(t)
  ! Function calculates dynamic viscosity of air (kg/m/s) as function of
  ! temperature (K) using Sutherland's formula
  implicit none

  real :: t
  real,parameter :: c=120.,t_0=291.15,eta_0=1.827e-5

  viscosity=eta_0*(t_0+c)/(t+c)*(t/t_0)**1.5

  return

end function viscosity

end module settling_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

!**************************************************************************
!****                       SUBROUTINE CONVECT                        *****
!****                          VERSION 4.3c                           *****
!****                          20 May, 2002                           *****
!****                          Kerry Emanuel                          *****
!**************************************************************************
!
  SUBROUTINE CONVECT &
         (ND,  NL,   DELT, IFLAG, &
         PRECIP, WD,   TPRIME, QPRIME, CBMF    )
  !
  !-cv *************************************************************************
  !-cv C. Forster, November 2003 - May 2004:
  !-cv
  !-cv The subroutine has been downloaded from Kerry Emanuel's homepage,
  !-cv where further infos on the convection scheme can be found
  !-cv http://www-paoc.mit.edu/~emanuel/home.html
  !-cv
  !-cv The following changes have been made to integrate this subroutine
  !-cv into FLEXPART
  !-cv
  !-cv Putting most of the variables in a new common block
  !-cv renaming eps to eps0 because there is some eps already in includepar
  !-cv
  !-cv removing the arrays U,V,TRA and related arrays
  !-cv
  !-cv renaming the original arrays T,Q,QS,P,PH to
  !-cv TCONV,QCONV,QSCONV,PCONV_HPA,PHCONV_HPA
  !-cv
  !-cv Initialization of variables has been put into parameter statements
  !-cv instead of assignment of values at each call, in order to save 
  !-cv computation time.
  !***************************************************************************
  !
  !-----------------------------------------------------------------------------
  !    *** On input:      ***
  !
  !T:   Array of absolute temperature (K) of dimension ND, with first
  !      index corresponding to lowest model level. Note that this array
  !      will be altered by the subroutine if dry convective adjustment
  !      occurs and if IPBL is not equal to 0.
  !
  !Q:   Array of specific humidity (gm/gm) of dimension ND, with first
  !       index corresponding to lowest model level. Must be defined
  !       at same grid levels as T. Note that this array will be altered
  !       if dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !QS:  Array of saturation specific humidity of dimension ND, with first
  !       index corresponding to lowest model level. Must be defined
  !       at same grid levels as T. Note that this array will be altered
  !       if dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !U:   Array of zonal wind velocity (m/s) of dimension ND, witth first
  !       index corresponding with the lowest model level. Defined at
  !       same levels as T. Note that this array will be altered if
  !       dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !V:   Same as U but for meridional velocity.
  !
  !TRA: Array of passive tracer mixing ratio, of dimensions (ND,NTRA),
  !       where NTRA is the number of different tracers. If no
  !       convective tracer transport is needed, define a dummy
  !       input array of dimension (ND,1). Tracers are defined at
  !       same vertical levels as T. Note that this array will be altered
  !       if dry convective adjustment occurs and if IPBL is not equal to 0.
  !
  !P:   Array of pressure (mb) of dimension ND, with first
  !       index corresponding to lowest model level. Must be defined
  !       at same grid levels as T.
  !
  !PH:  Array of pressure (mb) of dimension ND+1, with first index
  !       corresponding to lowest level. These pressures are defined at
  !       levels intermediate between those of P, T, Q and QS. The first
  !       value of PH should be greater than (i.e. at a lower level than)
  !       the first value of the array P.
  !
  !ND:  The dimension of the arrays T,Q,QS,P,PH,FT and FQ
  !
  !NL:  The maximum number of levels to which convection can
  !       penetrate, plus 1.
  !       NL MUST be less than or equal to ND-1.
  !
  !NTRA:The number of different tracers. If no tracer transport
  !       is needed, set this equal to 1. (On most compilers, setting
  !       NTRA to 0 will bypass tracer calculation, saving some CPU.)
  !
  !DELT: The model time step (sec) between calls to CONVECT
  !
  !----------------------------------------------------------------------------
  !    ***   On Output:         ***
  !
  !IFLAG: An output integer whose value denotes the following:
  !
  !           VALUE                        INTERPRETATION
  !           -----                        --------------
  !             0               No moist convection; atmosphere is not
  !                             unstable, or surface temperature is less
  !                             than 250 K or surface specific humidity
  !                             is non-positive.
  !
  !             1               Moist convection occurs.
  !
  !             2               No moist convection: lifted condensation
  !                             level is above the 200 mb level.
  !
  !             3               No moist convection: cloud base is higher
  !                             then the level NL-1.
  !
  !             4               Moist convection occurs, but a CFL condition
  !                             on the subsidence warming is violated. This
  !                             does not cause the scheme to terminate.
  !
  !FT:   Array of temperature tendency (K/s) of dimension ND, defined at same
  !        grid levels as T, Q, QS and P.
  !
  !FQ:   Array of specific humidity tendencies ((gm/gm)/s) of dimension ND,
  !        defined at same grid levels as T, Q, QS and P.
  !
  !FU:   Array of forcing of zonal velocity (m/s^2) of dimension ND,
  !        defined at same grid levels as T.
  !
  !FV:   Same as FU, but for forcing of meridional velocity.
  !
  !FTRA: Array of forcing of tracer content, in tracer mixing ratio per
  !        second, defined at same levels as T. Dimensioned (ND,NTRA).
  !
  !PRECIP: Scalar convective precipitation rate (mm/day).
  !
  !WD:    A convective downdraft velocity scale. For use in surface
  !        flux parameterizations. See convect.ps file for details.
  !
  !TPRIME: A convective downdraft temperature perturbation scale (K).
  !         For use in surface flux parameterizations. See convect.ps
  !         file for details.
  !
  !QPRIME: A convective downdraft specific humidity
  !         perturbation scale (gm/gm).
  !         For use in surface flux parameterizations. See convect.ps
  !         file for details.
  !
  !CBMF:   The cloud base mass flux ((kg/m**2)/s). THIS SCALAR VALUE MUST
  !         BE STORED BY THE CALLING PROGRAM AND RETURNED TO CONVECT AT
  !         ITS NEXT CALL. That is, the value of CBMF must be "remembered"
  !         by the calling program between calls to CONVECT.
  !
  !-----------------------------------------------------------------------------
  !
  !    ***  THE PARAMETER NA SHOULD IN GENERAL BE GREATER THAN   ***
  !    ***                OR EQUAL TO  ND + 1                    ***
  !
  !
  use par_mod
  use conv_mod

  implicit none
  !
  !-cv====>Begin Module CONVECT    File convect.f      Undeclared variables
  !
  !Argument variables
  !
  integer :: iflag, nd, nl
  !
  real :: cbmf, delt, precip, qprime, tprime, wd
  !
  !Local variables
  !
  integer :: i, icb, ihmin, inb, inb1, j, jtt, k
  integer :: nk
  !
  real :: ad, afac, ahmax, ahmin, alt, altem
  real :: am, amp1, anum, asij, awat, b6, bf2, bsum, by
  real :: byp, c6, cape, capem, cbmfold, chi, coeff
  real :: cpinv, cwat, damps, dbo, dbosum
  real :: defrac, dei, delm, delp, delt0, delti, denom, dhdp
  real :: dpinv, dtma, dtmin, dtpbl, elacrit, ents
  real :: epmax, fac, fqold, frac, ftold
  real :: plcl, qp1, qsm, qstm, qti, rat
  real :: rdcp, revap, rh, scrit, sigt, sjmax
  real :: sjmin, smid, smin, stemp, tca
  real :: tvaplcl, tvpplcl, tvx, tvy, wdtrain

  !integer jc,jn
  !real alvnew,a2,ahm,alv,rm,sum,qnew,dphinv,tc,thbar,tnew,x

  real :: FUP(NA),FDOWN(NA)
  !
  !-cv====>End Module   CONVECT    File convect.f

  INTEGER :: NENT(NA)
  REAL :: M(NA),MP(NA),MENT(NA,NA),QENT(NA,NA),ELIJ(NA,NA)
  REAL :: SIJ(NA,NA),TVP(NA),TV(NA),WATER(NA)
  REAL :: QP(NA),EP(NA),TH(NA),WT(NA),EVAP(NA),CLW(NA)
  REAL :: SIGP(NA),TP(NA),CPN(NA)
  REAL :: LV(NA),LVCP(NA),H(NA),HP(NA),GZ(NA),HM(NA)
  !REAL TOLD(NA)
  !
  ! -----------------------------------------------------------------------
  !
  !   ***                     Specify Switches                         ***
  !
  !   ***   IPBL: Set to zero to bypass dry adiabatic adjustment       ***
  !   ***    Any other value results in dry adiabatic adjustment       ***
  !   ***     (Zero value recommended for use in models with           ***
  !   ***                   boundary layer schemes)                    ***
  !
  !   ***   MINORIG: Lowest level from which convection may originate  ***
  !   ***     (Should be first model level at which T is defined       ***
  !   ***      for models using bulk PBL schemes; otherwise, it should ***
  !   ***      be the first model level at which T is defined above    ***
  !   ***                      the surface layer)                      ***
  !
    INTEGER,PARAMETER :: IPBL=0
    INTEGER,PARAMETER :: MINORIG=1
  !
  !------------------------------------------------------------------------------
  !
  !   ***                    SPECIFY PARAMETERS                        ***
  !
  !   *** ELCRIT IS THE AUTOCONVERSION THERSHOLD WATER CONTENT (gm/gm) ***
  !   ***  TLCRIT IS CRITICAL TEMPERATURE BELOW WHICH THE AUTO-        ***
  !   ***       CONVERSION THRESHOLD IS ASSUMED TO BE ZERO             ***
  !   ***     (THE AUTOCONVERSION THRESHOLD VARIES LINEARLY            ***
  !   ***               BETWEEN 0 C AND TLCRIT)                        ***
  !   ***   ENTP IS THE COEFFICIENT OF MIXING IN THE ENTRAINMENT       ***
  !   ***                       FORMULATION                            ***
  !   ***  SIGD IS THE FRACTIONAL AREA COVERED BY UNSATURATED DNDRAFT  ***
  !   ***  SIGS IS THE FRACTION OF PRECIPITATION FALLING OUTSIDE       ***
  !   ***                        OF CLOUD                              ***
  !   ***        OMTRAIN IS THE ASSUMED FALL SPEED (P/s) OF RAIN       ***
  !   ***     OMTSNOW IS THE ASSUMED FALL SPEED (P/s) OF SNOW          ***
  !   ***  COEFFR IS A COEFFICIENT GOVERNING THE RATE OF EVAPORATION   ***
  !   ***                          OF RAIN                             ***
  !   ***  COEFFS IS A COEFFICIENT GOVERNING THE RATE OF EVAPORATION   ***
  !   ***                          OF SNOW                             ***
  !   ***     CU IS THE COEFFICIENT GOVERNING CONVECTIVE MOMENTUM      ***
  !   ***                         TRANSPORT                            ***
  !   ***    DTMAX IS THE MAXIMUM NEGATIVE TEMPERATURE PERTURBATION    ***
  !   ***        A LIFTED PARCEL IS ALLOWED TO HAVE BELOW ITS LFC      ***
  !   ***    ALPHA AND DAMP ARE PARAMETERS THAT CONTROL THE RATE OF    ***
  !   ***                 APPROACH TO QUASI-EQUILIBRIUM                ***
  !   ***   (THEIR STANDARD VALUES ARE  0.20 AND 0.1, RESPECTIVELY)    ***
  !   ***                   (DAMP MUST BE LESS THAN 1)                 ***
  !
    REAL,PARAMETER :: ELCRIT=.0011
    REAL,PARAMETER :: TLCRIT=-55.0
    REAL,PARAMETER :: ENTP=1.5
    REAL,PARAMETER :: SIGD=0.05
    REAL,PARAMETER :: SIGS=0.12
    REAL,PARAMETER :: OMTRAIN=50.0
    REAL,PARAMETER :: OMTSNOW=5.5
    REAL,PARAMETER :: COEFFR=1.0
    REAL,PARAMETER :: COEFFS=0.8
    REAL,PARAMETER :: CU=0.7
    REAL,PARAMETER :: BETA=10.0
    REAL,PARAMETER :: DTMAX=0.9
    REAL,PARAMETER :: ALPHA=0.025  !original 0.2
    REAL,PARAMETER :: DAMP=0.1
  !
  !   ***        ASSIGN VALUES OF THERMODYNAMIC CONSTANTS,        ***
  !   ***            GRAVITY, AND LIQUID WATER DENSITY.           ***
  !   ***             THESE SHOULD BE CONSISTENT WITH             ***
  !   ***              THOSE USED IN CALLING PROGRAM              ***
  !   ***     NOTE: THESE ARE ALSO SPECIFIED IN SUBROUTINE TLIFT  ***
  !
  REAL,PARAMETER :: CPD=1005.7
  REAL,PARAMETER :: CPV=1870.0
  REAL,PARAMETER :: CL=2500.0
  REAL,PARAMETER :: RV=461.5
  REAL,PARAMETER :: RD=287.04
  REAL,PARAMETER :: LV0=2.501E6
  REAL,PARAMETER :: G=9.81
  REAL,PARAMETER :: ROWL=1000.0
  !
  REAL,PARAMETER :: CPVMCL=CL-CPV
  REAL,PARAMETER :: EPS0=RD/RV
  REAL,PARAMETER :: EPSI=1./EPS0
  REAL,PARAMETER :: GINV=1.0/G
  REAL,PARAMETER :: EPSILON=1.e-20

  ! EPSILON IS A SMALL NUMBER USED TO EXCLUDE MASS FLUXES OF ZERO
  !
  DELTI=1.0/DELT
  !
  !      ***  INITIALIZE OUTPUT ARRAYS AND PARAMETERS  ***
  !

    DO I=1,NL+1
     FT(I)=0.0
     FQ(I)=0.0
     FDOWN(I)=0.0
     SUB(I)=0.0
     FUP(I)=0.0
     M(I)=0.0
     MP(I)=0.0
    DO J=1,NL+1
     FMASS(I,J)=0.0
     MENT(I,J)=0.0
    END DO
    END DO
    DO I=1,NL+1
     RDCP=(RD*(1.-QCONV(I))+QCONV(I)*RV)/ &
          (CPD*(1.-QCONV(I))+QCONV(I)*CPV)
     TH(I)=TCONV(I)*(1000.0/PCONV_HPA(I))**RDCP
    END DO
    PRECIP=0.0
    WD=0.0
    TPRIME=0.0
    QPRIME=0.0
    IFLAG=0
  !
  !  IF(IPBL.NE.0)THEN
  !
  !***            PERFORM DRY ADIABATIC ADJUSTMENT            ***
  !
  !  JC=0
  !  DO 30 I=NL-1,1,-1
  !   JN=0
  !    SUM=TH(I)*(1.+QCONV(I)*EPSI-QCONV(I))
  !   DO 10 J=I+1,NL
  !    SUM=SUM+TH(J)*(1.+QCONV(J)*EPSI-QCONV(J))
  !    THBAR=SUM/REAL(J+1-I)
  !    IF((TH(J)*(1.+QCONV(J)*EPSI-QCONV(J))).LT.THBAR)JN=J
  !  10    CONTINUE
  !   IF(I.EQ.1)JN=MAX(JN,2)
  !   IF(JN.EQ.0)GOTO 30
  !  12    CONTINUE
  !   AHM=0.0
  !   RM=0.0
  !   DO 15 J=I,JN
  !    AHM=AHM+(CPD*(1.-QCONV(J))+QCONV(J)*CPV)*TCONV(J)*
  !    +   (PHCONV_HPA(J)-PHCONV_HPA(J+1))
  !    RM=RM+QCONV(J)*(PHCONV_HPA(J)-PHCONV_HPA(J+1))
  !  15    CONTINUE
  !   DPHINV=1./(PHCONV_HPA(I)-PHCONV_HPA(JN+1))
  !   RM=RM*DPHINV
  !   A2=0.0
  !   DO 20 J=I,JN
  !    QCONV(J)=RM
  !    RDCP=(RD*(1.-QCONV(J))+QCONV(J)*RV)/
  !    1     (CPD*(1.-QCONV(J))+QCONV(J)*CPV)
  !    X=(0.001*PCONV_HPA(J))**RDCP
  !    TOLD(J)=TCONV(J)
  !    TCONV(J)=X
  !    A2=A2+(CPD*(1.-QCONV(J))+QCONV(J)*CPV)*X*
  !    1    (PHCONV_HPA(J)-PHCONV_HPA(J+1))
  !  20    CONTINUE
  !   DO 25 J=I,JN
  !    TH(J)=AHM/A2
  !    TCONV(J)=TCONV(J)*TH(J)
  !    TC=TOLD(J)-273.15
  !    ALV=LV0-CPVMCL*TC
  !    QSCONV(J)=QSCONV(J)+QSCONV(J)*(1.+QSCONV(J)*(EPSI-1.))*ALV*
  !    1    (TCONV(J)- TOLD(J))/(RV*TOLD(J)*TOLD(J))
  ! if (qslev(j) .lt. 0.) then
  !   write(*,*) 'qslev.lt.0 ',j,qslev
  ! endif
  !  25    CONTINUE
  !   IF((TH(JN+1)*(1.+QCONV(JN+1)*EPSI-QCONV(JN+1))).LT.
  !    1    (TH(JN)*(1.+QCONV(JN)*EPSI-QCONV(JN))))THEN
  !    JN=JN+1
  !    GOTO 12
  !   END IF
  !   IF(I.EQ.1)JC=JN
  !  30   CONTINUE
  !
  !   ***   Remove any supersaturation that results from adjustment ***
  !
  !IF(JC.GT.1)THEN
  ! DO 38 J=1,JC
  !    IF(QSCONV(J).LT.QCONV(J))THEN
  !     ALV=LV0-CPVMCL*(TCONV(J)-273.15)
  !     TNEW=TCONV(J)+ALV*(QCONV(J)-QSCONV(J))/(CPD*(1.-QCONV(J))+
  !    1      CL*QCONV(J)+QSCONV(J)*(CPV-CL+ALV*ALV/(RV*TCONV(J)*TCONV(J))))
  !     ALVNEW=LV0-CPVMCL*(TNEW-273.15)
  !     QNEW=(ALV*QCONV(J)-(TNEW-TCONV(J))*(CPD*(1.-QCONV(J))
  !    1     +CL*QCONV(J)))/ALVNEW
  !     PRECIP=PRECIP+24.*3600.*1.0E5*(PHCONV_HPA(J)-PHCONV_HPA(J+1))*
  !    1      (QCONV(J)-QNEW)/(G*DELT*ROWL)
  !     TCONV(J)=TNEW
  !     QCONV(J)=QNEW
  !     QSCONV(J)=QNEW
  !    END IF
  !  38  CONTINUE
  !END IF
  !
  !END IF
  !
  !  *** CALCULATE ARRAYS OF GEOPOTENTIAL, HEAT CAPACITY AND STATIC ENERGY
  !
    GZ(1)=0.0
    CPN(1)=CPD*(1.-QCONV(1))+QCONV(1)*CPV
    H(1)=TCONV(1)*CPN(1)
    LV(1)=LV0-CPVMCL*(TCONV(1)-273.15)
    HM(1)=LV(1)*QCONV(1)
    TV(1)=TCONV(1)*(1.+QCONV(1)*EPSI-QCONV(1))
    AHMIN=1.0E12
    IHMIN=NL
    DO I=2,NL+1
      TVX=TCONV(I)*(1.+QCONV(I)*EPSI-QCONV(I))
      TVY=TCONV(I-1)*(1.+QCONV(I-1)*EPSI-QCONV(I-1))
      GZ(I)=GZ(I-1)+0.5*RD*(TVX+TVY)*(PCONV_HPA(I-1)-PCONV_HPA(I))/ &
           PHCONV_HPA(I)
      CPN(I)=CPD*(1.-QCONV(I))+CPV*QCONV(I)
      H(I)=TCONV(I)*CPN(I)+GZ(I)
      LV(I)=LV0-CPVMCL*(TCONV(I)-273.15)
      HM(I)=(CPD*(1.-QCONV(I))+CL*QCONV(I))*(TCONV(I)-TCONV(1))+ &
           LV(I)*QCONV(I)+GZ(I)
      TV(I)=TCONV(I)*(1.+QCONV(I)*EPSI-QCONV(I))
  !
  !  ***  Find level of minimum moist static energy    ***
  !
      IF(I.GE.MINORIG.AND.HM(I).LT.AHMIN.AND.HM(I).LT.HM(I-1))THEN
       AHMIN=HM(I)
       IHMIN=I
      END IF
    END DO
    IHMIN=MIN(IHMIN, NL-1)
  !
  !  ***     Find that model level below the level of minimum moist       ***
  !  ***  static energy that has the maximum value of moist static energy ***
  !
    AHMAX=0.0
  !  ***  bug fixed: need to assign an initial value to NK
  !  HSO, 05.08.2009
    NK=MINORIG
    DO I=MINORIG,IHMIN
     IF(HM(I).GT.AHMAX)THEN
      NK=I
      AHMAX=HM(I)
     END IF
    END DO
  !
  !  ***  CHECK WHETHER PARCEL LEVEL TEMPERATURE AND SPECIFIC HUMIDITY   ***
  !  ***                          ARE REASONABLE                         ***
  !  ***      Skip convection if HM increases monotonically upward       ***
  !
    IF(TCONV(NK).LT.250.0.OR.QCONV(NK).LE.0.0.OR.IHMIN.EQ.(NL-1)) &
         THEN
     IFLAG=0
     CBMF=0.0
     RETURN
    END IF
  !
  !   ***  CALCULATE LIFTED CONDENSATION LEVEL OF AIR AT PARCEL ORIGIN LEVEL ***
  !   ***       (WITHIN 0.2% OF FORMULA OF BOLTON, MON. WEA. REV.,1980)      ***
  !
    RH=QCONV(NK)/QSCONV(NK)
    CHI=TCONV(NK)/(1669.0-122.0*RH-TCONV(NK))
    PLCL=PCONV_HPA(NK)*(RH**CHI)
    IF(PLCL.LT.200.0.OR.PLCL.GE.2000.0)THEN
     IFLAG=2
     CBMF=0.0
     RETURN
    END IF
  !
  !   ***  CALCULATE FIRST LEVEL ABOVE LCL (=ICB)  ***
  !
    ICB=NL-1
    DO I=NK+1,NL
     IF(PCONV_HPA(I).LT.PLCL)THEN
      ICB=MIN(ICB,I)
     END IF
    END DO
    IF(ICB.GE.(NL-1))THEN
     IFLAG=3
     CBMF=0.0
     RETURN
    END IF
  !
  !   *** FIND TEMPERATURE UP THROUGH ICB AND TEST FOR INSTABILITY           ***
  !
  !   *** SUBROUTINE TLIFT CALCULATES PART OF THE LIFTED PARCEL VIRTUAL      ***
  !   ***  TEMPERATURE, THE ACTUAL TEMPERATURE AND THE ADIABATIC             ***
  !   ***                   LIQUID WATER CONTENT                             ***
  !
    CALL TLIFT(GZ,ICB,NK,TVP,TP,CLW,ND,NL,1)
    DO I=NK,ICB
     TVP(I)=TVP(I)-TP(I)*QCONV(NK)
    END DO
  !
  !   ***  If there was no convection at last time step and parcel    ***
  !   ***       is stable at ICB then skip rest of calculation        ***
  !
    IF(CBMF.EQ.0.0.AND.TVP(ICB).LE.(TV(ICB)-DTMAX))THEN
     IFLAG=0
     RETURN
    END IF
  !
  !   ***  IF THIS POINT IS REACHED, MOIST CONVECTIVE ADJUSTMENT IS NECESSARY ***
  !
    IF(IFLAG.NE.4)IFLAG=1
  !
  !   ***  FIND THE REST OF THE LIFTED PARCEL TEMPERATURES          ***
  !
    CALL TLIFT(GZ,ICB,NK,TVP,TP,CLW,ND,NL,2)
  !
  !   ***  SET THE PRECIPITATION EFFICIENCIES AND THE FRACTION OF   ***
  !   ***          PRECIPITATION FALLING OUTSIDE OF CLOUD           ***
  !   ***      THESE MAY BE FUNCTIONS OF TP(I), PCONV_HPA(I) AND CLW(I)     ***
  !
    DO I=1,NK
     EP(I)=0.0
     SIGP(I)=SIGS
    END DO
    DO I=NK+1,NL
     TCA=TP(I)-273.15
     IF(TCA.GE.0.0)THEN
      ELACRIT=ELCRIT
     ELSE
      ELACRIT=ELCRIT*(1.0-TCA/TLCRIT)
     END IF
     ELACRIT=MAX(ELACRIT,0.0)
     EPMAX=0.999
     EP(I)=EPMAX*(1.0-ELACRIT/MAX(CLW(I),1.0E-8))
     EP(I)=MAX(EP(I),0.0)
     EP(I)=MIN(EP(I),EPMAX)
     SIGP(I)=SIGS
    END DO
  !
  !   ***       CALCULATE VIRTUAL TEMPERATURE AND LIFTED PARCEL     ***
  !   ***                    VIRTUAL TEMPERATURE                    ***
  !
    DO I=ICB+1,NL
     TVP(I)=TVP(I)-TP(I)*QCONV(NK)
    END DO
    TVP(NL+1)=TVP(NL)-(GZ(NL+1)-GZ(NL))/CPD
  !
  !   ***        NOW INITIALIZE VARIOUS ARRAYS USED IN THE COMPUTATIONS       ***
  !
    DO I=1,NL+1
     HP(I)=H(I)
     NENT(I)=0
     WATER(I)=0.0
     EVAP(I)=0.0
     WT(I)=OMTSNOW
     LVCP(I)=LV(I)/CPN(I)
     DO J=1,NL+1
      QENT(I,J)=QCONV(J)
      ELIJ(I,J)=0.0
      SIJ(I,J)=0.0
     END DO
    END DO
    QP(1)=QCONV(1)
    DO I=2,NL+1
     QP(I)=QCONV(I-1)
    END DO
  !
  !  ***  FIND THE FIRST MODEL LEVEL (INB1) ABOVE THE PARCEL'S      ***
  !  ***          HIGHEST LEVEL OF NEUTRAL BUOYANCY                 ***
  !  ***     AND THE HIGHEST LEVEL OF POSITIVE CAPE (INB)           ***
  !
    CAPE=0.0
    CAPEM=0.0
    INB=ICB+1
    INB1=INB
    BYP=0.0
    DO I=ICB+1,NL-1
     BY=(TVP(I)-TV(I))*(PHCONV_HPA(I)-PHCONV_HPA(I+1))/PCONV_HPA(I)
     CAPE=CAPE+BY
     IF(BY.GE.0.0)INB1=I+1
     IF(CAPE.GT.0.0)THEN
      INB=I+1
      BYP=(TVP(I+1)-TV(I+1))*(PHCONV_HPA(I+1)-PHCONV_HPA(I+2))/ &
           PCONV_HPA(I+1)
      CAPEM=CAPE
     END IF
    END DO
    INB=MAX(INB,INB1)
    CAPE=CAPEM+BYP
    DEFRAC=CAPEM-CAPE
    DEFRAC=MAX(DEFRAC,0.001)
    FRAC=-CAPE/DEFRAC
    FRAC=MIN(FRAC,1.0)
    FRAC=MAX(FRAC,0.0)
  !
  !   ***   CALCULATE LIQUID WATER STATIC ENERGY OF LIFTED PARCEL   ***
  !
    DO I=ICB,INB
     HP(I)=H(NK)+(LV(I)+(CPD-CPV)*TCONV(I))*EP(I)*CLW(I)
    END DO
  !
  !   ***  CALCULATE CLOUD BASE MASS FLUX AND RATES OF MIXING, M(I),  ***
  !   ***                   AT EACH MODEL LEVEL                       ***
  !
    DBOSUM=0.0
  !
  !   ***     INTERPOLATE DIFFERENCE BETWEEN LIFTED PARCEL AND      ***
  !   ***  ENVIRONMENTAL TEMPERATURES TO LIFTED CONDENSATION LEVEL  ***
  !
    TVPPLCL=TVP(ICB-1)-RD*TVP(ICB-1)*(PCONV_HPA(ICB-1)-PLCL)/ &
         (CPN(ICB-1)*PCONV_HPA(ICB-1))
    TVAPLCL=TV(ICB)+(TVP(ICB)-TVP(ICB+1))*(PLCL-PCONV_HPA(ICB))/ &
         (PCONV_HPA(ICB)-PCONV_HPA(ICB+1))
    DTPBL=0.0
    DO I=NK,ICB-1
     DTPBL=DTPBL+(TVP(I)-TV(I))*(PHCONV_HPA(I)-PHCONV_HPA(I+1))
    END DO
    DTPBL=DTPBL/(PHCONV_HPA(NK)-PHCONV_HPA(ICB))
    DTMIN=TVPPLCL-TVAPLCL+DTMAX+DTPBL
    DTMA=DTMIN
  !
  !   ***  ADJUST CLOUD BASE MASS FLUX   ***
  !
  CBMFOLD=CBMF
  ! *** C. Forster: adjustment of CBMF is not allowed to depend on FLEXPART timestep
  DELT0=DELT/3.
  DAMPS=DAMP*DELT/DELT0
  CBMF=(1.-DAMPS)*CBMF+0.1*ALPHA*DTMA
  CBMF=MAX(CBMF,0.0)
  !
  !   *** If cloud base mass flux is zero, skip rest of calculation  ***
  !
  IF(CBMF.EQ.0.0.AND.CBMFOLD.EQ.0.0)THEN
   RETURN
  END IF

  !
  !   ***   CALCULATE RATES OF MIXING,  M(I)   ***
  !
  M(ICB)=0.0
  DO I=ICB+1,INB
   K=MIN(I,INB1)
   DBO=ABS(TV(K)-TVP(K))+ &
        ENTP*0.02*(PHCONV_HPA(K)-PHCONV_HPA(K+1))
   DBOSUM=DBOSUM+DBO
   M(I)=CBMF*DBO
  END DO
  DO I=ICB+1,INB
   M(I)=M(I)/DBOSUM
  END DO
  !
  !   ***  CALCULATE ENTRAINED AIR MASS FLUX (MENT), TOTAL WATER MIXING  ***
  !   ***     RATIO (QENT), TOTAL CONDENSED WATER (ELIJ), AND MIXING     ***
  !   ***                        FRACTION (SIJ)                          ***
  !
    DO I=ICB+1,INB
     QTI=QCONV(NK)-EP(I)*CLW(I)
     DO J=ICB,INB
      BF2=1.+LV(J)*LV(J)*QSCONV(J)/(RV*TCONV(J)*TCONV(J)*CPD)
      ANUM=H(J)-HP(I)+(CPV-CPD)*TCONV(J)*(QTI-QCONV(J))
      DENOM=H(I)-HP(I)+(CPD-CPV)*(QCONV(I)-QTI)*TCONV(J)
      DEI=DENOM
      IF(ABS(DEI).LT.0.01)DEI=0.01
      SIJ(I,J)=ANUM/DEI
      SIJ(I,I)=1.0
      ALTEM=SIJ(I,J)*QCONV(I)+(1.-SIJ(I,J))*QTI-QSCONV(J)
      ALTEM=ALTEM/BF2
      CWAT=CLW(J)*(1.-EP(J))
      STEMP=SIJ(I,J)
      IF((STEMP.LT.0.0.OR.STEMP.GT.1.0.OR. &
           ALTEM.GT.CWAT).AND.J.GT.I)THEN
       ANUM=ANUM-LV(J)*(QTI-QSCONV(J)-CWAT*BF2)
       DENOM=DENOM+LV(J)*(QCONV(I)-QTI)
       IF(ABS(DENOM).LT.0.01)DENOM=0.01
       SIJ(I,J)=ANUM/DENOM
       ALTEM=SIJ(I,J)*QCONV(I)+(1.-SIJ(I,J))*QTI-QSCONV(J)
       ALTEM=ALTEM-(BF2-1.)*CWAT
      END IF
      IF(SIJ(I,J).GT.0.0.AND.SIJ(I,J).LT.0.9)THEN
       QENT(I,J)=SIJ(I,J)*QCONV(I)+(1.-SIJ(I,J))*QTI
       ELIJ(I,J)=ALTEM
       ELIJ(I,J)=MAX(0.0,ELIJ(I,J))
       MENT(I,J)=M(I)/(1.-SIJ(I,J))
       NENT(I)=NENT(I)+1
      END IF
      SIJ(I,J)=MAX(0.0,SIJ(I,J))
      SIJ(I,J)=MIN(1.0,SIJ(I,J))
     END DO
  !
  !   ***   IF NO AIR CAN ENTRAIN AT LEVEL I ASSUME THAT UPDRAFT DETRAINS  ***
  !   ***   AT THAT LEVEL AND CALCULATE DETRAINED AIR FLUX AND PROPERTIES  ***
  !
     IF(NENT(I).EQ.0)THEN
      MENT(I,I)=M(I)
      QENT(I,I)=QCONV(NK)-EP(I)*CLW(I)
      ELIJ(I,I)=CLW(I)
      SIJ(I,I)=1.0
     END IF
    END DO
    SIJ(INB,INB)=1.0
  !
  !   ***  NORMALIZE ENTRAINED AIR MASS FLUXES TO REPRESENT EQUAL  ***
  !   ***              PROBABILITIES OF MIXING                     ***
  !
    DO I=ICB+1,INB
    IF(NENT(I).NE.0)THEN
     QP1=QCONV(NK)-EP(I)*CLW(I)
     ANUM=H(I)-HP(I)-LV(I)*(QP1-QSCONV(I))
     DENOM=H(I)-HP(I)+LV(I)*(QCONV(I)-QP1)
     IF(ABS(DENOM).LT.0.01)DENOM=0.01
     SCRIT=ANUM/DENOM
     ALT=QP1-QSCONV(I)+SCRIT*(QCONV(I)-QP1)
     IF(ALT.LT.0.0)SCRIT=1.0
     SCRIT=MAX(SCRIT,0.0)
     ASIJ=0.0
     SMIN=1.0
     DO J=ICB,INB
      IF(SIJ(I,J).GT.0.0.AND.SIJ(I,J).LT.0.9)THEN
       IF(J.GT.I)THEN
        SMID=MIN(SIJ(I,J),SCRIT)
        SJMAX=SMID
        SJMIN=SMID
        IF(SMID.LT.SMIN.AND.SIJ(I,J+1).LT.SMID)THEN
         SMIN=SMID
         SJMAX=MIN(SIJ(I,J+1),SIJ(I,J),SCRIT)
         SJMIN=MAX(SIJ(I,J-1),SIJ(I,J))
         SJMIN=MIN(SJMIN,SCRIT)
        END IF
       ELSE
        SJMAX=MAX(SIJ(I,J+1),SCRIT)
        SMID=MAX(SIJ(I,J),SCRIT)
        SJMIN=0.0
        IF(J.GT.1)SJMIN=SIJ(I,J-1)
        SJMIN=MAX(SJMIN,SCRIT)
       END IF
       DELP=ABS(SJMAX-SMID)
       DELM=ABS(SJMIN-SMID)
       ASIJ=ASIJ+(DELP+DELM)*(PHCONV_HPA(J)-PHCONV_HPA(J+1))
       MENT(I,J)=MENT(I,J)*(DELP+DELM)* &
            (PHCONV_HPA(J)-PHCONV_HPA(J+1))
      END IF
     END DO
     ASIJ=MAX(1.0E-21,ASIJ)
     ASIJ=1.0/ASIJ
     DO J=ICB,INB
      MENT(I,J)=MENT(I,J)*ASIJ
     END DO
     BSUM=0.0
     DO J=ICB,INB
      BSUM=BSUM+MENT(I,J)
     END DO
     IF(BSUM.LT.1.0E-18)THEN
      NENT(I)=0
      MENT(I,I)=M(I)
      QENT(I,I)=QCONV(NK)-EP(I)*CLW(I)
      ELIJ(I,I)=CLW(I)
      SIJ(I,I)=1.0
     END IF
    END IF
    END DO
  !
  !   ***  CHECK WHETHER EP(INB)=0, IF SO, SKIP PRECIPITATING    ***
  !   ***             DOWNDRAFT CALCULATION                      ***
  !
    IF(EP(INB).LT.0.0001)GOTO 405
  !
  !   ***  INTEGRATE LIQUID WATER EQUATION TO FIND CONDENSED WATER   ***
  !   ***                AND CONDENSED WATER FLUX                    ***
  !
    JTT=2
  !
  !    ***                    BEGIN DOWNDRAFT LOOP                    ***
  !
    DO I=INB,1,-1
  !
  !    ***              CALCULATE DETRAINED PRECIPITATION             ***
  !
    WDTRAIN=G*EP(I)*M(I)*CLW(I)
    IF(I.GT.1)THEN
     DO J=1,I-1
     AWAT=ELIJ(J,I)-(1.-EP(I))*CLW(I)
     AWAT=MAX(0.0,AWAT)
       WDTRAIN=WDTRAIN+G*AWAT*MENT(J,I)
     END DO
    END IF
  !
  !    ***    FIND RAIN WATER AND EVAPORATION USING PROVISIONAL   ***
  !    ***              ESTIMATES OF QP(I)AND QP(I-1)             ***
  !
  !
  !  ***  Value of terminal velocity and coefficient of evaporation for snow   ***
  !
    COEFF=COEFFS
    WT(I)=OMTSNOW
  !
  !  ***  Value of terminal velocity and coefficient of evaporation for rain   ***
  !
    IF(TCONV(I).GT.273.0)THEN
     COEFF=COEFFR
     WT(I)=OMTRAIN
    END IF
    QSM=0.5*(QCONV(I)+QP(I+1))
    AFAC=COEFF*PHCONV_HPA(I)*(QSCONV(I)-QSM)/ &
         (1.0E4+2.0E3*PHCONV_HPA(I)*QSCONV(I))
    AFAC=MAX(AFAC,0.0)
    SIGT=SIGP(I)
    SIGT=MAX(0.0,SIGT)
    SIGT=MIN(1.0,SIGT)
    B6=100.*(PHCONV_HPA(I)-PHCONV_HPA(I+1))*SIGT*AFAC/WT(I)
    C6=(WATER(I+1)*WT(I+1)+WDTRAIN/SIGD)/WT(I)
    REVAP=0.5*(-B6+SQRT(B6*B6+4.*C6))
    EVAP(I)=SIGT*AFAC*REVAP
    WATER(I)=REVAP*REVAP
  !
  !    ***  CALCULATE PRECIPITATING DOWNDRAFT MASS FLUX UNDER     ***
  !    ***              HYDROSTATIC APPROXIMATION                 ***
  !
    IF(I.EQ.1)GOTO 360
    DHDP=(H(I)-H(I-1))/(PCONV_HPA(I-1)-PCONV_HPA(I))
    DHDP=MAX(DHDP,10.0)
    MP(I)=100.*GINV*LV(I)*SIGD*EVAP(I)/DHDP
    MP(I)=MAX(MP(I),0.0)
  !
  !   ***   ADD SMALL AMOUNT OF INERTIA TO DOWNDRAFT              ***
  !
    FAC=20.0/(PHCONV_HPA(I-1)-PHCONV_HPA(I))
    MP(I)=(FAC*MP(I+1)+MP(I))/(1.+FAC)
  !
  !    ***      FORCE MP TO DECREASE LINEARLY TO ZERO                 ***
  !    ***      BETWEEN ABOUT 950 MB AND THE SURFACE                  ***
  !
      IF(PCONV_HPA(I).GT.(0.949*PCONV_HPA(1)))THEN
       JTT=MAX(JTT,I)
       MP(I)=MP(JTT)*(PCONV_HPA(1)-PCONV_HPA(I))/(PCONV_HPA(1)- &
            PCONV_HPA(JTT))
      END IF
  360   CONTINUE
  !
  !    ***       FIND MIXING RATIO OF PRECIPITATING DOWNDRAFT     ***
  !
    IF(I.EQ.INB)GOTO 400
    IF(I.EQ.1)THEN
     QSTM=QSCONV(1)
    ELSE
     QSTM=QSCONV(I-1)
    END IF
    IF(MP(I).GT.MP(I+1))THEN
      RAT=MP(I+1)/MP(I)
      QP(I)=QP(I+1)*RAT+QCONV(I)*(1.0-RAT)+100.*GINV* &
           SIGD*(PHCONV_HPA(I)-PHCONV_HPA(I+1))*(EVAP(I)/MP(I))
     ELSE
      IF(MP(I+1).GT.0.0)THEN
        QP(I)=(GZ(I+1)-GZ(I)+QP(I+1)*(LV(I+1)+TCONV(I+1)*(CL-CPD))+ &
             CPD*(TCONV(I+1)-TCONV(I)))/(LV(I)+TCONV(I)*(CL-CPD))
      END IF
    END IF
    QP(I)=MIN(QP(I),QSTM)
    QP(I)=MAX(QP(I),0.0)
400 CONTINUE
    END DO
  !
  !   ***  CALCULATE SURFACE PRECIPITATION IN MM/DAY     ***
  !
    PRECIP=PRECIP+WT(1)*SIGD*WATER(1)*3600.*24000./(ROWL*G)
  !
  405   CONTINUE
  !
  !   ***  CALCULATE DOWNDRAFT VELOCITY SCALE AND SURFACE TEMPERATURE AND  ***
  !   ***                    WATER VAPOR FLUCTUATIONS                      ***
  !
  WD=BETA*ABS(MP(ICB))*0.01*RD*TCONV(ICB)/(SIGD*PCONV_HPA(ICB))
  QPRIME=0.5*(QP(1)-QCONV(1))
  TPRIME=LV0*QPRIME/CPD
  !
  !   ***  CALCULATE TENDENCIES OF LOWEST LEVEL POTENTIAL TEMPERATURE  ***
  !   ***                      AND MIXING RATIO                        ***
  !
    DPINV=0.01/(PHCONV_HPA(1)-PHCONV_HPA(2))
    AM=0.0
    IF(NK.EQ.1)THEN
     DO K=2,INB
       AM=AM+M(K)
     END DO
    END IF
  ! save saturated upward mass flux for first level
    FUP(1)=AM
    IF((2.*G*DPINV*AM).GE.DELTI)IFLAG=4
    FT(1)=FT(1)+G*DPINV*AM*(TCONV(2)-TCONV(1)+(GZ(2)-GZ(1))/CPN(1))
    FT(1)=FT(1)-LVCP(1)*SIGD*EVAP(1)
    FT(1)=FT(1)+SIGD*WT(2)*(CL-CPD)*WATER(2)*(TCONV(2)- &
         TCONV(1))*DPINV/CPN(1)
    FQ(1)=FQ(1)+G*MP(2)*(QP(2)-QCONV(1))* &
         DPINV+SIGD*EVAP(1)
    FQ(1)=FQ(1)+G*AM*(QCONV(2)-QCONV(1))*DPINV
    DO J=2,INB
     FQ(1)=FQ(1)+G*DPINV*MENT(J,1)*(QENT(J,1)-QCONV(1))
    END DO
  !
  !   ***  CALCULATE TENDENCIES OF POTENTIAL TEMPERATURE AND MIXING RATIO  ***
  !   ***               AT LEVELS ABOVE THE LOWEST LEVEL                   ***
  !
  !   ***  FIRST FIND THE NET SATURATED UPDRAFT AND DOWNDRAFT MASS FLUXES  ***
  !   ***                      THROUGH EACH LEVEL                          ***
  !
    DO I=2,INB
    DPINV=0.01/(PHCONV_HPA(I)-PHCONV_HPA(I+1))
    CPINV=1.0/CPN(I)
    AMP1=0.0
    AD=0.0
    IF(I.GE.NK)THEN
     DO K=I+1,INB+1
       AMP1=AMP1+M(K)
     END DO
    END IF
    DO K=1,I
    DO J=I+1,INB+1
     AMP1=AMP1+MENT(K,J)
    END DO
    END DO
  ! save saturated upward mass flux
    FUP(I)=AMP1
    IF((2.*G*DPINV*AMP1).GE.DELTI)IFLAG=4
    DO K=1,I-1
    DO J=I,INB
     AD=AD+MENT(J,K)
    END DO
    END DO
  ! save saturated downward mass flux
    FDOWN(I)=AD
    FT(I)=FT(I)+G*DPINV*(AMP1*(TCONV(I+1)-TCONV(I)+(GZ(I+1)-GZ(I))* &
         CPINV)-AD*(TCONV(I)-TCONV(I-1)+(GZ(I)-GZ(I-1))*CPINV)) &
         -SIGD*LVCP(I)*EVAP(I)
    FT(I)=FT(I)+G*DPINV*MENT(I,I)*(HP(I)-H(I)+ &
         TCONV(I)*(CPV-CPD)*(QCONV(I)-QENT(I,I)))*CPINV
    FT(I)=FT(I)+SIGD*WT(I+1)*(CL-CPD)*WATER(I+1)* &
         (TCONV(I+1)-TCONV(I))*DPINV*CPINV
    FQ(I)=FQ(I)+G*DPINV*(AMP1*(QCONV(I+1)-QCONV(I))- &
         AD*(QCONV(I)-QCONV(I-1)))
    DO K=1,I-1
     AWAT=ELIJ(K,I)-(1.-EP(I))*CLW(I)
     AWAT=MAX(AWAT,0.0)
     FQ(I)=FQ(I)+G*DPINV*MENT(K,I)*(QENT(K,I)-AWAT-QCONV(I))
    END DO
    DO K=I,INB
     FQ(I)=FQ(I)+G*DPINV*MENT(K,I)*(QENT(K,I)-QCONV(I))
    END DO
    FQ(I)=FQ(I)+SIGD*EVAP(I)+G*(MP(I+1)* &
         (QP(I+1)-QCONV(I))-MP(I)*(QP(I)-QCONV(I-1)))*DPINV
    END DO
  !
  !   *** Adjust tendencies at top of convection layer to reflect  ***
  !   ***       actual position of the level zero CAPE             ***
  !
    FQOLD=FQ(INB)
    FQ(INB)=FQ(INB)*(1.-FRAC)
    FQ(INB-1)=FQ(INB-1)+FRAC*FQOLD*((PHCONV_HPA(INB)- &
         PHCONV_HPA(INB+1))/ &
         (PHCONV_HPA(INB-1)-PHCONV_HPA(INB)))*LV(INB)/LV(INB-1)
    FTOLD=FT(INB)
    FT(INB)=FT(INB)*(1.-FRAC)
    FT(INB-1)=FT(INB-1)+FRAC*FTOLD*((PHCONV_HPA(INB)- &
         PHCONV_HPA(INB+1))/ &
         (PHCONV_HPA(INB-1)-PHCONV_HPA(INB)))*CPN(INB)/CPN(INB-1)
  !
  !   ***   Very slightly adjust tendencies to force exact   ***
  !   ***     enthalpy, momentum and tracer conservation     ***
  !
    ENTS=0.0
    DO I=1,INB
     ENTS=ENTS+(CPN(I)*FT(I)+LV(I)*FQ(I))* &
          (PHCONV_HPA(I)-PHCONV_HPA(I+1))	
    END DO
    ENTS=ENTS/(PHCONV_HPA(1)-PHCONV_HPA(INB+1))
    DO I=1,INB
     FT(I)=FT(I)-ENTS/CPN(I)
    END DO

  ! ************************************************
  ! **** DETERMINE MASS DISPLACEMENT MATRIX
  ! ***** AND COMPENSATING SUBSIDENCE
  ! ************************************************

  ! mass displacement matrix due to saturated up-and downdrafts
  ! inside the cloud and determine compensating subsidence
  ! FUP(I) (saturated updrafts), FDOWN(I) (saturated downdrafts) are assumed to be
  ! balanced by  compensating subsidence (SUB(I))
  ! FDOWN(I) and SUB(I) defined positive downwards

  ! NCONVTOP IS THE TOP LEVEL AT WHICH CONVECTIVE MASS FLUXES ARE DIAGNOSED
  ! EPSILON IS A SMALL NUMBER

   SUB(1)=0.
   NCONVTOP=1
   do i=1,INB+1
   do j=1,INB+1
    if (j.eq.NK) then
     FMASS(j,i)=FMASS(j,i)+M(i)
    endif
     FMASS(j,i)=FMASS(j,i)+MENT(j,i)
     IF (FMASS(J,I).GT.EPSILON) NCONVTOP=MAX(NCONVTOP,I,J)
   end do
   if (i.gt.1) then
    SUB(i)=FUP(i-1)-FDOWN(i)
   endif
   end do
   NCONVTOP=NCONVTOP+1

    RETURN
  !
END SUBROUTINE CONVECT
!
! ---------------------------------------------------------------------------
!
SUBROUTINE TLIFT(GZ,ICB,NK,TVP,TPK,CLW,ND,NL,KK)
  !
  !-cv
  use par_mod
  use conv_mod

  implicit none
  !-cv
  !====>Begin Module TLIFT      File convect.f      Undeclared variables
  !
  !Argument variables
  !
  integer :: icb, kk, nd, nk, nl
  !
  !Local variables
  !
  integer :: i, j, nsb, nst
  !
  real :: ah0, ahg, alv, cpinv, cpp, denom
  real :: es, qg, rg, s, tc, tg
  !
  !====>End Module   TLIFT      File convect.f

    REAL :: GZ(ND),TPK(ND),CLW(ND)
    REAL :: TVP(ND)
  !
  !   ***   ASSIGN VALUES OF THERMODYNAMIC CONSTANTS     ***
  !
    REAL,PARAMETER :: CPD=1005.7
    REAL,PARAMETER :: CPV=1870.0
    REAL,PARAMETER :: CL=2500.0
    REAL,PARAMETER :: RV=461.5
    REAL,PARAMETER :: RD=287.04
    REAL,PARAMETER :: LV0=2.501E6
  !
    REAL,PARAMETER :: CPVMCL=CL-CPV
    REAL,PARAMETER :: EPS0=RD/RV
    REAL,PARAMETER :: EPSI=1./EPS0
  !
  !   ***  CALCULATE CERTAIN PARCEL QUANTITIES, INCLUDING STATIC ENERGY   ***
  !
    AH0=(CPD*(1.-QCONV(NK))+CL*QCONV(NK))*TCONV(NK)+QCONV(NK)* &
         (LV0-CPVMCL*( &
         TCONV(NK)-273.15))+GZ(NK)
    CPP=CPD*(1.-QCONV(NK))+QCONV(NK)*CPV
    CPINV=1./CPP
  !
    IF(KK.EQ.1)THEN
  !
  !   ***   CALCULATE LIFTED PARCEL QUANTITIES BELOW CLOUD BASE   ***
  !
    DO I=1,ICB-1
     CLW(I)=0.0
    END DO
    DO I=NK,ICB-1
     TPK(I)=TCONV(NK)-(GZ(I)-GZ(NK))*CPINV
     TVP(I)=TPK(I)*(1.+QCONV(NK)*EPSI)
    END DO
    END IF
  !
  !    ***  FIND LIFTED PARCEL QUANTITIES ABOVE CLOUD BASE    ***
  !
    NST=ICB
    NSB=ICB
    IF(KK.EQ.2)THEN
     NST=NL
     NSB=ICB+1
    END IF
    DO I=NSB,NST
     TG=TCONV(I)
     QG=QSCONV(I)
     ALV=LV0-CPVMCL*(TCONV(I)-273.15)
     DO J=1,2
      S=CPD+ALV*ALV*QG/(RV*TCONV(I)*TCONV(I))
      S=1./S
      AHG=CPD*TG+(CL-CPD)*QCONV(NK)*TCONV(I)+ALV*QG+GZ(I)
      TG=TG+S*(AH0-AHG)
      TG=MAX(TG,35.0)
      TC=TG-273.15
      DENOM=243.5+TC
      IF(TC.GE.0.0)THEN
       ES=6.112*EXP(17.67*TC/DENOM)
      ELSE
       ES=EXP(23.33086-6111.72784/TG+0.15215*LOG(TG))
      END IF
      QG=EPS0*ES/(PCONV_HPA(I)-ES*(1.-EPS0))
     END DO
     ALV=LV0-CPVMCL*(TCONV(I)-273.15)
     TPK(I)=(AH0-(CL-CPD)*QCONV(NK)*TCONV(I)-GZ(I)-ALV*QG)/CPD
     CLW(I)=QCONV(NK)-QG
     CLW(I)=MAX(0.0,CLW(I))
     RG=QG/(1.-QCONV(NK))
     TVP(I)=TPK(I)*(1.+RG*EPSI)
    END DO
    RETURN
END SUBROUTINE TLIFT

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine plumetraj(itime)
  !                       i
  !*****************************************************************************
  !                                                                            *
  ! Determines a plume centroid trajectory for each release site, and manages  *
  ! clustering of particle locations. Certain parameters (average PV,          *
  ! tropopause height, etc., are provided along the plume trajectories.        *
  ! At the end, output is written to file 'trajectories.txt'.                  *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 January 2002                                                        *
  !                                                                            *
  ! Variables:                                                                 *
  ! fclust          fraction of particles belonging to each cluster            *
  ! hmixcenter      mean mixing height for all particles                       *
  ! ncluster        number of clusters to be used                              *
  ! pvcenter        mean PV for all particles                                  *
  ! pvfract         fraction of particles with PV<2pvu                         *
  ! rms             total horizontal rms distance after clustering             *
  ! rmsdist         total horizontal rms distance before clustering            *
  ! rmsclust        horizontal rms distance for each individual cluster        *
  ! topocenter      mean topography underlying all particles                   *
  ! tropocenter     mean tropopause height at the positions of particles       *
  ! tropofract      fraction of particles within the troposphere               *
  ! zrms            total vertical rms distance after clustering               *
  ! zrmsdist        total vertical rms distance before clustering              *
  ! xclust,yclust,  Cluster centroid positions                                 *
  ! zclust                                                                     *
  !                                                                            *
  !*****************************************************************************

  use point_mod
  use par_mod
  use com_mod

  implicit none

  integer :: itime,ix,jy,ixp,jyp,indexh,i,j,k,m,n,il,ind,indz,indzp
  real :: xl(maxpart),yl(maxpart),zl(maxpart)
  real :: xcenter,ycenter,zcenter,dist,distance,rmsdist,zrmsdist

  real :: xclust(ncluster),yclust(ncluster),zclust(ncluster)
  real :: fclust(ncluster),rms,rmsclust(ncluster),zrms

  real :: dt1,dt2,dtt,ddx,ddy,rddx,rddy,p1,p2,p3,p4,dz1,dz2,dz
  real :: topo,topocenter,hm(2),hmixi,hmixfract,hmixcenter
  real :: pv1(2),pvprof(2),pvi,pvcenter,pvfract,tr(2),tri,tropofract
  real :: tropocenter


  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)


  ! Loop about all release points
  !******************************

  do j=1,numpoint
    if (abs(ireleasestart(j)-itime).gt.lage(nageclass)) goto 10
    topocenter=0.
    hmixcenter=0.
    hmixfract=0.
    tropocenter=0.
    tropofract=0.
    pvfract=0.
    pvcenter=0.
    rmsdist=0.
    zrmsdist=0.

    n=0
    do i=1,numpart
      if (itra1(i).ne.itime) goto 20
      if (npoint(i).ne.j) goto 20
      n=n+1
      xl(n)=xlon0+xtra1(i)*dx
      yl(n)=ylat0+ytra1(i)*dy
      zl(n)=ztra1(i)


  ! Interpolate PBL height, PV, and tropopause height to each
  ! particle position in order to determine fraction of particles
  ! within the PBL, above tropopause height, and average PV.
  ! Interpolate topography, too, and convert to altitude asl
  !**************************************************************

      ix=int(xtra1(i))
      jy=int(ytra1(i))
      ixp=ix+1
      jyp=jy+1
      ddx=xtra1(i)-real(ix)
      ddy=ytra1(i)-real(jy)
      rddx=1.-ddx
      rddy=1.-ddy
      p1=rddx*rddy
      p2=ddx*rddy
      p3=rddx*ddy
      p4=ddx*ddy

  ! Topography
  !***********

      topo=p1*oro(ix ,jy) &
           + p2*oro(ixp,jy) &
           + p3*oro(ix ,jyp) &
           + p4*oro(ixp,jyp)
      topocenter=topocenter+topo

  ! Potential vorticity
  !********************

      do il=2,nz
        if (height(il).gt.zl(n)) then
          indz=il-1
          indzp=il
          goto 6
        endif
      end do
6     continue

      dz1=zl(n)-height(indz)
      dz2=height(indzp)-zl(n)
      dz=1./(dz1+dz2)


      do ind=indz,indzp
        do m=1,2
          indexh=memind(m)
          pv1(m)=p1*pv(ix ,jy ,ind,indexh) &
               +p2*pv(ixp,jy ,ind,indexh) &
               +p3*pv(ix ,jyp,ind,indexh) &
               +p4*pv(ixp,jyp,ind,indexh)
        end do
        pvprof(ind-indz+1)=(pv1(1)*dt2+pv1(2)*dt1)*dtt
      end do
      pvi=(dz1*pvprof(2)+dz2*pvprof(1))*dz
      pvcenter=pvcenter+pvi
      if (yl(n).gt.0.) then
        if (pvi.lt.2.) pvfract=pvfract+1.
      else
        if (pvi.gt.-2.) pvfract=pvfract+1.
      endif


  ! Tropopause and PBL height
  !**************************

      do m=1,2
        indexh=memind(m)

        tr(m)=p1*tropopause(ix ,jy ,1,indexh) &
             + p2*tropopause(ixp,jy ,1,indexh) &
             + p3*tropopause(ix ,jyp,1,indexh) &
             + p4*tropopause(ixp,jyp,1,indexh)

        hm(m)=p1*hmix(ix ,jy ,1,indexh) &
             + p2*hmix(ixp,jy ,1,indexh) &
             + p3*hmix(ix ,jyp,1,indexh) &
             + p4*hmix(ixp,jyp,1,indexh)
      end do

      hmixi=(hm(1)*dt2+hm(2)*dt1)*dtt
      tri=(tr(1)*dt2+tr(2)*dt1)*dtt
      if (zl(n).lt.tri) tropofract=tropofract+1.
      tropocenter=tropocenter+tri+topo
      if (zl(n).lt.hmixi) hmixfract=hmixfract+1.
      zl(n)=zl(n)+topo        ! convert to height asl
      hmixcenter=hmixcenter+hmixi


20    continue
    end do


  ! Make statistics for all plumes with n>0 particles
  !**************************************************

    if (n.gt.0) then
      topocenter=topocenter/real(n)
      hmixcenter=hmixcenter/real(n)
      pvcenter=pvcenter/real(n)
      tropocenter=tropocenter/real(n)
      hmixfract=100.*hmixfract/real(n)
      pvfract=100.*pvfract/real(n)
      tropofract=100.*tropofract/real(n)

  ! Cluster the particle positions
  !*******************************

      call clustering(xl,yl,zl,n,xclust,yclust,zclust,fclust,rms, &
           rmsclust,zrms)


  ! Determine center of mass position on earth and average height
  !**************************************************************

      call centerofmass(xl,yl,n,xcenter,ycenter)
      call mean(zl,zcenter,zrmsdist,n)

  ! Root mean square distance from center of mass
  !**********************************************

      do k=1,n
        dist=distance(yl(k),xl(k),ycenter,xcenter)
        rmsdist=rmsdist+dist*dist
      end do
      if (rmsdist.gt.0.) rmsdist=sqrt(rmsdist/real(n))
      rmsdist=max(rmsdist,0.)

  ! Write out results in trajectory data file
  !******************************************

      write(unitouttraj,'(i5,i8,2f9.4,4f8.1,f8.2,4f8.1,3f6.1,&
           &5(2f8.3,f7.0,f6.1,f8.1))')&
           &j,itime-(ireleasestart(j)+ireleaseend(j))/2, &
           xcenter,ycenter,zcenter,topocenter,hmixcenter,tropocenter, &
           pvcenter,rmsdist,rms,zrmsdist,zrms,hmixfract,pvfract, &
           tropofract, &
           (xclust(k),yclust(k),zclust(k),fclust(k),rmsclust(k), &
           k=1,ncluster)
    endif


10  continue
  end do


end subroutine plumetraj

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine readavailable

  !*****************************************************************************
  !                                                                            *
  !   This routine reads the dates and times for which windfields are          *
  !   available.                                                               *
  !                                                                            *
  !     Authors: A. Stohl                                                      *
  !                                                                            *
  !     6 February 1994                                                        *
  !     8 February 1999, Use of nested fields, A. Stohl                        *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! bdate                beginning date as Julian date                         *
  ! beg                  beginning date for windfields                         *
  ! end                  ending date for windfields                            *
  ! fname                filename of wind field, help variable                 *
  ! ideltas [s]          duration of modelling period                          *
  ! idiff                time difference between 2 wind fields                 *
  ! idiffnorm            normal time difference between 2 wind fields          *
  ! idiffmax [s]         maximum allowable time between 2 wind fields          *
  ! jul                  julian date, help variable                            *
  ! numbwf               actual number of wind fields                          *
  ! wfname(maxwf)        file names of needed wind fields                      *
  ! wfspec(maxwf)        file specifications of wind fields (e.g., if on disc) *
  ! wftime(maxwf) [s]times of wind fields relative to beginning time           *
  ! wfname1,wfspec1,wftime1 = same as above, but only local (help variables)   *
  !                                                                            *
  ! Constants:                                                                 *
  ! maxwf                maximum number of wind fields                         *
  ! unitavailab          unit connected to file AVAILABLE                      *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod

  implicit none

  integer :: i,idiff,ldat,ltim,wftime1(maxwf),numbwfn(maxnests),k
  integer :: wftime1n(maxnests,maxwf),wftimen(maxnests,maxwf)
  real(kind=dp) :: juldate,jul,beg,end
  character(len=255) :: fname,spec,wfname1(maxwf),wfspec1(maxwf)
  character(len=255) :: wfname1n(maxnests,maxwf)
  character(len=40) :: wfspec1n(maxnests,maxwf)


  ! Windfields are only used, if they are within the modelling period.
  ! However, 1 additional day at the beginning and at the end is used for
  ! interpolation. -> Compute beginning and ending date for the windfields.
  !************************************************************************

  if (ideltas.gt.0) then         ! forward trajectories
    beg=bdate-1._dp
    end=bdate+real(ideltas,kind=dp)/86400._dp+real(idiffmax,kind=dp)/ &
         86400._dp
  else                           ! backward trajectories
    beg=bdate+real(ideltas,kind=dp)/86400._dp-real(idiffmax,kind=dp)/ &
         86400._dp
    end=bdate+1._dp
  endif

  ! Open the wind field availability file and read available wind fields
  ! within the modelling period.
  !*********************************************************************

  open(unitavailab,file=path(4)(1:length(4)),status='old', &
       err=999)

  do i=1,3
    read(unitavailab,*)
  end do

  numbwf=0
100   read(unitavailab,'(i8,1x,i6,2(6x,a255))',end=99) &
           ldat,ltim,fname,spec
    jul=juldate(ldat,ltim)
    if ((jul.ge.beg).and.(jul.le.end)) then
      numbwf=numbwf+1
      if (numbwf.gt.maxwf) then      ! check exceedance of dimension
       write(*,*) 'Number of wind fields needed is too great.'
       write(*,*) 'Reduce modelling period (file "COMMAND") or'
       write(*,*) 'reduce number of wind fields (file "AVAILABLE").'
       stop
      endif

      wfname1(numbwf)=fname(1:index(fname,' '))
      wfspec1(numbwf)=spec
      wftime1(numbwf)=nint((jul-bdate)*86400._dp)
    endif
    goto 100       ! next wind field

99   continue

  close(unitavailab)

  ! Open the wind field availability file and read available wind fields
  ! within the modelling period (nested grids)
  !*********************************************************************

  do k=1,numbnests
    open(unitavailab,file=path(numpath+2*(k-1)+2) &
         (1:length(numpath+2*(k-1)+2)),status='old',err=998)

    do i=1,3
      read(unitavailab,*)
    end do

    numbwfn(k)=0
700   read(unitavailab,'(i8,1x,i6,2(6x,a255))',end=699) ldat, &
           ltim,fname,spec
      jul=juldate(ldat,ltim)
      if ((jul.ge.beg).and.(jul.le.end)) then
        numbwfn(k)=numbwfn(k)+1
        if (numbwfn(k).gt.maxwf) then      ! check exceedance of dimension
       write(*,*) 'Number of nested wind fields is too great.'
       write(*,*) 'Reduce modelling period (file "COMMAND") or'
       write(*,*) 'reduce number of wind fields (file "AVAILABLE").'
          stop
        endif

        wfname1n(k,numbwfn(k))=fname
        wfspec1n(k,numbwfn(k))=spec
        wftime1n(k,numbwfn(k))=nint((jul-bdate)*86400._dp)
      endif
      goto 700       ! next wind field

699   continue

    close(unitavailab)
  end do


  ! Check wind field times of file AVAILABLE (expected to be in temporal order)
  !****************************************************************************

  if (numbwf.eq.0) then
    write(*,*) ' #### FLEXPART MODEL ERROR! NO WIND FIELDS    #### '
    write(*,*) ' #### AVAILABLE FOR SELECTED TIME PERIOD.     #### '
    stop
  endif

  do i=2,numbwf
    if (wftime1(i).le.wftime1(i-1)) then
      write(*,*) 'FLEXPART ERROR: FILE AVAILABLE IS CORRUPT.'
      write(*,*) 'THE WIND FIELDS ARE NOT IN TEMPORAL ORDER.'
      write(*,*) 'PLEASE CHECK FIELD ',wfname1(i)
      stop
    endif
  end do

  ! Check wind field times of file AVAILABLE for the nested fields
  ! (expected to be in temporal order)
  !***************************************************************

  do k=1,numbnests
    if (numbwfn(k).eq.0) then
      write(*,*) '#### FLEXPART MODEL ERROR! NO WIND FIELDS  ####'
      write(*,*) '#### AVAILABLE FOR SELECTED TIME PERIOD.   ####'
      stop
    endif

    do i=2,numbwfn(k)
      if (wftime1n(k,i).le.wftime1n(k,i-1)) then
      write(*,*) 'FLEXPART ERROR: FILE AVAILABLE IS CORRUPT. '
      write(*,*) 'THE NESTED WIND FIELDS ARE NOT IN TEMPORAL ORDER.'
      write(*,*) 'PLEASE CHECK FIELD ',wfname1n(k,i)
      write(*,*) 'AT NESTING LEVEL ',k
      stop
      endif
    end do

  end do


  ! For backward trajectories, reverse the order of the windfields
  !***************************************************************

  if (ideltas.ge.0) then
    do i=1,numbwf
      wfname(i)=wfname1(i)
      wfspec(i)=wfspec1(i)
      wftime(i)=wftime1(i)
    end do
    do k=1,numbnests
      do i=1,numbwfn(k)
        wfnamen(k,i)=wfname1n(k,i)
        wfspecn(k,i)=wfspec1n(k,i)
        wftimen(k,i)=wftime1n(k,i)
      end do
    end do
  else
    do i=1,numbwf
      wfname(numbwf-i+1)=wfname1(i)
      wfspec(numbwf-i+1)=wfspec1(i)
      wftime(numbwf-i+1)=wftime1(i)
    end do
    do k=1,numbnests
      do i=1,numbwfn(k)
        wfnamen(k,numbwfn(k)-i+1)=wfname1n(k,i)
        wfspecn(k,numbwfn(k)-i+1)=wfspec1n(k,i)
        wftimen(k,numbwfn(k)-i+1)=wftime1n(k,i)
      end do
    end do
  endif

  ! Check the time difference between the wind fields. If it is big,
  ! write a warning message. If it is too big, terminate the trajectory.
  !*********************************************************************

  do i=2,numbwf
    idiff=abs(wftime(i)-wftime(i-1))
    if (idiff.gt.idiffmax) then
      write(*,*) 'FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO'
      write(*,*) 'WIND FIELDS IS TOO BIG FOR TRANSPORT CALCULATION.&
           &'
      write(*,*) 'THEREFORE, TRAJECTORIES HAVE TO BE SKIPPED.'
    else if (idiff.gt.idiffnorm) then
      write(*,*) 'FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO'
      write(*,*) 'WIND FIELDS IS BIG. THIS MAY CAUSE A DEGRADATION'
      write(*,*) 'OF SIMULATION QUALITY.'
    endif
  end do

  do k=1,numbnests
    if (numbwfn(k).ne.numbwf) then
      write(*,*) 'FLEXPART ERROR: THE AVAILABLE FILES FOR THE'
      write(*,*) 'NESTED WIND FIELDS ARE NOT CONSISTENT WITH'
      write(*,*) 'THE AVAILABLE FILE OF THE MOTHER DOMAIN.  '
      write(*,*) 'ERROR AT NEST LEVEL: ',k
      stop
    endif
    do i=1,numbwf
      if (wftimen(k,i).ne.wftime(i)) then
        write(*,*) 'FLEXPART ERROR: THE AVAILABLE FILES FOR THE'
        write(*,*) 'NESTED WIND FIELDS ARE NOT CONSISTENT WITH'
        write(*,*) 'THE AVAILABLE FILE OF THE MOTHER DOMAIN.  '
        write(*,*) 'ERROR AT NEST LEVEL: ',k
        stop
      endif
    end do
  end do

  ! Reset the times of the wind fields that are kept in memory to no time
  !**********************************************************************

  do i=1,2
    memind(i)=i
    memtime(i)=999999999
  end do

  return

998   write(*,*) ' #### FLEXPART MODEL ERROR! FILE   #### '
  write(*,'(a)') '     '//path(numpath+2*(k-1)+2) &
       (1:length(numpath+2*(k-1)+2))
  write(*,*) ' #### CANNOT BE OPENED             #### '
  stop

999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE #### '
  write(*,'(a)') '     '//path(4)(1:length(4))
  write(*,*) ' #### CANNOT BE OPENED           #### '
  stop

end subroutine readavailable

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

real function zenithangle(ylat,xlon,jul)

  !*********************************************************************
  !                                                                    *
  !                      Author: G. WOTAWA                             *
  !                      Date: 1993-11-17                              *
  !                      Project: POP-M                                *
  !                      Last update:                                  *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !     DESCRIPTION: This function returns the sinus of solar          *
  !                  elevation as a function of geographic longitude,  *
  !                  latitude and GMT-Time.                            *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !     INPUT:                                                         *
  !                                                                    *
  !            ylat          geographical latitude  [DEG]              *
  !            xlon          geographical longitude [DEG]              *
  !            jjjj          Year                                      *
  !            mm            Month                                     *
  !            dd            Day                                       *
  !            hh            Hour                                      *
  !            minute        Minute                                    *
  !                                                                    *
  !*********************************************************************

  use par_mod, only: dp

  implicit none

  integer :: jjjj,mm,id,iu,minute,yyyymmdd,hhmmss
  integer :: ndaynum
  real :: sinsol,solelev,ylat,xlon
  real :: rnum,rylat,ttime,dekl,rdekl,eq
  real,parameter :: pi=3.1415927
  real(kind=dp)  :: jul

  call caldate(jul,yyyymmdd,hhmmss)
  jjjj=yyyymmdd/10000
  mm=yyyymmdd/100-jjjj*100
  id=yyyymmdd-jjjj*10000-mm*100
  iu=hhmmss/10000
  minute=hhmmss/100-100*iu

  ndaynum=31*(mm-1)+id
  if(mm.gt.2) ndaynum=ndaynum-int(0.4*mm+2.3)
  if((mm.gt.2).and.(jjjj/4*4.eq.jjjj)) ndaynum=ndaynum+1

  rnum=2.*pi*ndaynum/365.
  rylat=pi*ylat/180.
  ttime=real(iu)+real(minute)/60.

  dekl=0.396+3.631*sin(rnum)+0.038*sin(2.*rnum)+0.077*sin(3.*rnum)- &
       22.97*cos(rnum)-0.389*cos(2.*rnum)-0.158*cos(3.*rnum)
  rdekl=pi*dekl/180.

  eq=(0.003-7.343*sin(rnum)-9.47*sin(2.*rnum)- &
       0.329*sin(3.*rnum)-0.196*sin(4.*rnum)+ &
       0.552*cos(rnum)-3.020*cos(2.*rnum)- &
       0.076*cos(3.*rnum)-0.125*cos(4.*rnum))/60.

  sinsol=sin(rylat)*sin(rdekl)+cos(rylat)*cos(rdekl)* &
       cos((ttime-12.+xlon/15.+eq)*pi/12.)
  ! Calculate the maximum solar elevation on that day
  !sinsol=sin(rylat)*sin(rdekl)+cos(rylat)*cos(rdekl)*
  !    &       cos((eq)*pi/12.)
  solelev=asin(sinsol)*180./pi
  zenithangle=90.-solelev

  return
end function zenithangle

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine conccalc(itime,weight)
  !                      i     i
  !*****************************************************************************
  !                                                                            *
  !     Calculation of the concentrations on a regular grid using volume       *
  !     sampling                                                               *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     24 May 1996                                                            *
  !                                                                            *
  !     April 2000: Update to calculate age spectra                            *
  !                 Bug fix to avoid negative conc. at the domain boundaries,  *
  !                 as suggested by Petra Seibert                              *
  !                                                                            *
  !     2 July 2002: re-order if-statements in order to optimize CPU time      *
  !                                                                            *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! nspeciesdim     = nspec for forward runs, 1 for backward runs              *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: itime,itage,i,ix,jy,ixp,jyp,kz,ks,n,nage
  integer :: il,ind,indz,indzp,nrelpointer
  real :: rddx,rddy,p1,p2,p3,p4,dz1,dz2,dz
  real :: weight,hx,hy,hz,h,xd,yd,zd,xkern,r2,c(maxspec),ddx,ddy
  real :: rhoprof(2),rhoi
  real :: xl,yl,wx,wy,w
  real,parameter :: factor=.596831, hxmax=6.0, hymax=4.0, hzmax=150.


  ! For forward simulations, make a loop over the number of species;
  ! for backward simulations, make an additional loop over the
  ! releasepoints
  !***************************************************************************


  do i=1,numpart
    if (itra1(i).ne.itime) goto 20

  ! Determine age class of the particle
    itage=abs(itra1(i)-itramem(i))
    do nage=1,nageclass
      if (itage.lt.lage(nage)) goto 33
    end do
33   continue


  ! For special runs, interpolate the air density to the particle position
  !************************************************************************
  !***********************************************************************
  !AF IND_SOURCE switches between different units for concentrations at the source
  !Af    NOTE that in backward simulations the release of particles takes place
  !Af    at the receptor and the sampling at the source.
  !Af          1="mass"
  !Af          2="mass mixing ratio"
  !Af IND_RECEPTOR switches between different units for concentrations at the receptor
  !Af          1="mass"
  !Af          2="mass mixing ratio"

  !Af switches for the conccalcfile:
  !AF IND_SAMP =  0 : xmass * 1
  !Af IND_SAMP = -1 : xmass / rho

  !Af ind_samp is defined in readcommand.f

    if ( ind_samp .eq. -1 ) then

      ix=int(xtra1(i))
      jy=int(ytra1(i))
      ixp=ix+1
      jyp=jy+1
      ddx=xtra1(i)-real(ix)
      ddy=ytra1(i)-real(jy)
      rddx=1.-ddx
      rddy=1.-ddy
      p1=rddx*rddy
      p2=ddx*rddy
      p3=rddx*ddy
      p4=ddx*ddy

      do il=2,nz
        if (height(il).gt.ztra1(i)) then
          indz=il-1
          indzp=il
          goto 6
        endif
      end do
6     continue

      dz1=ztra1(i)-height(indz)
      dz2=height(indzp)-ztra1(i)
      dz=1./(dz1+dz2)

  ! Take density from 2nd wind field in memory (accurate enough, no time interpolation needed)
  !*****************************************************************************
      do ind=indz,indzp
        rhoprof(ind-indz+1)=p1*rho(ix ,jy ,ind,2) &
             +p2*rho(ixp,jy ,ind,2) &
             +p3*rho(ix ,jyp,ind,2) &
             +p4*rho(ixp,jyp,ind,2)
      end do
      rhoi=(dz1*rhoprof(2)+dz2*rhoprof(1))*dz
   elseif (ind_samp.eq.0) then
      rhoi = 1.
   endif


  !****************************************************************************
  ! 1. Evaluate grid concentrations using a uniform kernel of bandwidths dx, dy
  !****************************************************************************


  ! For backward simulations, look from which release point the particle comes from
  ! For domain-filling trajectory option, npoint contains a consecutive particle
  ! number, not the release point information. Therefore, nrelpointer is set to 1
  ! for the domain-filling option.
  !*****************************************************************************

    if ((ioutputforeachrelease.eq.0).or.(mdomainfill.eq.1)) then
       nrelpointer=1
    else
       nrelpointer=npoint(i)
    endif

    do kz=1,numzgrid                ! determine height of cell
      if (outheight(kz).gt.ztra1(i)) goto 21
    end do
21   continue
    if (kz.le.numzgrid) then           ! inside output domain


  !********************************
  ! Do everything for mother domain
  !********************************

      xl=(xtra1(i)*dx+xoutshift)/dxout
      yl=(ytra1(i)*dy+youtshift)/dyout
      ix=int(xl)
      if (xl.lt.0.) ix=ix-1
      jy=int(yl)
      if (yl.lt.0.) jy=jy-1

  ! if (i.eq.10000) write(*,*) itime,xtra1(i),ytra1(i),ztra1(i),xl,yl


  ! For particles aged less than 3 hours, attribute particle mass to grid cell
  ! it resides in rather than use the kernel, in order to avoid its smoothing effect.
  ! For older particles, use the uniform kernel.
  ! If a particle is close to the domain boundary, do not use the kernel either.
  !*****************************************************************************

      if ((itage.lt.10800).or.(xl.lt.0.5).or.(yl.lt.0.5).or. &
           (xl.gt.real(numxgrid-1)-0.5).or. &
           (yl.gt.real(numygrid-1)-0.5)) then             ! no kernel, direct attribution to grid cell
        if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
             (jy.le.numygrid-1)) then
          do ks=1,nspec
            gridunc(ix,jy,kz,ks,nrelpointer,nclass(i),nage)= &
                 gridunc(ix,jy,kz,ks,nrelpointer,nclass(i),nage)+ &
                 xmass1(i,ks)/rhoi*weight
          end do
        endif

      else                                 ! attribution via uniform kernel

        ddx=xl-real(ix)                   ! distance to left cell border
        ddy=yl-real(jy)                   ! distance to lower cell border
        if (ddx.gt.0.5) then
          ixp=ix+1
          wx=1.5-ddx
        else
          ixp=ix-1
          wx=0.5+ddx
        endif

        if (ddy.gt.0.5) then
          jyp=jy+1
          wy=1.5-ddy
        else
          jyp=jy-1
          wy=0.5+ddy
        endif


  ! Determine mass fractions for four grid points
  !**********************************************

        if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
          if ((jy.ge.0).and.(jy.le.numygrid-1)) then
            w=wx*wy
            do ks=1,nspec
              gridunc(ix,jy,kz,ks,nrelpointer,nclass(i),nage)= &
                   gridunc(ix,jy,kz,ks,nrelpointer,nclass(i),nage)+ &
                   xmass1(i,ks)/rhoi*weight*w
            end do
          endif

          if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
            w=wx*(1.-wy)
            do ks=1,nspec
              gridunc(ix,jyp,kz,ks,nrelpointer,nclass(i),nage)= &
                   gridunc(ix,jyp,kz,ks,nrelpointer,nclass(i),nage)+ &
                   xmass1(i,ks)/rhoi*weight*w
            end do
          endif
        endif


        if ((ixp.ge.0).and.(ixp.le.numxgrid-1)) then
          if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
            w=(1.-wx)*(1.-wy)
            do ks=1,nspec
              gridunc(ixp,jyp,kz,ks,nrelpointer,nclass(i),nage)= &
                   gridunc(ixp,jyp,kz,ks,nrelpointer,nclass(i),nage)+ &
                   xmass1(i,ks)/rhoi*weight*w
            end do
          endif

          if ((jy.ge.0).and.(jy.le.numygrid-1)) then
            w=(1.-wx)*wy
            do ks=1,nspec
              gridunc(ixp,jy,kz,ks,nrelpointer,nclass(i),nage)= &
                   gridunc(ixp,jy,kz,ks,nrelpointer,nclass(i),nage)+ &
                   xmass1(i,ks)/rhoi*weight*w
            end do
          endif
        endif
      endif



  !************************************
  ! Do everything for the nested domain
  !************************************

      if (nested_output.eq.1) then
        xl=(xtra1(i)*dx+xoutshiftn)/dxoutn
        yl=(ytra1(i)*dy+youtshiftn)/dyoutn
        ix=int(xl)
        if (xl.lt.0.) ix=ix-1
        jy=int(yl)
        if (yl.lt.0.) jy=jy-1


  ! For particles aged less than 3 hours, attribute particle mass to grid cell
  ! it resides in rather than use the kernel, in order to avoid its smoothing effect.
  ! For older particles, use the uniform kernel.
  ! If a particle is close to the domain boundary, do not use the kernel either.
  !*****************************************************************************

        if ((itage.lt.10800).or.(xl.lt.0.5).or.(yl.lt.0.5).or. &
             (xl.gt.real(numxgridn-1)-0.5).or. &
             (yl.gt.real(numygridn-1)-0.5)) then             ! no kernel, direct attribution to grid cell
          if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgridn-1).and. &
               (jy.le.numygridn-1)) then
            do ks=1,nspec
              griduncn(ix,jy,kz,ks,nrelpointer,nclass(i),nage)= &
                   griduncn(ix,jy,kz,ks,nrelpointer,nclass(i),nage)+ &
                   xmass1(i,ks)/rhoi*weight
            end do
          endif

        else                                 ! attribution via uniform kernel

          ddx=xl-real(ix)                   ! distance to left cell border
          ddy=yl-real(jy)                   ! distance to lower cell border
          if (ddx.gt.0.5) then
            ixp=ix+1
            wx=1.5-ddx
          else
            ixp=ix-1
            wx=0.5+ddx
          endif

          if (ddy.gt.0.5) then
            jyp=jy+1
            wy=1.5-ddy
          else
            jyp=jy-1
            wy=0.5+ddy
          endif


  ! Determine mass fractions for four grid points
  !**********************************************

          if ((ix.ge.0).and.(ix.le.numxgridn-1)) then
            if ((jy.ge.0).and.(jy.le.numygridn-1)) then
              w=wx*wy
              do ks=1,nspec
                griduncn(ix,jy,kz,ks,nrelpointer,nclass(i),nage)= &
                     griduncn(ix,jy,kz,ks,nrelpointer,nclass(i),nage)+ &
                     xmass1(i,ks)/rhoi*weight*w
              end do
            endif

            if ((jyp.ge.0).and.(jyp.le.numygridn-1)) then
              w=wx*(1.-wy)
              do ks=1,nspec
                griduncn(ix,jyp,kz,ks,nrelpointer,nclass(i),nage)= &
                     griduncn(ix,jyp,kz,ks,nrelpointer,nclass(i),nage)+ &
                     xmass1(i,ks)/rhoi*weight*w
              end do
            endif
          endif


          if ((ixp.ge.0).and.(ixp.le.numxgridn-1)) then
            if ((jyp.ge.0).and.(jyp.le.numygridn-1)) then
              w=(1.-wx)*(1.-wy)
              do ks=1,nspec
                griduncn(ixp,jyp,kz,ks,nrelpointer,nclass(i),nage)= &
                     griduncn(ixp,jyp,kz,ks,nrelpointer,nclass(i),nage)+ &
                     xmass1(i,ks)/rhoi*weight*w
              end do
            endif

            if ((jy.ge.0).and.(jy.le.numygridn-1)) then
              w=(1.-wx)*wy
              do ks=1,nspec
                griduncn(ixp,jy,kz,ks,nrelpointer,nclass(i),nage)= &
                     griduncn(ixp,jy,kz,ks,nrelpointer,nclass(i),nage)+ &
                     xmass1(i,ks)/rhoi*weight*w
              end do
            endif
          endif
        endif

      endif
    endif
20  continue
  end do

  !***********************************************************************
  ! 2. Evaluate concentrations at receptor points, using the kernel method
  !***********************************************************************

  do n=1,numreceptor


  ! Reset concentrations
  !*********************

    do ks=1,nspec
      c(ks)=0.
    end do


  ! Estimate concentration at receptor
  !***********************************

    do i=1,numpart

      if (itra1(i).ne.itime) goto 40
      itage=abs(itra1(i)-itramem(i))

      hz=min(50.+0.3*sqrt(real(itage)),hzmax)
      zd=ztra1(i)/hz
      if (zd.gt.1.) goto 40          ! save computing time, leave loop

      hx=min((0.29+2.222e-3*sqrt(real(itage)))*dx+ &
           real(itage)*1.2e-5,hxmax)                     ! 80 km/day
      xd=(xtra1(i)-xreceptor(n))/hx
      if (xd*xd.gt.1.) goto 40       ! save computing time, leave loop

      hy=min((0.18+1.389e-3*sqrt(real(itage)))*dy+ &
           real(itage)*7.5e-6,hymax)                     ! 80 km/day
      yd=(ytra1(i)-yreceptor(n))/hy
      if (yd*yd.gt.1.) goto 40       ! save computing time, leave loop
      h=hx*hy*hz

      r2=xd*xd+yd*yd+zd*zd
      if (r2.lt.1.) then
        xkern=factor*(1.-r2)
        do ks=1,nspec
          c(ks)=c(ks)+xmass1(i,ks)*xkern/h
        end do
      endif
40    continue
    end do

    do ks=1,nspec
      creceptor(n,ks)=creceptor(n,ks)+2.*weight*c(ks)/receptorarea(n)
    end do
  end do

end subroutine conccalc

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine initial_cond_calc(itime,i)
  !                               i   i
  !*****************************************************************************
  !                                                                            *
  !     Calculation of the sensitivity to initial conditions for BW runs       *
  !                                                                            *
  !     Author: A. Stohl                                                       *
  !                                                                            *
  !     15 January 2010                                                        *
  !                                                                            *
  !*****************************************************************************

  use unc_mod
  use outg_mod
  use par_mod
  use com_mod

  implicit none

  integer :: itime,i,ix,jy,ixp,jyp,kz,ks
  integer :: il,ind,indz,indzp,nrelpointer
  real :: rddx,rddy,p1,p2,p3,p4,dz1,dz2,dz
  real :: ddx,ddy
  real :: rhoprof(2),rhoi,xl,yl,wx,wy,w


  ! For forward simulations, make a loop over the number of species;
  ! for backward simulations, make an additional loop over the release points
  !**************************************************************************


  if (itra1(i).ne.itime) return

  ! Depending on output option, calculate air density or set it to 1
  ! linit_cond: 1=mass unit, 2=mass mixing ratio unit
  !*****************************************************************


  if (linit_cond.eq.1) then     ! mass unit

    ix=int(xtra1(i))
    jy=int(ytra1(i))
    ixp=ix+1
    jyp=jy+1
    ddx=xtra1(i)-real(ix)
    ddy=ytra1(i)-real(jy)
    rddx=1.-ddx
    rddy=1.-ddy
    p1=rddx*rddy
    p2=ddx*rddy
    p3=rddx*ddy
    p4=ddx*ddy

    do il=2,nz
      if (height(il).gt.ztra1(i)) then
        indz=il-1
        indzp=il
        goto 6
      endif
    end do
6   continue

    dz1=ztra1(i)-height(indz)
    dz2=height(indzp)-ztra1(i)
    dz=1./(dz1+dz2)

  ! Take density from 2nd wind field in memory (accurate enough, no time interpolation needed)
  !*****************************************************************************
    do ind=indz,indzp
      rhoprof(ind-indz+1)=p1*rho(ix ,jy ,ind,2) &
           +p2*rho(ixp,jy ,ind,2) &
           +p3*rho(ix ,jyp,ind,2) &
           +p4*rho(ixp,jyp,ind,2)
    end do
    rhoi=(dz1*rhoprof(2)+dz2*rhoprof(1))*dz
  elseif (linit_cond.eq.2) then    ! mass mixing ratio unit
    rhoi=1.
  endif


  !****************************************************************************
  ! 1. Evaluate grid concentrations using a uniform kernel of bandwidths dx, dy
  !****************************************************************************


  ! For backward simulations, look from which release point the particle comes from
  ! For domain-filling trajectory option, npoint contains a consecutive particle
  ! number, not the release point information. Therefore, nrelpointer is set to 1
  ! for the domain-filling option.
  !*****************************************************************************

  if ((ioutputforeachrelease.eq.0).or.(mdomainfill.eq.1)) then
    nrelpointer=1
  else
    nrelpointer=npoint(i)
  endif

  do kz=1,numzgrid                ! determine height of cell
    if (outheight(kz).gt.ztra1(i)) goto 21
  end do
21   continue
  if (kz.le.numzgrid) then           ! inside output domain


    xl=(xtra1(i)*dx+xoutshift)/dxout
    yl=(ytra1(i)*dy+youtshift)/dyout
    ix=int(xl)
    if (xl.lt.0.) ix=ix-1
    jy=int(yl)
    if (yl.lt.0.) jy=jy-1


  ! If a particle is close to the domain boundary, do not use the kernel either
  !****************************************************************************

    if ((xl.lt.0.5).or.(yl.lt.0.5).or. &
         (xl.gt.real(numxgrid-1)-0.5).or. &
         (yl.gt.real(numygrid-1)-0.5)) then             ! no kernel, direct attribution to grid cell
      if ((ix.ge.0).and.(jy.ge.0).and.(ix.le.numxgrid-1).and. &
           (jy.le.numygrid-1)) then
        do ks=1,nspec
          init_cond(ix,jy,kz,ks,nrelpointer)= &
               init_cond(ix,jy,kz,ks,nrelpointer)+ &
               xmass1(i,ks)/rhoi
        end do
      endif

    else                                 ! attribution via uniform kernel

      ddx=xl-real(ix)                   ! distance to left cell border
      ddy=yl-real(jy)                   ! distance to lower cell border
      if (ddx.gt.0.5) then
        ixp=ix+1
        wx=1.5-ddx
      else
        ixp=ix-1
        wx=0.5+ddx
      endif

      if (ddy.gt.0.5) then
        jyp=jy+1
        wy=1.5-ddy
      else
        jyp=jy-1
        wy=0.5+ddy
      endif


  ! Determine mass fractions for four grid points
  !**********************************************

      if ((ix.ge.0).and.(ix.le.numxgrid-1)) then
        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
          w=wx*wy
          do ks=1,nspec
            init_cond(ix,jy,kz,ks,nrelpointer)= &
                 init_cond(ix,jy,kz,ks,nrelpointer)+xmass1(i,ks)/rhoi*w
          end do
        endif

        if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
          w=wx*(1.-wy)
          do ks=1,nspec
            init_cond(ix,jyp,kz,ks,nrelpointer)= &
                 init_cond(ix,jyp,kz,ks,nrelpointer)+xmass1(i,ks)/rhoi*w
          end do
        endif
      endif


      if ((ixp.ge.0).and.(ixp.le.numxgrid-1)) then
        if ((jyp.ge.0).and.(jyp.le.numygrid-1)) then
          w=(1.-wx)*(1.-wy)
          do ks=1,nspec
            init_cond(ixp,jyp,kz,ks,nrelpointer)= &
                 init_cond(ixp,jyp,kz,ks,nrelpointer)+xmass1(i,ks)/rhoi*w
          end do
        endif

        if ((jy.ge.0).and.(jy.le.numygrid-1)) then
          w=(1.-wx)*wy
          do ks=1,nspec
            init_cond(ixp,jy,kz,ks,nrelpointer)= &
                 init_cond(ixp,jy,kz,ks,nrelpointer)+xmass1(i,ks)/rhoi*w
          end do
        endif
      endif
    endif

  endif

end subroutine initial_cond_calc

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine redist (ipart,ktop,ipconv)

  !**************************************************************************
  ! Do the redistribution of particles due to convection
  ! This subroutine is called for each particle which is assigned
  ! a new vertical position randomly, based on the convective redistribution
  ! matrix
  !**************************************************************************

  ! Petra Seibert, Feb 2001, Apr 2001, May 2001, Jan 2002, Nov 2002 and
  ! Andreas Frank, Nov 2002

  ! Caroline Forster:  November 2004 - February 2005

  use par_mod
  use com_mod
  use conv_mod

  implicit none

  real,parameter :: const=r_air/ga
  integer :: ipart, ktop,ipconv
  integer :: k, kz, levnew, levold
  real,save :: uvzlev(nuvzmax)
  real :: wsub(nuvzmax)
  real :: totlevmass, wsubpart
  real :: temp_levold,temp_levold1
  real :: sub_levold,sub_levold1
  real :: pint, pold, rn, tv, tvold, dlevfrac
  real :: ew,ran3, ztold,ffraction
  real :: tv1, tv2, dlogp, dz, dz1, dz2
  integer :: iseed = -88

  ! ipart   ... number of particle to be treated

  ipconv=1

  ! determine height of the eta half-levels (uvzlev)
  ! do that only once for each grid column
  ! i.e. when ktop.eq.1
  !**************************************************************

  if (ktop .le. 1) then

    tvold=tt2conv*(1.+0.378*ew(td2conv)/psconv)
    pold=psconv
    uvzlev(1)=0.

    pint = phconv(2)
  !  determine next virtual temperatures
    tv1 = tconv(1)*(1.+0.608*qconv(1))
    tv2 = tconv(2)*(1.+0.608*qconv(2))
  !  interpolate virtual temperature to half-level
    tv = tv1 + (tv2-tv1)*(pconv(1)-phconv(2))/(pconv(1)-pconv(2))
    if (abs(tv-tvold).gt.0.2) then
      uvzlev(2) = uvzlev(1) + &
           const*log(pold/pint)* &
           (tv-tvold)/log(tv/tvold)
    else
      uvzlev(2) = uvzlev(1)+ &
           const*log(pold/pint)*tv
    endif
    tvold=tv
    tv1=tv2
    pold=pint

  ! integrate profile (calculation of height agl of eta layers) as required
    do kz = 3, nconvtop+1
  !    note that variables defined in calcmatrix.f (pconv,tconv,qconv)
  !    start at the first real ECMWF model level whereas kz and
  !    thus uvzlev(kz) starts at the surface. uvzlev is defined at the
  !    half-levels (between the tconv, qconv etc. values !)
  !    Thus, uvzlev(kz) is the lower boundary of the tconv(kz) cell.
      pint = phconv(kz)
  !    determine next virtual temperatures
      tv2 = tconv(kz)*(1.+0.608*qconv(kz))
  !    interpolate virtual temperature to half-level
      tv = tv1 + (tv2-tv1)*(pconv(kz-1)-phconv(kz))/ &
           (pconv(kz-1)-pconv(kz))
      if (abs(tv-tvold).gt.0.2) then
        uvzlev(kz) = uvzlev(kz-1) + &
             const*log(pold/pint)* &
             (tv-tvold)/log(tv/tvold)
      else
        uvzlev(kz) = uvzlev(kz-1)+ &
             const*log(pold/pint)*tv
      endif
      tvold=tv
      tv1=tv2
      pold=pint

    end do

    ktop = 2

  endif ! (if ktop .le. 1) then

  !  determine vertical grid position of particle in the eta system
  !****************************************************************

  ztold = ztra1(abs(ipart))
  ! find old particle grid position
  do kz = 2, nconvtop
    if (uvzlev(kz) .ge. ztold ) then
      levold = kz-1
      goto 30
    endif
  end do

  ! Particle is above the potentially convective domain. Skip it.
  goto 90

30   continue

  ! now redistribute particles
  !****************************

  !  Choose a random number and find corresponding level of destination
  !  Random numbers to be evenly distributed in [0,1]

  rn = ran3(iseed)

  ! initialize levnew

  levnew = levold

  ffraction = 0.
  totlevmass=dpr(levold)/ga
  do k = 1,nconvtop
  ! for backward runs use the transposed matrix
   if (ldirect.eq.1) then
     ffraction=ffraction+fmassfrac(levold,k) &
          /totlevmass
   else
     ffraction=ffraction+fmassfrac(k,levold) &
          /totlevmass
   endif
   if (rn.le.ffraction) then
     levnew=k
  ! avoid division by zero or a too small number
  ! if division by zero or a too small number happens the
  ! particle is assigned to the center of the grid cell
     if (ffraction.gt.1.e-20) then
      if (ldirect.eq.1) then
        dlevfrac = (ffraction-rn) / fmassfrac(levold,k) * totlevmass
      else
        dlevfrac = (ffraction-rn) / fmassfrac(k,levold) * totlevmass
      endif
     else
       dlevfrac = 0.5
     endif
     goto 40
   endif
  end do

40   continue

  ! now assign new position to particle

  if (levnew.le.nconvtop) then
   if (levnew.eq.levold) then
      ztra1(abs(ipart)) = ztold
   else
    dlogp = (1.-dlevfrac)* &
         (log(phconv(levnew+1))-log(phconv(levnew)))
    pint = log(phconv(levnew))+dlogp
    dz1 = pint - log(phconv(levnew))
    dz2 = log(phconv(levnew+1)) - pint
    dz = dz1 + dz2
    ztra1(abs(ipart)) = (uvzlev(levnew)*dz2+uvzlev(levnew+1)*dz1)/dz
     if (ztra1(abs(ipart)).lt.0.) &
          ztra1(abs(ipart))=-1.*ztra1(abs(ipart))
     if (ipconv.gt.0) ipconv=-1
   endif
  endif

  ! displace particle according to compensating subsidence
  ! this is done to those particles, that were not redistributed
  ! by the matrix
  !**************************************************************

  if (levnew.le.nconvtop.and.levnew.eq.levold) then

  ztold = ztra1(abs(ipart))

  ! determine compensating vertical velocity at the levels
  ! above and below the particel position
  ! increase compensating subsidence by the fraction that
  ! is displaced by convection to this level

    if (levold.gt.1) then
     temp_levold = tconv(levold-1) + &
          (tconv(levold)-tconv(levold-1)) &
          *(pconv(levold-1)-phconv(levold))/ &
          (pconv(levold-1)-pconv(levold))
     sub_levold = sub(levold)/(1.-sub(levold)/dpr(levold)*ga)
     wsub(levold)=-1.*sub_levold*r_air*temp_levold/(phconv(levold))
    else
     wsub(levold)=0.
    endif

     temp_levold1 = tconv(levold) + &
          (tconv(levold+1)-tconv(levold)) &
          *(pconv(levold)-phconv(levold+1))/ &
          (pconv(levold)-pconv(levold+1))
     sub_levold1 = sub(levold+1)/(1.-sub(levold+1)/dpr(levold+1)*ga)
     wsub(levold+1)=-1.*sub_levold1*r_air*temp_levold1/ &
          (phconv(levold+1))

  ! interpolate wsub to the vertical particle position

  dz1 = ztold - uvzlev(levold)
  dz2 = uvzlev(levold+1) - ztold
  dz = dz1 + dz2

  wsubpart = (dz2*wsub(levold)+dz1*wsub(levold+1))/dz
  ztra1(abs(ipart)) = ztold+wsubpart*real(lsynctime)
  if (ztra1(abs(ipart)).lt.0.) then
     ztra1(abs(ipart))=-1.*ztra1(abs(ipart))
  endif

  endif      !(levnew.le.nconvtop.and.levnew.eq.levold)

  ! Maximum altitude .5 meter below uppermost model level
  !*******************************************************

 90   continue

  if (ztra1(abs(ipart)) .gt. height(nz)-0.5) &
       ztra1(abs(ipart)) = height(nz)-0.5

end subroutine redist

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine interpol_vdep(level,vdepo)
  !                           i     o
  !****************************************************************************
  !                                                                           *
  !  Interpolation of the deposition velocity on 2-d model layer.             *
  !  In horizontal direction bilinear interpolation interpolation is used.    *
  !  Temporally a linear interpolation is used.                               *
  !                                                                           *
  !  1 first time                                                             *
  !  2 second time                                                            *
  !                                                                           *
  !                                                                           *
  !     Author: A. Stohl                                                      *
  !                                                                           *
  !     30 May 1994                                                           *
  !                                                                           *
  !****************************************************************************
  !                                                                           *
  ! Variables:                                                                *
  !                                                                           *
  ! level                number of species for which interpolation is done    *
  !                                                                           *
  !****************************************************************************

  use par_mod
  use com_mod
  use interpol_mod

  implicit none

  integer :: level,indexh,m
  real :: y(2),vdepo

  ! a) Bilinear horizontal interpolation

  do m=1,2
    indexh=memind(m)

    y(m)=p1*vdep(ix ,jy ,level,indexh) &
         +p2*vdep(ixp,jy ,level,indexh) &
         +p3*vdep(ix ,jyp,level,indexh) &
         +p4*vdep(ixp,jyp,level,indexh)
  end do



  ! b) Temporal interpolation

  vdepo=(y(1)*dt2+y(2)*dt1)*dtt

  depoindicator(level)=.false.


end subroutine interpol_vdep

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine interpol_all_nests(itime,xt,yt,zt)
  !                                i   i  i  i
  !*****************************************************************************
  !                                                                            *
  !  This subroutine interpolates everything that is needed for calculating the*
  !  dispersion.                                                               *
  !  Version for interpolating nested grids.                                   *
  !                                                                            *
  !    Author: A. Stohl                                                        *
  !                                                                            *
  !    9 February 1999                                                         *
  !    16 December 1997                                                        *
  !                                                                            *
  !  Revision March 2005 by AST : all output variables in common block cal-    *
  !                               culation of standard deviation done in this  *
  !                               routine rather than subroutine call in order *
  !                               to save computation time                     *
  !                                                                            *
  !*****************************************************************************
  !                                                                            *
  ! Variables:                                                                 *
  ! itime [s]          current temporal position                               *
  ! memtime(3) [s]     times of the wind fields in memory                      *
  ! xt,yt,zt           coordinates position for which wind data shall be       *
  !                    calculated                                              *
  !                                                                            *
  ! Constants:                                                                 *
  !                                                                            *
  !*****************************************************************************

  use par_mod
  use com_mod
  use interpol_mod
  use hanna_mod

  implicit none

  integer :: itime
  real :: xt,yt,zt

  ! Auxiliary variables needed for interpolation
  real :: ust1(2),wst1(2),oli1(2),oliaux
  real :: y1(2),y2(2),y3(2),rho1(2),rhograd1(2)
  real :: usl,vsl,wsl,usq,vsq,wsq,xaux
  integer :: i,m,n,indexh
  real,parameter :: eps=1.0e-30


  !********************************************
  ! Multilinear interpolation in time and space
  !********************************************

  ! Determine the lower left corner and its distance to the current position
  !*************************************************************************

  ddx=xt-real(ix)
  ddy=yt-real(jy)
  rddx=1.-ddx
  rddy=1.-ddy
  p1=rddx*rddy
  p2=ddx*rddy
  p3=rddx*ddy
  p4=ddx*ddy

  ! Calculate variables for time interpolation
  !*******************************************

  dt1=real(itime-memtime(1))
  dt2=real(memtime(2)-itime)
  dtt=1./(dt1+dt2)


  !*****************************************
  ! 1. Interpolate u*, w* and Obukhov length
  !*****************************************

  ! a) Bilinear horizontal interpolation

  do m=1,2
    indexh=memind(m)

    ust1(m)=p1*ustarn(ix ,jy ,1,indexh,ngrid) &
         + p2*ustarn(ixp,jy ,1,indexh,ngrid) &
         + p3*ustarn(ix ,jyp,1,indexh,ngrid) &
         + p4*ustarn(ixp,jyp,1,indexh,ngrid)
    wst1(m)=p1*wstarn(ix ,jy ,1,indexh,ngrid) &
         + p2*wstarn(ixp,jy ,1,indexh,ngrid) &
         + p3*wstarn(ix ,jyp,1,indexh,ngrid) &
         + p4*wstarn(ixp,jyp,1,indexh,ngrid)
    oli1(m)=p1*olin(ix ,jy ,1,indexh,ngrid) &
         + p2*olin(ixp,jy ,1,indexh,ngrid) &
         + p3*olin(ix ,jyp,1,indexh,ngrid) &
         + p4*olin(ixp,jyp,1,indexh,ngrid)
  end do

  ! b) Temporal interpolation

  ust=(ust1(1)*dt2+ust1(2)*dt1)*dtt
  wst=(wst1(1)*dt2+wst1(2)*dt1)*dtt
  oliaux=(oli1(1)*dt2+oli1(2)*dt1)*dtt

  if (oliaux.ne.0.) then
    ol=1./oliaux
  else
    ol=99999.
  endif


  !*****************************************************
  ! 2. Interpolate vertical profiles of u,v,w,rho,drhodz
  !*****************************************************


  ! Determine the level below the current position
  !***********************************************

  do i=2,nz
    if (height(i).gt.zt) then
      indz=i-1
      indzp=i
      goto 6
    endif
  end do
6   continue

  !**************************************
  ! 1.) Bilinear horizontal interpolation
  ! 2.) Temporal interpolation (linear)
  !**************************************

  ! Loop over 2 time steps and indz levels
  !***************************************

  do n=indz,indz+1
    usl=0.
    vsl=0.
    wsl=0.
    usq=0.
    vsq=0.
    wsq=0.
    do m=1,2
      indexh=memind(m)
      y1(m)=p1*uun(ix ,jy ,n,indexh,ngrid) &
           +p2*uun(ixp,jy ,n,indexh,ngrid) &
           +p3*uun(ix ,jyp,n,indexh,ngrid) &
           +p4*uun(ixp,jyp,n,indexh,ngrid)
      y2(m)=p1*vvn(ix ,jy ,n,indexh,ngrid) &
           +p2*vvn(ixp,jy ,n,indexh,ngrid) &
           +p3*vvn(ix ,jyp,n,indexh,ngrid) &
           +p4*vvn(ixp,jyp,n,indexh,ngrid)
      y3(m)=p1*wwn(ix ,jy ,n,indexh,ngrid) &
           +p2*wwn(ixp,jy ,n,indexh,ngrid) &
           +p3*wwn(ix ,jyp,n,indexh,ngrid) &
           +p4*wwn(ixp,jyp,n,indexh,ngrid)
      rhograd1(m)=p1*drhodzn(ix ,jy ,n,indexh,ngrid) &
           +p2*drhodzn(ixp,jy ,n,indexh,ngrid) &
           +p3*drhodzn(ix ,jyp,n,indexh,ngrid) &
           +p4*drhodzn(ixp,jyp,n,indexh,ngrid)
      rho1(m)=p1*rhon(ix ,jy ,n,indexh,ngrid) &
           +p2*rhon(ixp,jy ,n,indexh,ngrid) &
           +p3*rhon(ix ,jyp,n,indexh,ngrid) &
           +p4*rhon(ixp,jyp,n,indexh,ngrid)

     usl=usl+uun(ix ,jy ,n,indexh,ngrid)+uun(ixp,jy ,n,indexh,ngrid) &
          +uun(ix ,jyp,n,indexh,ngrid)+uun(ixp,jyp,n,indexh,ngrid)
     vsl=vsl+vvn(ix ,jy ,n,indexh,ngrid)+vvn(ixp,jy ,n,indexh,ngrid) &
          +vvn(ix ,jyp,n,indexh,ngrid)+vvn(ixp,jyp,n,indexh,ngrid)
     wsl=wsl+wwn(ix ,jy ,n,indexh,ngrid)+wwn(ixp,jy ,n,indexh,ngrid) &
          +wwn(ix ,jyp,n,indexh,ngrid)+wwn(ixp,jyp,n,indexh,ngrid)

    usq=usq+uun(ix ,jy ,n,indexh,ngrid)*uun(ix ,jy ,n,indexh,ngrid)+ &
         uun(ixp,jy ,n,indexh,ngrid)*uun(ixp,jy ,n,indexh,ngrid)+ &
         uun(ix ,jyp,n,indexh,ngrid)*uun(ix ,jyp,n,indexh,ngrid)+ &
         uun(ixp,jyp,n,indexh,ngrid)*uun(ixp,jyp,n,indexh,ngrid)
    vsq=vsq+vvn(ix ,jy ,n,indexh,ngrid)*vvn(ix ,jy ,n,indexh,ngrid)+ &
         vvn(ixp,jy ,n,indexh,ngrid)*vvn(ixp,jy ,n,indexh,ngrid)+ &
         vvn(ix ,jyp,n,indexh,ngrid)*vvn(ix ,jyp,n,indexh,ngrid)+ &
         vvn(ixp,jyp,n,indexh,ngrid)*vvn(ixp,jyp,n,indexh,ngrid)
    wsq=wsq+wwn(ix ,jy ,n,indexh,ngrid)*wwn(ix ,jy ,n,indexh,ngrid)+ &
         wwn(ixp,jy ,n,indexh,ngrid)*wwn(ixp,jy ,n,indexh,ngrid)+ &
         wwn(ix ,jyp,n,indexh,ngrid)*wwn(ix ,jyp,n,indexh,ngrid)+ &
         wwn(ixp,jyp,n,indexh,ngrid)*wwn(ixp,jyp,n,indexh,ngrid)
    end do
    uprof(n)=(y1(1)*dt2+y1(2)*dt1)*dtt
    vprof(n)=(y2(1)*dt2+y2(2)*dt1)*dtt
    wprof(n)=(y3(1)*dt2+y3(2)*dt1)*dtt
    rhoprof(n)=(rho1(1)*dt2+rho1(2)*dt1)*dtt
    rhogradprof(n)=(rhograd1(1)*dt2+rhograd1(2)*dt1)*dtt
    indzindicator(n)=.false.

  ! Compute standard deviations
  !****************************

    xaux=usq-usl*usl/8.
    if (xaux.lt.eps) then
      usigprof(n)=0.
    else
      usigprof(n)=sqrt(xaux/7.)
    endif

    xaux=vsq-vsl*vsl/8.
    if (xaux.lt.eps) then
      vsigprof(n)=0.
    else
      vsigprof(n)=sqrt(xaux/7.)
    endif


    xaux=wsq-wsl*wsl/8.
    if (xaux.lt.eps) then
      wsigprof(n)=0.
    else
      wsigprof(n)=sqrt(xaux/7.)
    endif

  end do

end subroutine interpol_all_nests

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

module xmass_mod
  
  implicit none
  
  real,allocatable, dimension (:) :: xmasssave
  
end module xmass_mod

!**********************************************************************
! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
!                                                                     *
! This file is part of FLEXPART.                                      *
!                                                                     *
! FLEXPART is free software: you can redistribute it and/or modify    *
! it under the terms of the GNU General Public License as published by*
! the Free Software Foundation, either version 3 of the License, or   *
! (at your option) any later version.                                 *
!                                                                     *
! FLEXPART is distributed in the hope that it will be useful,         *
! but WITHOUT ANY WARRANTY; without even the implied warranty of      *
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
! GNU General Public License for more details.                        *
!                                                                     *
! You should have received a copy of the GNU General Public License   *
! along with FLEXPART.  If not, see <http://www.gnu.org/licenses/>.   *
!**********************************************************************

subroutine richardson(psurf,ust,ttlev,qvlev,ulev,vlev,nuvz, &
       akz,bkz,hf,tt2,td2,h,wst,hmixplus)
  !                        i    i    i     i    i    i    i
  ! i   i  i   i   i  o  o     o
  !****************************************************************************
  !                                                                           *
  !     Calculation of mixing height based on the critical Richardson number. *
  !     Calculation of convective time scale.                                 *
  !     For unstable conditions, one iteration is performed. An excess        *
  !     temperature (dependent on hf and wst) is calculated, added to the     *
  !     temperature at the lowest model level. Then the procedure is repeated.*
  !                                                                           *
  !     Author: A. Stohl                                                      *
  !                                                                           *
  !     22 August 1996                                                        *
  !                                                                           *
  !     Literature:                                                           *
  !     Vogelezang DHP and Holtslag AAM (1996): Evaluation and model impacts  *
  !     of alternative boundary-layer height formulations. Boundary-Layer     *
  !     Meteor. 81, 245-269.                                                  *
  !                                                                           *
  !     Update: 1999-02-01 by G. Wotawa                                       *
  !     CHANGE: 17/11/2005 Caroline Forster NCEP GFS version                  *
  !                                                                           *
  !     Two meter level (temperature, humidity) is taken as reference level   *
  !     instead of first model level.                                         *
  !     New input variables tt2, td2 introduced.                              *
  !                                                                           *
  !****************************************************************************
  !                                                                           *
  ! Variables:                                                                *
  ! h                          mixing height [m]                              *
  ! hf                         sensible heat flux                             *
  ! psurf                      surface pressure at point (xt,yt) [Pa]         *
  ! tv                         virtual temperature                            *
  ! wst                        convective velocity scale                      *
  !                                                                           *
  ! Constants:                                                                *
  ! ric                        critical Richardson number                     *
  !                                                                           *
  !****************************************************************************

  use par_mod

  implicit none

  integer :: i,k,nuvz,iter,llev
  real :: tv,tvold,zref,z,zold,pint,pold,theta,thetaref,ri
  real :: akz(nuvz),bkz(nuvz),ulev(nuvz),vlev(nuvz),hf,wst,tt2,td2,ew
  real :: psurf,ust,ttlev(nuvz),qvlev(nuvz),h,excess
  real :: thetaold,zl,ul,vl,thetal,ril,hmixplus,wspeed,bvfsq,bvf
  real :: f_qvsat,rh,rhold,rhl,theta1,theta2,zl1,zl2,thetam
  real,parameter :: const=r_air/ga, ric=0.25, b=100., bs=8.5
  integer,parameter :: itmax=3

  excess=0.0
  iter=0

  ! NCEP version: find first model level above ground
  !**************************************************

      llev = 0
      do i=1,nuvz
       if (psurf.lt.akz(i)) llev=i
      end do
       llev = llev+1
  ! sec llev should not be 1!
       if (llev.eq.1) llev = 2
       if (llev.gt.nuvz) llev = nuvz-1
  ! NCEP version


  ! Compute virtual temperature and virtual potential temperature at
  ! reference level (2 m)
  !*****************************************************************

30   iter=iter+1

  pold=psurf
  tvold=tt2*(1.+0.378*ew(td2)/psurf)
  zold=2.0
  zref=zold
  rhold=ew(td2)/ew(tt2)

  thetaref=tvold*(100000./pold)**(r_air/cpa)+excess
  thetaold=thetaref

  ! Integrate z up to one level above zt
  !*************************************

  do k=llev,nuvz
    pint=akz(k)+bkz(k)*psurf  ! pressure on model layers
    tv=ttlev(k)*(1.+0.608*qvlev(k))

    if (abs(tv-tvold).gt.0.2) then
      z=zold+const*log(pold/pint)*(tv-tvold)/log(tv/tvold)
    else
      z=zold+const*log(pold/pint)*tv
    endif

    theta=tv*(100000./pint)**(r_air/cpa)
  ! Petra
    rh = qvlev(k) / f_qvsat( pint, ttlev(k) )


  !alculate Richardson number at each level
  !****************************************

    ri=ga/thetaref*(theta-thetaref)*(z-zref)/ &
         max(((ulev(k)-ulev(2))**2+(vlev(k)-vlev(2))**2+b*ust**2),0.1)

  !  addition of second condition: MH should not be placed in an
  !  unstable layer (PS / Feb 2000)
    if (ri.gt.ric .and. thetaold.lt.theta) goto 20

    tvold=tv
    pold=pint
    rhold=rh
    thetaold=theta
    zold=z
  end do

20   continue

  ! Determine Richardson number between the critical levels
  !********************************************************

  zl1=zold
  theta1=thetaold
  do i=1,20
    zl=zold+real(i)/20.*(z-zold)
    ul=ulev(k-1)+real(i)/20.*(ulev(k)-ulev(k-1))
    vl=vlev(k-1)+real(i)/20.*(vlev(k)-vlev(k-1))
    thetal=thetaold+real(i)/20.*(theta-thetaold)
    rhl=rhold+real(i)/20.*(rh-rhold)
    ril=ga/thetaref*(thetal-thetaref)*(zl-zref)/ &
         max(((ul-ulev(2))**2+(vl-vlev(2))**2+b*ust**2),0.1)
    zl2=zl
    theta2=thetal
    if (ril.gt.ric) goto 25
    zl1=zl
    theta1=thetal
  end do

25   continue
  h=zl
  thetam=0.5*(theta1+theta2)
  wspeed=sqrt(ul**2+vl**2)                    ! Wind speed at z=hmix
  bvfsq=(ga/thetam)*(theta2-theta1)/(zl2-zl1) ! Brunt-Vaisala frequency
                                              ! at z=hmix

  ! Under stable conditions, limit the maximum effect of the subgrid-scale topography
  ! by the maximum lifting possible from the available kinetic energy
  !*****************************************************************************

  if(bvfsq.le.0.) then
    hmixplus=9999.
  else
    bvf=sqrt(bvfsq)
    hmixplus=wspeed/bvf*convke
  endif


  ! Calculate convective velocity scale
  !************************************

  if (hf.lt.0.) then
    wst=(-h*ga/thetaref*hf/cpa)**0.333
    excess=-bs*hf/cpa/wst
    if (iter.lt.itmax) goto 30
  else
    wst=0.
  endif

end subroutine richardson

#!/bin/bash

# export printgrid=$HOME/repos/flexpart/postproc/flex_read_fortran/printgrid

# default path to examples
#examples_default=./
#examples_default=../../examples
examples_default=../examples
# environment override on default
#examples_int=${1:-$examples_default}
examples_env=${examples:-$examples_default}
#internal (argument override)
examples_int=${1:-$examples_env}


#printgrid_default=printgrid
#printgrid_default=/Users/ignacio/repos/flexpart/postproc/flex_read_fortran/printgrid
printgrid_default=../flex_read_fortran/printgrid
# todo test exixtence of executable
# alternative: printgrid_default=$HOME/repos/flexpart/postprocess/read_fortran/printgrid
#overrun by input from ENV
printgrid_env=${printgrid:-$printgrid_default}
# overrun by command line arguments 
printgrid_int=${2:-$printgrid_env}

#printpart_default=../../postprocess/flex_read_fortran_part/printpart
printpart_default=../flex_read_fortran/printpart
#overrun by input from ENV
printpart_env=${printpart:-$printpart_default}
# overrun by command line arguments 
printpart_int=${2:-$printpart_env}



echo default example
stdout=$($printgrid_int $examples_int/output/ conc)
echo default $stdout

set_examples_default=set_examples_1.sh
echo default example variations $set_examples_default

set_examples_env=${set_examples:-$set_examples_default} 

#source ./set_examples_3.sh
#source ./set_examples_1.sh
#source ./set_examples_all
source ./${set_examples_env}

echo 'echo ${examples[@]}' 
echo ${examples[@]} 

iend=$(( ${#examples[@]} - 1 ))
#echo $(( iend + 1 )) 
echo loop on $(( iend + 1  )) examples  
ii=0
for i in `seq 0 $iend`;
do 
  ii=$(( ii + 1 ))
  #echo $i
  #echo $example
  b=${example:0:1}
  #echo $b
#  if [ $i == 3 ]; then  ii=3 ; fi
  if [ $i == 3 ] && [ $b == 1 ]; then  ii=3 ; fi

  example=${examples[$i]}
  unit=${units[$i]}
  format=${formats[$i]}
#    if [ $unit == "x" ]; then
#      echo $i '&' "not gridded binary"
#    else
    if [ $format == "cm" ]; then
      #echo $printgrid_int $examples_int/output_${example}/ ${unit}
      #stdout=$($printgrid_int $examples_int/output_1-1/ conc)
      stdout=$($printgrid_int $examples_int/output_${example}/ ${unit})
      #echo $i '&' ${example}: $stdout
      echo $ii '&' ${example} '&' $stdout '\\'
    elif [ $format == "part" ]; then
      #echo $printpart_int $examples_int/output_${example}/ ${unit}
      stdout=$($printpart_int $examples_int/output_${example}/ ${unit})
      echo $ii '&' ${example} '& xyz:' $stdout '\\'     
    elif [ $format == "nc" ]; then
      grid_conc_default="grid_conc_20190225190000.nc"
      grid_conc_env=${grid_conc:-$grid_conc_default} 
      #echo ${printgrid_int}_ncf $examples_int/output_${example}/ ${unit} $grid_conc_env
      filen=${filens[$i]}
      #echo $filen
      stdout=$(${printgrid_int}_ncf $examples_int/output_${example}/ ${unit} $filen)
      #stdout=$(${printgrid_int}_ncf $examples_int/output_${example}/ ${unit} $grid_conc_env)
      #echo $stdout
      echo $ii '&' ${example} '&' $stdout '\\'       
    else
      echo $ii '&' ${example} '&' $format "not yet supported"
    fi
done

exit
$printgrid_int $examples_int/output_2/ pptv

$printgrid_int $examples_int/output_bwd/ time


exit 

#!/bin/bash
# display in 83 columns
source ./declare_examples

i=$1


examples_value=$(echo "examples"$i)
#echo $examples_value
     #printf -v "examplesi" "%s" "$examples_value" 
     #echo $examplesi
examples="${examples_value}[@]"
#echo examples 1: $examples
    #export examples=("${examplesi[@]}") 
export examples=("${!examples}")
   #echo ${examples[@]}
   #echo examples 2: $examples[@] 
#echo examples 2: ${examples[@] }
echo examples: ${examples[@] }

array_name=$(echo "units"$i)
units="${array_name}[@]"
export units=("${!units}")
echo units: ${units[@] }
  
#export formats=("${formati[@]}") 

array_name=$(echo "format"$i)
target_array="${array_name}[@]"
export formats=("${!target_array}")
echo formats: ${formats[@] }

array_name=$(echo "filens"$i)
target_array="${array_name}[@]"
export filens=("${!target_array}")
echo filens : ${filens[@] }

#source ./display_examples.sh
# output eg:
#3-1_part 20120101100000 part
#3-2_part_end end part
#3-3_part_bwd 20120101080000 part

# H  MDOMAINFILL
# H1: DOMAINFILL
suffix=_7-1_DOMAINFILL
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/MDOMAINFILL=/c\ MDOMAINFILL=   1," $options_new/COMMAND
#sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    0," $options_new/COMMAND

 #### FLEXPART MODEL ERROR! FILE COMMAND:     ####
 #### FOR DOMAIN FILLING RUNS OUTPUT FOR      ####
 #### EACH RELEASE IS FORBIDDEN !             ####
##########################################

# suffix=_7-2_DOMAINFILL_bwd
# options_new=options$suffix
# cp -r  $options_template $options_new
# sed -i "/MDOMAINFILL=/c\ MDOMAINFILL=   1," $options_new/COMMAND
# sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
# sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND



 #### FLEXPART MODEL ERROR! FILE COMMAND:     ####
 #### FOR BACKWARD RUNS, IOUTPUTFOREACHRLEASE ####
 #### MUST BE SET TO ONE!                     ####
##########################################

#!/bin/bash
# By MB
# Build a FLEXPART container
CPATH=$(dirname $0)
#
# using podman to build containers
#
BRANCH=$(git rev-parse --abbrev-ref HEAD)
COMMIT=$(git log --pretty=format:'%h' -n 1)
echo "Building flexpart v11 branch: $BRANCH : $COMMIT"
read -n1 -rsp $'Press any key to continue or Ctrl+C to exit...\n'

cd $CPATH

if [ "$1" != "apptainer" ]; then
    # build with subdirectory as root
    podman build -f Dockerfile -t flexpartv11-${BRANCH}:${COMMIT} --build-arg COMMIT=$COMMIT ../
    # registry
    # podman build -t harbor.wolke.img.univie.ac.at/flexpart/flexpartv11-${BRANCH}:$COMMIT --build-arg COMMIT=$COMMIT ..
else
    apptainer build flexpartv11-${BRANCH}-${COMMIT}.sif Singularity
fi

#E: unit indices

## forward 
#E1: ind 1 2 
suffix=_4-1_ind_1_2
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IND_RECEPTOR=/c\ IND_RECEPTOR=   2,' $options_new/COMMAND

#E2: ind 2 1  
suffix=_4-2_ind_2_1
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND

#E3: ind 2 2
suffix=_4-3_ind_2_2
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND
sed -i "/IND_RECEPTOR=/c\ IND_RECEPTOR=    2," $options_new/COMMAND


## backward
#E4: bwd 1 2 --   
suffix=_4-4_bwd_ind_1_2
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_RECEPTOR=/c\ IND_RECEPTOR=    2," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

#E5: bwd 2 1 -- 
suffix=_4-5_bwd_ind_2_1
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

#E6: bwd 2 2
suffix=_4-6_bwd_ind_2_2
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND
sed -i "/IND_RECEPTOR=/c\ IND_RECEPTOR=    2," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

# J CBLFLAG
# J 1 -- CBLFLAG fwd
suffix=_9-1_CBLFLAG
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/CBLFLAG=/c\ CBLFLAG=   1," $options_new/COMMAND
sed -i "/CTL=/c\ CTL=     10," $options_new/COMMAND
sed -i "/IFINE=/c\ IFINE=  10," $options_new/COMMAND


# J 2 -- CBLFLAG bwd
suffix=_9-2_CBLFLAG_bwd
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/CBLFLAG=/c\ CBLFLAG=   1," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND
sed -i "/CTL=/c\ CTL=     10," $options_new/COMMAND
sed -i "/IFINE=/c\ IFINE=  10," $options_new/COMMAND

#G nested output

#G1
suffix=_6-1_nested
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND


#G2
suffix=_6-2_nested_mr
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND
sed -i '/IOUT=/c\ IOUT=2,' $options_new/COMMAND


#G3
suffix=_6-3_nested_bwd
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND



#G4
suffix=_6-4_nested_nc
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND
sed -i '/IOUT=/c\ IOUT=9,' $options_new/COMMAND

#G5
suffix=_6-5_nested_mr_nc
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND
sed -i '/IOUT=/c\ IOUT=10,' $options_new/COMMAND


#G6
suffix=_6-6_nested_bwd_nc
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND
sed -i '/IOUT=/c\ IOUT=9,' $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

exit




#G1
suffix=_6-3_nested1
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND
sed -i "/LON1=/c\ LON1=  -0.1," $options_new/RELEASES
sed -i "/LON1=/c\ LON1=   0.1," $options_new/RELEASES
sed -i "/OUTLAT0=/c\ OUTLAT0=  -3," $options_new/OUTGRID_NEST



# LON1=    0.000    ,
# LON2=    0.000    ,
# LAT1=   0.000    ,
# LAT2=   0.000    ,
# Z1=    50.000       ,
# Z2=    50.000       ,

#G2
suffix=_6-4_nested1_bwd
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=   1," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

#!/bin/bash
# By MB
# run FLEXPART, but provide a bit of information

RED='\033[0;31m'
GREEN='\033[0;32m'
YELLOW='\033[1;33m'
NC='\033[0m'
report() {
    if [ $? -eq 0 ]; then
        printf "%-68s[$GREEN%10s$NC]\n" "$@" "OK"
        return 0
    else
        printf "%-68s[$RED%10s$NC]\n" "$@" "FAILED"
        return 1
    fi
}

echo "Welcome, running FLEXPART "
test -e /pathnames
report "Using defaults (/pathnames)"
cat /pathnames
echo "Mount volumes to change inputs"
echo "Git: $COMMIT"
echo "EXECUTING FLEXPART"
if [ $# -eq 1 ]; then
    test -e /src/"$1"
    report "Executing: /src/$1"
    if [ $? -eq 0 ]; then
        /src/"$1" /pathnames
    else
        test -e "$1"
        report "Executing: $1"
        if [ $? -eq 0 ]; then
            exec "$1"
        fi
    fi

elif [ $# -eq 2 ]; then
    test -e /src/"$1"
    report "Executing: /src/$1 $2"
    if [ $? -eq 0 ]; then
        /src/"$1" "$2"
    fi
else
    test -e /src/FLEXPART_ETA
    report "Executing: /src/FLEXPART_ETA"
    /src/FLEXPART_ETA /pathnames
fi
echo "FINISHED"

#!/bin/bash
# runs the definitions $define_options with template $options_template
# options_template is a working options dir, by default from the repo HEAD
# $define_options must contain a suffix (empty for default) and sed substitutions

define_options_default=define_options_default.sh
#define_options=${1:-$define_options_default}
define_options=${1:-$define_options_default}


#template is in 1 or defalt here
#options_template_default=~/repos/flexpart/options
#options_template_default=~/repos/flex_gen_input/reference/options
# relative path, options reference copied 
#options_template_default=./options
# relative path to be included in the distribution
options_template_default=./options

options_template=${2:-$options_template_default}

# to do: 
# source settings

#define options contains $options_template 
source $define_options

#!/bin/bash

OUTPUTdefault="$(ls -1 *.cl)"
#OUTPUT=${OUTPUTvar:-$OUTPUTdefault}
# could input a subset of jobs to run "$(ls -1 *.cl)"
OUTPUT=${1:-$OUTPUTdefault}

#rm joblist

for i in ${OUTPUT}
do
   echo batch job $i #| tee -a joblist1$group
   #source $i | tee -a joblist2$group
   source $i | tee ${i}.stdout  # -a joblist2$group
   echo '##########################################' 
done

#!/bin/bash
# Ignacio Pisso 4/2018
# modified 30/10/18
# change default executable to  "../../FLEXPART". IP 12/2018
# optional args: 
# 1) flexpart executable (default "../../FLEXPART")
# 2) FLEXPART inline arguments (-i, -v, etc) (default none)
# example gen_batch_jobs_cl.sh FLEXPART -i

OUTPUTdefault="$(ls -1 pathnames*)"
OUTPUT=${OUTPUTvar:-$OUTPUTdefault}
#OUTPUTpwd="$(pwd)"



#FLEXPARTdefault=FLEXPART_8d70e43
# if FLEXPART is in $PATH
FLEXPARTdefault=../../src/FLEXPART

FLEXPART_env=${FLEXPART:-$FLEXPARTdefault}

#FLEXPART=${FLEXPARTvar:-$FLEXPARTdefault}
# $FLEXPART is the command line in or default defined above
#FLEXPART=${1:-$FLEXPARTdefault}
FLEXPART=${1:-$FLEXPART_env}

argsdefault=' ' # blank string
# if 2nd arg
args=${2:-$argsdefault}

# echo $OUTPUT

for i in ${OUTPUT}
do

suffix=${i#*patnames}

#FP_slurm_batch_sl=slurm_batch_$i.sl
#FP_slurm_batch_sl=batch_dry_$i.sl
#FP_slurm_batch_sl=clrun_full_$i.sl
#FP_slurm_batch_sl=fork_cl_$i.sl
FP_slurm_batch_sl=batch_job_$suffix.cl

#        echo  '                                          ' >> $FP_slurm_batch_sl
        echo  '                                          ' > $FP_slurm_batch_sl
        #FLEXPART_run_string="$FLEXPART  $i -i"
        FLEXPART_run_string="$FLEXPART  $i $args"
        echo $FLEXPART_run_string   >> $FP_slurm_batch_sl
	echo $FLEXPART_run_string
done

#C: backward runs: bwd, bwd5, bwd_nc
#rm -r  *_bwd
#C1: bwd -- default (conc)

suffix=_2-1_bwd
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/LDIRECT=/c\ LDIRECT=    -1,' $options_new/COMMAND
sed -i '/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1,' $options_new/COMMAND
sed -i '/IOUT=/c\ IOUT=    1,' $options_new/COMMAND #should not be needed

#C2: bwd5 -- bwd cluster 
suffix=_2-2_bwd5
options_new=options$suffix
#options_new=options_bwd5
cp -r  $options_template $options_new
sed -i '/LDIRECT=/c\ LDIRECT=    -1,' $options_new/COMMAND
sed -i '/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1,' $options_new/COMMAND
sed -i '/IOUT=/c\ IOUT=    5,' $options_new/COMMAND

#C3: bwd_nc -- bwd netCDF
suffix=_2-3_bwd_nc
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/LDIRECT=/c\ LDIRECT=    -1,' $options_new/COMMAND
sed -i '/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1,' $options_new/COMMAND
sed -i '/IOUT=/c\ IOUT=    9,' $options_new/COMMAND

#!/bin/bash
# By LB
# run ETEX simulations
RED='\033[0;31m'
GREEN='\033[0;32m'
YELLOW='\033[1;33m'
NC='\033[0m'
MM='FLEXPART AUTOMATIC OPTIONS TEST'

warning() {
    printf "%-68s[$YELLOW%10s$NC]\n" "$@" "SKIPPED"
    return 0
}

report() {
    if [ $? -eq 0 ]; then
        printf "%-68s[$GREEN%10s$NC]\n" "$@" "OK"
        return 0
    else
        printf "%-68s[$RED%10s$NC]\n" "$@" "FAILED"
        return 1
    fi
}
#
# initial conditions
#
warning "[$MM] $PWD"
#
# Change to directory of this script
#
cd $(dirname $0)
#
# Check for Flexpart executable build before
#
test -f ../src/FLEXPART
report "[$MM] executable: ../src/FLEXPART" || exit 1
ln -s ../src/FLEXPART .
test -d ./default_options
report "[$MM] default options: ./default_options" || exit 1
cp -rf ./default_options ./current
#
# Different options tests
#
STATUS=0
TESTSRUN=0
#
# run Options test with restart output disabled
#
sed -i "/LCONVECTION=/c\ LCONVECTION=      1," ./current/COMMAND
sed -i "/LTURBULENCE=/c\ LTURBULENCE=      1," ./current/COMMAND
#sed -i "/IPOUT=/c\ IPOUT=                  1," ./current/COMMAND
sed -i "/IBDATE=/c\ IBDATE=         19941023," ./current/COMMAND
sed -i "/IBTIME=/c\ IBTIME=           160000," ./current/COMMAND
sed -i "/IEDATE=/c\ IEDATE=         19941027," ./current/COMMAND
sed -i "/IETIME=/c\ IETIME=           110000," ./current/COMMAND
sed -i "/LOUTSTEP=/c\ LOUTSTEP=        10800," ./current/COMMAND
sed -i "/LOUTAVER=/c\ LOUTAVER=        10800," ./current/COMMAND
sed -i "/CTL=/c\ CTL=                10.0000," ./current/COMMAND
sed -i "/IFINE=/c\ IFINE=                  4," ./current/COMMAND
sed -i "/LOUTNETCDFOUT=/c\ LOUTNETCDFOUT=  1," ./current/COMMAND

sed -i "/IDATE1  =/c\ IDATE1  =       19941023," ./current/RELEASES
sed -i "/ITIME1  =/c\ ITIME1  =         160000," ./current/RELEASES
sed -i "/ITIME2  =/c\ ITIME2  =         035000," ./current/RELEASES
sed -i "/IDATE2  =/c\ IDATE2  =       19941024," ./current/RELEASES
sed -i "/LON1    =/c\ LON1    =    -2.00833011," ./current/RELEASES
sed -i "/LON2    =/c\ LON2    =    -2.00833011," ./current/RELEASES
sed -i "/LAT1    =/c\ LAT1    =        48.0583," ./current/RELEASES
sed -i "/LAT2    =/c\ LAT2    =        48.0583," ./current/RELEASES
sed -i "/Z1      =/c\ Z1    =         8.0000," ./current/RELEASES
sed -i "/Z2      =/c\ Z2    =       100.0000," ./current/RELEASES
sed -i "/MASS    =/c\ MASS    =       340.000," ./current/RELEASES
sed -i "/PARTS   =/c\ PARTS   =          10000," ./current/RELEASES

sed -i "/OUTLON0=/c\ OUTLON0=           -10.000," ./current/OUTGRID
sed -i "/OUTLAT0=/c\ OUTLAT0=            43.000," ./current/OUTGRID
sed -i "/NUMXGRID=/c\ NUMXGRID=            101," ./current/OUTGRID
sed -i "/NUMYGRID=/c\ NUMYGRID=             49," ./current/OUTGRID
sed -i "/DXOUT=/c\ DXOUT=              0.5," ./current/OUTGRID
sed -i "/DYOUT=/c\ DYOUT=              0.5," ./current/OUTGRID
sed -i "/OUTHEIGHTS=/c\ OUTHEIGHTS=      100.0" ./current/OUTGRID

cp ./default_etex/RECEPTORS ./current/

cp pathnames pathnames_etex
sed -i "/output/c\./output_etex/" ./pathnames_etex
sed -i "s/default_winds/default_etex/g" ./pathnames_etex
mkdir -p ./output_etex/
./FLEXPART pathnames_etex
report "[$MM] TEST $TESTRUN (ETEX)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
#
# FINAL
#
echo "[$MM] Tests failed: $STATUS / $TESTSRUN"
#
# Return collective error status
#
exit $STATUS

# I  LINIT_COND + SURF_ONLY
# I1: Gmode
#suffix=_8-1_Gmode_bwd
suffix=_8-1_init_cond
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/LINIT_COND=/c\ LINIT_COND=   1," $options_new/COMMAND
sed -i "/SURF_ONLY=/c\ SURF_ONLY=   1," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

# I2: Gmode_bwd
suffix=_8-2_init_cond_surf
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/LINIT_COND=/c\ LINIT_COND=   1," $options_new/COMMAND
sed -i "/SURF_ONLY=/c\ SURF_ONLY=   1," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

# I2: Gmode_bwd
suffix=_8-3_init_cond_ind_2_1
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/LINIT_COND=/c\ LINIT_COND=   1," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND
sed -i '/IND_RECEPTOR=/c\ IND_RECEPTOR=   2,' $options_new/COMMAND


#suffix=_8-4_init_cond_ind_1_2
#options_new=options$suffix
#cp -r  $options_template $options_new
#sed -i "/LINIT_COND=/c\ LINIT_COND=   1," $options_new/COMMAND
#sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
#sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND
#sed -i '/IND_RECEPTOR=/c\ IND_RECEPTOR=   2,' $options_new/COMMAND
#sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND
#sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND


# suffix=_8-5_init_cond_ind_2_2
# options_new=options$suffix
# cp -r  $options_template $options_new
# sed -i "/LINIT_COND=/c\ LINIT_COND=   1," $options_new/COMMAND
# sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
# sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND
# sed -i '/IND_RECEPTOR=/c\ IND_RECEPTOR=   2,' $options_new/COMMAND
# sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND

suffix=_10-1_bwd_ind_1_3
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_RECEPTOR=/c\ IND_RECEPTOR=    3," $options_new/COMMAND
#sed -i "/IND_SOURCE=/c\ IND_SOURCE=    3," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

suffix=_10-2_bwd_ind_1_4
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_RECEPTOR=/c\ IND_RECEPTOR=    4," $options_new/COMMAND
#sed -i "/IND_SOURCE=/c\ IND_SOURCE=    4," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

exit
# to do: check mixing ratio

suffix=_10-3_bwd_ind_2_3
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_RECEPTOR=/c\ IND_RECEPTOR=    3," $options_new/COMMAND
sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

suffix=_10-4_bwd_ind_2_4
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/IND_RECEPTOR=/c\ IND_RECEPTOR=    4," $options_new/COMMAND
sed -i "/IND_SOURCE=/c\ IND_SOURCE=    2," $options_new/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

#!/bin/bash
# By MB
# run default tests
RED='\033[0;31m'
GREEN='\033[0;32m'
YELLOW='\033[1;33m'
NC='\033[0m'
MM='FLEXPART AUTOMATIC OPTIONS TEST'

warning() {
    printf "%-68s[$YELLOW%10s$NC]\n" "$@" "SKIPPED"
    return 0
}

report() {
    if [ $? -eq 0 ]; then
        printf "%-68s[$GREEN%10s$NC]\n" "$@" "OK"
        return 0
    else
        printf "%-68s[$RED%10s$NC]\n" "$@" "FAILED"
        return 1
    fi
}
#
# initial conditions
#
warning "[$MM] $PWD"
#
# Change to directory of this script
#
cd $(dirname $0)
#
# Check for Flexpart executable build before
#
test -f ../src/FLEXPART
report "[$MM] executable: ../src/FLEXPART" || exit 1
ln -s ../src/FLEXPART .
ln -s ../src/FLEXPART_ETA .
test -d ./default_options
report "[$MM] default options: ./default_options" || exit 1
cp -rf ./default_options ./current
mkdir -p ./output/
#
# Different options tests
#
STATUS=0
TESTSRUN=0
#
#
# 
#BACKWARD WET DEPOSITION
cp -rf ./default_options ./current
sed -i "/LDIRECT=/c\ LDIRECT=   -1," ./current/COMMAND
# change release
# 
# IND_RECEPTOR=          1, ! Unit to be used at the receptor; [0]no receptor [1]mass 2]mass mixing ratio 3]wet depo. 4]dry depo.
# ! Release start time in UTC HHMISS: HH hours, MI=minutes, SS=seconds
sed "/SPECNUM_REL=/c\ SPECNUM_REL=   40," ./default_options/RELEASES > ./current/RELEASES
sed -i "/PSHAPE=/c\ PSHAPE= 0," ./current/SPECIES/SPECIES_040
sed -i "/PDQUER=/c\ PDQUER=1.0E-06," ./current/SPECIES/SPECIES_040
sed -i "/ITIME1  =/c\ ITIME1  =   030000," ./current/RELEASES
sed -i "/ITIME2  =/c\ ITIME2  =   030000," ./current/RELEASES
sed -i "/LON1    =/c\ LON1    =    -50.0," ./current/RELEASES
sed -i "/LON2    =/c\ LON2    =    50.0," ./current/RELEASES
sed -i "/LAT1    =/c\ LAT1    =        10.0," ./current/RELEASES
sed -i "/LAT2    =/c\ LAT2    =        80.0," ./current/RELEASES
sed -i "/Z1      =/c\ Z1      =         1.0000," ./current/RELEASES
sed -i "/Z2      =/c\ Z2      =       100.0000," ./current/RELEASES
sed -i "/IND_RECEPTOR/c\ IND_RECEPTOR=  3," ./current/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=  1," ./current/COMMAND

cp pathnames pathnames_tmp
sed -i "/output/c\./output_bkw/" ./pathnames_tmp
mkdir output_bkw

./FLEXPART pathnames_tmp

cp pathnames pathnames_tmp
sed -i "/output/c\./output_bkw_eta/" ./pathnames_tmp
mkdir output_bkw_eta

./FLEXPART_ETA pathnames_tmp

report "[$MM] TEST $TESTRUN (IND_RECEPTOR=3)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current
#
# 
#BACKWARD DRY DEPOSITION
cp -rf ./default_options ./current
sed -i "/LDIRECT=/c\ LDIRECT=   -1," ./current/COMMAND
sed "/SPECNUM_REL=/c\ SPECNUM_REL=   40," ./default_options/RELEASES > ./current/RELEASES
sed -i "/PSHAPE=/c\ PSHAPE= 0," ./current/SPECIES/SPECIES_040
sed -i "/PDQUER=/c\ PDQUER=1.0E-06," ./current/SPECIES/SPECIES_040
sed -i "/ITIME1  =/c\ ITIME1  =   030000," ./current/RELEASES
sed -i "/ITIME2  =/c\ ITIME2  =   030000," ./current/RELEASES
sed -i "/LON1    =/c\ LON1    =    -50.0," ./current/RELEASES
sed -i "/LON2    =/c\ LON2    =    50.0," ./current/RELEASES
sed -i "/LAT1    =/c\ LAT1    =        10.0," ./current/RELEASES
sed -i "/LAT2    =/c\ LAT2    =        80.0," ./current/RELEASES
sed -i "/Z1      =/c\ Z1    =         1.0000," ./current/RELEASES
sed -i "/Z2      =/c\ Z2    =       100.0000," ./current/RELEASES
sed -i "/IND_RECEPTOR/c\ IND_RECEPTOR=  4," ./current/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=  1," ./current/COMMAND

cp pathnames pathnames_tmp
sed -i "/output/c\./output_bkw/" ./pathnames_tmp
./FLEXPART pathnames_tmp

cp pathnames pathnames_tmp
sed -i "/output/c\./output_bkw_eta/" ./pathnames_tmp
./FLEXPART_ETA pathnames_tmp

report "[$MM] TEST $TESTRUN (IND_RECEPTOR=4)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current
#
#
#Convection
cp -rf ./default_options ./current
sed -i "/LCONVECTION=/c\ LCONVECTION=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (LCONVECTION=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#Turbulence
cp -rf ./default_options ./current
sed -i "/LTURBULENCE=/c\ LTURBULENCE=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (LTURBULENCE=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#Mesoscale turbulence
cp -rf ./default_options ./current
sed -i "/LTURBULENCE_MESO=/c\ LTURBULENCE_MESO=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (LTURBULENCE_MESO=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#CTL option
cp -rf ./default_options ./current
sed -i "/LTURBULENCE=/c\ LTURBULENCE=  1," ./current/COMMAND
sed -i "/CTL=/c\ CTL=  10.0000," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (CTL=10)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#CBLFLAG
cp -rf ./default_options ./current
sed -i "/LTURBULENCE=/c\ LTURBULENCE=  1," ./current/COMMAND
sed -i "/CTL=/c\ CTL=  10.0000," ./current/COMMAND
sed -i "/IFINE=/c\ IFINE=  10," ./current/COMMAND
sed -i "/CBLFLAG=/c\ CBLFLAG=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (CBLFLAG=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#NETCDF output
cp -rf ./default_options ./current
sed -i "/IOUT=/c\ IOUT=  9," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (IOUT=9)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#NETCDF particle output
cp -rf ./default_options ./current
sed -i "/IPOUT=/c\ IPOUT=  1," ./current/COMMAND
sed "/SPECNUM_REL=/c\ SPECNUM_REL=   40," ./default_options/RELEASES > ./current/RELEASES
sed -i "/PSHAPE=/c\ PSHAPE= 0," ./current/SPECIES/SPECIES_040
sed -i "/LON1    =/c\ LON1    =    10.00833011," ./current/RELEASES
sed -i "/LON2    =/c\ LON2    =    30.00833011," ./current/RELEASES
sed -i "/LAT1    =/c\ LAT1    =        20.0583," ./current/RELEASES
sed -i "/LAT2    =/c\ LAT2    =        50.0583," ./current/RELEASES
sed -i "/Z1      =/c\ Z1      =         0.0100," ./current/RELEASES
sed -i "/Z2      =/c\ Z2      =       100.0100," ./current/RELEASES
sed -i "/PDQUER/c\ PDQUER=1.0E-06" ./current/SPECIES/SPECIES_040

cp pathnames pathnames_tmp
sed -i "/output/c\./output_settling/" ./pathnames_tmp
#sed -i "s/default_winds/default_etex/g" ./pathnames_tmp
mkdir output_settling
export OMP_NUM_THREADS=1
./FLEXPART pathnames_tmp

cp pathnames pathnames_tmp
sed -i "/output/c\./output_settling_eta/" ./pathnames_tmp
#sed -i "s/default_winds/default_etex/g" ./pathnames_tmp
mkdir output_settling_eta
./FLEXPART_ETA pathnames_tmp

export OMP_NUM_THREADS=32
report "[$MM] TEST $TESTRUN (IPOUT=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current
#
#
#NETCDF particle output at the end
cp -rf ./default_options ./current
sed -i "/IPOUT=/c\ IPOUT=  2," ./current/COMMAND
sed "/SPECNUM_REL=/c\ SPECNUM_REL=   40," ./default_options/RELEASES > ./current/RELEASES
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (IPOUT=2)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#LSUBGRID
cp -rf ./default_options ./current
sed -i "/LSUBGRID=/c\ LSUBGRID=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (LSUBGRID=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#AGESPECTRA
cp -rf ./default_options ./current
sed -i "/LAGESPECTRA=/c\ LAGESPECTRA=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (LAGESPECTRA=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#
#OUTRESTART
cp -rf ./default_options ./current
sed -i "/LOUTRESTART=/c\ LOUTRESTART=  3600," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (LOUTRESTART=3600)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
#
# and IPIN
mv output/restart_20090101020000 output/restart.bin
sed -i "/IPIN=/c\ IPIN=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (IPIN=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#PART_IC.NC input
cp -rf ./default_options ./current
sed -i "/IPIN=/c\ IPIN=  3," ./current/COMMAND
sed -i "/LDIRECT=/c\ LDIRECT=   -1," ./current/COMMAND
sed -i "/LOUTRESTART=/c\ LOUTRESTART=  3600," ./current/COMMAND
sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=  1," ./current/COMMAND
sed -i "/IOUT=/c\ IOUT=  1," ./current/COMMAND
sed -i "/IBTIME=/c\ IBTIME=  020000," ./current/COMMAND
sed -i "/LOUTSTEP=/c\ LOUTSTEP=  3600," ./current/COMMAND
sed -i "/LOUTAVER=/c\ LOUTAVER=  3600," ./current/COMMAND
cp -rf part_ic.nc current/
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (IPIN=3)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))

# and IPIN=4
mv output/restart_20090101020000 output/restart.bin
sed -i "/IPIN=/c\ IPIN=  4," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (IPIN=4)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#IFLUX
cp -rf ./default_options ./current
sed -i "/IFLUX=/c\ IFLUX=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (IFLUX=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#MDOMAINFILL
cp -rf ./default_options ./current
sed -i "/MDOMAINFILL=/c\ MDOMAINFILL=  1," ./current/COMMAND
sed -i "/NXSHIFT=/c\ NXSHIFT=   89," ./current/COMMAND
sed -i "/IOUT=/c\ IOUT=   0," ./current/COMMAND
sed -i "/IPOUT=/c\ IPOUT=   1," ./current/COMMAND
sed -i "/LOUTNETCDFOUT=/c\ LOUTNETCDFOUT=   1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (MDOMAINFILL=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#MQUASILAG
cp -rf ./default_options ./current
sed -i "/MQUASILAG=/c\ MQUASILAG=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (MQUASILAG=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#NESTED_OUTPUT
cp -rf ./default_options ./current
sed -i "/NESTED_OUTPUT=/c\ NESTED_OUTPUT=  1," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (NESTED_OUTPUT=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#NESTED_INPUT
#
#
#LINIT_COND
cp -rf ./default_options ./current
sed -i "/LINIT_COND=/c\ LINIT_COND=  1," ./current/COMMAND
sed -i "/LNETCDFOUT=/c\ LNETCDFOUT=  0," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (LINIT_COND=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#SFC_ONLY
cp -rf ./default_options ./current
sed -i "/SFC_ONLY=/c\ SFC_ONLY=  1," ./current/COMMAND
sed -i "/LNETCDFOUT=/c\ LNETCDFOUT=  0," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (SFC_ONLY=1)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*
#
#
#MAXTHREADGRID
cp -rf ./default_options ./current
sed -i "/MAXTHREADGRID=/c\ MAXTHREADGRID=  10," ./current/COMMAND
./FLEXPART pathnames
report "[$MM] TEST $TESTRUN (MAXTHREADGRID=10)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
# clean up
rm -rf ./current ./output/*

# Test particale output (ipout=1)
# between openmp=1 and openmp=?? the locations should be identical
# no convection no turbulence
#

#
# Add comaprison with MASTER branch outputs
# add as a volume
#
#

#
# FINAL
#
echo "[$MM] Tests failed: $STATUS / $TESTSRUN"
#
# Return collective error status
#
exit $STATUS

suffix=_1-1_1
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IOUT=/c\ IOUT=1,' $options_new/COMMAND

suffix=_1-2_2
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IOUT=/c\ IOUT=2,' $options_new/COMMAND

suffix=_1-3_3
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IOUT=/c\ IOUT=3,' $options_new/COMMAND

#suffix=_1-4_4
#options_new=options$suffix
#cp -r  $options_template $options_new
#sed -i '/IOUT=/c\ IOUT=4,' $options_new/COMMAND

suffix=_1-5_5
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IOUT=/c\ IOUT=5,' $options_new/COMMAND

suffix=_1-6_9
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IOUT=/c\ IOUT=9,' $options_new/COMMAND

suffix=_1-7_10
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IOUT=/c\ IOUT=10,' $options_new/COMMAND

suffix=_1-8_11
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IOUT=/c\ IOUT=11,' $options_new/COMMAND

#suffix=_1-9_12
#options_new=options$suffix
#cp -r  $options_template $options_new
#sed -i '/IOUT=/c\ IOUT=12,' $options_new/COMMAND

#!/bin/bash

#hardcoded defaults
options_default=./options/
output_default=./output/
flex_winds_default=./flex_extract/work/ #blank 
AVAILABLE_default=./AVAILABLE

# flex_winds=${1:-"../flex_extract/work/"}
# AVAILABLE=${2:-"../AVAILABLE_flex_ecmwf_EA"}

#overrun by input from ENV
options_env=${options:-$options_default}
output_env=${output:-$output_default}
flex_winds_env=${flex_winds:-$flex_winds_default}
AVAILABLE_env=${AVAILABLE:-$AVAILABLE_default}

# overrun by command line arguments 
options_pathnames=${3:-$options_env}
output_pathnames=${4:-$output_env}
flex_winds_pathnames=${2:-$flex_winds_env}
AVAILABLE_pathnames=${1:-$AVAILABLE_env} 

# generate output 
echo $options_pathnames > pathnames
echo $output_pathnames >> pathnames
echo $flex_winds_pathnames >> pathnames
echo $AVAILABLE_pathnames >> pathnames

#!/bin/bash
# loop on list of option dirs 
# extract suffixes 
# generate corresponding pathnames from working template
# make corresponding output dirs locally

# snippet from 
# /Users/ignacio/todo/doing/flexpart/2018-05-25/loop_on_ls.sh
# /Users/ignacio/todo/doing/flexpart/2018-05-24/loop_on_ls.sh
# there the aim was to convert the format

#pathnames_template=~/repos/flexpart/pathnames
pathnames_template=./pathnames
echo pathnames_template = $pathnames_template 

#defaultdir=
#echo $defaultdir

#OUTPUT="$(ls -d1 ${1:-$defaultdir}options*)"
#option_dir_list="$(ls -d1 options*)"
#option_dir_list=${1:-"$(ls -d1 options*)"}
option_dir_list="$(ls -d1 options${1}*)"


for i in ${option_dir_list}
do
  # echo $i
  # echo expand:
  # extract suffix from options dirs
  suffix=${i#*options}
  echo suffix=$suffix
  options_new=$i

  # define name of new output and create it
  output_new=output$suffix
  if [ -d $output_new ]; then
     mv $output_new ${output_new}.bk 
  fi 
  mkdir $output_new

  # define name of new pathnames
  pathnames_new=pathnames$suffix
  echo pathnames_new = $pathnames_new
  # copy template (contains valid AVAILABLE file and winds)
  cp $pathnames_template $pathnames_new
  # replace options line
  sed -i "s/\boptions\b/$options_new/g" $pathnames_new
  # replace output line
  sed -i "s/\boutput\b/$output_new/g" $pathnames_new
done

#D: particle output
#D1: part1: Trajectories from default (conc)
#D2: part2 -- default + partposit in the end
#D3: part_bwd1 --  backward trajectories 
#D4: part_QUASILAG: Trajectories MQUASILAG


#D1: part1: Trajectories from default (conc)
suffix=_3-part1
#options_new=options_part1
options_new=options$suffix
cp -r  $options_template $options_new
sed -i '/IPOUT=/c\ IPOUT=    1,' $options_new/COMMAND

#D2: part2 -- default + partposit in the end
suffix=_3-part2
options_new=options$suffix
#options_new=options_part2
cp -r  $options_template $options_new
sed -i '/IPOUT=/c\ IPOUT=    2,' $options_new/COMMAND

#D3: part_bwd1 --  backward trajectories 
suffix=_3-part_bwd1
options_new=options$suffix
#options_new=options_part_bwd1
cp -r  $options_template $options_new
sed -i '/LDIRECT=/c\ LDIRECT=    -1,' $options_new/COMMAND
sed -i '/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1,' $options_new/COMMAND
sed -i '/IPOUT=/c\ IPOUT=    1,' $options_new/COMMAND

#D4: part_QUASILAG: Trajectories MQUASILAG
#suffix=_3-part_QUASILAG
#options_new=options$suffix
#cp -r  $options_template $options_new
#sed -i '/MQUASILAG=/c\ MQUASILAG=    1,' $options_new/COMMAND
#sed -i '/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    0,' $options_new/COMMAND

#!/bin/bash
# By LB
# run OpenMP simulations
RED='\033[0;31m'
GREEN='\033[0;32m'
YELLOW='\033[1;33m'
NC='\033[0m'
MM='FLEXPART AUTOMATIC OPTIONS TEST'

warning() {
    printf "%-68s[$YELLOW%10s$NC]\n" "$@" "SKIPPED"
    return 0
}

report() {
    if [ $? -eq 0 ]; then
        printf "%-68s[$GREEN%10s$NC]\n" "$@" "OK"
        return 0
    else
        printf "%-68s[$RED%10s$NC]\n" "$@" "FAILED"
        return 1
    fi
}
#
# initial conditions
#
warning "[$MM] $PWD"
#
# Change to directory of this script
#
cd $(dirname $0)
#
# Check for Flexpart executable build before
#
test -f ../src/FLEXPART
report "[$MM] executable: ../src/FLEXPART" || exit 1
ln -s ../src/FLEXPART .
ln -s ../src/FLEXPART_ETA .
test -d ./default_options
report "[$MM] default options: ./default_options" || exit 1
cp -rf ./default_options ./current
#
# Different options tests
#
STATUS=0
TESTSRUN=0
#
# run Options test with restart output disabled
#
sed "/LCONVECTION=/c\ LCONVECTION=   0," ./default_options/COMMAND > ./current/COMMAND
sed -i "/LTURBULENCE=/c\ LTURBULENCE=   0," ./current/COMMAND
sed -i "/IPOUT=/c\ IPOUT=   1," ./current/COMMAND

# Aerosol particles to capture settling speeds, dry and wet deposition in output
sed "/SPECNUM_REL=/c\ SPECNUM_REL=   40," ./default_options/RELEASES > ./current/RELEASES

sed "/output/c\./output_omp1/" ./pathnames > ./pathnames_omp1
sed "/output/c\./output_omp32/" ./pathnames > ./pathnames_omp32
mkdir -p ./output_omp1/
mkdir -p ./output_omp32/
export OMP_NUM_THREADS=1
./FLEXPART pathnames_omp1
export OMP_NUM_THREADS=32
./FLEXPART pathnames_omp32

sed "/output/c\./output_omp1_eta/" ./pathnames > ./pathnames_omp1
sed "/output/c\./output_omp32_eta/" ./pathnames > ./pathnames_omp32
mkdir -p ./output_omp1_eta/
mkdir -p ./output_omp32_eta/
export OMP_NUM_THREADS=1
./FLEXPART_ETA pathnames_omp1
export OMP_NUM_THREADS=32
./FLEXPART_ETA pathnames_omp32

report "[$MM] TEST $TESTRUN (OpenMP)"
STATUS=$((STATUS + $?))
TESTSRUN=$((TESTSRUN + 1))
#
# FINAL
#
echo "[$MM] Tests failed: $STATUS / $TESTSRUN"
#
# Return collective error status
#
exit $STATUS

#F different species

#F1: 
suffix=_5-1_specNO
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/SPECNUM_REL=/c\ SPECNUM_REL=   3," $options_new/COMMAND

#F2 
suffix=_5-2_specCO
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/SPECNUM_REL=/c\ SPECNUM_REL=   22," $options_new/COMMAND
output_new=output$suffix

#F3: 
suffix=_5-3_specAERO-TRACE
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/SPECNUM_REL=/c\ SPECNUM_REL=   25," $options_new/COMMAND

#F4: 
suffix=_5-4_specBC
options_new=options$suffix
cp -r  $options_template $options_new
sed -i "/SPECNUM_REL=/c\ SPECNUM_REL=   40," $options_new/COMMAND

#F5: add later 
#suffix=_5-5_bwd_specNO
#options_new=options$suffix
#cp -r  $options_template $options_new
#sed -i "/SPECNUM_REL=/c\ SPECNUM_REL=   3," $options_new/COMMAND
#sed -i "/LDIRECT=/c\ LDIRECT=    -1," $options_new/COMMAND
#sed -i "/IOUTPUTFOREACHRELEASE=/c\ IOUTPUTFOREACHRELEASE=    1," $options_new/COMMAND

# Examples

Since its inception, FLEXPART has proven to be a valuable tool for studying a wide range of environmental problems both for the research community as well as in operational settings. Some examples where FLEXPART was used in the literature are: 

- Studying the transport of heat and water in the atmosphere: [Baier et al. 2022](https://doi.org/10.1029/2022GL100906), [Peng et al. 2022](https://doi.org/10.1175/JCLI-D-21-0289.1).
- Volcanic and wildfire plumes: [Stohl et al. 2006](https://doi.org/10.1029/2006JD007216), [Stohl et al. 2011](https://doi.org/10.5194/acpd-11-5541-2011), [Moxnes et al. 2014](https://doi.org/10.1002/2013JD021129).
- Transport and fall-out after nuclear accidents or explosions: [Stohl et al. 2012](https://doi.org/10.5194/acp-12-2313-2012), [Arnold et al. 2015](https://doi.org/10.1016/j.jenvrad.2014.02.013).
- Transport of aerosols such as dust: [Zwaaftink et al. 2017](https://doi.org/10.5194/acp-17-10865-2017), [Ryder et al. 2019](https://doi.org/10.5194/acp-19-15353-2019).
- The interpretation of biogenic secondary organic aerosol compound measurements: [Martinsson et al. 2017](https://doi.org/10.5194/acp-17-11025-2017).
- Transport of pollutants into remote regions like the Arctic: [Dada et al. 2022](https://doi.org/10.1038/s41467-022-32872-2), [Zhu et al. 2020](https://doi.org/10.5194/acp-20-1641-2020).
- The interpretation of ice cores: [Eckhardt et al. 2023](https://doi.org/10.1038/s41467-022-35660-0).
- Modelling emission sensitivities of greenhouse gases: [Vojta et al. 2022](https://doi.org/10.5194/gmd-15-8295-2022).

## <a name="cases"></a>Example cases
The range of FLEXPART capabilities comes with a complicated set of option files (see [**option files**](configuration.md#options)), which can be overwhelming to new users. Therefore, we have outlined the settings of three common groups of simulations below, which correspond to the test cases used in the publication of FLEXPART 11.

Each set of option files can be found in the repository in the 'examples' directory. The `IGBP_int1.dat`, `sfcdata.t`, `sfcdepo.t` files are not present here, but can be found in the 'options' directory in the repository.

### Case Tracer
This case is useful for studying transport of heat and water through the global atmosphere. It is a domain-filling simulation, with 10 million particles representing a passive air tracer distributed across the globe following air density. Every hour, all particle information but no gridded output is written to NetCDF files. The example runs for only 5 hours, using 10 minute time-steps, and the turbulence options are set to CTL=10 and IFINE=10.

### Case Aerosol
This case serves as a template for option files using aerosol particles, i.e. tracing pollutants. Case Aerosol simulations generally take much longer than Case Tracer simulations, on one hand because of the extra computations in the wet and dry deposition and gravitational settling routines and on the other hand because of all particles starting within the ABL, where solving the Langevin equations of the turbulence parameterisation requires very short time steps. 

This is a very general example, where 1 million particles representing spherical aerosols with a diameter of 50 micrometer are initially homogeneously distributed in the bottom 100 meters across the globe. Every hour, gridded properties are printed to NetCDF files on the same horizontal resolution as the input data (0.5° by 0.5° global grid), and four vertical levels. The example runs for only 5 hours, using 15 minute time-steps, and turbulence options CTL=10 and IFINE=4. 
MAXTHREADGRID is set to 16, meaning that the gridded computations are using a maximum of 16 threads. The efficiency of this setting should be carefully checked when changing the dimensions of the grid and the number of particles.

### Case Nuclear
This example includes a nested input and output grid over Europe with 0.25° by 0.25°. Using the RELEASES file, 1 million particles representing xenon-133 are released at a single location, using the CBL option for skewed turbulence in the ABL and CTL=40 and IFINE=5. MAXTHREADGRID is set to 1, meaning that gridded computations are conducted on a single thread.

# Running

<span style="color:red">
**WARNING:**
</span>
For many systems it is required to print the following in the command line or to set it in your submit script before executing FLEXPART compiled with OpenMP:
~~~
ulimit -s unlimited
~~~
Not setting this can result in a segmentation fault close to the start of your simulation.

Additionaly, one should set the following for optimal memory usage:
~~~
export OMP_PLACES=cores
export OMP_PROC_BIND=true
~~~
Not setting these can result in unnecessary slow performance of your application.

## Command line usage

FLEXPART accepts two command line options:

- `pathnames`, setting all appropriate paths, as explained in [Configuration](configuration.md#config).
- `-v <verbosity>`, currently not operational

## Exit code

The introduction of `error stop` in Fortran 2008 now guarantees FLEXPART to only exit with code `0` for successful runs. Any other exit code indicates a failed run.

## Input data
FLEXPART advances particles based on interpolated meteorological fields, namely grid-scale three-dimensional fields of wind velocities, density, temperature, specific humidity, cloud liquid water and ice content, as well as precipitation and various surface fields. In principle, any gridded data set could be used. Data formats and coordinate systems used as well as differences in the meteorological variables provided, however, would make a generic input interface rather complex. The main FLEXPART code described here supports two input formats, data from ECMWF's and from NCEP's forecast systems (IFS and GFS, respectively). For ECMWF data, the [flex_extract](https://flexpart.img.univie.ac.at/flexextract/index.html) software package ([Tipka et al. 2020](https://gmd.copernicus.org/articles/13/5277/2020/)) is provided to extract, process, and store the required fields for use as FLEXPART input, including support for ECMWF's reanalyses.

In addition, to run FLEXPART, there are three important (sets) of files that need to be specified.
These are:

- the [**option files**](configuration.md#options), defining the set-up of the run,
- the [**pathnames file**](configuration.md#pathnames), defining the paths of where input and output are located, 
- the [**AVAILABLE file**](configuration.md#available), listing all available [meteorological input files](running.md#meteodata).

A full description of these files can be found in [Configuration](configuration.md#config).


### <a name="meteodata"></a>Meteorological input data

Necessary fields from Eularian models:

| Input field | Description | Unit|
| ------------- | ----------- | --------- |
**3D fields**
|horizontal velocities  |Grid scale velocities used for, e.g., particle propagation  | m/s |
|vertical velocity      |Vertical velocities on model levels used for, e.g., particle propagation. | Pa/s (IFS, flex_extract), m/s (GFS)|
|Temperature            |Air temperature used in convection, chemical loss, relative humidity, and vertical transformation calculation | K |
|Specific (IFS) or relative (GFS) humidity |Internal use of specific humidity for convection, relative humidity, vertical transformation, and dry air density calculation | kg/kg (IFS), % (GFS) |
**2D fields**
|Surface pressure |Pressure at the ground level. | Pa |
|Snow depth |Thickness of snow layer necessary for dry deposition calculation. | m |
|Cloud cover |Fraction of the grid cell that is covered by cloud, used for wet deposition calculations. | 0-1 |
|10 meter horizontal velocities |Used to compute surface stress if not available. | m/s |
|2 meter temperature |Used to calculate friction velocity, obukhov length, convection, and vertical transformation | K |
|2 meter dew point (ECMWF only) |Used to calculate friction velocity, obukhov length, convection, and vertical transformation, for GFS, this is computed according to [Bolton 1980](https://doi.org/10.1175/1520-0493(1980)108%3C1046:TCOEPT%3E2.0.CO;2). | K |
|Large scale precipitation |Used in the wet deposition scheme. | mm/h |
|Convective precipitation |Used in the wet deposition scheme. | mm/h |
|Sensible heat flux (ECMWF only)  | Used to compute Obukhov length, for GFS this is computed using the profile method ([Berkowicz & Prahm 1982](https://doi.org/10.1016/0004-6981(82)90032-4)). | J m^2 |
|Solar radiation (ECMWF only) |Used to calculate the surface resistance for gases, for GFS solar radiation is assumed to be zero. | J m^2 |
E-ward N-ward turbulent surface stress (ECMWF only)  |Surface stress used for dry deposition computations. For GFS data, surface stress is calculated using [Berkowicz & Prahm 1982](https://doi.org/10.1016/0004-6981(82)90032-4). | N m^2 s |
|Orography |Altitude of topography above sea level | m |
|Standard deviation of orography |Included into mixing layer height to account for subgrid scale variability | m |
|Land sea mask |Invoking surface stress computation including wind speeds over sea | 0-1 |
|Cloud liquid water content |Used by the wet scavenging scheme | kg/kg |
|Cloud ice water content |Used by the wet scavenging scheme | kg/kg |

<br/>

## OpenMP

Where most of FLEXPART's computational time is spent is very dependent on the specific problem to be solved and the set-up of FLEXPART. For example, when many particles are released from a single release point, initially most time is spent on particle trajectory computations. However, when a global high-resolution domain for the meteorological input data is used, significant time is spent on the convection computations on the grid. On the other hand, when few particles are used, computations on the gridded meteorological input data (e.g., coordinate transformations) are taking a large share. For this reason, we implemented OpenMP parallelisation throughout FLEXPART and tried to avoid bottlenecks at least for the most common set-ups.

We parallelised all particle based computations, apart from their initial release in the `releaseparticles` subroutine. On top of that, we parallelised the reading and computations on the meteorological fields, including the convection, wet and dry deposition, and the vertical coordinate transformation of the fields. Lastly, we parallelised the computations needed for the output, both for the gridded output and the particle dump.

One drawback of OpenMP parallelisation is that it is more difficult for users to make changes than in serial code, since they also are likely to have to update OpenMP regions. To minimise errors, we therefore strongly recommend users to make changes in the form of subroutines and functions and avoid the use of global variables.

We advise users to test their application using different number of threads in order to find the optimal set-up. The figure below (from [Bakels et al. 2024](https://egusphere.copernicus.org/preprints/2024/egusphere-2024-1713/)) serves as a guideline for deciding how many threads one should use given the three examples laid out in [Example cases](examples.md#cases).
<figure>
	<img src="images/OPTeta.png"
		alt="Benchmarking">
	<figcaption>Demonstration of the strong scalability of the OpenMP parallelisation of FLEXPART 11. Shown is the computation time as a function of the number of cores used. Perfect strong scalability is represented by the slope of the straight dotted thin black lines. The left column of panels, shaded in blue, show results for globally distributed passive tracer particles. The middle column, shaded in magenta, shows results for globally distributed aerosols. The right column, shaded in maroon, shows results for xenon-133 emitted from a single point source. In black, the total computational time of a 5 hour run is plotted for FLEXPART 11 (solid black lines). The MPI parallelised FLEXPART 10.4 equivalent is plotted for reference (solid grey lines). The coloured dashed lines represent the break-down of computational time spent in different components of FLEXPART 11: the blue lines represent the total computational time per hourly time-steps minus the I/O operations (green lines), and initialisation of the run (orange lines). Note that the black lines are not the sum of all other lines, since the black lines show the total time the simulation took, while both the I/O operations and computations are shown per hour of simulation time.</figcaption>
</figure>

## HPC systems

### SLURM example script

```
#!/bin/bash
#SBATCH --job-name=example
#SBATCH --output=example.log
#SBATCH --nodes=1 --ntasks-per-node=10 --ntasks-per-core=2 
#SBATCH --mem=30GB 
#SBATCH --time=20:00:00

export OMP_NUM_THREADS=10
export OMP_PLACES=cores
export OMP_PROC_BIND=true
ulimit -s unlimited

./FLEXPART_ETA pathnames
```

# Particle transport

<figure>
	<img src="images/Butterfly-advance2.png"
		alt="Schematic">
	<figcaption>Simplified call tree for the transport of particles; green boxes represent modules containing subroutines (blue boxes) responsible for updating the location of particles through time.</figcaption>
</figure>
(From [Bakels et al. 2024](https://egusphere.copernicus.org/preprints/2024/egusphere-2024-1713/))


## Turbulence
FLEXPART offers the option to choose between Gaussian and skewed turbulence. Gaussian turbulence is in principle only valid for stable and neutral conditions and not for convective conditions. For convective conditions, the error is minor for transport distances where particles get mixed through the planetary boundary layer. For applications where the well-mixed criterion is violated (e.g. for inverse modelling of point source emissions from near field measurements), the user can choose to set the switch [CBL](configuration.md#CBL) to 1 in the [COMMAND](configuration.md#command) file, switching on the skewed turbulence scheme developed by [Cassiani et al. 2015](https://link.springer.com/article/10.1007/s10546-014-9976-5). Recommended is to only use this option when necessary, because of the increased computational cost. A detailed description of the skewed turbulence scheme can be found in [Cassiani et al. 2015](https://link.springer.com/article/10.1007/s10546-014-9976-5).

### PBL
Turbulence in the planetary boundary layer is parameterised assuming a Markov chain based on the Langevin equation ([Thomson 1987](https://www.cambridge.org/core/journals/journal-of-fluid-mechanics/article/abs/criteria-for-the-selection-of-stochastic-models-of-particle-trajectories-in-turbulent-flows/3175551812282ED52EE96C23E37EBBDE)).
The three dimensional Lagrangian time scales and turbulent energy parameters for Gaussian turbulence are computed following the scheme described by Hanna and Chaughey or by [Ryall & Maryon 1998](https://www.sciencedirect.com/science/article/abs/pii/S1352231098001770) for neutral ($h$<sub>PBL</sub>/$l$<sub>obukhov</sub>$<1$), unstable ($l$<sub>obukhov</sub>$<0$), and stable conditions. This parameterisation uses the convective scale velocity, height of the PBL, Obukhov length, roughness length, friction velocity and vertical position of each particle. FLEXPART switches between the two schemes according to if adaptive time steps are used ([CTL](configuration.md#CTL) in [COMMAND](configuration.md#command)).

### Mesoscale
This is optional and can be set in the COMMAND file. It follows the method as described by [Maryon 1998](https://www.sciencedirect.com/science/article/abs/pii/S1352231097003257).

### Turbulence in the troposphere and stratosphere
Turbulent velocities above the PBL, both in the stratosphere and in the troposphere are computed following [Legras et al. 2003](https://agupubs.onlinelibrary.wiley.com/doi/full/10.1029/2002JD003045), using a constant vertical diffusivity ($D_z = 0.1$ m<sup>2</sup> s<sup>-1</sup>) to compute vertical turbulent velocities in the stratosphere, and a constant horizontal diffusivity ($D_h = 50$ m<sup>2</sup> s<sup>-1</sup>)  to compute horizontal turbulent velocities in the free troposphere. Velocity scales are then obtained by using $\sigma_{v_i}=\sqrt{D_i/dt}$. A linear transition height of 1 km is used between the troposphere and stratosphere.

## Convection

Convective transport is parameterised by using the scheme described by [Emanuel & Zivkovic-Rothman](https://journals.ametsoc.org/view/journals/atsc/56/11/1520-0469_1999_056_1766_daeoac_2.0.co_2.xml).

In FLEXPART 11, all convection related computations are located in the convection module (**conv\_mod.f90**), including subroutines that are solely used by the convection subroutines. The steps required are handled by `convmix`, and include the computation of the matrix describing convective redistribution of mass in a grid column (`calcmatrix`), making use of the convection scheme described in [Emanuel & Zivkovic-Rothman 1999](https://journals.ametsoc.org/view/journals/atsc/56/11/1520-0469_1999_056_1766_daeoac_2.0.co_2.xml) (`convect` and `tlift`), followed by the actual convective displacement of particles in `redist`. 

The sorting algorithm used in `convmix` has been updated with a modified sorting module from [The Fortran Standard Library](https://fortran-lang.org/), which codes the algorithm of [Musser 1997](https://onlinelibrary.wiley.com/doi/abs/10.1002/(SICI)1097-024X(199708)27:8%3C983::AID-SPE117%3E3.0.CO;2-%23). This new sorting algorithm is 4 orders of magnitudes faster; it is located in a separate module, **sort\_mod.f90**. In addition, most loops in the `convect` subroutine have been replaced with array operations.

## <a name="settling"></a>Settling

Gravitational settling of particles is computed at each time step and included in the vertical velocities. These are computed following [Naslund & Thaning 2007](https://www.tandfonline.com/doi/abs/10.1080/02786829108959487), with a temperature dependent dynamic viscosity that is computed using the formula of [Sutherland 1893](https://www.tandfonline.com/doi/abs/10.1080/14786449308620508?journalCode=tphm16).

### <a name="shape"></a>Shape factor
In FLEXPART 11, the computation of settling velocities is done in the settling module, **settling\_mod.f90**. Where the previous versions of FLEXPART did not consider other shapes of aerosols other than spheres, now the settling velocity can also be computed for non-spherical particles as described in detail in [Tatsii et al. 2023](https://pubs.acs.org/doi/10.1021/acs.est.3c08209).

# Configuration
To run FLEXPART, there are three important (sets) of files that need to be specified.
These are:

- the [**option files**](configuration.md#options), defining the set-up of the run,
- the [**pathnames file**](configuration.md#pathnames), defining the paths of where input and output are located, 
- the [**AVAILABLE file**](configuration.md#available), listing all available meteorological input,

Of course, there is also the **par_mod.f90** file, which needs to be specified before compiling (see [**Compiling FLEXPART**](building.md#compliling), but the parameters in this file are expected to not have to be changed between simulations.

In addition to the regular input files listed above, a simulation can also be started using a NetCDF file listing all particles to be released. This option can be switched on by specifying IPIN=3 in the COMMAND option file. More information about how to use this option can be found here: [User-defined initial conditions](configuration.md#ic).

When wanting to restart a previous simulation, see [restarting a simulation](configuration.md#restart).

## <a name="options"></a>Option files
These files define the simulation settings. At the start of a simulation, a copy of each file will be written to the output directory defined in the [**pathnames file**](configuration.md#pathnames).
All option files should be presented as namelists (i.e. &OPTIONFILE). A template of these files can be found in the options/ directory within the repository.

Inside the `options/` directory a template of all option files can be found:

- [COMMAND](configuration.md#command)
- [RELEASES](configuration.md#releases)
- [SPECIES](configuration.md#species)
- [OUTGRID](configuration.md#outgrid)
- [OUTGRID_NESTED](configuration.md#outgrid_nested)
- [AGECLASSES](configuration.md#ageclasses)
- [INITCONC (optional)](configuration.md#initconc)
- [RECEPTORS (optional)](configuration.md#receptors)
- [PARTOPTIONS (optional)](configuration.md#partoptions)
- [REAGENTS (optional)](configuration.md#reagents)
- [SATELLITES (optional)](configuration.md#satellites)

### <a name="command"></a>COMMAND
Sets the behaviour of the run (time range, backward or forward, output frequency, etc.). A table of all options is listed below.

- **Time variables**: Flexpart can be run in forward or backward mode. In forward mode, particles are being traced forward in time, while in backward more, the origin of particles are being traced, going backward in time. This can be set by the [LDIRECT](configuration.md#ldirect) variable. The start and end of the simulation are set by [IBDATE](configuration.md#IBDATE):[IBTIME](configuration.md#IBTIME) and [IEDATE](configuration.md#IEDATE):[IETIME](configuration.md#IETIME). [IEDATE](configuration.md#IEDATE):[IETIME](configuration.md#IETIME) is always at a later time than [IBDATE](configuration.md#IBDATE):[IBTIME](configuration.md#IBTIME), also for backwards simulations. Output variables can be written at specified times: [LOUTSTEP](configuration.md#LOUTSTEP), and restart files will be written at every [LOUTRESTART](configuration.md#LOUTRESTART) interval.
- **Numerical variables**: [LSYNCTIME](configuration.md#LSYNCTIME) and LOUTSAMPLE set the integration interval, smaller generally giving better results, although below a certain number, not much will be gained. With the [CTL](configuration.md#CTL) and [IFINE](configuration.md#IFINE) setting, you can make integration steps even smaller for the turbulence computations.
- **Output variables**: The output is written at every [LOUTSTEP](configuration.md#LOUTSTEP) interval. Both gridded data ([IOUT](configuration.md#IOUT)>0) and particle based data ([IPOUT](configuration.md#IPOUT)=1) can be written to NetCDF files (binary option for gridded data). Nested output can be set by the [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT) switch. Note that for gridded output, the [OUTGRID](configuration.md#OUTGRID) for ([IOUT](configuration.md#IOUT)>0) and [OUTGRID_NESTED](configuration.md#OUTGRID_NESTED) (for [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1) option files should be specified. [MAXFILESIZE](configuration.md#MAXFILESIZE) can be set to limit the size of the NetCDF files that contain the particle based data. [IND_RECEPTOR](configuration.md#IND_RECEPTOR) can be set to get concentrations or mixing ratios at specified receptor points set in the RECEPTORS options file. For backward simulations, [IND_RECEPTOR](configuration.md#IND_RECEPTOR) can be used to get wet or dry deposition gridded data. [SFC_ONLY](configuration.md#SFC_ONLY) and [LINIT_COND](configuration.md#LINIT_COND) are only working for binary output. 
- **Input variables**: IPIN can be set to chose the input type: either initial conditions from particles come from the [RELEASES](configuration.md#releases) file ([IPIN](configuration.md#IPIN)=0), from restart files of a previous run ([IPIN](configuration.md#IPIN)=1),
from a particle netCDF file written in a previous run (only works when the corresponding fields in [PARTOPTIONS](configuration.md#PARTOPTIONS) are chosen) ([IPIN](configuration.md#IPIN)=2), or from user-defined initial particle conditions ([IPIN](configuration.md#IPIN)=3). [MDOMAINFILL](configuration.md#MDOMAINFILL) can be set to distribute particles according to the air density or stratospheric ozone density profiles. This option overwrites the vertical levels set in the [RELEASES](configuration.md#releases) option file.

| Variable name | Description | Possible values and **default** (bold) |
| ----------- | ----------- | ----------- |
| <a name="ldirect"></a>LDIRECT | Simulation direction in time | **1 (forward)** or -1 (backward) |
| <a name="IBDATE"></a>IBDATE | Start date of the simulation | YYYYMMDD: YYYY=year, MM=month, DD=day |
| <a name="IBTIME"></a>IBTIME | Start time of the simulation | HHMISS: HH=hours, MI=minutes, SS=seconds. UTC zone. |
| <a name="IEDATE"></a>IEDATE | End date of the simulation | YYYYMMDD: YYYY=year, MM=month, DD=day |
| <a name="IETIME"></a>IETIME | End time of the simulation | HHMISS: HH=hours, MI=minutes, SS=seconds. UTC zone. |
| <a name="LOUTSTEP"></a>LOUTSTEP | Interval of model output. Average concentrations are calculated every LOUTSTEP (seconds) | **10800** |
| <a name="LOUTAVER"></a>LOUTAVER | Concentration averaging interval, instantaneous for value of zero (seconds) | **10800** |
| <a name="LOUTSAMPLE"></a>LOUTSAMPLE | Numerical sampling rate of output, higher statistical accuracy with shorter intervals (seconds) | **900** |
| <a name="LRECOUTSTEP"></a>LRECOUTSTEP | Interval of receptor output. Mixing ratios are calculated every LRECOUTSTEP (seconds) | **LOUTSTEP** |
| <a name="LRECOUTAVER"></a>LRECOUTAVER | Concentration averaging interval for receptors, instantaneous for value of zero (seconds) | **LOUTAVER** |
| <a name="LRECOUTSAMPLE"></a>LRECOUTSAMPLE | Numerical sampling rate of receptor output (seconds) | **LOUTSAMPLE** |
| <a name="LOUTRESTART"></a>LOUTRESTART | Time interval when a restart file is written (seconds) | **-1** |
| <a name="LSYNCTIME"></a>LSYNCTIME | All processes are synchronized to this time interval; all values above (and for radioactive decay also LOUTSTEP/2) should be dividable by this number (seconds) | **900** |
| <a name="CTL"></a>CTL | Factor by which particle transport time step in the ABL must be smaller than the Lagrangian timescale t l ; resulting time steps can be shorter than LSYNCTIME; LSYNCTIME is used if CTL < 0 | **-5.0** |
| <a name="IFINE"></a>IFINE | Additional reduction factor for time step used for vertical transport only considered if CTL > 1 | **4** |
| <a name="IOUT"></a>IOUT | Switch determining the gridded output type | 0 (no gridded output), **1 (forward: mass concentration; backwards: residence time)**, 2 (volume mixing ratio), 3 (1 and 2 combined), 4 (plume trajectories), 5 (1 and 4 combined), Add 8 for NetCDF output |
| <a name="IPOUT"></a>IPOUT | Switch for particle position output | **0 (no particle output)**, 1 (particle output every LOUTSTEP), 2 (particle output at the end of the simulation) |
| <a name="LSUBGRID"></a>LSUBGRID | Increase in ABL heights due to subgrid-scale orographic variations | **0 (off)**, 1 (on) |
| <a name="LCONVECTION"></a>LCONVECTION | Switch for convection parameterization | 0 (off), **1 (on)** |
| <a name="LTURBULENCE"></a>LTURBULENCE | Switch for turbulence parameterization | 0 (off), **1 (on)** |
| <a name="LTURBULENCE_MESO"></a>LTURBULENCE_MESO | Switch for mesoscale turbulence parameterization | **0 (off)**, 1 (on) |
| <a name="LAGESPECTRA"></a>LAGESPECTRA | Switch for calculation of age spectra (needs file [AGECLASSES](configuration.md#ageclasses) option file) | 0 (off), **1 (on)** |
| <a name="IPIN"></a>IPIN | Particle information input. Starting from [RELEASES](configuration.md#releases) option file, form restart.bin, or user-defined particle input data (see Silvia Bucci's stuff) | **0 (using RELEASES option file)**, 1 (using restart.bin file), 2 (using previous partoutput file), 3 (self made initial conditions), 4 (restart.bin and self made initial conditions) |
| <a name="IOUTPUTFOREACHRELEASE"></a>IOUTPUTFOREACHRELEASE | Switch for separate output fields for each location in the [RELEASES](configuration.md#releases) file | 0 (no), **1 (yes)** |
| <a name="IFLUX"></a>IFLUX | Output of mass fluxes through output grid box boundaries (northward, southward, eastward, westward, upward and downward) | 0 (off), **1 (on)** |
| <a name="MDOMAINFILL"></a>MDOMAINFILL | Switch for domain-filling calculations: particles are initialized to reproduce air density or stratospheric ozone density; for limited-area simulations, particles are generated at the domain boundaries | **0 (no)**, 1 (like air density), 2 (stratospheric ozone tracer) |
| <a name="IND_SOURCE"></a>IND_SOURCE | Unit to be used at the source; see Seibert and Frank (2004); Eckhardt et al. (2017) | **1 (mass)**, 2 (mass mixing ratio) |
| <a name="IND_RECEPTOR"></a>IND_RECEPTOR | Unit to be used at the receptor; see Seibert and Frank (2004); Eckhardt et al. (2017) | 0 (no receptor), **1 (mass)**, 2 (mass mixing ratio), 3 (backward only: wet deposition),  4 (backward only: dry depostion) |
| <a name="MQUASILAG"></a>MQUASILAG | Quasi-Lagrangian mode to track individual numbered particles | **0 (off)**, 1 (on) |
| <a name="NESTED_OUTPUT"></a>NESTED_OUTPUT | Switch to produce output also for a nested domain | **0 (no)**, 1 (yes) |
| <a name="LNETCDFOUT"></a>LNETCDFOUT | Switch to produce NetCDF output, overwritten to 1 when IOUT>8 and set to 0 when compiled without NetCDF libraries | 0 (no), **1 (yes)** |
| <a name="LINIT_COND"></a>LINIT_COND | Switch to produce output sensitivity to initial conditions given in concentration or mixing ratio units (in backwards mode only) | **0 (no)**, 1 (mass), 2 (mass mixing ratio) |
| <a name="LCMOUTPUT"></a>LCMOUTPUT | Linear Chemistry Module switch, should be used in combination with LDIRECT=1, MDOMAINFILL=1, IND_SOURCE=1, IND_RECEPTOR=1 | **0 (no)**, 1 (yes) |
| <a name="SFC_ONLY"></a>SFC_ONLY | Output of SRR for fluxes only for the lowest model layer, most useful for backward runs when LINIT_COND set to 1 or 2 | **0 (no)**, 1 (yes) |
| <a name="CBLFLAG"></a>CBLFLAG | Skewed rather than Gaussian turbulence in the convective ABL; when turned on, very short time steps should be used (see CTL and IFINE) | **0 (no)**, 1 (yes) |
| <a name="MAXTHREADGRID"></a>MAXTHREADGRID | Set maximum number of threads for doing grid computations. Recommended to set this to max 16. High numbers create more overhead and a larger memory footprint  | **1 (default=no parallelisation on grid)** integer |
| <a name="MAXFILESIZE"></a>MAXFILESIZE | Maximum output of each partoutput NetCDF-4 file in Mb before a new one is created  | *10000 (default=10GB)** integer |
| <a name="LOGVERTINTERP"></a>LOGVERTINTERP| Flag to set all vertical interpolation to logarithmic instead of linear  | *0=off (default)**, 1=on |
| <a name="NXSHIFT"></a>NXSHIFT|  Shift of the global meteorological data by number of grid cells. | Default 359 for ECMWF and 0 for GFS if not given |

<br/>

### <a name="releases"></a>RELEASES
This file contains the information about the particles initial conditions: how many, where and when they will be released, their mass and what species they are (defined in the SPECIES files).
The RELEASES file contains two types of namelists: 
 
 1. `&RELEASES_CTRL` namelist, specifying the total number of species and the specific species file associated (see [SPECIES](configuration.md#species)). There is only one of this namelist and it is found at the top of the file. 

 2. `&RELEASE` namelist, specifying for each release, the start and end of the release, the location of the release, and the number of particles that are to be released.

| Variable name `&RELEASES_CTRL` | Description | Data type |
| ------------- | ----------- | --------- |
|NSPEC | Total number of species | integer |
|SPECNUM_REL | Species numbers in directory SPECIES | integer(s divided by comma's) |

<br/>
And for each release:

| Variable name `&RELEASE` | Description | Data type |
| ------------- | ----------- | --------- |
|IDATE1 | Release start date | integer in the form of YYYYMMDD: YYYY=year, MM=month, DD=day|
|ITIME1 | Release start time in UTC | integers in the form of HHMISS: HH hours, MI=minutes, SS=seconds|
|IDATE2 | Release end date | same as IDATE1|
|ITIME2 | Release end time | same as ITIME1|
|LON1 | Left longitude of release box -180(NXSHIFT$\Delta$lon) < LON1 <180(NXSHIFT$\Delta$lon)| real |
|LON2 | Right longitude of release box, same as LON1| real |
|LAT1 | Lower latitude of release box, -90 < LAT1 < 90| real |
|LAT2 | Upper latitude of release box same format as LAT1 | real |
|Z1 | Lower height of release box meters/hPa above reference level| real |
|Z2 | Upper height of release box meters/hPa above reference level| real |
|ZKIND | Reference level | integer: 1=above ground, 2=above sea level, 3 for pressure in hPa|
|MASS | Total mass emitted, only relevant for fwd simulations| real |
|PARTS | Total number of particles to be released| integer |
|COMMENT | Comment, written in the outputfile| character string |

<br/>
**Note:** the RELEASES file is no longer necessary when using [IPIN](configuration.md#ipin)=3, giving full control to the user to decide where and when particles of different species are being released (see [User-defined initial conditions](configuration.md#ic)).

### <a name="species"></a>SPECIES
The subdirectory options/SPECIES/ needs to contain one or more files named SPECIES_nnn. In options/SPECIES/ templates for several species are given. These come with no warranty and will have to be renamed to SPECIES_nnn where nnn are three digits. For each species nnn listed in the header section of the RELEASES file, such a SPECIES_nnn file must exist. The parameters in the SPECIES_nnn file, contained in the namelist &SPECIES_PARAMS, set the species name and define the physicochemical properties of the species; they are described in Table 10. These are important for simulating radioactive or chemical decay, wet deposition (scavenging) for gases and aerosols, dry deposition for gases and aerosols, particle settling, and chemical reaction with the OH radical. Some parameters are only necessary for gas tracers and some are only necessary for aerosol tracers; thus, a namelist does not need to contain all parameters for both gases and particles. Optionally, since FLEXPART version 6.0, information about temporal emission variations can be added at the end of the file.

The following specifies the parameters associated with each physicochemical process simulated.

- Radioactive or chemical decay: set with PDECAY; off if PDECAY<0.
- Wet deposition for gases: set with PWETA_GAS, PWETB_GAS (for below-cloud) and PHENRY (for in-cloud). Switch off for both in- and below-cloud if either PWETA_GAS or PWETB_GAS is negative.
- Wet deposition for aerosols: set with PCCN_AERO, PIN_AERO for in-cloud scavenging and PCRAIN_AERO, PCSNOW_AERO and PDIA for below-cloud scavenging.
- Dry deposition for aerosols: set with PDENSITY, PDIA, PNDIA, and PDSIGMA; off if PDENSITY < 0. 
- Dry deposition for gases: set with PHENRY, PF0 and PRELDIFF; off if PRELDIFF < 0. Alternatively, a constant dry deposition velocity pdryvel can be given. 
- Settling of particles: set with PDENSITY and PDIA.
- Shape of particles: set with PSHAPE, PASPECTRATIO, PLA, PIA, PSA, and PORIENT.
- OH reaction: chemical reaction with the OH radical can be turned on by giving parameter PCCONST (cm^3 molecule^-1 s^-1 ), PDCONST (K) and PNCONST (no unit) positive values; defined by Eq. (13) in Pisso et al. (2019).
- Emission variation: emission variation during the hours (local time) of the day and during the days of the week can be specified. Factors should be 1.0 on average to obtain unbiased emissions overall. The area source factors (useful, e.g., for traffic emissions) are applied to emissions with a lower release height below 0.5 m above ground level (a.g.l.) and the point source factors (useful, e.g., for power plant emissions) to emissions with a lower release height than 0.5 m a.g.l. Default values are 1.0.

| Variable name | Description | Data type |
| ----------- | ----------- | --------- |
|PSPECIES | Tracer name | character(len=16) |
|<a name="PDECAY"></a>PDECAY | Species half life | real |
|PWETA_GAS | Below-cloud scavenging (gases) - A (weta_gas) | real |
|PWETB_GAS | Below-cloud scavenging (gases) - B (wetb_gas) | real |
|PCRAIN_AERO | Below-cloud scavenging (particles) - Crain (crain_aero) | real |
|PCSNOW_AERO | Below-cloud scavenging (particles) - Csnow (csnow_aero) | real |
|PCCN_AERO | In-cloud scavenging (particles) - CCNeff (ccn_aero) | real |
|PIN_AERO | In-cloud scavenging (particles) - INeff (in_aero) | real |
|PDENSITY | Dry deposition (particles) - rho | real |
|PDIA | Dry deposition (particles) - diameter or equivalent diameter for shape (meter) | real |
|PDSIGMA | Dry deposition (particles) - dsig | real |
|PNDIA | Dry deposition (particles) - ndia | integer |
|PDRYVEL | Alternative: dry deposition velocity | real |
|PRELDIFF | Dry deposition (gases) - D | real |
|PHENRY | Dry deposition (gases) - Henrys const. | real |
|PF0 | Dry deposition (gases) - f0 (reactivity) | real |
|PWEIGHTMOLAR | molweight | real |
|PREACTIONS | List of reactions, must correspond to names in REAGENTS | string |
|<a name="PCCONST"></a>PCCONST | OH Reaction rate - C [cm^3/molecule/sec], in order of PREACTIONS | real |
|<a name="PDCONST"></a>PDCONST | OH Reaction rate - D [K], in order of PREACTIONS | real |
|<a name="PNCONST"></a>PNCONST | OH Reaction rate - N [dimensionless], in order of PREACTIONS | real |
|PEMIS_PATH | Emissions path, if empty, no emissions | string |
|PEMIS_FILE | Generic file name for emissions, if empty, no emissions | string |
|PEMIS_NAME | Variable name for emissions, if empty, no emissions | string |
|PEMIS_UNIT | Unit of emissions | integer 0=per gridcell, 1=per m2 |
|PEMIS_COEFF | Coefficient to convert from emission input unit to kg/s | real |
|PSHAPE | Defining the shape of a particle | integer: **0=sphere (default)**, 1=any shape (defined by axes PLA,PIA,PSA), 2=cylinder, 3=cube, 4=tetrahedron, 5=octahedron, 6=ellipsoid |
|PASPECTRATIO | Aspect ratio of cylinders: works for PSHAPE=2 only | real |
|PLA | Longest axis in meter (Bagheri & Bonadonna 2016): only for PSHAPE=1 | real |
|PIA | Intermediate axis in meter: only for PSHAPE=1 | real |
|PSA | Smallest axis in meter: only for PSHAPE=1 | real |
|PORIENT | Falling orientation for aerosol particles of shape != 0 | integer: **0=horizontal (default)**, 1=random orientation of particles, 2=average between random and horizontal |

<br/>

### <a name="outgrid"></a>OUTGRID
The OUTGRID file specifies the domain and grid spacing of the three-dimensional output grid. Note that in a Lagrangian model, the domain and resolution of the gridded output are totally independent from those of the meteorological input (apart from the fact that the output domain must be contained within the computational domain). The output grid is available in binary and NetCDF format, which can be set by [IOUT](configuration.md#iout) in the [COMMAND](configuration.md#command) file.


| Variable name | Descriptions | Data type |
| ------------- | ------------ | --------- |
|OUTLON0 | Geographical longitude of the lower left corner of the output grid | real |
|OUTLAT0 | Geographical latitude of the lower left corner of the output grid | real |
|NUMXGRID | Number of grid points in the X direction (= No. of cells +1) | integer |
|NUMYGRID | Number of grid points in the Y direction (= No. of cells +1) | integer |
|DXOUT | Grid distance in the X direction | real |
|DYOUT | Grid distance in the Y direction | real |
|OUTHEIGHTS | The height of the levels (upper boundary) | real(s divided by comma's) |

<br/>

### <a name="outgrid_nest"></a>OUTGRID_NEST
Output can also be produced on one nested output grid with higher horizontal resolution.
This file specifies the size and dimensions of the nested output grid. The height levels are equal to those set in [OUTGRID](configuration.md#outgrid).

| Variable name | Descriptions | Data type |
| ------------- | ------------ | --------- |
|OUTLON0N | Geographical longitude of the lower left corner of the output grid | real |
|OUTLAT0N | Geographical latitude of the lower left corner of the output grid | real |
|NUMXGRIDN | Number of grid points in the X direction (= No. of cells +1) | integer |
|NUMYGRIDN | Number of grid points in the Y direction (= No. of cells +1) | integer |
|DXOUTN | Grid distance in the X direction | real |
|DYOUTN | Grid distance in the Y direction | real |

<br/>

### <a name="ageclasses"></a>AGECLASSES

The option to produce age class output can be activated by setting [LAGESPECTRA](configuration.md#lagespectra) in the [COMMAND](configuration.md#command) file. The AGECLASSES file then allows for the definition of a list of times (in seconds, in increasing order) that define the age classes used for model output. With this option, the model output (e.g., oncentrations) is split into contributions from particles of different age, defined as the time passed since the particle release. Particles are dropped from the simulation once they exceed the maximum age, skipping unnecesary computations. This is an important technique to limit the cpu usage for long-term simulations. Thus, even if the user is not interested in age information per se, it may often be useful to set one age class to define a maximum particle age.
The file should contain two namelist: 

1) &NAGE

| Variable name | Description | Data type |
| ------------- | ------------ | --------- |
|NAGECLASS | Number of ageclasses for the age spectra calculation | integer |

<br/>

2) &AGECLASS

| Variable name | Description | Data type |
| ------------- | ------------ | --------- |
|LAGE | Maximum age of particles in seconds for each ageclass | integer(s divided by comma's) |

<br/>

### <a name="initconc"></a>INITCONC

**Optional** Specifies input for initialising the mixing ratios. If hybrid pressure coordinates, the variable PS_NAME is required. Otherwise, either ALT_NAME or PRS_NAME need to be given. The file should contain two namelists:

1) &INITCONC_CTRL

| Variable name | Description | Data type |
| ------------- | ------------ | --------- |
|NINIT | Number of species for which initial concentration is specified | integer |
|SPECNUM_REL | List of species of length NSPEC set in [RELEASES](configuration.md#releases) | integer |

<br/>

2) &INITCONC

| Variable name | Description | Data type |
| ------------- | ------------ | --------- |
|PATH_NAME | Path to initial concentration files | character string |
|FILE_NAME | Generic name of file (using YYYY[MM][DD] for dates)  | character string |
|VAR_NAME | Name of concentration variable in file  | character string |
|HYA_NAME | Name of hybrid pressure coord A (use "" if none)| character string |
|HYB_NAME | Name of hybrid pressure coord B (use "" if none)| character string |
|PS_NAME | Name of surface pressure variable (use "" if none)  | character string |
|Q_NAME | Name of specific humidity variable (use "" if none, then assumes dry air mixing ratio) | character string |
|PRS_NAME | Name of vertical pressure coordinate (use "" if none) | character string |
|ALT_NAME | Name of altitude coordinate (use "" if none) | character string |
|COEFF | Coefficient from input unit to ppbv | real |


<br/>

### <a name="receptors"></a>RECEPTORS

**Optional** In addition to gridded model output, it is also possible to define receptor points. With this option output can be specifically produced for certain points at the surface in addition to gridded output. The RECEPTORS file contains a list with the definitions of the receptor name, longitude and latitude. If no such file is present, no receptors are written to output. At the moment, this data is added to the gridded_output file, when using netcdf, maybe this should be a dedicated RECEPTOR netcdf file instead.

| Variable name | Description | Data type |
| ------------- | ------------ | --------- |
|RECEPTOR | Name of the receptor point | character string |
|LON | Geographical longitude | real |
|LAT | Geographical latitude | real |
|ALT | Altitude | real |
|TIME | (Optional) time of receptor output | real |

<br/>

### <a name="partoptions"></a>PARTOPTIONS
**Optional** This option file is only necessary when requiring particle properties to be written out (IPOUT=1 in the COMMAND option file). In this file, the user can set what particle properties and interpolated fields they want to be written to files. At the moment, the available fields that can be written to file are:

- particle positions (longitude, latitude and height), 
- potential vorticity, 
- specific humidity, 
- density, temperature, 
- pressure, 
- particle mass, 
- separate cumulative wet and dry deposition masses, 
- settling velocity, 
- 3D velocities, 
- the height of the PBL, tropopause and topography.

Each property can also be printed out as an average instead of an instantaneous value. For example, if one makes internal time steps of 600 seconds each,
and writes properties to files every hour, the outputted value will be the average of the 6 previous values of the particle of the past hour. Note that this comes with an additional computational cost.

If the particle output is switched on (IPOUT=1), terminated particles are kept in the simulation, but values associated with them are set to `NaN` instead of being overwritten by newly released particles in the NetCDF output.
This comes with no additional computational cost, but it may need more memory than when running without the particle output option switched on. 
As some applications might use a large number of short-lived particles during a longer simulation, the behaviour of overwriting terminated particles can be restored by removing `ipout.eq.0` from the `get_newpart_index` subroutine, located in the file `particle_mod.f90`.
<br/>

### <a name="reagents"></a>REAGENTS
**Optional** Specifies chemical reagents for reactions. The corresponding rate constants are given in the SPECIES files (PREACTION).

| Variable name | Description | Data type |
| ------------- | ----------- | --------- |
| PREAGENT | Reagent name, must be the same as variable name and match those used in reactions list in SPECIES file | string |
| PREAG_PATH | path to reagent file | string |
| PHOURLY | Interpolate field to hourly based on solar zenith angle | integer: 0=no, 1=yes | 

<br/>

### <a name="satellites"></a>SATELLITES
**Optional** Specifies paths and input file names of satellite retrievals for which mixing ratios should be output

| Variable name | Description | Data type |
| ------------- | ----------- | --------- |
| PSATNAME | Name of satellite | string |
| PPATH | path to satellite files | string |
| PFILE | Generic name of satellite files | string ending with "YYYYMMDD.nc" | 

<br/>

## <a name="pathnames"></a>Pathnames file
The pathnames file is a text file containing the path to:

- first line: directory of the option files,
- second line: name of directory where output files are generated,
- third line: base path to the meteorological input data,
- fourth line: full path and filename of the AVAILABLE file (see [**AVAILABLE**](configuration.md#available)).

When using nested areas, the third and fourth line can be repeated with the respected meteorological data directory base paths and AVAILABLE_NEST file paths:

- Line 2n+3: path where meteorological fields are available (nested grid n),
- Line 2n+4: full path and filename of the AVAILABLE-file of nested grid n.

## <a name="available"></a>AVAILABLE files
The meteorological input data, one file for each input time, are stored in GRIB format in a common directory (specified in line 3 of pathnames). To enable FLEXPART to find these files, a file usually named AVAILABLE (given in line 4 of pathnames) contains a list of all available meteorological input files and their corresponding time stamps. Additional files containing nested input data may also be provided. In this case, a separate file containing the input file names (e.g., named AVAILABLE_NESTED) must be given. Date and time entries in the AVAILABLE* files for mother and nested
fields must be identical.

ECMWF data can be retrieved using [flex_extract](https://flexpart.img.univie.ac.at/flexextract/index.html)

## <a name="ic"></a>User-defined initial conditions
A simulation can be started using a NetCDF file listing all particles to be released. This option can be switched on by specifying [IPIN](configuration.md#ipin)=3 in the [COMMAND](configuration.md#command) option file. This file should be called **part_ic.nc** and located in the options directory defined in [Pathnames file](configuration.md#pathnames). It should have the following structure:

**Header**

| Variable name | Description | Data type |
| ------------- | ----------- | --------- |
| `nspecies` | Number of species | integer |
| `species` | Species IDs (see [SPECIES](configuration.md#species)) | 1D-array of integers |
| `kindz` | Reference level | integer: 1=above ground, 2=above sea level, 3 for pressure in hPa | 

<br/>

**Data**

| Variable name | Description | Data type |
| ------------- | ----------- | --------- |
| `longitude` | Initial longitude of each particle | 1D-array of reals with dimension `particle` |
| `latitude` | Initial latitude of each particle | 1D-array of reals with dimension `particle` |
| `height` | Initial height of each particle (meter above reference level) | 1D-array of reals with dimension `particle` |
| `time` | Release time of each particle seconds after simulation start (IBDATE/IBTIME for forward runs, IEDATE/IETIME for backward runs, set in [COMMAND](configuration.md#command)) | 1D-array of integers with dimension `particle` |
| `mass` | Initial mass of each particle (kg) | 2D-array of reals with dimension `species` and `particle` |
| `release` | Release ID of each particle, giving separate concentration fields for each release ID when [IOUTPUTFOREACHRELEASE](configuration.md#ioutputforeachrelease) in [COMMAND](configuration.md#command) is set | 1D-array of integers with dimension `particle` |

<br/>

## <a name="restart"></a>Restarting a simulation
In case your simulation crashes or if you simply want to extend your simulation period, it is possible to run using the restart option (COMMAND option file: IPIN=1 or IPIN=4 when initially running with part_ic.nc). You will need to decide if you will need this option before starting your initial simulation: LOUTRESTART in the COMMAND option file needs to be set to an appropriate time interval. For example, you can choose to set LOUTRESTART = 172800 s to get a new restart file ever 2 days. The restart files are written in binary and their name specifies the time within your simulation period they are written. When LOUTRESTART is set to -1, this option is disabled.

To run from one of these files, simply rename the desired restart_XXX.bin file to restart.bin, set IPIN=1 (or IPIN=4 when initially running with IPIN=3) and you can restart your run from there.

WARNING: If you chose to use gridded data output (IOUT>0), then new data will be written to this file. If it is not desirable to overwrite a gridded data output file from a previous run, copy this file to another directory.

# Evolution of particle properties
In FLEXPART, the modeling of particle movement involves a combination of interpolating properties from meteorological input data and computing properties that are intrinsic to each particle. This hybrid approach allows for a more comprehensive and realistic representation of particle behavior in the atmosphere.

In [**Particle transport**](transport.md), you can find how particles are advanced, using parameterisation schemes and meteorological data interpolated to the particle position. This interpolated meteorological data is necessary for computing the trajectories of particles, but such information can also be a valuable diagnostic tool on itself. For this reason, interpolated meteorological data along the trajectories of each particle, can be written to file setting the option [IPOUT](configuration.md#IPOUT) to a non-zero value in the [COMMAND](configuration.md#command) file.

In addition, FLEXPART goes beyond simple interpolation and incorporates intrinsic properties that are directly related to each individual particle. The main intrinsic property considered in the model is the mass of the particles. The mass of a particle can significantly impact its behavior in the atmosphere, affecting its movement and interactions with the environment (see [**Settling**](transport.md#settling). During the simulation, FLEXPART takes into account various processes that can modify the mass of particles over time. For instance, particles can undergo deposition ([**Dry deposition**](evolution.md#drydepo) and [**Wet deposition**](evolution.md#wetdepo), where they are partially removed from the atmosphere by settling onto surfaces (e.g., ground or vegetation). Additionally, for particles resulting from nuclear disasters or radioactive emissions, radioactive decay is another important process that leads to a reduction in particle mass over time (see [**Radioactive decay**](evolution.md#decay) and [**OH reaction**](evolution.md#ohreact)).

By considering these intrinsic properties, particularly the evolving mass of the particles, FLEXPART can simulate the transport, dispersion, and fate of pollutants, aerosols, and other substances in a more realistic manner. It allows the model to account for the varying lifetimes of different particles based on their specific properties and the environmental conditions they encounter.


## <a name="drydepo"></a>Dry deposition
In FLEXPART, the dry deposition module is used to calculate the dry deposition velocities of gases and particulate matter within the layer from 0 to 15 metres above ground (Eq. 48 in [Stohl et al. 2005](https://acp.copernicus.org/articles/5/2461/2005/)). Here, dry deposition is treated in a same way as in previous versions and can be found in `drydepo_mod.f90`. However, now the module considers different particle shapes as it is in the settling module (for details see [**Shape factor**](transport.md#settling)).

The limitation here is that the Stokes' number, which is used to calculate the deposition layer resistance, is not resolved for non-spherical particles and remains to be investigated. Therefore, in FLEXPART 11 the Stokes' number for particles of any shape is assumed to be similar to that for perfect spheres.

## <a name="wetdepo"></a>Wet deposition
The wet-deposition scheme in FLEXPART distinguishes between aerosols and gases and between in-cloud and below-cloud scavenging. In FLEXPART 11, cloud parameters and precipitation are interpolated to the particle position, and the scheme for below-cloud scavenging of aerosols has been replaced. Routines related to wet deposition are now collected in the `wetdepo_mod.f90` module. The revised wet-deposition scheme includes three changes with respect to the previous version:

1. **New below-cloud scavenging scheme for aerosols**: For below-cloud scavenging, the scheme of [Wang et al. 2014](https://doi.org/10.5194/gmd-7-799-2014) is used, which covers particles from 1 nm (nucleation mode) to 100 µm (coarse mode). This is important especially for larger particles like dust, sea salt, or pollen.

2. **Improved interpolation scheme for precipitation**: The interpolation scheme by [Hittmeir et al. 2018](https://doi.org/10.5194/gmd-11-2503-2018) is used for precipitation fields, which ensures the conservation of integral precipitation within each time interval, maintains continuity at interval boundaries, and conserves non-negativity.

3. **New cloud layer identification scheme**: To prevent unrealistic combinations of instantaneous cloud fields and accumulated precipitation fields, new steps are taken to identify clouds, including a threshold of relative humidity and minimum cloud thickness.

## <a name="decay"></a>Radioactive decay
FLEXPART can account for radioactive and/or chemical decay of particles by defining a half life $T_{1/2}$ (parameter [PDECAY](configuration.md#PDECAY) > 0 in the corresponding [SPECIES](configuration.md#species) file; off if [PDECAY](configuration.md#PDECAY) < 0). The decay affects the particle mass while traveling through the atmosphere as well as the deposited mass following:
$m(t + \Delta t) = m(t) e^{−\Delta t/\beta}$
with
$\beta = \frac{T_{1/2}}{ln(2)}$
The treatment of radioactive and/or chemical decay remains unchanged compared to v10.4 and we refer to [Pisso et al. 2019](https://gmd.copernicus.org/articles/12/4955/2019/) for a comparison with observations.

## <a name="ohreact"></a>OH reaction
Loss processes related to reactions with hydroxyl (OH) radicals are represented as a first-order, linear approximation in FLEXPART 11 --- identical to v10.4 and therefore only shortly summarized here; for a detailed description see [Pisso et al. 2019](https://gmd.copernicus.org/articles/12/4955/2019/).

The OH radical is the most important oxidant in the troposphere and although reactions with atmospheric gases can be highly non-linear (e.g., CH$_4$), a first-order, linear loss approximation using prescribed OH fields is possible (for FLEXPART 11: monthly averaged 3$^\circ$ x 5$^\circ$ OH fields with 17 vertical layers; following GEOS-Chem model by [Bey et al. 2001](https://agupubs.onlinelibrary.wiley.com/doi/abs/10.1029/2001JD000807) and read in from **OH\_variables.bin**). Hourly OH variations are accounted for by modifying the monthly fields with the hourly photolysis rate of ozone $j$ based on a simple could-free parameterization depending on the solar zenith angle:

$OH = \frac{j}{j^*} OH^*$

where $j^*$ and $OH^*$ are the monthly mean photolysis rate and OH concentration taken from **OH\_variables.bin**, respectively.

The OH reaction can be turned on by providing positive reaction rates in the corresponding [SPECIES](configuration.md#species) file (parameters [PCCONST](configuration.md#PCCONST), [PDCONST](configuration.md#PDCONST), and [PNCONST](configuration.md#PNCONST); turned off with negative values). The temperature-dependent OH reaction rate $\kappa$ (s$^{-1}$) is then calculated as:

$\kappa = C T^N e^{\frac{-D}{T}} OH$

where C, N and D are the species-specific constants defined in the [SPECIES](configuration.md#species) file. T is the absolute temperature, and $OH$ the OH concentration ([Atkinson 1997](https://pubs.aip.org/aip/jpr/article-abstract/26/2/215/241782/Gas-Phase-Tropospheric-Chemistry-of-Volatile)). The OH-related mass loss is then calculated as:

$m(t + \Delta t') = m(t) e^{−\kappa \Delta t'}$

with $\Delta t'$ being the reaction time step given by [LSYNCTIME](configuration.md#LSYNCTIME).

In order to be able to use higher spatially and temporally resolved OH fields, the user has to modify the OH-related FLEXPART subroutines (`readOHfield`, `gethourlyOH`, `ohreaction`, located in the **ohr\_mod.f90** module) to be able to read in and process these other OH fields.

# Building

## <a name="download"></a>Download FLEXPART
There are two options to download _FLEXPART_:

  - **tar ball**

    You can download a tar ball with the latest release from the [_FLEXPART_ page](https://www.flexpart.eu/roadmap.html) and then untar the file:

        $ tar -xvf <flexpart_vX.X.tar>

  - **git repository**

    If you have git installed, you can clone the latest version from our git repository:

        $ git clone --single-branch --branch master https://gitlab.phaidra.org/flexpart/flexpart.git

### Compiler
_FLEXPART_ 11 is written in Fortran 2018. The following compilers can be used to compile _FLEXPART_:

  - GNU Fortran compiler version 8+ (`gfortran`)
  - Intel Fortran compiler (`ifort`)

For running _FLEXPART_ in parallel mode, a compiler supporting [OpenMP](https://www.openmp.org/) is required. In addition, libraries (in particular hdf5) should be compiled threadsafe.

### Libraries
_FLEXPART_ uses the following libraries:

  - [ecCodes](https://confluence.ecmwf.int/display/ECC)
  - [netCDF](https://docs.unidata.ucar.edu/netcdf-fortran/current/)

These libraries are usually available as packages in most Linux distributions and MacOS package managers. For example:

  - In Debian/Ubuntu: `sudo apt install libeccodes-dev libnetcdff` 
  - In MacOS + Homebrew: `brew install eccodes netcdf`

## <a name="compiling"></a>Compiling FLEXPART
_FLEXPART_ is compiled with [make](https://www.gnu.org/software/make/), which uses the makefile in the `src` subdirectory. Starting from the root directory, you can then compile _FLEXPART_ with the following steps:

    $ cd src/
    $ make -j -f <prefered_makefile>

This will create the executable `FLEXPART_ETA`. Note that this executable can only be used on ECMWF data.

### Parameters
Before compiling FLEXPART, you might want to change parameters defined in par_mod.f90

- `dp`, `sp`, `dep_prec`: Setting the precision of the simulation.
- `lusekerneloutput`: Switch for using a kernel for calculating concentrations/deposition. Default: **True**.
- `lparticlecountoutput`: Switch to set output units to number of particles per grid cell. Default: **False**.
- `numpf`: Number of precipitation fields read by the executable. This should correspond with the number of precipitation fields present in the meteorological data. Default: **1**.
- `lpartoutputperfield`: When using particle output (IPOUT=1), this switch sets if all selected fields are written to one netcdf file or a separate one for each field.
- Many parameters that govern the different parameter schemes within FLEXPART.

### Compiling FLEXPART without eta coordinates

    $ make -j -f <prefered_makefile> eta=no

This will create the executable `FLEXPART`

### Compiling FLEXPART without NetCDF libraries

    $ make -j -f <prefered_makefile> eta=<yes/no> ncf=no

This will create the executable `FLEXPART_BIN`, or `FLEXPART_ETA_BIN` for `eta=yes`.
### <a name="paths"></a>Paths
the makefile provided uses a predefined `CPATH` and `LIBRARY_PATH`, the default on most servers. If these paths are not available, you will need to edit the makefile, adding the correct paths manually.

### <a name="optimisation"></a>Optimisation
The default and recommended optimisation flags in the makefile are `-O3 -march=native -mtune=native -fopenmp`. If not requiring a parallelised version, the `-fopenmp` can be switched off without consequence.

### <a name="dependency"></a>Dependencies
At the bottom of the default makefile, one can find the list of modules an how they depend on each other in ascending order.

# Containers

There are two most commonly used container formats available:

1. Docker/Podman
2. Singularity/Apptainer

with FLEXPART and recipes can be found in containers folder.

Since version 11, FLEXPART is also available as a container. There is a Dockerfile and some instructions on how to build the container from scratch using for example podman/docker or singularity/apptainer:

Specifications:
- compiled using `march=core-avx2`, compatible with CPUs above AVX2 (since Haswell or Zen)
- ECCodes (from package manager or manual build a specific version)

## Building the container image

The first step is always to build the container image.

Building the docker/podman container

```sh
# build container using podman (adjust for docker)
$ ./containers/build.sh

Building flexpart v11 branch: master : 2464aef
Press any key to continue or Ctrl+C to exit...
STEP 1/16: FROM rockylinux:9-minimal
...
STEP 16/16: CMD ["FLEXPART_ETA"]
--> Using cache 200844128a6919007417f3fa905221c8dbdea4bb285895ef80e89d3df80274b6
COMMIT flexpartv11-master:2464aef
--> 200844128a69
Successfully tagged localhost/flexpartv11-master:2464aef
200844128a6919007417f3fa905221c8dbdea4bb285895ef80e89d3df80274b6
# finished
```

Building the singularity/apptainer image

```sh
# using singularity/apptainer for running FLEXPART
# there might be some warnings about EPERM (can be ignored)
$ ./containers/build.sh apptainer

Building flexpart v11 branch: master : 2464aef
Press any key to continue or Ctrl+C to exit...
INFO:    Starting build...
INFO:    Adding environment to container
INFO:    Adding startscript
INFO:    Adding runscript
INFO:    Creating SIF file...
INFO:    Build complete: flexpartv11-master-2464aef.sif
# finished
```

## Running the container image

running using podman/docker, can be used without a mount to the local directory, because docker/podmann containers have writable temporary spaces. The outputs will be only inside the container. Create a volume mount point to map the outputs, inputs to the host.

```sh
# simple run the container with default settings
podman run localhost/flexpartv11-master:2464aef
```

running using the singularity/apptainer, requires a mount (bind) point. The container image can not be changed during runtime. Outputs need to be written to the host. 

```sh
# running the container requires a writable output directory
# mounting the local directory to /output inside the container
apptainer run -B .:/output flexpartv11-master-2464aef.sif
```

it is possible to run FLEXPART (no ETA) and FLEXPART_ETA (default), because both executables are being build. To launch FLEXPART without ETA run:

```sh
# using podman
podman run localhost/flexpartv11-master:2464aef FLEXPART
# using apptainer
apptainer run -B .:/output flexpartv11-master-2464aef.sif FLEXPART
```

<details>
<summary>podman/docker flexpart run log</summary>
<pre><code class="shell">
Welcome, running FLEXPART 
Using defaults (/pathnames)
/options/
/output/
/inputs/
/inputs/AVAILABLE
Mount volumes to change inputs
Git: c5bdd94 HEAD -> master, origin/master, origin/HEAD Tue Nov 21 16:15:27 2023 +0100
EXECUTING FLEXPART
trying to execute: /src/FLEXPART_ETA
Executing: /src/FLEXPART_ETA
 Welcome to FLEXPART Version 11
 Git: undefined
 FLEXPART is free software released under the GNU General Public License.
 FLEXPART is running with ETA coordinates.
              ----------------               
  INFORMATION: SUBGRIDSCALE TERRAIN EFFECT IS
  NOT PARAMETERIZED DURING THIS SIMULATION.  
              ----------------               

 *********** WARNING  **********************************
 * FLEXPART running in parallel mode                   *
 * Number of uncertainty classes in                    *
 * set to number of threads:                1          *
 * All other computations are done with     8 threads. *
 *******************************************************

 FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO
 WIND FIELDS IS BIG. THIS MAY CAUSE A DEGRADATION
 OF SIMULATION QUALITY.
 ECMWF metdata detected
 NXSHIFT is set to           0
 grid dim:         181          91          92          92          91          92
 Vertical levels in ECMWF data:      92     92

 Mother domain:
  Longitude range: -178.00000 to  182.00000   Grid distance:    2.00000
  Latitude range :  -90.00000 to   90.00000   Grid distance:    2.00000

 Number of receptors:            2
 Releasepoints :            1
 reading SPECIES          24
 Particle shape SPHERE for particle          24
  
 SPECIES:  24  AIRTRACER   (GAS) 
   Wet removal for gases      is turned: OFF 
   Dry deposition for gases   is turned: OFF 
   Below-cloud scavenging: OFF
   In-cloud scavenging: OFF
 Particles released (numpartmax):        10000
 Total mass released: 1.0000000E+00
 Allocating fields for global output (x,y):           85          65
 Concentrations are calculated using kernel
 WARNING: turbulence switched off.
 Simulated     0.0 hours (            0 s),             0 particles
 Time:            0 seconds. Total spawned:           0 alive:           0 terminated:           0
 Allocating        10000  particles           0           0           0
 Finished allocation
 Time:          900 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         1800 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         2700 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         3600 seconds. Total spawned:       10000 alive:       10000 terminated:           0
         3600 Seconds simulated:         10000 Particles:    Uncertainty:   0.000  0.000  0.000
 Time:         4500 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         5400 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         6300 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         7200 seconds. Total spawned:       10000 alive:       10000 terminated:           0
         7200 Seconds simulated:         10000 Particles:    Uncertainty:   0.000  0.000  0.000
 Time:         8100 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         9000 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         9900 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:        10800 seconds. Total spawned:       10000 alive:       10000 terminated:           0
        10800 Seconds simulated:         10000 Particles:    Uncertainty:   0.000  0.000  0.000
 Read wind fields:   0.609375000      seconds
 Timemanager:    1.17187500      seconds,first timestep:    1.09375000     seconds
 Write particle files:    4.68750000E-02  seconds
 Total running time:    1.81250000      seconds
 tps,io,tot:    1.95312500E-02  0.131249994       1.81250000    
 CONGRATULATIONS: YOU HAVE SUCCESSFULLY COMPLETED A FLEXPART MODEL RUN!
FINISHED
</code></pre>
</details>


<details>
<summary>singularity/apptainer flexpart run log</summary>
<pre>
<code class="language-shell">
INFO:    gocryptfs not found, will not be able to use gocryptfs
Welcome, running FLEXPART 
Using defaults (/pathnames)
/options/
/output/
/inputs/
/inputs/AVAILABLE
Mount volumes to change inputs
Git: c5bdd94 HEAD -> master, origin/master, origin/HEAD Tue Nov 21 16:15:27 2023 +0100
EXECUTING FLEXPART
trying to execute: /src/FLEXPART_ETA
Executing: /src/FLEXPART_ETA
 Welcome to FLEXPART Version 11
 Git: undefined
 FLEXPART is free software released under the GNU General Public License.
 FLEXPART is running with ETA coordinates.
              ----------------               
  INFORMATION: SUBGRIDSCALE TERRAIN EFFECT IS
  NOT PARAMETERIZED DURING THIS SIMULATION.  
              ----------------               

 *********** WARNING  **********************************
 * FLEXPART running in parallel mode                   *
 * Number of uncertainty classes in                    *
 * set to number of threads:                1          *
 * All other computations are done with     8 threads. *
 *******************************************************

 FLEXPART WARNING: TIME DIFFERENCE BETWEEN TWO
 WIND FIELDS IS BIG. THIS MAY CAUSE A DEGRADATION
 OF SIMULATION QUALITY.
 ECMWF metdata detected
 NXSHIFT is set to           0
 grid dim:         181          91          92          92          91          92
 Vertical levels in ECMWF data:      92     92

 Mother domain:
  Longitude range: -178.00000 to  182.00000   Grid distance:    2.00000
  Latitude range :  -90.00000 to   90.00000   Grid distance:    2.00000

 Number of receptors:            2
 Releasepoints :            1
 reading SPECIES          24
 Particle shape SPHERE for particle          24
  
 SPECIES:  24  AIRTRACER   (GAS) 
   Wet removal for gases      is turned: OFF 
   Dry deposition for gases   is turned: OFF 
   Below-cloud scavenging: OFF
   In-cloud scavenging: OFF
 Particles released (numpartmax):        10000
 Total mass released: 1.0000000E+00
 Allocating fields for global output (x,y):           85          65
 Concentrations are calculated using kernel
 WARNING: turbulence switched off.
 Simulated     0.0 hours (            0 s),             0 particles
 Time:            0 seconds. Total spawned:           0 alive:           0 terminated:           0
 Allocating        10000  particles           0           0           0
 Finished allocation
 Time:          900 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         1800 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         2700 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         3600 seconds. Total spawned:       10000 alive:       10000 terminated:           0
         3600 Seconds simulated:         10000 Particles:    Uncertainty:   0.000  0.000  0.000
 Time:         4500 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         5400 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         6300 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         7200 seconds. Total spawned:       10000 alive:       10000 terminated:           0
         7200 Seconds simulated:         10000 Particles:    Uncertainty:   0.000  0.000  0.000
 Time:         8100 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         9000 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:         9900 seconds. Total spawned:       10000 alive:       10000 terminated:           0
 Time:        10800 seconds. Total spawned:       10000 alive:       10000 terminated:           0
        10800 Seconds simulated:         10000 Particles:    Uncertainty:   0.000  0.000  0.000
 Read wind fields:   0.703125000      seconds
 Timemanager:    1.25000000      seconds,first timestep:    1.15625000     seconds
 Write particle files:    1.56250000E-02  seconds
 Total running time:    2.00000000      seconds
 tps,io,tot:    2.34375000E-02  0.143749997       2.00000000    
 CONGRATULATIONS: YOU HAVE SUCCESSFULLY COMPLETED A FLEXPART MODEL RUN!
FINISHED
</code></pre>
</details>

<details>
<summary>ncdump of default run output</summary>
<pre><code class="language-shell">
# check the output
ncdump -h grid_conc_20090101000000.nc
netcdf grid_conc_20090101000000 {
dimensions:
	time = UNLIMITED ; // (3 currently)
	longitude = 85 ;
	latitude = 65 ;
	height = 4 ;
	numspec = 1 ;
	pointspec = 1 ;
	nageclass = 1 ;
	nchar = 45 ;
	ncharrec = 16 ;
	numpoint = 1 ;
	receptor = UNLIMITED ; // (2 currently)
variables:
	int time(time) ;
		time:units = "seconds since 2009-01-01 00:00" ;
		time:calendar = "proleptic_gregorian" ;
	float longitude(longitude) ;
		longitude:long_name = "longitude in degree east" ;
		longitude:axis = "Lon" ;
		longitude:units = "degrees_east" ;
		longitude:standard_name = "grid_longitude" ;
		longitude:description = "grid cell centers" ;
	float latitude(latitude) ;
		latitude:long_name = "latitude in degree north" ;
		latitude:axis = "Lat" ;
		latitude:units = "degrees_north" ;
		latitude:standard_name = "grid_latitude" ;
		latitude:description = "grid cell centers" ;
	float height(height) ;
		height:units = "meters" ;
		height:positive = "up" ;
		height:standard_name = "height" ;
		height:long_name = "height above ground" ;
	char RELCOM(numpoint, nchar) ;
		RELCOM:long_name = "release point name" ;
	float RELLNG1(numpoint) ;
		RELLNG1:units = "degrees_east" ;
		RELLNG1:long_name = "release longitude lower left corner" ;
	float RELLNG2(numpoint) ;
		RELLNG2:units = "degrees_east" ;
		RELLNG2:long_name = "release longitude upper right corner" ;
	float RELLAT1(numpoint) ;
		RELLAT1:units = "degrees_north" ;
		RELLAT1:long_name = "release latitude lower left corner" ;
	float RELLAT2(numpoint) ;
		RELLAT2:units = "degrees_north" ;
		RELLAT2:long_name = "release latitude upper right corner" ;
	float RELZZ1(numpoint) ;
		RELZZ1:units = "meters" ;
		RELZZ1:long_name = "release height bottom" ;
	float RELZZ2(numpoint) ;
		RELZZ2:units = "meters" ;
		RELZZ2:long_name = "release height top" ;
	int RELKINDZ(numpoint) ;
		RELKINDZ:long_name = "release kind" ;
	int RELSTART(numpoint) ;
		RELSTART:units = "seconds" ;
		RELSTART:long_name = "release start relative to simulation start" ;
	int RELEND(numpoint) ;
		RELEND:units = "seconds" ;
		RELEND:long_name = "release end relative to simulation start" ;
	int RELPART(numpoint) ;
		RELPART:long_name = "number of release particles" ;
	float RELXMASS(numspec, numpoint) ;
		RELXMASS:long_name = "total release particle mass" ;
	int LAGE(nageclass) ;
		LAGE:units = "seconds" ;
		LAGE:long_name = "age class" ;
	int ORO(latitude, longitude) ;
		ORO:standard_name = "surface altitude" ;
		ORO:long_name = "outgrid surface altitude" ;
		ORO:units = "m" ;
	char receptor(receptor, ncharrec) ;
		receptor:long_name = "receptor name" ;
	float spec001_mr(nageclass, pointspec, time, height, latitude, longitude) ;
		spec001_mr:units = "ng m-3" ;
		spec001_mr:long_name = "AIRTRACER" ;
		spec001_mr:decay = -0.07001485f ;
		spec001_mr:weightmolar = 29.f ;
		spec001_mr:ohcconst = -9.e-10f ;
		spec001_mr:ohdconst = -9.9f ;
		spec001_mr:vsetaver = 0.f ;
	float receptor_conc001(receptor, time) ;
		receptor_conc001:units = "ng m-3" ;
		receptor_conc001:_FillValue = -1.f ;
		receptor_conc001:positive = "up" ;
		receptor_conc001:standard_name = "receptor_conc" ;
		receptor_conc001:long_name = "receptor_concentration" ;

// global attributes:
		:Conventions = "CF-1.6" ;
		:title = "FLEXPART model output" ;
		:git = "undefined" ;
		:source = "Version 11 model output" ;
		:history = "2023-11-21 16:22 +0100  created by mblaschek on NB513" ;
		:references = "Stohl et al., Atmos. Chem. Phys., 2005, doi:10.5194/acp-5-2461-200" ;
		:outlon0 = -25.f ;
		:outlat0 = 10.f ;
		:dxout = 1.f ;
		:dyout = 1.f ;
		:ldirect = 1 ;
		:ibdate = "20090101" ;
		:ibtime = "000000" ;
		:iedate = "20090101" ;
		:ietime = "030000" ;
		:loutstep = 3600 ;
		:loutaver = 3600 ;
		:loutsample = 900 ;
		:loutrestart = -1 ;
		:lsynctime = 900 ;
		:ctl = -0.2f ;
		:ifine = 1 ;
		:iout = 1 ;
		:ipout = 0 ;
		:lsubgrid = 0 ;
		:lconvection = 0 ;
		:lagespectra = 0 ;
		:ipin = 0 ;
		:ioutputforeachrelease = 0 ;
		:iflux = 0 ;
		:mdomainfill = 0 ;
		:ind_source = 1 ;
		:ind_receptor = 1 ;
		:mquasilag = 0 ;
		:nested_output = 0 ;
		:sfc_only = 0 ;
		:linit_cond = 0 ;
}
</code>
</pre>
</details>

## interactive shells

Interactive shells can be launched into containers, to have a look at configurations and to better understand what might go wrong. Podman/Docker allows to alter files inside of the container and save these changes. Singularity/Apptainer containers are not writeable, but acts like a normal executable with access to host files.

using the podman image with an interactive shell:

```sh
# using podman 
$ podman run -it localhost/flexpartv11-master:2464aef /bin/bash
Welcome, running FLEXPART 
Using defaults (/pathnames)                                         [        OK]
/options/
/output/
/inputs/
/inputs/AVAILABLE
Mount volumes to change inputs
Git: 2464aef
EXECUTING FLEXPART
Executing: /src//bin/bash                                           [    FAILED]
Executing: /bin/bash                                                [        OK]
bash-5.1# 
# now you are inside the container
bash-5.1# pwd
/src
# important directories are /input, /output, /src, /options
# it is possible to make changes in the podman container using
# podman commit 
bash-5.1# ./FLEXPART /pathnames
```

using the apptainer image with an interactive shell:

```sh
#
# using singularity/apptainer
$ apptainer run -B .:/output flexpartv11-master-2464aef.sif /bin/bash
# Check the directory, where you are and notice that FLEXPART and FLEXPART_ETA are available
$ pwd
/src
# run the example again
$ ./FLEXPART /pathnames

# or use (but this does not put you into /src)
$ apptainer shell -B .:/output flexpartv11-master-2464aef.sif
# check the directory, and notice that you are in the same directory as you where on your host.
$ pwd
/home/user/flexpart/or/so
# run the example again
$ /src/FLEXPART /pathnames
```

# Linear Chemistry Module
The Linear Chemistry Module (LCM) is based on the initial work of [Henne et al.](https://doi.org/10.5281/zenodo.1249190) who developed the FLEXPART-CTM model from FLEXPART 8, and was first described in [Groot Zwaaftink et al.](https://gmd.copernicus.org/articles/11/4469/2018/). This model was an extension of the domain-filling capability of FLEXPART and added the possibility to initialise particles' mixing ratio from pre-defined fields and to account for the influence of surface fluxes and simple linear chemistry on the particles' mass.

## How to run LCM
To run the LCM the following OPTIONS files are used and need to be edited (see also the Appendix for example OPTIONS files):

1. COMMAND: choose the following options:
	- LDIRECT= 1 (forward simulation)
	- MDOMAINFILL = 1 (domain-filling mode)
	- IND_SOURCE = 1 (releases units of mass)
	- IND_RECEPTOR = 1 (receptor units of mass)
	- LCMOUTPUT = 1 (uses the LCM initialization and output formats)

2. RELEASES: specify the following:
	- NSPEC: number of species including the mandatory species AIRTRACER
	- SPECNUM_REL: species number in the directory SPECIES (note AIRTRACER must be the first species)
	- LON1: left longitude of release box for global domain
	- LON2: right longitude of release box for global domain
	- LAT1: lower latitude of release box for global domain
	- LAT2: upper latitude of release box for global domain
	- PARTS: total number of particles to be used

- INITCONC: specifies input for initializing the mixing ratios

- OUTGRID: specifies the domain and vertical levels for the gridded output

- REAGENTS (optional): specifies chemical reagents for reactions (the corresponding rate constants are given in the SPECIES files)

- RECEPTORS (optional): specifies the locations and times of receptors where mixing ratios should be output.

- SATELLITES (optional): specifies paths and input file names of satellite retrievals for which mixing ratios should be output. Input files need to be generated from a satellite pre-processor, prep_satellite, and can be created using software obtainable from [flexinvertplus](https://git.nilu.no/flexpart/flexinvertplus).

# Welcome to the FLEXPART 11 documentation

<figure>
	<img src="images/flexpart-illustration-nologo-NILU-1.png"
		alt="Schematic">
	<figcaption>Credit: Christine Forsetlund Solbakken (<a href="https://www.colourbox.com/">https://www.colourbox.com/</a>) and Sabine Eckhardt (NILU).</figcaption>
</figure>

- [**Building**](building.md): Information on how to download and install FLEXPART.
	- [Download FLEXPART](building.md#download)
	- [Compiling FLEXPART](building.md#compiling)
- [**Configuration**](configuration.md#config): How to set up a simulation, with an explanation of all input files.
	- [Option files](configuration.md#options)
	- [Pathnames file](configuration.md#pathnames)
	- [AVAILABLE file](configuration.md#available)
	- [User-defined initial conditions](configuration.md#ic)
	- [Restarting a simulation](configuration.md#restart)
- [**Linear Chemistry Module**](LCM.md): A description of how to configure the Linear Chemistry Module.
- [**Running**](running.md): A description of how to run FLEXPART after building and configuration. <br />
- [**Output files**](output.md): A list of all possible output options and files.
- [**Particle transport**](transport.md): An overview of all processes relation to the direct transport of particles. <br />
- [**Evolution of particle properties**](evolution.md): An overview of internal particle processes.
- [**Examples**](examples.md): FLEXPART studies and example cases. <br />
- [**Containers**](containers.md): Available containers.
- [**Trouble Shooting**](troubleshooting.md): A list of common problems. <br />

This manual covers FLEXPART 11 ([Bakels et al. 2024](https://gmd.copernicus.org/articles/17/7595/2024/)). Please cite as:

> Bakels, L., Tatsii, D., Tipka, A., Thompson, R., Dütsch, M., Blaschek, M., Seibert, P., Baier, K., Bucci, S., Cassiani, M., Eckhardt, S., Groot Zwaaftink, C., Henne, S., Kaufmann, P., Lechner, V., Maurer, C., Mulder, M. D., Pisso, I., Plach, A., Subramanian, R., Vojta, M., and Stohl, A.: FLEXPART version 11: improved accuracy, efficiency, and flexibility, Geosci. Model Dev., 17, 7595–7627, https://doi.org/10.5194/gmd-17-7595-2024, 2024.


Although this manual might proof useful for earlier versions as well, please refer and cite the correct documentation when using an older version of FLEXPART:

- [FLEXPART 10.4](https://gmd.copernicus.org/articles/12/4955/2019/)
- [FLEXPART 9](https://gitlab.phaidra.org/flexpart/flexpart/-/blob/94106e2601162f779375849576d4326202e4a37a/doc/latex-manual/flexpart9.3.pdf)
- [FLEXPART 8](https://www.flexpart.eu/downloads/26)
- [FLEXPART 6.2](https://acp.copernicus.org/articles/5/2461/2005/)
- [FLEXPART 3.1](https://folk.nilu.no/~andreas/flexpart/flexpart61.pdf)
- [FLEXPART 1](https://www.sciencedirect.com/science/article/pii/S1352231098001848)

# Trouble Shooting

Here we provide a list of common problems and their solutions. 

<span style="color:seagreen;">
If you have a problem that is not listed or clearly explained by an error message, please create a ticket on our gitlab page by emailing to [gitlab.phaidra+flexpart-flexpart-456-issue-@univie.ac.at](mailto:gitlab.phaidra+flexpart-flexpart-456-issue-@univie.ac.at).
</span>

#### **My application crashes with a segmentation fault shortly after its launch**
This could be due to having compiled with OpenMP, but not setting the following `ulimit` before launching your application, resulting in too little memory per core:
~~~
ulimit -s unlimited
~~~

#### **My application is unexpectedly slow**
There could be many reasons for this to happen, here are some tips to make your application faster:

- Make sure you compiled using appropriate optimisation flags (see [Optimisation](building.md#paths)).
- Check if you need the resolution of output grid, number of particles, and timestep you are currently using and reduce these where possible. For an explanation of all options, see [Configuration](configuration.md).
- Use more OpenMP threads when running your application.
- Make sure to set the following options in your command line (or submit script if you use one) before launching your application:
~~~
export OMP_PLACES=cores
export OMP_PROC_BIND=true
~~~

# Output files

An overview of all possible output files is provided in the table below. Notice that not all these files are written out in every model run; the user settings control which files are produced. At the beginning of a run, FLEXPART records descriptive metadata to either the gridded NetCDF output file ([IOUT](configuration.md#IOUT)>8 or [LNETCDFOUT](configuration.md#LNETCDFOUT)=1), the particle output ([IPOUT](configuration.md#IOUT)=1), or to a dedicated binary file header and a plain text file **header_txt** (with the exception of the orography data and release information). Corresponding files header_nest are produced if nested output is selected. 

When [IOUT](configuration.md#IOUT) is set to a non-zero value, FLEXPART produces gridded output. When requiring binary files ([IOUT](configuration.md#IOUT)<8), separate files are created for every output time step ([LOUTSTEP](configuration.md#LOUTSTEP)), species and domain (mother and, if requested, nest). The naming convention for these files is grid_type_date_nnn. When requiring NetCDF output ([IOUT](configuration.md#IOUT)>8), this information is all contained in one file for the mother grid, and one for a possible nested grid ([NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)). When [IPOUT](configuration.md#IPOUT) is switched on, this information is also contained in the **partoutput_nnn.nc** files.

| Name | Format | Switches | Description of contents |
| ---- | ------ | -------- | ----------------------- |
| ** *Header* ** | | | |
| **`header`** | binary | [IOUT](configuration.md#IOUT)<8 | run metadata + ancillary data, included in **grid_conc_date.nc** and **partoutput_date.nc** when [IOUT](configuration.md#IOUT)>8 and [IPOUT](configuration.md#IPOUT)=1, respectively. |
| **`header_nest`** | binary | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [IOUT](configuration.md#IOUT)<8 | run metadata + ancillary data, included in **grid_conc_date_nest.nc** and **partoutput_date_nest.nc** when [IOUT](configuration.md#IOUT)>8 and [IPOUT](configuration.md#IPOUT)=1, respectively. |
| **`header_txt`** | text | [IOUT](configuration.md#IOUT)<8 | human-readable run metadata (from [COMMAND](configuration.md#command)) |
| **`header_txt_releases`** | text | [IOUT](configuration.md#IOUT)<8 | human-readable run metadata (from [RELEASES](configuration.md#releases) or **part_ic.nc**) |
| **`dates`** | text | [IOUT](configuration.md#IOUT)<8 | time series: dates of output files |
| ** *Gridded data* ** | | | |
| **`grid_conc_date_nnn`** | binary | [LDIRECT](configuration.md#ldirect)=1 [IOUT](configuration.md#IOUT)=1,3,5 | 3D tracer mass density and 2D deposition |
| **`grid_pptv_date_nnn`** | binary | [LDIRECT](configuration.md#ldirect)=1 [IOUT](configuration.md#IOUT)=2,3 | 3D tracer volume mixing ratio and 2D deposition |
| **`grid_time_date_nnn`** | binary | [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=1 | 3D sensitivity of atmospheric receptor to emissions |
| **`grid_drydep_date_nnn`** | binary | [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=1 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=3 | 3D sensitivity of dry deposition receptor to emissions |
| **`grid_wetdep_date_nnn`** | binary | [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=1 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=4 | 3D sensitivity of wet deposition receptor to emissions |
| **`grid_conc_date.nc`** | NetCDF | [LDIRECT](configuration.md#ldirect)=1 [IOUT](configuration.md#IOUT)=9,10,11,13 | 3D tracer and 2D wet and dry deposition |
| **`grid_time_date.nc`** | NetCDF | [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=9 | 3D sensitivity of atmospheric receptor to emissions |
| **`grid_drydep_date.nc`** | NetCDF | [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=9 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=3 | 3D sensitivity of dry deposition receptor to emissions |
| **`grid_wetdep_date.nc`** | NetCDF | [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=9 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=4 | 3D sensitivity of wet deposition receptor to emissions |
| **`grid_initial_nnn`** | binary | [LDIRECT](configuration.md#ldirect)=-1 [LINIT_COND](configuration.md#LINIT_COND)>0 | 3D sensitivity of receptor concentrations and deposition to initial conditions |
| ** *Nested gridded data* ** | | | |
| **`grid_conc_nest_date_nnn`** | binary | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=1 [IOUT](configuration.md#IOUT)=1,3,5 | 3D tracer mass density and 2D deposition |
| **`grid_pptv_nest_date_nnn`** | binary | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=1 [IOUT](configuration.md#IOUT)=2,3 | 3D tracer volume mixing ratio and 2D deposition |
| **`grid_time_nest_date_nnn`** | binary | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=1 | 3D sensitivity of atmospheric receptor to emissions |
| **`grid_drydep_nest_date_nnn`** | binary | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=1 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=3 | 3D sensitivity of dry deposition receptor to emissions |
| **`grid_wetdep_nest_date_nnn`** | binary | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=1 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=4 | 3D sensitivity of wet deposition receptor to emissions |
| **`grid_conc_nest_date.nc`** | NetCDF | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=1 [IOUT](configuration.md#IOUT)=9,10,11,13 | 3D tracer and 2D wet and dry deposition |
| **`grid_time_nest_date.nc`** | NetCDF | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=9 | 3D sensitivity of atmospheric receptor to emissions |
| **`grid_drydep_nest_date.nc`** | NetCDF | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=9 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=3 | 3D sensitivity of dry deposition receptor to emissions |
| **`grid_wetdep_nest_date.nc`** | NetCDF | [NESTED_OUTPUT](configuration.md#NESTED_OUTPUT)=1 [LDIRECT](configuration.md#ldirect)=-1 [IOUT](configuration.md#IOUT)=9 [IND_RECEPTOR](configuration.md#IND_RECEPTOR)=4 | 3D sensitivity of wet deposition receptor to emissions |
| ** *Particle data* ** | | | |
| **`partoutput_date.nc`** | NetCDF | [IPOUT](configuration.md#IPOUT)=1,2,3 | Data at particle level. Output fields set in [PARTOPTIONS](configuration.md#PARTOPTIONS) |
| **`partinit_date.nc`** | NetCDF | [IPOUT](configuration.md#IPOUT)=1,2,3 [IPIN](configuration.md#IPIN)=1 | Initial particle data at t=0. Output fields set in [PARTOPTIONS](configuration.md#PARTOPTIONS) |
| **`restart_date`** | binary | [LOUTRESTART](configuration.md#LOUTRESTART)>=0 | Binary restart files are written to file at each [LOUTRESTART](configuration.md#LOUTRESTART) interval, see [Restarting a simulation](configuration.md#RESTART) |
